import*as e from"../../core/host/host.js";import*as t from"../../core/i18n/i18n.js";import*as n from"../../third_party/marked/marked.js";import*as o from"../../ui/components/buttons/buttons.js";import*as s from"../../ui/components/helpers/helpers.js";import*as i from"../../ui/components/icon_button/icon_button.js";import*as r from"../../ui/components/markdown_view/markdown_view.js";import*as a from"../../ui/legacy/legacy.js";import*as c from"../../ui/lit-html/lit-html.js";import*as l from"../../core/root/root.js";import*as d from"../../core/sdk/sdk.js";import*as h from"../../models/bindings/bindings.js";import*as u from"../../models/formatter/formatter.js";import*as p from"../../models/logs/logs.js";import*as m from"../../ui/legacy/components/utils/utils.js";import*as g from"../console/console.js";const f=1e3;var v;!function(e){e.MESSAGE="message",e.STACKTRACE="stacktrace",e.NETWORK_REQUEST="networkRequest",e.RELATED_CODE="relatedCode",e.SEARCH_ANSWERS="searchAnswers"}(v||(v={}));class w{#e;#t;constructor(e){this.#e=e}async getSearchAnswers(){if(void 0!==this.#t)return this.#t;const e=l.Runtime.Runtime.queryParam("aidaApiKey");if(!e)return"";const t=this.#e.consoleMessage().messageText,n=await fetch(`https://customsearch.googleapis.com/customsearch/v1?cx=f499de4cd70e644b1&key=${e}&q="${encodeURIComponent(t)}"`),o=await n.json(),s=[];for(const e of o.items||[])if(e.pagemap?.question?.length&&e.pagemap?.answer){for(let t=0;t<Math.min(e.pagemap?.answer?.length,3);++t)s.push("  * "+e.pagemap?.answer[t].text);if(s.length>=4)break}return this.#t=s.join("\n"),this.#t}async getNetworkRequest(){const e=this.#e.consoleMessage().getAffectedResources()?.requestId;if(!e)return;return p.NetworkLog.NetworkLog.instance().requestsForId(e)[0]}async getMessageSourceCode(){const e=this.#e.consoleMessage().stackTrace?.callFrames[0],t=this.#e.consoleMessage().runtimeModel(),n=t?.debuggerModel();if(!n||!t||!e)return{text:"",columnNumber:0,lineNumber:0};const o=new d.DebuggerModel.Location(n,e.scriptId,e.lineNumber,e.columnNumber),s=await h.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().rawLocationToUILocation(o),i=await(s?.uiSourceCode.requestContent()),r=!i?.isEncoded&&i?.content?i.content:"",a=r.indexOf("\n");if(r.length>f&&(a<0||a>f)){const{formattedContent:e,formattedMapping:t}=await u.ScriptFormatter.formatScriptContent(s?.uiSourceCode.mimeType()??"text/javascript",r),[n,o]=t.originalToFormatted(s?.lineNumber??0,s?.columnNumber??0);return{text:e,columnNumber:o,lineNumber:n}}return{text:r,columnNumber:s?.columnNumber??0,lineNumber:s?.lineNumber??0}}async buildPrompt(e=Object.values(v)){const[t,n,o]=await Promise.all([e.includes(v.RELATED_CODE)?this.getMessageSourceCode():void 0,e.includes(v.NETWORK_REQUEST)?this.getNetworkRequest():void 0,e.includes(v.SEARCH_ANSWERS)?this.getSearchAnswers():""]),s=t?.text?b(t):"",i=n?R(n):"",r=e.includes(v.STACKTRACE)?E(this.#e):"",a=k(this.#e),c=this.formatPrompt({message:[a,r].join("\n").trim(),relatedCode:s,relatedRequest:i,searchAnswers:o}),l=[{type:v.MESSAGE,value:a}];return r&&l.push({type:v.STACKTRACE,value:r}),s&&l.push({type:v.RELATED_CODE,value:s}),i&&l.push({type:v.NETWORK_REQUEST,value:i}),o&&l.push({type:v.SEARCH_ANSWERS,value:o}),{prompt:c,sources:l}}formatPrompt({message:e,relatedCode:t,relatedRequest:n,searchAnswers:o}){const s=e=>{const s=[];return s.push("### Console message:",e.message),t&&s.push("### Code that generated the error:","```",e.relatedCode,"```"),n&&e.relatedRequest&&s.push("### Related network request:",e.relatedRequest),o&&s.push("### Suggestions:",e.searchAnswers),s.push("### Summary:",e.explanation),s.join("\n")};return`\nYou are an expert software engineer looking at a console message in DevTools.\n\nYou will follow these rules strictly:\n- Answer the question as truthfully as possible using the provided context\n- if you don't have the answer, say "I don't know" and suggest looking for this information\n  elsewhere\n- Start with the explanation immediately without repeating the given console message.\n- Always wrap code with three backticks (\`\`\`)\n\n${[{message:"Uncaught TypeError: Cannot read properties of undefined (reading 'setState') at home.jsx:15\n    at delta (home.jsx:15:14)\n    at Object.Dc (react-dom.production.min.js:54:317)\n    at Fc (react-dom.production.min.js:54:471)\n    at jc (react-dom.production.min.js:55:35)\n    at ai (react-dom.production.min.js:105:68)\n    at Ks (react-dom.production.min.js:106:380)\n    at react-dom.production.min.js:117:104\n    at Pu (react-dom.production.min.js:274:42)\n    at vs (react-dom.production.min.js:52:375)\n    at Dl (react-dom.production.min.js:109:469)\ndelta @ home.jsx:15\n\n\nDc @ react-dom.production.min.js:54\nFc @ react-dom.production.min.js:54\njc @ react-dom.production.min.js:55\nai @ react-dom.production.min.js:105\nKs @ react-dom.production.min.js:106\n(anonymous) @ react-dom.production.min.js:117\nPu @ react-dom.production.min.js:274\nvs @ react-dom.production.min.js:52\nDl @ react-dom.production.min.js:109\neu @ react-dom.production.min.js:74\nbc @ react-dom.production.min.js:73",relatedCode:"class Counter extends React.Component {\n    constructor(props) {\n        super(props);\n\n        this.state = {\n            count : 1\n        };\n\n        this.delta.bind(this);\n    }\n\n    delta() {\n        this.setState({\n            count : this.state.count++\n        });\n    }\n\n    render() {\n        return (\n            <div>\n                <h1>{this.state.count}</h1>\n                <button onClick={this.delta}>+</button>\n            </div>\n        );\n    }\n}",searchAnswers:"- This is due to this.delta not being bound to this. In order to bind set this.delta = this.delta.bind(this) in the constructor: constructor(props) { super(props); this.state = { count : 1 };...\n- In ES7+ (ES2016) you can use the experimental function bind syntax operator :: to bind. It is a syntactic sugar and will do the same as Davin Tryon's answer. You can then rewrite this.delta...\n- There is a difference of context between ES5 and ES6 class. So, there will be a little difference between the implementations as well. Here is the ES5 version: var Counter = React.createClass({...\n- You dont have to bind anything, Just use Arrow functions like this: class Counter extends React.Component { constructor(props) { super(props); this.state = { count: 1 }; } //ARROW FUNCTION...",explanation:"The error occurs because this.delta is not bound to the instance of the Counter component. The fix is it to change the code to be ` this.delta = this.delta.bind(this);`"},{message:"Uncaught TypeError: Cannot set properties of null(setting 'innerHTML')\n        at(index): 57: 49(anonymous) @(index): 57 ",relatedCode:'<script>\n      document.getElementById("test").innerHTML = "Element does not exist";\n    <\/script>\n    <div id="test"></div>',searchAnswers:"- You have to place the hello div before the script, so that it exists when the script is loaded.\n- Let us first try to understand the root cause as to why it is happening in first place. Why do I get an error or Uncaught TypeError: Cannot set property 'innerHTML' of null? The browser always...\n- You could tell javascript to perform the action \"onload\"... Try with this: <script type =\"text/javascript\"> window.onload = function what(){ document.getElementById('hello').innerHTML = 'hi';...\n- Just put your JS in window.onload window.onload = function() { what(); function what() { document.getElementById('hello').innerHTML = 'hi'; }; }",explanation:"The error means that getElementById returns null instead of the div element. This happens because the script runs before the element is added to the DOM."},{message:"Uncaught SyntaxError: Unexpected token ')' (at script.js:39:14)",relatedCode:"if (10 < 120)) {\n  console.log('test')\n}",searchAnswers:'- this is the way to re export default import as default export, export {default} from \'./Component\'\n- In your index.js. export default from \'./component\'"\n- Unexpected token errors in ESLint parsing occur due to incompatibility between your development environment and ESLint\'s current parsing capabilities with the ongoing changes with JavaScripts...\n- In my case (im using Firebase Cloud Functions) i opened .eslintrc.json and changed: "parserOptions": { // Required for certain syntax usages "ecmaVersion": 2017 }, to: "parserOptions": { //..."',explanation:"There is an extra closing `)`. Remove it to fix the issue."}].map(s).join("\n\n")}\n\n${s({message:e,relatedCode:t,relatedRequest:n,searchAnswers:o,explanation:""})}`}}function y(e){const t=e.name.toLowerCase().trim();return!t.startsWith("x-")&&("cookie"!==t&&"set-cookie"!==t&&"authorization"!==t)}function x(e){const t=/^\s*/.exec(e);if(!t||!t.length)return null;const n=t[0];return n===e?null:n}function b({text:e,columnNumber:t,lineNumber:n},o=1e3){const s=e.split("\n");if(s[n].length>=o/2){const e=Math.max(t-o/2,0),i=Math.min(t+o/2,s[n].length);return s[n].substring(e,i)}let i=0,r=n,a=x(s[n]);const c=new Map;for(;void 0!==s[r]&&i+s[r].length<=o/2;){const e=x(s[r]);null===e||null===a||e!==a&&e.startsWith(a)||(/^\s*[\}\)\]]/.exec(s[r])||c.set(e,r),a=e),i+=s[r].length+1,r--}r=n+1;let l=n,d=n;for(a=x(s[n]);void 0!==s[r]&&i+s[r].length<=o;){i+=s[r].length;const e=x(s[r]);if(null!==e&&null!==a&&(e===a||!e.startsWith(a))){const t=s[r+1],n=t?x(t):null;n&&n!==e&&n.startsWith(e)||c.has(e)&&(l=c.get(e)??0,d=r),a=e}r++}return s.slice(l,d+1).join("\n")}function R(e){return`Request: ${e.url()}\n\nRequest headers:\n${e.requestHeaders().filter(y).map((e=>`${e.name}: ${e.value}`)).join("\n")}\n\nResponse headers:\n${e.responseHeaders.filter(y).map((e=>`${e.name}: ${e.value}`)).join("\n")}\n\nResponse status: ${e.statusCode} ${e.statusText}`}function k(e){return e.toMessageTextString()}function E(e){const t=e.contentElement().querySelector(".stack-preview-container");if(!t)return"";const n=t.shadowRoot?.querySelector(".stack-preview-container");return n.childTextNodes().filter((e=>!e.parentElement?.closest(".show-all-link,.show-less-link,.hidden-row"))).map(m.Linkifier.Linkifier.untruncatedNodeText).join("").trim()}const S=new CSSStyleSheet;S.replaceSync("*{padding:0;margin:0;box-sizing:border-box}:host{--max-height:2000px;--loading-max-height:140px;font-family:var(--default-font-family);font-size:inherit;display:block;overflow:hidden;max-height:0}:host-context(.opening){animation:expand-to-loading var(--sys-motion-duration-medium2) var(--sys-motion-easing-emphasized);animation-fill-mode:forwards}:host-context(.loaded){animation:expand-to-full var(--sys-motion-duration-medium2) var(--sys-motion-easing-emphasized);animation-fill-mode:forwards}:host-context(.closing){animation:collapse var(--sys-motion-duration-medium2) var(--sys-motion-easing-emphasized);animation-fill-mode:forwards}@keyframes expand-to-loading{from{max-height:0}to{max-height:var(--loading-max-height)}}@keyframes expand-to-full{from{max-height:var(--actual-height,var(--loading-max-height))}to{max-height:var(--max-height)}}@keyframes collapse{from{max-height:var(--actual-height,var(--max-height))}to{max-height:0;margin-top:0;margin-bottom:0}}.wrapper{padding:16px 20px;background-color:var(--sys-color-cdt-base-container);border-radius:16px}.wrapper.top{border-radius:16px 16px 4px 4px}.wrapper.bottom{margin-top:5px;border-radius:4px 4px 16px 16px}header{display:flex;flex-direction:row;gap:6px;color:var(--sys-color-on-surface);font-size:14px;font-style:normal;font-weight:500;line-height:20px;height:20px}header > .filler{flex:1}main{--override-markdown-view-message-color:var(--sys-color-on-surface);margin:20px 0 0;color:var(--sys-color-on-surface);font-size:12px;font-style:normal;font-weight:400;line-height:20px}devtools-markdown-view{margin-bottom:12px}footer{display:flex;flex-direction:row;color:var(--sys-color-on-surface);font-size:12px;font-style:normal;font-weight:400;line-height:normal;margin-top:8px}footer > div:nth-child(1){display:flex;flex-direction:row;gap:10px}footer > .filler{flex:1}textarea{height:84px;padding:10px;border-radius:8px;border:1px solid var(--sys-color-neutral-outline);width:100%;font-family:var(--default-font-family);font-size:inherit}.buttons{margin-bottom:16px}.dogfood-feedback{display:flex;gap:2px;align-items:center}.link{color:var(--sys-color-primary);text-decoration-line:underline}.loader{background:linear-gradient(130deg,transparent 0%,var(--sys-color-gradient-tertiary) 20%,var(--sys-color-gradient-primary) 40%,transparent 60%,var(--sys-color-gradient-tertiary) 80%,var(--sys-color-gradient-primary) 100%);background-position:0% 0%;background-size:250% 250%;animation:gradient 5s infinite linear}@keyframes gradient{0%{background-position:0 0}100%{background-position:100% 100%}}summary{font-size:13px;font-style:normal;font-weight:400;line-height:20px}details{--collapsed-height:20px;overflow:hidden;height:var(--collapsed-height)}details[open]{height:calc(var(--list-height) + var(--collapsed-height) + 8px);transition:height var(--sys-motion-duration-short4) var(--sys-motion-easing-emphasized)}.refine-container{display:flex;flex-direction:row;margin-top:20px;margin-bottom:12px;gap:8px}h2{display:block;font-size:inherit;margin:0;font-weight:inherit}.info{width:20px;height:20px}\n/*# sourceURL=./components/consoleInsight.css */\n");const T=new CSSStyleSheet;T.replaceSync("*{padding:0;margin:0;box-sizing:border-box}:host{display:block}ul{padding-left:1em;color:var(--sys-color-primary);font-size:13px;font-style:normal;font-weight:400;line-height:20px;margin-top:8px}ul .link{color:var(--sys-color-primary);display:inline-flex!important;align-items:center;gap:4px;text-decoration-line:underline}\n/*# sourceURL=./components/consoleInsightSourcesList.css */\n");const I={inaccurate:"Inaccurate",irrelevant:"Irrelevant",inappropriate:"Inappropriate",notHelpful:"Not helpful",other:"Other",consoleMessage:"Console message",stackTrace:"Stacktrace",networkRequest:"Network request",relatedCode:"Related code",searchAnswers:"Google search answers",refineButtonHint:"Click this button to send the following data to the AI model running on Google's servers, so it can generate a more accurate and relevant response:",generating:"Generating…",insight:"Insight",close:"Close",closeInsight:"Close insight",sources:"Sources",refine:"Give context to personalize insight",refining:"Personalizing insight…",thumbUp:"Thumb up",thumbDown:"Thumb down",submitFeedback:"Submit feedback",dogfood:"Dogfood",reason:"Why did you choose this rating? (optional)",additionalFeedback:"Provide additional feedback (optional)",submit:"Submit",error:"Something went wrong…",refineInfo:"Learn how personalizing of insights works",opensInNewTab:"(opens in a new tab)"},N=t.i18n.registerUIStrings("panels/explain/components/ConsoleInsight.ts",I),$=t.i18n.getLocalizedString.bind(void 0,N),C=t.i18n.getLazilyComputedLocalizedString.bind(void 0,N),{render:M,html:A,Directives:j}=c;class L extends Event{static eventName="close";constructor(){super(L.eventName,{composed:!0,bubbles:!0})}}const B=[["inaccurate",C(I.inaccurate)],["irrelevant",C(I.irrelevant)],["inapproprate",C(I.inappropriate)],["not-helpful",C(I.notHelpful)],["other",C(I.other)]];function O(e){switch(e){case v.MESSAGE:return $(I.consoleMessage);case v.STACKTRACE:return $(I.stackTrace);case v.NETWORK_REQUEST:return $(I.networkRequest);case v.RELATED_CODE:return $(I.relatedCode);case v.SEARCH_ANSWERS:return $(I.searchAnswers)}}var F;!function(e){e.INSIGHT="insight",e.LOADING="loading",e.REFINING="refining",e.ERROR="error"}(F||(F={}));let D=0;class H extends HTMLElement{static litTagName=c.literal`devtools-console-insight`;#n=this.attachShadow({mode:"open"});#o=!0;#s=!1;#i;#r;#a=new P;#c={type:F.LOADING};#l=!1;#d;#h=new Set;#u;#p;#m=!1;constructor(e,t){super(),this.#i=e,this.#r=t,this.#g(),this.addEventListener("keydown",(e=>{e.stopPropagation()})),this.addEventListener("keyup",(e=>{e.stopPropagation()})),this.addEventListener("keypress",(e=>{e.stopPropagation()})),this.tabIndex=0,this.#p=D++,this.focus(),this.#u=new a.PopoverHelper.PopoverHelper(this,this.#f.bind(this)),this.#u.setTimeout(300),this.#u.setHasPadding(!0),this.addEventListener("animationend",(()=>{this.style.setProperty("--actual-height",`${this.offsetHeight}px`)}))}#f(e){const t=e.composedPath()[0];if(!t||!t.isSelfOrDescendant(this.#n.querySelector(".info")))return null;const n=this.#m||"mousemove"!==e.type;return{box:t.boxInWindow(),show:async e=>{const{sources:t}=await this.#i.buildPrompt(),o=`dialog-${this.#p}`,s=document.createElement("div");s.style.display="flex",s.style.flexDirection="column",s.style.fontSize="13px",s.style.lineHeight="20px",s.setAttribute("aria-modal","true"),s.tabIndex=-1,s.role="dialog",n&&s.addEventListener("keydown",(t=>{const n=t;if("Tab"===n.key){const n=function(e){const t=e.contentElement.getComponentRoot();if(!(t instanceof ShadowRoot))throw new Error("Expected a shadow root");const n=["x-link","[role=document]"],o=[];function s(e){const t=document.createTreeWalker(e,NodeFilter.SHOW_ELEMENT);do{const i=t.currentNode;i.shadowRoot&&s(i.shadowRoot),i instanceof ShadowRoot||i!==e&&n.some((e=>i.matches(e)))&&o.push(i)}while(t.nextNode())}return s(t.host),o}(e),o=function(e){const t=e.contentElement.getComponentRoot();if(!(t instanceof ShadowRoot))throw new Error("Expected a shadow root");let n=t.activeElement;for(;n&&n.shadowRoot?.activeElement;)n=n.shadowRoot?.activeElement;return n}(e);if(o){const e=n.indexOf(o);t.shiftKey&&0===e?(n.at(-1)?.focus(),t.preventDefault()):t.shiftKey||e!==n.length-1||(n.at(0)?.focus(),t.preventDefault())}}else"Escape"===n.key&&(t.consume(!0),this.#u.hidePopover(),this.#n.querySelector(".info")?.focus())}));const i=document.createElement("div");i.role="document",i.tabIndex=0,i.setAttribute("aria-describedby",o),s.append(i);const r=document.createElement("p");r.id=o,r.innerText=$(I.refineButtonHint),r.style.margin="0",i.append(r);const a=document.createElement("devtools-console-insight-sources-list");if(a.sources=t,i.append(a),e.contentElement.append(s),e.setAnchorBehavior("PreferBottom"),n){const t=e.show;e.show=n=>{t.call(e,n),e.contentElement.querySelector("[role=document]")?.focus()};const n=e.hide;e.hide=()=>{n.call(e),this.#n.querySelector(".info")?.focus()}}return!0}}}connectedCallback(){this.#n.adoptedStyleSheets=[S],this.classList.add("opening")}disonnectedCallback(){this.#u.dispose()}set dogfood(e){this.#o=e,this.#g()}get dogfood(){return this.#o}#v(e){const t=this.#c;this.#c=e,e.type!==t.type&&t.type===F.LOADING&&this.classList.add("loaded"),this.#g()}async update(t=this.#s){this.#v(this.#c.type===F.INSIGHT?{...this.#c,type:F.REFINING}:{type:F.LOADING});try{const e=t?void 0:[v.MESSAGE],{prompt:o,sources:s}=await this.#i.buildPrompt(e),i=await this.#r.getInsights(o);this.#v({type:F.INSIGHT,tokens:n.Marked.lexer(i),explanation:i,sources:s,refined:t})}catch(t){e.userMetrics.actionTaken(e.UserMetrics.Action.InsightErrored),this.#v({type:F.ERROR,error:t.message})}}#w(){this.dispatchEvent(new L),this.classList.add("closing")}#y(){this.#l=!1,this.#d=void 0,this.#h.clear(),this.#g()}#x(){this.#o&&this.#b(),this.#y()}#b(){if(this.#c.type!==F.INSIGHT)throw new Error("Unexpected state");const t=function(e,t,n,o,s,i,r){const a="Negative"===e?{"entry.1465663861":e,"entry.1232404632":n,"entry.37285503":s,"entry.542010749":o,"entry.420621380":i,"entry.822323774":r}:{"entry.1465663861":e,"entry.1805879004":n,"entry.720239045":s,"entry.623054399":o,"entry.1520357991":i,"entry.1966708581":r};return`http://go/console-insights-experiment-rating?usp=pp_url&${Object.keys(a).map((e=>`${e}=${encodeURIComponent(a[e])}`)).join("&")}`}(this.#d?"Positive":"Negative",this.#n.querySelector("textarea")?.value,this.#c.explanation,this.#c.sources.filter((e=>e.type===v.MESSAGE)).map((e=>e.value)).join("\n"),this.#c.sources.filter((e=>e.type===v.STACKTRACE)).map((e=>e.value)).join("\n"),this.#c.sources.filter((e=>e.type===v.RELATED_CODE)).map((e=>e.value)).join("\n"),this.#c.sources.filter((e=>e.type===v.NETWORK_REQUEST)).map((e=>e.value)).join("\n"));e.InspectorFrontendHost.InspectorFrontendHostInstance.openInNewTab(t)}#R(t){this.#d="true"===t.target.dataset.rating,this.#d?e.userMetrics.actionTaken(e.UserMetrics.Action.InsightRatedPositive):e.userMetrics.actionTaken(e.UserMetrics.Action.InsightRatedNegative),this.#o?this.#b():(this.#l=!0,this.#g())}#k(e){const t=e.target;t.active?this.#h.delete(t.dataset.reason):this.#h.add(t.dataset.reason),this.#g()}#E(){if(this.#c.type!==F.INSIGHT)throw new Error("Unexpected state");e.userMetrics.actionTaken(e.UserMetrics.Action.InsightRefined),this.update(!0)}#S(e){if(e instanceof KeyboardEvent)switch(e.key){case"Escape":e.consume(!0),this.#u.hidePopover();break;case"Enter":case" ":e.consume(!0),this.#m=!0;try{e.target?.dispatchEvent(new MouseEvent("mousedown",{bubbles:!0,composed:!0,cancelable:!0,clientX:e.target.getBoundingClientRect().x,clientY:e.target.getBoundingClientRect().y}))}finally{this.#m=!1}}}#T(){switch(this.#c.type){case F.LOADING:return A`<main>
            <div role="presentation" class="loader" style="clip-path: url('#clipPath');">
              <svg width="100%" height="64">
                <clipPath id="clipPath">
                  <rect x="0" y="0" width="100%" height="16" rx="8"></rect>
                  <rect x="0" y="24" width="100%" height="16" rx="8"></rect>
                  <rect x="0" y="48" width="100%" height="16" rx="8"></rect>
                </clipPath>
              </svg>
            </div>
          </main>`;case F.REFINING:case F.INSIGHT:return A`
        <main>
          <${r.MarkdownView.MarkdownView.litTagName}
            .data=${{tokens:this.#c.tokens,renderer:this.#a}}>
          </${r.MarkdownView.MarkdownView.litTagName}>
          <details style="--list-height: ${20*this.#c.sources.length}px;">
            <summary>${$(I.sources)}</summary>
            <${q.litTagName} .sources=${this.#c.sources}>
            </${q.litTagName}>
          </details>
          ${this.#c.refined?"":A`<div class="refine-container">
            <${o.Button.Button.litTagName}
                class="refine-button"
                .data=${{variant:"tonal",size:"MEDIUM",iconName:"spark"}}
                @click=${this.#E}
              >
              ${this.#c.type===F.REFINING?$(I.refining):$(I.refine)}
            </${o.Button.Button.litTagName}>
            <${o.Button.Button.litTagName}
              class="info"
              .data=${{variant:"round",size:"SMALL",iconName:"info",title:$(I.refineInfo)}}
              @keydown=${this.#S}
            ></${o.Button.Button.litTagName}>
          </div>
          `}
        </main>`;case F.ERROR:return A`
        <main>
          <div class="error">${this.#c.error}</div>
        </main>`}}#I(){switch(this.#c.type){case F.LOADING:case F.ERROR:return c.nothing;case F.INSIGHT:case F.REFINING:return A`<footer>
        <div>
          <${o.Button.Button.litTagName}
            data-rating=${"true"}
            .data=${{variant:"round",size:"SMALL",iconName:"thumb-up",active:this.#d,title:$(I.thumbUp)}}
            @click=${this.#R}
          ></${o.Button.Button.litTagName}>
          <${o.Button.Button.litTagName}
            data-rating=${"false"}
            .data=${{variant:"round",size:"SMALL",iconName:"thumb-down",active:void 0!==this.#d&&!this.#d,title:$(I.thumbDown)}}
            @click=${this.#R}
          ></${o.Button.Button.litTagName}>
        </div>
        <div class="filler"></div>
        ${this.#o?A`<div class="dogfood-feedback">
            <${i.Icon.Icon.litTagName}
              role="presentation"
              .data=${{iconName:"dog-paw",color:"var(--icon-default)",width:"16px",height:"16px"}}>
            </${i.Icon.Icon.litTagName}>
            <span>${$(I.dogfood)} - </span>
            <x-link href=${"http://go/console-insights-experiment-general-feedback"} class="link">${$(I.submitFeedback)}</x-link>
        </div>`:""}
      </footer>`}}#N(){switch(this.#c.type){case F.LOADING:return $(I.generating);case F.INSIGHT:case F.REFINING:return $(I.insight);case F.ERROR:return $(I.error)}}#g(){const e=j.classMap({wrapper:!0,top:this.#l}),t=j.classMap({wrapper:!0,bottom:this.#l});M(A`
      <div class=${e}>
        <header>
          <div>
            <${i.Icon.Icon.litTagName}
              role="presentation"
              .data=${{iconName:"spark",color:"var(--sys-color-primary-bright)",width:"20px",height:"20px"}}>
            </${i.Icon.Icon.litTagName}>
          </div>
          <div class="filler">
            <h2>
              ${this.#N()}
            </h2>
          </div>
          <div>
            <${o.Button.Button.litTagName}
              .data=${{variant:"round",size:"SMALL",iconName:"cross",title:$(I.closeInsight)}}
              @click=${this.#w}
            ></${o.Button.Button.litTagName}>
          </div>
        </header>
        ${this.#T()}
        ${this.#I()}
      </div>
      ${this.#l?A`
        <div class=${t}>
          <header>
            <div class="filler">${$(I.reason)}</div>
            <div>
              <${o.Button.Button.litTagName}
                .data=${{variant:"round",size:"SMALL",iconName:"cross",title:$(I.close)}}
                @click=${this.#y}
              ></${o.Button.Button.litTagName}>
            </div>
          </header>
          <main>
            ${this.#d?"":A`
                <div class="buttons">
                  ${j.repeat(B,(([e,t])=>A`
                      <${o.Button.Button.litTagName}
                        data-reason=${e}
                        @click=${this.#k}
                        .data=${{variant:"secondary",size:"MEDIUM",active:this.#h.has(e)}}
                      >
                        ${t()}
                      </${o.Button.Button.litTagName}>
                    `))}
                </div>
            `}
            <textarea placeholder=${$(I.additionalFeedback)}></textarea>
          </main>
          <footer>
            <div class="filler"></div>
            <div>
              <${o.Button.Button.litTagName}
                .data=${{variant:"primary",size:"MEDIUM",title:$(I.submit)}}
                @click=${this.#x}
              >
                ${$(I.submit)}
              </${o.Button.Button.litTagName}>
            </div>
          </footer>
        </div>
      `:""}
    `,this.#n,{host:this})}}class q extends HTMLElement{static litTagName=c.literal`devtools-console-insight-sources-list`;#n=this.attachShadow({mode:"open"});#$=[];constructor(){super(),this.#n.adoptedStyleSheets=[T]}#g(){M(A`
      <ul>
        ${j.repeat(this.#$,(e=>e.value),(e=>{const t=new i.Icon.Icon;return t.data={iconName:"open-externally",color:"var(--sys-color-primary)",width:"14px",height:"14px"},A`<li><x-link class="link" title="${O(e.type)} ${$(I.opensInNewTab)}" href=${`data:text/plain,${encodeURIComponent(e.value)}`}>${O(e.type)}${t}</x-link></li>`}))}
      </ul>
    `,this.#n,{host:this})}set sources(e){this.#$=e,this.#g()}}s.CustomElements.defineComponent("devtools-console-insight",H),s.CustomElements.defineComponent("devtools-console-insight-sources-list",q);class P extends r.MarkdownView.MarkdownLitRenderer{renderToken(e){const t=this.templateForToken(e);return null===t?(console.warn(`Markdown token type '${e.type}' not supported.`),c.html``):t}templateForToken(e){switch(e.type){case"heading":return A`<strong>${this.renderText(e)}</strong>`;case"link":case"image":return c.html`${a.XLink.XLink.create(e.href,e.text,void 0,void 0,"token")}`}return super.templateForToken(e)}}class U{static buildApiRequest(e){const t={input:e,client:"CHROME_DEVTOOLS"},n=parseFloat(l.Runtime.Runtime.queryParam("aidaTemperature")||"");return isNaN(n)||(t.options={temperature:n}),t}async getInsights(t){return new Promise(((n,o)=>{if(!e.InspectorFrontendHost.InspectorFrontendHostInstance.doAidaConversation)return o(new Error("doAidaConversation is not available"));console.time("request"),e.InspectorFrontendHost.InspectorFrontendHostInstance.doAidaConversation(JSON.stringify(U.buildApiRequest(t)),(e=>{console.timeEnd("request");try{const t=JSON.parse(e.response).map((e=>{if("textChunk"in e)return e.textChunk.text;if("codeChunk"in e)return"\n`````\n"+e.codeChunk.code+"\n`````\n";if("error"in e)throw new Error(`${e.error}: ${e.detail}`);throw new Error("Unknown chunk result")})).join("");n(t)}catch(e){o(e)}}))}))}}class z{handleAction(t,n){switch(n){case"explain.consoleMessage:context":case"explain.consoleMessage:context:error":case"explain.consoleMessage:context:warning":case"explain.consoleMessage:context:other":case"explain.consoleMessage:hover":{const o=t.flavor(g.ConsoleViewMessage.ConsoleViewMessage);if(o){n.startsWith("explain.consoleMessage:context")?e.userMetrics.actionTaken(e.UserMetrics.Action.InsightRequestedViaContextMenu):"explain.consoleMessage:hover"===n&&e.userMetrics.actionTaken(e.UserMetrics.Action.InsightRequestedViaHoverButton);const t=new H(new w(o),new U);return o.setInsight(t),t.update(),!0}return!1}}return!1}}export{z as ActionDelegate,L as CloseEvent,H as ConsoleInsight,U as InsightProvider,P as MarkdownRenderer,w as PromptBuilder,v as SourceType,y as allowHeader,k as formatConsoleMessage,R as formatNetworkRequest,b as formatRelatedCode,E as formatStackTrace,x as lineWhitespace};
