import*as e from"../../core/common/common.js";import*as t from"../../core/host/host.js";import*as s from"../../core/i18n/i18n.js";import*as i from"../../core/sdk/sdk.js";import*as r from"../../third_party/marked/marked.js";import*as n from"../../core/root/root.js";import*as o from"../bindings/bindings.js";import*as a from"../workspace/workspace.js";const u={improvements:"Improvements",pageErrors:"Page Errors",breakingChanges:"Breaking Changes",pageErrorIssue:"A page error issue: the page is not working correctly",breakingChangeIssue:"A breaking change issue: the page may stop working in an upcoming version of Chrome",improvementIssue:"An improvement issue: there is an opportunity to improve the page"},l=s.i18n.registerUIStrings("models/issues_manager/Issue.ts",u),d=s.i18n.getLocalizedString.bind(void 0,l);var c,g;!function(e){e.CrossOriginEmbedderPolicy="CrossOriginEmbedderPolicy",e.Generic="Generic",e.MixedContent="MixedContent",e.Cookie="Cookie",e.HeavyAd="HeavyAd",e.ContentSecurityPolicy="ContentSecurityPolicy",e.LowTextContrast="LowTextContrast",e.Cors="Cors",e.AttributionReporting="AttributionReporting",e.QuirksMode="QuirksMode",e.Other="Other"}(c||(c={})),function(e){e.PageError="PageError",e.BreakingChange="BreakingChange",e.Improvement="Improvement"}(g||(g={}));class m{#e;#t;issueId=void 0;#s;constructor(e,s=null,i){this.#e="object"==typeof e?e.code:e,this.#t=s,this.issueId=i,t.userMetrics.issueCreated("string"==typeof e?e:e.umaCode),this.#s=!1}code(){return this.#e}getBlockedByResponseDetails(){return[]}cookies(){return[]}rawCookieLines(){return[]}elements(){return[]}requests(){return[]}sources(){return[]}trackingSites(){return[]}metadataAllowedSites(){return[]}isAssociatedWithRequestId(e){for(const t of this.requests())if(t.requestId===e)return!0;return!1}model(){return this.#t}isCausedByThirdParty(){return!1}getIssueId(){return this.issueId}isHidden(){return this.#s}setHidden(e){this.#s=e}}function h(e){if(e)return{url:e.url,scriptId:e.scriptId,lineNumber:e.lineNumber,columnNumber:0===e.columnNumber?void 0:e.columnNumber-1}}var p=Object.freeze({__proto__:null,get IssueCategory(){return c},get IssueKind(){return g},getIssueKindName:function(e){switch(e){case g.BreakingChange:return d(u.breakingChanges);case g.Improvement:return d(u.improvements);case g.PageError:return d(u.pageErrors)}},getIssueKindDescription:function(e){switch(e){case g.PageError:return d(u.pageErrorIssue);case g.BreakingChange:return d(u.breakingChangeIssue);case g.Improvement:return d(u.improvementIssue)}},unionIssueKind:function(e,t){return e===g.PageError||t===g.PageError?g.PageError:e===g.BreakingChange||t===g.BreakingChange?g.BreakingChange:g.Improvement},getShowThirdPartyIssuesSetting:function(){return e.Settings.Settings.instance().createSetting("showThirdPartyIssues",!0)},Issue:m,toZeroBasedLocation:h});const I={link:"https://tools.ietf.org/id/draft-ietf-httpbis-header-structure-15.html#rfc.section.4.2.2",linkTitle:"Structured Headers RFC"};class f extends m{issueDetails;constructor(e,t){super(function(e){switch(e.violationType){case"PermissionPolicyDisabled":return"AttributionReportingIssue::PermissionPolicyDisabled";case"UntrustworthyReportingOrigin":return"AttributionReportingIssue::UntrustworthyReportingOrigin";case"InsecureContext":return"AttributionReportingIssue::InsecureContext";case"InvalidHeader":return"AttributionReportingIssue::InvalidRegisterSourceHeader";case"InvalidRegisterTriggerHeader":return"AttributionReportingIssue::InvalidRegisterTriggerHeader";case"SourceAndTriggerHeaders":return"AttributionReportingIssue::SourceAndTriggerHeaders";case"SourceIgnored":return"AttributionReportingIssue::SourceIgnored";case"TriggerIgnored":return"AttributionReportingIssue::TriggerIgnored";case"OsSourceIgnored":return"AttributionReportingIssue::OsSourceIgnored";case"OsTriggerIgnored":return"AttributionReportingIssue::OsTriggerIgnored";case"InvalidRegisterOsSourceHeader":return"AttributionReportingIssue::InvalidRegisterOsSourceHeader";case"InvalidRegisterOsTriggerHeader":return"AttributionReportingIssue::InvalidRegisterOsTriggerHeader";case"WebAndOsHeaders":return"AttributionReportingIssue::WebAndOsHeaders";case"NavigationRegistrationWithoutTransientUserActivation":return"AttributionReportingIssue::NavigationRegistrationWithoutTransientUserActivation";default:return"AttributionReportingIssue::Unknown"}}(e),t),this.issueDetails=e}getCategory(){return c.AttributionReporting}getHeaderValidatorLink(e){const t=new URL("https://wicg.github.io/attribution-reporting-api/validate-headers");return t.searchParams.set("header",e),this.issueDetails.invalidParameter&&t.searchParams.set("json",this.issueDetails.invalidParameter),{link:t.toString(),linkTitle:"Header Validator"}}getDescription(){switch(this.code()){case"AttributionReportingIssue::PermissionPolicyDisabled":return{file:"arPermissionPolicyDisabled.md",links:[]};case"AttributionReportingIssue::UntrustworthyReportingOrigin":return{file:"arUntrustworthyReportingOrigin.md",links:[]};case"AttributionReportingIssue::InsecureContext":return{file:"arInsecureContext.md",links:[]};case"AttributionReportingIssue::InvalidRegisterSourceHeader":return{file:"arInvalidRegisterSourceHeader.md",links:[this.getHeaderValidatorLink("source")]};case"AttributionReportingIssue::InvalidRegisterTriggerHeader":return{file:"arInvalidRegisterTriggerHeader.md",links:[this.getHeaderValidatorLink("trigger")]};case"AttributionReportingIssue::InvalidRegisterOsSourceHeader":return{file:"arInvalidRegisterOsSourceHeader.md",links:[this.getHeaderValidatorLink("os-source")]};case"AttributionReportingIssue::InvalidRegisterOsTriggerHeader":return{file:"arInvalidRegisterOsTriggerHeader.md",links:[this.getHeaderValidatorLink("os-trigger")]};case"AttributionReportingIssue::SourceAndTriggerHeaders":return{file:"arSourceAndTriggerHeaders.md",links:[]};case"AttributionReportingIssue::WebAndOsHeaders":return{file:"arWebAndOsHeaders.md",links:[]};case"AttributionReportingIssue::SourceIgnored":return{file:"arSourceIgnored.md",links:[I]};case"AttributionReportingIssue::TriggerIgnored":return{file:"arTriggerIgnored.md",links:[I]};case"AttributionReportingIssue::OsSourceIgnored":return{file:"arOsSourceIgnored.md",links:[I]};case"AttributionReportingIssue::OsTriggerIgnored":return{file:"arOsTriggerIgnored.md",links:[I]};case"AttributionReportingIssue::NavigationRegistrationWithoutTransientUserActivation":return{file:"arNavigationRegistrationWithoutTransientUserActivation.md",links:[]};case"AttributionReportingIssue::Unknown":return null}}primaryKey(){return JSON.stringify(this.issueDetails)}getKind(){switch(this.code()){case"AttributionReportingIssue::PermissionPolicyDisabled":case"AttributionReportingIssue::UntrustworthyReportingOrigin":case"AttributionReportingIssue::InsecureContext":case"AttributionReportingIssue::InvalidRegisterSourceHeader":case"AttributionReportingIssue::InvalidRegisterTriggerHeader":case"AttributionReportingIssue::InvalidRegisterOsSourceHeader":case"AttributionReportingIssue::InvalidRegisterOsTriggerHeader":case"AttributionReportingIssue::SourceAndTriggerHeaders":case"AttributionReportingIssue::WebAndOsHeaders":case"AttributionReportingIssue::SourceIgnored":case"AttributionReportingIssue::TriggerIgnored":case"AttributionReportingIssue::OsSourceIgnored":case"AttributionReportingIssue::OsTriggerIgnored":case"AttributionReportingIssue::NavigationRegistrationWithoutTransientUserActivation":case"AttributionReportingIssue::Unknown":return g.PageError}}static fromInspectorIssue(e,t){const{attributionReportingIssueDetails:s}=t.details;return s?[new f(s,e)]:(console.warn("Attribution Reporting issue without details received."),[])}}var k=Object.freeze({__proto__:null,AttributionReportingIssue:f});let C=null;class S{constructor(){i.TargetManager.TargetManager.instance().addModelListener(i.ResourceTreeModel.ResourceTreeModel,i.ResourceTreeModel.Events.Load,this.#i,this,{scoped:!0});for(const e of i.TargetManager.TargetManager.instance().models(i.ResourceTreeModel.ResourceTreeModel))e.target().outermostTarget()===e.target()&&this.#r(e)}static instance({forceNew:e}={forceNew:!1}){return C&&!e||(C=new S),C}#r(e){e.target().auditsAgent().invoke_checkFormsIssues()}#i(e){const{resourceTreeModel:t}=e.data;this.#r(t)}}var y=Object.freeze({__proto__:null,CheckFormsIssuesTrigger:S});function v(e){const t=new Map;e.substitutions?.forEach(((e,s)=>{t.set(s,e())}));return{file:e.file,links:e.links.map((function(e){return{link:e.link,linkTitle:e.linkTitle()}})),substitutions:t}}async function w(e){try{return(await fetch(e.toString())).text()}catch(t){throw new Error(`Markdown file ${e.toString()} not found. Make sure it is correctly listed in the relevant BUILD.gn files.`)}}async function b(e){return w(new URL(`descriptions/${e}`,import.meta.url))}function P(e,t){const s=r.Marked.lexer(e),i=D(s);if(!i)throw new Error("Markdown issue descriptions must start with a heading");return{title:i,markdown:s.slice(1),links:t.links}}const A=/\{(PLACEHOLDER_[a-zA-Z][a-zA-Z0-9]*)\}/g,T=/PLACEHOLDER_[a-zA-Z][a-zA-Z0-9]*/;function R(e,t){const s=new Set(t?t.keys():[]);!function(e){const t=[...e].filter((e=>!T.test(e)));if(t.length>0)throw new Error(`Invalid placeholders provided in the substitutions map: ${t}`)}(s);const i=e.replace(A,((e,i)=>{const r=t?t.get(i):void 0;if(void 0===r)throw new Error(`No replacement provided for placeholder '${i}'.`);return s.delete(i),r}));if(s.size>0)throw new Error(`Unused replacements provided: ${[...s]}`);return i}function D(e){return 0===e.length||"heading"!==e[0].type||1!==e[0].depth?null:e[0].text}async function M(e){const t=await b(e.file);return D(r.Marked.lexer(t))}var E=Object.freeze({__proto__:null,resolveLazyDescription:v,getFileContent:w,getMarkdownFileContent:b,createIssueDescriptionFromMarkdown:async function(e){return P(R(await b(e.file),e.substitutions),e)},createIssueDescriptionFromRawMarkdown:P,substitutePlaceholders:R,findTitleFromMarkdownAst:D,getIssueTitleFromMarkdownDescription:M});const N={clientHintsInfrastructure:"Client Hints Infrastructure"},F=s.i18n.registerUIStrings("models/issues_manager/ClientHintIssue.ts",N),x=s.i18n.getLazilyComputedLocalizedString.bind(void 0,F);class O extends m{issueDetails;constructor(e,t){super({code:"ClientHintIssue",umaCode:["ClientHintIssue",e.clientHintIssueReason].join("::")},t),this.issueDetails=e}getCategory(){return c.Other}details(){return this.issueDetails}getDescription(){const e=L.get(this.issueDetails.clientHintIssueReason);return e?v(e):null}sources(){return[this.issueDetails.sourceCodeLocation]}primaryKey(){return JSON.stringify(this.issueDetails)}getKind(){return g.BreakingChange}static fromInspectorIssue(e,t){const s=t.details.clientHintIssueDetails;return s?[new O(s,e)]:(console.warn("Client Hint issue without details received."),[])}}const L=new Map([["MetaTagAllowListInvalidOrigin",{file:"clientHintMetaTagAllowListInvalidOrigin.md",links:[{link:"https://wicg.github.io/client-hints-infrastructure/",linkTitle:x(N.clientHintsInfrastructure)}]}],["MetaTagModifiedHTML",{file:"clientHintMetaTagModifiedHTML.md",links:[{link:"https://wicg.github.io/client-hints-infrastructure/",linkTitle:x(N.clientHintsInfrastructure)}]}]]);var H=Object.freeze({__proto__:null,ClientHintIssue:O});const W={contentSecurityPolicySource:"Content Security Policy - Source Allowlists",contentSecurityPolicyInlineCode:"Content Security Policy - Inline Code",contentSecurityPolicyEval:"Content Security Policy - Eval",trustedTypesFixViolations:"Trusted Types - Fix violations",trustedTypesPolicyViolation:"Trusted Types - Policy violation"},U=s.i18n.registerUIStrings("models/issues_manager/ContentSecurityPolicyIssue.ts",W),B=s.i18n.getLazilyComputedLocalizedString.bind(void 0,U);class _ extends m{#n;constructor(e,t,s){super(["ContentSecurityPolicyIssue",e.contentSecurityPolicyViolationType].join("::"),t,s),this.#n=e}getCategory(){return c.ContentSecurityPolicy}primaryKey(){return JSON.stringify(this.#n,["blockedURL","contentSecurityPolicyViolationType","violatedDirective","isReportOnly","sourceCodeLocation","url","lineNumber","columnNumber","violatingNodeId"])}getDescription(){const e=X.get(this.#n.contentSecurityPolicyViolationType);return e?v(e):null}details(){return this.#n}getKind(){return this.#n.isReportOnly?g.Improvement:g.PageError}static fromInspectorIssue(e,t){const s=t.details.contentSecurityPolicyIssueDetails;return s?[new _(s,e,t.issueId)]:(console.warn("Content security policy issue without details received."),[])}}const q={file:"cspURLViolation.md",links:[{link:"https://developers.google.com/web/fundamentals/security/csp#source_allowlists",linkTitle:B(W.contentSecurityPolicySource)}]},z={file:"cspInlineViolation.md",links:[{link:"https://developers.google.com/web/fundamentals/security/csp#inline_code_is_considered_harmful",linkTitle:B(W.contentSecurityPolicyInlineCode)}]},V={file:"cspEvalViolation.md",links:[{link:"https://developers.google.com/web/fundamentals/security/csp#eval_too",linkTitle:B(W.contentSecurityPolicyEval)}]},j={file:"cspTrustedTypesSinkViolation.md",links:[{link:"https://web.dev/trusted-types/#fix-the-violations",linkTitle:B(W.trustedTypesFixViolations)}]},K={file:"cspTrustedTypesPolicyViolation.md",links:[{link:"https://web.dev/trusted-types/",linkTitle:B(W.trustedTypesPolicyViolation)}]},$=["ContentSecurityPolicyIssue","kURLViolation"].join("::"),G=["ContentSecurityPolicyIssue","kInlineViolation"].join("::"),Q=["ContentSecurityPolicyIssue","kEvalViolation"].join("::"),J=["ContentSecurityPolicyIssue","kTrustedTypesSinkViolation"].join("::"),Y=["ContentSecurityPolicyIssue","kTrustedTypesPolicyViolation"].join("::"),X=new Map([["kURLViolation",q],["kInlineViolation",z],["kEvalViolation",V],["kTrustedTypesSinkViolation",j],["kTrustedTypesPolicyViolation",K]]);var Z=Object.freeze({__proto__:null,ContentSecurityPolicyIssue:_,urlViolationCode:$,inlineViolationCode:G,evalViolationCode:Q,trustedTypesSinkViolationCode:J,trustedTypesPolicyViolationCode:Y});let ee=null;class te{#o=new WeakMap;#a=new WeakMap;constructor(){i.TargetManager.TargetManager.instance().observeModels(i.ResourceTreeModel.ResourceTreeModel,this)}static instance({forceNew:e}={forceNew:!1}){return ee&&!e||(ee=new te),ee}async modelAdded(e){this.#o.set(e,e.addEventListener(i.ResourceTreeModel.Events.Load,this.#i,this)),this.#a.set(e,e.addEventListener(i.ResourceTreeModel.Events.FrameAdded,this.#u,this))}modelRemoved(t){const s=this.#o.get(t);s&&e.EventTarget.removeEventListeners([s]);const i=this.#a.get(t);i&&e.EventTarget.removeEventListeners([i])}#l(e){n.Runtime.experiments.isEnabled("contrastIssues")&&e.target().auditsAgent().invoke_checkContrast({})}#i(e){const{resourceTreeModel:t}=e.data;this.#l(t)}async#u(e){if(!n.Runtime.experiments.isEnabled("contrastIssues"))return;const t=e.data;if(!t.isMainFrame())return;const s=await t.resourceTreeModel().target().runtimeAgent().invoke_evaluate({expression:"document.readyState",returnByValue:!0});s.result&&"complete"===s.result.value&&this.#l(t.resourceTreeModel())}}var se=Object.freeze({__proto__:null,ContrastCheckTrigger:te});const ie={samesiteCookiesExplained:"SameSite cookies explained",howSchemefulSamesiteWorks:"How Schemeful Same-Site Works",aSecure:"a secure",anInsecure:"an insecure",firstPartySetsExplained:"`First-Party Sets` and the `SameParty` attribute",thirdPartyPhaseoutExplained:"Prepare for phasing out third-party cookies",fileCrosSiteRedirectBug:"File a bug"},re=s.i18n.registerUIStrings("models/issues_manager/CookieIssue.ts",ie),ne=s.i18n.getLazilyComputedLocalizedString.bind(void 0,re);class oe extends m{#n;constructor(e,t,s){super(e,s),this.#n=t}#d(){if(this.#n.cookie){const{domain:e,path:t,name:s}=this.#n.cookie;return`${e};${t};${s}`}return this.#n.rawCookieLine??"no-cookie-info"}primaryKey(){const e=this.#n.request?this.#n.request.requestId:"no-request";return`${this.code()}-(${this.#d()})-(${e})`}static createIssuesFromCookieIssueDetails(e,t){const s=[];if(e.cookieExclusionReasons&&e.cookieExclusionReasons.length>0){for(const i of e.cookieExclusionReasons){const r=oe.codeForCookieIssueDetails(i,e.cookieWarningReasons,e.operation,e.cookieUrl);r&&s.push(new oe(r,e,t))}return s}if(e.cookieWarningReasons)for(const i of e.cookieWarningReasons){const r=oe.codeForCookieIssueDetails(i,[],e.operation,e.cookieUrl);r&&s.push(new oe(r,e,t))}return s}static codeForCookieIssueDetails(t,s,i,r){const n=r&&(e.ParsedURL.schemeIs(r,"https:")||e.ParsedURL.schemeIs(r,"wss:"))?"Secure":"Insecure";if("ExcludeSameSiteStrict"===t||"ExcludeSameSiteLax"===t||"ExcludeSameSiteUnspecifiedTreatedAsLax"===t){if(s&&s.length>0){if(s.includes("WarnSameSiteStrictLaxDowngradeStrict"))return["CookieIssue","ExcludeNavigationContextDowngrade",n].join("::");if(s.includes("WarnSameSiteStrictCrossDowngradeStrict")||s.includes("WarnSameSiteStrictCrossDowngradeLax")||s.includes("WarnSameSiteLaxCrossDowngradeStrict")||s.includes("WarnSameSiteLaxCrossDowngradeLax"))return["CookieIssue","ExcludeContextDowngrade",i,n].join("::")}return s.includes("WarnCrossSiteRedirectDowngradeChangesInclusion")?["CookieIssue","CrossSiteRedirectDowngradeChangesInclusion"].join("::"):"ExcludeSameSiteUnspecifiedTreatedAsLax"===t?["CookieIssue",t,i].join("::"):null}return"WarnSameSiteStrictLaxDowngradeStrict"===t?["CookieIssue",t,n].join("::"):"WarnSameSiteStrictCrossDowngradeStrict"===t||"WarnSameSiteStrictCrossDowngradeLax"===t||"WarnSameSiteLaxCrossDowngradeLax"===t||"WarnSameSiteLaxCrossDowngradeStrict"===t?["CookieIssue","WarnCrossDowngrade",i,n].join("::"):["CookieIssue",t,i].join("::")}cookies(){return this.#n.cookie?[this.#n.cookie]:[]}rawCookieLines(){return this.#n.rawCookieLine?[this.#n.rawCookieLine]:[]}requests(){return this.#n.request?[this.#n.request]:[]}getCategory(){return c.Cookie}getDescription(){const e=Fe.get(this.code());return e?v(e):null}isCausedByThirdParty(){return ae(i.FrameManager.FrameManager.instance().getOutermostFrame(),this.#n.cookieUrl)}getKind(){return this.#n.cookieExclusionReasons?.length>0?g.PageError:g.BreakingChange}static fromInspectorIssue(e,t){const s=t.details.cookieIssueDetails;return s?oe.createIssuesFromCookieIssueDetails(s,e):(console.warn("Cookie issue without details received."),[])}static getSubCategory(e){return e.includes("SameSite")||e.includes("Downgrade")?"SameSiteCookie":e.includes("ThirdPartyPhaseout")?"ThirdPartyPhaseoutCookie":"GenericCookie"}}function ae(t,s){if(!t)return!0;if(!s||""===t.domainAndRegistry())return!1;const i=e.ParsedURL.ParsedURL.fromString(s);return!!i&&!function(e,t){if(e.length<=t.length)return e===t;if(!e.endsWith(t))return!1;return e.substr(0,e.length-t.length).endsWith(".")}(i.domain(),t.domainAndRegistry())}const ue={file:"SameSiteUnspecifiedLaxAllowUnsafeRead.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:ne(ie.samesiteCookiesExplained)}]},le={file:"SameSiteUnspecifiedLaxAllowUnsafeSet.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:ne(ie.samesiteCookiesExplained)}]},de={file:"SameSiteNoneInsecureErrorRead.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:ne(ie.samesiteCookiesExplained)}]},ce={file:"SameSiteNoneInsecureErrorSet.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:ne(ie.samesiteCookiesExplained)}]},ge={file:"SameSiteNoneInsecureWarnRead.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:ne(ie.samesiteCookiesExplained)}]},me={file:"SameSiteNoneInsecureWarnSet.md",links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:ne(ie.samesiteCookiesExplained)}]},he=[{link:"https://web.dev/schemeful-samesite/",linkTitle:ne(ie.howSchemefulSamesiteWorks)}];function pe({isDestinationSecure:e,isOriginSecure:t}){return new Map([["PLACEHOLDER_destination",()=>e?"a secure":"an insecure"],["PLACEHOLDER_origin",()=>t?"a secure":"an insecure"]])}function Ie(e){return{file:"SameSiteWarnStrictLaxDowngradeStrict.md",substitutions:pe({isDestinationSecure:e,isOriginSecure:!e}),links:he}}function fe(e){return{file:"SameSiteExcludeNavigationContextDowngrade.md",substitutions:pe({isDestinationSecure:e,isOriginSecure:!e}),links:he}}function ke(e){return{file:"SameSiteWarnCrossDowngradeRead.md",substitutions:pe({isDestinationSecure:e,isOriginSecure:!e}),links:he}}function Ce(e){return{file:"SameSiteExcludeContextDowngradeRead.md",substitutions:pe({isDestinationSecure:e,isOriginSecure:!e}),links:he}}function Se(e){return{file:"SameSiteWarnCrossDowngradeSet.md",substitutions:pe({isDestinationSecure:!e,isOriginSecure:e}),links:he}}function ye(e){return{file:"SameSiteExcludeContextDowngradeSet.md",substitutions:pe({isDestinationSecure:e,isOriginSecure:!e}),links:he}}const ve={file:"SameSiteInvalidSameParty.md",links:[{link:"https://developer.chrome.com/blog/first-party-sets-sameparty/",linkTitle:ne(ie.firstPartySetsExplained)}]},we={file:"SameSiteSamePartyCrossPartyContextSet.md",links:[{link:"https://developer.chrome.com/blog/first-party-sets-sameparty/",linkTitle:ne(ie.firstPartySetsExplained)}]},be={file:"CookieAttributeValueExceedsMaxSize.md",links:[]},Pe={file:"cookieWarnDomainNonAscii.md",links:[]},Ae={file:"cookieExcludeDomainNonAscii.md",links:[]},Te={file:"cookieExcludeBlockedWithinRelatedWebsiteSet.md",links:[]},Re={file:"cookieWarnThirdPartyPhaseoutSet.md",links:[{link:"https://goo.gle/3pcd-dev-issue",linkTitle:ne(ie.thirdPartyPhaseoutExplained)}]},De={file:"cookieWarnThirdPartyPhaseoutRead.md",links:[{link:"https://goo.gle/3pcd-dev-issue",linkTitle:ne(ie.thirdPartyPhaseoutExplained)}]},Me={file:"cookieExcludeThirdPartyPhaseoutSet.md",links:[{link:"https://goo.gle/3pcd-dev-issue",linkTitle:ne(ie.thirdPartyPhaseoutExplained)}]},Ee={file:"cookieExcludeThirdPartyPhaseoutRead.md",links:[{link:"https://goo.gle/3pcd-dev-issue",linkTitle:ne(ie.thirdPartyPhaseoutExplained)}]},Ne={file:"cookieCrossSiteRedirectDowngrade.md",links:[{link:"https://bugs.chromium.org/p/chromium/issues/entry?template=Defect%20report%20from%20user&summary=[Cross-Site Redirect Chain] <INSERT BUG SUMMARY HERE>&comment=Chrome Version: (copy from chrome://version)%0AChannel: (e.g. Canary, Dev, Beta, Stable)%0A%0AAffected URLs:%0A%0AWhat is the expected result?%0A%0AWhat happens instead?%0A%0AWhat is the purpose of the cross-site redirect?:%0A%0AWhat steps will reproduce the problem?:%0A(1)%0A(2)%0A(3)%0A%0APlease provide any additional information below.&components=Internals%3ENetwork%3ECookies",linkTitle:ne(ie.fileCrosSiteRedirectBug)}]},Fe=new Map([["CookieIssue::WarnSameSiteUnspecifiedLaxAllowUnsafe::ReadCookie",ue],["CookieIssue::WarnSameSiteUnspecifiedLaxAllowUnsafe::SetCookie",le],["CookieIssue::WarnSameSiteUnspecifiedCrossSiteContext::ReadCookie",ue],["CookieIssue::WarnSameSiteUnspecifiedCrossSiteContext::SetCookie",le],["CookieIssue::ExcludeSameSiteNoneInsecure::ReadCookie",de],["CookieIssue::ExcludeSameSiteNoneInsecure::SetCookie",ce],["CookieIssue::WarnSameSiteNoneInsecure::ReadCookie",ge],["CookieIssue::WarnSameSiteNoneInsecure::SetCookie",me],["CookieIssue::WarnSameSiteStrictLaxDowngradeStrict::Secure",Ie(!0)],["CookieIssue::WarnSameSiteStrictLaxDowngradeStrict::Insecure",Ie(!1)],["CookieIssue::WarnCrossDowngrade::ReadCookie::Secure",ke(!0)],["CookieIssue::WarnCrossDowngrade::ReadCookie::Insecure",ke(!1)],["CookieIssue::WarnCrossDowngrade::SetCookie::Secure",Se(!0)],["CookieIssue::WarnCrossDowngrade::SetCookie::Insecure",Se(!1)],["CookieIssue::ExcludeNavigationContextDowngrade::Secure",fe(!0)],["CookieIssue::ExcludeNavigationContextDowngrade::Insecure",fe(!1)],["CookieIssue::ExcludeContextDowngrade::ReadCookie::Secure",Ce(!0)],["CookieIssue::ExcludeContextDowngrade::ReadCookie::Insecure",Ce(!1)],["CookieIssue::ExcludeContextDowngrade::SetCookie::Secure",ye(!0)],["CookieIssue::ExcludeContextDowngrade::SetCookie::Insecure",ye(!1)],["CookieIssue::ExcludeInvalidSameParty::SetCookie",ve],["CookieIssue::ExcludeSamePartyCrossPartyContext::SetCookie",we],["CookieIssue::WarnAttributeValueExceedsMaxSize::ReadCookie",be],["CookieIssue::WarnAttributeValueExceedsMaxSize::SetCookie",be],["CookieIssue::WarnDomainNonASCII::ReadCookie",Pe],["CookieIssue::WarnDomainNonASCII::SetCookie",Pe],["CookieIssue::ExcludeDomainNonASCII::ReadCookie",Ae],["CookieIssue::ExcludeDomainNonASCII::SetCookie",Ae],["CookieIssue::ExcludeThirdPartyCookieBlockedInRelatedWebsiteSet::ReadCookie",Te],["CookieIssue::ExcludeThirdPartyCookieBlockedInRelatedWebsiteSet::SetCookie",Te],["CookieIssue::WarnThirdPartyPhaseout::ReadCookie",De],["CookieIssue::WarnThirdPartyPhaseout::SetCookie",Re],["CookieIssue::ExcludeThirdPartyPhaseout::ReadCookie",Ee],["CookieIssue::ExcludeThirdPartyPhaseout::SetCookie",Me],["CookieIssue::CrossSiteRedirectDowngradeChangesInclusion",Ne]]);var xe=Object.freeze({__proto__:null,CookieIssue:oe,isCausedByThirdParty:ae});const Oe={corsPrivateNetworkAccess:"Private Network Access",CORS:"Cross-Origin Resource Sharing (`CORS`)"},Le=s.i18n.registerUIStrings("models/issues_manager/CorsIssue.ts",Oe),He=s.i18n.getLocalizedString.bind(void 0,Le);var We;function Ue(e){switch(e.corsErrorStatus.corsError){case"InvalidAllowMethodsPreflightResponse":case"InvalidAllowHeadersPreflightResponse":case"PreflightMissingAllowOriginHeader":case"PreflightMultipleAllowOriginValues":case"PreflightInvalidAllowOriginValue":case"MissingAllowOriginHeader":case"MultipleAllowOriginValues":case"InvalidAllowOriginValue":return We.InvalidHeaderValues;case"PreflightWildcardOriginNotAllowed":case"WildcardOriginNotAllowed":return We.WildcardOriginNotAllowed;case"PreflightInvalidStatus":case"PreflightDisallowedRedirect":case"InvalidResponse":return We.PreflightResponseInvalid;case"AllowOriginMismatch":case"PreflightAllowOriginMismatch":return We.OriginMismatch;case"InvalidAllowCredentials":case"PreflightInvalidAllowCredentials":return We.AllowCredentialsRequired;case"MethodDisallowedByPreflightResponse":return We.MethodDisallowedByPreflightResponse;case"HeaderDisallowedByPreflightResponse":return We.HeaderDisallowedByPreflightResponse;case"RedirectContainsCredentials":return We.RedirectContainsCredentials;case"DisallowedByMode":return We.DisallowedByMode;case"CorsDisabledScheme":return We.CorsDisabledScheme;case"PreflightMissingAllowExternal":return We.PreflightMissingAllowExternal;case"PreflightInvalidAllowExternal":return We.PreflightInvalidAllowExternal;case"InsecurePrivateNetwork":return We.InsecurePrivateNetwork;case"NoCorsRedirectModeNotFollow":return We.NoCorsRedirectModeNotFollow;case"InvalidPrivateNetworkAccess":return We.InvalidPrivateNetworkAccess;case"UnexpectedPrivateNetworkAccess":return We.UnexpectedPrivateNetworkAccess;case"PreflightMissingAllowPrivateNetwork":case"PreflightInvalidAllowPrivateNetwork":return We.PreflightAllowPrivateNetworkError;case"PreflightMissingPrivateNetworkAccessId":return We.PreflightMissingPrivateNetworkAccessId;case"PreflightMissingPrivateNetworkAccessName":return We.PreflightMissingPrivateNetworkAccessName;case"PrivateNetworkAccessPermissionUnavailable":return We.PrivateNetworkAccessPermissionUnavailable;case"PrivateNetworkAccessPermissionDenied":return We.PrivateNetworkAccessPermissionDenied}}!function(e){e.InsecurePrivateNetwork="CorsIssue::InsecurePrivateNetwork",e.InvalidHeaderValues="CorsIssue::InvalidHeaders",e.WildcardOriginNotAllowed="CorsIssue::WildcardOriginWithCredentials",e.PreflightResponseInvalid="CorsIssue::PreflightResponseInvalid",e.OriginMismatch="CorsIssue::OriginMismatch",e.AllowCredentialsRequired="CorsIssue::AllowCredentialsRequired",e.MethodDisallowedByPreflightResponse="CorsIssue::MethodDisallowedByPreflightResponse",e.HeaderDisallowedByPreflightResponse="CorsIssue::HeaderDisallowedByPreflightResponse",e.RedirectContainsCredentials="CorsIssue::RedirectContainsCredentials",e.DisallowedByMode="CorsIssue::DisallowedByMode",e.CorsDisabledScheme="CorsIssue::CorsDisabledScheme",e.PreflightMissingAllowExternal="CorsIssue::PreflightMissingAllowExternal",e.PreflightInvalidAllowExternal="CorsIssue::PreflightInvalidAllowExternal",e.NoCorsRedirectModeNotFollow="CorsIssue::NoCorsRedirectModeNotFollow",e.InvalidPrivateNetworkAccess="CorsIssue::InvalidPrivateNetworkAccess",e.UnexpectedPrivateNetworkAccess="CorsIssue::UnexpectedPrivateNetworkAccess",e.PreflightAllowPrivateNetworkError="CorsIssue::PreflightAllowPrivateNetworkError",e.PreflightMissingPrivateNetworkAccessId="CorsIssue::PreflightMissingPrivateNetworkAccessId",e.PreflightMissingPrivateNetworkAccessName="CorsIssue::PreflightMissingPrivateNetworkAccessName",e.PrivateNetworkAccessPermissionUnavailable="CorsIssue::PrivateNetworkAccessPermissionUnavailable",e.PrivateNetworkAccessPermissionDenied="CorsIssue::PrivateNetworkAccessPermissionDenied"}(We||(We={}));class Be extends m{#n;constructor(e,t,s){super(Ue(e),t,s),this.#n=e}getCategory(){return c.Cors}details(){return this.#n}getDescription(){switch(Ue(this.#n)){case We.InsecurePrivateNetwork:return{file:"corsInsecurePrivateNetwork.md",links:[{link:"https://developer.chrome.com/blog/private-network-access-update",linkTitle:He(Oe.corsPrivateNetworkAccess)}]};case We.PreflightAllowPrivateNetworkError:return{file:"corsPreflightAllowPrivateNetworkError.md",links:[{link:"https://developer.chrome.com/blog/private-network-access-update",linkTitle:He(Oe.corsPrivateNetworkAccess)}]};case We.InvalidHeaderValues:return{file:"corsInvalidHeaderValues.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.WildcardOriginNotAllowed:return{file:"corsWildcardOriginNotAllowed.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.PreflightResponseInvalid:return{file:"corsPreflightResponseInvalid.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.OriginMismatch:return{file:"corsOriginMismatch.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.AllowCredentialsRequired:return{file:"corsAllowCredentialsRequired.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.MethodDisallowedByPreflightResponse:return{file:"corsMethodDisallowedByPreflightResponse.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.HeaderDisallowedByPreflightResponse:return{file:"corsHeaderDisallowedByPreflightResponse.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.RedirectContainsCredentials:return{file:"corsRedirectContainsCredentials.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.DisallowedByMode:return{file:"corsDisallowedByMode.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.CorsDisabledScheme:return{file:"corsDisabledScheme.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.NoCorsRedirectModeNotFollow:return{file:"corsNoCorsRedirectModeNotFollow.md",links:[{link:"https://web.dev/cross-origin-resource-sharing",linkTitle:He(Oe.CORS)}]};case We.PreflightMissingPrivateNetworkAccessId:case We.PreflightMissingPrivateNetworkAccessName:return{file:"corsPrivateNetworkPermissionDenied.md",links:[{link:"https://developer.chrome.com/blog/private-network-access-update",linkTitle:He(Oe.corsPrivateNetworkAccess)}]};case We.PreflightMissingAllowExternal:case We.PreflightInvalidAllowExternal:case We.InvalidPrivateNetworkAccess:case We.UnexpectedPrivateNetworkAccess:case We.PrivateNetworkAccessPermissionUnavailable:case We.PrivateNetworkAccessPermissionDenied:return null}}primaryKey(){return JSON.stringify(this.#n)}getKind(){return!this.#n.isWarning||"InsecurePrivateNetwork"!==this.#n.corsErrorStatus.corsError&&"PreflightMissingAllowPrivateNetwork"!==this.#n.corsErrorStatus.corsError&&"PreflightInvalidAllowPrivateNetwork"!==this.#n.corsErrorStatus.corsError?g.PageError:g.BreakingChange}static fromInspectorIssue(e,t){const s=t.details.corsIssueDetails;return s?[new Be(s,e,t.issueId)]:(console.warn("Cors issue without details received."),[])}}var _e=Object.freeze({__proto__:null,get IssueCode(){return We},CorsIssue:Be});const qe={coopAndCoep:"COOP and COEP",samesiteAndSameorigin:"Same-Site and Same-Origin"},ze=s.i18n.registerUIStrings("models/issues_manager/CrossOriginEmbedderPolicyIssue.ts",qe),Ve=s.i18n.getLazilyComputedLocalizedString.bind(void 0,ze);function je(e){switch(e){case"CoepFrameResourceNeedsCoepHeader":case"CoopSandboxedIFrameCannotNavigateToCoopPage":case"CorpNotSameOrigin":case"CorpNotSameOriginAfterDefaultedToSameOriginByCoep":case"CorpNotSameSite":return!0}return!1}class Ke extends m{#n;constructor(e,t){super(`CrossOriginEmbedderPolicyIssue::${e.reason}`,t),this.#n=e}primaryKey(){return`${this.code()}-(${this.#n.request.requestId})`}getBlockedByResponseDetails(){return[this.#n]}requests(){return[this.#n.request]}getCategory(){return c.CrossOriginEmbedderPolicy}getDescription(){const e=$e.get(this.code());return e?v(e):null}getKind(){return g.PageError}}const $e=new Map([["CrossOriginEmbedderPolicyIssue::CorpNotSameOriginAfterDefaultedToSameOriginByCoep",{file:"CoepCorpNotSameOriginAfterDefaultedToSameOriginByCoep.md",links:[{link:"https://web.dev/coop-coep/",linkTitle:Ve(qe.coopAndCoep)},{link:"https://web.dev/same-site-same-origin/",linkTitle:Ve(qe.samesiteAndSameorigin)}]}],["CrossOriginEmbedderPolicyIssue::CoepFrameResourceNeedsCoepHeader",{file:"CoepFrameResourceNeedsCoepHeader.md",links:[{link:"https://web.dev/coop-coep/",linkTitle:Ve(qe.coopAndCoep)}]}],["CrossOriginEmbedderPolicyIssue::CoopSandboxedIframeCannotNavigateToCoopPage",{file:"CoepCoopSandboxedIframeCannotNavigateToCoopPage.md",links:[{link:"https://web.dev/coop-coep/",linkTitle:Ve(qe.coopAndCoep)}]}],["CrossOriginEmbedderPolicyIssue::CorpNotSameSite",{file:"CoepCorpNotSameSite.md",links:[{link:"https://web.dev/coop-coep/",linkTitle:Ve(qe.coopAndCoep)},{link:"https://web.dev/same-site-same-origin/",linkTitle:Ve(qe.samesiteAndSameorigin)}]}],["CrossOriginEmbedderPolicyIssue::CorpNotSameOrigin",{file:"CoepCorpNotSameOrigin.md",links:[{link:"https://web.dev/coop-coep/",linkTitle:Ve(qe.coopAndCoep)},{link:"https://web.dev/same-site-same-origin/",linkTitle:Ve(qe.samesiteAndSameorigin)}]}]]);var Ge=Object.freeze({__proto__:null,isCrossOriginEmbedderPolicyIssue:je,CrossOriginEmbedderPolicyIssue:Ke});const Qe={AuthorizationCoveredByWildcard:"Authorization will not be covered by the wildcard symbol (*) in CORS `Access-Control-Allow-Headers` handling.",CanRequestURLHTTPContainingNewline:"Resource requests whose URLs contained both removed whitespace `\\(n|r|t)` characters and less-than characters (`<`) are blocked. Please remove newlines and encode less-than characters from places like element attribute values in order to load these resources.",ChromeLoadTimesConnectionInfo:"`chrome.loadTimes()` is deprecated, instead use standardized API: Navigation Timing 2.",ChromeLoadTimesFirstPaintAfterLoadTime:"`chrome.loadTimes()` is deprecated, instead use standardized API: Paint Timing.",ChromeLoadTimesWasAlternateProtocolAvailable:"`chrome.loadTimes()` is deprecated, instead use standardized API: `nextHopProtocol` in Navigation Timing 2.",CookieWithTruncatingChar:"Cookies containing a `\\(0|r|n)` character will be rejected instead of truncated.",CrossOriginAccessBasedOnDocumentDomain:"Relaxing the same-origin policy by setting `document.domain` is deprecated, and will be disabled by default. This deprecation warning is for a cross-origin access that was enabled by setting `document.domain`.",CrossOriginWindowAlert:"Triggering window.alert from cross origin iframes has been deprecated and will be removed in the future.",CrossOriginWindowConfirm:"Triggering window.confirm from cross origin iframes has been deprecated and will be removed in the future.",CSSSelectorInternalMediaControlsOverlayCastButton:"The `disableRemotePlayback` attribute should be used in order to disable the default Cast integration instead of using `-internal-media-controls-overlay-cast-button` selector.",CSSValueAppearanceNonStandard:"CSS appearance values  `inner-spin-button`, `media-slider`, `media-sliderthumb`, `media-volume-slider`, `media-volume-sliderthumb`, `push-button`, `searchfield-cancel-button`, `slider-horizontal`, `sliderthumb-horizontal`, `sliderthumb-vertical`, `square-button` are not standardized and will be removed.",CSSValueAppearanceSliderVertical:"CSS appearance value `slider-vertical` is not standardized and will be removed.",DataUrlInSvgUse:"Support for data: URLs in SVGUseElement is deprecated and it will be removed in the future.",DocumentDomainSettingWithoutOriginAgentClusterHeader:"Relaxing the same-origin policy by setting `document.domain` is deprecated, and will be disabled by default. To continue using this feature, please opt-out of origin-keyed agent clusters by sending an `Origin-Agent-Cluster: ?0` header along with the HTTP response for the document and frames. See https://developer.chrome.com/blog/immutable-document-domain/ for more details.",DOMMutationEvents:"DOM Mutation Events, including `DOMSubtreeModified`, `DOMNodeInserted`, `DOMNodeRemoved`, `DOMNodeRemovedFromDocument`, `DOMNodeInsertedIntoDocument`, and `DOMCharacterDataModified` are deprecated (https://w3c.github.io/uievents/#legacy-event-types) and will be removed. Please use `MutationObserver` instead.",GeolocationInsecureOrigin:"`getCurrentPosition()` and `watchPosition()` no longer work on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",GeolocationInsecureOriginDeprecatedNotRemoved:"`getCurrentPosition()` and `watchPosition()` are deprecated on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",GetUserMediaInsecureOrigin:"`getUserMedia()` no longer works on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",HostCandidateAttributeGetter:"`RTCPeerConnectionIceErrorEvent.hostCandidate` is deprecated. Please use `RTCPeerConnectionIceErrorEvent.address` or `RTCPeerConnectionIceErrorEvent.port` instead.",IdentityInCanMakePaymentEvent:"The merchant origin and arbitrary data from the `canmakepayment` service worker event are deprecated and will be removed: `topOrigin`, `paymentRequestOrigin`, `methodData`, `modifiers`.",InsecurePrivateNetworkSubresourceRequest:"The website requested a subresource from a network that it could only access because of its users' privileged network position. These requests expose non-public devices and servers to the internet, increasing the risk of a cross-site request forgery (CSRF) attack, and/or information leakage. To mitigate these risks, Chrome deprecates requests to non-public subresources when initiated from non-secure contexts, and will start blocking them.",InterestGroupDailyUpdateUrl:"The `dailyUpdateUrl` field of `InterestGroups` passed to `joinAdInterestGroup()` has been renamed to `updateUrl`, to more accurately reflect its behavior.",LocalCSSFileExtensionRejected:"CSS cannot be loaded from `file:` URLs unless they end in a `.css` file extension.",MediaSourceAbortRemove:"Using `SourceBuffer.abort()` to abort `remove()`'s asynchronous range removal is deprecated due to specification change. Support will be removed in the future. You should listen to the `updateend` event instead. `abort()` is intended to only abort an asynchronous media append or reset parser state.",MediaSourceDurationTruncatingBuffered:"Setting `MediaSource.duration` below the highest presentation timestamp of any buffered coded frames is deprecated due to specification change. Support for implicit removal of truncated buffered media will be removed in the future. You should instead perform explicit `remove(newDuration, oldDuration)` on all `sourceBuffers`, where `newDuration < oldDuration`.",NonStandardDeclarativeShadowDOM:"The older, non-standardized `shadowroot` attribute is deprecated, and will *no longer function* in M119. Please use the new, standardized `shadowrootmode` attribute instead.",NoSysexWebMIDIWithoutPermission:"Web MIDI will ask a permission to use even if the sysex is not specified in the `MIDIOptions`.",NotificationInsecureOrigin:"The Notification API may no longer be used from insecure origins. You should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",NotificationPermissionRequestedIframe:"Permission for the Notification API may no longer be requested from a cross-origin iframe. You should consider requesting permission from a top-level frame or opening a new window instead.",ObsoleteCreateImageBitmapImageOrientationNone:"Option `imageOrientation: 'none'` in createImageBitmap is deprecated. Please use createImageBitmap with option {imageOrientation: 'from-image'} instead.",ObsoleteWebRtcCipherSuite:"Your partner is negotiating an obsolete (D)TLS version. Please check with your partner to have this fixed.",OverflowVisibleOnReplacedElement:"Specifying `overflow: visible` on img, video and canvas tags may cause them to produce visual content outside of the element bounds. See https://github.com/WICG/shared-element-transitions/blob/main/debugging_overflow_on_images.md.",PaymentInstruments:"`paymentManager.instruments` is deprecated. Please use just-in-time install for payment handlers instead.",PaymentRequestCSPViolation:"Your `PaymentRequest` call bypassed Content-Security-Policy (CSP) `connect-src` directive. This bypass is deprecated. Please add the payment method identifier from the `PaymentRequest` API (in `supportedMethods` field) to your CSP `connect-src` directive.",PersistentQuotaType:"`StorageType.persistent` is deprecated. Please use standardized `navigator.storage` instead.",PictureSourceSrc:"`<source src>` with a `<picture>` parent is invalid and therefore ignored. Please use `<source srcset>` instead.",PrefixedCancelAnimationFrame:"webkitCancelAnimationFrame is vendor-specific. Please use the standard cancelAnimationFrame instead.",PrefixedRequestAnimationFrame:"webkitRequestAnimationFrame is vendor-specific. Please use the standard requestAnimationFrame instead.",PrefixedVideoDisplayingFullscreen:"HTMLVideoElement.webkitDisplayingFullscreen is deprecated. Please use Document.fullscreenElement instead.",PrefixedVideoEnterFullScreen:"HTMLVideoElement.webkitEnterFullScreen() is deprecated. Please use Element.requestFullscreen() instead.",PrefixedVideoEnterFullscreen:"HTMLVideoElement.webkitEnterFullscreen() is deprecated. Please use Element.requestFullscreen() instead.",PrefixedVideoExitFullScreen:"HTMLVideoElement.webkitExitFullScreen() is deprecated. Please use Document.exitFullscreen() instead.",PrefixedVideoExitFullscreen:"HTMLVideoElement.webkitExitFullscreen() is deprecated. Please use Document.exitFullscreen() instead.",PrefixedVideoSupportsFullscreen:"HTMLVideoElement.webkitSupportsFullscreen is deprecated. Please use Document.fullscreenEnabled instead.",PrivacySandboxExtensionsAPI:"We're deprecating the API `chrome.privacy.websites.privacySandboxEnabled`, though it will remain active for backward compatibility until release M113. Instead, please use `chrome.privacy.websites.topicsEnabled`, `chrome.privacy.websites.fledgeEnabled` and `chrome.privacy.websites.adMeasurementEnabled`. See https://developer.chrome.com/docs/extensions/reference/privacy/#property-websites-privacySandboxEnabled.",RangeExpand:"Range.expand() is deprecated. Please use Selection.modify() instead.",RequestedSubresourceWithEmbeddedCredentials:"Subresource requests whose URLs contain embedded credentials (e.g. `https://user:pass@host/`) are blocked.",RTCConstraintEnableDtlsSrtpFalse:"The constraint `DtlsSrtpKeyAgreement` is removed. You have specified a `false` value for this constraint, which is interpreted as an attempt to use the removed `SDES key negotiation` method. This functionality is removed; use a service that supports `DTLS key negotiation` instead.",RTCConstraintEnableDtlsSrtpTrue:"The constraint `DtlsSrtpKeyAgreement` is removed. You have specified a `true` value for this constraint, which had no effect, but you can remove this constraint for tidiness.",RTCPeerConnectionGetStatsLegacyNonCompliant:"The callback-based getStats() is deprecated and will be removed. Use the spec-compliant getStats() instead.",RtcpMuxPolicyNegotiate:"The `rtcpMuxPolicy` option is deprecated and will be removed.",SharedArrayBufferConstructedWithoutIsolation:"`SharedArrayBuffer` will require cross-origin isolation. See https://developer.chrome.com/blog/enabling-shared-array-buffer/ for more details.",TextToSpeech_DisallowedByAutoplay:"`speechSynthesis.speak()` without user activation is deprecated and will be removed.",UnloadHandler:"Unload event listeners are deprecated and will be removed.",V8SharedArrayBufferConstructedInExtensionWithoutIsolation:"Extensions should opt into cross-origin isolation to continue using `SharedArrayBuffer`. See https://developer.chrome.com/docs/extensions/mv3/cross-origin-isolation/.",WebSQL:"Web SQL is deprecated. Please use SQLite WebAssembly or Indexed Database",WindowPlacementPermissionDescriptorUsed:"The permission descriptor `window-placement` is deprecated. Use `window-management` instead. For more help, check https://bit.ly/window-placement-rename.",WindowPlacementPermissionPolicyParsed:"The permission policy `window-placement` is deprecated. Use `window-management` instead. For more help, check https://bit.ly/window-placement-rename.",XHRJSONEncodingDetection:"UTF-16 is not supported by response json in `XMLHttpRequest`",XMLHttpRequestSynchronousInNonWorkerOutsideBeforeUnload:"Synchronous `XMLHttpRequest` on the main thread is deprecated because of its detrimental effects to the end user's experience. For more help, check https://xhr.spec.whatwg.org/.",XRSupportsSession:"`supportsSession()` is deprecated. Please use `isSessionSupported()` and check the resolved boolean value instead."},Je={AuthorizationCoveredByWildcard:{milestone:97},CSSSelectorInternalMediaControlsOverlayCastButton:{chromeStatusFeature:5714245488476160},CSSValueAppearanceNonStandard:{chromeStatusFeature:5066630972833792},CSSValueAppearanceSliderVertical:{chromeStatusFeature:6001359429566464},CanRequestURLHTTPContainingNewline:{chromeStatusFeature:5735596811091968},ChromeLoadTimesConnectionInfo:{chromeStatusFeature:5637885046816768},ChromeLoadTimesFirstPaintAfterLoadTime:{chromeStatusFeature:5637885046816768},ChromeLoadTimesWasAlternateProtocolAvailable:{chromeStatusFeature:5637885046816768},CookieWithTruncatingChar:{milestone:103},CrossOriginAccessBasedOnDocumentDomain:{milestone:115},DOMMutationEvents:{chromeStatusFeature:5083947249172480,milestone:127},DataUrlInSvgUse:{chromeStatusFeature:5128825141198848,milestone:119},DocumentDomainSettingWithoutOriginAgentClusterHeader:{milestone:115},IdentityInCanMakePaymentEvent:{chromeStatusFeature:5190978431352832},InsecurePrivateNetworkSubresourceRequest:{chromeStatusFeature:5436853517811712,milestone:92},LocalCSSFileExtensionRejected:{milestone:64},MediaSourceAbortRemove:{chromeStatusFeature:6107495151960064},MediaSourceDurationTruncatingBuffered:{chromeStatusFeature:6107495151960064},NoSysexWebMIDIWithoutPermission:{chromeStatusFeature:5138066234671104,milestone:82},NonStandardDeclarativeShadowDOM:{chromeStatusFeature:6239658726391808,milestone:119},NotificationPermissionRequestedIframe:{chromeStatusFeature:6451284559265792},ObsoleteCreateImageBitmapImageOrientationNone:{milestone:111},ObsoleteWebRtcCipherSuite:{milestone:81},OverflowVisibleOnReplacedElement:{chromeStatusFeature:5137515594383360,milestone:108},PaymentInstruments:{chromeStatusFeature:5099285054488576},PaymentRequestCSPViolation:{chromeStatusFeature:6286595631087616},PersistentQuotaType:{chromeStatusFeature:5176235376246784,milestone:106},RTCConstraintEnableDtlsSrtpFalse:{milestone:97},RTCConstraintEnableDtlsSrtpTrue:{milestone:97},RTCPeerConnectionGetStatsLegacyNonCompliant:{chromeStatusFeature:4631626228695040,milestone:117},RequestedSubresourceWithEmbeddedCredentials:{chromeStatusFeature:5669008342777856},RtcpMuxPolicyNegotiate:{chromeStatusFeature:5654810086866944,milestone:62},SharedArrayBufferConstructedWithoutIsolation:{milestone:106},TextToSpeech_DisallowedByAutoplay:{chromeStatusFeature:5687444770914304,milestone:71},UnloadHandler:{chromeStatusFeature:5579556305502208},V8SharedArrayBufferConstructedInExtensionWithoutIsolation:{milestone:96},WebSQL:{chromeStatusFeature:5134293578285056,milestone:115},WindowPlacementPermissionDescriptorUsed:{chromeStatusFeature:5137018030391296,milestone:112},WindowPlacementPermissionPolicyParsed:{chromeStatusFeature:5137018030391296,milestone:112},XHRJSONEncodingDetection:{milestone:93},XRSupportsSession:{milestone:80}},Ye={feature:"Check the feature status page for more details.",milestone:"This change will go into effect with milestone {milestone}.",title:"Deprecated feature used"},Xe=s.i18n.registerUIStrings("models/issues_manager/DeprecationIssue.ts",Ye),Ze=s.i18n.getLazilyComputedLocalizedString.bind(void 0,Xe),et=s.i18n.registerUIStrings("generated/Deprecation.ts",Qe),tt=s.i18n.getLazilyComputedLocalizedString.bind(void 0,et);class st extends m{#n;constructor(e,t){super({code:["DeprecationIssue",e.type].join("::"),umaCode:"DeprecationIssue"},t),this.#n=e}getCategory(){return c.Other}details(){return this.#n}getDescription(){let e=()=>"";const t=Qe[this.#n.type];t&&(e=tt(t));const s=[],i=Je[this.#n.type],r=i?.chromeStatusFeature??0;0!==r&&s.push({link:`https://chromestatus.com/feature/${r}`,linkTitle:Ze(Ye.feature)});const n=i?.milestone??0;return 0!==n&&s.push({link:"https://chromiumdash.appspot.com/schedule",linkTitle:Ze(Ye.milestone,{milestone:n})}),v({file:"deprecation.md",substitutions:new Map([["PLACEHOLDER_title",Ze(Ye.title)],["PLACEHOLDER_message",e]]),links:s})}sources(){return this.#n.sourceCodeLocation?[this.#n.sourceCodeLocation]:[]}primaryKey(){return JSON.stringify(this.#n)}getKind(){return g.BreakingChange}static fromInspectorIssue(e,t){const s=t.details.deprecationIssueDetails;return s?[new st(s,e)]:(console.warn("Deprecation issue without details received."),[])}}var it=Object.freeze({__proto__:null,DeprecationIssue:st});const rt={fedCmUserInfo:"Federated Credential Management User Info API"},nt=s.i18n.registerUIStrings("models/issues_manager/FederatedAuthUserInfoRequestIssue.ts",rt),ot=s.i18n.getLazilyComputedLocalizedString.bind(void 0,nt);class at extends m{#n;constructor(e,t){super({code:"FederatedAuthUserInfoRequestIssue",umaCode:["FederatedAuthUserInfoRequestIssue",e.federatedAuthUserInfoRequestIssueReason].join("::")},t),this.#n=e}getCategory(){return c.Other}details(){return this.#n}getDescription(){const e=ut.get(this.#n.federatedAuthUserInfoRequestIssueReason);return e?v(e):null}primaryKey(){return JSON.stringify(this.#n)}getKind(){return g.PageError}static fromInspectorIssue(e,t){const s=t.details.federatedAuthUserInfoRequestIssueDetails;return s?[new at(s,e)]:(console.warn("Federated auth user info request issue without details received."),[])}}const ut=new Map([["NotSameOrigin",{file:"federatedAuthUserInfoRequestNotSameOrigin.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}],["NotIframe",{file:"federatedAuthUserInfoRequestNotIframe.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}],["NotPotentiallyTrustworthy",{file:"federatedAuthUserInfoRequestNotPotentiallyTrustworthy.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}],["NoApiPermission",{file:"federatedAuthUserInfoRequestNoApiPermission.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}],["NotSignedInWithIdp",{file:"federatedAuthUserInfoRequestNotSignedInWithIdp.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}],["NoAccountSharingPermission",{file:"federatedAuthUserInfoRequestNoAccountSharingPermission.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}],["InvalidConfigOrWellKnown",{file:"federatedAuthUserInfoRequestInvalidConfigOrWellKnown.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}],["InvalidAccountsResponse",{file:"federatedAuthUserInfoRequestInvalidAccountsResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}],["NoReturningUserFromFetchedAccounts",{file:"federatedAuthUserInfoRequestNoReturningUserFromFetchedAccounts.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:ot(rt.fedCmUserInfo)}]}]]);var lt=Object.freeze({__proto__:null,FederatedAuthUserInfoRequestIssue:at});const dt={crossOriginPortalPostMessage:"Portals - Same-origin communication channels",howDoesAutofillWorkPageTitle:"How does autofill work?",labelFormlementsPageTitle:"The label elements",inputFormElementPageTitle:"The form input element",autocompleteAttributePageTitle:"HTML attribute: autocomplete",corbExplainerPageTitle:"CORB explainer"},ct=s.i18n.registerUIStrings("models/issues_manager/GenericIssue.ts",dt),gt=s.i18n.getLazilyComputedLocalizedString.bind(void 0,ct);class mt extends m{#n;constructor(e,t,s){super(["GenericIssue",e.errorType].join("::"),t,s),this.#n=e}requests(){return this.#n.request?[this.#n.request]:[]}getCategory(){return c.Generic}primaryKey(){const e=this.#n.request?this.#n.request.requestId:"no-request";return`${this.code()}-(${this.#n.frameId})-(${this.#n.violatingNodeId})-(${this.#n.violatingNodeAttribute})-(${e})`}getDescription(){const e=At.get(this.#n.errorType);return e?v(e):null}details(){return this.#n}getKind(){return Tt.get(this.#n.errorType)||g.Improvement}static fromInspectorIssue(e,t){const s=t.details.genericIssueDetails;return s?[new mt(s,e,t.issueId)]:(console.warn("Generic issue without details received."),[])}}const ht={file:"genericCrossOriginPortalPostMessageError.md",links:[{link:"https://github.com/WICG/portals#same-origin-communication-channels",linkTitle:gt(dt.crossOriginPortalPostMessage)}]},pt={file:"genericFormLabelForNameError.md",links:[{link:"https://html.spec.whatwg.org/multipage/forms.html#attr-label-for",linkTitle:s.i18n.lockedLazyString("HTML Standard")}]},It={file:"genericFormInputWithNoLabelError.md",links:[]},ft={file:"genericFormAutocompleteAttributeEmptyError.md",links:[]},kt={file:"genericFormDuplicateIdForInputError.md",links:[{link:"https://web.dev/learn/forms/autofill/#how-does-autofill-work",linkTitle:gt(dt.howDoesAutofillWorkPageTitle)}]},Ct={file:"genericFormAriaLabelledByToNonExistingId.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Element/label",linkTitle:gt(dt.labelFormlementsPageTitle)}]},St={file:"genericFormEmptyIdAndNameAttributesForInputError.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input",linkTitle:gt(dt.inputFormElementPageTitle)}]},yt={file:"genericFormInputAssignedAutocompleteValueToIdOrNameAttributeError.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/autocomplete#values",linkTitle:gt(dt.autocompleteAttributePageTitle)}]},vt={file:"genericFormInputHasWrongButWellIntendedAutocompleteValueError.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/autocomplete#values",linkTitle:gt(dt.autocompleteAttributePageTitle)}]},wt={file:"genericFormLabelForMatchesNonExistingIdError.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Element/label",linkTitle:gt(dt.labelFormlementsPageTitle)}]},bt={file:"genericFormLabelHasNeitherForNorNestedInput.md",links:[{link:"https://developer.mozilla.org/en-US/docs/Web/HTML/Element/label",linkTitle:gt(dt.labelFormlementsPageTitle)}]},Pt={file:"genericResponseWasBlockedByORB.md",links:[{link:"https://www.chromium.org/Home/chromium-security/corb-for-developers/",linkTitle:gt(dt.corbExplainerPageTitle)}]},At=new Map([["CrossOriginPortalPostMessageError",ht],["FormLabelForNameError",pt],["FormInputWithNoLabelError",It],["FormAutocompleteAttributeEmptyError",ft],["FormDuplicateIdForInputError",kt],["FormAriaLabelledByToNonExistingId",Ct],["FormEmptyIdAndNameAttributesForInputError",St],["FormInputAssignedAutocompleteValueToIdOrNameAttributeError",yt],["FormLabelForMatchesNonExistingIdError",wt],["FormLabelHasNeitherForNorNestedInput",bt],["FormInputHasWrongButWellIntendedAutocompleteValueError",vt],["ResponseWasBlockedByORB",Pt]]),Tt=new Map([["CrossOriginPortalPostMessageError",g.Improvement],["FormLabelForNameError",g.PageError],["FormInputWithNoLabelError",g.Improvement],["FormAutocompleteAttributeEmptyError",g.PageError],["FormDuplicateIdForInputError",g.PageError],["FormAriaLabelledByToNonExistingId",g.Improvement],["FormEmptyIdAndNameAttributesForInputError",g.Improvement],["FormInputAssignedAutocompleteValueToIdOrNameAttributeError",g.Improvement],["FormLabelForMatchesNonExistingIdError",g.PageError],["FormLabelHasNeitherForNorNestedInput",g.Improvement],["FormInputHasWrongButWellIntendedAutocompleteValueError",g.Improvement]]);var Rt=Object.freeze({__proto__:null,GenericIssue:mt,genericCrossOriginPortalPostMessageError:ht,genericFormLabelForNameError:pt,genericFormInputWithNoLabelError:It,genericFormAutocompleteAttributeEmptyError:ft,genericFormDuplicateIdForInputError:kt,genericFormAriaLabelledByToNonExistingId:Ct,genericFormEmptyIdAndNameAttributesForInputError:St,genericFormInputAssignedAutocompleteValueToIdOrNameAttributeError:yt,genericFormInputHasWrongButWellIntendedAutocompleteValue:vt,genericFormLabelForMatchesNonExistingIdError:wt,genericFormLabelHasNeitherForNorNestedInput:bt,genericResponseWasBlockedbyORB:Pt});const Dt={handlingHeavyAdInterventions:"Handling Heavy Ad Interventions"},Mt=s.i18n.registerUIStrings("models/issues_manager/HeavyAdIssue.ts",Dt),Et=s.i18n.getLocalizedString.bind(void 0,Mt);class Nt extends m{#n;constructor(e,t){super({code:"HeavyAdIssue",umaCode:["HeavyAdIssue",e.reason].join("::")},t),this.#n=e}details(){return this.#n}primaryKey(){return`HeavyAdIssue-${JSON.stringify(this.#n)}`}getDescription(){return{file:"heavyAd.md",links:[{link:"https://developers.google.com/web/updates/2020/05/heavy-ad-interventions",linkTitle:Et(Dt.handlingHeavyAdInterventions)}]}}getCategory(){return c.HeavyAd}getKind(){switch(this.#n.resolution){case"HeavyAdBlocked":return g.PageError;case"HeavyAdWarning":return g.BreakingChange}}static fromInspectorIssue(e,t){const s=t.details.heavyAdIssueDetails;return s?[new Nt(s,e)]:(console.warn("Heavy Ad issue without details received."),[])}}var Ft=Object.freeze({__proto__:null,HeavyAdIssue:Nt});const xt={bounceTrackingMitigations:"Bounce tracking mitigations"},Ot=s.i18n.registerUIStrings("models/issues_manager/BounceTrackingIssue.ts",xt),Lt=s.i18n.getLocalizedString.bind(void 0,Ot);class Ht extends m{#n;constructor(e,t){super("BounceTrackingIssue",t),this.#n=e}getCategory(){return c.Other}getDescription(){return{file:"bounceTrackingMitigations.md",links:[{link:"https://privacycg.github.io/nav-tracking-mitigations/#bounce-tracking-mitigations",linkTitle:Lt(xt.bounceTrackingMitigations)}]}}details(){return this.#n}getKind(){return g.BreakingChange}primaryKey(){return JSON.stringify(this.#n)}trackingSites(){return this.#n.trackingSites?this.#n.trackingSites:[]}static fromInspectorIssue(e,t){const s=t.details.bounceTrackingIssueDetails;return s?[new Ht(s,e)]:(console.warn("Bounce tracking issue without details received."),[])}}const Wt={thirdPartyPhaseoutExplained:"Prepare for phasing out third-party cookies"},Ut=s.i18n.registerUIStrings("models/issues_manager/CookieDeprecationMetadataIssue.ts",Wt),Bt=s.i18n.getLocalizedString.bind(void 0,Ut);class _t extends m{#n;constructor(e,t){super("CookieDeprecationMetadataIssue",t),this.#n=e}getCategory(){return c.Other}getDescription(){return{file:"cookieWarnMetadataGrantRead.md",links:[{link:"https://developer.chrome.com/docs/privacy-sandbox/third-party-cookie-phase-out/",linkTitle:Bt(Wt.thirdPartyPhaseoutExplained)}]}}details(){return this.#n}getKind(){return g.BreakingChange}primaryKey(){return JSON.stringify(this.#n)}metadataAllowedSites(){return this.#n.allowedSites?this.#n.allowedSites:[]}static fromInspectorIssue(e,t){const s=t.details.cookieDeprecationMetadataIssueDetails;return s?[new _t(s,e)]:(console.warn("Cookie deprecation metadata issue without details received."),[])}}const qt={fedCm:"Federated Credential Management API"},zt=s.i18n.registerUIStrings("models/issues_manager/FederatedAuthRequestIssue.ts",qt),Vt=s.i18n.getLazilyComputedLocalizedString.bind(void 0,zt);class jt extends m{#n;constructor(e,t){super({code:"FederatedAuthRequestIssue",umaCode:["FederatedAuthRequestIssue",e.federatedAuthRequestIssueReason].join("::")},t),this.#n=e}getCategory(){return c.Other}details(){return this.#n}getDescription(){const e=Kt.get(this.#n.federatedAuthRequestIssueReason);return e?v(e):null}primaryKey(){return JSON.stringify(this.#n)}getKind(){return g.PageError}static fromInspectorIssue(e,t){const s=t.details.federatedAuthRequestIssueDetails;return s?[new jt(s,e)]:(console.warn("Federated auth request issue without details received."),[])}}const Kt=new Map([["TooManyRequests",{file:"federatedAuthRequestTooManyRequests.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["ConfigHttpNotFound",{file:"federatedAuthRequestManifestHttpNotFound.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["ConfigNoResponse",{file:"federatedAuthRequestManifestNoResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["ConfigInvalidResponse",{file:"federatedAuthRequestManifestInvalidResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["ClientMetadataHttpNotFound",{file:"federatedAuthRequestClientMetadataHttpNotFound.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["ClientMetadataNoResponse",{file:"federatedAuthRequestClientMetadataNoResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["ClientMetadataInvalidResponse",{file:"federatedAuthRequestClientMetadataInvalidResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["ErrorFetchingSignin",{file:"federatedAuthRequestErrorFetchingSignin.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["InvalidSigninResponse",{file:"federatedAuthRequestInvalidSigninResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["AccountsHttpNotFound",{file:"federatedAuthRequestAccountsHttpNotFound.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["AccountsNoResponse",{file:"federatedAuthRequestAccountsNoResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["AccountsInvalidResponse",{file:"federatedAuthRequestAccountsInvalidResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["IdTokenHttpNotFound",{file:"federatedAuthRequestIdTokenHttpNotFound.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["IdTokenNoResponse",{file:"federatedAuthRequestIdTokenNoResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["IdTokenInvalidResponse",{file:"federatedAuthRequestIdTokenInvalidResponse.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["IdTokenInvalidRequest",{file:"federatedAuthRequestIdTokenInvalidRequest.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["ErrorIdToken",{file:"federatedAuthRequestErrorIdToken.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}],["Canceled",{file:"federatedAuthRequestCanceled.md",links:[{link:"https://fedidcg.github.io/FedCM/",linkTitle:Vt(qt.fedCm)}]}]]),$t={colorAndContrastAccessibility:"Color and contrast accessibility"},Gt=s.i18n.registerUIStrings("models/issues_manager/LowTextContrastIssue.ts",$t),Qt=s.i18n.getLocalizedString.bind(void 0,Gt);class Jt extends m{#n;constructor(e,t){super("LowTextContrastIssue",t),this.#n=e}primaryKey(){return`${this.code()}-(${this.#n.violatingNodeId})`}getCategory(){return c.LowTextContrast}details(){return this.#n}getDescription(){return{file:"LowTextContrast.md",links:[{link:"https://web.dev/color-and-contrast-accessibility/",linkTitle:Qt($t.colorAndContrastAccessibility)}]}}getKind(){return g.Improvement}static fromInspectorIssue(e,t){const s=t.details.lowTextContrastIssueDetails;return s?[new Jt(s,e)]:(console.warn("LowTextContrast issue without details received."),[])}}var Yt=Object.freeze({__proto__:null,LowTextContrastIssue:Jt});const Xt={preventingMixedContent:"Preventing mixed content"},Zt=s.i18n.registerUIStrings("models/issues_manager/MixedContentIssue.ts",Xt),es=s.i18n.getLocalizedString.bind(void 0,Zt);class ts extends m{#n;constructor(e,t){super("MixedContentIssue",t),this.#n=e}requests(){return this.#n.request?[this.#n.request]:[]}getDetails(){return this.#n}getCategory(){return c.MixedContent}getDescription(){return{file:"mixedContent.md",links:[{link:"https://web.dev/what-is-mixed-content/",linkTitle:es(Xt.preventingMixedContent)}]}}primaryKey(){return JSON.stringify(this.#n)}getKind(){switch(this.#n.resolutionStatus){case"MixedContentAutomaticallyUpgraded":case"MixedContentWarning":return g.Improvement;case"MixedContentBlocked":return g.PageError}}static fromInspectorIssue(e,t){const s=t.details.mixedContentIssueDetails;return s?[new ts(s,e)]:(console.warn("Mixed content issue without details received."),[])}}var ss=Object.freeze({__proto__:null,MixedContentIssue:ts});class is extends m{#n;#c;constructor(e,t){const s=JSON.stringify(e);super(s,t),this.#c=s,this.#n=e}sources(){return[this.#n.sourceCodeLocation]}details(){return this.#n}primaryKey(){return this.#c}getPropertyName(){switch(this.#n.propertyRuleIssueReason){case"InvalidInherits":return"inherits";case"InvalidInitialValue":return"initial-value";case"InvalidSyntax":return"syntax"}return""}getDescription(){if("InvalidName"===this.#n.propertyRuleIssueReason)return{file:"propertyRuleInvalidNameIssue.md",links:[]};const e=this.#n.propertyValue?`: ${this.#n.propertyValue}`:"",t=`${this.getPropertyName()}${e}`;return{file:"propertyRuleIssue.md",substitutions:new Map([["PLACEHOLDER_property",t]]),links:[]}}getCategory(){return c.Other}getKind(){return g.PageError}static fromInspectorIssue(e,t){const s=t.details.propertyRuleIssueDetails;return s?[new is(s,e)]:(console.warn("Property rule issue without details received"),[])}}var rs=Object.freeze({__proto__:null,PropertyRuleIssue:is});const ns={documentCompatibilityMode:"Document compatibility mode"},os=s.i18n.registerUIStrings("models/issues_manager/QuirksModeIssue.ts",ns),as=s.i18n.getLocalizedString.bind(void 0,os);class us extends m{#n;constructor(e,t){super({code:"QuirksModeIssue",umaCode:["QuirksModeIssue",e.isLimitedQuirksMode?"LimitedQuirksMode":"QuirksMode"].join("::")},t),this.#n=e}primaryKey(){return`${this.code()}-(${this.#n.documentNodeId})-(${this.#n.url})`}getCategory(){return c.QuirksMode}details(){return this.#n}getDescription(){return{file:"CompatibilityModeQuirks.md",links:[{link:"https://web.dev/doctype/",linkTitle:as(ns.documentCompatibilityMode)}]}}getKind(){return g.Improvement}static fromInspectorIssue(e,t){const s=t.details.quirksModeIssueDetails;return s?[new us(s,e)]:(console.warn("Quirks Mode issue without details received."),[])}}var ls=Object.freeze({__proto__:null,QuirksModeIssue:us});const ds={enablingSharedArrayBuffer:"Enabling `SharedArrayBuffer`"},cs=s.i18n.registerUIStrings("models/issues_manager/SharedArrayBufferIssue.ts",ds),gs=s.i18n.getLocalizedString.bind(void 0,cs);class ms extends m{#n;constructor(e,t){super({code:"SharedArrayBufferIssue",umaCode:["SharedArrayBufferIssue",e.type].join("::")},t),this.#n=e}getCategory(){return c.Other}details(){return this.#n}getDescription(){return{file:"sharedArrayBuffer.md",links:[{link:"https://developer.chrome.com/blog/enabling-shared-array-buffer/",linkTitle:gs(ds.enablingSharedArrayBuffer)}]}}primaryKey(){return JSON.stringify(this.#n)}getKind(){return this.#n.isWarning?g.BreakingChange:g.PageError}static fromInspectorIssue(e,t){const s=t.details.sharedArrayBufferIssueDetails;return s?[new ms(s,e)]:(console.warn("SAB transfer issue without details received."),[])}}var hs=Object.freeze({__proto__:null,SharedArrayBufferIssue:ms});const ps=["StylesheetLoadingIssue","LateImportRule"].join("::");class Is extends m{#n;constructor(e,t){super(`StylesheetLoadingIssue::${e.styleSheetLoadingIssueReason}`,t),this.#n=e}sources(){return[this.#n.sourceCodeLocation]}requests(){if(!this.#n.failedRequestInfo)return[];const{url:e,requestId:t}=this.#n.failedRequestInfo;return t?[{url:e,requestId:t}]:[]}details(){return this.#n}primaryKey(){return JSON.stringify(this.#n)}getDescription(){switch(this.#n.styleSheetLoadingIssueReason){case"LateImportRule":return{file:"stylesheetLateImport.md",links:[]};case"RequestFailed":return{file:"stylesheetRequestFailed.md",links:[]}}}getCategory(){return c.Other}getKind(){return g.PageError}static fromInspectorIssue(e,t){const s=t.details.stylesheetLoadingIssueDetails;return s?[new Is(s,e)]:(console.warn("Stylesheet loading issue without details received"),[])}}var fs=Object.freeze({__proto__:null,lateImportStylesheetLoadingCode:ps,StylesheetLoadingIssue:Is});class ks{issuesManager;#g=new o.PresentationConsoleMessageHelper.PresentationSourceFrameMessageManager;constructor(e){this.issuesManager=e,this.issuesManager.addEventListener("IssueAdded",this.#m,this),this.issuesManager.addEventListener("FullUpdateRequired",this.#h,this)}#m(e){const{issue:t}=e.data;this.#p(t)}async#p(t){if(!this.#I(t)&&!this.#f(t)&&!this.#k(t))return;const s=t.model();if(!s)return;const i=h(t.details().sourceCodeLocation),r=t.getDescription();if(!r||!i)return;const n=await M(r);if(!n)return;this.#g.addMessage(new Cs(n,t.getKind(),(()=>{e.Revealer.reveal(t)})),{line:i.lineNumber,column:i.columnNumber??-1,url:i.url,scriptId:i.scriptId},s.target())}#h(){this.#C();const e=this.issuesManager.issues();for(const t of e)this.#p(t)}#I(e){return e instanceof _&&e.code()===J||e.code()===Y}#k(e){return e instanceof is}#f(e){return e.code()===ps}#C(){this.#g.clear()}}class Cs extends a.UISourceCode.Message{#S;constructor(e,t,s){super(a.UISourceCode.Message.Level.Issue,e,s),this.#S=t}getIssueKind(){return this.#S}}var Ss=Object.freeze({__proto__:null,SourceFrameIssuesManager:ks,IssueMessage:Cs});let ys=null;const vs=new Map([["CookieIssue",oe.fromInspectorIssue],["MixedContentIssue",ts.fromInspectorIssue],["HeavyAdIssue",Nt.fromInspectorIssue],["ContentSecurityPolicyIssue",_.fromInspectorIssue],["BlockedByResponseIssue",function(e,t){const s=t.details.blockedByResponseIssueDetails;return s?je(s.reason)?[new Ke(s,e)]:[]:(console.warn("BlockedByResponse issue without details received."),[])}],["SharedArrayBufferIssue",ms.fromInspectorIssue],["LowTextContrastIssue",Jt.fromInspectorIssue],["CorsIssue",Be.fromInspectorIssue],["QuirksModeIssue",us.fromInspectorIssue],["AttributionReportingIssue",f.fromInspectorIssue],["GenericIssue",mt.fromInspectorIssue],["DeprecationIssue",st.fromInspectorIssue],["ClientHintIssue",O.fromInspectorIssue],["FederatedAuthRequestIssue",jt.fromInspectorIssue],["BounceTrackingIssue",Ht.fromInspectorIssue],["StylesheetLoadingIssue",Is.fromInspectorIssue],["PropertyRuleIssue",is.fromInspectorIssue],["CookieDeprecationMetadataIssue",_t.fromInspectorIssue]]);function ws(){return{}}class bs extends e.ObjectWrapper.ObjectWrapper{showThirdPartyIssuesSetting;hideIssueSetting;#y=new WeakMap;#v=new Map;#w=new Map;#b=new Map;#P=new Map;#A=!1;#T=new Map;#R=new Map;constructor(e,t){super(),this.showThirdPartyIssuesSetting=e,this.hideIssueSetting=t,new ks(this),i.TargetManager.TargetManager.instance().observeModels(i.IssuesModel.IssuesModel,this),i.TargetManager.TargetManager.instance().addModelListener(i.ResourceTreeModel.ResourceTreeModel,i.ResourceTreeModel.Events.PrimaryPageChanged,this.#D,this),i.FrameManager.FrameManager.instance().addEventListener(i.FrameManager.Events.FrameAddedToTarget,this.#M,this),this.showThirdPartyIssuesSetting?.addChangeListener((()=>this.#E())),this.hideIssueSetting?.addChangeListener((()=>this.#E())),i.TargetManager.TargetManager.instance().observeTargets({targetAdded:e=>{e.outermostTarget()===e&&this.#E()},targetRemoved:e=>{}},{scoped:!0})}static instance(e={forceNew:!1,ensureFirst:!1}){if(ys&&e.ensureFirst)throw new Error('IssuesManager was already created. Either set "ensureFirst" to false or make sure that this invocation is really the first one.');return ys&&!e.forceNew||(ys=new bs(e.showThirdPartyIssuesSetting,e.hideIssueSetting)),ys}static removeInstance(){ys=null}reloadForAccurateInformationRequired(){return!this.#A}#D(e){const{frame:t,type:s}=e.data,r=new Map;for(const[e,n]of this.#v.entries())if(n.isAssociatedWithRequestId(t.loaderId))r.set(e,n);else if("Activation"===s&&t.resourceTreeModel().target()===n.model()?.target())r.set(e,n);else if("BounceTrackingIssue"===n.code()||"CookieIssue"===n.code()){const s=t.resourceTreeModel().target().model(i.NetworkManager.NetworkManager);!1===s?.requestForLoaderId(t.loaderId)?.hasUserGesture()&&r.set(e,n)}this.#v=r,this.#A=!0,this.#E()}#M(e){const{frame:t}=e.data;t.isOutermostFrame()&&i.TargetManager.TargetManager.instance().isInScope(t.resourceTreeModel())&&this.#E()}modelAdded(e){const t=e.addEventListener("IssueAdded",this.#N,this);this.#y.set(e,t)}modelRemoved(t){const s=this.#y.get(t);s&&e.EventTarget.removeEventListeners([s])}#N(e){const{issuesModel:t,inspectorIssue:s}=e.data,i=function(e,t){const s=vs.get(t.code);return s?s(e,t):(console.warn(`No handler registered for issue code ${t.code}`),[])}(t,s);for(const e of i)this.addIssue(t,e)}addIssue(e,t){if(!t.getDescription())return;const s=t.primaryKey();if(this.#v.has(s))return;this.#v.set(s,t);const i=e.target().outermostTarget();if(i){let e=this.#R.get(i);e||(e=new Set,this.#R.set(i,e)),e.add(t)}if(this.#F(t)){this.#w.set(s,t),this.#b.set(t.getKind(),1+(this.#b.get(t.getKind())||0));const i=t.getIssueId();i&&this.#T.set(i,t);const r=this.hideIssueSetting?.get();this.#x(t,r),t.isHidden()&&this.#P.set(t.getKind(),1+(this.#P.get(t.getKind())||0)),this.dispatchEventToListeners("IssueAdded",{issuesModel:e,issue:t})}this.dispatchEventToListeners("IssuesCountUpdated")}issues(){return this.#w.values()}numberOfIssues(e){return e?(this.#b.get(e)??0)-this.numberOfHiddenIssues(e):this.#w.size-this.numberOfHiddenIssues()}numberOfHiddenIssues(e){if(e)return this.#P.get(e)??0;let t=0;for(const e of this.#P.values())t+=e;return t}numberOfAllStoredIssues(){return this.#v.size}#F(e){const t=i.TargetManager.TargetManager.instance().scopeTarget();return!!t&&(!!this.#R.get(t)?.has(e)&&(this.showThirdPartyIssuesSetting?.get()||!e.isCausedByThirdParty()))}#x(e,t){const s=e.code();if(t&&t[s])return"Hidden"===t[s]?void e.setHidden(!0):void e.setHidden(!1)}#E(){this.#w.clear(),this.#b.clear(),this.#T.clear(),this.#P.clear();const e=this.hideIssueSetting?.get();for(const[t,s]of this.#v)if(this.#F(s)){this.#x(s,e),this.#w.set(t,s),this.#b.set(s.getKind(),1+(this.#b.get(s.getKind())??0)),s.isHidden()&&this.#P.set(s.getKind(),1+(this.#P.get(s.getKind())||0));const i=s.getIssueId();i&&this.#T.set(i,s)}this.dispatchEventToListeners("FullUpdateRequired"),this.dispatchEventToListeners("IssuesCountUpdated")}unhideAllIssues(){for(const e of this.#v.values())e.setHidden(!1);this.hideIssueSetting?.set({})}getIssueById(e){return this.#T.get(e)}}globalThis.addIssueForTest=e=>{const t=i.TargetManager.TargetManager.instance().primaryPageTarget(),s=t?.model(i.IssuesModel.IssuesModel);s?.issueAdded({issue:e})};var Ps=Object.freeze({__proto__:null,defaultHideIssueByCodeSetting:ws,getHideIssueByCodeSetting:function(){return e.Settings.Settings.instance().createSetting("HideIssueByCodeSetting-Experiment-2021",{})},IssuesManager:bs});class As extends e.ResolverBase.ResolverBase{#O=null;#L;constructor(e=bs.instance()){super(),this.#L=e}getForId(e){return this.#L.getIssueById(e)||null}#m(e){const{issue:t}=e.data,s=t.getIssueId();s&&this.onResolve(s,t)}startListening(){this.#O||(this.#O=this.#L.addEventListener("IssueAdded",this.#m,this))}stopListening(){this.#O&&(e.EventTarget.removeEventListeners([this.#O]),this.#O=null)}}var Ts=Object.freeze({__proto__:null,IssueResolver:As});function Rs(e,t){if(t instanceof i.NetworkRequest.NetworkRequest)return function(e,t){return e.filter((e=>{for(const s of e.requests())if(s.requestId===t.requestId())return!0;return!1}))}(e,t);if(t instanceof i.Cookie.Cookie)return function(e,t,s,i){return e.filter((e=>{for(const r of e.cookies())if(r.domain===t&&r.name===s&&r.path===i)return!0;return!1}))}(e,t.domain(),t.name(),t.path());throw new Error(`issues can not be associated with ${JSON.stringify(t)}`)}var Ds=Object.freeze({__proto__:null,issuesAssociatedWith:Rs,hasIssues:function(e){return Rs(Array.from(bs.instance().issues()),e).length>0},hasIssueOfCategory:function(e,t){return Rs(Array.from(bs.instance().issues()),e).some((e=>e.getCategory()===t))},hasThirdPartyPhaseoutCookieIssue:function(e){return Rs(Array.from(bs.instance().issues()),e).some((e=>"ThirdPartyPhaseoutCookie"===oe.getSubCategory(e.code())))},hasThirdPartyPhaseoutCookieIssueForDomain:function(e){return Array.from(bs.instance().issues()).filter((t=>Array.from(t.cookies()).some((t=>t.domain===e)))).some((e=>"ThirdPartyPhaseoutCookie"===oe.getSubCategory(e.code())))},reveal:async function(t,s){if("string"==typeof t){const s=bs.instance().getIssueById(t);if(s)return e.Revealer.reveal(s)}const i=Rs(Array.from(bs.instance().issues()),t).filter((e=>!s||e.getCategory()===s));if(i.length>0)return e.Revealer.reveal(i[0])}});export{k as AttributionReportingIssue,y as CheckFormsIssuesTrigger,H as ClientHintIssue,Z as ContentSecurityPolicyIssue,se as ContrastCheckTrigger,xe as CookieIssue,_e as CorsIssue,Ge as CrossOriginEmbedderPolicyIssue,it as DeprecationIssue,lt as FederatedAuthUserInfoRequestIssue,Rt as GenericIssue,Ft as HeavyAdIssue,p as Issue,Ts as IssueResolver,Ps as IssuesManager,Yt as LowTextContrastIssue,E as MarkdownIssueDescription,ss as MixedContentIssue,rs as PropertyRuleIssue,ls as QuirksModeIssue,Ds as RelatedIssue,hs as SharedArrayBufferIssue,Ss as SourceFrameIssuesManager,fs as StylesheetLoadingIssue};
