/**
 * Lighthouse v11.4.0 (Dec 11 2023)
 *
 * Automated auditing, performance metrics, and best practices for the web.
 *
 * @homepage https://github.com/GoogleChrome/lighthouse#readme
 * @author   Copyright 2023 Google LLC
 * @license  Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
 */
"use strict";(()=>{var Y9=Object.create;var $c=Object.defineProperty;var K9=Object.getOwnPropertyDescriptor;var X9=Object.getOwnPropertyNames;var J9=Object.getPrototypeOf,Z9=Object.prototype.hasOwnProperty;var s=(e,t)=>$c(e,"name",{value:t,configurable:!0});var b=(e,t)=>()=>(e&&(t=e(e=0)),t);var I=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),T=(e,t)=>{for(var n in t)$c(e,n,{get:t[n],enumerable:!0})},QS=(e,t,n,r)=>{if(t&&typeof t=="object"||typeof t=="function")for(let a of X9(t))!Z9.call(e,a)&&a!==n&&$c(e,a,{get:()=>t[a],enumerable:!(r=K9(t,a))||r.enumerable});return e};var Lt=(e,t,n)=>(n=e!=null?Y9(J9(e)):{},QS(t||!e||!e.__esModule?$c(n,"default",{value:e,enumerable:!0}):n,e)),Q9=e=>QS($c({},"__esModule",{value:!0}),e);function e2(){throw new Error("setTimeout has not been defined")}function t2(){throw new Error("clearTimeout has not been defined")}function n2(e){if(Ea===setTimeout)return setTimeout(e,0);if((Ea===e2||!Ea)&&setTimeout)return Ea=setTimeout,setTimeout(e,0);try{return Ea(e,0)}catch{try{return Ea.call(null,e,0)}catch{return Ea.call(this,e,0)}}}function ej(e){if(xa===clearTimeout)return clearTimeout(e);if((xa===t2||!xa)&&clearTimeout)return xa=clearTimeout,clearTimeout(e);try{return xa(e)}catch{try{return xa.call(null,e)}catch{return xa.call(this,e)}}}function tj(){!ki||!So||(ki=!1,So.length?$r=So.concat($r):km=-1,$r.length&&r2())}function r2(){if(!ki){var e=n2(tj);ki=!0;for(var t=$r.length;t;){for(So=$r,$r=[];++km<t;)So&&So[km].run();km=-1,t=$r.length}So=null,ki=!1,ej(e)}}function nn(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];$r.push(new a2(e,t)),$r.length===1&&!ki&&n2(r2)}function a2(e,t){this.fun=e,this.array=t}function ko(){}function bj(e){throw new Error("process.binding is not supported")}function vj(){return"/"}function wj(e){throw new Error("process.chdir is not supported")}function Dj(){return 0}function xj(e){var t=Ej.call(Si)*.001,n=Math.floor(t),r=Math.floor(t%1*1e9);return e&&(n=n-e[0],r=r-e[1],r<0&&(n--,r+=1e9)),[n,r]}function Sj(){var e=new Date,t=e-Tj;return t/1e3}var Ea,xa,$r,ki,So,km,nj,rj,aj,oj,ij,sj,cj,uj,lj,dj,mj,pj,fj,hj,gj,yj,Si,Ej,Tj,rn,Ta=b(()=>{d();s(e2,"defaultSetTimout");s(t2,"defaultClearTimeout");Ea=e2,xa=t2;typeof globalThis.setTimeout=="function"&&(Ea=setTimeout);typeof globalThis.clearTimeout=="function"&&(xa=clearTimeout);s(n2,"runTimeout");s(ej,"runClearTimeout");$r=[],ki=!1,km=-1;s(tj,"cleanUpNextTick");s(r2,"drainQueue");s(nn,"nextTick");s(a2,"Item");a2.prototype.run=function(){this.fun.apply(null,this.array)};nj="browser",rj="browser",aj=!0,oj={},ij=[],sj="",cj={},uj={},lj={};s(ko,"noop");dj=ko,mj=ko,pj=ko,fj=ko,hj=ko,gj=ko,yj=ko;s(bj,"binding");s(vj,"cwd");s(wj,"chdir");s(Dj,"umask");Si=globalThis.performance||{},Ej=Si.now||Si.mozNow||Si.msNow||Si.oNow||Si.webkitNow||function(){return new Date().getTime()};s(xj,"hrtime");Tj=new Date;s(Sj,"uptime");rn={nextTick:nn,title:nj,browser:aj,env:oj,argv:ij,version:sj,versions:cj,on:dj,addListener:mj,once:pj,off:fj,removeListener:hj,removeAllListeners:gj,emit:yj,binding:bj,cwd:vj,chdir:wj,umask:Dj,hrtime:xj,platform:rj,release:uj,config:lj,uptime:Sj}});var d=b(()=>{"use strict";Ta();globalThis.process=rn});function c2(){Jh=!0;for(var e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",t=0,n=e.length;t<n;++t)yr[t]=e[t],Un[e.charCodeAt(t)]=t;Un["-".charCodeAt(0)]=62,Un["_".charCodeAt(0)]=63}function Cj(e){Jh||c2();var t,n,r,a,o,i,c=e.length;if(c%4>0)throw new Error("Invalid string. Length must be a multiple of 4");o=e[c-2]==="="?2:e[c-1]==="="?1:0,i=new kj(c*3/4-o),r=o>0?c-4:c;var u=0;for(t=0,n=0;t<r;t+=4,n+=3)a=Un[e.charCodeAt(t)]<<18|Un[e.charCodeAt(t+1)]<<12|Un[e.charCodeAt(t+2)]<<6|Un[e.charCodeAt(t+3)],i[u++]=a>>16&255,i[u++]=a>>8&255,i[u++]=a&255;return o===2?(a=Un[e.charCodeAt(t)]<<2|Un[e.charCodeAt(t+1)]>>4,i[u++]=a&255):o===1&&(a=Un[e.charCodeAt(t)]<<10|Un[e.charCodeAt(t+1)]<<4|Un[e.charCodeAt(t+2)]>>2,i[u++]=a>>8&255,i[u++]=a&255),i}function Aj(e){return yr[e>>18&63]+yr[e>>12&63]+yr[e>>6&63]+yr[e&63]}function _j(e,t,n){for(var r,a=[],o=t;o<n;o+=3)r=(e[o]<<16)+(e[o+1]<<8)+e[o+2],a.push(Aj(r));return a.join("")}function o2(e){Jh||c2();for(var t,n=e.length,r=n%3,a="",o=[],i=16383,c=0,u=n-r;c<u;c+=i)o.push(_j(e,c,c+i>u?u:c+i));return r===1?(t=e[n-1],a+=yr[t>>2],a+=yr[t<<4&63],a+="=="):r===2&&(t=(e[n-2]<<8)+e[n-1],a+=yr[t>>10],a+=yr[t>>4&63],a+=yr[t<<2&63],a+="="),o.push(a),o.join("")}function _m(e,t,n,r,a){var o,i,c=a*8-r-1,u=(1<<c)-1,l=u>>1,m=-7,p=n?a-1:0,h=n?-1:1,f=e[t+p];for(p+=h,o=f&(1<<-m)-1,f>>=-m,m+=c;m>0;o=o*256+e[t+p],p+=h,m-=8);for(i=o&(1<<-m)-1,o>>=-m,m+=r;m>0;i=i*256+e[t+p],p+=h,m-=8);if(o===0)o=1-l;else{if(o===u)return i?NaN:(f?-1:1)*(1/0);i=i+Math.pow(2,r),o=o-l}return(f?-1:1)*i*Math.pow(2,o-r)}function u2(e,t,n,r,a,o){var i,c,u,l=o*8-a-1,m=(1<<l)-1,p=m>>1,h=a===23?Math.pow(2,-24)-Math.pow(2,-77):0,f=r?0:o-1,y=r?1:-1,v=t<0||t===0&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(c=isNaN(t)?1:0,i=m):(i=Math.floor(Math.log(t)/Math.LN2),t*(u=Math.pow(2,-i))<1&&(i--,u*=2),i+p>=1?t+=h/u:t+=h*Math.pow(2,1-p),t*u>=2&&(i++,u/=2),i+p>=m?(c=0,i=m):i+p>=1?(c=(t*u-1)*Math.pow(2,a),i=i+p):(c=t*Math.pow(2,p-1)*Math.pow(2,a),i=0));a>=8;e[n+f]=c&255,f+=y,c/=256,a-=8);for(i=i<<a|c,l+=a;l>0;e[n+f]=i&255,f+=y,i/=256,l-=8);e[n+f-y]|=v*128}function Cm(){return U.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function Yr(e,t){if(Cm()<t)throw new RangeError("Invalid typed array length");return U.TYPED_ARRAY_SUPPORT?(e=new Uint8Array(t),e.__proto__=U.prototype):(e===null&&(e=new U(t)),e.length=t),e}function U(e,t,n){if(!U.TYPED_ARRAY_SUPPORT&&!(this instanceof U))return new U(e,t,n);if(typeof e=="number"){if(typeof t=="string")throw new Error("If encoding is specified then the first argument must be a string");return Zh(this,e)}return d2(this,e,t,n)}function d2(e,t,n,r){if(typeof t=="number")throw new TypeError('"value" argument must not be a number');return typeof ArrayBuffer<"u"&&t instanceof ArrayBuffer?Mj(e,t,n,r):typeof t=="string"?Nj(e,t,n):Lj(e,t)}function m2(e){if(typeof e!="number")throw new TypeError('"size" argument must be a number');if(e<0)throw new RangeError('"size" argument must not be negative')}function Ij(e,t,n,r){return m2(t),t<=0?Yr(e,t):n!==void 0?typeof r=="string"?Yr(e,t).fill(n,r):Yr(e,t).fill(n):Yr(e,t)}function Zh(e,t){if(m2(t),e=Yr(e,t<0?0:Qh(t)|0),!U.TYPED_ARRAY_SUPPORT)for(var n=0;n<t;++n)e[n]=0;return e}function Nj(e,t,n){if((typeof n!="string"||n==="")&&(n="utf8"),!U.isEncoding(n))throw new TypeError('"encoding" must be a valid string encoding');var r=p2(t,n)|0;e=Yr(e,r);var a=e.write(t,n);return a!==r&&(e=e.slice(0,a)),e}function Xh(e,t){var n=t.length<0?0:Qh(t.length)|0;e=Yr(e,n);for(var r=0;r<n;r+=1)e[r]=t[r]&255;return e}function Mj(e,t,n,r){if(t.byteLength,n<0||t.byteLength<n)throw new RangeError("'offset' is out of bounds");if(t.byteLength<n+(r||0))throw new RangeError("'length' is out of bounds");return n===void 0&&r===void 0?t=new Uint8Array(t):r===void 0?t=new Uint8Array(t,n):t=new Uint8Array(t,n,r),U.TYPED_ARRAY_SUPPORT?(e=t,e.__proto__=U.prototype):e=Xh(e,t),e}function Lj(e,t){if(br(t)){var n=Qh(t.length)|0;return e=Yr(e,n),e.length===0||t.copy(e,0,0,n),e}if(t){if(typeof ArrayBuffer<"u"&&t.buffer instanceof ArrayBuffer||"length"in t)return typeof t.length!="number"||eq(t.length)?Yr(e,0):Xh(e,t);if(t.type==="Buffer"&&l2(t.data))return Xh(e,t.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.")}function Qh(e){if(e>=Cm())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+Cm().toString(16)+" bytes");return e|0}function br(e){return!!(e!=null&&e._isBuffer)}function p2(e,t){if(br(e))return e.length;if(typeof ArrayBuffer<"u"&&typeof ArrayBuffer.isView=="function"&&(ArrayBuffer.isView(e)||e instanceof ArrayBuffer))return e.byteLength;typeof e!="string"&&(e=""+e);var n=e.length;if(n===0)return 0;for(var r=!1;;)switch(t){case"ascii":case"latin1":case"binary":return n;case"utf8":case"utf-8":case void 0:return Am(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return n*2;case"hex":return n>>>1;case"base64":return w2(e).length;default:if(r)return Am(e).length;t=(""+t).toLowerCase(),r=!0}}function Pj(e,t,n){var r=!1;if((t===void 0||t<0)&&(t=0),t>this.length||((n===void 0||n>this.length)&&(n=this.length),n<=0)||(n>>>=0,t>>>=0,n<=t))return"";for(e||(e="utf8");;)switch(e){case"hex":return Wj(this,t,n);case"utf8":case"utf-8":return g2(this,t,n);case"ascii":return Gj(this,t,n);case"latin1":case"binary":return Vj(this,t,n);case"base64":return zj(this,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return $j(this,t,n);default:if(r)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),r=!0}}function Co(e,t,n){var r=e[t];e[t]=e[n],e[n]=r}function f2(e,t,n,r,a){if(e.length===0)return-1;if(typeof n=="string"?(r=n,n=0):n>2147483647?n=2147483647:n<-2147483648&&(n=-2147483648),n=+n,isNaN(n)&&(n=a?0:e.length-1),n<0&&(n=e.length+n),n>=e.length){if(a)return-1;n=e.length-1}else if(n<0)if(a)n=0;else return-1;if(typeof t=="string"&&(t=U.from(t,r)),br(t))return t.length===0?-1:i2(e,t,n,r,a);if(typeof t=="number")return t=t&255,U.TYPED_ARRAY_SUPPORT&&typeof Uint8Array.prototype.indexOf=="function"?a?Uint8Array.prototype.indexOf.call(e,t,n):Uint8Array.prototype.lastIndexOf.call(e,t,n):i2(e,[t],n,r,a);throw new TypeError("val must be string, number or Buffer")}function i2(e,t,n,r,a){var o=1,i=e.length,c=t.length;if(r!==void 0&&(r=String(r).toLowerCase(),r==="ucs2"||r==="ucs-2"||r==="utf16le"||r==="utf-16le")){if(e.length<2||t.length<2)return-1;o=2,i/=2,c/=2,n/=2}function u(f,y){return o===1?f[y]:f.readUInt16BE(y*o)}s(u,"read");var l;if(a){var m=-1;for(l=n;l<i;l++)if(u(e,l)===u(t,m===-1?0:l-m)){if(m===-1&&(m=l),l-m+1===c)return m*o}else m!==-1&&(l-=l-m),m=-1}else for(n+c>i&&(n=i-c),l=n;l>=0;l--){for(var p=!0,h=0;h<c;h++)if(u(e,l+h)!==u(t,h)){p=!1;break}if(p)return l}return-1}function Oj(e,t,n,r){n=Number(n)||0;var a=e.length-n;r?(r=Number(r),r>a&&(r=a)):r=a;var o=t.length;if(o%2!==0)throw new TypeError("Invalid hex string");r>o/2&&(r=o/2);for(var i=0;i<r;++i){var c=parseInt(t.substr(i*2,2),16);if(isNaN(c))return i;e[n+i]=c}return i}function Bj(e,t,n,r){return Im(Am(t,e.length-n),e,n,r)}function h2(e,t,n,r){return Im(Zj(t),e,n,r)}function Uj(e,t,n,r){return h2(e,t,n,r)}function jj(e,t,n,r){return Im(w2(t),e,n,r)}function qj(e,t,n,r){return Im(Qj(t,e.length-n),e,n,r)}function zj(e,t,n){return t===0&&n===e.length?o2(e):o2(e.slice(t,n))}function g2(e,t,n){n=Math.min(e.length,n);for(var r=[],a=t;a<n;){var o=e[a],i=null,c=o>239?4:o>223?3:o>191?2:1;if(a+c<=n){var u,l,m,p;switch(c){case 1:o<128&&(i=o);break;case 2:u=e[a+1],(u&192)===128&&(p=(o&31)<<6|u&63,p>127&&(i=p));break;case 3:u=e[a+1],l=e[a+2],(u&192)===128&&(l&192)===128&&(p=(o&15)<<12|(u&63)<<6|l&63,p>2047&&(p<55296||p>57343)&&(i=p));break;case 4:u=e[a+1],l=e[a+2],m=e[a+3],(u&192)===128&&(l&192)===128&&(m&192)===128&&(p=(o&15)<<18|(u&63)<<12|(l&63)<<6|m&63,p>65535&&p<1114112&&(i=p))}}i===null?(i=65533,c=1):i>65535&&(i-=65536,r.push(i>>>10&1023|55296),i=56320|i&1023),r.push(i),a+=c}return Hj(r)}function Hj(e){var t=e.length;if(t<=s2)return String.fromCharCode.apply(String,e);for(var n="",r=0;r<t;)n+=String.fromCharCode.apply(String,e.slice(r,r+=s2));return n}function Gj(e,t,n){var r="";n=Math.min(e.length,n);for(var a=t;a<n;++a)r+=String.fromCharCode(e[a]&127);return r}function Vj(e,t,n){var r="";n=Math.min(e.length,n);for(var a=t;a<n;++a)r+=String.fromCharCode(e[a]);return r}function Wj(e,t,n){var r=e.length;(!t||t<0)&&(t=0),(!n||n<0||n>r)&&(n=r);for(var a="",o=t;o<n;++o)a+=Jj(e[o]);return a}function $j(e,t,n){for(var r=e.slice(t,n),a="",o=0;o<r.length;o+=2)a+=String.fromCharCode(r[o]+r[o+1]*256);return a}function $t(e,t,n){if(e%1!==0||e<0)throw new RangeError("offset is not uint");if(e+t>n)throw new RangeError("Trying to access beyond buffer length")}function Tn(e,t,n,r,a,o){if(!br(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(t>a||t<o)throw new RangeError('"value" argument is out of bounds');if(n+r>e.length)throw new RangeError("Index out of range")}function Rm(e,t,n,r){t<0&&(t=65535+t+1);for(var a=0,o=Math.min(e.length-n,2);a<o;++a)e[n+a]=(t&255<<8*(r?a:1-a))>>>(r?a:1-a)*8}function Fm(e,t,n,r){t<0&&(t=4294967295+t+1);for(var a=0,o=Math.min(e.length-n,4);a<o;++a)e[n+a]=t>>>(r?a:3-a)*8&255}function y2(e,t,n,r,a,o){if(n+r>e.length)throw new RangeError("Index out of range");if(n<0)throw new RangeError("Index out of range")}function b2(e,t,n,r,a){return a||y2(e,t,n,4),u2(e,t,n,r,23,4),n+4}function v2(e,t,n,r,a){return a||y2(e,t,n,8),u2(e,t,n,r,52,8),n+8}function Kj(e){if(e=Xj(e).replace(Yj,""),e.length<2)return"";for(;e.length%4!==0;)e=e+"=";return e}function Xj(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function Jj(e){return e<16?"0"+e.toString(16):e.toString(16)}function Am(e,t){t=t||1/0;for(var n,r=e.length,a=null,o=[],i=0;i<r;++i){if(n=e.charCodeAt(i),n>55295&&n<57344){if(!a){if(n>56319){(t-=3)>-1&&o.push(239,191,189);continue}else if(i+1===r){(t-=3)>-1&&o.push(239,191,189);continue}a=n;continue}if(n<56320){(t-=3)>-1&&o.push(239,191,189),a=n;continue}n=(a-55296<<10|n-56320)+65536}else a&&(t-=3)>-1&&o.push(239,191,189);if(a=null,n<128){if((t-=1)<0)break;o.push(n)}else if(n<2048){if((t-=2)<0)break;o.push(n>>6|192,n&63|128)}else if(n<65536){if((t-=3)<0)break;o.push(n>>12|224,n>>6&63|128,n&63|128)}else if(n<1114112){if((t-=4)<0)break;o.push(n>>18|240,n>>12&63|128,n>>6&63|128,n&63|128)}else throw new Error("Invalid code point")}return o}function Zj(e){for(var t=[],n=0;n<e.length;++n)t.push(e.charCodeAt(n)&255);return t}function Qj(e,t){for(var n,r,a,o=[],i=0;i<e.length&&!((t-=2)<0);++i)n=e.charCodeAt(i),r=n>>8,a=n%256,o.push(a),o.push(r);return o}function w2(e){return Cj(Kj(e))}function Im(e,t,n,r){for(var a=0;a<r&&!(a+n>=t.length||a>=e.length);++a)t[a+n]=e[a];return a}function eq(e){return e!==e}function tq(e){return e!=null&&(!!e._isBuffer||D2(e)||nq(e))}function D2(e){return!!e.constructor&&typeof e.constructor.isBuffer=="function"&&e.constructor.isBuffer(e)}function nq(e){return typeof e.readFloatLE=="function"&&typeof e.slice=="function"&&D2(e.slice(0,0))}var yr,Un,kj,Jh,Rj,l2,Fj,fle,s2,Yj,Ci=b(()=>{d();yr=[],Un=[],kj=typeof Uint8Array<"u"?Uint8Array:Array,Jh=!1;s(c2,"init");s(Cj,"toByteArray");s(Aj,"tripletToBase64");s(_j,"encodeChunk");s(o2,"fromByteArray");s(_m,"read");s(u2,"write");Rj={}.toString,l2=Array.isArray||function(e){return Rj.call(e)=="[object Array]"};Fj=50;U.TYPED_ARRAY_SUPPORT=globalThis.TYPED_ARRAY_SUPPORT!==void 0?globalThis.TYPED_ARRAY_SUPPORT:!0;fle=Cm();s(Cm,"kMaxLength");s(Yr,"createBuffer");s(U,"Buffer");U.poolSize=8192;U._augment=function(e){return e.__proto__=U.prototype,e};s(d2,"from");U.from=function(e,t,n){return d2(null,e,t,n)};U.TYPED_ARRAY_SUPPORT&&(U.prototype.__proto__=Uint8Array.prototype,U.__proto__=Uint8Array,typeof Symbol<"u"&&Symbol.species&&U[Symbol.species]);s(m2,"assertSize");s(Ij,"alloc");U.alloc=function(e,t,n){return Ij(null,e,t,n)};s(Zh,"allocUnsafe");U.allocUnsafe=function(e){return Zh(null,e)};U.allocUnsafeSlow=function(e){return Zh(null,e)};s(Nj,"fromString");s(Xh,"fromArrayLike");s(Mj,"fromArrayBuffer");s(Lj,"fromObject");s(Qh,"checked");U.isBuffer=tq;s(br,"internalIsBuffer");U.compare=s(function(t,n){if(!br(t)||!br(n))throw new TypeError("Arguments must be Buffers");if(t===n)return 0;for(var r=t.length,a=n.length,o=0,i=Math.min(r,a);o<i;++o)if(t[o]!==n[o]){r=t[o],a=n[o];break}return r<a?-1:a<r?1:0},"compare");U.isEncoding=s(function(t){switch(String(t).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},"isEncoding");U.concat=s(function(t,n){if(!l2(t))throw new TypeError('"list" argument must be an Array of Buffers');if(t.length===0)return U.alloc(0);var r;if(n===void 0)for(n=0,r=0;r<t.length;++r)n+=t[r].length;var a=U.allocUnsafe(n),o=0;for(r=0;r<t.length;++r){var i=t[r];if(!br(i))throw new TypeError('"list" argument must be an Array of Buffers');i.copy(a,o),o+=i.length}return a},"concat");s(p2,"byteLength");U.byteLength=p2;s(Pj,"slowToString");U.prototype._isBuffer=!0;s(Co,"swap");U.prototype.swap16=s(function(){var t=this.length;if(t%2!==0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var n=0;n<t;n+=2)Co(this,n,n+1);return this},"swap16");U.prototype.swap32=s(function(){var t=this.length;if(t%4!==0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var n=0;n<t;n+=4)Co(this,n,n+3),Co(this,n+1,n+2);return this},"swap32");U.prototype.swap64=s(function(){var t=this.length;if(t%8!==0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var n=0;n<t;n+=8)Co(this,n,n+7),Co(this,n+1,n+6),Co(this,n+2,n+5),Co(this,n+3,n+4);return this},"swap64");U.prototype.toString=s(function(){var t=this.length|0;return t===0?"":arguments.length===0?g2(this,0,t):Pj.apply(this,arguments)},"toString");U.prototype.equals=s(function(t){if(!br(t))throw new TypeError("Argument must be a Buffer");return this===t?!0:U.compare(this,t)===0},"equals");U.prototype.inspect=s(function(){var t="",n=Fj;return this.length>0&&(t=this.toString("hex",0,n).match(/.{2}/g).join(" "),this.length>n&&(t+=" ... ")),"<Buffer "+t+">"},"inspect");U.prototype.compare=s(function(t,n,r,a,o){if(!br(t))throw new TypeError("Argument must be a Buffer");if(n===void 0&&(n=0),r===void 0&&(r=t?t.length:0),a===void 0&&(a=0),o===void 0&&(o=this.length),n<0||r>t.length||a<0||o>this.length)throw new RangeError("out of range index");if(a>=o&&n>=r)return 0;if(a>=o)return-1;if(n>=r)return 1;if(n>>>=0,r>>>=0,a>>>=0,o>>>=0,this===t)return 0;for(var i=o-a,c=r-n,u=Math.min(i,c),l=this.slice(a,o),m=t.slice(n,r),p=0;p<u;++p)if(l[p]!==m[p]){i=l[p],c=m[p];break}return i<c?-1:c<i?1:0},"compare");s(f2,"bidirectionalIndexOf");s(i2,"arrayIndexOf");U.prototype.includes=s(function(t,n,r){return this.indexOf(t,n,r)!==-1},"includes");U.prototype.indexOf=s(function(t,n,r){return f2(this,t,n,r,!0)},"indexOf");U.prototype.lastIndexOf=s(function(t,n,r){return f2(this,t,n,r,!1)},"lastIndexOf");s(Oj,"hexWrite");s(Bj,"utf8Write");s(h2,"asciiWrite");s(Uj,"latin1Write");s(jj,"base64Write");s(qj,"ucs2Write");U.prototype.write=s(function(t,n,r,a){if(n===void 0)a="utf8",r=this.length,n=0;else if(r===void 0&&typeof n=="string")a=n,r=this.length,n=0;else if(isFinite(n))n=n|0,isFinite(r)?(r=r|0,a===void 0&&(a="utf8")):(a=r,r=void 0);else throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");var o=this.length-n;if((r===void 0||r>o)&&(r=o),t.length>0&&(r<0||n<0)||n>this.length)throw new RangeError("Attempt to write outside buffer bounds");a||(a="utf8");for(var i=!1;;)switch(a){case"hex":return Oj(this,t,n,r);case"utf8":case"utf-8":return Bj(this,t,n,r);case"ascii":return h2(this,t,n,r);case"latin1":case"binary":return Uj(this,t,n,r);case"base64":return jj(this,t,n,r);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return qj(this,t,n,r);default:if(i)throw new TypeError("Unknown encoding: "+a);a=(""+a).toLowerCase(),i=!0}},"write");U.prototype.toJSON=s(function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}},"toJSON");s(zj,"base64Slice");s(g2,"utf8Slice");s2=4096;s(Hj,"decodeCodePointsArray");s(Gj,"asciiSlice");s(Vj,"latin1Slice");s(Wj,"hexSlice");s($j,"utf16leSlice");U.prototype.slice=s(function(t,n){var r=this.length;t=~~t,n=n===void 0?r:~~n,t<0?(t+=r,t<0&&(t=0)):t>r&&(t=r),n<0?(n+=r,n<0&&(n=0)):n>r&&(n=r),n<t&&(n=t);var a;if(U.TYPED_ARRAY_SUPPORT)a=this.subarray(t,n),a.__proto__=U.prototype;else{var o=n-t;a=new U(o,void 0);for(var i=0;i<o;++i)a[i]=this[i+t]}return a},"slice");s($t,"checkOffset");U.prototype.readUIntLE=s(function(t,n,r){t=t|0,n=n|0,r||$t(t,n,this.length);for(var a=this[t],o=1,i=0;++i<n&&(o*=256);)a+=this[t+i]*o;return a},"readUIntLE");U.prototype.readUIntBE=s(function(t,n,r){t=t|0,n=n|0,r||$t(t,n,this.length);for(var a=this[t+--n],o=1;n>0&&(o*=256);)a+=this[t+--n]*o;return a},"readUIntBE");U.prototype.readUInt8=s(function(t,n){return n||$t(t,1,this.length),this[t]},"readUInt8");U.prototype.readUInt16LE=s(function(t,n){return n||$t(t,2,this.length),this[t]|this[t+1]<<8},"readUInt16LE");U.prototype.readUInt16BE=s(function(t,n){return n||$t(t,2,this.length),this[t]<<8|this[t+1]},"readUInt16BE");U.prototype.readUInt32LE=s(function(t,n){return n||$t(t,4,this.length),(this[t]|this[t+1]<<8|this[t+2]<<16)+this[t+3]*16777216},"readUInt32LE");U.prototype.readUInt32BE=s(function(t,n){return n||$t(t,4,this.length),this[t]*16777216+(this[t+1]<<16|this[t+2]<<8|this[t+3])},"readUInt32BE");U.prototype.readIntLE=s(function(t,n,r){t=t|0,n=n|0,r||$t(t,n,this.length);for(var a=this[t],o=1,i=0;++i<n&&(o*=256);)a+=this[t+i]*o;return o*=128,a>=o&&(a-=Math.pow(2,8*n)),a},"readIntLE");U.prototype.readIntBE=s(function(t,n,r){t=t|0,n=n|0,r||$t(t,n,this.length);for(var a=n,o=1,i=this[t+--a];a>0&&(o*=256);)i+=this[t+--a]*o;return o*=128,i>=o&&(i-=Math.pow(2,8*n)),i},"readIntBE");U.prototype.readInt8=s(function(t,n){return n||$t(t,1,this.length),this[t]&128?(255-this[t]+1)*-1:this[t]},"readInt8");U.prototype.readInt16LE=s(function(t,n){n||$t(t,2,this.length);var r=this[t]|this[t+1]<<8;return r&32768?r|4294901760:r},"readInt16LE");U.prototype.readInt16BE=s(function(t,n){n||$t(t,2,this.length);var r=this[t+1]|this[t]<<8;return r&32768?r|4294901760:r},"readInt16BE");U.prototype.readInt32LE=s(function(t,n){return n||$t(t,4,this.length),this[t]|this[t+1]<<8|this[t+2]<<16|this[t+3]<<24},"readInt32LE");U.prototype.readInt32BE=s(function(t,n){return n||$t(t,4,this.length),this[t]<<24|this[t+1]<<16|this[t+2]<<8|this[t+3]},"readInt32BE");U.prototype.readFloatLE=s(function(t,n){return n||$t(t,4,this.length),_m(this,t,!0,23,4)},"readFloatLE");U.prototype.readFloatBE=s(function(t,n){return n||$t(t,4,this.length),_m(this,t,!1,23,4)},"readFloatBE");U.prototype.readDoubleLE=s(function(t,n){return n||$t(t,8,this.length),_m(this,t,!0,52,8)},"readDoubleLE");U.prototype.readDoubleBE=s(function(t,n){return n||$t(t,8,this.length),_m(this,t,!1,52,8)},"readDoubleBE");s(Tn,"checkInt");U.prototype.writeUIntLE=s(function(t,n,r,a){if(t=+t,n=n|0,r=r|0,!a){var o=Math.pow(2,8*r)-1;Tn(this,t,n,r,o,0)}var i=1,c=0;for(this[n]=t&255;++c<r&&(i*=256);)this[n+c]=t/i&255;return n+r},"writeUIntLE");U.prototype.writeUIntBE=s(function(t,n,r,a){if(t=+t,n=n|0,r=r|0,!a){var o=Math.pow(2,8*r)-1;Tn(this,t,n,r,o,0)}var i=r-1,c=1;for(this[n+i]=t&255;--i>=0&&(c*=256);)this[n+i]=t/c&255;return n+r},"writeUIntBE");U.prototype.writeUInt8=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,1,255,0),U.TYPED_ARRAY_SUPPORT||(t=Math.floor(t)),this[n]=t&255,n+1},"writeUInt8");s(Rm,"objectWriteUInt16");U.prototype.writeUInt16LE=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,2,65535,0),U.TYPED_ARRAY_SUPPORT?(this[n]=t&255,this[n+1]=t>>>8):Rm(this,t,n,!0),n+2},"writeUInt16LE");U.prototype.writeUInt16BE=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,2,65535,0),U.TYPED_ARRAY_SUPPORT?(this[n]=t>>>8,this[n+1]=t&255):Rm(this,t,n,!1),n+2},"writeUInt16BE");s(Fm,"objectWriteUInt32");U.prototype.writeUInt32LE=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,4,4294967295,0),U.TYPED_ARRAY_SUPPORT?(this[n+3]=t>>>24,this[n+2]=t>>>16,this[n+1]=t>>>8,this[n]=t&255):Fm(this,t,n,!0),n+4},"writeUInt32LE");U.prototype.writeUInt32BE=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,4,4294967295,0),U.TYPED_ARRAY_SUPPORT?(this[n]=t>>>24,this[n+1]=t>>>16,this[n+2]=t>>>8,this[n+3]=t&255):Fm(this,t,n,!1),n+4},"writeUInt32BE");U.prototype.writeIntLE=s(function(t,n,r,a){if(t=+t,n=n|0,!a){var o=Math.pow(2,8*r-1);Tn(this,t,n,r,o-1,-o)}var i=0,c=1,u=0;for(this[n]=t&255;++i<r&&(c*=256);)t<0&&u===0&&this[n+i-1]!==0&&(u=1),this[n+i]=(t/c>>0)-u&255;return n+r},"writeIntLE");U.prototype.writeIntBE=s(function(t,n,r,a){if(t=+t,n=n|0,!a){var o=Math.pow(2,8*r-1);Tn(this,t,n,r,o-1,-o)}var i=r-1,c=1,u=0;for(this[n+i]=t&255;--i>=0&&(c*=256);)t<0&&u===0&&this[n+i+1]!==0&&(u=1),this[n+i]=(t/c>>0)-u&255;return n+r},"writeIntBE");U.prototype.writeInt8=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,1,127,-128),U.TYPED_ARRAY_SUPPORT||(t=Math.floor(t)),t<0&&(t=255+t+1),this[n]=t&255,n+1},"writeInt8");U.prototype.writeInt16LE=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,2,32767,-32768),U.TYPED_ARRAY_SUPPORT?(this[n]=t&255,this[n+1]=t>>>8):Rm(this,t,n,!0),n+2},"writeInt16LE");U.prototype.writeInt16BE=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,2,32767,-32768),U.TYPED_ARRAY_SUPPORT?(this[n]=t>>>8,this[n+1]=t&255):Rm(this,t,n,!1),n+2},"writeInt16BE");U.prototype.writeInt32LE=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,4,2147483647,-2147483648),U.TYPED_ARRAY_SUPPORT?(this[n]=t&255,this[n+1]=t>>>8,this[n+2]=t>>>16,this[n+3]=t>>>24):Fm(this,t,n,!0),n+4},"writeInt32LE");U.prototype.writeInt32BE=s(function(t,n,r){return t=+t,n=n|0,r||Tn(this,t,n,4,2147483647,-2147483648),t<0&&(t=4294967295+t+1),U.TYPED_ARRAY_SUPPORT?(this[n]=t>>>24,this[n+1]=t>>>16,this[n+2]=t>>>8,this[n+3]=t&255):Fm(this,t,n,!1),n+4},"writeInt32BE");s(y2,"checkIEEE754");s(b2,"writeFloat");U.prototype.writeFloatLE=s(function(t,n,r){return b2(this,t,n,!0,r)},"writeFloatLE");U.prototype.writeFloatBE=s(function(t,n,r){return b2(this,t,n,!1,r)},"writeFloatBE");s(v2,"writeDouble");U.prototype.writeDoubleLE=s(function(t,n,r){return v2(this,t,n,!0,r)},"writeDoubleLE");U.prototype.writeDoubleBE=s(function(t,n,r){return v2(this,t,n,!1,r)},"writeDoubleBE");U.prototype.copy=s(function(t,n,r,a){if(r||(r=0),!a&&a!==0&&(a=this.length),n>=t.length&&(n=t.length),n||(n=0),a>0&&a<r&&(a=r),a===r||t.length===0||this.length===0)return 0;if(n<0)throw new RangeError("targetStart out of bounds");if(r<0||r>=this.length)throw new RangeError("sourceStart out of bounds");if(a<0)throw new RangeError("sourceEnd out of bounds");a>this.length&&(a=this.length),t.length-n<a-r&&(a=t.length-n+r);var o=a-r,i;if(this===t&&r<n&&n<a)for(i=o-1;i>=0;--i)t[i+n]=this[i+r];else if(o<1e3||!U.TYPED_ARRAY_SUPPORT)for(i=0;i<o;++i)t[i+n]=this[i+r];else Uint8Array.prototype.set.call(t,this.subarray(r,r+o),n);return o},"copy");U.prototype.fill=s(function(t,n,r,a){if(typeof t=="string"){if(typeof n=="string"?(a=n,n=0,r=this.length):typeof r=="string"&&(a=r,r=this.length),t.length===1){var o=t.charCodeAt(0);o<256&&(t=o)}if(a!==void 0&&typeof a!="string")throw new TypeError("encoding must be a string");if(typeof a=="string"&&!U.isEncoding(a))throw new TypeError("Unknown encoding: "+a)}else typeof t=="number"&&(t=t&255);if(n<0||this.length<n||this.length<r)throw new RangeError("Out of range index");if(r<=n)return this;n=n>>>0,r=r===void 0?this.length:r>>>0,t||(t=0);var i;if(typeof t=="number")for(i=n;i<r;++i)this[i]=t;else{var c=br(t)?t:Am(new U(t,a).toString()),u=c.length;for(i=0;i<r-n;++i)this[i+n]=c[i%u]}return this},"fill");Yj=/[^+\/0-9A-Za-z-_]/g;s(Kj,"base64clean");s(Xj,"stringtrim");s(Jj,"toHex");s(Am,"utf8ToBytes");s(Zj,"asciiToBytes");s(Qj,"utf16leToBytes");s(w2,"base64ToBytes");s(Im,"blitBuffer");s(eq,"isnan");s(tq,"isBuffer");s(D2,"isFastBuffer");s(nq,"isSlowBuffer")});function Sa(){}function Be(){Be.init.call(this)}function E2(e){return e._maxListeners===void 0?Be.defaultMaxListeners:e._maxListeners}function rq(e,t,n){if(t)e.call(n);else for(var r=e.length,a=Yc(e,r),o=0;o<r;++o)a[o].call(n)}function aq(e,t,n,r){if(t)e.call(n,r);else for(var a=e.length,o=Yc(e,a),i=0;i<a;++i)o[i].call(n,r)}function oq(e,t,n,r,a){if(t)e.call(n,r,a);else for(var o=e.length,i=Yc(e,o),c=0;c<o;++c)i[c].call(n,r,a)}function iq(e,t,n,r,a,o){if(t)e.call(n,r,a,o);else for(var i=e.length,c=Yc(e,i),u=0;u<i;++u)c[u].call(n,r,a,o)}function sq(e,t,n,r){if(t)e.apply(n,r);else for(var a=e.length,o=Yc(e,a),i=0;i<a;++i)o[i].apply(n,r)}function x2(e,t,n,r){var a,o,i;if(typeof n!="function")throw new TypeError('"listener" argument must be a function');if(o=e._events,o?(o.newListener&&(e.emit("newListener",t,n.listener?n.listener:n),o=e._events),i=o[t]):(o=e._events=new Sa,e._eventsCount=0),!i)i=o[t]=n,++e._eventsCount;else if(typeof i=="function"?i=o[t]=r?[n,i]:[i,n]:r?i.unshift(n):i.push(n),!i.warned&&(a=E2(e),a&&a>0&&i.length>a)){i.warned=!0;var c=new Error("Possible EventEmitter memory leak detected. "+i.length+" "+t+" listeners added. Use emitter.setMaxListeners() to increase limit");c.name="MaxListenersExceededWarning",c.emitter=e,c.type=t,c.count=i.length,cq(c)}return e}function cq(e){typeof console.warn=="function"?console.warn(e):console.log(e)}function T2(e,t,n){var r=!1;function a(){e.removeListener(t,a),r||(r=!0,n.apply(e,arguments))}return s(a,"g"),a.listener=n,a}function S2(e){var t=this._events;if(t){var n=t[e];if(typeof n=="function")return 1;if(n)return n.length}return 0}function uq(e,t){for(var n=t,r=n+1,a=e.length;r<a;n+=1,r+=1)e[n]=e[r];e.pop()}function Yc(e,t){for(var n=new Array(t);t--;)n[t]=e[t];return n}function lq(e){for(var t=new Array(e.length),n=0;n<t.length;++n)t[n]=e[n].listener||e[n];return t}var e1,jn,Kr=b(()=>{"use strict";d();s(Sa,"EventHandlers");Sa.prototype=Object.create(null);s(Be,"EventEmitter");jn=Be;Be.EventEmitter=Be;Be.usingDomains=!1;Be.prototype.domain=void 0;Be.prototype._events=void 0;Be.prototype._maxListeners=void 0;Be.defaultMaxListeners=10;Be.init=function(){this.domain=null,Be.usingDomains&&e1.active&&!(this instanceof e1.Domain)&&(this.domain=e1.active),(!this._events||this._events===Object.getPrototypeOf(this)._events)&&(this._events=new Sa,this._eventsCount=0),this._maxListeners=this._maxListeners||void 0};Be.prototype.setMaxListeners=s(function(t){if(typeof t!="number"||t<0||isNaN(t))throw new TypeError('"n" argument must be a positive number');return this._maxListeners=t,this},"setMaxListeners");s(E2,"$getMaxListeners");Be.prototype.getMaxListeners=s(function(){return E2(this)},"getMaxListeners");s(rq,"emitNone");s(aq,"emitOne");s(oq,"emitTwo");s(iq,"emitThree");s(sq,"emitMany");Be.prototype.emit=s(function(t){var n,r,a,o,i,c,u,l=!1,m=t==="error";if(c=this._events,c)m=m&&c.error==null;else if(!m)return!1;if(u=this.domain,m){if(n=arguments[1],u)n||(n=new Error('Uncaught, unspecified "error" event')),n.domainEmitter=this,n.domain=u,n.domainThrown=!1,u.emit("error",n);else{if(n instanceof Error)throw n;var p=new Error('Uncaught, unspecified "error" event. ('+n+")");throw p.context=n,p}return!1}if(r=c[t],!r)return!1;var h=typeof r=="function";switch(a=arguments.length,a){case 1:rq(r,h,this);break;case 2:aq(r,h,this,arguments[1]);break;case 3:oq(r,h,this,arguments[1],arguments[2]);break;case 4:iq(r,h,this,arguments[1],arguments[2],arguments[3]);break;default:for(o=new Array(a-1),i=1;i<a;i++)o[i-1]=arguments[i];sq(r,h,this,o)}return l&&u.exit(),!0},"emit");s(x2,"_addListener");s(cq,"emitWarning");Be.prototype.addListener=s(function(t,n){return x2(this,t,n,!1)},"addListener");Be.prototype.on=Be.prototype.addListener;Be.prototype.prependListener=s(function(t,n){return x2(this,t,n,!0)},"prependListener");s(T2,"_onceWrap");Be.prototype.once=s(function(t,n){if(typeof n!="function")throw new TypeError('"listener" argument must be a function');return this.on(t,T2(this,t,n)),this},"once");Be.prototype.prependOnceListener=s(function(t,n){if(typeof n!="function")throw new TypeError('"listener" argument must be a function');return this.prependListener(t,T2(this,t,n)),this},"prependOnceListener");Be.prototype.removeListener=s(function(t,n){var r,a,o,i,c;if(typeof n!="function")throw new TypeError('"listener" argument must be a function');if(a=this._events,!a)return this;if(r=a[t],!r)return this;if(r===n||r.listener&&r.listener===n)--this._eventsCount===0?this._events=new Sa:(delete a[t],a.removeListener&&this.emit("removeListener",t,r.listener||n));else if(typeof r!="function"){for(o=-1,i=r.length;i-- >0;)if(r[i]===n||r[i].listener&&r[i].listener===n){c=r[i].listener,o=i;break}if(o<0)return this;if(r.length===1){if(r[0]=void 0,--this._eventsCount===0)return this._events=new Sa,this;delete a[t]}else uq(r,o);a.removeListener&&this.emit("removeListener",t,c||n)}return this},"removeListener");Be.prototype.off=function(e,t){return this.removeListener(e,t)};Be.prototype.removeAllListeners=s(function(t){var n,r;if(r=this._events,!r)return this;if(!r.removeListener)return arguments.length===0?(this._events=new Sa,this._eventsCount=0):r[t]&&(--this._eventsCount===0?this._events=new Sa:delete r[t]),this;if(arguments.length===0){for(var a=Object.keys(r),o=0,i;o<a.length;++o)i=a[o],i!=="removeListener"&&this.removeAllListeners(i);return this.removeAllListeners("removeListener"),this._events=new Sa,this._eventsCount=0,this}if(n=r[t],typeof n=="function")this.removeListener(t,n);else if(n)do this.removeListener(t,n[n.length-1]);while(n[0]);return this},"removeAllListeners");Be.prototype.listeners=s(function(t){var n,r,a=this._events;return a?(n=a[t],n?typeof n=="function"?r=[n.listener||n]:r=lq(n):r=[]):r=[],r},"listeners");Be.listenerCount=function(e,t){return typeof e.listenerCount=="function"?e.listenerCount(t):S2.call(e,t)};Be.prototype.listenerCount=S2;s(S2,"listenerCount");Be.prototype.eventNames=s(function(){return this._eventsCount>0?Reflect.ownKeys(this._events):[]},"eventNames");s(uq,"spliceOne");s(Yc,"arrayClone");s(lq,"unwrapListeners")});var C2=I((Dle,k2)=>{d();var Ai=1e3,_i=Ai*60,Ri=_i*60,Ao=Ri*24,dq=Ao*7,mq=Ao*365.25;k2.exports=function(e,t){t=t||{};var n=typeof e;if(n==="string"&&e.length>0)return pq(e);if(n==="number"&&isFinite(e))return t.long?hq(e):fq(e);throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))};function pq(e){if(e=String(e),!(e.length>100)){var t=/^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(e);if(t){var n=parseFloat(t[1]),r=(t[2]||"ms").toLowerCase();switch(r){case"years":case"year":case"yrs":case"yr":case"y":return n*mq;case"weeks":case"week":case"w":return n*dq;case"days":case"day":case"d":return n*Ao;case"hours":case"hour":case"hrs":case"hr":case"h":return n*Ri;case"minutes":case"minute":case"mins":case"min":case"m":return n*_i;case"seconds":case"second":case"secs":case"sec":case"s":return n*Ai;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return n;default:return}}}}s(pq,"parse");function fq(e){var t=Math.abs(e);return t>=Ao?Math.round(e/Ao)+"d":t>=Ri?Math.round(e/Ri)+"h":t>=_i?Math.round(e/_i)+"m":t>=Ai?Math.round(e/Ai)+"s":e+"ms"}s(fq,"fmtShort");function hq(e){var t=Math.abs(e);return t>=Ao?Nm(e,t,Ao,"day"):t>=Ri?Nm(e,t,Ri,"hour"):t>=_i?Nm(e,t,_i,"minute"):t>=Ai?Nm(e,t,Ai,"second"):e+" ms"}s(hq,"fmtLong");function Nm(e,t,n,r){var a=t>=n*1.5;return Math.round(e/n)+" "+r+(a?"s":"")}s(Nm,"plural")});var _2=I((Tle,A2)=>{d();function gq(e){n.debug=n,n.default=n,n.coerce=u,n.disable=o,n.enable=a,n.enabled=i,n.humanize=C2(),n.destroy=l,Object.keys(e).forEach(m=>{n[m]=e[m]}),n.names=[],n.skips=[],n.formatters={};function t(m){let p=0;for(let h=0;h<m.length;h++)p=(p<<5)-p+m.charCodeAt(h),p|=0;return n.colors[Math.abs(p)%n.colors.length]}s(t,"selectColor"),n.selectColor=t;function n(m){let p,h=null,f,y;function v(...D){if(!v.enabled)return;let E=v,S=Number(new Date),k=S-(p||S);E.diff=k,E.prev=p,E.curr=S,p=S,D[0]=n.coerce(D[0]),typeof D[0]!="string"&&D.unshift("%O");let C=0;D[0]=D[0].replace(/%([a-zA-Z%])/g,(z,B)=>{if(z==="%%")return"%";C++;let J=n.formatters[B];if(typeof J=="function"){let ne=D[C];z=J.call(E,ne),D.splice(C,1),C--}return z}),n.formatArgs.call(E,D),(E.log||n.log).apply(E,D)}return s(v,"debug"),v.namespace=m,v.useColors=n.useColors(),v.color=n.selectColor(m),v.extend=r,v.destroy=n.destroy,Object.defineProperty(v,"enabled",{enumerable:!0,configurable:!1,get:()=>h!==null?h:(f!==n.namespaces&&(f=n.namespaces,y=n.enabled(m)),y),set:D=>{h=D}}),typeof n.init=="function"&&n.init(v),v}s(n,"createDebug");function r(m,p){let h=n(this.namespace+(typeof p>"u"?":":p)+m);return h.log=this.log,h}s(r,"extend");function a(m){n.save(m),n.namespaces=m,n.names=[],n.skips=[];let p,h=(typeof m=="string"?m:"").split(/[\s,]+/),f=h.length;for(p=0;p<f;p++)h[p]&&(m=h[p].replace(/\*/g,".*?"),m[0]==="-"?n.skips.push(new RegExp("^"+m.slice(1)+"$")):n.names.push(new RegExp("^"+m+"$")))}s(a,"enable");function o(){let m=[...n.names.map(c),...n.skips.map(c).map(p=>"-"+p)].join(",");return n.enable(""),m}s(o,"disable");function i(m){if(m[m.length-1]==="*")return!0;let p,h;for(p=0,h=n.skips.length;p<h;p++)if(n.skips[p].test(m))return!1;for(p=0,h=n.names.length;p<h;p++)if(n.names[p].test(m))return!0;return!1}s(i,"enabled");function c(m){return m.toString().substring(2,m.toString().length-2).replace(/\.\*\?$/,"*")}s(c,"toNamespace");function u(m){return m instanceof Error?m.stack||m.message:m}s(u,"coerce");function l(){console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.")}return s(l,"destroy"),n.enable(n.load()),n}s(gq,"setup");A2.exports=gq});var R2=I((Rn,Mm)=>{d();Rn.formatArgs=bq;Rn.save=vq;Rn.load=wq;Rn.useColors=yq;Rn.storage=Dq();Rn.destroy=(()=>{let e=!1;return()=>{e||(e=!0,console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."))}})();Rn.colors=["#0000CC","#0000FF","#0033CC","#0033FF","#0066CC","#0066FF","#0099CC","#0099FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#3300CC","#3300FF","#3333CC","#3333FF","#3366CC","#3366FF","#3399CC","#3399FF","#33CC00","#33CC33","#33CC66","#33CC99","#33CCCC","#33CCFF","#6600CC","#6600FF","#6633CC","#6633FF","#66CC00","#66CC33","#9900CC","#9900FF","#9933CC","#9933FF","#99CC00","#99CC33","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF","#CC6600","#CC6633","#CC9900","#CC9933","#CCCC00","#CCCC33","#FF0000","#FF0033","#FF0066","#FF0099","#FF00CC","#FF00FF","#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#FF6600","#FF6633","#FF9900","#FF9933","#FFCC00","#FFCC33"];function yq(){return typeof window<"u"&&window.process&&(window.process.type==="renderer"||window.process.__nwjs)?!0:typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)?!1:typeof document<"u"&&document.documentElement&&document.documentElement.style&&document.documentElement.style.WebkitAppearance||typeof window<"u"&&window.console&&(window.console.firebug||window.console.exception&&window.console.table)||typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/)}s(yq,"useColors");function bq(e){if(e[0]=(this.useColors?"%c":"")+this.namespace+(this.useColors?" %c":" ")+e[0]+(this.useColors?"%c ":" ")+"+"+Mm.exports.humanize(this.diff),!this.useColors)return;let t="color: "+this.color;e.splice(1,0,t,"color: inherit");let n=0,r=0;e[0].replace(/%[a-zA-Z%]/g,a=>{a!=="%%"&&(n++,a==="%c"&&(r=n))}),e.splice(r,0,t)}s(bq,"formatArgs");Rn.log=console.debug||console.log||(()=>{});function vq(e){try{e?Rn.storage.setItem("debug",e):Rn.storage.removeItem("debug")}catch{}}s(vq,"save");function wq(){let e;try{e=Rn.storage.getItem("debug")}catch{}return!e&&typeof process<"u"&&"env"in process&&(e=process.env.DEBUG),e}s(wq,"load");function Dq(){try{return localStorage}catch{}}s(Dq,"localstorage");Mm.exports=_2()(Rn);var{formatters:Eq}=Mm.exports;Eq.j=function(e){try{return JSON.stringify(e)}catch(t){return"[UnexpectedJSONParseError]: "+t.message}}});function Lm(e){if(!e)throw new Error("name must be non-empty")}function xq(e,t){for(var n=0,r=e.length,a;n<r;)a=n+r>>>1,e[a].startTime<t.startTime?n=a+1:r=a;e.splice(n,0,t)}var fn,F2,Bm,Um,Kc,jm,Pm,Om,I2=b(()=>{d();fn=typeof performance<"u"&&performance,F2=fn&&fn.now?function(){return fn.now()}:function(){return Date.now()};s(Lm,"throwIfEmpty");s(xq,"insertSorted");fn&&fn.mark&&fn.getEntriesByName&&fn.getEntriesByType&&fn.clearMeasures?(Bm=s(function(e){Lm(e),fn.mark("start "+e)},"mark"),Um=s(function(e){Lm(e),fn.mark("end "+e),fn.measure(e,"start "+e,"end "+e);var t=fn.getEntriesByName(e);return t[t.length-1]},"stop"),Kc=s(function(){return fn.getEntriesByType("measure")},"getEntries"),jm=s(function(){fn.clearMarks(),fn.clearMeasures()},"clear")):(Pm={},Om=[],Bm=s(function(e){Lm(e);var t=F2();Pm["$"+e]=t},"mark"),Um=s(function(e){Lm(e);var t=F2(),n=Pm["$"+e];if(!n)throw new Error("no known mark: "+e);var r={startTime:n,name:e,duration:t-n,entryType:"measure"};return xq(Om,r),r},"stop"),Kc=s(function(){return Om},"getEntries"),jm=s(function(){Pm={},Om=[]},"clear"))});var Ca,ka,Fi,Ii,t1,N2,Sq,M2,Ni,F,Ae=b(()=>{d();Ta();Kr();Ca=Lt(R2());I2();ka=rn.platform==="win32",Fi=rn.browser,Ii={red:Fi?"crimson":1,yellow:Fi?"gold":3,cyan:Fi?"darkturquoise":6,green:Fi?"forestgreen":2,blue:Fi?"steelblue":4,magenta:Fi?"palevioletred":5};Ca.default.colors=[Ii.cyan,Ii.green,Ii.blue,Ii.magenta];t1=class extends Be{static{s(this,"Emitter")}issueStatus(t,n){(t==="status"||t==="statusEnd")&&this.emit(t,[t,...n])}issueWarning(t,n){this.emit("warning",[t,...n])}},N2={},Sq=25,Ni=class e{static{s(this,"Log")}static _logToStdErr(t,n){e.loggerfn(t)(...n)}static loggerfn(t){t=`LH:${t}`;let n=N2[t];return n||(n=(0,Ca.default)(t),N2[t]=n,t.endsWith("error")?n.color=Ii.red:t.endsWith("warn")&&(n.color=Ii.yellow)),n}static setLevel(t){switch(M2=t,t){case"silent":Ca.default.enable("-LH:*");break;case"verbose":Ca.default.enable("LH:*");break;case"warn":Ca.default.enable("-LH:*, LH:*:warn, LH:*:error");break;case"error":Ca.default.enable("-LH:*, LH:*:error");break;default:Ca.default.enable("LH:*, -LH:*:verbose")}}static formatProtocol(t,n,r){let a=!rn||rn.browser?1/0:rn.stdout.columns,o=n.method||"?????",i=a-o.length-t.length-Sq,c=n.params&&o!=="IO.read"?JSON.stringify(n.params).substr(0,i):"";e._logToStdErr(`${t}:${r||""}`,[o,c])}static isVerbose(){return M2==="verbose"}static time({msg:t,id:n,args:r=[]},a="log"){Bm(n),e[a]("status",t,...r)}static timeEnd({msg:t,id:n,args:r=[]},a="verbose"){e[a]("statusEnd",t,...r),Um(n)}static log(t,...n){return e.events.issueStatus(t,n),e._logToStdErr(t,n)}static warn(t,...n){return e.events.issueWarning(t,n),e._logToStdErr(`${t}:warn`,n)}static error(t,...n){return e._logToStdErr(`${t}:error`,n)}static verbose(t,...n){return e.events.issueStatus(t,n),e._logToStdErr(`${t}:verbose`,n)}static greenify(t){return`${e.green}${t}${e.reset}`}static redify(t){return`${e.red}${t}${e.reset}`}static get green(){return"\x1B[32m"}static get red(){return"\x1B[31m"}static get yellow(){return"\x1B[33m"}static get purple(){return"\x1B[95m"}static get reset(){return"\x1B[0m"}static get bold(){return"\x1B[1m"}static get dim(){return"\x1B[2m"}static get tick(){return ka?"√":"✓"}static get cross(){return ka?"×":"✘"}static get whiteSmallSquare(){return ka?"·":"▫"}static get heavyHorizontal(){return ka?"─":"━"}static get heavyVertical(){return ka?"│ ":"┃ "}static get heavyUpAndRight(){return ka?"└":"┗"}static get heavyVerticalAndRight(){return ka?"├":"┣"}static get heavyDownAndHorizontal(){return ka?"┬":"┳"}static get doubleLightHorizontal(){return"──"}};Ni.events=new t1;Ni.takeTimeEntries=()=>{let e=Kc();return jm(),e};Ni.getTimeEntries=()=>Kc();F=Ni});var jt=b(()=>{"use strict";d();});var n1,$,Se=b(()=>{"use strict";d();jt();n1=class{static{s(this,"BaseGatherer")}meta={supportedModes:[]};startInstrumentation(t){}startSensitiveInstrumentation(t){}stopSensitiveInstrumentation(t){}stopInstrumentation(t){}getArtifact(t){}},$=n1});var kq,Cq,Aq,_q,Rq,Fq,qt,vr=b(()=>{"use strict";d();Ae();kq=/^(chrome|https?):/,Cq=16,Aq="RunTask",_q="ThreadControllerImpl::RunTask",Rq="ThreadControllerImpl::DoWork",Fq="TaskQueueManager::ProcessTaskFromWorkQueue",qt=class e{static{s(this,"TraceProcessor")}static get TIMESPAN_MARKER_ID(){return"__lighthouseTimespanStart__"}static createNoNavstartError(){return new Error("No navigationStart event found")}static createNoResourceSendRequestError(){return new Error("No ResourceSendRequest event found")}static createNoTracingStartedError(){return new Error("No tracingStartedInBrowser event found")}static createNoFirstContentfulPaintError(){return new Error("No FirstContentfulPaint event found")}static createNoLighthouseMarkerError(){return new Error("No Lighthouse timespan marker event found")}static _isNavigationStartOfInterest(t){return t.name!=="navigationStart"?!1:t.args.data?.documentLoaderURL===void 0?!0:t.args.data?.documentLoaderURL?kq.test(t.args.data.documentLoaderURL):!1}static _sortTimestampEventGroup(t,n,r,a){let o=s(p=>n[p],"lookupArrayIndexByTsIndex"),i=s(p=>a[o(p)],"lookupEventByTsIndex"),c=[],u=[],l=[];for(let p of t){let h=o(p),f=i(p);f.ph==="E"?c.push(h):f.ph==="X"||f.ph==="B"?u.push(h):l.push(h)}let m=new Map;for(let p of u){let h=a[p];if(h.ph==="X")m.set(p,h.dur);else{let f=Number.MAX_SAFE_INTEGER,y=0,v=r+t.length;for(let D=v;D<n.length;D++){let E=i(D);if(E.name===h.name&&E.pid===h.pid&&E.tid===h.tid)if(E.ph==="E"&&y===0){f=E.ts-h.ts;break}else E.ph==="E"?y--:E.ph==="B"&&y++}m.set(p,f)}}return u.sort((p,h)=>(m.get(h)||0)-(m.get(p)||0)||p-h),l.sort((p,h)=>p-h),[...c,...u,...l]}static filteredTraceSort(t,n){let r=[];for(let o=0;o<t.length;o++)n(t[o])&&r.push(o);r.sort((o,i)=>t[o].ts-t[i].ts);for(let o=0;o<r.length-1;o++){let i=t[r[o]].ts,c=[o];for(let l=o+1;l<r.length&&t[r[l]].ts===i;l++)c.push(l);if(c.length===1)continue;let u=e._sortTimestampEventGroup(c,r,o,t);r.splice(o,u.length,...u),o+=c.length-1}let a=[];for(let o=0;o<r.length;o++)a.push(t[r[o]]);return a}static assertHasToplevelEvents(t){if(!t.some(this.isScheduleableTask))throw new Error("Could not find any top level events")}static _riskPercentiles(t,n,r,a=0){let o=0;for(let h=0;h<t.length;h++)o+=t[h];o-=a;let i=n-o,c=0,u=i,l=[],m=-1,p=t.length+1;a>0&&p--;for(let h of r){let f=h*n;for(;u<f&&m<t.length-1;)i+=c,p-=c<0?-1:1,a>0&&a<t[m+1]?(c=-a,a=0):(m++,c=t[m]),u=i+Math.abs(c)*p;l.push({percentile:h,time:Math.max(0,(f-i)/p)+Cq})}return l}static getRiskToResponsiveness(t,n,r,a=[.5,.75,.9,.99,1]){let o=r-n;a.sort((c,u)=>c-u);let i=this.getMainThreadTopLevelEventDurations(t,n,r);return this._riskPercentiles(i.durations,o,a,i.clippedLength)}static getMainThreadTopLevelEventDurations(t,n=0,r=1/0){let a=[],o=0;for(let i of t){if(i.end<n||i.start>r)continue;let c=i.duration,u=i.start;u<n&&(u=n,c=i.end-n),i.end>r&&(o=c-(r-u)),a.push(c)}return a.sort((i,c)=>i-c),{durations:a,clippedLength:o}}static getMainThreadTopLevelEvents(t,n=0,r=1/0){let a=[];for(let o of t.mainThreadEvents){if(!this.isScheduleableTask(o)||!o.dur)continue;let i=(o.ts-t.timeOriginEvt.ts)/1e3,c=(o.ts+o.dur-t.timeOriginEvt.ts)/1e3;i>r||c<n||a.push({start:i,end:c,duration:o.dur/1e3})}return a}static findMainFrameIds(t){let n=t.find(i=>i.name==="TracingStartedInBrowser");if(n?.args.data?.frames){let i=n.args.data.frames.find(l=>!l.parent),c=i?.frame,u=i?.processId;if(u&&c)return{startingPid:u,frameId:c}}let r=t.find(i=>i.name==="TracingStartedInPage");if(r?.args?.data){let i=r.args.data.page;if(i)return{startingPid:r.pid,frameId:i}}let a=t.find(i=>this._isNavigationStartOfInterest(i)&&i.args.data?.isLoadingMainFrame),o=t.find(i=>i.name==="ResourceSendRequest");if(a?.args?.data&&o&&o.pid===a.pid&&o.tid===a.tid){let i=a.args.frame;if(i)return{startingPid:a.pid,frameId:i}}throw this.createNoTracingStartedError()}static findMainFramePidTids(t,n){let r=n.filter(i=>(i.name==="FrameCommittedInBrowser"||i.name==="ProcessReadyInBrowser")&&i.args?.data?.frame===t.frameId&&i?.args?.data?.processId),a=r.length?r.map(i=>i?.args?.data?.processId):[t.startingPid],o=new Map;for(let i of new Set(a)){let c=n.filter(m=>m.cat==="__metadata"&&m.pid===i&&m.ph==="M"&&m.name==="thread_name"),u=c.find(m=>m.args.name==="CrRendererMain");u||(u=c.find(m=>m.args.name==="CrBrowserMain"));let l=u?.tid;if(!l)throw new Error("Unable to determine tid for renderer process");o.set(i,l)}return o}static isScheduleableTask(t){return t.name===Aq||t.name===_q||t.name===Rq||t.name===Fq}static isLCPEvent(t){return t.name!=="largestContentfulPaint::Invalidate"&&t.name!=="largestContentfulPaint::Candidate"?!1:!!t.args?.frame}static isLCPCandidateEvent(t){return!!(t.name==="largestContentfulPaint::Candidate"&&t.args?.frame&&t.args.data&&t.args.data.size!==void 0)}static getFrameId(t){return t.args?.data?.frame||t.args.data?.frameID||t.args.frame}static computeValidLCPAllFrames(t,n){let r=t.filter(this.isLCPEvent).reverse(),a=new Map;for(let i of r){if(i.ts<=n.ts)break;let c=i.args.frame;a.has(c)||a.set(c,i)}let o;for(let i of a.values())this.isLCPCandidateEvent(i)&&(!o||i.args.data.size>o.args.data.size)&&(o=i);return{lcp:o,invalidated:!!(!o&&a.size)}}static resolveRootFrames(t){let n=new Map;for(let a of t)a.parent&&n.set(a.id,a.parent);let r=new Map;for(let a of t){let o=a.id;for(;n.has(o);)o=n.get(o);if(o===void 0)throw new Error("Unexpected undefined frameId");r.set(a.id,o)}return r}static processTrace(t,n){let{timeOriginDeterminationMethod:r="auto"}=n||{},a=this.filteredTraceSort(t.traceEvents,C=>C.cat.includes("blink.user_timing")||C.cat.includes("loading")||C.cat.includes("devtools.timeline")||C.cat==="__metadata"),o=this.findMainFrameIds(a),i=this.findMainFramePidTids(o,a),c=e.filteredTraceSort(t.traceEvents,C=>i.has(C.pid)),u=new Map,l=a.find(C=>C.name==="TracingStartedInBrowser")?.args?.data?.frames;if(l)for(let C of l)u.set(C.frame,{id:C.frame,url:C.url,parent:C.parent});a.filter(C=>!!(C.name==="FrameCommittedInBrowser"&&C.args.data?.frame&&C.args.data.url!==void 0)).forEach(C=>{u.set(C.args.data.frame,{id:C.args.data.frame,url:C.args.data.url,parent:C.args.data.parent})});let m=[...u.values()],p=this.resolveRootFrames(m),h=[...p.entries()].filter(([,C])=>C===o.frameId).map(([C])=>C);function f(C){return e.getFrameId(C)===o.frameId}s(f,"associatedToMainFrame");function y(C){let R=e.getFrameId(C);return R?h.includes(R):!1}s(y,"associatedToAllFrames");let v=a.filter(C=>f(C)),D=[];p.has(o.frameId)?D=a.filter(C=>y(C)):(F.warn("TraceProcessor","frameTreeEvents may be incomplete, make sure the trace has frame events"),p.set(o.frameId,o.frameId),D=v);let E=this.computeTimeOrigin({keyEvents:a,frameEvents:v,mainFrameInfo:o},r),S=c.filter(C=>C.tid===i.get(C.pid)),k=this.computeTraceEnd(t.traceEvents,E);return{frames:m,mainThreadEvents:S,frameEvents:v,frameTreeEvents:D,processEvents:c,mainFrameInfo:o,timeOriginEvt:E,timings:{timeOrigin:0,traceEnd:k.timing},timestamps:{timeOrigin:E.ts,traceEnd:k.timestamp},_keyEvents:a,_rendererPidToTid:i}}static processNavigation(t){let{frameEvents:n,frameTreeEvents:r,timeOriginEvt:a,timings:o,timestamps:i}=t,c=this.computeNavigationTimingsForFrame(n,{timeOriginEvt:a}),u=r.find(h=>h.name==="firstContentfulPaint"&&h.ts>a.ts);if(!u)throw this.createNoFirstContentfulPaintError();let l=this.computeValidLCPAllFrames(r,a).lcp,m=s(h=>(h-a.ts)/1e3,"getTiming"),p=s(h=>h===void 0?void 0:m(h),"maybeGetTiming");return{timings:{timeOrigin:o.timeOrigin,firstPaint:c.timings.firstPaint,firstContentfulPaint:c.timings.firstContentfulPaint,firstContentfulPaintAllFrames:m(u.ts),firstMeaningfulPaint:c.timings.firstMeaningfulPaint,largestContentfulPaint:c.timings.largestContentfulPaint,largestContentfulPaintAllFrames:p(l?.ts),load:c.timings.load,domContentLoaded:c.timings.domContentLoaded,traceEnd:o.traceEnd},timestamps:{timeOrigin:i.timeOrigin,firstPaint:c.timestamps.firstPaint,firstContentfulPaint:c.timestamps.firstContentfulPaint,firstContentfulPaintAllFrames:u.ts,firstMeaningfulPaint:c.timestamps.firstMeaningfulPaint,largestContentfulPaint:c.timestamps.largestContentfulPaint,largestContentfulPaintAllFrames:l?.ts,load:c.timestamps.load,domContentLoaded:c.timestamps.domContentLoaded,traceEnd:i.traceEnd},firstPaintEvt:c.firstPaintEvt,firstContentfulPaintEvt:c.firstContentfulPaintEvt,firstContentfulPaintAllFramesEvt:u,firstMeaningfulPaintEvt:c.firstMeaningfulPaintEvt,largestContentfulPaintEvt:c.largestContentfulPaintEvt,largestContentfulPaintAllFramesEvt:l,loadEvt:c.loadEvt,domContentLoadedEvt:c.domContentLoadedEvt,fmpFellBack:c.fmpFellBack,lcpInvalidated:c.lcpInvalidated}}static computeTraceEnd(t,n){let r=-1/0;for(let a of t)r=Math.max(a.ts+(a.dur||0),r);return{timestamp:r,timing:(r-n.ts)/1e3}}static computeTimeOrigin(t,n){let r=s(()=>t.frameEvents.filter(this._isNavigationStartOfInterest).pop(),"lastNavigationStart"),a=s(()=>t.keyEvents.find(i=>i.name==="clock_sync"&&i.args.sync_id===e.TIMESPAN_MARKER_ID),"lighthouseMarker");switch(n){case"firstResourceSendRequest":{let o=t.keyEvents.find(i=>i.name!=="ResourceSendRequest"?!1:(i.args.data||{}).frame===t.mainFrameInfo.frameId);if(!o)throw this.createNoResourceSendRequestError();return o}case"lastNavigationStart":{let o=r();if(!o)throw this.createNoNavstartError();return o}case"lighthouseMarker":{let o=a();if(!o)throw this.createNoLighthouseMarkerError();return o}case"auto":{let o=a()||r();if(!o)throw this.createNoNavstartError();return o}}}static computeNavigationTimingsForFrame(t,n){let{timeOriginEvt:r}=n,a=t.find(D=>D.name==="firstPaint"&&D.ts>r.ts),o=t.find(D=>D.name==="firstContentfulPaint"&&D.ts>r.ts);if(!o)throw this.createNoFirstContentfulPaintError();let i=t.find(D=>D.name==="firstMeaningfulPaint"&&D.ts>r.ts),c=!1;if(!i){let D="firstMeaningfulPaintCandidate";c=!0,F.verbose("TraceProcessor",`No firstMeaningfulPaint found, falling back to last ${D}`);let E=t.filter(S=>S.name===D).pop();E||F.verbose("TraceProcessor","No `firstMeaningfulPaintCandidate` events found in trace"),i=E}let u=this.computeValidLCPAllFrames(t,r),l=t.find(D=>D.name==="loadEventEnd"&&D.ts>r.ts),m=t.find(D=>D.name==="domContentLoadedEventEnd"&&D.ts>r.ts),p=s(D=>D?.ts,"getTimestamp"),h={timeOrigin:r.ts,firstPaint:p(a),firstContentfulPaint:o.ts,firstMeaningfulPaint:p(i),largestContentfulPaint:p(u.lcp),load:p(l),domContentLoaded:p(m)},f=s(D=>(D-r.ts)/1e3,"getTiming"),y=s(D=>D===void 0?void 0:f(D),"maybeGetTiming");return{timings:{timeOrigin:0,firstPaint:y(h.firstPaint),firstContentfulPaint:f(h.firstContentfulPaint),firstMeaningfulPaint:y(h.firstMeaningfulPaint),largestContentfulPaint:y(h.largestContentfulPaint),load:y(h.load),domContentLoaded:y(h.domContentLoaded)},timestamps:h,timeOriginEvt:r,firstPaintEvt:a,firstContentfulPaintEvt:o,firstMeaningfulPaintEvt:i,largestContentfulPaintEvt:u.lcp,loadEvt:l,domContentLoadedEvt:m,fmpFellBack:c,lcpInvalidated:u.invalidated}}}});var L2={};T(L2,{default:()=>Xr});var r1,Xr,Mi=b(()=>{"use strict";d();Se();vr();r1=class e extends ${static{s(this,"Trace")}_trace={traceEvents:[]};static getDefaultTraceCategories(){return["-*","disabled-by-default-lighthouse","loading","v8","v8.execute","blink.user_timing","blink.console","devtools.timeline","disabled-by-default-devtools.timeline","disabled-by-default-devtools.screenshot","disabled-by-default-devtools.timeline.stack","disabled-by-default-devtools.timeline.frame","latencyInfo"]}static async endTraceAndCollectEvents(t){let n=[],r=s(function(a){n.push(...a.value)},"dataListener");return t.on("Tracing.dataCollected",r),new Promise((a,o)=>{t.once("Tracing.tracingComplete",i=>{t.off("Tracing.dataCollected",r),a({traceEvents:n})}),t.sendCommand("Tracing.end").catch(o)})}static symbol=Symbol("Trace");meta={symbol:e.symbol,supportedModes:["timespan","navigation"]};async startSensitiveInstrumentation({driver:t,gatherMode:n,settings:r}){let a=e.getDefaultTraceCategories().concat(r.additionalTraceCategories||[]);await t.defaultSession.sendCommand("Page.enable"),await t.defaultSession.sendCommand("Tracing.start",{categories:a.join(","),options:"sampling-frequency=10000"}),n==="timespan"&&await t.defaultSession.sendCommand("Tracing.recordClockSyncMarker",{syncId:qt.TIMESPAN_MARKER_ID})}async stopSensitiveInstrumentation({driver:t}){this._trace=await e.endTraceAndCollectEvents(t.defaultSession)}getArtifact(){return this._trace}},Xr=r1});var P2={};T(P2,{default:()=>Sn});var Sn,Jr=b(()=>{d();Sn={}});function O2(e,t){for(var n=0,r=e.length-1;r>=0;r--){var a=e[r];a==="."?e.splice(r,1):a===".."?(e.splice(r,1),n++):n&&(e.splice(r,1),n--)}if(t)for(;n--;n)e.unshift("..");return e}function a1(){for(var e="",t=!1,n=arguments.length-1;n>=-1&&!t;n--){var r=n>=0?arguments[n]:"/";if(typeof r!="string")throw new TypeError("Arguments to path.resolve must be strings");if(!r)continue;e=r+"/"+e,t=r.charAt(0)==="/"}return e=O2(i1(e.split("/"),function(a){return!!a}),!t).join("/"),(t?"/":"")+e||"."}function B2(e){var t=U2(e),n=jq(e,-1)==="/";return e=O2(i1(e.split("/"),function(r){return!!r}),!t).join("/"),!e&&!t&&(e="."),e&&n&&(e+="/"),(t?"/":"")+e}function U2(e){return e.charAt(0)==="/"}function Nq(){var e=Array.prototype.slice.call(arguments,0);return B2(i1(e,function(t,n){if(typeof t!="string")throw new TypeError("Arguments to path.join must be strings");return t}).join("/"))}function Mq(e,t){e=a1(e).substr(1),t=a1(t).substr(1);function n(l){for(var m=0;m<l.length&&l[m]==="";m++);for(var p=l.length-1;p>=0&&l[p]==="";p--);return m>p?[]:l.slice(m,p-m+1)}s(n,"trim");for(var r=n(e.split("/")),a=n(t.split("/")),o=Math.min(r.length,a.length),i=o,c=0;c<o;c++)if(r[c]!==a[c]){i=c;break}for(var u=[],c=i;c<r.length;c++)u.push("..");return u=u.concat(a.slice(i)),u.join("/")}function Oq(e){var t=o1(e),n=t[0],r=t[1];return!n&&!r?".":(r&&(r=r.substr(0,r.length-1)),n+r)}function Bq(e,t){var n=o1(e)[2];return t&&n.substr(-1*t.length)===t&&(n=n.substr(0,n.length-t.length)),n}function Uq(e){return o1(e)[3]}function i1(e,t){if(e.filter)return e.filter(t);for(var n=[],r=0;r<e.length;r++)t(e[r],r,e)&&n.push(e[r]);return n}var Iq,o1,Lq,Pq,Dt,jq,Aa=b(()=>{d();s(O2,"normalizeArray");Iq=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/,o1=s(function(e){return Iq.exec(e).slice(1)},"splitPath");s(a1,"resolve");s(B2,"normalize");s(U2,"isAbsolute");s(Nq,"join");s(Mq,"relative");Lq="/",Pq=":";s(Oq,"dirname");s(Bq,"basename");s(Uq,"extname");Dt={extname:Uq,basename:Bq,dirname:Oq,sep:Lq,delimiter:Pq,relative:Mq,join:Nq,isAbsolute:U2,normalize:B2,resolve:a1};s(i1,"filter");jq="ab".substr(-1)==="b"?function(e,t,n){return e.substr(t,n)}:function(e,t,n){return t<0&&(t=e.length+t),e.substr(t,n)}});var q2=I((Qle,j2)=>{d();function qq(){this.__data__=[],this.size=0}s(qq,"listCacheClear");j2.exports=qq});var s1=I((nde,z2)=>{d();function zq(e,t){return e===t||e!==e&&t!==t}s(zq,"eq");z2.exports=zq});var Xc=I((ode,H2)=>{d();var Hq=s1();function Gq(e,t){for(var n=e.length;n--;)if(Hq(e[n][0],t))return n;return-1}s(Gq,"assocIndexOf");H2.exports=Gq});var V2=I((cde,G2)=>{d();var Vq=Xc(),Wq=Array.prototype,$q=Wq.splice;function Yq(e){var t=this.__data__,n=Vq(t,e);if(n<0)return!1;var r=t.length-1;return n==r?t.pop():$q.call(t,n,1),--this.size,!0}s(Yq,"listCacheDelete");G2.exports=Yq});var $2=I((dde,W2)=>{d();var Kq=Xc();function Xq(e){var t=this.__data__,n=Kq(t,e);return n<0?void 0:t[n][1]}s(Xq,"listCacheGet");W2.exports=Xq});var K2=I((fde,Y2)=>{d();var Jq=Xc();function Zq(e){return Jq(this.__data__,e)>-1}s(Zq,"listCacheHas");Y2.exports=Zq});var J2=I((yde,X2)=>{d();var Qq=Xc();function ez(e,t){var n=this.__data__,r=Qq(n,e);return r<0?(++this.size,n.push([e,t])):n[r][1]=t,this}s(ez,"listCacheSet");X2.exports=ez});var Jc=I((wde,Z2)=>{d();var tz=q2(),nz=V2(),rz=$2(),az=K2(),oz=J2();function Li(e){var t=-1,n=e==null?0:e.length;for(this.clear();++t<n;){var r=e[t];this.set(r[0],r[1])}}s(Li,"ListCache");Li.prototype.clear=tz;Li.prototype.delete=nz;Li.prototype.get=rz;Li.prototype.has=az;Li.prototype.set=oz;Z2.exports=Li});var ek=I((xde,Q2)=>{d();var iz=Jc();function sz(){this.__data__=new iz,this.size=0}s(sz,"stackClear");Q2.exports=sz});var nk=I((kde,tk)=>{d();function cz(e){var t=this.__data__,n=t.delete(e);return this.size=t.size,n}s(cz,"stackDelete");tk.exports=cz});var ak=I((_de,rk)=>{d();function uz(e){return this.__data__.get(e)}s(uz,"stackGet");rk.exports=uz});var ik=I((Ide,ok)=>{d();function lz(e){return this.__data__.has(e)}s(lz,"stackHas");ok.exports=lz});var c1=I((Lde,sk)=>{d();var dz=typeof globalThis=="object"&&globalThis&&globalThis.Object===Object&&globalThis;sk.exports=dz});var wr=I((Ode,ck)=>{d();var mz=c1(),pz=typeof self=="object"&&self&&self.Object===Object&&self,fz=mz||pz||Function("return this")();ck.exports=fz});var qm=I((Ude,uk)=>{d();var hz=wr(),gz=hz.Symbol;uk.exports=gz});var pk=I((qde,mk)=>{d();var lk=qm(),dk=Object.prototype,yz=dk.hasOwnProperty,bz=dk.toString,Zc=lk?lk.toStringTag:void 0;function vz(e){var t=yz.call(e,Zc),n=e[Zc];try{e[Zc]=void 0;var r=!0}catch{}var a=bz.call(e);return r&&(t?e[Zc]=n:delete e[Zc]),a}s(vz,"getRawTag");mk.exports=vz});var hk=I((Gde,fk)=>{d();var wz=Object.prototype,Dz=wz.toString;function Ez(e){return Dz.call(e)}s(Ez,"objectToString");fk.exports=Ez});var Qc=I(($de,bk)=>{d();var gk=qm(),xz=pk(),Tz=hk(),Sz="[object Null]",kz="[object Undefined]",yk=gk?gk.toStringTag:void 0;function Cz(e){return e==null?e===void 0?kz:Sz:yk&&yk in Object(e)?xz(e):Tz(e)}s(Cz,"baseGetTag");bk.exports=Cz});var u1=I((Xde,vk)=>{d();function Az(e){var t=typeof e;return e!=null&&(t=="object"||t=="function")}s(Az,"isObject");vk.exports=Az});var l1=I((Qde,wk)=>{d();var _z=Qc(),Rz=u1(),Fz="[object AsyncFunction]",Iz="[object Function]",Nz="[object GeneratorFunction]",Mz="[object Proxy]";function Lz(e){if(!Rz(e))return!1;var t=_z(e);return t==Iz||t==Nz||t==Fz||t==Mz}s(Lz,"isFunction");wk.exports=Lz});var Ek=I((nme,Dk)=>{d();var Pz=wr(),Oz=Pz["__core-js_shared__"];Dk.exports=Oz});var Sk=I((ame,Tk)=>{d();var d1=Ek(),xk=function(){var e=/[^.]+$/.exec(d1&&d1.keys&&d1.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}();function Bz(e){return!!xk&&xk in e}s(Bz,"isMasked");Tk.exports=Bz});var m1=I((sme,kk)=>{d();var Uz=Function.prototype,jz=Uz.toString;function qz(e){if(e!=null){try{return jz.call(e)}catch{}try{return e+""}catch{}}return""}s(qz,"toSource");kk.exports=qz});var Ak=I((lme,Ck)=>{d();var zz=l1(),Hz=Sk(),Gz=u1(),Vz=m1(),Wz=/[\\^$.*+?()[\]{}|]/g,$z=/^\[object .+?Constructor\]$/,Yz=Function.prototype,Kz=Object.prototype,Xz=Yz.toString,Jz=Kz.hasOwnProperty,Zz=RegExp("^"+Xz.call(Jz).replace(Wz,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");function Qz(e){if(!Gz(e)||Hz(e))return!1;var t=zz(e)?Zz:$z;return t.test(Vz(e))}s(Qz,"baseIsNative");Ck.exports=Qz});var Rk=I((pme,_k)=>{d();function eH(e,t){return e?.[t]}s(eH,"getValue");_k.exports=eH});var _o=I((gme,Fk)=>{d();var tH=Ak(),nH=Rk();function rH(e,t){var n=nH(e,t);return tH(n)?n:void 0}s(rH,"getNative");Fk.exports=rH});var zm=I((vme,Ik)=>{d();var aH=_o(),oH=wr(),iH=aH(oH,"Map");Ik.exports=iH});var eu=I((Dme,Nk)=>{d();var sH=_o(),cH=sH(Object,"create");Nk.exports=cH});var Pk=I((xme,Lk)=>{d();var Mk=eu();function uH(){this.__data__=Mk?Mk(null):{},this.size=0}s(uH,"hashClear");Lk.exports=uH});var Bk=I((kme,Ok)=>{d();function lH(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t}s(lH,"hashDelete");Ok.exports=lH});var jk=I((_me,Uk)=>{d();var dH=eu(),mH="__lodash_hash_undefined__",pH=Object.prototype,fH=pH.hasOwnProperty;function hH(e){var t=this.__data__;if(dH){var n=t[e];return n===mH?void 0:n}return fH.call(t,e)?t[e]:void 0}s(hH,"hashGet");Uk.exports=hH});var zk=I((Ime,qk)=>{d();var gH=eu(),yH=Object.prototype,bH=yH.hasOwnProperty;function vH(e){var t=this.__data__;return gH?t[e]!==void 0:bH.call(t,e)}s(vH,"hashHas");qk.exports=vH});var Gk=I((Lme,Hk)=>{d();var wH=eu(),DH="__lodash_hash_undefined__";function EH(e,t){var n=this.__data__;return this.size+=this.has(e)?0:1,n[e]=wH&&t===void 0?DH:t,this}s(EH,"hashSet");Hk.exports=EH});var Wk=I((Bme,Vk)=>{d();var xH=Pk(),TH=Bk(),SH=jk(),kH=zk(),CH=Gk();function Pi(e){var t=-1,n=e==null?0:e.length;for(this.clear();++t<n;){var r=e[t];this.set(r[0],r[1])}}s(Pi,"Hash");Pi.prototype.clear=xH;Pi.prototype.delete=TH;Pi.prototype.get=SH;Pi.prototype.has=kH;Pi.prototype.set=CH;Vk.exports=Pi});var Kk=I((qme,Yk)=>{d();var $k=Wk(),AH=Jc(),_H=zm();function RH(){this.size=0,this.__data__={hash:new $k,map:new(_H||AH),string:new $k}}s(RH,"mapCacheClear");Yk.exports=RH});var Jk=I((Gme,Xk)=>{d();function FH(e){var t=typeof e;return t=="string"||t=="number"||t=="symbol"||t=="boolean"?e!=="__proto__":e===null}s(FH,"isKeyable");Xk.exports=FH});var tu=I(($me,Zk)=>{d();var IH=Jk();function NH(e,t){var n=e.__data__;return IH(t)?n[typeof t=="string"?"string":"hash"]:n.map}s(NH,"getMapData");Zk.exports=NH});var eC=I((Xme,Qk)=>{d();var MH=tu();function LH(e){var t=MH(this,e).delete(e);return this.size-=t?1:0,t}s(LH,"mapCacheDelete");Qk.exports=LH});var nC=I((Qme,tC)=>{d();var PH=tu();function OH(e){return PH(this,e).get(e)}s(OH,"mapCacheGet");tC.exports=OH});var aC=I((npe,rC)=>{d();var BH=tu();function UH(e){return BH(this,e).has(e)}s(UH,"mapCacheHas");rC.exports=UH});var iC=I((ope,oC)=>{d();var jH=tu();function qH(e,t){var n=jH(this,e),r=n.size;return n.set(e,t),this.size+=n.size==r?0:1,this}s(qH,"mapCacheSet");oC.exports=qH});var p1=I((cpe,sC)=>{d();var zH=Kk(),HH=eC(),GH=nC(),VH=aC(),WH=iC();function Oi(e){var t=-1,n=e==null?0:e.length;for(this.clear();++t<n;){var r=e[t];this.set(r[0],r[1])}}s(Oi,"MapCache");Oi.prototype.clear=zH;Oi.prototype.delete=HH;Oi.prototype.get=GH;Oi.prototype.has=VH;Oi.prototype.set=WH;sC.exports=Oi});var uC=I((dpe,cC)=>{d();var $H=Jc(),YH=zm(),KH=p1(),XH=200;function JH(e,t){var n=this.__data__;if(n instanceof $H){var r=n.__data__;if(!YH||r.length<XH-1)return r.push([e,t]),this.size=++n.size,this;n=this.__data__=new KH(r)}return n.set(e,t),this.size=n.size,this}s(JH,"stackSet");cC.exports=JH});var dC=I((fpe,lC)=>{d();var ZH=Jc(),QH=ek(),eG=nk(),tG=ak(),nG=ik(),rG=uC();function Bi(e){var t=this.__data__=new ZH(e);this.size=t.size}s(Bi,"Stack");Bi.prototype.clear=QH;Bi.prototype.delete=eG;Bi.prototype.get=tG;Bi.prototype.has=nG;Bi.prototype.set=rG;lC.exports=Bi});var pC=I((ype,mC)=>{d();var aG="__lodash_hash_undefined__";function oG(e){return this.__data__.set(e,aG),this}s(oG,"setCacheAdd");mC.exports=oG});var hC=I((wpe,fC)=>{d();function iG(e){return this.__data__.has(e)}s(iG,"setCacheHas");fC.exports=iG});var yC=I((xpe,gC)=>{d();var sG=p1(),cG=pC(),uG=hC();function Hm(e){var t=-1,n=e==null?0:e.length;for(this.__data__=new sG;++t<n;)this.add(e[t])}s(Hm,"SetCache");Hm.prototype.add=Hm.prototype.push=cG;Hm.prototype.has=uG;gC.exports=Hm});var vC=I((kpe,bC)=>{d();function lG(e,t){for(var n=-1,r=e==null?0:e.length;++n<r;)if(t(e[n],n,e))return!0;return!1}s(lG,"arraySome");bC.exports=lG});var DC=I((_pe,wC)=>{d();function dG(e,t){return e.has(t)}s(dG,"cacheHas");wC.exports=dG});var f1=I((Ipe,EC)=>{d();var mG=yC(),pG=vC(),fG=DC(),hG=1,gG=2;function yG(e,t,n,r,a,o){var i=n&hG,c=e.length,u=t.length;if(c!=u&&!(i&&u>c))return!1;var l=o.get(e),m=o.get(t);if(l&&m)return l==t&&m==e;var p=-1,h=!0,f=n&gG?new mG:void 0;for(o.set(e,t),o.set(t,e);++p<c;){var y=e[p],v=t[p];if(r)var D=i?r(v,y,p,t,e,o):r(y,v,p,e,t,o);if(D!==void 0){if(D)continue;h=!1;break}if(f){if(!pG(t,function(E,S){if(!fG(f,S)&&(y===E||a(y,E,n,r,o)))return f.push(S)})){h=!1;break}}else if(!(y===v||a(y,v,n,r,o))){h=!1;break}}return o.delete(e),o.delete(t),h}s(yG,"equalArrays");EC.exports=yG});var TC=I((Lpe,xC)=>{d();var bG=wr(),vG=bG.Uint8Array;xC.exports=vG});var kC=I((Ope,SC)=>{d();function wG(e){var t=-1,n=Array(e.size);return e.forEach(function(r,a){n[++t]=[a,r]}),n}s(wG,"mapToArray");SC.exports=wG});var AC=I((jpe,CC)=>{d();function DG(e){var t=-1,n=Array(e.size);return e.forEach(function(r){n[++t]=r}),n}s(DG,"setToArray");CC.exports=DG});var NC=I((Hpe,IC)=>{d();var _C=qm(),RC=TC(),EG=s1(),xG=f1(),TG=kC(),SG=AC(),kG=1,CG=2,AG="[object Boolean]",_G="[object Date]",RG="[object Error]",FG="[object Map]",IG="[object Number]",NG="[object RegExp]",MG="[object Set]",LG="[object String]",PG="[object Symbol]",OG="[object ArrayBuffer]",BG="[object DataView]",FC=_C?_C.prototype:void 0,h1=FC?FC.valueOf:void 0;function UG(e,t,n,r,a,o,i){switch(n){case BG:if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case OG:return!(e.byteLength!=t.byteLength||!o(new RC(e),new RC(t)));case AG:case _G:case IG:return EG(+e,+t);case RG:return e.name==t.name&&e.message==t.message;case NG:case LG:return e==t+"";case FG:var c=TG;case MG:var u=r&kG;if(c||(c=SG),e.size!=t.size&&!u)return!1;var l=i.get(e);if(l)return l==t;r|=CG,i.set(e,t);var m=xG(c(e),c(t),r,a,o,i);return i.delete(e),m;case PG:if(h1)return h1.call(e)==h1.call(t)}return!1}s(UG,"equalByTag");IC.exports=UG});var LC=I((Wpe,MC)=>{d();function jG(e,t){for(var n=-1,r=t.length,a=e.length;++n<r;)e[a+n]=t[n];return e}s(jG,"arrayPush");MC.exports=jG});var Gm=I((Kpe,PC)=>{d();var qG=Array.isArray;PC.exports=qG});var BC=I((Jpe,OC)=>{d();var zG=LC(),HG=Gm();function GG(e,t,n){var r=t(e);return HG(e)?r:zG(r,n(e))}s(GG,"baseGetAllKeys");OC.exports=GG});var jC=I((efe,UC)=>{d();function VG(e,t){for(var n=-1,r=e==null?0:e.length,a=0,o=[];++n<r;){var i=e[n];t(i,n,e)&&(o[a++]=i)}return o}s(VG,"arrayFilter");UC.exports=VG});var zC=I((rfe,qC)=>{d();function WG(){return[]}s(WG,"stubArray");qC.exports=WG});var VC=I((ife,GC)=>{d();var $G=jC(),YG=zC(),KG=Object.prototype,XG=KG.propertyIsEnumerable,HC=Object.getOwnPropertySymbols,JG=HC?function(e){return e==null?[]:(e=Object(e),$G(HC(e),function(t){return XG.call(e,t)}))}:YG;GC.exports=JG});var $C=I((cfe,WC)=>{d();function ZG(e,t){for(var n=-1,r=Array(e);++n<e;)r[n]=t(n);return r}s(ZG,"baseTimes");WC.exports=ZG});var nu=I((dfe,YC)=>{d();function QG(e){return e!=null&&typeof e=="object"}s(QG,"isObjectLike");YC.exports=QG});var XC=I((ffe,KC)=>{d();var eV=Qc(),tV=nu(),nV="[object Arguments]";function rV(e){return tV(e)&&eV(e)==nV}s(rV,"baseIsArguments");KC.exports=rV});var eA=I((yfe,QC)=>{d();var JC=XC(),aV=nu(),ZC=Object.prototype,oV=ZC.hasOwnProperty,iV=ZC.propertyIsEnumerable,sV=JC(function(){return arguments}())?JC:function(e){return aV(e)&&oV.call(e,"callee")&&!iV.call(e,"callee")};QC.exports=sV});var nA=I((vfe,tA)=>{d();function cV(){return!1}s(cV,"stubFalse");tA.exports=cV});var g1=I((ru,Ui)=>{d();var uV=wr(),lV=nA(),oA=typeof ru=="object"&&ru&&!ru.nodeType&&ru,rA=oA&&typeof Ui=="object"&&Ui&&!Ui.nodeType&&Ui,dV=rA&&rA.exports===oA,aA=dV?uV.Buffer:void 0,mV=aA?aA.isBuffer:void 0,pV=mV||lV;Ui.exports=pV});var sA=I((xfe,iA)=>{d();var fV=9007199254740991,hV=/^(?:0|[1-9]\d*)$/;function gV(e,t){var n=typeof e;return t=t??fV,!!t&&(n=="number"||n!="symbol"&&hV.test(e))&&e>-1&&e%1==0&&e<t}s(gV,"isIndex");iA.exports=gV});var y1=I((kfe,cA)=>{d();var yV=9007199254740991;function bV(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=yV}s(bV,"isLength");cA.exports=bV});var lA=I((_fe,uA)=>{d();var vV=Qc(),wV=y1(),DV=nu(),EV="[object Arguments]",xV="[object Array]",TV="[object Boolean]",SV="[object Date]",kV="[object Error]",CV="[object Function]",AV="[object Map]",_V="[object Number]",RV="[object Object]",FV="[object RegExp]",IV="[object Set]",NV="[object String]",MV="[object WeakMap]",LV="[object ArrayBuffer]",PV="[object DataView]",OV="[object Float32Array]",BV="[object Float64Array]",UV="[object Int8Array]",jV="[object Int16Array]",qV="[object Int32Array]",zV="[object Uint8Array]",HV="[object Uint8ClampedArray]",GV="[object Uint16Array]",VV="[object Uint32Array]",bt={};bt[OV]=bt[BV]=bt[UV]=bt[jV]=bt[qV]=bt[zV]=bt[HV]=bt[GV]=bt[VV]=!0;bt[EV]=bt[xV]=bt[LV]=bt[TV]=bt[PV]=bt[SV]=bt[kV]=bt[CV]=bt[AV]=bt[_V]=bt[RV]=bt[FV]=bt[IV]=bt[NV]=bt[MV]=!1;function WV(e){return DV(e)&&wV(e.length)&&!!bt[vV(e)]}s(WV,"baseIsTypedArray");uA.exports=WV});var mA=I((Ife,dA)=>{d();function $V(e){return function(t){return e(t)}}s($V,"baseUnary");dA.exports=$V});var fA=I((au,ji)=>{d();var YV=c1(),pA=typeof au=="object"&&au&&!au.nodeType&&au,ou=pA&&typeof ji=="object"&&ji&&!ji.nodeType&&ji,KV=ou&&ou.exports===pA,b1=KV&&YV.process,XV=function(){try{var e=ou&&ou.require&&ou.require("util").types;return e||b1&&b1.binding&&b1.binding("util")}catch{}}();ji.exports=XV});var v1=I((Pfe,yA)=>{d();var JV=lA(),ZV=mA(),hA=fA(),gA=hA&&hA.isTypedArray,QV=gA?ZV(gA):JV;yA.exports=QV});var vA=I((Bfe,bA)=>{d();var eW=$C(),tW=eA(),nW=Gm(),rW=g1(),aW=sA(),oW=v1(),iW=Object.prototype,sW=iW.hasOwnProperty;function cW(e,t){var n=nW(e),r=!n&&tW(e),a=!n&&!r&&rW(e),o=!n&&!r&&!a&&oW(e),i=n||r||a||o,c=i?eW(e.length,String):[],u=c.length;for(var l in e)(t||sW.call(e,l))&&!(i&&(l=="length"||a&&(l=="offset"||l=="parent")||o&&(l=="buffer"||l=="byteLength"||l=="byteOffset")||aW(l,u)))&&c.push(l);return c}s(cW,"arrayLikeKeys");bA.exports=cW});var DA=I((qfe,wA)=>{d();var uW=Object.prototype;function lW(e){var t=e&&e.constructor,n=typeof t=="function"&&t.prototype||uW;return e===n}s(lW,"isPrototype");wA.exports=lW});var xA=I((Gfe,EA)=>{d();function dW(e,t){return function(n){return e(t(n))}}s(dW,"overArg");EA.exports=dW});var SA=I(($fe,TA)=>{d();var mW=xA(),pW=mW(Object.keys,Object);TA.exports=pW});var CA=I((Kfe,kA)=>{d();var fW=DA(),hW=SA(),gW=Object.prototype,yW=gW.hasOwnProperty;function bW(e){if(!fW(e))return hW(e);var t=[];for(var n in Object(e))yW.call(e,n)&&n!="constructor"&&t.push(n);return t}s(bW,"baseKeys");kA.exports=bW});var _A=I((Zfe,AA)=>{d();var vW=l1(),wW=y1();function DW(e){return e!=null&&wW(e.length)&&!vW(e)}s(DW,"isArrayLike");AA.exports=DW});var FA=I((the,RA)=>{d();var EW=vA(),xW=CA(),TW=_A();function SW(e){return TW(e)?EW(e):xW(e)}s(SW,"keys");RA.exports=SW});var NA=I((ahe,IA)=>{d();var kW=BC(),CW=VC(),AW=FA();function _W(e){return kW(e,AW,CW)}s(_W,"getAllKeys");IA.exports=_W});var PA=I((she,LA)=>{d();var MA=NA(),RW=1,FW=Object.prototype,IW=FW.hasOwnProperty;function NW(e,t,n,r,a,o){var i=n&RW,c=MA(e),u=c.length,l=MA(t),m=l.length;if(u!=m&&!i)return!1;for(var p=u;p--;){var h=c[p];if(!(i?h in t:IW.call(t,h)))return!1}var f=o.get(e),y=o.get(t);if(f&&y)return f==t&&y==e;var v=!0;o.set(e,t),o.set(t,e);for(var D=i;++p<u;){h=c[p];var E=e[h],S=t[h];if(r)var k=i?r(S,E,h,t,e,o):r(E,S,h,e,t,o);if(!(k===void 0?E===S||a(E,S,n,r,o):k)){v=!1;break}D||(D=h=="constructor")}if(v&&!D){var C=e.constructor,R=t.constructor;C!=R&&"constructor"in e&&"constructor"in t&&!(typeof C=="function"&&C instanceof C&&typeof R=="function"&&R instanceof R)&&(v=!1)}return o.delete(e),o.delete(t),v}s(NW,"equalObjects");LA.exports=NW});var BA=I((lhe,OA)=>{d();var MW=_o(),LW=wr(),PW=MW(LW,"DataView");OA.exports=PW});var jA=I((mhe,UA)=>{d();var OW=_o(),BW=wr(),UW=OW(BW,"Promise");UA.exports=UW});var zA=I((fhe,qA)=>{d();var jW=_o(),qW=wr(),zW=jW(qW,"Set");qA.exports=zW});var GA=I((ghe,HA)=>{d();var HW=_o(),GW=wr(),VW=HW(GW,"WeakMap");HA.exports=VW});var ZA=I((bhe,JA)=>{d();var w1=BA(),D1=zm(),E1=jA(),x1=zA(),T1=GA(),XA=Qc(),qi=m1(),VA="[object Map]",WW="[object Object]",WA="[object Promise]",$A="[object Set]",YA="[object WeakMap]",KA="[object DataView]",$W=qi(w1),YW=qi(D1),KW=qi(E1),XW=qi(x1),JW=qi(T1),Ro=XA;(w1&&Ro(new w1(new ArrayBuffer(1)))!=KA||D1&&Ro(new D1)!=VA||E1&&Ro(E1.resolve())!=WA||x1&&Ro(new x1)!=$A||T1&&Ro(new T1)!=YA)&&(Ro=s(function(e){var t=XA(e),n=t==WW?e.constructor:void 0,r=n?qi(n):"";if(r)switch(r){case $W:return KA;case YW:return VA;case KW:return WA;case XW:return $A;case JW:return YA}return t},"getTag"));JA.exports=Ro});var i_=I((Dhe,o_)=>{d();var S1=dC(),ZW=f1(),QW=NC(),e$=PA(),QA=ZA(),e_=Gm(),t_=g1(),t$=v1(),n$=1,n_="[object Arguments]",r_="[object Array]",Vm="[object Object]",r$=Object.prototype,a_=r$.hasOwnProperty;function a$(e,t,n,r,a,o){var i=e_(e),c=e_(t),u=i?r_:QA(e),l=c?r_:QA(t);u=u==n_?Vm:u,l=l==n_?Vm:l;var m=u==Vm,p=l==Vm,h=u==l;if(h&&t_(e)){if(!t_(t))return!1;i=!0,m=!1}if(h&&!m)return o||(o=new S1),i||t$(e)?ZW(e,t,n,r,a,o):QW(e,t,u,n,r,a,o);if(!(n&n$)){var f=m&&a_.call(e,"__wrapped__"),y=p&&a_.call(t,"__wrapped__");if(f||y){var v=f?e.value():e,D=y?t.value():t;return o||(o=new S1),a(v,D,n,r,o)}}return h?(o||(o=new S1),e$(e,t,n,r,a,o)):!1}s(a$,"baseIsEqualDeep");o_.exports=a$});var l_=I((The,u_)=>{d();var o$=i_(),s_=nu();function c_(e,t,n,r,a){return e===t?!0:e==null||t==null||!s_(e)&&!s_(t)?e!==e&&t!==t:o$(e,t,n,r,c_,a)}s(c_,"baseIsEqual");u_.exports=c_});var iu=I((Che,d_)=>{d();var i$=l_();function s$(e,t){return i$(e,t)}s(s$,"isEqual");d_.exports=s$});var m_,p_=b(()=>{"use strict";d();Ta();m_=!!rn.env.CI||rn.env.NODE_ENV==="test"});function d$(e){let t=Math.sign(e);e=Math.abs(e);let n=.254829592,r=-.284496736,a=1.421413741,o=-1.453152027,i=1.061405429,u=1/(1+.3275911*e),l=u*(n+u*(r+u*(a+u*(o+u*i))));return t*(1-l*Math.exp(-e*e))}function f_({median:e,p10:t},n){if(e<=0)throw new Error("median must be greater than zero");if(t<=0)throw new Error("p10 must be greater than zero");if(t>=e)throw new Error("p10 must be less than the median");if(n<=0)return 1;let r=.9061938024368232,a=Math.max(Number.MIN_VALUE,n/e),o=Math.log(a),i=Math.max(Number.MIN_VALUE,t/e),c=-Math.log(i),u=o*r/c,l=(1-d$(u))/2,m;return n<=t?m=Math.max(.9,Math.min(1,l)):n<=e?m=Math.max(u$,Math.min(c$,l)):m=Math.max(0,Math.min(l$,l)),m}function h_(e,t,n,r,a){let o=(r-t)/(n-e);return t+(a-e)*o}var c$,u$,l$,k1=b(()=>{"use strict";d();c$=.8999999999999999,u$=.5,l$=.49999999999999994;s(d$,"erf");s(f_,"getLogNormalScore");s(h_,"linearInterpolation")});var Zr,p$,g_,f$,h$,Me,Fn=b(()=>{"use strict";d();k1();Zr="…",p$=" ",g_=.9,f$={PASS:{label:"pass",minScore:g_},AVERAGE:{label:"average",minScore:.5},FAIL:{label:"fail"},ERROR:{label:"error"}},h$=["com","co","gov","edu","ac","org","go","gob","or","net","in","ne","nic","gouv","web","spb","blog","jus","kiev","mil","wi","qc","ca","bel","on"],Me=class e{static{s(this,"Util")}static get RATINGS(){return f$}static get PASS_THRESHOLD(){return g_}static get MS_DISPLAY_VALUE(){return`%10d${p$}ms`}static getFinalDisplayedUrl(t){if(t.finalDisplayedUrl)return t.finalDisplayedUrl;if(t.finalUrl)return t.finalUrl;throw new Error("Could not determine final displayed URL")}static getMainDocumentUrl(t){return t.mainDocumentUrl||t.finalUrl}static getFullPageScreenshot(t){return t.fullPageScreenshot?t.fullPageScreenshot:t.audits["full-page-screenshot"]?.details}static getEntityFromUrl(t,n){return n&&n.find(a=>a.origins.find(o=>t.startsWith(o)))||e.getPseudoRootDomain(t)}static splitMarkdownCodeSpans(t){let n=[],r=t.split(/`(.*?)`/g);for(let a=0;a<r.length;a++){let o=r[a];if(!o)continue;let i=a%2!==0;n.push({isCode:i,text:o})}return n}static splitMarkdownLink(t){let n=[],r=t.split(/\[([^\]]+?)\]\((https?:\/\/.*?)\)/g);for(;r.length;){let[a,o,i]=r.splice(0,3);a&&n.push({isLink:!1,text:a}),o&&i&&n.push({isLink:!0,text:o,linkHref:i})}return n}static truncate(t,n,r="…"){if(t.length<=n)return t;let o=new Intl.Segmenter(void 0,{granularity:"grapheme"}).segment(t)[Symbol.iterator](),i=0;for(let c=0;c<=n-r.length;c++){let u=o.next();if(u.done)return t;i=u.value.index}for(let c=0;c<r.length;c++)if(o.next().done)return t;return t.slice(0,i)+r}static getURLDisplayName(t,n){n=n||{numPathParts:void 0,preserveQuery:void 0,preserveHost:void 0};let r=n.numPathParts!==void 0?n.numPathParts:2,a=n.preserveQuery!==void 0?n.preserveQuery:!0,o=n.preserveHost||!1,i;if(t.protocol==="about:"||t.protocol==="data:")i=t.href;else{i=t.pathname;let u=i.split("/").filter(l=>l.length);r&&u.length>r&&(i=Zr+u.slice(-1*r).join("/")),o&&(i=`${t.host}/${i.replace(/^\//,"")}`),a&&(i=`${i}${t.search}`)}let c=64;if(t.protocol!=="data:"&&(i=i.slice(0,200),i=i.replace(/([a-f0-9]{7})[a-f0-9]{13}[a-f0-9]*/g,`$1${Zr}`),i=i.replace(/([a-zA-Z0-9-_]{9})(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])[a-zA-Z0-9-_]{10,}/g,`$1${Zr}`),i=i.replace(/(\d{3})\d{6,}/g,`$1${Zr}`),i=i.replace(/\u2026+/g,Zr),i.length>c&&i.includes("?")&&(i=i.replace(/\?([^=]*)(=)?.*/,`?$1$2${Zr}`),i.length>c&&(i=i.replace(/\?.*/,`?${Zr}`)))),i.length>c){let u=i.lastIndexOf(".");u>=0?i=i.slice(0,c-1-(i.length-u))+`${Zr}${i.slice(u)}`:i=i.slice(0,c-1)+Zr}return i}static getChromeExtensionOrigin(t){let n=new URL(t);return n.protocol+"//"+n.host}static parseURL(t){let n=new URL(t);return{file:e.getURLDisplayName(n),hostname:n.hostname,origin:n.protocol==="chrome-extension:"?e.getChromeExtensionOrigin(t):n.origin}}static createOrReturnURL(t){return t instanceof URL?t:new URL(t)}static getPseudoTld(t){let n=t.split(".").slice(-2);return h$.includes(n[0])?`.${n.join(".")}`:`.${n[n.length-1]}`}static getPseudoRootDomain(t){let n=e.createOrReturnURL(t).hostname,a=e.getPseudoTld(n).split(".");return n.split(".").slice(-a.length).join(".")}static filterRelevantLines(t,n,r){if(n.length===0)return t.slice(0,r*2+1);let a=3,o=new Set;return n=n.sort((i,c)=>(i.lineNumber||0)-(c.lineNumber||0)),n.forEach(({lineNumber:i})=>{let c=i-r,u=i+r;for(;c<1;)c++,u++;o.has(c-a-1)&&(c-=a);for(let l=c;l<=u;l++){let m=l;o.add(m)}}),t.filter(i=>o.has(i.lineNumber))}static computeLogNormalScore(t,n){let r=f_(t,n);return r>.9&&(r+=.05*(r-.9)),Math.floor(r*100)/100}}});var g$,y$,g,V=b(()=>{"use strict";d();jt();p_();Fn();g$="defaultPass",y$=s(e=>Math.round(e*100)/100,"clampTo2Decimals"),g=class e{static{s(this,"Audit")}static get DEFAULT_PASS(){return g$}static get SCORING_MODES(){return{NUMERIC:"numeric",METRIC_SAVINGS:"metricSavings",BINARY:"binary",MANUAL:"manual",INFORMATIVE:"informative",NOT_APPLICABLE:"notApplicable",ERROR:"error"}}static get meta(){throw new Error("Audit meta information must be overridden.")}static get defaultOptions(){return{}}static audit(t,n){throw new Error("audit() method must be overridden")}static computeLogNormalScore(t,n){return Me.computeLogNormalScore(t,n)}static assertHeadingKeysExist(t,n){if(n.length&&m_)for(let r of t){if(r.key===null)continue;let a=r.key;if(!n.some(o=>a in o))throw new Error(`"${r.key}" is missing from items`)}}static makeTableDetails(t,n,r={}){let{wastedBytes:a,wastedMs:o,sortedBy:i,skipSumming:c,isEntityGrouped:u}=r,l=a||o?{wastedBytes:a,wastedMs:o}:void 0;return n.length===0?{type:"table",headings:[],items:[],summary:l}:(e.assertHeadingKeysExist(t,n),{type:"table",headings:t,items:n,summary:l,sortedBy:i,skipSumming:c,isEntityGrouped:u})}static makeListDetails(t){return{type:"list",items:t}}static makeSnippetDetails({content:t,title:n,lineMessages:r,generalMessages:a,node:o,maxLineLength:i=200,maxLinesAroundMessage:c=20}){let u=e._makeSnippetLinesArray(t,i);return{type:"snippet",lines:Me.filterRelevantLines(u,r,c),title:n,lineMessages:r,generalMessages:a,lineCount:u.length,node:o}}static _makeSnippetLinesArray(t,n){return t.split(`
`).map((r,a)=>{let o=a+1,i={content:Me.truncate(r,n),lineNumber:o};return r.length>n&&(i.truncated=!0),i})}static makeOpportunityDetails(t,n,r){e.assertHeadingKeysExist(t,n);let{overallSavingsMs:a,overallSavingsBytes:o,sortedBy:i,skipSumming:c,isEntityGrouped:u}=r;return{type:"opportunity",headings:n.length===0?[]:t,items:n,overallSavingsMs:a,overallSavingsBytes:o,sortedBy:i,skipSumming:c,isEntityGrouped:u}}static makeNodeItem(t){return{type:"node",lhId:t.lhId,path:t.devtoolsNodePath,selector:t.selector,boundingRect:t.boundingRect,snippet:t.snippet,nodeLabel:t.nodeLabel}}static _findOriginalLocation(t,n,r){let a=t?.map.findEntry(n,r);if(a)return{file:a.sourceURL||"",line:a.sourceLineNumber||0,column:a.sourceColumnNumber||0}}static makeSourceLocation(t,n,r,a){return{type:"source-location",url:t,urlProvider:"network",line:n,column:r,original:a&&this._findOriginalLocation(a,n,r)}}static makeSourceLocationFromConsoleMessage(t,n){if(!t.url)return;let r=t.lineNumber||0,a=t.columnNumber||0;return this.makeSourceLocation(t.url,r,a,n)}static _normalizeAuditScore(t,n,r){if(n!==e.SCORING_MODES.BINARY&&n!==e.SCORING_MODES.NUMERIC&&n!==e.SCORING_MODES.METRIC_SAVINGS)return null;if(t===null||!Number.isFinite(t))throw new Error(`Invalid score for ${r}: ${t}`);if(t>1)throw new Error(`Audit score for ${r} is > 1`);if(t<0)throw new Error(`Audit score for ${r} is < 0`);return t=y$(t),t}static generateErrorAuditResult(t,n,r){return e.generateAuditResult(t,{score:null,errorMessage:n,errorStack:r})}static generateAuditResult(t,n){if(n.score===void 0)throw new Error("generateAuditResult requires a score");let r=t.meta.scoreDisplayMode||e.SCORING_MODES.BINARY,a=n.score;n.errorMessage!==void 0?r=e.SCORING_MODES.ERROR:n.notApplicable?r=e.SCORING_MODES.NOT_APPLICABLE:n.scoreDisplayMode&&(r=n.scoreDisplayMode),r===e.SCORING_MODES.METRIC_SAVINGS&&(a&&a>=Me.PASS_THRESHOLD?a=1:Object.values(n.metricSavings||{}).some(c=>c)?a=0:a=.5),a=e._normalizeAuditScore(a,r,t.meta.id);let o=t.meta.title;t.meta.failureTitle&&a!==null&&a<Me.PASS_THRESHOLD&&(o=t.meta.failureTitle);let i="numericUnit"in n?n:void 0;return{id:t.meta.id,title:o,description:t.meta.description,score:a,scoreDisplayMode:r,numericValue:i?.numericValue,numericUnit:i?.numericUnit,displayValue:n.displayValue,explanation:n.explanation,errorMessage:n.errorMessage,errorStack:n.errorStack,warnings:n.warnings,scoringOptions:n.scoringOptions,metricSavings:n.metricSavings,details:n.details,guidanceLevel:t.meta.guidanceLevel}}static makeMetricComputationDataInput(t,n){let r=t.traces[e.DEFAULT_PASS],a=t.devtoolsLogs[e.DEFAULT_PASS],o=t.GatherContext;return{trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL}}}});var b$,Wm,y_=b(()=>{"use strict";d();V();b$=s(e=>Math.round(e*100)/100,"clampTo2Decimals"),Wm=class e{static{s(this,"ReportScoring")}static arithmeticMean(t){if(t=t.filter(r=>r.weight>0),t.some(r=>r.score===null))return null;let n=t.reduce((r,a)=>{let o=a.score,i=a.weight;return{weight:r.weight+i,sum:r.sum+o*i}},{weight:0,sum:0});return b$(n.sum/n.weight||0)}static scoreAllCategories(t,n){let r={};for(let[a,o]of Object.entries(t)){let i=o.auditRefs.map(l=>{let m={...l},p=n[m.id];return(p.scoreDisplayMode===g.SCORING_MODES.NOT_APPLICABLE||p.scoreDisplayMode===g.SCORING_MODES.INFORMATIVE||p.scoreDisplayMode===g.SCORING_MODES.MANUAL)&&(m.weight=0),m}),c=i.map(l=>({score:n[l.id].score,weight:l.weight})),u=e.arithmeticMean(c);r[a]={...o,auditRefs:i,id:a,score:u}}return r}}});function su(e,t){if(typeof t!="function"&&t!==null)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");C1(e,t);function n(){this.constructor=e}s(n,"__"),e.prototype=t===null?Object.create(t):(n.prototype=t.prototype,new n)}function b_(e,t){var n={};for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&t.indexOf(r)<0&&(n[r]=e[r]);if(e!=null&&typeof Object.getOwnPropertySymbols=="function")for(var a=0,r=Object.getOwnPropertySymbols(e);a<r.length;a++)t.indexOf(r[a])<0&&Object.prototype.propertyIsEnumerable.call(e,r[a])&&(n[r[a]]=e[r[a]]);return n}function $m(e,t,n){if(n||arguments.length===2)for(var r=0,a=t.length,o;r<a;r++)(o||!(r in t))&&(o||(o=Array.prototype.slice.call(t,0,r)),o[r]=t[r]);return e.concat(o||Array.prototype.slice.call(t))}var C1,rr,A1=b(()=>{d();C1=s(function(e,t){return C1=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(n,r){n.__proto__=r}||function(n,r){for(var a in r)Object.prototype.hasOwnProperty.call(r,a)&&(n[a]=r[a])},C1(e,t)},"extendStatics");s(su,"__extends");rr=s(function(){return rr=Object.assign||s(function(t){for(var n,r=1,a=arguments.length;r<a;r++){n=arguments[r];for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&(t[o]=n[o])}return t},"__assign"),rr.apply(this,arguments)},"__assign");s(b_,"__rest");s($m,"__spreadArray")});var zi,_1=b(()=>{d();zi=s(function(){return zi=Object.assign||s(function(t){for(var n,r=1,a=arguments.length;r<a;r++){n=arguments[r];for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&(t[o]=n[o])}return t},"__assign"),zi.apply(this,arguments)},"__assign")});var Ue,R1=b(()=>{d();(function(e){e[e.EXPECT_ARGUMENT_CLOSING_BRACE=1]="EXPECT_ARGUMENT_CLOSING_BRACE",e[e.EMPTY_ARGUMENT=2]="EMPTY_ARGUMENT",e[e.MALFORMED_ARGUMENT=3]="MALFORMED_ARGUMENT",e[e.EXPECT_ARGUMENT_TYPE=4]="EXPECT_ARGUMENT_TYPE",e[e.INVALID_ARGUMENT_TYPE=5]="INVALID_ARGUMENT_TYPE",e[e.EXPECT_ARGUMENT_STYLE=6]="EXPECT_ARGUMENT_STYLE",e[e.INVALID_NUMBER_SKELETON=7]="INVALID_NUMBER_SKELETON",e[e.INVALID_DATE_TIME_SKELETON=8]="INVALID_DATE_TIME_SKELETON",e[e.EXPECT_NUMBER_SKELETON=9]="EXPECT_NUMBER_SKELETON",e[e.EXPECT_DATE_TIME_SKELETON=10]="EXPECT_DATE_TIME_SKELETON",e[e.UNCLOSED_QUOTE_IN_ARGUMENT_STYLE=11]="UNCLOSED_QUOTE_IN_ARGUMENT_STYLE",e[e.EXPECT_SELECT_ARGUMENT_OPTIONS=12]="EXPECT_SELECT_ARGUMENT_OPTIONS",e[e.EXPECT_PLURAL_ARGUMENT_OFFSET_VALUE=13]="EXPECT_PLURAL_ARGUMENT_OFFSET_VALUE",e[e.INVALID_PLURAL_ARGUMENT_OFFSET_VALUE=14]="INVALID_PLURAL_ARGUMENT_OFFSET_VALUE",e[e.EXPECT_SELECT_ARGUMENT_SELECTOR=15]="EXPECT_SELECT_ARGUMENT_SELECTOR",e[e.EXPECT_PLURAL_ARGUMENT_SELECTOR=16]="EXPECT_PLURAL_ARGUMENT_SELECTOR",e[e.EXPECT_SELECT_ARGUMENT_SELECTOR_FRAGMENT=17]="EXPECT_SELECT_ARGUMENT_SELECTOR_FRAGMENT",e[e.EXPECT_PLURAL_ARGUMENT_SELECTOR_FRAGMENT=18]="EXPECT_PLURAL_ARGUMENT_SELECTOR_FRAGMENT",e[e.INVALID_PLURAL_ARGUMENT_SELECTOR=19]="INVALID_PLURAL_ARGUMENT_SELECTOR",e[e.DUPLICATE_PLURAL_ARGUMENT_SELECTOR=20]="DUPLICATE_PLURAL_ARGUMENT_SELECTOR",e[e.DUPLICATE_SELECT_ARGUMENT_SELECTOR=21]="DUPLICATE_SELECT_ARGUMENT_SELECTOR",e[e.MISSING_OTHER_CLAUSE=22]="MISSING_OTHER_CLAUSE",e[e.INVALID_TAG=23]="INVALID_TAG",e[e.INVALID_TAG_NAME=25]="INVALID_TAG_NAME",e[e.UNMATCHED_CLOSING_TAG=26]="UNMATCHED_CLOSING_TAG",e[e.UNCLOSED_TAG=27]="UNCLOSED_TAG"})(Ue||(Ue={}))});function F1(e){return e.type===vt.literal}function v_(e){return e.type===vt.argument}function Ym(e){return e.type===vt.number}function Km(e){return e.type===vt.date}function Xm(e){return e.type===vt.time}function Jm(e){return e.type===vt.select}function Zm(e){return e.type===vt.plural}function w_(e){return e.type===vt.pound}function Qm(e){return e.type===vt.tag}function ep(e){return!!(e&&typeof e=="object"&&e.type===Fo.number)}function cu(e){return!!(e&&typeof e=="object"&&e.type===Fo.dateTime)}var vt,Fo,tp=b(()=>{d();(function(e){e[e.literal=0]="literal",e[e.argument=1]="argument",e[e.number=2]="number",e[e.date=3]="date",e[e.time=4]="time",e[e.select=5]="select",e[e.plural=6]="plural",e[e.pound=7]="pound",e[e.tag=8]="tag"})(vt||(vt={}));(function(e){e[e.number=0]="number",e[e.dateTime=1]="dateTime"})(Fo||(Fo={}));s(F1,"isLiteralElement");s(v_,"isArgumentElement");s(Ym,"isNumberElement");s(Km,"isDateElement");s(Xm,"isTimeElement");s(Jm,"isSelectElement");s(Zm,"isPluralElement");s(w_,"isPoundElement");s(Qm,"isTagElement");s(ep,"isNumberSkeleton");s(cu,"isDateTimeSkeleton")});var I1,D_=b(()=>{d();I1=/[ \xA0\u1680\u2000-\u200A\u202F\u205F\u3000]/});function E_(e){var t={};return e.replace(v$,function(n){var r=n.length;switch(n[0]){case"G":t.era=r===4?"long":r===5?"narrow":"short";break;case"y":t.year=r===2?"2-digit":"numeric";break;case"Y":case"u":case"U":case"r":throw new RangeError("`Y/u/U/r` (year) patterns are not supported, use `y` instead");case"q":case"Q":throw new RangeError("`q/Q` (quarter) patterns are not supported");case"M":case"L":t.month=["numeric","2-digit","short","long","narrow"][r-1];break;case"w":case"W":throw new RangeError("`w/W` (week) patterns are not supported");case"d":t.day=["numeric","2-digit"][r-1];break;case"D":case"F":case"g":throw new RangeError("`D/F/g` (day) patterns are not supported, use `d` instead");case"E":t.weekday=r===4?"short":r===5?"narrow":"short";break;case"e":if(r<4)throw new RangeError("`e..eee` (weekday) patterns are not supported");t.weekday=["short","long","narrow","short"][r-4];break;case"c":if(r<4)throw new RangeError("`c..ccc` (weekday) patterns are not supported");t.weekday=["short","long","narrow","short"][r-4];break;case"a":t.hour12=!0;break;case"b":case"B":throw new RangeError("`b/B` (period) patterns are not supported, use `a` instead");case"h":t.hourCycle="h12",t.hour=["numeric","2-digit"][r-1];break;case"H":t.hourCycle="h23",t.hour=["numeric","2-digit"][r-1];break;case"K":t.hourCycle="h11",t.hour=["numeric","2-digit"][r-1];break;case"k":t.hourCycle="h24",t.hour=["numeric","2-digit"][r-1];break;case"j":case"J":case"C":throw new RangeError("`j/J/C` (hour) patterns are not supported, use `h/H/K/k` instead");case"m":t.minute=["numeric","2-digit"][r-1];break;case"s":t.second=["numeric","2-digit"][r-1];break;case"S":case"A":throw new RangeError("`S/A` (second) patterns are not supported, use `s` instead");case"z":t.timeZoneName=r<4?"short":"long";break;case"Z":case"O":case"v":case"V":case"X":case"x":throw new RangeError("`Z/O/v/V/X/x` (timeZone) patterns are not supported, use `z` instead")}return""}),t}var v$,x_=b(()=>{d();v$=/(?:[Eec]{1,6}|G{1,5}|[Qq]{1,5}|(?:[yYur]+|U{1,5})|[ML]{1,5}|d{1,2}|D{1,3}|F{1}|[abB]{1,5}|[hkHK]{1,2}|w{1,2}|W{1}|m{1,2}|s{1,2}|[zZOvVxX]{1,4})(?=([^']*'[^']*')*[^']*$)/g;s(E_,"parseDateTimeSkeleton")});var At,T_=b(()=>{d();At=s(function(){return At=Object.assign||s(function(t){for(var n,r=1,a=arguments.length;r<a;r++){n=arguments[r];for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&(t[o]=n[o])}return t},"__assign"),At.apply(this,arguments)},"__assign")});var S_,k_=b(()=>{d();S_=/[\t-\r \x85\u200E\u200F\u2028\u2029]/i});function R_(e){if(e.length===0)throw new Error("Number skeleton cannot be empty");for(var t=e.split(S_).filter(function(h){return h.length>0}),n=[],r=0,a=t;r<a.length;r++){var o=a[r],i=o.split("/");if(i.length===0)throw new Error("Invalid number skeleton");for(var c=i[0],u=i.slice(1),l=0,m=u;l<m.length;l++){var p=m[l];if(p.length===0)throw new Error("Invalid number skeleton")}n.push({stem:c,options:u})}return n}function w$(e){return e.replace(/^(.*?)-/,"")}function A_(e){var t={};return e[e.length-1]==="r"?t.roundingPriority="morePrecision":e[e.length-1]==="s"&&(t.roundingPriority="lessPrecision"),e.replace(F_,function(n,r,a){return typeof a!="string"?(t.minimumSignificantDigits=r.length,t.maximumSignificantDigits=r.length):a==="+"?t.minimumSignificantDigits=r.length:r[0]==="#"?t.maximumSignificantDigits=r.length:(t.minimumSignificantDigits=r.length,t.maximumSignificantDigits=r.length+(typeof a=="string"?a.length:0)),""}),t}function N_(e){switch(e){case"sign-auto":return{signDisplay:"auto"};case"sign-accounting":case"()":return{currencySign:"accounting"};case"sign-always":case"+!":return{signDisplay:"always"};case"sign-accounting-always":case"()!":return{signDisplay:"always",currencySign:"accounting"};case"sign-except-zero":case"+?":return{signDisplay:"exceptZero"};case"sign-accounting-except-zero":case"()?":return{signDisplay:"exceptZero",currencySign:"accounting"};case"sign-never":case"+_":return{signDisplay:"never"}}}function E$(e){var t;if(e[0]==="E"&&e[1]==="E"?(t={notation:"engineering"},e=e.slice(2)):e[0]==="E"&&(t={notation:"scientific"},e=e.slice(1)),t){var n=e.slice(0,2);if(n==="+!"?(t.signDisplay="always",e=e.slice(2)):n==="+?"&&(t.signDisplay="exceptZero",e=e.slice(2)),!I_.test(e))throw new Error("Malformed concise eng/scientific notation");t.minimumIntegerDigits=e.length}return t}function __(e){var t={},n=N_(e);return n||t}function M_(e){for(var t={},n=0,r=e;n<r.length;n++){var a=r[n];switch(a.stem){case"percent":case"%":t.style="percent";continue;case"%x100":t.style="percent",t.scale=100;continue;case"currency":t.style="currency",t.currency=a.options[0];continue;case"group-off":case",_":t.useGrouping=!1;continue;case"precision-integer":case".":t.maximumFractionDigits=0;continue;case"measure-unit":case"unit":t.style="unit",t.unit=w$(a.options[0]);continue;case"compact-short":case"K":t.notation="compact",t.compactDisplay="short";continue;case"compact-long":case"KK":t.notation="compact",t.compactDisplay="long";continue;case"scientific":t=At(At(At({},t),{notation:"scientific"}),a.options.reduce(function(u,l){return At(At({},u),__(l))},{}));continue;case"engineering":t=At(At(At({},t),{notation:"engineering"}),a.options.reduce(function(u,l){return At(At({},u),__(l))},{}));continue;case"notation-simple":t.notation="standard";continue;case"unit-width-narrow":t.currencyDisplay="narrowSymbol",t.unitDisplay="narrow";continue;case"unit-width-short":t.currencyDisplay="code",t.unitDisplay="short";continue;case"unit-width-full-name":t.currencyDisplay="name",t.unitDisplay="long";continue;case"unit-width-iso-code":t.currencyDisplay="symbol";continue;case"scale":t.scale=parseFloat(a.options[0]);continue;case"integer-width":if(a.options.length>1)throw new RangeError("integer-width stems only accept a single optional option");a.options[0].replace(D$,function(u,l,m,p,h,f){if(l)t.minimumIntegerDigits=m.length;else{if(p&&h)throw new Error("We currently do not support maximum integer digits");if(f)throw new Error("We currently do not support exact integer digits")}return""});continue}if(I_.test(a.stem)){t.minimumIntegerDigits=a.stem.length;continue}if(C_.test(a.stem)){if(a.options.length>1)throw new RangeError("Fraction-precision stems only accept a single optional option");a.stem.replace(C_,function(u,l,m,p,h,f){return m==="*"?t.minimumFractionDigits=l.length:p&&p[0]==="#"?t.maximumFractionDigits=p.length:h&&f?(t.minimumFractionDigits=h.length,t.maximumFractionDigits=h.length+f.length):(t.minimumFractionDigits=l.length,t.maximumFractionDigits=l.length),""});var o=a.options[0];o==="w"?t=At(At({},t),{trailingZeroDisplay:"stripIfInteger"}):o&&(t=At(At({},t),A_(o)));continue}if(F_.test(a.stem)){t=At(At({},t),A_(a.stem));continue}var i=N_(a.stem);i&&(t=At(At({},t),i));var c=E$(a.stem);c&&(t=At(At({},t),c))}return t}var C_,F_,D$,I_,L_=b(()=>{d();T_();k_();s(R_,"parseNumberSkeletonFromString");s(w$,"icuUnitToEcma");C_=/^\.(?:(0+)(\*)?|(#+)|(0+)(#+))$/g,F_=/^(@+)?(\+|#+)?[rs]?$/g,D$=/(\*)(0+)|(#+)(0+)|(0+)/g,I_=/^(0+)$/;s(A_,"parseSignificantPrecision");s(N_,"parseSign");s(E$,"parseConciseScientificAndEngineeringStem");s(__,"parseNotationOptions");s(M_,"parseNumberSkeleton")});var P_=b(()=>{d();x_();L_()});var uu,O_=b(()=>{d();uu={"001":["H","h"],AC:["H","h","hb","hB"],AD:["H","hB"],AE:["h","hB","hb","H"],AF:["H","hb","hB","h"],AG:["h","hb","H","hB"],AI:["H","h","hb","hB"],AL:["h","H","hB"],AM:["H","hB"],AO:["H","hB"],AR:["H","h","hB","hb"],AS:["h","H"],AT:["H","hB"],AU:["h","hb","H","hB"],AW:["H","hB"],AX:["H"],AZ:["H","hB","h"],BA:["H","hB","h"],BB:["h","hb","H","hB"],BD:["h","hB","H"],BE:["H","hB"],BF:["H","hB"],BG:["H","hB","h"],BH:["h","hB","hb","H"],BJ:["H","hB"],BL:["H","hB"],BM:["h","hb","H","hB"],BN:["hb","hB","h","H"],BO:["H","hB","h","hb"],BQ:["H"],BR:["H","hB"],BS:["h","hb","H","hB"],BT:["h","H"],BW:["H","h","hb","hB"],BZ:["H","h","hb","hB"],CA:["h","hb","H","hB"],CC:["H","h","hb","hB"],CD:["hB","H"],CF:["H","h","hB"],CG:["H","hB"],CH:["H","hB","h"],CI:["H","hB"],CK:["H","h","hb","hB"],CL:["H","h","hB","hb"],CM:["H","h","hB"],CN:["H","hB","hb","h"],CO:["h","H","hB","hb"],CP:["H"],CR:["H","h","hB","hb"],CU:["H","h","hB","hb"],CV:["H","hB"],CX:["H","h","hb","hB"],CY:["h","H","hb","hB"],CZ:["H"],DE:["H","hB"],DG:["H","h","hb","hB"],DJ:["h","H"],DK:["H"],DM:["h","hb","H","hB"],DO:["h","H","hB","hb"],DZ:["h","hB","hb","H"],EA:["H","h","hB","hb"],EC:["H","hB","h","hb"],EE:["H","hB"],EG:["h","hB","hb","H"],EH:["h","hB","hb","H"],ER:["h","H"],ES:["H","hB","h","hb"],ET:["hB","hb","h","H"],FI:["H"],FJ:["h","hb","H","hB"],FK:["H","h","hb","hB"],FM:["h","hb","H","hB"],FR:["H","hB"],GA:["H","hB"],GB:["H","h","hb","hB"],GD:["h","hb","H","hB"],GE:["H","hB","h"],GF:["H","hB"],GG:["H","h","hb","hB"],GH:["h","H"],GI:["H","h","hb","hB"],GM:["h","hb","H","hB"],GN:["H","hB"],GP:["H","hB"],GQ:["H","hB","h","hb"],GR:["h","H","hb","hB"],GT:["H","h","hB","hb"],GU:["h","hb","H","hB"],GW:["H","hB"],GY:["h","hb","H","hB"],HK:["h","hB","hb","H"],HN:["H","h","hB","hb"],HR:["H","hB"],IC:["H","h","hB","hb"],ID:["H"],IE:["H","h","hb","hB"],IL:["H","hB"],IM:["H","h","hb","hB"],IN:["h","H"],IO:["H","h","hb","hB"],IQ:["h","hB","hb","H"],IR:["hB","H"],IS:["H"],IT:["H","hB"],JE:["H","h","hb","hB"],JM:["h","hb","H","hB"],JO:["h","hB","hb","H"],JP:["H","h","K"],KE:["hB","hb","H","h"],KG:["H","h","hB","hb"],KH:["hB","h","H","hb"],KI:["h","hb","H","hB"],KM:["H","h","hB","hb"],KN:["h","hb","H","hB"],KP:["h","H","hB","hb"],KR:["h","H","hB","hb"],KW:["h","hB","hb","H"],KY:["h","hb","H","hB"],KZ:["H","hB"],LA:["H","hb","hB","h"],LB:["h","hB","hb","H"],LC:["h","hb","H","hB"],LI:["H","hB","h"],LK:["H","h","hB","hb"],LR:["h","hb","H","hB"],LS:["h","H"],LT:["H","h","hb","hB"],LU:["H","h","hB"],LV:["H","hB","hb","h"],LY:["h","hB","hb","H"],MA:["H","h","hB","hb"],MC:["H","hB"],MD:["H","hB"],ME:["H","hB","h"],MF:["H","hB"],MH:["h","hb","H","hB"],MK:["H","h","hb","hB"],ML:["H"],MM:["hB","hb","H","h"],MN:["H","h","hb","hB"],MO:["h","hB","hb","H"],MP:["h","hb","H","hB"],MQ:["H","hB"],MR:["h","hB","hb","H"],MS:["H","h","hb","hB"],MW:["h","hb","H","hB"],MX:["H","h","hB","hb"],MY:["hb","hB","h","H"],MZ:["H","hB"],NA:["h","H","hB","hb"],NC:["H","hB"],NE:["H"],NF:["H","h","hb","hB"],NG:["H","h","hb","hB"],NI:["H","h","hB","hb"],NL:["H","hB"],NP:["H","h","hB"],NR:["H","h","hb","hB"],NU:["H","h","hb","hB"],NZ:["h","hb","H","hB"],OM:["h","hB","hb","H"],PA:["h","H","hB","hb"],PE:["H","hB","h","hb"],PF:["H","h","hB"],PG:["h","H"],PH:["h","hB","hb","H"],PK:["h","hB","H"],PM:["H","hB"],PN:["H","h","hb","hB"],PR:["h","H","hB","hb"],PS:["h","hB","hb","H"],PT:["H","hB"],PW:["h","H"],PY:["H","h","hB","hb"],QA:["h","hB","hb","H"],RE:["H","hB"],RO:["H","hB"],RS:["H","hB","h"],RU:["H"],SA:["h","hB","hb","H"],SB:["h","hb","H","hB"],SC:["H","h","hB"],SD:["h","hB","hb","H"],SE:["H"],SG:["h","hb","H","hB"],SH:["H","h","hb","hB"],SI:["H","hB"],SJ:["H"],SK:["H"],SL:["h","hb","H","hB"],SM:["H","h","hB"],SN:["H","h","hB"],SO:["h","H"],SR:["H","hB"],SS:["h","hb","H","hB"],ST:["H","hB"],SV:["H","h","hB","hb"],SX:["H","h","hb","hB"],SY:["h","hB","hb","H"],SZ:["h","hb","H","hB"],TA:["H","h","hb","hB"],TC:["h","hb","H","hB"],TD:["h","H","hB"],TF:["H","h","hB"],TG:["H","hB"],TL:["H","hB","hb","h"],TN:["h","hB","hb","H"],TO:["h","H"],TR:["H","hB"],TT:["h","hb","H","hB"],TW:["hB","hb","h","H"],TZ:["hB","hb","H","h"],UA:["H","hB","h"],UG:["hB","hb","H","h"],UM:["h","hb","H","hB"],US:["h","hb","H","hB"],UY:["H","h","hB","hb"],UZ:["H","hB","h"],VA:["H","h","hB"],VC:["h","hb","H","hB"],VE:["h","H","hB","hb"],VG:["h","hb","H","hB"],VI:["h","hb","H","hB"],VU:["h","H"],WF:["H","hB"],WS:["h","H"],XK:["H","hB","h"],YE:["h","hB","hb","H"],YT:["H","hB"],ZA:["H","h","hb","hB"],ZM:["h","hb","H","hB"],"af-ZA":["H","h","hB","hb"],"ar-001":["h","hB","hb","H"],"ca-ES":["H","h","hB"],"en-001":["h","hb","H","hB"],"es-BO":["H","h","hB","hb"],"es-BR":["H","h","hB","hb"],"es-EC":["H","h","hB","hb"],"es-ES":["H","h","hB","hb"],"es-GQ":["H","h","hB","hb"],"es-PE":["H","h","hB","hb"],"fr-CA":["H","h","hB"],"gl-ES":["H","h","hB"],"gu-IN":["hB","hb","h","H"],"hi-IN":["hB","h","H"],"it-CH":["H","h","hB"],"it-IT":["H","h","hB"],"kn-IN":["hB","h","H"],"ml-IN":["hB","h","H"],"mr-IN":["hB","hb","h","H"],"pa-IN":["hB","hb","h","H"],"ta-IN":["hB","h","hb","H"],"te-IN":["hB","h","H"],"zu-ZA":["H","hB","hb","h"]}});function B_(e,t){for(var n="",r=0;r<e.length;r++){var a=e.charAt(r);if(a==="j"){for(var o=0;r+1<e.length&&e.charAt(r+1)===a;)o++,r++;var i=1+(o&1),c=o<2?1:3+(o>>1),u="a",l=x$(t);for((l=="H"||l=="k")&&(c=0);c-- >0;)n+=u;for(;i-- >0;)n=l+n}else a==="J"?n+="H":n+=a}return n}function x$(e){var t=e.hourCycle;if(t===void 0&&e.hourCycles&&e.hourCycles.length&&(t=e.hourCycles[0]),t)switch(t){case"h24":return"k";case"h23":return"H";case"h12":return"h";case"h11":return"K";default:throw new Error("Invalid hourCycle")}var n=e.language,r;n!=="root"&&(r=e.maximize().region);var a=uu[r||""]||uu[n||""]||uu["".concat(n,"-001")]||uu["001"];return a[0]}var U_=b(()=>{d();O_();s(B_,"getBestPattern");s(x$,"getDefaultHourSymbolFromLocale")});function Ve(e,t){return{start:e,end:t}}function G_(e,t){return new RegExp(e,t)}function B1(e){return e>=97&&e<=122||e>=65&&e<=90}function P$(e){return B1(e)||e===47}function O$(e){return e===45||e===46||e>=48&&e<=57||e===95||e>=97&&e<=122||e>=65&&e<=90||e==183||e>=192&&e<=214||e>=216&&e<=246||e>=248&&e<=893||e>=895&&e<=8191||e>=8204&&e<=8205||e>=8255&&e<=8256||e>=8304&&e<=8591||e>=11264&&e<=12271||e>=12289&&e<=55295||e>=63744&&e<=64975||e>=65008&&e<=65533||e>=65536&&e<=983039}function W_(e){return e>=9&&e<=13||e===32||e===133||e>=8206&&e<=8207||e===8232||e===8233}function B$(e){return e>=33&&e<=35||e===36||e>=37&&e<=39||e===40||e===41||e===42||e===43||e===44||e===45||e>=46&&e<=47||e>=58&&e<=59||e>=60&&e<=62||e>=63&&e<=64||e===91||e===92||e===93||e===94||e===96||e===123||e===124||e===125||e===126||e===161||e>=162&&e<=165||e===166||e===167||e===169||e===171||e===172||e===174||e===176||e===177||e===182||e===187||e===191||e===215||e===247||e>=8208&&e<=8213||e>=8214&&e<=8215||e===8216||e===8217||e===8218||e>=8219&&e<=8220||e===8221||e===8222||e===8223||e>=8224&&e<=8231||e>=8240&&e<=8248||e===8249||e===8250||e>=8251&&e<=8254||e>=8257&&e<=8259||e===8260||e===8261||e===8262||e>=8263&&e<=8273||e===8274||e===8275||e>=8277&&e<=8286||e>=8592&&e<=8596||e>=8597&&e<=8601||e>=8602&&e<=8603||e>=8604&&e<=8607||e===8608||e>=8609&&e<=8610||e===8611||e>=8612&&e<=8613||e===8614||e>=8615&&e<=8621||e===8622||e>=8623&&e<=8653||e>=8654&&e<=8655||e>=8656&&e<=8657||e===8658||e===8659||e===8660||e>=8661&&e<=8691||e>=8692&&e<=8959||e>=8960&&e<=8967||e===8968||e===8969||e===8970||e===8971||e>=8972&&e<=8991||e>=8992&&e<=8993||e>=8994&&e<=9e3||e===9001||e===9002||e>=9003&&e<=9083||e===9084||e>=9085&&e<=9114||e>=9115&&e<=9139||e>=9140&&e<=9179||e>=9180&&e<=9185||e>=9186&&e<=9254||e>=9255&&e<=9279||e>=9280&&e<=9290||e>=9291&&e<=9311||e>=9472&&e<=9654||e===9655||e>=9656&&e<=9664||e===9665||e>=9666&&e<=9719||e>=9720&&e<=9727||e>=9728&&e<=9838||e===9839||e>=9840&&e<=10087||e===10088||e===10089||e===10090||e===10091||e===10092||e===10093||e===10094||e===10095||e===10096||e===10097||e===10098||e===10099||e===10100||e===10101||e>=10132&&e<=10175||e>=10176&&e<=10180||e===10181||e===10182||e>=10183&&e<=10213||e===10214||e===10215||e===10216||e===10217||e===10218||e===10219||e===10220||e===10221||e===10222||e===10223||e>=10224&&e<=10239||e>=10240&&e<=10495||e>=10496&&e<=10626||e===10627||e===10628||e===10629||e===10630||e===10631||e===10632||e===10633||e===10634||e===10635||e===10636||e===10637||e===10638||e===10639||e===10640||e===10641||e===10642||e===10643||e===10644||e===10645||e===10646||e===10647||e===10648||e>=10649&&e<=10711||e===10712||e===10713||e===10714||e===10715||e>=10716&&e<=10747||e===10748||e===10749||e>=10750&&e<=11007||e>=11008&&e<=11055||e>=11056&&e<=11076||e>=11077&&e<=11078||e>=11079&&e<=11084||e>=11085&&e<=11123||e>=11124&&e<=11125||e>=11126&&e<=11157||e===11158||e>=11159&&e<=11263||e>=11776&&e<=11777||e===11778||e===11779||e===11780||e===11781||e>=11782&&e<=11784||e===11785||e===11786||e===11787||e===11788||e===11789||e>=11790&&e<=11798||e===11799||e>=11800&&e<=11801||e===11802||e===11803||e===11804||e===11805||e>=11806&&e<=11807||e===11808||e===11809||e===11810||e===11811||e===11812||e===11813||e===11814||e===11815||e===11816||e===11817||e>=11818&&e<=11822||e===11823||e>=11824&&e<=11833||e>=11834&&e<=11835||e>=11836&&e<=11839||e===11840||e===11841||e===11842||e>=11843&&e<=11855||e>=11856&&e<=11857||e===11858||e>=11859&&e<=11903||e>=12289&&e<=12291||e===12296||e===12297||e===12298||e===12299||e===12300||e===12301||e===12302||e===12303||e===12304||e===12305||e>=12306&&e<=12307||e===12308||e===12309||e===12310||e===12311||e===12312||e===12313||e===12314||e===12315||e===12316||e===12317||e>=12318&&e<=12319||e===12320||e===12336||e===64830||e===64831||e>=65093&&e<=65094}var N1,T$,S$,k$,C$,A$,_$,R$,F$,I$,N$,L1,j_,q_,P1,z_,H_,M$,L$,O1,M1,V_,$_=b(()=>{d();_1();R1();tp();D_();P_();U_();T$=new RegExp("^".concat(I1.source,"*")),S$=new RegExp("".concat(I1.source,"*$"));s(Ve,"createLocation");k$=!!String.prototype.startsWith&&"_a".startsWith("a",1),C$=!!String.fromCodePoint,A$=!!Object.fromEntries,_$=!!String.prototype.codePointAt,R$=!!String.prototype.trimStart,F$=!!String.prototype.trimEnd,I$=!!Number.isSafeInteger,N$=I$?Number.isSafeInteger:function(e){return typeof e=="number"&&isFinite(e)&&Math.floor(e)===e&&Math.abs(e)<=9007199254740991},L1=!0;try{j_=G_("([^\\p{White_Space}\\p{Pattern_Syntax}]*)","yu"),L1=((N1=j_.exec("a"))===null||N1===void 0?void 0:N1[0])==="a"}catch{L1=!1}q_=s(k$?function(t,n,r){return t.startsWith(n,r)}:function(t,n,r){return t.slice(r,r+n.length)===n},"startsWith"),P1=C$?String.fromCodePoint:s(function(){for(var t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];for(var r="",a=t.length,o=0,i;a>o;){if(i=t[o++],i>1114111)throw RangeError(i+" is not a valid code point");r+=i<65536?String.fromCharCode(i):String.fromCharCode(((i-=65536)>>10)+55296,i%1024+56320)}return r},"fromCodePoint"),z_=A$?Object.fromEntries:s(function(t){for(var n={},r=0,a=t;r<a.length;r++){var o=a[r],i=o[0],c=o[1];n[i]=c}return n},"fromEntries"),H_=s(_$?function(t,n){return t.codePointAt(n)}:function(t,n){var r=t.length;if(!(n<0||n>=r)){var a=t.charCodeAt(n),o;return a<55296||a>56319||n+1===r||(o=t.charCodeAt(n+1))<56320||o>57343?a:(a-55296<<10)+(o-56320)+65536}},"codePointAt"),M$=s(R$?function(t){return t.trimStart()}:function(t){return t.replace(T$,"")},"trimStart"),L$=s(F$?function(t){return t.trimEnd()}:function(t){return t.replace(S$,"")},"trimEnd");s(G_,"RE");L1?(M1=G_("([^\\p{White_Space}\\p{Pattern_Syntax}]*)","yu"),O1=s(function(t,n){var r;M1.lastIndex=n;var a=M1.exec(t);return(r=a[1])!==null&&r!==void 0?r:""},"matchIdentifierAtIndex")):O1=s(function(t,n){for(var r=[];;){var a=H_(t,n);if(a===void 0||W_(a)||B$(a))break;r.push(a),n+=a>=65536?2:1}return P1.apply(void 0,r)},"matchIdentifierAtIndex");V_=function(){function e(t,n){n===void 0&&(n={}),this.message=t,this.position={offset:0,line:1,column:1},this.ignoreTag=!!n.ignoreTag,this.locale=n.locale,this.requiresOtherClause=!!n.requiresOtherClause,this.shouldParseSkeletons=!!n.shouldParseSkeletons}return s(e,"Parser"),e.prototype.parse=function(){if(this.offset()!==0)throw Error("parser can only be used once");return this.parseMessage(0,"",!1)},e.prototype.parseMessage=function(t,n,r){for(var a=[];!this.isEOF();){var o=this.char();if(o===123){var i=this.parseArgument(t,r);if(i.err)return i;a.push(i.val)}else{if(o===125&&t>0)break;if(o===35&&(n==="plural"||n==="selectordinal")){var c=this.clonePosition();this.bump(),a.push({type:vt.pound,location:Ve(c,this.clonePosition())})}else if(o===60&&!this.ignoreTag&&this.peek()===47){if(r)break;return this.error(Ue.UNMATCHED_CLOSING_TAG,Ve(this.clonePosition(),this.clonePosition()))}else if(o===60&&!this.ignoreTag&&B1(this.peek()||0)){var i=this.parseTag(t,n);if(i.err)return i;a.push(i.val)}else{var i=this.parseLiteral(t,n);if(i.err)return i;a.push(i.val)}}}return{val:a,err:null}},e.prototype.parseTag=function(t,n){var r=this.clonePosition();this.bump();var a=this.parseTagName();if(this.bumpSpace(),this.bumpIf("/>"))return{val:{type:vt.literal,value:"<".concat(a,"/>"),location:Ve(r,this.clonePosition())},err:null};if(this.bumpIf(">")){var o=this.parseMessage(t+1,n,!0);if(o.err)return o;var i=o.val,c=this.clonePosition();if(this.bumpIf("</")){if(this.isEOF()||!B1(this.char()))return this.error(Ue.INVALID_TAG,Ve(c,this.clonePosition()));var u=this.clonePosition(),l=this.parseTagName();return a!==l?this.error(Ue.UNMATCHED_CLOSING_TAG,Ve(u,this.clonePosition())):(this.bumpSpace(),this.bumpIf(">")?{val:{type:vt.tag,value:a,children:i,location:Ve(r,this.clonePosition())},err:null}:this.error(Ue.INVALID_TAG,Ve(c,this.clonePosition())))}else return this.error(Ue.UNCLOSED_TAG,Ve(r,this.clonePosition()))}else return this.error(Ue.INVALID_TAG,Ve(r,this.clonePosition()))},e.prototype.parseTagName=function(){var t=this.offset();for(this.bump();!this.isEOF()&&O$(this.char());)this.bump();return this.message.slice(t,this.offset())},e.prototype.parseLiteral=function(t,n){for(var r=this.clonePosition(),a="";;){var o=this.tryParseQuote(n);if(o){a+=o;continue}var i=this.tryParseUnquoted(t,n);if(i){a+=i;continue}var c=this.tryParseLeftAngleBracket();if(c){a+=c;continue}break}var u=Ve(r,this.clonePosition());return{val:{type:vt.literal,value:a,location:u},err:null}},e.prototype.tryParseLeftAngleBracket=function(){return!this.isEOF()&&this.char()===60&&(this.ignoreTag||!P$(this.peek()||0))?(this.bump(),"<"):null},e.prototype.tryParseQuote=function(t){if(this.isEOF()||this.char()!==39)return null;switch(this.peek()){case 39:return this.bump(),this.bump(),"'";case 123:case 60:case 62:case 125:break;case 35:if(t==="plural"||t==="selectordinal")break;return null;default:return null}this.bump();var n=[this.char()];for(this.bump();!this.isEOF();){var r=this.char();if(r===39)if(this.peek()===39)n.push(39),this.bump();else{this.bump();break}else n.push(r);this.bump()}return P1.apply(void 0,n)},e.prototype.tryParseUnquoted=function(t,n){if(this.isEOF())return null;var r=this.char();return r===60||r===123||r===35&&(n==="plural"||n==="selectordinal")||r===125&&t>0?null:(this.bump(),P1(r))},e.prototype.parseArgument=function(t,n){var r=this.clonePosition();if(this.bump(),this.bumpSpace(),this.isEOF())return this.error(Ue.EXPECT_ARGUMENT_CLOSING_BRACE,Ve(r,this.clonePosition()));if(this.char()===125)return this.bump(),this.error(Ue.EMPTY_ARGUMENT,Ve(r,this.clonePosition()));var a=this.parseIdentifierIfPossible().value;if(!a)return this.error(Ue.MALFORMED_ARGUMENT,Ve(r,this.clonePosition()));if(this.bumpSpace(),this.isEOF())return this.error(Ue.EXPECT_ARGUMENT_CLOSING_BRACE,Ve(r,this.clonePosition()));switch(this.char()){case 125:return this.bump(),{val:{type:vt.argument,value:a,location:Ve(r,this.clonePosition())},err:null};case 44:return this.bump(),this.bumpSpace(),this.isEOF()?this.error(Ue.EXPECT_ARGUMENT_CLOSING_BRACE,Ve(r,this.clonePosition())):this.parseArgumentOptions(t,n,a,r);default:return this.error(Ue.MALFORMED_ARGUMENT,Ve(r,this.clonePosition()))}},e.prototype.parseIdentifierIfPossible=function(){var t=this.clonePosition(),n=this.offset(),r=O1(this.message,n),a=n+r.length;this.bumpTo(a);var o=this.clonePosition(),i=Ve(t,o);return{value:r,location:i}},e.prototype.parseArgumentOptions=function(t,n,r,a){var o,i=this.clonePosition(),c=this.parseIdentifierIfPossible().value,u=this.clonePosition();switch(c){case"":return this.error(Ue.EXPECT_ARGUMENT_TYPE,Ve(i,u));case"number":case"date":case"time":{this.bumpSpace();var l=null;if(this.bumpIf(",")){this.bumpSpace();var m=this.clonePosition(),p=this.parseSimpleArgStyleIfPossible();if(p.err)return p;var h=L$(p.val);if(h.length===0)return this.error(Ue.EXPECT_ARGUMENT_STYLE,Ve(this.clonePosition(),this.clonePosition()));var f=Ve(m,this.clonePosition());l={style:h,styleLocation:f}}var y=this.tryParseArgumentClose(a);if(y.err)return y;var v=Ve(a,this.clonePosition());if(l&&q_(l?.style,"::",0)){var D=M$(l.style.slice(2));if(c==="number"){var p=this.parseNumberSkeletonFromString(D,l.styleLocation);return p.err?p:{val:{type:vt.number,value:r,location:v,style:p.val},err:null}}else{if(D.length===0)return this.error(Ue.EXPECT_DATE_TIME_SKELETON,v);var E=D;this.locale&&(E=B_(D,this.locale));var h={type:Fo.dateTime,pattern:E,location:l.styleLocation,parsedOptions:this.shouldParseSkeletons?E_(E):{}},S=c==="date"?vt.date:vt.time;return{val:{type:S,value:r,location:v,style:h},err:null}}}return{val:{type:c==="number"?vt.number:c==="date"?vt.date:vt.time,value:r,location:v,style:(o=l?.style)!==null&&o!==void 0?o:null},err:null}}case"plural":case"selectordinal":case"select":{var k=this.clonePosition();if(this.bumpSpace(),!this.bumpIf(","))return this.error(Ue.EXPECT_SELECT_ARGUMENT_OPTIONS,Ve(k,zi({},k)));this.bumpSpace();var C=this.parseIdentifierIfPossible(),R=0;if(c!=="select"&&C.value==="offset"){if(!this.bumpIf(":"))return this.error(Ue.EXPECT_PLURAL_ARGUMENT_OFFSET_VALUE,Ve(this.clonePosition(),this.clonePosition()));this.bumpSpace();var p=this.tryParseDecimalInteger(Ue.EXPECT_PLURAL_ARGUMENT_OFFSET_VALUE,Ue.INVALID_PLURAL_ARGUMENT_OFFSET_VALUE);if(p.err)return p;this.bumpSpace(),C=this.parseIdentifierIfPossible(),R=p.val}var z=this.tryParsePluralOrSelectOptions(t,c,n,C);if(z.err)return z;var y=this.tryParseArgumentClose(a);if(y.err)return y;var B=Ve(a,this.clonePosition());return c==="select"?{val:{type:vt.select,value:r,options:z_(z.val),location:B},err:null}:{val:{type:vt.plural,value:r,options:z_(z.val),offset:R,pluralType:c==="plural"?"cardinal":"ordinal",location:B},err:null}}default:return this.error(Ue.INVALID_ARGUMENT_TYPE,Ve(i,u))}},e.prototype.tryParseArgumentClose=function(t){return this.isEOF()||this.char()!==125?this.error(Ue.EXPECT_ARGUMENT_CLOSING_BRACE,Ve(t,this.clonePosition())):(this.bump(),{val:!0,err:null})},e.prototype.parseSimpleArgStyleIfPossible=function(){for(var t=0,n=this.clonePosition();!this.isEOF();){var r=this.char();switch(r){case 39:{this.bump();var a=this.clonePosition();if(!this.bumpUntil("'"))return this.error(Ue.UNCLOSED_QUOTE_IN_ARGUMENT_STYLE,Ve(a,this.clonePosition()));this.bump();break}case 123:{t+=1,this.bump();break}case 125:{if(t>0)t-=1;else return{val:this.message.slice(n.offset,this.offset()),err:null};break}default:this.bump();break}}return{val:this.message.slice(n.offset,this.offset()),err:null}},e.prototype.parseNumberSkeletonFromString=function(t,n){var r=[];try{r=R_(t)}catch{return this.error(Ue.INVALID_NUMBER_SKELETON,n)}return{val:{type:Fo.number,tokens:r,location:n,parsedOptions:this.shouldParseSkeletons?M_(r):{}},err:null}},e.prototype.tryParsePluralOrSelectOptions=function(t,n,r,a){for(var o,i=!1,c=[],u=new Set,l=a.value,m=a.location;;){if(l.length===0){var p=this.clonePosition();if(n!=="select"&&this.bumpIf("=")){var h=this.tryParseDecimalInteger(Ue.EXPECT_PLURAL_ARGUMENT_SELECTOR,Ue.INVALID_PLURAL_ARGUMENT_SELECTOR);if(h.err)return h;m=Ve(p,this.clonePosition()),l=this.message.slice(p.offset,this.offset())}else break}if(u.has(l))return this.error(n==="select"?Ue.DUPLICATE_SELECT_ARGUMENT_SELECTOR:Ue.DUPLICATE_PLURAL_ARGUMENT_SELECTOR,m);l==="other"&&(i=!0),this.bumpSpace();var f=this.clonePosition();if(!this.bumpIf("{"))return this.error(n==="select"?Ue.EXPECT_SELECT_ARGUMENT_SELECTOR_FRAGMENT:Ue.EXPECT_PLURAL_ARGUMENT_SELECTOR_FRAGMENT,Ve(this.clonePosition(),this.clonePosition()));var y=this.parseMessage(t+1,n,r);if(y.err)return y;var v=this.tryParseArgumentClose(f);if(v.err)return v;c.push([l,{value:y.val,location:Ve(f,this.clonePosition())}]),u.add(l),this.bumpSpace(),o=this.parseIdentifierIfPossible(),l=o.value,m=o.location}return c.length===0?this.error(n==="select"?Ue.EXPECT_SELECT_ARGUMENT_SELECTOR:Ue.EXPECT_PLURAL_ARGUMENT_SELECTOR,Ve(this.clonePosition(),this.clonePosition())):this.requiresOtherClause&&!i?this.error(Ue.MISSING_OTHER_CLAUSE,Ve(this.clonePosition(),this.clonePosition())):{val:c,err:null}},e.prototype.tryParseDecimalInteger=function(t,n){var r=1,a=this.clonePosition();this.bumpIf("+")||this.bumpIf("-")&&(r=-1);for(var o=!1,i=0;!this.isEOF();){var c=this.char();if(c>=48&&c<=57)o=!0,i=i*10+(c-48),this.bump();else break}var u=Ve(a,this.clonePosition());return o?(i*=r,N$(i)?{val:i,err:null}:this.error(n,u)):this.error(t,u)},e.prototype.offset=function(){return this.position.offset},e.prototype.isEOF=function(){return this.offset()===this.message.length},e.prototype.clonePosition=function(){return{offset:this.position.offset,line:this.position.line,column:this.position.column}},e.prototype.char=function(){var t=this.position.offset;if(t>=this.message.length)throw Error("out of bound");var n=H_(this.message,t);if(n===void 0)throw Error("Offset ".concat(t," is at invalid UTF-16 code unit boundary"));return n},e.prototype.error=function(t,n){return{val:null,err:{kind:t,message:this.message,location:n}}},e.prototype.bump=function(){if(!this.isEOF()){var t=this.char();t===10?(this.position.line+=1,this.position.column=1,this.position.offset+=1):(this.position.column+=1,this.position.offset+=t<65536?1:2)}},e.prototype.bumpIf=function(t){if(q_(this.message,t,this.offset())){for(var n=0;n<t.length;n++)this.bump();return!0}return!1},e.prototype.bumpUntil=function(t){var n=this.offset(),r=this.message.indexOf(t,n);return r>=0?(this.bumpTo(r),!0):(this.bumpTo(this.message.length),!1)},e.prototype.bumpTo=function(t){if(this.offset()>t)throw Error("targetOffset ".concat(t," must be greater than or equal to the current offset ").concat(this.offset()));for(t=Math.min(t,this.message.length);;){var n=this.offset();if(n===t)break;if(n>t)throw Error("targetOffset ".concat(t," is at invalid UTF-16 code unit boundary"));if(this.bump(),this.isEOF())break}},e.prototype.bumpSpace=function(){for(;!this.isEOF()&&W_(this.char());)this.bump()},e.prototype.peek=function(){if(this.isEOF())return null;var t=this.char(),n=this.offset(),r=this.message.charCodeAt(n+(t>=65536?2:1));return r??null},e}();s(B1,"_isAlpha");s(P$,"_isAlphaOrSlash");s(O$,"_isPotentialElementNameChar");s(W_,"_isWhiteSpace");s(B$,"_isPatternSyntax")});function U1(e){e.forEach(function(t){if(delete t.location,Jm(t)||Zm(t))for(var n in t.options)delete t.options[n].location,U1(t.options[n].value);else Ym(t)&&ep(t.style)||(Km(t)||Xm(t))&&cu(t.style)?delete t.style.location:Qm(t)&&U1(t.children)})}function Y_(e,t){t===void 0&&(t={}),t=zi({shouldParseSkeletons:!0,requiresOtherClause:!0},t);var n=new V_(e,t).parse();if(n.err){var r=SyntaxError(Ue[n.err.kind]);throw r.location=n.err.location,r.originalMessage=n.err.message,r}return t?.captureLocation||U1(n.val),n.val}var j1=b(()=>{d();_1();R1();$_();tp();tp();s(U1,"pruneLocation");s(Y_,"parse")});function np(e,t){var n=t&&t.cache?t.cache:G$,r=t&&t.serializer?t.serializer:H$,a=t&&t.strategy?t.strategy:j$;return a(e,{cache:n,serializer:r})}function U$(e){return e==null||typeof e=="number"||typeof e=="boolean"}function K_(e,t,n,r){var a=U$(r)?r:n(r),o=t.get(a);return typeof o>"u"&&(o=e.call(this,r),t.set(a,o)),o}function X_(e,t,n){var r=Array.prototype.slice.call(arguments,3),a=n(r),o=t.get(a);return typeof o>"u"&&(o=e.apply(this,r),t.set(a,o)),o}function q1(e,t,n,r,a){return n.bind(t,e,r,a)}function j$(e,t){var n=e.length===1?K_:X_;return q1(e,this,n,t.cache.create(),t.serializer)}function q$(e,t){return q1(e,this,X_,t.cache.create(),t.serializer)}function z$(e,t){return q1(e,this,K_,t.cache.create(),t.serializer)}function z1(){this.cache=Object.create(null)}var H$,G$,rp,J_=b(()=>{d();s(np,"memoize");s(U$,"isPrimitive");s(K_,"monadic");s(X_,"variadic");s(q1,"assemble");s(j$,"strategyDefault");s(q$,"strategyVariadic");s(z$,"strategyMonadic");H$=s(function(){return JSON.stringify(arguments)},"serializerDefault");s(z1,"ObjectWithoutPrototypeCache");z1.prototype.get=function(e){return this.cache[e]};z1.prototype.set=function(e,t){this.cache[e]=t};G$={create:s(function(){return new z1},"create")},rp={variadic:q$,monadic:z$}});var Io,lu,H1,Z_,Q_,G1=b(()=>{d();A1();(function(e){e.MISSING_VALUE="MISSING_VALUE",e.INVALID_VALUE="INVALID_VALUE",e.MISSING_INTL_API="MISSING_INTL_API"})(Io||(Io={}));lu=function(e){su(t,e);function t(n,r,a){var o=e.call(this,n)||this;return o.code=r,o.originalMessage=a,o}return s(t,"FormatError"),t.prototype.toString=function(){return"[formatjs Error: ".concat(this.code,"] ").concat(this.message)},t}(Error),H1=function(e){su(t,e);function t(n,r,a,o){return e.call(this,'Invalid values for "'.concat(n,'": "').concat(r,'". Options are "').concat(Object.keys(a).join('", "'),'"'),Io.INVALID_VALUE,o)||this}return s(t,"InvalidValueError"),t}(lu),Z_=function(e){su(t,e);function t(n,r,a){return e.call(this,'Value for "'.concat(n,'" must be of type ').concat(r),Io.INVALID_VALUE,a)||this}return s(t,"InvalidValueTypeError"),t}(lu),Q_=function(e){su(t,e);function t(n,r){return e.call(this,'The intl string context variable "'.concat(n,'" was not provided to the string "').concat(r,'"'),Io.MISSING_VALUE,r)||this}return s(t,"MissingValueError"),t}(lu)});function V$(e){return e.length<2?e:e.reduce(function(t,n){var r=t[t.length-1];return!r||r.type!==an.literal||n.type!==an.literal?t.push(n):r.value+=n.value,t},[])}function W$(e){return typeof e=="function"}function du(e,t,n,r,a,o,i){if(e.length===1&&F1(e[0]))return[{type:an.literal,value:e[0].value}];for(var c=[],u=0,l=e;u<l.length;u++){var m=l[u];if(F1(m)){c.push({type:an.literal,value:m.value});continue}if(w_(m)){typeof o=="number"&&c.push({type:an.literal,value:n.getNumberFormat(t).format(o)});continue}var p=m.value;if(!(a&&p in a))throw new Q_(p,i);var h=a[p];if(v_(m)){(!h||typeof h=="string"||typeof h=="number")&&(h=typeof h=="string"||typeof h=="number"?String(h):""),c.push({type:typeof h=="string"?an.literal:an.object,value:h});continue}if(Km(m)){var f=typeof m.style=="string"?r.date[m.style]:cu(m.style)?m.style.parsedOptions:void 0;c.push({type:an.literal,value:n.getDateTimeFormat(t,f).format(h)});continue}if(Xm(m)){var f=typeof m.style=="string"?r.time[m.style]:cu(m.style)?m.style.parsedOptions:r.time.medium;c.push({type:an.literal,value:n.getDateTimeFormat(t,f).format(h)});continue}if(Ym(m)){var f=typeof m.style=="string"?r.number[m.style]:ep(m.style)?m.style.parsedOptions:void 0;f&&f.scale&&(h=h*(f.scale||1)),c.push({type:an.literal,value:n.getNumberFormat(t,f).format(h)});continue}if(Qm(m)){var y=m.children,v=m.value,D=a[v];if(!W$(D))throw new Z_(v,"function",i);var E=du(y,t,n,r,a,o),S=D(E.map(function(R){return R.value}));Array.isArray(S)||(S=[S]),c.push.apply(c,S.map(function(R){return{type:typeof R=="string"?an.literal:an.object,value:R}}))}if(Jm(m)){var k=m.options[h]||m.options.other;if(!k)throw new H1(m.value,h,Object.keys(m.options),i);c.push.apply(c,du(k.value,t,n,r,a));continue}if(Zm(m)){var k=m.options["=".concat(h)];if(!k){if(!Intl.PluralRules)throw new lu(`Intl.PluralRules is not available in this environment.
Try polyfilling it using "@formatjs/intl-pluralrules"
`,Io.MISSING_INTL_API,i);var C=n.getPluralRules(t,{type:m.pluralType}).select(h-(m.offset||0));k=m.options[C]||m.options.other}if(!k)throw new H1(m.value,h,Object.keys(m.options),i);c.push.apply(c,du(k.value,t,n,r,a,h-(m.offset||0)));continue}}return V$(c)}var an,V1=b(()=>{d();j1();G1();(function(e){e[e.literal=0]="literal",e[e.object=1]="object"})(an||(an={}));s(V$,"mergeLiteral");s(W$,"isFormatXMLElementFn");s(du,"formatToParts")});function $$(e,t){return t?rr(rr(rr({},e||{}),t||{}),Object.keys(e).reduce(function(n,r){return n[r]=rr(rr({},e[r]),t[r]||{}),n},{})):e}function Y$(e,t){return t?Object.keys(e).reduce(function(n,r){return n[r]=$$(e[r],t[r]),n},rr({},e)):e}function W1(e){return{create:function(){return{get:function(t){return e[t]},set:function(t,n){e[t]=n}}}}}function K$(e){return e===void 0&&(e={number:{},dateTime:{},pluralRules:{}}),{getNumberFormat:np(function(){for(var t,n=[],r=0;r<arguments.length;r++)n[r]=arguments[r];return new((t=Intl.NumberFormat).bind.apply(t,$m([void 0],n,!1)))},{cache:W1(e.number),strategy:rp.variadic}),getDateTimeFormat:np(function(){for(var t,n=[],r=0;r<arguments.length;r++)n[r]=arguments[r];return new((t=Intl.DateTimeFormat).bind.apply(t,$m([void 0],n,!1)))},{cache:W1(e.dateTime),strategy:rp.variadic}),getPluralRules:np(function(){for(var t,n=[],r=0;r<arguments.length;r++)n[r]=arguments[r];return new((t=Intl.PluralRules).bind.apply(t,$m([void 0],n,!1)))},{cache:W1(e.pluralRules),strategy:rp.variadic})}}var eR,$1=b(()=>{d();A1();j1();J_();V1();s($$,"mergeConfig");s(Y$,"mergeConfigs");s(W1,"createFastMemoizeCache");s(K$,"createDefaultFormatters");eR=function(){function e(t,n,r,a){n===void 0&&(n=e.defaultLocale);var o=this;if(this.formatterCache={number:{},dateTime:{},pluralRules:{}},this.format=function(l){var m=o.formatToParts(l);if(m.length===1)return m[0].value;var p=m.reduce(function(h,f){return!h.length||f.type!==an.literal||typeof h[h.length-1]!="string"?h.push(f.value):h[h.length-1]+=f.value,h},[]);return p.length<=1?p[0]||"":p},this.formatToParts=function(l){return du(o.ast,o.locales,o.formatters,o.formats,l,void 0,o.message)},this.resolvedOptions=function(){var l;return{locale:((l=o.resolvedLocale)===null||l===void 0?void 0:l.toString())||Intl.NumberFormat.supportedLocalesOf(o.locales)[0]}},this.getAst=function(){return o.ast},this.locales=n,this.resolvedLocale=e.resolveLocale(n),typeof t=="string"){if(this.message=t,!e.__parse)throw new TypeError("IntlMessageFormat.__parse must be set to process `message` of type `string`");var i=a||{},c=i.formatters,u=b_(i,["formatters"]);this.ast=e.__parse(t,rr(rr({},u),{locale:this.resolvedLocale}))}else this.ast=t;if(!Array.isArray(this.ast))throw new TypeError("A message must be provided as a String or AST.");this.formats=Y$(e.formats,r),this.formatters=a&&a.formatters||K$(this.formatterCache)}return s(e,"IntlMessageFormat"),Object.defineProperty(e,"defaultLocale",{get:function(){return e.memoizedDefaultLocale||(e.memoizedDefaultLocale=new Intl.NumberFormat().resolvedOptions().locale),e.memoizedDefaultLocale},enumerable:!1,configurable:!0}),e.memoizedDefaultLocale=null,e.resolveLocale=function(t){if(!(typeof Intl.Locale>"u")){var n=Intl.NumberFormat.supportedLocalesOf(t);return n.length>0?new Intl.Locale(n[0]):new Intl.Locale(typeof t=="string"?t:t[0])}},e.__parse=Y_,e.formats={number:{integer:{maximumFractionDigits:0},currency:{style:"currency"},percent:{style:"percent"}},date:{short:{month:"numeric",day:"numeric",year:"2-digit"},medium:{month:"short",day:"numeric",year:"numeric"},long:{month:"long",day:"numeric",year:"numeric"},full:{weekday:"long",month:"long",day:"numeric",year:"numeric"}},time:{short:{hour:"numeric",minute:"numeric"},medium:{hour:"numeric",minute:"numeric",second:"numeric"},long:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"},full:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"}}},e}()});var Y1,tR=b(()=>{d();$1();V1();$1();G1();Y1=eR});var No,Hi=b(()=>{d();No=s(()=>({resolve(){throw new Error("createRequire.resolve is not supported in bundled Lighthouse")}}),"createRequire")});var X$,J$,Mo,mu=b(()=>{d();X$=globalThis.URL,J$=s(e=>e,"fileURLToPath"),Mo={URL:X$,fileURLToPath:J$}});function nR(e){return Mo.fileURLToPath(e.url)}var Lo=b(()=>{"use strict";d();Hi();mu();Aa();s(nR,"getModulePath")});function K1(e){return typeof e=="object"&&e!==null&&!Array.isArray(e)}function rR(e){return typeof e=="object"&&e!==null}var aR=b(()=>{"use strict";d();s(K1,"isObjectOfUnknownValues");s(rR,"isObjectOrArrayOfUnknownValues")});var oR,iR=b(()=>{d();oR={}});function cR(e,t=new Map){for(let n of e)if(!(n.type===ap.literal||n.type===ap.pound)&&(t.set(n.value,n),n.type===ap.plural))for(let r of Object.values(n.options))cR(r.value,t);return t}function eY(e,t={},n){let r=cR(e.getAst()),a={};for(let[o,i]of r){if(!(o in t))throw new Error(`ICU Message "${n}" contains a value reference ("${o}") that wasn't provided`);let c=t[o];if(i.type!==ap.number){a[o]=c;continue}if(typeof c!="number")throw new Error(`ICU Message "${n}" contains a numeric reference ("${o}") but provided value was not a number`);i.style==="milliseconds"?a[o]=Math.round(c/10)*10:i.style==="seconds"&&o==="timeInMs"?a[o]=Math.round(c/100)/10:i.style==="bytes"?a[o]=c/1024:a[o]=c}for(let o of Object.keys(t))if(!(o in a)){if(o==="errorCode"){a.errorCode=t.errorCode;continue}throw new Error(`Provided value "${o}" does not match any placeholder in ICU message "${n}"`)}return a}function tY(e){return e.replace(/'/g,"''").replace(/\\{/g,"'{").replace(/\\}/g,"'}")}function J1(e,t,n){e=tY(e);let r=n==="en-XA"||n==="en-XL"?"de-DE":n,a=Y1.IntlMessageFormat||Y1,o=new a(e,r,Q$,{ignoreTag:!0}),i=eY(o,t,e),c=o.format(i);if(typeof c!="string")throw new Error("unexpected formatted result");return c}function nY(e,t){let r=lR(t)[e.i18nId];return r?J1(r.message,e.values,t):e.formattedDefault}function uR(e){let t=lR(e),n=Object.keys(t).filter(a=>a.startsWith("report/renderer/report-utils.js")),r={};for(let a of n){let{filename:o,key:i}=aY(a);if(!o.endsWith("report-utils.js"))throw new Error(`Unexpected message: ${a}`);r[i]=t[a].message}return r}function Vi(e){if(!K1(e))return!1;let{i18nId:t,values:n,formattedDefault:r}=e;if(typeof t!="string"||typeof r!="string")return!1;if(n!==void 0){if(!K1(n))return!1;for(let a of Object.values(n))if(typeof a!="string"&&typeof a!="number")return!1}return sR.test(t)}function Po(e,t){if(Vi(e))return nY(e,t);if(typeof e=="string")return e;throw new Error("Attempted to format invalid icuMessage type")}function rY(e){let t="";for(let n of e)if(/^[a-z]+$/i.test(n))t.length&&(t+="."),t+=n;else{if(/]|"|'|\s/.test(n))throw new Error(`Cannot handle "${n}" in i18n`);t+=`[${n}]`}return t}function Z1(e,t){function n(a,o,i=[]){if(rR(a))for(let[c,u]of Object.entries(a)){let l=i.concat([c]);if(Vi(u)){let m=Po(u,t),p=o[u.i18nId]||[],h=rY(l);p.push(u.values?{values:u.values,path:h}:h),a[c]=m,o[u.i18nId]=p}else n(u,o,l)}}s(n,"replaceInObject");let r={};return n(e,r),r}function lR(e){let t=X1[e];if(!t){if(e===Gi)return{};throw new Error(`Unsupported locale '${e}'`)}return t}function dR(){return Z$}function mR(){return[...new Set([...Object.keys(X1),Gi])].sort()}function pR(e,t){X1[e]=t}function aY(e){if(!sR.test(e))throw Error(`"${e}" does not appear to be a valid ICU message id`);let[t,n]=e.split(" | ");return{filename:t,key:n}}var ap,X1,Gi,Z$,sR,Q$,Qr=b(()=>{"use strict";d();Jr();tR();Lo();aR();iR();ap={literal:0,argument:1,number:2,date:3,time:4,select:5,plural:6,pound:7,tag:8},X1=oR,Gi="en-US",Z$=["ar-XB.json","ar.json","bg.json","ca.json","cs.json","da.json","de.json","el.json","en-GB.json","en-US.json","en-XA.json","en-XL.json","es-419.json","es.json","fi.json","fil.json","fr.json","he.json","hi.json","hr.json","hu.json","id.json","it.json","ja.json","ko.json","lt.json","lv.json","nl.json","no.json","pl.json","pt-PT.json","pt.json","ro.json","ru.json","sk.json","sl.json","sr-Latn.json","sr.json","sv.json","ta.json","te.json","th.json","tr.json","uk.json","vi.json","zh-HK.json","zh-TW.json","zh.json"].filter(e=>e.endsWith(".json")&&!e.endsWith(".ctc.json")).map(e=>e.replace(".json","")).sort(),sR=/ | [^\s]+$/,Q$={number:{bytes:{maximumFractionDigits:0},milliseconds:{maximumFractionDigits:0},seconds:{minimumFractionDigits:1,maximumFractionDigits:1},extendedPercent:{maximumFractionDigits:2,style:"percent"}}};s(cR,"collectAllCustomElementsFromICU");s(eY,"_preformatValues");s(tY,"escapeIcuMessage");s(J1,"formatMessage");s(nY,"_localizeIcuMessage");s(uR,"getRendererFormattedStrings");s(Vi,"isIcuMessage");s(Po,"getFormatted");s(rY,"_formatPathAsString");s(Z1,"replaceIcuMessages");s(lR,"_getLocaleMessages");s(dR,"getCanonicalLocales");s(mR,"getAvailableLocales");s(pR,"registerLocaleData");s(aY,"getIcuMessageIdParts")});var hR=I((Gge,fR)=>{d();var oY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 256 256"><path fill="%230379c4" fill-rule="evenodd" d="m171.887 116.28-53.696 89.36h-9.728l9.617-58.227-30.2.047a4.852 4.852 0 0 1-4.855-4.855c0-1.152 1.07-3.102 1.07-3.102l53.52-89.254 9.9.043-9.86 58.317 30.413-.043a4.852 4.852 0 0 1 4.855 4.855c0 1.088-.427 2.044-1.033 2.854l.004.004zM128 0C57.306 0 0 57.3 0 128s57.306 128 128 128 128-57.306 128-128S198.7 0 128 0z"/></svg>',iY={"modern-image-formats":"Consider displaying all [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) components in WebP formats while specifying an appropriate fallback for other browsers. [Learn more](https://amp.dev/documentation/components/amp-img/#example:-specifying-a-fallback-image).","offscreen-images":"Ensure that you are using [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) for images to automatically lazy-load. [Learn more](https://amp.dev/documentation/guides-and-tutorials/develop/media_iframes_3p/?format=websites#images).","render-blocking-resources":"Use tools such as [AMP Optimizer](https://github.com/ampproject/amp-toolbox/tree/master/packages/optimizer) to [server-side render AMP layouts](https://amp.dev/documentation/guides-and-tutorials/optimize-and-measure/server-side-rendering/).","unminified-css":"Refer to the [AMP documentation](https://amp.dev/documentation/guides-and-tutorials/develop/style_and_layout/style_pages/) to ensure all styles are supported.","efficient-animated-content":"For animated content, use [`amp-anim`](https://amp.dev/documentation/components/amp-anim/) to minimize CPU usage when the content is offscreen.","uses-responsive-images":"The [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) component supports the [`srcset`](https://web.dev/use-srcset-to-automatically-choose-the-right-image/) attribute to specify which image assets to use based on the screen size. [Learn more](https://amp.dev/documentation/guides-and-tutorials/develop/style_and_layout/art_direction/)."};fR.exports={id:"amp",title:"AMP",icon:oY,UIStrings:iY}});var yR=I((Wge,gR)=>{d();var sY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 250 250"><path fill="%23dd0031" d="M125 30 31.9 63.2l14.2 123.1L125 230l78.9-43.7 14.2-123.1z"/><path fill="%23c3002f" d="M125 30v22.2-.1V230l78.9-43.7 14.2-123.1L125 30z"/><path fill="%23fff" d="M125 52.1 66.8 182.6h21.7l11.7-29.2h49.4l11.7 29.2H183L125 52.1zm17 83.3h-34l17-40.9 17 40.9z"/></svg>',cY={"total-byte-weight":"Apply [route-level code splitting](https://web.dev/route-level-code-splitting-in-angular/) to minimize the size of your JavaScript bundles. Also, consider precaching assets with the [Angular service worker](https://web.dev/precaching-with-the-angular-service-worker/).","unminified-warning":"If you are using Angular CLI, ensure that builds are generated in production mode. [Learn more](https://angular.io/guide/deployment#enable-runtime-production-mode).","unused-javascript":"If you are using Angular CLI, include source maps in your production build to inspect your bundles. [Learn more](https://angular.io/guide/deployment#inspect-the-bundles).","uses-responsive-images":"Consider using the `BreakpointObserver` utility in the Component Dev Kit (CDK) to manage image breakpoints. [Learn more](https://material.angular.io/cdk/layout/overview).","uses-rel-preload":"Preload routes ahead of time to speed up navigation. [Learn more](https://web.dev/route-preloading-in-angular/).","dom-size":"Consider virtual scrolling with the Component Dev Kit (CDK) if very large lists are being rendered. [Learn more](https://web.dev/virtualize-lists-with-angular-cdk/)."};gR.exports={id:"angular",title:"Angular",icon:sY,UIStrings:cY}});var vR=I((Yge,bR)=>{d();var uY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 186.525 243.713"><path fill="%23009cde" d="M131.64 51.91C114.491 34.769 98.13 18.429 93.26 0c-4.87 18.429-21.234 34.769-38.38 51.91C29.16 77.613 0 106.743 0 150.434a93.263 93.263 0 1 0 186.525 0c0-43.688-29.158-72.821-54.885-98.524m-92 120.256c-5.719-.194-26.824-36.571 12.329-75.303l25.909 28.3a2.215 2.215 0 0 1-.173 3.306c-6.183 6.34-32.534 32.765-35.81 41.902-.675 1.886-1.663 1.815-2.256 1.795m53.624 47.943a32.075 32.075 0 0 1-32.076-32.075 33.423 33.423 0 0 1 7.995-21.187c5.784-7.072 24.077-26.963 24.077-26.963s18.012 20.183 24.033 26.896a31.368 31.368 0 0 1 8.046 21.254 32.076 32.076 0 0 1-32.075 32.075m61.392-52.015c-.691 1.512-2.26 4.036-4.376 4.113-3.773.138-4.176-1.796-6.965-5.923-6.122-9.06-59.551-64.9-69.545-75.699-8.79-9.498-1.238-16.195 2.266-19.704 4.395-4.403 17.224-17.225 17.224-17.225s38.255 36.296 54.19 61.096 10.444 46.26 7.206 53.342"/></svg>',lY={"unused-css-rules":"Consider removing unused CSS rules and only attach the needed Drupal libraries to the relevant page or component in a page. See the [Drupal documentation link](https://www.drupal.org/docs/8/creating-custom-modules/adding-stylesheets-css-and-javascript-js-to-a-drupal-8-module#library) for details. To identify attached libraries that are adding extraneous CSS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/module responsible from the URL of the stylesheet when CSS aggregation is disabled in your Drupal site. Look out for themes/modules that have many stylesheets in the list which have a lot of red in code coverage. A theme/module should only enqueue a stylesheet if it is actually used on the page.","unused-javascript":"Consider removing unused JavaScript assets and only attach the needed Drupal libraries to the relevant page or component in a page. See the [Drupal documentation link](https://www.drupal.org/docs/8/creating-custom-modules/adding-stylesheets-css-and-javascript-js-to-a-drupal-8-module#library) for details. To identify attached libraries that are adding extraneous JavaScript, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/module responsible from the URL of the script when JavaScript aggregation is disabled in your Drupal site. Look out for themes/modules that have many scripts in the list which have a lot of red in code coverage. A theme/module should only enqueue a script if it is actually used on the page.","modern-image-formats":"Consider configuring [WebP image formats with a Convert image style](https://www.drupal.org/docs/core-modules-and-themes/core-modules/image-module/working-with-images#styles) on your site.","offscreen-images":"Install [a Drupal module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=im_vid_3%3A67&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=%22lazy+load%22&solrsort=iss_project_release_usage+desc&op=Search) that can lazy load images. Such modules provide the ability to defer any offscreen images to improve performance.","total-byte-weight":"Consider using [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) to reduce the size of images loaded on your page. If you are using Views to show multiple content items on a page, consider implementing pagination to limit the number of content items shown on a given page.","render-blocking-resources":"Consider using a module to inline critical CSS and JavaScript, and use the defer attribute for non-critical CSS or JavaScript.","unminified-css":'Ensure you have enabled "Aggregate CSS files" in the "Administration » Configuration » Development" page.  Ensure your Drupal site is running at least Drupal 10.1 for improved asset aggregation support.',"unminified-javascript":'Ensure you have enabled "Aggregate JavaScript files" in the "Administration » Configuration » Development" page.  Ensure your Drupal site is running at least Drupal 10.1 for improved asset aggregation support.',"efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.","uses-long-cache-ttl":'Set the "Browser and proxy cache maximum age" in the "Administration » Configuration » Development" page. Read about [Drupal cache and optimizing for performance](https://www.drupal.org/docs/7/managing-site-performance-and-scalability/caching-to-improve-performance/caching-overview#s-drupal-performance-resources).',"uses-optimized-images":"Consider using [a module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=im_vid_3%3A123&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=optimize+images&solrsort=iss_project_release_usage+desc&op=Search) that automatically optimizes and reduces the size of images uploaded through the site while retaining quality. Also, ensure you are using the native [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) provided from Drupal (available in Drupal 8 and above) for all images rendered on the site.","uses-responsive-images":"Ensure that you are using the native [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) provided from Drupal (available in Drupal 8 and above). Use the Responsive Image Styles when rendering image fields through view modes, views, or images uploaded through the WYSIWYG editor.","server-response-time":"Themes, modules, and server specifications all contribute to server response time. Consider finding a more optimized theme, carefully selecting an optimization module, and/or upgrading your server. Your hosting servers should make use of PHP opcode caching, memory-caching to reduce database query times such as Redis or Memcached, as well as optimized application logic to prepare pages faster.","uses-rel-preconnect":"Preconnect or dns-prefetch resource hints can be added by installing and configuring [a module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=dns-prefetch&solrsort=iss_project_release_usage+desc&op=Search) that provides facilities for user agent resource hints.","font-display":"Specify `@font-display` when defining custom fonts in your theme."};bR.exports={id:"drupal",title:"Drupal",icon:uY,UIStrings:lY}});var DR=I((Xge,wR)=>{d();var dY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 82 82"><path fill="%235FA624" fill-rule="evenodd" d="M81.37 48.117C85.301 25.821 70.413 4.56 48.117.63 25.821-3.3 4.56 11.586.63 33.883-3.3 56.178 11.586 77.44 33.883 81.37 56.18 85.301 77.44 70.412 81.37 48.117Zm-8.935-14.17c2.77 12.357-1.942 25.721-12.96 33.436-14.57 10.203-34.656 6.662-44.859-7.909a32.434 32.434 0 0 1-2.869-4.98l28.7-20.097a6.53 6.53 0 1 0-3.744-5.347L9.564 48.054c-2.768-12.359 1.943-25.724 12.96-33.439 14.572-10.203 34.656-6.662 44.86 7.91a32.349 32.349 0 0 1 2.868 4.98L41.554 47.6a6.53 6.53 0 1 0 3.746 5.35l27.136-19.003Z"/></svg>',mY={"unused-css-rules":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Remove Unused CSS` to help with this issue. It will identify the CSS classes that are actually used on each page of your site, and remove any others to keep the file size small.","modern-image-formats":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Next-Gen Formats` to convert images to WebP.","offscreen-images":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Lazy Load Images` to defer loading off-screen images until they are needed.","render-blocking-resources":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Critical CSS` and `Script Delay` to defer non-critical JS/CSS.","unminified-css":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Minify CSS` to automatically minify your CSS to reduce network payload sizes.","unminified-javascript":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Minify Javascript` to automatically minify your JS to reduce network payload sizes.","uses-long-cache-ttl":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Efficient Static Cache Policy` to set recommended values in the caching header for static assests.","uses-optimized-images":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Next-Gen Formats` to convert images to WebP.","uses-responsive-images":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Resize Images` to resize images to a device appropriate size, reducing network payload sizes.","server-response-time":"Use [Ezoic Cloud Caching](https://pubdash.ezoic.com/speed/caching) to cache your content across our world wide network, improving time to first byte.","uses-rel-preconnect":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Pre-Connect Origins` to automatically add `preconnect` resource hints to establish early connections to important third-party origins.","uses-rel-preload":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Preload Fonts` and `Preload Background Images` to add `preload` links to prioritize fetching resources that are currently requested later in page load.","font-display":"Use [Ezoic Leap](https://pubdash.ezoic.com/speed) and enable `Optimize Fonts` to automatically leverage the `font-display` CSS feature to ensure text is user-visible while webfonts are loading."};wR.exports={id:"ezoic",title:"Ezoic",icon:dY,UIStrings:mY}});var xR=I((Zge,ER)=>{d();var pY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 28 28"><circle cx="14" cy="14" r="14" fill="%23639"/><path fill="%23fff" d="M6.2 21.8C4.1 19.7 3 16.9 3 14.2L13.9 25c-2.8-.1-5.6-1.1-7.7-3.2zm10.2 2.9L3.3 11.6C4.4 6.7 8.8 3 14 3c3.7 0 6.9 1.8 8.9 4.5l-1.5 1.3C19.7 6.5 17 5 14 5c-3.9 0-7.2 2.5-8.5 6L17 22.5c2.9-1 5.1-3.5 5.8-6.5H18v-2h7c0 5.2-3.7 9.6-8.6 10.7z"/></svg>',fY={"unused-css-rules":"Use the `PurgeCSS` `Gatsby` plugin to remove unused rules from stylesheets. [Learn more](https://purgecss.com/plugins/gatsby.html).","modern-image-formats":"Use the `gatsby-plugin-image` component instead of `<img>` to automatically optimize image format. [Learn more](https://www.gatsbyjs.com/docs/how-to/images-and-media/using-gatsby-plugin-image).","offscreen-images":"Use the `gatsby-plugin-image` component instead of `<img>` to automatically lazy-load images. [Learn more](https://www.gatsbyjs.com/docs/how-to/images-and-media/using-gatsby-plugin-image).","render-blocking-resources":"Use the `Gatsby Script API` to defer loading of non-critical third-party scripts. [Learn more](https://www.gatsbyjs.com/docs/reference/built-in-components/gatsby-script/).","unused-javascript":"Use `Webpack Bundle Analyzer` to detect unused JavaScript code. [Learn more](https://www.gatsbyjs.com/plugins/gatsby-plugin-webpack-bundle-analyser-v2/)","uses-long-cache-ttl":"Configure caching for immutable assets. [Learn more](https://www.gatsbyjs.com/docs/how-to/previews-deploys-hosting/caching/).","uses-optimized-images":"Use the `gatsby-plugin-image` component instead of `<img>` to adjust image quality. [Learn more](https://www.gatsbyjs.com/docs/how-to/images-and-media/using-gatsby-plugin-image).","uses-responsive-images":"Use the `gatsby-plugin-image` component to set appropriate `sizes`. [Learn more](https://www.gatsbyjs.com/docs/how-to/images-and-media/using-gatsby-plugin-image).","prioritize-lcp-image":"Use the `gatsby-plugin-image` component and set the `loading` prop to `eager`. [Learn more](https://www.gatsbyjs.com/docs/reference/built-in-components/gatsby-plugin-image#shared-props)."};ER.exports={id:"gatsby",title:"Gatsby",icon:pY,UIStrings:fY}});var SR=I((eye,TR)=>{"use strict";d();var hY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" preserveAspectRatio="xMidYMid" viewBox="0 0 256 258"><path fill="%23F9AE41" d="M255.7 35.6a33.7 33.7 0 0 0-67-4.8l-.4-.2c-27.6-12.4-50.8 9.6-50.8 9.6l-61.4 61.7 24.3 23.4 49.4-48.6c23-23 35.6-7.4 35.6-7.4 17.4 14.6.6 32 .6 32l24.9 24c20.3-22 21.5-41.1 15.3-56.3a33.7 33.7 0 0 0 29.5-33.4"/><path fill="%23EE4035" d="m226.5 190.5.2-.3c12.4-27.6-9.6-50.8-9.6-50.8L155.4 78l-23.3 24.3 48.5 49.4c23 23 7.5 35.6 7.5 35.6-14.7 17.4-32 .6-32 .6l-24 24.9c21.9 20.3 41 21.5 56.2 15.3a33.7 33.7 0 1 0 38.2-37.6"/><path fill="%234F91CD" d="m156 133-49.5 48.6c-23 23-35.6 7.4-35.6 7.4-17.4-14.6-.6-32-.6-32l-24.9-24c-20.3 22-21.4 41.1-15.3 56.3a33.7 33.7 0 1 0 37.6 38.2l.3.2c27.6 12.4 50.8-9.6 50.8-9.6l61.4-61.7-24.3-23.4"/><path fill="%237AC043" d="M75.7 106.6c-23-23-7.4-35.6-7.4-35.6 14.6-17.4 32-.6 32-.6l24-24.9c-22-20.3-41-21.5-56.3-15.3a33.7 33.7 0 1 0-38.2 37.6l-.2.3C17.2 95.7 39.2 119 39.2 119l61.7 61.4 23.4-24.3-48.6-49.4"/></svg>',gY={"unused-css-rules":"Consider reducing, or switching, the number of [Joomla extensions](https://extensions.joomla.org/) loading unused CSS in your page. To identify extensions that are adding extraneous CSS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the stylesheet. Look out for plugins that have many stylesheets in the list which have a lot of red in code coverage. A plugin should only enqueue a stylesheet if it is actually used on the page.","modern-image-formats":"Consider using a [plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=webp) or service that will automatically convert your uploaded images to the optimal formats.","offscreen-images":"Install a [lazy-load Joomla plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=lazy%20loading) that provides the ability to defer any offscreen images, or switch to a template that provides that functionality. Starting with Joomla 4.0, all new images will [automatically](https://github.com/joomla/joomla-cms/pull/30748) get the `loading` attribute from the core.","total-byte-weight":"Consider showing excerpts in your article categories (e.g. via the read more link), reducing the number of articles shown on a given page, breaking your long posts into multiple pages, or using a plugin to lazy-load comments.","render-blocking-resources":"There are a number of Joomla plugins that can help you [inline critical assets](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) or [defer less important resources](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance). Beware that optimizations provided by these plugins may break features of your templates or plugins, so you will need to test these thoroughly.","unminified-css":"A number of [Joomla extensions](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) can speed up your site by concatenating, minifying, and compressing your css styles. There are also templates that provide this functionality.","unminified-javascript":"A number of [Joomla extensions](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) can speed up your site by concatenating, minifying, and compressing your scripts. There are also templates that provide this functionality.","efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.","unused-javascript":"Consider reducing, or switching, the number of [Joomla extensions](https://extensions.joomla.org/) loading unused JavaScript in your page. To identify plugins that are adding extraneous JS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the extension responsible from the URL of the script. Look out for extensions that have many scripts in the list which have a lot of red in code coverage. An extension should only enqueue a script if it is actually used on the page.","uses-long-cache-ttl":"Read about [Browser Caching in Joomla](https://docs.joomla.org/Cache).","uses-optimized-images":"Consider using an [image optimization plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) that compresses your images while retaining quality.","uses-text-compression":"You can enable text compression by enabling Gzip Page Compression in Joomla (System > Global configuration > Server).","uses-responsive-images":"Consider using a [responsive images plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=responsive%20images) to use responsive images in your content.","server-response-time":"Templates, extensions, and server specifications all contribute to server response time. Consider finding a more optimized template, carefully selecting an optimization extension, and/or upgrading your server."};TR.exports={id:"joomla",title:"Joomla",icon:hY,UIStrings:gY}});var CR=I((nye,kR)=>{d();var yY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" fill="%23f26322" viewBox="0 0 1000 1000"><path d="M916.9 267.4v465.3l-111.3 67.4V331.4l-1.5-.9-303.9-189-304.6 189.2-1.2.8V799L83.1 732.6V267.4l.7-.4L500.3 10l416 257 .6.4zM560.7 468.5v383.3L500.3 890l-61-38.2V306.7l-136 84.3v476.6l197 122.5 196.4-122.5V391l-136-84.3v161.8z"/></svg>',bY={"modern-image-formats":"Consider searching the [Magento Marketplace](https://marketplace.magento.com/catalogsearch/result/?q=webp) for a variety of third-party extensions to leverage newer image formats.","offscreen-images":"Consider modifying your product and catalog templates to make use of the web platform's [lazy loading](https://web.dev/native-lazy-loading) feature.","disable-bundling":"Disable Magento's built-in [JavaScript bundling and minification](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/themes/js-bundling.html), and consider using [baler](https://github.com/magento/baler/) instead.","unminified-css":`Enable the "Minify CSS Files" option in your store's Developer settings. [Learn more](https://devdocs.magento.com/guides/v2.3/performance-best-practices/configuration.html?itm_source=devdocs&itm_medium=search_page&itm_campaign=federated_search&itm_term=minify%20css%20files).`,"unminified-javascript":"Use [Terser](https://www.npmjs.com/package/terser) to minify all JavaScript assets from static content deployment, and disable the built-in minification feature.","unused-javascript":"Disable Magento's built-in [JavaScript bundling](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/themes/js-bundling.html).","uses-optimized-images":"Consider searching the [Magento Marketplace](https://marketplace.magento.com/catalogsearch/result/?q=optimize%20image) for a variety of third party extensions to optimize images.","server-response-time":"Use Magento's [Varnish integration](https://devdocs.magento.com/guides/v2.3/config-guide/varnish/config-varnish.html).","uses-rel-preconnect":"Preconnect or dns-prefetch resource hints can be added by [modifying a themes's layout](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/layouts/xml-manage.html).","uses-rel-preload":"`<link rel=preload>` tags can be added by [modifying a themes's layout](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/layouts/xml-manage.html).","critical-request-chains":"If you are not bundling your JavaScript assets, consider using [baler](https://github.com/magento/baler).","font-display":"Specify `@font-display` when [defining custom fonts](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/css-topics/using-fonts.html)."};kR.exports={id:"magento",title:"Magento",icon:yY,UIStrings:bY}});var _R=I((aye,AR)=>{d();var vY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 207 124"><path fill="%23000" d="M48.942 32.632h38.96v3.082h-35.39v23.193H85.79v3.082H52.513v25.464h35.794v3.081H48.942V32.632Zm42.45 0h4.139l18.343 25.464 18.749-25.464L158.124.287l-41.896 60.485 21.59 29.762h-4.302l-19.642-27.086L94.15 90.534h-4.22l21.751-29.762-20.29-28.14Zm47.967 3.082v-3.082h44.397v3.082h-20.453v54.82h-3.571v-54.82h-20.373ZM.203 32.632h4.464l61.557 91.671-25.439-33.769L3.936 37.011l-.162 53.523H.203zm183.194 53.891c.738 0 1.276-.563 1.276-1.29 0-.727-.538-1.29-1.276-1.29-.73 0-1.277.563-1.277 1.29 0 .727.547 1.29 1.277 1.29Zm3.509-3.393c0 2.146 1.555 3.549 3.822 3.549 2.414 0 3.874-1.446 3.874-3.956v-8.837h-1.946v8.828c0 1.394-.704 2.138-1.946 2.138-1.112 0-1.867-.692-1.893-1.722h-1.911Zm10.24-.113c.14 2.233 2.007 3.662 4.787 3.662 2.97 0 4.83-1.498 4.83-3.887 0-1.878-1.06-2.917-3.632-3.514l-1.38-.338c-1.634-.38-2.294-.891-2.294-1.783 0-1.125 1.025-1.86 2.563-1.86 1.459 0 2.466.718 2.649 1.869h1.893c-.113-2.103-1.971-3.583-4.516-3.583-2.737 0-4.56 1.48-4.56 3.704 0 1.835 1.033 2.926 3.3 3.454l1.616.39c1.659.389 2.388.96 2.388 1.912 0 1.108-1.146 1.913-2.71 1.913-1.676 0-2.84-.753-3.005-1.939h-1.928Z"/></svg>',wY={"unused-css-rules":"Consider setting up `PurgeCSS` in `Next.js` configuration to remove unused rules from stylesheets. [Learn more](https://purgecss.com/guides/next.html).","modern-image-formats":"Use the `next/image` component instead of `<img>` to automatically optimize image format. [Learn more](https://nextjs.org/docs/basic-features/image-optimization).","offscreen-images":"Use the `next/image` component instead of `<img>` to automatically lazy-load images. [Learn more](https://nextjs.org/docs/basic-features/image-optimization).","render-blocking-resources":"Use the `next/script` component to defer loading of non-critical third-party scripts. [Learn more](https://nextjs.org/docs/basic-features/script).","unused-javascript":"Use `Webpack Bundle Analyzer` to detect unused JavaScript code. [Learn more](https://github.com/vercel/next.js/tree/canary/packages/next-bundle-analyzer)","uses-long-cache-ttl":"Configure caching for immutable assets and `Server-side Rendered` (SSR) pages. [Learn more](https://nextjs.org/docs/going-to-production#caching).","uses-optimized-images":"Use the `next/image` component instead of `<img>` to adjust image quality. [Learn more](https://nextjs.org/docs/basic-features/image-optimization).","uses-text-compression":"Enable compression on your Next.js server. [Learn more](https://nextjs.org/docs/api-reference/next.config.js/compression).","uses-responsive-images":"Use the `next/image` component to set the appropriate `sizes`. [Learn more](https://nextjs.org/docs/api-reference/next/image#sizes).","user-timings":"Consider using `Next.js Analytics` to measure your app's real-world performance. [Learn more](https://nextjs.org/docs/advanced-features/measuring-performance).","prioritize-lcp-image":'Use the `next/image` component and set "priority" to true to preload LCP image. [Learn more](https://nextjs.org/docs/api-reference/next/image#priority).',"unsized-images":"Use the `next/image` component to make sure images are always sized appropriately. [Learn more](https://nextjs.org/docs/api-reference/next/image#width)."};AR.exports={id:"next.js",title:"Next.js",icon:vY,UIStrings:wY}});var FR=I((iye,RR)=>{d();var DY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="142" height="54"><g fill="none" fill-rule="evenodd"><g fill="%231B004E"><path d="M19.486 53.24h-3.891L4.682 39.247v13.936H0V32.946h5.444l9.475 12.398V32.946h4.567zM21.346 32.94h4.647v3.57h-4.647v-3.57Zm0 5.477h4.647V53.18h-4.647V38.417ZM40.569 53.183H36c-3.408 0-4.991-1.625-4.991-4.697v-6.22h-3.777V38.42h3.777v-5.474h4.598v5.474h4.958v3.846h-4.958v4.588c0 1.597.477 2.252 2.197 2.252h2.764v4.077ZM46.688 53.183h-4.57V38.42h4.57v2.308c.31-.686 1.351-2.336 4.425-2.336h3.13v4.56h-4.004c-2.593 0-3.55.967-3.55 3.019v7.212ZM70.612 45.802c0 4.56-3.409 7.75-8.01 7.75s-8.006-3.19-8.006-7.75c0-4.56 3.408-7.755 8.006-7.755 4.598 0 8.01 3.195 8.01 7.755Zm-4.599 0c0-2.14-1.35-3.733-3.408-3.733-2.057 0-3.44 1.594-3.44 3.733 0 2.139 1.41 3.733 3.44 3.733 2.03 0 3.408-1.598 3.408-3.733ZM72.47 32.946h11.7c4.543 0 7.192 2.28 7.192 6.526 0 4.247-2.649 6.577-7.191 6.577h-6.935v7.125h-4.765V32.946Zm4.766 4.218v4.676h6.485c1.832 0 2.736-.883 2.736-2.34 0-1.565-.904-2.336-2.736-2.336h-6.485ZM102.662 51.016c-.254.485-1.636 2.48-4.71 2.48-3.665 0-6.627-2.906-6.627-7.694 0-4.789 2.962-7.667 6.656-7.667 2.962 0 4.372 1.851 4.626 2.336v-2.05h4.567v14.762h-4.512v-2.167Zm-3.327-8.932c-2.03 0-3.384 1.594-3.384 3.733 0 2.14 1.354 3.733 3.384 3.733s3.327-1.597 3.327-3.733-1.298-3.733-3.327-3.733ZM119.184 43.578a2.98 2.98 0 0 0-2.749-1.494c-1.918 0-3.13 1.594-3.13 3.733 0 2.14 1.24 3.758 3.158 3.758 1.807 0 2.625-1.168 2.764-1.51h4.4c-.143 2.052-2.116 5.5-7.275 5.5-4.286 0-7.641-3.078-7.641-7.75 0-4.673 3.328-7.755 7.585-7.755 5.159 0 7.105 3.392 7.33 5.53l-4.442-.012ZM129.712 46.6v6.577h-4.567V32.194h4.567v11.998l5.838-5.784h5.751l-6.994 6.811 7.362 7.952h-5.921z"/></g><g fill="%2325F5CE"><path d="M49.159 4.65c12.832 0 23.235 10.41 23.235 23.251h4.648C77.042 12.491 64.558 0 49.159 0c-15.4 0-27.883 12.492-27.883 27.901h4.647c0-12.841 10.403-23.25 23.236-23.25Z"/><path d="M44.852 25.793a3.632 3.632 0 0 1 2.6-5.097L63.8 16.951 50.426 27.09a3.626 3.626 0 0 1-5.574-1.296Z"/></g></g></svg>',EY={"unused-css-rules":"Enable [`Reduce Unused CSS`](https://support.nitropack.io/hc/en-us/articles/360020418457-Reduce-Unused-CSS) to remove CSS rules that are not applicable to this page.","modern-image-formats":"Use [`Image Optimization`](https://support.nitropack.io/hc/en-us/articles/16547237162513) to automatically convert your images to WebP.","offscreen-images":"Defer offscreen images by enabling [`Automatic Image Lazy Loading`](https://support.nitropack.io/hc/en-us/articles/12457493524369-NitroPack-Lazy-Loading-Feature-for-Images).","render-blocking-resources":"Enable [`Remove render-blocking resources`](https://support.nitropack.io/hc/en-us/articles/13820893500049-How-to-Deal-with-Render-Blocking-Resources-in-NitroPack) in NitroPack for faster initial load times.","unminified-css":"Enable [`Minify resources`](https://support.nitropack.io/hc/en-us/articles/360061059394-Minify-Resources) in your Caching settings to reduce the size of your CSS, HTML, and JavaScript files for faster load times.","unminified-javascript":"Enable [`Minify resources`](https://support.nitropack.io/hc/en-us/articles/360061059394-Minify-Resources) in your Caching settings to reduce the size of your JS, HTML, and CSS files for faster load times.","unused-javascript":"Configure [`Delayed Scripts`](https://support.nitropack.io/hc/en-us/articles/1500002600942-Delayed-Scripts) in NitroPack to delay loading of scripts until they are needed.","uses-long-cache-ttl":"Go to the [`Improve Server Response Time`](https://support.nitropack.io/hc/en-us/articles/1500002321821-Improve-Server-Response-Time) feature in the `Caching` menu and adjust your page cache expiration time to improve loading times and user experience.","uses-optimized-images":"Automatically compress, optimize, and convert your images into WebP by enabling the [`Image Optimization`](https://support.nitropack.io/hc/en-us/articles/14177271695121-How-to-serve-images-in-next-gen-formats-using-NitroPack) setting.","uses-text-compression":"Use [`Gzip compression`](https://support.nitropack.io/hc/en-us/articles/13229297479313-Enabling-GZIP-compression) in NitroPack to reduce the size of the files that are sent to the browser.","uses-responsive-images":"Enable [`Adaptive Image Sizing`](https://support.nitropack.io/hc/en-us/articles/10123833029905-How-to-Enable-Adaptive-Image-Sizing-For-Your-Site) to preemptively optimize your images and make them match the dimensions of the containers they’re displayed in across all devices.","server-response-time":"Improve server response time and optimize perceived performance by activating [`Instant Load`](https://support.nitropack.io/hc/en-us/articles/16547340617361).","dom-size":"Contact your account manager to enable [`HTML Lazy Load`](https://support.nitropack.io/hc/en-us/articles/17144942904337). Configuring it will prioritize and optimize your page rendering performance.","font-display":"Use the [`Override Font Rendering Behavior`](https://support.nitropack.io/hc/en-us/articles/16547358865041) option in NitroPack to set a desired value for the CSS font-display rule."};RR.exports={id:"nitropack",title:"NitroPack",icon:DY,UIStrings:EY}});var NR=I((cye,IR)=>{d();var xY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 512 512"><path fill="%2300DC82" d="M281.44 397.667h156.88c5.006 0 9.798-1.759 14.133-4.244.336-2.481 8.805-5.596 11.307-9.894 2.502-4.297 4.242-9.173 4.24-14.134-.002-4.962-1.734-9.836-4.24-14.131l-106-182.321c-2.502-4.297-5.559-7.413-9.893-9.894-4.335-2.48-10.542-4.24-15.547-4.24-5.005 0-9.799 1.76-14.133 4.24-4.335 2.481-7.392 5.597-9.894 9.894l-26.853 46.64-53.707-90.457c-2.504-4.296-5.557-8.823-9.893-11.303-4.336-2.481-9.127-2.827-14.133-2.827-5.006 0-9.798.346-14.134 2.827-4.335 2.48-8.802 7.007-11.306 11.303L46.827 355.268c-2.506 4.295-2.8259.169-2.827 14.131-.002 4.961.325 9.836 2.827 14.134 2.502 4.297 6.97 7.413 11.306 9.894 4.336 2.481 9.127 4.24 14.134 4.24H171.2c39.201 0 67.734-17.585 87.627-50.88L306.88 263.4l25.44-43.813 77.733 132.853H306.88l-25.44 45.227ZM169.787 352.44h-69.254l103.174-178.08L256 263.4l-34.639 60.384c-13.21 21.603-28.272 28.656-51.574 28.656Z"/></svg>',TY={"modern-image-formats":'Use the `nuxt/image` component and set `format="webp"`. [Learn more](https://image.nuxt.com/usage/nuxt-img#format).',"offscreen-images":'Use the `nuxt/image` component and set `loading="lazy"` for offscreen images. [Learn more](https://image.nuxt.com/usage/nuxt-img#loading).',"uses-optimized-images":"Use the `nuxt/image` component and set the appropriate `quality`. [Learn more](https://image.nuxt.com/usage/nuxt-img#quality).","uses-responsive-images":"Use the `nuxt/image` component and set the appropriate `sizes`. [Learn more](https://image.nuxt.com/usage/nuxt-img#sizes).","prioritize-lcp-image":"Use the `nuxt/image` component and specify `preload` for LCP image. [Learn more](https://image.nuxt.com/usage/nuxt-img#preload).","unsized-images":"Use the `nuxt/image` component and specify explicit `width` and `height`. [Learn more](https://image.nuxt.com/usage/nuxt-img#width-height)."};IR.exports={id:"nuxt",title:"Nuxt",icon:xY,UIStrings:TY}});var LR=I((lye,MR)=>{d();var SY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 310 310"><path fill="none" d="M-1-1h802v602H-1z"/><path fill="%23de6c26" d="M135 6.9c-14.2 4.4-34.9 21.8-49.9 42C55.8 88.5 39.6 135.8 41.4 177c.8 20.2 4.9 35.5 14.4 54.5 13.6 27.4 40.8 55.1 65.5 66.9 14.1 6.7 13.4 6.9 14.1-2.8.3-4.4 1-32.4 1.6-62.1 2.7-137.3 4.4-176 8.2-191.3.6-2.3 1.4-4.2 1.9-4.2 1.2 0 3.6 9.1 4.9 18.3.5 4.3 1 17.7 1 29.8 0 12 .3 21.9.7 21.9.3 0 5.7-5 11.9-11 6.9-6.8 12-11 13.3-11 1.8 0 1.9.3 1 2.7-1.2 3.1-7.9 13.2-19.1 28.5L153 128l.1 31.2c.1 17.2.4 37.4.8 44.9l.6 13.7 11-12.6c14-16 35.1-37.1 39.5-39.6l3.3-1.9-.6 3.2c-2 9.8-9.5 20.7-37.4 54.3L154 240.8v31.1c0 18.3.4 31.1.9 31.1 2.8 0 19.3-6.4 26.8-10.5 13.8-7.3 23.8-15 38.3-29.5 15.7-15.7 24.4-27.4 33.4-45.2 20.5-40 21-80.3 1.6-119-17.8-35.6-54.6-72.1-87.8-86.9-11.7-5.3-24.6-7.3-32.2-5z"/></svg>',kY={"unused-css-rules":"Consider reviewing the [plugins](https://octobercms.com/plugins) loading unused CSS on the website. To identify plugins that add unnecessary CSS, run [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. Identify the theme/plugin responsible from the stylesheet URL. Look for plugins with many stylesheets with lots of red in code coverage. A plugin should only add a stylesheet if it is actually used on the web page.","modern-image-formats":"Consider using a [plugin](https://octobercms.com/plugins?search=image) or service that will automatically convert the uploaded images to the optimal formats. [WebP lossless images](https://developers.google.com/speed/webp) are 26% smaller in size compared to PNGs and 25-34% smaller than comparable JPEG images at the equivalent SSIM quality index. Another next-gen image format to consider is [AVIF](https://jakearchibald.com/2020/avif-has-landed/).","offscreen-images":"Consider installing an [image lazy loading plugin](https://octobercms.com/plugins?search=lazy) that provides the ability to defer any offscreen images, or switch to a theme that provides that functionality. Also consider using [the AMP plugin](https://octobercms.com/plugins?search=Accelerated+Mobile+Pages).","total-byte-weight":"Consider showing excerpts in the post lists (e.g. using a `show more` button), reducing the number of posts shown on a given web page, breaking long posts into multiple web pages, or using a plugin to lazy-load comments.","render-blocking-resources":"There are many plugins that help [inline critical assets](https://octobercms.com/plugins?search=css). These plugins may break other plugins, so you should test thoroughly.","unminified-css":"There are many [plugins](https://octobercms.com/plugins?search=css) that can speed up a website by concatenating, minifying and compressing the styles. Using a build process to do this minification up-front can speed up development.","unminified-javascript":"There are many [plugins](https://octobercms.com/plugins?search=javascript) that can speed up a website by concatenating, minifying and compressing the scripts. Using a build process to do this minification up-front can speed up development.","efficient-animated-content":"[Replace animated GIFs with video](https://web.dev/replace-gifs-with-videos/) for faster web page loads and consider using modern file formats such as [WebM](https://web.dev/replace-gifs-with-videos/#create-webm-videos) or [AV1](https://developers.google.com/web/updates/2018/09/chrome-70-media-updates#av1-decoder) to improve compression efficiency by greater than 30% over the current state-of-the-art video codec, VP9.","unused-javascript":"Consider reviewing the [plugins](https://octobercms.com/plugins?search=javascript) that load unused JavaScript in the web page. To identify plugins that add unnecessary JavaScript, run [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. Identify the theme/plugin responsible from the URL of the script. Look for plugins with many scripts with lots of red in code coverage. A plugin should only add a script if it is actually used on the web page.","uses-long-cache-ttl":"Read about [preventing unnecessary network requests with the HTTP Cache](https://web.dev/http-cache/#caching-checklist). There are many [plugins](https://octobercms.com/plugins?search=Caching) that can be used to speed up caching.","uses-optimized-images":"Consider using an [image optimization plugin](https://octobercms.com/plugins?search=image) to compresses images while retaining the quality.","uses-text-compression":"Enable text compression in the web server configuration.","uses-responsive-images":"Upload images directly in the media manager to ensure the required image sizes are available. Consider using the [resize filter](https://octobercms.com/docs/markup/filter-resize) or an [image resizing plugin](https://octobercms.com/plugins?search=image) to ensure the optimal image sizes are used.","server-response-time":"Themes, plugins and server specifications all contribute to the server response time. Consider finding a more optimized theme, carefully selecting an optimization plugin and/or upgrade the server. October CMS also allows developers to use [`Queues`](https://octobercms.com/docs/services/queues) to defer the processing of a time consuming task, such as sending an e-mail. This drastically speeds up web requests."};MR.exports={id:"octobercms",title:"October CMS",icon:SY,UIStrings:kY}});var OR=I((mye,PR)=>{d();var CY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 841.9 595.3"><g fill="%2361DAFB"><path d="M666.3 296.5c0-32.5-40.7-63.3-103.1-82.4 14.4-63.6 8-114.2-20.2-130.4-6.5-3.8-14.1-5.6-22.4-5.6v22.3c4.6 0 8.3.9 11.4 2.6 13.6 7.8 19.5 37.5 14.9 75.7-1.1 9.4-2.9 19.3-5.1 29.4-19.6-4.8-41-8.5-63.5-10.9-13.5-18.5-27.5-35.3-41.6-50 32.6-30.3 63.2-46.9 84-46.9V78c-27.5 0-63.5 19.6-99.9 53.6-36.4-33.8-72.4-53.2-99.9-53.2v22.3c20.7 0 51.4 16.5 84 46.6-14 14.7-28 31.4-41.3 49.9-22.6 2.4-44 6.1-63.6 11-2.3-10-4-19.7-5.2-29-4.7-38.2 1.1-67.9 14.6-75.8 3-1.8 6.9-2.6 11.5-2.6V78.5c-8.4 0-16 1.8-22.6 5.6-28.1 16.2-34.4 66.7-19.9 130.1-62.2 19.2-102.7 49.9-102.7 82.3 0 32.5 40.7 63.3 103.1 82.4-14.4 63.6-8 114.2 20.2 130.4 6.5 3.8 14.1 5.6 22.5 5.6 27.5 0 63.5-19.6 99.9-53.6 36.4 33.8 72.4 53.2 99.9 53.2 8.4 0 16-1.8 22.6-5.6 28.1-16.2 34.4-66.7 19.9-130.1 62-19.1 102.5-49.9 102.5-82.3zm-130.2-66.7c-3.7 12.9-8.3 26.2-13.5 39.5-4.1-8-8.4-16-13.1-24-4.6-8-9.5-15.8-14.4-23.4 14.2 2.1 27.9 4.7 41 7.9zm-45.8 106.5c-7.8 13.5-15.8 26.3-24.1 38.2-14.9 1.3-30 2-45.2 2-15.1 0-30.2-.7-45-1.9-8.3-11.9-16.4-24.6-24.2-38-7.6-13.1-14.5-26.4-20.8-39.8 6.2-13.4 13.2-26.8 20.7-39.9 7.8-13.5 15.8-26.3 24.1-38.2 14.9-1.3 30-2 45.2-2 15.1 0 30.2.7 45 1.9 8.3 11.9 16.4 24.6 24.2 38 7.6 13.1 14.5 26.4 20.8 39.8-6.3 13.4-13.2 26.8-20.7 39.9zm32.3-13c5.4 13.4 10 26.8 13.8 39.8-13.1 3.2-26.9 5.9-41.2 8 4.9-7.7 9.8-15.6 14.4-23.7 4.6-8 8.9-16.1 13-24.1zM421.2 430c-9.3-9.6-18.6-20.3-27.8-32 9 .4 18.2.7 27.5.7 9.4 0 18.7-.2 27.8-.7-9 11.7-18.3 22.4-27.5 32zm-74.4-58.9c-14.2-2.1-27.9-4.7-41-7.9 3.7-12.9 8.3-26.2 13.5-39.5 4.1 8 8.4 16 13.1 24 4.7 8 9.5 15.8 14.4 23.4zM420.7 163c9.3 9.6 18.6 20.3 27.8 32-9-.4-18.2-.7-27.5-.7-9.4 0-18.7.2-27.8.7 9-11.7 18.3-22.4 27.5-32zm-74 58.9c-4.9 7.7-9.8 15.6-14.4 23.7-4.6 8-8.9 16-13 24-5.4-13.4-10-26.8-13.8-39.8 13.1-3.1 26.9-5.8 41.2-7.9zm-90.5 125.2c-35.4-15.1-58.3-34.9-58.3-50.6 0-15.7 22.9-35.6 58.3-50.6 8.6-3.7 18-7 27.7-10.1 5.7 19.6 13.2 40 22.5 60.9-9.2 20.8-16.6 41.1-22.2 60.6-9.9-3.1-19.3-6.5-28-10.2zM310 490c-13.6-7.8-19.5-37.5-14.9-75.7 1.1-9.4 2.9-19.3 5.1-29.4 19.6 4.8 41 8.5 63.5 10.9 13.5 18.5 27.5 35.3 41.6 50-32.6 30.3-63.2 46.9-84 46.9-4.5-.1-8.3-1-11.3-2.7zm237.2-76.2c4.7 38.2-1.1 67.9-14.6 75.8-3 1.8-6.9 2.6-11.5 2.6-20.7 0-51.4-16.5-84-46.6 14-14.7 28-31.4 41.3-49.9 22.6-2.4 44-6.1 63.6-11 2.3 10.1 4.1 19.8 5.2 29.1zm38.5-66.7c-8.6 3.7-18 7-27.7 10.1-5.7-19.6-13.2-40-22.5-60.9 9.2-20.8 16.6-41.1 22.2-60.6 9.9 3.1 19.3 6.5 28.1 10.2 35.4 15.1 58.3 34.9 58.3 50.6-.1 15.7-23 35.6-58.4 50.6zM320.8 78.4z"/><circle cx="420.9" cy="296.5" r="45.7"/><path d="M520.5 78.1z"/></g></svg>',AY={"unminified-css":"If your build system minifies CSS files automatically, ensure that you are deploying the production build of your application. You can check this with the React Developer Tools extension. [Learn more](https://reactjs.org/docs/optimizing-performance.html#use-the-production-build).","unminified-javascript":"If your build system minifies JS files automatically, ensure that you are deploying the production build of your application. You can check this with the React Developer Tools extension. [Learn more](https://reactjs.org/docs/optimizing-performance.html#use-the-production-build).","unused-javascript":"If you are not server-side rendering, [split your JavaScript bundles](https://web.dev/code-splitting-suspense/) with `React.lazy()`. Otherwise, code-split using a third-party library such as [loadable-components](https://www.smooth-code.com/open-source/loadable-components/docs/getting-started/).","server-response-time":"If you are server-side rendering any React components, consider using `renderToPipeableStream()` or `renderToStaticNodeStream()` to allow the client to receive and hydrate different parts of the markup instead of all at once. [Learn more](https://reactjs.org/docs/react-dom-server.html#renderToPipeableStream).",redirects:"If you are using React Router, minimize usage of the `<Redirect>` component for [route navigations](https://reacttraining.com/react-router/web/api/Redirect).","user-timings":"Use the React DevTools Profiler, which makes use of the Profiler API, to measure the rendering performance of your components. [Learn more.](https://reactjs.org/blog/2018/09/10/introducing-the-react-profiler.html)","dom-size":'Consider using a "windowing" library like `react-window` to minimize the number of DOM nodes created if you are rendering many repeated elements on the page. [Learn more](https://web.dev/virtualize-long-lists-react-window/). Also, minimize unnecessary re-renders using [`shouldComponentUpdate`](https://reactjs.org/docs/optimizing-performance.html#shouldcomponentupdate-in-action), [`PureComponent`](https://reactjs.org/docs/react-api.html#reactpurecomponent), or [`React.memo`](https://reactjs.org/docs/react-api.html#reactmemo) and [skip effects](https://reactjs.org/docs/hooks-effect.html#tip-optimizing-performance-by-skipping-effects) only until certain dependencies have changed if you are using the `Effect` hook to improve runtime performance.'};PR.exports={id:"react",title:"React",icon:CY,UIStrings:AY}});var UR=I((fye,BR)=>{d();var _Y='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 71 28"><path fill-rule="evenodd" d="M0 .032s2.796-.356 4.66 1.31C5.81 2.37 6.145 4.008 6.145 4.008L9.952 18.96l3.165-12.239c.309-1.301.864-2.909 1.743-3.997 1.121-1.385 3.398-1.472 3.641-1.472.242 0 2.519.087 3.639 1.472.88 1.088 1.435 2.696 1.744 3.997l3.165 12.239 3.806-14.953s.336-1.638 1.486-2.666C34.205-.324 37 .032 37 .032l-7.289 27.945s-2.404.176-3.607-.446c-1.58-.816-2.332-1.447-3.289-5.249l-.099-.395c-.349-1.399-.883-3.59-1.424-5.813l-.162-.667-.162-.664c-.779-3.198-1.497-6.143-1.612-6.517-.108-.351-.236-1.187-.855-1.187-.607 0-.746.837-.857 1.187-.13.412-.99 3.955-1.856 7.514l-.162.667c-.512 2.107-1.01 4.151-1.341 5.48l-.1.395c-.956 3.802-1.708 4.433-3.288 5.249-1.204.622-3.608.446-3.608.446zM43.998 5v.995L44 5.994v16.628c-.014 3.413-.373 4.17-1.933 4.956-1.213.61-3.067.379-3.067.379V9.332c0-.935.315-1.548 1.477-2.098.693-.329 1.34-.58 2.012-.953C43.54 5.703 43.998 5 43.998 5zM46 .125s3.877-.673 5.797 1.107c1.228 1.14 2.602 3.19 2.602 3.19l3.38 4.965c.164.258.378.54.72.54.343 0 .558-.282.722-.54l3.38-4.965s1.374-2.05 2.602-3.19C67.123-.548 71 .125 71 .125l-9.186 13.923 9.161 13.881-.032.004c-.38.045-4.036.423-5.855-1.266-1.229-1.138-2.487-2.992-2.487-2.992l-3.38-4.964c-.164-.26-.379-.54-.721-.54-.343 0-.557.28-.721.54l-3.38 4.964s-1.19 1.854-2.418 2.992c-1.92 1.783-5.957 1.262-5.957 1.262l9.161-13.88zM43.96 0H44c0 1.91-.186 3.042-1.387 3.923-.384.28-1.048.71-1.826.992C39.719 5.304 39 6 39 6c0-3.476.53-4.734 1.95-5.48.865-.452 2.272-.514 2.82-.52z"></path></svg>',RY={"modern-image-formats":"Upload images using `Wix Media Manager` to ensure they are automatically served as WebP. Find [more ways to optimize](https://support.wix.com/en/article/site-performance-optimizing-your-media) your site's media.","render-blocking-resources":"When [adding third-party code](https://support.wix.com/en/article/site-performance-using-third-party-code-on-your-site) in the `Custom Code` tab of your site's dashboard, make sure it's deferred or loaded at the end of the code body. Where possible, use Wix’s [integrations](https://support.wix.com/en/article/about-marketing-integrations) to embed marketing tools on your site. ","efficient-animated-content":"Place videos inside `VideoBoxes`, customize them using `Video Masks` or add `Transparent Videos`. [Learn more](https://support.wix.com/en/article/wix-video-about-wix-video).","unused-javascript":"Review any third-party code you've added to your site in the `Custom Code` tab of your site's dashboard and only keep the services that are necessary to your site. [Find out more](https://support.wix.com/en/article/site-performance-removing-unused-javascript).","server-response-time":"Wix utilizes CDNs and caching to serve responses as fast as possible for most visitors. Consider [manually enabling caching](https://support.wix.com/en/article/site-performance-caching-pages-to-optimize-loading-speed) for your site, especially if using `Velo`."};BR.exports={id:"wix",title:"Wix",icon:_Y,UIStrings:RY}});var qR=I((gye,jR)=>{d();var FY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 122.5 122.5"><g fill="%232f3439"><path d="M8.7 61.3c0 20.8 12.1 38.7 29.6 47.3l-25-68.7c-3 6.5-4.6 13.7-4.6 21.4zm88-2.7c0-6.5-2.3-11-4.3-14.5-2.7-4.3-5.2-8-5.2-12.3 0-4.8 3.7-9.3 8.9-9.3h.7a52.4 52.4 0 0 0-79.4 9.9h3.3c5.5 0 14-.6 14-.6 2.9-.2 3.2 4 .4 4.3 0 0-2.9.4-6 .5l19.1 57L59.7 59l-8.2-22.5c-2.8-.1-5.5-.5-5.5-.5-2.8-.1-2.5-4.5.3-4.3 0 0 8.7.7 13.9.7 5.5 0 14-.7 14-.7 2.8-.2 3.2 4 .3 4.3 0 0-2.8.4-6 .5l19 56.5 5.2-17.5c2.3-7.3 4-12.5 4-17z"/><path d="m62.2 65.9-15.8 45.8a52.6 52.6 0 0 0 32.3-.9l-.4-.7zM107.4 36a49.6 49.6 0 0 1-3.6 24.2l-16.1 46.5A52.5 52.5 0 0 0 107.4 36z"/><path d="M61.3 0a61.3 61.3 0 1 0 .1 122.7A61.3 61.3 0 0 0 61.3 0zm0 119.7a58.5 58.5 0 1 1 .1-117 58.5 58.5 0 0 1-.1 117z"/></g></svg>',IY={"unused-css-rules":"Consider reducing, or switching, the number of [WordPress plugins](https://wordpress.org/plugins/) loading unused CSS in your page. To identify plugins that are adding extraneous CSS, try running [code coverage](https://developer.chrome.com/docs/devtools/coverage/) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the stylesheet. Look out for plugins that have many stylesheets in the list which have a lot of red in code coverage. A plugin should only enqueue a stylesheet if it is actually used on the page.","modern-image-formats":"Consider using the [Performance Lab](https://wordpress.org/plugins/performance-lab/) plugin to automatically convert your uploaded JPEG images into WebP, wherever supported.","offscreen-images":"Install a [lazy-load WordPress plugin](https://wordpress.org/plugins/search/lazy+load/) that provides the ability to defer any offscreen images, or switch to a theme that provides that functionality. Also consider using [the AMP plugin](https://wordpress.org/plugins/amp/).","total-byte-weight":"Consider showing excerpts in your post lists (e.g. via the more tag), reducing the number of posts shown on a given page, breaking your long posts into multiple pages, or using a plugin to lazy-load comments.","render-blocking-resources":"There are a number of WordPress plugins that can help you [inline critical assets](https://wordpress.org/plugins/search/critical+css/) or [defer less important resources](https://wordpress.org/plugins/search/defer+css+javascript/). Beware that optimizations provided by these plugins may break features of your theme or plugins, so you will likely need to make code changes.","unminified-css":"A number of [WordPress plugins](https://wordpress.org/plugins/search/minify+css/) can speed up your site by concatenating, minifying, and compressing your styles. You may also want to use a build process to do this minification up-front if possible.","unminified-javascript":"A number of [WordPress plugins](https://wordpress.org/plugins/search/minify+javascript/) can speed up your site by concatenating, minifying, and compressing your scripts. You may also want to use a build process to do this minification up front if possible.","efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.","unused-javascript":"Consider reducing, or switching, the number of [WordPress plugins](https://wordpress.org/plugins/) loading unused JavaScript in your page. To identify plugins that are adding extraneous JS, try running [code coverage](https://developer.chrome.com/docs/devtools/coverage/) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the script. Look out for plugins that have many scripts in the list which have a lot of red in code coverage. A plugin should only enqueue a script if it is actually used on the page.","uses-long-cache-ttl":"Read about [Browser Caching in WordPress](https://wordpress.org/support/article/optimization/#browser-caching).","uses-optimized-images":"Consider using an [image optimization WordPress plugin](https://wordpress.org/plugins/search/optimize+images/) that compresses your images while retaining quality.","uses-text-compression":"You can enable text compression in your web server configuration.","uses-responsive-images":"Upload images directly through the [media library](https://wordpress.org/support/article/media-library-screen/) to ensure that the required image sizes are available, and then insert them from the media library or use the image widget to ensure the optimal image sizes are used (including those for the responsive breakpoints). Avoid using `Full Size` images unless the dimensions are adequate for their usage. [Learn More](https://wordpress.org/support/article/inserting-images-into-posts-and-pages/).","server-response-time":"Themes, plugins, and server specifications all contribute to server response time. Consider finding a more optimized theme, carefully selecting an optimization plugin, and/or upgrading your server."};jR.exports={id:"wordpress",title:"WordPress",icon:FY,UIStrings:IY}});var HR=I((bye,zR)=>{d();var NY='data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 294 524"><defs><linearGradient id="a" x1="36.742%" x2="37.116%" y1="100.518%" y2="-.001%"><stop offset="0%" stop-color="%23DD5F29"/><stop offset="26.042%" stop-color="%23F26B32"/><stop offset="100%" stop-color="%23FAC932"/></linearGradient><linearGradient id="b" x1="28.046%" x2="28.421%" y1="100.518%" y2="-.003%"><stop offset="0%" stop-color="%23DD5F29"/><stop offset="26.042%" stop-color="%23F26B32"/><stop offset="100%" stop-color="%23FAC932"/></linearGradient><linearGradient id="c" x1="38.215%" x2="38.589%" y1="100.518%" y2="0%"><stop offset="0%" stop-color="%23DD5F29"/><stop offset="26.042%" stop-color="%23F26B32"/><stop offset="100%" stop-color="%23FAC932"/></linearGradient></defs><g fill="none" fill-rule="evenodd"><path fill="url(%23a)" d="M218.617 270.615c-9.752 0-18.896-5.689-23.366-14.63l-7.72-17.27h-76.6l-7.722 17.27c-4.47 8.941-13.613 14.63-23.366 14.63H75.78l32.712 249.306c1.625 4.671 4.673 4.671 6.502 0l32.51-79.648 28.242 79.442c1.625 4.676 4.673 4.676 6.501 0L220.04 270.82l-1.423-.204Z" transform="translate(-1.58 -.2)"/><path fill="url(%23b)" d="M184.47 231.784h-70.3l-10.77 24.179c-3.657 7.314-10.768 12.597-18.489 14.02L109.7 423.791c1.625 2.844 4.673 2.844 6.501 0l31.697-48.155 29.055 47.951c1.829 2.845 4.673 2.845 6.502 0l28.039-154.012c-6.908-2.032-13.004-6.908-16.255-13.613l-10.768-24.18Z" transform="translate(-1.58 -.2)"/><path fill="url(%23c)" d="m195.259 255.988-46.123-103.014-45.92 103.014c-1.625 3.048-3.656 5.69-6.095 7.925l19.1 102.2c1.015 1.423 3.657 1.83 5.485 0l25.601-33.931 25.602 33.728c1.625 2.032 4.47 1.626 5.485 0l21.131-103.42c-1.625-2.032-3.047-4.064-4.266-6.502Z" transform="translate(-1.58 -.2)"/><path fill="%23F56F46" d="M.439 12.559c-1.422-4.877 1.422-8.33 6.299-8.33H47.17c2.845 0 5.486 2.437 6.299 4.876l29.665 116.83h1.422l53.437-121.3c1.016-2.032 3.048-3.86 5.892-3.86h6.299c3.047 0 5.08 1.625 5.892 3.86l53.437 121.3h1.423L240.6 9.105c.61-2.439 3.454-4.877 6.299-4.877h40.433c4.877 0 7.518 3.454 6.299 8.33l-65.221 231.63c-.61 2.845-3.454 4.876-6.298 4.876h-5.487c-2.438 0-4.876-1.625-5.892-3.86l-63.19-141.009h-1.015L83.744 245.203c-1.016 2.032-3.454 3.86-5.892 3.86h-5.486c-2.845 0-5.486-2.031-6.299-4.876L.44 12.559Z"/></g></svg>',MY={"unused-css-rules":"Enable [Remove Unused CSS](https://docs.wp-rocket.me/article/1529-remove-unused-css) in 'WP Rocket' to fix this issue. It reduces page size by removing all CSS and stylesheets that are not used while keeping only the used CSS for each page.","modern-image-formats":"Enable 'Imagify' from the Image Optimization tab in 'WP Rocket' to convert your images to WebP.","unused-javascript":"Enable [Delay JavaScript execution](https://docs.wp-rocket.me/article/1349-delay-javascript-execution) in 'WP Rocket' to fix this problem. It will improve the loading of your page by delaying the execution of scripts until user interaction. If your site has iframes, you can use WP Rocket's [LazyLoad for iframes and videos](https://docs.wp-rocket.me/article/1674-lazyload-for-iframes-and-videos) and [Replace YouTube iframe with preview image](https://docs.wp-rocket.me/article/1488-replace-youtube-iframe-with-preview-image) as well.","render-blocking-resources":"Enable [Remove Unused CSS](https://docs.wp-rocket.me/article/1529-remove-unused-css) and [Load JavaScript deferred](https://docs.wp-rocket.me/article/1265-load-javascript-deferred) in 'WP Rocket' to address this recommendation. These features will respectively optimize the CSS and JavaScript files so that they don't block the rendering of your page.","unminified-css":"Enable [Minify CSS files](https://docs.wp-rocket.me/article/1350-css-minify-combine) in 'WP Rocket' to fix this issue. Any spaces and comments in your site's CSS files will be removed to make the file size smaller and faster to download.","unminified-javascript":"Enable [Minify JavaScript files](https://docs.wp-rocket.me/article/1351-javascript-minify-combine) in 'WP Rocket' to fix this issue. Empty spaces and comments will be removed from JavaScript files to make their size smaller and faster to download.","uses-optimized-images":"Enable 'Imagify' from the Image Optimization tab in 'WP Rocket' and run Bulk Optimization to compress your images.","uses-rel-preconnect":`Use [Prefetch DNS Requests](https://docs.wp-rocket.me/article/1302-prefetch-dns-requests) in 'WP Rocket' to add "dns-prefetch" and speed up the connection with external domains. Also, 'WP Rocket' automatically adds "preconnect" to [Google Fonts domain](https://docs.wp-rocket.me/article/1312-optimize-google-fonts) and any CNAME(S) added via the [Enable CDN](https://docs.wp-rocket.me/article/42-using-wp-rocket-with-a-cdn) feature.`,"uses-rel-preload":"To fix this issue for fonts, enable [Remove Unused CSS](https://docs.wp-rocket.me/article/1529-remove-unused-css) in 'WP Rocket'. Your site's critical fonts will be preloaded with priority.","offscreen-images":"Enable [LazyLoad](https://docs.wp-rocket.me/article/1141-lazyload-for-images) in WP Rocket to fix this recommendation. This feature delays the loading of the images until the visitor scrolls down the page and actually needs to see them."};zR.exports={id:"wp-rocket",title:"WP Rocket",icon:NY,UIStrings:MY}});var VR=I((wye,GR)=>{d();var LY=[hR(),yR(),vR(),DR(),xR(),SR(),CR(),_R(),FR(),NR(),LR(),OR(),UR(),qR(),HR()];GR.exports=LY});var $R=I((Eye,WR)=>{d();WR.exports=s(function(t,n){if(typeof t=="string"&&n[t])return t;for(var r=[].concat(t||[]),a=0,o=r.length;a<o;++a)for(var i=r[a].split("-");i.length;){var c=i.join("-");if(n[c])return c;i.pop()}},"lookupClosestLocale")});var op,PY,ip,Wi=b(()=>{"use strict";d();Jr();Aa();Lo();op=Dt.dirname(""),PY=JSON.parse(`{
  "name": "lighthouse",
  "type": "module",
  "version": "11.4.0",
  "description": "Automated auditing, performance metrics, and best practices for the web.",
  "main": "./core/index.js",
  "bin": {
    "lighthouse": "./cli/index.js",
    "chrome-debug": "./core/scripts/manual-chrome-launcher.js",
    "smokehouse": "./cli/test/smokehouse/frontends/smokehouse-bin.js"
  },
  "engines": {
    "node": ">=18.16"
  },
  "scripts": {
    "prepack": "yarn build-report --standalone --flow --esm && yarn build-types",
    "postpack": "yarn clean-types",
    "build-all": "npm-run-posix-or-windows build-all:task",
    "build-all:task": "yarn build-report && yarn build-cdt-lib && yarn build-devtools && concurrently 'yarn build-extension' 'yarn build-lr' 'yarn build-viewer' 'yarn build-treemap' 'yarn build-smokehouse-bundle' && yarn build-pack",
    "build-all:task:windows": "yarn build-report && yarn build-cdt-lib && yarn build-extension && yarn build-devtools && yarn build-lr && yarn build-viewer && yarn build-treemap && yarn build-smokehouse-bundle",
    "build-cdt-lib": "node ./build/build-cdt-lib.js",
    "build-extension": "yarn build-extension-chrome && yarn build-extension-firefox",
    "build-extension-chrome": "node ./build/build-extension.js chrome",
    "build-extension-firefox": "node ./build/build-extension.js firefox",
    "build-devtools": "yarn reset-link && node ./build/build-bundle.js clients/devtools/devtools-entry.js dist/lighthouse-dt-bundle.js && node ./build/build-dt-report-resources.js",
    "build-smokehouse-bundle": "node ./build/build-smokehouse-bundle.js",
    "build-lr": "yarn reset-link && node --max-old-space-size=4096 ./build/build-lightrider-bundles.js",
    "build-pack": "bash build/build-pack.sh",
    "build-report": "node build/build-report-components.js && node build/build-report.js",
    "build-sample-reports": "yarn build-report && node build/build-sample-reports.js",
    "build-treemap": "node ./build/build-treemap.js",
    "build-viewer": "node ./build/build-viewer.js",
    "build-types": "yarn type-check && rsync -a .tmp/tsbuildinfo/ ./ --include='*.d.ts' --include='*.d.cts' --exclude='*.map' --exclude='*.tsbuildinfo'",
    "reset-link": "(yarn unlink || true) && yarn link && yarn link lighthouse",
    "c8": "bash core/scripts/c8.sh",
    "clean": "rm -r dist proto/scripts/*.json proto/scripts/*_pb2.* proto/scripts/*_pb.* proto/scripts/__pycache__ proto/scripts/*.pyc *.report.html *.report.dom.html *.report.json *.devtoolslog.json *.trace.json shared/localization/locales/*.ctc.json || true",
    "clean-types": "git clean -xfq '*.d.ts' '*.d.cts' -e 'node_modules/' -e 'dist/' -e '.tmp/' -e '**/types/'",
    "lint": "[ \\"$CI\\" = true ] && eslint --quiet -f codeframe . || eslint .",
    "smoke": "node -r source-map-support/register cli/test/smokehouse/frontends/smokehouse-bin.js",
    "debug": "node --inspect-brk ./cli/index.js",
    "start": "yarn build-report --standalone && node ./cli/index.js",
    "mocha": "node --loader=testdouble core/test/scripts/run-mocha-tests.js",
    "test": "yarn diff:sample-json && yarn lint --quiet && yarn unit && yarn type-check",
    "test-bundle": "yarn smoke --runner bundle",
    "test-clients": "yarn mocha --testMatch clients/**/*-test.js && yarn mocha --testMatch clients/**/*-test-pptr.js",
    "test-viewer": "yarn unit-viewer && yarn mocha --testMatch viewer/**/*-test-pptr.js --timeout 35000",
    "test-treemap": "yarn unit-treemap && yarn mocha --testMatch treemap/**/*-test-pptr.js --timeout 35000",
    "test-lantern": "bash core/scripts/test-lantern.sh",
    "test-legacy-javascript": "bash core/scripts/test-legacy-javascript.sh",
    "test-docs": "yarn --cwd docs/recipes/ test",
    "test-proto": "yarn compile-proto && yarn build-proto-roundtrip",
    "unit-core": "yarn mocha core",
    "unit-cli": "yarn mocha --testMatch cli/**/*-test.js",
    "unit-report": "yarn mocha --testMatch report/**/*-test.js",
    "unit-treemap": "yarn mocha --testMatch treemap/**/*-test.js",
    "unit-viewer": "yarn mocha --testMatch viewer/**/*-test.js",
    "unit-flow": "bash flow-report/test/run-flow-report-tests.sh",
    "unit": "yarn unit-flow && yarn mocha",
    "unit:ci": "NODE_OPTIONS=--max-old-space-size=8192 npm run unit",
    "core-unit": "yarn unit-core",
    "cli-unit": "yarn unit-cli",
    "viewer-unit": "yarn unit-viewer",
    "watch": "yarn unit-core --watch",
    "unit:cicoverage": "yarn c8 --all yarn unit:ci",
    "coverage": "yarn unit:cicoverage && c8 report --reporter html",
    "coverage:smoke": "yarn c8 yarn smoke -j=1 && c8 report --reporter html",
    "devtools": "bash core/scripts/roll-to-devtools.sh",
    "chrome": "node core/scripts/manual-chrome-launcher.js",
    "fast": "node ./cli/index.js --preset=desktop --throttlingMethod=provided",
    "deploy-treemap": "yarn build-treemap --deploy",
    "deploy-viewer": "yarn build-viewer --deploy",
    "vercel-build": "yarn build-sample-reports && yarn build-viewer && yarn build-treemap",
    "dogfood-lhci": "./core/scripts/dogfood-lhci.sh",
    "timing-trace": "node core/scripts/generate-timing-trace.js",
    "changelog": "conventional-changelog --config ./build/changelog-generator/index.cjs --infile changelog.md --same-file",
    "type-check": "tsc --build ./tsconfig-all.json",
    "i18n:checks": "./core/scripts/i18n/assert-strings-collected.sh",
    "i18n:collect-strings": "node core/scripts/i18n/collect-strings.js",
    "update:lantern-baseline": "node core/scripts/lantern/update-baseline-lantern-values.js",
    "update:sample-artifacts": "node core/scripts/update-report-fixtures.js",
    "update:sample-json": "yarn i18n:collect-strings && node ./cli -A=./core/test/results/artifacts --config-path=./core/test/results/sample-config.js --output=json --output-path=./core/test/results/sample_v2.json && node core/scripts/cleanup-LHR-for-diff.js ./core/test/results/sample_v2.json --only-remove-timing && node ./core/scripts/update-flow-fixtures.js",
    "update:flow-sample-json": "yarn i18n:collect-strings && node ./core/scripts/update-flow-fixtures.js",
    "test-devtools": "bash core/test/devtools-tests/test-locally.sh",
    "open-devtools": "bash core/scripts/open-devtools.sh",
    "run-devtools": "node core/scripts/pptr-run-devtools.js",
    "diff:sample-json": "yarn i18n:checks && bash core/scripts/assert-golden-lhr-unchanged.sh",
    "diff:flow-sample-json": "yarn i18n:collect-strings && bash core/scripts/assert-baseline-flow-result-unchanged.sh",
    "computeBenchmarkIndex": "./core/scripts/benchmark.js",
    "save-latest-run": "./core/scripts/save-latest-run.sh",
    "compile-proto": "protoc --python_out=./ ./proto/lighthouse-result.proto && mv ./proto/*_pb2.py ./proto/scripts || (echo \\"❌ Install protobuf = 3.20.x to compile the proto file.\\" && false)",
    "build-proto-roundtrip": "mkdir -p .tmp && python3 proto/scripts/json_roundtrip_via_proto.py",
    "static-server": "node cli/test/fixtures/static-server.js",
    "serve-dist": "cd dist && python3 -m http.server 7878",
    "serve-gh-pages": "cd dist/gh-pages && python3 -m http.server 7333",
    "serve-treemap": "yarn serve-gh-pages",
    "serve-viewer": "yarn serve-gh-pages",
    "flow-report": "yarn build-report --flow && node ./core/scripts/build-test-flow-report.js"
  },
  "devDependencies": {
    "@build-tracker/cli": "^1.0.0-beta.15",
    "@esbuild-kit/esm-loader": "^2.1.1",
    "@esbuild-plugins/node-modules-polyfill": "^0.1.4",
    "@formatjs/icu-messageformat-parser": "^2.6.2",
    "@jest/fake-timers": "^28.1.0",
    "@testing-library/preact": "^3.1.1",
    "@testing-library/preact-hooks": "^1.1.0",
    "@types/archiver": "^2.1.2",
    "@types/chrome": "^0.0.154",
    "@types/configstore": "^4.0.0",
    "@types/cpy": "^5.1.0",
    "@types/debug": "^4.1.7",
    "@types/eslint": "^8.2.1",
    "@types/estree": "^0.0.50",
    "@types/gh-pages": "^2.0.0",
    "@types/google.analytics": "0.0.39",
    "@types/jpeg-js": "^0.3.7",
    "@types/jsdom": "^16.2.13",
    "@types/lodash": "^4.14.178",
    "@types/mocha": "^9.0.0",
    "@types/node": "*",
    "@types/pako": "^1.0.1",
    "@types/resize-observer-browser": "^0.1.1",
    "@types/resolve": "^1.20.2",
    "@types/semver": "^5.5.0",
    "@types/tabulator-tables": "^4.9.1",
    "@types/ws": "^7.0.0",
    "@types/yargs": "^17.0.8",
    "@types/yargs-parser": "^20.2.1",
    "@typescript-eslint/eslint-plugin": "^5.48.0",
    "@typescript-eslint/parser": "^5.48.0",
    "acorn": "^8.5.0",
    "angular": "^1.7.4",
    "archiver": "^3.0.0",
    "builtin-modules": "^3.3.0",
    "c8": "^7.11.3",
    "chalk": "^2.4.1",
    "chrome-devtools-frontend": "1.0.1153166",
    "concurrently": "^6.4.0",
    "conventional-changelog-cli": "^2.1.1",
    "cpy": "^8.1.2",
    "cross-env": "^7.0.2",
    "csv-validator": "^0.0.3",
    "es-main": "^1.2.0",
    "esbuild": "^0.18.11",
    "eslint": "^8.4.1",
    "eslint-config-google": "^0.14.0",
    "eslint-formatter-codeframe": "^7.32.1",
    "eslint-plugin-import": "^2.25.3",
    "eslint-plugin-local-rules": "1.1.0",
    "event-target-shim": "^6.0.2",
    "expect": "^28.1.0",
    "firebase": "^9.0.2",
    "gh-pages": "^2.0.1",
    "glob": "^7.1.3",
    "idb-keyval": "2.2.0",
    "jest-mock": "^27.3.0",
    "jest-snapshot": "^28.1.0",
    "jsdom": "^12.2.0",
    "lighthouse-plugin-publisher-ads": "1.5.7-beta",
    "lighthouse-plugin-soft-navigation": "^1.0.1",
    "magic-string": "^0.25.7",
    "mime-types": "^2.1.30",
    "mocha": "^10.0.0",
    "node-fetch": "^2.6.1",
    "npm-run-posix-or-windows": "^2.0.2",
    "pako": "^2.0.3",
    "preact": "^10.7.2",
    "pretty-json-stringify": "^0.0.2",
    "puppeteer": "^21.5.2",
    "resolve": "^1.22.1",
    "rollup": "^2.52.7",
    "rollup-plugin-polyfill-node": "^0.12.0",
    "source-map-support": "^0.5.21",
    "tabulator-tables": "^4.9.3",
    "terser": "^5.18.2",
    "testdouble": "^3.18.0",
    "typed-query-selector": "^2.6.1",
    "typescript": "^5.0.4",
    "wait-for-expect": "^3.0.2",
    "webtreemap-cdt": "^3.2.1"
  },
  "dependencies": {
    "@sentry/node": "^6.17.4",
    "axe-core": "^4.8.1",
    "chrome-launcher": "^1.1.0",
    "configstore": "^5.0.1",
    "csp_evaluator": "1.1.1",
    "devtools-protocol": "0.0.1211954",
    "enquirer": "^2.3.6",
    "http-link-header": "^1.1.1",
    "intl-messageformat": "^10.5.3",
    "jpeg-js": "^0.4.4",
    "js-library-detector": "^6.7.0",
    "lighthouse-logger": "^2.0.1",
    "lighthouse-stack-packs": "1.12.1",
    "lodash": "^4.17.21",
    "lookup-closest-locale": "6.2.0",
    "metaviewport-parser": "0.3.0",
    "open": "^8.4.0",
    "parse-cache-control": "1.0.1",
    "ps-list": "^8.0.0",
    "puppeteer-core": "^21.5.2",
    "robots-parser": "^3.0.1",
    "semver": "^5.3.0",
    "speedline-core": "^1.4.3",
    "third-party-web": "^0.24.1",
    "tldts-icann": "^6.1.0",
    "ws": "^7.0.0",
    "yargs": "^17.3.1",
    "yargs-parser": "^21.0.0"
  },
  "resolutions": {
    "puppeteer/**/devtools-protocol": "0.0.1211954",
    "puppeteer-core/**/devtools-protocol": "0.0.1211954"
  },
  "repository": "GoogleChrome/lighthouse",
  "keywords": [
    "google",
    "chrome",
    "devtools"
  ],
  "author": "Google LLC",
  "license": "Apache-2.0",
  "bugs": {
    "url": "https://github.com/GoogleChrome/lighthouse/issues"
  },
  "homepage": "https://github.com/GoogleChrome/lighthouse#readme"
}
`),ip=PY.version});function sp(e,t){if(typeof Intl!="object")throw new Error("Lighthouse must be run in Node with `Intl` support. See https://nodejs.org/api/intl.html for help");let n=Intl.getCanonicalLocales(e),r=Intl.NumberFormat.supportedLocalesOf(n),a=t||mR(),o=Object.fromEntries(a.map(c=>[c,{}])),i=(0,YR.default)(r,o);return i||(Intl.NumberFormat.supportedLocalesOf("es").length===0&&F.warn("i18n","Requested locale not available in this version of node. The `full-icu` npm module can provide additional locales. For help, see https://github.com/GoogleChrome/lighthouse/blob/main/readme.md#how-do-i-get-localized-lighthouse-results-via-the-cli"),F.warn("i18n",`locale(s) '${e}' not available. Falling back to default '${Gi}'`)),i||Gi}function w(e,t={}){e.startsWith("file://")&&(e=Mo.fileURLToPath(e)),Dt.isAbsolute(e)&&(e=Dt.relative(op,e));let n={...x,...t};return s((a,o)=>{let i=Object.keys(n).find(m=>n[m]===a);if(!i)throw new Error(`Could not locate: ${a}`);return{i18nId:`${(i in t?e:Dt.relative(op,nR({url:"core/lib/i18n/i18n.js"}))).replace(/\\/g,"/")} | ${i}`,values:o,formattedDefault:J1(a,o,Gi)}},"getIcuMessageFn")}function Dr(e){return typeof e=="string"||Vi(e)}var YR,x,A=b(()=>{"use strict";d();Aa();mu();YR=Lt($R(),1);Ae();Qr();Wi();Qr();Lo();x={ms:"{timeInMs, number, milliseconds} ms",seconds:"{timeInMs, number, seconds} s",displayValueByteSavings:"Potential savings of {wastedBytes, number, bytes} KiB",displayValueMsSavings:"Potential savings of {wastedMs, number, milliseconds} ms",displayValueElementsFound:"{nodeCount, plural, =1 {1 element found} other {# elements found}}",columnURL:"URL",columnSize:"Size",columnResourceSize:"Resource Size",columnTransferSize:"Transfer Size",columnCacheTTL:"Cache TTL",columnWastedBytes:"Potential Savings",columnWastedMs:"Potential Savings",columnBlockingTime:"Main-Thread Blocking Time",columnTimeSpent:"Time Spent",columnLocation:"Location",columnResourceType:"Resource Type",columnRequests:"Requests",columnName:"Name",columnSource:"Source",columnOverBudget:"Over Budget",columnElement:"Element",columnStartTime:"Start Time",columnDuration:"Duration",columnFailingElem:"Failing Elements",columnDescription:"Description",totalResourceType:"Total",documentResourceType:"Document",scriptResourceType:"Script",stylesheetResourceType:"Stylesheet",imageResourceType:"Image",mediaResourceType:"Media",fontResourceType:"Font",otherResourceType:"Other",thirdPartyResourceType:"Third-party",otherResourcesLabel:"Other resources",firstContentfulPaintMetric:"First Contentful Paint",interactiveMetric:"Time to Interactive",firstMeaningfulPaintMetric:"First Meaningful Paint",totalBlockingTimeMetric:"Total Blocking Time",maxPotentialFIDMetric:"Max Potential First Input Delay",speedIndexMetric:"Speed Index",largestContentfulPaintMetric:"Largest Contentful Paint",cumulativeLayoutShiftMetric:"Cumulative Layout Shift",interactionToNextPaint:"Interaction to Next Paint",itemSeverityLow:"Low",itemSeverityMedium:"Medium",itemSeverityHigh:"High"};s(sp,"lookupLocale");s(w,"createIcuMessageFn");s(Dr,"isStringOrIcuMessage")});function XR(e){if(!e)return[];let t=[];for(let n of e){let r=eg.find(u=>u.requiredStacks.includes(`${n.detector}:${n.id}`));if(!r)continue;let a=KR.default.find(u=>u.id===r.packId);if(!a){F.warn("StackPacks",`'${r.packId}' stack pack was matched but is not found in stack-packs lib`);continue}let o=w(`node_modules/lighthouse-stack-packs/packs/${a.id}.js`,a.UIStrings),i={},c=a.UIStrings;for(let u in c)c[u]&&(i[u]=o(c[u]));t.push({id:a.id,title:a.title,iconDataURL:a.icon,descriptions:i})}return t.sort((n,r)=>{let a=eg.findIndex(i=>i.packId===n.id),o=eg.findIndex(i=>i.packId===r.id);return a-o})}var KR,eg,JR=b(()=>{"use strict";d();Ae();KR=Lt(VR(),1);A();eg=[{packId:"gatsby",requiredStacks:["js:gatsby"]},{packId:"wordpress",requiredStacks:["js:wordpress"]},{packId:"wix",requiredStacks:["js:wix"]},{packId:"wp-rocket",requiredStacks:["js:wp-rocket"]},{packId:"ezoic",requiredStacks:["js:ezoic"]},{packId:"drupal",requiredStacks:["js:drupal"]},{packId:"nitropack",requiredStacks:["js:nitropack"]},{packId:"amp",requiredStacks:["js:amp"]},{packId:"magento",requiredStacks:["js:magento"]},{packId:"octobercms",requiredStacks:["js:octobercms"]},{packId:"joomla",requiredStacks:["js:joomla"]},{packId:"next.js",requiredStacks:["js:next"]},{packId:"nuxt",requiredStacks:["js:nuxt"]},{packId:"angular",requiredStacks:["js:@angular/core"]},{packId:"react",requiredStacks:["js:react"]}];s(XR,"getStackPacks")});var tg,Ft,ZR=b(()=>{d();typeof Object.create=="function"?tg=s(function(t,n){t.super_=n,t.prototype=Object.create(n.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}})},"inherits"):tg=s(function(t,n){t.super_=n;var r=s(function(){},"TempCtor");r.prototype=n.prototype,t.prototype=new r,t.prototype.constructor=t},"inherits");Ft=tg});function jY(e){if(!lg(e)){for(var t=[],n=0;n<arguments.length;n++)t.push(Ra(arguments[n]));return t.join(" ")}for(var n=1,r=arguments,a=r.length,o=String(e).replace(UY,function(c){if(c==="%%")return"%";if(n>=a)return c;switch(c){case"%s":return String(r[n++]);case"%d":return Number(r[n++]);case"%j":try{return JSON.stringify(r[n++])}catch{return"[Circular]"}default:return c}}),i=r[n];n<a;i=r[++n])ug(i)||!pu(i)?o+=" "+i:o+=" "+Ra(i);return o}function cg(e,t){if(_a(globalThis.process))return function(){return cg(e,t).apply(this,arguments)};if(rn.noDeprecation===!0)return e;var n=!1;function r(){if(!n){if(rn.throwDeprecation)throw new Error(t);rn.traceDeprecation?console.trace(t):console.error(t),n=!0}return e.apply(this,arguments)}return s(r,"deprecated"),r}function eF(e){if(_a(ng)&&(ng=rn.env.NODE_DEBUG||""),e=e.toUpperCase(),!cp[e])if(new RegExp("\\b"+e+"\\b","i").test(ng)){var t=0;cp[e]=function(){var n=jY.apply(null,arguments);console.error("%s %d: %s",e,t,n)}}else cp[e]=function(){};return cp[e]}function Ra(e,t){var n={seen:[],stylize:zY};return arguments.length>=3&&(n.depth=arguments[2]),arguments.length>=4&&(n.colors=arguments[3]),tF(t)?n.showHidden=t:t&&KY(n,t),_a(n.showHidden)&&(n.showHidden=!1),_a(n.depth)&&(n.depth=2),_a(n.colors)&&(n.colors=!1),_a(n.customInspect)&&(n.customInspect=!0),n.colors&&(n.stylize=qY),up(n,e,n.depth)}function qY(e,t){var n=Ra.styles[t];return n?"\x1B["+Ra.colors[n][0]+"m"+e+"\x1B["+Ra.colors[n][1]+"m":e}function zY(e,t){return e}function HY(e){var t={};return e.forEach(function(n,r){t[n]=!0}),t}function up(e,t,n){if(e.customInspect&&t&&ig(t.inspect)&&t.inspect!==Ra&&!(t.constructor&&t.constructor.prototype===t)){var r=t.inspect(n,e);return lg(r)||(r=up(e,r,n)),r}var a=GY(e,t);if(a)return a;var o=Object.keys(t),i=HY(o);if(e.showHidden&&(o=Object.getOwnPropertyNames(t)),og(t)&&(o.indexOf("message")>=0||o.indexOf("description")>=0))return rg(t);if(o.length===0){if(ig(t)){var c=t.name?": "+t.name:"";return e.stylize("[Function"+c+"]","special")}if(ag(t))return e.stylize(RegExp.prototype.toString.call(t),"regexp");if(QR(t))return e.stylize(Date.prototype.toString.call(t),"date");if(og(t))return rg(t)}var u="",l=!1,m=["{","}"];if($Y(t)&&(l=!0,m=["[","]"]),ig(t)){var p=t.name?": "+t.name:"";u=" [Function"+p+"]"}if(ag(t)&&(u=" "+RegExp.prototype.toString.call(t)),QR(t)&&(u=" "+Date.prototype.toUTCString.call(t)),og(t)&&(u=" "+rg(t)),o.length===0&&(!l||t.length==0))return m[0]+u+m[1];if(n<0)return ag(t)?e.stylize(RegExp.prototype.toString.call(t),"regexp"):e.stylize("[Object]","special");e.seen.push(t);var h;return l?h=VY(e,t,n,i,o):h=o.map(function(f){return sg(e,t,n,i,f,l)}),e.seen.pop(),WY(h,u,m)}function GY(e,t){if(_a(t))return e.stylize("undefined","undefined");if(lg(t)){var n="'"+JSON.stringify(t).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return e.stylize(n,"string")}if(YY(t))return e.stylize(""+t,"number");if(tF(t))return e.stylize(""+t,"boolean");if(ug(t))return e.stylize("null","null")}function rg(e){return"["+Error.prototype.toString.call(e)+"]"}function VY(e,t,n,r,a){for(var o=[],i=0,c=t.length;i<c;++i)nF(t,String(i))?o.push(sg(e,t,n,r,String(i),!0)):o.push("");return a.forEach(function(u){u.match(/^\d+$/)||o.push(sg(e,t,n,r,u,!0))}),o}function sg(e,t,n,r,a,o){var i,c,u;if(u=Object.getOwnPropertyDescriptor(t,a)||{value:t[a]},u.get?u.set?c=e.stylize("[Getter/Setter]","special"):c=e.stylize("[Getter]","special"):u.set&&(c=e.stylize("[Setter]","special")),nF(r,a)||(i="["+a+"]"),c||(e.seen.indexOf(u.value)<0?(ug(n)?c=up(e,u.value,null):c=up(e,u.value,n-1),c.indexOf(`
`)>-1&&(o?c=c.split(`
`).map(function(l){return"  "+l}).join(`
`).substr(2):c=`
`+c.split(`
`).map(function(l){return"   "+l}).join(`
`))):c=e.stylize("[Circular]","special")),_a(i)){if(o&&a.match(/^\d+$/))return c;i=JSON.stringify(""+a),i.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(i=i.substr(1,i.length-2),i=e.stylize(i,"name")):(i=i.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),i=e.stylize(i,"string"))}return i+": "+c}function WY(e,t,n){var r=0,a=e.reduce(function(o,i){return r++,i.indexOf(`
`)>=0&&r++,o+i.replace(/\u001b\[\d\d?m/g,"").length+1},0);return a>60?n[0]+(t===""?"":t+`
 `)+" "+e.join(`,
  `)+" "+n[1]:n[0]+t+" "+e.join(", ")+" "+n[1]}function $Y(e){return Array.isArray(e)}function tF(e){return typeof e=="boolean"}function ug(e){return e===null}function YY(e){return typeof e=="number"}function lg(e){return typeof e=="string"}function _a(e){return e===void 0}function ag(e){return pu(e)&&dg(e)==="[object RegExp]"}function pu(e){return typeof e=="object"&&e!==null}function QR(e){return pu(e)&&dg(e)==="[object Date]"}function og(e){return pu(e)&&(dg(e)==="[object Error]"||e instanceof Error)}function ig(e){return typeof e=="function"}function dg(e){return Object.prototype.toString.call(e)}function KY(e,t){if(!t||!pu(t))return e;for(var n=Object.keys(t),r=n.length;r--;)e[n[r]]=t[n[r]];return e}function nF(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function XY(e){if(typeof e!="function")throw new TypeError('The "original" argument must be of type Function');if(Oo&&e[Oo]){var t=e[Oo];if(typeof t!="function")throw new TypeError('The "util.promisify.custom" argument must be of type Function');return Object.defineProperty(t,Oo,{value:t,enumerable:!1,writable:!1,configurable:!0}),t}function t(){for(var n,r,a=new Promise(function(c,u){n=c,r=u}),o=[],i=0;i<arguments.length;i++)o.push(arguments[i]);o.push(function(c,u){c?r(c):n(u)});try{e.apply(this,o)}catch(c){r(c)}return a}return s(t,"fn"),Object.setPrototypeOf(t,Object.getPrototypeOf(e)),Oo&&Object.defineProperty(t,Oo,{value:t,enumerable:!1,writable:!1,configurable:!0}),Object.defineProperties(t,BY(e))}var BY,UY,cp,ng,Oo,Fa=b(()=>{d();Ta();ZR();BY=Object.getOwnPropertyDescriptors||s(function(t){for(var n=Object.keys(t),r={},a=0;a<n.length;a++)r[n[a]]=Object.getOwnPropertyDescriptor(t,n[a]);return r},"getOwnPropertyDescriptors"),UY=/%[sdj%]/g;s(jY,"format");s(cg,"deprecate");cp={};s(eF,"debuglog");s(Ra,"inspect");Ra.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]};Ra.styles={special:"cyan",number:"yellow",boolean:"yellow",undefined:"grey",null:"bold",string:"green",date:"magenta",regexp:"red"};s(qY,"stylizeWithColor");s(zY,"stylizeNoColor");s(HY,"arrayToHash");s(up,"formatValue");s(GY,"formatPrimitive");s(rg,"formatError");s(VY,"formatArray");s(sg,"formatProperty");s(WY,"reduceToSingleString");s($Y,"isArray");s(tF,"isBoolean");s(ug,"isNull");s(YY,"isNumber");s(lg,"isString");s(_a,"isUndefined");s(ag,"isRegExp");s(pu,"isObject");s(QR,"isDate");s(og,"isError");s(ig,"isFunction");s(dg,"objectToString");s(KY,"_extend");s(nF,"hasOwnProperty");Oo=typeof Symbol<"u"?Symbol("util.promisify.custom"):void 0;s(XY,"promisify");XY.custom=Oo});function Bo(){this.head=null,this.tail=null,this.length=0}var rF,aF=b(()=>{d();Ci();rF=Bo;s(Bo,"BufferList");Bo.prototype.push=function(e){var t={data:e,next:null};this.length>0?this.tail.next=t:this.head=t,this.tail=t,++this.length};Bo.prototype.unshift=function(e){var t={data:e,next:this.head};this.length===0&&(this.tail=t),this.head=t,++this.length};Bo.prototype.shift=function(){if(this.length!==0){var e=this.head.data;return this.length===1?this.head=this.tail=null:this.head=this.head.next,--this.length,e}};Bo.prototype.clear=function(){this.head=this.tail=null,this.length=0};Bo.prototype.join=function(e){if(this.length===0)return"";for(var t=this.head,n=""+t.data;t=t.next;)n+=e+t.data;return n};Bo.prototype.concat=function(e){if(this.length===0)return U.alloc(0);if(this.length===1)return this.head.data;for(var t=U.allocUnsafe(e>>>0),n=this.head,r=0;n;)n.data.copy(t,r),r+=n.data.length,n=n.next;return t}});function ZY(e){if(e&&!JY(e))throw new Error("Unknown encoding: "+e)}function $i(e){switch(this.encoding=(e||"utf8").toLowerCase().replace(/[-_]/,""),ZY(e),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=eK;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=tK;break;default:this.write=QY;return}this.charBuffer=new U(6),this.charReceived=0,this.charLength=0}function QY(e){return e.toString(this.encoding)}function eK(e){this.charReceived=e.length%2,this.charLength=this.charReceived?2:0}function tK(e){this.charReceived=e.length%3,this.charLength=this.charReceived?3:0}var JY,oF=b(()=>{d();Ci();JY=U.isEncoding||function(e){switch(e&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}};s(ZY,"assertEncoding");s($i,"StringDecoder");$i.prototype.write=function(e){for(var t="";this.charLength;){var n=e.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:e.length;if(e.copy(this.charBuffer,this.charReceived,0,n),this.charReceived+=n,this.charReceived<this.charLength)return"";e=e.slice(n,e.length),t=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var a=t.charCodeAt(t.length-1);if(a>=55296&&a<=56319){this.charLength+=this.surrogateSize,t="";continue}if(this.charReceived=this.charLength=0,e.length===0)return t;break}this.detectIncompleteChar(e);var r=e.length;this.charLength&&(e.copy(this.charBuffer,0,e.length-this.charReceived,r),r-=this.charReceived),t+=e.toString(this.encoding,0,r);var r=t.length-1,a=t.charCodeAt(r);if(a>=55296&&a<=56319){var o=this.surrogateSize;return this.charLength+=o,this.charReceived+=o,this.charBuffer.copy(this.charBuffer,o,0,o),e.copy(this.charBuffer,0,0,o),t.substring(0,r)}return t};$i.prototype.detectIncompleteChar=function(e){for(var t=e.length>=3?3:e.length;t>0;t--){var n=e[e.length-t];if(t==1&&n>>5==6){this.charLength=2;break}if(t<=2&&n>>4==14){this.charLength=3;break}if(t<=3&&n>>3==30){this.charLength=4;break}}this.charReceived=t};$i.prototype.end=function(e){var t="";if(e&&e.length&&(t=this.write(e)),this.charReceived){var n=this.charReceived,r=this.charBuffer,a=this.encoding;t+=r.slice(0,n).toString(a)}return t};s(QY,"passThroughWrite");s(eK,"utf16DetectIncompleteChar");s(tK,"base64DetectIncompleteChar")});function nK(e,t,n){if(typeof e.prependListener=="function")return e.prependListener(t,n);!e._events||!e._events[t]?e.on(t,n):Array.isArray(e._events[t])?e._events[t].unshift(n):e._events[t]=[n,e._events[t]]}function rK(e,t){return e.listeners(t).length}function uF(e,t){e=e||{},this.objectMode=!!e.objectMode,t instanceof on&&(this.objectMode=this.objectMode||!!e.readableObjectMode);var n=e.highWaterMark,r=this.objectMode?16:16*1024;this.highWaterMark=n||n===0?n:r,this.highWaterMark=~~this.highWaterMark,this.buffer=new rF,this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.defaultEncoding=e.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,e.encoding&&(this.decoder=new $i(e.encoding),this.encoding=e.encoding)}function Et(e){if(!(this instanceof Et))return new Et(e);this._readableState=new uF(e,this),this.readable=!0,e&&typeof e.read=="function"&&(this._read=e.read),jn.call(this)}function lF(e,t,n,r,a){var o=iK(t,n);if(o)e.emit("error",o);else if(n===null)t.reading=!1,sK(e,t);else if(t.objectMode||n&&n.length>0)if(t.ended&&!a){var i=new Error("stream.push() after EOF");e.emit("error",i)}else if(t.endEmitted&&a){var c=new Error("stream.unshift() after end event");e.emit("error",c)}else{var u;t.decoder&&!a&&!r&&(n=t.decoder.write(n),u=!t.objectMode&&n.length===0),a||(t.reading=!1),u||(t.flowing&&t.length===0&&!t.sync?(e.emit("data",n),e.read(0)):(t.length+=t.objectMode?1:n.length,a?t.buffer.unshift(n):t.buffer.push(n),t.needReadable&&lp(e))),cK(e,t)}else a||(t.reading=!1);return aK(t)}function aK(e){return!e.ended&&(e.needReadable||e.length<e.highWaterMark||e.length===0)}function oK(e){return e>=iF?e=iF:(e--,e|=e>>>1,e|=e>>>2,e|=e>>>4,e|=e>>>8,e|=e>>>16,e++),e}function sF(e,t){return e<=0||t.length===0&&t.ended?0:t.objectMode?1:e!==e?t.flowing&&t.length?t.buffer.head.data.length:t.length:(e>t.highWaterMark&&(t.highWaterMark=oK(e)),e<=t.length?e:t.ended?t.length:(t.needReadable=!0,0))}function iK(e,t){var n=null;return!Buffer.isBuffer(t)&&typeof t!="string"&&t!==null&&t!==void 0&&!e.objectMode&&(n=new TypeError("Invalid non-string/buffer chunk")),n}function sK(e,t){if(!t.ended){if(t.decoder){var n=t.decoder.end();n&&n.length&&(t.buffer.push(n),t.length+=t.objectMode?1:n.length)}t.ended=!0,lp(e)}}function lp(e){var t=e._readableState;t.needReadable=!1,t.emittedReadable||(tt("emitReadable",t.flowing),t.emittedReadable=!0,t.sync?nn(cF,e):cF(e))}function cF(e){tt("emit readable"),e.emit("readable"),pg(e)}function cK(e,t){t.readingMore||(t.readingMore=!0,nn(uK,e,t))}function uK(e,t){for(var n=t.length;!t.reading&&!t.flowing&&!t.ended&&t.length<t.highWaterMark&&(tt("maybeReadMore read 0"),e.read(0),n!==t.length);)n=t.length;t.readingMore=!1}function lK(e){return function(){var t=e._readableState;tt("pipeOnDrain",t.awaitDrain),t.awaitDrain&&t.awaitDrain--,t.awaitDrain===0&&e.listeners("data").length&&(t.flowing=!0,pg(e))}}function dK(e){tt("readable nexttick read 0"),e.read(0)}function mK(e,t){t.resumeScheduled||(t.resumeScheduled=!0,nn(pK,e,t))}function pK(e,t){t.reading||(tt("resume read 0"),e.read(0)),t.resumeScheduled=!1,t.awaitDrain=0,e.emit("resume"),pg(e),t.flowing&&!t.reading&&e.read(0)}function pg(e){var t=e._readableState;for(tt("flow",t.flowing);t.flowing&&e.read()!==null;);}function dF(e,t){if(t.length===0)return null;var n;return t.objectMode?n=t.buffer.shift():!e||e>=t.length?(t.decoder?n=t.buffer.join(""):t.buffer.length===1?n=t.buffer.head.data:n=t.buffer.concat(t.length),t.buffer.clear()):n=fK(e,t.buffer,t.decoder),n}function fK(e,t,n){var r;return e<t.head.data.length?(r=t.head.data.slice(0,e),t.head.data=t.head.data.slice(e)):e===t.head.data.length?r=t.shift():r=n?hK(e,t):gK(e,t),r}function hK(e,t){var n=t.head,r=1,a=n.data;for(e-=a.length;n=n.next;){var o=n.data,i=e>o.length?o.length:e;if(i===o.length?a+=o:a+=o.slice(0,e),e-=i,e===0){i===o.length?(++r,n.next?t.head=n.next:t.head=t.tail=null):(t.head=n,n.data=o.slice(i));break}++r}return t.length-=r,a}function gK(e,t){var n=Buffer.allocUnsafe(e),r=t.head,a=1;for(r.data.copy(n),e-=r.data.length;r=r.next;){var o=r.data,i=e>o.length?o.length:e;if(o.copy(n,n.length-e,0,i),e-=i,e===0){i===o.length?(++a,r.next?t.head=r.next:t.head=t.tail=null):(t.head=r,r.data=o.slice(i));break}++a}return t.length-=a,n}function mg(e){var t=e._readableState;if(t.length>0)throw new Error('"endReadable()" called on non-empty stream');t.endEmitted||(t.ended=!0,nn(yK,t,e))}function yK(e,t){!e.endEmitted&&e.length===0&&(e.endEmitted=!0,t.readable=!1,t.emit("end"))}function bK(e,t){for(var n=0,r=e.length;n<r;n++)t(e[n],n)}function mF(e,t){for(var n=0,r=e.length;n<r;n++)if(e[n]===t)return n;return-1}var tt,iF,fg=b(()=>{"use strict";d();Kr();Fa();aF();oF();fu();Ta();Et.ReadableState=uF;tt=eF("stream");Ft(Et,jn);s(nK,"prependListener");s(rK,"listenerCount");s(uF,"ReadableState");s(Et,"Readable");Et.prototype.push=function(e,t){var n=this._readableState;return!n.objectMode&&typeof e=="string"&&(t=t||n.defaultEncoding,t!==n.encoding&&(e=Buffer.from(e,t),t="")),lF(this,n,e,t,!1)};Et.prototype.unshift=function(e){var t=this._readableState;return lF(this,t,e,"",!0)};Et.prototype.isPaused=function(){return this._readableState.flowing===!1};s(lF,"readableAddChunk");s(aK,"needMoreData");Et.prototype.setEncoding=function(e){return this._readableState.decoder=new $i(e),this._readableState.encoding=e,this};iF=8388608;s(oK,"computeNewHighWaterMark");s(sF,"howMuchToRead");Et.prototype.read=function(e){tt("read",e),e=parseInt(e,10);var t=this._readableState,n=e;if(e!==0&&(t.emittedReadable=!1),e===0&&t.needReadable&&(t.length>=t.highWaterMark||t.ended))return tt("read: emitReadable",t.length,t.ended),t.length===0&&t.ended?mg(this):lp(this),null;if(e=sF(e,t),e===0&&t.ended)return t.length===0&&mg(this),null;var r=t.needReadable;tt("need readable",r),(t.length===0||t.length-e<t.highWaterMark)&&(r=!0,tt("length less than watermark",r)),t.ended||t.reading?(r=!1,tt("reading or ended",r)):r&&(tt("do read"),t.reading=!0,t.sync=!0,t.length===0&&(t.needReadable=!0),this._read(t.highWaterMark),t.sync=!1,t.reading||(e=sF(n,t)));var a;return e>0?a=dF(e,t):a=null,a===null?(t.needReadable=!0,e=0):t.length-=e,t.length===0&&(t.ended||(t.needReadable=!0),n!==e&&t.ended&&mg(this)),a!==null&&this.emit("data",a),a};s(iK,"chunkInvalid");s(sK,"onEofChunk");s(lp,"emitReadable");s(cF,"emitReadable_");s(cK,"maybeReadMore");s(uK,"maybeReadMore_");Et.prototype._read=function(e){this.emit("error",new Error("not implemented"))};Et.prototype.pipe=function(e,t){var n=this,r=this._readableState;switch(r.pipesCount){case 0:r.pipes=e;break;case 1:r.pipes=[r.pipes,e];break;default:r.pipes.push(e);break}r.pipesCount+=1,tt("pipe count=%d opts=%j",r.pipesCount,t);var a=!t||t.end!==!1,o=a?c:m;r.endEmitted?nn(o):n.once("end",o),e.on("unpipe",i);function i(E){tt("onunpipe"),E===n&&m()}s(i,"onunpipe");function c(){tt("onend"),e.end()}s(c,"onend");var u=lK(n);e.on("drain",u);var l=!1;function m(){tt("cleanup"),e.removeListener("close",y),e.removeListener("finish",v),e.removeListener("drain",u),e.removeListener("error",f),e.removeListener("unpipe",i),n.removeListener("end",c),n.removeListener("end",m),n.removeListener("data",h),l=!0,r.awaitDrain&&(!e._writableState||e._writableState.needDrain)&&u()}s(m,"cleanup");var p=!1;n.on("data",h);function h(E){tt("ondata"),p=!1;var S=e.write(E);S===!1&&!p&&((r.pipesCount===1&&r.pipes===e||r.pipesCount>1&&mF(r.pipes,e)!==-1)&&!l&&(tt("false write response, pause",n._readableState.awaitDrain),n._readableState.awaitDrain++,p=!0),n.pause())}s(h,"ondata");function f(E){tt("onerror",E),D(),e.removeListener("error",f),rK(e,"error")===0&&e.emit("error",E)}s(f,"onerror"),nK(e,"error",f);function y(){e.removeListener("finish",v),D()}s(y,"onclose"),e.once("close",y);function v(){tt("onfinish"),e.removeListener("close",y),D()}s(v,"onfinish"),e.once("finish",v);function D(){tt("unpipe"),n.unpipe(e)}return s(D,"unpipe"),e.emit("pipe",n),r.flowing||(tt("pipe resume"),n.resume()),e};s(lK,"pipeOnDrain");Et.prototype.unpipe=function(e){var t=this._readableState;if(t.pipesCount===0)return this;if(t.pipesCount===1)return e&&e!==t.pipes?this:(e||(e=t.pipes),t.pipes=null,t.pipesCount=0,t.flowing=!1,e&&e.emit("unpipe",this),this);if(!e){var n=t.pipes,r=t.pipesCount;t.pipes=null,t.pipesCount=0,t.flowing=!1;for(var a=0;a<r;a++)n[a].emit("unpipe",this);return this}var o=mF(t.pipes,e);return o===-1?this:(t.pipes.splice(o,1),t.pipesCount-=1,t.pipesCount===1&&(t.pipes=t.pipes[0]),e.emit("unpipe",this),this)};Et.prototype.on=function(e,t){var n=jn.prototype.on.call(this,e,t);if(e==="data")this._readableState.flowing!==!1&&this.resume();else if(e==="readable"){var r=this._readableState;!r.endEmitted&&!r.readableListening&&(r.readableListening=r.needReadable=!0,r.emittedReadable=!1,r.reading?r.length&&lp(this,r):nn(dK,this))}return n};Et.prototype.addListener=Et.prototype.on;s(dK,"nReadingNextTick");Et.prototype.resume=function(){var e=this._readableState;return e.flowing||(tt("resume"),e.flowing=!0,mK(this,e)),this};s(mK,"resume");s(pK,"resume_");Et.prototype.pause=function(){return tt("call pause flowing=%j",this._readableState.flowing),this._readableState.flowing!==!1&&(tt("pause"),this._readableState.flowing=!1,this.emit("pause")),this};s(pg,"flow");Et.prototype.wrap=function(e){var t=this._readableState,n=!1,r=this;e.on("end",function(){if(tt("wrapped end"),t.decoder&&!t.ended){var i=t.decoder.end();i&&i.length&&r.push(i)}r.push(null)}),e.on("data",function(i){if(tt("wrapped data"),t.decoder&&(i=t.decoder.write(i)),!(t.objectMode&&i==null)&&!(!t.objectMode&&(!i||!i.length))){var c=r.push(i);c||(n=!0,e.pause())}});for(var a in e)this[a]===void 0&&typeof e[a]=="function"&&(this[a]=function(i){return function(){return e[i].apply(e,arguments)}}(a));var o=["error","close","destroy","pause","resume"];return bK(o,function(i){e.on(i,r.emit.bind(r,i))}),r._read=function(i){tt("wrapped _read",i),n&&(n=!1,e.resume())},r};Et._fromList=dF;s(dF,"fromList");s(fK,"fromListPartial");s(hK,"copyFromBufferString");s(gK,"copyFromBuffer");s(mg,"endReadable");s(yK,"endReadableNT");s(bK,"forEach");s(mF,"indexOf")});function vK(){}function wK(e,t,n){this.chunk=e,this.encoding=t,this.callback=n,this.next=null}function gg(e,t){Object.defineProperty(this,"buffer",{get:cg(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")}),e=e||{},this.objectMode=!!e.objectMode,t instanceof on&&(this.objectMode=this.objectMode||!!e.writableObjectMode);var n=e.highWaterMark,r=this.objectMode?16:16*1024;this.highWaterMark=n||n===0?n:r,this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var a=e.decodeStrings===!1;this.decodeStrings=!a,this.defaultEncoding=e.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(o){CK(t,o)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.bufferedRequestCount=0,this.corkedRequestsFree=new bF(this)}function Yt(e){if(!(this instanceof Yt)&&!(this instanceof on))return new Yt(e);this._writableState=new gg(e,this),this.writable=!0,e&&(typeof e.write=="function"&&(this._write=e.write),typeof e.writev=="function"&&(this._writev=e.writev)),Be.call(this)}function DK(e,t){var n=new Error("write after end");e.emit("error",n),nn(t,n)}function EK(e,t,n,r){var a=!0,o=!1;return n===null?o=new TypeError("May not write null values to stream"):!U.isBuffer(n)&&typeof n!="string"&&n!==void 0&&!t.objectMode&&(o=new TypeError("Invalid non-string/buffer chunk")),o&&(e.emit("error",o),nn(r,o),a=!1),a}function xK(e,t,n){return!e.objectMode&&e.decodeStrings!==!1&&typeof t=="string"&&(t=U.from(t,n)),t}function TK(e,t,n,r,a){n=xK(t,n,r),U.isBuffer(n)&&(r="buffer");var o=t.objectMode?1:n.length;t.length+=o;var i=t.length<t.highWaterMark;if(i||(t.needDrain=!0),t.writing||t.corked){var c=t.lastBufferedRequest;t.lastBufferedRequest=new wK(n,r,a),c?c.next=t.lastBufferedRequest:t.bufferedRequest=t.lastBufferedRequest,t.bufferedRequestCount+=1}else hg(e,t,!1,o,n,r,a);return i}function hg(e,t,n,r,a,o,i){t.writelen=r,t.writecb=i,t.writing=!0,t.sync=!0,n?e._writev(a,t.onwrite):e._write(a,o,t.onwrite),t.sync=!1}function SK(e,t,n,r,a){--t.pendingcb,n?nn(a,r):a(r),e._writableState.errorEmitted=!0,e.emit("error",r)}function kK(e){e.writing=!1,e.writecb=null,e.length-=e.writelen,e.writelen=0}function CK(e,t){var n=e._writableState,r=n.sync,a=n.writecb;if(kK(n),t)SK(e,n,r,t,a);else{var o=gF(n);!o&&!n.corked&&!n.bufferProcessing&&n.bufferedRequest&&hF(e,n),r?nn(pF,e,n,o,a):pF(e,n,o,a)}}function pF(e,t,n,r){n||AK(e,t),t.pendingcb--,r(),yF(e,t)}function AK(e,t){t.length===0&&t.needDrain&&(t.needDrain=!1,e.emit("drain"))}function hF(e,t){t.bufferProcessing=!0;var n=t.bufferedRequest;if(e._writev&&n&&n.next){var r=t.bufferedRequestCount,a=new Array(r),o=t.corkedRequestsFree;o.entry=n;for(var i=0;n;)a[i]=n,n=n.next,i+=1;hg(e,t,!0,t.length,a,"",o.finish),t.pendingcb++,t.lastBufferedRequest=null,o.next?(t.corkedRequestsFree=o.next,o.next=null):t.corkedRequestsFree=new bF(t)}else{for(;n;){var c=n.chunk,u=n.encoding,l=n.callback,m=t.objectMode?1:c.length;if(hg(e,t,!1,m,c,u,l),n=n.next,t.writing)break}n===null&&(t.lastBufferedRequest=null)}t.bufferedRequestCount=0,t.bufferedRequest=n,t.bufferProcessing=!1}function gF(e){return e.ending&&e.length===0&&e.bufferedRequest===null&&!e.finished&&!e.writing}function fF(e,t){t.prefinished||(t.prefinished=!0,e.emit("prefinish"))}function yF(e,t){var n=gF(t);return n&&(t.pendingcb===0?(fF(e,t),t.finished=!0,e.emit("finish")):fF(e,t)),n}function _K(e,t,n){t.ending=!0,yF(e,t),n&&(t.finished?nn(n):e.once("finish",n)),t.ended=!0,e.writable=!1}function bF(e){var t=this;this.next=null,this.entry=null,this.finish=function(n){var r=t.entry;for(t.entry=null;r;){var a=r.callback;e.pendingcb--,a(n),r=r.next}e.corkedRequestsFree?e.corkedRequestsFree.next=t:e.corkedRequestsFree=t}}var yg=b(()=>{d();Fa();Ci();Kr();fu();Ta();Yt.WritableState=gg;Ft(Yt,Be);s(vK,"nop");s(wK,"WriteReq");s(gg,"WritableState");gg.prototype.getBuffer=s(function(){for(var t=this.bufferedRequest,n=[];t;)n.push(t),t=t.next;return n},"writableStateGetBuffer");s(Yt,"Writable");Yt.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe, not readable"))};s(DK,"writeAfterEnd");s(EK,"validChunk");Yt.prototype.write=function(e,t,n){var r=this._writableState,a=!1;return typeof t=="function"&&(n=t,t=null),U.isBuffer(e)?t="buffer":t||(t=r.defaultEncoding),typeof n!="function"&&(n=vK),r.ended?DK(this,n):EK(this,r,e,n)&&(r.pendingcb++,a=TK(this,r,e,t,n)),a};Yt.prototype.cork=function(){var e=this._writableState;e.corked++};Yt.prototype.uncork=function(){var e=this._writableState;e.corked&&(e.corked--,!e.writing&&!e.corked&&!e.finished&&!e.bufferProcessing&&e.bufferedRequest&&hF(this,e))};Yt.prototype.setDefaultEncoding=s(function(t){if(typeof t=="string"&&(t=t.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((t+"").toLowerCase())>-1))throw new TypeError("Unknown encoding: "+t);return this._writableState.defaultEncoding=t,this},"setDefaultEncoding");s(xK,"decodeChunk");s(TK,"writeOrBuffer");s(hg,"doWrite");s(SK,"onwriteError");s(kK,"onwriteStateUpdate");s(CK,"onwrite");s(pF,"afterWrite");s(AK,"onwriteDrain");s(hF,"clearBuffer");Yt.prototype._write=function(e,t,n){n(new Error("not implemented"))};Yt.prototype._writev=null;Yt.prototype.end=function(e,t,n){var r=this._writableState;typeof e=="function"?(n=e,e=null,t=null):typeof t=="function"&&(n=t,t=null),e!=null&&this.write(e,t),r.corked&&(r.corked=1,this.uncork()),!r.ending&&!r.finished&&_K(this,r,n)};s(gF,"needFinish");s(fF,"prefinish");s(yF,"finishMaybe");s(_K,"endWritable");s(bF,"CorkedRequest")});function on(e){if(!(this instanceof on))return new on(e);Et.call(this,e),Yt.call(this,e),e&&e.readable===!1&&(this.readable=!1),e&&e.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,e&&e.allowHalfOpen===!1&&(this.allowHalfOpen=!1),this.once("end",RK)}function RK(){this.allowHalfOpen||this._writableState.ended||nn(FK,this)}function FK(e){e.end()}var vF,mp,dp,fu=b(()=>{d();Fa();Ta();fg();yg();Ft(on,Et);vF=Object.keys(Yt.prototype);for(dp=0;dp<vF.length;dp++)mp=vF[dp],on.prototype[mp]||(on.prototype[mp]=Yt.prototype[mp]);s(on,"Duplex");s(RK,"onend");s(FK,"onEndNT")});function IK(e){this.afterTransform=function(t,n){return NK(e,t,n)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null,this.writeencoding=null}function NK(e,t,n){var r=e._transformState;r.transforming=!1;var a=r.writecb;if(!a)return e.emit("error",new Error("no writecb in Transform class"));r.writechunk=null,r.writecb=null,n!=null&&e.push(n),a(t);var o=e._readableState;o.reading=!1,(o.needReadable||o.length<o.highWaterMark)&&e._read(o.highWaterMark)}function hn(e){if(!(this instanceof hn))return new hn(e);on.call(this,e),this._transformState=new IK(this);var t=this;this._readableState.needReadable=!0,this._readableState.sync=!1,e&&(typeof e.transform=="function"&&(this._transform=e.transform),typeof e.flush=="function"&&(this._flush=e.flush)),this.once("prefinish",function(){typeof this._flush=="function"?this._flush(function(n){wF(t,n)}):wF(t)})}function wF(e,t){if(t)return e.emit("error",t);var n=e._writableState,r=e._transformState;if(n.length)throw new Error("Calling transform done when ws.length != 0");if(r.transforming)throw new Error("Calling transform done when still transforming");return e.push(null)}var bg=b(()=>{d();fu();Fa();Ft(hn,on);s(IK,"TransformState");s(NK,"afterTransform");s(hn,"Transform");hn.prototype.push=function(e,t){return this._transformState.needTransform=!1,on.prototype.push.call(this,e,t)};hn.prototype._transform=function(e,t,n){throw new Error("Not implemented")};hn.prototype._write=function(e,t,n){var r=this._transformState;if(r.writecb=n,r.writechunk=e,r.writeencoding=t,!r.transforming){var a=this._readableState;(r.needTransform||a.needReadable||a.length<a.highWaterMark)&&this._read(a.highWaterMark)}};hn.prototype._read=function(e){var t=this._transformState;t.writechunk!==null&&t.writecb&&!t.transforming?(t.transforming=!0,this._transform(t.writechunk,t.writeencoding,t.afterTransform)):t.needTransform=!0};s(wF,"done")});function Yi(e){if(!(this instanceof Yi))return new Yi(e);hn.call(this,e)}var DF=b(()=>{d();bg();Fa();Ft(Yi,hn);s(Yi,"PassThrough");Yi.prototype._transform=function(e,t,n){n(null,e)}});function Er(){jn.call(this)}var vg,wg=b(()=>{d();Kr();Fa();fu();fg();yg();bg();DF();Ft(Er,jn);Er.Readable=Et;Er.Writable=Yt;Er.Duplex=on;Er.Transform=hn;Er.PassThrough=Yi;Er.Stream=Er;vg=Er;s(Er,"Stream");Er.prototype.pipe=function(e,t){var n=this;function r(m){e.writable&&e.write(m)===!1&&n.pause&&n.pause()}s(r,"ondata"),n.on("data",r);function a(){n.readable&&n.resume&&n.resume()}s(a,"ondrain"),e.on("drain",a),!e._isStdio&&(!t||t.end!==!1)&&(n.on("end",i),n.on("close",c));var o=!1;function i(){o||(o=!0,e.end())}s(i,"onend");function c(){o||(o=!0,typeof e.destroy=="function"&&e.destroy())}s(c,"onclose");function u(m){if(l(),jn.listenerCount(this,"error")===0)throw m}s(u,"onerror"),n.on("error",u),e.on("error",u);function l(){n.removeListener("data",r),e.removeListener("drain",a),n.removeListener("end",i),n.removeListener("close",c),n.removeListener("error",u),e.removeListener("error",u),n.removeListener("end",l),n.removeListener("close",l),e.removeListener("close",l)}return s(l,"cleanup"),n.on("end",l),n.on("close",l),e.on("close",l),e.emit("pipe",n),e}});var ye,gn=b(()=>{"use strict";d();ye=class e{static{s(this,"BaseNode")}constructor(t){this._id=t,this._isMainDocument=!1,this._dependents=[],this._dependencies=[]}get id(){return this._id}get type(){throw new Error("Unimplemented")}get startTime(){throw new Error("Unimplemented")}get endTime(){throw new Error("Unimplemented")}setIsMainDocument(t){this._isMainDocument=t}isMainDocument(){return this._isMainDocument}getDependents(){return this._dependents.slice()}getNumberOfDependents(){return this._dependents.length}getDependencies(){return this._dependencies.slice()}getNumberOfDependencies(){return this._dependencies.length}getRootNode(){let t=this;for(;t._dependencies.length;)t=t._dependencies[0];return t}addDependent(t){t.addDependency(this)}addDependency(t){if(t===this)throw new Error("Cannot add dependency on itself");this._dependencies.includes(t)||(t._dependents.push(this),this._dependencies.push(t))}removeDependent(t){t.removeDependency(this)}removeDependency(t){if(!this._dependencies.includes(t))return;let n=t._dependents.indexOf(this);t._dependents.splice(n,1),this._dependencies.splice(this._dependencies.indexOf(t),1)}removeAllDependencies(){for(let t of this._dependencies.slice())this.removeDependency(t)}isDependentOn(t){let n=!1;return this.traverse(r=>{n||(n=r===t)},r=>n?[]:r.getDependencies()),n}cloneWithoutRelationships(){let t=new e(this.id);return t.setIsMainDocument(this._isMainDocument),t}cloneWithRelationships(t){let n=this.getRootNode(),r=new Map;n.traverse(o=>{if(!r.has(o.id)){if(t===void 0){r.set(o.id,o.cloneWithoutRelationships());return}t(o)&&o.traverse(i=>r.set(i.id,i.cloneWithoutRelationships()),i=>i._dependencies.filter(c=>!r.has(c.id)))}}),n.traverse(o=>{let i=r.get(o.id);if(i)for(let c of o._dependencies){let u=r.get(c.id);if(!u)throw new Error("Dependency somehow not cloned");i.addDependency(u)}});let a=r.get(this.id);if(!a)throw new Error("Cloned graph missing node");return a}traverse(t,n){for(let{node:r,traversalPath:a}of this.traverseGenerator(n))t(r,a)}*traverseGenerator(t){t||(t=s(a=>a.getDependents(),"getNextNodes"));let n=[[this]],r=new Set([this.id]);for(;n.length;){let a=n.shift(),o=a[0];yield{node:o,traversalPath:a};for(let i of t(o))r.has(i.id)||(r.add(i.id),n.push([i,...a]))}}static hasCycle(t,n="both"){if(n==="both")return e.hasCycle(t,"dependents")||e.hasCycle(t,"dependencies");let r=new Set,a=[],o=[t],i=new Map([[t,0]]);for(;o.length;){let c=o.pop();if(a.includes(c))return!0;if(r.has(c))continue;for(;a.length>i.get(c);)a.pop();r.add(c),a.push(c);let u=n==="dependents"?c._dependents:c._dependencies;for(let l of u)o.includes(l)||(o.push(l),i.set(l,a.length))}return!1}canDependOn(t){return t.startTime<=this.startTime}};ye.TYPES={NETWORK:"network",CPU:"cpu"}});var Ki,Dg=b(()=>{"use strict";d();Ki=class e{static{s(this,"TcpConnection")}constructor(t,n,r=0,a=!0,o=!1){this._warmed=!1,this._ssl=a,this._h2=o,this._rtt=t,this._throughput=n,this._serverLatency=r,this._congestionWindow=10,this._h2OverflowBytesDownloaded=0}static maximumSaturatedConnections(t,n){let i=1e3/t*1460*8;return Math.floor(n/i)}_computeMaximumCongestionWindowInSegments(){let t=this._throughput/8,n=this._rtt/1e3,r=t*n;return Math.floor(r/1460)}setThroughput(t){this._throughput=t}setCongestionWindow(t){this._congestionWindow=t}setWarmed(t){this._warmed=t}isWarm(){return this._warmed}isH2(){return this._h2}get congestionWindow(){return this._congestionWindow}setH2OverflowBytesDownloaded(t){this._h2&&(this._h2OverflowBytesDownloaded=t)}clone(){return Object.assign(new e(this._rtt,this._throughput),this)}simulateDownloadUntil(t,n){let{timeAlreadyElapsed:r=0,maximumTimeToElapse:a=1/0,dnsResolutionTime:o=0}=n||{};this._warmed&&this._h2&&(t-=this._h2OverflowBytesDownloaded);let i=this._rtt,c=i/2,u=this._computeMaximumCongestionWindowInSegments(),l=c;this._warmed||(l=o+c+c+c+(this._ssl?i:0));let m=Math.ceil(l/i),p=l+this._serverLatency+c;this._warmed&&this._h2&&(p=0);let h=Math.max(p-r,0),f=a-h,y=Math.min(this._congestionWindow,u),v=0;h>0?v=y*1460:m=0;let D=0,E=t-v;for(;E>0&&D<=f;){m++,D+=i,y=Math.max(Math.min(u,y*2),1);let z=y*1460;v+=z,E-=z}let S=h+D,k=this._h2?Math.max(v-t,0):0,C=Math.max(Math.min(v,t),0),R;return this._warmed?this._h2?R={timeToFirstByte:p}:R={connectionTime:l,timeToFirstByte:p}:R={dnsResolutionTime:o,connectionTime:l-o,sslTime:this._ssl?i:void 0,timeToFirstByte:p},{roundTrips:m,timeElapsed:S,bytesDownloaded:C,extraBytesDownloaded:k,congestionWindow:y,connectionTiming:R}}}});function MK(e,t){return e.endsWith(t)?e.length===t.length||e[e.length-t.length-1]===".":!1}function LK(e,t){let n=e.length-t.length-2,r=e.lastIndexOf(".",n);return r===-1?e:e.slice(r+1)}function Eg(e,t,n){if(n.validHosts!==null){let a=n.validHosts;for(let o of a)if(MK(t,o))return o}let r=0;if(t.startsWith("."))for(;r<t.length&&t[r]===".";)r+=1;return e.length===t.length-r?null:LK(t,e)}var EF=b(()=>{d();s(MK,"shareSameDomainSuffix");s(LK,"extractDomainWithSuffix");s(Eg,"getDomain")});function xg(e,t){return e.slice(0,-t.length-1)}var xF=b(()=>{d();s(xg,"getDomainWithoutSuffix")});function pp(e,t){let n=0,r=e.length,a=!1;if(!t){if(e.startsWith("data:"))return null;for(;n<e.length&&e.charCodeAt(n)<=32;)n+=1;for(;r>n+1&&e.charCodeAt(r-1)<=32;)r-=1;if(e.charCodeAt(n)===47&&e.charCodeAt(n+1)===47)n+=2;else{let l=e.indexOf(":/",n);if(l!==-1){let m=l-n,p=e.charCodeAt(n),h=e.charCodeAt(n+1),f=e.charCodeAt(n+2),y=e.charCodeAt(n+3),v=e.charCodeAt(n+4);if(!(m===5&&p===104&&h===116&&f===116&&y===112&&v===115)){if(!(m===4&&p===104&&h===116&&f===116&&y===112)){if(!(m===3&&p===119&&h===115&&f===115)){if(!(m===2&&p===119&&h===115))for(let D=n;D<l;D+=1){let E=e.charCodeAt(D)|32;if(!(E>=97&&E<=122||E>=48&&E<=57||E===46||E===45||E===43))return null}}}}for(n=l+2;e.charCodeAt(n)===47;)n+=1}}let i=-1,c=-1,u=-1;for(let l=n;l<r;l+=1){let m=e.charCodeAt(l);if(m===35||m===47||m===63){r=l;break}else m===64?i=l:m===93?c=l:m===58?u=l:m>=65&&m<=90&&(a=!0)}if(i!==-1&&i>n&&i<r&&(n=i+1),e.charCodeAt(n)===91)return c!==-1?e.slice(n+1,c).toLowerCase():null;u!==-1&&u>n&&u<r&&(r=u)}for(;r>n+1&&e.charCodeAt(r-1)===46;)r-=1;let o=n!==0||r!==e.length?e.slice(n,r):e;return a?o.toLowerCase():o}var TF=b(()=>{d();s(pp,"extractHostname")});function PK(e){if(e.length<7||e.length>15)return!1;let t=0;for(let n=0;n<e.length;n+=1){let r=e.charCodeAt(n);if(r===46)t+=1;else if(r<48||r>57)return!1}return t===3&&e.charCodeAt(0)!==46&&e.charCodeAt(e.length-1)!==46}function OK(e){if(e.length<3)return!1;let t=e.startsWith("[")?1:0,n=e.length;if(e[n-1]==="]"&&(n-=1),n-t>39)return!1;let r=!1;for(;t<n;t+=1){let a=e.charCodeAt(t);if(a===58)r=!0;else if(!(a>=48&&a<=57||a>=97&&a<=102||a>=65&&a<=90))return!1}return r}function Tg(e){return OK(e)||PK(e)}var SF=b(()=>{d();s(PK,"isProbablyIpv4");s(OK,"isProbablyIpv6");s(Tg,"isIp")});function kF(e){return e>=97&&e<=122||e>=48&&e<=57||e>127}function fp(e){if(e.length>255||e.length===0||!kF(e.charCodeAt(0))&&e.charCodeAt(0)!==46&&e.charCodeAt(0)!==95)return!1;let t=-1,n=-1,r=e.length;for(let a=0;a<r;a+=1){let o=e.charCodeAt(a);if(o===46){if(a-t>64||n===46||n===45||n===95)return!1;t=a}else if(!(kF(o)||o===45||o===95))return!1;n=o}return r-t-1<=63&&n!==45}var CF=b(()=>{d();s(kF,"isValidAscii");s(fp,"default")});function AF({allowIcannDomains:e=!0,allowPrivateDomains:t=!1,detectIp:n=!0,extractHostname:r=!0,mixedInputs:a=!0,validHosts:o=null,validateHostname:i=!0}){return{allowIcannDomains:e,allowPrivateDomains:t,detectIp:n,extractHostname:r,mixedInputs:a,validHosts:o,validateHostname:i}}function Sg(e){return e===void 0?BK:AF(e)}var BK,kg=b(()=>{d();s(AF,"setDefaultsImpl");BK=AF({});s(Sg,"setDefaults")});function Cg(e,t){return t.length===e.length?"":e.slice(0,-t.length-1)}var _F=b(()=>{d();s(Cg,"getSubdomain")});function Ag(){return{domain:null,domainWithoutSuffix:null,hostname:null,isIcann:null,isIp:null,isPrivate:null,publicSuffix:null,subdomain:null}}function _g(e){e.domain=null,e.domainWithoutSuffix=null,e.hostname=null,e.isIcann=null,e.isIp=null,e.isPrivate=null,e.publicSuffix=null,e.subdomain=null}function Rg(e,t,n,r,a){let o=Sg(r);return typeof e!="string"||(o.extractHostname?o.mixedInputs?a.hostname=pp(e,fp(e)):a.hostname=pp(e,!1):a.hostname=e,t===0||a.hostname===null)||o.detectIp&&(a.isIp=Tg(a.hostname),a.isIp)?a:o.validateHostname&&o.extractHostname&&!fp(a.hostname)?(a.hostname=null,a):(n(a.hostname,o,a),t===2||a.publicSuffix===null||(a.domain=Eg(a.publicSuffix,a.hostname,o),t===3||a.domain===null)||(a.subdomain=Cg(a.hostname,a.domain),t===4)||(a.domainWithoutSuffix=xg(a.domain,a.publicSuffix)),a)}var RF=b(()=>{d();EF();xF();TF();SF();CF();kg();_F();s(Ag,"getEmptyResult");s(_g,"resetResult");s(Rg,"parseImpl")});function hp(e,t,n){if(!t.allowPrivateDomains&&e.length>3){let r=e.length-1,a=e.charCodeAt(r),o=e.charCodeAt(r-1),i=e.charCodeAt(r-2),c=e.charCodeAt(r-3);if(a===109&&o===111&&i===99&&c===46)return n.isIcann=!0,n.isPrivate=!1,n.publicSuffix="com",!0;if(a===103&&o===114&&i===111&&c===46)return n.isIcann=!0,n.isPrivate=!1,n.publicSuffix="org",!0;if(a===117&&o===100&&i===101&&c===46)return n.isIcann=!0,n.isPrivate=!1,n.publicSuffix="edu",!0;if(a===118&&o===111&&i===103&&c===46)return n.isIcann=!0,n.isPrivate=!1,n.publicSuffix="gov",!0;if(a===116&&o===101&&i===110&&c===46)return n.isIcann=!0,n.isPrivate=!1,n.publicSuffix="net",!0;if(a===101&&o===100&&i===46)return n.isIcann=!0,n.isPrivate=!1,n.publicSuffix="de",!0}return!1}var FF=b(()=>{d();s(hp,"default")});var Fg=b(()=>{d();RF();FF();kg()});var IF,NF,MF=b(()=>{d();IF=function(){let e=[1,{}],t=[0,{city:e}];return[0,{ck:[0,{www:e}],jp:[0,{kawasaki:t,kitakyushu:t,kobe:t,nagoya:t,sapporo:t,sendai:t,yokohama:t}]}]}(),NF=function(){let e=[1,{}],t=[1,{com:e,edu:e,gov:e,net:e,mil:e,org:e}],n=[1,{gov:e,com:e,org:e,net:e,edu:e}],r=[1,{gov:e}],a=[1,{com:e}],o=[0,{"*":e}],i=[1,{com:e,edu:e,net:e,org:e}],c=[1,{co:e,net:e,org:e}],u=[1,{co:e,com:e,edu:e,gov:e,net:e,org:e}],l=[1,{com:e,org:e,net:e,edu:e,sch:e,gov:e,mil:e,name:e}],m=[1,{edu:e,biz:e,net:e,org:e,gov:e,info:e,com:e}],p=[1,{gs:e}],h=[0,{nes:e}],f=[1,{k12:e,cc:e,lib:e}],y=[1,{cc:e}],v=[1,{cc:e,lib:e}];return[0,{ac:t,ad:[1,{nom:e}],ae:[1,{co:e,net:e,org:e,sch:e,ac:e,gov:e,mil:e}],aero:[1,{"accident-investigation":e,"accident-prevention":e,aerobatic:e,aeroclub:e,aerodrome:e,agents:e,aircraft:e,airline:e,airport:e,"air-surveillance":e,airtraffic:e,"air-traffic-control":e,ambulance:e,amusement:e,association:e,author:e,ballooning:e,broker:e,caa:e,cargo:e,catering:e,certification:e,championship:e,charter:e,civilaviation:e,club:e,conference:e,consultant:e,consulting:e,control:e,council:e,crew:e,design:e,dgca:e,educator:e,emergency:e,engine:e,engineer:e,entertainment:e,equipment:e,exchange:e,express:e,federation:e,flight:e,fuel:e,gliding:e,government:e,groundhandling:e,group:e,hanggliding:e,homebuilt:e,insurance:e,journal:e,journalist:e,leasing:e,logistics:e,magazine:e,maintenance:e,media:e,microlight:e,modelling:e,navigation:e,parachuting:e,paragliding:e,"passenger-association":e,pilot:e,press:e,production:e,recreation:e,repbody:e,res:e,research:e,rotorcraft:e,safety:e,scientist:e,services:e,show:e,skydiving:e,software:e,student:e,trader:e,trading:e,trainer:e,union:e,workinggroup:e,works:e}],af:n,ag:[1,{com:e,org:e,net:e,co:e,nom:e}],ai:[1,{off:e,com:e,net:e,org:e}],al:t,am:[1,{co:e,com:e,commune:e,net:e,org:e}],ao:[1,{ed:e,gv:e,og:e,co:e,pb:e,it:e}],aq:e,ar:[1,{bet:e,com:e,coop:e,edu:e,gob:e,gov:e,int:e,mil:e,musica:e,mutual:e,net:e,org:e,senasa:e,tur:e}],arpa:[1,{e164:e,"in-addr":e,ip6:e,iris:e,uri:e,urn:e}],as:r,asia:e,at:[1,{ac:[1,{sth:e}],co:e,gv:e,or:e}],au:[1,{com:e,net:e,org:e,edu:[1,{act:e,catholic:e,nsw:[1,{schools:e}],nt:e,qld:e,sa:e,tas:e,vic:e,wa:e}],gov:[1,{qld:e,sa:e,tas:e,vic:e,wa:e}],asn:e,id:e,info:e,conf:e,oz:e,act:e,nsw:e,nt:e,qld:e,sa:e,tas:e,vic:e,wa:e}],aw:a,ax:e,az:[1,{com:e,net:e,int:e,gov:e,org:e,edu:e,info:e,pp:e,mil:e,name:e,pro:e,biz:e}],ba:t,bb:[1,{biz:e,co:e,com:e,edu:e,gov:e,info:e,net:e,org:e,store:e,tv:e}],bd:o,be:[1,{ac:e}],bf:r,bg:[1,{0:e,1:e,2:e,3:e,4:e,5:e,6:e,7:e,8:e,9:e,a:e,b:e,c:e,d:e,e,f:e,g:e,h:e,i:e,j:e,k:e,l:e,m:e,n:e,o:e,p:e,q:e,r:e,s:e,t:e,u:e,v:e,w:e,x:e,y:e,z:e}],bh:n,bi:[1,{co:e,com:e,edu:e,or:e,org:e}],biz:e,bj:[1,{africa:e,agro:e,architectes:e,assur:e,avocats:e,co:e,com:e,eco:e,econo:e,edu:e,info:e,loisirs:e,money:e,net:e,org:e,ote:e,resto:e,restaurant:e,tourism:e,univ:e}],bm:n,bn:n,bo:[1,{com:e,edu:e,gob:e,int:e,org:e,net:e,mil:e,tv:e,web:e,academia:e,agro:e,arte:e,blog:e,bolivia:e,ciencia:e,cooperativa:e,democracia:e,deporte:e,ecologia:e,economia:e,empresa:e,indigena:e,industria:e,info:e,medicina:e,movimiento:e,musica:e,natural:e,nombre:e,noticias:e,patria:e,politica:e,profesional:e,plurinacional:e,pueblo:e,revista:e,salud:e,tecnologia:e,tksat:e,transporte:e,wiki:e}],br:[1,{"9guacu":e,abc:e,adm:e,adv:e,agr:e,aju:e,am:e,anani:e,aparecida:e,app:e,arq:e,art:e,ato:e,b:e,barueri:e,belem:e,bhz:e,bib:e,bio:e,blog:e,bmd:e,boavista:e,bsb:e,campinagrande:e,campinas:e,caxias:e,cim:e,cng:e,cnt:e,com:e,contagem:e,coop:e,coz:e,cri:e,cuiaba:e,curitiba:e,def:e,des:e,det:e,dev:e,ecn:e,eco:e,edu:e,emp:e,enf:e,eng:e,esp:e,etc:e,eti:e,far:e,feira:e,flog:e,floripa:e,fm:e,fnd:e,fortal:e,fot:e,foz:e,fst:e,g12:e,geo:e,ggf:e,goiania:e,gov:[1,{ac:e,al:e,am:e,ap:e,ba:e,ce:e,df:e,es:e,go:e,ma:e,mg:e,ms:e,mt:e,pa:e,pb:e,pe:e,pi:e,pr:e,rj:e,rn:e,ro:e,rr:e,rs:e,sc:e,se:e,sp:e,to:e}],gru:e,imb:e,ind:e,inf:e,jab:e,jampa:e,jdf:e,joinville:e,jor:e,jus:e,leg:e,lel:e,log:e,londrina:e,macapa:e,maceio:e,manaus:e,maringa:e,mat:e,med:e,mil:e,morena:e,mp:e,mus:e,natal:e,net:e,niteroi:e,nom:o,not:e,ntr:e,odo:e,ong:e,org:e,osasco:e,palmas:e,poa:e,ppg:e,pro:e,psc:e,psi:e,pvh:e,qsl:e,radio:e,rec:e,recife:e,rep:e,ribeirao:e,rio:e,riobranco:e,riopreto:e,salvador:e,sampa:e,santamaria:e,santoandre:e,saobernardo:e,saogonca:e,seg:e,sjc:e,slg:e,slz:e,sorocaba:e,srv:e,taxi:e,tc:e,tec:e,teo:e,the:e,tmp:e,trd:e,tur:e,tv:e,udi:e,vet:e,vix:e,vlog:e,wiki:e,zlg:e}],bs:n,bt:n,bv:e,bw:[1,{co:e,org:e}],by:[1,{gov:e,mil:e,com:e,of:e}],bz:n,ca:[1,{ab:e,bc:e,mb:e,nb:e,nf:e,nl:e,ns:e,nt:e,nu:e,on:e,pe:e,qc:e,sk:e,yk:e,gc:e}],cat:e,cc:e,cd:r,cf:e,cg:e,ch:e,ci:[1,{org:e,or:e,com:e,co:e,edu:e,ed:e,ac:e,net:e,go:e,asso:e,"xn--aroport-bya":e,aéroport:e,int:e,presse:e,md:e,gouv:e}],ck:o,cl:[1,{co:e,gob:e,gov:e,mil:e}],cm:[1,{co:e,com:e,gov:e,net:e}],cn:[1,{ac:e,com:e,edu:e,gov:e,net:e,org:e,mil:e,"xn--55qx5d":e,公司:e,"xn--io0a7i":e,网络:e,"xn--od0alg":e,網絡:e,ah:e,bj:e,cq:e,fj:e,gd:e,gs:e,gz:e,gx:e,ha:e,hb:e,he:e,hi:e,hl:e,hn:e,jl:e,js:e,jx:e,ln:e,nm:e,nx:e,qh:e,sc:e,sd:e,sh:e,sn:e,sx:e,tj:e,xj:e,xz:e,yn:e,zj:e,hk:e,mo:e,tw:e}],co:[1,{arts:e,com:e,edu:e,firm:e,gov:e,info:e,int:e,mil:e,net:e,nom:e,org:e,rec:e,web:e}],com:e,coop:e,cr:[1,{ac:e,co:e,ed:e,fi:e,go:e,or:e,sa:e}],cu:[1,{com:e,edu:e,org:e,net:e,gov:e,inf:e}],cv:[1,{com:e,edu:e,int:e,nome:e,org:e}],cw:i,cx:r,cy:[1,{ac:e,biz:e,com:e,ekloges:e,gov:e,ltd:e,mil:e,net:e,org:e,press:e,pro:e,tm:e}],cz:e,de:e,dj:e,dk:e,dm:n,do:[1,{art:e,com:e,edu:e,gob:e,gov:e,mil:e,net:e,org:e,sld:e,web:e}],dz:[1,{art:e,asso:e,com:e,edu:e,gov:e,org:e,net:e,pol:e,soc:e,tm:e}],ec:[1,{com:e,info:e,net:e,fin:e,k12:e,med:e,pro:e,org:e,edu:e,gov:e,gob:e,mil:e}],edu:e,ee:[1,{edu:e,gov:e,riik:e,lib:e,med:e,com:e,pri:e,aip:e,org:e,fie:e}],eg:[1,{com:e,edu:e,eun:e,gov:e,mil:e,name:e,net:e,org:e,sci:e}],er:o,es:[1,{com:e,nom:e,org:e,gob:e,edu:e}],et:[1,{com:e,gov:e,org:e,edu:e,biz:e,name:e,info:e,net:e}],eu:e,fi:[1,{aland:e}],fj:[1,{ac:e,biz:e,com:e,gov:e,info:e,mil:e,name:e,net:e,org:e,pro:e}],fk:o,fm:i,fo:e,fr:[1,{asso:e,com:e,gouv:e,nom:e,prd:e,tm:e,avoues:e,cci:e,greta:e,"huissier-justice":e}],ga:e,gb:e,gd:[1,{edu:e,gov:e}],ge:[1,{com:e,edu:e,gov:e,org:e,mil:e,net:e,pvt:e}],gf:e,gg:c,gh:[1,{com:e,edu:e,gov:e,org:e,mil:e}],gi:[1,{com:e,ltd:e,gov:e,mod:e,edu:e,org:e}],gl:[1,{co:e,com:e,edu:e,net:e,org:e}],gm:e,gn:[1,{ac:e,com:e,edu:e,gov:e,org:e,net:e}],gov:e,gp:[1,{com:e,net:e,mobi:e,edu:e,org:e,asso:e}],gq:e,gr:n,gs:e,gt:[1,{com:e,edu:e,gob:e,ind:e,mil:e,net:e,org:e}],gu:[1,{com:e,edu:e,gov:e,guam:e,info:e,net:e,org:e,web:e}],gw:e,gy:u,hk:[1,{com:e,edu:e,gov:e,idv:e,net:e,org:e,"xn--55qx5d":e,公司:e,"xn--wcvs22d":e,教育:e,"xn--lcvr32d":e,敎育:e,"xn--mxtq1m":e,政府:e,"xn--gmqw5a":e,個人:e,"xn--ciqpn":e,个人:e,"xn--gmq050i":e,箇人:e,"xn--zf0avx":e,網络:e,"xn--io0a7i":e,网络:e,"xn--mk0axi":e,组織:e,"xn--od0alg":e,網絡:e,"xn--od0aq3b":e,网絡:e,"xn--tn0ag":e,组织:e,"xn--uc0atv":e,組織:e,"xn--uc0ay4a":e,組织:e}],hm:e,hn:[1,{com:e,edu:e,org:e,net:e,mil:e,gob:e}],hr:[1,{iz:e,from:e,name:e,com:e}],ht:[1,{com:e,shop:e,firm:e,info:e,adult:e,net:e,pro:e,org:e,med:e,art:e,coop:e,pol:e,asso:e,edu:e,rel:e,gouv:e,perso:e}],hu:[1,{2e3:e,co:e,info:e,org:e,priv:e,sport:e,tm:e,agrar:e,bolt:e,casino:e,city:e,erotica:e,erotika:e,film:e,forum:e,games:e,hotel:e,ingatlan:e,jogasz:e,konyvelo:e,lakas:e,media:e,news:e,reklam:e,sex:e,shop:e,suli:e,szex:e,tozsde:e,utazas:e,video:e}],id:[1,{ac:e,biz:e,co:e,desa:e,go:e,mil:e,my:e,net:e,or:e,ponpes:e,sch:e,web:e}],ie:r,il:[1,{ac:e,co:e,gov:e,idf:e,k12:e,muni:e,net:e,org:e}],"xn--4dbrk0ce":[1,{"xn--4dbgdty6c":e,"xn--5dbhl8d":e,"xn--8dbq2a":e,"xn--hebda8b":e}],ישראל:[1,{אקדמיה:e,ישוב:e,צהל:e,ממשל:e}],im:[1,{ac:e,co:[1,{ltd:e,plc:e}],com:e,net:e,org:e,tt:e,tv:e}],in:[1,{"5g":e,"6g":e,ac:e,ai:e,am:e,bihar:e,biz:e,business:e,ca:e,cn:e,co:e,com:e,coop:e,cs:e,delhi:e,dr:e,edu:e,er:e,firm:e,gen:e,gov:e,gujarat:e,ind:e,info:e,int:e,internet:e,io:e,me:e,mil:e,net:e,nic:e,org:e,pg:e,post:e,pro:e,res:e,travel:e,tv:e,uk:e,up:e,us:e}],info:e,int:[1,{eu:e}],io:a,iq:t,ir:[1,{ac:e,co:e,gov:e,id:e,net:e,org:e,sch:e,"xn--mgba3a4f16a":e,ایران:e,"xn--mgba3a4fra":e,ايران:e}],is:[1,{net:e,com:e,edu:e,gov:e,org:e,int:e}],it:[1,{gov:e,edu:e,abr:e,abruzzo:e,"aosta-valley":e,aostavalley:e,bas:e,basilicata:e,cal:e,calabria:e,cam:e,campania:e,"emilia-romagna":e,emiliaromagna:e,emr:e,"friuli-v-giulia":e,"friuli-ve-giulia":e,"friuli-vegiulia":e,"friuli-venezia-giulia":e,"friuli-veneziagiulia":e,"friuli-vgiulia":e,"friuliv-giulia":e,"friulive-giulia":e,friulivegiulia:e,"friulivenezia-giulia":e,friuliveneziagiulia:e,friulivgiulia:e,fvg:e,laz:e,lazio:e,lig:e,liguria:e,lom:e,lombardia:e,lombardy:e,lucania:e,mar:e,marche:e,mol:e,molise:e,piedmont:e,piemonte:e,pmn:e,pug:e,puglia:e,sar:e,sardegna:e,sardinia:e,sic:e,sicilia:e,sicily:e,taa:e,tos:e,toscana:e,"trentin-sud-tirol":e,"xn--trentin-sd-tirol-rzb":e,"trentin-süd-tirol":e,"trentin-sudtirol":e,"xn--trentin-sdtirol-7vb":e,"trentin-südtirol":e,"trentin-sued-tirol":e,"trentin-suedtirol":e,"trentino-a-adige":e,"trentino-aadige":e,"trentino-alto-adige":e,"trentino-altoadige":e,"trentino-s-tirol":e,"trentino-stirol":e,"trentino-sud-tirol":e,"xn--trentino-sd-tirol-c3b":e,"trentino-süd-tirol":e,"trentino-sudtirol":e,"xn--trentino-sdtirol-szb":e,"trentino-südtirol":e,"trentino-sued-tirol":e,"trentino-suedtirol":e,trentino:e,"trentinoa-adige":e,trentinoaadige:e,"trentinoalto-adige":e,trentinoaltoadige:e,"trentinos-tirol":e,trentinostirol:e,"trentinosud-tirol":e,"xn--trentinosd-tirol-rzb":e,"trentinosüd-tirol":e,trentinosudtirol:e,"xn--trentinosdtirol-7vb":e,trentinosüdtirol:e,"trentinosued-tirol":e,trentinosuedtirol:e,"trentinsud-tirol":e,"xn--trentinsd-tirol-6vb":e,"trentinsüd-tirol":e,trentinsudtirol:e,"xn--trentinsdtirol-nsb":e,trentinsüdtirol:e,"trentinsued-tirol":e,trentinsuedtirol:e,tuscany:e,umb:e,umbria:e,"val-d-aosta":e,"val-daosta":e,"vald-aosta":e,valdaosta:e,"valle-aosta":e,"valle-d-aosta":e,"valle-daosta":e,valleaosta:e,"valled-aosta":e,valledaosta:e,"vallee-aoste":e,"xn--valle-aoste-ebb":e,"vallée-aoste":e,"vallee-d-aoste":e,"xn--valle-d-aoste-ehb":e,"vallée-d-aoste":e,valleeaoste:e,"xn--valleaoste-e7a":e,valléeaoste:e,valleedaoste:e,"xn--valledaoste-ebb":e,valléedaoste:e,vao:e,vda:e,ven:e,veneto:e,ag:e,agrigento:e,al:e,alessandria:e,"alto-adige":e,altoadige:e,an:e,ancona:e,"andria-barletta-trani":e,"andria-trani-barletta":e,andriabarlettatrani:e,andriatranibarletta:e,ao:e,aosta:e,aoste:e,ap:e,aq:e,aquila:e,ar:e,arezzo:e,"ascoli-piceno":e,ascolipiceno:e,asti:e,at:e,av:e,avellino:e,ba:e,"balsan-sudtirol":e,"xn--balsan-sdtirol-nsb":e,"balsan-südtirol":e,"balsan-suedtirol":e,balsan:e,bari:e,"barletta-trani-andria":e,barlettatraniandria:e,belluno:e,benevento:e,bergamo:e,bg:e,bi:e,biella:e,bl:e,bn:e,bo:e,bologna:e,"bolzano-altoadige":e,bolzano:e,"bozen-sudtirol":e,"xn--bozen-sdtirol-2ob":e,"bozen-südtirol":e,"bozen-suedtirol":e,bozen:e,br:e,brescia:e,brindisi:e,bs:e,bt:e,"bulsan-sudtirol":e,"xn--bulsan-sdtirol-nsb":e,"bulsan-südtirol":e,"bulsan-suedtirol":e,bulsan:e,bz:e,ca:e,cagliari:e,caltanissetta:e,"campidano-medio":e,campidanomedio:e,campobasso:e,"carbonia-iglesias":e,carboniaiglesias:e,"carrara-massa":e,carraramassa:e,caserta:e,catania:e,catanzaro:e,cb:e,ce:e,"cesena-forli":e,"xn--cesena-forl-mcb":e,"cesena-forlì":e,cesenaforli:e,"xn--cesenaforl-i8a":e,cesenaforlì:e,ch:e,chieti:e,ci:e,cl:e,cn:e,co:e,como:e,cosenza:e,cr:e,cremona:e,crotone:e,cs:e,ct:e,cuneo:e,cz:e,"dell-ogliastra":e,dellogliastra:e,en:e,enna:e,fc:e,fe:e,fermo:e,ferrara:e,fg:e,fi:e,firenze:e,florence:e,fm:e,foggia:e,"forli-cesena":e,"xn--forl-cesena-fcb":e,"forlì-cesena":e,forlicesena:e,"xn--forlcesena-c8a":e,forlìcesena:e,fr:e,frosinone:e,ge:e,genoa:e,genova:e,go:e,gorizia:e,gr:e,grosseto:e,"iglesias-carbonia":e,iglesiascarbonia:e,im:e,imperia:e,is:e,isernia:e,kr:e,"la-spezia":e,laquila:e,laspezia:e,latina:e,lc:e,le:e,lecce:e,lecco:e,li:e,livorno:e,lo:e,lodi:e,lt:e,lu:e,lucca:e,macerata:e,mantova:e,"massa-carrara":e,massacarrara:e,matera:e,mb:e,mc:e,me:e,"medio-campidano":e,mediocampidano:e,messina:e,mi:e,milan:e,milano:e,mn:e,mo:e,modena:e,"monza-brianza":e,"monza-e-della-brianza":e,monza:e,monzabrianza:e,monzaebrianza:e,monzaedellabrianza:e,ms:e,mt:e,na:e,naples:e,napoli:e,no:e,novara:e,nu:e,nuoro:e,og:e,ogliastra:e,"olbia-tempio":e,olbiatempio:e,or:e,oristano:e,ot:e,pa:e,padova:e,padua:e,palermo:e,parma:e,pavia:e,pc:e,pd:e,pe:e,perugia:e,"pesaro-urbino":e,pesarourbino:e,pescara:e,pg:e,pi:e,piacenza:e,pisa:e,pistoia:e,pn:e,po:e,pordenone:e,potenza:e,pr:e,prato:e,pt:e,pu:e,pv:e,pz:e,ra:e,ragusa:e,ravenna:e,rc:e,re:e,"reggio-calabria":e,"reggio-emilia":e,reggiocalabria:e,reggioemilia:e,rg:e,ri:e,rieti:e,rimini:e,rm:e,rn:e,ro:e,roma:e,rome:e,rovigo:e,sa:e,salerno:e,sassari:e,savona:e,si:e,siena:e,siracusa:e,so:e,sondrio:e,sp:e,sr:e,ss:e,suedtirol:e,"xn--sdtirol-n2a":e,südtirol:e,sv:e,ta:e,taranto:e,te:e,"tempio-olbia":e,tempioolbia:e,teramo:e,terni:e,tn:e,to:e,torino:e,tp:e,tr:e,"trani-andria-barletta":e,"trani-barletta-andria":e,traniandriabarletta:e,tranibarlettaandria:e,trapani:e,trento:e,treviso:e,trieste:e,ts:e,turin:e,tv:e,ud:e,udine:e,"urbino-pesaro":e,urbinopesaro:e,va:e,varese:e,vb:e,vc:e,ve:e,venezia:e,venice:e,verbania:e,vercelli:e,verona:e,vi:e,"vibo-valentia":e,vibovalentia:e,vicenza:e,viterbo:e,vr:e,vs:e,vt:e,vv:e}],je:c,jm:o,jo:l,jobs:e,jp:[1,{ac:e,ad:e,co:e,ed:e,go:e,gr:e,lg:e,ne:e,or:e,aichi:[1,{aisai:e,ama:e,anjo:e,asuke:e,chiryu:e,chita:e,fuso:e,gamagori:e,handa:e,hazu:e,hekinan:e,higashiura:e,ichinomiya:e,inazawa:e,inuyama:e,isshiki:e,iwakura:e,kanie:e,kariya:e,kasugai:e,kira:e,kiyosu:e,komaki:e,konan:e,kota:e,mihama:e,miyoshi:e,nishio:e,nisshin:e,obu:e,oguchi:e,oharu:e,okazaki:e,owariasahi:e,seto:e,shikatsu:e,shinshiro:e,shitara:e,tahara:e,takahama:e,tobishima:e,toei:e,togo:e,tokai:e,tokoname:e,toyoake:e,toyohashi:e,toyokawa:e,toyone:e,toyota:e,tsushima:e,yatomi:e}],akita:[1,{akita:e,daisen:e,fujisato:e,gojome:e,hachirogata:e,happou:e,higashinaruse:e,honjo:e,honjyo:e,ikawa:e,kamikoani:e,kamioka:e,katagami:e,kazuno:e,kitaakita:e,kosaka:e,kyowa:e,misato:e,mitane:e,moriyoshi:e,nikaho:e,noshiro:e,odate:e,oga:e,ogata:e,semboku:e,yokote:e,yurihonjo:e}],aomori:[1,{aomori:e,gonohe:e,hachinohe:e,hashikami:e,hiranai:e,hirosaki:e,itayanagi:e,kuroishi:e,misawa:e,mutsu:e,nakadomari:e,noheji:e,oirase:e,owani:e,rokunohe:e,sannohe:e,shichinohe:e,shingo:e,takko:e,towada:e,tsugaru:e,tsuruta:e}],chiba:[1,{abiko:e,asahi:e,chonan:e,chosei:e,choshi:e,chuo:e,funabashi:e,futtsu:e,hanamigawa:e,ichihara:e,ichikawa:e,ichinomiya:e,inzai:e,isumi:e,kamagaya:e,kamogawa:e,kashiwa:e,katori:e,katsuura:e,kimitsu:e,kisarazu:e,kozaki:e,kujukuri:e,kyonan:e,matsudo:e,midori:e,mihama:e,minamiboso:e,mobara:e,mutsuzawa:e,nagara:e,nagareyama:e,narashino:e,narita:e,noda:e,oamishirasato:e,omigawa:e,onjuku:e,otaki:e,sakae:e,sakura:e,shimofusa:e,shirako:e,shiroi:e,shisui:e,sodegaura:e,sosa:e,tako:e,tateyama:e,togane:e,tohnosho:e,tomisato:e,urayasu:e,yachimata:e,yachiyo:e,yokaichiba:e,yokoshibahikari:e,yotsukaido:e}],ehime:[1,{ainan:e,honai:e,ikata:e,imabari:e,iyo:e,kamijima:e,kihoku:e,kumakogen:e,masaki:e,matsuno:e,matsuyama:e,namikata:e,niihama:e,ozu:e,saijo:e,seiyo:e,shikokuchuo:e,tobe:e,toon:e,uchiko:e,uwajima:e,yawatahama:e}],fukui:[1,{echizen:e,eiheiji:e,fukui:e,ikeda:e,katsuyama:e,mihama:e,minamiechizen:e,obama:e,ohi:e,ono:e,sabae:e,sakai:e,takahama:e,tsuruga:e,wakasa:e}],fukuoka:[1,{ashiya:e,buzen:e,chikugo:e,chikuho:e,chikujo:e,chikushino:e,chikuzen:e,chuo:e,dazaifu:e,fukuchi:e,hakata:e,higashi:e,hirokawa:e,hisayama:e,iizuka:e,inatsuki:e,kaho:e,kasuga:e,kasuya:e,kawara:e,keisen:e,koga:e,kurate:e,kurogi:e,kurume:e,minami:e,miyako:e,miyama:e,miyawaka:e,mizumaki:e,munakata:e,nakagawa:e,nakama:e,nishi:e,nogata:e,ogori:e,okagaki:e,okawa:e,oki:e,omuta:e,onga:e,onojo:e,oto:e,saigawa:e,sasaguri:e,shingu:e,shinyoshitomi:e,shonai:e,soeda:e,sue:e,tachiarai:e,tagawa:e,takata:e,toho:e,toyotsu:e,tsuiki:e,ukiha:e,umi:e,usui:e,yamada:e,yame:e,yanagawa:e,yukuhashi:e}],fukushima:[1,{aizubange:e,aizumisato:e,aizuwakamatsu:e,asakawa:e,bandai:e,date:e,fukushima:e,furudono:e,futaba:e,hanawa:e,higashi:e,hirata:e,hirono:e,iitate:e,inawashiro:e,ishikawa:e,iwaki:e,izumizaki:e,kagamiishi:e,kaneyama:e,kawamata:e,kitakata:e,kitashiobara:e,koori:e,koriyama:e,kunimi:e,miharu:e,mishima:e,namie:e,nango:e,nishiaizu:e,nishigo:e,okuma:e,omotego:e,ono:e,otama:e,samegawa:e,shimogo:e,shirakawa:e,showa:e,soma:e,sukagawa:e,taishin:e,tamakawa:e,tanagura:e,tenei:e,yabuki:e,yamato:e,yamatsuri:e,yanaizu:e,yugawa:e}],gifu:[1,{anpachi:e,ena:e,gifu:e,ginan:e,godo:e,gujo:e,hashima:e,hichiso:e,hida:e,higashishirakawa:e,ibigawa:e,ikeda:e,kakamigahara:e,kani:e,kasahara:e,kasamatsu:e,kawaue:e,kitagata:e,mino:e,minokamo:e,mitake:e,mizunami:e,motosu:e,nakatsugawa:e,ogaki:e,sakahogi:e,seki:e,sekigahara:e,shirakawa:e,tajimi:e,takayama:e,tarui:e,toki:e,tomika:e,wanouchi:e,yamagata:e,yaotsu:e,yoro:e}],gunma:[1,{annaka:e,chiyoda:e,fujioka:e,higashiagatsuma:e,isesaki:e,itakura:e,kanna:e,kanra:e,katashina:e,kawaba:e,kiryu:e,kusatsu:e,maebashi:e,meiwa:e,midori:e,minakami:e,naganohara:e,nakanojo:e,nanmoku:e,numata:e,oizumi:e,ora:e,ota:e,shibukawa:e,shimonita:e,shinto:e,showa:e,takasaki:e,takayama:e,tamamura:e,tatebayashi:e,tomioka:e,tsukiyono:e,tsumagoi:e,ueno:e,yoshioka:e}],hiroshima:[1,{asaminami:e,daiwa:e,etajima:e,fuchu:e,fukuyama:e,hatsukaichi:e,higashihiroshima:e,hongo:e,jinsekikogen:e,kaita:e,kui:e,kumano:e,kure:e,mihara:e,miyoshi:e,naka:e,onomichi:e,osakikamijima:e,otake:e,saka:e,sera:e,seranishi:e,shinichi:e,shobara:e,takehara:e}],hokkaido:[1,{abashiri:e,abira:e,aibetsu:e,akabira:e,akkeshi:e,asahikawa:e,ashibetsu:e,ashoro:e,assabu:e,atsuma:e,bibai:e,biei:e,bifuka:e,bihoro:e,biratori:e,chippubetsu:e,chitose:e,date:e,ebetsu:e,embetsu:e,eniwa:e,erimo:e,esan:e,esashi:e,fukagawa:e,fukushima:e,furano:e,furubira:e,haboro:e,hakodate:e,hamatonbetsu:e,hidaka:e,higashikagura:e,higashikawa:e,hiroo:e,hokuryu:e,hokuto:e,honbetsu:e,horokanai:e,horonobe:e,ikeda:e,imakane:e,ishikari:e,iwamizawa:e,iwanai:e,kamifurano:e,kamikawa:e,kamishihoro:e,kamisunagawa:e,kamoenai:e,kayabe:e,kembuchi:e,kikonai:e,kimobetsu:e,kitahiroshima:e,kitami:e,kiyosato:e,koshimizu:e,kunneppu:e,kuriyama:e,kuromatsunai:e,kushiro:e,kutchan:e,kyowa:e,mashike:e,matsumae:e,mikasa:e,minamifurano:e,mombetsu:e,moseushi:e,mukawa:e,muroran:e,naie:e,nakagawa:e,nakasatsunai:e,nakatombetsu:e,nanae:e,nanporo:e,nayoro:e,nemuro:e,niikappu:e,niki:e,nishiokoppe:e,noboribetsu:e,numata:e,obihiro:e,obira:e,oketo:e,okoppe:e,otaru:e,otobe:e,otofuke:e,otoineppu:e,oumu:e,ozora:e,pippu:e,rankoshi:e,rebun:e,rikubetsu:e,rishiri:e,rishirifuji:e,saroma:e,sarufutsu:e,shakotan:e,shari:e,shibecha:e,shibetsu:e,shikabe:e,shikaoi:e,shimamaki:e,shimizu:e,shimokawa:e,shinshinotsu:e,shintoku:e,shiranuka:e,shiraoi:e,shiriuchi:e,sobetsu:e,sunagawa:e,taiki:e,takasu:e,takikawa:e,takinoue:e,teshikaga:e,tobetsu:e,tohma:e,tomakomai:e,tomari:e,toya:e,toyako:e,toyotomi:e,toyoura:e,tsubetsu:e,tsukigata:e,urakawa:e,urausu:e,uryu:e,utashinai:e,wakkanai:e,wassamu:e,yakumo:e,yoichi:e}],hyogo:[1,{aioi:e,akashi:e,ako:e,amagasaki:e,aogaki:e,asago:e,ashiya:e,awaji:e,fukusaki:e,goshiki:e,harima:e,himeji:e,ichikawa:e,inagawa:e,itami:e,kakogawa:e,kamigori:e,kamikawa:e,kasai:e,kasuga:e,kawanishi:e,miki:e,minamiawaji:e,nishinomiya:e,nishiwaki:e,ono:e,sanda:e,sannan:e,sasayama:e,sayo:e,shingu:e,shinonsen:e,shiso:e,sumoto:e,taishi:e,taka:e,takarazuka:e,takasago:e,takino:e,tamba:e,tatsuno:e,toyooka:e,yabu:e,yashiro:e,yoka:e,yokawa:e}],ibaraki:[1,{ami:e,asahi:e,bando:e,chikusei:e,daigo:e,fujishiro:e,hitachi:e,hitachinaka:e,hitachiomiya:e,hitachiota:e,ibaraki:e,ina:e,inashiki:e,itako:e,iwama:e,joso:e,kamisu:e,kasama:e,kashima:e,kasumigaura:e,koga:e,miho:e,mito:e,moriya:e,naka:e,namegata:e,oarai:e,ogawa:e,omitama:e,ryugasaki:e,sakai:e,sakuragawa:e,shimodate:e,shimotsuma:e,shirosato:e,sowa:e,suifu:e,takahagi:e,tamatsukuri:e,tokai:e,tomobe:e,tone:e,toride:e,tsuchiura:e,tsukuba:e,uchihara:e,ushiku:e,yachiyo:e,yamagata:e,yawara:e,yuki:e}],ishikawa:[1,{anamizu:e,hakui:e,hakusan:e,kaga:e,kahoku:e,kanazawa:e,kawakita:e,komatsu:e,nakanoto:e,nanao:e,nomi:e,nonoichi:e,noto:e,shika:e,suzu:e,tsubata:e,tsurugi:e,uchinada:e,wajima:e}],iwate:[1,{fudai:e,fujisawa:e,hanamaki:e,hiraizumi:e,hirono:e,ichinohe:e,ichinoseki:e,iwaizumi:e,iwate:e,joboji:e,kamaishi:e,kanegasaki:e,karumai:e,kawai:e,kitakami:e,kuji:e,kunohe:e,kuzumaki:e,miyako:e,mizusawa:e,morioka:e,ninohe:e,noda:e,ofunato:e,oshu:e,otsuchi:e,rikuzentakata:e,shiwa:e,shizukuishi:e,sumita:e,tanohata:e,tono:e,yahaba:e,yamada:e}],kagawa:[1,{ayagawa:e,higashikagawa:e,kanonji:e,kotohira:e,manno:e,marugame:e,mitoyo:e,naoshima:e,sanuki:e,tadotsu:e,takamatsu:e,tonosho:e,uchinomi:e,utazu:e,zentsuji:e}],kagoshima:[1,{akune:e,amami:e,hioki:e,isa:e,isen:e,izumi:e,kagoshima:e,kanoya:e,kawanabe:e,kinko:e,kouyama:e,makurazaki:e,matsumoto:e,minamitane:e,nakatane:e,nishinoomote:e,satsumasendai:e,soo:e,tarumizu:e,yusui:e}],kanagawa:[1,{aikawa:e,atsugi:e,ayase:e,chigasaki:e,ebina:e,fujisawa:e,hadano:e,hakone:e,hiratsuka:e,isehara:e,kaisei:e,kamakura:e,kiyokawa:e,matsuda:e,minamiashigara:e,miura:e,nakai:e,ninomiya:e,odawara:e,oi:e,oiso:e,sagamihara:e,samukawa:e,tsukui:e,yamakita:e,yamato:e,yokosuka:e,yugawara:e,zama:e,zushi:e}],kochi:[1,{aki:e,geisei:e,hidaka:e,higashitsuno:e,ino:e,kagami:e,kami:e,kitagawa:e,kochi:e,mihara:e,motoyama:e,muroto:e,nahari:e,nakamura:e,nankoku:e,nishitosa:e,niyodogawa:e,ochi:e,okawa:e,otoyo:e,otsuki:e,sakawa:e,sukumo:e,susaki:e,tosa:e,tosashimizu:e,toyo:e,tsuno:e,umaji:e,yasuda:e,yusuhara:e}],kumamoto:[1,{amakusa:e,arao:e,aso:e,choyo:e,gyokuto:e,kamiamakusa:e,kikuchi:e,kumamoto:e,mashiki:e,mifune:e,minamata:e,minamioguni:e,nagasu:e,nishihara:e,oguni:e,ozu:e,sumoto:e,takamori:e,uki:e,uto:e,yamaga:e,yamato:e,yatsushiro:e}],kyoto:[1,{ayabe:e,fukuchiyama:e,higashiyama:e,ide:e,ine:e,joyo:e,kameoka:e,kamo:e,kita:e,kizu:e,kumiyama:e,kyotamba:e,kyotanabe:e,kyotango:e,maizuru:e,minami:e,minamiyamashiro:e,miyazu:e,muko:e,nagaokakyo:e,nakagyo:e,nantan:e,oyamazaki:e,sakyo:e,seika:e,tanabe:e,uji:e,ujitawara:e,wazuka:e,yamashina:e,yawata:e}],mie:[1,{asahi:e,inabe:e,ise:e,kameyama:e,kawagoe:e,kiho:e,kisosaki:e,kiwa:e,komono:e,kumano:e,kuwana:e,matsusaka:e,meiwa:e,mihama:e,minamiise:e,misugi:e,miyama:e,nabari:e,shima:e,suzuka:e,tado:e,taiki:e,taki:e,tamaki:e,toba:e,tsu:e,udono:e,ureshino:e,watarai:e,yokkaichi:e}],miyagi:[1,{furukawa:e,higashimatsushima:e,ishinomaki:e,iwanuma:e,kakuda:e,kami:e,kawasaki:e,marumori:e,matsushima:e,minamisanriku:e,misato:e,murata:e,natori:e,ogawara:e,ohira:e,onagawa:e,osaki:e,rifu:e,semine:e,shibata:e,shichikashuku:e,shikama:e,shiogama:e,shiroishi:e,tagajo:e,taiwa:e,tome:e,tomiya:e,wakuya:e,watari:e,yamamoto:e,zao:e}],miyazaki:[1,{aya:e,ebino:e,gokase:e,hyuga:e,kadogawa:e,kawaminami:e,kijo:e,kitagawa:e,kitakata:e,kitaura:e,kobayashi:e,kunitomi:e,kushima:e,mimata:e,miyakonojo:e,miyazaki:e,morotsuka:e,nichinan:e,nishimera:e,nobeoka:e,saito:e,shiiba:e,shintomi:e,takaharu:e,takanabe:e,takazaki:e,tsuno:e}],nagano:[1,{achi:e,agematsu:e,anan:e,aoki:e,asahi:e,azumino:e,chikuhoku:e,chikuma:e,chino:e,fujimi:e,hakuba:e,hara:e,hiraya:e,iida:e,iijima:e,iiyama:e,iizuna:e,ikeda:e,ikusaka:e,ina:e,karuizawa:e,kawakami:e,kiso:e,kisofukushima:e,kitaaiki:e,komagane:e,komoro:e,matsukawa:e,matsumoto:e,miasa:e,minamiaiki:e,minamimaki:e,minamiminowa:e,minowa:e,miyada:e,miyota:e,mochizuki:e,nagano:e,nagawa:e,nagiso:e,nakagawa:e,nakano:e,nozawaonsen:e,obuse:e,ogawa:e,okaya:e,omachi:e,omi:e,ookuwa:e,ooshika:e,otaki:e,otari:e,sakae:e,sakaki:e,saku:e,sakuho:e,shimosuwa:e,shinanomachi:e,shiojiri:e,suwa:e,suzaka:e,takagi:e,takamori:e,takayama:e,tateshina:e,tatsuno:e,togakushi:e,togura:e,tomi:e,ueda:e,wada:e,yamagata:e,yamanouchi:e,yasaka:e,yasuoka:e}],nagasaki:[1,{chijiwa:e,futsu:e,goto:e,hasami:e,hirado:e,iki:e,isahaya:e,kawatana:e,kuchinotsu:e,matsuura:e,nagasaki:e,obama:e,omura:e,oseto:e,saikai:e,sasebo:e,seihi:e,shimabara:e,shinkamigoto:e,togitsu:e,tsushima:e,unzen:e}],nara:[1,{ando:e,gose:e,heguri:e,higashiyoshino:e,ikaruga:e,ikoma:e,kamikitayama:e,kanmaki:e,kashiba:e,kashihara:e,katsuragi:e,kawai:e,kawakami:e,kawanishi:e,koryo:e,kurotaki:e,mitsue:e,miyake:e,nara:e,nosegawa:e,oji:e,ouda:e,oyodo:e,sakurai:e,sango:e,shimoichi:e,shimokitayama:e,shinjo:e,soni:e,takatori:e,tawaramoto:e,tenkawa:e,tenri:e,uda:e,yamatokoriyama:e,yamatotakada:e,yamazoe:e,yoshino:e}],niigata:[1,{aga:e,agano:e,gosen:e,itoigawa:e,izumozaki:e,joetsu:e,kamo:e,kariwa:e,kashiwazaki:e,minamiuonuma:e,mitsuke:e,muika:e,murakami:e,myoko:e,nagaoka:e,niigata:e,ojiya:e,omi:e,sado:e,sanjo:e,seiro:e,seirou:e,sekikawa:e,shibata:e,tagami:e,tainai:e,tochio:e,tokamachi:e,tsubame:e,tsunan:e,uonuma:e,yahiko:e,yoita:e,yuzawa:e}],oita:[1,{beppu:e,bungoono:e,bungotakada:e,hasama:e,hiji:e,himeshima:e,hita:e,kamitsue:e,kokonoe:e,kuju:e,kunisaki:e,kusu:e,oita:e,saiki:e,taketa:e,tsukumi:e,usa:e,usuki:e,yufu:e}],okayama:[1,{akaiwa:e,asakuchi:e,bizen:e,hayashima:e,ibara:e,kagamino:e,kasaoka:e,kibichuo:e,kumenan:e,kurashiki:e,maniwa:e,misaki:e,nagi:e,niimi:e,nishiawakura:e,okayama:e,satosho:e,setouchi:e,shinjo:e,shoo:e,soja:e,takahashi:e,tamano:e,tsuyama:e,wake:e,yakage:e}],okinawa:[1,{aguni:e,ginowan:e,ginoza:e,gushikami:e,haebaru:e,higashi:e,hirara:e,iheya:e,ishigaki:e,ishikawa:e,itoman:e,izena:e,kadena:e,kin:e,kitadaito:e,kitanakagusuku:e,kumejima:e,kunigami:e,minamidaito:e,motobu:e,nago:e,naha:e,nakagusuku:e,nakijin:e,nanjo:e,nishihara:e,ogimi:e,okinawa:e,onna:e,shimoji:e,taketomi:e,tarama:e,tokashiki:e,tomigusuku:e,tonaki:e,urasoe:e,uruma:e,yaese:e,yomitan:e,yonabaru:e,yonaguni:e,zamami:e}],osaka:[1,{abeno:e,chihayaakasaka:e,chuo:e,daito:e,fujiidera:e,habikino:e,hannan:e,higashiosaka:e,higashisumiyoshi:e,higashiyodogawa:e,hirakata:e,ibaraki:e,ikeda:e,izumi:e,izumiotsu:e,izumisano:e,kadoma:e,kaizuka:e,kanan:e,kashiwara:e,katano:e,kawachinagano:e,kishiwada:e,kita:e,kumatori:e,matsubara:e,minato:e,minoh:e,misaki:e,moriguchi:e,neyagawa:e,nishi:e,nose:e,osakasayama:e,sakai:e,sayama:e,sennan:e,settsu:e,shijonawate:e,shimamoto:e,suita:e,tadaoka:e,taishi:e,tajiri:e,takaishi:e,takatsuki:e,tondabayashi:e,toyonaka:e,toyono:e,yao:e}],saga:[1,{ariake:e,arita:e,fukudomi:e,genkai:e,hamatama:e,hizen:e,imari:e,kamimine:e,kanzaki:e,karatsu:e,kashima:e,kitagata:e,kitahata:e,kiyama:e,kouhoku:e,kyuragi:e,nishiarita:e,ogi:e,omachi:e,ouchi:e,saga:e,shiroishi:e,taku:e,tara:e,tosu:e,yoshinogari:e}],saitama:[1,{arakawa:e,asaka:e,chichibu:e,fujimi:e,fujimino:e,fukaya:e,hanno:e,hanyu:e,hasuda:e,hatogaya:e,hatoyama:e,hidaka:e,higashichichibu:e,higashimatsuyama:e,honjo:e,ina:e,iruma:e,iwatsuki:e,kamiizumi:e,kamikawa:e,kamisato:e,kasukabe:e,kawagoe:e,kawaguchi:e,kawajima:e,kazo:e,kitamoto:e,koshigaya:e,kounosu:e,kuki:e,kumagaya:e,matsubushi:e,minano:e,misato:e,miyashiro:e,miyoshi:e,moroyama:e,nagatoro:e,namegawa:e,niiza:e,ogano:e,ogawa:e,ogose:e,okegawa:e,omiya:e,otaki:e,ranzan:e,ryokami:e,saitama:e,sakado:e,satte:e,sayama:e,shiki:e,shiraoka:e,soka:e,sugito:e,toda:e,tokigawa:e,tokorozawa:e,tsurugashima:e,urawa:e,warabi:e,yashio:e,yokoze:e,yono:e,yorii:e,yoshida:e,yoshikawa:e,yoshimi:e}],shiga:[1,{aisho:e,gamo:e,higashiomi:e,hikone:e,koka:e,konan:e,kosei:e,koto:e,kusatsu:e,maibara:e,moriyama:e,nagahama:e,nishiazai:e,notogawa:e,omihachiman:e,otsu:e,ritto:e,ryuoh:e,takashima:e,takatsuki:e,torahime:e,toyosato:e,yasu:e}],shimane:[1,{akagi:e,ama:e,gotsu:e,hamada:e,higashiizumo:e,hikawa:e,hikimi:e,izumo:e,kakinoki:e,masuda:e,matsue:e,misato:e,nishinoshima:e,ohda:e,okinoshima:e,okuizumo:e,shimane:e,tamayu:e,tsuwano:e,unnan:e,yakumo:e,yasugi:e,yatsuka:e}],shizuoka:[1,{arai:e,atami:e,fuji:e,fujieda:e,fujikawa:e,fujinomiya:e,fukuroi:e,gotemba:e,haibara:e,hamamatsu:e,higashiizu:e,ito:e,iwata:e,izu:e,izunokuni:e,kakegawa:e,kannami:e,kawanehon:e,kawazu:e,kikugawa:e,kosai:e,makinohara:e,matsuzaki:e,minamiizu:e,mishima:e,morimachi:e,nishiizu:e,numazu:e,omaezaki:e,shimada:e,shimizu:e,shimoda:e,shizuoka:e,susono:e,yaizu:e,yoshida:e}],tochigi:[1,{ashikaga:e,bato:e,haga:e,ichikai:e,iwafune:e,kaminokawa:e,kanuma:e,karasuyama:e,kuroiso:e,mashiko:e,mibu:e,moka:e,motegi:e,nasu:e,nasushiobara:e,nikko:e,nishikata:e,nogi:e,ohira:e,ohtawara:e,oyama:e,sakura:e,sano:e,shimotsuke:e,shioya:e,takanezawa:e,tochigi:e,tsuga:e,ujiie:e,utsunomiya:e,yaita:e}],tokushima:[1,{aizumi:e,anan:e,ichiba:e,itano:e,kainan:e,komatsushima:e,matsushige:e,mima:e,minami:e,miyoshi:e,mugi:e,nakagawa:e,naruto:e,sanagochi:e,shishikui:e,tokushima:e,wajiki:e}],tokyo:[1,{adachi:e,akiruno:e,akishima:e,aogashima:e,arakawa:e,bunkyo:e,chiyoda:e,chofu:e,chuo:e,edogawa:e,fuchu:e,fussa:e,hachijo:e,hachioji:e,hamura:e,higashikurume:e,higashimurayama:e,higashiyamato:e,hino:e,hinode:e,hinohara:e,inagi:e,itabashi:e,katsushika:e,kita:e,kiyose:e,kodaira:e,koganei:e,kokubunji:e,komae:e,koto:e,kouzushima:e,kunitachi:e,machida:e,meguro:e,minato:e,mitaka:e,mizuho:e,musashimurayama:e,musashino:e,nakano:e,nerima:e,ogasawara:e,okutama:e,ome:e,oshima:e,ota:e,setagaya:e,shibuya:e,shinagawa:e,shinjuku:e,suginami:e,sumida:e,tachikawa:e,taito:e,tama:e,toshima:e}],tottori:[1,{chizu:e,hino:e,kawahara:e,koge:e,kotoura:e,misasa:e,nanbu:e,nichinan:e,sakaiminato:e,tottori:e,wakasa:e,yazu:e,yonago:e}],toyama:[1,{asahi:e,fuchu:e,fukumitsu:e,funahashi:e,himi:e,imizu:e,inami:e,johana:e,kamiichi:e,kurobe:e,nakaniikawa:e,namerikawa:e,nanto:e,nyuzen:e,oyabe:e,taira:e,takaoka:e,tateyama:e,toga:e,tonami:e,toyama:e,unazuki:e,uozu:e,yamada:e}],wakayama:[1,{arida:e,aridagawa:e,gobo:e,hashimoto:e,hidaka:e,hirogawa:e,inami:e,iwade:e,kainan:e,kamitonda:e,katsuragi:e,kimino:e,kinokawa:e,kitayama:e,koya:e,koza:e,kozagawa:e,kudoyama:e,kushimoto:e,mihama:e,misato:e,nachikatsuura:e,shingu:e,shirahama:e,taiji:e,tanabe:e,wakayama:e,yuasa:e,yura:e}],yamagata:[1,{asahi:e,funagata:e,higashine:e,iide:e,kahoku:e,kaminoyama:e,kaneyama:e,kawanishi:e,mamurogawa:e,mikawa:e,murayama:e,nagai:e,nakayama:e,nanyo:e,nishikawa:e,obanazawa:e,oe:e,oguni:e,ohkura:e,oishida:e,sagae:e,sakata:e,sakegawa:e,shinjo:e,shirataka:e,shonai:e,takahata:e,tendo:e,tozawa:e,tsuruoka:e,yamagata:e,yamanobe:e,yonezawa:e,yuza:e}],yamaguchi:[1,{abu:e,hagi:e,hikari:e,hofu:e,iwakuni:e,kudamatsu:e,mitou:e,nagato:e,oshima:e,shimonoseki:e,shunan:e,tabuse:e,tokuyama:e,toyota:e,ube:e,yuu:e}],yamanashi:[1,{chuo:e,doshi:e,fuefuki:e,fujikawa:e,fujikawaguchiko:e,fujiyoshida:e,hayakawa:e,hokuto:e,ichikawamisato:e,kai:e,kofu:e,koshu:e,kosuge:e,"minami-alps":e,minobu:e,nakamichi:e,nanbu:e,narusawa:e,nirasaki:e,nishikatsura:e,oshino:e,otsuki:e,showa:e,tabayama:e,tsuru:e,uenohara:e,yamanakako:e,yamanashi:e}],"xn--4pvxs":e,栃木:e,"xn--vgu402c":e,愛知:e,"xn--c3s14m":e,愛媛:e,"xn--f6qx53a":e,兵庫:e,"xn--8pvr4u":e,熊本:e,"xn--uist22h":e,茨城:e,"xn--djrs72d6uy":e,北海道:e,"xn--mkru45i":e,千葉:e,"xn--0trq7p7nn":e,和歌山:e,"xn--8ltr62k":e,長崎:e,"xn--2m4a15e":e,長野:e,"xn--efvn9s":e,新潟:e,"xn--32vp30h":e,青森:e,"xn--4it797k":e,静岡:e,"xn--1lqs71d":e,東京:e,"xn--5rtp49c":e,石川:e,"xn--5js045d":e,埼玉:e,"xn--ehqz56n":e,三重:e,"xn--1lqs03n":e,京都:e,"xn--qqqt11m":e,佐賀:e,"xn--kbrq7o":e,大分:e,"xn--pssu33l":e,大阪:e,"xn--ntsq17g":e,奈良:e,"xn--uisz3g":e,宮城:e,"xn--6btw5a":e,宮崎:e,"xn--1ctwo":e,富山:e,"xn--6orx2r":e,山口:e,"xn--rht61e":e,山形:e,"xn--rht27z":e,山梨:e,"xn--djty4k":e,岩手:e,"xn--nit225k":e,岐阜:e,"xn--rht3d":e,岡山:e,"xn--klty5x":e,島根:e,"xn--kltx9a":e,広島:e,"xn--kltp7d":e,徳島:e,"xn--uuwu58a":e,沖縄:e,"xn--zbx025d":e,滋賀:e,"xn--ntso0iqx3a":e,神奈川:e,"xn--elqq16h":e,福井:e,"xn--4it168d":e,福岡:e,"xn--klt787d":e,福島:e,"xn--rny31h":e,秋田:e,"xn--7t0a264c":e,群馬:e,"xn--5rtq34k":e,香川:e,"xn--k7yn95e":e,高知:e,"xn--tor131o":e,鳥取:e,"xn--d5qv7z876c":e,鹿児島:e,kawasaki:o,kitakyushu:o,kobe:o,nagoya:o,sapporo:o,sendai:o,yokohama:o}],ke:[1,{ac:e,co:e,go:e,info:e,me:e,mobi:e,ne:e,or:e,sc:e}],kg:t,kh:o,ki:m,km:[1,{org:e,nom:e,gov:e,prd:e,tm:e,edu:e,mil:e,ass:e,com:e,coop:e,asso:e,presse:e,medecin:e,notaires:e,pharmaciens:e,veterinaire:e,gouv:e}],kn:[1,{net:e,org:e,edu:e,gov:e}],kp:[1,{com:e,edu:e,gov:e,org:e,rep:e,tra:e}],kr:[1,{ac:e,co:e,es:e,go:e,hs:e,kg:e,mil:e,ms:e,ne:e,or:e,pe:e,re:e,sc:e,busan:e,chungbuk:e,chungnam:e,daegu:e,daejeon:e,gangwon:e,gwangju:e,gyeongbuk:e,gyeonggi:e,gyeongnam:e,incheon:e,jeju:e,jeonbuk:e,jeonnam:e,seoul:e,ulsan:e}],kw:[1,{com:e,edu:e,emb:e,gov:e,ind:e,net:e,org:e}],ky:i,kz:t,la:[1,{int:e,net:e,info:e,edu:e,gov:e,per:e,com:e,org:e}],lb:n,lc:u,li:e,lk:[1,{gov:e,sch:e,net:e,int:e,com:e,org:e,edu:e,ngo:e,soc:e,web:e,ltd:e,assn:e,grp:e,hotel:e,ac:e}],lr:n,ls:[1,{ac:e,biz:e,co:e,edu:e,gov:e,info:e,net:e,org:e,sc:e}],lt:r,lu:e,lv:[1,{com:e,edu:e,gov:e,org:e,mil:e,id:e,net:e,asn:e,conf:e}],ly:[1,{com:e,net:e,gov:e,plc:e,edu:e,sch:e,med:e,org:e,id:e}],ma:[1,{co:e,net:e,gov:e,org:e,ac:e,press:e}],mc:[1,{tm:e,asso:e}],md:e,me:[1,{co:e,net:e,org:e,edu:e,ac:e,gov:e,its:e,priv:e}],mg:[1,{org:e,nom:e,gov:e,prd:e,tm:e,edu:e,mil:e,com:e,co:e}],mh:e,mil:e,mk:[1,{com:e,org:e,net:e,edu:e,gov:e,inf:e,name:e}],ml:[1,{com:e,edu:e,gouv:e,gov:e,net:e,org:e,presse:e}],mm:o,mn:[1,{gov:e,edu:e,org:e}],mo:n,mobi:e,mp:e,mq:e,mr:r,ms:n,mt:i,mu:[1,{com:e,net:e,org:e,gov:e,ac:e,co:e,or:e}],museum:e,mv:[1,{aero:e,biz:e,com:e,coop:e,edu:e,gov:e,info:e,int:e,mil:e,museum:e,name:e,net:e,org:e,pro:e}],mw:[1,{ac:e,biz:e,co:e,com:e,coop:e,edu:e,gov:e,int:e,museum:e,net:e,org:e}],mx:[1,{com:e,org:e,gob:e,edu:e,net:e}],my:[1,{biz:e,com:e,edu:e,gov:e,mil:e,name:e,net:e,org:e}],mz:[1,{ac:e,adv:e,co:e,edu:e,gov:e,mil:e,net:e,org:e}],na:[1,{info:e,pro:e,name:e,school:e,or:e,dr:e,us:e,mx:e,ca:e,in:e,cc:e,tv:e,ws:e,mobi:e,co:e,com:e,org:e}],name:e,nc:[1,{asso:e,nom:e}],ne:e,net:e,nf:[1,{com:e,net:e,per:e,rec:e,web:e,arts:e,firm:e,info:e,other:e,store:e}],ng:[1,{com:e,edu:e,gov:e,i:e,mil:e,mobi:e,name:e,net:e,org:e,sch:e}],ni:[1,{ac:e,biz:e,co:e,com:e,edu:e,gob:e,in:e,info:e,int:e,mil:e,net:e,nom:e,org:e,web:e}],nl:e,no:[1,{fhs:e,vgs:e,fylkesbibl:e,folkebibl:e,museum:e,idrett:e,priv:e,mil:e,stat:e,dep:e,kommune:e,herad:e,aa:p,ah:p,bu:p,fm:p,hl:p,hm:p,"jan-mayen":p,mr:p,nl:p,nt:p,of:p,ol:p,oslo:p,rl:p,sf:p,st:p,svalbard:p,tm:p,tr:p,va:p,vf:p,akrehamn:e,"xn--krehamn-dxa":e,åkrehamn:e,algard:e,"xn--lgrd-poac":e,ålgård:e,arna:e,brumunddal:e,bryne:e,bronnoysund:e,"xn--brnnysund-m8ac":e,brønnøysund:e,drobak:e,"xn--drbak-wua":e,drøbak:e,egersund:e,fetsund:e,floro:e,"xn--flor-jra":e,florø:e,fredrikstad:e,hokksund:e,honefoss:e,"xn--hnefoss-q1a":e,hønefoss:e,jessheim:e,jorpeland:e,"xn--jrpeland-54a":e,jørpeland:e,kirkenes:e,kopervik:e,krokstadelva:e,langevag:e,"xn--langevg-jxa":e,langevåg:e,leirvik:e,mjondalen:e,"xn--mjndalen-64a":e,mjøndalen:e,"mo-i-rana":e,mosjoen:e,"xn--mosjen-eya":e,mosjøen:e,nesoddtangen:e,orkanger:e,osoyro:e,"xn--osyro-wua":e,osøyro:e,raholt:e,"xn--rholt-mra":e,råholt:e,sandnessjoen:e,"xn--sandnessjen-ogb":e,sandnessjøen:e,skedsmokorset:e,slattum:e,spjelkavik:e,stathelle:e,stavern:e,stjordalshalsen:e,"xn--stjrdalshalsen-sqb":e,stjørdalshalsen:e,tananger:e,tranby:e,vossevangen:e,afjord:e,"xn--fjord-lra":e,åfjord:e,agdenes:e,al:e,"xn--l-1fa":e,ål:e,alesund:e,"xn--lesund-hua":e,ålesund:e,alstahaug:e,alta:e,"xn--lt-liac":e,áltá:e,alaheadju:e,"xn--laheadju-7ya":e,álaheadju:e,alvdal:e,amli:e,"xn--mli-tla":e,åmli:e,amot:e,"xn--mot-tla":e,åmot:e,andebu:e,andoy:e,"xn--andy-ira":e,andøy:e,andasuolo:e,ardal:e,"xn--rdal-poa":e,årdal:e,aremark:e,arendal:e,"xn--s-1fa":e,ås:e,aseral:e,"xn--seral-lra":e,åseral:e,asker:e,askim:e,askvoll:e,askoy:e,"xn--asky-ira":e,askøy:e,asnes:e,"xn--snes-poa":e,åsnes:e,audnedaln:e,aukra:e,aure:e,aurland:e,"aurskog-holand":e,"xn--aurskog-hland-jnb":e,"aurskog-høland":e,austevoll:e,austrheim:e,averoy:e,"xn--avery-yua":e,averøy:e,balestrand:e,ballangen:e,balat:e,"xn--blt-elab":e,bálát:e,balsfjord:e,bahccavuotna:e,"xn--bhccavuotna-k7a":e,báhccavuotna:e,bamble:e,bardu:e,beardu:e,beiarn:e,bajddar:e,"xn--bjddar-pta":e,bájddar:e,baidar:e,"xn--bidr-5nac":e,báidár:e,berg:e,bergen:e,berlevag:e,"xn--berlevg-jxa":e,berlevåg:e,bearalvahki:e,"xn--bearalvhki-y4a":e,bearalváhki:e,bindal:e,birkenes:e,bjarkoy:e,"xn--bjarky-fya":e,bjarkøy:e,bjerkreim:e,bjugn:e,bodo:e,"xn--bod-2na":e,bodø:e,badaddja:e,"xn--bdddj-mrabd":e,bådåddjå:e,budejju:e,bokn:e,bremanger:e,bronnoy:e,"xn--brnny-wuac":e,brønnøy:e,bygland:e,bykle:e,barum:e,"xn--brum-voa":e,bærum:e,telemark:[0,{bo:e,"xn--b-5ga":e,bø:e}],nordland:[0,{bo:e,"xn--b-5ga":e,bø:e,heroy:e,"xn--hery-ira":e,herøy:e}],bievat:e,"xn--bievt-0qa":e,bievát:e,bomlo:e,"xn--bmlo-gra":e,bømlo:e,batsfjord:e,"xn--btsfjord-9za":e,båtsfjord:e,bahcavuotna:e,"xn--bhcavuotna-s4a":e,báhcavuotna:e,dovre:e,drammen:e,drangedal:e,dyroy:e,"xn--dyry-ira":e,dyrøy:e,donna:e,"xn--dnna-gra":e,dønna:e,eid:e,eidfjord:e,eidsberg:e,eidskog:e,eidsvoll:e,eigersund:e,elverum:e,enebakk:e,engerdal:e,etne:e,etnedal:e,evenes:e,evenassi:e,"xn--eveni-0qa01ga":e,evenášši:e,"evje-og-hornnes":e,farsund:e,fauske:e,fuossko:e,fuoisku:e,fedje:e,fet:e,finnoy:e,"xn--finny-yua":e,finnøy:e,fitjar:e,fjaler:e,fjell:e,flakstad:e,flatanger:e,flekkefjord:e,flesberg:e,flora:e,fla:e,"xn--fl-zia":e,flå:e,folldal:e,forsand:e,fosnes:e,frei:e,frogn:e,froland:e,frosta:e,frana:e,"xn--frna-woa":e,fræna:e,froya:e,"xn--frya-hra":e,frøya:e,fusa:e,fyresdal:e,forde:e,"xn--frde-gra":e,førde:e,gamvik:e,gangaviika:e,"xn--ggaviika-8ya47h":e,gáŋgaviika:e,gaular:e,gausdal:e,gildeskal:e,"xn--gildeskl-g0a":e,gildeskål:e,giske:e,gjemnes:e,gjerdrum:e,gjerstad:e,gjesdal:e,gjovik:e,"xn--gjvik-wua":e,gjøvik:e,gloppen:e,gol:e,gran:e,grane:e,granvin:e,gratangen:e,grimstad:e,grong:e,kraanghke:e,"xn--kranghke-b0a":e,kråanghke:e,grue:e,gulen:e,hadsel:e,halden:e,halsa:e,hamar:e,hamaroy:e,habmer:e,"xn--hbmer-xqa":e,hábmer:e,hapmir:e,"xn--hpmir-xqa":e,hápmir:e,hammerfest:e,hammarfeasta:e,"xn--hmmrfeasta-s4ac":e,hámmárfeasta:e,haram:e,hareid:e,harstad:e,hasvik:e,aknoluokta:e,"xn--koluokta-7ya57h":e,ákŋoluokta:e,hattfjelldal:e,aarborte:e,haugesund:e,hemne:e,hemnes:e,hemsedal:e,"more-og-romsdal":[0,{heroy:e,sande:e}],"xn--mre-og-romsdal-qqb":[0,{"xn--hery-ira":e,sande:e}],"møre-og-romsdal":[0,{herøy:e,sande:e}],hitra:e,hjartdal:e,hjelmeland:e,hobol:e,"xn--hobl-ira":e,hobøl:e,hof:e,hol:e,hole:e,holmestrand:e,holtalen:e,"xn--holtlen-hxa":e,holtålen:e,hornindal:e,horten:e,hurdal:e,hurum:e,hvaler:e,hyllestad:e,hagebostad:e,"xn--hgebostad-g3a":e,hægebostad:e,hoyanger:e,"xn--hyanger-q1a":e,høyanger:e,hoylandet:e,"xn--hylandet-54a":e,høylandet:e,ha:e,"xn--h-2fa":e,hå:e,ibestad:e,inderoy:e,"xn--indery-fya":e,inderøy:e,iveland:e,jevnaker:e,jondal:e,jolster:e,"xn--jlster-bya":e,jølster:e,karasjok:e,karasjohka:e,"xn--krjohka-hwab49j":e,kárášjohka:e,karlsoy:e,galsa:e,"xn--gls-elac":e,gálsá:e,karmoy:e,"xn--karmy-yua":e,karmøy:e,kautokeino:e,guovdageaidnu:e,klepp:e,klabu:e,"xn--klbu-woa":e,klæbu:e,kongsberg:e,kongsvinger:e,kragero:e,"xn--krager-gya":e,kragerø:e,kristiansand:e,kristiansund:e,krodsherad:e,"xn--krdsherad-m8a":e,krødsherad:e,kvalsund:e,rahkkeravju:e,"xn--rhkkervju-01af":e,ráhkkerávju:e,kvam:e,kvinesdal:e,kvinnherad:e,kviteseid:e,kvitsoy:e,"xn--kvitsy-fya":e,kvitsøy:e,kvafjord:e,"xn--kvfjord-nxa":e,kvæfjord:e,giehtavuoatna:e,kvanangen:e,"xn--kvnangen-k0a":e,kvænangen:e,navuotna:e,"xn--nvuotna-hwa":e,návuotna:e,kafjord:e,"xn--kfjord-iua":e,kåfjord:e,gaivuotna:e,"xn--givuotna-8ya":e,gáivuotna:e,larvik:e,lavangen:e,lavagis:e,loabat:e,"xn--loabt-0qa":e,loabát:e,lebesby:e,davvesiida:e,leikanger:e,leirfjord:e,leka:e,leksvik:e,lenvik:e,leangaviika:e,"xn--leagaviika-52b":e,leaŋgaviika:e,lesja:e,levanger:e,lier:e,lierne:e,lillehammer:e,lillesand:e,lindesnes:e,lindas:e,"xn--linds-pra":e,lindås:e,lom:e,loppa:e,lahppi:e,"xn--lhppi-xqa":e,láhppi:e,lund:e,lunner:e,luroy:e,"xn--lury-ira":e,lurøy:e,luster:e,lyngdal:e,lyngen:e,ivgu:e,lardal:e,lerdal:e,"xn--lrdal-sra":e,lærdal:e,lodingen:e,"xn--ldingen-q1a":e,lødingen:e,lorenskog:e,"xn--lrenskog-54a":e,lørenskog:e,loten:e,"xn--lten-gra":e,løten:e,malvik:e,masoy:e,"xn--msy-ula0h":e,måsøy:e,muosat:e,"xn--muost-0qa":e,muosát:e,mandal:e,marker:e,marnardal:e,masfjorden:e,meland:e,meldal:e,melhus:e,meloy:e,"xn--mely-ira":e,meløy:e,meraker:e,"xn--merker-kua":e,meråker:e,moareke:e,"xn--moreke-jua":e,moåreke:e,midsund:e,"midtre-gauldal":e,modalen:e,modum:e,molde:e,moskenes:e,moss:e,mosvik:e,malselv:e,"xn--mlselv-iua":e,målselv:e,malatvuopmi:e,"xn--mlatvuopmi-s4a":e,málatvuopmi:e,namdalseid:e,aejrie:e,namsos:e,namsskogan:e,naamesjevuemie:e,"xn--nmesjevuemie-tcba":e,nååmesjevuemie:e,laakesvuemie:e,nannestad:e,narvik:e,narviika:e,naustdal:e,"nedre-eiker":e,akershus:h,buskerud:h,nesna:e,nesodden:e,nesseby:e,unjarga:e,"xn--unjrga-rta":e,unjárga:e,nesset:e,nissedal:e,nittedal:e,"nord-aurdal":e,"nord-fron":e,"nord-odal":e,norddal:e,nordkapp:e,davvenjarga:e,"xn--davvenjrga-y4a":e,davvenjárga:e,"nordre-land":e,nordreisa:e,raisa:e,"xn--risa-5na":e,ráisa:e,"nore-og-uvdal":e,notodden:e,naroy:e,"xn--nry-yla5g":e,nærøy:e,notteroy:e,"xn--nttery-byae":e,nøtterøy:e,odda:e,oksnes:e,"xn--ksnes-uua":e,øksnes:e,oppdal:e,oppegard:e,"xn--oppegrd-ixa":e,oppegård:e,orkdal:e,orland:e,"xn--rland-uua":e,ørland:e,orskog:e,"xn--rskog-uua":e,ørskog:e,orsta:e,"xn--rsta-fra":e,ørsta:e,hedmark:[0,{os:e,valer:e,"xn--vler-qoa":e,våler:e}],hordaland:[0,{os:e}],osen:e,osteroy:e,"xn--ostery-fya":e,osterøy:e,"ostre-toten":e,"xn--stre-toten-zcb":e,"østre-toten":e,overhalla:e,"ovre-eiker":e,"xn--vre-eiker-k8a":e,"øvre-eiker":e,oyer:e,"xn--yer-zna":e,øyer:e,oygarden:e,"xn--ygarden-p1a":e,øygarden:e,"oystre-slidre":e,"xn--ystre-slidre-ujb":e,"øystre-slidre":e,porsanger:e,porsangu:e,"xn--porsgu-sta26f":e,porsáŋgu:e,porsgrunn:e,radoy:e,"xn--rady-ira":e,radøy:e,rakkestad:e,rana:e,ruovat:e,randaberg:e,rauma:e,rendalen:e,rennebu:e,rennesoy:e,"xn--rennesy-v1a":e,rennesøy:e,rindal:e,ringebu:e,ringerike:e,ringsaker:e,rissa:e,risor:e,"xn--risr-ira":e,risør:e,roan:e,rollag:e,rygge:e,ralingen:e,"xn--rlingen-mxa":e,rælingen:e,rodoy:e,"xn--rdy-0nab":e,rødøy:e,romskog:e,"xn--rmskog-bya":e,rømskog:e,roros:e,"xn--rros-gra":e,røros:e,rost:e,"xn--rst-0na":e,røst:e,royken:e,"xn--ryken-vua":e,røyken:e,royrvik:e,"xn--ryrvik-bya":e,røyrvik:e,rade:e,"xn--rde-ula":e,råde:e,salangen:e,siellak:e,saltdal:e,salat:e,"xn--slt-elab":e,sálát:e,"xn--slat-5na":e,sálat:e,samnanger:e,vestfold:[0,{sande:e}],sandefjord:e,sandnes:e,sandoy:e,"xn--sandy-yua":e,sandøy:e,sarpsborg:e,sauda:e,sauherad:e,sel:e,selbu:e,selje:e,seljord:e,sigdal:e,siljan:e,sirdal:e,skaun:e,skedsmo:e,ski:e,skien:e,skiptvet:e,skjervoy:e,"xn--skjervy-v1a":e,skjervøy:e,skierva:e,"xn--skierv-uta":e,skiervá:e,skjak:e,"xn--skjk-soa":e,skjåk:e,skodje:e,skanland:e,"xn--sknland-fxa":e,skånland:e,skanit:e,"xn--sknit-yqa":e,skánit:e,smola:e,"xn--smla-hra":e,smøla:e,snillfjord:e,snasa:e,"xn--snsa-roa":e,snåsa:e,snoasa:e,snaase:e,"xn--snase-nra":e,snåase:e,sogndal:e,sokndal:e,sola:e,solund:e,songdalen:e,sortland:e,spydeberg:e,stange:e,stavanger:e,steigen:e,steinkjer:e,stjordal:e,"xn--stjrdal-s1a":e,stjørdal:e,stokke:e,"stor-elvdal":e,stord:e,stordal:e,storfjord:e,omasvuotna:e,strand:e,stranda:e,stryn:e,sula:e,suldal:e,sund:e,sunndal:e,surnadal:e,sveio:e,svelvik:e,sykkylven:e,sogne:e,"xn--sgne-gra":e,søgne:e,somna:e,"xn--smna-gra":e,sømna:e,"sondre-land":e,"xn--sndre-land-0cb":e,"søndre-land":e,"sor-aurdal":e,"xn--sr-aurdal-l8a":e,"sør-aurdal":e,"sor-fron":e,"xn--sr-fron-q1a":e,"sør-fron":e,"sor-odal":e,"xn--sr-odal-q1a":e,"sør-odal":e,"sor-varanger":e,"xn--sr-varanger-ggb":e,"sør-varanger":e,"matta-varjjat":e,"xn--mtta-vrjjat-k7af":e,"mátta-várjjat":e,sorfold:e,"xn--srfold-bya":e,sørfold:e,sorreisa:e,"xn--srreisa-q1a":e,sørreisa:e,sorum:e,"xn--srum-gra":e,sørum:e,tana:e,deatnu:e,time:e,tingvoll:e,tinn:e,tjeldsund:e,dielddanuorri:e,tjome:e,"xn--tjme-hra":e,tjøme:e,tokke:e,tolga:e,torsken:e,tranoy:e,"xn--trany-yua":e,tranøy:e,tromso:e,"xn--troms-zua":e,tromsø:e,tromsa:e,romsa:e,trondheim:e,troandin:e,trysil:e,trana:e,"xn--trna-woa":e,træna:e,trogstad:e,"xn--trgstad-r1a":e,trøgstad:e,tvedestrand:e,tydal:e,tynset:e,tysfjord:e,divtasvuodna:e,divttasvuotna:e,tysnes:e,tysvar:e,"xn--tysvr-vra":e,tysvær:e,tonsberg:e,"xn--tnsberg-q1a":e,tønsberg:e,ullensaker:e,ullensvang:e,ulvik:e,utsira:e,vadso:e,"xn--vads-jra":e,vadsø:e,cahcesuolo:e,"xn--hcesuolo-7ya35b":e,čáhcesuolo:e,vaksdal:e,valle:e,vang:e,vanylven:e,vardo:e,"xn--vard-jra":e,vardø:e,varggat:e,"xn--vrggt-xqad":e,várggát:e,vefsn:e,vaapste:e,vega:e,vegarshei:e,"xn--vegrshei-c0a":e,vegårshei:e,vennesla:e,verdal:e,verran:e,vestby:e,vestnes:e,"vestre-slidre":e,"vestre-toten":e,vestvagoy:e,"xn--vestvgy-ixa6o":e,vestvågøy:e,vevelstad:e,vik:e,vikna:e,vindafjord:e,volda:e,voss:e,varoy:e,"xn--vry-yla5g":e,værøy:e,vagan:e,"xn--vgan-qoa":e,vågan:e,voagat:e,vagsoy:e,"xn--vgsy-qoa0j":e,vågsøy:e,vaga:e,"xn--vg-yiab":e,vågå:e,ostfold:[0,{valer:e}],"xn--stfold-9xa":[0,{"xn--vler-qoa":e}],østfold:[0,{våler:e}]}],np:o,nr:m,nu:e,nz:[1,{ac:e,co:e,cri:e,geek:e,gen:e,govt:e,health:e,iwi:e,kiwi:e,maori:e,mil:e,"xn--mori-qsa":e,māori:e,net:e,org:e,parliament:e,school:e}],om:[1,{co:e,com:e,edu:e,gov:e,med:e,museum:e,net:e,org:e,pro:e}],onion:e,org:e,pa:[1,{ac:e,gob:e,com:e,org:e,sld:e,edu:e,net:e,ing:e,abo:e,med:e,nom:e}],pe:[1,{edu:e,gob:e,nom:e,mil:e,org:e,com:e,net:e}],pf:[1,{com:e,org:e,edu:e}],pg:o,ph:[1,{com:e,net:e,org:e,gov:e,edu:e,ngo:e,mil:e,i:e}],pk:[1,{com:e,net:e,edu:e,org:e,fam:e,biz:e,web:e,gov:e,gob:e,gok:e,gon:e,gop:e,gos:e,info:e}],pl:[1,{com:e,net:e,org:e,aid:e,agro:e,atm:e,auto:e,biz:e,edu:e,gmina:e,gsm:e,info:e,mail:e,miasta:e,media:e,mil:e,nieruchomosci:e,nom:e,pc:e,powiat:e,priv:e,realestate:e,rel:e,sex:e,shop:e,sklep:e,sos:e,szkola:e,targi:e,tm:e,tourism:e,travel:e,turystyka:e,gov:[1,{ap:e,griw:e,ic:e,is:e,kmpsp:e,konsulat:e,kppsp:e,kwp:e,kwpsp:e,mup:e,mw:e,oia:e,oirm:e,oke:e,oow:e,oschr:e,oum:e,pa:e,pinb:e,piw:e,po:e,pr:e,psp:e,psse:e,pup:e,rzgw:e,sa:e,sdn:e,sko:e,so:e,sr:e,starostwo:e,ug:e,ugim:e,um:e,umig:e,upow:e,uppo:e,us:e,uw:e,uzs:e,wif:e,wiih:e,winb:e,wios:e,witd:e,wiw:e,wkz:e,wsa:e,wskr:e,wsse:e,wuoz:e,wzmiuw:e,zp:e,zpisdn:e}],augustow:e,"babia-gora":e,bedzin:e,beskidy:e,bialowieza:e,bialystok:e,bielawa:e,bieszczady:e,boleslawiec:e,bydgoszcz:e,bytom:e,cieszyn:e,czeladz:e,czest:e,dlugoleka:e,elblag:e,elk:e,glogow:e,gniezno:e,gorlice:e,grajewo:e,ilawa:e,jaworzno:e,"jelenia-gora":e,jgora:e,kalisz:e,"kazimierz-dolny":e,karpacz:e,kartuzy:e,kaszuby:e,katowice:e,kepno:e,ketrzyn:e,klodzko:e,kobierzyce:e,kolobrzeg:e,konin:e,konskowola:e,kutno:e,lapy:e,lebork:e,legnica:e,lezajsk:e,limanowa:e,lomza:e,lowicz:e,lubin:e,lukow:e,malbork:e,malopolska:e,mazowsze:e,mazury:e,mielec:e,mielno:e,mragowo:e,naklo:e,nowaruda:e,nysa:e,olawa:e,olecko:e,olkusz:e,olsztyn:e,opoczno:e,opole:e,ostroda:e,ostroleka:e,ostrowiec:e,ostrowwlkp:e,pila:e,pisz:e,podhale:e,podlasie:e,polkowice:e,pomorze:e,pomorskie:e,prochowice:e,pruszkow:e,przeworsk:e,pulawy:e,radom:e,"rawa-maz":e,rybnik:e,rzeszow:e,sanok:e,sejny:e,slask:e,slupsk:e,sosnowiec:e,"stalowa-wola":e,skoczow:e,starachowice:e,stargard:e,suwalki:e,swidnica:e,swiebodzin:e,swinoujscie:e,szczecin:e,szczytno:e,tarnobrzeg:e,tgory:e,turek:e,tychy:e,ustka:e,walbrzych:e,warmia:e,warszawa:e,waw:e,wegrow:e,wielun:e,wlocl:e,wloclawek:e,wodzislaw:e,wolomin:e,wroclaw:e,zachpomor:e,zagan:e,zarow:e,zgora:e,zgorzelec:e}],pm:e,pn:[1,{gov:e,co:e,org:e,edu:e,net:e}],post:e,pr:[1,{com:e,net:e,org:e,gov:e,edu:e,isla:e,pro:e,biz:e,info:e,name:e,est:e,prof:e,ac:e}],pro:[1,{aaa:e,aca:e,acct:e,avocat:e,bar:e,cpa:e,eng:e,jur:e,law:e,med:e,recht:e}],ps:[1,{edu:e,gov:e,sec:e,plo:e,com:e,org:e,net:e}],pt:[1,{net:e,gov:e,org:e,edu:e,int:e,publ:e,com:e,nome:e}],pw:[1,{co:e,ne:e,or:e,ed:e,go:e,belau:e}],py:[1,{com:e,coop:e,edu:e,gov:e,mil:e,net:e,org:e}],qa:l,re:[1,{asso:e,com:e,nom:e}],ro:[1,{arts:e,com:e,firm:e,info:e,nom:e,nt:e,org:e,rec:e,store:e,tm:e,www:e}],rs:[1,{ac:e,co:e,edu:e,gov:e,in:e,org:e}],ru:e,rw:[1,{ac:e,co:e,coop:e,gov:e,mil:e,net:e,org:e}],sa:[1,{com:e,net:e,org:e,gov:e,med:e,pub:e,edu:e,sch:e}],sb:n,sc:n,sd:[1,{com:e,net:e,org:e,edu:e,med:e,tv:e,gov:e,info:e}],se:[1,{a:e,ac:e,b:e,bd:e,brand:e,c:e,d:e,e,f:e,fh:e,fhsk:e,fhv:e,g:e,h:e,i:e,k:e,komforb:e,kommunalforbund:e,komvux:e,l:e,lanbib:e,m:e,n:e,naturbruksgymn:e,o:e,org:e,p:e,parti:e,pp:e,press:e,r:e,s:e,t:e,tm:e,u:e,w:e,x:e,y:e,z:e}],sg:[1,{com:e,net:e,org:e,gov:e,edu:e,per:e}],sh:[1,{com:e,net:e,gov:e,org:e,mil:e}],si:e,sj:e,sk:e,sl:n,sm:e,sn:[1,{art:e,com:e,edu:e,gouv:e,org:e,perso:e,univ:e}],so:[1,{com:e,edu:e,gov:e,me:e,net:e,org:e}],sr:e,ss:[1,{biz:e,com:e,edu:e,gov:e,me:e,net:e,org:e,sch:e}],st:[1,{co:e,com:e,consulado:e,edu:e,embaixada:e,mil:e,net:e,org:e,principe:e,saotome:e,store:e}],su:e,sv:[1,{com:e,edu:e,gob:e,org:e,red:e}],sx:r,sy:t,sz:[1,{co:e,ac:e,org:e}],tc:e,td:e,tel:e,tf:e,tg:e,th:[1,{ac:e,co:e,go:e,in:e,mi:e,net:e,or:e}],tj:[1,{ac:e,biz:e,co:e,com:e,edu:e,go:e,gov:e,int:e,mil:e,name:e,net:e,nic:e,org:e,test:e,web:e}],tk:e,tl:r,tm:[1,{com:e,co:e,org:e,net:e,nom:e,gov:e,mil:e,edu:e}],tn:[1,{com:e,ens:e,fin:e,gov:e,ind:e,info:e,intl:e,mincom:e,nat:e,net:e,org:e,perso:e,tourism:e}],to:t,tr:[1,{av:e,bbs:e,bel:e,biz:e,com:e,dr:e,edu:e,gen:e,gov:e,info:e,mil:e,k12:e,kep:e,name:e,net:e,org:e,pol:e,tel:e,tsk:e,tv:e,web:e,nc:r}],tt:[1,{co:e,com:e,org:e,net:e,biz:e,info:e,pro:e,int:e,coop:e,jobs:e,mobi:e,travel:e,museum:e,aero:e,name:e,gov:e,edu:e}],tv:e,tw:[1,{edu:e,gov:e,mil:e,com:e,net:e,org:e,idv:e,game:e,ebiz:e,club:e,"xn--zf0ao64a":e,網路:e,"xn--uc0atv":e,組織:e,"xn--czrw28b":e,商業:e}],tz:[1,{ac:e,co:e,go:e,hotel:e,info:e,me:e,mil:e,mobi:e,ne:e,or:e,sc:e,tv:e}],ua:[1,{com:e,edu:e,gov:e,in:e,net:e,org:e,cherkassy:e,cherkasy:e,chernigov:e,chernihiv:e,chernivtsi:e,chernovtsy:e,ck:e,cn:e,cr:e,crimea:e,cv:e,dn:e,dnepropetrovsk:e,dnipropetrovsk:e,donetsk:e,dp:e,if:e,"ivano-frankivsk":e,kh:e,kharkiv:e,kharkov:e,kherson:e,khmelnitskiy:e,khmelnytskyi:e,kiev:e,kirovograd:e,km:e,kr:e,kropyvnytskyi:e,krym:e,ks:e,kv:e,kyiv:e,lg:e,lt:e,lugansk:e,luhansk:e,lutsk:e,lv:e,lviv:e,mk:e,mykolaiv:e,nikolaev:e,od:e,odesa:e,odessa:e,pl:e,poltava:e,rivne:e,rovno:e,rv:e,sb:e,sebastopol:e,sevastopol:e,sm:e,sumy:e,te:e,ternopil:e,uz:e,uzhgorod:e,uzhhorod:e,vinnica:e,vinnytsia:e,vn:e,volyn:e,yalta:e,zakarpattia:e,zaporizhzhe:e,zaporizhzhia:e,zhitomir:e,zhytomyr:e,zp:e,zt:e}],ug:[1,{co:e,or:e,ac:e,sc:e,go:e,ne:e,com:e,org:e}],uk:[1,{ac:e,co:e,gov:e,ltd:e,me:e,net:e,nhs:e,org:e,plc:e,police:e,sch:o}],us:[1,{dni:e,fed:e,isa:e,kids:e,nsn:e,ak:f,al:f,ar:f,as:f,az:f,ca:f,co:f,ct:f,dc:f,de:y,fl:f,ga:f,gu:f,hi:v,ia:f,id:f,il:f,in:f,ks:f,ky:f,la:f,ma:[1,{k12:[1,{pvt:e,chtr:e,paroch:e}],cc:e,lib:e}],md:f,me:f,mi:[1,{k12:e,cc:e,lib:e,"ann-arbor":e,cog:e,dst:e,eaton:e,gen:e,mus:e,tec:e,washtenaw:e}],mn:f,mo:f,ms:f,mt:f,nc:f,nd:v,ne:f,nh:f,nj:f,nm:f,nv:f,ny:f,oh:f,ok:f,or:f,pa:f,pr:f,ri:v,sc:f,sd:v,tn:f,tx:f,ut:f,vi:f,vt:f,va:f,wa:f,wi:f,wv:y,wy:f}],uy:[1,{com:e,edu:e,gub:e,mil:e,net:e,org:e}],uz:[1,{co:e,com:e,net:e,org:e}],va:e,vc:t,ve:[1,{arts:e,bib:e,co:e,com:e,e12:e,edu:e,firm:e,gob:e,gov:e,info:e,int:e,mil:e,net:e,nom:e,org:e,rar:e,rec:e,store:e,tec:e,web:e}],vg:e,vi:[1,{co:e,com:e,k12:e,net:e,org:e}],vn:[1,{ac:e,ai:e,biz:e,com:e,edu:e,gov:e,health:e,id:e,info:e,int:e,io:e,name:e,net:e,org:e,pro:e,angiang:e,bacgiang:e,backan:e,baclieu:e,bacninh:e,"baria-vungtau":e,bentre:e,binhdinh:e,binhduong:e,binhphuoc:e,binhthuan:e,camau:e,cantho:e,caobang:e,daklak:e,daknong:e,danang:e,dienbien:e,dongnai:e,dongthap:e,gialai:e,hagiang:e,haiduong:e,haiphong:e,hanam:e,hanoi:e,hatinh:e,haugiang:e,hoabinh:e,hungyen:e,khanhhoa:e,kiengiang:e,kontum:e,laichau:e,lamdong:e,langson:e,laocai:e,longan:e,namdinh:e,nghean:e,ninhbinh:e,ninhthuan:e,phutho:e,phuyen:e,quangbinh:e,quangnam:e,quangngai:e,quangninh:e,quangtri:e,soctrang:e,sonla:e,tayninh:e,thaibinh:e,thainguyen:e,thanhhoa:e,thanhphohochiminh:e,thuathienhue:e,tiengiang:e,travinh:e,tuyenquang:e,vinhlong:e,vinhphuc:e,yenbai:e}],vu:i,wf:e,ws:n,yt:e,"xn--mgbaam7a8h":e,امارات:e,"xn--y9a3aq":e,հայ:e,"xn--54b7fta0cc":e,বাংলা:e,"xn--90ae":e,бг:e,"xn--mgbcpq6gpa1a":e,البحرين:e,"xn--90ais":e,бел:e,"xn--fiqs8s":e,中国:e,"xn--fiqz9s":e,中國:e,"xn--lgbbat1ad8j":e,الجزائر:e,"xn--wgbh1c":e,مصر:e,"xn--e1a4c":e,ею:e,"xn--qxa6a":e,ευ:e,"xn--mgbah1a3hjkrd":e,موريتانيا:e,"xn--node":e,გე:e,"xn--qxam":e,ελ:e,"xn--j6w193g":[1,{"xn--55qx5d":e,"xn--wcvs22d":e,"xn--mxtq1m":e,"xn--gmqw5a":e,"xn--od0alg":e,"xn--uc0atv":e}],香港:[1,{公司:e,教育:e,政府:e,個人:e,網絡:e,組織:e}],"xn--2scrj9c":e,ಭಾರತ:e,"xn--3hcrj9c":e,ଭାରତ:e,"xn--45br5cyl":e,ভাৰত:e,"xn--h2breg3eve":e,भारतम्:e,"xn--h2brj9c8c":e,भारोत:e,"xn--mgbgu82a":e,ڀارت:e,"xn--rvc1e0am3e":e,ഭാരതം:e,"xn--h2brj9c":e,भारत:e,"xn--mgbbh1a":e,بارت:e,"xn--mgbbh1a71e":e,بھارت:e,"xn--fpcrj9c3d":e,భారత్:e,"xn--gecrj9c":e,ભારત:e,"xn--s9brj9c":e,ਭਾਰਤ:e,"xn--45brj9c":e,ভারত:e,"xn--xkc2dl3a5ee0h":e,இந்தியா:e,"xn--mgba3a4f16a":e,ایران:e,"xn--mgba3a4fra":e,ايران:e,"xn--mgbtx2b":e,عراق:e,"xn--mgbayh7gpa":e,الاردن:e,"xn--3e0b707e":e,한국:e,"xn--80ao21a":e,қаз:e,"xn--q7ce6a":e,ລາວ:e,"xn--fzc2c9e2c":e,ලංකා:e,"xn--xkc2al3hye2a":e,இலங்கை:e,"xn--mgbc0a9azcg":e,المغرب:e,"xn--d1alf":e,мкд:e,"xn--l1acc":e,мон:e,"xn--mix891f":e,澳門:e,"xn--mix082f":e,澳门:e,"xn--mgbx4cd0ab":e,مليسيا:e,"xn--mgb9awbf":e,عمان:e,"xn--mgbai9azgqp6j":e,پاکستان:e,"xn--mgbai9a5eva00b":e,پاكستان:e,"xn--ygbi2ammx":e,فلسطين:e,"xn--90a3ac":[1,{"xn--o1ac":e,"xn--c1avg":e,"xn--90azh":e,"xn--d1at":e,"xn--o1ach":e,"xn--80au":e}],срб:[1,{пр:e,орг:e,обр:e,од:e,упр:e,ак:e}],"xn--p1ai":e,рф:e,"xn--wgbl6a":e,قطر:e,"xn--mgberp4a5d4ar":e,السعودية:e,"xn--mgberp4a5d4a87g":e,السعودیة:e,"xn--mgbqly7c0a67fbc":e,السعودیۃ:e,"xn--mgbqly7cvafr":e,السعوديه:e,"xn--mgbpl2fh":e,سودان:e,"xn--yfro4i67o":e,新加坡:e,"xn--clchc0ea0b2g2a9gcd":e,சிங்கப்பூர்:e,"xn--ogbpf8fl":e,سورية:e,"xn--mgbtf8fl":e,سوريا:e,"xn--o3cw4h":[1,{"xn--12c1fe0br":e,"xn--12co0c3b4eva":e,"xn--h3cuzk1di":e,"xn--o3cyx2a":e,"xn--m3ch0j3a":e,"xn--12cfi8ixb8l":e}],ไทย:[1,{ศึกษา:e,ธุรกิจ:e,รัฐบาล:e,ทหาร:e,เน็ต:e,องค์กร:e}],"xn--pgbs0dh":e,تونس:e,"xn--kpry57d":e,台灣:e,"xn--kprw13d":e,台湾:e,"xn--nnx388a":e,臺灣:e,"xn--j1amh":e,укр:e,"xn--mgb2ddes":e,اليمن:e,xxx:e,ye:t,za:[0,{ac:e,agric:e,alt:e,co:e,edu:e,gov:e,grondar:e,law:e,mil:e,net:e,ngo:e,nic:e,nis:e,nom:e,org:e,school:e,tm:e,web:e}],zm:[1,{ac:e,biz:e,co:e,com:e,edu:e,gov:e,info:e,mil:e,net:e,org:e,sch:e}],zw:[1,{ac:e,co:e,gov:e,mil:e,org:e}],aaa:e,aarp:e,abb:e,abbott:e,abbvie:e,abc:e,able:e,abogado:e,abudhabi:e,academy:e,accenture:e,accountant:e,accountants:e,aco:e,actor:e,ads:e,adult:e,aeg:e,aetna:e,afl:e,africa:e,agakhan:e,agency:e,aig:e,airbus:e,airforce:e,airtel:e,akdn:e,alibaba:e,alipay:e,allfinanz:e,allstate:e,ally:e,alsace:e,alstom:e,amazon:e,americanexpress:e,americanfamily:e,amex:e,amfam:e,amica:e,amsterdam:e,analytics:e,android:e,anquan:e,anz:e,aol:e,apartments:e,app:e,apple:e,aquarelle:e,arab:e,aramco:e,archi:e,army:e,art:e,arte:e,asda:e,associates:e,athleta:e,attorney:e,auction:e,audi:e,audible:e,audio:e,auspost:e,author:e,auto:e,autos:e,avianca:e,aws:e,axa:e,azure:e,baby:e,baidu:e,banamex:e,bananarepublic:e,band:e,bank:e,bar:e,barcelona:e,barclaycard:e,barclays:e,barefoot:e,bargains:e,baseball:e,basketball:e,bauhaus:e,bayern:e,bbc:e,bbt:e,bbva:e,bcg:e,bcn:e,beats:e,beauty:e,beer:e,bentley:e,berlin:e,best:e,bestbuy:e,bet:e,bharti:e,bible:e,bid:e,bike:e,bing:e,bingo:e,bio:e,black:e,blackfriday:e,blockbuster:e,blog:e,bloomberg:e,blue:e,bms:e,bmw:e,bnpparibas:e,boats:e,boehringer:e,bofa:e,bom:e,bond:e,boo:e,book:e,booking:e,bosch:e,bostik:e,boston:e,bot:e,boutique:e,box:e,bradesco:e,bridgestone:e,broadway:e,broker:e,brother:e,brussels:e,build:e,builders:e,business:e,buy:e,buzz:e,bzh:e,cab:e,cafe:e,cal:e,call:e,calvinklein:e,cam:e,camera:e,camp:e,canon:e,capetown:e,capital:e,capitalone:e,car:e,caravan:e,cards:e,care:e,career:e,careers:e,cars:e,casa:e,case:e,cash:e,casino:e,catering:e,catholic:e,cba:e,cbn:e,cbre:e,center:e,ceo:e,cern:e,cfa:e,cfd:e,chanel:e,channel:e,charity:e,chase:e,chat:e,cheap:e,chintai:e,christmas:e,chrome:e,church:e,cipriani:e,circle:e,cisco:e,citadel:e,citi:e,citic:e,city:e,claims:e,cleaning:e,click:e,clinic:e,clinique:e,clothing:e,cloud:e,club:e,clubmed:e,coach:e,codes:e,coffee:e,college:e,cologne:e,comcast:e,commbank:e,community:e,company:e,compare:e,computer:e,comsec:e,condos:e,construction:e,consulting:e,contact:e,contractors:e,cooking:e,cool:e,corsica:e,country:e,coupon:e,coupons:e,courses:e,cpa:e,credit:e,creditcard:e,creditunion:e,cricket:e,crown:e,crs:e,cruise:e,cruises:e,cuisinella:e,cymru:e,cyou:e,dabur:e,dad:e,dance:e,data:e,date:e,dating:e,datsun:e,day:e,dclk:e,dds:e,deal:e,dealer:e,deals:e,degree:e,delivery:e,dell:e,deloitte:e,delta:e,democrat:e,dental:e,dentist:e,desi:e,design:e,dev:e,dhl:e,diamonds:e,diet:e,digital:e,direct:e,directory:e,discount:e,discover:e,dish:e,diy:e,dnp:e,docs:e,doctor:e,dog:e,domains:e,dot:e,download:e,drive:e,dtv:e,dubai:e,dunlop:e,dupont:e,durban:e,dvag:e,dvr:e,earth:e,eat:e,eco:e,edeka:e,education:e,email:e,emerck:e,energy:e,engineer:e,engineering:e,enterprises:e,epson:e,equipment:e,ericsson:e,erni:e,esq:e,estate:e,eurovision:e,eus:e,events:e,exchange:e,expert:e,exposed:e,express:e,extraspace:e,fage:e,fail:e,fairwinds:e,faith:e,family:e,fan:e,fans:e,farm:e,farmers:e,fashion:e,fast:e,fedex:e,feedback:e,ferrari:e,ferrero:e,fidelity:e,fido:e,film:e,final:e,finance:e,financial:e,fire:e,firestone:e,firmdale:e,fish:e,fishing:e,fit:e,fitness:e,flickr:e,flights:e,flir:e,florist:e,flowers:e,fly:e,foo:e,food:e,football:e,ford:e,forex:e,forsale:e,forum:e,foundation:e,fox:e,free:e,fresenius:e,frl:e,frogans:e,frontier:e,ftr:e,fujitsu:e,fun:e,fund:e,furniture:e,futbol:e,fyi:e,gal:e,gallery:e,gallo:e,gallup:e,game:e,games:e,gap:e,garden:e,gay:e,gbiz:e,gdn:e,gea:e,gent:e,genting:e,george:e,ggee:e,gift:e,gifts:e,gives:e,giving:e,glass:e,gle:e,global:e,globo:e,gmail:e,gmbh:e,gmo:e,gmx:e,godaddy:e,gold:e,goldpoint:e,golf:e,goo:e,goodyear:e,goog:e,google:e,gop:e,got:e,grainger:e,graphics:e,gratis:e,green:e,gripe:e,grocery:e,group:e,guardian:e,gucci:e,guge:e,guide:e,guitars:e,guru:e,hair:e,hamburg:e,hangout:e,haus:e,hbo:e,hdfc:e,hdfcbank:e,health:e,healthcare:e,help:e,helsinki:e,here:e,hermes:e,hiphop:e,hisamitsu:e,hitachi:e,hiv:e,hkt:e,hockey:e,holdings:e,holiday:e,homedepot:e,homegoods:e,homes:e,homesense:e,honda:e,horse:e,hospital:e,host:e,hosting:e,hot:e,hotels:e,hotmail:e,house:e,how:e,hsbc:e,hughes:e,hyatt:e,hyundai:e,ibm:e,icbc:e,ice:e,icu:e,ieee:e,ifm:e,ikano:e,imamat:e,imdb:e,immo:e,immobilien:e,inc:e,industries:e,infiniti:e,ing:e,ink:e,institute:e,insurance:e,insure:e,international:e,intuit:e,investments:e,ipiranga:e,irish:e,ismaili:e,ist:e,istanbul:e,itau:e,itv:e,jaguar:e,java:e,jcb:e,jeep:e,jetzt:e,jewelry:e,jio:e,jll:e,jmp:e,jnj:e,joburg:e,jot:e,joy:e,jpmorgan:e,jprs:e,juegos:e,juniper:e,kaufen:e,kddi:e,kerryhotels:e,kerrylogistics:e,kerryproperties:e,kfh:e,kia:e,kids:e,kim:e,kindle:e,kitchen:e,kiwi:e,koeln:e,komatsu:e,kosher:e,kpmg:e,kpn:e,krd:e,kred:e,kuokgroup:e,kyoto:e,lacaixa:e,lamborghini:e,lamer:e,lancaster:e,land:e,landrover:e,lanxess:e,lasalle:e,lat:e,latino:e,latrobe:e,law:e,lawyer:e,lds:e,lease:e,leclerc:e,lefrak:e,legal:e,lego:e,lexus:e,lgbt:e,lidl:e,life:e,lifeinsurance:e,lifestyle:e,lighting:e,like:e,lilly:e,limited:e,limo:e,lincoln:e,link:e,lipsy:e,live:e,living:e,llc:e,llp:e,loan:e,loans:e,locker:e,locus:e,lol:e,london:e,lotte:e,lotto:e,love:e,lpl:e,lplfinancial:e,ltd:e,ltda:e,lundbeck:e,luxe:e,luxury:e,madrid:e,maif:e,maison:e,makeup:e,man:e,management:e,mango:e,map:e,market:e,marketing:e,markets:e,marriott:e,marshalls:e,mattel:e,mba:e,mckinsey:e,med:e,media:e,meet:e,melbourne:e,meme:e,memorial:e,men:e,menu:e,merckmsd:e,miami:e,microsoft:e,mini:e,mint:e,mit:e,mitsubishi:e,mlb:e,mls:e,mma:e,mobile:e,moda:e,moe:e,moi:e,mom:e,monash:e,money:e,monster:e,mormon:e,mortgage:e,moscow:e,moto:e,motorcycles:e,mov:e,movie:e,msd:e,mtn:e,mtr:e,music:e,nab:e,nagoya:e,natura:e,navy:e,nba:e,nec:e,netbank:e,netflix:e,network:e,neustar:e,new:e,news:e,next:e,nextdirect:e,nexus:e,nfl:e,ngo:e,nhk:e,nico:e,nike:e,nikon:e,ninja:e,nissan:e,nissay:e,nokia:e,norton:e,now:e,nowruz:e,nowtv:e,nra:e,nrw:e,ntt:e,nyc:e,obi:e,observer:e,office:e,okinawa:e,olayan:e,olayangroup:e,oldnavy:e,ollo:e,omega:e,one:e,ong:e,onl:e,online:e,ooo:e,open:e,oracle:e,orange:e,organic:e,origins:e,osaka:e,otsuka:e,ott:e,ovh:e,page:e,panasonic:e,paris:e,pars:e,partners:e,parts:e,party:e,pay:e,pccw:e,pet:e,pfizer:e,pharmacy:e,phd:e,philips:e,phone:e,photo:e,photography:e,photos:e,physio:e,pics:e,pictet:e,pictures:e,pid:e,pin:e,ping:e,pink:e,pioneer:e,pizza:e,place:e,play:e,playstation:e,plumbing:e,plus:e,pnc:e,pohl:e,poker:e,politie:e,porn:e,pramerica:e,praxi:e,press:e,prime:e,prod:e,productions:e,prof:e,progressive:e,promo:e,properties:e,property:e,protection:e,pru:e,prudential:e,pub:e,pwc:e,qpon:e,quebec:e,quest:e,racing:e,radio:e,read:e,realestate:e,realtor:e,realty:e,recipes:e,red:e,redstone:e,redumbrella:e,rehab:e,reise:e,reisen:e,reit:e,reliance:e,ren:e,rent:e,rentals:e,repair:e,report:e,republican:e,rest:e,restaurant:e,review:e,reviews:e,rexroth:e,rich:e,richardli:e,ricoh:e,ril:e,rio:e,rip:e,rocks:e,rodeo:e,rogers:e,room:e,rsvp:e,rugby:e,ruhr:e,run:e,rwe:e,ryukyu:e,saarland:e,safe:e,safety:e,sakura:e,sale:e,salon:e,samsclub:e,samsung:e,sandvik:e,sandvikcoromant:e,sanofi:e,sap:e,sarl:e,sas:e,save:e,saxo:e,sbi:e,sbs:e,sca:e,scb:e,schaeffler:e,schmidt:e,scholarships:e,school:e,schule:e,schwarz:e,science:e,scot:e,search:e,seat:e,secure:e,security:e,seek:e,select:e,sener:e,services:e,seven:e,sew:e,sex:e,sexy:e,sfr:e,shangrila:e,sharp:e,shaw:e,shell:e,shia:e,shiksha:e,shoes:e,shop:e,shopping:e,shouji:e,show:e,silk:e,sina:e,singles:e,site:e,ski:e,skin:e,sky:e,skype:e,sling:e,smart:e,smile:e,sncf:e,soccer:e,social:e,softbank:e,software:e,sohu:e,solar:e,solutions:e,song:e,sony:e,soy:e,spa:e,space:e,sport:e,spot:e,srl:e,stada:e,staples:e,star:e,statebank:e,statefarm:e,stc:e,stcgroup:e,stockholm:e,storage:e,store:e,stream:e,studio:e,study:e,style:e,sucks:e,supplies:e,supply:e,support:e,surf:e,surgery:e,suzuki:e,swatch:e,swiss:e,sydney:e,systems:e,tab:e,taipei:e,talk:e,taobao:e,target:e,tatamotors:e,tatar:e,tattoo:e,tax:e,taxi:e,tci:e,tdk:e,team:e,tech:e,technology:e,temasek:e,tennis:e,teva:e,thd:e,theater:e,theatre:e,tiaa:e,tickets:e,tienda:e,tips:e,tires:e,tirol:e,tjmaxx:e,tjx:e,tkmaxx:e,tmall:e,today:e,tokyo:e,tools:e,top:e,toray:e,toshiba:e,total:e,tours:e,town:e,toyota:e,toys:e,trade:e,trading:e,training:e,travel:e,travelers:e,travelersinsurance:e,trust:e,trv:e,tube:e,tui:e,tunes:e,tushu:e,tvs:e,ubank:e,ubs:e,unicom:e,university:e,uno:e,uol:e,ups:e,vacations:e,vana:e,vanguard:e,vegas:e,ventures:e,verisign:e,versicherung:e,vet:e,viajes:e,video:e,vig:e,viking:e,villas:e,vin:e,vip:e,virgin:e,visa:e,vision:e,viva:e,vivo:e,vlaanderen:e,vodka:e,volvo:e,vote:e,voting:e,voto:e,voyage:e,wales:e,walmart:e,walter:e,wang:e,wanggou:e,watch:e,watches:e,weather:e,weatherchannel:e,webcam:e,weber:e,website:e,wed:e,wedding:e,weibo:e,weir:e,whoswho:e,wien:e,wiki:e,williamhill:e,win:e,windows:e,wine:e,winners:e,wme:e,wolterskluwer:e,woodside:e,work:e,works:e,world:e,wow:e,wtc:e,wtf:e,xbox:e,xerox:e,xfinity:e,xihuan:e,xin:e,"xn--11b4c3d":e,कॉम:e,"xn--1ck2e1b":e,セール:e,"xn--1qqw23a":e,佛山:e,"xn--30rr7y":e,慈善:e,"xn--3bst00m":e,集团:e,"xn--3ds443g":e,在线:e,"xn--3pxu8k":e,点看:e,"xn--42c2d9a":e,คอม:e,"xn--45q11c":e,八卦:e,"xn--4gbrim":e,موقع:e,"xn--55qw42g":e,公益:e,"xn--55qx5d":e,公司:e,"xn--5su34j936bgsg":e,香格里拉:e,"xn--5tzm5g":e,网站:e,"xn--6frz82g":e,移动:e,"xn--6qq986b3xl":e,我爱你:e,"xn--80adxhks":e,москва:e,"xn--80aqecdr1a":e,католик:e,"xn--80asehdb":e,онлайн:e,"xn--80aswg":e,сайт:e,"xn--8y0a063a":e,联通:e,"xn--9dbq2a":e,קום:e,"xn--9et52u":e,时尚:e,"xn--9krt00a":e,微博:e,"xn--b4w605ferd":e,淡马锡:e,"xn--bck1b9a5dre4c":e,ファッション:e,"xn--c1avg":e,орг:e,"xn--c2br7g":e,नेट:e,"xn--cck2b3b":e,ストア:e,"xn--cckwcxetd":e,アマゾン:e,"xn--cg4bki":e,삼성:e,"xn--czr694b":e,商标:e,"xn--czrs0t":e,商店:e,"xn--czru2d":e,商城:e,"xn--d1acj3b":e,дети:e,"xn--eckvdtc9d":e,ポイント:e,"xn--efvy88h":e,新闻:e,"xn--fct429k":e,家電:e,"xn--fhbei":e,كوم:e,"xn--fiq228c5hs":e,中文网:e,"xn--fiq64b":e,中信:e,"xn--fjq720a":e,娱乐:e,"xn--flw351e":e,谷歌:e,"xn--fzys8d69uvgm":e,電訊盈科:e,"xn--g2xx48c":e,购物:e,"xn--gckr3f0f":e,クラウド:e,"xn--gk3at1e":e,通販:e,"xn--hxt814e":e,网店:e,"xn--i1b6b1a6a2e":e,संगठन:e,"xn--imr513n":e,餐厅:e,"xn--io0a7i":e,网络:e,"xn--j1aef":e,ком:e,"xn--jlq480n2rg":e,亚马逊:e,"xn--jvr189m":e,食品:e,"xn--kcrx77d1x4a":e,飞利浦:e,"xn--kput3i":e,手机:e,"xn--mgba3a3ejt":e,ارامكو:e,"xn--mgba7c0bbn0a":e,العليان:e,"xn--mgbab2bd":e,بازار:e,"xn--mgbca7dzdo":e,ابوظبي:e,"xn--mgbi4ecexp":e,كاثوليك:e,"xn--mgbt3dhd":e,همراه:e,"xn--mk1bu44c":e,닷컴:e,"xn--mxtq1m":e,政府:e,"xn--ngbc5azd":e,شبكة:e,"xn--ngbe9e0a":e,بيتك:e,"xn--ngbrx":e,عرب:e,"xn--nqv7f":e,机构:e,"xn--nqv7fs00ema":e,组织机构:e,"xn--nyqy26a":e,健康:e,"xn--otu796d":e,招聘:e,"xn--p1acf":e,рус:e,"xn--pssy2u":e,大拿:e,"xn--q9jyb4c":e,みんな:e,"xn--qcka1pmc":e,グーグル:e,"xn--rhqv96g":e,世界:e,"xn--rovu88b":e,書籍:e,"xn--ses554g":e,网址:e,"xn--t60b56a":e,닷넷:e,"xn--tckwe":e,コム:e,"xn--tiq49xqyj":e,天主教:e,"xn--unup4y":e,游戏:e,"xn--vermgensberater-ctb":e,vermögensberater:e,"xn--vermgensberatung-pwb":e,vermögensberatung:e,"xn--vhquv":e,企业:e,"xn--vuq861b":e,信息:e,"xn--w4r85el8fhu5dnra":e,嘉里大酒店:e,"xn--w4rs40l":e,嘉里:e,"xn--xhq521b":e,广东:e,"xn--zfr164b":e,政务:e,xyz:e,yachts:e,yahoo:e,yamaxun:e,yandex:e,yodobashi:e,yoga:e,yokohama:e,you:e,youtube:e,yun:e,zappos:e,zara:e,zero:e,zip:e,zone:e,zuerich:e}]}()});function LF(e,t,n){let r=null,a=t;for(;a!==void 0&&(a[0]===1&&(r={index:n+1}),n!==-1);){let o=a[1];a=Object.prototype.hasOwnProperty.call(o,e[n])?o[e[n]]:o["*"],n-=1}return r}function Ig(e,t,n){var r;if(hp(e,t,n))return;let a=e.split("."),o=LF(a,IF,a.length-1);if(o!==null){n.publicSuffix=a.slice(o.index+1).join(".");return}let i=LF(a,NF,a.length-1);if(i!==null){n.publicSuffix=a.slice(i.index).join(".");return}n.publicSuffix=(r=a[a.length-1])!==null&&r!==void 0?r:null}var PF=b(()=>{d();Fg();MF();s(LF,"lookupInTrie");s(Ig,"suffixLookup")});function BF(e,t={}){return _g(OF),Rg(e,3,Ig,t,OF).domain}var OF,UF=b(()=>{d();Fg();PF();OF=Ag();s(BF,"getDomain")});var Ke,UK,jF,qF,j,jK,It=b(()=>{"use strict";d();A();Ke={didntCollectScreenshots:"Chrome didn't collect any screenshots during the page load. Please make sure there is content visible on the page, and then try re-running Lighthouse. ({errorCode})",badTraceRecording:"Something went wrong with recording the trace over your page load. Please run Lighthouse again. ({errorCode})",noFcp:"The page did not paint any content. Please ensure you keep the browser window in the foreground during the load and try again. ({errorCode})",noLcp:"The page did not display content that qualifies as a Largest Contentful Paint (LCP). Ensure the page has a valid LCP element and then try again. ({errorCode})",pageLoadTookTooLong:"Your page took too long to load. Please follow the opportunities in the report to reduce your page load time, and then try re-running Lighthouse. ({errorCode})",pageLoadFailed:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests.",pageLoadFailedWithStatusCode:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests. (Status code: {statusCode})",pageLoadFailedWithDetails:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests. (Details: {errorDetails})",pageLoadFailedInsecure:"The URL you have provided does not have a valid security certificate. {securityMessages}",pageLoadFailedInterstitial:"Chrome prevented page load with an interstitial. Make sure you are testing the correct URL and that the server is properly responding to all requests.",internalChromeError:"An internal Chrome error occurred. Please restart Chrome and try re-running Lighthouse.",requestContentTimeout:"Fetching resource content has exceeded the allotted time",notHtml:"The page provided is not HTML (served as MIME type {mimeType}).",urlInvalid:"The URL you have provided appears to be invalid.",protocolTimeout:"Waiting for DevTools protocol response has exceeded the allotted time. (Method: {protocolMethod})",dnsFailure:"DNS servers could not resolve the provided domain.",pageLoadFailedHung:"Lighthouse was unable to reliably load the URL you requested because the page stopped responding.",criTimeout:"Timeout waiting for initial Debugger Protocol connection.",missingRequiredArtifact:"Required {artifactName} gatherer did not run.",erroredRequiredArtifact:"Required {artifactName} gatherer encountered an error: {errorMessage}",oldChromeDoesNotSupportFeature:"This version of Chrome is too old to support '{featureName}'. Use a newer version to see full results."},UK=w("core/lib/lh-error.js",Ke),jF="__LighthouseErrorSentinel",qF="__ErrorSentinel",j=class e extends Error{static{s(this,"LighthouseError")}constructor(t,n,r){super(t.code,r),this.name="LighthouseError",this.code=t.code,this.friendlyMessage=UK(t.message,{errorCode:this.code,...n}),this.lhrRuntimeError=!!t.lhrRuntimeError,n&&Object.assign(this,n),Error.captureStackTrace(this,e)}static fromProtocolMessage(t,n){let r=Object.values(e.errors).filter(i=>i.pattern).find(i=>i.pattern&&i.pattern.test(n.message));if(r)return new e(r);let a=`(${t}): ${n.message}`;n.data&&(a+=` (${n.data})`);let o=new Error(`Protocol error ${a}`);return Object.assign(o,{protocolMethod:t,protocolError:n.message})}static stringifyReplacer(t){if(t instanceof e){let{name:n,code:r,message:a,friendlyMessage:o,lhrRuntimeError:i,stack:c,cause:u,...l}=t;return{sentinel:jF,code:r,stack:c,cause:u,properties:l}}if(t instanceof Error){let{message:n,stack:r,cause:a}=t,o=t.code;return{sentinel:qF,message:n,code:o,stack:r,cause:a}}throw new Error("Invalid value for LighthouseError stringification")}static parseReviver(t,n){if(typeof n=="object"&&n!==null){if(n.sentinel===jF){let{code:r,stack:a,cause:o,properties:i}=n,c=e.errors[r],u=new e(c,i,{cause:o});return u.stack=a,u}if(n.sentinel===qF){let{message:r,code:a,stack:o,cause:i}=n,c=i?{cause:i}:void 0,u=new Error(r,c);return Object.assign(u,{code:a,stack:o}),u}}return n}},jK={NO_SPEEDLINE_FRAMES:{code:"NO_SPEEDLINE_FRAMES",message:Ke.didntCollectScreenshots,lhrRuntimeError:!0},SPEEDINDEX_OF_ZERO:{code:"SPEEDINDEX_OF_ZERO",message:Ke.didntCollectScreenshots,lhrRuntimeError:!0},NO_SCREENSHOTS:{code:"NO_SCREENSHOTS",message:Ke.didntCollectScreenshots,lhrRuntimeError:!0},INVALID_SPEEDLINE:{code:"INVALID_SPEEDLINE",message:Ke.didntCollectScreenshots,lhrRuntimeError:!0},NO_TRACING_STARTED:{code:"NO_TRACING_STARTED",message:Ke.badTraceRecording,lhrRuntimeError:!0},NO_RESOURCE_REQUEST:{code:"NO_RESOURCE_REQUEST",message:Ke.badTraceRecording,lhrRuntimeError:!0},NO_NAVSTART:{code:"NO_NAVSTART",message:Ke.badTraceRecording,lhrRuntimeError:!0},NO_FCP:{code:"NO_FCP",message:Ke.noFcp,lhrRuntimeError:!0},NO_DCL:{code:"NO_DCL",message:Ke.badTraceRecording,lhrRuntimeError:!0},NO_FMP:{code:"NO_FMP",message:Ke.badTraceRecording},NO_LCP:{code:"NO_LCP",message:Ke.noLcp},NO_LCP_ALL_FRAMES:{code:"NO_LCP_ALL_FRAMES",message:Ke.noLcp},UNSUPPORTED_OLD_CHROME:{code:"UNSUPPORTED_OLD_CHROME",message:Ke.oldChromeDoesNotSupportFeature},NO_TTI_CPU_IDLE_PERIOD:{code:"NO_TTI_CPU_IDLE_PERIOD",message:Ke.pageLoadTookTooLong},NO_TTI_NETWORK_IDLE_PERIOD:{code:"NO_TTI_NETWORK_IDLE_PERIOD",message:Ke.pageLoadTookTooLong},NO_DOCUMENT_REQUEST:{code:"NO_DOCUMENT_REQUEST",message:Ke.pageLoadFailed,lhrRuntimeError:!0},FAILED_DOCUMENT_REQUEST:{code:"FAILED_DOCUMENT_REQUEST",message:Ke.pageLoadFailedWithDetails,lhrRuntimeError:!0},ERRORED_DOCUMENT_REQUEST:{code:"ERRORED_DOCUMENT_REQUEST",message:Ke.pageLoadFailedWithStatusCode,lhrRuntimeError:!0},INSECURE_DOCUMENT_REQUEST:{code:"INSECURE_DOCUMENT_REQUEST",message:Ke.pageLoadFailedInsecure,lhrRuntimeError:!0},CHROME_INTERSTITIAL_ERROR:{code:"CHROME_INTERSTITIAL_ERROR",message:Ke.pageLoadFailedInterstitial,lhrRuntimeError:!0},PAGE_HUNG:{code:"PAGE_HUNG",message:Ke.pageLoadFailedHung,lhrRuntimeError:!0},NOT_HTML:{code:"NOT_HTML",message:Ke.notHtml,lhrRuntimeError:!0},TRACING_ALREADY_STARTED:{code:"TRACING_ALREADY_STARTED",message:Ke.internalChromeError,pattern:/Tracing.*started/,lhrRuntimeError:!0},PARSING_PROBLEM:{code:"PARSING_PROBLEM",message:Ke.internalChromeError,pattern:/Parsing problem/,lhrRuntimeError:!0},READ_FAILED:{code:"READ_FAILED",message:Ke.internalChromeError,pattern:/Read failed/,lhrRuntimeError:!0},INVALID_URL:{code:"INVALID_URL",message:Ke.urlInvalid},PROTOCOL_TIMEOUT:{code:"PROTOCOL_TIMEOUT",message:Ke.protocolTimeout,lhrRuntimeError:!0},DNS_FAILURE:{code:"DNS_FAILURE",message:Ke.dnsFailure,lhrRuntimeError:!0},CRI_TIMEOUT:{code:"CRI_TIMEOUT",message:Ke.criTimeout,lhrRuntimeError:!0},MISSING_REQUIRED_ARTIFACT:{code:"MISSING_REQUIRED_ARTIFACT",message:Ke.missingRequiredArtifact},ERRORED_REQUIRED_ARTIFACT:{code:"ERRORED_REQUIRED_ARTIFACT",message:Ke.erroredRequiredArtifact}};j.errors=jK;j.NO_ERROR="NO_ERROR";j.UNKNOWN_ERROR="UNKNOWN_ERROR"});function VK(e){return!e||!e.startsWith("chrome://")?e:(e.endsWith("/")&&(e=e.replace(/\/$/,"")),e.replace(/^chrome:\/\/chrome\//,"chrome://"))}var qK,zK,HK,GK,gp,Y,Ze=b(()=>{"use strict";d();UF();Fn();It();qK=["https:","http:","chrome:","chrome-extension:"],zK=["data","https","wss","blob","chrome","chrome-extension","about","filesystem"],HK=["localhost","127.0.0.1"],GK=["blob","data","intent","file","filesystem","chrome-extension"];s(VK,"rewriteChromeInternalUrl");gp=class e{static{s(this,"UrlUtils")}static isValid(t){try{return new URL(t),!0}catch{return!1}}static hostsMatch(t,n){try{return new URL(t).host===new URL(n).host}catch{return!1}}static originsMatch(t,n){try{return new URL(t).origin===new URL(n).origin}catch{return!1}}static getOrigin(t){try{let n=new URL(t);return n.protocol==="chrome-extension:"?Me.getChromeExtensionOrigin(t):n.host&&n.origin||null}catch{return null}}static getRootDomain(t){let n=Me.createOrReturnURL(t);return BF(n.href)||n.hostname}static rootDomainsMatch(t,n){let r,a;try{r=Me.createOrReturnURL(t),a=Me.createOrReturnURL(n)}catch{return!1}if(!r.hostname||!a.hostname)return!1;let o=e.getRootDomain(r),i=e.getRootDomain(a);return o===i}static getURLDisplayName(t,n){return Me.getURLDisplayName(new URL(t),n)}static elideDataURI(t){try{return new URL(t).protocol==="data:"?Me.truncate(t,100):t}catch{return t}}static equalWithExcludedFragments(t,n){[t,n]=[t,n].map(VK);try{let r=new URL(t);r.hash="";let a=new URL(n);return a.hash="",r.href===a.href}catch{return!1}}static isProtocolAllowed(t){try{let n=new URL(t);return qK.includes(n.protocol)}catch{return!1}}static isLikeLocalhost(t){return HK.includes(t)||t.endsWith(".localhost")}static isSecureScheme(t){return zK.includes(t)}static isNonNetworkProtocol(t){let n=t.includes(":")?t.slice(0,t.indexOf(":")):t;return GK.includes(n)}static guessMimeType(t){let n;try{n=new URL(t)}catch{return}if(n.protocol==="data:"){let o=n.pathname.match(/^(image\/(png|jpeg|svg\+xml|webp|gif|avif))[;,]/);return o?o[1]:void 0}let r=n.pathname.toLowerCase().match(/\.(png|jpeg|jpg|svg|webp|gif|avif)$/);if(!r)return;let a=r[1];return a==="svg"?"image/svg+xml":a==="jpg"?"image/jpeg":`image/${a}`}static normalizeUrl(t){if(t&&this.isValid(t)&&this.isProtocolAllowed(t))return new URL(t).href;throw new j(j.errors.INVALID_URL)}};gp.INVALID_URL_DEBUG_STRING="Lighthouse was unable to determine the URL of some script executions. It's possible a Chrome extension or other eval'd code is the source.";Y=gp});var zF,WK,$K,Gt,Uo=b(()=>{"use strict";d();Ze();zF=14*1024,WK=.4,$K={Document:.9,XHR:.9,Fetch:.9},Gt=class e{static{s(this,"NetworkAnalyzer")}static get SUMMARY(){return"__SUMMARY__"}static groupByOrigin(t){let n=new Map;return t.forEach(r=>{let a=r.parsedURL.securityOrigin,o=n.get(a)||[];o.push(r),n.set(a,o)}),n}static getSummary(t){t.sort((r,a)=>r-a);let n;if(t.length===0)n=t[0];else if(t.length%2===0){let r=t[Math.floor((t.length-1)/2)],a=t[Math.floor((t.length-1)/2)+1];n=(r+a)/2}else n=t[Math.floor((t.length-1)/2)];return{min:t[0],max:t[t.length-1],avg:t.reduce((r,a)=>r+a,0)/t.length,median:n}}static summarize(t){let n=new Map,r=[];for(let[a,o]of t)n.set(a,e.getSummary(o)),r.push(...o);return n.set(e.SUMMARY,e.getSummary(r)),n}static _estimateValueByOrigin(t,n){let r=e.estimateIfConnectionWasReused(t),a=e.groupByOrigin(t),o=new Map;for(let[i,c]of a.entries()){let u=[];for(let l of c){let m=l.timing;if(!m)continue;let p=n({record:l,timing:m,connectionReused:r.get(l.requestId)});typeof p<"u"&&(u=u.concat(p))}u.length&&o.set(i,u)}return o}static _estimateRTTViaConnectionTiming(t){let{timing:n,connectionReused:r,record:a}=t;if(r)return;if(globalThis.isLightrider&&a.lrStatistics)return a.protocol.startsWith("h3")?a.lrStatistics.TCPMs:[a.lrStatistics.TCPMs/2,a.lrStatistics.TCPMs/2];let{connectStart:o,sslStart:i,sslEnd:c,connectEnd:u}=n;if(u>=0&&o>=0&&a.protocol.startsWith("h3"))return u-o;if(i>=0&&c>=0&&i!==o)return[u-i,i-o];if(o>=0&&u>=0)return u-o}static _estimateRTTViaDownloadTiming(t){let{timing:n,connectionReused:r,record:a}=t;if(r||a.transferSize<=zF||!Number.isFinite(n.receiveHeadersEnd)||n.receiveHeadersEnd<0)return;let i=a.networkEndTime-a.networkRequestTime-n.receiveHeadersEnd,c=Math.log2(a.transferSize/zF);if(!(c>5))return i/c}static _estimateRTTViaSendStartTiming(t){let{timing:n,connectionReused:r,record:a}=t;if(r||!Number.isFinite(n.sendStart)||n.sendStart<0)return;let o=1;return a.protocol.startsWith("h3")||(o+=1),a.parsedURL.scheme==="https"&&(o+=1),n.sendStart/o}static _estimateRTTViaHeadersEndTiming(t){let{timing:n,connectionReused:r,record:a}=t;if(!Number.isFinite(n.receiveHeadersEnd)||n.receiveHeadersEnd<0||!a.resourceType)return;let o=$K[a.resourceType]||WK,i=n.receiveHeadersEnd*o,c=1;return r||(c+=1,a.protocol.startsWith("h3")||(c+=1),a.parsedURL.scheme==="https"&&(c+=1)),Math.max((n.receiveHeadersEnd-i)/c,3)}static _estimateResponseTimeByOrigin(t,n){return e._estimateValueByOrigin(t,({record:r,timing:a})=>{if(globalThis.isLightrider&&r.lrStatistics)return r.lrStatistics.requestMs;if(!Number.isFinite(a.receiveHeadersEnd)||a.receiveHeadersEnd<0||!Number.isFinite(a.sendEnd)||a.sendEnd<0)return;let o=a.receiveHeadersEnd-a.sendEnd,i=r.parsedURL.securityOrigin,c=n.get(i)||n.get(e.SUMMARY)||0;return Math.max(o-c,0)})}static canTrustConnectionInformation(t){let n=new Map;for(let r of t){let a=n.get(r.connectionId)||!r.connectionReused;n.set(r.connectionId,a)}return n.size<=1?!1:Array.from(n.values()).every(r=>r)}static estimateIfConnectionWasReused(t,n){let{forceCoarseEstimates:r=!1}=n||{};if(!r&&e.canTrustConnectionInformation(t))return new Map(t.map(i=>[i.requestId,!!i.connectionReused]));let a=new Map,o=e.groupByOrigin(t);for(let[i,c]of o.entries()){let u=c.map(m=>m.networkEndTime).reduce((m,p)=>Math.min(m,p),1/0);for(let m of c)a.set(m.requestId,m.networkRequestTime>=u||m.protocol==="h2");let l=c.reduce((m,p)=>m.networkRequestTime>p.networkRequestTime?p:m);a.set(l.requestId,!1)}return a}static estimateRTTByOrigin(t,n){let{forceCoarseEstimates:r=!1,coarseEstimateMultiplier:a=.3,useDownloadEstimates:o=!0,useSendStartEstimates:i=!0,useHeadersEndEstimates:c=!0}=n||{},u=e.estimateIfConnectionWasReused(t),l=e.groupByOrigin(t),m=new Map;for(let[h,f]of l.entries()){let v=function(D,E=1){for(let S of f){let k=S.timing;if(!k)continue;let C=D({record:S,timing:k,connectionReused:u.get(S.requestId)});C!==void 0&&(Array.isArray(C)?y.push(...C.map(R=>R*E)):y.push(C*E))}};var p=v;s(v,"collectEstimates");let y=[];r||v(this._estimateRTTViaConnectionTiming),y.length||(o&&v(this._estimateRTTViaDownloadTiming,a),i&&v(this._estimateRTTViaSendStartTiming,a),c&&v(this._estimateRTTViaHeadersEndTiming,a)),y.length&&m.set(h,y)}if(!m.size)throw new Error("No timing information available");return e.summarize(m)}static estimateServerResponseTimeByOrigin(t,n){let r=(n||{}).rttByOrigin;if(!r){r=new Map;let o=e.estimateRTTByOrigin(t,n);for(let[i,c]of o.entries())r.set(i,c.min)}let a=e._estimateResponseTimeByOrigin(t,r);return e.summarize(a)}static estimateThroughput(t){let n=0,r=t.reduce((c,u)=>(u.parsedURL?.scheme==="data"||u.failed||!u.finished||u.statusCode>300||!u.transferSize||(n+=u.transferSize,c.push({time:u.responseHeadersEndTime/1e3,isStart:!0}),c.push({time:u.networkEndTime/1e3,isStart:!1})),c),[]).sort((c,u)=>c.time-u.time);if(!r.length)return 1/0;let a=0,o=0,i=0;return r.forEach(c=>{c.isStart?(a===0&&(o=c.time),a++):(a--,a===0&&(i+=c.time-o))}),n*8/i}static findResourceForUrl(t,n){return t.find(r=>n.startsWith(r.url)&&Y.equalWithExcludedFragments(r.url,n))}static findLastDocumentForUrl(t,n){let r=t.filter(a=>a.resourceType==="Document"&&n.startsWith(a.url)&&Y.equalWithExcludedFragments(a.url,n));return r[r.length-1]}static resolveRedirects(t){for(;t.redirectDestination;)t=t.redirectDestination;return t}}});var YK,KK,XK,yp,HF=b(()=>{"use strict";d();jt();Uo();Dg();YK=30,KK=["https","wss"],XK=6,yp=class{static{s(this,"ConnectionPool")}constructor(t,n){this._options=n,this._records=t,this._connectionsByOrigin=new Map,this._connectionsByRecord=new Map,this._connectionsInUse=new Set,this._connectionReusedByRequestId=Gt.estimateIfConnectionWasReused(t,{forceCoarseEstimates:!0}),this._initializeConnections()}connectionsInUse(){return Array.from(this._connectionsInUse)}_initializeConnections(){let t=this._connectionReusedByRequestId,n=this._options.additionalRttByOrigin,r=this._options.serverResponseTimeByOrigin,a=Gt.groupByOrigin(this._records);for(let[o,i]of a.entries()){let c=[],u=n.get(o)||0,l=r.get(o)||YK;for(let p of i){if(t.get(p.requestId))continue;let h=KK.includes(p.parsedURL.scheme),f=p.protocol==="h2",y=new Ki(this._options.rtt+u,this._options.throughput,l,h,f);c.push(y)}if(!c.length)throw new Error(`Could not find a connection for origin: ${o}`);let m=c[0].isH2()?1:XK;for(;c.length<m;)c.push(c[0].clone());this._connectionsByOrigin.set(o,c)}}_findAvailableConnectionWithLargestCongestionWindow(t,n){let{ignoreConnectionReused:r,observedConnectionWasReused:a}=n,o=null;for(let i=0;i<t.length;i++){let c=t[i];if(!r&&c._warmed!==a||this._connectionsInUse.has(c))continue;let u=o?.congestionWindow||-1/0;c.congestionWindow>u&&(o=c)}return o}acquire(t,n={}){if(this._connectionsByRecord.has(t))throw new Error("Record already has a connection");let r=t.parsedURL.securityOrigin,a=!!this._connectionReusedByRequestId.get(t.requestId),o=this._connectionsByOrigin.get(r)||[],i=this._findAvailableConnectionWithLargestCongestionWindow(o,{ignoreConnectionReused:n.ignoreConnectionReused,observedConnectionWasReused:a});return i?(this._connectionsInUse.add(i),this._connectionsByRecord.set(t,i),i):null}acquireActiveConnectionFromRecord(t){let n=this._connectionsByRecord.get(t);if(!n)throw new Error("Could not find an active connection for record");return n}release(t){let n=this._connectionsByRecord.get(t);this._connectionsByRecord.delete(t),this._connectionsInUse.delete(n)}}});var JK,Xi,GF=b(()=>{"use strict";d();jt();JK=2,Xi=class e{static{s(this,"DNSCache")}constructor({rtt:t}){this._rtt=t,this._resolvedDomainNames=new Map}getTimeUntilResolution(t,n){let{requestedAt:r=0,shouldUpdateCache:a=!1}=n||{},o=t.parsedURL.host,i=this._resolvedDomainNames.get(o),c=this._rtt*e.RTT_MULTIPLIER;if(i){let l=Math.max(i.resolvedAt-r,0);c=Math.min(l,c)}let u=r+c;return a&&this._updateCacheResolvedAtIfNeeded(t,u),c}_updateCacheResolvedAtIfNeeded(t,n){let r=t.parsedURL.host,a=this._resolvedDomainNames.get(r)||{resolvedAt:n};a.resolvedAt=Math.min(a.resolvedAt,n),this._resolvedDomainNames.set(r,a)}setResolvedAt(t,n){this._resolvedDomainNames.set(t,{resolvedAt:n})}};Xi.RTT_MULTIPLIER=JK});var hu,VF=b(()=>{"use strict";d();gn();hu=class{static{s(this,"SimulatorTimingMap")}constructor(){this._nodeTimings=new Map}getNodes(){return Array.from(this._nodeTimings.keys())}setReadyToStart(t,n){this._nodeTimings.set(t,n)}setInProgress(t,n){let r={...this.getQueued(t),startTime:n.startTime,timeElapsed:0};this._nodeTimings.set(t,t.type===ye.TYPES.NETWORK?{...r,timeElapsedOvershoot:0,bytesDownloaded:0}:r)}setCompleted(t,n){let r={...this.getInProgress(t),endTime:n.endTime,connectionTiming:n.connectionTiming};this._nodeTimings.set(t,r)}setCpu(t,n){let r={...this.getCpuStarted(t),timeElapsed:n.timeElapsed};this._nodeTimings.set(t,r)}setCpuEstimated(t,n){let r={...this.getCpuStarted(t),estimatedTimeElapsed:n.estimatedTimeElapsed};this._nodeTimings.set(t,r)}setNetwork(t,n){let r={...this.getNetworkStarted(t),timeElapsed:n.timeElapsed,timeElapsedOvershoot:n.timeElapsedOvershoot,bytesDownloaded:n.bytesDownloaded};this._nodeTimings.set(t,r)}setNetworkEstimated(t,n){let r={...this.getNetworkStarted(t),estimatedTimeElapsed:n.estimatedTimeElapsed};this._nodeTimings.set(t,r)}getQueued(t){let n=this._nodeTimings.get(t);if(!n)throw new Error(`Node ${t.id} not yet queued`);return n}getCpuStarted(t){let n=this._nodeTimings.get(t);if(!n)throw new Error(`Node ${t.id} not yet queued`);if(!("startTime"in n))throw new Error(`Node ${t.id} not yet started`);if("bytesDownloaded"in n)throw new Error(`Node ${t.id} timing not valid`);return n}getNetworkStarted(t){let n=this._nodeTimings.get(t);if(!n)throw new Error(`Node ${t.id} not yet queued`);if(!("startTime"in n))throw new Error(`Node ${t.id} not yet started`);if(!("bytesDownloaded"in n))throw new Error(`Node ${t.id} timing not valid`);return n}getInProgress(t){let n=this._nodeTimings.get(t);if(!n)throw new Error(`Node ${t.id} not yet queued`);if(!("startTime"in n))throw new Error(`Node ${t.id} not yet started`);if(!("estimatedTimeElapsed"in n))throw new Error(`Node ${t.id} not yet in progress`);return n}getCompleted(t){let n=this._nodeTimings.get(t);if(!n)throw new Error(`Node ${t.id} not yet queued`);if(!("startTime"in n))throw new Error(`Node ${t.id} not yet started`);if(!("estimatedTimeElapsed"in n))throw new Error(`Node ${t.id} not yet in progress`);if(!("endTime"in n))throw new Error(`Node ${t.id} not yet completed`);return n}}});var xr={};T(xr,{defaultSettings:()=>qn,nonSimulatedSettingsOverrides:()=>Ji,screenEmulationMetrics:()=>bp,throttling:()=>In,userAgents:()=>Ia});var In,ZK,QK,bp,eX,tX,Ia,qn,Ji,zn=b(()=>{"use strict";d();In={DEVTOOLS_RTT_ADJUSTMENT_FACTOR:3.75,DEVTOOLS_THROUGHPUT_ADJUSTMENT_FACTOR:.9,mobileSlow4G:{rttMs:150,throughputKbps:1638.4,requestLatencyMs:562.5,downloadThroughputKbps:1474.5600000000002,uploadThroughputKbps:675,cpuSlowdownMultiplier:4},mobileRegular3G:{rttMs:300,throughputKbps:700,requestLatencyMs:1125,downloadThroughputKbps:630,uploadThroughputKbps:630,cpuSlowdownMultiplier:4},desktopDense4G:{rttMs:40,throughputKbps:10240,cpuSlowdownMultiplier:1,requestLatencyMs:0,downloadThroughputKbps:0,uploadThroughputKbps:0}},ZK={mobile:!0,width:412,height:823,deviceScaleFactor:1.75,disabled:!1},QK={mobile:!1,width:1350,height:940,deviceScaleFactor:1,disabled:!1},bp={mobile:ZK,desktop:QK},eX="Mozilla/5.0 (Linux; Android 11; moto g power (2022)) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/119.0.0.0 Mobile Safari/537.36",tX="Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/119.0.0.0 Safari/537.36",Ia={mobile:eX,desktop:tX},qn={output:"json",maxWaitForFcp:30*1e3,maxWaitForLoad:45*1e3,pauseAfterFcpMs:1e3,pauseAfterLoadMs:1e3,networkQuietThresholdMs:1e3,cpuQuietThresholdMs:1e3,formFactor:"mobile",throttling:In.mobileSlow4G,throttlingMethod:"simulate",screenEmulation:bp.mobile,emulatedUserAgent:Ia.mobile,auditMode:!1,gatherMode:!1,clearStorageTypes:["file_systems","shader_cache","service_workers","cache_storage"],disableStorageReset:!1,debugNavigation:!1,channel:"node",usePassiveGathering:!1,disableFullPageScreenshot:!1,skipAboutBlank:!1,blankPage:"about:blank",ignoreStatusCode:!1,budgets:null,locale:"en-US",blockedUrlPatterns:null,additionalTraceCategories:null,extraHeaders:null,precomputedLanternData:null,onlyAudits:null,onlyCategories:null,skipAudits:null},Ji={pauseAfterFcpMs:5250,pauseAfterLoadMs:5250,networkQuietThresholdMs:5250,cpuQuietThresholdMs:5250}});var Ng,nX,rX,aX,Hn,oX,WF,gu,Mg=b(()=>{"use strict";d();jt();gn();Dg();HF();GF();VF();zn();Ng=In.mobileSlow4G,nX=10,rX=.5,aX=1e4,Hn={NotReadyToStart:0,ReadyToStart:1,InProgress:2,Complete:3},oX={VeryHigh:0,High:.25,Medium:.5,Low:1,VeryLow:2},WF=new Map,gu=class e{static{s(this,"Simulator")}constructor(t){if(this._options=Object.assign({rtt:Ng.rttMs,throughput:Ng.throughputKbps*1024,maximumConcurrentRequests:nX,cpuSlowdownMultiplier:Ng.cpuSlowdownMultiplier,layoutTaskMultiplier:rX,additionalRttByOrigin:new Map,serverResponseTimeByOrigin:new Map},t),this._rtt=this._options.rtt,this._throughput=this._options.throughput,this._maximumConcurrentRequests=Math.max(Math.min(Ki.maximumSaturatedConnections(this._rtt,this._throughput),this._options.maximumConcurrentRequests),1),this._cpuSlowdownMultiplier=this._options.cpuSlowdownMultiplier,this._layoutTaskMultiplier=this._cpuSlowdownMultiplier*this._options.layoutTaskMultiplier,this._cachedNodeListByStartPosition=[],this._flexibleOrdering=!1,this._nodeTimings=new hu,this._numberInProgressByType=new Map,this._nodes={},this._dns=new Xi({rtt:this._rtt}),this._connectionPool=null,!Number.isFinite(this._rtt))throw new Error(`Invalid rtt ${this._rtt}`);if(!Number.isFinite(this._throughput))throw new Error(`Invalid rtt ${this._throughput}`)}get rtt(){return this._rtt}_initializeConnectionPool(t){let n=[];t.getRootNode().traverse(r=>{r.type===ye.TYPES.NETWORK&&n.push(r.record)}),this._connectionPool=new yp(n,this._options)}_initializeAuxiliaryData(){this._nodeTimings=new hu,this._numberInProgressByType=new Map,this._nodes={},this._cachedNodeListByStartPosition=[];for(let t of Object.values(Hn))this._nodes[t]=new Set}_numberInProgress(t){return this._numberInProgressByType.get(t)||0}_markNodeAsReadyToStart(t,n){let r=e._computeNodeStartPosition(t),a=this._cachedNodeListByStartPosition.findIndex(i=>e._computeNodeStartPosition(i)>r),o=a===-1?this._cachedNodeListByStartPosition.length:a;this._cachedNodeListByStartPosition.splice(o,0,t),this._nodes[Hn.ReadyToStart].add(t),this._nodes[Hn.NotReadyToStart].delete(t),this._nodeTimings.setReadyToStart(t,{queuedTime:n})}_markNodeAsInProgress(t,n){let r=this._cachedNodeListByStartPosition.indexOf(t);this._cachedNodeListByStartPosition.splice(r,1),this._nodes[Hn.InProgress].add(t),this._nodes[Hn.ReadyToStart].delete(t),this._numberInProgressByType.set(t.type,this._numberInProgress(t.type)+1),this._nodeTimings.setInProgress(t,{startTime:n})}_markNodeAsComplete(t,n,r){this._nodes[Hn.Complete].add(t),this._nodes[Hn.InProgress].delete(t),this._numberInProgressByType.set(t.type,this._numberInProgress(t.type)-1),this._nodeTimings.setCompleted(t,{endTime:n,connectionTiming:r});for(let a of t.getDependents())a.getDependencies().some(i=>!this._nodes[Hn.Complete].has(i))||this._markNodeAsReadyToStart(a,n)}_acquireConnection(t){return this._connectionPool.acquire(t,{ignoreConnectionReused:this._flexibleOrdering})}_getNodesSortedByStartPosition(){return Array.from(this._cachedNodeListByStartPosition)}_startNodeIfPossible(t,n){if(t.type===ye.TYPES.CPU){this._numberInProgress(t.type)===0&&this._markNodeAsInProgress(t,n);return}if(t.type!==ye.TYPES.NETWORK)throw new Error("Unsupported");!t.isConnectionless&&(this._numberInProgress(t.type)>=this._maximumConcurrentRequests||!this._acquireConnection(t.record))||this._markNodeAsInProgress(t,n)}_updateNetworkCapacity(){let t=this._numberInProgress(ye.TYPES.NETWORK);if(t!==0)for(let n of this._connectionPool.connectionsInUse())n.setThroughput(this._throughput/t)}_estimateTimeRemaining(t){if(t.type===ye.TYPES.CPU)return this._estimateCPUTimeRemaining(t);if(t.type===ye.TYPES.NETWORK)return this._estimateNetworkTimeRemaining(t);throw new Error("Unsupported")}_estimateCPUTimeRemaining(t){let n=this._nodeTimings.getCpuStarted(t),r=t.didPerformLayout()?this._layoutTaskMultiplier:this._cpuSlowdownMultiplier,o=Math.min(Math.round(t.event.dur/1e3*r),aX)-n.timeElapsed;return this._nodeTimings.setCpuEstimated(t,{estimatedTimeElapsed:o}),o}_estimateNetworkTimeRemaining(t){let n=t.record,r=this._nodeTimings.getNetworkStarted(t),a=0;if(t.fromDiskCache)a=8+20*((n.resourceSize||0)/1024/1024)-r.timeElapsed;else if(t.isNonNetworkProtocol)a=2+10*((n.resourceSize||0)/1024/1024)-r.timeElapsed;else{let i=this._connectionPool.acquireActiveConnectionFromRecord(n),c=this._dns.getTimeUntilResolution(n,{requestedAt:r.startTime,shouldUpdateCache:!0}),u=r.timeElapsed;a=i.simulateDownloadUntil(n.transferSize-r.bytesDownloaded,{timeAlreadyElapsed:u,dnsResolutionTime:c,maximumTimeToElapse:1/0}).timeElapsed}let o=a+r.timeElapsedOvershoot;return this._nodeTimings.setNetworkEstimated(t,{estimatedTimeElapsed:o}),o}_findNextNodeCompletionTime(){let t=1/0;for(let n of this._nodes[Hn.InProgress])t=Math.min(t,this._estimateTimeRemaining(n));return t}_updateProgressMadeInTimePeriod(t,n,r){let a=this._nodeTimings.getInProgress(t),o=a.estimatedTimeElapsed===n;if(t.type===ye.TYPES.CPU||t.isConnectionless)return o?this._markNodeAsComplete(t,r):a.timeElapsed+=n;if(t.type!==ye.TYPES.NETWORK)throw new Error("Unsupported");if(!("bytesDownloaded"in a))throw new Error("Invalid timing data");let i=t.record,c=this._connectionPool.acquireActiveConnectionFromRecord(i),u=this._dns.getTimeUntilResolution(i,{requestedAt:a.startTime,shouldUpdateCache:!0}),l=c.simulateDownloadUntil(i.transferSize-a.bytesDownloaded,{dnsResolutionTime:u,timeAlreadyElapsed:a.timeElapsed,maximumTimeToElapse:n-a.timeElapsedOvershoot});c.setCongestionWindow(l.congestionWindow),c.setH2OverflowBytesDownloaded(l.extraBytesDownloaded),o?(c.setWarmed(!0),this._connectionPool.release(i),this._markNodeAsComplete(t,r,l.connectionTiming)):(a.timeElapsed+=l.timeElapsed,a.timeElapsedOvershoot+=l.timeElapsed-n,a.bytesDownloaded+=l.bytesDownloaded)}_computeFinalNodeTimings(){let t=this._nodeTimings.getNodes().map(r=>[r,this._nodeTimings.getCompleted(r)]);t.sort((r,a)=>r[1].startTime-a[1].startTime);let n=t.map(([r,a])=>[r,{startTime:a.startTime,endTime:a.endTime,duration:a.endTime-a.startTime}]);return{nodeTimings:new Map(n),completeNodeTimings:new Map(t)}}getOptions(){return this._options}simulate(t,n){if(ye.hasCycle(t))throw new Error("Cannot simulate graph with cycle");n=Object.assign({label:void 0,flexibleOrdering:!1},n),this._flexibleOrdering=!!n.flexibleOrdering,this._dns=new Xi({rtt:this._rtt}),this._initializeConnectionPool(t),this._initializeAuxiliaryData();let r=this._nodes[Hn.NotReadyToStart],a=this._nodes[Hn.ReadyToStart],o=this._nodes[Hn.InProgress],i=t.getRootNode();i.traverse(p=>r.add(p));let c=0,u=0;for(this._markNodeAsReadyToStart(i,c);a.size||o.size;){for(let h of this._getNodesSortedByStartPosition())this._startNodeIfPossible(h,c);if(!o.size){if(this._flexibleOrdering)throw new Error("Failed to start a node");this._flexibleOrdering=!0;continue}this._updateNetworkCapacity();let p=this._findNextNodeCompletionTime();if(c+=p,!Number.isFinite(p)||u>1e5)throw new Error("Simulation failed, depth exceeded");u++;for(let h of o)this._updateProgressMadeInTimePeriod(h,p,c)}let{nodeTimings:l,completeNodeTimings:m}=this._computeFinalNodeTimings();return WF.set(n.label||"unlabeled",m),{timeInMs:c,nodeTimings:l}}computeWastedMsFromWastedBytes(t){let{throughput:n,observedThroughput:r}=this._options,a=n===0?r:n;if(a===0)return 0;let i=t*8/a*1e3;return Math.round(i/10)*10}static get ALL_NODE_TIMINGS(){return WF}static _computeNodeStartPosition(t){return t.type==="cpu"?t.startTime:t.startTime+(oX[t.record.priority]*1e3*1e3||0)}}});var $F=b(()=>{"use strict";d();});var YF=b(()=>{"use strict";d();Ae();vr();});var KF,vp,XF=b(()=>{"use strict";d();KF=Lt(iu(),1);vp=class e{static{s(this,"ArbitraryEqualityMap")}constructor(){this._equalsFn=e.deepEquals,this._entries=[]}setEqualityFn(t){this._equalsFn=t}has(t){return this._findIndexOf(t)!==-1}get(t){return this._entries[this._findIndexOf(t)]?.value}set(t,n){let r=this._findIndexOf(t);r===-1&&(r=this._entries.length),this._entries[r]={key:t,value:n}}_findIndexOf(t){for(let n=0;n<this._entries.length;n++)if(this._equalsFn(t,this._entries[n].key))return n;return-1}static deepEquals(t,n){return(0,KF.default)(t,n)}}});function q(e,t){return Object.assign(e,{request:s((r,a)=>{let o=t?Object.fromEntries(t.map(h=>[h,r[h]])):r,i=a.computedCache,c=e.name,u=i.get(c)||new vp;i.set(c,u);let l=u.get(o);if(l)return l;let m={msg:`Computing artifact: ${c}`,id:`lh:computed:${c}`};F.time(m,"verbose");let p=e.compute_(o,a);return u.set(o,p),p.then(()=>F.timeEnd(m)).catch(()=>F.timeEnd(m)),p},"request")})}var ue=b(()=>{"use strict";d();Ae();XF();s(q,"makeComputedArtifact")});var JF,ZF,QF,eI,tI,nI,rI,wp,G,lt=b(()=>{"use strict";d();jt();Ze();JF="X-TCPMs",ZF="X-SSLMs",QF="X-RequestMs",eI="X-ResponseMs",tI="X-TotalMs",nI="X-TotalFetchedSize",rI="X-ProtocolIsH2",wp={XHR:"XHR",Fetch:"Fetch",EventSource:"EventSource",Script:"Script",Stylesheet:"Stylesheet",Image:"Image",Media:"Media",Font:"Font",Document:"Document",TextTrack:"TextTrack",WebSocket:"WebSocket",Other:"Other",Manifest:"Manifest",SignedExchange:"SignedExchange",Ping:"Ping",Preflight:"Preflight",CSPViolationReport:"CSPViolationReport",Prefetch:"Prefetch"},G=class e{static{s(this,"NetworkRequest")}constructor(){this.requestId="",this.connectionId="0",this.connectionReused=!1,this.url="",this.protocol="",this.isSecure=!1,this.isValid=!1,this.parsedURL={scheme:""},this.documentURL="",this.rendererStartTime=-1,this.networkRequestTime=-1,this.responseHeadersEndTime=-1,this.networkEndTime=-1,this.transferSize=0,this.responseHeadersTransferSize=0,this.resourceSize=0,this.fromDiskCache=!1,this.fromMemoryCache=!1,this.fromPrefetchCache=!1,this.lrStatistics=void 0,this.finished=!1,this.requestMethod="",this.statusCode=-1,this.redirectSource=void 0,this.redirectDestination=void 0,this.redirects=void 0,this.failed=!1,this.localizedFailDescription="",this.initiator={type:"other"},this.timing=void 0,this.resourceType=void 0,this.mimeType="",this.priority="Low",this.initiatorRequest=void 0,this.responseHeaders=[],this.responseHeadersText="",this.fetchedViaServiceWorker=!1,this.frameId="",this.sessionId=void 0,this.sessionTargetType=void 0,this.isLinkPreload=!1}hasErrorStatusCode(){return this.statusCode>=400}setInitiatorRequest(t){this.initiatorRequest=t}onRequestWillBeSent(t){this.requestId=t.requestId;let n;try{n=new URL(t.request.url)}catch{return}this.url=t.request.url,this.documentURL=t.documentURL,this.parsedURL={scheme:n.protocol.split(":")[0],host:n.hostname,securityOrigin:n.origin},this.isSecure=Y.isSecureScheme(this.parsedURL.scheme),this.rendererStartTime=t.timestamp*1e3,this.networkRequestTime=this.rendererStartTime,this.requestMethod=t.request.method,this.initiator=t.initiator,this.resourceType=t.type&&wp[t.type],this.priority=t.request.initialPriority,this.frameId=t.frameId,this.isLinkPreload=t.initiator.type==="preload"||!!t.request.isLinkPreload,this.isValid=!0}onRequestServedFromCache(){this.fromMemoryCache=!0}onResponseReceived(t){this._onResponse(t.response,t.timestamp,t.type),this._updateProtocolForLightrider(),this.frameId=t.frameId}onResponseReceivedExtraInfo(t){this.responseHeadersText=t.headersText||""}onDataReceived(t){this.resourceSize+=t.dataLength,t.encodedDataLength!==-1&&(this.transferSize+=t.encodedDataLength)}onLoadingFinished(t){this.finished||(this.finished=!0,this.networkEndTime=t.timestamp*1e3,t.encodedDataLength>=0&&(this.transferSize=t.encodedDataLength),this._updateResponseHeadersEndTimeIfNecessary(),this._backfillReceiveHeaderStartTiming(),this._updateTransferSizeForLightrider(),this._updateTimingsForLightrider())}onLoadingFailed(t){this.finished||(this.finished=!0,this.networkEndTime=t.timestamp*1e3,this.failed=!0,this.resourceType=t.type&&wp[t.type],this.localizedFailDescription=t.errorText,this._updateResponseHeadersEndTimeIfNecessary(),this._backfillReceiveHeaderStartTiming(),this._updateTransferSizeForLightrider(),this._updateTimingsForLightrider())}onResourceChangedPriority(t){this.priority=t.newPriority}onRedirectResponse(t){if(!t.redirectResponse)throw new Error("Missing redirectResponse data");this._onResponse(t.redirectResponse,t.timestamp,t.type),this.resourceType=void 0,this.finished=!0,this.networkEndTime=t.timestamp*1e3,this._updateResponseHeadersEndTimeIfNecessary(),this._backfillReceiveHeaderStartTiming()}setSession(t){this.sessionId=t}get isOutOfProcessIframe(){return this.sessionTargetType==="iframe"}_onResponse(t,n,r){this.url=t.url,this.connectionId=String(t.connectionId),this.connectionReused=t.connectionReused,t.protocol&&(this.protocol=t.protocol),this.responseHeadersEndTime=n*1e3,this.transferSize=t.encodedDataLength,this.responseHeadersTransferSize=t.encodedDataLength,typeof t.fromDiskCache=="boolean"&&(this.fromDiskCache=t.fromDiskCache),typeof t.fromPrefetchCache=="boolean"&&(this.fromPrefetchCache=t.fromPrefetchCache),this.statusCode=t.status,this.timing=t.timing,r&&(this.resourceType=wp[r]),this.mimeType=t.mimeType,this.responseHeaders=e._headersDictToHeadersArray(t.headers),this.fetchedViaServiceWorker=!!t.fromServiceWorker,this.fromMemoryCache&&(this.timing=void 0),this.timing&&this._recomputeTimesWithResourceTiming(this.timing)}_recomputeTimesWithResourceTiming(t){if(t.requestTime===0||t.receiveHeadersEnd===-1)return;this.networkRequestTime=t.requestTime*1e3;let n=this.networkRequestTime+t.receiveHeadersEnd,r=this.responseHeadersEndTime;this.responseHeadersEndTime=n,this.responseHeadersEndTime=Math.min(this.responseHeadersEndTime,r),this.responseHeadersEndTime=Math.max(this.responseHeadersEndTime,this.networkRequestTime),this.networkEndTime=Math.max(this.networkEndTime,this.responseHeadersEndTime)}_updateResponseHeadersEndTimeIfNecessary(){this.responseHeadersEndTime=Math.min(this.networkEndTime,this.responseHeadersEndTime)}_updateTransferSizeForLightrider(){if(!globalThis.isLightrider)return;let t=this.responseHeaders.find(r=>r.name===nI);if(!t)return;let n=parseFloat(t.value);isNaN(n)||(this.transferSize=n)}_updateProtocolForLightrider(){globalThis.isLightrider&&this.responseHeaders.some(t=>t.name===rI)&&(this.protocol="h2")}_backfillReceiveHeaderStartTiming(){!this.timing||this.timing.receiveHeadersStart!==void 0||(this.timing.receiveHeadersStart=this.timing.receiveHeadersEnd)}_updateTimingsForLightrider(){if(!globalThis.isLightrider)return;let t=this.responseHeaders.find(p=>p.name===tI);if(!t)return;let n=parseInt(t.value),r=this.responseHeaders.find(p=>p.name===JF),a=this.responseHeaders.find(p=>p.name===ZF),o=this.responseHeaders.find(p=>p.name===QF),i=this.responseHeaders.find(p=>p.name===eI),c=r?Math.max(0,parseInt(r.value)):0,u=a?Math.max(0,parseInt(a.value)):0,l=o?Math.max(0,parseInt(o.value)):0,m=i?Math.max(0,parseInt(i.value)):0;if(!Number.isNaN(c+l+m+n)){if(c+l+m!==n){if(Math.abs(c+l+m-n)>=25)return;n=c+l+m}u>c||(this.lrStatistics={endTimeDeltaMs:this.networkEndTime-(this.networkRequestTime+n),TCPMs:c,requestMs:l,responseMs:m})}}static getRequestIdForBackend(t){return t.replace(/(:redirect)+$/,"")}static _headersDictToHeadersArray(t){let n=[];for(let r of Object.keys(t)){let a=t[r].split(`
`);for(let o=0;o<a.length;++o)n.push({name:r,value:a[o]})}return n}static get TYPES(){return wp}static isNonNetworkRequest(t){return Y.isNonNetworkProtocol(t.protocol)||Y.isNonNetworkProtocol(t.parsedURL.scheme)}static isSecureRequest(t){return Y.isSecureScheme(t.parsedURL.scheme)||Y.isSecureScheme(t.protocol)||Y.isLikeLocalhost(t.parsedURL.host)||e.isHstsRequest(t)}static isHstsRequest(t){let n=t.redirectDestination;return n?t.responseHeaders.find(o=>o.name==="Non-Authoritative-Reason")?.value==="HSTS"&&e.isSecureRequest(n):!1}static isContentEncoded(t){let n=/^content-encoding$/i;return t.responseHeaders.some(r=>r.name.match(n))}static getResourceSizeOnNetwork(t){return Math.min(t.resourceSize||0,t.transferSize||1/0)}};G.HEADER_TCP=JF;G.HEADER_SSL=ZF;G.HEADER_REQ=QF;G.HEADER_RES=eI;G.HEADER_TOTAL=tI;G.HEADER_FETCHED_SIZE=nI;G.HEADER_PROTOCOL_IS_H2=rI});var yu,bu=b(()=>{"use strict";d();jt();gn();lt();yu=class e extends ye{static{s(this,"NetworkNode")}constructor(t){super(t.requestId),this._record=t}get type(){return ye.TYPES.NETWORK}get startTime(){return this._record.networkRequestTime*1e3}get endTime(){return this._record.networkEndTime*1e3}get record(){return this._record}get initiatorType(){return this._record.initiator&&this._record.initiator.type}get fromDiskCache(){return!!this._record.fromDiskCache}get isNonNetworkProtocol(){return G.isNonNetworkRequest(this._record)}get isConnectionless(){return this.fromDiskCache||this.isNonNetworkProtocol}hasRenderBlockingPriority(){let t=this._record.priority,n=this._record.resourceType===G.TYPES.Script,r=this._record.resourceType===G.TYPES.Document;return t==="VeryHigh"||t==="High"&&n||t==="High"&&r}cloneWithoutRelationships(){let t=new e(this._record);return t.setIsMainDocument(this._isMainDocument),t}}});var Dp,vu=b(()=>{"use strict";d();jt();gn();Dp=class e extends ye{static{s(this,"CPUNode")}constructor(t,n=[]){let r=`${t.tid}.${t.ts}`;super(r),this._event=t,this._childEvents=n}get type(){return ye.TYPES.CPU}get startTime(){return this._event.ts}get endTime(){return this._event.ts+this._event.dur}get event(){return this._event}get childEvents(){return this._childEvents}didPerformLayout(){return this._childEvents.some(t=>t.name==="Layout")}getEvaluateScriptURLs(){let t=new Set;for(let n of this._childEvents)n.name==="EvaluateScript"&&(!n.args.data||!n.args.data.url||t.add(n.args.data.url));return t}cloneWithoutRelationships(){return new e(this._event,this._childEvents)}}});var Lg,wu,Pg=b(()=>{"use strict";d();It();vr();Lg=class extends qt{static{s(this,"LHTraceProcessor")}static createNoNavstartError(){return new j(j.errors.NO_NAVSTART)}static createNoResourceSendRequestError(){return new j(j.errors.NO_RESOURCE_REQUEST)}static createNoTracingStartedError(){return new j(j.errors.NO_TRACING_STARTED)}static createNoFirstContentfulPaintError(){return new j(j.errors.NO_FCP)}},wu=Lg});var Og,ke,Nt=b(()=>{"use strict";d();ue();Pg();Og=class{static{s(this,"ProcessedTrace")}static async compute_(t){return wu.processTrace(t)}},ke=q(Og,null)});var Bg,aI,oI=b(()=>{"use strict";d();Uo();ue();de();Nt();Bg=class{static{s(this,"DocumentUrls")}static async compute_(t,n){let r=await ke.request(t.trace,n),a=await H.request(t.devtoolsLog,n),o=r.mainFrameInfo.frameId,i,c;for(let l of t.devtoolsLog)if(l.method==="Page.frameNavigated"&&l.params.frame.id===o){let{url:m}=l.params.frame;i||(i=m),c=m}if(!i||!c)throw new Error("No main frame navigations found");let u=Gt.findResourceForUrl(a,i);return u?.redirects?.length&&(i=u.redirects[0].url),{requestedUrl:i,mainDocumentUrl:c}}},aI=q(Bg,["devtoolsLog","trace"])});var iX,sX,Ug,xt,Nn=b(()=>{"use strict";d();ue();bu();vu();vr();lt();Nt();de();Uo();oI();iX=10,sX=/^video/,Ug=class e{static{s(this,"PageDependencyGraph")}static getNetworkInitiators(t){if(!t.initiator)return[];if(t.initiator.url)return[t.initiator.url];if(t.initiator.type==="script"){let n=new Set,r=t.initiator.stack;for(;r;){let a=r.callFrames||[];for(let o of a)o.url&&n.add(o.url);r=r.parent}return Array.from(n)}return[]}static getNetworkNodeOutput(t){let n=[],r=new Map,a=new Map,o=new Map;return t.forEach(i=>{if(sX.test(i.mimeType)||i.sessionTargetType==="worker")return;for(;r.has(i.requestId);)i.requestId+=":duplicate";let c=new yu(i);n.push(c);let u=a.get(i.url)||[];if(u.push(c),r.set(i.requestId,c),a.set(i.url,u),i.frameId&&i.resourceType===G.TYPES.Document&&i.documentURL===i.url){let l=o.has(i.frameId)?null:c;o.set(i.frameId,l)}}),{nodes:n,idToNodeMap:r,urlToNodeMap:a,frameIdToNodeMap:o}}static getCPUNodes({mainThreadEvents:t}){let n=[],r=0;for(qt.assertHasToplevelEvents(t);r<t.length;){let a=t[r];if(r++,!qt.isScheduleableTask(a)||!a.dur)continue;let o=[];for(let i=a.ts+a.dur;r<t.length&&t[r].ts<i;r++)o.push(t[r]);n.push(new Dp(a,o))}return n}static linkNetworkNodes(t,n){n.nodes.forEach(r=>{let a=r.record.initiatorRequest||t.record,o=n.idToNodeMap.get(a.requestId)||t,i=!o.isDependentOn(r)&&r.canDependOn(o),c=e.getNetworkInitiators(r.record);if(c.length?c.forEach(l=>{let m=n.urlToNodeMap.get(l)||[];m.length===1&&m[0].startTime<=r.startTime&&!m[0].isDependentOn(r)?r.addDependency(m[0]):i&&o.addDependent(r)}):i&&o.addDependent(r),r!==t&&r.getDependencies().length===0&&r.canDependOn(t)&&r.addDependency(t),!r.record.redirects)return;let u=[...r.record.redirects,r.record];for(let l=1;l<u.length;l++){let m=n.idToNodeMap.get(u[l-1].requestId),p=n.idToNodeMap.get(u[l].requestId);p&&m&&p.addDependency(m)}})}static linkCPUNodes(t,n,r){let a=new Set([G.TYPES.XHR,G.TYPES.Fetch,G.TYPES.Script]);function o(f,y){let v=n.idToNodeMap.get(y);if(!v||v.startTime<=f.startTime)return;let{record:D}=v,E=D.resourceType||D.redirectDestination?.resourceType;a.has(E)&&f.addDependent(v)}s(o,"addDependentNetworkRequest");function i(f,y){if(!y)return;let v=n.frameIdToNodeMap.get(y);v&&(v.startTime>=f.startTime||f.addDependency(v))}s(i,"addDependencyOnFrame");function c(f,y){if(!y)return;let v=-100*1e3,D=n.urlToNodeMap.get(y)||[],E=null,S=1/0;for(let k of D){if(f.startTime<=k.startTime)return;let C=f.startTime-k.endTime;C>=v&&C<S&&(E=k,S=C)}E&&f.addDependency(E)}s(c,"addDependencyOnUrl");let u=new Map;for(let f of r){for(let y of f.childEvents){if(!y.args.data)continue;let v=y.args.data.url,D=(y.args.data.stackTrace||[]).map(E=>E.url).filter(Boolean);switch(y.name){case"TimerInstall":u.set(y.args.data.timerId,f),D.forEach(E=>c(f,E));break;case"TimerFire":{let E=u.get(y.args.data.timerId);if(!E||E.endTime>f.startTime)break;E.addDependent(f);break}case"InvalidateLayout":case"ScheduleStyleRecalculation":i(f,y.args.data.frame),D.forEach(E=>c(f,E));break;case"EvaluateScript":i(f,y.args.data.frame),c(f,v),D.forEach(E=>c(f,E));break;case"XHRReadyStateChange":if(y.args.data.readyState!==4)break;c(f,v),D.forEach(E=>c(f,E));break;case"FunctionCall":case"v8.compile":i(f,y.args.data.frame),c(f,v);break;case"ParseAuthorStyleSheet":i(f,y.args.data.frame),c(f,y.args.data.styleSheetUrl);break;case"ResourceSendRequest":i(f,y.args.data.frame),o(f,y.args.data.requestId),D.forEach(E=>c(f,E));break}}f.getNumberOfDependencies()===0&&f.canDependOn(t)&&f.addDependency(t)}let l=iX*1e3,m=!1,p=!1,h=!1;for(let f of r){let y=!1;!m&&f.childEvents.some(v=>v.name==="Layout")&&(y=m=!0),!p&&f.childEvents.some(v=>v.name==="Paint")&&(y=p=!0),!h&&f.childEvents.some(v=>v.name==="ParseHTML")&&(y=h=!0),!(y||f.event.dur>=l)&&(f.getNumberOfDependencies()===1||f.getNumberOfDependents()<=1)&&e._pruneNode(f)}}static _pruneNode(t){let n=t.getDependencies(),r=t.getDependents();for(let a of n){t.removeDependency(a);for(let o of r)a.addDependent(o)}for(let a of r)t.removeDependent(a)}static createGraph(t,n,r){let a=e.getNetworkNodeOutput(n),o=e.getCPUNodes(t),{requestedUrl:i,mainDocumentUrl:c}=r;if(!i)throw new Error("requestedUrl is required to get the root request");if(!c)throw new Error("mainDocumentUrl is required to get the main resource");let u=Gt.findResourceForUrl(n,i);if(!u)throw new Error("rootRequest not found");let l=a.idToNodeMap.get(u.requestId);if(!l)throw new Error("rootNode not found");let m=Gt.findLastDocumentForUrl(n,c);if(!m)throw new Error("mainDocumentRequest not found");let p=a.idToNodeMap.get(m.requestId);if(!p)throw new Error("mainDocumentNode not found");if(e.linkNetworkNodes(l,a),e.linkCPUNodes(l,a,o),p.setIsMainDocument(!0),yu.hasCycle(l))throw new Error("Invalid dependency graph created, cycle detected");return l}static printGraph(t,n=100){function r(l,m,p=" "){return l+p.repeat(Math.max(m-l.length,0))}s(r,"padRight");let a=[];t.traverse(l=>a.push(l)),a.sort((l,m)=>l.startTime-m.startTime);let o=a[0].startTime,u=(a.reduce((l,m)=>Math.max(l,m.endTime),0)-o)/n;a.forEach(l=>{let m=Math.round((l.startTime-o)/u),p=Math.ceil((l.endTime-l.startTime)/u),h=r("",m)+r("",p,"="),f=l.record?l.record.url:l.type;console.log(r(h,n),`| ${f.slice(0,30)}`)})}static async compute_(t,n){let{trace:r,devtoolsLog:a}=t,[o,i]=await Promise.all([ke.request(r,n),H.request(a,n)]),c=t.URL||await aI.request(t,n);return e.createGraph(o,i,c)}},xt=q(Ug,["devtoolsLog","trace","URL"])});var cX,Zi,jg=b(()=>{"use strict";d();Kr();Ae();jt();lt();Nn();cX=Be,Zi=class e extends cX{static{s(this,"NetworkRecorder")}constructor(){super(),this._records=[],this._recordsById=new Map}getRawRecords(){return Array.from(this._records)}onRequestStarted(t){this._records.push(t),this._recordsById.set(t.requestId,t),this.emit("requeststarted",t)}onRequestFinished(t){this.emit("requestfinished",t)}onRequestWillBeSent(t){let n=t.params,r=this._findRealRequestAndSetSession(n.requestId,t.targetType,t.sessionId);if(!r){let i=new G;i.onRequestWillBeSent(n),i.sessionId=t.sessionId,i.sessionTargetType=t.targetType,this.onRequestStarted(i),F.verbose("network",`request will be sent to ${i.url}`);return}if(!n.redirectResponse)return;let a={...n,initiator:r.initiator,requestId:`${r.requestId}:redirect`},o=new G;o.onRequestWillBeSent(a),r.onRedirectResponse(n),F.verbose("network",`${r.url} redirected to ${o.url}`),r.redirectDestination=o,o.redirectSource=r,this.onRequestStarted(o),this.onRequestFinished(r)}onRequestServedFromCache(t){let n=t.params,r=this._findRealRequestAndSetSession(n.requestId,t.targetType,t.sessionId);r&&(F.verbose("network",`${r.url} served from cache`),r.onRequestServedFromCache())}onResponseReceived(t){let n=t.params,r=this._findRealRequestAndSetSession(n.requestId,t.targetType,t.sessionId);r&&(F.verbose("network",`${r.url} response received`),r.onResponseReceived(n))}onResponseReceivedExtraInfo(t){let n=t.params,r=this._findRealRequestAndSetSession(n.requestId,t.targetType,t.sessionId);r&&(F.verbose("network",`${r.url} response received extra info`),r.onResponseReceivedExtraInfo(n))}onDataReceived(t){let n=t.params,r=this._findRealRequestAndSetSession(n.requestId,t.targetType,t.sessionId);r&&(F.verbose("network",`${r.url} data received`),r.onDataReceived(n))}onLoadingFinished(t){let n=t.params,r=this._findRealRequestAndSetSession(n.requestId,t.targetType,t.sessionId);r&&(F.verbose("network",`${r.url} loading finished`),r.onLoadingFinished(n),this.onRequestFinished(r))}onLoadingFailed(t){let n=t.params,r=this._findRealRequestAndSetSession(n.requestId,t.targetType,t.sessionId);r&&(F.verbose("network",`${r.url} loading failed`),r.onLoadingFailed(n),this.onRequestFinished(r))}onResourceChangedPriority(t){let n=t.params,r=this._findRealRequestAndSetSession(n.requestId,t.targetType,t.sessionId);r&&r.onResourceChangedPriority(n)}dispatch(t){switch(t.method){case"Network.requestWillBeSent":return this.onRequestWillBeSent(t);case"Network.requestServedFromCache":return this.onRequestServedFromCache(t);case"Network.responseReceived":return this.onResponseReceived(t);case"Network.responseReceivedExtraInfo":return this.onResponseReceivedExtraInfo(t);case"Network.dataReceived":return this.onDataReceived(t);case"Network.loadingFinished":return this.onLoadingFinished(t);case"Network.loadingFailed":return this.onLoadingFailed(t);case"Network.resourceChangedPriority":return this.onResourceChangedPriority(t);default:return}}_findRealRequestAndSetSession(t,n,r){let a=this._recordsById.get(t);if(!(!a||!a.isValid)){for(;a.redirectDestination;)a=a.redirectDestination;return a.setSession(r),a.sessionTargetType=n,a}}static _chooseInitiatorRequest(t,n){if(t.redirectSource)return t.redirectSource;let r=xt.getNetworkInitiators(t)[0],a=n.get(r)||[];if(a=a.filter(o=>o.responseHeadersEndTime<=t.networkRequestTime&&o.finished&&!o.failed),a.length>1){let o=a.filter(i=>i.resourceType!==G.TYPES.Other);o.length&&(a=o)}if(a.length>1){let o=a.filter(i=>i.frameId===t.frameId);o.length&&(a=o)}if(a.length>1&&t.initiator.type==="parser"){let o=a.filter(i=>i.resourceType===G.TYPES.Document);o.length&&(a=o)}if(a.length>1){let o=a.filter(i=>i.isLinkPreload);if(o.length){let i=a.filter(u=>!u.isLinkPreload),c=i.every(u=>u.fromDiskCache||u.fromMemoryCache);i.length&&c&&(a=o)}}return a.length===1?a[0]:null}static recordsFromLogs(t){let n=new e;t.forEach(o=>n.dispatch(o));let r=n.getRawRecords().filter(o=>o.isValid),a=new Map;for(let o of r){let i=a.get(o.url)||[];i.push(o),a.set(o.url,i)}for(let o of r){let i=e._chooseInitiatorRequest(o,a);i&&o.setInitiatorRequest(i);let c=o;for(;c.redirectDestination;)c=c.redirectDestination;if(c===o||c.redirects)continue;let u=[];for(let l=c.redirectSource;l;l=l.redirectSource)u.unshift(l);c.redirects=u}return r}}});var qg,H,de=b(()=>{"use strict";d();jt();ue();jg();qg=class{static{s(this,"NetworkRecords")}static async compute_(t){return Zi.recordsFromLogs(t)}},H=q(qg,null)});var zg,ar,jo=b(()=>{"use strict";d();ue();Uo();de();zg=class e{static{s(this,"NetworkAnalysis")}static computeRTTAndServerResponseTime(t){let n=new Map;for(let[c,u]of Gt.estimateRTTByOrigin(t).entries())n.set(c,u.min);let r=Math.min(...Array.from(n.values())),a=Gt.estimateServerResponseTimeByOrigin(t,{rttByOrigin:n}),o=new Map,i=new Map;for(let[c,u]of a.entries()){let l=n.get(c)||r;o.set(c,l-r),i.set(c,u.median)}return{rtt:r,additionalRttByOrigin:o,serverResponseTimeByOrigin:i}}static async compute_(t,n){let r=await H.request(t,n),a=Gt.estimateThroughput(r),o=e.computeRTTAndServerResponseTime(r);return{throughput:a,...o}}},ar=q(zg,null)});var Hg,Pt,Gn=b(()=>{"use strict";d();ue();zn();Mg();jo();Hg=class{static{s(this,"LoadSimulator")}static async compute_(t,n){let{throttlingMethod:r,throttling:a,precomputedLanternData:o}=t.settings,i=await ar.request(t.devtoolsLog,n),c={additionalRttByOrigin:i.additionalRttByOrigin,serverResponseTimeByOrigin:i.serverResponseTimeByOrigin,observedThroughput:i.throughput};switch(o&&(c.additionalRttByOrigin=new Map(Object.entries(o.additionalRttByOrigin)),c.serverResponseTimeByOrigin=new Map(Object.entries(o.serverResponseTimeByOrigin))),r){case"provided":c.rtt=i.rtt,c.throughput=i.throughput,c.cpuSlowdownMultiplier=1,c.layoutTaskMultiplier=1;break;case"devtools":a&&(c.rtt=a.requestLatencyMs/In.DEVTOOLS_RTT_ADJUSTMENT_FACTOR,c.throughput=a.downloadThroughputKbps*1024/In.DEVTOOLS_THROUGHPUT_ADJUSTMENT_FACTOR),c.cpuSlowdownMultiplier=1,c.layoutTaskMultiplier=1;break;case"simulate":a&&(c.rtt=a.rttMs,c.throughput=a.throughputKbps*1024,c.cpuSlowdownMultiplier=a.cpuSlowdownMultiplier);break;default:break}return new gu(c)}static convertAnalysisToSaveableLanternData(t){let n={additionalRttByOrigin:{},serverResponseTimeByOrigin:{}};for(let[r,a]of t.additionalRttByOrigin.entries())r.startsWith("http")&&(n.additionalRttByOrigin[r]=a);for(let[r,a]of t.serverResponseTimeByOrigin.entries())r.startsWith("http")&&(n.serverResponseTimeByOrigin[r]=a);return n}},Pt=q(Hg,["devtoolsLog","settings"])});function cI(e){if(F.log("Reading artifacts from disk:",e),!Sn.existsSync(e))throw new Error("No saved artifacts found at "+e);let t=Sn.readFileSync(Dt.join(e,Gg),"utf8"),n=JSON.parse(t,j.parseReviver),r=Sn.readdirSync(e);return r.filter(a=>a.endsWith(Eu)).forEach(a=>{n.devtoolsLogs||(n.devtoolsLogs={});let o=a.replace(Eu,""),i=JSON.parse(Sn.readFileSync(Dt.join(e,a),"utf8"));n.devtoolsLogs[o]=i,o===Ep&&(n.DevtoolsLog=i),o===xp&&(n.DevtoolsLogError=i)}),r.filter(a=>a.endsWith(Du)).forEach(a=>{n.traces||(n.traces={});let o=Sn.readFileSync(Dt.join(e,a),{encoding:"utf-8"}),i=JSON.parse(o),c=a.replace(Du,"");n.traces[c]=Array.isArray(i)?{traceEvents:i}:i,c===Ep&&(n.Trace=n.traces[c]),c===xp&&(n.TraceError=n.traces[c])}),Array.isArray(n.Timing)&&n.Timing.forEach(a=>a.gather=!0),n}function uX(e,t){return t instanceof Error?j.stringifyReplacer(t):t}async function uI(e,t){let n={msg:"Saving artifacts",id:"lh:assetSaver:saveArtifacts"};F.time(n),Sn.mkdirSync(t,{recursive:!0});let r=Sn.readdirSync(t);for(let h of r)(h.endsWith(Du)||h.endsWith(Eu)||h===Gg)&&Sn.unlinkSync(`${t}/${h}`);let{traces:a,devtoolsLogs:o,DevtoolsLog:i,Trace:c,DevtoolsLogError:u,TraceError:l,...m}=e;c&&await iI(c,`${t}/${Ep}${Du}`),l&&await iI(l,`${t}/${xp}${Du}`),i&&await sI(i,`${t}/${Ep}${Eu}`),u&&await sI(u,`${t}/${xp}${Eu}`);let p=JSON.stringify(m,uX,2)+`
`;Sn.writeFileSync(`${t}/${Gg}`,p,"utf8"),F.log("Artifacts saved to disk in folder:",t),F.timeEnd(n)}function lI(e,t){Sn.writeFileSync(`${t}/lhr.report.json`,JSON.stringify(e,null,2))}function*dI(e){if(yield`[
`,e.length>0){let n=e[Symbol.iterator](),r=n.next().value;yield`  ${JSON.stringify(r)}`;let a=500,o="";for(let i of n)o+=`,
  ${JSON.stringify(i)}`,a--,a===0&&(yield o,a=500,o="");yield o}yield`
]`}function*lX(e){let{traceEvents:t,...n}=e;yield`{
`,yield'"traceEvents": ',yield*dI(t);for(let[r,a]of Object.entries(n))yield`,
"${r}": ${JSON.stringify(a,null,2)}`;yield`}
`}async function iI(e,t){let n=lX(e),r=Sn.createWriteStream(t);return vg.promises.pipeline(n,r)}function sI(e,t){let n=Sn.createWriteStream(t);return vg.promises.pipeline(function*(){yield*dI(e),yield`
`},n)}var Gg,Du,Eu,Ep,xp,mI=b(()=>{"use strict";d();Jr();Aa();wg();mu();Ae();Mg();$F();YF();jo();Gn();It();Wi();Gg="artifacts.json",Du=".trace.json",Eu=".devtoolslog.json",Ep="defaultPass",xp="pageLoadError-defaultPass";s(cI,"loadArtifacts");s(uX,"stringifyReplacer");s(uI,"saveArtifacts");s(lI,"saveLhr");s(dI,"arrayOfObjectsJsonGenerator");s(lX,"traceJsonGenerator");s(iI,"saveTrace");s(sI,"saveDevtoolsLog")});var pI,mX,pX,fX,hX,Qi,fI=b(()=>{"use strict";d();pI=["server-response-time","render-blocking-resources","redirects","critical-request-chains","uses-text-compression","uses-rel-preconnect","uses-rel-preload","font-display","unminified-javascript","unminified-css","unused-css-rules"],mX=[...pI,"largest-contentful-paint-element","prioritize-lcp-image","unused-javascript","efficient-animated-content","total-byte-weight","lcp-lazy-loaded"],pX=["long-tasks","third-party-summary","third-party-facades","bootup-time","mainthread-work-breakdown","dom-size","duplicated-javascript","legacy-javascript","viewport"],fX=["layout-shift-elements","non-composited-animations","unsized-images"],hX=["work-during-interaction"],Qi={fcpRelevantAudits:pI,lcpRelevantAudits:mX,tbtRelevantAudits:pX,clsRelevantAudits:fX,inpRelevantAudits:hX}});var he,be,hI,Tp,Vg=b(()=>{"use strict";d();jt();zn();A();fI();he={performanceCategoryTitle:"Performance",budgetsGroupTitle:"Budgets",budgetsGroupDescription:"Performance budgets set standards for the performance of your site.",metricGroupTitle:"Metrics",loadOpportunitiesGroupTitle:"Opportunities",loadOpportunitiesGroupDescription:"These suggestions can help your page load faster. They don't [directly affect](https://developer.chrome.com/docs/lighthouse/performance/performance-scoring/) the Performance score.",firstPaintImprovementsGroupTitle:"First Paint Improvements",firstPaintImprovementsGroupDescription:"The most critical aspect of performance is how quickly pixels are rendered onscreen. Key metrics: First Contentful Paint, First Meaningful Paint",overallImprovementsGroupTitle:"Overall Improvements",overallImprovementsGroupDescription:"Enhance the overall loading experience, so the page is responsive and ready to use as soon as possible. Key metrics: Time to Interactive, Speed Index",diagnosticsGroupTitle:"Diagnostics",diagnosticsGroupDescription:"More information about the performance of your application. These numbers don't [directly affect](https://developer.chrome.com/docs/lighthouse/performance/performance-scoring/) the Performance score.",a11yCategoryTitle:"Accessibility",a11yCategoryDescription:"These checks highlight opportunities to [improve the accessibility of your web app](https://developer.chrome.com/docs/lighthouse/accessibility/). Automatic detection can only detect a subset of issues and does not guarantee the accessibility of your web app, so [manual testing](https://web.dev/articles/how-to-review) is also encouraged.",a11yCategoryManualDescription:"These items address areas which an automated testing tool cannot cover. Learn more in our guide on [conducting an accessibility review](https://web.dev/articles/how-to-review).",a11yBestPracticesGroupTitle:"Best practices",a11yBestPracticesGroupDescription:"These items highlight common accessibility best practices.",a11yColorContrastGroupTitle:"Contrast",a11yColorContrastGroupDescription:"These are opportunities to improve the legibility of your content.",a11yNamesLabelsGroupTitle:"Names and labels",a11yNamesLabelsGroupDescription:"These are opportunities to improve the semantics of the controls in your application. This may enhance the experience for users of assistive technology, like a screen reader.",a11yNavigationGroupTitle:"Navigation",a11yNavigationGroupDescription:"These are opportunities to improve keyboard navigation in your application.",a11yAriaGroupTitle:"ARIA",a11yAriaGroupDescription:"These are opportunities to improve the usage of ARIA in your application which may enhance the experience for users of assistive technology, like a screen reader.",a11yLanguageGroupTitle:"Internationalization and localization",a11yLanguageGroupDescription:"These are opportunities to improve the interpretation of your content by users in different locales.",a11yAudioVideoGroupTitle:"Audio and video",a11yAudioVideoGroupDescription:"These are opportunities to provide alternative content for audio and video. This may improve the experience for users with hearing or vision impairments.",a11yTablesListsVideoGroupTitle:"Tables and lists",a11yTablesListsVideoGroupDescription:"These are opportunities to improve the experience of reading tabular or list data using assistive technology, like a screen reader.",seoCategoryTitle:"SEO",seoCategoryDescription:"These checks ensure that your page is following basic search engine optimization advice. There are many additional factors Lighthouse does not score here that may affect your search ranking, including performance on [Core Web Vitals](https://web.dev/explore/vitals). [Learn more about Google Search Essentials](https://support.google.com/webmasters/answer/35769).",seoCategoryManualDescription:"Run these additional validators on your site to check additional SEO best practices.",seoMobileGroupTitle:"Mobile Friendly",seoMobileGroupDescription:"Make sure your pages are mobile friendly so users don’t have to pinch or zoom in order to read the content pages. [Learn how to make pages mobile-friendly](https://developers.google.com/search/mobile-sites/).",seoContentGroupTitle:"Content Best Practices",seoContentGroupDescription:"Format your HTML in a way that enables crawlers to better understand your app’s content.",seoCrawlingGroupTitle:"Crawling and Indexing",seoCrawlingGroupDescription:"To appear in search results, crawlers need access to your app.",pwaCategoryTitle:"PWA",pwaCategoryDescription:"These checks validate the aspects of a Progressive Web App. [Learn what makes a good Progressive Web App](https://web.dev/articles/pwa-checklist).",pwaCategoryManualDescription:"These checks are required by the baseline [PWA Checklist](https://web.dev/articles/pwa-checklist) but are not automatically checked by Lighthouse. They do not affect your score but it's important that you verify them manually.",bestPracticesCategoryTitle:"Best Practices",bestPracticesTrustSafetyGroupTitle:"Trust and Safety",bestPracticesUXGroupTitle:"User Experience",bestPracticesBrowserCompatGroupTitle:"Browser Compatibility",bestPracticesGeneralGroupTitle:"General",pwaInstallableGroupTitle:"Installable",pwaOptimizedGroupTitle:"PWA Optimized"},be=w("core/config/default-config.js",he),hI={settings:qn,artifacts:[{id:"DevtoolsLog",gatherer:"devtools-log"},{id:"Trace",gatherer:"trace"},{id:"Accessibility",gatherer:"accessibility"},{id:"AnchorElements",gatherer:"anchor-elements"},{id:"CacheContents",gatherer:"cache-contents"},{id:"ConsoleMessages",gatherer:"console-messages"},{id:"CSSUsage",gatherer:"css-usage"},{id:"Doctype",gatherer:"dobetterweb/doctype"},{id:"DOMStats",gatherer:"dobetterweb/domstats"},{id:"EmbeddedContent",gatherer:"seo/embedded-content"},{id:"FontSize",gatherer:"seo/font-size"},{id:"Inputs",gatherer:"inputs"},{id:"GlobalListeners",gatherer:"global-listeners"},{id:"IFrameElements",gatherer:"iframe-elements"},{id:"ImageElements",gatherer:"image-elements"},{id:"InstallabilityErrors",gatherer:"installability-errors"},{id:"InspectorIssues",gatherer:"inspector-issues"},{id:"JsUsage",gatherer:"js-usage"},{id:"LinkElements",gatherer:"link-elements"},{id:"MainDocumentContent",gatherer:"main-document-content"},{id:"MetaElements",gatherer:"meta-elements"},{id:"NetworkUserAgent",gatherer:"network-user-agent"},{id:"OptimizedImages",gatherer:"dobetterweb/optimized-images"},{id:"ResponseCompression",gatherer:"dobetterweb/response-compression"},{id:"RobotsTxt",gatherer:"seo/robots-txt"},{id:"ServiceWorker",gatherer:"service-worker"},{id:"ScriptElements",gatherer:"script-elements"},{id:"Scripts",gatherer:"scripts"},{id:"SourceMaps",gatherer:"source-maps"},{id:"Stacks",gatherer:"stacks"},{id:"TagsBlockingFirstPaint",gatherer:"dobetterweb/tags-blocking-first-paint"},{id:"TapTargets",gatherer:"seo/tap-targets"},{id:"TraceElements",gatherer:"trace-elements"},{id:"ViewportDimensions",gatherer:"viewport-dimensions"},{id:"WebAppManifest",gatherer:"web-app-manifest"},{id:"devtoolsLogs",gatherer:"devtools-log-compat"},{id:"traces",gatherer:"trace-compat"},{id:"FullPageScreenshot",gatherer:"full-page-screenshot"},{id:"BFCacheFailures",gatherer:"bf-cache-failures"}],audits:["is-on-https","viewport","metrics/first-contentful-paint","metrics/largest-contentful-paint","metrics/first-meaningful-paint","metrics/speed-index","screenshot-thumbnails","final-screenshot","metrics/total-blocking-time","metrics/max-potential-fid","metrics/cumulative-layout-shift","metrics/interaction-to-next-paint","errors-in-console","server-response-time","metrics/interactive","user-timings","critical-request-chains","redirects","installable-manifest","splash-screen","themed-omnibox","maskable-icon","content-width","image-aspect-ratio","image-size-responsive","preload-fonts","deprecations","third-party-cookies","mainthread-work-breakdown","bootup-time","uses-rel-preload","uses-rel-preconnect","font-display","diagnostics","network-requests","network-rtt","network-server-latency","main-thread-tasks","metrics","performance-budget","timing-budget","resource-summary","third-party-summary","third-party-facades","largest-contentful-paint-element","lcp-lazy-loaded","layout-shift-elements","long-tasks","no-unload-listeners","non-composited-animations","unsized-images","valid-source-maps","prioritize-lcp-image","csp-xss","script-treemap-data","manual/pwa-cross-browser","manual/pwa-page-transitions","manual/pwa-each-page-has-url","accessibility/accesskeys","accessibility/aria-allowed-attr","accessibility/aria-allowed-role","accessibility/aria-command-name","accessibility/aria-dialog-name","accessibility/aria-hidden-body","accessibility/aria-hidden-focus","accessibility/aria-input-field-name","accessibility/aria-meter-name","accessibility/aria-progressbar-name","accessibility/aria-required-attr","accessibility/aria-required-children","accessibility/aria-required-parent","accessibility/aria-roles","accessibility/aria-text","accessibility/aria-toggle-field-name","accessibility/aria-tooltip-name","accessibility/aria-treeitem-name","accessibility/aria-valid-attr-value","accessibility/aria-valid-attr","accessibility/button-name","accessibility/bypass","accessibility/color-contrast","accessibility/definition-list","accessibility/dlitem","accessibility/document-title","accessibility/duplicate-id-active","accessibility/duplicate-id-aria","accessibility/empty-heading","accessibility/form-field-multiple-labels","accessibility/frame-title","accessibility/heading-order","accessibility/html-has-lang","accessibility/html-lang-valid","accessibility/html-xml-lang-mismatch","accessibility/identical-links-same-purpose","accessibility/image-alt","accessibility/image-redundant-alt","accessibility/input-button-name","accessibility/input-image-alt","accessibility/label-content-name-mismatch","accessibility/label","accessibility/landmark-one-main","accessibility/link-name","accessibility/link-in-text-block","accessibility/list","accessibility/listitem","accessibility/meta-refresh","accessibility/meta-viewport","accessibility/object-alt","accessibility/select-name","accessibility/skip-link","accessibility/tabindex","accessibility/table-duplicate-name","accessibility/table-fake-caption","accessibility/target-size","accessibility/td-has-header","accessibility/td-headers-attr","accessibility/th-has-data-cells","accessibility/valid-lang","accessibility/video-caption","accessibility/manual/custom-controls-labels","accessibility/manual/custom-controls-roles","accessibility/manual/focus-traps","accessibility/manual/focusable-controls","accessibility/manual/interactive-element-affordance","accessibility/manual/logical-tab-order","accessibility/manual/managed-focus","accessibility/manual/offscreen-content-hidden","accessibility/manual/use-landmarks","accessibility/manual/visual-order-follows-dom","byte-efficiency/uses-long-cache-ttl","byte-efficiency/total-byte-weight","byte-efficiency/offscreen-images","byte-efficiency/render-blocking-resources","byte-efficiency/unminified-css","byte-efficiency/unminified-javascript","byte-efficiency/unused-css-rules","byte-efficiency/unused-javascript","byte-efficiency/modern-image-formats","byte-efficiency/uses-optimized-images","byte-efficiency/uses-text-compression","byte-efficiency/uses-responsive-images","byte-efficiency/efficient-animated-content","byte-efficiency/duplicated-javascript","byte-efficiency/legacy-javascript","byte-efficiency/uses-responsive-images-snapshot","dobetterweb/doctype","dobetterweb/charset","dobetterweb/dom-size","dobetterweb/geolocation-on-start","dobetterweb/inspector-issues","dobetterweb/no-document-write","dobetterweb/js-libraries","dobetterweb/notification-on-start","dobetterweb/paste-preventing-inputs","dobetterweb/uses-http2","dobetterweb/uses-passive-event-listeners","seo/meta-description","seo/http-status-code","seo/font-size","seo/link-text","seo/crawlable-anchors","seo/is-crawlable","seo/robots-txt","seo/tap-targets","seo/hreflang","seo/plugins","seo/canonical","seo/manual/structured-data","work-during-interaction","bf-cache"],groups:{metrics:{title:be(he.metricGroupTitle)},"load-opportunities":{title:be(he.loadOpportunitiesGroupTitle),description:be(he.loadOpportunitiesGroupDescription)},budgets:{title:be(he.budgetsGroupTitle),description:be(he.budgetsGroupDescription)},diagnostics:{title:be(he.diagnosticsGroupTitle),description:be(he.diagnosticsGroupDescription)},"pwa-installable":{title:be(he.pwaInstallableGroupTitle)},"pwa-optimized":{title:be(he.pwaOptimizedGroupTitle)},"a11y-best-practices":{title:be(he.a11yBestPracticesGroupTitle),description:be(he.a11yBestPracticesGroupDescription)},"a11y-color-contrast":{title:be(he.a11yColorContrastGroupTitle),description:be(he.a11yColorContrastGroupDescription)},"a11y-names-labels":{title:be(he.a11yNamesLabelsGroupTitle),description:be(he.a11yNamesLabelsGroupDescription)},"a11y-navigation":{title:be(he.a11yNavigationGroupTitle),description:be(he.a11yNavigationGroupDescription)},"a11y-aria":{title:be(he.a11yAriaGroupTitle),description:be(he.a11yAriaGroupDescription)},"a11y-language":{title:be(he.a11yLanguageGroupTitle),description:be(he.a11yLanguageGroupDescription)},"a11y-audio-video":{title:be(he.a11yAudioVideoGroupTitle),description:be(he.a11yAudioVideoGroupDescription)},"a11y-tables-lists":{title:be(he.a11yTablesListsVideoGroupTitle),description:be(he.a11yTablesListsVideoGroupDescription)},"seo-mobile":{title:be(he.seoMobileGroupTitle),description:be(he.seoMobileGroupDescription)},"seo-content":{title:be(he.seoContentGroupTitle),description:be(he.seoContentGroupDescription)},"seo-crawl":{title:be(he.seoCrawlingGroupTitle),description:be(he.seoCrawlingGroupDescription)},"best-practices-trust-safety":{title:be(he.bestPracticesTrustSafetyGroupTitle)},"best-practices-ux":{title:be(he.bestPracticesUXGroupTitle)},"best-practices-browser-compat":{title:be(he.bestPracticesBrowserCompatGroupTitle)},"best-practices-general":{title:be(he.bestPracticesGeneralGroupTitle)},hidden:{title:""}},categories:{performance:{title:be(he.performanceCategoryTitle),supportedModes:["navigation","timespan","snapshot"],auditRefs:[{id:"first-contentful-paint",weight:10,group:"metrics",acronym:"FCP",relevantAudits:Qi.fcpRelevantAudits},{id:"largest-contentful-paint",weight:25,group:"metrics",acronym:"LCP",relevantAudits:Qi.lcpRelevantAudits},{id:"total-blocking-time",weight:30,group:"metrics",acronym:"TBT",relevantAudits:Qi.tbtRelevantAudits},{id:"cumulative-layout-shift",weight:25,group:"metrics",acronym:"CLS",relevantAudits:Qi.clsRelevantAudits},{id:"speed-index",weight:10,group:"metrics",acronym:"SI"},{id:"interaction-to-next-paint",weight:0,group:"metrics",acronym:"INP",relevantAudits:Qi.inpRelevantAudits},{id:"interactive",weight:0,group:"hidden",acronym:"TTI"},{id:"max-potential-fid",weight:0,group:"hidden"},{id:"first-meaningful-paint",weight:0,acronym:"FMP",group:"hidden"},{id:"render-blocking-resources",weight:0},{id:"uses-responsive-images",weight:0},{id:"offscreen-images",weight:0},{id:"unminified-css",weight:0},{id:"unminified-javascript",weight:0},{id:"unused-css-rules",weight:0},{id:"unused-javascript",weight:0},{id:"uses-optimized-images",weight:0},{id:"modern-image-formats",weight:0},{id:"uses-text-compression",weight:0},{id:"uses-rel-preconnect",weight:0},{id:"server-response-time",weight:0},{id:"redirects",weight:0},{id:"uses-rel-preload",weight:0},{id:"uses-http2",weight:0},{id:"efficient-animated-content",weight:0},{id:"duplicated-javascript",weight:0},{id:"legacy-javascript",weight:0},{id:"prioritize-lcp-image",weight:0},{id:"total-byte-weight",weight:0},{id:"uses-long-cache-ttl",weight:0},{id:"dom-size",weight:0},{id:"critical-request-chains",weight:0},{id:"user-timings",weight:0},{id:"bootup-time",weight:0},{id:"mainthread-work-breakdown",weight:0},{id:"font-display",weight:0},{id:"third-party-summary",weight:0},{id:"third-party-facades",weight:0},{id:"largest-contentful-paint-element",weight:0},{id:"lcp-lazy-loaded",weight:0},{id:"layout-shift-elements",weight:0},{id:"uses-passive-event-listeners",weight:0},{id:"no-document-write",weight:0},{id:"long-tasks",weight:0},{id:"non-composited-animations",weight:0},{id:"unsized-images",weight:0},{id:"viewport",weight:0},{id:"uses-responsive-images-snapshot",weight:0},{id:"work-during-interaction",weight:0},{id:"bf-cache",weight:0},{id:"performance-budget",weight:0,group:"budgets"},{id:"timing-budget",weight:0,group:"budgets"},{id:"network-requests",weight:0,group:"hidden"},{id:"network-rtt",weight:0,group:"hidden"},{id:"network-server-latency",weight:0,group:"hidden"},{id:"main-thread-tasks",weight:0,group:"hidden"},{id:"diagnostics",weight:0,group:"hidden"},{id:"metrics",weight:0,group:"hidden"},{id:"screenshot-thumbnails",weight:0,group:"hidden"},{id:"final-screenshot",weight:0,group:"hidden"},{id:"script-treemap-data",weight:0,group:"hidden"},{id:"resource-summary",weight:0,group:"hidden"}]},accessibility:{title:be(he.a11yCategoryTitle),description:be(he.a11yCategoryDescription),manualDescription:be(he.a11yCategoryManualDescription),supportedModes:["navigation","snapshot"],auditRefs:[{id:"accesskeys",weight:7,group:"a11y-navigation"},{id:"aria-allowed-attr",weight:10,group:"a11y-aria"},{id:"aria-allowed-role",weight:1,group:"a11y-aria"},{id:"aria-command-name",weight:7,group:"a11y-aria"},{id:"aria-dialog-name",weight:7,group:"a11y-aria"},{id:"aria-hidden-body",weight:10,group:"a11y-aria"},{id:"aria-hidden-focus",weight:7,group:"a11y-aria"},{id:"aria-input-field-name",weight:7,group:"a11y-aria"},{id:"aria-meter-name",weight:7,group:"a11y-aria"},{id:"aria-progressbar-name",weight:7,group:"a11y-aria"},{id:"aria-required-attr",weight:10,group:"a11y-aria"},{id:"aria-required-children",weight:10,group:"a11y-aria"},{id:"aria-required-parent",weight:10,group:"a11y-aria"},{id:"aria-roles",weight:7,group:"a11y-aria"},{id:"aria-text",weight:7,group:"a11y-aria"},{id:"aria-toggle-field-name",weight:7,group:"a11y-aria"},{id:"aria-tooltip-name",weight:7,group:"a11y-aria"},{id:"aria-treeitem-name",weight:7,group:"a11y-aria"},{id:"aria-valid-attr-value",weight:10,group:"a11y-aria"},{id:"aria-valid-attr",weight:10,group:"a11y-aria"},{id:"button-name",weight:10,group:"a11y-names-labels"},{id:"bypass",weight:7,group:"a11y-navigation"},{id:"color-contrast",weight:7,group:"a11y-color-contrast"},{id:"definition-list",weight:7,group:"a11y-tables-lists"},{id:"dlitem",weight:7,group:"a11y-tables-lists"},{id:"document-title",weight:7,group:"a11y-names-labels"},{id:"duplicate-id-active",weight:7,group:"a11y-navigation"},{id:"duplicate-id-aria",weight:10,group:"a11y-aria"},{id:"form-field-multiple-labels",weight:3,group:"a11y-names-labels"},{id:"frame-title",weight:7,group:"a11y-names-labels"},{id:"heading-order",weight:3,group:"a11y-navigation"},{id:"html-has-lang",weight:7,group:"a11y-language"},{id:"html-lang-valid",weight:7,group:"a11y-language"},{id:"html-xml-lang-mismatch",weight:3,group:"a11y-language"},{id:"image-alt",weight:10,group:"a11y-names-labels"},{id:"image-redundant-alt",weight:1,group:"a11y-names-labels"},{id:"input-button-name",weight:10,group:"a11y-names-labels"},{id:"input-image-alt",weight:10,group:"a11y-names-labels"},{id:"label",weight:7,group:"a11y-names-labels"},{id:"link-in-text-block",weight:7,group:"a11y-color-contrast"},{id:"link-name",weight:7,group:"a11y-names-labels"},{id:"list",weight:7,group:"a11y-tables-lists"},{id:"listitem",weight:7,group:"a11y-tables-lists"},{id:"meta-refresh",weight:10,group:"a11y-best-practices"},{id:"meta-viewport",weight:10,group:"a11y-best-practices"},{id:"object-alt",weight:7,group:"a11y-names-labels"},{id:"select-name",weight:7,group:"a11y-names-labels"},{id:"skip-link",weight:3,group:"a11y-names-labels"},{id:"tabindex",weight:7,group:"a11y-navigation"},{id:"table-duplicate-name",weight:1,group:"a11y-tables-lists"},{id:"td-headers-attr",weight:7,group:"a11y-tables-lists"},{id:"th-has-data-cells",weight:7,group:"a11y-tables-lists"},{id:"valid-lang",weight:7,group:"a11y-language"},{id:"video-caption",weight:10,group:"a11y-audio-video"},{id:"focusable-controls",weight:0},{id:"interactive-element-affordance",weight:0},{id:"logical-tab-order",weight:0},{id:"visual-order-follows-dom",weight:0},{id:"focus-traps",weight:0},{id:"managed-focus",weight:0},{id:"use-landmarks",weight:0},{id:"offscreen-content-hidden",weight:0},{id:"custom-controls-labels",weight:0},{id:"custom-controls-roles",weight:0},{id:"empty-heading",weight:0,group:"hidden"},{id:"identical-links-same-purpose",weight:0,group:"hidden"},{id:"landmark-one-main",weight:0,group:"hidden"},{id:"target-size",weight:0,group:"hidden"},{id:"label-content-name-mismatch",weight:0,group:"hidden"},{id:"table-fake-caption",weight:0,group:"hidden"},{id:"td-has-header",weight:0,group:"hidden"}]},"best-practices":{title:be(he.bestPracticesCategoryTitle),supportedModes:["navigation","timespan","snapshot"],auditRefs:[{id:"is-on-https",weight:5,group:"best-practices-trust-safety"},{id:"geolocation-on-start",weight:1,group:"best-practices-trust-safety"},{id:"notification-on-start",weight:1,group:"best-practices-trust-safety"},{id:"csp-xss",weight:0,group:"best-practices-trust-safety"},{id:"paste-preventing-inputs",weight:3,group:"best-practices-ux"},{id:"image-aspect-ratio",weight:1,group:"best-practices-ux"},{id:"image-size-responsive",weight:1,group:"best-practices-ux"},{id:"preload-fonts",weight:1,group:"best-practices-ux"},{id:"doctype",weight:1,group:"best-practices-browser-compat"},{id:"charset",weight:1,group:"best-practices-browser-compat"},{id:"no-unload-listeners",weight:1,group:"best-practices-general"},{id:"js-libraries",weight:0,group:"best-practices-general"},{id:"deprecations",weight:5,group:"best-practices-general"},{id:"third-party-cookies",weight:5,group:"best-practices-general"},{id:"errors-in-console",weight:1,group:"best-practices-general"},{id:"valid-source-maps",weight:0,group:"best-practices-general"},{id:"inspector-issues",weight:1,group:"best-practices-general"}]},seo:{title:be(he.seoCategoryTitle),description:be(he.seoCategoryDescription),manualDescription:be(he.seoCategoryManualDescription),supportedModes:["navigation","snapshot"],auditRefs:[{id:"viewport",weight:1,group:"seo-mobile"},{id:"document-title",weight:1,group:"seo-content"},{id:"meta-description",weight:1,group:"seo-content"},{id:"http-status-code",weight:1,group:"seo-crawl"},{id:"link-text",weight:1,group:"seo-content"},{id:"crawlable-anchors",weight:1,group:"seo-crawl"},{id:"is-crawlable",weight:1,group:"seo-crawl"},{id:"robots-txt",weight:1,group:"seo-crawl"},{id:"image-alt",weight:1,group:"seo-content"},{id:"hreflang",weight:1,group:"seo-content"},{id:"canonical",weight:1,group:"seo-content"},{id:"font-size",weight:1,group:"seo-mobile"},{id:"plugins",weight:1,group:"seo-content"},{id:"tap-targets",weight:1,group:"seo-mobile"},{id:"structured-data",weight:0}]},pwa:{title:be(he.pwaCategoryTitle),description:be(he.pwaCategoryDescription),manualDescription:be(he.pwaCategoryManualDescription),supportedModes:["navigation"],auditRefs:[{id:"installable-manifest",weight:2,group:"pwa-installable"},{id:"splash-screen",weight:1,group:"pwa-optimized"},{id:"themed-omnibox",weight:1,group:"pwa-optimized"},{id:"content-width",weight:1,group:"pwa-optimized"},{id:"viewport",weight:2,group:"pwa-optimized"},{id:"maskable-icon",weight:1,group:"pwa-optimized"},{id:"pwa-cross-browser",weight:0},{id:"pwa-page-transitions",weight:0},{id:"pwa-each-page-has-url",weight:0}]}}};Object.defineProperty(hI,"UIStrings",{enumerable:!1,get:()=>he});Tp=hI});function gI(e,t){let n={timespan:0,snapshot:1,navigation:2},r=Math.min(...e.instance.meta.supportedModes.map(o=>n[o])),a=Math.min(...t.instance.meta.supportedModes.map(o=>n[o]));return r===n.timespan?a===n.timespan:r===n.snapshot?a===n.snapshot:!0}function yI(e,t){if(!t.startsWith("lighthouse-plugin-"))throw new Error(`plugin name '${t}' does not start with 'lighthouse-plugin-'`);if(e.categories?.[t])throw new Error(`plugin name '${t}' not allowed because it is the id of a category already found in config`)}function gX(e){let t=e.gatherer.instance;if(typeof t.meta!="object")throw new Error(`Gatherer for ${e.id} did not provide a meta object.`);if(t.meta.supportedModes.length===0)throw new Error(`Gatherer for ${e.id} did not support any gather modes.`);if(typeof t.getArtifact!="function"||t.getArtifact===$.prototype.getArtifact)throw new Error(`Gatherer for ${e.id} did not define a "getArtifact" method.`)}function Wg(e){let{implementation:t,path:n}=e,r=n||t?.meta?.id||"Unknown audit";if(typeof t.audit!="function"||t.audit===g.audit)throw new Error(`${r} has no audit() method.`);if(typeof t.meta.id!="string")throw new Error(`${r} has no meta.id property, or the property is not a string.`);if(!Dr(t.meta.title))throw new Error(`${r} has no meta.title property, or the property is not a string.`);let a=t.meta.scoreDisplayMode||g.SCORING_MODES.BINARY;if(!Dr(t.meta.failureTitle)&&a===g.SCORING_MODES.BINARY)throw new Error(`${r} has no meta.failureTitle and should.`);if(Dr(t.meta.description)){if(t.meta.description==="")throw new Error(`${r} has an empty meta.description string. Please add a description for the UI.`)}else throw new Error(`${r} has no meta.description property, or the property is not a string.`);if(!Array.isArray(t.meta.requiredArtifacts))throw new Error(`${r} has no meta.requiredArtifacts property, or the property is not an array.`)}function yX(e,t,n){if(!e)return;let r=new Map((t||[]).map(a=>[a.implementation.meta.id,a]));Object.keys(e).forEach(a=>{e[a].auditRefs.forEach((o,i)=>{if(!o.id)throw new Error(`missing an audit id at ${a}[${i}]`);let c=r.get(o.id);if(!c)throw new Error(`could not find ${o.id} audit for category ${a}`);let l=c.implementation.meta.scoreDisplayMode==="manual";if(a==="accessibility"&&!o.group&&!l)throw new Error(`${o.id} accessibility audit does not have a group`);if(o.weight>0&&l)throw new Error(`${o.id} is manual but has a positive weight`);if(o.group&&(!n||!n[o.group]))throw new Error(`${o.id} references unknown group ${o.group}`)})})}function $g(e){if(!e.formFactor)throw new Error("`settings.formFactor` must be defined as 'mobile' or 'desktop'. See https://github.com/GoogleChrome/lighthouse/blob/main/docs/emulation.md");if(!e.screenEmulation.disabled&&e.screenEmulation.mobile!==(e.formFactor==="mobile"))throw new Error(`Screen emulation mobile setting (${e.screenEmulation.mobile}) does not match formFactor setting (${e.formFactor}). See https://github.com/GoogleChrome/lighthouse/blob/main/docs/emulation.md`);let t=e.skipAudits?.find(n=>e.onlyAudits?.includes(n));if(t)throw new Error(`${t} appears in both skipAudits and onlyAudits`)}function bX(e){let t=new Set;for(let n of e){if(gX(n),t.has(n.id))throw new Error(`Config defined multiple artifacts with id '${n.id}'`);if(t.add(n.id),!!n.dependencies)for(let[r,{id:a}]of Object.entries(n.dependencies))t.has(a)||Yg(n.id,r)}}function bI(e){bX(e.artifacts||[]);for(let t of e.audits||[])Wg(t);yX(e.categories,e.audits,e.groups),$g(e.settings)}function Yg(e,t){throw new Error([`Failed to find dependency "${t}" for "${e}" artifact`,"Check that...",`  1. A gatherer exposes a matching Symbol that satisfies "${t}".`,`  2. "${t}" is configured to run before "${e}"`].join(`
`))}function vI(e,t){throw new Error([`Dependency "${t}" for "${e}" artifact is invalid.`,"The dependency must be collected before the dependent."].join(`
`))}var Kg=b(()=>{"use strict";d();V();Se();A();s(gI,"isValidArtifactDependency");s(yI,"assertValidPluginName");s(gX,"assertValidArtifact");s(Wg,"assertValidAudit");s(yX,"assertValidCategories");s($g,"assertValidSettings");s(bX,"assertValidArtifacts");s(bI,"assertValidConfig");s(Yg,"throwInvalidDependencyOrder");s(vI,"throwInvalidArtifactDependency")});function wI(e,t){if(!e)return new Set;t=t||Object.keys(e);let r=t.map(a=>e[a]).flatMap(a=>a?.auditRefs||[]);return new Set(r.map(a=>a.id))}function TX(e,t){if(!e)return null;if(!t)return e;let n=new Map(e.map(o=>[o.id,o])),r=new Set([...xX,...t.flatMap(o=>o.implementation.meta.requiredArtifacts)]),a=0;for(;a!==r.size;){a=r.size;for(let o of r){let i=n.get(o);if(i&&i.dependencies)for(let c of Object.values(i.dependencies))r.add(c.id)}}return e.filter(o=>r.has(o.id))}function SX(e,t){return e?e.filter(n=>n.gatherer.instance.meta.supportedModes.includes(t)):null}function kX(e,t){if(!e)return null;let n=new Set(t.map(r=>r.id).concat(DX));return e.filter(r=>r.implementation.meta.requiredArtifacts.every(o=>n.has(o)))}function CX(e,t){return e?e.filter(n=>{let r=n.implementation.meta;return!r.supportedModes||r.supportedModes.includes(t)}):null}function AX(e,t){if(!e)return null;let n=Object.entries(e).filter(([r,a])=>!a.supportedModes||a.supportedModes.includes(t));return Object.fromEntries(n)}function _X(e,t){if(!e||!t)return e;let n=Object.entries(e).filter(([r])=>t.includes(r));return Object.fromEntries(n)}function RX(e,t){if(t)for(let n of t)e?.[n]||F.warn("config",`unrecognized category in 'onlyCategories': ${n}`)}function DI(e,t){if(!e)return e;let n=new Map(t.map(a=>[a.implementation.meta.id,a.implementation.meta])),r=Object.entries(e).map(([a,o])=>{let i={...o,auditRefs:o.auditRefs.filter(l=>n.has(l.id))},c=i.auditRefs.length<o.auditRefs.length,u=i.auditRefs.every(l=>{let m=n.get(l.id);return m?m.scoreDisplayMode===g.SCORING_MODES.MANUAL:!1});return c&&u&&(i.auditRefs=[]),[a,i]}).filter(a=>typeof a[1]=="object"&&a[1].auditRefs.length);return Object.fromEntries(r)}function EI(e,t){let n=SX(e.artifacts,t),r=CX(e.audits,t),a=kX(r,n||[]),o=AX(e.categories,t),i=DI(o,a||[]);return{...e,artifacts:n,audits:a,categories:i}}function xI(e,t){let{onlyAudits:n,onlyCategories:r,skipAudits:a}=t;RX(e.categories,r);let o=wI(e.categories,void 0);r?o=wI(e.categories,r):n?o=new Set:(!e.categories||!Object.keys(e.categories).length)&&(o=new Set(e.audits?.map(p=>p.implementation.meta.id)));let i=new Set([...o,...n||[],...EX].filter(p=>!a||!a.includes(p))),c=i.size&&e.audits?e.audits.filter(p=>i.has(p.implementation.meta.id)):e.audits,u=DI(e.categories,c||[]),l=_X(u,r),m=TX(e.artifacts,c);return m&&e.settings.disableFullPageScreenshot&&(m=m.filter(({id:p})=>p!=="FullPageScreenshot")),{...e,artifacts:m,audits:c,categories:l}}var wX,DX,EX,xX,TI=b(()=>{"use strict";d();Ae();V();wX={fetchTime:"",LighthouseRunWarnings:"",BenchmarkIndex:"",BenchmarkIndexes:"",settings:"",Timing:"",URL:"",PageLoadError:"",HostFormFactor:"",HostUserAgent:"",HostProduct:"",GatherContext:""},DX=Object.keys(wX),EX=[],xX=["Stacks","NetworkUserAgent","FullPageScreenshot"];s(wI,"getAuditIdsInCategories");s(TX,"filterArtifactsByAvailableAudits");s(SX,"filterArtifactsByGatherMode");s(kX,"filterAuditsByAvailableArtifacts");s(CX,"filterAuditsByGatherMode");s(AX,"filterCategoriesByGatherMode");s(_X,"filterCategoriesByExplicitFilters");s(RX,"warnOnUnknownOnlyCategories");s(DI,"filterCategoriesByAvailableAudits");s(EI,"filterConfigByGatherMode");s(xI,"filterConfigByExplicitFilters")});function Sp(e){return Array.isArray(e)&&e.every(kI)}function kI(e){return typeof e=="object"&&e!==null&&!Array.isArray(e)}function SI(e){return typeof e=="number"&&!isNaN(e)}var Tr,xu=b(()=>{"use strict";d();s(Sp,"isArrayOfUnknownObjects");s(kI,"isObjectOfUnknownProperties");s(SI,"isNumber");Tr=class e{static{s(this,"Budget")}static assertNoExcessProperties(t,n){let r=Object.keys(t);if(r.length>0){let a=r.join(", ");throw new Error(`${n} has unrecognized properties: [${a}]`)}}static assertNoDuplicateStrings(t,n){let r=new Set;for(let a of t){if(r.has(a))throw new Error(`${n} has duplicate entry of type '${a}'`);r.add(a)}}static validateResourceBudget(t){let{resourceType:n,budget:r,...a}=t;e.assertNoExcessProperties(a,"Resource Budget");let o=["total","document","script","stylesheet","image","media","font","other","third-party"];if(!o.includes(n))throw new Error(`Invalid resource type: ${n}. 
Valid resource types are: ${o.join(", ")}`);if(!SI(r))throw new Error(`Invalid budget: ${r}`);return{resourceType:n,budget:r}}static throwInvalidPathError(t,n){throw new Error(`Invalid path ${t}. ${n}
'Path' should be specified using the 'robots.txt' format.
Learn more about the 'robots.txt' format here:
https://developers.google.com/search/reference/robots_txt#url-matching-based-on-path-values`)}static validatePath(t){if(t!==void 0){if(typeof t!="string"){this.throwInvalidPathError(t,"Path should be a string.");return}else t.startsWith("/")?(t.match(/\*/g)||[]).length>1?this.throwInvalidPathError(t,"Path should only contain one '*'."):(t.match(/\$/g)||[]).length>1?this.throwInvalidPathError(t,"Path should only contain one '$' character."):t.includes("$")&&!t.endsWith("$")&&this.throwInvalidPathError(t,"'$' character should only occur at end of path."):this.throwInvalidPathError(t,"Path should start with '/'.");return t}}static getMatchingBudget(t,n){if(!(t===null||n===void 0))for(let r=t.length-1;r>=0;r--){let a=t[r];if(this.urlMatchesPattern(n,a.path))return a}}static urlMatchesPattern(t,n="/"){let r=new URL(t),a=r.pathname+r.search,o=n.includes("*"),i=n.includes("$");if(!o&&!i)return a.startsWith(n);if(!o&&i)return a===n.slice(0,-1);if(o&&!i){let[c,u]=n.split("*"),l=a.slice(c.length);return a.startsWith(c)&&l.includes(u)}else if(o&&i){let[c,u]=n.split("*"),l=a.slice(c.length);return a.startsWith(c)&&l.endsWith(u.slice(0,-1))}return!1}static validateTimingBudget(t){let{metric:n,budget:r,...a}=t;e.assertNoExcessProperties(a,"Timing Budget");let o=["first-contentful-paint","interactive","first-meaningful-paint","max-potential-fid","total-blocking-time","speed-index","largest-contentful-paint","cumulative-layout-shift"];if(!o.includes(n))throw new Error(`Invalid timing metric: ${n}. 
Valid timing metrics are: ${o.join(", ")}`);if(!SI(r))throw new Error(`Invalid budget: ${r}`);return{metric:n,budget:r}}static validateHostname(t){let n=`${t} is not a valid hostname.`;if(t.length===0)throw new Error(n);if(t.includes("/"))throw new Error(n);if(t.includes(":"))throw new Error(n);if(t.includes("*")&&(!t.startsWith("*.")||t.lastIndexOf("*")>0))throw new Error(n);return t}static validateHostnames(t){if(Array.isArray(t)&&t.every(n=>typeof n=="string"))return t.map(e.validateHostname);if(t!==void 0)throw new Error("firstPartyHostnames should be defined as an array of strings.")}static initializeBudget(t){if(t=JSON.parse(JSON.stringify(t)),!Sp(t))throw new Error("Budget file is not defined as an array of budgets.");return t.map((r,a)=>{let o={},{path:i,options:c,resourceSizes:u,resourceCounts:l,timings:m,...p}=r;if(e.assertNoExcessProperties(p,"Budget"),o.path=e.validatePath(i),kI(c)){let{firstPartyHostnames:h,...f}=c;e.assertNoExcessProperties(f,"Options property"),o.options={},o.options.firstPartyHostnames=e.validateHostnames(h)}else if(c!==void 0)throw new Error(`Invalid options property in budget at index ${a}`);if(Sp(u))o.resourceSizes=u.map(e.validateResourceBudget),e.assertNoDuplicateStrings(o.resourceSizes.map(h=>h.resourceType),`budgets[${a}].resourceSizes`);else if(u!==void 0)throw new Error(`Invalid resourceSizes entry in budget at index ${a}`);if(Sp(l))o.resourceCounts=l.map(e.validateResourceBudget),e.assertNoDuplicateStrings(o.resourceCounts.map(h=>h.resourceType),`budgets[${a}].resourceCounts`);else if(l!==void 0)throw new Error(`Invalid resourceCounts entry in budget at index ${a}`);if(Sp(m))o.timings=m.map(e.validateTimingBudget),e.assertNoDuplicateStrings(o.timings.map(h=>h.metric),`budgets[${a}].timings`);else if(m!==void 0)throw new Error(`Invalid timings entry in budget at index ${a}`);return o})}}});function CI(e){return Array.isArray(e)&&e.every(Su)}function Su(e){return typeof e=="object"&&e!==null&&!Array.isArray(e)}function FX(e){return typeof e!="string"?!1:e==="navigation"||e==="timespan"||e==="snapshot"}function IX(e){return Array.isArray(e)?e.every(FX):!1}function Tu(e,t,n=""){n&&(n+=" ");let r=Object.keys(e);if(r.length>0){let a=r.join(", ");throw new Error(`${t} has unrecognized ${n}properties: [${a}]`)}}var Xg,AI,_I=b(()=>{"use strict";d();A();s(CI,"isArrayOfUnknownObjects");s(Su,"isObjectOfUnknownProperties");s(FX,"objectIsGatherMode");s(IX,"isArrayOfGatherModes");s(Tu,"assertNoExcessProperties");Xg=class e{static{s(this,"ConfigPlugin")}static _parseAuditsList(t,n){if(t!==void 0){if(!CI(t))throw new Error(`${n} has an invalid audits array.`);return t.map(r=>{let{path:a,...o}=r;if(Tu(o,n,"audit"),typeof a!="string")throw new Error(`${n} has a missing audit path.`);return{path:a}})}}static _parseAuditRefsList(t,n){if(!CI(t))throw new Error(`${n} has no valid auditsRefs.`);return t.map(r=>{let{id:a,weight:o,group:i,...c}=r;if(Tu(c,n,"auditRef"),typeof a!="string")throw new Error(`${n} has an invalid auditRef id.`);if(typeof o!="number")throw new Error(`${n} has an invalid auditRef weight.`);if(typeof i!="string"&&typeof i<"u")throw new Error(`${n} has an invalid auditRef group.`);let u=i&&`${n}-${i}`;return{id:a,weight:o,group:u}})}static _parseCategory(t,n){if(!Su(t))throw new Error(`${n} has no valid category.`);let{title:r,description:a,manualDescription:o,auditRefs:i,supportedModes:c,...u}=t;if(Tu(u,n,"category"),!Dr(r))throw new Error(`${n} has an invalid category tile.`);if(!Dr(a)&&a!==void 0)throw new Error(`${n} has an invalid category description.`);if(!Dr(o)&&o!==void 0)throw new Error(`${n} has an invalid category manualDescription.`);if(!IX(c)&&c!==void 0)throw new Error(`${n} supportedModes must be an array, valid array values are "navigation", "timespan", and "snapshot".`);let l=e._parseAuditRefsList(i,n);return{title:r,auditRefs:l,description:a,manualDescription:o,supportedModes:c}}static _parseGroups(t,n){if(t===void 0)return;if(!Su(t))throw new Error(`${n} groups json is not defined as an object.`);let r=Object.entries(t),a={};return r.forEach(([o,i])=>{if(!Su(i))throw new Error(`${n} has a group not defined as an object.`);let{title:c,description:u,...l}=i;if(Tu(l,n,"group"),!Dr(c))throw new Error(`${n} has an invalid group title.`);if(!Dr(u)&&u!==void 0)throw new Error(`${n} has an invalid group description.`);a[`${n}-${o}`]={title:c,description:u}}),a}static parsePlugin(t,n){if(t=JSON.parse(JSON.stringify(t)),!Su(t))throw new Error(`${n} is not defined as an object.`);let{audits:r,category:a,groups:o,...i}=t;return Tu(i,n),{audits:e._parseAuditsList(r,n),categories:{[n]:e._parseCategory(a,n)},groups:e._parseGroups(o,n)}}},AI=Xg});var RI,FI=b(()=>{"use strict";d();Jr();Hi();RI=`/*! axe v4.8.1
 * Copyright (c) 2015 - 2023 Deque Systems, Inc.
 *
 * Your use of this Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * This entire copyright notice must appear in every copy of this file you
 * distribute or in any file that contains substantial portions of this source
 * code.
 */
!function e(t){var n=t,a=t.document;function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}var o=o||{};function i(e){this.name="SupportError",this.cause=e.cause,this.message="\`".concat(e.cause,"\` - feature unsupported in your environment."),e.ruleId&&(this.ruleId=e.ruleId,this.message+=" Skipping ".concat(this.ruleId," rule.")),this.stack=(new Error).stack}o.version="4.8.1","function"==typeof define&&define.amd&&define("axe-core",[],(function(){return o})),"object"===("undefined"==typeof module?"undefined":r(module))&&module.exports&&"function"==typeof e.toString&&(o.source="("+e.toString()+')(typeof window === "object" ? window : this);',module.exports=o),"function"==typeof t.getComputedStyle&&(t.axe=o),(i.prototype=Object.create(Error.prototype)).constructor=i;var u=["node"],l=["relatedNodes"],s=["node"],c=["variant"],d=["matches"],p=["chromium"],f=["noImplicit"],m=["noPresentational"],D=["precision","format","inGamut"],h=["space"],g=["algorithm"],b=["method"],v=["maxDeltaE","deltaEMethod","steps","maxSteps"],y=["node"],F=["environmentData"],w=["environmentData"],E=["environmentData"],C=["environmentData"],x=["environmentData"];function A(e,t,n){return(A=R()?Reflect.construct.bind():function(e,t,n){var a=[null];return a.push.apply(a,t),t=new(Function.bind.apply(e,a)),n&&N(t,n.prototype),t}).apply(null,arguments)}function k(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&N(e,t)}function N(e,t){return(N=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e})(e,t)}function B(e){var t=R();return function(){var n,a=_(e);n=t?(n=_(this).constructor,Reflect.construct(a,arguments,n)):a.apply(this,arguments),a=this;if(n&&("object"===r(n)||"function"==typeof n))return n;if(void 0!==n)throw new TypeError("Derived constructors may only return object or undefined");return T(a)}}function T(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function R(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}function _(e){return(_=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function S(e,t,n){M(e,t),t.set(e,n)}function O(e,t){M(e,t),t.add(e)}function M(e,t){if(t.has(e))throw new TypeError("Cannot initialize the same private elements twice on an object")}function P(e,t){return(t=j(e,t,"get")).get?t.get.call(e):t.value}function I(e,t,n){if(t.has(e))return n;throw new TypeError("attempted to get private field on non-instance")}function L(e,t,n){if((t=j(e,t,"set")).set)t.set.call(e,n);else{if(!t.writable)throw new TypeError("attempted to set read only private field");t.value=n}}function j(e,t,n){if(t.has(e))return t.get(e);throw new TypeError("attempted to "+n+" private field on non-instance")}function q(e,t){if(null==e)return{};var n,a=function(e,t){if(null==e)return{};var n,a,r={},o=Object.keys(e);for(a=0;a<o.length;a++)n=o[a],0<=t.indexOf(n)||(r[n]=e[n]);return r}(e,t);if(Object.getOwnPropertySymbols)for(var r=Object.getOwnPropertySymbols(e),o=0;o<r.length;o++)n=r[o],0<=t.indexOf(n)||Object.prototype.propertyIsEnumerable.call(e,n)&&(a[n]=e[n]);return a}function z(e){return function(e){if(Array.isArray(e))return Q(e)}(e)||V(e)||J(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function V(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}function $(){return($=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var n,a=arguments[t];for(n in a)Object.prototype.hasOwnProperty.call(a,n)&&(e[n]=a[n])}return e}).apply(this,arguments)}function H(e,t){return G(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var a,r,o,i,u=[],l=!0,s=!1;try{if(o=(n=n.call(e)).next,0===t){if(Object(n)!==n)return;l=!1}else for(;!(l=(a=o.call(n)).done)&&(u.push(a.value),u.length!==t);l=!0);}catch(e){s=!0,r=e}finally{try{if(!l&&null!=n.return&&(i=n.return(),Object(i)!==i))return}finally{if(s)throw r}}return u}}(e,t)||J(e,t)||U()}function U(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function G(e){if(Array.isArray(e))return e}function W(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Y(e,t){for(var n=0;n<t.length;n++){var a=t[n];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,X(a.key),a)}}function K(e,t,n){return t&&Y(e.prototype,t),n&&Y(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}function X(e){return e=function(e,t){if("object"!==r(e)||null===e)return e;var n=e[Symbol.toPrimitive];if(void 0===n)return String(e);if(n=n.call(e,"string"),"object"===r(n))throw new TypeError("@@toPrimitive must return a primitive value.");return n}(e),"symbol"===r(e)?e:String(e)}function Z(e,t){var n,a,r,o,i="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(i)return a=!(n=!0),{s:function(){i=i.call(e)},n:function(){var e=i.next();return n=e.done,e},e:function(e){a=!0,r=e},f:function(){try{n||null==i.return||i.return()}finally{if(a)throw r}}};if(Array.isArray(e)||(i=J(e))||t&&e&&"number"==typeof e.length)return i&&(e=i),o=0,{s:t=function(){},n:function(){return o>=e.length?{done:!0}:{done:!1,value:e[o++]}},e:function(e){throw e},f:t};throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function J(e,t){var n;if(e)return"string"==typeof e?Q(e,t):"Map"===(n="Object"===(n=Object.prototype.toString.call(e).slice(8,-1))&&e.constructor?e.constructor.name:n)||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Q(e,t):void 0}function Q(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,a=new Array(t);n<t;n++)a[n]=e[n];return a}function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function ee(e,t){return function(){return t||e((t={exports:{}}).exports,t),t.exports}}function te(e,t){for(var n in t)se(e,n,{get:t[n],enumerable:!0})}function ne(e){return function(e,t,n){if(t&&"object"===r(t)||"function"==typeof t){var a,o=Z(pe(t));try{for(o.s();!(a=o.n()).done;)!function(){var r=a.value;de.call(e,r)||"default"===r||se(e,r,{get:function(){return t[r]},enumerable:!(n=fe(t,r))||n.enumerable})}()}catch(e){o.e(e)}finally{o.f()}}return e}((t=se(null!=e?le(ce(e)):{},"default",e&&e.__esModule&&"default"in e?{get:function(){return e.default},enumerable:!0}:{value:e,enumerable:!0}),se(t,"__esModule",{value:!0})),e);var t}function ae(e,t,n){(t="symbol"!==r(t)?t+"":t)in e?se(e,t,{enumerable:!0,configurable:!0,writable:!0,value:n}):e[t]=n}var re,oe,ie,ue,le=Object.create,se=Object.defineProperty,ce=Object.getPrototypeOf,de=Object.prototype.hasOwnProperty,pe=Object.getOwnPropertyNames,fe=Object.getOwnPropertyDescriptor,me=ee((function(e,t){"use strict";t.exports=function(){}})),De=ee((function(e,t){"use strict";var n=me()();t.exports=function(e){return e!==n&&null!==e}})),he=ee((function(e,t){"use strict";var n=De(),a=Array.prototype.forEach,r=Object.create;t.exports=function(e){var t=r(null);return a.call(arguments,(function(e){if(n(e)){var a,r=Object(e),o=t;for(a in r)o[a]=r[a]}})),t}})),ge=ee((function(e,t){"use strict";t.exports=function(){var e=Math.sign;return"function"==typeof e&&1===e(10)&&-1===e(-20)}})),be=ee((function(e,t){"use strict";t.exports=function(e){return e=Number(e),isNaN(e)||0===e?e:0<e?1:-1}})),ve=ee((function(e,t){"use strict";t.exports=ge()()?Math.sign:be()})),ye=ee((function(e,t){"use strict";var n=ve(),a=Math.abs,r=Math.floor;t.exports=function(e){return isNaN(e)?0:0!==(e=Number(e))&&isFinite(e)?n(e)*r(a(e)):e}})),Fe=ee((function(e,t){"use strict";var n=ye(),a=Math.max;t.exports=function(e){return a(0,n(e))}})),we=ee((function(e,t){"use strict";var n=Fe();t.exports=function(e,t,a){return isNaN(e)?0<=t?a&&t?t-1:t:1:!1!==e&&n(e)}})),Ee=ee((function(e,t){"use strict";t.exports=function(e){if("function"!=typeof e)throw new TypeError(e+" is not a function");return e}})),Ce=ee((function(e,t){"use strict";var n=De();t.exports=function(e){if(n(e))return e;throw new TypeError("Cannot use null or undefined")}})),xe=ee((function(e,t){"use strict";var n=Ee(),a=Ce(),r=Function.prototype.bind,o=Function.prototype.call,i=Object.keys,u=Object.prototype.propertyIsEnumerable;t.exports=function(e,t){return function(l,s){var c,d=arguments[2],p=arguments[3];return l=Object(a(l)),n(s),c=i(l),p&&c.sort("function"==typeof p?r.call(p,l):void 0),"function"!=typeof e&&(e=c[e]),o.call(e,c,(function(e,n){return u.call(l,e)?o.call(s,d,l[e],e,l,n):t}))}}})),Ae=ee((function(e,t){"use strict";t.exports=xe()("forEach")})),ke=ee((function(){})),Ne=ee((function(e,t){"use strict";t.exports=function(){var e=Object.assign;return"function"==typeof e&&(e(e={foo:"raz"},{bar:"dwa"},{trzy:"trzy"}),e.foo+e.bar+e.trzy==="razdwatrzy")}})),Be=ee((function(e,t){"use strict";t.exports=function(){try{return Object.keys("primitive"),!0}catch(e){return!1}}})),Te=ee((function(e,t){"use strict";var n=De(),a=Object.keys;t.exports=function(e){return a(n(e)?Object(e):e)}})),Re=ee((function(e,t){"use strict";t.exports=Be()()?Object.keys:Te()})),_e=ee((function(e,t){"use strict";var n=Re(),a=Ce(),r=Math.max;t.exports=function(e,t){var o,i,u,l=r(arguments.length,2);for(e=Object(a(e)),u=function(n){try{e[n]=t[n]}catch(n){o=o||n}},i=1;i<l;++i)n(t=arguments[i]).forEach(u);if(void 0!==o)throw o;return e}})),Se=ee((function(e,t){"use strict";t.exports=Ne()()?Object.assign:_e()})),Oe=ee((function(e,t){"use strict";var n=De(),a={function:!0,object:!0};t.exports=function(e){return n(e)&&a[r(e)]||!1}})),Me=ee((function(e,t){"use strict";var n=Se(),a=Oe(),r=De(),o=Error.captureStackTrace;t.exports=function(e){e=new Error(e);var i=arguments[1],u=arguments[2];return r(u)||a(i)&&(u=i,i=null),r(u)&&n(e,u),r(i)&&(e.code=i),o&&o(e,t.exports),e}})),Pe=ee((function(e,t){"use strict";var n=Ce(),a=Object.defineProperty,r=Object.getOwnPropertyDescriptor,o=Object.getOwnPropertyNames,i=Object.getOwnPropertySymbols;t.exports=function(e,t){var u,l=Object(n(t));if(e=Object(n(e)),o(l).forEach((function(n){try{a(e,n,r(t,n))}catch(n){u=n}})),"function"==typeof i&&i(l).forEach((function(n){try{a(e,n,r(t,n))}catch(n){u=n}})),void 0!==u)throw u;return e}})),Ie=ee((function(e,t){"use strict";function n(e,t){return t}var a,r,o,i,u,l=Fe();try{Object.defineProperty(n,"length",{configurable:!0,writable:!1,enumerable:!1,value:1})}catch(e){}1===n.length?(a={configurable:!0,writable:!1,enumerable:!1},r=Object.defineProperty,t.exports=function(e,t){return t=l(t),e.length===t?e:(a.value=t,r(e,"length",a))}):(i=Pe(),u=[],o=function(e){var t,n=0;if(u[e])return u[e];for(t=[];e--;)t.push("a"+(++n).toString(36));return new Function("fn","return function ("+t.join(", ")+") { return fn.apply(this, arguments); };")},t.exports=function(e,t){if(t=l(t),e.length===t)return e;t=o(t)(e);try{i(t,e)}catch(e){}return t})})),Le=ee((function(e,t){"use strict";t.exports=function(e){return null!=e}})),je=ee((function(e,t){"use strict";var n=Le(),a={object:!0,function:!0,undefined:!0};t.exports=function(e){return!!n(e)&&hasOwnProperty.call(a,r(e))}})),qe=ee((function(e,t){"use strict";var n=je();t.exports=function(e){if(!n(e))return!1;try{return!!e.constructor&&e.constructor.prototype===e}catch(e){return!1}}})),ze=ee((function(e,t){"use strict";var n=qe();t.exports=function(e){if("function"!=typeof e)return!1;if(!hasOwnProperty.call(e,"length"))return!1;try{if("number"!=typeof e.length)return!1;if("function"!=typeof e.call)return!1;if("function"!=typeof e.apply)return!1}catch(e){return!1}return!n(e)}})),Ve=ee((function(e,t){"use strict";var n=ze(),a=/^\\s*class[\\s{/}]/,r=Function.prototype.toString;t.exports=function(e){return!!n(e)&&!a.test(r.call(e))}})),$e=ee((function(e,t){"use strict";var n="razdwatrzy";t.exports=function(){return"function"==typeof n.contains&&!0===n.contains("dwa")&&!1===n.contains("foo")}})),He=ee((function(e,t){"use strict";var n=String.prototype.indexOf;t.exports=function(e){return-1<n.call(this,e,arguments[1])}})),Ue=ee((function(e,t){"use strict";t.exports=$e()()?String.prototype.contains:He()})),Ge=ee((function(e,t){"use strict";var n=Le(),a=Ve(),r=Se(),o=he(),i=Ue();(t.exports=function(e,t){var a,u,l,s;return arguments.length<2||"string"!=typeof e?(s=t,t=e,e=null):s=arguments[2],n(e)?(a=i.call(e,"c"),u=i.call(e,"e"),l=i.call(e,"w")):u=!(a=l=!0),e={value:t,configurable:a,enumerable:u,writable:l},s?r(o(s),e):e}).gs=function(e,t,u){var l,s;return"string"!=typeof e?(s=u,u=t,t=e,e=null):s=arguments[3],n(t)?a(t)?n(u)?a(u)||(s=u,u=void 0):u=void 0:(s=t,t=u=void 0):t=void 0,e=n(e)?(l=i.call(e,"c"),i.call(e,"e")):!(l=!0),t={get:t,set:u,configurable:l,enumerable:e},s?r(o(s),t):t}})),We=ee((function(e,t){"use strict";var n=Ge(),a=Ee(),o=Function.prototype.apply,i=Function.prototype.call,u=Object.create,l=Object.defineProperty,s=Object.defineProperties,c=Object.prototype.hasOwnProperty,d={configurable:!0,enumerable:!1,writable:!0},p=function(e,t){var n;return a(t),c.call(this,"__ee__")?n=this.__ee__:(n=d.value=u(null),l(this,"__ee__",d),d.value=null),n[e]?"object"===r(n[e])?n[e].push(t):n[e]=[n[e],t]:n[e]=t,this},f=function(e,t){var n,r;return a(t),r=this,p.call(this,e,n=function(){m.call(r,e,n),o.call(t,this,arguments)}),n.__eeOnceListener__=t,this},m=function(e,t){var n,o,i,u;if(a(t),c.call(this,"__ee__")&&(n=this.__ee__)[e])if(o=n[e],"object"===r(o))for(u=0;i=o[u];++u)i!==t&&i.__eeOnceListener__!==t||(2===o.length?n[e]=o[u?0:1]:o.splice(u,1));else o!==t&&o.__eeOnceListener__!==t||delete n[e];return this},D=function(e){var t,n,a,u,l;if(c.call(this,"__ee__")&&(u=this.__ee__[e]))if("object"===r(u)){for(n=arguments.length,l=new Array(n-1),t=1;t<n;++t)l[t-1]=arguments[t];for(u=u.slice(),t=0;a=u[t];++t)o.call(a,this,l)}else switch(arguments.length){case 1:i.call(u,this);break;case 2:i.call(u,this,arguments[1]);break;case 3:i.call(u,this,arguments[1],arguments[2]);break;default:for(n=arguments.length,l=new Array(n-1),t=1;t<n;++t)l[t-1]=arguments[t];o.call(u,this,l)}},h={on:p,once:f,off:m,emit:D},g={on:n(p),once:n(f),off:n(m),emit:n(D)},b=s({},g);t.exports=e=function(e){return null==e?u(b):s(Object(e),g)},e.methods=h})),Ye=ee((function(e,t){"use strict";t.exports=function(){var e,t=Array.from;return"function"==typeof t&&(e=t(t=["raz","dwa"]),Boolean(e&&e!==t&&"dwa"===e[1]))}})),Ke=ee((function(e,t){"use strict";t.exports=function(){return"object"===("undefined"==typeof globalThis?"undefined":r(globalThis))&&!!globalThis&&globalThis.Array===Array}})),Xe=ee((function(e,n){function a(){if("object"===("undefined"==typeof self?"undefined":r(self))&&self)return self;if("object"===(void 0===t?"undefined":r(t))&&t)return t;throw new Error("Unable to resolve global \`this\`")}n.exports=function(){if(this)return this;try{Object.defineProperty(Object.prototype,"__global__",{get:function(){return this},configurable:!0})}catch(e){return a()}try{return __global__||a()}finally{delete Object.prototype.__global__}}()})),Ze=ee((function(e,t){"use strict";t.exports=Ke()()?globalThis:Xe()})),Je=ee((function(e,t){"use strict";var n=Ze(),a={object:!0,symbol:!0};t.exports=function(){var e,t=n.Symbol;if("function"!=typeof t)return!1;e=t("test symbol");try{String(e)}catch(e){return!1}return!!a[r(t.iterator)]&&!!a[r(t.toPrimitive)]&&!!a[r(t.toStringTag)]}})),Qe=ee((function(e,t){"use strict";t.exports=function(e){return!!e&&("symbol"===r(e)||!!e.constructor&&"Symbol"===e.constructor.name&&"Symbol"===e[e.constructor.toStringTag])}})),et=ee((function(e,t){"use strict";var n=Qe();t.exports=function(e){if(n(e))return e;throw new TypeError(e+" is not a symbol")}})),tt=ee((function(e,t){"use strict";var n=Ge(),a=Object.create,r=Object.defineProperty,o=Object.prototype,i=a(null);t.exports=function(e){for(var t,a,u=0;i[e+(u||"")];)++u;return i[e+=u||""]=!0,r(o,t="@@"+e,n.gs(null,(function(e){a||(a=!0,r(this,t,n(e)),a=!1)}))),t}})),nt=ee((function(e,t){"use strict";var n=Ge(),a=Ze().Symbol;t.exports=function(e){return Object.defineProperties(e,{hasInstance:n("",a&&a.hasInstance||e("hasInstance")),isConcatSpreadable:n("",a&&a.isConcatSpreadable||e("isConcatSpreadable")),iterator:n("",a&&a.iterator||e("iterator")),match:n("",a&&a.match||e("match")),replace:n("",a&&a.replace||e("replace")),search:n("",a&&a.search||e("search")),species:n("",a&&a.species||e("species")),split:n("",a&&a.split||e("split")),toPrimitive:n("",a&&a.toPrimitive||e("toPrimitive")),toStringTag:n("",a&&a.toStringTag||e("toStringTag")),unscopables:n("",a&&a.unscopables||e("unscopables"))})}})),at=ee((function(e,t){"use strict";var n=Ge(),a=et(),r=Object.create(null);t.exports=function(e){return Object.defineProperties(e,{for:n((function(t){return r[t]||(r[t]=e(String(t)))})),keyFor:n((function(e){for(var t in a(e),r)if(r[t]===e)return t}))})}})),rt=ee((function(e,t){"use strict";var n,a,o,i=Ge(),u=et(),l=Ze().Symbol,s=tt(),c=nt(),d=at(),p=Object.create,f=Object.defineProperties,m=Object.defineProperty;if("function"==typeof l)try{String(l()),o=!0}catch(e){}else l=null;a=function(e){if(this instanceof a)throw new TypeError("Symbol is not a constructor");return n(e)},t.exports=n=function e(t){var n;if(this instanceof e)throw new TypeError("Symbol is not a constructor");return o?l(t):(n=p(a.prototype),t=void 0===t?"":String(t),f(n,{__description__:i("",t),__name__:i("",s(t))}))},c(n),d(n),f(a.prototype,{constructor:i(n),toString:i("",(function(){return this.__name__}))}),f(n.prototype,{toString:i((function(){return"Symbol ("+u(this).__description__+")"})),valueOf:i((function(){return u(this)}))}),m(n.prototype,n.toPrimitive,i("",(function(){var e=u(this);return"symbol"===r(e)?e:e.toString()}))),m(n.prototype,n.toStringTag,i("c","Symbol")),m(a.prototype,n.toStringTag,i("c",n.prototype[n.toStringTag])),m(a.prototype,n.toPrimitive,i("c",n.prototype[n.toPrimitive]))})),ot=ee((function(e,t){"use strict";t.exports=Je()()?Ze().Symbol:rt()})),it=ee((function(e,t){"use strict";var n=Object.prototype.toString,a=n.call(function(){return arguments}());t.exports=function(e){return n.call(e)===a}})),ut=ee((function(e,t){"use strict";var n=Object.prototype.toString,a=RegExp.prototype.test.bind(/^[object [A-Za-z0-9]*Function]$/);t.exports=function(e){return"function"==typeof e&&a(n.call(e))}})),lt=ee((function(e,t){"use strict";var n=Object.prototype.toString,a=n.call("");t.exports=function(e){return"string"==typeof e||e&&"object"===r(e)&&(e instanceof String||n.call(e)===a)||!1}})),st=ee((function(e,t){"use strict";var n=ot().iterator,a=it(),r=ut(),o=Fe(),i=Ee(),u=Ce(),l=De(),s=lt(),c=Array.isArray,d=Function.prototype.call,p={configurable:!0,enumerable:!0,writable:!0,value:null},f=Object.defineProperty;t.exports=function(e){var t,m,D,h,g,b,v,y,F,w,E=arguments[1],C=arguments[2];if(e=Object(u(e)),l(E)&&i(E),this&&this!==Array&&r(this))t=this;else{if(!E){if(a(e))return 1!==(g=e.length)?Array.apply(null,e):((h=new Array(1))[0]=e[0],h);if(c(e)){for(h=new Array(g=e.length),m=0;m<g;++m)h[m]=e[m];return h}}h=[]}if(!c(e))if(void 0!==(F=e[n])){for(v=i(F).call(e),t&&(h=new t),y=v.next(),m=0;!y.done;)w=E?d.call(E,C,y.value,m):y.value,t?(p.value=w,f(h,m,p)):h[m]=w,y=v.next(),++m;g=m}else if(s(e)){for(g=e.length,t&&(h=new t),D=m=0;m<g;++m)w=e[m],m+1<g&&55296<=(b=w.charCodeAt(0))&&b<=56319&&(w+=e[++m]),w=E?d.call(E,C,w,D):w,t?(p.value=w,f(h,D,p)):h[D]=w,++D;g=D}if(void 0===g)for(g=o(e.length),t&&(h=new t(g)),m=0;m<g;++m)w=E?d.call(E,C,e[m],m):e[m],t?(p.value=w,f(h,m,p)):h[m]=w;return t&&(p.value=null,h.length=g),h}})),ct=ee((function(e,t){"use strict";t.exports=Ye()()?Array.from:st()})),dt=ee((function(e,t){"use strict";var n=ct(),a=Array.isArray;t.exports=function(e){return a(e)?e:n(e)}})),pt=ee((function(e,t){"use strict";var n=dt(),a=De(),r=Ee(),o=Array.prototype.slice,i=function(e){return this.map((function(t,n){return t?t(e[n]):e[n]})).concat(o.call(e,this.length))};t.exports=function(e){return(e=n(e)).forEach((function(e){a(e)&&r(e)})),i.bind(e)}})),ft=ee((function(e,t){"use strict";var n=Ee();t.exports=function(e){var t;return"function"==typeof e?{set:e,get:e}:(t={get:n(e.get)},void 0!==e.set?(t.set=n(e.set),e.delete&&(t.delete=n(e.delete)),e.clear&&(t.clear=n(e.clear))):t.set=t.get,t)}})),mt=ee((function(e,t){"use strict";var n=Me(),a=Ie(),r=Ge(),o=We().methods,i=pt(),u=ft(),l=Function.prototype.apply,s=Function.prototype.call,c=Object.create,d=Object.defineProperties,p=o.on,f=o.emit;t.exports=function(e,t,o){var m,D,h,g,b,v,y,F,w,E,C,x=c(null),A=!1!==t?t:isNaN(e.length)?1:e.length;return o.normalizer&&(E=u(o.normalizer),D=E.get,h=E.set,g=E.delete,b=E.clear),null!=o.resolvers&&(C=i(o.resolvers)),E=D?a((function(t){var a,r,o=arguments;if(C&&(o=C(o)),null!==(a=D(o))&&hasOwnProperty.call(x,a))return y&&m.emit("get",a,o,this),x[a];if(r=1===o.length?s.call(e,this,o[0]):l.call(e,this,o),null===a){if(null!==(a=D(o)))throw n("Circular invocation","CIRCULAR_INVOCATION");a=h(o)}else if(hasOwnProperty.call(x,a))throw n("Circular invocation","CIRCULAR_INVOCATION");return x[a]=r,F&&m.emit("set",a,null,r),r}),A):0===t?function(){var t;if(hasOwnProperty.call(x,"data"))return y&&m.emit("get","data",arguments,this),x.data;if(t=arguments.length?l.call(e,this,arguments):s.call(e,this),hasOwnProperty.call(x,"data"))throw n("Circular invocation","CIRCULAR_INVOCATION");return x.data=t,F&&m.emit("set","data",null,t),t}:function(t){var a,r=arguments;if(C&&(r=C(arguments)),a=String(r[0]),hasOwnProperty.call(x,a))return y&&m.emit("get",a,r,this),x[a];if(r=1===r.length?s.call(e,this,r[0]):l.call(e,this,r),hasOwnProperty.call(x,a))throw n("Circular invocation","CIRCULAR_INVOCATION");return x[a]=r,F&&m.emit("set",a,null,r),r},m={original:e,memoized:E,profileName:o.profileName,get:function(e){return C&&(e=C(e)),D?D(e):String(e[0])},has:function(e){return hasOwnProperty.call(x,e)},delete:function(e){var t;hasOwnProperty.call(x,e)&&(g&&g(e),t=x[e],delete x[e],w)&&m.emit("delete",e,t)},clear:function(){var e=x;b&&b(),x=c(null),m.emit("clear",e)},on:function(e,t){return"get"===e?y=!0:"set"===e?F=!0:"delete"===e&&(w=!0),p.call(this,e,t)},emit:f,updateEnv:function(){e=m.original}},o=D?a((function(e){var t=arguments;C&&(t=C(t)),null!==(t=D(t))&&m.delete(t)}),A):0===t?function(){return m.delete("data")}:function(e){return C&&(e=C(arguments)[0]),m.delete(e)},A=a((function(){var e=arguments;return 0===t?x.data:(C&&(e=C(e)),e=D?D(e):String(e[0]),x[e])})),v=a((function(){var e=arguments;return 0===t?m.has("data"):(C&&(e=C(e)),null!==(e=D?D(e):String(e[0]))&&m.has(e))})),d(E,{__memoized__:r(!0),delete:r(o),clear:r(m.clear),_get:r(A),_has:r(v)}),m}})),Dt=ee((function(e,t){"use strict";var n=Ee(),a=Ae(),r=ke(),o=mt(),i=we();t.exports=function e(t){var u,l,s;if(n(t),(u=Object(arguments[1])).async&&u.promise)throw new Error("Options 'async' and 'promise' cannot be used together");return hasOwnProperty.call(t,"__memoized__")&&!u.force?t:(l=i(u.length,t.length,u.async&&r.async),s=o(t,l,u),a(r,(function(e,t){u[t]&&e(u[t],s,u)})),e.__profiler__&&e.__profiler__(s),s.updateEnv(),s.memoized)}})),ht=ee((function(e,t){"use strict";t.exports=function(e){var t,n,a=e.length;if(!a)return"";for(t=String(e[n=0]);--a;)t+=""+e[++n];return t}})),gt=ee((function(e,t){"use strict";t.exports=function(e){return e?function(t){for(var n=String(t[0]),a=0,r=e;--r;)n+=""+t[++a];return n}:function(){return""}}})),bt=ee((function(e,t){"use strict";t.exports=function(){var e=Number.isNaN;return"function"==typeof e&&!e({})&&e(NaN)&&!e(34)}})),vt=ee((function(e,t){"use strict";t.exports=function(e){return e!=e}})),yt=ee((function(e,t){"use strict";t.exports=bt()()?Number.isNaN:vt()})),Ft=ee((function(e,t){"use strict";var n=yt(),a=Fe(),r=Ce(),o=Array.prototype.indexOf,i=Object.prototype.hasOwnProperty,u=Math.abs,l=Math.floor;t.exports=function(e){var t,s,c;if(!n(e))return o.apply(this,arguments);for(s=a(r(this).length),e=arguments[1],t=e=isNaN(e)?0:0<=e?l(e):a(this.length)-l(u(e));t<s;++t)if(i.call(this,t)&&(c=this[t],n(c)))return t;return-1}})),wt=ee((function(e,t){"use strict";var n=Ft(),a=Object.create;t.exports=function(){var e=0,t=[],r=a(null);return{get:function(e){var a,r=0,o=t,i=e.length;if(0===i)return o[i]||null;if(o=o[i]){for(;r<i-1;){if(-1===(a=n.call(o[0],e[r])))return null;o=o[1][a],++r}return-1===(a=n.call(o[0],e[r]))?null:o[1][a]||null}return null},set:function(a){var o,i=0,u=t,l=a.length;if(0===l)u[l]=++e;else{for(u[l]||(u[l]=[[],[]]),u=u[l];i<l-1;)-1===(o=n.call(u[0],a[i]))&&(o=u[0].push(a[i])-1,u[1].push([[],[]])),u=u[1][o],++i;-1===(o=n.call(u[0],a[i]))&&(o=u[0].push(a[i])-1),u[1][o]=++e}return r[e]=a,e},delete:function(e){var a,o=0,i=t,u=r[e],l=u.length,s=[];if(0===l)delete i[l];else if(i=i[l]){for(;o<l-1;){if(-1===(a=n.call(i[0],u[o])))return;s.push(i,a),i=i[1][a],++o}if(-1===(a=n.call(i[0],u[o])))return;for(e=i[1][a],i[0].splice(a,1),i[1].splice(a,1);!i[0].length&&s.length;)a=s.pop(),(i=s.pop())[0].splice(a,1),i[1].splice(a,1)}delete r[e]},clear:function(){t=[],r=a(null)}}}})),Et=ee((function(e,t){"use strict";var n=Ft();t.exports=function(){var e=0,t=[],a=[];return{get:function(e){return-1===(e=n.call(t,e[0]))?null:a[e]},set:function(n){return t.push(n[0]),a.push(++e),e},delete:function(e){-1!==(e=n.call(a,e))&&(t.splice(e,1),a.splice(e,1))},clear:function(){t=[],a=[]}}}})),Ct=ee((function(e,t){"use strict";var n=Ft(),a=Object.create;t.exports=function(e){var t=0,r=[[],[]],o=a(null);return{get:function(t){for(var a,o=0,i=r;o<e-1;){if(-1===(a=n.call(i[0],t[o])))return null;i=i[1][a],++o}return-1!==(a=n.call(i[0],t[o]))&&i[1][a]||null},set:function(a){for(var i,u=0,l=r;u<e-1;)-1===(i=n.call(l[0],a[u]))&&(i=l[0].push(a[u])-1,l[1].push([[],[]])),l=l[1][i],++u;return-1===(i=n.call(l[0],a[u]))&&(i=l[0].push(a[u])-1),l[1][i]=++t,o[t]=a,t},delete:function(t){for(var a,i=0,u=r,l=[],s=o[t];i<e-1;){if(-1===(a=n.call(u[0],s[i])))return;l.push(u,a),u=u[1][a],++i}if(-1!==(a=n.call(u[0],s[i]))){for(t=u[1][a],u[0].splice(a,1),u[1].splice(a,1);!u[0].length&&l.length;)a=l.pop(),(u=l.pop())[0].splice(a,1),u[1].splice(a,1);delete o[t]}},clear:function(){r=[[],[]],o=a(null)}}}})),xt=ee((function(e,t){"use strict";var n=Ee(),a=Ae(),r=Function.prototype.call;t.exports=function(e,t){var o={},i=arguments[2];return n(t),a(e,(function(e,n,a,u){o[n]=r.call(t,i,e,n,a,u)})),o}})),At=ee((function(e,t){"use strict";function n(e){if("function"!=typeof e)throw new TypeError(e+" is not a function");return e}function o(e){var t,r,o=a.createTextNode(""),i=0;return new e((function(){var e;if(t)r&&(t=r.concat(t));else{if(!r)return;t=r}if(r=t,t=null,"function"==typeof r)e=r,r=null,e();else for(o.data=i=++i%2;r;)e=r.shift(),r.length||(r=null),e()})).observe(o,{characterData:!0}),function(e){n(e),t?"function"==typeof t?t=[t,e]:t.push(e):(t=e,o.data=i=++i%2)}}t.exports=function(){if("object"===("undefined"==typeof process?"undefined":r(process))&&process&&"function"==typeof process.nextTick)return process.nextTick;if("function"==typeof queueMicrotask)return function(e){queueMicrotask(n(e))};if("object"===(void 0===a?"undefined":r(a))&&a){if("function"==typeof MutationObserver)return o(MutationObserver);if("function"==typeof WebKitMutationObserver)return o(WebKitMutationObserver)}return"function"==typeof setImmediate?function(e){setImmediate(n(e))}:"function"==typeof setTimeout||"object"===("undefined"==typeof setTimeout?"undefined":r(setTimeout))?function(e){setTimeout(n(e),0)}:null}()})),kt=ee((function(){"use strict";var e=ct(),t=xt(),n=Pe(),a=Ie(),r=At(),o=Array.prototype.slice,i=Function.prototype.apply,u=Object.create;ke().async=function(l,s){var c,d,p,f=u(null),m=u(null),D=s.memoized,h=s.original;s.memoized=a((function(e){var t=arguments,n=t[t.length-1];return"function"==typeof n&&(c=n,t=o.call(t,0,-1)),D.apply(d=this,p=t)}),D);try{n(s.memoized,D)}catch(l){}s.on("get",(function(e){var t,n,a;c&&(f[e]?("function"==typeof f[e]?f[e]=[f[e],c]:f[e].push(c),c=null):(t=c,n=d,a=p,c=d=p=null,r((function(){var r;hasOwnProperty.call(m,e)?(r=m[e],s.emit("getasync",e,a,n),i.call(t,r.context,r.args)):(c=t,d=n,p=a,D.apply(n,a))}))))})),s.original=function(){var t,n,a,o;return c?(t=e(arguments),a=c,c=d=p=null,t.push(n=function t(n){var a,u,l=t.id;if(null==l)r(i.bind(t,this,arguments));else if(delete t.id,a=f[l],delete f[l],a)return u=e(arguments),s.has(l)&&(n?s.delete(l):(m[l]={context:this,args:u},s.emit("setasync",l,"function"==typeof a?1:a.length))),"function"==typeof a?o=i.call(a,this,u):a.forEach((function(e){o=i.call(e,this,u)}),this),o}),o=i.call(h,this,t),n.cb=a,c=n,o):i.call(h,this,arguments)},s.on("set",(function(e){c?(f[e]?"function"==typeof f[e]?f[e]=[f[e],c.cb]:f[e].push(c.cb):f[e]=c.cb,delete c.cb,c.id=e,c=null):s.delete(e)})),s.on("delete",(function(e){var t;hasOwnProperty.call(f,e)||m[e]&&(t=m[e],delete m[e],s.emit("deleteasync",e,o.call(t.args,1)))})),s.on("clear",(function(){var e=m;m=u(null),s.emit("clearasync",t(e,(function(e){return o.call(e.args,1)})))}))}})),Nt=ee((function(e,t){"use strict";var n=Array.prototype.forEach,a=Object.create;t.exports=function(e){var t=a(null);return n.call(arguments,(function(e){t[e]=!0})),t}})),Bt=ee((function(e,t){"use strict";t.exports=function(e){return"function"==typeof e}})),Tt=ee((function(e,t){"use strict";var n=Bt();t.exports=function(e){try{return e&&n(e.toString)?e.toString():String(e)}catch(e){throw new TypeError("Passed argument cannot be stringifed")}}})),Rt=ee((function(e,t){"use strict";var n=Ce(),a=Tt();t.exports=function(e){return a(n(e))}})),_t=ee((function(e,t){"use strict";var n=Bt();t.exports=function(e){try{return e&&n(e.toString)?e.toString():String(e)}catch(e){return"<Non-coercible to string value>"}}})),St=ee((function(e,t){"use strict";var n=_t(),a=/[\\n\\r\\u2028\\u2029]/g;t.exports=function(e){return(e=100<(e=n(e)).length?e.slice(0,99)+"…":e).replace(a,(function(e){return JSON.stringify(e).slice(1,-1)}))}})),Ot=ee((function(e,t){function n(e){return!!e&&("object"===r(e)||"function"==typeof e)&&"function"==typeof e.then}t.exports=n,t.exports.default=n})),Mt=ee((function(){"use strict";var e=xt(),t=Nt(),n=Rt(),a=St(),r=Ot(),o=At(),i=Object.create,u=t("then","then:finally","done","done:finally");ke().promise=function(t,l){var s=i(null),c=i(null),d=i(null);if(!0===t)t=null;else if(t=n(t),!u[t])throw new TypeError("'"+a(t)+"' is not valid promise mode");l.on("set",(function(e,n,a){var i=!1;if(r(a)){s[e]=1,d[e]=a;var u=function(t){var n=s[e];if(i)throw new Error("Memoizee error: Detected unordered then|done & finally resolution, which in turn makes proper detection of success/failure impossible (when in 'done:finally' mode)\\nConsider to rely on 'then' or 'done' mode instead.");n&&(delete s[e],c[e]=t,l.emit("setasync",e,n))},p=function(){i=!0,s[e]&&(delete s[e],delete d[e],l.delete(e))},f=t;if("then"===(f=f||"then")){var m=function(){o(p)};"function"==typeof(a=a.then((function(e){o(u.bind(this,e))}),m)).finally&&a.finally(m)}else if("done"===f){if("function"!=typeof a.done)throw new Error("Memoizee error: Retrieved promise does not implement 'done' in 'done' mode");a.done(u,p)}else if("done:finally"===f){if("function"!=typeof a.done)throw new Error("Memoizee error: Retrieved promise does not implement 'done' in 'done:finally' mode");if("function"!=typeof a.finally)throw new Error("Memoizee error: Retrieved promise does not implement 'finally' in 'done:finally' mode");a.done(u),a.finally(p)}}else c[e]=a,l.emit("setasync",e,1)})),l.on("get",(function(e,t,n){var a,i;s[e]?++s[e]:(a=d[e],i=function(){l.emit("getasync",e,t,n)},r(a)?"function"==typeof a.done?a.done(i):a.then((function(){o(i)})):i())})),l.on("delete",(function(e){var t;delete d[e],s[e]?delete s[e]:hasOwnProperty.call(c,e)&&(t=c[e],delete c[e],l.emit("deleteasync",e,[t]))})),l.on("clear",(function(){var t=c;c=i(null),s=i(null),d=i(null),l.emit("clearasync",e(t,(function(e){return[e]})))}))}})),Pt=ee((function(){"use strict";var e=Ee(),t=Ae(),n=ke(),a=Function.prototype.apply;n.dispose=function(r,o,i){var u;e(r),i.async&&n.async||i.promise&&n.promise?(o.on("deleteasync",u=function(e,t){a.call(r,null,t)}),o.on("clearasync",(function(e){t(e,(function(e,t){u(t,e)}))}))):(o.on("delete",u=function(e,t){r(t)}),o.on("clear",(function(e){t(e,(function(e,t){u(t,e)}))})))}})),It=ee((function(e,t){"use strict";t.exports=2147483647})),Lt=ee((function(e,t){"use strict";var n=Fe(),a=It();t.exports=function(e){if(e=n(e),a<e)throw new TypeError(e+" exceeds maximum possible timeout");return e}})),jt=ee((function(){"use strict";var e=ct(),t=Ae(),n=At(),a=Ot(),r=Lt(),o=ke(),i=Function.prototype,u=Math.max,l=Math.min,s=Object.create;o.maxAge=function(c,d,p){var f,m,D,h;(c=r(c))&&(f=s(null),m=p.async&&o.async||p.promise&&o.promise?"async":"",d.on("set"+m,(function(e){f[e]=setTimeout((function(){d.delete(e)}),c),"function"==typeof f[e].unref&&f[e].unref(),h&&(h[e]&&"nextTick"!==h[e]&&clearTimeout(h[e]),h[e]=setTimeout((function(){delete h[e]}),D),"function"==typeof h[e].unref)&&h[e].unref()})),d.on("delete"+m,(function(e){clearTimeout(f[e]),delete f[e],h&&("nextTick"!==h[e]&&clearTimeout(h[e]),delete h[e])})),p.preFetch&&(D=!0===p.preFetch||isNaN(p.preFetch)?.333:u(l(Number(p.preFetch),1),0))&&(h={},D=(1-D)*c,d.on("get"+m,(function(t,r,o){h[t]||(h[t]="nextTick",n((function(){var n;"nextTick"===h[t]&&(delete h[t],d.delete(t),p.async&&(r=e(r)).push(i),n=d.memoized.apply(o,r),p.promise)&&a(n)&&("function"==typeof n.done?n.done(i,i):n.then(i,i))})))}))),d.on("clear"+m,(function(){t(f,(function(e){clearTimeout(e)})),f={},h&&(t(h,(function(e){"nextTick"!==e&&clearTimeout(e)})),h={})})))}})),qt=ee((function(e,t){"use strict";var n=Fe(),a=Object.create,r=Object.prototype.hasOwnProperty;t.exports=function(e){var t,o=0,i=1,u=a(null),l=a(null),s=0;return e=n(e),{hit:function(n){var a=l[n],c=++s;if(u[c]=n,l[n]=c,!a)return++o<=e?void 0:(n=u[i],t(n),n);if(delete u[a],i===a)for(;!r.call(u,++i););},delete:t=function(e){var t=l[e];if(t&&(delete u[t],delete l[e],--o,i===t))if(o)for(;!r.call(u,++i););else s=0,i=1},clear:function(){o=0,i=1,u=a(null),l=a(null),s=0}}}})),zt=ee((function(){"use strict";var e=Fe(),t=qt(),n=ke();n.max=function(a,r,o){var i;(a=e(a))&&(i=t(a),a=o.async&&n.async||o.promise&&n.promise?"async":"",r.on("set"+a,o=function(e){void 0!==(e=i.hit(e))&&r.delete(e)}),r.on("get"+a,o),r.on("delete"+a,i.delete),r.on("clear"+a,i.clear))}})),Vt=ee((function(){"use strict";var e=Ge(),t=ke(),n=Object.create,a=Object.defineProperties;t.refCounter=function(r,o,i){var u=n(null);i=i.async&&t.async||i.promise&&t.promise?"async":"";o.on("set"+i,(function(e,t){u[e]=t||1})),o.on("get"+i,(function(e){++u[e]})),o.on("delete"+i,(function(e){delete u[e]})),o.on("clear"+i,(function(){u={}})),a(o.memoized,{deleteRef:e((function(){var e=o.get(arguments);return null!==e&&u[e]?!--u[e]&&(o.delete(e),!0):null})),getRefCount:e((function(){var e=o.get(arguments);return null!==e&&u[e]||0}))})}})),$t=ee((function(e,t){"use strict";var n=he(),a=we(),r=Dt();t.exports=function(e){var t,o=n(arguments[1]);return o.normalizer||0!==(t=o.length=a(o.length,e.length,o.async))&&(o.primitive?!1===t?o.normalizer=ht():1<t&&(o.normalizer=gt()(t)):o.normalizer=!1===t?wt()():1===t?Et()():Ct()(t)),o.async&&kt(),o.promise&&Mt(),o.dispose&&Pt(),o.maxAge&&jt(),o.max&&zt(),o.refCounter&&Vt(),r(e,o)}})),Ht=ee((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isIdentStart=function(e){return"a"<=e&&e<="z"||"A"<=e&&e<="Z"||"-"===e||"_"===e},e.isIdent=function(e){return"a"<=e&&e<="z"||"A"<=e&&e<="Z"||"0"<=e&&e<="9"||"-"===e||"_"===e},e.isHex=function(e){return"a"<=e&&e<="f"||"A"<=e&&e<="F"||"0"<=e&&e<="9"},e.escapeIdentifier=function(t){for(var n=t.length,a="",r=0;r<n;){var o=t.charAt(r);if(e.identSpecialChars[o])a+="\\\\"+o;else if("_"===o||"-"===o||"A"<=o&&o<="Z"||"a"<=o&&o<="z"||0!==r&&"0"<=o&&o<="9")a+=o;else{if(55296==(63488&(o=o.charCodeAt(0)))){var i=t.charCodeAt(r++);if(55296!=(64512&o)||56320!=(64512&i))throw Error("UCS-2(decode): illegal sequence");o=((1023&o)<<10)+(1023&i)+65536}a+="\\\\"+o.toString(16)+" "}r++}return a},e.escapeStr=function(t){for(var n,a=t.length,r="",o=0;o<a;){var i=t.charAt(o);'"'===i?i='\\\\"':"\\\\"===i?i="\\\\\\\\":void 0!==(n=e.strReplacementsRev[i])&&(i=n),r+=i,o++}return'"'+r+'"'},e.identSpecialChars={"!":!0,'"':!0,"#":!0,$:!0,"%":!0,"&":!0,"'":!0,"(":!0,")":!0,"*":!0,"+":!0,",":!0,".":!0,"/":!0,";":!0,"<":!0,"=":!0,">":!0,"?":!0,"@":!0,"[":!0,"\\\\":!0,"]":!0,"^":!0,"\`":!0,"{":!0,"|":!0,"}":!0,"~":!0},e.strReplacementsRev={"\\n":"\\\\n","\\r":"\\\\r","\\t":"\\\\t","\\f":"\\\\f","\\v":"\\\\v"},e.singleQuoteEscapeChars={n:"\\n",r:"\\r",t:"\\t",f:"\\f","\\\\":"\\\\","'":"'"},e.doubleQuotesEscapeChars={n:"\\n",r:"\\r",t:"\\t",f:"\\f","\\\\":"\\\\",'"':'"'}})),Ut=ee((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=Ht();e.parseCssSelector=function(e,n,a,r,o,i){var u=e.length,l="";function s(a,r){var o="";for(n++,l=e.charAt(n);n<u;){if(l===a)return n++,o;var i;if("\\\\"===l)if(n++,(l=e.charAt(n))===a)o+=a;else if(void 0!==(i=r[l]))o+=i;else{if(t.isHex(l)){var s=l;for(n++,l=e.charAt(n);t.isHex(l);)s+=l,n++,l=e.charAt(n);" "===l&&(n++,l=e.charAt(n)),o+=String.fromCharCode(parseInt(s,16));continue}o+=l}else o+=l;n++,l=e.charAt(n)}return o}function c(){var a="";for(l=e.charAt(n);n<u;){if(!t.isIdent(l)){if("\\\\"!==l)return a;if(u<=++n)throw Error("Expected symbol but end of file reached.");if(l=e.charAt(n),!t.identSpecialChars[l]&&t.isHex(l)){var r=l;for(n++,l=e.charAt(n);t.isHex(l);)r+=l,n++,l=e.charAt(n);" "===l&&(n++,l=e.charAt(n)),a+=String.fromCharCode(parseInt(r,16));continue}}a+=l,n++,l=e.charAt(n)}return a}function d(){for(l=e.charAt(n);" "===l||"\\t"===l||"\\n"===l||"\\r"===l||"\\f"===l;)n++,l=e.charAt(n)}function p(){var t=f();if(!t)return null;var a=t;for(l=e.charAt(n);","===l;){if(n++,d(),"selectors"!==a.type&&(a={type:"selectors",selectors:[t]}),!(t=f()))throw Error('Rule expected after ",".');a.selectors.push(t)}return a}function f(){d();var t={type:"ruleSet"},a=m();if(!a)return null;for(var r=t;a&&(a.type="rule",r.rule=a,r=a,d(),l=e.charAt(n),!(u<=n||","===l||")"===l));)if(o[l]){var i=l;if(n++,d(),!(a=m()))throw Error('Rule expected after "'+i+'".');a.nestingOperator=i}else(a=m())&&(a.nestingOperator=null);return t}function m(){for(var o=null;n<u;)if("*"===(l=e.charAt(n)))n++,(o=o||{}).tagName="*";else if(t.isIdentStart(l)||"\\\\"===l)(o=o||{}).tagName=c();else if("."===l)n++,((o=o||{}).classNames=o.classNames||[]).push(c());else if("#"===l)n++,(o=o||{}).id=c();else if("["===l){n++,d();var f={name:c()};if(d(),"]"===l)n++;else{var m="";if(r[l]&&(m=l,n++,l=e.charAt(n)),u<=n)throw Error('Expected "=" but end of file reached.');if("="!==l)throw Error('Expected "=" but "'+l+'" found.');f.operator=m+"=",n++,d();var D="";if(f.valueType="string",'"'===l)D=s('"',t.doubleQuotesEscapeChars);else if("'"===l)D=s("'",t.singleQuoteEscapeChars);else if(i&&"$"===l)n++,D=c(),f.valueType="substitute";else{for(;n<u&&"]"!==l;)D+=l,n++,l=e.charAt(n);D=D.trim()}if(d(),u<=n)throw Error('Expected "]" but end of file reached.');if("]"!==l)throw Error('Expected "]" but "'+l+'" found.');n++,f.value=D}((o=o||{}).attrs=o.attrs||[]).push(f)}else{if(":"!==l)break;if(n++,f={name:m=c()},"("===l){n++;var h="";if(d(),"selector"===a[m])f.valueType="selector",h=p();else{if(f.valueType=a[m]||"string",'"'===l)h=s('"',t.doubleQuotesEscapeChars);else if("'"===l)h=s("'",t.singleQuoteEscapeChars);else if(i&&"$"===l)n++,h=c(),f.valueType="substitute";else{for(;n<u&&")"!==l;)h+=l,n++,l=e.charAt(n);h=h.trim()}d()}if(u<=n)throw Error('Expected ")" but end of file reached.');if(")"!==l)throw Error('Expected ")" but "'+l+'" found.');n++,f.value=h}((o=o||{}).pseudos=o.pseudos||[]).push(f)}return o}var D=p();if(n<u)throw Error('Rule expected but "'+e.charAt(n)+'" found.');return D}})),Gt=ee((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=Ht();e.renderEntity=function e(n){var a="";switch(n.type){case"ruleSet":for(var r=n.rule,o=[];r;)r.nestingOperator&&o.push(r.nestingOperator),o.push(e(r)),r=r.rule;a=o.join(" ");break;case"selectors":a=n.selectors.map(e).join(", ");break;case"rule":n.tagName&&(a="*"===n.tagName?"*":t.escapeIdentifier(n.tagName)),n.id&&(a+="#"+t.escapeIdentifier(n.id)),n.classNames&&(a+=n.classNames.map((function(e){return"."+t.escapeIdentifier(e)})).join("")),n.attrs&&(a+=n.attrs.map((function(e){return"operator"in e?"substitute"===e.valueType?"["+t.escapeIdentifier(e.name)+e.operator+"$"+e.value+"]":"["+t.escapeIdentifier(e.name)+e.operator+t.escapeStr(e.value)+"]":"["+t.escapeIdentifier(e.name)+"]"})).join("")),n.pseudos&&(a+=n.pseudos.map((function(n){return n.valueType?"selector"===n.valueType?":"+t.escapeIdentifier(n.name)+"("+e(n.value)+")":"substitute"===n.valueType?":"+t.escapeIdentifier(n.name)+"($"+n.value+")":"numeric"===n.valueType?":"+t.escapeIdentifier(n.name)+"("+n.value+")":":"+t.escapeIdentifier(n.name)+"("+t.escapeIdentifier(n.value)+")":":"+t.escapeIdentifier(n.name)})).join(""));break;default:throw Error('Unknown entity type: "'+n.type+'".')}return a}})),Wt=ee((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=Ut(),n=Gt();function a(){this.pseudos={},this.attrEqualityMods={},this.ruleNestingOperators={},this.substitutesEnabled=!1}a.prototype.registerSelectorPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)this.pseudos[a[n]]="selector";return this},a.prototype.unregisterSelectorPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)delete this.pseudos[a[n]];return this},a.prototype.registerNumericPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)this.pseudos[a[n]]="numeric";return this},a.prototype.unregisterNumericPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)delete this.pseudos[a[n]];return this},a.prototype.registerNestingOperators=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)this.ruleNestingOperators[a[n]]=!0;return this},a.prototype.unregisterNestingOperators=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)delete this.ruleNestingOperators[a[n]];return this},a.prototype.registerAttrEqualityMods=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)this.attrEqualityMods[a[n]]=!0;return this},a.prototype.unregisterAttrEqualityMods=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var n=0,a=e;n<a.length;n++)delete this.attrEqualityMods[a[n]];return this},a.prototype.enableSubstitutes=function(){return this.substitutesEnabled=!0,this},a.prototype.disableSubstitutes=function(){return this.substitutesEnabled=!1,this},a.prototype.parse=function(e){return t.parseCssSelector(e,0,this.pseudos,this.attrEqualityMods,this.ruleNestingOperators,this.substitutesEnabled)},a.prototype.render=function(e){return n.renderEntity(e).trim()},e.CssSelectorParser=a})),Yt=ee((function(e,a){!function(){"use strict";var e={name:"doT",version:"1.1.1",templateSettings:{evaluate:/\\{\\{([\\s\\S]+?(\\}?)+)\\}\\}/g,interpolate:/\\{\\{=([\\s\\S]+?)\\}\\}/g,encode:/\\{\\{!([\\s\\S]+?)\\}\\}/g,use:/\\{\\{#([\\s\\S]+?)\\}\\}/g,useParams:/(^|[^\\w$])def(?:\\.|\\[[\\'\\"])([\\w$\\.]+)(?:[\\'\\"]\\])?\\s*\\:\\s*([\\w$\\.]+|\\"[^\\"]+\\"|\\'[^\\']+\\'|\\{[^\\}]+\\})/g,define:/\\{\\{##\\s*([\\w\\.$]+)\\s*(\\:|=)([\\s\\S]+?)#\\}\\}/g,defineParams:/^\\s*([\\w$]+):([\\s\\S]+)/,conditional:/\\{\\{\\?(\\?)?\\s*([\\s\\S]*?)\\s*\\}\\}/g,iterate:/\\{\\{~\\s*(?:\\}\\}|([\\s\\S]+?)\\s*\\:\\s*([\\w$]+)\\s*(?:\\:\\s*([\\w$]+))?\\s*\\}\\})/g,varname:"it",strip:!0,append:!0,selfcontained:!1,doNotSkipEncoded:!1},template:void 0,compile:void 0,log:!0};if("object"!==("undefined"==typeof globalThis?"undefined":r(globalThis)))try{Object.defineProperty(Object.prototype,"__magic__",{get:function(){return this},configurable:!0}),__magic__.globalThis=__magic__,delete Object.prototype.__magic__}catch(e){t.globalThis=function(){if("undefined"!=typeof self)return self;if(void 0!==t)return t;if(void 0!==n)return n;if(void 0!==this)return this;throw new Error("Unable to locate global \`this\`")}()}e.encodeHTMLSource=function(e){var t={"&":"&#38;","<":"&#60;",">":"&#62;",'"':"&#34;","'":"&#39;","/":"&#47;"},n=e?/[&<>"'\\/]/g:/&(?!#?\\w+;)|<|>|"|'|\\//g;return function(e){return e?e.toString().replace(n,(function(e){return t[e]||e})):""}},void 0!==a&&a.exports?a.exports=e:"function"==typeof define&&define.amd?define((function(){return e})):globalThis.doT=e;var o={append:{start:"'+(",end:")+'",startencode:"'+encodeHTML("},split:{start:"';out+=(",end:");out+='",startencode:"';out+=encodeHTML("}},i=/$^/;function u(e){return e.replace(/\\\\('|\\\\)/g,"$1").replace(/[\\r\\t\\n]/g," ")}e.template=function(t,n,a){var r,l,s=(n=n||e.templateSettings).append?o.append:o.split,c=0;a=n.use||n.define?function e(t,n,a){return("string"==typeof n?n:n.toString()).replace(t.define||i,(function(e,n,r,o){return(n=0===n.indexOf("def.")?n.substring(4):n)in a||(":"===r?(t.defineParams&&o.replace(t.defineParams,(function(e,t,r){a[n]={arg:t,text:r}})),n in a||(a[n]=o)):new Function("def","def['"+n+"']="+o)(a)),""})).replace(t.use||i,(function(n,r){return t.useParams&&(r=r.replace(t.useParams,(function(e,t,n,r){var o;if(a[n]&&a[n].arg&&r)return o=(n+":"+r).replace(/'|\\\\/g,"_"),a.__exp=a.__exp||{},a.__exp[o]=a[n].text.replace(new RegExp("(^|[^\\\\w$])"+a[n].arg+"([^\\\\w$])","g"),"$1"+r+"$2"),t+"def.__exp['"+o+"']"}))),(r=new Function("def","return "+r)(a))&&e(t,r,a)}))}(n,t,a||{}):t,a=("var out='"+(n.strip?a.replace(/(^|\\r|\\n)\\t* +| +\\t*(\\r|\\n|$)/g," ").replace(/\\r|\\n|\\t|\\/\\*[\\s\\S]*?\\*\\//g,""):a).replace(/'|\\\\/g,"\\\\$&").replace(n.interpolate||i,(function(e,t){return s.start+u(t)+s.end})).replace(n.encode||i,(function(e,t){return r=!0,s.startencode+u(t)+s.end})).replace(n.conditional||i,(function(e,t,n){return t?n?"';}else if("+u(n)+"){out+='":"';}else{out+='":n?"';if("+u(n)+"){out+='":"';}out+='"})).replace(n.iterate||i,(function(e,t,n,a){return t?(c+=1,l=a||"i"+c,t=u(t),"';var arr"+c+"="+t+";if(arr"+c+"){var "+n+","+l+"=-1,l"+c+"=arr"+c+".length-1;while("+l+"<l"+c+"){"+n+"=arr"+c+"["+l+"+=1];out+='"):"';} } out+='"})).replace(n.evaluate||i,(function(e,t){return"';"+u(t)+"out+='"}))+"';return out;").replace(/\\n/g,"\\\\n").replace(/\\t/g,"\\\\t").replace(/\\r/g,"\\\\r").replace(/(\\s|;|\\}|^|\\{)out\\+='';/g,"$1").replace(/\\+''/g,"");r&&(n.selfcontained||!globalThis||globalThis._encodeHTML||(globalThis._encodeHTML=e.encodeHTMLSource(n.doNotSkipEncoded)),a="var encodeHTML = typeof _encodeHTML !== 'undefined' ? _encodeHTML : ("+e.encodeHTMLSource.toString()+"("+(n.doNotSkipEncoded||"")+"));"+a);try{return new Function(n.varname,a)}catch(t){throw"undefined"!=typeof console&&console.log("Could not create a template function: "+a),t}},e.compile=function(t,n){return e.template(t,null,n)}}()})),Kt=ee((function(e,o){var i;i=function(){"use strict";function e(e){return"function"==typeof e}var o=Array.isArray||function(e){return"[object Array]"===Object.prototype.toString.call(e)},i=0,u=void 0,l=void 0,s=function(e,t){D[i]=e,D[i+1]=t,2===(i+=2)&&(l?l(h):y())},c=void 0!==t?t:void 0,d=(d=c||{}).MutationObserver||d.WebKitMutationObserver,p="undefined"==typeof self&&"undefined"!=typeof process&&"[object process]"==={}.toString.call(process),f="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel;function m(){var e=setTimeout;return function(){return e(h,1)}}var D=new Array(1e3);function h(){for(var e=0;e<i;e+=2)(0,D[e])(D[e+1]),D[e]=void 0,D[e+1]=void 0;i=0}var g,b,v,y=void 0;function F(e,t){var n,a=this,r=new this.constructor(C),o=(void 0===r[E]&&I(r),a._state);return o?(n=arguments[o-1],s((function(){return M(o,r,n,a._result)}))):S(a,r,e,t),r}function w(e){var t;return e&&"object"===r(e)&&e.constructor===this?e:(B(t=new this(C),e),t)}y=p?function(){return process.nextTick(h)}:d?(b=0,p=new d(h),v=a.createTextNode(""),p.observe(v,{characterData:!0}),function(){v.data=b=++b%2}):f?((g=new MessageChannel).port1.onmessage=h,function(){return g.port2.postMessage(0)}):(void 0===c?function(){try{var e=Function("return this")().require("vertx");return void 0!==(u=e.runOnLoop||e.runOnContext)?function(){u(h)}:m()}catch(e){return m()}}:m)();var E=Math.random().toString(36).substring(2);function C(){}var x=void 0,A=1,k=2;function N(t,n,a){var r,o;n.constructor===t.constructor&&a===F&&n.constructor.resolve===w?(r=t,(o=n)._state===A?R(r,o._result):o._state===k?_(r,o._result):S(o,void 0,(function(e){return B(r,e)}),(function(e){return _(r,e)}))):void 0!==a&&e(a)?function(e,t,n){s((function(e){var a=!1,r=function(e,t,n,a){try{e.call(t,n,a)}catch(e){return e}}(n,t,(function(n){a||(a=!0,(t!==n?B:R)(e,n))}),(function(t){a||(a=!0,_(e,t))}),e._label);!a&&r&&(a=!0,_(e,r))}),e)}(t,n,a):R(t,n)}function B(e,t){if(e===t)_(e,new TypeError("You cannot resolve a promise with itself"));else if(a=r(n=t),null===n||"object"!==a&&"function"!==a)R(e,t);else{n=void 0;try{n=t.then}catch(t){return void _(e,t)}N(e,t,n)}var n,a}function T(e){e._onerror&&e._onerror(e._result),O(e)}function R(e,t){e._state===x&&(e._result=t,e._state=A,0!==e._subscribers.length)&&s(O,e)}function _(e,t){e._state===x&&(e._state=k,e._result=t,s(T,e))}function S(e,t,n,a){var r=e._subscribers,o=r.length;e._onerror=null,r[o]=t,r[o+A]=n,r[o+k]=a,0===o&&e._state&&s(O,e)}function O(e){var t=e._subscribers,n=e._state;if(0!==t.length){for(var a,r=void 0,o=e._result,i=0;i<t.length;i+=3)a=t[i],r=t[i+n],a?M(n,a,r,o):r(o);e._subscribers.length=0}}function M(t,n,a,r){var o=e(a),i=void 0,u=void 0,l=!0;if(o){try{i=a(r)}catch(t){l=!1,u=t}if(n===i)return void _(n,new TypeError("A promises callback cannot return that same promise."))}else i=r;n._state===x&&(o&&l?B(n,i):!1===l?_(n,u):t===A?R(n,i):t===k&&_(n,i))}var P=0;function I(e){e[E]=P++,e._state=void 0,e._result=void 0,e._subscribers=[]}j.prototype._enumerate=function(e){for(var t=0;this._state===x&&t<e.length;t++)this._eachEntry(e[t],t)},j.prototype._eachEntry=function(e,t){var n=this._instanceConstructor,a=n.resolve;if(a===w){var r,o=void 0,i=void 0,u=!1;try{o=e.then}catch(t){u=!0,i=t}o===F&&e._state!==x?this._settledAt(e._state,t,e._result):"function"!=typeof o?(this._remaining--,this._result[t]=e):n===q?(r=new n(C),u?_(r,i):N(r,e,o),this._willSettleAt(r,t)):this._willSettleAt(new n((function(t){return t(e)})),t)}else this._willSettleAt(a(e),t)},j.prototype._settledAt=function(e,t,n){var a=this.promise;a._state===x&&(this._remaining--,e===k?_(a,n):this._result[t]=n),0===this._remaining&&R(a,this._result)},j.prototype._willSettleAt=function(e,t){var n=this;S(e,void 0,(function(e){return n._settledAt(A,t,e)}),(function(e){return n._settledAt(k,t,e)}))};var L=j;function j(e,t){this._instanceConstructor=e,this.promise=new e(C),this.promise[E]||I(this.promise),o(t)?(this.length=t.length,this._remaining=t.length,this._result=new Array(this.length),0!==this.length&&(this.length=this.length||0,this._enumerate(t),0!==this._remaining)||R(this.promise,this._result)):_(this.promise,new Error("Array Methods must be provided an Array"))}z.prototype.catch=function(e){return this.then(null,e)},z.prototype.finally=function(t){var n=this.constructor;return e(t)?this.then((function(e){return n.resolve(t()).then((function(){return e}))}),(function(e){return n.resolve(t()).then((function(){throw e}))})):this.then(t,t)};var q=z;function z(e){if(this[E]=P++,this._result=this._state=void 0,this._subscribers=[],C!==e){if("function"!=typeof e)throw new TypeError("You must pass a resolver function as the first argument to the promise constructor");if(!(this instanceof z))throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.");var t=this;try{e((function(e){B(t,e)}),(function(e){_(t,e)}))}catch(e){_(t,e)}}}return q.prototype.then=F,q.all=function(e){return new L(this,e).promise},q.race=function(e){var t=this;return o(e)?new t((function(n,a){for(var r=e.length,o=0;o<r;o++)t.resolve(e[o]).then(n,a)})):new t((function(e,t){return t(new TypeError("You must pass an array to race."))}))},q.resolve=w,q.reject=function(e){var t=new this(C);return _(t,e),t},q._setScheduler=function(e){l=e},q._setAsap=function(e){s=e},q._asap=s,q.polyfill=function(){var e=void 0;if(void 0!==n)e=n;else if("undefined"!=typeof self)e=self;else try{e=Function("return this")()}catch(e){throw new Error("polyfill failed because global object is unavailable in this environment")}var t=e.Promise;if(t){var a=null;try{a=Object.prototype.toString.call(t.resolve())}catch(e){}if("[object Promise]"===a&&!t.cast)return}e.Promise=q},q.Promise=q},"object"===r(e)&&void 0!==o?o.exports=i():"function"==typeof define&&define.amd?define(i):e.ES6Promise=i()})),Xt=ee((function(e){var t,n,a=1e5,o=(t=Object.prototype.toString,n=Object.prototype.hasOwnProperty,{Class:function(e){return t.call(e).replace(/^\\[object *|\\]$/g,"")},HasProperty:function(e,t){return t in e},HasOwnProperty:function(e,t){return n.call(e,t)},IsCallable:function(e){return"function"==typeof e},ToInt32:function(e){return e>>0},ToUint32:function(e){return e>>>0}}),i=Math.LN2,u=Math.abs,l=Math.floor,s=Math.log,c=Math.min,d=Math.pow,p=Math.round;function f(e,t,n){return e<t?t:n<e?n:e}var m,D,h,g,b,v,y,F,w,E,C,x=Object.getOwnPropertyNames||function(e){if(e!==Object(e))throw new TypeError("Object.getOwnPropertyNames called on non-object");var t,n=[];for(t in e)o.HasOwnProperty(e,t)&&n.push(t);return n};function A(e){if(x&&m)for(var t=x(e),n=0;n<t.length;n+=1)m(e,t[n],{value:e[t[n]],writable:!1,enumerable:!1,configurable:!1})}function k(e){if(m){if(e.length>a)throw new RangeError("Array too large for polyfill");for(var t=0;t<e.length;t+=1)!function(t){m(e,t,{get:function(){return e._getter(t)},set:function(n){e._setter(t,n)},enumerable:!0,configurable:!1})}(t)}}function N(e,t){return e<<(t=32-t)>>t}function B(e,t){return e<<(t=32-t)>>>t}function T(e){return B(e[0],8)}function R(e,t,n){var a,r,o,p,f,m,D,h=(1<<t-1)-1;function g(e){var t=l(e);return(e=e-t)<.5||!(.5<e||t%2)?t:t+1}for(e!=e?(r=(1<<t)-1,o=d(2,n-1),a=0):e===1/0||e===-1/0?(r=(1<<t)-1,a=e<(o=0)?1:0):0===e?a=1/e==-1/(o=r=0)?1:0:(a=e<0,(e=u(e))>=d(2,1-h)?(r=c(l(s(e)/i),1023),2<=(o=g(e/d(2,r)*d(2,n)))/d(2,n)&&(r+=1,o=1),h<r?(r=(1<<t)-1,o=0):(r+=h,o-=d(2,n))):(r=0,o=g(e/d(2,1-h-n)))),f=[],p=n;p;--p)f.push(o%2?1:0),o=l(o/2);for(p=t;p;--p)f.push(r%2?1:0),r=l(r/2);for(f.push(a?1:0),f.reverse(),m=f.join(""),D=[];m.length;)D.push(parseInt(m.substring(0,8),2)),m=m.substring(8);return D}function _(e,t,n){for(var a,r,o,i,u,l,s=[],c=e.length;c;--c)for(r=e[c-1],a=8;a;--a)s.push(r%2?1:0),r>>=1;return s.reverse(),l=s.join(""),o=(1<<t-1)-1,i=parseInt(l.substring(0,1),2)?-1:1,u=parseInt(l.substring(1,1+t),2),l=parseInt(l.substring(1+t),2),u===(1<<t)-1?0===l?1/0*i:NaN:0<u?i*d(2,u-o)*(1+l/d(2,n)):0!==l?i*d(2,-(o-1))*(l/d(2,n)):i<0?-0:0}function S(e){if((e=o.ToInt32(e))<0)throw new RangeError("ArrayBuffer size is not a small enough positive integer");var t;for(this.byteLength=e,this._bytes=[],this._bytes.length=e,t=0;t<this.byteLength;t+=1)this._bytes[t]=0;A(this)}function O(){}function M(e,t,n){var a=function(e,t,n){var i,u,l,s;if(arguments.length&&"number"!=typeof e)if("object"===r(e)&&e.constructor===a)for(this.length=(i=e).length,this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new S(this.byteLength),l=this.byteOffset=0;l<this.length;l+=1)this._setter(l,i._getter(l));else if("object"!==r(e)||e instanceof S||"ArrayBuffer"===o.Class(e)){if("object"!==r(e)||!(e instanceof S||"ArrayBuffer"===o.Class(e)))throw new TypeError("Unexpected argument type(s)");if(this.buffer=e,this.byteOffset=o.ToUint32(t),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteOffset%this.BYTES_PER_ELEMENT)throw new RangeError("ArrayBuffer length minus the byteOffset is not a multiple of the element size.");if(arguments.length<3){if(this.byteLength=this.buffer.byteLength-this.byteOffset,this.byteLength%this.BYTES_PER_ELEMENT)throw new RangeError("length of buffer minus byteOffset not a multiple of the element size");this.length=this.byteLength/this.BYTES_PER_ELEMENT}else this.length=o.ToUint32(n),this.byteLength=this.length*this.BYTES_PER_ELEMENT;if(this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer")}else for(this.length=o.ToUint32((u=e).length),this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new S(this.byteLength),l=this.byteOffset=0;l<this.length;l+=1)s=u[l],this._setter(l,Number(s));else{if(this.length=o.ToInt32(e),n<0)throw new RangeError("ArrayBufferView size is not a small enough positive integer");this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new S(this.byteLength),this.byteOffset=0}this.constructor=a,A(this),k(this)};return(a.prototype=new O).BYTES_PER_ELEMENT=e,a.prototype._pack=t,a.prototype._unpack=n,a.BYTES_PER_ELEMENT=e,a.prototype.get=a.prototype._getter=function(e){if(arguments.length<1)throw new SyntaxError("Not enough arguments");if(!((e=o.ToUint32(e))>=this.length)){for(var t=[],n=0,a=this.byteOffset+e*this.BYTES_PER_ELEMENT;n<this.BYTES_PER_ELEMENT;n+=1,a+=1)t.push(this.buffer._bytes[a]);return this._unpack(t)}},a.prototype._setter=function(e,t){if(arguments.length<2)throw new SyntaxError("Not enough arguments");if((e=o.ToUint32(e))<this.length)for(var n=this._pack(t),a=0,r=this.byteOffset+e*this.BYTES_PER_ELEMENT;a<this.BYTES_PER_ELEMENT;a+=1,r+=1)this.buffer._bytes[r]=n[a]},a.prototype.set=function(e,t){if(arguments.length<1)throw new SyntaxError("Not enough arguments");var n,a,i,u,l,s,c,d,p,f;if("object"===r(e)&&e.constructor===this.constructor){if(n=e,(i=o.ToUint32(t))+n.length>this.length)throw new RangeError("Offset plus length of array is out of range");if(d=this.byteOffset+i*this.BYTES_PER_ELEMENT,p=n.length*this.BYTES_PER_ELEMENT,n.buffer===this.buffer){for(f=[],l=0,s=n.byteOffset;l<p;l+=1,s+=1)f[l]=n.buffer._bytes[s];for(l=0,c=d;l<p;l+=1,c+=1)this.buffer._bytes[c]=f[l]}else for(l=0,s=n.byteOffset,c=d;l<p;l+=1,s+=1,c+=1)this.buffer._bytes[c]=n.buffer._bytes[s]}else{if("object"!==r(e)||void 0===e.length)throw new TypeError("Unexpected argument type(s)");if(u=o.ToUint32((a=e).length),(i=o.ToUint32(t))+u>this.length)throw new RangeError("Offset plus length of array is out of range");for(l=0;l<u;l+=1)s=a[l],this._setter(i+l,Number(s))}},a.prototype.subarray=function(e,t){e=o.ToInt32(e),t=o.ToInt32(t),arguments.length<1&&(e=0),arguments.length<2&&(t=this.length),e<0&&(e=this.length+e),t<0&&(t=this.length+t),e=f(e,0,this.length);var n=(t=f(t,0,this.length))-e;return new this.constructor(this.buffer,this.byteOffset+e*this.BYTES_PER_ELEMENT,n=n<0?0:n)},a}function P(e,t){return o.IsCallable(e.get)?e.get(t):e[t]}function I(t,n,a){if(0===arguments.length)t=new e.ArrayBuffer(0);else if(!(t instanceof e.ArrayBuffer||"ArrayBuffer"===o.Class(t)))throw new TypeError("TypeError");if(this.buffer=t||new e.ArrayBuffer(0),this.byteOffset=o.ToUint32(n),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteLength=arguments.length<3?this.buffer.byteLength-this.byteOffset:o.ToUint32(a),this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer");A(this)}function L(t){return function(n,a){if((n=o.ToUint32(n))+t.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");n+=this.byteOffset;for(var r=new e.Uint8Array(this.buffer,n,t.BYTES_PER_ELEMENT),i=[],u=0;u<t.BYTES_PER_ELEMENT;u+=1)i.push(P(r,u));return Boolean(a)===Boolean(C)&&i.reverse(),P(new t(new e.Uint8Array(i).buffer),0)}}function j(t){return function(n,a,r){if((n=o.ToUint32(n))+t.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");a=new t([a]);for(var i=new e.Uint8Array(a.buffer),u=[],l=0;l<t.BYTES_PER_ELEMENT;l+=1)u.push(P(i,l));Boolean(r)===Boolean(C)&&u.reverse(),new e.Uint8Array(this.buffer,n,t.BYTES_PER_ELEMENT).set(u)}}m=Object.defineProperty&&function(){try{return Object.defineProperty({},"x",{}),1}catch(e){}}()?Object.defineProperty:function(e,t,n){if(!e===Object(e))throw new TypeError("Object.defineProperty called on non-object");return o.HasProperty(n,"get")&&Object.prototype.__defineGetter__&&Object.prototype.__defineGetter__.call(e,t,n.get),o.HasProperty(n,"set")&&Object.prototype.__defineSetter__&&Object.prototype.__defineSetter__.call(e,t,n.set),o.HasProperty(n,"value")&&(e[t]=n.value),e},e.ArrayBuffer=e.ArrayBuffer||S,E=M(1,(function(e){return[255&e]}),(function(e){return N(e[0],8)})),D=M(1,(function(e){return[255&e]}),T),h=M(1,(function(e){return[(e=p(Number(e)))<0?0:255<e?255:255&e]}),T),g=M(2,(function(e){return[e>>8&255,255&e]}),(function(e){return N(e[0]<<8|e[1],16)})),b=M(2,(function(e){return[e>>8&255,255&e]}),(function(e){return B(e[0]<<8|e[1],16)})),v=M(4,(function(e){return[e>>24&255,e>>16&255,e>>8&255,255&e]}),(function(e){return N(e[0]<<24|e[1]<<16|e[2]<<8|e[3],32)})),y=M(4,(function(e){return[e>>24&255,e>>16&255,e>>8&255,255&e]}),(function(e){return B(e[0]<<24|e[1]<<16|e[2]<<8|e[3],32)})),F=M(4,(function(e){return R(e,8,23)}),(function(e){return _(e,8,23)})),w=M(8,(function(e){return R(e,11,52)}),(function(e){return _(e,11,52)})),e.Int8Array=e.Int8Array||E,e.Uint8Array=e.Uint8Array||D,e.Uint8ClampedArray=e.Uint8ClampedArray||h,e.Int16Array=e.Int16Array||g,e.Uint16Array=e.Uint16Array||b,e.Int32Array=e.Int32Array||v,e.Uint32Array=e.Uint32Array||y,e.Float32Array=e.Float32Array||F,e.Float64Array=e.Float64Array||w,E=new e.Uint16Array([4660]),C=18===P(new e.Uint8Array(E.buffer),0),I.prototype.getUint8=L(e.Uint8Array),I.prototype.getInt8=L(e.Int8Array),I.prototype.getUint16=L(e.Uint16Array),I.prototype.getInt16=L(e.Int16Array),I.prototype.getUint32=L(e.Uint32Array),I.prototype.getInt32=L(e.Int32Array),I.prototype.getFloat32=L(e.Float32Array),I.prototype.getFloat64=L(e.Float64Array),I.prototype.setUint8=j(e.Uint8Array),I.prototype.setInt8=j(e.Int8Array),I.prototype.setUint16=j(e.Uint16Array),I.prototype.setInt16=j(e.Int16Array),I.prototype.setUint32=j(e.Uint32Array),I.prototype.setInt32=j(e.Int32Array),I.prototype.setFloat32=j(e.Float32Array),I.prototype.setFloat64=j(e.Float64Array),e.DataView=e.DataView||I})),Zt=ee((function(e){!function(e){"use strict";var t,n,a;function o(){if(void 0===this)throw new TypeError("Constructor WeakMap requires 'new'");if(a(this,"_id","_WeakMap_"+u()+"."+u()),0<arguments.length)throw new TypeError("WeakMap iterable is not supported")}function i(e,n){if(!l(e)||!t.call(e,"_id"))throw new TypeError(n+" method called on incompatible receiver "+r(e))}function u(){return Math.random().toString().substring(2)}function l(e){return Object(e)===e}e.WeakMap||(t=Object.prototype.hasOwnProperty,n=Object.defineProperty&&function(){try{return 1===Object.defineProperty({},"x",{value:1}).x}catch(e){}}(),e.WeakMap=((a=function(e,t,a){n?Object.defineProperty(e,t,{configurable:!0,writable:!0,value:a}):e[t]=a})(o.prototype,"delete",(function(e){var t;return i(this,"delete"),!!l(e)&&!(!(t=e[this._id])||t[0]!==e||(delete e[this._id],0))})),a(o.prototype,"get",(function(e){var t;return i(this,"get"),l(e)&&(t=e[this._id])&&t[0]===e?t[1]:void 0})),a(o.prototype,"has",(function(e){var t;return i(this,"has"),!!l(e)&&!(!(t=e[this._id])||t[0]!==e)})),a(o.prototype,"set",(function(e,t){var n;if(i(this,"set"),l(e))return(n=e[this._id])&&n[0]===e?n[1]=t:a(e,this._id,[e,t]),this;throw new TypeError("Invalid value used as weak map key")})),a(o,"_polyfill",!0),o))}("undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self?self:void 0!==t?t:void 0!==n?n:e)})),Jt={helpUrlBase:"https://dequeuniversity.com/rules/",gridSize:200,results:[],resultGroups:[],resultGroupMap:{},impact:Object.freeze(["minor","moderate","serious","critical"]),preload:Object.freeze({assets:["cssom","media"],timeout:1e4}),allOrigins:"<unsafe_all_origins>",sameOrigin:"<same_origin>"},Qt=([{name:"NA",value:"inapplicable",priority:0,group:"inapplicable"},{name:"PASS",value:"passed",priority:1,group:"passes"},{name:"CANTTELL",value:"cantTell",priority:2,group:"incomplete"},{name:"FAIL",value:"failed",priority:3,group:"violations"}].forEach((function(e){var t=e.name,n=e.value,a=e.priority;e=e.group;Jt[t]=n,Jt[t+"_PRIO"]=a,Jt[t+"_GROUP"]=e,Jt.results[a]=n,Jt.resultGroups[a]=e,Jt.resultGroupMap[n]=e})),Object.freeze(Jt.results),Object.freeze(Jt.resultGroups),Object.freeze(Jt.resultGroupMap),Object.freeze(Jt),Jt),en=function(){"object"===("undefined"==typeof console?"undefined":r(console))&&console.log&&Function.prototype.apply.call(console.log,console,arguments)},tn=/[\\t\\r\\n\\f]/g;function nn(){W(this,nn),this.parent=void 0}K(nn,[{key:"props",get:function(){throw new Error('VirtualNode class must have a "props" object consisting of "nodeType" and "nodeName" properties')}},{key:"attrNames",get:function(){throw new Error('VirtualNode class must have an "attrNames" property')}},{key:"attr",value:function(){throw new Error('VirtualNode class must have an "attr" function')}},{key:"hasAttr",value:function(){throw new Error('VirtualNode class must have a "hasAttr" function')}},{key:"hasClass",value:function(e){var t=this.attr("class");return!!t&&(e=" "+e+" ",0<=(" "+t+" ").replace(tn," ").indexOf(e))}}]);var an=nn,rn={},on=(te(rn,{DqElement:function(){return Jn},aggregate:function(){return on},aggregateChecks:function(){return pn},aggregateNodeResults:function(){return mn},aggregateResult:function(){return hn},areStylesSet:function(){return gn},assert:function(){return bn},checkHelper:function(){return Qn},clone:function(){return ea},closest:function(){return ca},collectResultsFromFrames:function(){return rr},contains:function(){return or},convertSelector:function(){return la},cssParser:function(){return ta},deepMerge:function(){return ir},escapeSelector:function(){return yn},extendMetaData:function(){return ur},filterHtmlAttrs:function(){return hp},finalizeRuleResult:function(){return fn},findBy:function(){return tr},getAllChecks:function(){return er},getAncestry:function(){return Un},getBaseLang:function(){return od},getCheckMessage:function(){return md},getCheckOption:function(){return Dd},getEnvironmentData:function(){return hd},getFlattenedTree:function(){return ad},getFrameContexts:function(){return Nd},getFriendlyUriEnd:function(){return Cn},getNodeAttributes:function(){return xn},getNodeFromTree:function(){return Kn},getPreloadConfig:function(){return cp},getRootNode:function(){return dr},getRule:function(){return Bd},getScroll:function(){return Rd},getScrollState:function(){return _d},getSelector:function(){return $n},getSelectorData:function(){return jn},getShadowSelector:function(){return Tn},getStandards:function(){return Sd},getStyleSheetFactory:function(){return Md},getXpath:function(){return Gn},injectStyle:function(){return Pd},isHidden:function(){return Id},isHtmlElement:function(){return Ld},isNodeInContext:function(){return jd},isShadowRoot:function(){return sr},isValidLang:function(){return Ap},isXHTML:function(){return Bn},matchAncestry:function(){return zd},matches:function(){return na},matchesExpression:function(){return sa},matchesSelector:function(){return An},memoize:function(){return Nn},mergeResults:function(){return ar},nodeLookup:function(){return $d},nodeSerializer:function(){return Qa},nodeSorter:function(){return Vd},parseCrossOriginStylesheet:function(){return Yd},parseSameOriginStylesheet:function(){return Gd},parseStylesheet:function(){return Wd},performanceTimer:function(){return Jd},pollyfillElementsFromPoint:function(){return Qd},preload:function(){return lp},preloadCssom:function(){return rp},preloadMedia:function(){return up},processMessage:function(){return fd},publishMetaData:function(){return dp},querySelectorAll:function(){return fp},querySelectorAllFilter:function(){return ap},queue:function(){return ha},respondable:function(){return Ga},ruleShouldRun:function(){return Dp},select:function(){return bp},sendCommandToFrame:function(){return Ya},setScrollState:function(){return vp},shadowSelect:function(){return yp},shadowSelectAll:function(){return Fp},shouldPreload:function(){return sp},toArray:function(){return vn},tokenList:function(){return Xc},uniqueArray:function(){return tp},uuid:function(){return Ba},validInputTypes:function(){return wp},validLangs:function(){return Cp}}),function(e,t,n){return t=t.slice(),n&&t.push(n),n=t.map((function(t){return e.indexOf(t)})).sort(),e[n.pop()]}),un=Qt.CANTTELL_PRIO,ln=Qt.FAIL_PRIO,sn=[],cn=(sn[Qt.PASS_PRIO]=!0,sn[Qt.CANTTELL_PRIO]=null,sn[Qt.FAIL_PRIO]=!1,["any","all","none"]);function dn(e,t){cn.reduce((function(n,a){return n[a]=(e[a]||[]).map((function(e){return t(e,a)})),n}),{})}var pn=function(e){var t=Object.assign({},e),n=(dn(t,(function(e,t){var n=void 0===e.result?-1:sn.indexOf(e.result);e.priority=-1!==n?n:Qt.CANTTELL_PRIO,"none"===t&&(e.priority===Qt.PASS_PRIO?e.priority=Qt.FAIL_PRIO:e.priority===Qt.FAIL_PRIO&&(e.priority=Qt.PASS_PRIO))})),{all:t.all.reduce((function(e,t){return Math.max(e,t.priority)}),0),none:t.none.reduce((function(e,t){return Math.max(e,t.priority)}),0),any:t.any.reduce((function(e,t){return Math.min(e,t.priority)}),4)%4}),a=(t.priority=Math.max(n.all,n.none,n.any),[]);return cn.forEach((function(e){t[e]=t[e].filter((function(a){return a.priority===t.priority&&a.priority===n[e]})),t[e].forEach((function(e){return a.push(e.impact)}))})),[un,ln].includes(t.priority)?t.impact=on(Qt.impact,a):t.impact=null,dn(t,(function(e){delete e.result,delete e.priority})),t.result=Qt.results[t.priority],delete t.priority,t};function fn(e){var t=o._audit.rules.find((function(t){return t.id===e.id}));return t&&t.impact&&e.nodes.forEach((function(e){["any","all","none"].forEach((function(n){(e[n]||[]).forEach((function(e){e.impact=t.impact}))}))})),Object.assign(e,mn(e.nodes)),delete e.nodes,e}var mn=function(e){var t={},n=((e=e.map((function(e){if(e.any&&e.all&&e.none)return pn(e);if(Array.isArray(e.node))return fn(e);throw new TypeError("Invalid Result type")})))&&e.length?(n=e.map((function(e){return e.result})),t.result=on(Qt.results,n,t.result)):t.result="inapplicable",Qt.resultGroups.forEach((function(e){return t[e]=[]})),e.forEach((function(e){var n=Qt.resultGroupMap[e.result];t[n].push(e)})),Qt.FAIL_GROUP);return 0===t[n].length&&(n=Qt.CANTTELL_GROUP),0<t[n].length?(e=t[n].map((function(e){return e.impact})),t.impact=on(Qt.impact,e)||null):t.impact=null,t};function Dn(e,t,n){var a=Object.assign({},t);a.nodes=(a[n]||[]).concat(),Qt.resultGroups.forEach((function(e){delete a[e]})),e[n].push(a)}var hn=function(e){var t={};return Qt.resultGroups.forEach((function(e){return t[e]=[]})),e.forEach((function(e){e.error?Dn(t,e,Qt.CANTTELL_GROUP):e.result===Qt.NA?Dn(t,e,Qt.NA_GROUP):Qt.resultGroups.forEach((function(n){Array.isArray(e[n])&&0<e[n].length&&Dn(t,e,n)}))})),t},gn=function e(n,a,r){var o=t.getComputedStyle(n,null);if(!o)return!1;for(var i=0;i<a.length;++i){var u=a[i];if(o.getPropertyValue(u.property)===u.value)return!0}return!(!n.parentNode||n.nodeName.toUpperCase()===r.toUpperCase())&&e(n.parentNode,a,r)},bn=function(e,t){if(!e)throw new Error(t)},vn=function(e){return Array.prototype.slice.call(e)},yn=function(e){for(var t,n=String(e),a=n.length,r=-1,o="",i=n.charCodeAt(0);++r<a;)0==(t=n.charCodeAt(r))?o+="�":o+=1<=t&&t<=31||127==t||0==r&&48<=t&&t<=57||1==r&&48<=t&&t<=57&&45==i?"\\\\"+t.toString(16)+" ":0==r&&1==a&&45==t||!(128<=t||45==t||95==t||48<=t&&t<=57||65<=t&&t<=90||97<=t&&t<=122)?"\\\\"+n.charAt(r):n.charAt(r);return o};function Fn(e,t){return[e.substring(0,t),e.substring(t)]}function wn(e){return e.replace(/\\s+$/,"")}var En,Cn=function(){var e,t,n,a,r,o,i,u,l=0<arguments.length&&void 0!==arguments[0]?arguments[0]:"",s=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};if(!(l.length<=1||"data:"===l.substr(0,5)||"javascript:"===l.substr(0,11)||l.includes("?")))return e=s.currentDomain,s=void 0===(s=s.maxLength)?25:s,i=o=u=r=a="",(n=l).includes("#")&&(l=(t=H(Fn(l,l.indexOf("#")),2))[0],i=t[1]),l.includes("?")&&(l=(t=H(Fn(l,l.indexOf("?")),2))[0],o=t[1]),l.includes("://")?(a=(t=H(l.split("://"),2))[0],r=(t=H(Fn(l=t[1],l.indexOf("/")),2))[0],l=t[1]):"//"===l.substr(0,2)&&(r=(t=H(Fn(l=l.substr(2),l.indexOf("/")),2))[0],l=t[1]),(r="www."===r.substr(0,4)?r.substr(4):r)&&r.includes(":")&&(r=(t=H(Fn(r,r.indexOf(":")),2))[0],u=t[1]),n=(t={original:n,protocol:a,domain:r,port:u,path:l,query:o,hash:i}).domain,a=t.hash,u=(r=t.path).substr(r.substr(0,r.length-2).lastIndexOf("/")+1),a?u&&(u+a).length<=s?wn(u+a):u.length<2&&2<a.length&&a.length<=s?wn(a):void 0:n&&n.length<s&&r.length<=1||r==="/"+u&&n&&e&&n!==e&&(n+r).length<=s?wn(n+r):(-1===(l=u.lastIndexOf("."))||1<l)&&(-1!==l||2<u.length)&&u.length<=s&&!u.match(/index(\\.[a-zA-Z]{2-4})?/)&&!function(e){var t=0<arguments.length&&void 0!==e?e:"";return 0!==t.length&&(t.match(/[0-9]/g)||"").length>=t.length/2}(u)?wn(u):void 0},xn=function(e){return(e.attributes instanceof t.NamedNodeMap?e:e.cloneNode(!1)).attributes},An=function(e,t){return!!e[En=En&&e[En]?En:function(e){for(var t,n=["matches","matchesSelector","mozMatchesSelector","webkitMatchesSelector","msMatchesSelector"],a=n.length,r=0;r<a;r++)if(e[t=n[r]])return t}(e)]&&e[En](t)},kn=ne($t()),Nn=(o._memoizedFns=[],function(e){return e=(0,kn.default)(e),o._memoizedFns.push(e),e}),Bn=Nn((function(e){return!(null==e||!e.createElement)&&"A"===e.createElement("A").localName}));function Tn(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{};if(!t)return"";var r=t.getRootNode&&t.getRootNode()||a;if(11!==r.nodeType)return e(t,n,r);for(var o=[];11===r.nodeType;){if(!r.host)return"";o.unshift({elm:t,doc:r}),r=(t=r.host).getRootNode()}return o.unshift({elm:t,doc:r}),o.map((function(t){return e(t.elm,n,t.doc)}))}var Rn=["class","style","id","selected","checked","disabled","tabindex","aria-checked","aria-selected","aria-invalid","aria-activedescendant","aria-busy","aria-disabled","aria-expanded","aria-grabbed","aria-pressed","aria-valuenow"],_n=31,Sn=/([\\\\"])/g,On=/(\\r\\n|\\r|\\n)/g;function Mn(e){return e.replace(Sn,"\\\\$1").replace(On,"\\\\a ")}function Pn(e,t){var n,a=t.name;return-1!==a.indexOf("href")||-1!==a.indexOf("src")?(n=Cn(e.getAttribute(a)))?yn(t.name)+'$="'+Mn(n)+'"':yn(t.name)+'="'+Mn(e.getAttribute(a))+'"':yn(a)+'="'+Mn(t.value)+'"'}function In(e,t){return e.count<t.count?-1:e.count===t.count?0:1}function Ln(e){return!Rn.includes(e.name)&&-1===e.name.indexOf(":")&&(!e.value||e.value.length<_n)}function jn(e){for(var t={classes:{},tags:{},attributes:{}},n=(e=Array.isArray(e)?e:[e]).slice(),a=[];n.length;)!function(){var e,r=n.pop(),o=r.actualNode;for(o.querySelectorAll&&(e=o.nodeName,t.tags[e]?t.tags[e]++:t.tags[e]=1,o.classList&&Array.from(o.classList).forEach((function(e){e=yn(e),t.classes[e]?t.classes[e]++:t.classes[e]=1})),o.hasAttributes())&&Array.from(xn(o)).filter(Ln).forEach((function(e){(e=Pn(o,e))&&(t.attributes[e]?t.attributes[e]++:t.attributes[e]=1)})),r.children.length&&(a.push(n),n=r.children.slice());!n.length&&a.length;)n=a.pop()}();return t}function qn(e){var t=Bn(a);return yn(t?e.localName:e.nodeName.toLowerCase())}function zn(e,t){var n,a,r,o,i,u,l,s,c,d="",p=(a=e,r=[],o=t.classes,i=t.tags,a.classList&&Array.from(a.classList).forEach((function(e){e=yn(e),o[e]<i[a.nodeName]&&r.push({name:e,count:o[e],species:"class"})})),r.sort(In));u=e,l=[],s=t.attributes,c=t.tags,u.hasAttributes()&&Array.from(xn(u)).filter(Ln).forEach((function(e){(e=Pn(u,e))&&s[e]<c[u.nodeName]&&l.push({name:e,count:s[e],species:"attribute"})})),t=l.sort(In);return p.length&&1===p[0].count?n=[p[0]]:t.length&&1===t[0].count?(n=[t[0]],d=qn(e)):((n=p.concat(t)).sort(In),(n=n.slice(0,3)).some((function(e){return"class"===e.species}))?n.sort((function(e,t){return e.species!==t.species&&"class"===e.species?-1:e.species===t.species?0:1})):d=qn(e)),d+n.reduce((function(e,t){switch(t.species){case"class":return e+"."+t.name;case"attribute":return e+"["+t.name+"]"}return e}),"")}function Vn(e,t,n){if(!o._selectorData)throw new Error("Expect axe._selectorData to be set up");var r,i,u=void 0!==(t=t.toRoot)&&t;do{var l=function(e){var t;if(e.getAttribute("id"))return t=e.getRootNode&&e.getRootNode()||a,(e="#"+yn(e.getAttribute("id")||"")).match(/player_uid_/)||1!==t.querySelectorAll(e).length?void 0:e}(e);l||(l=zn(e,o._selectorData),l+=function(e,t){var n=e.parentNode&&Array.from(e.parentNode.children||"")||[];return n.find((function(n){return n!==e&&An(n,t)}))?":nth-child("+(1+n.indexOf(e))+")":""}(e,l)),r=r?l+" > "+r:l,i=i?i.filter((function(e){return An(e,r)})):Array.from(n.querySelectorAll(r)),e=e.parentElement}while((1<i.length||u)&&e&&11!==e.nodeType);return 1===i.length?r:-1!==r.indexOf(" > ")?":root"+r.substring(r.indexOf(" > ")):":root"}function $n(e,t){return Tn(Vn,e,t)}function Hn(e){var t,n=e.nodeName.toLowerCase(),a=e.parentElement;return a?(t="","head"!==n&&"body"!==n&&1<a.children.length&&(e=Array.prototype.indexOf.call(a.children,e)+1,t=":nth-child(".concat(e,")")),Hn(a)+" > "+n+t):n}function Un(e,t){return Tn(Hn,e,t)}var Gn=function(e){return function e(t,n){var a,r,o,i;if(!t)return[];if(!n&&9===t.nodeType)return[{str:"html"}];if(n=n||[],t.parentNode&&t.parentNode!==t&&(n=e(t.parentNode,n)),t.previousSibling){for(r=1,a=t.previousSibling;1===a.nodeType&&a.nodeName===t.nodeName&&r++,a=a.previousSibling;);1===r&&(r=null)}else if(t.nextSibling)for(a=t.nextSibling;a=1===a.nodeType&&a.nodeName===t.nodeName?(r=1,null):(r=null,a.previousSibling););return 1===t.nodeType&&((o={}).str=t.nodeName.toLowerCase(),(i=t.getAttribute&&yn(t.getAttribute("id")))&&1===t.ownerDocument.querySelectorAll("#"+i).length&&(o.id=t.getAttribute("id")),1<r&&(o.count=r),n.push(o)),n}(e).reduce((function(e,t){return t.id?"/".concat(t.str,"[@id='").concat(t.id,"']"):e+"/".concat(t.str)+(0<t.count?"[".concat(t.count,"]"):"")}),"")},Wn={},Yn={set:function(e,t){var n;bn("string"==typeof(n=e),"key must be a string, "+r(n)+" given"),bn(""!==n,"key must not be empty"),Wn[e]=t},get:function(e,t){var n;return bn("function"==typeof(n=t)||void 0===n,"creator must be a function or undefined, "+r(n)+" given"),e in Wn?Wn[e]:"function"==typeof t?(n=t(),bn(void 0!==n,"Cache creator function should not return undefined"),this.set(e,n),Wn[e]):void 0},clear:function(){Wn={}}},Kn=function(e,t){return t=t||e,Yn.get("nodeMap")?Yn.get("nodeMap").get(t):null},Xn="DqElm.RunOptions";function Zn(e){var n,a,r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:null,i=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{};r=r||(null!=(n=Yn.get(Xn))?n:{}),this.spec=i,e instanceof an?(this._virtualNode=e,this._element=e.actualNode):(this._element=e,this._virtualNode=Kn(e)),this.fromFrame=1<(null==(n=this.spec.selector)?void 0:n.length),this._includeElementInJson=r.elementRef,r.absolutePaths&&(this._options={toRoot:!0}),this.nodeIndexes=[],Array.isArray(this.spec.nodeIndexes)?this.nodeIndexes=this.spec.nodeIndexes:"number"==typeof(null==(i=this._virtualNode)?void 0:i.nodeIndex)&&(this.nodeIndexes=[this._virtualNode.nodeIndex]),this.source=null,o._audit.noHtml||(this.source=null!=(n=this.spec.source)?n:null!=(r=this._element)&&r.outerHTML?((i=r.outerHTML)||"function"!=typeof t.XMLSerializer||(i=(new t.XMLSerializer).serializeToString(r)),(r=i||"").length>(a=a||300)&&(a=r.indexOf(">"),r=r.substring(0,a+1)),r):"")}Zn.prototype={get selector(){return this.spec.selector||[$n(this.element,this._options)]},get ancestry(){return this.spec.ancestry||[Un(this.element)]},get xpath(){return this.spec.xpath||[Gn(this.element)]},get element(){return this._element},toJSON:function(){var e={selector:this.selector,source:this.source,xpath:this.xpath,ancestry:this.ancestry,nodeIndexes:this.nodeIndexes,fromFrame:this.fromFrame};return this._includeElementInJson&&(e.element=this._element),e}},Zn.fromFrame=function(e,t,n){return e=Zn.mergeSpecs(e,n),new Zn(n.element,t,e)},Zn.mergeSpecs=function(e,t){return $({},e,{selector:[].concat(z(t.selector),z(e.selector)),ancestry:[].concat(z(t.ancestry),z(e.ancestry)),xpath:[].concat(z(t.xpath),z(e.xpath)),nodeIndexes:[].concat(z(t.nodeIndexes),z(e.nodeIndexes)),fromFrame:!0})},Zn.setRunOptions=function(e){var t=e.elementRef;e=e.absolutePaths;Yn.set(Xn,{elementRef:t,absolutePaths:e})};var Jn=Zn,Qn=function(e,n,a,r){return{isAsync:!1,async:function(){return this.isAsync=!0,function(t){t instanceof Error==0?(e.result=t,a(e)):r(t)}},data:function(t){e.data=t},relatedNodes:function(n){t.Node&&(n=n instanceof t.Node||n instanceof an?[n]:vn(n),e.relatedNodes=[],n.forEach((function(n){(n=n instanceof an?n.actualNode:n)instanceof t.Node&&(n=new Jn(n),e.relatedNodes.push(n))})))}}};function ea(e){return function e(n,a){var o,i;if(null===n||"object"!==r(n))return n;if(null!=(o=t)&&o.Node&&n instanceof t.Node||null!=(o=t)&&o.HTMLCollection&&n instanceof t.HTMLCollection||"nodeName"in n&&"nodeType"in n&&"ownerDocument"in n)return n;if(a.has(n))return a.get(n);if(Array.isArray(n))return i=[],a.set(n,i),n.forEach((function(t){i.push(e(t,a))})),i;var u={};for(var l in a.set(n,u),n)u[l]=e(n[l],a);return u}(e,new Map)}(Go=new(ne(Wt()).CssSelectorParser)).registerSelectorPseudos("not"),Go.registerSelectorPseudos("is"),Go.registerNestingOperators(">"),Go.registerAttrEqualityMods("^","$","*","~");var ta=Go;function na(e,t){return la(t).some((function(t){return sa(e,t)}))}function aa(e,t){return i=t,1===(o=e).props.nodeType&&("*"===i.tag||o.props.nodeName===i.tag)&&(r=e,!(o=t).classes||o.classes.every((function(e){return r.hasClass(e.value)})))&&(a=e,!(i=t).attributes||i.attributes.every((function(e){var t=a.attr(e.key);return null!==t&&e.test(t)})))&&(o=e,!(i=t).id||o.props.id===i.id)&&(n=e,!((o=t).pseudos&&!o.pseudos.every((function(e){if("not"===e.name)return!e.expressions.some((function(e){return sa(n,e)}));if("is"===e.name)return e.expressions.some((function(e){return sa(n,e)}));throw new Error("the pseudo selector "+e.name+" has not yet been implemented")}))));var n,a,r,o,i}ra=/(?=[\\-\\[\\]{}()*+?.\\\\\\^$|,#\\s])/g;var ra,oa=function(e){return e.replace(ra,"\\\\")},ia=/\\\\/g;function ua(e){return e.map((function(e){for(var t=[],n=e.rule;n;)t.push({tag:n.tagName?n.tagName.toLowerCase():"*",combinator:n.nestingOperator||" ",id:n.id,attributes:function(e){if(e)return e.map((function(e){var t,n,a=e.name.replace(ia,""),r=(e.value||"").replace(ia,"");switch(e.operator){case"^=":n=new RegExp("^"+oa(r));break;case"$=":n=new RegExp(oa(r)+"$");break;case"~=":n=new RegExp("(^|\\\\s)"+oa(r)+"(\\\\s|$)");break;case"|=":n=new RegExp("^"+oa(r)+"(-|$)");break;case"=":t=function(e){return r===e};break;case"*=":t=function(e){return e&&e.includes(r)};break;case"!=":t=function(e){return r!==e};break;default:t=function(e){return null!==e}}return""===r&&/^[*$^]=$/.test(e.operator)&&(t=function(){return!1}),{key:a,value:r,type:void 0===e.value?"attrExist":"attrValue",test:t=t||function(e){return e&&n.test(e)}}}))}(n.attrs),classes:function(e){if(e)return e.map((function(e){return{value:e=e.replace(ia,""),regexp:new RegExp("(^|\\\\s)"+oa(e)+"(\\\\s|$)")}}))}(n.classNames),pseudos:function(e){if(e)return e.map((function(e){var t;return["is","not"].includes(e.name)&&(t=ua(t=(t=e.value).selectors||[t])),{name:e.name,expressions:t,value:e.value}}))}(n.pseudos)}),n=n.rule;return t}))}function la(e){return ua((e=ta.parse(e)).selectors||[e])}function sa(e,t,n){return function e(t,n,a,r){if(!t)return!1;for(var o=Array.isArray(n)?n[a]:n,i=aa(t,o);!i&&r&&t.parent;)i=aa(t=t.parent,o);if(0<a){if(!1===[" ",">"].includes(o.combinator))throw new Error("axe.utils.matchesExpression does not support the combinator: "+o.combinator);i=i&&e(t.parent,n,a-1," "===o.combinator)}return i}(e,t,t.length-1,n)}var ca=function(e,t){for(;e;){if(na(e,t))return e;if(void 0===e.parent)throw new TypeError("Cannot resolve parent for non-DOM nodes");e=e.parent}return null};function da(){}function pa(e){if("function"!=typeof e)throw new TypeError("Queue methods require functions as arguments")}for(var fa,ma,Da,ha=function(){function e(e){t=e,setTimeout((function(){null!=t&&en("Uncaught error (of queue)",t)}),1)}var t,n=[],a=0,o=0,i=da,u=!1,l=e;function s(e){return i=da,l(e),n}function c(){for(var e=n.length;a<e;a++){var t=n[a];try{t.call(null,function(e){return function(t){n[e]=t,--o||i===da||(u=!0,i(n))}}(a),s)}catch(e){s(e)}}}var d={defer:function(e){var a;if("object"===r(e)&&e.then&&e.catch&&(a=e,e=function(e,t){a.then(e).catch(t)}),pa(e),void 0===t){if(u)throw new Error("Queue already completed");return n.push(e),++o,c(),d}},then:function(e){if(pa(e),i!==da)throw new Error("queue \`then\` already set");return t||(i=e,o)||(u=!0,i(n)),d},catch:function(n){if(pa(n),l!==e)throw new Error("queue \`catch\` already set");return t?(n(t),t=null):l=n,d},abort:s};return d},ga=t.crypto||t.msCrypto,ba=(!fa&&ga&&ga.getRandomValues&&(ma=new Uint8Array(16),fa=function(){return ga.getRandomValues(ma),ma}),fa||(Da=new Array(16),fa=function(){for(var e,t=0;t<16;t++)0==(3&t)&&(e=4294967296*Math.random()),Da[t]=e>>>((3&t)<<3)&255;return Da}),"function"==typeof t.Buffer?t.Buffer:Array),va=[],ya={},Fa=0;Fa<256;Fa++)va[Fa]=(Fa+256).toString(16).substr(1),ya[va[Fa]]=Fa;function wa(e,t){return t=t||0,va[e[t++]]+va[e[t++]]+va[e[t++]]+va[e[t++]]+"-"+va[e[t++]]+va[e[t++]]+"-"+va[e[t++]]+va[e[t++]]+"-"+va[e[t++]]+va[e[t++]]+"-"+va[e[t++]]+va[e[t++]]+va[e[t++]]+va[e[t++]]+va[e[t++]]+va[e[+t]]}var Ea=[1|(Go=fa())[0],Go[1],Go[2],Go[3],Go[4],Go[5]],Ca=16383&(Go[6]<<8|Go[7]),xa=0,Aa=0;function ka(e,t,n){var a=t&&n||0,r=t||[],o=(n=null!=(e=e||{}).clockseq?e.clockseq:Ca,null!=e.msecs?e.msecs:(new Date).getTime()),i=null!=e.nsecs?e.nsecs:Aa+1;if((u=o-xa+(i-Aa)/1e4)<0&&null==e.clockseq&&(n=n+1&16383),1e4<=(i=(u<0||xa<o)&&null==e.nsecs?0:i))throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");xa=o,Ca=n;for(var u=(1e4*(268435455&(o+=122192928e5))+(Aa=i))%4294967296,l=(i=(r[a++]=u>>>24&255,r[a++]=u>>>16&255,r[a++]=u>>>8&255,r[a++]=255&u,o/4294967296*1e4&268435455),r[a++]=i>>>8&255,r[a++]=255&i,r[a++]=i>>>24&15|16,r[a++]=i>>>16&255,r[a++]=n>>>8|128,r[a++]=255&n,e.node||Ea),s=0;s<6;s++)r[a+s]=l[s];return t||wa(r)}function Na(e,t,n){var a=t&&n||0,r=("string"==typeof e&&(t="binary"==e?new ba(16):null,e=null),(e=e||{}).random||(e.rng||fa)());if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,t)for(var o=0;o<16;o++)t[a+o]=r[o];return t||wa(r)}(Go=Na).v1=ka,Go.v4=Na,Go.parse=function(e,t,n){var a=t&&n||0,r=0;for(t=t||[],e.toLowerCase().replace(/[0-9a-f]{2}/g,(function(e){r<16&&(t[a+r++]=ya[e])}));r<16;)t[a+r++]=0;return t},Go.unparse=wa,Go.BufferClass=ba,o._uuid=ka();var Ba=Na,Ta=Object.freeze(["EvalError","RangeError","ReferenceError","SyntaxError","TypeError","URIError"]);function Ra(){var e="axeAPI",t="";return(e=void 0!==o&&o._audit&&o._audit.application?o._audit.application:e)+"."+(void 0!==o?o.version:t)}function _a(e){Oa(e),bn(t.parent===e,"Source of the response must be the parent window.")}function Sa(e){Oa(e),bn(e.parent===t,"Respondable target must be a frame in the current window")}function Oa(e){bn(t!==e,"Messages can not be sent to the same window.")}var Ma={},Pa=[];function Ia(){var e="".concat(Na(),":").concat(Na());return Pa.includes(e)?Ia():(Pa.push(e),e)}function La(e,t,n,a){var r,i,u,l,s;return(n?_a:Sa)(e),t.message instanceof Error&&!n?(o.log(t.message),!1):(s=(i=$({messageId:Ia()},t)).topic,u=i.channelId,l=i.message,u={channelId:u,topic:s,messageId:i.messageId,keepalive:!!i.keepalive,source:Ra()},l instanceof Error?u.error={name:l.name,message:l.message,stack:l.stack}:u.payload=l,r=JSON.stringify(u),!(!(s=o._audit.allowedOrigins)||!s.length||("function"==typeof a&&function(e,t,n){var a=!(2<arguments.length&&void 0!==n)||n;bn(!Ma[e],"A replyHandler already exists for this message channel."),Ma[e]={replyHandler:t,sendToParent:a}}(t.channelId,a,n),s.forEach((function(t){try{e.postMessage(r,t)}catch(n){if(n instanceof e.DOMException)throw new Error('allowedOrigins value "'.concat(t,'" is not a valid origin'));throw n}})),0)))}function ja(e,t,n){var a=!(2<arguments.length&&void 0!==n)||n;return function(n,r,o){La(e,{channelId:t,message:n,keepalive:r},a,o)}}function qa(e,n){var a,i,u,l=e.origin,s=e.data;e=e.source;try{var c=function(e){var n,a,o,i;try{n=JSON.parse(e)}catch(e){return}if(null!==(e=n)&&"object"===r(e)&&"string"==typeof e.channelId&&e.source===Ra())return a=(e=n).topic,o=e.channelId,i=e.messageId,e=e.keepalive,{topic:a,message:"object"===r(n.error)?function(e){var n=e.message||"Unknown error occurred",a=Ta.includes(e.name)?e.name:"Error";return a=t[a]||Error,e.stack&&(n+="\\n"+e.stack.replace(e.message,"")),new a(n)}(n.error):n.payload,messageId:i,channelId:o,keepalive:!!e}}(s)||{},d=c.channelId,p=c.message,f=c.messageId;if(i=l,((u=o._audit.allowedOrigins)&&u.includes("*")||u.includes(i))&&(a=f,!Pa.includes(a))&&(Pa.push(a),1))if(p instanceof Error&&e.parent!==t)o.log(p);else try{if(c.topic){var m=ja(e,d);_a(e),n(c,m)}else{var D=e,h=(b=c).channelId,g=b.message,b=b.keepalive,v=(y=function(e){return Ma[e]}(h)||{}).replyHandler,y=y.sendToParent;if(v){(y?_a:Sa)(D),D=ja(D,h,y),!b&&h&&function(e){delete Ma[e]}(h);try{v(g,b,D)}catch(n){o.log(n),D(n,b)}}}}catch(n){var F=e,w=n,E=d;if(!F.parent!==t)o.log(w);else try{La(F,{topic:null,channelId:E,message:w,messageId:Ia(),keepalive:!0},!0)}catch(n){return void o.log(n)}}}catch(n){o.log(n)}}var za,Va,$a={open:function(e){var n;if("function"==typeof t.addEventListener)return t.addEventListener("message",n=function(t){qa(t,e)},!1),function(){t.removeEventListener("message",n,!1)}},post:function(e,n,a){return"function"==typeof t.addEventListener&&La(e,n,!1,a)}};function Ha(e){e.updateMessenger($a)}var Ua={};function Ga(e,t,n,a,r){return t={topic:t,message:n,channelId:"".concat(Na(),":").concat(Na()),keepalive:a},Va(e,t,r)}function Wa(e,t){var n=e.topic,a=e.message;e=e.keepalive;if(n=Ua[n])try{n(a,e,t)}catch(n){o.log(n),t(n,e)}}function Ya(e,t,n,a){var r,o=e.contentWindow,i=null!=(i=null==(i=t.options)?void 0:i.pingWaitTime)?i:500;o?0===i?Ka(e,t,n,a):(r=setTimeout((function(){r=setTimeout((function(){t.debug?a(Xa("No response from frame",e)):n(null)}),0)}),i),Ga(o,"axe.ping",null,void 0,(function(){clearTimeout(r),Ka(e,t,n,a)}))):(en("Frame does not have a content window",e),n(null))}function Ka(e,t,n,a){var r=null!=(r=null==(r=t.options)?void 0:r.frameWaitTime)?r:6e4,o=e.contentWindow,i=setTimeout((function(){a(Xa("Axe in frame timed out",e))}),r);Ga(o,"axe.start",t,void 0,(function(e){clearTimeout(i),(e instanceof Error==0?n:a)(e)}))}function Xa(e,t){var n;return o._tree&&(n=$n(t)),new Error(e+": "+(n||t))}Ga.updateMessenger=function(e){var t=e.open;e=e.post,bn("function"==typeof t,"open callback must be a function"),bn("function"==typeof e,"post callback must be a function"),za&&za(),t=t(Wa);za=t?(bn("function"==typeof t,"open callback must return a cleanup function"),t):null,Va=e},Ga.subscribe=function(e,t){bn("function"==typeof t,"Subscriber callback must be a function"),bn(!Ua[e],"Topic ".concat(e," is already registered to.")),Ua[e]=t},Ga.isInFrame=function(){return!!(0<arguments.length&&void 0!==arguments[0]?arguments[0]:t).frameElement},Ha(Ga);var Za=null,Ja={update:function(e){bn("object"===r(e),"serializer must be an object"),Za=e},toSpec:function(e){return Ja.dqElmToSpec(new Jn(e))},dqElmToSpec:function(e,t){var n,a,r,o,i;return e instanceof Jn==0?e:(t&&(a=(n=e).fromFrame,r=t.ancestry,o=t.xpath,i=!1!==t.selectors||a,(n=new Jn(n.element,t,{source:n.source,nodeIndexes:n.nodeIndexes,selector:i?n.selector:[":root"],ancestry:r?n.ancestry:[":root"],xpath:o?n.xpath:"/"})).fromFrame=a,e=n),"function"==typeof(null==(t=Za)?void 0:t.toSpec)?Za.toSpec(e):e.toJSON())},mergeSpecs:function(e,t){var n;return("function"==typeof(null==(n=Za)?void 0:n.mergeSpecs)?Za:Jn).mergeSpecs(e,t)},mapRawResults:function(e){return e.map((function(e){return $({},e,{nodes:Ja.mapRawNodeResults(e.nodes)})}))},mapRawNodeResults:function(e){return null==e?void 0:e.map((function(e){var t=e.node,n=q(e,u);n.node=Ja.dqElmToSpec(t);for(var a=0,r=["any","all","none"];a<r.length;a++){var o=r[a];n[o]=n[o].map((function(e){var t=e.relatedNodes;return(e=q(e,l)).relatedNodes=t.map(Ja.dqElmToSpec),e}))}return n}))}},Qa=Ja,er=function(e){return[].concat(e.any||[]).concat(e.all||[]).concat(e.none||[])},tr=function(e,t,n){if(Array.isArray(e))return e.find((function(e){return null!==e&&"object"===r(e)&&Object.hasOwn(e,t)&&e[t]===n}))};function nr(e,t){for(var n=0<arguments.length&&void 0!==e?e:[],a=1<arguments.length&&void 0!==t?t:[],r=Math.max(null==n?void 0:n.length,null==a?void 0:a.length),o=0;o<r;o++){var i=null==n?void 0:n[o],u=null==a?void 0:a[o];if("number"!=typeof i||isNaN(i))return 0===o?1:-1;if("number"!=typeof u||isNaN(u))return 0===o?-1:1;if(i!==u)return i-u}return 0}var ar=function(e,t){var n=[];return e.forEach((function(e){var t,a=(a=e)&&a.results?Array.isArray(a.results)?a.results.length?a.results:null:[a.results]:null;a&&a.length&&(t=function(e){return e.frameElement?Qa.toSpec(e.frameElement):e.frameSpec?e.frameSpec:null}(e),a.forEach((function(e){e.nodes&&t&&(r=e.nodes,a=t,r.forEach((function(e){e.node=Qa.mergeSpecs(e.node,a),er(e).forEach((function(e){e.relatedNodes=e.relatedNodes.map((function(e){return Qa.mergeSpecs(e,a)}))}))})));var a,r=tr(n,"id",e.id);if(r){if(e.nodes.length){for(var o=r.nodes,i=e.nodes,u=i[0].node,l=0;l<o.length;l++){var s=o[l].node,c=nr(s.nodeIndexes,u.nodeIndexes);if(0<c||0===c&&u.selector.length<s.selector.length)return void o.splice.apply(o,[l,0].concat(z(i)))}o.push.apply(o,z(i))}}else n.push(e)})))})),n.forEach((function(e){e.nodes&&e.nodes.sort((function(e,t){return nr(e.node.nodeIndexes,t.node.nodeIndexes)}))})),n};function rr(e,t,n,a,r,o){t=$({},t,{elementRef:!1});var i=ha();e.frames.forEach((function(e){var r=e.node,o=q(e,s);i.defer((function(e,i){Ya(r,{options:t,command:n,parameter:a,context:o},(function(t){return e(t?{results:t,frameElement:r}:null)}),i)}))})),i.then((function(e){r(ar(e,t))})).catch(o)}function or(e,t){if(!e.shadowId&&!t.shadowId&&e.actualNode&&"function"==typeof e.actualNode.contains)return e.actualNode.contains(t.actualNode);do{if(e===t)return!0;if(t.nodeIndex<e.nodeIndex)return!1}while(t=t.parent);return!1}var ir=function e(){for(var t={},n=arguments.length,a=new Array(n),o=0;o<n;o++)a[o]=arguments[o];return a.forEach((function(n){if(n&&"object"===r(n)&&!Array.isArray(n))for(var a=0,o=Object.keys(n);a<o.length;a++){var i=o[a];!t.hasOwnProperty(i)||"object"!==r(n[i])||Array.isArray(t[i])?t[i]=n[i]:t[i]=e(t[i],n[i])}})),t},ur=function(e,t){Object.assign(e,t),Object.keys(t).filter((function(e){return"function"==typeof t[e]})).forEach((function(n){e[n]=null;try{e[n]=t[n](e)}catch(n){}}))},lr=["article","aside","blockquote","body","div","footer","h1","h2","h3","h4","h5","h6","header","main","nav","p","section","span"],sr=function(e){return!!(e.shadowRoot&&(e=e.nodeName.toLowerCase(),lr.includes(e)||/^[a-z][a-z0-9_.-]*-[a-z0-9_.-]*$/.test(e)))},cr={},dr=(te(cr,{createGrid:function(){return lo},findElmsInContext:function(){return fr},findNearbyElms:function(){return go},findUp:function(){return Dr},findUpVirtual:function(){return mr},focusDisabled:function(){return Co},getComposedParent:function(){return Pr},getElementByReference:function(){return No},getElementCoordinates:function(){return Lr},getElementStack:function(){return _o},getModalDialog:function(){return vo},getOverflowHiddenAncestors:function(){return br},getRootNode:function(){return pr},getScrollOffset:function(){return Ir},getTabbableElements:function(){return So},getTargetRects:function(){return Io},getTargetSize:function(){return Lo},getTextElementStack:function(){return yu},getViewportSize:function(){return jr},getVisibleChildTextRects:function(){return vu},hasContent:function(){return Au},hasContentVirtual:function(){return xu},hasLangText:function(){return ku},idrefs:function(){return qo},insertedIntoFocusOrder:function(){return Nu},isCurrentPageLink:function(){return ko},isFocusable:function(){return Mo},isHTML5:function(){return _u},isHiddenForEveryone:function(){return Sr},isHiddenWithCSS:function(){return Ru},isInTabOrder:function(){return Po},isInTextBlock:function(){return Pu},isInert:function(){return yo},isModalOpen:function(){return Iu},isMultiline:function(){return Lu},isNativelyFocusable:function(){return Oo},isNode:function(){return ju},isOffscreen:function(){return qr},isOpaque:function(){return Sc},isSkipLink:function(){return Oc},isVisible:function(){return Lc},isVisibleOnScreen:function(){return Vr},isVisibleToScreenReaders:function(){return Mi},isVisualContent:function(){return wu},reduceToElementsBelowFloating:function(){return jc},shadowElementsFromPoint:function(){return $c},urlPropsFromAttribute:function(){return Hc},visuallyContains:function(){return qc},visuallyOverlaps:function(){return Uc},visuallySort:function(){return Bo}}),function(e){var t=e.getRootNode&&e.getRootNode()||a;return t===e?a:t}),pr=dr,fr=function(e){var t=e.context,n=e.value,a=e.attr;e=void 0===(e=e.elm)?"":e,n=yn(n),t=9===t.nodeType||11===t.nodeType?t:pr(t);return Array.from(t.querySelectorAll(e+"["+a+"="+n+"]"))},mr=function(e,t){var n=e.actualNode;if(!e.shadowId&&"function"==typeof e.actualNode.closest)return e.actualNode.closest(t)||null;for(;(n=(n=n.assignedSlot||n.parentNode)&&11===n.nodeType?n.host:n)&&!An(n,t)&&n!==a.documentElement;);return n&&An(n,t)?n:null},Dr=function(e,t){return mr(Kn(e),t)};function hr(e,t){return(0|e.left)<(0|t.right)&&(0|e.right)>(0|t.left)&&(0|e.top)<(0|t.bottom)&&(0|e.bottom)>(0|t.top)}var gr=Nn((function(e){var t=[];return e?("hidden"===e.getComputedStylePropertyValue("overflow")&&t.push(e),t.concat(gr(e.parent))):t})),br=gr,vr=/rect\\s*\\(([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px\\s*\\)/,yr=/(\\w+)\\((\\d+)/;function Fr(e){return["style","script","noscript","template"].includes(e.props.nodeName)}function wr(e){return"area"!==e.props.nodeName&&"none"===e.getComputedStylePropertyValue("display")}function Er(e){return!(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).isAncestor&&["hidden","collapse"].includes(e.getComputedStylePropertyValue("visibility"))}function Cr(e){return!!(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).isAncestor&&"hidden"===e.getComputedStylePropertyValue("content-visibility")}function xr(e){return"true"===e.attr("aria-hidden")}function Ar(e){return"0"===e.getComputedStylePropertyValue("opacity")}function kr(e){var t=Rd(e.actualNode),n=parseInt(e.getComputedStylePropertyValue("height"));e=parseInt(e.getComputedStylePropertyValue("width"));return!!t&&(0===n||0===e)}function Nr(e){var t,n;return!(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).isAncestor&&(t=e.boundingClientRect,!!(n=br(e)).length)&&n.some((function(e){return(e=e.boundingClientRect).width<2||e.height<2||!hr(t,e)}))}function Br(e){var t=e.getComputedStylePropertyValue("clip").match(vr),n=e.getComputedStylePropertyValue("clip-path").match(yr);if(t&&5===t.length&&(e=e.getComputedStylePropertyValue("position"),["fixed","absolute"].includes(e)))return t[3]-t[1]<=0&&t[2]-t[4]<=0;if(n){e=n[1];var a=parseInt(n[2],10);switch(e){case"inset":return 50<=a;case"circle":return 0===a}}return!1}function Tr(e,t){var n,a=ca(e,"map");return!a||!((a=a.attr("name"))&&(e=dr(e.actualNode))&&9===e.nodeType&&(n=fp(o._tree,'img[usemap="#'.concat(yn(a),'"]')))&&n.length)||n.some((function(e){return!t(e)}))}function Rr(e){var t;return"details"===(null==(t=e.parent)?void 0:t.props.nodeName)&&(("summary"!==e.props.nodeName||e.parent.children.find((function(e){return"summary"===e.props.nodeName}))!==e)&&!e.parent.hasAttr("open"))}var _r=[wr,Er,Cr,Rr];function Sr(e){var t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).skipAncestors,n=void 0!==(n=n.isAncestor)&&n;return e=$d(e).vNode,(t?Or:Mr)(e,n)}var Or=Nn((function(e,t){return!!Fr(e)||!(!e.actualNode||!_r.some((function(n){return n(e,{isAncestor:t})}))&&e.actualNode.isConnected)})),Mr=Nn((function(e,t){return!!Or(e,t)||!!e.parent&&Mr(e.parent,!0)})),Pr=function e(t){if(t.assignedSlot)return e(t.assignedSlot);if(t.parentNode){if(1===(t=t.parentNode).nodeType)return t;if(t.host)return t.host}return null},Ir=function(e){var t,n;return 9===(e=!e.nodeType&&e.document?e.document:e).nodeType?(t=e.documentElement,n=e.body,{left:t&&t.scrollLeft||n&&n.scrollLeft||0,top:t&&t.scrollTop||n&&n.scrollTop||0}):{left:e.scrollLeft,top:e.scrollTop}},Lr=function(e){var t=(n=Ir(a)).left,n=n.top;return{top:(e=e.getBoundingClientRect()).top+n,right:e.right+t,bottom:e.bottom+n,left:e.left+t,width:e.right-e.left,height:e.bottom-e.top}},jr=function(e){var t=e.document,n=t.documentElement;return e.innerWidth?{width:e.innerWidth,height:e.innerHeight}:n?{width:n.clientWidth,height:n.clientHeight}:{width:(e=t.body).clientWidth,height:e.clientHeight}},qr=function(e){if((1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).isAncestor)return!1;var n=$d(e).domNode;if(n){var r=a.documentElement,o=t.getComputedStyle(n),i=t.getComputedStyle(a.body||r).getPropertyValue("direction"),u=Lr(n);if(u.bottom<0&&(function(e,t){for(e=Pr(e);e&&"html"!==e.nodeName.toLowerCase();){if(e.scrollTop&&0<=(t+=e.scrollTop))return;e=Pr(e)}return 1}(n,u.bottom)||"absolute"===o.position))return!0;if(0!==u.left||0!==u.right)if("ltr"===i){if(u.right<=0)return!0}else if(n=Math.max(r.scrollWidth,jr(t).width),u.left>=n)return!0;return!1}},zr=[Ar,kr,Nr,Br,qr];function Vr(e){return e=$d(e).vNode,$r(e)}var $r=Nn((function(e,t){return e.actualNode&&"area"===e.props.nodeName?!Tr(e,$r):!(Sr(e,{skipAncestors:!0,isAncestor:t})||e.actualNode&&zr.some((function(n){return n(e,{isAncestor:t})})))&&(!e.parent||$r(e.parent,!0))}));function Hr(e,n){var a=Math.min(e.top,n.top),r=Math.max(e.right,n.right),o=Math.max(e.bottom,n.bottom);e=Math.min(e.left,n.left);return new t.DOMRect(e,a,r-e,o-a)}function Ur(e,t){var n=e.x,a=(e=e.y,t.top),r=t.right,o=t.bottom;t=t.left;return a<=e&&n<=r&&e<=o&&t<=n}var Gr={};function Wr(e,n){var a=Math.max(e.left,n.left),r=Math.min(e.right,n.right),o=Math.max(e.top,n.top);e=Math.min(e.bottom,n.bottom);return r<=a||e<=o?null:new t.DOMRect(a,o,r-a,e-o)}function Yr(e){var n=e.left,a=e.top,r=e.width;e=e.height;return new t.DOMPoint(n+r/2,a+e/2)}te(Gr,{getBoundingRect:function(){return Hr},getIntersectionRect:function(){return Wr},getOffset:function(){return Zr},getRectCenter:function(){return Yr},hasVisualOverlap:function(){return Qr},isPointInRect:function(){return Ur},rectHasMinimumSize:function(){return Xr},rectsOverlap:function(){return hr},splitRects:function(){return eo}});var Kr=.05;function Xr(e,t){var n=t.width;t=t.height;return e<=n+Kr&&e<=t+Kr}function Zr(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:12,a=Io(e),r=Io(t);if(!a.length||!r.length)return 0;var o,i=Yr(a.reduce(Hr)),u=1/0,l=Z(r);try{for(l.s();!(o=l.n()).done;){var s=o.value;if(Ur(i,s))return 0;var c=Jr(i,function(e,t){return{x:e.x<t.left?t.left:e.x>t.right?t.right:e.x,y:t=e.y<t.top?t.top:e.y>t.bottom?t.bottom:e.y}}(i,s));u=Math.min(u,c)}}catch(e){l.e(e)}finally{l.f()}return Xr(2*n,Lo(t))?u:(a=Jr(i,Yr(r.reduce(Hr)))-n,Math.max(0,Math.min(u,a)))}function Jr(e,t){return Math.hypot(e.x-t.x,e.y-t.y)}function Qr(e,t){var n=e.boundingClientRect,a=t.boundingClientRect;return!(n.left>=a.right||n.right<=a.left||n.top>=a.bottom||n.bottom<=a.top)&&0<Bo(e,t)}function eo(e,t){var n,a=[e],r=Z(t);try{function o(){var e=n.value;a=a.reduce((function(t,n){return t.concat(function(e,t){var n=e.top,a=e.left,r=e.bottom,o=e.right,i=n<t.bottom&&r>t.top,u=a<t.right&&o>t.left,l=[];if(to(t.top,n,r)&&u&&l.push({top:n,left:a,bottom:t.top,right:o}),to(t.right,a,o)&&i&&l.push({top:n,left:t.right,bottom:r,right:o}),to(t.bottom,n,r)&&u&&l.push({top:t.bottom,right:o,bottom:r,left:a}),to(t.left,a,o)&&i&&l.push({top:n,left:a,bottom:r,right:t.left}),0===l.length){if(function(e,t){return e.top>=t.top&&e.left>=t.left&&e.bottom<=t.bottom&&e.right<=t.right}(e,t))return[];l.push(e)}return l.map(no)}(n,e))}),[])}for(r.s();!(n=r.n()).done;)o()}catch(e){r.e(e)}finally{r.f()}return a}var to=function(e,t,n){return t<e&&e<n};function no(e){return new t.DOMRect(e.left,e.top,e.right-e.left,e.bottom-e.top)}var ao=0,ro=.1,oo=.2,io=.3,uo=0;function lo(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:a.body,n=1<arguments.length?arguments[1]:void 0,r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null;if(!Yn.get("gridCreated")||r){Yn.set("gridCreated",!0),r||(u=(u=Kn(a.documentElement))||new Kc(a.documentElement),uo=0,u._stackingOrder=[po(ao,uo++,null)],fo(n=null!=n?n:new mo,u),Rd(u.actualNode)&&(i=new mo(u),u._subGrid=i));for(var i,u,l=a.createTreeWalker(e,t.NodeFilter.SHOW_ELEMENT,null,!1),s=r?l.nextNode():l.currentNode;s;){var c=Kn(s),d=(c&&c.parent?r=c.parent:s.assignedSlot?r=Kn(s.assignedSlot):s.parentElement?r=Kn(s.parentElement):s.parentNode&&Kn(s.parentNode)&&(r=Kn(s.parentNode)),(c=c||new o.VirtualNode(s,r))._stackingOrder=function(e,t,n){var a=t._stackingOrder.slice();so(e,t)&&-1!==(r=a.findIndex((function(e){return e=e.stackLevel,[ao,oo,io].includes(e)})))&&a.splice(r,a.length-r);var r=function(e,t){var n=function(e,t){return"static"!==e.getComputedStylePropertyValue("position")||co(t)?e.getComputedStylePropertyValue("z-index"):"auto"}(e,t);return["auto","0"].includes(n)?"static"!==e.getComputedStylePropertyValue("position")?io:"none"!==e.getComputedStylePropertyValue("float")?oo:so(e,t)?ro:null:parseInt(n)}(e,t);return null!==r&&a.push(po(r,n,e)),a}(c,r,uo++),function(e,t){for(var n=null,a=[e];t;){if(Rd(t.actualNode)){n=t;break}if(t._scrollRegionParent){n=t._scrollRegionParent;break}a.push(t),t=Kn(t.actualNode.parentElement||t.actualNode.parentNode)}return a.forEach((function(e){return e._scrollRegionParent=n})),n}(c,r)),p=(d=d?d._subGrid:n,Rd(c.actualNode)&&(p=new mo(c),c._subGrid=p),c.boundingClientRect);0!==p.width&&0!==p.height&&Vr(s)&&fo(d,c),sr(s)&&lo(s.shadowRoot,d,c),s=l.nextNode()}}return Qt.gridSize}function so(e,t){var n=e.getComputedStylePropertyValue("position"),a=e.getComputedStylePropertyValue("z-index");return"fixed"===n||"sticky"===n||"auto"!==a&&"static"!==n||"1"!==e.getComputedStylePropertyValue("opacity")||"none"!==(e.getComputedStylePropertyValue("-webkit-transform")||e.getComputedStylePropertyValue("-ms-transform")||e.getComputedStylePropertyValue("transform")||"none")||(n=e.getComputedStylePropertyValue("mix-blend-mode"))&&"normal"!==n||(n=e.getComputedStylePropertyValue("filter"))&&"none"!==n||(n=e.getComputedStylePropertyValue("perspective"))&&"none"!==n||(n=e.getComputedStylePropertyValue("clip-path"))&&"none"!==n||"none"!==(e.getComputedStylePropertyValue("-webkit-mask")||e.getComputedStylePropertyValue("mask")||"none")||"none"!==(e.getComputedStylePropertyValue("-webkit-mask-image")||e.getComputedStylePropertyValue("mask-image")||"none")||"none"!==(e.getComputedStylePropertyValue("-webkit-mask-border")||e.getComputedStylePropertyValue("mask-border")||"none")||"isolate"===e.getComputedStylePropertyValue("isolation")||"transform"===(n=e.getComputedStylePropertyValue("will-change"))||"opacity"===n||"touch"===e.getComputedStylePropertyValue("-webkit-overflow-scrolling")||(n=e.getComputedStylePropertyValue("contain"),["layout","paint","strict","content"].includes(n))||!("auto"===a||!co(t))}function co(e){if(e)return e=e.getComputedStylePropertyValue("display"),["flex","inline-flex","grid","inline-grid"].includes(e)}function po(e,t,n){return{stackLevel:e,treeOrder:t,vNode:n}}function fo(e,t){var n=br(t);t.clientRects.forEach((function(a){a=n.reduce((function(e,t){return e&&Wr(e,t.boundingClientRect)}),a);a&&(null==t._grid&&(t._grid=e),a=e.getGridPositionOfRect(a),e.loopGridPosition(a,(function(e){e.includes(t)||e.push(t)})))}))}K(Do,[{key:"toGridIndex",value:function(e){return Math.floor(e/Qt.gridSize)}},{key:"getCellFromPoint",value:function(e){var t=e.x;e=e.y,bn(this.boundaries,"Grid does not have cells added"),e=this.toGridIndex(e),t=this.toGridIndex(t);return null!=(t=(e=(bn(Ur({y:e,x:t},this.boundaries),"Element midpoint exceeds the grid bounds"),null!=(e=this.cells[e-this.cells._negativeIndex])?e:[]))[t-e._negativeIndex])?t:[]}},{key:"loopGridPosition",value:function(e,t){var n=(o=e).left,a=o.right,r=o.top,o=o.bottom;this.boundaries&&(e=Hr(this.boundaries,e)),this.boundaries=e,ho(this.cells,r,o,(function(e,r){ho(e,n,a,(function(e,n){t(e,{row:r,col:n})}))}))}},{key:"getGridPositionOfRect",value:function(e){var n=e.top,a=e.right,r=e.bottom,o=e.left,i=1<arguments.length&&void 0!==arguments[1]?arguments[1]:0;n=this.toGridIndex(n-i),a=this.toGridIndex(a+i-1),r=this.toGridIndex(r+i-1),o=this.toGridIndex(o-i);return new t.DOMRect(o,n,a-o,r-n)}}]);var mo=Do;function Do(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:null;W(this,Do),this.container=e,this.cells=[]}function ho(e,t,n,a){if(null!=e._negativeIndex||(e._negativeIndex=0),t<e._negativeIndex){for(var r=0;r<e._negativeIndex-t;r++)e.splice(0,0,[]);e._negativeIndex=t}for(var o,i=t-e._negativeIndex,u=n-e._negativeIndex,l=i;l<=u;l++)null==e[o=l]&&(e[o]=[]),a(e[l],l+e._negativeIndex)}function go(e){var t,n,a,r,o=1<arguments.length&&void 0!==arguments[1]?arguments[1]:0;return lo(),null!=(a=e._grid)&&null!=(a=a.cells)&&a.length?(a=e.boundingClientRect,t=e._grid,n=bo(e),a=t.getGridPositionOfRect(a,o),r=[],t.loopGridPosition(a,(function(t){var a,o=Z(t);try{for(o.s();!(a=o.n()).done;){var i=a.value;i&&i!==e&&!r.includes(i)&&n===bo(i)&&r.push(i)}}catch(t){o.e(t)}finally{o.f()}})),r):[]}var bo=Nn((function(e){return!!e&&("fixed"===e.getComputedStylePropertyValue("position")||bo(e.parent))})),vo=Nn((function(){var e;return o._tree&&(e=ap(o._tree[0],"dialog[open]",(function(e){var t=e.boundingClientRect;return a.elementsFromPoint(t.left+1,t.top+1).includes(e.actualNode)&&Vr(e)}))).length?e.find((function(e){var t=e.boundingClientRect;return a.elementsFromPoint(t.left-10,t.top-10).includes(e.actualNode)}))||(null!=(e=e.find((function(e){e=null!=(e=function(e){lo();var n=o._tree[0]._grid,a=new t.DOMRect(0,0,t.innerWidth,t.innerHeight);if(n)for(var r=0;r<n.cells.length;r++){var i=n.cells[r];if(i)for(var u=0;u<i.length;u++){var l=i[u];if(l)for(var s=0;s<l.length;s++){var c=l[s],d=Wr(c.boundingClientRect,a);if("html"!==c.props.nodeName&&c!==e&&"none"!==c.getComputedStylePropertyValue("pointer-events")&&d)return{vNode:c,rect:d}}}}}(e))?e:{};var n=e.vNode;e=e.rect;return!!n&&!a.elementsFromPoint(e.left+1,e.top+1).includes(n.actualNode)})))?e:null):null}));function yo(e){var t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).skipAncestors,n=n.isAncestor;return(t?Fo:wo)(e,n)}var Fo=Nn((function(e,t){return!!e.hasAttr("inert")||!(t||!e.actualNode||!(t=vo())||or(t,e))})),wo=Nn((function(e,t){return!!Fo(e,t)||!!e.parent&&wo(e.parent,!0)})),Eo=["button","command","fieldset","keygen","optgroup","option","select","textarea","input"],Co=function(e){var t=$d(e).vNode;if(e=t.props.nodeName,Eo.includes(e)&&t.hasAttr("disabled")||yo(t))return!0;for(var n=t.parent,a=[],r=!1;n&&n.shadowId===t.shadowId&&!r&&(a.push(n),"legend"!==n.props.nodeName);){if(void 0!==n._inDisabledFieldset){r=n._inDisabledFieldset;break}"fieldset"===n.props.nodeName&&n.hasAttr("disabled")&&(r=!0),n=n.parent}return a.forEach((function(e){return e._inDisabledFieldset=r})),!!r||"area"!==t.props.nodeName&&!!t.actualNode&&Sr(t)},xo=/^\\/\\#/,Ao=/^#[!/]/;function ko(e){var n,a,r,o,i=e.getAttribute("href");return!(!i||"#"===i)&&(!!xo.test(i)||(o=e.hash,n=e.protocol,a=e.hostname,r=e.port,e=e.pathname,!Ao.test(o)&&("#"===i.charAt(0)||("string"!=typeof(null==(o=t.location)?void 0:o.origin)||-1===t.location.origin.indexOf("://")?null:(i=t.location.origin+t.location.pathname,o=a?"".concat(n,"//").concat(a).concat(r?":".concat(r):""):t.location.origin,(o+=e?("/"!==e[0]?"/":"")+e:t.location.pathname)===i)))))}var No=function(e,t){var n=e.getAttribute(t);return n&&("href"!==t||ko(e))?(-1!==n.indexOf("#")&&(n=decodeURIComponent(n.substr(n.indexOf("#")+1))),(t=a.getElementById(n))||((t=a.getElementsByName(n)).length?t[0]:null)):null};function Bo(e,n){lo();for(var a=Math.max(e._stackingOrder.length,n._stackingOrder.length),r=0;r<a;r++){if(void 0===n._stackingOrder[r])return-1;if(void 0===e._stackingOrder[r])return 1;if(n._stackingOrder[r].stackLevel>e._stackingOrder[r].stackLevel)return 1;if(n._stackingOrder[r].stackLevel<e._stackingOrder[r].stackLevel)return-1;if(n._stackingOrder[r].treeOrder!==e._stackingOrder[r].treeOrder)return n._stackingOrder[r].treeOrder-e._stackingOrder[r].treeOrder}var o=e.actualNode,i=n.actualNode;if(o.getRootNode&&o.getRootNode()!==i.getRootNode()){for(var u=[];o;)u.push({root:o.getRootNode(),node:o}),o=o.getRootNode().host;for(;i&&!u.find((function(e){return e.root===i.getRootNode()}));)i=i.getRootNode().host;if((o=u.find((function(e){return e.root===i.getRootNode()})).node)===i)return e.actualNode.getRootNode()!==o.getRootNode()?-1:1}var l,s=(d=t.Node).DOCUMENT_POSITION_FOLLOWING,c=d.DOCUMENT_POSITION_CONTAINS,d=d.DOCUMENT_POSITION_CONTAINED_BY;s=(l=o.compareDocumentPosition(i))&s?1:-1,c=l&c||l&d;return(l=To(e))===(d=To(n))||c?s:d-l}function To(e){return-1!==e.getComputedStylePropertyValue("display").indexOf("inline")?2:function e(t){if(!t)return!1;if(void 0!==t._isFloated)return t._isFloated;var n=t.getComputedStylePropertyValue("float");return"none"!==n?t._isFloated=!0:(n=e(t.parent),t._isFloated=n,n)}(e)?1:0}function Ro(e,t,n){var r=2<arguments.length&&void 0!==n&&n,o=Yr(t),i=e.getCellFromPoint(o)||[],u=Math.floor(o.x),l=Math.floor(o.y);o=i.filter((function(e){return e.clientRects.some((function(e){var t=e.left,n=e.top;return u<Math.floor(t+e.width)&&u>=Math.floor(t)&&l<Math.floor(n+e.height)&&l>=Math.floor(n)}))}));return(i=e.container)&&(o=Ro(i._grid,i.boundingClientRect,!0).concat(o)),r?o:o.sort(Bo).map((function(e){return e.actualNode})).concat(a.documentElement).filter((function(e,t,n){return n.indexOf(e)===t}))}var _o=function(e){lo();var t=(e=Kn(e))._grid;return t?Ro(t,e.boundingClientRect):[]},So=function(e){return fp(e,"*").filter((function(e){var t=e.isFocusable;return(e=(e=e.actualNode.getAttribute("tabindex"))&&!isNaN(parseInt(e,10))?parseInt(e):null)?t&&0<=e:t}))},Oo=function(e){var t=$d(e).vNode;if(t&&!Co(t))switch(t.props.nodeName){case"a":case"area":if(t.hasAttr("href"))return!0;break;case"input":return"hidden"!==t.props.type;case"textarea":case"select":case"summary":case"button":return!0;case"details":return!fp(t,"summary").length}return!1};function Mo(e){return 1===(e=$d(e).vNode).props.nodeType&&!(Co(e)||!Oo(e)&&(!(e=e.attr("tabindex"))||isNaN(parseInt(e,10))))}function Po(e){return 1===(e=$d(e).vNode).props.nodeType&&!(parseInt(e.attr("tabindex",10))<=-1)&&Mo(e)}var Io=Nn((function(e){var t=e.boundingClientRect,n=go(e).filter((function(t){return Qr(e,t)&&"none"!==t.getComputedStylePropertyValue("pointer-events")&&!(e.actualNode.contains(t.actualNode)&&!Po(t))}));return n.length?(n=n.map((function(e){return e.boundingClientRect})),eo(t,n)):[t]})),Lo=Nn((function(e,t){return function(e,t){return e.reduce((function(e,n){var a=Xr(t,e);return a!==Xr(t,n)?a?e:n:(a=e.width*e.height,n.width*n.height<a?e:n)}))}(Io(e),t)})),jo={},qo=(te(jo,{accessibleText:function(){return zo},accessibleTextVirtual:function(){return uu},autocomplete:function(){return du},formControlValue:function(){return Ki},formControlValueMethods:function(){return Wi},hasUnicode:function(){return ou},isHumanInterpretable:function(){return cu},isIconLigature:function(){return iu},isValidAutocomplete:function(){return pu},label:function(){return hu},labelText:function(){return Ji},labelVirtual:function(){return Du},nativeElementType:function(){return gu},nativeTextAlternative:function(){return au},nativeTextMethods:function(){return nu},removeUnicode:function(){return su},sanitize:function(){return li},subtreeText:function(){return Zi},titleText:function(){return Ri},unsupported:function(){return Oi},visible:function(){return mu},visibleTextNodes:function(){return bu},visibleVirtual:function(){return Ii}}),function(e,t){e=e.actualNode||e;try{var n=pr(e),a=[];if(r=e.getAttribute(t))for(var r=Xc(r),o=0;o<r.length;o++)a.push(n.getElementById(r[o]));return a}catch(e){throw new TypeError("Cannot resolve id references for non-DOM nodes")}}),zo=function(e,t){return uu(Kn(e),t)},Vo=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=$d(e).vNode;return 1!==(null==n?void 0:n.props.nodeType)||1!==n.props.nodeType||t.inLabelledByContext||t.inControlContext||!n.attr("aria-labelledby")?"":qo(n,"aria-labelledby").filter((function(e){return e})).reduce((function(e,a){return a=zo(a,$({inLabelledByContext:!0,startNode:t.startNode||n},t)),e?"".concat(e," ").concat(a):a}),"")};function $o(e){return 1===(null==(e=$d(e).vNode)?void 0:e.props.nodeType)&&e.attr("aria-label")||""}var Ho={"aria-activedescendant":{type:"idref",allowEmpty:!0},"aria-atomic":{type:"boolean",global:!0},"aria-autocomplete":{type:"nmtoken",values:["inline","list","both","none"]},"aria-braillelabel":{type:"string",allowEmpty:!0,global:!0},"aria-brailleroledescription":{type:"string",allowEmpty:!0,global:!0},"aria-busy":{type:"boolean",global:!0},"aria-checked":{type:"nmtoken",values:["false","mixed","true","undefined"]},"aria-colcount":{type:"int",minValue:-1},"aria-colindex":{type:"int",minValue:1},"aria-colspan":{type:"int",minValue:1},"aria-controls":{type:"idrefs",allowEmpty:!0,global:!0},"aria-current":{type:"nmtoken",allowEmpty:!0,values:["page","step","location","date","time","true","false"],global:!0},"aria-describedby":{type:"idrefs",allowEmpty:!0,global:!0},"aria-description":{type:"string",allowEmpty:!0,global:!0},"aria-details":{type:"idref",allowEmpty:!0,global:!0},"aria-disabled":{type:"boolean",global:!0},"aria-dropeffect":{type:"nmtokens",values:["copy","execute","link","move","none","popup"],global:!0},"aria-errormessage":{type:"idref",allowEmpty:!0,global:!0},"aria-expanded":{type:"nmtoken",values:["true","false","undefined"]},"aria-flowto":{type:"idrefs",allowEmpty:!0,global:!0},"aria-grabbed":{type:"nmtoken",values:["true","false","undefined"],global:!0},"aria-haspopup":{type:"nmtoken",allowEmpty:!0,values:["true","false","menu","listbox","tree","grid","dialog"],global:!0},"aria-hidden":{type:"nmtoken",values:["true","false","undefined"],global:!0},"aria-invalid":{type:"nmtoken",values:["grammar","false","spelling","true"],global:!0},"aria-keyshortcuts":{type:"string",allowEmpty:!0,global:!0},"aria-label":{type:"string",allowEmpty:!0,global:!0},"aria-labelledby":{type:"idrefs",allowEmpty:!0,global:!0},"aria-level":{type:"int",minValue:1},"aria-live":{type:"nmtoken",values:["assertive","off","polite"],global:!0},"aria-modal":{type:"boolean"},"aria-multiline":{type:"boolean"},"aria-multiselectable":{type:"boolean"},"aria-orientation":{type:"nmtoken",values:["horizontal","undefined","vertical"]},"aria-owns":{type:"idrefs",allowEmpty:!0,global:!0},"aria-placeholder":{type:"string",allowEmpty:!0},"aria-posinset":{type:"int",minValue:1},"aria-pressed":{type:"nmtoken",values:["false","mixed","true","undefined"]},"aria-readonly":{type:"boolean"},"aria-relevant":{type:"nmtokens",values:["additions","all","removals","text"],global:!0},"aria-required":{type:"boolean"},"aria-roledescription":{type:"string",allowEmpty:!0,global:!0},"aria-rowcount":{type:"int",minValue:-1},"aria-rowindex":{type:"int",minValue:1},"aria-rowspan":{type:"int",minValue:0},"aria-selected":{type:"nmtoken",values:["false","true","undefined"]},"aria-setsize":{type:"int",minValue:-1},"aria-sort":{type:"nmtoken",values:["ascending","descending","none","other"]},"aria-valuemax":{type:"decimal"},"aria-valuemin":{type:"decimal"},"aria-valuenow":{type:"decimal"},"aria-valuetext":{type:"string",allowEmpty:!0}},Uo={alert:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},alertdialog:{type:"widget",allowedAttrs:["aria-expanded","aria-modal"],superclassRole:["alert","dialog"],accessibleNameRequired:!0},application:{type:"landmark",allowedAttrs:["aria-activedescendant","aria-expanded"],superclassRole:["structure"],accessibleNameRequired:!0},article:{type:"structure",allowedAttrs:["aria-posinset","aria-setsize","aria-expanded"],superclassRole:["document"]},banner:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},blockquote:{type:"structure",superclassRole:["section"]},button:{type:"widget",allowedAttrs:["aria-expanded","aria-pressed"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},caption:{type:"structure",requiredContext:["figure","table","grid","treegrid"],superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},cell:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-colindex","aria-colspan","aria-rowindex","aria-rowspan","aria-expanded"],superclassRole:["section"],nameFromContent:!0},checkbox:{type:"widget",requiredAttrs:["aria-checked"],allowedAttrs:["aria-readonly","aria-expanded","aria-required"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},code:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},columnheader:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-sort","aria-colindex","aria-colspan","aria-expanded","aria-readonly","aria-required","aria-rowindex","aria-rowspan","aria-selected"],superclassRole:["cell","gridcell","sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},combobox:{type:"widget",requiredAttrs:["aria-expanded","aria-controls"],allowedAttrs:["aria-owns","aria-autocomplete","aria-readonly","aria-required","aria-activedescendant","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!0},command:{type:"abstract",superclassRole:["widget"]},complementary:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},composite:{type:"abstract",superclassRole:["widget"]},contentinfo:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},comment:{type:"structure",allowedAttrs:["aria-level","aria-posinset","aria-setsize"],superclassRole:["article"]},definition:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"]},deletion:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},dialog:{type:"widget",allowedAttrs:["aria-expanded","aria-modal"],superclassRole:["window"],accessibleNameRequired:!0},directory:{type:"structure",deprecated:!0,allowedAttrs:["aria-expanded"],superclassRole:["list"],nameFromContent:!0},document:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["structure"]},emphasis:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},feed:{type:"structure",requiredOwned:["article"],allowedAttrs:["aria-expanded"],superclassRole:["list"]},figure:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},form:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},grid:{type:"composite",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-level","aria-multiselectable","aria-readonly","aria-activedescendant","aria-colcount","aria-expanded","aria-rowcount"],superclassRole:["composite","table"],accessibleNameRequired:!1},gridcell:{type:"widget",requiredContext:["row"],allowedAttrs:["aria-readonly","aria-required","aria-selected","aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan"],superclassRole:["cell","widget"],nameFromContent:!0},group:{type:"structure",allowedAttrs:["aria-activedescendant","aria-expanded"],superclassRole:["section"]},heading:{type:"structure",requiredAttrs:["aria-level"],allowedAttrs:["aria-expanded"],superclassRole:["sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},img:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],accessibleNameRequired:!0,childrenPresentational:!0},input:{type:"abstract",superclassRole:["widget"]},insertion:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},landmark:{type:"abstract",superclassRole:["section"]},link:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0},list:{type:"structure",requiredOwned:["listitem"],allowedAttrs:["aria-expanded"],superclassRole:["section"]},listbox:{type:"widget",requiredOwned:["group","option"],allowedAttrs:["aria-multiselectable","aria-readonly","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!0},listitem:{type:"structure",requiredContext:["list"],allowedAttrs:["aria-level","aria-posinset","aria-setsize","aria-expanded"],superclassRole:["section"],nameFromContent:!0},log:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},main:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},marquee:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},math:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],childrenPresentational:!0},menu:{type:"composite",requiredOwned:["group","menuitemradio","menuitem","menuitemcheckbox","menu","separator"],allowedAttrs:["aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"]},menubar:{type:"composite",requiredOwned:["group","menuitemradio","menuitem","menuitemcheckbox","menu","separator"],allowedAttrs:["aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["menu"]},menuitem:{type:"widget",requiredContext:["menu","menubar","group"],allowedAttrs:["aria-posinset","aria-setsize","aria-expanded"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0},menuitemcheckbox:{type:"widget",requiredContext:["menu","menubar","group"],requiredAttrs:["aria-checked"],allowedAttrs:["aria-expanded","aria-posinset","aria-readonly","aria-setsize"],superclassRole:["checkbox","menuitem"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},menuitemradio:{type:"widget",requiredContext:["menu","menubar","group"],requiredAttrs:["aria-checked"],allowedAttrs:["aria-expanded","aria-posinset","aria-readonly","aria-setsize"],superclassRole:["menuitemcheckbox","radio"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},meter:{type:"structure",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-valuemax","aria-valuemin","aria-valuetext"],superclassRole:["range"],accessibleNameRequired:!0,childrenPresentational:!0},mark:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},navigation:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},none:{type:"structure",superclassRole:["structure"],prohibitedAttrs:["aria-label","aria-labelledby"]},note:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"]},option:{type:"widget",requiredContext:["group","listbox"],allowedAttrs:["aria-selected","aria-checked","aria-posinset","aria-setsize"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},paragraph:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},presentation:{type:"structure",superclassRole:["structure"],prohibitedAttrs:["aria-label","aria-labelledby"]},progressbar:{type:"widget",allowedAttrs:["aria-expanded","aria-valuemax","aria-valuemin","aria-valuenow","aria-valuetext"],superclassRole:["range"],accessibleNameRequired:!0,childrenPresentational:!0},radio:{type:"widget",requiredAttrs:["aria-checked"],allowedAttrs:["aria-posinset","aria-setsize","aria-required"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},radiogroup:{type:"composite",allowedAttrs:["aria-readonly","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!1},range:{type:"abstract",superclassRole:["widget"]},region:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"],accessibleNameRequired:!1},roletype:{type:"abstract",superclassRole:[]},row:{type:"structure",requiredContext:["grid","rowgroup","table","treegrid"],requiredOwned:["cell","columnheader","gridcell","rowheader"],allowedAttrs:["aria-colindex","aria-level","aria-rowindex","aria-selected","aria-activedescendant","aria-expanded","aria-posinset","aria-setsize"],superclassRole:["group","widget"],nameFromContent:!0},rowgroup:{type:"structure",requiredContext:["grid","table","treegrid"],requiredOwned:["row"],superclassRole:["structure"],nameFromContent:!0},rowheader:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-sort","aria-colindex","aria-colspan","aria-expanded","aria-readonly","aria-required","aria-rowindex","aria-rowspan","aria-selected"],superclassRole:["cell","gridcell","sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},scrollbar:{type:"widget",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-controls","aria-orientation","aria-valuemax","aria-valuemin","aria-valuetext"],superclassRole:["range"],childrenPresentational:!0},search:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},searchbox:{type:"widget",allowedAttrs:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-placeholder","aria-readonly","aria-required"],superclassRole:["textbox"],accessibleNameRequired:!0},section:{type:"abstract",superclassRole:["structure"],nameFromContent:!0},sectionhead:{type:"abstract",superclassRole:["structure"],nameFromContent:!0},select:{type:"abstract",superclassRole:["composite","group"]},separator:{type:"structure",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-valuemax","aria-valuemin","aria-orientation","aria-valuetext"],superclassRole:["structure","widget"],childrenPresentational:!0},slider:{type:"widget",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-valuemax","aria-valuemin","aria-orientation","aria-readonly","aria-required","aria-valuetext"],superclassRole:["input","range"],accessibleNameRequired:!0,childrenPresentational:!0},spinbutton:{type:"widget",allowedAttrs:["aria-valuemax","aria-valuemin","aria-readonly","aria-required","aria-activedescendant","aria-valuetext","aria-valuenow"],superclassRole:["composite","input","range"],accessibleNameRequired:!0},status:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},strong:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},structure:{type:"abstract",superclassRole:["roletype"]},subscript:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},superscript:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},switch:{type:"widget",requiredAttrs:["aria-checked"],allowedAttrs:["aria-expanded","aria-readonly","aria-required"],superclassRole:["checkbox"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},suggestion:{type:"structure",requiredOwned:["insertion","deletion"],superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},tab:{type:"widget",requiredContext:["tablist"],allowedAttrs:["aria-posinset","aria-selected","aria-setsize","aria-expanded"],superclassRole:["sectionhead","widget"],nameFromContent:!0,childrenPresentational:!0},table:{type:"structure",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-colcount","aria-rowcount","aria-expanded"],superclassRole:["section"],accessibleNameRequired:!1,nameFromContent:!0},tablist:{type:"composite",requiredOwned:["tab"],allowedAttrs:["aria-level","aria-multiselectable","aria-orientation","aria-activedescendant","aria-expanded"],superclassRole:["composite"]},tabpanel:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"],accessibleNameRequired:!1},term:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},text:{type:"structure",superclassRole:["section"],nameFromContent:!0},textbox:{type:"widget",allowedAttrs:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-placeholder","aria-readonly","aria-required"],superclassRole:["input"],accessibleNameRequired:!0},time:{type:"structure",superclassRole:["section"]},timer:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["status"]},toolbar:{type:"structure",allowedAttrs:["aria-orientation","aria-activedescendant","aria-expanded"],superclassRole:["group"],accessibleNameRequired:!0},tooltip:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},tree:{type:"composite",requiredOwned:["group","treeitem"],allowedAttrs:["aria-multiselectable","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!1},treegrid:{type:"composite",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-activedescendant","aria-colcount","aria-expanded","aria-level","aria-multiselectable","aria-orientation","aria-readonly","aria-required","aria-rowcount"],superclassRole:["grid","tree"],accessibleNameRequired:!1},treeitem:{type:"widget",requiredContext:["group","tree"],allowedAttrs:["aria-checked","aria-expanded","aria-level","aria-posinset","aria-selected","aria-setsize"],superclassRole:["listitem","option"],accessibleNameRequired:!0,nameFromContent:!0},widget:{type:"abstract",superclassRole:["roletype"]},window:{type:"abstract",superclassRole:["roletype"]}},Go={a:{variant:{href:{matches:"[href]",contentTypes:["interactive","phrasing","flow"],allowedRoles:["button","checkbox","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab","treeitem","doc-backlink","doc-biblioref","doc-glossref","doc-noteref"],namingMethods:["subtreeText"]},default:{contentTypes:["phrasing","flow"],allowedRoles:!0}}},abbr:{contentTypes:["phrasing","flow"],allowedRoles:!0},address:{contentTypes:["flow"],allowedRoles:!0},area:{variant:{href:{matches:"[href]",allowedRoles:!1},default:{allowedRoles:["button","link"]}},contentTypes:["phrasing","flow"],namingMethods:["altText"]},article:{contentTypes:["sectioning","flow"],allowedRoles:["feed","presentation","none","document","application","main","region"],shadowRoot:!0},aside:{contentTypes:["sectioning","flow"],allowedRoles:["feed","note","presentation","none","region","search","doc-dedication","doc-example","doc-footnote","doc-glossary","doc-pullquote","doc-tip"]},audio:{variant:{controls:{matches:"[controls]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application"],chromiumRole:"Audio"},b:{contentTypes:["phrasing","flow"],allowedRoles:!0},base:{allowedRoles:!1,noAriaAttrs:!0},bdi:{contentTypes:["phrasing","flow"],allowedRoles:!0},bdo:{contentTypes:["phrasing","flow"],allowedRoles:!0},blockquote:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},body:{allowedRoles:!1,shadowRoot:!0},br:{contentTypes:["phrasing","flow"],allowedRoles:["presentation","none"],namingMethods:["titleText","singleSpace"]},button:{contentTypes:["interactive","phrasing","flow"],allowedRoles:["checkbox","combobox","link","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab"],namingMethods:["subtreeText"]},canvas:{allowedRoles:!0,contentTypes:["embedded","phrasing","flow"],chromiumRole:"Canvas"},caption:{allowedRoles:!1},cite:{contentTypes:["phrasing","flow"],allowedRoles:!0},code:{contentTypes:["phrasing","flow"],allowedRoles:!0},col:{allowedRoles:!1,noAriaAttrs:!0},colgroup:{allowedRoles:!1,noAriaAttrs:!0},data:{contentTypes:["phrasing","flow"],allowedRoles:!0},datalist:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0,implicitAttrs:{"aria-multiselectable":"false"}},dd:{allowedRoles:!1},del:{contentTypes:["phrasing","flow"],allowedRoles:!0},dfn:{contentTypes:["phrasing","flow"],allowedRoles:!0},details:{contentTypes:["interactive","flow"],allowedRoles:!1},dialog:{contentTypes:["flow"],allowedRoles:["alertdialog"]},div:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},dl:{contentTypes:["flow"],allowedRoles:["group","list","presentation","none"],chromiumRole:"DescriptionList"},dt:{allowedRoles:["listitem"]},em:{contentTypes:["phrasing","flow"],allowedRoles:!0},embed:{contentTypes:["interactive","embedded","phrasing","flow"],allowedRoles:["application","document","img","presentation","none"],chromiumRole:"EmbeddedObject"},fieldset:{contentTypes:["flow"],allowedRoles:["none","presentation","radiogroup"],namingMethods:["fieldsetLegendText"]},figcaption:{allowedRoles:["group","none","presentation"]},figure:{contentTypes:["flow"],allowedRoles:!0,namingMethods:["figureText","titleText"]},footer:{contentTypes:["flow"],allowedRoles:["group","none","presentation","doc-footnote"],shadowRoot:!0},form:{contentTypes:["flow"],allowedRoles:["search","none","presentation"]},h1:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"1"}},h2:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"2"}},h3:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"3"}},h4:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"4"}},h5:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"5"}},h6:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"6"}},head:{allowedRoles:!1,noAriaAttrs:!0},header:{contentTypes:["flow"],allowedRoles:["group","none","presentation","doc-footnote"],shadowRoot:!0},hgroup:{contentTypes:["heading","flow"],allowedRoles:!0},hr:{contentTypes:["flow"],allowedRoles:["none","presentation","doc-pagebreak"],namingMethods:["titleText","singleSpace"]},html:{allowedRoles:!1,noAriaAttrs:!0},i:{contentTypes:["phrasing","flow"],allowedRoles:!0},iframe:{contentTypes:["interactive","embedded","phrasing","flow"],allowedRoles:["application","document","img","none","presentation"],chromiumRole:"Iframe"},img:{variant:{nonEmptyAlt:{matches:[{attributes:{alt:"/.+/"}},{hasAccessibleName:!0}],allowedRoles:["button","checkbox","link","menuitem","menuitemcheckbox","menuitemradio","meter","option","progressbar","radio","scrollbar","separator","slider","switch","tab","treeitem","doc-cover"]},usemap:{matches:"[usemap]",contentTypes:["interactive","embedded","flow"]},default:{allowedRoles:["presentation","none"],contentTypes:["embedded","flow"]}},namingMethods:["altText"]},input:{variant:{button:{matches:{properties:{type:"button"}},allowedRoles:["checkbox","combobox","link","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab"]},buttonType:{matches:{properties:{type:["button","submit","reset"]}},namingMethods:["valueText","titleText","buttonDefaultText"]},checkboxPressed:{matches:{properties:{type:"checkbox"},attributes:{"aria-pressed":"/.*/"}},allowedRoles:["button","menuitemcheckbox","option","switch"],implicitAttrs:{"aria-checked":"false"}},checkbox:{matches:{properties:{type:"checkbox"},attributes:{"aria-pressed":null}},allowedRoles:["menuitemcheckbox","option","switch"],implicitAttrs:{"aria-checked":"false"}},noRoles:{matches:{properties:{type:["color","date","datetime-local","file","month","number","password","range","reset","submit","time","week"]}},allowedRoles:!1},hidden:{matches:{properties:{type:"hidden"}},contentTypes:["flow"],allowedRoles:!1,noAriaAttrs:!0},image:{matches:{properties:{type:"image"}},allowedRoles:["link","menuitem","menuitemcheckbox","menuitemradio","radio","switch"],namingMethods:["altText","valueText","labelText","titleText","buttonDefaultText"]},radio:{matches:{properties:{type:"radio"}},allowedRoles:["menuitemradio"],implicitAttrs:{"aria-checked":"false"}},textWithList:{matches:{properties:{type:"text"},attributes:{list:"/.*/"}},allowedRoles:!1},default:{contentTypes:["interactive","flow"],allowedRoles:["combobox","searchbox","spinbutton"],implicitAttrs:{"aria-valuenow":""},namingMethods:["labelText","placeholderText"]}}},ins:{contentTypes:["phrasing","flow"],allowedRoles:!0},kbd:{contentTypes:["phrasing","flow"],allowedRoles:!0},label:{contentTypes:["interactive","phrasing","flow"],allowedRoles:!1,chromiumRole:"Label"},legend:{allowedRoles:!1},li:{allowedRoles:["menuitem","menuitemcheckbox","menuitemradio","option","none","presentation","radio","separator","tab","treeitem","doc-biblioentry","doc-endnote"],implicitAttrs:{"aria-setsize":"1","aria-posinset":"1"}},link:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},main:{contentTypes:["flow"],allowedRoles:!1,shadowRoot:!0},map:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},math:{contentTypes:["embedded","phrasing","flow"],allowedRoles:!1},mark:{contentTypes:["phrasing","flow"],allowedRoles:!0},menu:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},meta:{variant:{itemprop:{matches:"[itemprop]",contentTypes:["phrasing","flow"]}},allowedRoles:!1,noAriaAttrs:!0},meter:{contentTypes:["phrasing","flow"],allowedRoles:!1,chromiumRole:"progressbar"},nav:{contentTypes:["sectioning","flow"],allowedRoles:["doc-index","doc-pagelist","doc-toc","menu","menubar","none","presentation","tablist"],shadowRoot:!0},noscript:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},object:{variant:{usemap:{matches:"[usemap]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application","document","img"],chromiumRole:"PluginObject"},ol:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},optgroup:{allowedRoles:!1},option:{allowedRoles:!1,implicitAttrs:{"aria-selected":"false"}},output:{contentTypes:["phrasing","flow"],allowedRoles:!0,namingMethods:["subtreeText"]},p:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},param:{allowedRoles:!1,noAriaAttrs:!0},picture:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},pre:{contentTypes:["flow"],allowedRoles:!0},progress:{contentTypes:["phrasing","flow"],allowedRoles:!1,implicitAttrs:{"aria-valuemax":"100","aria-valuemin":"0","aria-valuenow":"0"}},q:{contentTypes:["phrasing","flow"],allowedRoles:!0},rp:{allowedRoles:!0},rt:{allowedRoles:!0},ruby:{contentTypes:["phrasing","flow"],allowedRoles:!0},s:{contentTypes:["phrasing","flow"],allowedRoles:!0},samp:{contentTypes:["phrasing","flow"],allowedRoles:!0},script:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},search:{contentTypes:["flow"],allowedRoles:["form","group","none","presentation","region","search"]},section:{contentTypes:["sectioning","flow"],allowedRoles:["alert","alertdialog","application","banner","complementary","contentinfo","dialog","document","feed","group","log","main","marquee","navigation","none","note","presentation","search","status","tabpanel","doc-abstract","doc-acknowledgments","doc-afterword","doc-appendix","doc-bibliography","doc-chapter","doc-colophon","doc-conclusion","doc-credit","doc-credits","doc-dedication","doc-endnotes","doc-epigraph","doc-epilogue","doc-errata","doc-example","doc-foreword","doc-glossary","doc-index","doc-introduction","doc-notice","doc-pagelist","doc-part","doc-preface","doc-prologue","doc-pullquote","doc-qna","doc-toc"],shadowRoot:!0},select:{variant:{combobox:{matches:{attributes:{multiple:null,size:[null,"1"]}},allowedRoles:["menu"]},default:{allowedRoles:!1}},contentTypes:["interactive","phrasing","flow"],implicitAttrs:{"aria-valuenow":""},namingMethods:["labelText"]},slot:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},small:{contentTypes:["phrasing","flow"],allowedRoles:!0},source:{allowedRoles:!1,noAriaAttrs:!0},span:{contentTypes:["phrasing","flow"],allowedRoles:!0,shadowRoot:!0},strong:{contentTypes:["phrasing","flow"],allowedRoles:!0},style:{allowedRoles:!1,noAriaAttrs:!0},svg:{contentTypes:["embedded","phrasing","flow"],allowedRoles:!0,chromiumRole:"SVGRoot",namingMethods:["svgTitleText"]},sub:{contentTypes:["phrasing","flow"],allowedRoles:!0},summary:{allowedRoles:!1,namingMethods:["subtreeText"]},sup:{contentTypes:["phrasing","flow"],allowedRoles:!0},table:{contentTypes:["flow"],allowedRoles:!0,namingMethods:["tableCaptionText","tableSummaryText"]},tbody:{allowedRoles:!0},template:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},textarea:{contentTypes:["interactive","phrasing","flow"],allowedRoles:!1,implicitAttrs:{"aria-valuenow":"","aria-multiline":"true"},namingMethods:["labelText","placeholderText"]},tfoot:{allowedRoles:!0},thead:{allowedRoles:!0},time:{contentTypes:["phrasing","flow"],allowedRoles:!0},title:{allowedRoles:!1,noAriaAttrs:!0},td:{allowedRoles:!0},th:{allowedRoles:!0},tr:{allowedRoles:!0},track:{allowedRoles:!1,noAriaAttrs:!0},u:{contentTypes:["phrasing","flow"],allowedRoles:!0},ul:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},var:{contentTypes:["phrasing","flow"],allowedRoles:!0},video:{variant:{controls:{matches:"[controls]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application"],chromiumRole:"video"},wbr:{contentTypes:["phrasing","flow"],allowedRoles:["presentation","none"]}},Wo={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},Yo={ariaAttrs:Ho,ariaRoles:$({},Uo,{"doc-abstract":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-acknowledgments":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-afterword":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-appendix":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-backlink":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-biblioentry":{type:"listitem",allowedAttrs:["aria-expanded","aria-level","aria-posinset","aria-setsize"],superclassRole:["listitem"],deprecated:!0},"doc-bibliography":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-biblioref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-chapter":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-colophon":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-conclusion":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-cover":{type:"img",allowedAttrs:["aria-expanded"],superclassRole:["img"]},"doc-credit":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-credits":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-dedication":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-endnote":{type:"listitem",allowedAttrs:["aria-expanded","aria-level","aria-posinset","aria-setsize"],superclassRole:["listitem"],deprecated:!0},"doc-endnotes":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-epigraph":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-epilogue":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-errata":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-example":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-footnote":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-foreword":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-glossary":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-glossref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-index":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]},"doc-introduction":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-noteref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-notice":{type:"note",allowedAttrs:["aria-expanded"],superclassRole:["note"]},"doc-pagebreak":{type:"separator",allowedAttrs:["aria-expanded","aria-orientation"],superclassRole:["separator"],childrenPresentational:!0},"doc-pagelist":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]},"doc-part":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-preface":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-prologue":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-pullquote":{type:"none",superclassRole:["none"]},"doc-qna":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-subtitle":{type:"sectionhead",allowedAttrs:["aria-expanded"],superclassRole:["sectionhead"]},"doc-tip":{type:"note",allowedAttrs:["aria-expanded"],superclassRole:["note"]},"doc-toc":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]}},{"graphics-document":{type:"structure",superclassRole:["document"],accessibleNameRequired:!0},"graphics-object":{type:"structure",superclassRole:["group"],nameFromContent:!0},"graphics-symbol":{type:"structure",superclassRole:["img"],accessibleNameRequired:!0,childrenPresentational:!0}}),htmlElms:Go,cssColors:Wo},Ko=$({},Yo),Xo=Ko,Zo=function(e){return!!(e=Xo.ariaRoles[e])&&!!e.unsupported},Jo=function(e){var t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).allowAbstract,n=void 0!==(n=n.flagUnsupported)&&n,a=Xo.ariaRoles[e],r=Zo(e);return!(!a||n&&r||!t&&"abstract"===a.type)},Qo=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=t.fallback,a=t.abstracts,r=t.dpub;return 1===(e=e instanceof an?e:Kn(e)).props.nodeType&&(t=(e.attr("role")||"").trim().toLowerCase(),(n?Xc(t):[t]).find((function(e){return!(!r&&"doc-"===e.substr(0,4))&&Jo(e,{allowAbstract:a})})))||null},ei=function(e){return Object.keys(Xo.htmlElms).filter((function(t){return(t=Xo.htmlElms[t]).contentTypes?t.contentTypes.includes(e):!!t.variant&&!(!t.variant.default||!t.variant.default.contentTypes)&&t.variant.default.contentTypes.includes(e)}))},ti=function(){return Yn.get("globalAriaAttrs",(function(){return Object.keys(Xo.ariaAttrs).filter((function(e){return Xo.ariaAttrs[e].global}))}))},ni=Nn((function(e){for(var t=[],n=e.rows,a=0,r=n.length;a<r;a++)for(var o=n[a].cells,i=(t[a]=t[a]||[],0),u=0,l=o.length;u<l;u++)for(var s=0;s<o[u].colSpan;s++){for(var c=o[u].getAttribute("rowspan"),d=0===parseInt(c)||0===o[u].rowspan?n.length:o[u].rowSpan,p=0;p<d;p++){for(t[a+p]=t[a+p]||[];t[a+p][i];)i++;t[a+p][i]=o[u]}i++}return t})),ai=Nn((function(e,t){var n,a;for(t=t||ni(Dr(e,"table")),n=0;n<t.length;n++)if(t[n]&&-1!==(a=t[n].indexOf(e)))return{x:a,y:n}}));function ri(e){var t,n=(e=$d(e)).vNode,a=(e=e.domNode,n.attr("scope")),r=n.attr("role");if(["td","th"].includes(n.props.nodeName))return"columnheader"===r?"col":"rowheader"===r?"row":"col"===a||"row"===a?a:"th"===n.props.nodeName&&(n.actualNode?(r=ni(Dr(e,"table")))[(t=ai(e,r)).y].every((function(e){return"TH"===e.nodeName.toUpperCase()}))?"col":r.map((function(e){return e[t.x]})).every((function(e){return e&&"TH"===e.nodeName.toUpperCase()}))?"row":"auto":"auto");throw new TypeError("Expected TD or TH element")}var oi=function(e){return-1!==["col","auto"].indexOf(ri(e))},ii=function(e){return["row","auto"].includes(ri(e))};function ui(){return Yn.get("sectioningElementSelector",(function(){return ei("sectioning").map((function(e){return"".concat(e,":not([role])")})).join(", ")+" , main:not([role]), [role=article], [role=complementary], [role=main], [role=navigation], [role=region]"}))}var li=function(e){return e?e.replace(/\\r\\n/g,"\\n").replace(/\\u00A0/g," ").replace(/[\\s]{2,}/g," ").trim():""};function si(e){var t=li(Vo(e));e=li($o(e));return t||e}var ci={a:function(e){return e.hasAttr("href")?"link":null},area:function(e){return e.hasAttr("href")?"link":null},article:"article",aside:"complementary",body:"document",button:"button",datalist:"listbox",dd:"definition",dfn:"term",details:"group",dialog:"dialog",dt:"term",fieldset:"group",figure:"figure",footer:function(e){return ca(e,ui())?null:"contentinfo"},form:function(e){return si(e)?"form":null},h1:"heading",h2:"heading",h3:"heading",h4:"heading",h5:"heading",h6:"heading",header:function(e){return ca(e,ui())?null:"banner"},hr:"separator",img:function(e){var t=e.hasAttr("alt")&&!e.attr("alt"),n=ti().find((function(t){return e.hasAttr(t)}));return!t||n||Mo(e)?"img":"presentation"},input:function(e){var t,n;switch(e.hasAttr("list")&&(n=(t=qo(e.actualNode,"list").filter((function(e){return!!e}))[0])&&"datalist"===t.nodeName.toLowerCase()),e.props.type){case"checkbox":return"checkbox";case"number":return"spinbutton";case"radio":return"radio";case"range":return"slider";case"search":return n?"combobox":"searchbox";case"button":case"image":case"reset":case"submit":return"button";case"text":case"tel":case"url":case"email":case"":return n?"combobox":"textbox";default:return"textbox"}},li:"listitem",main:"main",math:"math",menu:"list",nav:"navigation",ol:"list",optgroup:"group",option:"option",output:"status",progress:"progressbar",search:"search",section:function(e){return si(e)?"region":null},select:function(e){return e.hasAttr("multiple")||1<parseInt(e.attr("size"))?"listbox":"combobox"},summary:"button",table:"table",tbody:"rowgroup",td:function(e){return e=ca(e,"table"),e=Qo(e),["grid","treegrid"].includes(e)?"gridcell":"cell"},textarea:"textbox",tfoot:"rowgroup",th:function(e){return oi(e)?"columnheader":ii(e)?"rowheader":void 0},thead:"rowgroup",tr:"row",ul:"list"},di=function(e,t){var n=r(t);if(Array.isArray(t)&&void 0!==e)return t.includes(e);if("function"===n)return!!t(e);if(null!=e){if(t instanceof RegExp)return t.test(e);if(/^\\/.*\\/$/.test(t))return n=t.substring(1,t.length-1),new RegExp(n).test(e)}return t===e};function pi(e,t){return di(!!uu(e),t)}var fi=function(e,t){if("object"!==r(t)||Array.isArray(t)||t instanceof RegExp)throw new Error("Expect matcher to be an object");return Object.keys(t).every((function(n){return di(e(n),t[n])}))};function mi(e,t){return e=$d(e).vNode,fi((function(t){return e.attr(t)}),t)}function Di(e,t){return!!t(e)}function hi(e,t){return di(Qo(e),t)}function gi(e,t){return di(Ai(e),t)}function bi(e,t){return e=$d(e).vNode,di(e.props.nodeName,t)}function vi(e,t){return e=$d(e).vNode,fi((function(t){return e.props[t]}),t)}function yi(e,t){return di(Bi(e),t)}var Fi={hasAccessibleName:pi,attributes:mi,condition:Di,explicitRole:hi,implicitRole:gi,nodeName:bi,properties:vi,semanticRole:yi},wi=function e(t,n){return t=$d(t).vNode,Array.isArray(n)?n.some((function(n){return e(t,n)})):"string"==typeof n?na(t,n):Object.keys(n).every((function(e){var a;if(Fi[e])return a=n[e],(0,Fi[e])(t,a);throw new Error('Unknown matcher type "'.concat(e,'"'))}))},Ei=function(e,t){return wi(e,t)},Ci=(Ei.hasAccessibleName=pi,Ei.attributes=mi,Ei.condition=Di,Ei.explicitRole=hi,Ei.fromDefinition=wi,Ei.fromFunction=fi,Ei.fromPrimative=di,Ei.implicitRole=gi,Ei.nodeName=bi,Ei.properties=vi,Ei.semanticRole=yi,Ei),xi=function(e){var t=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).noMatchAccessibleName,n=void 0!==t&&t,a=Xo.htmlElms[e.props.nodeName];if(!a)return{};if(!a.variant)return a;var r,o,i=a.variant,u=q(a,c);for(r in i)if(i.hasOwnProperty(r)&&"default"!==r){for(var l=i[r],s=l.matches,p=q(l,d),f=Array.isArray(s)?s:[s],m=0;m<f.length&&n;m++)if(f[m].hasOwnProperty("hasAccessibleName"))return a;if(Ci(e,s))for(var D in p)p.hasOwnProperty(D)&&(u[D]=p[D])}for(o in i.default)i.default.hasOwnProperty(o)&&void 0===u[o]&&(u[o]=i.default[o]);return u},Ai=function(e){var t,n=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).chromium,a=e instanceof an?e:Kn(e);if(e=a.actualNode,a)return t=a.props.nodeName,!(t=ci[t])&&n?xi(a).chromiumRole||null:"function"==typeof t?t(a):t||null;throw new ReferenceError("Cannot get implicit role of a node outside the current scope.")},ki={td:["tr"],th:["tr"],tr:["thead","tbody","tfoot","table"],thead:["table"],tbody:["table"],tfoot:["table"],li:["ol","ul"],dt:["dl","div"],dd:["dl","div"],div:["dl"]};function Ni(e){return ti().some((function(t){return e.hasAttr(t)}))||Mo(e)}var Bi=function(e){var t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).noPresentational,n=function(e,t){var n,a=(r=1<arguments.length&&void 0!==t?t:{}).noImplicit,r=q(r,f),o=$d(e).vNode;return 1!==o.props.nodeType?null:!(n=Qo(o,r))||["presentation","none"].includes(n)&&Ni(o)?a?null:function(e,t){var n=t.chromium;return t=q(t,p),(n=Ai(e,{chromium:n}))?function e(t,n){var a=ki[t.props.nodeName];if(a){if(t.parent)return a.includes(t.parent.props.nodeName)?(a=Qo(t.parent,n),["none","presentation"].includes(a)&&!Ni(t.parent)?a:a?null:e(t.parent,n)):null;if(t.actualNode)throw new ReferenceError("Cannot determine role presentational inheritance of a required parent outside the current scope.")}return null}(e,t)||n:null}(o,r):n}(e,q(n,m));return t&&["presentation","none"].includes(n)?null:n},Ti=["iframe"],Ri=function(e){var t=$d(e).vNode;return 1!==t.props.nodeType||!e.hasAttr("title")||!Ei(t,Ti)&&["none","presentation"].includes(Bi(t))?"":t.attr("title")},_i=function(e){var t,n,a=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).strict;return 1===(e=e instanceof an?e:Kn(e)).props.nodeType&&(t=Bi(e),!(!(n=Xo.ariaRoles[t])||!n.nameFromContent)||!a&&(!n||["presentation","none"].includes(t)))},Si=function(e){var t=e.actualNode,n=e.children;if(n)return e.hasAttr("aria-owns")?(e=qo(t,"aria-owns").filter((function(e){return!!e})).map((function(e){return o.utils.getNodeFromTree(e)})),[].concat(z(n),z(e))):z(n);throw new Error("getOwnedVirtual requires a virtual node")},Oi={accessibleNameFromFieldValue:["progressbar"]};function Mi(e){return e=$d(e).vNode,Pi(e)}var Pi=Nn((function(e,t){return!xr(e)&&!yo(e,{skipAncestors:!0,isAncestor:t})&&(e.actualNode&&"area"===e.props.nodeName?!Tr(e,Pi):!Sr(e,{skipAncestors:!0,isAncestor:t})&&(!e.parent||Pi(e.parent,!0)))})),Ii=function e(t,n,a){var r=$d(t).vNode,o=n?Mi:Vr,i=!t.actualNode||t.actualNode&&o(t);o=r.children.map((function(t){var r=(o=t.props).nodeType,o=o.nodeValue;if(3===r){if(o&&i)return o}else if(!a)return e(t,n)})).join("");return li(o)},Li=["button","checkbox","color","file","hidden","image","password","radio","reset","submit"],ji=function(e){var t=(e=e instanceof an?e:Kn(e)).props.nodeName;return"textarea"===t||"input"===t&&!Li.includes((e.attr("type")||"").toLowerCase())},qi=function(e){return"select"===(e=e instanceof an?e:Kn(e)).props.nodeName},zi=function(e){return"textbox"===Qo(e)},Vi=function(e){return"listbox"===Qo(e)},$i=function(e){return"combobox"===Qo(e)},Hi=["progressbar","scrollbar","slider","spinbutton"],Ui=function(e){return e=Qo(e),Hi.includes(e)},Gi=["textbox","progressbar","scrollbar","slider","spinbutton","combobox","listbox"],Wi={nativeTextboxValue:function(e){return e=$d(e).vNode,ji(e)&&e.props.value||""},nativeSelectValue:function(e){if(e=$d(e).vNode,!qi(e))return"";var t=(e=fp(e,"option")).filter((function(e){return e.props.selected}));return t.length||t.push(e[0]),t.map((function(e){return Ii(e)})).join(" ")||""},ariaTextboxValue:function(e){var t=(e=$d(e)).vNode;e=e.domNode;return zi(t)?e&&Sr(e)?e.textContent:Ii(t,!0):""},ariaListboxValue:Yi,ariaComboboxValue:function(e,t){e=$d(e).vNode;return $i(e)&&(e=Si(e).filter((function(e){return"listbox"===Bi(e)}))[0])?Yi(e,t):""},ariaRangeValue:function(e){e=$d(e).vNode;return Ui(e)&&e.hasAttr("aria-valuenow")?(e=+e.attr("aria-valuenow"),isNaN(e)?"0":String(e)):""}};function Yi(e,t){e=$d(e).vNode;return Vi(e)&&0!==(e=Si(e).filter((function(e){return"option"===Bi(e)&&"true"===e.attr("aria-selected")}))).length?uu(e[0],t):""}var Ki=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=e.actualNode,a=Oi.accessibleNameFromFieldValue||[],r=Bi(e);return t.startNode===e||!Gi.includes(r)||a.includes(r)?"":(a=Object.keys(Wi).map((function(e){return Wi[e]})).reduce((function(n,a){return n||a(e,t)}),""),t.debug&&en(a||"{empty-value}",n,t),a)},Xi=ei("phrasing").concat(["#text"]),Zi=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=uu.alreadyProcessed;t.startNode=t.startNode||e;var a=(o=t).strict,r=o.inControlContext,o=o.inLabelledByContext,i=Bi(e),u=xi(e,{noMatchAccessibleName:!0}).contentTypes;return n(e,t)||1!==e.props.nodeType||null!=u&&u.includes("embedded")||Gi.includes(i)||!(t.subtreeDescendant||t.inLabelledByContext||_i(e,{strict:a}))?"":(a||(t=$({subtreeDescendant:!r&&!o},t)),Si(e).reduce((function(e,n){var a=t,r=n.props.nodeName;return(n=uu(n,a))?(Xi.includes(r)||(" "!==n[0]&&(n+=" "),e&&" "!==e[e.length-1]&&(n=" "+n)),e+n):e}),""))},Ji=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=uu.alreadyProcessed;if(t.inControlContext||t.inLabelledByContext||n(e,t))return"";t.startNode||(t.startNode=e);var a,r=$({inControlContext:!0},t);n=function(e){if(!e.attr("id"))return[];if(e.actualNode)return fr({elm:"label",attr:"for",value:e.attr("id"),context:e.actualNode});throw new TypeError("Cannot resolve explicit label reference for non-DOM nodes")}(e);return(t=ca(e,"label"))?(a=[].concat(z(n),[t.actualNode])).sort(Vd):a=n,a.map((function(e){return zo(e,r)})).filter((function(e){return""!==e})).join(" ")},Qi={submit:"Submit",image:"Submit",reset:"Reset",button:""};function eu(e,t){return t.attr(e)||""}function tu(e,t,n){t=t.actualNode;var a=[e=e.toLowerCase(),t.nodeName.toLowerCase()].join(",");return(t=t.querySelector(a))&&t.nodeName.toLowerCase()===e?zo(t,n):""}var nu={valueText:function(e){return e.actualNode.value||""},buttonDefaultText:function(e){return e=e.actualNode,Qi[e.type]||""},tableCaptionText:tu.bind(null,"caption"),figureText:tu.bind(null,"figcaption"),svgTitleText:tu.bind(null,"title"),fieldsetLegendText:tu.bind(null,"legend"),altText:eu.bind(null,"alt"),tableSummaryText:eu.bind(null,"summary"),titleText:Ri,subtreeText:Zi,labelText:Ji,singleSpace:function(){return" "},placeholderText:eu.bind(null,"placeholder")};function au(e){var t,n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=e.actualNode;return 1!==e.props.nodeType||["presentation","none"].includes(Bi(e))?"":(t=(xi(e,{noMatchAccessibleName:!0}).namingMethods||[]).map((function(e){return nu[e]})).reduce((function(t,a){return t||a(e,n)}),""),n.debug&&o.log(t||"{empty-value}",a,n),t)}function ru(){return/[#*0-9]\\uFE0F?\\u20E3|[\\xA9\\xAE\\u203C\\u2049\\u2122\\u2139\\u2194-\\u2199\\u21A9\\u21AA\\u231A\\u231B\\u2328\\u23CF\\u23ED-\\u23EF\\u23F1\\u23F2\\u23F8-\\u23FA\\u24C2\\u25AA\\u25AB\\u25B6\\u25C0\\u25FB\\u25FC\\u25FE\\u2600-\\u2604\\u260E\\u2611\\u2614\\u2615\\u2618\\u2620\\u2622\\u2623\\u2626\\u262A\\u262E\\u262F\\u2638-\\u263A\\u2640\\u2642\\u2648-\\u2653\\u265F\\u2660\\u2663\\u2665\\u2666\\u2668\\u267B\\u267E\\u267F\\u2692\\u2694-\\u2697\\u2699\\u269B\\u269C\\u26A0\\u26A7\\u26AA\\u26B0\\u26B1\\u26BD\\u26BE\\u26C4\\u26C8\\u26CF\\u26D1\\u26D3\\u26E9\\u26F0-\\u26F5\\u26F7\\u26F8\\u26FA\\u2702\\u2708\\u2709\\u270F\\u2712\\u2714\\u2716\\u271D\\u2721\\u2733\\u2734\\u2744\\u2747\\u2757\\u2763\\u27A1\\u2934\\u2935\\u2B05-\\u2B07\\u2B1B\\u2B1C\\u2B55\\u3030\\u303D\\u3297\\u3299]\\uFE0F?|[\\u261D\\u270C\\u270D](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\u270A\\u270B](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\u23E9-\\u23EC\\u23F0\\u23F3\\u25FD\\u2693\\u26A1\\u26AB\\u26C5\\u26CE\\u26D4\\u26EA\\u26FD\\u2705\\u2728\\u274C\\u274E\\u2753-\\u2755\\u2795-\\u2797\\u27B0\\u27BF\\u2B50]|\\u26F9(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\u2764\\uFE0F?(?:\\u200D(?:\\uD83D\\uDD25|\\uD83E\\uDE79))?|\\uD83C(?:[\\uDC04\\uDD70\\uDD71\\uDD7E\\uDD7F\\uDE02\\uDE37\\uDF21\\uDF24-\\uDF2C\\uDF36\\uDF7D\\uDF96\\uDF97\\uDF99-\\uDF9B\\uDF9E\\uDF9F\\uDFCD\\uDFCE\\uDFD4-\\uDFDF\\uDFF5\\uDFF7]\\uFE0F?|[\\uDF85\\uDFC2\\uDFC7](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDFC3\\uDFC4\\uDFCA](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDFCB\\uDFCC](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDCCF\\uDD8E\\uDD91-\\uDD9A\\uDE01\\uDE1A\\uDE2F\\uDE32-\\uDE36\\uDE38-\\uDE3A\\uDE50\\uDE51\\uDF00-\\uDF20\\uDF2D-\\uDF35\\uDF37-\\uDF7C\\uDF7E-\\uDF84\\uDF86-\\uDF93\\uDFA0-\\uDFC1\\uDFC5\\uDFC6\\uDFC8\\uDFC9\\uDFCF-\\uDFD3\\uDFE0-\\uDFF0\\uDFF8-\\uDFFF]|\\uDDE6\\uD83C[\\uDDE8-\\uDDEC\\uDDEE\\uDDF1\\uDDF2\\uDDF4\\uDDF6-\\uDDFA\\uDDFC\\uDDFD\\uDDFF]|\\uDDE7\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEF\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9\\uDDFB\\uDDFC\\uDDFE\\uDDFF]|\\uDDE8\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDEE\\uDDF0-\\uDDF5\\uDDF7\\uDDFA-\\uDDFF]|\\uDDE9\\uD83C[\\uDDEA\\uDDEC\\uDDEF\\uDDF0\\uDDF2\\uDDF4\\uDDFF]|\\uDDEA\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDED\\uDDF7-\\uDDFA]|\\uDDEB\\uD83C[\\uDDEE-\\uDDF0\\uDDF2\\uDDF4\\uDDF7]|\\uDDEC\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEE\\uDDF1-\\uDDF3\\uDDF5-\\uDDFA\\uDDFC\\uDDFE]|\\uDDED\\uD83C[\\uDDF0\\uDDF2\\uDDF3\\uDDF7\\uDDF9\\uDDFA]|\\uDDEE\\uD83C[\\uDDE8-\\uDDEA\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9]|\\uDDEF\\uD83C[\\uDDEA\\uDDF2\\uDDF4\\uDDF5]|\\uDDF0\\uD83C[\\uDDEA\\uDDEC-\\uDDEE\\uDDF2\\uDDF3\\uDDF5\\uDDF7\\uDDFC\\uDDFE\\uDDFF]|\\uDDF1\\uD83C[\\uDDE6-\\uDDE8\\uDDEE\\uDDF0\\uDDF7-\\uDDFB\\uDDFE]|\\uDDF2\\uD83C[\\uDDE6\\uDDE8-\\uDDED\\uDDF0-\\uDDFF]|\\uDDF3\\uD83C[\\uDDE6\\uDDE8\\uDDEA-\\uDDEC\\uDDEE\\uDDF1\\uDDF4\\uDDF5\\uDDF7\\uDDFA\\uDDFF]|\\uDDF4\\uD83C\\uDDF2|\\uDDF5\\uD83C[\\uDDE6\\uDDEA-\\uDDED\\uDDF0-\\uDDF3\\uDDF7-\\uDDF9\\uDDFC\\uDDFE]|\\uDDF6\\uD83C\\uDDE6|\\uDDF7\\uD83C[\\uDDEA\\uDDF4\\uDDF8\\uDDFA\\uDDFC]|\\uDDF8\\uD83C[\\uDDE6-\\uDDEA\\uDDEC-\\uDDF4\\uDDF7-\\uDDF9\\uDDFB\\uDDFD-\\uDDFF]|\\uDDF9\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDED\\uDDEF-\\uDDF4\\uDDF7\\uDDF9\\uDDFB\\uDDFC\\uDDFF]|\\uDDFA\\uD83C[\\uDDE6\\uDDEC\\uDDF2\\uDDF3\\uDDF8\\uDDFE\\uDDFF]|\\uDDFB\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDEE\\uDDF3\\uDDFA]|\\uDDFC\\uD83C[\\uDDEB\\uDDF8]|\\uDDFD\\uD83C\\uDDF0|\\uDDFE\\uD83C[\\uDDEA\\uDDF9]|\\uDDFF\\uD83C[\\uDDE6\\uDDF2\\uDDFC]|\\uDFF3\\uFE0F?(?:\\u200D(?:\\u26A7\\uFE0F?|\\uD83C\\uDF08))?|\\uDFF4(?:\\u200D\\u2620\\uFE0F?|\\uDB40\\uDC67\\uDB40\\uDC62\\uDB40(?:\\uDC65\\uDB40\\uDC6E\\uDB40\\uDC67|\\uDC73\\uDB40\\uDC63\\uDB40\\uDC74|\\uDC77\\uDB40\\uDC6C\\uDB40\\uDC73)\\uDB40\\uDC7F)?)|\\uD83D(?:[\\uDC08\\uDC26](?:\\u200D\\u2B1B)?|[\\uDC3F\\uDCFD\\uDD49\\uDD4A\\uDD6F\\uDD70\\uDD73\\uDD76-\\uDD79\\uDD87\\uDD8A-\\uDD8D\\uDDA5\\uDDA8\\uDDB1\\uDDB2\\uDDBC\\uDDC2-\\uDDC4\\uDDD1-\\uDDD3\\uDDDC-\\uDDDE\\uDDE1\\uDDE3\\uDDE8\\uDDEF\\uDDF3\\uDDFA\\uDECB\\uDECD-\\uDECF\\uDEE0-\\uDEE5\\uDEE9\\uDEF0\\uDEF3]\\uFE0F?|[\\uDC42\\uDC43\\uDC46-\\uDC50\\uDC66\\uDC67\\uDC6B-\\uDC6D\\uDC72\\uDC74-\\uDC76\\uDC78\\uDC7C\\uDC83\\uDC85\\uDC8F\\uDC91\\uDCAA\\uDD7A\\uDD95\\uDD96\\uDE4C\\uDE4F\\uDEC0\\uDECC](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC6E\\uDC70\\uDC71\\uDC73\\uDC77\\uDC81\\uDC82\\uDC86\\uDC87\\uDE45-\\uDE47\\uDE4B\\uDE4D\\uDE4E\\uDEA3\\uDEB4-\\uDEB6](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD74\\uDD90](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC00-\\uDC07\\uDC09-\\uDC14\\uDC16-\\uDC25\\uDC27-\\uDC3A\\uDC3C-\\uDC3E\\uDC40\\uDC44\\uDC45\\uDC51-\\uDC65\\uDC6A\\uDC79-\\uDC7B\\uDC7D-\\uDC80\\uDC84\\uDC88-\\uDC8E\\uDC90\\uDC92-\\uDCA9\\uDCAB-\\uDCFC\\uDCFF-\\uDD3D\\uDD4B-\\uDD4E\\uDD50-\\uDD67\\uDDA4\\uDDFB-\\uDE2D\\uDE2F-\\uDE34\\uDE37-\\uDE44\\uDE48-\\uDE4A\\uDE80-\\uDEA2\\uDEA4-\\uDEB3\\uDEB7-\\uDEBF\\uDEC1-\\uDEC5\\uDED0-\\uDED2\\uDED5-\\uDED7\\uDEDC-\\uDEDF\\uDEEB\\uDEEC\\uDEF4-\\uDEFC\\uDFE0-\\uDFEB\\uDFF0]|\\uDC15(?:\\u200D\\uD83E\\uDDBA)?|\\uDC3B(?:\\u200D\\u2744\\uFE0F?)?|\\uDC41\\uFE0F?(?:\\u200D\\uD83D\\uDDE8\\uFE0F?)?|\\uDC68(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDC68\\uDC69]\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC69(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?[\\uDC68\\uDC69]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?|\\uDC69\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?))|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC6F(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDD75(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDE2E(?:\\u200D\\uD83D\\uDCA8)?|\\uDE35(?:\\u200D\\uD83D\\uDCAB)?|\\uDE36(?:\\u200D\\uD83C\\uDF2B\\uFE0F?)?)|\\uD83E(?:[\\uDD0C\\uDD0F\\uDD18-\\uDD1F\\uDD30-\\uDD34\\uDD36\\uDD77\\uDDB5\\uDDB6\\uDDBB\\uDDD2\\uDDD3\\uDDD5\\uDEC3-\\uDEC5\\uDEF0\\uDEF2-\\uDEF8](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDD26\\uDD35\\uDD37-\\uDD39\\uDD3D\\uDD3E\\uDDB8\\uDDB9\\uDDCD-\\uDDCF\\uDDD4\\uDDD6-\\uDDDD](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDDDE\\uDDDF](?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD0D\\uDD0E\\uDD10-\\uDD17\\uDD20-\\uDD25\\uDD27-\\uDD2F\\uDD3A\\uDD3F-\\uDD45\\uDD47-\\uDD76\\uDD78-\\uDDB4\\uDDB7\\uDDBA\\uDDBC-\\uDDCC\\uDDD0\\uDDE0-\\uDDFF\\uDE70-\\uDE7C\\uDE80-\\uDE88\\uDE90-\\uDEBD\\uDEBF-\\uDEC2\\uDECE-\\uDEDB\\uDEE0-\\uDEE8]|\\uDD3C(?:\\u200D[\\u2640\\u2642]\\uFE0F?|\\uD83C[\\uDFFB-\\uDFFF])?|\\uDDD1(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1))|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFC-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFD-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFD\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFE]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?))?|\\uDEF1(?:\\uD83C(?:\\uDFFB(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFC-\\uDFFF])?|\\uDFFC(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])?|\\uDFFD(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])?|\\uDFFE(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])?|\\uDFFF(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFE])?))?)/g}var ou=function(e,t){var n=t.emoji,a=t.nonBmp,r=(t=t.punctuations,!1);return n&&(r=r||/[#*0-9]\\uFE0F?\\u20E3|[\\xA9\\xAE\\u203C\\u2049\\u2122\\u2139\\u2194-\\u2199\\u21A9\\u21AA\\u231A\\u231B\\u2328\\u23CF\\u23ED-\\u23EF\\u23F1\\u23F2\\u23F8-\\u23FA\\u24C2\\u25AA\\u25AB\\u25B6\\u25C0\\u25FB\\u25FC\\u25FE\\u2600-\\u2604\\u260E\\u2611\\u2614\\u2615\\u2618\\u2620\\u2622\\u2623\\u2626\\u262A\\u262E\\u262F\\u2638-\\u263A\\u2640\\u2642\\u2648-\\u2653\\u265F\\u2660\\u2663\\u2665\\u2666\\u2668\\u267B\\u267E\\u267F\\u2692\\u2694-\\u2697\\u2699\\u269B\\u269C\\u26A0\\u26A7\\u26AA\\u26B0\\u26B1\\u26BD\\u26BE\\u26C4\\u26C8\\u26CF\\u26D1\\u26D3\\u26E9\\u26F0-\\u26F5\\u26F7\\u26F8\\u26FA\\u2702\\u2708\\u2709\\u270F\\u2712\\u2714\\u2716\\u271D\\u2721\\u2733\\u2734\\u2744\\u2747\\u2757\\u2763\\u27A1\\u2934\\u2935\\u2B05-\\u2B07\\u2B1B\\u2B1C\\u2B55\\u3030\\u303D\\u3297\\u3299]\\uFE0F?|[\\u261D\\u270C\\u270D](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\u270A\\u270B](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\u23E9-\\u23EC\\u23F0\\u23F3\\u25FD\\u2693\\u26A1\\u26AB\\u26C5\\u26CE\\u26D4\\u26EA\\u26FD\\u2705\\u2728\\u274C\\u274E\\u2753-\\u2755\\u2795-\\u2797\\u27B0\\u27BF\\u2B50]|\\u26F9(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\u2764\\uFE0F?(?:\\u200D(?:\\uD83D\\uDD25|\\uD83E\\uDE79))?|\\uD83C(?:[\\uDC04\\uDD70\\uDD71\\uDD7E\\uDD7F\\uDE02\\uDE37\\uDF21\\uDF24-\\uDF2C\\uDF36\\uDF7D\\uDF96\\uDF97\\uDF99-\\uDF9B\\uDF9E\\uDF9F\\uDFCD\\uDFCE\\uDFD4-\\uDFDF\\uDFF5\\uDFF7]\\uFE0F?|[\\uDF85\\uDFC2\\uDFC7](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDFC3\\uDFC4\\uDFCA](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDFCB\\uDFCC](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDCCF\\uDD8E\\uDD91-\\uDD9A\\uDE01\\uDE1A\\uDE2F\\uDE32-\\uDE36\\uDE38-\\uDE3A\\uDE50\\uDE51\\uDF00-\\uDF20\\uDF2D-\\uDF35\\uDF37-\\uDF7C\\uDF7E-\\uDF84\\uDF86-\\uDF93\\uDFA0-\\uDFC1\\uDFC5\\uDFC6\\uDFC8\\uDFC9\\uDFCF-\\uDFD3\\uDFE0-\\uDFF0\\uDFF8-\\uDFFF]|\\uDDE6\\uD83C[\\uDDE8-\\uDDEC\\uDDEE\\uDDF1\\uDDF2\\uDDF4\\uDDF6-\\uDDFA\\uDDFC\\uDDFD\\uDDFF]|\\uDDE7\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEF\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9\\uDDFB\\uDDFC\\uDDFE\\uDDFF]|\\uDDE8\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDEE\\uDDF0-\\uDDF5\\uDDF7\\uDDFA-\\uDDFF]|\\uDDE9\\uD83C[\\uDDEA\\uDDEC\\uDDEF\\uDDF0\\uDDF2\\uDDF4\\uDDFF]|\\uDDEA\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDED\\uDDF7-\\uDDFA]|\\uDDEB\\uD83C[\\uDDEE-\\uDDF0\\uDDF2\\uDDF4\\uDDF7]|\\uDDEC\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEE\\uDDF1-\\uDDF3\\uDDF5-\\uDDFA\\uDDFC\\uDDFE]|\\uDDED\\uD83C[\\uDDF0\\uDDF2\\uDDF3\\uDDF7\\uDDF9\\uDDFA]|\\uDDEE\\uD83C[\\uDDE8-\\uDDEA\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9]|\\uDDEF\\uD83C[\\uDDEA\\uDDF2\\uDDF4\\uDDF5]|\\uDDF0\\uD83C[\\uDDEA\\uDDEC-\\uDDEE\\uDDF2\\uDDF3\\uDDF5\\uDDF7\\uDDFC\\uDDFE\\uDDFF]|\\uDDF1\\uD83C[\\uDDE6-\\uDDE8\\uDDEE\\uDDF0\\uDDF7-\\uDDFB\\uDDFE]|\\uDDF2\\uD83C[\\uDDE6\\uDDE8-\\uDDED\\uDDF0-\\uDDFF]|\\uDDF3\\uD83C[\\uDDE6\\uDDE8\\uDDEA-\\uDDEC\\uDDEE\\uDDF1\\uDDF4\\uDDF5\\uDDF7\\uDDFA\\uDDFF]|\\uDDF4\\uD83C\\uDDF2|\\uDDF5\\uD83C[\\uDDE6\\uDDEA-\\uDDED\\uDDF0-\\uDDF3\\uDDF7-\\uDDF9\\uDDFC\\uDDFE]|\\uDDF6\\uD83C\\uDDE6|\\uDDF7\\uD83C[\\uDDEA\\uDDF4\\uDDF8\\uDDFA\\uDDFC]|\\uDDF8\\uD83C[\\uDDE6-\\uDDEA\\uDDEC-\\uDDF4\\uDDF7-\\uDDF9\\uDDFB\\uDDFD-\\uDDFF]|\\uDDF9\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDED\\uDDEF-\\uDDF4\\uDDF7\\uDDF9\\uDDFB\\uDDFC\\uDDFF]|\\uDDFA\\uD83C[\\uDDE6\\uDDEC\\uDDF2\\uDDF3\\uDDF8\\uDDFE\\uDDFF]|\\uDDFB\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDEE\\uDDF3\\uDDFA]|\\uDDFC\\uD83C[\\uDDEB\\uDDF8]|\\uDDFD\\uD83C\\uDDF0|\\uDDFE\\uD83C[\\uDDEA\\uDDF9]|\\uDDFF\\uD83C[\\uDDE6\\uDDF2\\uDDFC]|\\uDFF3\\uFE0F?(?:\\u200D(?:\\u26A7\\uFE0F?|\\uD83C\\uDF08))?|\\uDFF4(?:\\u200D\\u2620\\uFE0F?|\\uDB40\\uDC67\\uDB40\\uDC62\\uDB40(?:\\uDC65\\uDB40\\uDC6E\\uDB40\\uDC67|\\uDC73\\uDB40\\uDC63\\uDB40\\uDC74|\\uDC77\\uDB40\\uDC6C\\uDB40\\uDC73)\\uDB40\\uDC7F)?)|\\uD83D(?:[\\uDC08\\uDC26](?:\\u200D\\u2B1B)?|[\\uDC3F\\uDCFD\\uDD49\\uDD4A\\uDD6F\\uDD70\\uDD73\\uDD76-\\uDD79\\uDD87\\uDD8A-\\uDD8D\\uDDA5\\uDDA8\\uDDB1\\uDDB2\\uDDBC\\uDDC2-\\uDDC4\\uDDD1-\\uDDD3\\uDDDC-\\uDDDE\\uDDE1\\uDDE3\\uDDE8\\uDDEF\\uDDF3\\uDDFA\\uDECB\\uDECD-\\uDECF\\uDEE0-\\uDEE5\\uDEE9\\uDEF0\\uDEF3]\\uFE0F?|[\\uDC42\\uDC43\\uDC46-\\uDC50\\uDC66\\uDC67\\uDC6B-\\uDC6D\\uDC72\\uDC74-\\uDC76\\uDC78\\uDC7C\\uDC83\\uDC85\\uDC8F\\uDC91\\uDCAA\\uDD7A\\uDD95\\uDD96\\uDE4C\\uDE4F\\uDEC0\\uDECC](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC6E\\uDC70\\uDC71\\uDC73\\uDC77\\uDC81\\uDC82\\uDC86\\uDC87\\uDE45-\\uDE47\\uDE4B\\uDE4D\\uDE4E\\uDEA3\\uDEB4-\\uDEB6](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD74\\uDD90](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC00-\\uDC07\\uDC09-\\uDC14\\uDC16-\\uDC25\\uDC27-\\uDC3A\\uDC3C-\\uDC3E\\uDC40\\uDC44\\uDC45\\uDC51-\\uDC65\\uDC6A\\uDC79-\\uDC7B\\uDC7D-\\uDC80\\uDC84\\uDC88-\\uDC8E\\uDC90\\uDC92-\\uDCA9\\uDCAB-\\uDCFC\\uDCFF-\\uDD3D\\uDD4B-\\uDD4E\\uDD50-\\uDD67\\uDDA4\\uDDFB-\\uDE2D\\uDE2F-\\uDE34\\uDE37-\\uDE44\\uDE48-\\uDE4A\\uDE80-\\uDEA2\\uDEA4-\\uDEB3\\uDEB7-\\uDEBF\\uDEC1-\\uDEC5\\uDED0-\\uDED2\\uDED5-\\uDED7\\uDEDC-\\uDEDF\\uDEEB\\uDEEC\\uDEF4-\\uDEFC\\uDFE0-\\uDFEB\\uDFF0]|\\uDC15(?:\\u200D\\uD83E\\uDDBA)?|\\uDC3B(?:\\u200D\\u2744\\uFE0F?)?|\\uDC41\\uFE0F?(?:\\u200D\\uD83D\\uDDE8\\uFE0F?)?|\\uDC68(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDC68\\uDC69]\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC69(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?[\\uDC68\\uDC69]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?|\\uDC69\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?))|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC6F(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDD75(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDE2E(?:\\u200D\\uD83D\\uDCA8)?|\\uDE35(?:\\u200D\\uD83D\\uDCAB)?|\\uDE36(?:\\u200D\\uD83C\\uDF2B\\uFE0F?)?)|\\uD83E(?:[\\uDD0C\\uDD0F\\uDD18-\\uDD1F\\uDD30-\\uDD34\\uDD36\\uDD77\\uDDB5\\uDDB6\\uDDBB\\uDDD2\\uDDD3\\uDDD5\\uDEC3-\\uDEC5\\uDEF0\\uDEF2-\\uDEF8](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDD26\\uDD35\\uDD37-\\uDD39\\uDD3D\\uDD3E\\uDDB8\\uDDB9\\uDDCD-\\uDDCF\\uDDD4\\uDDD6-\\uDDDD](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDDDE\\uDDDF](?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD0D\\uDD0E\\uDD10-\\uDD17\\uDD20-\\uDD25\\uDD27-\\uDD2F\\uDD3A\\uDD3F-\\uDD45\\uDD47-\\uDD76\\uDD78-\\uDDB4\\uDDB7\\uDDBA\\uDDBC-\\uDDCC\\uDDD0\\uDDE0-\\uDDFF\\uDE70-\\uDE7C\\uDE80-\\uDE88\\uDE90-\\uDEBD\\uDEBF-\\uDEC2\\uDECE-\\uDEDB\\uDEE0-\\uDEE8]|\\uDD3C(?:\\u200D[\\u2640\\u2642]\\uFE0F?|\\uD83C[\\uDFFB-\\uDFFF])?|\\uDDD1(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1))|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFC-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFD-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFD\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFE]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?))?|\\uDEF1(?:\\uD83C(?:\\uDFFB(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFC-\\uDFFF])?|\\uDFFC(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])?|\\uDFFD(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])?|\\uDFFE(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])?|\\uDFFF(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFE])?))?)/g.test(e)),a&&(r=r||/[\\u1D00-\\u1D7F\\u1D80-\\u1DBF\\u1DC0-\\u1DFF\\u20A0-\\u20CF\\u20D0-\\u20FF\\u2100-\\u214F\\u2150-\\u218F\\u2190-\\u21FF\\u2200-\\u22FF\\u2300-\\u23FF\\u2400-\\u243F\\u2440-\\u245F\\u2460-\\u24FF\\u2500-\\u257F\\u2580-\\u259F\\u25A0-\\u25FF\\u2600-\\u26FF\\u2700-\\u27BF\\uE000-\\uF8FF]/g.test(e)||/[\\uDB80-\\uDBBF][\\uDC00-\\uDFFF]/g.test(e)||/[\\xAD\\u0600-\\u0605\\u061C\\u06DD\\u070F\\u08E2\\u180E\\u200B-\\u200F\\u202A-\\u202E\\u2060-\\u2064\\u2066-\\u206F\\uFEFF\\uFFF9-\\uFFFB]|\\uD804[\\uDCBD\\uDCCD]|\\uD80D[\\uDC30-\\uDC38]|\\uD82F[\\uDCA0-\\uDCA3]|\\uD834[\\uDD73-\\uDD7A]|\\uDB40[\\uDC01\\uDC20-\\uDC7F]/g.test(e)),t?r||/[\\u2000-\\u206F\\u2E00-\\u2E7F\\\\'!"#$%&\\xa3\\xa2\\xa5\\xa7\\u20ac()*+,\\-.\\/:;<=>?@\\[\\]^_\`{|}~\\xb1]/g.test(e):r};function iu(e){var n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:.15,r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:3,o=e.actualNode.nodeValue.trim();if(!li(o)||ou(o,{emoji:!0,nonBmp:!0}))return!1;var i,u=Yn.get("canvasContext",(function(){return a.createElement("canvas").getContext("2d",{willReadFrequently:!0})})),l=u.canvas;if((i=((i=Yn.get("fonts",(function(){return{}})))[m=t.getComputedStyle(e.parent.actualNode).getPropertyValue("font-family")]||(i[m]={occurrences:0,numLigatures:0}),i[m])).occurrences>=r){if(i.numLigatures/i.occurrences==1)return!0;if(0===i.numLigatures)return!1}i.occurrences++;var s="".concat(r=30,"px ").concat(m),c=(u.font=s,o.charAt(0)),d=u.measureText(c).width;if(0===d)return i.numLigatures++,!0;d<30&&(d*=p=30/d,s="".concat(r*=p,"px ").concat(m)),l.width=d,l.height=r,u.font=s,u.textAlign="left",u.textBaseline="top",u.fillText(c,0,0);var p=new Uint32Array(u.getImageData(0,0,d,r).data.buffer);if(!p.some((function(e){return e})))return i.numLigatures++,!0;u.clearRect(0,0,d,r),u.fillText(o,0,0);var f=new Uint32Array(u.getImageData(0,0,d,r).data.buffer),m=p.reduce((function(e,t,n){return 0===t&&0===f[n]||0!==t&&0!==f[n]?e:++e}),0);l=o.split("").reduce((function(e,t){return e+u.measureText(t).width}),0),s=u.measureText(o).width;return n<=m/p.length&&n<=1-s/l&&(i.numLigatures++,!0)}function uu(e){var t,n,a,r,i,u=function(e,t){return t.startNode||(t=$({startNode:e},t)),1===e.props.nodeType&&t.inLabelledByContext&&void 0===t.includeHidden&&(t=$({includeHidden:!Mi(e)},t)),t}(e,1<arguments.length&&void 0!==arguments[1]?arguments[1]:{});return function(e,t){if(e&&1===e.props.nodeType&&!t.includeHidden)return!Mi(e)}(e,u)||(t=e,n=(i=u).ignoreIconLigature,a=i.pixelThreshold,r=null!=(r=i.occurrenceThreshold)?r:i.occuranceThreshold,3===t.props.nodeType&&n&&iu(t,a,r))?"":(i=[Vo,$o,au,Ki,Zi,lu,Ri].reduce((function(t,n){return""!==(t=u.startNode===e?li(t):t)?t:n(e,u)}),""),u.debug&&o.log(i||"{empty-value}",e.actualNode,u),i)}function lu(e){return 3!==e.props.nodeType?"":e.props.nodeValue}uu.alreadyProcessed=function(e,t){return t.processed=t.processed||[],!!t.processed.includes(e)||(t.processed.push(e),!1)};var su=function(e,t){var n=t.emoji,a=t.nonBmp;t=t.punctuations;return n&&(e=e.replace(/[#*0-9]\\uFE0F?\\u20E3|[\\xA9\\xAE\\u203C\\u2049\\u2122\\u2139\\u2194-\\u2199\\u21A9\\u21AA\\u231A\\u231B\\u2328\\u23CF\\u23ED-\\u23EF\\u23F1\\u23F2\\u23F8-\\u23FA\\u24C2\\u25AA\\u25AB\\u25B6\\u25C0\\u25FB\\u25FC\\u25FE\\u2600-\\u2604\\u260E\\u2611\\u2614\\u2615\\u2618\\u2620\\u2622\\u2623\\u2626\\u262A\\u262E\\u262F\\u2638-\\u263A\\u2640\\u2642\\u2648-\\u2653\\u265F\\u2660\\u2663\\u2665\\u2666\\u2668\\u267B\\u267E\\u267F\\u2692\\u2694-\\u2697\\u2699\\u269B\\u269C\\u26A0\\u26A7\\u26AA\\u26B0\\u26B1\\u26BD\\u26BE\\u26C4\\u26C8\\u26CF\\u26D1\\u26D3\\u26E9\\u26F0-\\u26F5\\u26F7\\u26F8\\u26FA\\u2702\\u2708\\u2709\\u270F\\u2712\\u2714\\u2716\\u271D\\u2721\\u2733\\u2734\\u2744\\u2747\\u2757\\u2763\\u27A1\\u2934\\u2935\\u2B05-\\u2B07\\u2B1B\\u2B1C\\u2B55\\u3030\\u303D\\u3297\\u3299]\\uFE0F?|[\\u261D\\u270C\\u270D](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\u270A\\u270B](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\u23E9-\\u23EC\\u23F0\\u23F3\\u25FD\\u2693\\u26A1\\u26AB\\u26C5\\u26CE\\u26D4\\u26EA\\u26FD\\u2705\\u2728\\u274C\\u274E\\u2753-\\u2755\\u2795-\\u2797\\u27B0\\u27BF\\u2B50]|\\u26F9(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\u2764\\uFE0F?(?:\\u200D(?:\\uD83D\\uDD25|\\uD83E\\uDE79))?|\\uD83C(?:[\\uDC04\\uDD70\\uDD71\\uDD7E\\uDD7F\\uDE02\\uDE37\\uDF21\\uDF24-\\uDF2C\\uDF36\\uDF7D\\uDF96\\uDF97\\uDF99-\\uDF9B\\uDF9E\\uDF9F\\uDFCD\\uDFCE\\uDFD4-\\uDFDF\\uDFF5\\uDFF7]\\uFE0F?|[\\uDF85\\uDFC2\\uDFC7](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDFC3\\uDFC4\\uDFCA](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDFCB\\uDFCC](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDCCF\\uDD8E\\uDD91-\\uDD9A\\uDE01\\uDE1A\\uDE2F\\uDE32-\\uDE36\\uDE38-\\uDE3A\\uDE50\\uDE51\\uDF00-\\uDF20\\uDF2D-\\uDF35\\uDF37-\\uDF7C\\uDF7E-\\uDF84\\uDF86-\\uDF93\\uDFA0-\\uDFC1\\uDFC5\\uDFC6\\uDFC8\\uDFC9\\uDFCF-\\uDFD3\\uDFE0-\\uDFF0\\uDFF8-\\uDFFF]|\\uDDE6\\uD83C[\\uDDE8-\\uDDEC\\uDDEE\\uDDF1\\uDDF2\\uDDF4\\uDDF6-\\uDDFA\\uDDFC\\uDDFD\\uDDFF]|\\uDDE7\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEF\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9\\uDDFB\\uDDFC\\uDDFE\\uDDFF]|\\uDDE8\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDEE\\uDDF0-\\uDDF5\\uDDF7\\uDDFA-\\uDDFF]|\\uDDE9\\uD83C[\\uDDEA\\uDDEC\\uDDEF\\uDDF0\\uDDF2\\uDDF4\\uDDFF]|\\uDDEA\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDED\\uDDF7-\\uDDFA]|\\uDDEB\\uD83C[\\uDDEE-\\uDDF0\\uDDF2\\uDDF4\\uDDF7]|\\uDDEC\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEE\\uDDF1-\\uDDF3\\uDDF5-\\uDDFA\\uDDFC\\uDDFE]|\\uDDED\\uD83C[\\uDDF0\\uDDF2\\uDDF3\\uDDF7\\uDDF9\\uDDFA]|\\uDDEE\\uD83C[\\uDDE8-\\uDDEA\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9]|\\uDDEF\\uD83C[\\uDDEA\\uDDF2\\uDDF4\\uDDF5]|\\uDDF0\\uD83C[\\uDDEA\\uDDEC-\\uDDEE\\uDDF2\\uDDF3\\uDDF5\\uDDF7\\uDDFC\\uDDFE\\uDDFF]|\\uDDF1\\uD83C[\\uDDE6-\\uDDE8\\uDDEE\\uDDF0\\uDDF7-\\uDDFB\\uDDFE]|\\uDDF2\\uD83C[\\uDDE6\\uDDE8-\\uDDED\\uDDF0-\\uDDFF]|\\uDDF3\\uD83C[\\uDDE6\\uDDE8\\uDDEA-\\uDDEC\\uDDEE\\uDDF1\\uDDF4\\uDDF5\\uDDF7\\uDDFA\\uDDFF]|\\uDDF4\\uD83C\\uDDF2|\\uDDF5\\uD83C[\\uDDE6\\uDDEA-\\uDDED\\uDDF0-\\uDDF3\\uDDF7-\\uDDF9\\uDDFC\\uDDFE]|\\uDDF6\\uD83C\\uDDE6|\\uDDF7\\uD83C[\\uDDEA\\uDDF4\\uDDF8\\uDDFA\\uDDFC]|\\uDDF8\\uD83C[\\uDDE6-\\uDDEA\\uDDEC-\\uDDF4\\uDDF7-\\uDDF9\\uDDFB\\uDDFD-\\uDDFF]|\\uDDF9\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDED\\uDDEF-\\uDDF4\\uDDF7\\uDDF9\\uDDFB\\uDDFC\\uDDFF]|\\uDDFA\\uD83C[\\uDDE6\\uDDEC\\uDDF2\\uDDF3\\uDDF8\\uDDFE\\uDDFF]|\\uDDFB\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDEE\\uDDF3\\uDDFA]|\\uDDFC\\uD83C[\\uDDEB\\uDDF8]|\\uDDFD\\uD83C\\uDDF0|\\uDDFE\\uD83C[\\uDDEA\\uDDF9]|\\uDDFF\\uD83C[\\uDDE6\\uDDF2\\uDDFC]|\\uDFF3\\uFE0F?(?:\\u200D(?:\\u26A7\\uFE0F?|\\uD83C\\uDF08))?|\\uDFF4(?:\\u200D\\u2620\\uFE0F?|\\uDB40\\uDC67\\uDB40\\uDC62\\uDB40(?:\\uDC65\\uDB40\\uDC6E\\uDB40\\uDC67|\\uDC73\\uDB40\\uDC63\\uDB40\\uDC74|\\uDC77\\uDB40\\uDC6C\\uDB40\\uDC73)\\uDB40\\uDC7F)?)|\\uD83D(?:[\\uDC08\\uDC26](?:\\u200D\\u2B1B)?|[\\uDC3F\\uDCFD\\uDD49\\uDD4A\\uDD6F\\uDD70\\uDD73\\uDD76-\\uDD79\\uDD87\\uDD8A-\\uDD8D\\uDDA5\\uDDA8\\uDDB1\\uDDB2\\uDDBC\\uDDC2-\\uDDC4\\uDDD1-\\uDDD3\\uDDDC-\\uDDDE\\uDDE1\\uDDE3\\uDDE8\\uDDEF\\uDDF3\\uDDFA\\uDECB\\uDECD-\\uDECF\\uDEE0-\\uDEE5\\uDEE9\\uDEF0\\uDEF3]\\uFE0F?|[\\uDC42\\uDC43\\uDC46-\\uDC50\\uDC66\\uDC67\\uDC6B-\\uDC6D\\uDC72\\uDC74-\\uDC76\\uDC78\\uDC7C\\uDC83\\uDC85\\uDC8F\\uDC91\\uDCAA\\uDD7A\\uDD95\\uDD96\\uDE4C\\uDE4F\\uDEC0\\uDECC](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC6E\\uDC70\\uDC71\\uDC73\\uDC77\\uDC81\\uDC82\\uDC86\\uDC87\\uDE45-\\uDE47\\uDE4B\\uDE4D\\uDE4E\\uDEA3\\uDEB4-\\uDEB6](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD74\\uDD90](?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDC00-\\uDC07\\uDC09-\\uDC14\\uDC16-\\uDC25\\uDC27-\\uDC3A\\uDC3C-\\uDC3E\\uDC40\\uDC44\\uDC45\\uDC51-\\uDC65\\uDC6A\\uDC79-\\uDC7B\\uDC7D-\\uDC80\\uDC84\\uDC88-\\uDC8E\\uDC90\\uDC92-\\uDCA9\\uDCAB-\\uDCFC\\uDCFF-\\uDD3D\\uDD4B-\\uDD4E\\uDD50-\\uDD67\\uDDA4\\uDDFB-\\uDE2D\\uDE2F-\\uDE34\\uDE37-\\uDE44\\uDE48-\\uDE4A\\uDE80-\\uDEA2\\uDEA4-\\uDEB3\\uDEB7-\\uDEBF\\uDEC1-\\uDEC5\\uDED0-\\uDED2\\uDED5-\\uDED7\\uDEDC-\\uDEDF\\uDEEB\\uDEEC\\uDEF4-\\uDEFC\\uDFE0-\\uDFEB\\uDFF0]|\\uDC15(?:\\u200D\\uD83E\\uDDBA)?|\\uDC3B(?:\\u200D\\u2744\\uFE0F?)?|\\uDC41\\uFE0F?(?:\\u200D\\uD83D\\uDDE8\\uFE0F?)?|\\uDC68(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDC68\\uDC69]\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?)|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?\\uDC68\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC69(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:\\uDC8B\\u200D\\uD83D)?[\\uDC68\\uDC69]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D(?:[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?|\\uDC69\\u200D\\uD83D(?:\\uDC66(?:\\u200D\\uD83D\\uDC66)?|\\uDC67(?:\\u200D\\uD83D[\\uDC66\\uDC67])?))|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFC-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D\\uD83D(?:[\\uDC68\\uDC69]|\\uDC8B\\u200D\\uD83D[\\uDC68\\uDC69])\\uD83C[\\uDFFB-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83D[\\uDC68\\uDC69]\\uD83C[\\uDFFB-\\uDFFE])))?))?|\\uDC6F(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDD75(?:\\uFE0F|\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|\\uDE2E(?:\\u200D\\uD83D\\uDCA8)?|\\uDE35(?:\\u200D\\uD83D\\uDCAB)?|\\uDE36(?:\\u200D\\uD83C\\uDF2B\\uFE0F?)?)|\\uD83E(?:[\\uDD0C\\uDD0F\\uDD18-\\uDD1F\\uDD30-\\uDD34\\uDD36\\uDD77\\uDDB5\\uDDB6\\uDDBB\\uDDD2\\uDDD3\\uDDD5\\uDEC3-\\uDEC5\\uDEF0\\uDEF2-\\uDEF8](?:\\uD83C[\\uDFFB-\\uDFFF])?|[\\uDD26\\uDD35\\uDD37-\\uDD39\\uDD3D\\uDD3E\\uDDB8\\uDDB9\\uDDCD-\\uDDCF\\uDDD4\\uDDD6-\\uDDDD](?:\\uD83C[\\uDFFB-\\uDFFF])?(?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDDDE\\uDDDF](?:\\u200D[\\u2640\\u2642]\\uFE0F?)?|[\\uDD0D\\uDD0E\\uDD10-\\uDD17\\uDD20-\\uDD25\\uDD27-\\uDD2F\\uDD3A\\uDD3F-\\uDD45\\uDD47-\\uDD76\\uDD78-\\uDDB4\\uDDB7\\uDDBA\\uDDBC-\\uDDCC\\uDDD0\\uDDE0-\\uDDFF\\uDE70-\\uDE7C\\uDE80-\\uDE88\\uDE90-\\uDEBD\\uDEBF-\\uDEC2\\uDECE-\\uDEDB\\uDEE0-\\uDEE8]|\\uDD3C(?:\\u200D[\\u2640\\u2642]\\uFE0F?|\\uD83C[\\uDFFB-\\uDFFF])?|\\uDDD1(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1))|\\uD83C(?:\\uDFFB(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFC-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFC(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFD-\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFD(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFE(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFD\\uDFFF]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?|\\uDFFF(?:\\u200D(?:[\\u2695\\u2696\\u2708]\\uFE0F?|\\u2764\\uFE0F?\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFE]|\\uD83C[\\uDF3E\\uDF73\\uDF7C\\uDF84\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E(?:[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]|\\uDD1D\\u200D\\uD83E\\uDDD1\\uD83C[\\uDFFB-\\uDFFF])))?))?|\\uDEF1(?:\\uD83C(?:\\uDFFB(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFC-\\uDFFF])?|\\uDFFC(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])?|\\uDFFD(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])?|\\uDFFE(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])?|\\uDFFF(?:\\u200D\\uD83E\\uDEF2\\uD83C[\\uDFFB-\\uDFFE])?))?)/g,"")),a&&(e=e.replace(/[\\u1D00-\\u1D7F\\u1D80-\\u1DBF\\u1DC0-\\u1DFF\\u20A0-\\u20CF\\u20D0-\\u20FF\\u2100-\\u214F\\u2150-\\u218F\\u2190-\\u21FF\\u2200-\\u22FF\\u2300-\\u23FF\\u2400-\\u243F\\u2440-\\u245F\\u2460-\\u24FF\\u2500-\\u257F\\u2580-\\u259F\\u25A0-\\u25FF\\u2600-\\u26FF\\u2700-\\u27BF\\uE000-\\uF8FF]/g,"").replace(/[\\uDB80-\\uDBBF][\\uDC00-\\uDFFF]/g,"").replace(/[\\xAD\\u0600-\\u0605\\u061C\\u06DD\\u070F\\u08E2\\u180E\\u200B-\\u200F\\u202A-\\u202E\\u2060-\\u2064\\u2066-\\u206F\\uFEFF\\uFFF9-\\uFFFB]|\\uD804[\\uDCBD\\uDCCD]|\\uD80D[\\uDC30-\\uDC38]|\\uD82F[\\uDCA0-\\uDCA3]|\\uD834[\\uDD73-\\uDD7A]|\\uDB40[\\uDC01\\uDC20-\\uDC7F]/g,"")),t?e.replace(/[\\u2000-\\u206F\\u2E00-\\u2E7F\\\\'!"#$%&\\xa3\\xa2\\xa5\\xa7\\u20ac()*+,\\-.\\/:;<=>?@\\[\\]^_\`{|}~\\xb1]/g,""):e},cu=function(e){return e.length&&!["x","i"].includes(e)&&(e=su(e,{emoji:!0,nonBmp:!0,punctuations:!0}),li(e))?1:0},du={stateTerms:["on","off"],standaloneTerms:["name","honorific-prefix","given-name","additional-name","family-name","honorific-suffix","nickname","username","new-password","current-password","organization-title","organization","street-address","address-line1","address-line2","address-line3","address-level4","address-level3","address-level2","address-level1","country","country-name","postal-code","cc-name","cc-given-name","cc-additional-name","cc-family-name","cc-number","cc-exp","cc-exp-month","cc-exp-year","cc-csc","cc-type","transaction-currency","transaction-amount","language","bday","bday-day","bday-month","bday-year","sex","url","photo","one-time-code"],qualifiers:["home","work","mobile","fax","pager"],qualifiedTerms:["tel","tel-country-code","tel-national","tel-area-code","tel-local","tel-local-prefix","tel-local-suffix","tel-extension","email","impp"],locations:["billing","shipping"]},pu=function(e){var t=void 0!==(t=(i=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).looseTyped)&&t,n=void 0===(n=i.stateTerms)?[]:n,a=void 0===(a=i.locations)?[]:a,r=void 0===(r=i.qualifiers)?[]:r,o=void 0===(o=i.standaloneTerms)?[]:o,i=void 0===(i=i.qualifiedTerms)?[]:i;return e=e.toLowerCase().trim(),!(!(n=n.concat(du.stateTerms)).includes(e)&&""!==e)||(r=r.concat(du.qualifiers),a=a.concat(du.locations),o=o.concat(du.standaloneTerms),i=i.concat(du.qualifiedTerms),!("webauthn"===(n=e.split(/\\s+/g))[n.length-1]&&(n.pop(),0===n.length)||!t&&(8<n[0].length&&"section-"===n[0].substr(0,8)&&n.shift(),a.includes(n[0])&&n.shift(),r.includes(n[0])&&(n.shift(),o=[]),1!==n.length))&&(t=n[n.length-1],o.includes(t)||i.includes(t)))},fu=function(e){var t;return e.attr("aria-labelledby")&&(t=qo(e.actualNode,"aria-labelledby").map((function(e){return(e=Kn(e))?Ii(e):""})).join(" ").trim())?t:(t=(t=e.attr("aria-label"))&&li(t))||null},mu=function(e,t,n){return e=Kn(e),Ii(e,t,n)},Du=function(e){if(t=fu(e))return t;if(e.attr("id")){if(!e.actualNode)throw new TypeError("Cannot resolve explicit label reference for non-DOM nodes");var t,n=yn(e.attr("id"));if(t=(n=pr(e.actualNode).querySelector('label[for="'+n+'"]'))&&mu(n,!0))return t}return(t=(n=ca(e,"label"))&&Ii(n,!0))||null},hu=function(e){return e=Kn(e),Du(e)},gu=[{matches:[{nodeName:"textarea"},{nodeName:"input",properties:{type:["text","password","search","tel","email","url"]}}],namingMethods:"labelText"},{matches:{nodeName:"input",properties:{type:["button","submit","reset"]}},namingMethods:["valueText","titleText","buttonDefaultText"]},{matches:{nodeName:"input",properties:{type:"image"}},namingMethods:["altText","valueText","labelText","titleText","buttonDefaultText"]},{matches:"button",namingMethods:"subtreeText"},{matches:"fieldset",namingMethods:"fieldsetLegendText"},{matches:"OUTPUT",namingMethods:"subtreeText"},{matches:[{nodeName:"select"},{nodeName:"input",properties:{type:/^(?!text|password|search|tel|email|url|button|submit|reset)/}}],namingMethods:"labelText"},{matches:"summary",namingMethods:"subtreeText"},{matches:"figure",namingMethods:["figureText","titleText"]},{matches:"img",namingMethods:"altText"},{matches:"table",namingMethods:["tableCaptionText","tableSummaryText"]},{matches:["hr","br"],namingMethods:["titleText","singleSpace"]}],bu=function e(t){var n=Vr(t),a=[];return t.children.forEach((function(t){3===t.actualNode.nodeType?n&&a.push(t):a=a.concat(e(t))})),a},vu=Nn((function(e){var t=Kn(e),n=t.boundingClientRect,r=[],o=br(t);return e.childNodes.forEach((function(e){var t,i,u,l;3!==e.nodeType||""===li(e.nodeValue)||((t=a.createRange()).selectNodeContents(e),e=Array.from(t.getClientRects()),i=n,e.some((function(e){return!Ur(Yr(e),i)})))||r.push.apply(r,z((u=o,l=[],e.forEach((function(e){e.width<1||e.height<1||(e=u.reduce((function(e,t){return e&&Wr(e,t.boundingClientRect)}),e))&&l.push(e)})),l)))})),r.length?r:[n]})),yu=function(e){lo();var t=Kn(e)._grid;return t?vu(e).map((function(e){return Ro(t,e)})):[]},Fu=["checkbox","img","meter","progressbar","scrollbar","radio","slider","spinbutton","textbox"],wu=function(e){var t=$d(e).vNode;if(e=o.commons.aria.getExplicitRole(t))return-1!==Fu.indexOf(e);switch(t.props.nodeName){case"img":case"iframe":case"object":case"video":case"audio":case"canvas":case"svg":case"math":case"button":case"select":case"textarea":case"keygen":case"progress":case"meter":return!0;case"input":return"hidden"!==t.props.type;default:return!1}},Eu=["head","title","template","script","style","iframe","object","video","audio","noscript"];function Cu(e){return!Eu.includes(e.props.nodeName)&&e.children.some((function(e){return 3===(e=e.props).nodeType&&e.nodeValue.trim()}))}var xu=function e(t,n,a){return Cu(t)||wu(t.actualNode)||!a&&!!fu(t)||!n&&t.children.some((function(t){return 1===t.actualNode.nodeType&&e(t)}))},Au=function(e,t,n){return e=Kn(e),xu(e,t,n)};function ku(e){return!(void 0!==e.children&&!Cu(e))||(1===e.props.nodeType&&wu(e)?!!o.commons.text.accessibleTextVirtual(e):e.children.some((function(e){return!e.attr("lang")&&ku(e)&&!Sr(e)})))}var Nu=function(e){return-1<parseInt(e.getAttribute("tabindex"),10)&&Mo(e)&&!Oo(e)};function Bu(e,t){var n=(e=$d(e)).vNode;e=e.domNode;return n?(void 0===n._isHiddenWithCSS&&(n._isHiddenWithCSS=Tu(e,t)),n._isHiddenWithCSS):Tu(e,t)}function Tu(e,n){if(9===e.nodeType)return!1;if(11===e.nodeType&&(e=e.host),["STYLE","SCRIPT"].includes(e.nodeName.toUpperCase()))return!1;var a,r=t.getComputedStyle(e,null);if(r)return"none"===r.getPropertyValue("display")||(a=["hidden","collapse"],r=r.getPropertyValue("visibility"),!(!a.includes(r)||n))||!!(a.includes(r)&&n&&a.includes(n))||!(!(n=Pr(e))||a.includes(r))&&Bu(n,r);throw new Error("Style does not exist for the given element.")}var Ru=Bu,_u=function(e){return null!==(e=e.doctype)&&"html"===e.name&&!e.publicId&&!e.systemId},Su=function(e){(e instanceof an||null!=(n=t)&&n.Node&&e instanceof t.Node)&&(e=o.commons.aria.getRole(e));var n=Xo.ariaRoles[e];return(null==n?void 0:n.type)||null},Ou=["block","list-item","table","flex","grid","inline-block"];function Mu(e){return e=t.getComputedStyle(e).getPropertyValue("display"),Ou.includes(e)||"table-"===e.substr(0,6)}var Pu=function(e,t){var n,a,r,o;return!Mu(e)&&(n=function(e){for(var t=Pr(e);t&&!Mu(t);)t=Pr(t);return Kn(t)}(e),r=a="",o=0,function e(t,n){!1!==n(t.actualNode)&&t.children.forEach((function(t){return e(t,n)}))}(n,(function(t){if(2===o)return!1;if(3===t.nodeType&&(a+=t.nodeValue),1===t.nodeType){var n=(t.nodeName||"").toUpperCase();if(t===e&&(o=1),!["BR","HR"].includes(n))return!("none"===t.style.display||"hidden"===t.style.overflow||!["",null,"none"].includes(t.style.float)||!["",null,"relative"].includes(t.style.position))&&("widget"===Su(t)?(r+=t.textContent,!1):void 0);0===o?r=a="":o=2}})),a=li(a),null!=t&&t.noLengthCompare?0!==a.length:(r=li(r),a.length>r.length))},Iu=function(e){if(e=(e=e||{}).modalPercent||.75,Yn.get("isModalOpen"))return Yn.get("isModalOpen");if(ap(o._tree[0],"dialog, [role=dialog], [aria-modal=true]",Vr).length)return Yn.set("isModalOpen",!0),!0;for(var n=jr(t),i=n.width*e,u=n.height*e,l=(e=(n.width-i)/2,(n.height-u)/2),s=[{x:e,y:l},{x:n.width-e,y:l},{x:n.width/2,y:n.height/2},{x:e,y:n.height-l},{x:n.width-e,y:n.height-l}].map((function(e){return Array.from(a.elementsFromPoint(e.x,e.y))})),c=0;c<s.length;c++){var d=function(e){var n=s[e].find((function(e){return e=t.getComputedStyle(e),parseInt(e.width,10)>=i&&parseInt(e.height,10)>=u&&"none"!==e.getPropertyValue("pointer-events")&&("absolute"===e.position||"fixed"===e.position)}));if(n&&s.every((function(e){return e.includes(n)})))return Yn.set("isModalOpen",!0),{v:!0}}(c);if("object"===r(d))return d.v}Yn.set("isModalOpen",void 0)};function Lu(e){var t,n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:2,a=e.ownerDocument.createRange(),r=(a.setStart(e,0),a.setEnd(e,e.childNodes.length),0),o=0,i=Z(a.getClientRects());try{for(i.s();!(t=i.n()).done;){var u=t.value;if(!(u.height<=n))if(r>u.top+n)r=Math.max(r,u.bottom);else{if(0!==o)return!0;r=u.bottom,o++}}}catch(e){i.e(e)}finally{i.f()}return!1}var ju=function(e){return e instanceof t.Node},qu="color.incompleteData",zu={set:function(e,t){if("string"!=typeof e)throw new Error("Incomplete data: key must be a string");var n=Yn.get(qu,(function(){return{}}));return t&&(n[e]=t),n[e]},get:function(e){var t=Yn.get(qu);return null==t?void 0:t[e]},clear:function(){Yn.set(qu,{})}},Vu=function(e,n){var a=e.nodeName.toUpperCase();return["IMG","CANVAS","OBJECT","IFRAME","VIDEO","SVG"].includes(a)?(zu.set("bgColor","imgNode"),!0):((e="none"!==(a=(n=n||t.getComputedStyle(e)).getPropertyValue("background-image")))&&(n=/gradient/.test(a),zu.set("bgColor",n?"bgGradient":"bgImage")),e)},$u=(te(Go={},{Colorjs:function(){return yc},CssSelectorParser:function(){return $u.CssSelectorParser},doT:function(){return Hu.default},emojiRegexText:function(){return ru},memoize:function(){return Uu.default}}),ne(Wt())),Hu=ne(Yt()),Uu=ne($t());function Gu(e,t){var n=e.length,a=(Array.isArray(e[0])||(e=[e]),(t=Array.isArray(t[0])?t:t.map((function(e){return[e]})))[0].length),r=t[0].map((function(e,n){return t.map((function(e){return e[n]}))}));e=e.map((function(e){return r.map((function(t){var n=0;if(Array.isArray(e))for(var a=0;a<e.length;a++)n+=e[a]*(t[a]||0);else{var r,o=Z(t);try{for(o.s();!(r=o.n()).done;){var i=r.value;n+=e*i}}catch(t){o.e(t)}finally{o.f()}}return n}))}));return 1===n&&(e=e[0]),1===a?e.map((function(e){return e[0]})):e}function Wu(e){return"string"===Yu(e)}function Yu(e){return(Object.prototype.toString.call(e).match(/^\\[object\\s+(.*?)\\]$/)[1]||"").toLowerCase()}function Ku(e,t){e=+e,t=+t;var n=(Math.floor(e)+"").length;return n<t?+e.toFixed(t-n):(n=Math.pow(10,n-t),Math.round(e/n)*n)}function Xu(e){var t,n;if(e)return e=e.trim(),t=/^-?[\\d.]+$/,(e=e.match(/^([a-z]+)\\((.+?)\\)$/i))?(n=[],e[2].replace(/\\/?\\s*([-\\w.]+(?:%|deg)?)/g,(function(e,a){/%$/.test(a)?(a=new Number(a.slice(0,-1)/100)).type="<percentage>":/deg$/.test(a)?((a=new Number(+a.slice(0,-3))).type="<angle>",a.unit="deg"):t.test(a)&&((a=new Number(a)).type="<number>"),e.startsWith("/")&&((a=a instanceof Number?a:new Number(a)).alpha=!0),n.push(a)})),{name:e[1].toLowerCase(),rawName:e[1],rawArgs:e[2],args:n}):void 0}function Zu(e){return e[e.length-1]}function Ju(e,t,n){return isNaN(e)?t:isNaN(t)?e:e+(t-e)*n}function Qu(e,t,n){return(n-e)/(t-e)}function el(e,t,n){return Ju(t[0],t[1],Qu(e[0],e[1],n))}function tl(e){return e.map((function(e){return e.split("|").map((function(e){var t,n=(e=e.trim()).match(/^(<[a-z]+>)\\[(-?[.\\d]+),\\s*(-?[.\\d]+)\\]?$/);return n?((t=new String(n[1])).range=[+n[2],+n[3]],t):e}))}))}function nl(){W(this,nl)}Wo=Object.freeze({__proto__:null,isString:Wu,type:Yu,toPrecision:Ku,parseFunction:Xu,last:Zu,interpolate:Ju,interpolateInv:Qu,mapRange:el,parseCoordGrammar:tl,multiplyMatrices:Gu}),K(nl,[{key:"add",value:function(e,t,n){if("string"!=typeof arguments[0])for(var e in arguments[0])this.add(e,arguments[0][e],t);else(Array.isArray(e)?e:[e]).forEach((function(e){this[e]=this[e]||[],t&&this[e][n?"unshift":"push"](t)}),this)}},{key:"run",value:function(e,t){this[e]=this[e]||[],this[e].forEach((function(e){e.call(t&&t.context?t.context:t,t)}))}}]);var al=new nl,rl={gamut_mapping:"lch.c",precision:5,deltaE:"76"},ol={D50:[.3457/.3585,1,.2958/.3585],D65:[.3127/.329,1,.3583/.329]};function il(e){return Array.isArray(e)?e:ol[e]}function ul(e,t,n,a){var r=3<arguments.length&&void 0!==a?a:{};if(e=il(e),t=il(t),!e||!t)throw new TypeError("Missing white point to convert ".concat(e?"":"from").concat(e||t?"":"/").concat(t?"":"to"));if(e===t)return n;if(r={W1:e,W2:t,XYZ:n,options:r},al.run("chromatic-adaptation-start",r),r.M||(r.W1===ol.D65&&r.W2===ol.D50?r.M=[[1.0479298208405488,.022946793341019088,-.05019222954313557],[.029627815688159344,.990434484573249,-.01707382502938514],[-.009243058152591178,.015055144896577895,.7518742899580008]]:r.W1===ol.D50&&r.W2===ol.D65&&(r.M=[[.9554734527042182,-.023098536874261423,.0632593086610217],[-.028369706963208136,1.0099954580058226,.021041398966943008],[.012314001688319899,-.020507696433477912,1.3303659366080753]])),al.run("chromatic-adaptation-end",r),r.M)return Gu(r.M,r.XYZ);throw new TypeError("Only Bradford CAT with white points D50 and D65 supported for now.")}function ll(e){W(this,ll),O(this,ie),O(this,re),S(this,oe,{writable:!0,value:void 0}),this.id=e.id,this.name=e.name,this.base=e.base?ll.get(e.base):null,this.aliases=e.aliases,this.base&&(this.fromBase=e.fromBase,this.toBase=e.toBase);var t,n=null!=(n=e.coords)?n:this.base.coords;this.coords=n,n=null!=(n=null!=(n=e.white)?n:this.base.white)?n:"D65";for(t in this.white=il(n),this.formats=null!=(n=e.formats)?n:{},this.formats){var a=this.formats[t];a.type||(a.type="function"),a.name||(a.name=t)}!e.cssId||null!=(n=this.formats.functions)&&n.color?null==(n=this.formats)||!n.color||null!=(n=this.formats)&&n.color.id||(this.formats.color.id=this.id):(this.formats.color={id:e.cssId},Object.defineProperty(this,"cssId",{value:e.cssId})),this.referred=e.referred,L(this,oe,I(this,ie,cl).call(this).reverse()),al.run("colorspace-init-end",this)}function sl(e){var t;return e.coords&&!e.coordGrammar&&(e.type||(e.type="function"),e.name||(e.name="color"),e.coordGrammar=tl(e.coords),t=Object.entries(this.coords).map((function(t,n){(t=H(t,2))[0],t=t[1],n=e.coordGrammar[n][0],t=t.range||t.refRange;var a=n.range,r="";return"<percentage>"==n?(a=[0,100],r="%"):"<angle>"==n&&(r="deg"),{fromRange:t,toRange:a,suffix:r}})),e.serializeCoords=function(e,n){return e.map((function(e,a){var r=(a=t[a]).fromRange,o=a.toRange;a=a.suffix;return e=Ku(e=r&&o?el(r,o,e):e,n),a&&(e+=a),e}))}),e}function cl(){for(var e=[this],t=this;t=t.base;)e.push(t);return e}re=new WeakSet,oe=new WeakMap,ie=new WeakSet,K(ll,[{key:"inGamut",value:function(e){var t,n=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).epsilon,a=void 0===n?75e-6:n;return this.isPolar?(e=this.toBase(e),this.base.inGamut(e,{epsilon:a})):(t=Object.values(this.coords),e.every((function(e,n){var r;return"angle"===(n=t[n]).type||!n.range||!!Number.isNaN(e)||(r=(n=H(n.range,2))[0],n=n[1],(void 0===r||r-a<=e)&&(void 0===n||e<=n+a))})))}},{key:"cssId",get:function(){var e;return(null==(e=this.formats.functions)||null==(e=e.color)?void 0:e.id)||this.id}},{key:"isPolar",get:function(){for(var e in this.coords)if("angle"===this.coords[e].type)return!0;return!1}},{key:"getFormat",value:function(e){return"object"===r(e)||(e="default"===e?Object.values(this.formats)[0]:this.formats[e])?I(this,re,sl).call(this,e):null}},{key:"to",value:function(e,t){var n;if(1===arguments.length&&(e=(n=[e.space,e.coords])[0],t=n[1]),this!==(e=ll.get(e))){t=t.map((function(e){return Number.isNaN(e)?0:e}));for(var a,r,o=P(this,oe),i=P(e,oe),u=0;u<o.length&&o[u]===i[u];u++)a=o[u],r=u;if(!a)throw new Error("Cannot convert between color spaces ".concat(this," and ").concat(e,": no connection space was found"));for(var l=o.length-1;r<l;l--)t=o[l].toBase(t);for(var s=r+1;s<i.length;s++)t=i[s].fromBase(t)}return t}},{key:"from",value:function(e,t){var n;return 1===arguments.length&&(e=(n=[e.space,e.coords])[0],t=n[1]),(e=ll.get(e)).to(this,t)}},{key:"toString",value:function(){return"".concat(this.name," (").concat(this.id,")")}},{key:"getMinCoords",value:function(){var e,t=[];for(e in this.coords){var n=(n=this.coords[e]).range||n.refRange;t.push(null!=(n=null==n?void 0:n.min)?n:0)}return t}}],[{key:"all",get:function(){return z(new Set(Object.values(ll.registry)))}},{key:"register",value:function(e,t){if(1===arguments.length&&(e=(t=arguments[0]).id),t=this.get(t),this.registry[e]&&this.registry[e]!==t)throw new Error("Duplicate color space registration: '".concat(e,"'"));if(this.registry[e]=t,1===arguments.length&&t.aliases){var n,a=Z(t.aliases);try{for(a.s();!(n=a.n()).done;){var r=n.value;this.register(r,t)}}catch(e){a.e(e)}finally{a.f()}}return t}},{key:"get",value:function(e){if(!e||e instanceof ll)return e;if("string"===Yu(e)){var t=ll.registry[e.toLowerCase()];if(t)return t;throw new TypeError('No color space found with id = "'.concat(e,'"'))}for(var n=arguments.length,a=new Array(1<n?n-1:0),r=1;r<n;r++)a[r-1]=arguments[r];if(a.length)return ll.get.apply(ll,a);throw new TypeError("".concat(e," is not a valid color space"))}},{key:"resolveCoord",value:function(e,t){var n,a;if(a="string"===Yu(e)?e.includes(".")?(n=(a=H(e.split("."),2))[0],a[1]):(n=void 0,e):Array.isArray(e)?(n=(a=H(e,2))[0],a[1]):(n=e.space,e.coordId),!(n=(n=ll.get(n))||t))throw new TypeError("Cannot resolve coordinate reference ".concat(e,": No color space specified and relative references are not allowed here"));if(("number"===(t=Yu(a))||"string"===t&&0<=a)&&(e=Object.entries(n.coords)[a]))return $({space:n,id:e[0],index:a},e[1]);n=ll.get(n);var r,o=a.toLowerCase(),i=0;for(r in n.coords){var u,l=n.coords[r];if(r.toLowerCase()===o||(null==(u=l.name)?void 0:u.toLowerCase())===o)return $({space:n,id:r,index:i},l);i++}throw new TypeError('No "'.concat(a,'" coordinate found in ').concat(n.name,". Its coordinates are: ").concat(Object.keys(n.coords).join(", ")))}}]);var dl,pl=ll,fl=(ae(pl,"registry",{}),ae(pl,"DEFAULT_FORMAT",{type:"functions",name:"color"}),new pl({id:"xyz-d65",name:"XYZ D65",coords:{x:{name:"X"},y:{name:"Y"},z:{name:"Z"}},white:"D65",formats:{color:{ids:["xyz-d65","xyz"]}},aliases:["xyz"]}));k(ml,pl),dl=B(ml),Wt=K(ml);function ml(e){var t;return W(this,ml),e.coords||(e.coords={r:{range:[0,1],name:"Red"},g:{range:[0,1],name:"Green"},b:{range:[0,1],name:"Blue"}}),e.base||(e.base=fl),e.toXYZ_M&&e.fromXYZ_M&&(null==e.toBase&&(e.toBase=function(n){return n=Gu(e.toXYZ_M,n),t.white!==t.base.white?ul(t.white,t.base.white,n):n}),null==e.fromBase)&&(e.fromBase=function(n){return n=ul(t.base.white,t.white,n),Gu(e.fromXYZ_M,n)}),null==e.referred&&(e.referred="display"),t=dl.call(this,e)}function Dl(e){var t={str:null==(n=String(e))?void 0:n.trim()};if(al.run("parse-start",t),t.color)return t.color;if(t.parsed=Xu(t.str),t.parsed){var n=function(){var e=t.parsed.name;if("color"===e){var n,a=t.parsed.args.shift(),o=0<t.parsed.rawArgs.indexOf("/")?t.parsed.args.pop():1,i=Z(pl.all);try{for(i.s();!(n=i.n()).done;){var u,l=n.value,s=l.getFormat("color");if(s&&(a===s.id||null!=(u=s.ids)&&u.includes(a))){var c=function(){var e=Object.keys(l.coords).length,n=Array(e).fill(0);return n.forEach((function(e,a){return n[a]=t.parsed.args[a]||0})),{v:{v:{spaceId:l.id,coords:n,alpha:o}}}}();if("object"===r(c))return c.v}}}catch(n){i.e(n)}finally{i.f()}var d,p="";throw a in pl.registry&&(d=null==(d=pl.registry[a].formats)||null==(d=d.functions)||null==(d=d.color)?void 0:d.id)&&(p="Did you mean color(".concat(d,")?")),new TypeError("Cannot parse color(".concat(a,"). ")+(p||"Missing a plugin?"))}var f,m=Z(pl.all);try{for(m.s();!(f=m.n()).done;){var D=function(){var n,a,r=f.value,o=r.getFormat(e);if(o&&"function"===o.type)return n=1,(o.lastAlpha||Zu(t.parsed.args).alpha)&&(n=t.parsed.args.pop()),a=t.parsed.args,o.coordGrammar&&Object.entries(r.coords).forEach((function(t,n){var r=(t=H(t,2))[0],i=(t=t[1],o.coordGrammar[n]),u=null==(l=a[n])?void 0:l.type;if(!(i=i.find((function(e){return e==u}))))throw l=t.name||r,new TypeError("".concat(u," not allowed for ").concat(l," in ").concat(e,"()"));r=i.range;var l=t.range||t.refRange;(r="<percentage>"===u?r||[0,1]:r)&&l&&(a[n]=el(r,l,a[n]))})),{v:{v:{spaceId:r.id,coords:a,alpha:n}}}}();if("object"===r(D))return D.v}}catch(n){m.e(n)}finally{m.f()}}();if("object"===r(n))return n.v}else{var a,o=Z(pl.all);try{for(o.s();!(a=o.n()).done;){var i,u=a.value;for(i in u.formats){var l=u.formats[i];if("custom"===l.type&&(!l.test||l.test(t.str))){var s=l.parse(t.str);if(s)return null==s.alpha&&(s.alpha=1),s}}}}catch(e){o.e(e)}finally{o.f()}}throw new TypeError("Could not parse ".concat(e," as a color. Missing a plugin?"))}function hl(e){var t;if(e)return(t=(e=Wu(e)?Dl(e):e).space||e.spaceId)instanceof pl||(e.space=pl.get(t)),void 0===e.alpha&&(e.alpha=1),e;throw new TypeError("Empty color reference")}function gl(e,t){return(t=pl.get(t)).from(e)}function bl(e,t){var n=(t=pl.resolveCoord(t,e.space)).space;t=t.index;return gl(e,n)[t]}function vl(e,t,n){return t=pl.get(t),e.coords=t.to(e.space,n),e}function yl(e,t,n){if(e=hl(e),2===arguments.length&&"object"===Yu(t)){var a,r=t;for(a in r)yl(e,a,r[a])}else{"function"==typeof n&&(n=n(bl(e,t)));var o=(i=pl.resolveCoord(t,e.space)).space,i=i.index,u=gl(e,o);u[i]=n,vl(e,o,u)}return e}$t=new pl({id:"xyz-d50",name:"XYZ D50",white:"D50",base:fl,fromBase:function(e){return ul(fl.white,"D50",e)},toBase:function(e){return ul("D50",fl.white,e)},formats:{color:{}}});var Fl=24389/27,wl=ol.D50,El=new pl({id:"lab",name:"Lab",coords:{l:{refRange:[0,100],name:"L"},a:{refRange:[-125,125]},b:{refRange:[-125,125]}},white:wl,base:$t,fromBase:function(e){return e=e.map((function(e,t){return e/wl[t]})).map((function(e){return 216/24389<e?Math.cbrt(e):(Fl*e+16)/116})),[116*e[1]-16,500*(e[0]-e[1]),200*(e[1]-e[2])]},toBase:function(e){var t=[];return t[1]=(e[0]+16)/116,t[0]=e[1]/500+t[1],t[2]=t[1]-e[2]/200,[24/116<t[0]?Math.pow(t[0],3):(116*t[0]-16)/Fl,8<e[0]?Math.pow((e[0]+16)/116,3):e[0]/Fl,24/116<t[2]?Math.pow(t[2],3):(116*t[2]-16)/Fl].map((function(e,t){return e*wl[t]}))},formats:{lab:{coords:["<number> | <percentage>","<number>","<number>"]}}});function Cl(e){return(e%360+360)%360}var xl=new pl({id:"lch",name:"LCH",coords:{l:{refRange:[0,100],name:"Lightness"},c:{refRange:[0,150],name:"Chroma"},h:{refRange:[0,360],type:"angle",name:"Hue"}},base:El,fromBase:function(e){var t=(e=H(e,3))[0],n=e[1],a=(e=e[2],Math.abs(n)<.02&&Math.abs(e)<.02?NaN:180*Math.atan2(e,n)/Math.PI);return[t,Math.sqrt(Math.pow(n,2)+Math.pow(e,2)),Cl(a)]},toBase:function(e){var t=(e=H(e,3))[0],n=e[1];e=e[2];return n<0&&(n=0),isNaN(e)&&(e=0),[t,n*Math.cos(e*Math.PI/180),n*Math.sin(e*Math.PI/180)]},formats:{lch:{coords:["<number> | <percentage>","<number>","<number> | <angle>"]}}}),Al=Math.pow(25,7),kl=Math.PI,Nl=180/kl,Bl=kl/180;function Tl(e,t){var n=void 0===(n=(r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).kL)?1:n,a=void 0===(a=r.kC)?1:a,r=void 0===(r=r.kH)?1:r,o=(u=H(El.from(e),3))[0],i=u[1],u=u[2],l=xl.from(El,[o,i,u])[1],s=(d=H(El.from(t),3))[0],c=d[1],d=d[2],p=(l=((l=l<0?0:l)+(p=(p=xl.from(El,[s,c,d])[1])<0?0:p))/2,Math.pow(l,7)),f=(p=(1+(l=.5*(1-Math.sqrt(p/(p+Al)))))*i,i=(1+l)*c,l=Math.sqrt(Math.pow(p,2)+Math.pow(u,2)),c=Math.sqrt(Math.pow(i,2)+Math.pow(d,2)),u=0==p&&0===u?0:Math.atan2(u,p),p=0==i&&0===d?0:Math.atan2(d,i),d=(u<0&&(u+=2*kl),p<0&&(p+=2*kl),s-o),i=c-l,(p*=Nl)-(u*=Nl)),m=(u=u+p,p=Math.abs(f),f=(l*c==0?m=0:p<=180?m=f:180<f?m=f-360:f<-180?m=360+f:console.log("the unthinkable has happened"),2*Math.sqrt(c*l)*Math.sin(m*Bl/2)),(o+s)/2);o=(l+c)/2,s=Math.pow(o,7),l=l*c==0?u:p<=180?u/2:u<360?(u+360)/2:(u-360)/2,p=1+.015*(c=Math.pow(m-50,2))/Math.sqrt(20+c),u=1+.045*o,m=1,c=1+.015*o*((m-=.17*Math.cos((l-30)*Bl))+.24*Math.cos(2*l*Bl)+.32*Math.cos((3*l+6)*Bl)-.2*Math.cos((4*l-63)*Bl)),o=30*Math.exp(-1*Math.pow((l-275)/25,2)),m=2*Math.sqrt(s/(s+Al)),l=-1*Math.sin(2*o*Bl)*m,s=Math.pow(d/(n*p),2),s=(s+=Math.pow(i/(a*u),2))+Math.pow(f/(r*c),2)+i/(a*u)*l*(f/(r*c));return Math.sqrt(s)}var Rl=75e-6;function _l(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:e.space,n=void 0===(n=(2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).epsilon)?Rl:n,a=(e=hl(e),t=pl.get(t),e.coords);return t!==e.space&&(a=t.from(e)),t.inGamut(a,{epsilon:n})}function Sl(e){return{space:e.space,coords:e.coords.slice(),alpha:e.alpha}}function Ol(e){var t=void 0===(t=(r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).method)?rl.gamut_mapping:t,n=void 0===(r=r.space)?e.space:r;if(Wu(arguments[1])&&(n=arguments[1]),!_l(e,n=pl.get(n),{epsilon:0})){var a,r=Ml(e,n);if("clip"!==t&&!_l(e,n)){var o=Ol(Sl(r),{method:"clip",space:n});if(2<Tl(e,o)){for(var i=pl.resolveCoord(t),u=i.space,l=i.id,s=Ml(r,u),c=(i.range||i.refRange)[0],d=bl(s,l);.01<d-c;)Tl(s,Ol(Sl(s),{space:n,method:"clip"}))-2<.01?c=bl(s,l):d=bl(s,l),yl(s,l,(c+d)/2);r=Ml(s,n)}else r=o}"clip"!==t&&_l(r,n,{epsilon:0})||(a=Object.values(n.coords).map((function(e){return e.range||[]})),r.coords=r.coords.map((function(e,t){var n=(t=H(a[t],2))[0];t=t[1];return void 0!==n&&(e=Math.max(n,e)),void 0!==t?Math.min(e,t):e}))),n!==e.space&&(r=Ml(r,e.space)),e.coords=r.coords}return e}function Ml(e,t){var n=(2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).inGamut,a=(e=hl(e),(t=pl.get(t)).from(e));a={space:t,coords:a,alpha:e.alpha};return n?Ol(a):a}function Pl(e){var t=void 0===(n=(r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).precision)?rl.precision:n,n=void 0===(n=r.format)?"default":n,a=void 0===(a=r.inGamut)||a,r=q(r,D),o=n,i=(n=null!=(i=null!=(i=(e=hl(e)).space.getFormat(n))?i:e.space.getFormat("default"))?i:pl.DEFAULT_FORMAT,a=a||n.toGamut,(i=e.coords).map((function(e){return e||0})));if(a&&!_l(e)&&(i=Ol(Sl(e),!0===a?void 0:a).coords),"custom"===n.type){if(r.precision=t,!n.serialize)throw new TypeError("format ".concat(o," can only be used to parse colors, not for serialization"));u=n.serialize(i,e.alpha,r)}else{a=n.name||"color",o=(n.serializeCoords?i=n.serializeCoords(i,t):null!==t&&(i=i.map((function(e){return Ku(e,t)}))),z(i)),r=("color"===a&&(i=n.id||(null==(r=n.ids)?void 0:r[0])||e.space.id,o.unshift(i)),e.alpha),i=(null!==t&&(r=Ku(r,t)),e.alpha<1&&!n.noAlpha?"".concat(n.commas?",":" /"," ").concat(r):"");var u="".concat(a,"(").concat(o.join(n.commas?", ":" ")).concat(i,")")}return u}Ml.returns=Ol.returns="color";var Il=new Wt({id:"rec2020-linear",name:"Linear REC.2020",white:"D65",toXYZ_M:[[.6369580483012914,.14461690358620832,.1688809751641721],[.2627002120112671,.6779980715188708,.05930171646986196],[0,.028072693049087428,1.060985057710791]],fromXYZ_M:[[1.716651187971268,-.355670783776392,-.25336628137366],[-.666684351832489,1.616481236634939,.0157685458139111],[.017639857445311,-.042770613257809,.942103121235474]],formats:{color:{}}}),Ll=1.09929682680944,jl=.018053968510807,ql=new Wt({id:"rec2020",name:"REC.2020",base:Il,toBase:function(e){return e.map((function(e){return e<4.5*jl?e/4.5:Math.pow((e+Ll-1)/Ll,1/.45)}))},fromBase:function(e){return e.map((function(e){return jl<=e?Ll*Math.pow(e,.45)-(Ll-1):4.5*e}))},formats:{color:{}}}),zl=new Wt({id:"p3-linear",name:"Linear P3",white:"D65",toXYZ_M:[[.4865709486482162,.26566769316909306,.1982172852343625],[.2289745640697488,.6917385218365064,.079286914093745],[0,.04511338185890264,1.043944368900976]],fromXYZ_M:[[2.493496911941425,-.9313836179191239,-.40271078445071684],[-.8294889695615747,1.7626640603183463,.023624685841943577],[.03584583024378447,-.07617238926804182,.9568845240076872]]}),Vl=new Wt({id:"srgb-linear",name:"Linear sRGB",white:"D65",toXYZ_M:[[.41239079926595934,.357584339383878,.1804807884018343],[.21263900587151027,.715168678767756,.07219231536073371],[.01933081871559182,.11919477979462598,.9505321522496607]],fromXYZ_M:[[3.2409699419045226,-1.537383177570094,-.4986107602930034],[-.9692436362808796,1.8759675015077202,.04155505740717559],[.05563007969699366,-.20397695888897652,1.0569715142428786]],formats:{color:{}}}),$l={aliceblue:[240/255,248/255,1],antiquewhite:[250/255,235/255,215/255],aqua:[0,1,1],aquamarine:[127/255,1,212/255],azure:[240/255,1,1],beige:[245/255,245/255,220/255],bisque:[1,228/255,196/255],black:[0,0,0],blanchedalmond:[1,235/255,205/255],blue:[0,0,1],blueviolet:[138/255,43/255,226/255],brown:[165/255,42/255,42/255],burlywood:[222/255,184/255,135/255],cadetblue:[95/255,158/255,160/255],chartreuse:[127/255,1,0],chocolate:[210/255,105/255,30/255],coral:[1,127/255,80/255],cornflowerblue:[100/255,149/255,237/255],cornsilk:[1,248/255,220/255],crimson:[220/255,20/255,60/255],cyan:[0,1,1],darkblue:[0,0,139/255],darkcyan:[0,139/255,139/255],darkgoldenrod:[184/255,134/255,11/255],darkgray:[169/255,169/255,169/255],darkgreen:[0,100/255,0],darkgrey:[169/255,169/255,169/255],darkkhaki:[189/255,183/255,107/255],darkmagenta:[139/255,0,139/255],darkolivegreen:[85/255,107/255,47/255],darkorange:[1,140/255,0],darkorchid:[.6,50/255,.8],darkred:[139/255,0,0],darksalmon:[233/255,150/255,122/255],darkseagreen:[143/255,188/255,143/255],darkslateblue:[72/255,61/255,139/255],darkslategray:[47/255,79/255,79/255],darkslategrey:[47/255,79/255,79/255],darkturquoise:[0,206/255,209/255],darkviolet:[148/255,0,211/255],deeppink:[1,20/255,147/255],deepskyblue:[0,191/255,1],dimgray:[105/255,105/255,105/255],dimgrey:[105/255,105/255,105/255],dodgerblue:[30/255,144/255,1],firebrick:[178/255,34/255,34/255],floralwhite:[1,250/255,240/255],forestgreen:[34/255,139/255,34/255],fuchsia:[1,0,1],gainsboro:[220/255,220/255,220/255],ghostwhite:[248/255,248/255,1],gold:[1,215/255,0],goldenrod:[218/255,165/255,32/255],gray:[128/255,128/255,128/255],green:[0,128/255,0],greenyellow:[173/255,1,47/255],grey:[128/255,128/255,128/255],honeydew:[240/255,1,240/255],hotpink:[1,105/255,180/255],indianred:[205/255,92/255,92/255],indigo:[75/255,0,130/255],ivory:[1,1,240/255],khaki:[240/255,230/255,140/255],lavender:[230/255,230/255,250/255],lavenderblush:[1,240/255,245/255],lawngreen:[124/255,252/255,0],lemonchiffon:[1,250/255,205/255],lightblue:[173/255,216/255,230/255],lightcoral:[240/255,128/255,128/255],lightcyan:[224/255,1,1],lightgoldenrodyellow:[250/255,250/255,210/255],lightgray:[211/255,211/255,211/255],lightgreen:[144/255,238/255,144/255],lightgrey:[211/255,211/255,211/255],lightpink:[1,182/255,193/255],lightsalmon:[1,160/255,122/255],lightseagreen:[32/255,178/255,170/255],lightskyblue:[135/255,206/255,250/255],lightslategray:[119/255,136/255,.6],lightslategrey:[119/255,136/255,.6],lightsteelblue:[176/255,196/255,222/255],lightyellow:[1,1,224/255],lime:[0,1,0],limegreen:[50/255,205/255,50/255],linen:[250/255,240/255,230/255],magenta:[1,0,1],maroon:[128/255,0,0],mediumaquamarine:[.4,205/255,170/255],mediumblue:[0,0,205/255],mediumorchid:[186/255,85/255,211/255],mediumpurple:[147/255,112/255,219/255],mediumseagreen:[60/255,179/255,113/255],mediumslateblue:[123/255,104/255,238/255],mediumspringgreen:[0,250/255,154/255],mediumturquoise:[72/255,209/255,.8],mediumvioletred:[199/255,21/255,133/255],midnightblue:[25/255,25/255,112/255],mintcream:[245/255,1,250/255],mistyrose:[1,228/255,225/255],moccasin:[1,228/255,181/255],navajowhite:[1,222/255,173/255],navy:[0,0,128/255],oldlace:[253/255,245/255,230/255],olive:[128/255,128/255,0],olivedrab:[107/255,142/255,35/255],orange:[1,165/255,0],orangered:[1,69/255,0],orchid:[218/255,112/255,214/255],palegoldenrod:[238/255,232/255,170/255],palegreen:[152/255,251/255,152/255],paleturquoise:[175/255,238/255,238/255],palevioletred:[219/255,112/255,147/255],papayawhip:[1,239/255,213/255],peachpuff:[1,218/255,185/255],peru:[205/255,133/255,63/255],pink:[1,192/255,203/255],plum:[221/255,160/255,221/255],powderblue:[176/255,224/255,230/255],purple:[128/255,0,128/255],rebeccapurple:[.4,.2,.6],red:[1,0,0],rosybrown:[188/255,143/255,143/255],royalblue:[65/255,105/255,225/255],saddlebrown:[139/255,69/255,19/255],salmon:[250/255,128/255,114/255],sandybrown:[244/255,164/255,96/255],seagreen:[46/255,139/255,87/255],seashell:[1,245/255,238/255],sienna:[160/255,82/255,45/255],silver:[192/255,192/255,192/255],skyblue:[135/255,206/255,235/255],slateblue:[106/255,90/255,205/255],slategray:[112/255,128/255,144/255],slategrey:[112/255,128/255,144/255],snow:[1,250/255,250/255],springgreen:[0,1,127/255],steelblue:[70/255,130/255,180/255],tan:[210/255,180/255,140/255],teal:[0,128/255,128/255],thistle:[216/255,191/255,216/255],tomato:[1,99/255,71/255],turquoise:[64/255,224/255,208/255],violet:[238/255,130/255,238/255],wheat:[245/255,222/255,179/255],white:[1,1,1],whitesmoke:[245/255,245/255,245/255],yellow:[1,1,0],yellowgreen:[154/255,205/255,50/255]},Hl=new Wt({id:"srgb",name:"sRGB",base:Vl,fromBase:function(e){return e.map((function(e){var t=e<0?-1:1,n=e*t;return.0031308<n?t*(1.055*Math.pow(n,1/2.4)-.055):12.92*e}))},toBase:function(e){return e.map((function(e){var t=e<0?-1:1,n=e*t;return n<.04045?e/12.92:t*Math.pow((.055+n)/1.055,2.4)}))},formats:{rgb:{coords:Hl=Array(3).fill("<percentage> | <number>[0, 255]")},rgb_number:{name:"rgb",commas:!0,coords:Ul=Array(3).fill("<number>[0, 255]"),noAlpha:!0},color:{},rgba:{coords:Hl,commas:!0,lastAlpha:!0},rgba_number:{name:"rgba",commas:!0,coords:Ul},hex:{type:"custom",toGamut:!0,test:function(e){return/^#([a-f0-9]{3,4}){1,2}$/i.test(e)},parse:function(e){e.length<=5&&(e=e.replace(/[a-f0-9]/gi,"$&$&"));var t=[];return e.replace(/[a-f0-9]{2}/gi,(function(e){t.push(parseInt(e,16)/255)})),{spaceId:"srgb",coords:t.slice(0,3),alpha:t.slice(3)[0]}},serialize:function(e,t){var n=void 0===(n=(2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).collapse)||n,a=(t<1&&e.push(t),e=e.map((function(e){return Math.round(255*e)})),n&&e.every((function(e){return e%17==0})));return"#"+e.map((function(e){return a?(e/17).toString(16):e.toString(16).padStart(2,"0")})).join("")}},keyword:{type:"custom",test:function(e){return/^[a-z]+$/i.test(e)},parse:function(e){var t={spaceId:"srgb",coords:null,alpha:1};if("transparent"===(e=e.toLowerCase())?(t.coords=$l.black,t.alpha=0):t.coords=$l[e],t.coords)return t}}}}),Ul=new Wt({id:"p3",name:"P3",base:zl,fromBase:Hl.fromBase,toBase:Hl.toBase,formats:{color:{id:"display-p3"}}});if(rl.display_space=Hl,"undefined"!=typeof CSS&&CSS.supports)for(var Gl=0,Wl=[El,ql,Ul];Gl<Wl.length;Gl++){var Yl=Wl[Gl],Kl=Yl.getMinCoords();Kl=Pl({space:Yl,coords:Kl,alpha:1});if(CSS.supports("color",Kl)){rl.display_space=Yl;break}}function Xl(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:"lab",a=(n=pl.get(n)).from(e),r=n.from(t);return Math.sqrt(a.reduce((function(e,t,n){return n=r[n],isNaN(t)||isNaN(n)?e:e+Math.pow(n-t,2)}),0))}function Zl(e){return bl(e,[fl,"y"])}function Jl(e,t){yl(e,[fl,"y"],t)}var Ql=Object.freeze({__proto__:null,getLuminance:Zl,setLuminance:Jl,register:function(e){Object.defineProperty(e.prototype,"luminance",{get:function(){return Zl(this)},set:function(e){Jl(this,e)}})}});function es(e){return.022<=e?e:e+Math.pow(.022-e,1.414)}function ts(e){var t=e<0?-1:1;e=Math.abs(e);return t*Math.pow(e,2.4)}var ns=24389/27,as=ol.D65,rs=new pl({id:"lab-d65",name:"Lab D65",coords:{l:{refRange:[0,100],name:"L"},a:{refRange:[-125,125]},b:{refRange:[-125,125]}},white:as,base:fl,fromBase:function(e){return e=e.map((function(e,t){return e/as[t]})).map((function(e){return 216/24389<e?Math.cbrt(e):(ns*e+16)/116})),[116*e[1]-16,500*(e[0]-e[1]),200*(e[1]-e[2])]},toBase:function(e){var t=[];return t[1]=(e[0]+16)/116,t[0]=e[1]/500+t[1],t[2]=t[1]-e[2]/200,[24/116<t[0]?Math.pow(t[0],3):(116*t[0]-16)/ns,8<e[0]?Math.pow((e[0]+16)/116,3):e[0]/ns,24/116<t[2]?Math.pow(t[2],3):(116*t[2]-16)/ns].map((function(e,t){return e*as[t]}))},formats:{"lab-d65":{coords:["<number> | <percentage>","<number>","<number>"]}}}),os=.5*Math.pow(5,.5)+.5,is=Object.freeze({__proto__:null,contrastWCAG21:function(e,t){var n;return e=hl(e),t=hl(t),(e=Math.max(Zl(e),0))<(t=Math.max(Zl(t),0))&&(e=(n=[t,e])[0],t=n[1]),(e+.05)/(t+.05)},contrastAPCA:function(e,t){t=hl(t),e=hl(e);var n=(t=H((t=Ml(t,"srgb")).coords,3))[0],a=t[1],r=(t=t[2],.2126729*ts(n)+.7151522*ts(a)+.072175*ts(t));n=(e=H((e=Ml(e,"srgb")).coords,3))[0],a=e[1],t=e[2],e=.2126729*ts(n)+.7151522*ts(a)+.072175*ts(t),t=(n=es(r))<(a=es(e)),r=Math.abs(a-n)<5e-4?0:t?1.14*(Math.pow(a,.56)-Math.pow(n,.57)):1.14*(Math.pow(a,.65)-Math.pow(n,.62));return 100*(Math.abs(r)<.1?0:0<r?r-.027:r+.027)},contrastMichelson:function(e,t){e=hl(e),t=hl(t);var n=((e=Math.max(Zl(e),0))<(t=Math.max(Zl(t),0))&&(e=(n=[t,e])[0],t=n[1]),e+t);return 0===n?0:(e-t)/n},contrastWeber:function(e,t){var n;return e=hl(e),t=hl(t),(e=Math.max(Zl(e),0))<(t=Math.max(Zl(t),0))&&(e=(n=[t,e])[0],t=n[1]),0===t?5e4:(e-t)/t},contrastLstar:function(e,t){return e=hl(e),t=hl(t),e=bl(e,[El,"l"]),t=bl(t,[El,"l"]),Math.abs(e-t)},contrastDeltaPhi:function(e,t){return e=hl(e),t=hl(t),e=bl(e,[rs,"l"]),t=bl(t,[rs,"l"]),e=Math.abs(Math.pow(e,os)-Math.pow(t,os)),(t=Math.pow(e,1/os)*Math.SQRT2-40)<7.5?0:t}});function us(e){var t=(e=H(gl(e,fl),3))[0],n=e[1];return[4*t/(e=t+15*n+3*e[2]),9*n/e]}function ls(e){var t=(e=H(gl(e,fl),3))[0],n=e[1];return[t/(e=t+n+e[2]),n/e]}var ss=Object.freeze({__proto__:null,uv:us,xy:ls,register:function(e){Object.defineProperty(e.prototype,"uv",{get:function(){return us(this)}}),Object.defineProperty(e.prototype,"xy",{get:function(){return ls(this)}})}}),cs=Math.PI/180,ds=new pl({id:"xyz-abs-d65",name:"Absolute XYZ D65",coords:{x:{refRange:[0,9504.7],name:"Xa"},y:{refRange:[0,1e4],name:"Ya"},z:{refRange:[0,10888.3],name:"Za"}},base:fl,fromBase:function(e){return e.map((function(e){return Math.max(203*e,0)}))},toBase:function(e){return e.map((function(e){return Math.max(e/203,0)}))}}),ps=2610/Math.pow(2,14),fs=Math.pow(2,14)/2610,ms=3424/Math.pow(2,12),Ds=2413/Math.pow(2,7),hs=2392/Math.pow(2,7),gs=1.7*2523/Math.pow(2,5),bs=Math.pow(2,5)/(1.7*2523),vs=16295499532821565e-27,ys=[[.41478972,.579999,.014648],[-.20151,1.120649,.0531008],[-.0166008,.2648,.6684799]],Fs=[[1.9242264357876067,-1.0047923125953657,.037651404030618],[.35031676209499907,.7264811939316552,-.06538442294808501],[-.09098281098284752,-.3127282905230739,1.5227665613052603]],ws=[[.5,.5,0],[3.524,-4.066708,.542708],[.199076,1.096799,-1.295875]],Es=[[1,.1386050432715393,.05804731615611886],[.9999999999999999,-.1386050432715393,-.05804731615611886],[.9999999999999998,-.09601924202631895,-.8118918960560388]],Cs=new pl({id:"jzazbz",name:"Jzazbz",coords:{jz:{refRange:[0,1],name:"Jz"},az:{refRange:[-.5,.5]},bz:{refRange:[-.5,.5]}},base:ds,fromBase:function(e){var t=(e=H(e,3))[0],n=e[1];e=e[2],n=Gu(ys,[1.15*t-(1.15-1)*e,.66*n-(.66-1)*t,e]).map((function(e){var t=ms+Ds*Math.pow(e/1e4,ps);e=1+hs*Math.pow(e/1e4,ps);return Math.pow(t/e,gs)})),e=(t=H(Gu(ws,n),3))[0],n=t[1],t=t[2];return[(1-.56)*e/(1+-.56*e)-vs,n,t]},toBase:function(e){var t=(e=H(e,3))[0],n=e[1];e=e[2],t=Gu(Es,[(t+vs)/(1-.56- -.56*(t+vs)),n,e]).map((function(e){var t=ms-Math.pow(e,bs);e=hs*Math.pow(e,bs)-Ds;return 1e4*Math.pow(t/e,fs)})),e=(n=H(Gu(Fs,t),3))[0],t=n[1];return[e=(e+(1.15-1)*(n=n[2]))/1.15,(t+(.66-1)*e)/.66,n]},formats:{color:{}}}),xs=new pl({id:"jzczhz",name:"JzCzHz",coords:{jz:{refRange:[0,1],name:"Jz"},cz:{refRange:[0,1],name:"Chroma"},hz:{refRange:[0,360],type:"angle",name:"Hue"}},base:Cs,fromBase:function(e){var t=(e=H(e,3))[0],n=e[1],a=(e=e[2],Math.abs(n)<2e-4&&Math.abs(e)<2e-4?NaN:180*Math.atan2(e,n)/Math.PI);return[t,Math.sqrt(Math.pow(n,2)+Math.pow(e,2)),Cl(a)]},toBase:function(e){return[e[0],e[1]*Math.cos(e[2]*Math.PI/180),e[1]*Math.sin(e[2]*Math.PI/180)]},formats:{color:{}}}),As=2610/16384,ks=[[.3592,.6976,-.0358],[-.1922,1.1004,.0755],[.007,.0749,.8434]],Ns=[[.5,.5,0],[6610/4096,-13613/4096,7003/4096],[17933/4096,-17390/4096,-543/4096]],Bs=[[.9999888965628402,.008605050147287059,.11103437159861648],[1.00001110343716,-.008605050147287059,-.11103437159861648],[1.0000320633910054,.56004913547279,-.3206339100541203]],Ts=[[2.0701800566956137,-1.326456876103021,.20661600684785517],[.3649882500326575,.6804673628522352,-.04542175307585323],[-.04959554223893211,-.04942116118675749,1.1879959417328034]],Rs=new pl({id:"ictcp",name:"ICTCP",coords:{i:{refRange:[0,1],name:"I"},ct:{refRange:[-.5,.5],name:"CT"},cp:{refRange:[-.5,.5],name:"CP"}},base:ds,fromBase:function(e){var t=e=Gu(ks,e);return t=e.map((function(e){var t=.8359375+2413/128*Math.pow(e/1e4,As);e=1+18.6875*Math.pow(e/1e4,As);return Math.pow(t/e,2523/32)})),Gu(Ns,t)},toBase:function(e){return e=Gu(Bs,e).map((function(e){var t=Math.max(Math.pow(e,32/2523)-.8359375,0);e=2413/128-18.6875*Math.pow(e,32/2523);return 1e4*Math.pow(t/e,16384/2610)})),Gu(Ts,e)},formats:{color:{}}}),_s=[[.8190224432164319,.3619062562801221,-.12887378261216414],[.0329836671980271,.9292868468965546,.03614466816999844],[.048177199566046255,.26423952494422764,.6335478258136937]],Ss=[[1.2268798733741557,-.5578149965554813,.28139105017721583],[-.04057576262431372,1.1122868293970594,-.07171106666151701],[-.07637294974672142,-.4214933239627914,1.5869240244272418]],Os=[[.2104542553,.793617785,-.0040720468],[1.9779984951,-2.428592205,.4505937099],[.0259040371,.7827717662,-.808675766]],Ms=[[.9999999984505198,.39633779217376786,.2158037580607588],[1.0000000088817609,-.10556134232365635,-.06385417477170591],[1.0000000546724108,-.08948418209496575,-1.2914855378640917]],Ps=new pl({id:"oklab",name:"OKLab",coords:{l:{refRange:[0,1],name:"L"},a:{refRange:[-.4,.4]},b:{refRange:[-.4,.4]}},white:"D65",base:fl,fromBase:function(e){return e=Gu(_s,e).map((function(e){return Math.cbrt(e)})),Gu(Os,e)},toBase:function(e){return e=Gu(Ms,e).map((function(e){return Math.pow(e,3)})),Gu(Ss,e)},formats:{oklab:{coords:["<number> | <percentage>","<number>","<number>"]}}}),Is=Object.freeze({__proto__:null,deltaE76:function(e,t){return Xl(e,t,"lab")},deltaECMC:function(e,t){var n=void 0===(n=(a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{}).l)?2:n,a=void 0===(a=a.c)?1:a,r=(i=H(El.from(e),3))[0],o=i[1],i=i[2],u=(l=H(xl.from(El,[r,o,i]),3))[1],l=l[2],s=(d=H(El.from(t),3))[0],c=d[1],d=d[2],p=xl.from(El,[s,c,d])[1];s=r-s,p=(u=u<0?0:u)-(p=p<0?0:p),i-=d,d=Math.pow(o-c,2)+Math.pow(i,2)-Math.pow(p,2),o=.511,16<=r&&(o=.040975*r/(1+.01765*r)),c=.0638*u/(1+.0131*u)+.638,i=164<=(l=Number.isNaN(l)?0:l)&&l<=345?.56+Math.abs(.2*Math.cos((l+168)*cs)):.36+Math.abs(.4*Math.cos((l+35)*cs)),r=Math.pow(u,4),u=c*((l=Math.sqrt(r/(r+1900)))*i+1-l),r=Math.pow(s/(n*o),2),r=(r+=Math.pow(p/(a*c),2))+d/Math.pow(u,2);return Math.sqrt(r)},deltaE2000:Tl,deltaEJz:function(e,t){var n=(e=H(xs.from(e),3))[0],a=e[1],r=(e=e[2],(t=H(xs.from(t),3))[0]),o=t[1];t=t[2],n-=r,r=a-o,Number.isNaN(e)&&Number.isNaN(t)?t=e=0:Number.isNaN(e)?e=t:Number.isNaN(t)&&(t=e),e-=t,t=2*Math.sqrt(a*o)*Math.sin(e/2*(Math.PI/180));return Math.sqrt(Math.pow(n,2)+Math.pow(r,2)+Math.pow(t,2))},deltaEITP:function(e,t){var n=(e=H(Rs.from(e),3))[0],a=e[1],r=(e=e[2],(t=H(Rs.from(t),3))[0]),o=t[1];t=t[2];return 720*Math.sqrt(Math.pow(n-r,2)+.25*Math.pow(a-o,2)+Math.pow(e-t,2))},deltaEOK:function(e,t){var n=(e=H(Ps.from(e),3))[0],a=e[1],r=(e=e[2],(t=H(Ps.from(t),3))[0]);a-=t[1],e-=t[2];return Math.sqrt(Math.pow(n-r,2)+Math.pow(a,2)+Math.pow(e,2))}});function Ls(e,t){var n,a,r=(a=a=Wu(a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{})?{method:a}:a).method,o=void 0===r?rl.deltaE:r,i=q(a,b);for(n in e=hl(e),t=hl(t),Is)if("deltae"+o.toLowerCase()===n.toLowerCase())return Is[n](e,t,i);throw new TypeError("Unknown deltaE method: ".concat(o))}var js=Object.freeze({__proto__:null,lighten:function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:.25;return yl(e,[pl.get("oklch","lch"),"l"],(function(e){return e*(1+t)}))},darken:function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:.25;return yl(e,[pl.get("oklch","lch"),"l"],(function(e){return e*(1-t)}))}});function qs(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:.5,a=3<arguments.length&&void 0!==arguments[3]?arguments[3]:{},r=(e=(r=[hl(e),hl(t)])[0],t=r[1],"object"===Yu(n)&&(n=(r=[.5,n])[0],a=r[1]),a);return Vs(e,t,{space:r.space,outputSpace:r.outputSpace,premultiplied:r.premultiplied})(n)}function zs(e,t){var n,a,r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},o=(s=($s(e)&&(r=t,e=(s=H((n=e).rangeArgs.colors,2))[0],t=s[1]),r)).maxDeltaE,i=s.deltaEMethod,u=(r=void 0===(r=s.steps)?2:r,void 0===(l=s.maxSteps)?1e3:l),l=q(s,v),s=(n||(e=(s=[hl(e),hl(t)])[0],t=s[1],n=Vs(e,t,l)),Ls(e,t)),c=(l=0<o?Math.max(r,Math.ceil(s/o)+1):r,[]);if(void 0!==u&&(l=Math.min(l,u)),c=1===l?[{p:.5,color:n(.5)}]:(a=1/(l-1),Array.from({length:l},(function(e,t){return{p:t*=a,color:n(t)}}))),0<o)for(var d=c.reduce((function(e,t,n){return 0===n?0:(t=Ls(t.color,c[n-1].color,i),Math.max(e,t))}),0);o<d;){d=0;for(var p=1;p<c.length&&c.length<u;p++){var f=c[p-1],m=c[p],D=(m.p+f.p)/2,h=n(D);d=Math.max(d,Ls(h,f.color),Ls(h,m.color));c.splice(p,0,{p:D,color:n(D)}),p++}}return c=c.map((function(e){return e.color}))}function Vs(e,t){var n,a,r,o,i,u,l,s,c,d,p,f,m=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{};return $s(e)?(r=e,o=t,Vs.apply(void 0,z(r.rangeArgs.colors).concat([$({},r.rangeArgs.options,o)]))):(p=m.space,f=m.outputSpace,n=m.progression,a=m.premultiplied,e=hl(e),t=hl(t),e=Sl(e),t=Sl(t),r={colors:[e,t],options:m},p=p?pl.get(p):pl.registry[rl.interpolationSpace]||e.space,f=f?pl.get(f):p,e=Ml(e,p),t=Ml(t,p),e=Ol(e),t=Ol(t),p.coords.h&&"angle"===p.coords.h.type&&(o=m.hue=m.hue||"shorter",s=[(u=[bl(e,m=[p,"h"]),bl(t,m)])[0],u=u[1]],l="raw"===(l=o)?s:(c=(s=H(s.map(Cl),2))[0],d=(s=s[1])-c,"increasing"===l?d<0&&(s+=360):"decreasing"===l?0<d&&(c+=360):"longer"===l?-180<d&&d<180&&(0<d?s+=360:c+=360):"shorter"===l&&(180<d?c+=360:d<-180&&(s+=360)),[c,s]),i=(d=H(l,2))[0],u=d[1],yl(e,m,i),yl(t,m,u)),a&&(e.coords=e.coords.map((function(t){return t*e.alpha})),t.coords=t.coords.map((function(e){return e*t.alpha}))),Object.assign((function(r){r=n?n(r):r;var o=e.coords.map((function(e,n){return Ju(e,t.coords[n],r)})),i=Ju(e.alpha,t.alpha,r);o={space:p,coords:o,alpha:i};return a&&(o.coords=o.coords.map((function(e){return e/i}))),f!==p?Ml(o,f):o}),{rangeArgs:r}))}function $s(e){return"function"===Yu(e)&&!!e.rangeArgs}rl.interpolationSpace="lab";var Hs=Object.freeze({__proto__:null,mix:qs,steps:zs,range:Vs,isRange:$s,register:function(e){e.defineFunction("mix",qs,{returns:"color"}),e.defineFunction("range",Vs,{returns:"function<color>"}),e.defineFunction("steps",zs,{returns:"array<color>"})}}),Us=new pl({id:"hsl",name:"HSL",coords:{h:{refRange:[0,360],type:"angle",name:"Hue"},s:{range:[0,100],name:"Saturation"},l:{range:[0,100],name:"Lightness"}},base:Hl,fromBase:function(e){var t=Math.max.apply(Math,z(e)),n=Math.min.apply(Math,z(e)),a=(e=H(e,3))[0],r=e[1],o=e[2],i=NaN,u=(e=0,(n+t)/2),l=t-n;if(0!=l){switch(e=0==u||1==u?0:(t-u)/Math.min(u,1-u),t){case a:i=(r-o)/l+(r<o?6:0);break;case r:i=(o-a)/l+2;break;case o:i=(a-r)/l+4}i*=60}return[i,100*e,100*u]},toBase:function(e){var t=(e=H(e,3))[0],n=e[1],a=e[2];function r(e){e=(e+t/30)%12;var r=n*Math.min(a,1-a);return a-r*Math.max(-1,Math.min(e-3,9-e,1))}return(t%=360)<0&&(t+=360),n/=100,a/=100,[r(0),r(8),r(4)]},formats:{hsl:{toGamut:!0,coords:["<number> | <angle>","<percentage>","<percentage>"]},hsla:{coords:["<number> | <angle>","<percentage>","<percentage>"],commas:!0,lastAlpha:!0}}}),Gs=new pl({id:"hsv",name:"HSV",coords:{h:{refRange:[0,360],type:"angle",name:"Hue"},s:{range:[0,100],name:"Saturation"},v:{range:[0,100],name:"Value"}},base:Us,fromBase:function(e){var t=(e=H(e,3))[0],n=e[1];e=e[2];return[t,0==(n=(e/=100)+(n/=100)*Math.min(e,1-e))?0:200*(1-e/n),100*n]},toBase:function(e){var t=(e=H(e,3))[0],n=e[1];e=e[2];return[t,0==(n=(e/=100)*(1-(n/=100)/2))||1==n?0:(e-n)/Math.min(n,1-n)*100,100*n]},formats:{color:{toGamut:!0}}}),Ws=new pl({id:"hwb",name:"HWB",coords:{h:{refRange:[0,360],type:"angle",name:"Hue"},w:{range:[0,100],name:"Whiteness"},b:{range:[0,100],name:"Blackness"}},base:Gs,fromBase:function(e){var t=(e=H(e,3))[0],n=e[1];return[t,(e=e[2])*(100-n)/100,100-e]},toBase:function(e){var t=(e=H(e,3))[0],n=e[1],a=(e=e[2],(n/=100)+(e/=100));return 1<=a?[t,0,n/a*100]:[t,100*(0==(a=1-e)?0:1-n/a),100*a]},formats:{hwb:{toGamut:!0,coords:["<number> | <angle>","<percentage>","<percentage>"]}}}),Ys=new Wt({id:"a98rgb-linear",name:"Linear Adobe® 98 RGB compatible",white:"D65",toXYZ_M:[[.5766690429101305,.1855582379065463,.1882286462349947],[.29734497525053605,.6273635662554661,.07529145849399788],[.02703136138641234,.07068885253582723,.9913375368376388]],fromXYZ_M:[[2.0415879038107465,-.5650069742788596,-.34473135077832956],[-.9692436362808795,1.8759675015077202,.04155505740717557],[.013444280632031142,-.11836239223101838,1.0151749943912054]]}),Ks=new Wt({id:"a98rgb",name:"Adobe® 98 RGB compatible",base:Ys,toBase:function(e){return e.map((function(e){return Math.pow(Math.abs(e),563/256)*Math.sign(e)}))},fromBase:function(e){return e.map((function(e){return Math.pow(Math.abs(e),256/563)*Math.sign(e)}))},formats:{color:{id:"a98-rgb"}}}),Xs=new Wt({id:"prophoto-linear",name:"Linear ProPhoto",white:"D50",base:$t,toXYZ_M:[[.7977604896723027,.13518583717574031,.0313493495815248],[.2880711282292934,.7118432178101014,8565396060525902e-20],[0,0,.8251046025104601]],fromXYZ_M:[[1.3457989731028281,-.25558010007997534,-.05110628506753401],[-.5446224939028347,1.5082327413132781,.02053603239147973],[0,0,1.2119675456389454]]}),Zs=new Wt({id:"prophoto",name:"ProPhoto",base:Xs,toBase:function(e){return e.map((function(e){return e<.03125?e/16:Math.pow(e,1.8)}))},fromBase:function(e){return e.map((function(e){return 1/512<=e?Math.pow(e,1/1.8):16*e}))},formats:{color:{id:"prophoto-rgb"}}}),Js=new pl({id:"oklch",name:"OKLCh",coords:{l:{refRange:[0,1],name:"Lightness"},c:{refRange:[0,.4],name:"Chroma"},h:{refRange:[0,360],type:"angle",name:"Hue"}},white:"D65",base:Ps,fromBase:function(e){var t=(e=H(e,3))[0],n=e[1],a=(e=e[2],Math.abs(n)<2e-4&&Math.abs(e)<2e-4?NaN:180*Math.atan2(e,n)/Math.PI);return[t,Math.sqrt(Math.pow(n,2)+Math.pow(e,2)),Cl(a)]},toBase:function(e){var t,n=(e=H(e,3))[0],a=e[1];e=e[2],a=isNaN(e)?t=0:(t=a*Math.cos(e*Math.PI/180),a*Math.sin(e*Math.PI/180));return[n,t,a]},formats:{oklch:{coords:["<number> | <percentage>","<number>","<number> | <angle>"]}}}),Qs=2610/Math.pow(2,14),ec=Math.pow(2,14)/2610,tc=2523/Math.pow(2,5),nc=Math.pow(2,5)/2523,ac=3424/Math.pow(2,12),rc=2413/Math.pow(2,7),oc=2392/Math.pow(2,7),ic=new Wt({id:"rec2100pq",name:"REC.2100-PQ",base:Il,toBase:function(e){return e.map((function(e){return 1e4*Math.pow(Math.max(Math.pow(e,nc)-ac,0)/(rc-oc*Math.pow(e,nc)),ec)/203}))},fromBase:function(e){return e.map((function(e){e=Math.max(203*e/1e4,0);var t=ac+rc*Math.pow(e,Qs);e=1+oc*Math.pow(e,Qs);return Math.pow(t/e,tc)}))},formats:{color:{id:"rec2100-pq"}}}),uc=.17883277,lc=.28466892,sc=.55991073,cc=3.7743,dc=new Wt({id:"rec2100hlg",cssid:"rec2100-hlg",name:"REC.2100-HLG",referred:"scene",base:Il,toBase:function(e){return e.map((function(e){return e<=.5?Math.pow(e,2)/3*cc:Math.exp((e-sc)/uc+lc)/12*cc}))},fromBase:function(e){return e.map((function(e){return(e/=cc)<=1/12?Math.sqrt(3*e):uc*Math.log(12*e-lc)+sc}))},formats:{color:{id:"rec2100-hlg"}}}),pc={};function fc(e){var t=e.id;e.toCone_M,e.fromCone_M,pc[t]=e}function mc(e,t,n){var a=pc[2<arguments.length&&void 0!==n?n:"Bradford"],r=(i=H(Gu(a.toCone_M,e),3))[0],o=i[1],i=i[2],u=H(Gu(a.toCone_M,t),3);r=Gu([[u[0]/r,0,0],[0,u[1]/o,0],[0,0,u[2]/i]],a.toCone_M);return Gu(a.fromCone_M,r)}al.add("chromatic-adaptation-start",(function(e){e.options.method&&(e.M=mc(e.W1,e.W2,e.options.method))})),al.add("chromatic-adaptation-end",(function(e){e.M||(e.M=mc(e.W1,e.W2,e.options.method))})),fc({id:"von Kries",toCone_M:[[.40024,.7076,-.08081],[-.2263,1.16532,.0457],[0,0,.91822]],fromCone_M:[[1.8599364,-1.1293816,.2198974],[.3611914,.6388125,-64e-7],[0,0,1.0890636]]}),fc({id:"Bradford",toCone_M:[[.8951,.2664,-.1614],[-.7502,1.7135,.0367],[.0389,-.0685,1.0296]],fromCone_M:[[.9869929,-.1470543,.1599627],[.4323053,.5183603,.0492912],[-.0085287,.0400428,.9684867]]}),fc({id:"CAT02",toCone_M:[[.7328,.4296,-.1624],[-.7036,1.6975,.0061],[.003,.0136,.9834]],fromCone_M:[[1.0961238,-.278869,.1827452],[.454369,.4735332,.0720978],[-.0096276,-.005698,1.0153256]]}),fc({id:"CAT16",toCone_M:[[.401288,.650173,-.051461],[-.250268,1.204414,.045854],[-.002079,.048952,.953127]],fromCone_M:[[1.862067855087233,-1.011254630531685,.1491867754444518],[.3875265432361372,.6214474419314753,-.008973985167612518],[-.01584149884933386,-.03412293802851557,1.04996443687785]]}),Object.assign(ol,{A:[1.0985,1,.35585],C:[.98074,1,1.18232],D55:[.95682,1,.92149],D75:[.94972,1,1.22638],E:[1,1,1],F2:[.99186,1,.67393],F7:[.95041,1,1.08747],F11:[1.00962,1,.6435]}),ol.ACES=[.32168/.33767,1,.34065/.33767];var Dc=new Wt({id:"acescg",name:"ACEScg",coords:{r:{range:[0,65504],name:"Red"},g:{range:[0,65504],name:"Green"},b:{range:[0,65504],name:"Blue"}},referred:"scene",white:ol.ACES,toXYZ_M:[[.6624541811085053,.13400420645643313,.1561876870049078],[.27222871678091454,.6740817658111484,.05368951740793705],[-.005574649490394108,.004060733528982826,1.0103391003129971]],fromXYZ_M:[[1.6410233796943257,-.32480329418479,-.23642469523761225],[-.6636628587229829,1.6153315916573379,.016756347685530137],[.011721894328375376,-.008284441996237409,.9883948585390215]],formats:{color:{}}}),hc=Math.pow(2,-16),gc=-.35828683,bc=(Math.log2(65504)+9.72)/17.52,vc=(Wt=new Wt({id:"acescc",name:"ACEScc",coords:{r:{range:[gc,bc],name:"Red"},g:{range:[gc,bc],name:"Green"},b:{range:[gc,bc],name:"Blue"}},referred:"scene",base:Dc,toBase:function(e){return e.map((function(e){return e<=(9.72-15)/17.52?2*(Math.pow(2,17.52*e-9.72)-hc):e<bc?Math.pow(2,17.52*e-9.72):65504}))},fromBase:function(e){return e.map((function(e){return e<=0?(Math.log2(hc)+9.72)/17.52:e<hc?(Math.log2(hc+.5*e)+9.72)/17.52:(Math.log2(e)+9.72)/17.52}))},formats:{color:{}}}),Object.freeze({__proto__:null,XYZ_D65:fl,XYZ_D50:$t,XYZ_ABS_D65:ds,Lab_D65:rs,Lab:El,LCH:xl,sRGB_Linear:Vl,sRGB:Hl,HSL:Us,HWB:Ws,HSV:Gs,P3_Linear:zl,P3:Ul,A98RGB_Linear:Ys,A98RGB:Ks,ProPhoto_Linear:Xs,ProPhoto:Zs,REC_2020_Linear:Il,REC_2020:ql,OKLab:Ps,OKLCH:Js,Jzazbz:Cs,JzCzHz:xs,ICTCP:Rs,REC_2100_PQ:ic,REC_2100_HLG:dc,ACEScg:Dc,ACEScc:Wt})),yc=(ue=new WeakMap,K(Fc,[{key:"space",get:function(){return P(this,ue)}},{key:"spaceId",get:function(){return P(this,ue).id}},{key:"clone",value:function(){return new Fc(this.space,this.coords,this.alpha)}},{key:"toJSON",value:function(){return{spaceId:this.spaceId,coords:this.coords,alpha:this.alpha}}},{key:"display",value:function(){for(var e=arguments.length,t=new Array(e),n=0;n<e;n++)t[n]=arguments[n];var a=function(e){var t=void 0===(t=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).space)?rl.display_space:t,n=q(n,h),a=Pl(e,n);return"undefined"==typeof CSS||CSS.supports("color",a)||!rl.display_space?(a=new String(a)).color=e:(t=Ml(e,t),(a=new String(Pl(t,n))).color=t),a}.apply(void 0,[this].concat(t));return a.color=new Fc(a.color),a}}],[{key:"get",value:function(e){if(e instanceof Fc)return e;for(var t=arguments.length,n=new Array(1<t?t-1:0),a=1;a<t;a++)n[a-1]=arguments[a];return A(Fc,[e].concat(n))}},{key:"defineFunction",value:function(e,t){function n(){var e,n=t.apply(void 0,arguments);return"color"===o?n=Fc.get(n):"function<color>"===o?(e=n,n=function(){var t=e.apply(void 0,arguments);return Fc.get(t)},Object.assign(n,e)):"array<color>"===o&&(n=n.map((function(e){return Fc.get(e)}))),n}var a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:t,r=void 0===(r=a.instance)||r,o=a.returns;e in Fc||(Fc[e]=n),r&&(Fc.prototype[e]=function(){for(var e=arguments.length,t=new Array(e),a=0;a<e;a++)t[a]=arguments[a];return n.apply(void 0,[this].concat(t))})}},{key:"defineFunctions",value:function(e){for(var t in e)Fc.defineFunction(t,e[t],e[t])}},{key:"extend",value:function(e){if(e.register)e.register(Fc);else for(var t in e)Fc.defineFunction(t,e[t])}}]),Fc);function Fc(){var e=this;W(this,Fc),S(this,ue,{writable:!0,value:void 0});for(var t,n,a,r=arguments.length,o=new Array(r),i=0;i<r;i++)o[i]=arguments[i];a=(a=1===o.length?hl(o[0]):a)?(t=a.space||a.spaceId,n=a.coords,a.alpha):(t=o[0],n=o[1],o[2]),L(this,ue,pl.get(t)),this.coords=n?n.slice():[0,0,0],this.alpha=a<1?a:1;for(var u=0;u<this.coords.length;u++)"NaN"===this.coords[u]&&(this.coords[u]=NaN);for(var l in P(this,ue).coords)!function(t){Object.defineProperty(e,t,{get:function(){return e.get(t)},set:function(n){return e.set(t,n)}})}(l)}yc.defineFunctions({get:bl,getAll:gl,set:yl,setAll:vl,to:Ml,equals:function(e,t){return e=hl(e),t=hl(t),e.space===t.space&&e.alpha===t.alpha&&e.coords.every((function(e,n){return e===t.coords[n]}))},inGamut:_l,toGamut:Ol,distance:Xl,toString:Pl}),Object.assign(yc,{util:Wo,hooks:al,WHITES:ol,Space:pl,spaces:pl.registry,parse:Dl,defaults:rl});for(var wc,Ec=0,Cc=Object.keys(vc);Ec<Cc.length;Ec++){var xc=Cc[Ec];pl.register(vc[xc])}for(wc in pl.registry)Ac(wc,pl.registry[wc]);function Ac(e,t){Object.keys(t.coords),Object.values(t.coords).map((function(e){return e.name}));var n=e.replace(/-/g,"_");Object.defineProperty(yc.prototype,n,{get:function(){var n=this,a=this.getAll(e);return"undefined"==typeof Proxy?a:new Proxy(a,{has:function(e,n){try{return pl.resolveCoord([t,n]),!0}catch(e){}return Reflect.has(e,n)},get:function(e,n,a){if(n&&"symbol"!==r(n)&&!(n in e)){var o=pl.resolveCoord([t,n]).index;if(0<=o)return e[o]}return Reflect.get(e,n,a)},set:function(a,o,i,u){if(o&&"symbol"!==r(o)&&!(o in a)||0<=o){var l=pl.resolveCoord([t,o]).index;if(0<=l)return a[l]=i,n.setAll(e,a),!0}return Reflect.set(a,o,i,u)}})},set:function(t){this.setAll(e,t)},configurable:!0,enumerable:!0})}al.add("colorspace-init-end",(function(e){var t;Ac(e.id,e),null!=(t=e.aliases)&&t.forEach((function(t){Ac(t,e)}))})),yc.extend(Is),yc.extend({deltaE:Ls}),yc.extend(js),yc.extend({contrast:function(e,t){var n,a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},r=(a=a=Wu(a)?{algorithm:a}:a).algorithm,o=q(a,g);if(!r)throw a=Object.keys(is).map((function(e){return e.replace(/^contrast/,"")})).join(", "),new TypeError("contrast() function needs a contrast algorithm. Please specify one of: ".concat(a));for(n in e=hl(e),t=hl(t),is)if("contrast"+r.toLowerCase()===n.toLowerCase())return is[n](e,t,o);throw new TypeError("Unknown contrast algorithm: ".concat(r))}}),yc.extend(ss),yc.extend(Ql),yc.extend(Hs),yc.extend(is);gc=ne(Kt()),$t=ne(Xt());var kc=(ne(Zt()),Hu.default.templateSettings.strip=!1,"Promise"in t||gc.default.polyfill(),"Uint32Array"in t||(t.Uint32Array=$t.Uint32Array),t.Uint32Array&&("some"in t.Uint32Array.prototype||Object.defineProperty(t.Uint32Array.prototype,"some",{value:Array.prototype.some}),"reduce"in t.Uint32Array.prototype||Object.defineProperty(t.Uint32Array.prototype,"reduce",{value:Array.prototype.reduce})),/^#[0-9a-f]{3,8}$/i),Nc=/hsl\\(\\s*([\\d.]+)(rad|turn)/;function Bc(e,t,n){var a=3<arguments.length&&void 0!==arguments[3]?arguments[3]:1;W(this,Bc),this.red=e,this.green=t,this.blue=n,this.alpha=a}K(Bc,[{key:"toHexString",value:function(){var e=Math.round(this.red).toString(16),t=Math.round(this.green).toString(16),n=Math.round(this.blue).toString(16);return"#"+(15.5<this.red?e:"0"+e)+(15.5<this.green?t:"0"+t)+(15.5<this.blue?n:"0"+n)}},{key:"toJSON",value:function(){return{red:this.red,green:this.green,blue:this.blue,alpha:this.alpha}}},{key:"parseString",value:function(e){e=e.replace(Nc,(function(e,t,n){var a=t+n;switch(n){case"rad":return e.replace(a,180*t/Math.PI);case"turn":return e.replace(a,360*t)}}));try{var t=new yc(e).to("srgb");this.red=Math.round(255*Rc(t.r,0,1)),this.green=Math.round(255*Rc(t.g,0,1)),this.blue=Math.round(255*Rc(t.b,0,1)),this.alpha=+t.alpha}catch(t){throw new Error('Unable to parse color "'.concat(e,'"'))}return this}},{key:"parseRgbString",value:function(e){this.parseString(e)}},{key:"parseHexString",value:function(e){e.match(kc)&&![6,8].includes(e.length)&&this.parseString(e)}},{key:"parseColorFnString",value:function(e){this.parseString(e)}},{key:"getRelativeLuminance",value:function(){var e=this.red/255,t=this.green/255,n=this.blue/255;return.2126*(e<=.03928?e/12.92:Math.pow((.055+e)/1.055,2.4))+.7152*(t<=.03928?t/12.92:Math.pow((.055+t)/1.055,2.4))+.0722*(n<=.03928?n/12.92:Math.pow((.055+n)/1.055,2.4))}}]);var Tc=Bc;function Rc(e,t,n){return Math.min(Math.max(t,e),n)}var _c=function(e){var t=new Tc;return t.parseString(e.getPropertyValue("background-color")),0!==t.alpha&&(e=e.getPropertyValue("opacity"),t.alpha=t.alpha*e),t},Sc=function(e){var n=t.getComputedStyle(e);return Vu(e,n)||1===_c(n).alpha};function Oc(e){var t;return!(!e.href||(t=Yn.get("firstPageLink",Mc))&&e.compareDocumentPosition(t.actualNode)!==e.DOCUMENT_POSITION_FOLLOWING)}function Mc(){return(t.location.origin?fp(o._tree,'a[href]:not([href^="javascript:"])').find((function(e){return!ko(e.actualNode)})):fp(o._tree,'a:not([href^="#"]):not([href^="/#"]):not([href^="javascript:"])')[0])||null}var Pc=/rect\\s*\\(([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px\\s*\\)/,Ic=/(\\w+)\\((\\d+)/;var Lc=function e(n,a,r){if(!n)throw new TypeError("Cannot determine if element is visible for non-DOM nodes");var i,u,l,s=n instanceof an?n:Kn(n),c=(n=s?s.actualNode:n,"_isVisible"+(a?"ScreenReader":"")),d=(p=null!=(p=t.Node)?p:{}).DOCUMENT_NODE,p=p.DOCUMENT_FRAGMENT_NODE,f=(s?s.props:n).nodeType,m=s?s.props.nodeName:n.nodeName.toLowerCase();return s&&void 0!==s[c]?s[c]:f===d||!["style","script","noscript","template"].includes(m)&&(n&&f===p&&(n=n.host),(!a||"true"!==(s?s.attr("aria-hidden"):n.getAttribute("aria-hidden")))&&(n?null!==(d=t.getComputedStyle(n,null))&&("area"===m?(i=a,u=r,!!(p=Dr(f=n,"map"))&&!!(p=p.getAttribute("name"))&&!(!(f=pr(f))||9!==f.nodeType||!(l=fp(o._tree,'img[usemap="#'.concat(yn(p),'"]')))||!l.length)&&l.some((function(t){return e(t.actualNode,i,u)}))):"none"!==d.getPropertyValue("display")&&(m=parseInt(d.getPropertyValue("height")),f=parseInt(d.getPropertyValue("width")),l=(p=Rd(n))&&0===m,p=p&&0===f,m="absolute"===d.getPropertyValue("position")&&(m<2||f<2)&&"hidden"===d.getPropertyValue("overflow"),!(!a&&(function(e){var t=e.getPropertyValue("clip").match(Pc),n=e.getPropertyValue("clip-path").match(Ic);if(t&&5===t.length&&(e=e.getPropertyValue("position"),["fixed","absolute"].includes(e)))return t[3]-t[1]<=0&&t[2]-t[4]<=0;if(n){e=n[1];var a=parseInt(n[2],10);switch(e){case"inset":return 50<=a;case"circle":return 0===a}}}(d)||"0"===d.getPropertyValue("opacity")||l||p||m)||!r&&("hidden"===d.getPropertyValue("visibility")||!a&&qr(n))))&&(f=!1,(p=n.assignedSlot||n.parentNode)&&(f=e(p,a,!0)),s&&(s[c]=f),f)):(m=!0,(r=s.parent)&&(m=e(r,a,!0)),s&&(s[c]=m),m)))},jc=function(e,n){for(var a=["fixed","sticky"],r=[],o=!1,i=0;i<e.length;++i){var u=e[i],l=(u===n&&(o=!0),t.getComputedStyle(u));o||-1===a.indexOf(l.position)?r.push(u):r=[]}return r};function qc(e,n){var a=zc(n);do{var r,o,i,u,l,s,c=zc(e);if(c===a||c===n)return u=e,r=n,i=(o=t.getComputedStyle(r)).getPropertyValue("overflow"),"inline"===o.getPropertyValue("display")||(u=Array.from(u.getClientRects()),l=r.getBoundingClientRect(),s={left:l.left,top:l.top,width:l.width,height:l.height},(["scroll","auto"].includes(i)||r instanceof t.HTMLHtmlElement)&&(s.width=r.scrollWidth,s.height=r.scrollHeight),1===u.length&&"hidden"===i&&"nowrap"===o.getPropertyValue("white-space")&&(u[0]=s),u.some((function(e){return!(Math.ceil(e.left)<Math.floor(s.left)||Math.ceil(e.top)<Math.floor(s.top)||Math.floor(e.left+e.width)>Math.ceil(s.left+s.width)||Math.floor(e.top+e.height)>Math.ceil(s.top+s.height))})))}while(e=c);return!1}function zc(e){for(var t=Kn(e).parent;t;){if(Rd(t.actualNode))return t.actualNode;t=t.parent}}var Vc,$c=function e(t,n){var r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:a,o=3<arguments.length&&void 0!==arguments[3]?arguments[3]:0;if(999<o)throw new Error("Infinite loop detected");return Array.from(r.elementsFromPoint(t,n)||[]).filter((function(e){return pr(e)===r})).reduce((function(a,r){var i;return sr(r)&&(i=e(t,n,r.shadowRoot,o+1),!(a=a.concat(i)).length||!qc(a[0],r))||a.push(r),a}),[])},Hc=function(e,t){var n,r;if(e.hasAttribute(t))return r=e.nodeName.toUpperCase(),n=e,["A","AREA"].includes(r)&&!e.ownerSVGElement||((n=a.createElement("a")).href=e.getAttribute(t)),r=["https:","ftps:"].includes(n.protocol)?n.protocol.replace(/s:$/,":"):n.protocol,t=(e=(e=(t=e=/^\\//.test(n.pathname)?n.pathname:"/".concat(n.pathname)).split("/").pop())&&-1!==e.indexOf(".")?{pathname:t.replace(e,""),filename:/index./.test(e)?"":e}:{pathname:t,filename:""}).pathname,e=e.filename,{protocol:r,hostname:n.hostname,port:(r=n.port,["443","80"].includes(r)?"":r),pathname:/\\/$/.test(t)?t:"".concat(t,"/"),search:function(e){var t={};if(e&&e.length){var n=e.substring(1).split("&");if(n&&n.length)for(var a=0;a<n.length;a++){var r=(o=H(n[a].split("="),2))[0],o=void 0===(o=o[1])?"":o;t[decodeURIComponent(r)]=decodeURIComponent(o)}}return t}(n.search),hash:(r=n.hash)&&(t=r.match(/#!?\\/?/g))&&"#"!==H(t,1)[0]?r:"",filename:e}},Uc=function(e,n){var a=n.getBoundingClientRect(),r=a.top,o=a.left,i=r-n.scrollTop,u=(r=r-n.scrollTop+n.scrollHeight,o-n.scrollLeft);o=o-n.scrollLeft+n.scrollWidth;return!(e.left>o&&e.left>a.right||e.top>r&&e.top>a.bottom||e.right<u&&e.right<a.left||e.bottom<i&&e.bottom<a.top)&&(o=t.getComputedStyle(n),!(e.left>a.right||e.top>a.bottom)||"scroll"===o.overflow||"auto"===o.overflow||n instanceof t.HTMLBodyElement||n instanceof t.HTMLHtmlElement)},Gc=0;function Wc(e,t,n){var a;return W(this,Wc),(a=Vc.call(this)).shadowId=n,a.children=[],a.actualNode=e,(a.parent=t)||(Gc=0),a.nodeIndex=Gc++,a._isHidden=null,a._cache={},a._isXHTML=Bn(e.ownerDocument),"input"===e.nodeName.toLowerCase()&&(n=e.getAttribute("type"),n=a._isXHTML?n:(n||"").toLowerCase(),wp().includes(n)||(n="text"),a._type=n),Yn.get("nodeMap")&&Yn.get("nodeMap").set(e,T(a)),a}k(Wc,an),Vc=B(Wc),K(Wc,[{key:"props",get:function(){var e,t,n,a,r,o,i,u,l;return this._cache.hasOwnProperty("props")||(e=(l=this.actualNode).nodeType,t=l.nodeName,n=l.id,a=l.multiple,r=l.nodeValue,o=l.value,i=l.selected,u=l.checked,l=l.indeterminate,this._cache.props={nodeType:e,nodeName:this._isXHTML?t:t.toLowerCase(),id:n,type:this._type,multiple:a,nodeValue:r,value:o,selected:i,checked:u,indeterminate:l}),this._cache.props}},{key:"attr",value:function(e){return"function"!=typeof this.actualNode.getAttribute?null:this.actualNode.getAttribute(e)}},{key:"hasAttr",value:function(e){return"function"==typeof this.actualNode.hasAttribute&&this.actualNode.hasAttribute(e)}},{key:"attrNames",get:function(){var e;return this._cache.hasOwnProperty("attrNames")||(e=(this.actualNode.attributes instanceof t.NamedNodeMap?this.actualNode:this.actualNode.cloneNode(!1)).attributes,this._cache.attrNames=Array.from(e).map((function(e){return e.name}))),this._cache.attrNames}},{key:"getComputedStylePropertyValue",value:function(e){var n="computedStyle_"+e;return this._cache.hasOwnProperty(n)||(this._cache.hasOwnProperty("computedStyle")||(this._cache.computedStyle=t.getComputedStyle(this.actualNode)),this._cache[n]=this._cache.computedStyle.getPropertyValue(e)),this._cache[n]}},{key:"isFocusable",get:function(){return this._cache.hasOwnProperty("isFocusable")||(this._cache.isFocusable=Mo(this.actualNode)),this._cache.isFocusable}},{key:"tabbableElements",get:function(){return this._cache.hasOwnProperty("tabbableElements")||(this._cache.tabbableElements=So(this)),this._cache.tabbableElements}},{key:"clientRects",get:function(){return this._cache.hasOwnProperty("clientRects")||(this._cache.clientRects=Array.from(this.actualNode.getClientRects()).filter((function(e){return 0<e.width}))),this._cache.clientRects}},{key:"boundingClientRect",get:function(){return this._cache.hasOwnProperty("boundingClientRect")||(this._cache.boundingClientRect=this.actualNode.getBoundingClientRect()),this._cache.boundingClientRect}}]);var Yc,Kc=Wc,Xc=function(e){return(e||"").trim().replace(/\\s{2,}/g," ").split(" ")},Zc=" [idsMap]";function Jc(e,t,n){var a=e[0]._selectorMap;if(a){for(var r=e[0].shadowId,o=0;o<t.length;o++)if(1<t[o].length&&t[o].some(Qc))return;var i=new Set,u=(t.forEach((function(e){var t,n=function(e,t,n){var a=e[e.length-1],r=null,o=1<e.length||!!a.pseudos||!!a.classes;if(Qc(a))r=t["*"];else{if(a.id){if(!t[Zc]||!Object.hasOwn(t[Zc],a.id)||null==(e=t[Zc][a.id])||!e.length)return;r=t[Zc][a.id].filter((function(e){return e.shadowId===n}))}if(a.tag&&"*"!==a.tag){if(null==(e=t[a.tag])||!e.length)return;e=t[a.tag];r=r?ed(e,r):e}if(a.classes){if(null==(e=t["[class]"])||!e.length)return;e=t["[class]"],r=r?ed(e,r):e}if(a.attributes)for(var i=0;i<a.attributes.length;i++){var u=a.attributes[i];if("attrValue"===u.type&&(o=!0),null==(l=t["[".concat(u.key,"]")])||!l.length)return;var l=t["[".concat(u.key,"]")];r=r?ed(l,r):l}}return{nodes:r,isComplexSelector:o}}(e,a,r);null!=n&&null!=(t=n.nodes)&&t.forEach((function(t){n.isComplexSelector&&!sa(t,e)||i.add(t)}))})),[]);return i.forEach((function(e){return u.push(e)})),(u=n?u.filter(n):u).sort((function(e,t){return e.nodeIndex-t.nodeIndex}))}}function Qc(e){return"*"===e.tag&&!e.attributes&&!e.id&&!e.classes}function ed(e,t){return e.filter((function(e){return t.includes(e)}))}function td(e,t,n){Object.hasOwn(n,e)||(n[e]=[]),n[e].push(t)}function nd(e,t){1===e.props.nodeType&&(td(e.props.nodeName,e,t),td("*",e,t),e.attrNames.forEach((function(n){"id"===n&&(t[Zc]=t[Zc]||{},Xc(e.attr(n)).forEach((function(n){td(n,e,t[Zc])}))),td("[".concat(n,"]"),e,t)})))}function ad(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:a.documentElement,n=1<arguments.length?arguments[1]:void 0,r=(Yc=!1,{});Yn.set("nodeMap",new WeakMap),Yn.set("selectorMap",r),e=function e(n,a,r){var o,i,u;function l(t,n,r){return(n=e(n,a,r))?t.concat(n):t}return n.documentElement&&(n=n.documentElement),u=n.nodeName.toLowerCase(),sr(n)?(Yc=!0,o=rd(n,r,a),a="a"+Math.random().toString().substring(2),i=Array.from(n.shadowRoot.childNodes),o.children=i.reduce((function(e,t){return l(e,t,o)}),[]),[o]):"content"===u&&"function"==typeof n.getDistributedNodes?(i=Array.from(n.getDistributedNodes())).reduce((function(e,t){return l(e,t,r)}),[]):"slot"===u&&"function"==typeof n.assignedNodes?((i=Array.from(n.assignedNodes())).length||(i=function(e){var t=[];for(e=e.firstChild;e;)t.push(e),e=e.nextSibling;return t}(n)),t.getComputedStyle(n),i.reduce((function(e,t){return l(e,t,r)}),[])):1===n.nodeType?(o=rd(n,r,a),i=Array.from(n.childNodes),o.children=i.reduce((function(e,t){return l(e,t,o)}),[]),[o]):3===n.nodeType?[rd(n,r)]:void 0}(e,n,null);return e[0]._selectorMap=r,e[0]._hasShadowRoot=Yc,e}function rd(e,t,n){return nd(e=new Kc(e,t,n),Yn.get("selectorMap")),e}var od=function(e){return e?e.trim().split("-")[0].toLowerCase():""},id=function(e){var t={};return t.none=e.none.concat(e.all),t.any=e.any,Object.keys(t).map((function(e){var n;return t[e].length&&(n=o._audit.data.failureSummaries[e])&&"function"==typeof n.failureMessage?n.failureMessage(t[e].map((function(e){return e.message||""}))):void 0})).filter((function(e){return void 0!==e})).join("\\n\\n")};function ud(){var e=o._audit.data.incompleteFallbackMessage;return"string"!=typeof(e="function"==typeof e?e():e)?"":e}var ld=Qt.resultGroups;function sd(e,t){var n=o.utils.aggregateResult(e);return ld.forEach((function(e){t.resultTypes&&!t.resultTypes.includes(e)&&(n[e]||[]).forEach((function(e){Array.isArray(e.nodes)&&0<e.nodes.length&&(e.nodes=[e.nodes[0]])})),n[e]=(n[e]||[]).map((function(e){return e=Object.assign({},e),Array.isArray(e.nodes)&&0<e.nodes.length&&(e.nodes=e.nodes.map((function(e){var n,a,o;return"object"===r(e.node)&&(n=cd(e.node,t),Object.assign(e,n)),delete e.result,delete e.node,a=e,o=t,["any","all","none"].forEach((function(e){Array.isArray(a[e])&&a[e].filter((function(e){return Array.isArray(e.relatedNodes)})).forEach((function(e){e.relatedNodes=e.relatedNodes.map((function(e){return cd(e,o)}))}))})),e}))),ld.forEach((function(t){return delete e[t]})),delete e.pageLevel,delete e.result,e}))})),n}function cd(e,t){var n,a=0<arguments.length&&void 0!==e?e:{},r=1<arguments.length?t:void 0,i=(a=Qa.dqElmToSpec(a,r),{});return o._audit.noHtml?i.html=null:i.html=null!=(n=a.source)?n:"Undefined",r.elementRef&&!a.fromFrame&&(i.element=null!=(n=a.element)?n:null),!1===r.selectors&&!a.fromFrame||(i.target=null!=(n=a.selector)?n:[":root"]),r.ancestry&&(i.ancestry=null!=(n=a.ancestry)?n:[":root"]),r.xpath&&(i.xpath=null!=(n=a.xpath)?n:["/"]),i}var dd=/\\$\\{\\s?data\\s?\\}/g;function pd(e,t){if("string"==typeof t)return e.replace(dd,t);for(var n in t){var a;t.hasOwnProperty(n)&&(a=new RegExp("\\\\\${\\\\s?data\\\\."+n+"\\\\s?}","g"),n=void 0===t[n]?"":String(t[n]),e=e.replace(a,n))}return e}var fd=function e(t,n){var a;if(t)return Array.isArray(n)?(n.values=n.join(", "),"string"==typeof t.singular&&"string"==typeof t.plural?pd(1===n.length?t.singular:t.plural,n):pd(t,n)):"string"==typeof t?pd(t,n):"string"==typeof n?pd(t[n],n):(a=t.default||ud(),e(a=n&&n.messageKey&&t[n.messageKey]?t[n.messageKey]:a,n))},md=function(e,t,n){var a=o._audit.data.checks[e];if(!a)throw new Error("Cannot get message for unknown check: ".concat(e,"."));if(a.messages[t])return fd(a.messages[t],n);throw new Error('Check "'.concat(e,'"" does not have a "').concat(t,'" message.'))},Dd=function(e,t,n){t=((n.rules&&n.rules[t]||{}).checks||{})[e.id];var a=(n.checks||{})[e.id],r=e.enabled;e=e.options;return a&&(a.hasOwnProperty("enabled")&&(r=a.enabled),a.hasOwnProperty("options"))&&(e=a.options),t&&(t.hasOwnProperty("enabled")&&(r=t.enabled),t.hasOwnProperty("options"))&&(e=t.options),{enabled:r,options:e,absolutePaths:n.absolutePaths}};function hd(){var e,n,a,i,u=0<arguments.length&&void 0!==arguments[0]?arguments[0]:null,l=1<arguments.length&&void 0!==arguments[1]?arguments[1]:t;return u&&"object"===r(u)?u:"object"!==r(l)?{}:{testEngine:{name:"axe-core",version:o.version},testRunner:{name:o._audit.brand},testEnvironment:(u=l).navigator&&"object"===r(u.navigator)?(e=u.navigator,n=u.innerHeight,a=u.innerWidth,u=function(e){return(e=e.screen).orientation||e.msOrientation||e.mozOrientation}(u)||{},i=u.angle,u=u.type,{userAgent:e.userAgent,windowWidth:a,windowHeight:n,orientationAngle:i,orientationType:u}):{},timestamp:(new Date).toISOString(),url:null==(e=l.location)?void 0:e.href}}function gd(e,t){var n=t.focusable;t=t.page;return{node:e,include:[],exclude:[],initiator:!1,focusable:n&&(!(n=(n=e).getAttribute("tabindex"))||(n=parseInt(n,10),isNaN(n))||0<=n),size:function(e){var t=parseInt(e.getAttribute("width"),10),n=parseInt(e.getAttribute("height"),10);return(isNaN(t)||isNaN(n))&&(e=e.getBoundingClientRect(),t=isNaN(t)?e.width:t,n=isNaN(n)?e.height:n),{width:t,height:n}}(e),page:t}}function bd(e){var n=0<arguments.length&&void 0!==e?e:[],a=[];Ed(n)||(n=[n]);for(var r=0;r<n.length;r++){var o=function(e){return e instanceof t.Node?e:"string"==typeof e?[e]:(Fd(e)?(function(e){Cd(Array.isArray(e.fromFrames),"fromFrames property must be an array"),Cd(e.fromFrames.every((function(e){return!xd(e,"fromFrames")})),"Invalid context; fromFrames selector must be appended, rather than nested"),Cd(!xd(e,"fromShadowDom"),"fromFrames and fromShadowDom cannot be used on the same object")}(e),e=e.fromFrames):wd(e)&&(e=[e]),function(e){if(Array.isArray(e)){var t,n=[],a=Z(e);try{for(a.s();!(t=a.n()).done;){var r=t.value;if(wd(r)&&(function(e){Cd(Array.isArray(e.fromShadowDom),"fromShadowDom property must be an array"),Cd(e.fromShadowDom.every((function(e){return!xd(e,"fromFrames")})),"shadow selector must be inside fromFrame instead"),Cd(e.fromShadowDom.every((function(e){return!xd(e,"fromShadowDom")})),"fromShadowDom selector must be appended, rather than nested")}(r),r=r.fromShadowDom),"string"!=typeof r&&!function(e){return Array.isArray(e)&&e.every((function(e){return"string"==typeof e}))}(r))return;n.push(r)}}catch(e){a.e(e)}finally{a.f()}return n}}(e))}(n[r]);o&&a.push(o)}return a}function vd(e){return["include","exclude"].some((function(t){return xd(e,t)&&yd(e[t])}))}function yd(e){return"string"==typeof e||e instanceof t.Node||Fd(e)||wd(e)||Ed(e)}function Fd(e){return xd(e,"fromFrames")}function wd(e){return xd(e,"fromShadowDom")}function Ed(e){return e&&"object"===r(e)&&"number"==typeof e.length&&e instanceof t.Node==0}function Cd(e,t){bn(e,"Invalid context; ".concat(t,"\\nSee: https://github.com/dequelabs/axe-core/blob/master/doc/context.md"))}function xd(e,t){return!(!e||"object"!==r(e))&&Object.prototype.hasOwnProperty.call(e,t)}function Ad(e,n){for(var a=[],r=0,o=e[n].length;r<o;r++){var i=e[n][r];i instanceof t.Node?i.documentElement instanceof t.Node?a.push(e.flatTree[0]):a.push(Kn(i)):i&&i.length&&(1<i.length?function(e,t,n){e.frames=e.frames||[],Fp(n.shift()).forEach((function(a){var r=e.frames.find((function(e){return e.node===a}));r||(r=gd(a,e),e.frames.push(r)),r[t].push(n)}))}(e,n,i):(i=Fp(i[0]),a.push.apply(a,z(i.map((function(e){return Kn(e)}))))))}return a.filter((function(e){return e}))}function kd(e,n){var o=this,i=(e=ea(e),this.frames=[],this.page="boolean"==typeof(null==(i=e)?void 0:i.page)?e.page:void 0,this.initiator="boolean"!=typeof(null==(i=e)?void 0:i.initiator)||e.initiator,this.focusable="boolean"!=typeof(null==(i=e)?void 0:i.focusable)||e.focusable,this.size="object"===r(null==(i=e)?void 0:i.size)?e.size:{},e=function(e){if(vd(e)){var t=" must be used inside include or exclude. It should not be on the same object.";Cd(!xd(e,"fromFrames"),"fromFrames"+t),Cd(!xd(e,"fromShadowDom"),"fromShadowDom"+t)}else{if(!yd(e))return{include:[a],exclude:[]};e={include:e,exclude:[]}}return 0===(t=bd(e.include)).length&&t.push(a),{include:t,exclude:e=bd(e.exclude)}}(e),this.flatTree=null!=n?n:ad(function(e){for(var n=e.include,r=(e=e.exclude,Array.from(n).concat(Array.from(e))),o=0;o<r.length;o++){var i=r[o];if(i instanceof t.Element)return i.ownerDocument.documentElement;if(i instanceof t.Document)return i.documentElement}return a.documentElement}(e)),this.exclude=e.exclude,this.include=e.include,this.include=Ad(this,"include"),this.exclude=Ad(this,"exclude"),bp("frame, iframe",this).forEach((function(e){var t;jd(e,o)&&(t=o,Mi(e=e.actualNode))&&!tr(t.frames,"node",e)&&t.frames.push(gd(e,t))})),void 0===this.page&&(this.page=function(e){return 1===(e=e.include).length&&e[0].actualNode===a.documentElement}(this),this.frames.forEach((function(e){e.page=o.page}))),this);if(0===i.include.length&&0===i.frames.length)throw i=Ga.isInFrame()?"frame":"page",new Error("No elements found for include in "+i+" Context");Array.isArray(this.include)||(this.include=Array.from(this.include)),this.include.sort(Vd)}function Nd(e){return!1===(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).iframes?[]:new kd(e).frames.map((function(e){var t=e.node;return(e=q(e,y)).initiator=!1,{frameSelector:Un(t),frameContext:e}}))}function Bd(e){var t=o._audit.rules.find((function(t){return t.id===e}));if(t)return t;throw new Error("Cannot find rule by id: ".concat(e))}function Td(e,t){return e=e.getPropertyValue(t),["scroll","auto"].includes(e)}var Rd=Nn((function(e){var n,a,r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:0,o=e.scrollWidth>e.clientWidth+r;r=e.scrollHeight>e.clientHeight+r;if(o||r)return n=Td(a=t.getComputedStyle(e),"overflow-x"),a=Td(a,"overflow-y"),o&&n||r&&a?{elm:e,top:e.scrollTop,left:e.scrollLeft}:void 0})),_d=function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:t,n=e.document.documentElement;return[void 0!==e.pageXOffset?{elm:e,top:e.pageYOffset,left:e.pageXOffset}:{elm:n,top:n.scrollTop,left:n.scrollLeft}].concat(function e(t){return Array.from(t.children||t.childNodes||[]).reduce((function(t,n){var a=Rd(n);return a&&t.push(a),t.concat(e(n))}),[])}(a.body))};function Sd(){return ea(Xo)}var Od,Md=function(e){if(e)return function(t){var n=t.data,a=void 0!==(a=t.isCrossOrigin)&&a,r=t.shadowId,o=t.root,i=t.priority,u=(t=void 0!==(t=t.isLink)&&t,e.createElement("style"));return t?(t=e.createTextNode('@import "'.concat(n.href,'"')),u.appendChild(t)):u.appendChild(e.createTextNode(n)),e.head.appendChild(u),{sheet:u.sheet,isCrossOrigin:a,shadowId:r,root:o,priority:i}};throw new Error("axe.utils.getStyleSheetFactory should be invoked with an argument")},Pd=function(e){var t;return Od&&Od.parentNode?(void 0===Od.styleSheet?Od.appendChild(a.createTextNode(e)):Od.styleSheet.cssText+=e,Od):e?(t=a.head||a.getElementsByTagName("head")[0],(Od=a.createElement("style")).type="text/css",void 0===Od.styleSheet?Od.appendChild(a.createTextNode(e)):Od.styleSheet.cssText=e,t.appendChild(Od),Od):void 0},Id=function e(n,a){var r,o=Kn(n);return 9!==n.nodeType&&(11===n.nodeType&&(n=n.host),o&&null!==o._isHidden?o._isHidden:!(r=t.getComputedStyle(n,null))||!n.parentNode||"none"===r.getPropertyValue("display")||!a&&"hidden"===r.getPropertyValue("visibility")||"true"===n.getAttribute("aria-hidden")||(a=e(n.assignedSlot||n.parentNode,!0),o&&(o._isHidden=a),a))},Ld=function(e){var t=null!=(t=null==(t=e.props)?void 0:t.nodeName)?t:e.nodeName.toLowerCase();return"http://www.w3.org/2000/svg"!==e.namespaceURI&&!!Xo.htmlElms[t]};function jd(e,t){var n=void 0===(n=t.include)?[]:n;t=void 0===(t=t.exclude)?[]:t,n=n.filter((function(t){return or(t,e)}));return 0!==n.length&&(0===(t=t.filter((function(t){return or(t,e)}))).length||(n=qd(n),or(qd(t),n)))}function qd(e){var t,n,a=Z(e);try{for(a.s();!(n=a.n()).done;){var r=n.value;t&&or(r,t)||(t=r)}}catch(e){a.e(e)}finally{a.f()}return t}function zd(e,t){return e.length===t.length&&e.every((function(e,n){var a=t[n];return Array.isArray(e)?e.length===a.length&&e.every((function(e,t){return a[t]===e})):e===a}))}var Vd=function(e,t){return(e=e.actualNode||e)===(t=t.actualNode||t)?0:4&e.compareDocumentPosition(t)?-1:1};function $d(e){return e instanceof an?{vNode:e,domNode:e.actualNode}:{vNode:Kn(e),domNode:e}}var Hd,Ud,Gd=function(e,t,n,a){var r,o=4<arguments.length&&void 0!==arguments[4]&&arguments[4],i=Array.from(e.cssRules);return i?(r=i.filter((function(e){return 3===e.type}))).length?(r=r.filter((function(e){return e.href})).map((function(e){return e.href})).filter((function(e){return!a.includes(e)})).map((function(e,r){r=[].concat(z(n),[r]);var o=/^https?:\\/\\/|^\\/\\//i.test(e);return Yd(e,t,r,a,o)})),(i=i.filter((function(e){return 3!==e.type}))).length&&r.push(Promise.resolve(t.convertDataToStylesheet({data:i.map((function(e){return e.cssText})).join(),isCrossOrigin:o,priority:n,root:t.rootNode,shadowId:t.shadowId}))),Promise.all(r)):Promise.resolve({isCrossOrigin:o,priority:n,root:t.rootNode,shadowId:t.shadowId,sheet:e}):Promise.resolve()},Wd=function(e,t,n,a){var r=4<arguments.length&&void 0!==arguments[4]&&arguments[4];return function(e){try{return!(!e.cssRules&&e.href)}catch(e){return!1}}(e)?Gd(e,t,n,a,r):Yd(e.href,t,n,a,!0)},Yd=function(e,n,a,r,o){return r.push(e),new Promise((function(n,a){var r=new t.XMLHttpRequest;r.open("GET",e),r.timeout=Qt.preload.timeout,r.addEventListener("error",a),r.addEventListener("timeout",a),r.addEventListener("loadend",(function(e){if(e.loaded&&r.responseText)return n(r.responseText);a(r.responseText)})),r.send()})).then((function(e){return e=n.convertDataToStylesheet({data:e,isCrossOrigin:o,priority:a,root:n.rootNode,shadowId:n.shadowId}),Wd(e.sheet,n,a,r,e.isCrossOrigin)}))};function Kd(){if(t.performance&&t.performance)return t.performance.now()}Hd=null,Ud=Kd();var Xd,Zd,Jd={start:function(){this.mark("mark_axe_start")},end:function(){this.mark("mark_axe_end"),this.measure("axe","mark_axe_start","mark_axe_end"),this.logMeasures("axe")},auditStart:function(){this.mark("mark_audit_start")},auditEnd:function(){this.mark("mark_audit_end"),this.measure("audit_start_to_end","mark_audit_start","mark_audit_end"),this.logMeasures()},mark:function(e){t.performance&&void 0!==t.performance.mark&&t.performance.mark(e)},measure:function(e,n,a){t.performance&&void 0!==t.performance.measure&&t.performance.measure(e,n,a)},logMeasures:function(e){function n(e){en("Measure "+e.name+" took "+e.duration+"ms")}if(t.performance&&void 0!==t.performance.getEntriesByType)for(var a=t.performance.getEntriesByName("mark_axe_start")[0],r=t.performance.getEntriesByType("measure").filter((function(e){return e.startTime>=a.startTime})),o=0;o<r.length;++o){var i=r[o];if(i.name===e)return void n(i);n(i)}},timeElapsed:function(){return Kd()-Ud},reset:function(){Hd=Hd||Kd(),Ud=Kd()}};function Qd(){var e,t,n,r;return a.elementsFromPoint||a.msElementsFromPoint||((e=a.createElement("x")).style.cssText="pointer-events:auto",e="auto"===e.style.pointerEvents,t=e?"pointer-events":"visibility",n=e?"none":"hidden",(r=a.createElement("style")).innerHTML=e?"* { pointer-events: all }":"* { visibility: visible }",function(e,o){var i,u,l,s=[],c=[];for(a.head.appendChild(r);(i=a.elementFromPoint(e,o))&&-1===s.indexOf(i);)s.push(i),c.push({value:i.style.getPropertyValue(t),priority:i.style.getPropertyPriority(t)}),i.style.setProperty(t,n,"important");for(s.indexOf(a.documentElement)<s.length-1&&(s.splice(s.indexOf(a.documentElement),1),s.push(a.documentElement)),u=c.length;l=c[--u];)s[u].style.setProperty(t,l.value||"",l.priority);return a.head.removeChild(r),s})}function ep(e){return"function"==typeof e||"[object Function]"===Xd.call(e)}"function"!=typeof Object.assign&&(Object.assign=function(e){if(null==e)throw new TypeError("Cannot convert undefined or null to object");for(var t=Object(e),n=1;n<arguments.length;n++){var a=arguments[n];if(null!=a)for(var r in a)a.hasOwnProperty(r)&&(t[r]=a[r])}return t}),Array.prototype.find||Object.defineProperty(Array.prototype,"find",{value:function(e){if(null===this)throw new TypeError("Array.prototype.find called on null or undefined");if("function"!=typeof e)throw new TypeError("predicate must be a function");for(var t,n=Object(this),a=n.length>>>0,r=arguments[1],o=0;o<a;o++)if(t=n[o],e.call(r,t,o,n))return t}}),Array.prototype.findIndex||Object.defineProperty(Array.prototype,"findIndex",{value:function(e,t){if(null===this)throw new TypeError("Array.prototype.find called on null or undefined");if("function"!=typeof e)throw new TypeError("predicate must be a function");for(var n,a=Object(this),r=a.length>>>0,o=0;o<r;o++)if(n=a[o],e.call(t,n,o,a))return o;return-1}}),"function"==typeof t.addEventListener&&(a.elementsFromPoint=Qd()),Array.prototype.includes||Object.defineProperty(Array.prototype,"includes",{value:function(e){var t=Object(this),n=parseInt(t.length,10)||0;if(0!==n){var a,r,o=parseInt(arguments[1],10)||0;for(0<=o?a=o:(a=n+o)<0&&(a=0);a<n;){if(e===(r=t[a])||e!=e&&r!=r)return!0;a++}}return!1}}),Array.prototype.some||Object.defineProperty(Array.prototype,"some",{value:function(e){if(null==this)throw new TypeError("Array.prototype.some called on null or undefined");if("function"!=typeof e)throw new TypeError;for(var t=Object(this),n=t.length>>>0,a=2<=arguments.length?arguments[1]:void 0,r=0;r<n;r++)if(r in t&&e.call(a,t[r],r,t))return!0;return!1}}),Array.from||Object.defineProperty(Array,"from",{value:(Xd=Object.prototype.toString,Zd=Math.pow(2,53)-1,function(e){var t=Object(e);if(null==e)throw new TypeError("Array.from requires an array-like object - not null or undefined");var n,a=1<arguments.length?arguments[1]:void 0;if(void 0!==a){if(!ep(a))throw new TypeError("Array.from: when provided, the second argument must be a function");2<arguments.length&&(n=arguments[2])}for(var r,o=function(e){return e=function(e){return e=Number(e),isNaN(e)?0:0!==e&&isFinite(e)?(0<e?1:-1)*Math.floor(Math.abs(e)):e}(e),Math.min(Math.max(e,0),Zd)}(t.length),i=ep(this)?Object(new this(o)):new Array(o),u=0;u<o;)r=t[u],i[u]=a?void 0===n?a(r,u):a.call(n,r,u):r,u+=1;return i.length=o,i})}),String.prototype.includes||(String.prototype.includes=function(e,t){return!((t="number"!=typeof t?0:t)+e.length>this.length)&&-1!==this.indexOf(e,t)}),Array.prototype.flat||Object.defineProperty(Array.prototype,"flat",{configurable:!0,value:function e(){var t=isNaN(arguments[0])?1:Number(arguments[0]);return t?Array.prototype.reduce.call(this,(function(n,a){return Array.isArray(a)?n.push.apply(n,e.call(a,t-1)):n.push(a),n}),[]):Array.prototype.slice.call(this)},writable:!0}),!t.Node||"isConnected"in t.Node.prototype||Object.defineProperty(t.Node.prototype,"isConnected",{get:function(){return!(this.ownerDocument&&this.ownerDocument.compareDocumentPosition(this)&this.DOCUMENT_POSITION_DISCONNECTED)}});var tp=function(e,t){return e.concat(t).filter((function(e,t,n){return n.indexOf(e)===t}))};function np(e,t,n,a,r){return(r=r||{}).vNodes=e,r.vNodesIndex=0,r.anyLevel=t,r.thisLevel=n,r.parentShadowId=a,r}var ap=function(e,t,n){if(a=Jc(e=Array.isArray(e)?e:[e],t=la(t),n))return a;for(var a=e,r=(e=t,n),o=Yn.get("qsa.recycledLocalVariables",(function(){return[]})),i=[],u=np(Array.isArray(a)?a:[a],e,null,a[0].shadowId,o.pop()),l=[];u.vNodesIndex<u.vNodes.length;){for(var s,c=u.vNodes[u.vNodesIndex++],d=null,p=null,f=((null==(s=u.anyLevel)?void 0:s.length)||0)+((null==(s=u.thisLevel)?void 0:s.length)||0),m=!1,D=0;D<f;D++){var h=D<((null==(h=u.anyLevel)?void 0:h.length)||0)?u.anyLevel[D]:u.thisLevel[D-((null==(h=u.anyLevel)?void 0:h.length)||0)];if((!h[0].id||c.shadowId===u.parentShadowId)&&sa(c,h[0]))if(1===h.length)m||r&&!r(c)||(l.push(c),m=!0);else{var g=h.slice(1);if(!1===[" ",">"].includes(g[0].combinator))throw new Error("axe.utils.querySelectorAll does not support the combinator: "+h[1].combinator);(">"===g[0].combinator?d=d||[]:p=p||[]).push(g)}h[0].id&&c.shadowId!==u.parentShadowId||null==(g=u.anyLevel)||!g.includes(h)||(p=p||[]).push(h)}for(c.children&&c.children.length&&(i.push(u),u=np(c.children,p,d,c.shadowId,o.pop()));u.vNodesIndex===u.vNodes.length&&i.length;)o.push(u),u=i.pop()}return l},rp=function(e){var t,n,r,i;e=void 0===(e=e.treeRoot)?o._tree[0]:e;return t=[],e=ap(e,"*",(function(e){return!t.includes(e.shadowId)&&(t.push(e.shadowId),!0)})).map((function(e){return{shadowId:e.shadowId,rootNode:dr(e.actualNode)}})),(e=tp(e,[])).length?(n=a.implementation.createHTMLDocument("Dynamic document for loading cssom"),n=Md(n),r=n,i=[],e.forEach((function(e,t){var n=e.rootNode,a=function(e,t,n){return t=11===e.nodeType&&t?function(e,t){return Array.from(e.children).filter(op).reduce((function(n,a){var r=a.nodeName.toUpperCase();a="STYLE"===r?a.textContent:a;return(a=t({data:a,isLink:"LINK"===r,root:e})).sheet&&n.push(a.sheet),n}),[])}(e,n):function(e){return Array.from(e.styleSheets).filter((function(e){return!!e.media&&ip(e.media.mediaText)}))}(e),function(e){var t=[];return e.filter((function(e){if(e.href){if(t.includes(e.href))return!1;t.push(e.href)}return!0}))}(t)}(n,e=e.shadowId,r);if(!a)return Promise.all(i);var o=t+1,u={rootNode:n,shadowId:e,convertDataToStylesheet:r,rootIndex:o},l=[];t=Promise.all(a.map((function(e,t){return Wd(e,u,[o,t],l)})));i.push(t)})),Promise.all(i).then((function e(t){return t.reduce((function(t,n){return Array.isArray(n)?t.concat(e(n)):t.concat(n)}),[])}))):Promise.resolve()};function op(e){var t=e.nodeName.toUpperCase(),n=e.getAttribute("href"),a=e.getAttribute("rel");n="LINK"===t&&n&&a&&e.rel.toUpperCase().includes("STYLESHEET");return"STYLE"===t||n&&ip(e.media)}function ip(e){return!e||!e.toUpperCase().includes("PRINT")}var up=function(e){return e=void 0===(e=e.treeRoot)?o._tree[0]:e,e=ap(e,"video, audio",(function(e){return(e=e.actualNode).hasAttribute("src")?!!e.getAttribute("src"):!(Array.from(e.getElementsByTagName("source")).filter((function(e){return!!e.getAttribute("src")})).length<=0)})),Promise.all(e.map((function(e){var t;e=e.actualNode;return t=e,new Promise((function(e){0<t.readyState&&e(t),t.addEventListener("loadedmetadata",(function n(){t.removeEventListener("loadedmetadata",n),e(t)}))}))})))};function lp(e){var t={cssom:rp,media:up};return sp(e)?new Promise((function(n,a){var r=(o=cp(e)).assets,o=o.timeout,i=setTimeout((function(){return a(new Error("Preload assets timed out."))}),o);Promise.all(r.map((function(n){return t[n](e).then((function(e){return t={},(a=X(a=n))in t?Object.defineProperty(t,a,{value:e,enumerable:!0,configurable:!0,writable:!0}):t[a]=e,t;var t,a}))}))).then((function(e){e=e.reduce((function(e,t){return $({},e,t)}),{}),clearTimeout(i),n(e)})).catch((function(e){clearTimeout(i),a(e)}))})):Promise.resolve()}function sp(e){return!e||void 0===e.preload||null===e.preload||("boolean"==typeof e.preload?e.preload:(e=e.preload,"object"===r(e)&&Array.isArray(e.assets)))}function cp(e){var t=(n=Qt.preload).assets,n=n.timeout;n={assets:t,timeout:n};if(e.preload&&"boolean"!=typeof e.preload){if(!e.preload.assets.every((function(e){return t.includes(e.toLowerCase())})))throw new Error("Requested assets, not supported. Supported assets are: ".concat(t.join(", "),"."));n.assets=tp(e.preload.assets.map((function(e){return e.toLowerCase()})),[]),e.preload.timeout&&"number"==typeof e.preload.timeout&&!isNaN(e.preload.timeout)&&(n.timeout=e.preload.timeout)}return n}function dp(e){var t=o._audit.data.checks||{},n=o._audit.data.rules||{},a=tr(o._audit.rules,"id",e.id)||{},r=(e.tags=ea(a.tags||[]),pp(t,!0,a)),i=pp(t,!1,a);e.nodes.forEach((function(e){e.any.forEach(r),e.all.forEach(r),e.none.forEach(i)})),ur(e,ea(n[e.id]||{}))}function pp(e,t,n){return function(a){var o,i=(o=e[a.id]||{}).messages||{};delete(o=Object.assign({},o)).messages,n.reviewOnFail||void 0!==a.result?o.message=a.result===t?i.pass:i.fail:("object"!==r(i.incomplete)||Array.isArray(a.data)||(o.message=function(e,t){function n(e){return e.incomplete&&e.incomplete.default?e.incomplete.default:ud()}if(!e||!e.missingData)return e&&e.messageKey?t.incomplete[e.messageKey]:n(t);try{var a=t.incomplete[e.missingData[0].reason];if(a)return a;throw new Error}catch(a){return"string"==typeof e.missingData?t.incomplete[e.missingData]:n(t)}}(a.data,i)),o.message||(o.message=i.incomplete)),"function"!=typeof o.message&&(o.message=fd(o.message,a.data)),ur(a,o)}}var fp=function(e,t){return ap(e,t)};function mp(e,t){var n,a=o._audit&&o._audit.tagExclude?o._audit.tagExclude:[],r=t.hasOwnProperty("include")||t.hasOwnProperty("exclude")?(n=t.include||[],n=Array.isArray(n)?n:[n],r=t.exclude||[],(r=Array.isArray(r)?r:[r]).concat(a.filter((function(e){return-1===n.indexOf(e)})))):(n=Array.isArray(t)?t:[t],a.filter((function(e){return-1===n.indexOf(e)})));return!!(n.some((function(t){return-1!==e.tags.indexOf(t)}))||0===n.length&&!1!==e.enabled)&&r.every((function(t){return-1===e.tags.indexOf(t)}))}var Dp=function(e,t,n){var a=n.runOnly||{};n=(n.rules||{})[e.id];return!(e.pageLevel&&!t.page)&&("rule"===a.type?-1!==a.values.indexOf(e.id):n&&"boolean"==typeof n.enabled?n.enabled:"tag"===a.type&&a.values?mp(e,a.values):mp(e,[]))};function hp(e,t){var n,a,r;return t?(r=e.cloneNode(!1),n=xn(r),r=1===r.nodeType?(a=r.outerHTML,Yn.get(a,(function(){return gp(r,n,e,t)}))):gp(r,n,e,t),Array.from(e.childNodes).forEach((function(e){r.appendChild(hp(e,t))})),r):e}function gp(e,t,n,r){return t&&(e=a.createElement(e.nodeName),Array.from(t).forEach((function(t){var a,o,i;a=n,o=t.name,void 0!==(i=r)[o]&&(!0===i[o]||An(a,i[o]))||e.setAttribute(t.name,t.value)}))),e}function bp(e,t){var n=[];if(o._selectCache)for(var a=0,r=o._selectCache.length;a<r;a++){var i=o._selectCache[a];if(i.selector===e)return i.result}for(var u,l=t.include.reduce((function(e,t){return e.length&&or(e[e.length-1],t)||e.push(t),e}),[]),s=(u=t).exclude&&0!==u.exclude.length?function(e){return jd(e,u)}:null,c=0;c<l.length;c++){var d=l[c];n=function(e,t){if(0===e.length)return t;var n;e.length<t.length&&(n=e,e=t,t=n);for(var a=0,r=t.length;a<r;a++)e.includes(t[a])||e.push(t[a]);return e}(n,ap(d,e,s))}return o._selectCache&&o._selectCache.push({selector:e,result:n}),n}var vp=function(e){e.forEach((function(e){var n=e.elm,a=e.top;e=e.left;if(n===t)return n.scroll(e,a);n.scrollTop=a,n.scrollLeft=e}))};function yp(e){return function e(t,n){var a=t.shift();return n=a?n.querySelector(a):null,0===t.length?n:null!=n&&n.shadowRoot?e(t,n.shadowRoot):null}(Array.isArray(e)?z(e):[e],a)}function Fp(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:a,n=Array.isArray(e)?z(e):[e];return 0===e.length?[]:function e(t,n){t=function(e){return G(e)||V(e)||J(e)||U()}(t);var a=t[0],r=t.slice(1);if(t=n.querySelectorAll(a),0===r.length)return Array.from(t);var o,i=[],u=Z(t);try{for(u.s();!(o=u.n()).done;){var l=o.value;null!=l&&l.shadowRoot&&i.push.apply(i,z(e(r,l.shadowRoot)))}}catch(e){u.e(e)}finally{u.f()}return i}(n,t)}var wp=function(){return["hidden","text","search","tel","url","email","password","date","month","week","time","datetime-local","number","range","color","checkbox","radio","file","submit","image","reset","button"]},Ep=[,[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,,,,,1,1,1,1,,,1,1,1,,1,,1,,1,1],[1,1,1,,1,1,,1,1,1,,1,,,1,1,1,,,1,1,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,,,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1],[,1,,,,,,1,,1,,,,,1,,1,,,,1,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,,,1,,,,,1,1,1,,1,,1,,1,,,,,,1],[1,,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,,1,,1,,,,,1,,1,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,,1,1,1,,1,,1,1,1,,,1,1,1,1,1,1,1,1],[,,1,,,1,,1,,,,1,1,1,,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1,1,1,1,1,,,1,1,1],[1,1,1,1,1,,,1,,,1,,,1,1,1,,,,,1,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1],[,1,,1,1,1,,1,1,,1,,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,,,1,1,1,,,1,1,,,,,,1,1],[1,1,1,,,,,1,,,,1,1,,1,,,,,,1,,,,,1],[,1,,,1,,,1,,,,,,1],[,1,,1,,,,1,,,,1],[1,,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,,1,,,1,1,1,1],[,1,1,1,1,1,,,1,,,1,,1,1,,1,,1,,,,,1,,1],[,1,,,,1,,,1,1,,1,,1,1,1,1,,1,1,,,1,,,1],[,1,1,,,,,,1,,,,1,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,,1,1,1,,,1,1,1,1,1,1,,1,,,,,1,1,,1,,1],[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,1,1],[,1,1,1,,,,1,1,1,,1,1,,,1,1,,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,,1,,,,,1,1,1,,,1,,1,,,1,1],[,,,,1,,,,,,,,,,,,,,,,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,,1,1,1,,1,1,,,,1,1,1,1,1,,,1,1,1,,,,,1],[1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,1,,,,,,,1],[,1,1,,1,1,,1,,,,,,,,,,,,,1],,[1,1,1,,,,,,,,,,,,,1],[,,,,,,,,1,,,1,,,1,1,,,,,1]],[,[1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,,1],[,,,1,,,,,,,,,,,,,,,1],[,1,,,1,1,,1,,1,1,,,,1,1,,,1,1,,,,1],[1,,,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,,,,1],,[,1,1,1,1,1,,1,1,1,,1,1,,1,1,,,1,1,1,1,,1,1,,1],[,1,,,1,,,1,,1,,,1,1,1,1,,,1,1,,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,,,1,1,1,1,1,1,1,,,1,,,1,,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,,,,1],[,,,,,,,1,,,,1,,1,1],[,1,1,1,1,1,1,1,,,,1,1,1,1,1,,,1,1,,1,1,1,1,1],[,1,,,1,1,,1,,1,1,1,,,1,1,,,1,,1,1,1,1,,1],[,1,1,1,,1,1,,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1],[,,,,,,,,,,,,,,,,1],,[,1,1,1,1,1,,1,1,1,,,1,,1,1,,1,1,1,1,1,,1,,1],[,,1,,,1,,,1,1,,,1,,1,1,,1],[,1,1,,1,,,,1,1,,1,,1,1,1,1,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,1,,1,,1,1],,[,1,1,,1,,,1,,1,,,,1,1,1,,,,,,1,,,,1],[1,1,,,1,1,,1,,,,,1,,1]],[,[,1],[,,,1,,,,1,,,,1,,,,1,,,1,,,1],[,,,,,,,,,,,,,,,,,,1,1,,,,,,1],,[1,,,,,1],[,1,,,,1,,,,1],[,1,,,,,,,,,,,1,,,1,,,,,,,,,1,1],[,,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,1,,1],[,1],[,1,,1,,1,,1,,1,,1,1,1,,1,1,,1,,,,,,,1],[1,,,,,1,,,1,1,,1,,1,,1,1,,,,,1,,,1],[,1,1,,,1,,1,,1,,1,,1,1,1,1,,,1,,1,,1,1,1],[1,1,1,1,1,,1,,1,,,,1,1,1,1,,1,1,,,1,1,1,1],[1,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],,[,1,,,,,,1,1,1,,1,,,,1,,,1,1,1,,,1],[1,,,,,1,,1,1,1,,1,1,1,1,1,,1,,1,,1,,,1,1],[1,,1,1,,,,,1,,,,,,1,1,,,1,1,1,1,,,1,,1],[1,,,,,,,,,,,,,,,,,1],[,,,,,1,,,1,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,,,1],[,1,,,,1]],[,[1,1,1,,1,,1,1,1,1,1,1,1,1,1,,1,,1,,1,1,,,1,1,1],[,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],,[,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1],,[1,1,,,,1,1,,,,,,1,,,,1,,1,,1,1,,1],[1],[,,,,,,,,,,,1,,,,,,,,,,,1],[,1,,,,,,,1,1,,,1,,1,,,,1,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,,1],[,,1,,,,,1,,1],[1,,,,1,,,,,1,,,,1,1,,,,1,1,,,,,1],[,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[1,,,1,1,,,,,,,1,,1,,1,1,1,1,1,1],[,,,,,1,,,,,,,1,,,,,,,1],,[,,1,1,1,1,1,,1,1,1,,,1,1,,,1,1,,1,1,1,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,,,,1],,[1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,,,1,1,1,1,,,,,,1,,1,,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,,,,1,,1,,,1,1,1,1,1],[,,,,,,,,,,,1,,,,,,,,,1,,,,1],[,1,1,,1,1,,1,,,,1,1,,1,1,,,1,,1,1,,1],[,1,,1,,1,,,1,,,1,1,,1,1,,,1,1,1],[,1,1,1,1,1,,1,1,,,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,,,,,,,,,1,,1,,1,1,,,,1,,,1],[,1,,,1,1,,,,,,,,,1,1,1,,,,,1],[1,,,1,1,,,,1,1,1,1,1,,,1,,,1,,,1,,1,,1],[,1,1,,1,1,,1,1,,,,1,1,1,,,1,1,,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,,,,1,,,,,,,,,1],[,1,,,,,,,,1,,,,,1,,,,1,,,1],[,1,1,1,1,,,1,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1],[,,,,,1,,1,,,,,1,1,1,1,1,,,1,,,,1],[,1,,,,,,,,1,,,,,,,,,,,,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,1,,,,1,,1,1,1,1,1,,1,1,,,,,,1],[,1,1,1,1,1,1,1,,1,1,,,1,1,,,,1,,1,1,,1,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,1,1,,1,,,1,1,1,1,,,1,,,,,,,1],[,1,,,,,,,,1,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1],[,1,1,,,,,,,,,,,,1,1,,,,,,1],[,1,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,,,,,1],[1,1,,,1,,,1,1,1,,,,1],,[,,,,,,,,,,,,,1,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,1,,,,,,,1],[1,1,1,,1,,1,1,1,1,1,1,1,1,,1,,,1,,1,,,1,1],[,,,,,,,,,1],[,1,,,,1,,,,,,1,,,1,,,,,1],[,1,1,,1,1,,,,,,,,,,,,,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,1,1,1,,,,1,1,,,,1,,1],[1,1,1,1,1,1,,,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,,1,1],[,,,,,,,,,,,,,,,1,,,,1],,[1,1,,1,,1,,,,,,1,,1,,1,1,,1,,1,1,,1,1,,1],[,,1,,,,,,1,,,,1,,1,,,,,1],[1,,,,,,,,,1,,,,,,1,,,,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,,1,,,,,,1,,,1,,,,,,,,1],[,1,,1,,,,,,,,,,,,1],,[1,1,,,,,,,,,,,,,,,,,,,,,,1,1],[1]],[,[1,,,,,,,,,1,,,,,1,,1,,1],[,1,1,,1,1,,1,1,1,,,1,1,1,,,,1,,,1,,,,1],[,1,,,,,,,1,,,,1,,,,,,1],[1,1,1,1,1,1,,,,1,,,,,,,,,1,1,1,1],[1],[,1,1,,,1,1,,,,,1,,1,,,,,,,,1,,,,1],[1,,1,,,1,,1,,,,,1,1,1,1,,,,1,,,,1],[,,1,,,,,,,1,,,,,,,1,,,,,,,1],[1,,,,,,,,,,,,,,1,,,,1],[,,,1,,1,,,,,1,,,,1,1,,,,1],[1,,,,,1,,,,1,,1,1,,,1,1,,1,1,1,,1,1,1,,1],[,1,1,,,,,1,,1,,1,1,1,,1,1,,,1,,1,1,1],[,1,,,,1,,,,1,,,1,,1,1,,,1,1,,,,,,1],[1,,1,1,,1,,1,1,,1,,1,1,1,1,1,,,1,1,,,,,,1],[1,,,,,,,,,,,,,,,,,,1,,,1,,1],[,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,,1,,1],[,1,,,,1,,,1,1,,1,,,1,1,,,1,,,1,,,1,1],[1,1,,1,1,1,,1,1,1,,1,,1,1,1,,,1,,1,1],[1,,1,1,1,1,,,,1,,1,1,1,,1,,,1,1,1,,1,1,1,1,1],[1,,,,,,,,,,,,,1],[,,1,,,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,,,1,,1,,1,,,,1],[,,,1,,,,,,,,,1],[,1,,,,,,,,,,,,,,1,,,,,,,,,1],[,,,,,,,,1,1,,,,,,,,,1,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,,,1,1,1],[,,,,,1,,,,1,1,1,,,1,1,,,1,,1,1,,1],[,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,1,,,,,,,,,,,,,1],[,,1,,,1,,1,1,1,,1,1,,1,,,,1,,1,1],,[,,1,,,1,,,,,,1,,,,1],[,,,,,,,,,1,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,,1,1,,1,,1,,,1,1,1,,,1],[,,,,,1,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,1,,1,1,,1,,,1],[,,,,,1,,,,,,,,,,,,,,1],[,1,1,1,1,,,,,1,,,1,,1,,,,1,1,,,,1,1],[,1,,,1,,,1,,1,1,,1,,,,,,,1],[,,1,,1,,,1,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,,,,,,,,,,1,,1,1],[,,,,,,,,,,,,1],,[,1,1,1,1,,,,1,1,,1,1,1,1,1,1,,1,1,1,1,,1,,1],[1,,,,1,,,,,,,,,,1],[1,,,,,,,,,1],,[,1,,,,1,,,,,,,,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,,1,,,,1,1,,,1,1,,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,1],[1,1,1,,,,,1,1,1,,1,1,1,1,,,1,1,,1,1,,,,,1],[,1,,,,,,,1,1,,,1,1,1,,1,,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,,,1,,,,1,,,1,,,,1,,,,,,,1,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1],[1,1,1,,1,,,1,1,1,1,,1,1,1,1,,,,1,,1,,1,,,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,,1,1,,,,,,,,,1],,[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,,1,,1,,,,1],[,1,,,1,1,,1,1,1,,,1,1,1,1,1,,1,1,1,,1,,,1],[1,,,1,,,,1,1,1,,,,,1,1,,,,1,,1],[1,1,,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,,1,,1,,,,,,,,1,,1],[,1,,,,1,,1,1,,,,1,1,,1,,,,1,1,1,,1],,[,1,,,,,,1,,,,,,,1],[,,,,,,,,1,,,,1,,1,,,,,,,,,,,,1]],[,[,1,1,,1,1,1,1,,1,1,1,,1,1,,1,1,,1,1,1,1,1,1,,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,,,1,,,,,,,,1,,,,,,1,,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,,1,,1,1,1,1,1,1,1,,1,1,,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1],[,1,1,,,,,1,1,1,,,1,,1,1,,,,1,,1,,,1,1],[,,,,,,,1,,,,1,1,1,1,1,,1,,,,,,,,1],[1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,,1,,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,1,1,,1,,1,1,1,,1,,1,1,,1,1,,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,,1,,,,,1,,1],[,1,1,1,,1,,1,,1,,,,1,,1,,,1,,,,,,1,1],[,1,,,1,1,,1,,1,,1,1,1,1,1,,1,1,,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,,1,,1,,1,,,,,,1,,1,,,,1,1]],[,[,1,,1,,,,,,,,,,,,,,,1,,,,1],[,,,,,,,,,1,,1,1,1,,1,,,1,,1,1],[1,1,,,,,,,1,,,,,,,1,,,,,,1],[,1,,,,,,,,,,1,,,,,,,,,1,1],,[,,,,,,,,,,,,,,,1,,,,1,,1],[,,1,1,,1,,1,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,,,,,,,,1],[1,,1,1,,,,1,,,,,,,,,1,,,1,,,1,1],[,1,1,,1,1,,1,1,1,1,1,1,1,1,1,,,1,1,,1,1,,1],[,1,,,1,1,,,,,,1,,1,,1,,,1,,1,1],[1,1,1,1,,1,,1,,1,,1,1,,1,1,1,1,1,,1,1,1,1,1],[,1,1,,,1,,1,,1,1,1,,,1,1,1,,1,1,1,1,,1,1],[,,,,1,,,1,,,,,,,1,,,,1,1],[,1,,,,,,,,,,1,,1,,1,,,,,1,,,,,1],,[1,1,,1,,1,,1,1,,,,,,1,1,,,1,1,1,1,1,1,1,1,1],[1,1,,1,,,,,,1,,,,,,1,1,,,,1,1,,,1],[,1,1,,1,1,,,,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,,,1,,,,1,,,,1,1],[,,,,1],[,,,,,,,,,1,,,1],,[,,1,,1,,,,,,,,,1,,,,,,,,,,,,1],[,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,,,1],[,1,,1,,,,,,1,,,,,1,1,,,,,1,1],[,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,,,1,,1,1,1],[,1,,,,1,,,,,,,1],[,1,,,1,,,1,,1,,1,1,,1,,,,,1,,1,,,,1,1],[,1,,,1,,,1,1,1,,1,1,1,1,1,,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,1,1,,,,1,1,,,,,,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,,1,1,,1,1,1,1,1],[,1,,,,1,,,,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,1,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,,1,1,1,,1,1,1,,,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,,,,,,,1,1,,,,,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,1,,1,1,1,1],,[,1,1,,,,,1,,1,,,,1,1,1,,,1,,,,,1],[,,,,,,,,,,,,,1],[,,,,,1,,,,,,,,1,1,,,,,1,,1,,,1,1],[,,,,,,,,,,,,,,1]],[,[,1],,,,,,,,,,,,,,,,,,,,[1,1,1,1,1,,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,1,1,1,1],[,1,,1,,1,,,1,1,1,,1,1,1,1,1,,,1,,,,1,,1,1],[,1,,1,,1,,,1,,,,,1,,,,,,1,1],[,1,,1,,,,,1,,,,1,,1,1,1,1,1,1,1,1,,1],[,1,,,,,,,,,,,,,,,1]],[,[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,,,,,,,,,1,1,,,,1],[,,,,,,1],[,,1],[,1,1,,,1,,1,,1,1,,1,1,1,,,,1,1,1,,,,,1],,[,1,,,,1,,,,,,1,,,1,,,,1,1,,1],[,,,,,,,1,,,,,,,,,1],[,1,,,,1,1,,,,,,1,1,1,,,,1,,1,1],[,,,,,,,1,,1,,,,,,,,,,1],[,1,1,,,,,,1,1,,,,1,,,,,,,1,,,1],,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,,1,,,1,,,,,1,,1,,1,,1,,,,,1],[1,1,1,1,1,1,1,1,,,,,1,1,,1,1,,1,,,1,,1],[,,,,,,,,,,,,,,1,,,,,,1],,[,,,,,,,,,1,,,,,,1,,,,,1],[,,1,,,,,,,1,,,1,1],[,,,1,,,,,1,,,,,1,,,,,,1,,,,1],[1,,1,1,,1,1,1,1,1,,1,,,,1,1,1,,,1,1,,,,1,1],,[1,1,,,,,,,,,,1,,1,,1,,,1],[,,,,1,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,1],[,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,,1,,,1,,,,,,,,1,,,,,,1,,,,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,1,,,,1,1,1,1,1,1,,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,1,,1,1,,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,,1,,1,,1,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,,,,,,1,,1,,,,,1,1,,,,,1],[1,,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,,1,,,,1,1,1,1,1,,,1,1,,1,,1],[,1,1,1,1,,,,,1,,1,1,1,1,1,,,1,1,,,,1,1,1],[,1,1,1,1,1,,1,,,,,1,,1,,1,,,1,,,1,1,,1]],[,[1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,,,,,1,,,,,1,1,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,,,,1,,1,1,,1,1,1,1,1,,,1,,1,,1],[1,1,1,,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,,1,,,,,,,,,,1,1,1,1,1,1,1,,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,1,1,,,,,,1,1,1,1,1,,,,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,,1,1,1],[,1,1,1,,1,,1,1,1,1,,,1,1,1,,1,1,1,1,1,,,1,1],[1,1,,,,1,,,1,1,1,,1,,1,,1,,1,1,1,1,1,,1,,1],[,1,,,,,,,1,,1,,1,1,1,1,,,,,,,,,1]],[,[,,,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,1,,,1,,,,,,1,,,1,,,,1],,[,1,,,,1,,1,,1,1,,1,1,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],[1,1,1,,,1,,,,,,,,,1,1,,,,,,,,,,1],[,1,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1,,,1],[,,,,,,,,,1],[1,1,,,,,,1,1,1,,1,1,,,,1,1,,1,,1,1,1,,1],[,1,1,1,,1,1,,,1,,1,1,1,1,,,,,,,1,,1],[,1,1,1,1,,,1,,1,,,,1,1,1,1,,1,1,,1],[,1,,,1,1,,1,,,,1,,1,1,,1,,1,,,1,,,1,,1],[,,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,,,,,1],,[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1],[,1,,,,,,,1,1,,1,,,,,1,,,1,,1],[,1,,,,1,,,1,,,,,,,,1,,1,,,1],[,,,,,,,,,,,,,1,1,,,,1,,,1],[,,,,,1,,,1,,,,1],[,1],,[,1],[1,,,,,,,,,,,,,,1,,,,,1]],[,[,1,,,,1,1,1,1,1,1,,1,1,1,1,1,,1,1,,1,1,,,1],[,,1,,,,,,,,,1],,,[1,,,1,1,,,,,,,,1,1,,1,1,,1],,[,,,,,,,,,,,,,,,,,,1,,1],,[1,,,1,1,,1,1,,,,,1,,1,,,,,1,1,,1],,[,1,,,,,,,,1,1,1,1,1,,1,1,,,,1,1],[,,,,,,,,,,,,,,,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,,1,1,1,1,1,1],[,,,,,,,,,,,1,,1,,,1],[1,,,,,,,,,,,,,,,,,,1,,1],,,[,1,,,,,,,,,,,,,,1,,,,1,1],[,,,,,,,,,1,,,1,,,,,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,1,1,,,,,,1],,[,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,1,1,,1,1,1,1,1,1,,,1,1,1,1,1,,1,1],[,1,,,,,,,,1],[,,,,1,,,1,,,1,1,,,,,,,,,,1,,,,1],[,1,,1,1,,,1,1,1,,,,1,1,1,1,,1,1,1,1,,1],[,,,,,,,1],[,1,1,,,,,1,,1,,,,,,1,,,,,,1,,1,,1],[,1,,,,,,1,,,,1,,,,,,,,,,1],[,,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1,1,1,1,,1],[,1,,,,,,,,1],[,1,1,,1,,,,,,,,1,,,,,,1,,,1,,1,,1],[,1,,1,,1,,1,1,1,,1,1,1,,1,,,1,1,,1,1,1,1,1],[,1,1,1,1,1,,,1,1,,,,1,1,1,,,,1,1,,,1,1],[,,1,1,1,1,,1,,1,,1,,1,1,1,1,,,,,1,,1,,1],[1,1,1,1,1,1,1,1,,1,,1,,1,1,1,,,1,1,,,,1,,1],[,,,1],,[,1,1,,1,,,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1],[,1,,,,,,1,,1,,1,,,,,,,1,1,,1,1],[,,,,,,1,,1,1,,1,,1,,,,,,,,,,1],[,1,1,,1,,,,1,,,,1,1,1,,,,1,,1,1,1,,1,1],,[,1,1,,,,,,,,,,,,,1,,,1,,,,,1],[,1,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,1,,,,1,,,,,1,,,,,,,1]],[,[,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[,1,1,1,1,1,,1,,1,1,,,1,1,1,1,,1,,,,,1,1,1],[,,1,1,,1,,1,1,,,,1,1,1,1,,,1,,1,1,1,1,,1],[,1,,1,,,,,,,,1,,1,,1,,,,,,,,,,1],[,,1,,1,,,1,,,,,1,1,,,1,,1,1,1,1],[,1],[,1,1,,1,,1,1,,1,,,1,1,1,,,,1,,,1,,1],[1,1,,1,1,1,,,,,,,,,,,,,1,,1,1,1],[,1,1,,,,,,,1,,,1,,1,,1,,1,1,,,1,,,1],[,,1,,,,,,,,,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,,1,,,,,1,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,,1,,1,1,1,,,1,1,1,1,,,,1,1],[,,,1,1,,,1,,1,,1,,1,1,1,1,,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,,1,,1,,,,1,1,,,1,1,,1,1,,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1,,1,1,,,1],[,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,,1,,,1,,,1,,1,1,1,1,1,,1,,1,1],[,,,,,1,,,,1,,,,,1,1,,,,1],[,1,,1,1,1,,1,,,1,1,1,,,1,,,1,,1,,,1],[,,1,,,,,,,,,1,,1,,,,,1,,1],[,1,1,,,,,,,,1,1,1,,,,,,,,1,,,,,1],[,,,,,,,,1,,,,,1,,,1]],[,[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,,1,1,1,1,1,1,1,1,,,,,,,,,1,1],[,,,,,,,,1,,,,1,,1,,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,1,,1,,1,,,,1,1,,1,,1,,,,1,1,1,1,1,,,1],,[,1,,,,,,,,1,,,1,1,,,1,,1,1,,1,,1],[,1,,,1,,,,,,,,1,,,,,,,1],[1,1,,,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1],,[,1,,,,,,1,,1,,1,1,1,1,1,,,1,,1,1,,,,1],[,1,1,,,1,,1,,1,,,1,1,1,1,,,1,,,1,,,,1],[,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1],[,1,,,1,1,,1,1,,,1,1,,1,1,,1,,1,,1],[1,,1,,,,,1,,1,,1,1,1,1,,,,,1,1,,,,1,1],[,1,1,,,,,1,1,,,1,,1,1,1,1,,,,,,,,,,1],,[,1,1,,,1,,,,1,,1,1,1,1,1,,,,1,,,,1,,1],[,,,1,1,,,1,,,,,1,,1,1,1,,1,1,,,,,,1],[,1,,,,,,,,,,,1,,,,1,,,,,,,1,,1],[,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,1,,,,,1,,1,,,1,1,,1,1,,1],[,1,,,,,,1,,,,,1,1,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1,,,1,,,,,1],[,,,,,,,1,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,,1,,,,,,,1,,,,,,,,1,,,1],[,1,,,,,,,1],[,,,,,,,,,,1],[,1,,,,,,1,1,,,,,,1],,[,1,1,,,,,,1,,,,,1,1,,,,1],[1,,1,,1,,,,,1,,,,,1,,,,,,,,,1,1],[,1,1,,,,,,,,,1,1,1,1,,,,1,,,,,1,,,1],,[,1,1,,1,,,1,1,,,1,,,1,1,1,,1,,1,1,1,,,,1],[,,,,,1,,,,,1,,,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,,,1,,,,,1,,,,,1,,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,1],[,1,,,,,,1,,,,,,,1,1,1,,,1],[,1,,,,,,,,,,1,1,1,,,,,1,,,1],[,,,,,1,,1,,,,,1,1,1,,1,1,,1,1,1,,,1,1],[1,1,,,,,,,1,,,,,1,1,,,,,,,,,,,1],,[,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,,1,,,,,1,,,1,,,,1,,1],[,1,,,,,,,,,1]]];function Cp(e){e=Array.isArray(e)?e:Ep;var t=[];return e.forEach((function(e,n){var a=String.fromCharCode(n+96).replace("\`","");Array.isArray(e)?t=t.concat(Cp(e).map((function(e){return a+e}))):t.push(a)})),t}var xp,Ap=function(e){for(var t=Ep;e.length<3;)e+="\`";for(var n=0;n<=e.length-1;n++)if(!(t=t[e.charCodeAt(n)-96]))return!1;return!0};k(kp,an),xp=B(kp),K(kp,[{key:"props",get:function(){return this._props}},{key:"attr",value:function(e){return null!=(e=this._attrs[e])?e:null}},{key:"hasAttr",value:function(e){return void 0!==this._attrs[e]}},{key:"attrNames",get:function(){return Object.keys(this._attrs)}}]),ds=kp;function kp(e){var t,n,a;return W(this,kp),(t=xp.call(this))._props=function(e){var t=null!=(t=e.nodeName)?t:Tp[e.nodeType],n=null!=(n=null!=(n=e.nodeType)?n:Bp[e.nodeName])?n:1,a=(bn("number"==typeof n,"nodeType has to be a number, got '".concat(n,"'")),bn("string"==typeof t,"nodeName has to be a string, got '".concat(t,"'")),t=t.toLowerCase(),null);return"input"===t&&(a=(e.type||e.attributes&&e.attributes.type||"").toLowerCase(),wp().includes(a)||(a="text")),e=$({},e,{nodeType:n,nodeName:t}),a&&(e.type=a),delete e.attributes,Object.freeze(e)}(e),t._attrs=(e=e.attributes,n=void 0===e?{}:e,a={htmlFor:"for",className:"class"},Object.keys(n).reduce((function(e,t){var o=n[t];return bn("object"!==r(o)||null===o,"expects attributes not to be an object, '".concat(t,"' was")),void 0!==o&&(e[a[t]||t]=null!==o?String(o):null),e}),{})),t}var Np,Bp={"#cdata-section":2,"#text":3,"#comment":8,"#document":9,"#document-fragment":11},Tp={},Rp=(Object.keys(Bp).forEach((function(e){Tp[Bp[e]]=e})),ds),_p=function(e,t){if(e=e||function(){},t=t||o.log,!o._audit)throw new Error("No audit configured");var n=o.utils.queue(),r=[],i=(Object.keys(o.plugins).forEach((function(e){n.defer((function(t){function n(e){r.push(e),t()}try{o.plugins[e].cleanup(t,n)}catch(e){n(e)}}))})),o.utils.getFlattenedTree(a.body));o.utils.querySelectorAll(i,"iframe, frame").forEach((function(e){n.defer((function(t,n){return o.utils.sendCommandToFrame(e.actualNode,{command:"cleanup-plugin"},t,n)}))})),n.then((function(n){0===r.length?e(n):t(r)})).catch(t)},Sp={};function Op(e){return Sp.hasOwnProperty(e)}function Mp(e){return"string"==typeof e&&Sp[e]?Sp[e]:"function"==typeof e?e:Np}var Pp={},Ip=(te(Pp,{allowedAttr:function(){return Ip},arialabelText:function(){return $o},arialabelledbyText:function(){return Vo},getAccessibleRefs:function(){return jp},getElementUnallowedRoles:function(){return $p},getExplicitRole:function(){return Qo},getImplicitRole:function(){return Ai},getOwnedVirtual:function(){return Si},getRole:function(){return Bi},getRoleType:function(){return Su},getRolesByType:function(){return Up},getRolesWithNameFromContents:function(){return Kp},implicitNodes:function(){return Zp},implicitRole:function(){return Ai},isAccessibleRef:function(){return Jp},isAriaRoleAllowedOnElement:function(){return qp},isComboboxPopup:function(){return Qp},isUnsupportedRole:function(){return Zo},isValidRole:function(){return Jo},label:function(){return tf},labelVirtual:function(){return fu},lookupTable:function(){return Xp},namedFromContents:function(){return _i},requiredAttr:function(){return nf},requiredContext:function(){return af},requiredOwned:function(){return rf},validateAttr:function(){return uf},validateAttrValue:function(){return of}}),function(e){e=Xo.ariaRoles[e];var t=z(ti());return e&&(e.allowedAttrs&&t.push.apply(t,z(e.allowedAttrs)),e.requiredAttrs)&&t.push.apply(t,z(e.requiredAttrs)),t}),Lp=/^idrefs?$/,jp=function(e){e=e.actualNode||e;var t=(t=pr(e)).documentElement||t,n=Yn.get("idRefsByRoot",(function(){return new Map})),a=n.get(t);return a||(a=new Map,n.set(t,a),function e(t,n,a){if(t.hasAttribute){var r;"LABEL"===t.nodeName.toUpperCase()&&t.hasAttribute("for")&&(r=t.getAttribute("for"),n.has(r)?n.get(r).push(t):n.set(r,[t]));for(var o=0;o<a.length;++o){var i=a[o];if(i=li(t.getAttribute(i)||"")){var u,l=Z(Xc(i));try{for(l.s();!(u=l.n()).done;){var s=u.value;n.has(s)?n.get(s).push(t):n.set(s,[t])}}catch(e){l.e(e)}finally{l.f()}}}}for(var c=0;c<t.childNodes.length;c++)1===t.childNodes[c].nodeType&&e(t.childNodes[c],n,a)}(t,a,Object.keys(Xo.ariaAttrs).filter((function(e){return e=Xo.ariaAttrs[e].type,Lp.test(e)})))),null!=(n=a.get(e.id))?n:[]},qp=function(e,t){e=e instanceof an?e:Kn(e);var n=Ai(e);e=xi(e);return Array.isArray(e.allowedRoles)?e.allowedRoles.includes(t):t!==n&&!!e.allowedRoles},zp=["doc-backlink","doc-biblioentry","doc-biblioref","doc-cover","doc-endnote","doc-glossref","doc-noteref"],Vp={header:"banner",footer:"contentinfo"},$p=function(e){var t,n,a,r=!(1<arguments.length&&void 0!==arguments[1])||arguments[1],o=$d(e).vNode;return Ld(o)?(a=o.props.nodeName,t=Ai(o)||Vp[a],a=[],((n=o)?(n.hasAttr("role")&&(n=Xc(n.attr("role").toLowerCase()),a=a.concat(n)),a.filter((function(e){return Jo(e)}))):a).filter((function(e){var n=o,a=t;return!(r&&e===a||(!zp.includes(e)||Su(e)===a)&&qp(n,e))}))):[]},Hp=function(e){return Object.keys(Xo.ariaRoles).filter((function(t){return Xo.ariaRoles[t].type===e}))},Up=function(e){return Hp(e)},Gp=function(){return Yn.get("ariaRolesNameFromContent",(function(){return Object.keys(Xo.ariaRoles).filter((function(e){return Xo.ariaRoles[e].nameFromContent}))}))};function Wp(e){return null===e}function Yp(e){return null!==e}var Kp=function(){return Gp()},Xp=((Vl={attributes:{"aria-activedescendant":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-atomic":{type:"boolean",values:["true","false"],unsupported:!1},"aria-autocomplete":{type:"nmtoken",values:["inline","list","both","none"],unsupported:!1},"aria-busy":{type:"boolean",values:["true","false"],unsupported:!1},"aria-checked":{type:"nmtoken",values:["true","false","mixed","undefined"],unsupported:!1},"aria-colcount":{type:"int",unsupported:!1},"aria-colindex":{type:"int",unsupported:!1},"aria-colspan":{type:"int",unsupported:!1},"aria-controls":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-current":{type:"nmtoken",allowEmpty:!0,values:["page","step","location","date","time","true","false"],unsupported:!1},"aria-describedby":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-describedat":{unsupported:!0,unstandardized:!0},"aria-details":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-disabled":{type:"boolean",values:["true","false"],unsupported:!1},"aria-dropeffect":{type:"nmtokens",values:["copy","move","reference","execute","popup","none"],unsupported:!1},"aria-errormessage":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-expanded":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-flowto":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-grabbed":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-haspopup":{type:"nmtoken",allowEmpty:!0,values:["true","false","menu","listbox","tree","grid","dialog"],unsupported:!1},"aria-hidden":{type:"boolean",values:["true","false"],unsupported:!1},"aria-invalid":{type:"nmtoken",allowEmpty:!0,values:["true","false","spelling","grammar"],unsupported:!1},"aria-keyshortcuts":{type:"string",allowEmpty:!0,unsupported:!1},"aria-label":{type:"string",allowEmpty:!0,unsupported:!1},"aria-labelledby":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-level":{type:"int",unsupported:!1},"aria-live":{type:"nmtoken",values:["off","polite","assertive"],unsupported:!1},"aria-modal":{type:"boolean",values:["true","false"],unsupported:!1},"aria-multiline":{type:"boolean",values:["true","false"],unsupported:!1},"aria-multiselectable":{type:"boolean",values:["true","false"],unsupported:!1},"aria-orientation":{type:"nmtoken",values:["horizontal","vertical"],unsupported:!1},"aria-owns":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-placeholder":{type:"string",allowEmpty:!0,unsupported:!1},"aria-posinset":{type:"int",unsupported:!1},"aria-pressed":{type:"nmtoken",values:["true","false","mixed","undefined"],unsupported:!1},"aria-readonly":{type:"boolean",values:["true","false"],unsupported:!1},"aria-relevant":{type:"nmtokens",values:["additions","removals","text","all"],unsupported:!1},"aria-required":{type:"boolean",values:["true","false"],unsupported:!1},"aria-roledescription":{type:"string",allowEmpty:!0,unsupported:!1},"aria-rowcount":{type:"int",unsupported:!1},"aria-rowindex":{type:"int",unsupported:!1},"aria-rowspan":{type:"int",unsupported:!1},"aria-selected":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-setsize":{type:"int",unsupported:!1},"aria-sort":{type:"nmtoken",values:["ascending","descending","other","none"],unsupported:!1},"aria-valuemax":{type:"decimal",unsupported:!1},"aria-valuemin":{type:"decimal",unsupported:!1},"aria-valuenow":{type:"decimal",unsupported:!1},"aria-valuetext":{type:"string",unsupported:!1}},globalAttributes:["aria-atomic","aria-busy","aria-controls","aria-current","aria-describedby","aria-details","aria-disabled","aria-dropeffect","aria-flowto","aria-grabbed","aria-haspopup","aria-hidden","aria-invalid","aria-keyshortcuts","aria-label","aria-labelledby","aria-live","aria-owns","aria-relevant","aria-roledescription"]}).role={alert:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},alertdialog:{type:"widget",attributes:{allowed:["aria-expanded","aria-modal","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["dialog","section"]},application:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage","aria-activedescendant"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["article","audio","embed","iframe","object","section","svg","video"]},article:{type:"structure",attributes:{allowed:["aria-expanded","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["article"],unsupported:!1},banner:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["header"],unsupported:!1,allowedElements:["section"]},button:{type:"widget",attributes:{allowed:["aria-expanded","aria-pressed","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["button",'input[type="button"]','input[type="image"]','input[type="reset"]','input[type="submit"]',"summary"],unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Yp}}]},cell:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-rowindex","aria-rowspan","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["td","th"],unsupported:!1},checkbox:{type:"widget",attributes:{allowed:["aria-checked","aria-required","aria-readonly","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:['input[type="checkbox"]'],unsupported:!1,allowedElements:["button"]},columnheader:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-required","aria-readonly","aria-selected","aria-sort","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["th"],unsupported:!1},combobox:{type:"composite",attributes:{allowed:["aria-autocomplete","aria-required","aria-activedescendant","aria-orientation","aria-errormessage"],required:["aria-expanded"]},owned:{all:["listbox","tree","grid","dialog","textbox"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:"input",properties:{type:["text","search","tel","url","email"]}}]},command:{nameFrom:["author"],type:"abstract",unsupported:!1},complementary:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["aside"],unsupported:!1,allowedElements:["section"]},composite:{nameFrom:["author"],type:"abstract",unsupported:!1},contentinfo:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["footer"],unsupported:!1,allowedElements:["section"]},definition:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["dd","dfn"],unsupported:!1},dialog:{type:"widget",attributes:{allowed:["aria-expanded","aria-modal","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["dialog"],unsupported:!1,allowedElements:["section"]},directory:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:["ol","ul"]},document:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["body"],unsupported:!1,allowedElements:["article","embed","iframe","object","section","svg"]},"doc-abstract":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-acknowledgments":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-afterword":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-appendix":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-backlink":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Yp}}]},"doc-biblioentry":{type:"listitem",attributes:{allowed:["aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author"],context:["doc-bibliography"],unsupported:!1,allowedElements:["li"]},"doc-bibliography":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["doc-biblioentry"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-biblioref":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Yp}}]},"doc-chapter":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-colophon":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-conclusion":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-cover":{type:"img",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1},"doc-credit":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-credits":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-dedication":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-endnote":{type:"listitem",attributes:{allowed:["aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,namefrom:["author"],context:["doc-endnotes"],unsupported:!1,allowedElements:["li"]},"doc-endnotes":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["doc-endnote"]},namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-epigraph":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1},"doc-epilogue":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-errata":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-example":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","section"]},"doc-footnote":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","footer","header"]},"doc-foreword":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-glossary":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:["term","definition"],namefrom:["author"],context:null,unsupported:!1,allowedElements:["dl"]},"doc-glossref":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Yp}}]},"doc-index":{type:"navigation",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},"doc-introduction":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-noteref":{type:"link",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Yp}}]},"doc-notice":{type:"note",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-pagebreak":{type:"separator",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["hr"]},"doc-pagelist":{type:"navigation",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},"doc-part":{type:"landmark",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-preface":{type:"landmark",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-prologue":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-pullquote":{type:"none",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","section"]},"doc-qna":{type:"section",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-subtitle":{type:"sectionhead",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["h1","h2","h3","h4","h5","h6"]}},"doc-tip":{type:"note",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside"]},"doc-toc":{type:"navigation",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},feed:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["article"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["article","aside","section"]},figure:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["figure"],unsupported:!1},form:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["form"],unsupported:!1},grid:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-colcount","aria-level","aria-multiselectable","aria-readonly","aria-rowcount","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author"],context:null,implicit:["table"],unsupported:!1},gridcell:{type:"widget",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-selected","aria-readonly","aria-required","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["td","th"],unsupported:!1},group:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["details","optgroup"],unsupported:!1,allowedElements:["dl","figcaption","fieldset","figure","footer","header","ol","ul"]},heading:{type:"structure",attributes:{required:["aria-level"],allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["h1","h2","h3","h4","h5","h6"],unsupported:!1},img:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["img"],unsupported:!1,allowedElements:["embed","iframe","object","svg"]},input:{nameFrom:["author"],type:"abstract",unsupported:!1},landmark:{nameFrom:["author"],type:"abstract",unsupported:!1},link:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["a[href]","area[href]"],unsupported:!1,allowedElements:["button",{nodeName:"input",properties:{type:["image","button"]}}]},list:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{all:["listitem"]},nameFrom:["author"],context:null,implicit:["ol","ul","dl"],unsupported:!1},listbox:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-multiselectable","aria-readonly","aria-required","aria-expanded","aria-orientation","aria-errormessage"]},owned:{all:["option"]},nameFrom:["author"],context:null,implicit:["select"],unsupported:!1,allowedElements:["ol","ul"]},listitem:{type:"structure",attributes:{allowed:["aria-level","aria-posinset","aria-setsize","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["list"],implicit:["li","dt"],unsupported:!1},log:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},main:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["main"],unsupported:!1,allowedElements:["article","section"]},marquee:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},math:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["math"],unsupported:!1},menu:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:{one:["menuitem","menuitemradio","menuitemcheckbox"]},nameFrom:["author"],context:null,implicit:['menu[type="context"]'],unsupported:!1,allowedElements:["ol","ul"]},menubar:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:{one:["menuitem","menuitemradio","menuitemcheckbox"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},menuitem:{type:"widget",attributes:{allowed:["aria-posinset","aria-setsize","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:['menuitem[type="command"]'],unsupported:!1,allowedElements:["button","li",{nodeName:"iput",properties:{type:["image","button"]}},{nodeName:"a",attributes:{href:Yp}}]},menuitemcheckbox:{type:"widget",attributes:{allowed:["aria-checked","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:['menuitem[type="checkbox"]'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["checkbox","image","button"]}},{nodeName:"a",attributes:{href:Yp}}]},menuitemradio:{type:"widget",attributes:{allowed:["aria-checked","aria-selected","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:['menuitem[type="radio"]'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["image","button","radio"]}},{nodeName:"a",attributes:{href:Yp}}]},navigation:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["nav"],unsupported:!1,allowedElements:["section"]},none:{type:"structure",attributes:null,owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:["article","aside","dl","embed","figcaption","fieldset","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hr","iframe","li","ol","section","ul"]},{nodeName:"img",attributes:{alt:Yp}}]},note:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["aside"]},option:{type:"widget",attributes:{allowed:["aria-selected","aria-posinset","aria-setsize","aria-checked","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["listbox"],implicit:["option"],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["checkbox","button"]}},{nodeName:"a",attributes:{href:Yp}}]},presentation:{type:"structure",attributes:null,owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:["article","aside","dl","embed","figcaption","fieldset","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hr","iframe","li","ol","section","ul"]},{nodeName:"img",attributes:{alt:Yp}}]},progressbar:{type:"widget",attributes:{allowed:["aria-valuetext","aria-valuenow","aria-valuemax","aria-valuemin","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["progress"],unsupported:!1},radio:{type:"widget",attributes:{allowed:["aria-selected","aria-posinset","aria-setsize","aria-required","aria-errormessage","aria-checked"]},owned:null,nameFrom:["author","contents"],context:null,implicit:['input[type="radio"]'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["image","button"]}}]},radiogroup:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-required","aria-expanded","aria-readonly","aria-errormessage","aria-orientation"]},owned:{all:["radio"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["ol","ul","fieldset"]}},range:{nameFrom:["author"],type:"abstract",unsupported:!1},region:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["section[aria-label]","section[aria-labelledby]","section[title]"],unsupported:!1,allowedElements:{nodeName:["article","aside"]}},roletype:{type:"abstract",unsupported:!1},row:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-colindex","aria-expanded","aria-level","aria-selected","aria-rowindex","aria-errormessage"]},owned:{one:["cell","columnheader","rowheader","gridcell"]},nameFrom:["author","contents"],context:["rowgroup","grid","treegrid","table"],implicit:["tr"],unsupported:!1},rowgroup:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-errormessage"]},owned:{all:["row"]},nameFrom:["author","contents"],context:["grid","table","treegrid"],implicit:["tbody","thead","tfoot"],unsupported:!1},rowheader:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-required","aria-readonly","aria-selected","aria-sort","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["th"],unsupported:!1},scrollbar:{type:"widget",attributes:{required:["aria-controls","aria-valuenow"],allowed:["aria-valuetext","aria-orientation","aria-errormessage","aria-valuemax","aria-valuemin"]},owned:null,nameFrom:["author"],context:null,unsupported:!1},search:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["aside","form","section"]}},searchbox:{type:"widget",attributes:{allowed:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-readonly","aria-required","aria-placeholder","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:['input[type="search"]'],unsupported:!1,allowedElements:{nodeName:"input",properties:{type:"text"}}},section:{nameFrom:["author","contents"],type:"abstract",unsupported:!1},sectionhead:{nameFrom:["author","contents"],type:"abstract",unsupported:!1},select:{nameFrom:["author"],type:"abstract",unsupported:!1},separator:{type:"structure",attributes:{allowed:["aria-expanded","aria-orientation","aria-valuenow","aria-valuemax","aria-valuemin","aria-valuetext","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["hr"],unsupported:!1,allowedElements:["li"]},slider:{type:"widget",attributes:{allowed:["aria-valuetext","aria-orientation","aria-readonly","aria-errormessage","aria-valuemax","aria-valuemin"],required:["aria-valuenow"]},owned:null,nameFrom:["author"],context:null,implicit:['input[type="range"]'],unsupported:!1},spinbutton:{type:"widget",attributes:{allowed:["aria-valuetext","aria-required","aria-readonly","aria-errormessage","aria-valuemax","aria-valuemin"],required:["aria-valuenow"]},owned:null,nameFrom:["author"],context:null,implicit:['input[type="number"]'],unsupported:!1,allowedElements:{nodeName:"input",properties:{type:["text","tel"]}}},status:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["output"],unsupported:!1,allowedElements:["section"]},structure:{type:"abstract",unsupported:!1},switch:{type:"widget",attributes:{allowed:["aria-errormessage"],required:["aria-checked"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:["button",{nodeName:"input",properties:{type:["checkbox","image","button"]}},{nodeName:"a",attributes:{href:Yp}}]},tab:{type:"widget",attributes:{allowed:["aria-selected","aria-expanded","aria-setsize","aria-posinset","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["tablist"],unsupported:!1,allowedElements:[{nodeName:["button","h1","h2","h3","h4","h5","h6","li"]},{nodeName:"input",properties:{type:"button"}},{nodeName:"a",attributes:{href:Yp}}]},table:{type:"structure",attributes:{allowed:["aria-colcount","aria-rowcount","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author","contents"],context:null,implicit:["table"],unsupported:!1},tablist:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-level","aria-multiselectable","aria-orientation","aria-errormessage"]},owned:{all:["tab"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},tabpanel:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},term:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["dt"],unsupported:!1},textbox:{type:"widget",attributes:{allowed:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-readonly","aria-required","aria-placeholder","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:['input[type="text"]','input[type="email"]','input[type="password"]','input[type="tel"]','input[type="url"]',"input:not([type])","textarea"],unsupported:!1},timer:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1},toolbar:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:['menu[type="toolbar"]'],unsupported:!1,allowedElements:["ol","ul"]},tooltip:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1},tree:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-multiselectable","aria-required","aria-expanded","aria-orientation","aria-errormessage"]},owned:{all:["treeitem"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},treegrid:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-colcount","aria-expanded","aria-level","aria-multiselectable","aria-readonly","aria-required","aria-rowcount","aria-orientation","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author"],context:null,unsupported:!1},treeitem:{type:"widget",attributes:{allowed:["aria-checked","aria-selected","aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["group","tree"],unsupported:!1,allowedElements:["li",{nodeName:"a",attributes:{href:Yp}}]},widget:{type:"abstract",unsupported:!1},window:{nameFrom:["author"],type:"abstract",unsupported:!1}},Vl.implicitHtmlRole=ci,Vl.elementsAllowedNoRole=[{nodeName:["base","body","caption","col","colgroup","datalist","dd","details","dt","head","html","keygen","label","legend","main","map","math","meta","meter","noscript","optgroup","param","picture","progress","script","source","style","template","textarea","title","track"]},{nodeName:"area",attributes:{href:Yp}},{nodeName:"input",properties:{type:["color","data","datatime","file","hidden","month","number","password","range","reset","submit","time","week"]}},{nodeName:"link",attributes:{href:Yp}},{nodeName:"menu",attributes:{type:"context"}},{nodeName:"menuitem",attributes:{type:["command","checkbox","radio"]}},{nodeName:"select",condition:function(e){return e instanceof o.AbstractVirtualNode||(e=o.utils.getNodeFromTree(e)),1<Number(e.attr("size"))},properties:{multiple:!0}},{nodeName:["clippath","cursor","defs","desc","feblend","fecolormatrix","fecomponenttransfer","fecomposite","feconvolvematrix","fediffuselighting","fedisplacementmap","fedistantlight","fedropshadow","feflood","fefunca","fefuncb","fefuncg","fefuncr","fegaussianblur","feimage","femerge","femergenode","femorphology","feoffset","fepointlight","fespecularlighting","fespotlight","fetile","feturbulence","filter","hatch","hatchpath","lineargradient","marker","mask","meshgradient","meshpatch","meshrow","metadata","mpath","pattern","radialgradient","solidcolor","stop","switch","view"]}],Vl.elementsAllowedAnyRole=[{nodeName:"a",attributes:{href:Wp}},{nodeName:"img",attributes:{alt:Wp}},{nodeName:["abbr","address","canvas","div","p","pre","blockquote","ins","del","output","span","table","tbody","thead","tfoot","td","em","strong","small","s","cite","q","dfn","abbr","time","code","var","samp","kbd","sub","sup","i","b","u","mark","ruby","rt","rp","bdi","bdo","br","wbr","th","tr"]}],Vl.evaluateRoleForElement={A:function(e){var t=e.node;e=e.out;return"http://www.w3.org/2000/svg"===t.namespaceURI||!t.href.length||e},AREA:function(e){return!e.node.href},BUTTON:function(e){var t=e.node,n=e.role;e=e.out;return"menu"===t.getAttribute("type")?"menuitem"===n:e},IMG:function(e){var t=e.node,n=e.role,a=e.out;switch(t.alt){case null:return a;case"":return"presentation"===n||"none"===n;default:return"presentation"!==n&&"none"!==n}},INPUT:function(e){var t=e.node,n=e.role,a=e.out;switch(t.type){case"button":case"image":return a;case"checkbox":return!("button"!==n||!t.hasAttribute("aria-pressed"))||a;case"radio":return"menuitemradio"===n;case"text":return"combobox"===n||"searchbox"===n||"spinbutton"===n;case"tel":return"combobox"===n||"spinbutton"===n;case"url":case"search":case"email":return"combobox"===n;default:return!1}},LI:function(e){var t=e.node;e=e.out;return!o.utils.matchesSelector(t,"ol li, ul li")||e},MENU:function(e){return"context"!==e.node.getAttribute("type")},OPTION:function(e){return e=e.node,!o.utils.matchesSelector(e,"select > option, datalist > option, optgroup > option")},SELECT:function(e){var t=e.node;e=e.role;return!t.multiple&&t.size<=1&&"menu"===e},SVG:function(e){var t=e.node;e=e.out;return!(!t.parentNode||"http://www.w3.org/2000/svg"!==t.parentNode.namespaceURI)||e}},Vl.rolesOfType={widget:["button","checkbox","dialog","gridcell","link","log","marquee","menuitem","menuitemcheckbox","menuitemradio","option","progressbar","radio","scrollbar","searchbox","slider","spinbutton","status","switch","tab","tabpanel","textbox","timer","tooltip","tree","treeitem"]},Vl),Zp=function(e){var t=null;return(e=Xp.role[e])&&e.implicit?ea(e.implicit):t},Jp=function(e){return!!jp(e).length};function Qp(e){var t=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).popupRoles,n=Bi(e);if(!(t=null!=t?t:Ho["aria-haspopup"].values).includes(n))return!1;if(t=function(e){for(;e=e.parent;)if(null!==Bi(e,{noPresentational:!0}))return e;return null}(e),ef(t))return!0;if(!(n=e.props.id))return!1;if(e.actualNode)return t=dr(e.actualNode).querySelectorAll('[aria-owns~="'.concat(n,'"][role~="combobox"]:not(select),\\n     [aria-controls~="').concat(n,'"][role~="combobox"]:not(select)')),Array.from(t).some(ef);throw new Error("Unable to determine combobox popup without an actualNode")}var ef=function(e){return e&&"combobox"===Bi(e)},tf=function(e){return e=Kn(e),fu(e)},nf=function(e){return(e=Xo.ariaRoles[e])&&Array.isArray(e.requiredAttrs)?z(e.requiredAttrs):[]},af=function(e){return(e=Xo.ariaRoles[e])&&Array.isArray(e.requiredContext)?z(e.requiredContext):null},rf=function(e){return(e=Xo.ariaRoles[e])&&Array.isArray(e.requiredOwned)?z(e.requiredOwned):null},of=function(e,t){var n,a=(e=e instanceof an?e:Kn(e)).attr(t),r=Xo.ariaAttrs[t];if(!r)return!0;if(r.allowEmpty&&(!a||""===a.trim()))return!0;switch(r.type){case"boolean":return["true","false"].includes(a.toLowerCase());case"nmtoken":return"string"==typeof a&&r.values.includes(a.toLowerCase());case"nmtokens":return(n=Xc(a)).reduce((function(e,t){return e&&r.values.includes(t)}),0!==n.length);case"idref":try{var o=pr(e.actualNode);return!(!a||!o.getElementById(a))}catch(e){throw new TypeError("Cannot resolve id references for partial DOM")}case"idrefs":return qo(e,t).some((function(e){return!!e}));case"string":return""!==a.trim();case"decimal":return!(!(n=a.match(/^[-+]?([0-9]*)\\.?([0-9]*)$/))||!n[1]&&!n[2]);case"int":return o=void 0!==r.minValue?r.minValue:-1/0,/^[-+]?[0-9]+$/.test(a)&&parseInt(a)>=o}},uf=function(e){return!!Xo.ariaAttrs[e]};function lf(e,t,n){var a=(r=n.props).nodeName,r=r.type,o=function(e){return e?(e=e.toLowerCase(),["mixed","true"].includes(e)?e:"false"):""}(n.attr("aria-checked"));return"input"!==a||"checkbox"!==r||!o||o===(a=function(e){return e.props.indeterminate?"mixed":e.props.checked?"true":"false"}(n))||(this.data({messageKey:"checkbox",checkState:a}),!1)}function sf(e){var t,n,a=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).invalidTableRowAttrs,r=2<arguments.length?arguments[2]:void 0;a=null!=(t=null==a||null==(t=a.filter)?void 0:t.call(a,(function(e){return r.hasAttr(e)})))?t:[];return 0===a.length||!(t=(t=function(e){if(e.parent)return ca(e,'table:not([role]), [role~="treegrid"], [role~="table"], [role~="grid"]')}(r))&&Bi(t))||"treegrid"===t||(n="row".concat(1<a.length?"Plural":"Singular"),this.data({messageKey:n,invalidAttrs:a,ownerRole:t}),!1)}var cf={row:sf,checkbox:lf};var df={};function pf(e){return 3===(e=e.vNode).props.nodeType?0<e.props.nodeValue.trim().length:xu(e,!1,!0)}function ff(e,t,n,a){var r=Qo(e);if(!(n=n||af(r)))return null;for(var o=n.includes("group"),i=a?e:e.parent;i;){var u=Bi(i,{noPresentational:!0});if(u){if("group"!==u||!o)return n.includes(u)?null:n;t.includes(r)&&n.push(r),n=n.filter((function(e){return"group"!==e}))}i=i.parent}return n}te(df,{getAriaRolesByType:function(){return Hp},getAriaRolesSupportingNameFromContent:function(){return Gp},getElementSpec:function(){return xi},getElementsByContentType:function(){return ei},getGlobalAriaAttrs:function(){return ti},implicitHtmlRoles:function(){return ci}});var mf={ARTICLE:!0,ASIDE:!0,NAV:!0,SECTION:!0},Df={application:!0,article:!0,banner:!1,complementary:!0,contentinfo:!0,form:!0,main:!0,navigation:!0,region:!0,search:!1};var hf={},gf=(te(hf,{Color:function(){return Tc},centerPointOfRect:function(){return gf},elementHasImage:function(){return Vu},elementIsDistinct:function(){return vf},filteredRectStack:function(){return Ff},flattenColors:function(){return Cf},flattenShadowColors:function(){return xf},getBackgroundColor:function(){return qf},getBackgroundStack:function(){return Af},getContrast:function(){return $f},getForegroundColor:function(){return Hf},getOwnBackgroundColor:function(){return _c},getRectStack:function(){return yf},getStackingContext:function(){return Mf},getStrokeColorsFromShadows:function(){return Rf},getTextShadowColors:function(){return Of},hasValidContrastRatio:function(){return Uf},incompleteData:function(){return zu},parseTextShadows:function(){return Sf},stackingContextToColor:function(){return Pf}}),function(e){if(!(e.left>t.innerWidth||e.top>t.innerHeight))return{x:Math.min(Math.ceil(e.left+e.width/2),t.innerWidth-1),y:Math.min(Math.ceil(e.top+e.height/2),t.innerHeight-1)}});function bf(e){return e.getPropertyValue("font-family").split(/[,;]/g).map((function(e){return e.trim().toLowerCase()}))}var vf=function(e,n){var a,r=t.getComputedStyle(e);return"none"!==r.getPropertyValue("background-image")||!!["border-bottom","border-top","outline"].reduce((function(e,t){var n=new Tc;return n.parseString(r.getPropertyValue(t+"-color")),e||"none"!==r.getPropertyValue(t+"-style")&&0<parseFloat(r.getPropertyValue(t+"-width"))&&0!==n.alpha}),!1)||(a=t.getComputedStyle(n),bf(r)[0]!==bf(a)[0])||(e=["text-decoration-line","text-decoration-style","font-weight","font-style","font-size"].reduce((function(e,t){return e||r.getPropertyValue(t)!==a.getPropertyValue(t)}),!1),(n=r.getPropertyValue("text-decoration")).split(" ").length<3?e||n!==a.getPropertyValue("text-decoration"):e)},yf=function(e){var t=_o(e);return!(e=yu(e))||e.length<=1?[t]:e.some((function(e){return void 0===e}))?null:(e.splice(0,0,t),e)},Ff=function(e){var t,n,a=yf(e);return a&&1===a.length?a[0]:a&&1<a.length?(t=a.shift(),a.forEach((function(r,o){var i,u;0!==o&&(i=a[o-1],u=a[o],n=i.every((function(e,t){return e===u[t]}))||t.includes(e))})),n?a[0]:(zu.set("bgColor","elmPartiallyObscuring"),null)):(zu.set("bgColor","outsideViewport"),null)},wf={normal:function(e,t){return t},multiply:function(e,t){return t*e},screen:function(e,t){return e+t-e*t},overlay:function(e,t){return this["hard-light"](t,e)},darken:function(e,t){return Math.min(e,t)},lighten:function(e,t){return Math.max(e,t)},"color-dodge":function(e,t){return 0===e?0:1===t?1:Math.min(1,e/(1-t))},"color-burn":function(e,t){return 1===e?1:0===t?0:1-Math.min(1,(1-e)/t)},"hard-light":function(e,t){return t<=.5?this.multiply(e,2*t):this.screen(e,2*t-1)},"soft-light":function(e,t){return t<=.5?e-(1-2*t)*e*(1-e):e+(2*t-1)*((e<=.25?((16*e-12)*e+4)*e:Math.sqrt(e))-e)},difference:function(e,t){return Math.abs(e-t)},exclusion:function(e,t){return e+t-2*e*t}};function Ef(e,t,n,a,r){return t*(1-a)*e+t*a*wf[r](n/255,e/255)*255+(1-t)*a*n}var Cf=function(e,t){var n,a,r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:"normal",o=Ef(e.red,e.alpha,t.red,t.alpha,r),i=Ef(e.green,e.alpha,t.green,t.alpha,r),u=(r=Ef(e.blue,e.alpha,t.blue,t.alpha,r),n=e.alpha+t.alpha*(1-e.alpha),u=0,a=1,Math.min(Math.max(u,n),a));return 0===u?new Tc(o,i,r,u):(n=Math.round(o/u),a=Math.round(i/u),o=Math.round(r/u),new Tc(n,a,o,u))};function xf(e,t){var n=(1-(r=e.alpha))*t.red+r*e.red,a=(1-r)*t.green+r*e.green,r=(1-r)*t.blue+r*e.blue;t=e.alpha+t.alpha*(1-e.alpha);return new Tc(n,a,r,t)}function Af(e){for(var n=yu(e).map((function(n){return function(e){var n=e.indexOf(a.body),r=_c(t.getComputedStyle(a.documentElement));return 1<n&&0===r.alpha&&!Vu(a.documentElement)&&(1<n&&(e.splice(n,1),e.push(a.body)),0<(r=e.indexOf(a.documentElement)))&&(e.splice(r,1),e.push(a.documentElement)),e}(n=jc(n,e))})),r=0;r<n.length;r++){var o=n[r];if(o[0]!==e)return zu.set("bgColor","bgOverlap"),null;if(0!==r&&!function(e,t){if(e!==t){if(null===e||null===t)return;if(e.length!==t.length)return;for(var n=0;n<e.length;++n)if(e[n]!==t[n])return}return 1}(o,n[0]))return zu.set("bgColor","elmPartiallyObscuring"),null}return n[0]||null}var kf=.54,Nf=.5,Bf=1.5,Tf=["top","right","bottom","left"];function Rf(e){var t=void 0!==(t=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).ignoreEdgeCount)&&t,n=function(e){var t,n={},a=Z(e);try{for(a.s();!(t=a.n()).done;){var r=t.value,o=r.colorStr,i=r.pixels,u=(null!=n[o]||(n[o]={top:[],right:[],bottom:[],left:[]}),n[o]),l=H(i,2),s=l[0],c=l[1];Nf<s?u.right.push(s):Nf<-s&&u.left.push(-s),Nf<c?u.bottom.push(c):Nf<-c&&u.top.push(-c)}}catch(e){a.e(e)}finally{a.f()}return n}(e);n=Object.entries(n).map((function(e){var t=(e=H(e,2))[0],n=e[1];e=Tf.filter((function(e){return 0!==n[e].length})).length;return{colorStr:t,sides:n,edgeCount:e}}));return!t&&n.some((function(e){return 1<(e=e.edgeCount)&&e<4}))?null:n.map(_f).filter((function(e){return null!==e}))}function _f(e){var t,n,a=e.colorStr,r=e.sides;return 4!==e.edgeCount?null:((e=new Tc).parseString(a),n=!(t=0),Tf.forEach((function(e){t+=r[e].length/4,n=n&&r[e].every((function(e){return Bf<e}))})),n||(e.alpha=1-Math.pow(kf,t)),e)}function Sf(e){var t={pixels:[]},n=[t];if(!(o=e.trim()))return[];for(;o;){var a=o.match(/^[a-z]+(\\([^)]+\\))?/i)||o.match(/^#[0-9a-f]+/i),r=o.match(/^([0-9.-]+)px/i)||o.match(/^(0)/);if(a)bn(!t.colorStr,"Multiple colors identified in text-shadow: ".concat(e)),o=o.replace(a[0],"").trim(),t.colorStr=a[0];else if(r){bn(t.pixels.length<3,"Too many pixel units in text-shadow: ".concat(e));var o=o.replace(r[0],"").trim();a=parseFloat(("."===r[1][0]?"0":"")+r[1]);t.pixels.push(a)}else{if(","!==o[0])throw new Error("Unable to process text-shadows: ".concat(o));bn(2<=t.pixels.length,"Missing pixel value in text-shadow: ".concat(e)),n.push(t={pixels:[]}),o=o.substr(1).trim()}}return n.forEach((function(e){2===(e=e.pixels).length&&e.push(0)})),n}function Of(e){var n,a=(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).minRatio,r=n.maxRatio,o=n.ignoreEdgeCount,i=[],u=t.getComputedStyle(e);if("none"!==(n=u.getPropertyValue("text-shadow"))){var l,s=u.getPropertyValue("font-size"),c=parseInt(s),d=(bn(!1===isNaN(c),"Unable to determine font-size value ".concat(s)),[]),p=Z(Sf(n));try{for(p.s();!(l=p.n()).done;){var f=l.value,m=f.colorStr||u.getPropertyValue("color"),D=H(f.pixels,3),h=D[0],g=D[1],b=D[2],v=void 0===b?0:b;if(!(r&&c*r<=v))if(a&&v<c*a)d.push({colorStr:m,pixels:f.pixels});else{if(0<d.length){var y=Rf(d,{ignoreEdgeCount:o});if(null===y)return null;i.push.apply(i,z(y)),d.splice(0,d.length)}var F=function(e){var t=e.colorStr,n=e.offsetX,a=e.offsetY,r=e.blurRadius;e=e.fontSize;return r<n||r<a?new Tc(0,0,0,0):((n=new Tc).parseString(t),n.alpha*=function(e,t){return 0===e?1:.185/(e/t+.4)}(r,e),n)}({colorStr:m,offsetX:h,offsetY:g,blurRadius:v,fontSize:c});i.push(F)}}}catch(e){p.e(e)}finally{p.f()}if(0<d.length){if(null===(s=Rf(d,{ignoreEdgeCount:o})))return null;i.push.apply(i,z(s))}}return i}function Mf(e,t){var n,a,r,o=Kn(e);return o._stackingContext||(a=[],r=new Map,(t=null!=(n=t)?n:Af(e)).forEach((function(e){var t=(t=e=Kn(e),(o=new Tc).parseString(t.getComputedStylePropertyValue("background-color")),o),n=e._stackingOrder.filter((function(e){return!!e.vNode})),o=(n.forEach((function(e,t){e=e.vNode;var o=null==(o=n[t-1])?void 0:o.vNode;o=jf(r,e,o);0!==t||r.get(e)||a.unshift(o),r.set(e,o)})),null==(o=n[n.length-1])?void 0:o.vNode);e=jf(r,e,o);n.length||a.unshift(e),e.bgColor=t})),o._stackingContext=a)}function Pf(e){var t;return null!=(t=e.descendants)&&t.length?(t=e.descendants.reduce(If,Lf()),(t=Cf(t,e.bgColor,e.descendants[0].blendMode)).alpha*=e.opacity):(t=e.bgColor).alpha*=e.opacity,{color:t,blendMode:e.blendMode}}function If(e,t){e=e instanceof Tc?e:Pf(e).color;var n=Pf(t).color;return Cf(n,e,t.blendMode)}function Lf(e,t){return{vNode:e,ancestor:t,opacity:parseFloat(null!=(t=null==e?void 0:e.getComputedStylePropertyValue("opacity"))?t:1),bgColor:new Tc(0,0,0,0),blendMode:(null==e?void 0:e.getComputedStylePropertyValue("mix-blend-mode"))||void 0,descendants:[]}}function jf(e,t,n){var a=e.get(n);e=null!=(e=e.get(t))?e:Lf(t,a);return a&&n!==t&&!a.descendants.includes(e)&&a.descendants.unshift(e),e}function qf(e){var n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:[],r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:.1,o=Kn(e),i=o._cache.getBackgroundColor;return i?(n.push.apply(n,z(i.bgElms)),zu.set("bgColor",i.incompleteData),i.bgColor):(i=function(e,n,r){var o=Af(e);if(!o)return null;var i=vu(e);(r=null!=(r=Of(e,{minRatio:r,ignoreEdgeCount:!0}))?r:[]).length&&(r=[{color:r.reduce(xf)}]);for(var u=0;u<o.length;u++){var l=o[u],s=t.getComputedStyle(l);if(Vu(l,s))return n.push(l),null;var c=_c(s);if(0!==c.alpha){if("inline"!==s.getPropertyValue("display")&&!zf(l,i))return n.push(l),zu.set("bgColor","elmPartiallyObscured"),null;if(n.push(l),1===c.alpha)break}}var d=(r=(d=Mf(e,o)).map(Pf).concat(r),function(e,n){var r,o,i,u,l=[];return n||(n=a.documentElement,u=a.body,n=t.getComputedStyle(n),r=t.getComputedStyle(u),o=_c(n),u=0!==(i=_c(r)).alpha&&zf(u,e.getBoundingClientRect()),(0!==i.alpha&&0===o.alpha||u&&1!==i.alpha)&&l.unshift({color:i,blendMode:Vf(r.getPropertyValue("mix-blend-mode"))}),0===o.alpha)||u&&1===i.alpha||l.unshift({color:o,blendMode:Vf(n.getPropertyValue("mix-blend-mode"))}),l}(e,o.includes(a.body)));return r.unshift.apply(r,z(d)),0===r.length?new Tc(255,255,255,1):(e=r.reduce((function(e,t){return Cf(t.color,e.color instanceof Tc?e.color:e,t.blendMode)})),Cf(e.color instanceof Tc?e.color:e,new Tc(255,255,255,1)))}(e,n,r),o._cache.getBackgroundColor={bgColor:i,bgElms:n,incompleteData:zu.get("bgColor")},i)}function zf(e,n){n=Array.isArray(n)?n:[n];var a=e.getBoundingClientRect(),r=a.right,o=a.bottom,i=t.getComputedStyle(e).getPropertyValue("overflow");return(["scroll","auto"].includes(i)||e instanceof t.HTMLHtmlElement)&&(r=a.left+e.scrollWidth,o=a.top+e.scrollHeight),n.every((function(e){return e.top>=a.top&&e.bottom<=o&&e.left>=a.left&&e.right<=r}))}function Vf(e){return e||void 0}var $f=function(e,t){return t&&e?(t.alpha<1&&(t=Cf(t,e)),e=e.getRelativeLuminance(),t=t.getRelativeLuminance(),(Math.max(t,e)+.05)/(Math.min(t,e)+.05)):null};function Hf(e,n,a){for(var r=3<arguments.length&&void 0!==arguments[3]?arguments[3]:{},o=t.getComputedStyle(e),i=[],u=0,l=[function(){var e,t,n=o,a=void 0===(a=(a=r).textStrokeEmMin)?0:a;return 0===(t=parseFloat(n.getPropertyValue("-webkit-text-stroke-width")))||(e=n.getPropertyValue("font-size"),t/=parseFloat(e),isNaN(t))||t<a?null:(e=n.getPropertyValue("-webkit-text-stroke-color"),(new Tc).parseString(e))},function(){return e=o,(new Tc).parseString(e.getPropertyValue("-webkit-text-fill-color")||e.getPropertyValue("color"));var e},function(){return Of(e,{minRatio:0})}];u<l.length;u++){var s=(0,l[u])();if(s&&(i=i.concat(s),1===s.alpha))break}var c,d,p=i.reduce((function(e,t){return Cf(e,t)}));return null===(a=null==a?qf(e,[]):a)?(c=zu.get("bgColor"),zu.set("fgColor",c),null):(d=function e(t,n){var a,r=Z(t);try{for(r.s();!(a=r.n()).done;){var o,i=a.value;if((null==(o=i.vNode)?void 0:o.actualNode)===n)return i;var u=e(i.descendants,n);if(u)return u}}catch(e){r.e(e)}finally{r.f()}}(c=Mf(e),e),Cf(function(e,t,n){for(;t;){var a;1===t.opacity&&t.ancestor||(e.alpha*=t.opacity,a=(null==(a=t.ancestor)?void 0:a.descendants)||n,(a=(a=1!==t.opacity?a.slice(0,a.indexOf(t)):a).map(Pf)).length&&(a=a.reduce((function(e,t){return Cf(t.color,e.color instanceof Tc?e.color:e)}),{color:new Tc(0,0,0,0),blendMode:"normal"}),e=Cf(e,a))),t=t.ancestor}return e}(p,d,c),new Tc(255,255,255,1)))}var Uf=function(e,t,n,a){return e=$f(e,t),{isValid:(t=a&&Math.ceil(72*n)/96<14||!a&&Math.ceil(72*n)/96<18?4.5:3)<e,contrastRatio:e,expectedContrastRatio:t}},Gf=Nn((function(e,n){function a(e,t){return r.getPropertyValue(e)===t}var r=t.getComputedStyle(e,n);return a("content","none")||a("display","none")||a("visibility","hidden")||!1===a("position","absolute")||0===_c(r).alpha&&a("background-image","none")?0:(e=Wf(r.getPropertyValue("width")),n=Wf(r.getPropertyValue("height")),"px"!==e.unit||"px"!==n.unit?0===e.value||0===n.value?0:1/0:e.value*n.value)}));function Wf(e){var t=(e=H(e.match(/^([0-9.]+)([a-z]+)$/i)||[],3))[1];e=void 0===(e=e[2])?"":e;return{value:parseFloat(void 0===t?"":t),unit:e.toLowerCase()}}function Yf(e,t){return e=e.getRelativeLuminance(),t=t.getRelativeLuminance(),(Math.max(e,t)+.05)/(Math.min(e,t)+.05)}var Kf=["block","list-item","table","flex","grid","inline-block"];function Xf(e){return e=t.getComputedStyle(e).getPropertyValue("display"),-1!==Kf.indexOf(e)||"table-"===e.substr(0,6)}var Zf=["block","list-item","table","flex","grid","inline-block"];function Jf(e){return e=t.getComputedStyle(e).getPropertyValue("display"),-1!==Zf.indexOf(e)||"table-"===e.substr(0,6)}function Qf(e){return e=parseInt(e.attr("tabindex"),10),!isNaN(e)&&e<0}function em(e,t){return t=tm(t),e=tm(e),!(!t||!e)&&t.includes(e)}function tm(e){return e=su(e,{emoji:!0,nonBmp:!0,punctuations:!0}),li(e)}function nm(e){return""!==(e||"").trim()}function am(e,t){var n=1<arguments.length&&void 0!==t&&t;return e.map((function(e){return{vChild:e,nested:n}}))}function rm(e,t){return e=e.boundingClientRect,t=t.boundingClientRect,e.top>=t.top&&e.left>=t.left&&e.bottom<=t.bottom&&e.right<=t.right}function om(e){return{width:Math.round(10*e.width)/10,height:Math.round(10*e.height)/10}}function im(e,t){return e.actualNode.contains(t.actualNode)&&!Po(t)}function um(e){return e.map((function(e){return e.actualNode}))}function lm(e,t){var n=null==(n=t.data)?void 0:n.headingOrder,a=cm(t.node.ancestry,1);return n&&(t=n.map((function(e){return $({},e,{ancestry:a.concat(e.ancestry)})})),-1===(n=function(e,t){for(;t.length;){var n=sm(e,t);if(-1!==n)return n;t=cm(t,1)}return-1}(e,a))?e.push.apply(e,z(t)):e.splice.apply(e,[n,0].concat(z(t)))),e}function sm(e,t){return e.findIndex((function(e){return zd(e.ancestry,t)}))}function cm(e,t){return e.slice(0,e.length-t)}te(Hl={},{aria:function(){return Pp},color:function(){return hf},dom:function(){return cr},forms:function(){return dm},matches:function(){return Ci},math:function(){return Gr},standards:function(){return df},table:function(){return mm},text:function(){return jo},utils:function(){return rn}});var dm={},pm=(te(dm,{isAriaCombobox:function(){return $i},isAriaListbox:function(){return Vi},isAriaRange:function(){return Ui},isAriaTextbox:function(){return zi},isDisabled:function(){return fm},isNativeSelect:function(){return qi},isNativeTextbox:function(){return ji}}),["fieldset","button","select","input","textarea"]),fm=function e(t){var n,a,r=t._isDisabled;return"boolean"!=typeof r&&(n=t.props.nodeName,a=t.attr("aria-disabled"),r=!(!pm.includes(n)||!t.hasAttr("disabled"))||(a?"true"===a.toLowerCase():!!t.parent&&e(t.parent)),t._isDisabled=r),r},mm={},Dm=(te(mm,{getAllCells:function(){return Dm},getCellPosition:function(){return ai},getHeaders:function(){return gm},getScope:function(){return ri},isColumnHeader:function(){return oi},isDataCell:function(){return bm},isDataTable:function(){return vm},isHeader:function(){return ym},isRowHeader:function(){return ii},toArray:function(){return ni},toGrid:function(){return ni},traverse:function(){return Fm}}),function(e){for(var t,n,a=[],r=0,o=e.rows.length;r<o;r++)for(t=0,n=e.rows[r].cells.length;t<n;t++)a.push(e.rows[r].cells[t]);return a});function hm(e,t,n){for(var a,r="row"===e?"_rowHeaders":"_colHeaders",i="row"===e?ii:oi,u=(s=n[t.y][t.x]).colSpan-1,l=s.getAttribute("rowspan"),s=(l=0===parseInt(l)||0===s.rowspan?n.length:s.rowSpan,t.y+(l-1)),c=t.x+u,d="row"===e?t.y:0,p="row"===e?0:t.x,f=[],m=s;d<=m&&!a;m--)for(var D=c;p<=D;D--){var h=n[m]?n[m][D]:void 0;if(h){var g=o.utils.getNodeFromTree(h);if(g[r]){a=g[r];break}f.push(h)}}return a=(a||[]).concat(f.filter(i)),f.forEach((function(e){o.utils.getNodeFromTree(e)[r]=a})),a}var gm=function(e,t){if(e.getAttribute("headers")){var n=qo(e,"headers");if(n.filter((function(e){return e})).length)return n}return t=t||ni(Dr(e,"table")),e=hm("row",n=ai(e,t),t),n=hm("col",n,t),[].concat(e,n).reverse()},bm=function(e){var t;return!(!e.children.length&&!e.textContent.trim())&&(t=e.getAttribute("role"),Jo(t)?["cell","gridcell"].includes(t):"TD"===e.nodeName.toUpperCase())},vm=function(e){var n=(e.getAttribute("role")||"").toLowerCase();if(("presentation"===n||"none"===n)&&!Mo(e))return!1;if("true"===e.getAttribute("contenteditable")||Dr(e,'[contenteditable="true"]'))return!0;if("grid"===n||"treegrid"===n||"table"===n)return!0;if("landmark"===Su(n))return!0;if("0"===e.getAttribute("datatable"))return!1;if(e.getAttribute("summary"))return!0;if(e.tHead||e.tFoot||e.caption)return!0;for(var a=0,r=e.children.length;a<r;a++)if("COLGROUP"===e.children[a].nodeName.toUpperCase())return!0;for(var o,i,u,l=0,s=e.rows.length,c=!1,d=0;d<s;d++)for(var p,f=0,m=(p=e.rows[d]).cells.length;f<m;f++){if("TH"===(o=p.cells[f]).nodeName.toUpperCase())return!0;if(c||o.offsetWidth===o.clientWidth&&o.offsetHeight===o.clientHeight||(c=!0),o.getAttribute("scope")||o.getAttribute("headers")||o.getAttribute("abbr"))return!0;if(["columnheader","rowheader"].includes((o.getAttribute("role")||"").toLowerCase()))return!0;if(1===o.children.length&&"ABBR"===o.children[0].nodeName.toUpperCase())return!0;l++}if(e.getElementsByTagName("table").length)return!1;if(s<2)return!1;if(1===(n=e.rows[Math.ceil(s/2)]).cells.length&&1===n.cells[0].colSpan)return!1;if(5<=n.cells.length)return!0;if(c)return!0;for(d=0;d<s;d++){if(p=e.rows[d],i&&i!==t.getComputedStyle(p).getPropertyValue("background-color"))return!0;if(i=t.getComputedStyle(p).getPropertyValue("background-color"),u&&u!==t.getComputedStyle(p).getPropertyValue("background-image"))return!0;u=t.getComputedStyle(p).getPropertyValue("background-image")}return 20<=s||!(Lr(e).width>.95*jr(t).width||l<10||e.querySelector("object, embed, iframe, applet"))},ym=function(e){return!(!oi(e)&&!ii(e))||!!e.getAttribute("id")&&(e=yn(e.getAttribute("id")),!!a.querySelector('[headers~="'.concat(e,'"]')))},Fm=function(e,t,n,a){if(Array.isArray(t)&&(a=n,n=t,t={x:0,y:0}),"string"==typeof e)switch(e){case"left":e={x:-1,y:0};break;case"up":e={x:0,y:-1};break;case"right":e={x:1,y:0};break;case"down":e={x:0,y:1}}return function e(t,n,a,r){var o,i=a[n.y]?a[n.y][n.x]:void 0;return i?"function"==typeof r&&!0===(o=r(i,n,a))?[i]:((o=e(t,{x:n.x+t.x,y:n.y+t.y},a,r)).unshift(i),o):[]}(e,{x:t.x+e.x,y:t.y+e.y},n,a)};var wm=/[;,\\s]/,Em=/^[0-9.]+$/;function Cm(e){return e=t.getComputedStyle(function(e){for(var t=e,n=e.textContent.trim(),a=n;a===n&&void 0!==t;){var r=-1;if(0===(e=t).children.length)return e;for(;r++,""===(a=e.children[r].textContent.trim())&&r+1<e.children.length;);t=e.children[r]}return e}(e)),{fontWeight:function(e){switch(e){case"lighter":return 100;case"normal":return 400;case"bold":return 700;case"bolder":return 900}return e=parseInt(e),isNaN(e)?400:e}(e.getPropertyValue("font-weight")),fontSize:parseInt(e.getPropertyValue("font-size")),isItalic:"italic"===e.getPropertyValue("font-style")}}function xm(e,t,n){return n.reduce((function(n,a){return n||(!a.size||e.fontSize/a.size>t.fontSize)&&(!a.weight||e.fontWeight-a.weight>t.fontWeight)&&(!a.italic||e.isItalic&&!t.isItalic)}),!1)}var Am=["alert","log","status"];function km(e){return"caption"===e.props.nodeName}Us=Vr;var Nm=function(e,t,n){return n.initiator};var Bm={emoji:!0,nonBmp:!1,punctuations:!0};var Tm=function(e,t){try{return"svg"===t.props.nodeName||!!ca(t,"svg")}catch(e){return!1}};var Rm=["article","aside","main","nav","section"].join(",");var _m=function(e,t){var n=Qo(t);return!(n&&!["none","presentation"].includes(n)&&!(Uo[n]||{}).accessibleNameRequired&&!Mo(t))};var Sm=[function(e,t){return Om(t)},function(e,t){return"area"!==t.props.nodeName},function(e,t){return!Tm(0,t)},function(e,t){return Mo(t)},function(e,t){return Po(t)||!Mm(t)},function(e){return!Pu(e,{noLengthCompare:!0})}];function Om(e){return"widget"===Su(e)}var Mm=Nn((function e(t){return!(null==t||!t.parent)&&(!(!Om(t.parent)||!Po(t.parent))||e(t.parent))})),Pm={"abstractrole-evaluate":function(e,t,n){return 0<(n=Xc(n.attr("role")).filter((function(e){return"abstract"===Su(e)}))).length&&(this.data(n),!0)},"accesskeys-after":function(e){var t={};return e.filter((function(e){if(e.data){var n=e.data.toUpperCase();if(!t[n])return(t[n]=e).relatedNodes=[],!0;t[n].relatedNodes.push(e.relatedNodes[0])}return!1})).map((function(e){return e.result=!!e.relatedNodes.length,e}))},"accesskeys-evaluate":function(e,t,n){return Sr(n)||(this.data(n.attr("accesskey")),this.relatedNodes([e])),!0},"alt-space-value-evaluate":function(e,t,n){return"string"==typeof(n=n.attr("alt"))&&/^\\s+$/.test(n)},"aria-allowed-attr-evaluate":function(e,t,n){var a,r=[],o=Bi(n),i=Ip(o),u=(Array.isArray(t[o])&&(i=tp(t[o].concat(i))),Z(n.attrNames));try{for(u.s();!(a=u.n()).done;){var l=a.value;uf(l)&&!i.includes(l)&&r.push(l)}}catch(e){u.e(e)}finally{u.f()}return!r.length||(this.data(r.map((function(e){return e+'="'+n.attr(e)+'"'}))),!(o||Ld(n)||Mo(n))&&void 0)},"aria-allowed-attr-matches":function(e,t){var n=/^aria-/,a=t.attrNames;if(a.length)for(var r=0,o=a.length;r<o;r++)if(n.test(a[r]))return!0;return!1},"aria-allowed-role-evaluate":function(e){var t=2<arguments.length?arguments[2]:void 0,n=void 0===(n=(a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).allowImplicit)||n,a=void 0===(a=a.ignoredTags)?[]:a,r=t.props.nodeName;return!!a.map((function(e){return e.toLowerCase()})).includes(r)||!(a=$p(t,n)).length||(this.data(a),!Mi(t)&&void 0)},"aria-allowed-role-matches":function(e,t){return null!==Qo(t,{dpub:!0,fallback:!0})},"aria-busy-evaluate":function(e,t,n){return"true"===n.attr("aria-busy")},"aria-conditional-attr-evaluate":function(e,t,n){var a=Bi(n);return!cf[a]||cf[a].call(this,e,t,n)},"aria-conditional-checkbox-attr-evaluate":lf,"aria-conditional-row-attr-evaluate":sf,"aria-errormessage-evaluate":function(e,t,n){t=Array.isArray(t)?t:[];var a=n.attr("aria-errormessage"),r=n.hasAttr("aria-errormessage"),o=n.attr("aria-invalid");return!n.hasAttr("aria-invalid")||"false"===o||-1!==t.indexOf(a)||!r||(this.data(Xc(a)),function(e){if(""===e.trim())return Xo.ariaAttrs["aria-errormessage"].allowEmpty;var t;try{t=e&&qo(n,"aria-errormessage")[0]}catch(t){return void this.data({messageKey:"idrefs",values:Xc(e)})}return t?Mi(t)?"alert"===t.getAttribute("role")||"assertive"===t.getAttribute("aria-live")||"polite"===t.getAttribute("aria-live")||-1<Xc(n.attr("aria-describedby")).indexOf(e):(this.data({messageKey:"hidden",values:Xc(e)}),!1):void 0}.call(this,a))},"aria-has-attr-matches":function(e,t){var n=/^aria-/;return t.attrNames.some((function(e){return n.test(e)}))},"aria-hidden-body-evaluate":function(e,t,n){return"true"!==n.attr("aria-hidden")},"aria-hidden-focus-matches":function(e){return function e(t){return!t||"true"!==t.getAttribute("aria-hidden")&&e(Pr(t))}(Pr(e))},"aria-label-evaluate":function(e,t,n){return!!li($o(n))},"aria-labelledby-evaluate":function(e,t,n){try{return!!li(Vo(n))}catch(e){}},"aria-level-evaluate":function(e,t,n){if(n=n.attr("aria-level"),!(6<(n=parseInt(n,10))))return!0},"aria-prohibited-attr-evaluate":function(e){var t,n=2<arguments.length?arguments[2]:void 0,a=(null==(a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{})?void 0:a.elementsAllowedAriaLabel)||[],r=n.props.nodeName,o=Bi(n,{chromium:!0});return 0!==(a=function(e,t,n){var a=Xo.ariaRoles[e];return a?a.prohibitedAttrs||[]:e||n.includes(t)?[]:["aria-label","aria-labelledby"]}(o,r,a).filter((function(e){return!!n.attrNames.includes(e)&&""!==li(n.attr(e))}))).length&&(t=n.hasAttr("role")?"hasRole":"noRole",t+=1<a.length?"Plural":"Singular",this.data({role:o,nodeName:r,messageKey:t,prohibited:a}),o=Zi(n,{subtreeDescendant:!0}),""===li(o)||void 0)},"aria-required-attr-evaluate":function(e){var t,n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=2<arguments.length?arguments[2]:void 0,r=Qo(a),o=a.attrNames,i=nf(r);return Array.isArray(n[r])&&(i=tp(n[r],i)),!(r&&o.length&&i.length&&(n=a,"separator"!==r||Mo(n))&&(o=a,"combobox"!==r||"false"!==o.attr("aria-expanded"))&&(t=xi(a),(n=i.filter((function(e){return!(a.attr(e)||void 0!==(null==(n=(n=t).implicitAttrs)?void 0:n[e]));var n}))).length&&(this.data(n),1)))},"aria-required-children-evaluate":function(e,t,n){t=t&&Array.isArray(t.reviewEmpty)?t.reviewEmpty:[];var a,r,o=Qo(n,{dpub:!0}),i=rf(o);return null===i||((a=(n=function(e,t){function n(){if(3===a.props.nodeType&&r.push({vNode:a,role:null}),1!==a.props.nodeType||!Mi(a))return"continue";var e,n=Bi(a,{noPresentational:!0}),i=(e=a,ti().find((function(t){return e.hasAttr(t)}))),u=!!i||Mo(a);!n&&!u||["group","rowgroup"].includes(n)&&t.some((function(e){return e===n}))?o.push.apply(o,z(a.children)):(n||u)&&r.push({role:n,attr:i||"tabindex",vNode:a})}for(var a,r=[],o=Si(e);a=o.shift();)n();return r}(n,i)).filter((function(e){var t=e.role;return 1===e.vNode.props.nodeType&&!i.includes(t)}))).length?(this.relatedNodes(a.map((function(e){return e.vNode}))),this.data({messageKey:"unallowed",values:a.map((function(e){var t=e.vNode,n=(e=e.attr,t.props),a=n.nodeName;return 3===n.nodeType?"#text":(n=Qo(t,{dpub:!0}))?"[role=".concat(n,"]"):e?a+"[".concat(e,"]"):a})).filter((function(e,t,n){return n.indexOf(e)===t})).join(", ")}),!1):(r=i,!!n.some((function(e){return(e=e.role)&&r.includes(e)}))||(this.data(i),!(!t.includes(o)||n.some(pf))&&void 0)))},"aria-required-children-matches":function(e,t){return t=Qo(t,{dpub:!0}),!!rf(t)},"aria-required-parent-evaluate":function(e,t,n){var a=t&&Array.isArray(t.ownGroupRoles)?t.ownGroupRoles:[],r=ff(n,a);if(!r)return!0;var o=function(e){for(var t,n=[];e;)e.getAttribute("id")&&(t=yn(e.getAttribute("id")),t=pr(e).querySelector("[aria-owns~=".concat(t,"]")))&&n.push(t),e=e.parentElement;return n.length?n:null}(e);if(o)for(var i=0,u=o.length;i<u;i++)if(!(r=ff(Kn(o[i]),a,r,!0)))return!0;return this.data(r),!1},"aria-required-parent-matches":function(e,t){return t=Qo(t),!!af(t)},"aria-roledescription-evaluate":function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=Bi(2<arguments.length?arguments[2]:void 0);return!!(t.supportedRoles||[]).includes(n)||!(!n||"presentation"===n||"none"===n)&&void 0},"aria-unsupported-attr-evaluate":function(e,t,n){return!!(n=n.attrNames.filter((function(t){var n=Xo.ariaAttrs[t];return!!uf(t)&&(t=n.unsupported,"object"!==r(t)?!!t:!Ci(e,t.exceptions))}))).length&&(this.data(n),!0)},"aria-valid-attr-evaluate":function(e,t,n){t=Array.isArray(t.value)?t.value:[];var a=[],r=/^aria-/;return n.attrNames.forEach((function(e){-1===t.indexOf(e)&&r.test(e)&&!uf(e)&&a.push(e)})),!a.length||(this.data(a),!1)},"aria-valid-attr-value-evaluate":function(e,t,n){t=Array.isArray(t.value)?t.value:[];var a="",r="",i=[],u=/^aria-/,l=["aria-errormessage"],s={"aria-controls":function(){return"false"!==n.attr("aria-expanded")&&"false"!==n.attr("aria-selected")},"aria-current":function(e){e||(a='aria-current="'.concat(n.attr("aria-current"),'"'),r="ariaCurrent")},"aria-owns":function(){return"false"!==n.attr("aria-expanded")},"aria-describedby":function(e){e||(a='aria-describedby="'.concat(n.attr("aria-describedby"),'"'),r=o._tree&&o._tree[0]._hasShadowRoot?"noIdShadow":"noId")},"aria-labelledby":function(e){e||(a='aria-labelledby="'.concat(n.attr("aria-labelledby"),'"'),r=o._tree&&o._tree[0]._hasShadowRoot?"noIdShadow":"noId")}};return n.attrNames.forEach((function(e){if(!l.includes(e)&&!t.includes(e)&&u.test(e)){var o,c=n.attr(e);try{o=of(n,e)}catch(o){return a="".concat(e,'="').concat(c,'"'),void(r="idrefs")}s[e]&&!s[e](o)||o||(""===c&&(o=e,"string"!==(null==(o=Xo.ariaAttrs[e])?void 0:o.type))?(a=e,r="empty"):i.push("".concat(e,'="').concat(c,'"')))}})),i.length?(this.data(i),!1):!a||void this.data({messageKey:r,needsReview:a})},"attr-non-space-content-evaluate":function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=2<arguments.length?arguments[2]:void 0;if(t.attribute&&"string"==typeof t.attribute)return n.hasAttr(t.attribute)?(n=n.attr(t.attribute),!!li(n)||(this.data({messageKey:"emptyAttr"}),!1)):(this.data({messageKey:"noAttr"}),!1);throw new TypeError("attr-non-space-content requires options.attribute to be a string")},"autocomplete-appropriate-evaluate":function(e,t,n){var a,o,i;return"input"!==n.props.nodeName||(o={bday:["text","search","date"],email:["text","search","email"],username:["text","search","email"],"street-address":["text"],tel:["text","search","tel"],"tel-country-code":["text","search","tel"],"tel-national":["text","search","tel"],"tel-area-code":["text","search","tel"],"tel-local":["text","search","tel"],"tel-local-prefix":["text","search","tel"],"tel-local-suffix":["text","search","tel"],"tel-extension":["text","search","tel"],"cc-number":a=["text","search","number","tel"],"cc-exp":["text","search","month","tel"],"cc-exp-month":a,"cc-exp-year":a,"cc-csc":a,"transaction-amount":a,"bday-day":a,"bday-month":a,"bday-year":a,"new-password":["text","search","password"],"current-password":["text","search","password"],url:i=["text","search","url"],photo:i,impp:i},"object"===r(t)&&Object.keys(t).forEach((function(e){o[e]||(o[e]=[]),o[e]=o[e].concat(t[e])})),i=(a=n.attr("autocomplete").split(/\\s+/g).map((function(e){return e.toLowerCase()})))[a.length-1],!!du.stateTerms.includes(i))||(a=o[i],i=n.hasAttr("type")?li(n.attr("type")).toLowerCase():"text",i=wp().includes(i)?i:"text",void 0===a?"text"===i:a.includes(i))},"autocomplete-matches":function(e,t){if(!(n=t.attr("autocomplete"))||""===li(n))return!1;if(n=t.props.nodeName,!1===["textarea","input","select"].includes(n))return!1;if("input"===n&&["submit","reset","button","hidden"].includes(t.props.type))return!1;if(n=t.attr("aria-disabled")||"false",t.hasAttr("disabled")||"true"===n.toLowerCase())return!1;var n=t.attr("role"),a=t.attr("tabindex");return("-1"!==a||!n||void 0!==(n=Xo.ariaRoles[n])&&"widget"===n.type)&&!("-1"===a&&t.actualNode&&!Vr(t)&&!Mi(t))},"autocomplete-valid-evaluate":function(e,t,n){return n=n.attr("autocomplete")||"",pu(n,t)},"avoid-inline-spacing-evaluate":function(e,t){return!(0<(t=t.cssProperties.filter((function(t){if("important"===e.style.getPropertyPriority(t))return t}))).length&&(this.data(t),1))},"braille-label-equivalent-evaluate":function(e,t,n){var a;if(!(null!=(a=n.attr("aria-braillelabel"))?a:"").trim())return!0;try{return""!==li(uu(n))}catch(e){}},"braille-roledescription-equivalent-evaluate":function(e,t,n){var a=null!=(a=n.attr("aria-brailleroledescription"))?a:"";return""===li(a)||("string"!=typeof(a=n.attr("aria-roledescription"))?(this.data({messageKey:"noRoleDescription"}),!1):""!==li(a)||(this.data({messageKey:"emptyRoleDescription"}),!1))},"bypass-matches":function(e,t,n){return!Nm(0,0,n)||!!e.querySelector("a[href]")},"caption-evaluate":function(e,t,n){return!fp(n,"track").some((function(e){return"captions"===(e.attr("kind")||"").toLowerCase()}))&&void 0},"caption-faked-evaluate":function(e){var t=ni(e),n=t[0];return t.length<=1||n.length<=1||e.rows.length<=1||n.reduce((function(e,t,a){return e||t!==n[a+1]&&void 0!==n[a+1]}),!1)},"color-contrast-evaluate":function(e,n,a){var r=n.ignoreUnicode,o=n.ignoreLength,i=n.ignorePseudo,u=n.boldValue,l=n.boldTextPt,s=n.largeTextPt,c=n.contrastRatio,d=n.shadowOutlineEmMax,p=n.pseudoSizeThreshold;if(!Vr(e))return this.data({messageKey:"hidden"}),!0;var f=Ii(a,!1,!0);if(r&&(D=ou(r=f,m={nonBmp:!0}),r=""===li(su(r,m)),D)&&r)this.data({messageKey:"nonBmp"});else{var m=t.getComputedStyle(e),D=parseFloat(m.getPropertyValue("font-size"));r=m.getPropertyValue("font-weight"),u=parseFloat(r)>=u||"bold"===r,r=Math.ceil(72*D)/96,r=(l=u&&r<l||!u&&r<s?c.normal:c.large).expected,s=l.minThreshold,c=l.maxThreshold,l=function(e,t){var n=void 0===(n=t.pseudoSizeThreshold)?.25:n;if(!(t=void 0!==(t=t.ignorePseudo)&&t)){var a=(t=e.boundingClientRect).width*t.height*n;do{if(a<Gf(e.actualNode,":before")+Gf(e.actualNode,":after"))return e}while(e=e.parent)}}(a,{ignorePseudo:i,pseudoSizeThreshold:p});if(l)this.data({fontSize:"".concat((72*D/96).toFixed(1),"pt (").concat(D,"px)"),fontWeight:u?"bold":"normal",messageKey:"pseudoContent",expectedContrastRatio:r+":1"}),this.relatedNodes(l.actualNode);else{var h,g,b;if(null!==(a=Of(e,{minRatio:.001,maxRatio:d})))return l=Hf(e,!(i=[]),p=qf(e,i,d),n),n=d=e=null,0===a.length?e=$f(p,l):l&&p&&(n=[].concat(z(a),[p]).reduce(xf),a=$f(p,l),b=$f(p,n),h=$f(n,l),(e=Math.max(a,b,h))!==a)&&(d=h<b?"shadowOnBgColor":"fgOnShadowColor"),a=r<e,"number"==typeof s&&("number"!=typeof e||e<s)||"number"==typeof c&&("number"!=typeof e||c<e)?(this.data({contrastRatio:e}),!0):(h=Math.floor(100*e)/100,null===p?g=zu.get("bgColor"):a||(g=d),b=1===f.length,(s=1==h)?g=zu.set("bgColor","equalRatio"):a||!b||o||(g="shortTextContent"),this.data({fgColor:l?l.toHexString():void 0,bgColor:p?p.toHexString():void 0,contrastRatio:h,fontSize:"".concat((72*D/96).toFixed(1),"pt (").concat(D,"px)"),fontWeight:u?"bold":"normal",messageKey:g,expectedContrastRatio:r+":1",shadowColor:n?n.toHexString():void 0}),null===l||null===p||s||b&&!o&&!a?(g=null,zu.clear(),void this.relatedNodes(i)):(a||this.relatedNodes(i),a));this.data({messageKey:"complexTextShadows"})}}},"color-contrast-matches":function(e,n){var r=(o=n.props).nodeName,o=o.type;if("option"!==r&&("select"!==r||e.options.length)&&!("input"===r&&["hidden","range","color","checkbox","radio","image"].includes(o)||fm(n)||yo(n))){if(["input","select","textarea"].includes(r)){if(o=t.getComputedStyle(e),o=parseInt(o.getPropertyValue("text-indent"),10)){var i={top:(i=e.getBoundingClientRect()).top,bottom:i.bottom,left:i.left+o,right:i.right+o};if(!Uc(i,e))return!1}return!0}if(o=mr(n,"label"),"label"===r||o){if(i=o||e,r=o?Kn(o):n,i.htmlFor&&(i=(o=pr(i).getElementById(i.htmlFor))&&Kn(o))&&fm(i))return!1;if((o=fp(r,'input:not([type="hidden"],[type="image"],[type="button"],[type="submit"],[type="reset"]), select, textarea')[0])&&fm(o))return!1}for(var u,l=[],s=n;s;)s.props.id&&(u=jp(s).filter((function(e){return Xc(e.getAttribute("aria-labelledby")||"").includes(s.props.id)})).map((function(e){return Kn(e)})),l.push.apply(l,z(u))),s=s.parent;if(!(0<l.length&&l.every(fm))&&""!==(r=Ii(i=n,!1,!0))&&""!==su(r,Bm)&&i.children.some((function(e){return"#text"===e.props.nodeName&&!iu(e)}))){for(var c=a.createRange(),d=n.children,p=0;p<d.length;p++){var f=d[p];3===f.actualNode.nodeType&&""!==li(f.actualNode.nodeValue)&&c.selectNodeContents(f.actualNode)}for(var m=c.getClientRects(),D=0;D<m.length;D++)if(Uc(m[D],e))return!0}}return!1},"css-orientation-lock-evaluate":function(e,t,n,a){a=void 0===(a=(a||{}).cssom)?void 0:a;var r=void 0===(t=(t||{}).degreeThreshold)?0:t;if(a&&a.length){function o(){var e=c[s],t=(e=l[e]).root;if(!(e=e.rules.filter(d)).length)return"continue";e.forEach((function(e){e=e.cssRules,Array.from(e).forEach((function(e){var n=function(e){var t=e.selectorText;e=e.style;return!(!t||e.length<=0)&&(!(!(t=e.transform||e.webkitTransform||e.msTransform||!1)&&!e.rotate)&&(t=function(e){return e&&(e=e.match(/(rotate|rotateZ|rotate3d|matrix|matrix3d)\\(([^)]+)\\)(?!.*(rotate|rotateZ|rotate3d|matrix|matrix3d))/))?p((e=H(e,3))[1],e=e[2]):0}(t),!!(t+=e=p("rotate",e.rotate))&&(t=Math.abs(t),!(Math.abs(t-180)%180<=r)&&Math.abs(t-90)%90<=r)))}(e);n&&"HTML"!==e.selectorText.toUpperCase()&&(e=Array.from(t.querySelectorAll(e.selectorText))||[],u=u.concat(e)),i=i||n}))}))}for(var i=!1,u=[],l=a.reduce((function(e,t){var n=t.sheet,a=t.root;return e[t=(t=t.shadowId)||"topDocument"]||(e[t]={root:a,rules:[]}),n&&n.cssRules&&(a=Array.from(n.cssRules),e[t].rules=e[t].rules.concat(a)),e}),{}),s=0,c=Object.keys(l);s<c.length;s++)o();return!i||(u.length&&this.relatedNodes(u),!1)}function d(e){var t=e.type;e=e.cssText;return 4===t&&(/orientation:\\s*landscape/i.test(e)||/orientation:\\s*portrait/i.test(e))}function p(e,t){switch(e){case"rotate":case"rotateZ":return f(t);case"rotate3d":var n=H(t.split(",").map((function(e){return e.trim()})),4),a=n[2];n=n[3];return 0===parseInt(a)?void 0:f(n);case"matrix":case"matrix3d":var r,o;return(a=(a=t).split(",")).length<=6?(r=(o=H(a,2))[0],o=o[1],m(Math.atan2(parseFloat(o),parseFloat(r)))):(o=parseFloat(a[8]),r=Math.asin(o),o=Math.cos(r),m(Math.acos(parseFloat(a[0])/o)));default:return 0}}function f(e){var t=H(e.match(/(deg|grad|rad|turn)/)||[],1)[0];if(!t)return 0;var n=parseFloat(e.replace(t,""));switch(t){case"rad":return m(n);case"grad":var a=n;return(a%=400)<0&&(a+=400),Math.round(a/400*360);case"turn":return Math.round(360/(1/n));default:return parseInt(n)}}function m(e){return Math.round(e*(180/Math.PI))}},"data-table-large-matches":function(e){return!!vm(e)&&3<=(e=ni(e)).length&&3<=e[0].length&&3<=e[1].length&&3<=e[2].length},"data-table-matches":function(e){return vm(e)},"deprecatedrole-evaluate":function(e,t,n){n=Bi(n,{dpub:!0,fallback:!0});var a=Xo.ariaRoles[n];return!(null==a||!a.deprecated||(this.data(n),0))},"dlitem-evaluate":function(e){var t=(e=Pr(e)).nodeName.toUpperCase(),n=Qo(e);return"DIV"===t&&["presentation","none",null].includes(n)&&(t=(e=Pr(e)).nodeName.toUpperCase(),n=Qo(e)),"DL"===t&&!(n&&!["presentation","none","list"].includes(n))},"doc-has-title-evaluate":function(){var e=a.title;return!!li(e)},"duplicate-id-active-matches":function(e){var t=e.getAttribute("id").trim();return t='*[id="'.concat(yn(t),'"]'),t=Array.from(pr(e).querySelectorAll(t)),!Jp(e)&&t.some(Mo)},"duplicate-id-after":function(e){var t=[];return e.filter((function(e){return-1===t.indexOf(e.data)&&(t.push(e.data),!0)}))},"duplicate-id-aria-matches":function(e){return Jp(e)},"duplicate-id-evaluate":function(e){var t,n=e.getAttribute("id").trim();return!n||(t=pr(e),(t=Array.from(t.querySelectorAll('[id="'.concat(yn(n),'"]'))).filter((function(t){return t!==e}))).length&&this.relatedNodes(t),this.data(n),0===t.length)},"duplicate-id-misc-matches":function(e){var t=e.getAttribute("id").trim();return t='*[id="'.concat(yn(t),'"]'),t=Array.from(pr(e).querySelectorAll(t)),!Jp(e)&&t.every((function(e){return!Mo(e)}))},"duplicate-img-label-evaluate":function(e,t,n){return!["none","presentation"].includes(Bi(n))&&!!(t=ca(n,t.parentSelector))&&""!==(t=Ii(t,!0).toLowerCase())&&t===uu(n).toLowerCase()},"exists-evaluate":function(){},"explicit-evaluate":function(e,t,n){var a=this;if(!n.attr("id"))return!1;if(n.actualNode){var r=pr(n.actualNode),o=yn(n.attr("id"));r=Array.from(r.querySelectorAll('label[for="'.concat(o,'"]')));if(this.relatedNodes(r),!r.length)return!1;try{return r.some((function(e){return!Vr(e)||(e=li(zo(e,{inControlContext:!0,startNode:n})),a.data({explicitLabel:e}),!!e)}))}catch(e){}}},"fallbackrole-evaluate":function(e,t,n){var a=Xc(n.attr("role"));return!(a.length<=1)&&(!(!Ai(n)&&2===a.length&&a.includes("none")&&a.includes("presentation"))||void 0)},"focusable-content-evaluate":function(e,t,n){var a=n.tabbableElements;return!!a&&0<a.filter((function(e){return e!==n})).length},"focusable-disabled-evaluate":function(e,t,n){var a=["button","fieldset","input","select","textarea"];return!((n=n.tabbableElements)&&n.length&&(n=n.filter((function(e){return a.includes(e.props.nodeName)})),this.relatedNodes(n.map((function(e){return e.actualNode}))),0!==n.length)&&!Iu())||!!n.every((function(e){var t=e.getComputedStylePropertyValue("pointer-events"),n=parseInt(e.getComputedStylePropertyValue("width")),a=parseInt(e.getComputedStylePropertyValue("height"));return e.actualNode.onfocus||(0===n||0===a)&&"none"===t}))&&void 0},"focusable-element-evaluate":function(e,t,n){return!(!n.hasAttr("contenteditable")||!function e(t){return"true"===(t=t.attr("contenteditable"))||""===t||"false"!==t&&(!!(t=ca(n.parent,"[contenteditable]"))&&e(t))}(n))||Po(n)},"focusable-modal-open-evaluate":function(e,t,n){return!(n=n.tabbableElements.map((function(e){return e.actualNode})))||!n.length||!Iu()||void this.relatedNodes(n)},"focusable-no-name-evaluate":function(e,t,n){var a=n.attr("tabindex");if(!(Mo(n)&&-1<a))return!1;try{return!uu(n)}catch(e){}},"focusable-not-tabbable-evaluate":function(e,t,n){var a=["button","fieldset","input","select","textarea"];return!((n=n.tabbableElements)&&n.length&&(n=n.filter((function(e){return!a.includes(e.props.nodeName)})),this.relatedNodes(n.map((function(e){return e.actualNode}))),0!==n.length)&&!Iu())||!!n.every((function(e){var t=e.getComputedStylePropertyValue("pointer-events"),n=parseInt(e.getComputedStylePropertyValue("width")),a=parseInt(e.getComputedStylePropertyValue("height"));return e.actualNode.onfocus||(0===n||0===a)&&"none"===t}))&&void 0},"frame-focusable-content-evaluate":function(e,t,n){if(n.children)try{return!n.children.some((function e(t){if(Po(t))return!0;if(!t.children){if(1===t.props.nodeType)throw new Error("Cannot determine children");return!1}return t.children.some((function(t){return e(t)}))}))}catch(e){}},"frame-focusable-content-matches":function(e,t,n){var a;return!n.initiator&&!n.focusable&&1<(null==(a=n.size)?void 0:a.width)*(null==(a=n.size)?void 0:a.height)},"frame-tested-after":function(e){var t={};return e.filter((function(e){var n;return"html"!==e.node.ancestry[e.node.ancestry.length-1]?(n=e.node.ancestry.flat(1/0).join(" > "),t[n]=e,!0):(n=e.node.ancestry.slice(0,e.node.ancestry.length-1).flat(1/0).join(" > "),t[n]&&(t[n].result=!0),!1)}))},"frame-tested-evaluate":function(e,t){return!t.isViolation&&void 0},"frame-title-has-text-matches":function(e){return e=e.getAttribute("title"),!!li(e)},"has-alt-evaluate":function(e,t,n){var a=n.props.nodeName;return!!["img","input","area"].includes(a)&&n.hasAttr("alt")},"has-descendant-after":function(e){return e.some((function(e){return!0===e.result}))&&e.forEach((function(e){e.result=!0})),e},"has-descendant-evaluate":function(e,t,n){if(t&&t.selector&&"string"==typeof t.selector)return!(!t.passForModal||!Iu())||(n=ap(n,t.selector,Mi),this.relatedNodes(n.map((function(e){return e.actualNode}))),0<n.length);throw new TypeError("has-descendant requires options.selector to be a string")},"has-global-aria-attribute-evaluate":function(e,t,n){var a=ti().filter((function(e){return n.hasAttr(e)}));return this.data(a),0<a.length},"has-implicit-chromium-role-matches":function(e,t){return null!==Ai(t,{chromium:!0})},"has-lang-evaluate":function(e,t,n){var r=void 0!==a&&Bn(a);return t.attributes.includes("xml:lang")&&t.attributes.includes("lang")&&nm(n.attr("xml:lang"))&&!nm(n.attr("lang"))&&!r?(this.data({messageKey:"noXHTML"}),!1):!!t.attributes.some((function(e){return nm(n.attr(e))}))||(this.data({messageKey:"noLang"}),!1)},"has-text-content-evaluate":function(e,t,n){try{return""!==li(Zi(n))}catch(e){}},"has-widget-role-evaluate":function(e){return null!==(e=e.getAttribute("role"))&&("widget"===(e=Su(e))||"composite"===e)},"heading-matches":function(e,t){return"heading"===Bi(t)},"heading-order-after":function(e){(t=z(t=e)).sort((function(e,t){return e=e.node,t=t.node,e.ancestry.length-t.ancestry.length}));var t,n=t.reduce(lm,[]).filter((function(e){return-1!==e.level}));return e.forEach((function(e){e.result=function(e,t){var n=null!=(n=null==(n=t[e=sm(t,e.node.ancestry)])?void 0:n.level)?n:-1;t=null!=(t=null==(t=t[e-1])?void 0:t.level)?t:-1;return 0===e||(-1!==n?n-t<=1:void 0)}(e,n)})),e},"heading-order-evaluate":function(){var e,t=Yn.get("headingOrder");return t||(t=(e=ap(o._tree[0],"h1, h2, h3, h4, h5, h6, [role=heading], iframe, frame",Mi)).map((function(e){return{ancestry:[Un(e.actualNode)],level:(t=(t=Bi(e))&&t.includes("heading"),n=e.attr("aria-level"),a=parseInt(n,10),e=H(e.props.nodeName.match(/h(\\d)/)||[],2)[1],t?e&&!n?parseInt(e,10):isNaN(a)||a<1?e?parseInt(e,10):2:a||-1:-1)};var t,n,a})),this.data({headingOrder:t}),Yn.set("headingOrder",e)),!0},"help-same-as-label-evaluate":function(e,t,n){n=Du(n);var a=e.getAttribute("title");return!!n&&(a||(a="",e.getAttribute("aria-describedby")&&(a=qo(e,"aria-describedby").map((function(e){return e?zo(e):""})).join(""))),li(a)===li(n))},"hidden-content-evaluate":function(e,n,a){if(!["SCRIPT","HEAD","TITLE","NOSCRIPT","STYLE","TEMPLATE"].includes(e.nodeName.toUpperCase())&&xu(a)){if("none"===(a=t.getComputedStyle(e)).getPropertyValue("display"))return;if("hidden"===a.getPropertyValue("visibility")&&(!(e=(a=Pr(e))&&t.getComputedStyle(a))||"hidden"!==e.getPropertyValue("visibility")))return}return!0},"hidden-explicit-label-evaluate":function(e,t,n){if(n.hasAttr("id")){if(!n.actualNode)return;var a,r=pr(e);e=yn(e.getAttribute("id"));if((r=r.querySelector('label[for="'.concat(e,'"]')))&&!Mi(r)){try{a=uu(n).trim()}catch(e){return}return""===a}}return!1},"html-namespace-matches":function(e,t){return!Tm(0,t)},"html5-scope-evaluate":function(e){return!_u(a)||"TH"===e.nodeName.toUpperCase()},"identical-links-same-purpose-after":function(e){if(e.length<2)return e;function t(e){var t=n[e],i=t.data,u=i.name,l=i.urlProps;if(o[u])return"continue";var s=(i=n.filter((function(t,n){return t.data.name===u&&n!==e}))).every((function(e){return function e(t,n){var a,o;return!(!t||!n)&&(a=Object.getOwnPropertyNames(t),o=Object.getOwnPropertyNames(n),a.length===o.length)&&a.every((function(a){var o=t[a];a=n[a];return r(o)===r(a)&&("object"===r(o)||"object"===r(a)?e(o,a):o===a)}))}(e.data.urlProps,l)}));i.length&&!s&&(t.result=void 0),t.relatedNodes=[],(s=t.relatedNodes).push.apply(s,z(i.map((function(e){return e.relatedNodes[0]})))),o[u]=i,a.push(t)}for(var n=e.filter((function(e){return void 0!==e.result})),a=[],o={},i=0;i<n.length;i++)t(i);return a},"identical-links-same-purpose-evaluate":function(e,t,n){if(n=jo.accessibleTextVirtual(n),n=jo.sanitize(jo.removeUnicode(n,{emoji:!0,nonBmp:!0,punctuations:!0})).toLowerCase())return n={name:n,urlProps:cr.urlPropsFromAttribute(e,"href")},this.data(n),this.relatedNodes([e]),!0},"identical-links-same-purpose-matches":function(e,t){return!(!uu(t)||(t=Bi(e))&&"link"!==t)},"implicit-evaluate":function(e,t,n){try{var a,r=ca(n,"label");return!!r&&(a=li(uu(r,{inControlContext:!0,startNode:n})),r.actualNode&&this.relatedNodes([r.actualNode]),this.data({implicitLabel:a}),!!a)}catch(e){}},"inline-style-property-evaluate":function(e,n){var a=n.cssProperty,r=n.absoluteValues,o=n.minValue,i=n.maxValue,u=void 0===(u=n.normalValue)?0:u,l=n.noImportant;n=n.multiLineOnly;return!!(!l&&"important"!==e.style.getPropertyPriority(a)||n&&!Lu(e))||(l={},"number"==typeof o&&(l.minValue=o),"number"==typeof i&&(l.maxValue=i),n=e.style.getPropertyValue(a),["inherit","unset","revert","revert-layer"].includes(n)?(this.data($({value:n},l)),!0):(n=function(e,n){var a=n.cssProperty,r=n.absoluteValues;n=n.normalValue;return"normal"===(a=(e=t.getComputedStyle(e)).getPropertyValue(a))?n:(n=parseFloat(a),r?n:(r=parseFloat(e.getPropertyValue("font-size")),e=Math.round(n/r*100)/100,isNaN(e)?a:e))}(e,{absoluteValues:r,cssProperty:a,normalValue:u}),this.data($({value:n},l)),"number"==typeof n?("number"!=typeof o||o<=n)&&("number"!=typeof i||n<=i):void 0))},"inserted-into-focus-order-matches":function(e){return Nu(e)},"internal-link-present-evaluate":function(e,t,n){return fp(n,"a[href]").some((function(e){return/^#[^/!]/.test(e.attr("href"))}))},"invalid-children-evaluate":function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n=2<arguments.length?arguments[2]:void 0,a=[],r=[];if(n.children){for(var o=am(n.children);o.length;){var i=(u=o.shift()).vChild,u=u.nested;if(t.divGroups&&!u&&"div"===(l=i).props.nodeName&&null===Qo(l)){if(!i.children)return;var l=am(i.children,!0);o.push.apply(o,z(l))}else l=function(e,t,n){var a=void 0===(a=n.validRoles)?[]:a,r=(n=void 0===(n=n.validNodeNames)?[]:n,(i=e.props).nodeName),o=i.nodeType,i=i.nodeValue;t=t?"div > ":"";return 3===o&&""!==i.trim()?t+"#text":!(1!==o||!Mi(e))&&((i=Qo(e))?!a.includes(i)&&t+"[role=".concat(i,"]"):!n.includes(r)&&t+r)}(i,u,t),l&&(r.includes(l)||r.push(l),1===(null==i||null==(u=i.actualNode)?void 0:u.nodeType))&&a.push(i.actualNode)}return 0!==r.length&&(this.data({values:r.join(", ")}),this.relatedNodes(a),!0)}},"invalidrole-evaluate":function(e,t,n){return!!(n=Xc(n.attr("role"))).every((function(e){return!Jo(e,{allowAbstract:!0})}))&&(this.data(n),!0)},"is-element-focusable-evaluate":function(e,t,n){return Mo(n)},"is-initiator-matches":Nm,"is-on-screen-evaluate":Us,"is-visible-matches":Vr,"is-visible-on-screen-matches":function(e,t){return Vr(t)},"label-content-name-mismatch-evaluate":function(e,t,n){var a=null==t?void 0:t.pixelThreshold,r=null!=(r=null==t?void 0:t.occurrenceThreshold)?r:null==t?void 0:t.occuranceThreshold;if(t=zo(e).toLowerCase(),!(cu(t)<1))return!(e=li(Zi(n,{subtreeDescendant:!0,ignoreIconLigature:!0,pixelThreshold:a,occurrenceThreshold:r})).toLowerCase())||(cu(e)<1?!!em(e,t)||void 0:em(e,t))},"label-content-name-mismatch-matches":function(e,t){var n=Bi(e);return!!(n&&Hp("widget").includes(n)&&Gp().includes(n)&&(li($o(t))||li(Vo(e)))&&li(Ii(t)))},"label-matches":function(e,t){return"input"!==t.props.nodeName||!1===t.hasAttr("type")||(t=t.attr("type").toLowerCase(),!1===["hidden","image","button","submit","reset"].includes(t))},"landmark-has-body-context-matches":function(e,t){return e.hasAttribute("role")||!mr(t,"article, aside, main, nav, section")},"landmark-is-top-level-evaluate":function(e){var t=Hp("landmark"),n=Pr(e),a=Bi(e);for(this.data({role:a});n;){var r=n.getAttribute("role");if((r=r||"FORM"===n.nodeName.toUpperCase()?r:Ai(n))&&t.includes(r)&&("main"!==r||"complementary"!==a))return!1;n=Pr(n)}return!0},"landmark-is-unique-after":function(e){var t=[];return e.filter((function(e){var n=t.find((function(t){return e.data.role===t.data.role&&e.data.accessibleText===t.data.accessibleText}));return n?(n.result=!1,n.relatedNodes.push(e.relatedNodes[0]),!1):(t.push(e),e.relatedNodes=[],!0)}))},"landmark-is-unique-evaluate":function(e,t,n){var a=Bi(e);return n=(n=uu(n))?n.toLowerCase():null,this.data({role:a,accessibleText:n}),this.relatedNodes([e]),!0},"landmark-unique-matches":function(e,t){return n=t,r=Hp("landmark"),!!(o=Bi(n))&&("header"!==(a=n.props.nodeName)&&"footer"!==a?"section"!==a&&"form"!==a?0<=r.indexOf(o)||"region"===o:!!uu(n):!ca(n,Rm))&&Mi(t);var n,a,r,o},"layout-table-matches":function(e){return!vm(e)&&!Mo(e)},"link-in-text-block-evaluate":function(e,t){var n=t.requiredContrastRatio;if(t=t.allowSameColor,Xf(e))return!1;for(var a=Pr(e);a&&1===a.nodeType&&!Xf(a);)a=Pr(a);if(a){this.relatedNodes([a]);var r=Hf(e),o=Hf(a),i=(e=qf(e),qf(a)),u=r&&o?Yf(r,o):void 0;if((u=u&&Math.floor(100*u)/100)&&n<=u)return!0;var l=e&&i?Yf(e,i):void 0;if((l=l&&Math.floor(100*l)/100)&&n<=l)return!0;if(l){if(u)return!(!t||1!==u||1!==l)||(1===u&&1<l?this.data({messageKey:"bgContrast",contrastRatio:l,requiredContrastRatio:n,nodeBackgroundColor:e?e.toHexString():void 0,parentBackgroundColor:i?i.toHexString():void 0}):this.data({messageKey:"fgContrast",contrastRatio:u,requiredContrastRatio:n,nodeColor:r?r.toHexString():void 0,parentColor:o?o.toHexString():void 0}),!1)}else l=null!=(t=zu.get("bgColor"))?t:"bgContrast",this.data({messageKey:l}),zu.clear()}},"link-in-text-block-matches":function(e){var t=li(e.innerText),n=e.getAttribute("role");return!(n&&"link"!==n||!t||!Vr(e))&&Pu(e)},"link-in-text-block-style-evaluate":function(e){if(Jf(e))return!1;for(var n=Pr(e);n&&1===n.nodeType&&!Jf(n);)n=Pr(n);return n?(this.relatedNodes([n]),!!vf(e,n)||!!function(e){for(var n=0,a=["before","after"];n<a.length;n++){var r=a[n];if("none"!==t.getComputedStyle(e,":".concat(r)).getPropertyValue("content"))return 1}}(e)&&void this.data({messageKey:"pseudoContent"})):void 0},"listitem-evaluate":function(e,t,n){var a;if(n=n.parent)return a=n.props.nodeName,n=Qo(n),!!["presentation","none","list"].includes(n)||(n&&Jo(n)?(this.data({messageKey:"roleNotValid"}),!1):["ul","ol","menu"].includes(a))},"matches-definition-evaluate":function(e,t,n){return Ci(n,t.matcher)},"meta-refresh-evaluate":function(e,t,n){var a=(r=t||{}).minDelay,r=r.maxDelay;return!(n=H((n.attr("content")||"").trim().split(wm),1)[0]).match(Em)||(n=parseFloat(n),this.data({redirectDelay:n}),"number"==typeof a&&n<=t.minDelay)||"number"==typeof r&&n>t.maxDelay},"meta-viewport-scale-evaluate":function(e,t,n){var a,r=void 0===(r=(t=t||{}).scaleMinimum)?2:r;return t=void 0!==(t=t.lowerBound)&&t,!((n=n.attr("content")||"")&&(n=n.split(/[;,]/).reduce((function(e,t){var n;return(t=t.trim())&&(n=(t=H(t.split("="),2))[0],t=t[1],n)&&t&&(n=n.toLowerCase().trim(),t=t.toLowerCase().trim(),"maximum-scale"===n&&"yes"===t&&(t=1),"maximum-scale"===n&&parseFloat(t)<0||(e[n]=t)),e}),{}),!(t&&n["maximum-scale"]&&parseFloat(n["maximum-scale"])<t))&&(t||"no"!==n["user-scalable"]?(a=parseFloat(n["user-scalable"]),!t&&n["user-scalable"]&&(a||0===a)&&-1<a&&a<1?(this.data("user-scalable"),1):n["maximum-scale"]&&parseFloat(n["maximum-scale"])<r&&(this.data("maximum-scale"),1)):(this.data("user-scalable=no"),1)))},"multiple-label-evaluate":function(e){var t=yn(e.getAttribute("id")),n=e.parentNode,a=(a=pr(e)).documentElement||a,r=Array.from(a.querySelectorAll('label[for="'.concat(t,'"]')));for(r.length&&(r=r.filter((function(e){return!Sr(e)})));n;)"LABEL"===n.nodeName.toUpperCase()&&-1===r.indexOf(n)&&r.push(n),n=n.parentNode;return this.relatedNodes(r),1<r.length&&(1<(a=r.filter(Mi)).length||!qo(e,"aria-labelledby").includes(a[0]))&&void 0},"nested-interactive-matches":function(e,t){return!!(t=Bi(t))&&!!Xo.ariaRoles[t].childrenPresentational},"no-autoplay-audio-evaluate":function(e,t){var n,a;if(e.duration)return t=void 0===(t=t.allowedDuration)?3:t,((n=e).currentSrc?(a=function(e){if(e=e.match(/#t=(.*)/))return H(e,2)[1].split(",").map((function(e){if(/:/.test(e)){for(var t=e.split(":"),n=0,a=1;0<t.length;)n+=a*parseInt(t.pop(),10),a*=60;return parseFloat(n)}return parseFloat(e)}))}(n.currentSrc))?1!==a.length?Math.abs(a[1]-a[0]):Math.abs(n.duration-a[0]):Math.abs(n.duration-(n.currentTime||0)):0)<=t&&!e.hasAttribute("loop")||!!e.hasAttribute("controls");console.warn("axe.utils.preloadMedia did not load metadata")},"no-autoplay-audio-matches":function(e){return!!e.currentSrc&&!e.hasAttribute("paused")&&!e.hasAttribute("muted")},"no-empty-role-matches":function(e,t){return!!t.hasAttr("role")&&!!t.attr("role").trim()},"no-explicit-name-required-matches":_m,"no-focusable-content-evaluate":function(e,t,n){if(n.children)try{var a,r=function e(t){if(!t.children){if(1===t.props.nodeType)throw new Error("Cannot determine children");return[]}var n=[];return t.children.forEach((function(t){"widget"===Su(t)&&Mo(t)?n.push(t):n.push.apply(n,z(e(t)))})),n}(n);return!r.length||(0<(a=r.filter(Qf)).length?(this.data({messageKey:"notHidden"}),this.relatedNodes(a)):this.relatedNodes(r),!1)}catch(e){}},"no-implicit-explicit-label-evaluate":function(e,t,n){var a,r,o=Bi(n,{noImplicit:!0});this.data(o);try{a=li(Ji(n)).toLowerCase(),r=li(uu(n)).toLowerCase()}catch(e){return}return!(!r&&!a||(r||!a)&&r.includes(a))&&void 0},"no-naming-method-matches":function(e,t){var n=xi(t).namingMethods;return!(n&&0!==n.length||"combobox"===Qo(t)&&fp(t,'input:not([type="hidden"])').length||Qp(t,{popupRoles:["listbox"]}))},"no-negative-tabindex-matches":function(e,t){return t=parseInt(t.attr("tabindex"),10),isNaN(t)||0<=t},"no-role-matches":function(e,t){return!t.attr("role")},"non-empty-if-present-evaluate":function(e,t,n){var a=n.props.nodeName,r=(n.attr("type")||"").toLowerCase();return(n=n.attr("value"))&&this.data({messageKey:"has-label"}),!("input"!==a||!["submit","reset"].includes(r))&&null===n},"not-html-matches":function(e,t){return"html"!==t.props.nodeName},"object-is-loaded-matches":function(e,t){return[_m,function(e){var t;return null==e||null==(t=e.ownerDocument)||!t.createRange||((t=e.ownerDocument.createRange()).setStart(e,0),t.setEnd(e,e.childNodes.length),0===t.getClientRects().length)}].every((function(n){return n(e,t)}))},"only-dlitems-evaluate":function(e,t,n){var a=["definition","term","list"];return(n=n.children.reduce((function(e,t){var n=t.actualNode;return"DIV"===n.nodeName.toUpperCase()&&null===Bi(n)?e.concat(t.children):e.concat(t)}),[]).reduce((function(e,t){var n,r=(t=t.actualNode).nodeName.toUpperCase();return 1===t.nodeType&&Mi(t)?(n=Qo(t),("DT"!==r&&"DD"!==r||n)&&!a.includes(n)&&e.badNodes.push(t)):3===t.nodeType&&""!==t.nodeValue.trim()&&(e.hasNonEmptyTextNode=!0),e}),{badNodes:[],hasNonEmptyTextNode:!1})).badNodes.length&&this.relatedNodes(n.badNodes),!!n.badNodes.length||n.hasNonEmptyTextNode},"only-listitems-evaluate":function(e,t,n){var a=!1,r=!1,o=!0,i=[],u=[],l=[];if(n.children.forEach((function(e){var t,n,s=e.actualNode;3===s.nodeType&&""!==s.nodeValue.trim()?a=!0:1===s.nodeType&&Mi(s)&&(o=!1,t="LI"===s.nodeName.toUpperCase(),n="listitem"===(e=Bi(e)),t||n||i.push(s),t&&!n&&(u.push(s),l.includes(e)||l.push(e)),n)&&(r=!0)})),a||i.length)this.relatedNodes(i);else{if(o||r)return!1;this.relatedNodes(u),this.data({messageKey:"roleNotValid",roles:l.join(", ")})}return!0},"p-as-heading-evaluate":function(e,t,n){var a=(i=Array.from(e.parentNode.children)).indexOf(e),r=(t=t||{}).margins||[],o=i.slice(a+1).find((function(e){return"P"===e.nodeName.toUpperCase()})),i=i.slice(0,a).reverse().find((function(e){return"P"===e.nodeName.toUpperCase()})),u=(a=Cm(e),o?Cm(o):null),l=(i=i?Cm(i):null,t.passLength);return t=t.failLength,e=e.textContent.trim().length,(o=null==o?void 0:o.textContent.trim().length)*l<e||!u||!xm(a,u,r)||!!((l=mr(n,"blockquote"))&&"BLOCKQUOTE"===l.nodeName.toUpperCase()||i&&!xm(a,i,r)||o*t<e)&&void 0},"p-as-heading-matches":function(e){var t=Array.from(e.parentNode.childNodes),n=e.textContent.trim();return!(0===n.length||2<=(n.match(/[.!?:;](?![.!?:;])/g)||[]).length)&&0!==t.slice(t.indexOf(e)+1).filter((function(e){return"P"===e.nodeName.toUpperCase()&&""!==e.textContent.trim()})).length},"page-no-duplicate-after":function(e){return e.filter((function(e){return"ignored"!==e.data}))},"page-no-duplicate-evaluate":function(e,t,n){if(!t||!t.selector||"string"!=typeof t.selector)throw new TypeError("page-no-duplicate requires options.selector to be a string");var a="page-no-duplicate;"+t.selector;if(!Yn.get(a))return Yn.set(a,!0),a=ap(o._tree[0],t.selector,Mi),"string"==typeof t.nativeScopeFilter&&(a=a.filter((function(e){return e.actualNode.hasAttribute("role")||!mr(e,t.nativeScopeFilter)}))),"string"==typeof t.role&&(a=a.filter((function(e){return Bi(e)===t.role}))),this.relatedNodes(a.filter((function(e){return e!==n})).map((function(e){return e.actualNode}))),a.length<=1;this.data("ignored")},"presentation-role-conflict-matches":function(e,t){return null!==Ai(t,{chromiumRoles:!0})},"presentational-role-evaluate":function(e,t,n){var a=Qo(n);if(["presentation","none"].includes(a)&&["iframe","frame"].includes(n.props.nodeName)&&n.hasAttr("title"))this.data({messageKey:"iframe",nodeName:n.props.nodeName});else{var r,o=Bi(n);if(["presentation","none"].includes(o))return this.data({role:o}),!0;["presentation","none"].includes(a)&&(a=ti().some((function(e){return n.hasAttr(e)})),r=Mo(n),this.data({messageKey:a&&!r?"globalAria":!a&&r?"focusable":"both",role:o}))}return!1},"region-after":function(e){var t=e.filter((function(e){return e.data.isIframe}));return e.forEach((function(e){if(!e.result&&1!==e.node.ancestry.length){var n,a=e.node.ancestry.slice(0,-1),r=Z(t);try{for(r.s();!(n=r.n()).done;){var o=n.value;if(zd(a,o.node.ancestry)){e.result=o.result;break}}}catch(e){r.e(e)}finally{r.f()}}})),t.forEach((function(e){e.result||(e.result=!0)})),e},"region-evaluate":function(e,t,n){return this.data({isIframe:["iframe","frame"].includes(n.props.nodeName)}),!Yn.get("regionlessNodes",(function(){return function e(t,n){var r=t.actualNode;if("button"===Bi(t)||function(e,t){var n=e.actualNode,a=Bi(e),r=(n=(n.getAttribute("aria-live")||"").toLowerCase().trim(),Hp("landmark"));return!!(["assertive","polite"].includes(n)||Am.includes(a)||r.includes(a)||t.regionMatcher&&Ci(e,t.regionMatcher))}(t,n)||["iframe","frame"].includes(t.props.nodeName)||Oc(t.actualNode)&&No(t.actualNode,"href")||!Mi(r)){for(var o=t;o;)o._hasRegionDescendant=!0,o=o.parent;return["iframe","frame"].includes(t.props.nodeName)?[t]:[]}return r!==a.body&&Au(r,!0)?[t]:t.children.filter((function(e){return 1===(e=e.actualNode).nodeType})).map((function(t){return e(t,n)})).reduce((function(e,t){return e.concat(t)}),[])}(o._tree[0],t).map((function(e){for(;e.parent&&!e.parent._hasRegionDescendant&&e.parent.actualNode!==a.body;)e=e.parent;return e})).filter((function(e,t,n){return n.indexOf(e)===t}))})).includes(n)},"same-caption-summary-evaluate":function(e,t,n){var a;if(void 0!==n.children)return a=n.attr("summary"),!(!(n=!!(n=n.children.find(km))&&li(Zi(n)))||!a)&&li(a).toLowerCase()===li(n).toLowerCase()},"scope-value-evaluate":function(e,t){return e=e.getAttribute("scope").toLowerCase(),-1!==t.values.indexOf(e)},"scrollable-region-focusable-matches":function(e,t){return void 0!==Rd(e,13)&&!1===Qp(t)&&fp(t,"*").some((function(e){return xu(e,!0,!0)}))},"skip-link-evaluate":function(e){return!!(e=No(e,"href"))&&(Mi(e)||void 0)},"skip-link-matches":function(e){return Oc(e)&&qr(e)},"structured-dlitems-evaluate":function(e,t,n){var a=n.children;if(!a||!a.length)return!1;for(var r,o=!1,i=!1,u=0;u<a.length;u++){if((o="DT"===(r=a[u].props.nodeName.toUpperCase())||o)&&"DD"===r)return!1;"DD"===r&&(i=!0)}return o||i},"svg-namespace-matches":Tm,"svg-non-empty-title-evaluate":function(e,t,n){if(n.children){if(n=n.children.find((function(e){return"title"===e.props.nodeName})),!n)return this.data({messageKey:"noTitle"}),!1;try{if(""===Zi(n,{includeHidden:!0}).trim())return this.data({messageKey:"emptyTitle"}),!1}catch(e){return}return!0}},"tabindex-evaluate":function(e,t,n){return n=parseInt(n.attr("tabindex"),10),!!isNaN(n)||n<=0},"table-or-grid-role-matches":function(e,t){return t=Bi(t),["treegrid","grid","table"].includes(t)},"target-offset-evaluate":function(e,t,n){var a,r,o=(null==t?void 0:t.minOffset)||24,i=[],u=o,l=Z(go(n,o));try{for(l.s();!(a=l.n()).done;){var s,c=a.value;"widget"===Su(c)&&Mo(c)&&(o<=.05+(s=2*(r=Zr(n,c,o/2),Math.round(10*r)/10))||(u=Math.min(u,s),i.push(c)))}}catch(e){l.e(e)}finally{l.f()}return 0===i.length?(this.data({closestOffset:u,minOffset:o}),!0):(this.relatedNodes(i.map((function(e){return e.actualNode}))),i.some(Po)?(this.data({closestOffset:u,minOffset:o}),!Po(n)&&void 0):void this.data({messageKey:"nonTabbableNeighbor",closestOffset:u,minOffset:o}))},"target-size-evaluate":function(e,t,n){t=(null==t?void 0:t.minSize)||24;var a,r,o=n.boundingClientRect,i=Xr.bind(null,t),u=go(n),l=(a=n,u.filter((function(e){return!rm(e,a)&&im(a,e)}))),s=(u=function(e,t){var n,a=[],r=[],o=Z(t);try{for(o.s();!(n=o.n()).done;){var i=n.value;!im(e,i)&&Qr(e,i)&&"none"!==i.getComputedStylePropertyValue("pointer-events")&&(rm(e,i)?a:r).push(i)}}catch(e){o.e(e)}finally{o.f()}return{fullyObscuringElms:a,partialObscuringElms:r}}(n,u)).fullyObscuringElms;u=u.partialObscuringElms;return s.length&&!l.length?(this.relatedNodes(um(s)),this.data({messageKey:"obscured"}),!0):(r=!Po(n)&&void 0,i(o)||l.length?(u=function(e,t){return e=e.boundingClientRect,0===t.length?null:(t=t.map((function(e){return e.boundingClientRect})),function(e,t){return e.reduce((function(e,n){var a=Xr(t,e);return a!==Xr(t,n)?a?e:n:(a=e.width*e.height,n.width*n.height<a?e:n)}))}(eo(e,t)))}(n,n=u.filter((function(e){return"widget"===Su(e)&&Mo(e)}))),!l.length||!s.length&&i(u||o)?0===n.length||i(u)?(this.data($({minSize:t},om(u||o))),this.relatedNodes(um(n)),!0):(s=n.every(Po),i="partiallyObscured".concat(s?"":"NonTabbable"),this.data($({messageKey:i,minSize:t},om(u))),this.relatedNodes(um(n)),s?r:void 0):(this.data({minSize:t,messageKey:"contentOverflow"}),void this.relatedNodes(um(l)))):(this.data($({minSize:t},om(o))),r))},"td-has-header-evaluate":function(e){var t=[],n=Dm(e),a=ni(e);return n.forEach((function(e){Au(e)&&bm(e)&&!tf(e)&&!gm(e,a).some((function(e){return null!==e&&!!Au(e)}))&&t.push(e)})),!t.length||(this.relatedNodes(t),!1)},"td-headers-attr-evaluate":function(e){for(var t=[],n=[],a=[],r=0;r<e.rows.length;r++)for(var o=e.rows[r],i=0;i<o.cells.length;i++)t.push(o.cells[i]);var u=t.filter((function(e){return e.getAttribute("id")})).map((function(e){return e.getAttribute("id")}));return t.forEach((function(e){var t,r=!1;if(e.hasAttribute("headers")&&Mi(e))return(t=e.getAttribute("headers").trim())?void(0!==(t=Xc(t)).length&&(e.getAttribute("id")&&(r=-1!==t.indexOf(e.getAttribute("id").trim())),t=t.some((function(e){return!u.includes(e)})),r||t)&&a.push(e)):n.push(e)})),0<a.length?(this.relatedNodes(a),!1):!n.length||void this.relatedNodes(n)},"th-has-data-cells-evaluate":function(e){var t=Dm(e),n=this,a=[],r=(t=(t.forEach((function(e){var t;(t=((t=e.getAttribute("headers"))&&(a=a.concat(t.split(/\\s+/))),e.getAttribute("aria-labelledby")))&&(a=a.concat(t.split(/\\s+/)))})),t.filter((function(e){return""!==li(e.textContent)&&("TH"===e.nodeName.toUpperCase()||-1!==["rowheader","columnheader"].indexOf(e.getAttribute("role")))}))),ni(e)),o=!0;return t.forEach((function(e){var t,i;e.getAttribute("id")&&a.includes(e.getAttribute("id"))||(t=ai(e,r),i=!1,(i=!(i=oi(e)?Fm("down",t,r).find((function(t){return!oi(t)&&gm(t,r).includes(e)})):i)&&ii(e)?Fm("right",t,r).find((function(t){return!ii(t)&&gm(t,r).includes(e)})):i)||n.relatedNodes(e),o=o&&i)})),!!o||void 0},"title-only-evaluate":function(e,t,n){var a=Du(n),r=Ri(n);return n=n.attr("aria-describedby"),!(a||!r&&!n)},"unique-frame-title-after":function(e){var t={};return e.forEach((function(e){t[e.data]=void 0!==t[e.data]?++t[e.data]:0})),e.forEach((function(e){e.result=!!t[e.data]})),e},"unique-frame-title-evaluate":function(e,t,n){return n=li(n.attr("title")).toLowerCase(),this.data(n),!0},"unsupportedrole-evaluate":function(e,t,n){n=Bi(n,{dpub:!0,fallback:!0});var a=Zo(n);return a&&this.data(n),a},"valid-lang-evaluate":function(e,t,n){var a=[];return t.attributes.forEach((function(e){var r,o,i=n.attr(e);"string"==typeof i&&(r=od(i),o=t.value?!t.value.map(od).includes(r):!Ap(r),""!==r&&o||""!==i&&!li(i))&&a.push(e+'="'+n.attr(e)+'"')})),!!a.length&&!("html"!==n.props.nodeName&&!ku(n)||(this.data(a),0))},"valid-scrollable-semantics-evaluate":function(e,t){return(n=Qo(n=e))&&(Df[n]||t.roles.includes(n))||(t=(t=e).nodeName.toUpperCase(),mf[t])||!1;var n},"widget-not-inline-matches":function(e,t){return Sm.every((function(n){return n(e,t)}))},"window-is-top-matches":function(e){return e.ownerDocument.defaultView.self===e.ownerDocument.defaultView.top},"xml-lang-mismatch-evaluate":function(e,t,n){return od(n.attr("lang"))===od(n.attr("xml:lang"))},"xml-lang-mismatch-matches":function(e){var t=od(e.getAttribute("lang"));e=od(e.getAttribute("xml:lang"));return Ap(t)&&Ap(e)}},Im=function(e){this.id=e.id,this.data=null,this.relatedNodes=[],this.result=null};function Lm(e){if("string"!=typeof e)return e;if(Pm[e])return Pm[e];if(/^\\s*function[\\s\\w]*\\(/.test(e))return new Function("return "+e+";")();throw new ReferenceError("Function ID does not exist in the metadata-function-map: ".concat(e))}function jm(e){var t=0<arguments.length&&void 0!==e?e:{};return Array.isArray(t)||"object"!==r(t)?{value:t}:t}function qm(e){e&&(this.id=e.id,this.configure(e))}qm.prototype.enabled=!0,qm.prototype.run=function(e,t,n,a,r){var o=((t=t||{}).hasOwnProperty("enabled")?t:this).enabled,i=this.getOptions(t.options);if(o){var u;o=new Im(this),t=Qn(o,t,a,r);try{u=this.evaluate.call(t,e.actualNode,i,e,n)}catch(t){return e&&e.actualNode&&(t.errorNode=Qa.toSpec(e)),void r(t)}t.isAsync||(o.result=u,a(o))}else a(null)},qm.prototype.runSync=function(e,t,n){if(!(void 0===(r=(t=t||{}).enabled)?this.enabled:r))return null;var a,r=this.getOptions(t.options),o=new Im(this);(t=Qn(o,t)).async=function(){throw new Error("Cannot run async check while in a synchronous run")};try{a=this.evaluate.call(t,e.actualNode,r,e,n)}catch(t){throw e&&e.actualNode&&(t.errorNode=Qa.toSpec(e)),t}return o.result=a,o},qm.prototype.configure=function(e){var t=this;e.evaluate&&!Pm[e.evaluate]||(this._internalCheck=!0),e.hasOwnProperty("enabled")&&(this.enabled=e.enabled),e.hasOwnProperty("options")&&(this._internalCheck?this.options=jm(e.options):this.options=e.options),["evaluate","after"].filter((function(t){return e.hasOwnProperty(t)})).forEach((function(n){return t[n]=Lm(e[n])}))},qm.prototype.getOptions=function(e){return this._internalCheck?ir(this.options,jm(e||{})):e||this.options};var zm=qm,Vm=function(e){this.id=e.id,this.result=Qt.NA,this.pageLevel=e.pageLevel,this.impact=null,this.nodes=[]};function $m(e,t){this._audit=t,this.id=e.id,this.selector=e.selector||"*",e.impact&&(bn(Qt.impact.includes(e.impact),"Impact ".concat(e.impact," is not a valid impact")),this.impact=e.impact),this.excludeHidden="boolean"!=typeof e.excludeHidden||e.excludeHidden,this.enabled="boolean"!=typeof e.enabled||e.enabled,this.pageLevel="boolean"==typeof e.pageLevel&&e.pageLevel,this.reviewOnFail="boolean"==typeof e.reviewOnFail&&e.reviewOnFail,this.any=e.any||[],this.all=e.all||[],this.none=e.none||[],this.tags=e.tags||[],this.preload=!!e.preload,this.actIds=e.actIds,e.matches&&(this.matches=Lm(e.matches))}function Hm(e){var t,n;if(e.length)return t=!1,n={},e.forEach((function(e){var a=e.results.filter((function(e){return e}));(n[e.type]=a).length&&(t=!0)})),t?n:null}$m.prototype.matches=function(){return!0},$m.prototype.gather=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},n="mark_gather_start_"+this.id,a="mark_gather_end_"+this.id,r="mark_isVisibleToScreenReaders_start_"+this.id,o="mark_isVisibleToScreenReaders_end_"+this.id,i=(t.performanceTimer&&Jd.mark(n),bp(this.selector,e));return this.excludeHidden&&(t.performanceTimer&&Jd.mark(r),i=i.filter(Mi),t.performanceTimer)&&(Jd.mark(o),Jd.measure("rule_"+this.id+"#gather_axe.utils.isVisibleToScreenReaders",r,o)),t.performanceTimer&&(Jd.mark(a),Jd.measure("rule_"+this.id+"#gather",n,a)),i},$m.prototype.runChecks=function(e,t,n,a,r,o){var i=this,u=ha();this[e].forEach((function(e){var r=i._audit.checks[e.id||e],o=Dd(r,i.id,n);u.defer((function(e,n){r.run(t,o,a,e,n)}))})),u.then((function(t){t=t.filter((function(e){return e})),r({type:e,results:t})})).catch(o)},$m.prototype.runChecksSync=function(e,t,n,a){var r=this,o=[];return this[e].forEach((function(e){e=r._audit.checks[e.id||e];var i=Dd(e,r.id,n);o.push(e.runSync(t,i,a))})),{type:e,results:o=o.filter((function(e){return e}))}},$m.prototype.run=function(e){var t,n=this,a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},r=2<arguments.length?arguments[2]:void 0,o=3<arguments.length?arguments[3]:void 0,u=(a.performanceTimer&&this._trackPerformance(),ha()),l=new Vm(this);try{t=this.gatherAndMatchNodes(e,a)}catch(t){return void o(new i({cause:t,ruleId:this.id}))}a.performanceTimer&&this._logGatherPerformance(t),t.forEach((function(t){u.defer((function(r,o){var i=ha();["any","all","none"].forEach((function(r){i.defer((function(o,i){n.runChecks(r,t,a,e,o,i)}))})),i.then((function(e){var a=Hm(e);a&&(a.node=new Jn(t),l.nodes.push(a),n.reviewOnFail)&&(["any","all"].forEach((function(e){a[e].forEach((function(e){!1===e.result&&(e.result=void 0)}))})),a.none.forEach((function(e){!0===e.result&&(e.result=void 0)}))),r()})).catch((function(e){return o(e)}))}))})),u.defer((function(e){return setTimeout(e,0)})),a.performanceTimer&&this._logRulePerformance(),u.then((function(){return r(l)})).catch((function(e){return o(e)}))},$m.prototype.runSync=function(e){var t,n=this,a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},r=(a.performanceTimer&&this._trackPerformance(),new Vm(this));try{t=this.gatherAndMatchNodes(e,a)}catch(t){throw new i({cause:t,ruleId:this.id})}return a.performanceTimer&&this._logGatherPerformance(t),t.forEach((function(t){var o=[],i=(["any","all","none"].forEach((function(r){o.push(n.runChecksSync(r,t,a,e))})),Hm(o));i&&(i.node=t.actualNode?new Jn(t):null,r.nodes.push(i),n.reviewOnFail)&&(["any","all"].forEach((function(e){i[e].forEach((function(e){!1===e.result&&(e.result=void 0)}))})),i.none.forEach((function(e){!0===e.result&&(e.result=void 0)})))})),a.performanceTimer&&this._logRulePerformance(),r},$m.prototype._trackPerformance=function(){this._markStart="mark_rule_start_"+this.id,this._markEnd="mark_rule_end_"+this.id,this._markChecksStart="mark_runchecks_start_"+this.id,this._markChecksEnd="mark_runchecks_end_"+this.id},$m.prototype._logGatherPerformance=function(e){en("gather (",e.length,"):",Jd.timeElapsed()+"ms"),Jd.mark(this._markChecksStart)},$m.prototype._logRulePerformance=function(){Jd.mark(this._markChecksEnd),Jd.mark(this._markEnd),Jd.measure("runchecks_"+this.id,this._markChecksStart,this._markChecksEnd),Jd.measure("rule_"+this.id,this._markStart,this._markEnd)},$m.prototype.gatherAndMatchNodes=function(e,t){var n=this,a="mark_matches_start_"+this.id,r="mark_matches_end_"+this.id,o=this.gather(e,t);return t.performanceTimer&&Jd.mark(a),o=o.filter((function(t){return n.matches(t.actualNode,t,e)})),t.performanceTimer&&(Jd.mark(r),Jd.measure("rule_"+this.id+"#matches",a,r)),o},$m.prototype.after=function(e,t){var n,a,r,o=this,i=er(n=this).map((function(e){return(e=n._audit.checks[e.id||e])&&"function"==typeof e.after?e:null})).filter(Boolean),u=this.id;return i.forEach((function(n){i=e.nodes,a=n.id,r=[],i.forEach((function(e){er(e).forEach((function(t){t.id===a&&(t.node=e.node,r.push(t))}))}));var a,r,i=r,l=Dd(n,u,t),s=n.after(i,l.options);o.reviewOnFail&&s.forEach((function(e){var t=(o.any.includes(e.id)||o.all.includes(e.id))&&!1===e.result,n=o.none.includes(e.id)&&!0===e.result;(t||n)&&(e.result=void 0)})),i.forEach((function(e){delete e.node,-1===s.indexOf(e)&&(e.filtered=!0)}))})),e.nodes=(a=["any","all","none"],r=(i=e).nodes.filter((function(e){var t=0;return a.forEach((function(n){e[n]=e[n].filter((function(e){return!0!==e.filtered})),t+=e[n].length})),0<t})),r=i.pageLevel&&r.length?[r.reduce((function(e,t){if(e)return a.forEach((function(n){e[n].push.apply(e[n],t[n])})),e}))]:r),e},$m.prototype.configure=function(e){e.hasOwnProperty("selector")&&(this.selector=e.selector),e.hasOwnProperty("excludeHidden")&&(this.excludeHidden="boolean"!=typeof e.excludeHidden||e.excludeHidden),e.hasOwnProperty("enabled")&&(this.enabled="boolean"!=typeof e.enabled||e.enabled),e.hasOwnProperty("pageLevel")&&(this.pageLevel="boolean"==typeof e.pageLevel&&e.pageLevel),e.hasOwnProperty("reviewOnFail")&&(this.reviewOnFail="boolean"==typeof e.reviewOnFail&&e.reviewOnFail),e.hasOwnProperty("any")&&(this.any=e.any),e.hasOwnProperty("all")&&(this.all=e.all),e.hasOwnProperty("none")&&(this.none=e.none),e.hasOwnProperty("tags")&&(this.tags=e.tags),e.hasOwnProperty("actIds")&&(this.actIds=e.actIds),e.hasOwnProperty("matches")&&(this.matches=Lm(e.matches)),e.impact&&(bn(Qt.impact.includes(e.impact),"Impact ".concat(e.impact," is not a valid impact")),this.impact=e.impact)};var Um=ne(Yt()),Gm=/\\{\\{.+?\\}\\}/g;function Wm(e){W(this,Wm),this.lang="en",this.defaultConfig=e,this.standards=Xo,this._init(),this._defaultLocale=null}K(Wm,[{key:"_setDefaultLocale",value:function(){if(!this._defaultLocale){for(var e={checks:{},rules:{},failureSummaries:{},incompleteFallbackMessage:"",lang:this.lang},t=Object.keys(this.data.checks),n=0;n<t.length;n++){var a=t[n],r=(i=this.data.checks[a].messages).pass,o=i.fail,i=i.incomplete;e.checks[a]={pass:r,fail:o,incomplete:i}}for(var u=Object.keys(this.data.rules),l=0;l<u.length;l++){var s=u[l],c=(d=this.data.rules[s]).description,d=d.help;e.rules[s]={description:c,help:d}}for(var p=Object.keys(this.data.failureSummaries),f=0;f<p.length;f++){var m=p[f],D=this.data.failureSummaries[m].failureMessage;e.failureSummaries[m]={failureMessage:D}}e.incompleteFallbackMessage=this.data.incompleteFallbackMessage,this._defaultLocale=e}}},{key:"_resetLocale",value:function(){var e=this._defaultLocale;e&&this.applyLocale(e)}},{key:"_applyCheckLocale",value:function(e){for(var t=Object.keys(e),n=0;n<t.length;n++){var a=t[n];if(!this.data.checks[a])throw new Error('Locale provided for unknown check: "'.concat(a,'"'));this.data.checks[a]=Zm(this.data.checks[a],e[a])}}},{key:"_applyRuleLocale",value:function(e){for(var t=Object.keys(e),n=0;n<t.length;n++){var a=t[n];if(!this.data.rules[a])throw new Error('Locale provided for unknown rule: "'.concat(a,'"'));this.data.rules[a]=Jm(this.data.rules[a],e[a])}}},{key:"_applyFailureSummaries",value:function(e){for(var t=Object.keys(e),n=0;n<t.length;n++){var a=t[n];if(!this.data.failureSummaries[a])throw new Error('Locale provided for unknown failureMessage: "'.concat(a,'"'));this.data.failureSummaries[a]=Qm(this.data.failureSummaries[a],e[a])}}},{key:"applyLocale",value:function(e){this._setDefaultLocale(),e.checks&&this._applyCheckLocale(e.checks),e.rules&&this._applyRuleLocale(e.rules),e.failureSummaries&&this._applyFailureSummaries(e.failureSummaries,"failureSummaries"),e.incompleteFallbackMessage&&(this.data.incompleteFallbackMessage=eD(this.data.incompleteFallbackMessage,e.incompleteFallbackMessage)),e.lang&&(this.lang=e.lang)}},{key:"setAllowedOrigins",value:function(e){var t,n=Km(),a=(this.allowedOrigins=[],Z(e));try{for(a.s();!(t=a.n()).done;){var r=t.value;if(r===Qt.allOrigins)return void(this.allowedOrigins=["*"]);r!==Qt.sameOrigin?this.allowedOrigins.push(r):n&&this.allowedOrigins.push(n)}}catch(e){a.e(e)}finally{a.f()}}},{key:"_init",value:function(){var e=function(e){var t;return e?(t=ea(e)).commons=e.commons:t={},t.reporter=t.reporter||null,t.noHtml=t.noHtml||!1,t.allowedOrigins||(e=Km(),t.allowedOrigins=e?[e]:[]),t.rules=t.rules||[],t.checks=t.checks||[],t.data=$({checks:{},rules:{}},t.data),t}(this.defaultConfig);this.lang=e.lang||"en",this.reporter=e.reporter,this.commands={},this.rules=[],this.checks={},this.brand="axe",this.application="axeAPI",this.tagExclude=["experimental"],this.noHtml=e.noHtml,this.allowedOrigins=e.allowedOrigins,Xm(e.rules,this,"addRule"),Xm(e.checks,this,"addCheck"),this.data={},this.data.checks=e.data&&e.data.checks||{},this.data.rules=e.data&&e.data.rules||{},this.data.failureSummaries=e.data&&e.data.failureSummaries||{},this.data.incompleteFallbackMessage=e.data&&e.data.incompleteFallbackMessage||"",this._constructHelpUrls()}},{key:"registerCommand",value:function(e){this.commands[e.id]=e.callback}},{key:"addRule",value:function(e){e.metadata&&(this.data.rules[e.id]=e.metadata);var t=this.getRule(e.id);t?t.configure(e):this.rules.push(new $m(e,this))}},{key:"addCheck",value:function(e){var t=e.metadata;"object"===r(t)&&(this.data.checks[e.id]=t,"object"===r(t.messages))&&Object.keys(t.messages).filter((function(e){return t.messages.hasOwnProperty(e)&&"string"==typeof t.messages[e]})).forEach((function(e){0===t.messages[e].indexOf("function")&&(t.messages[e]=new Function("return "+t.messages[e]+";")())})),this.checks[e.id]?this.checks[e.id].configure(e):this.checks[e.id]=new zm(e)}},{key:"run",value:function(e,t,n,a){this.normalizeOptions(t),Jn.setRunOptions(t),o._selectCache=[],u=this.rules,r=e,i=t;var r,i,u=u.reduce((function(e,t){return Dp(t,r,i)&&(t.preload?e.later:e.now).push(t),e}),{now:[],later:[]}),l=u.now,s=u.later,c=ha();l.forEach((function(n){c.defer(tD(n,e,t))})),u=ha();(l=(s.length&&u.defer((function(e){lp(t).then((function(t){return e(t)})).catch((function(t){console.warn("Couldn't load preload assets: ",t),e(void 0)}))})),ha())).defer(c),l.defer(u),l.then((function(r){var i,u=r.pop(),l=(u&&u.length&&(u=u[0])&&(e=$({},e,u)),r[0]);s.length?(i=ha(),s.forEach((function(n){n=tD(n,e,t),i.defer(n)})),i.then((function(e){o._selectCache=void 0,n(l.concat(e).filter((function(e){return!!e})))})).catch(a)):(o._selectCache=void 0,n(l.filter((function(e){return!!e}))))})).catch(a)}},{key:"after",value:function(e,t){var n=this.rules;return e.map((function(e){var a=tr(n,"id",e.id);if(a)return a.after(e,t);throw new Error("Result for unknown rule. You may be running mismatch axe-core versions")}))}},{key:"getRule",value:function(e){return this.rules.find((function(t){return t.id===e}))}},{key:"normalizeOptions",value:function(e){var t=[],n=[];if(this.rules.forEach((function(e){n.push(e.id),e.tags.forEach((function(e){t.includes(e)||t.push(e)}))})),["object","string"].includes(r(e.runOnly))){if("string"==typeof e.runOnly&&(e.runOnly=[e.runOnly]),Array.isArray(e.runOnly)){var a=e.runOnly.find((function(e){return t.includes(e)})),i=e.runOnly.find((function(e){return n.includes(e)}));if(a&&i)throw new Error("runOnly cannot be both rules and tags");e.runOnly=i?{type:"rule",values:e.runOnly}:{type:"tag",values:e.runOnly}}if((a=e.runOnly).value&&!a.values&&(a.values=a.value,delete a.value),!Array.isArray(a.values)||0===a.values.length)throw new Error("runOnly.values must be a non-empty array");if(["rule","rules"].includes(a.type))a.type="rule",a.values.forEach((function(e){if(!n.includes(e))throw new Error("unknown rule \`"+e+"\` in options.runOnly")}));else{if(!["tag","tags",void 0].includes(a.type))throw new Error("Unknown runOnly type '".concat(a.type,"'"));a.type="tag",i=a.values.filter((function(e){return!t.includes(e)&&!/wcag2[1-3]a{1,3}/.test(e)})),0!==i.length&&o.log("Could not find tags \`"+i.join("\`, \`")+"\`")}}return"object"===r(e.rules)&&Object.keys(e.rules).forEach((function(e){if(!n.includes(e))throw new Error("unknown rule \`"+e+"\` in options.rules")})),e}},{key:"setBranding",value:function(e){var t={brand:this.brand,application:this.application};"string"==typeof e&&(this.application=e),e&&e.hasOwnProperty("brand")&&e.brand&&"string"==typeof e.brand&&(this.brand=e.brand),e&&e.hasOwnProperty("application")&&e.application&&"string"==typeof e.application&&(this.application=e.application),this._constructHelpUrls(t)}},{key:"_constructHelpUrls",value:function(){var e=this,t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:null,n=(o.version.match(/^[1-9][0-9]*\\.[0-9]+/)||["x.y"])[0];this.rules.forEach((function(a){e.data.rules[a.id]||(e.data.rules[a.id]={});var r=e.data.rules[a.id];("string"!=typeof r.helpUrl||t&&r.helpUrl===nD(t,a.id,n))&&(r.helpUrl=nD(e,a.id,n))}))}},{key:"resetRulesAndChecks",value:function(){this._init(),this._resetLocale()}}]);var Ym=Wm;function Km(){return t.origin&&"null"!==t.origin?t.origin:t.location&&t.location.origin&&"null"!==t.location.origin?t.location.origin:void 0}function Xm(e,t,n){for(var a=0,r=e.length;a<r;a++)t[n](e[a])}var Zm=function(e,t){var n=t.pass,a=t.fail;return"string"==typeof n&&Gm.test(n)&&(n=Um.default.compile(n)),"string"==typeof a&&Gm.test(a)&&(a=Um.default.compile(a)),$({},e,{messages:{pass:n||e.messages.pass,fail:a||e.messages.fail,incomplete:"object"===r(e.messages.incomplete)?$({},e.messages.incomplete,t.incomplete):t.incomplete}})},Jm=function(e,t){var n=t.help;t=t.description;return"string"==typeof n&&Gm.test(n)&&(n=Um.default.compile(n)),"string"==typeof t&&Gm.test(t)&&(t=Um.default.compile(t)),$({},e,{help:n||e.help,description:t||e.description})},Qm=function(e,t){return $({},e,{failureMessage:(t="string"==typeof(t=t.failureMessage)&&Gm.test(t)?Um.default.compile(t):t)||e.failureMessage})},eD=function(e,t){return(t="string"==typeof t&&Gm.test(t)?Um.default.compile(t):t)||e};function tD(e,t,n){return n.performanceTimer&&Jd.mark("mark_rule_start_"+e.id),function(a,r){e.run(t,n,(function(e){a(e)}),(function(t){n.debug?r(t):(t=Object.assign(new Vm(e),{result:Qt.CANTTELL,description:"An error occured while running this rule",message:t.message,stack:t.stack,error:t,errorNode:t.errorNode}),a(t))}))}}function nD(e,t,n){var a=e.brand,r=e.application;e=e.lang;return Qt.helpUrlBase+a+"/"+(n||o.version.substring(0,o.version.lastIndexOf(".")))+"/"+t+"?application="+encodeURIComponent(r)+(e&&"en"!==e?"&lang="+encodeURIComponent(e):"")}function aD(e){var n=t&&"Node"in t&&"NodeList"in t,r=!!a;if(!n||!r){if(!e||!e.ownerDocument)throw new Error('Required "window" or "document" globals not defined and cannot be deduced from the context. Either set the globals before running or pass in a valid Element.');r||(Yn.set("globalDocumentSet",!0),a=e.ownerDocument),n||(Yn.set("globalWindowSet",!0),t=a.defaultView)}}var rD=function(){Yn.get("globalDocumentSet")&&(Yn.set("globalDocumentSet",!1),a=null),Yn.get("globalWindowSet")&&(Yn.set("globalWindowSet",!1),t=null),o._memoizedFns.forEach((function(e){return e.clear()})),Yn.clear(),o._tree=void 0,o._selectorData=void 0,o._selectCache=void 0};function oD(e,t,n,a){try{e=new kd(e),o._tree=e.flatTree,o._selectorData=jn(e.flatTree)}catch(r){return rD(),a(r)}var r=ha(),i=o._audit;t.performanceTimer&&Jd.auditStart(),e.frames.length&&!1!==t.iframes&&r.defer((function(n,a){rr(e,t,"rules",null,n,a)})),r.defer((function(n,a){i.run(e,t,n,a)})),r.then((function(r){try{t.performanceTimer&&Jd.auditEnd();var o=ar(r.map((function(e){return{results:e}})));e.initiator&&((o=i.after(o,t)).forEach(dp),o=o.map(fn));try{n(o,rD)}catch(r){rD(),en(r)}}catch(r){rD(),a(r)}})).catch((function(e){rD(),a(e)}))}function iD(e){this._run=e.run,this._collect=e.collect,this._registry={},e.commands.forEach((function(e){o._audit.registerCommand(e)}))}function uD(e){var t,n=(e=H(e,3))[0],i=e[1],u=(e=e[2],new TypeError("axe.run arguments are invalid"));if(!vd(t=n)&&!yd(t)){if(void 0!==e)throw u;e=i,i=n,n=a}if("object"!==r(i)){if(void 0!==e)throw u;e=i,i={}}if("function"!=typeof e&&void 0!==e)throw u;return(i=ea(i)).reporter=null!=(t=null!=(t=i.reporter)?t:null==(u=o._audit)?void 0:u.reporter)?t:"v1",{context:n,options:i,callback:e}}t.top!==t&&(Ga.subscribe("axe.start",(function(e,t,n){function r(e){e instanceof Error==0&&(e=new Error(e)),n(e)}var i=n,u=e&&e.context||{},l=(u.hasOwnProperty("include")&&!u.include.length&&(u.include=[a]),e&&e.options||{});switch(e.command){case"rules":return oD(u,l,(function(e,t){e=Qa.mapRawResults(e),i(e),t()}),r);case"cleanup-plugin":return _p(i,r);default:if(o._audit&&o._audit.commands&&o._audit.commands[e.command])return o._audit.commands[e.command](e,n)}})),Ga.subscribe("axe.ping",(function(e,t,n){n({axe:!0})}))),iD.prototype.run=function(){return this._run.apply(this,arguments)},iD.prototype.collect=function(){return this._collect.apply(this,arguments)},iD.prototype.cleanup=function(e){var t=o.utils.queue(),n=this;Object.keys(this._registry).forEach((function(e){t.defer((function(t){n._registry[e].cleanup(t)}))})),t.then(e)},iD.prototype.add=function(e){this._registry[e.id]=e};var lD=function(){};var sD=function(e,t,n){if("function"==typeof t&&(n=t,t={}),!e||!Array.isArray(e))return n(e);n(e.map((function(e){for(var t=$({},e),n=0,a=["passes","violations","incomplete","inapplicable"];n<a.length;n++){var r=a[n];t[r]=Qa.mapRawNodeResults(t[r])}return t})))};Ws={base:{Audit:Ym,CheckResult:Im,Check:zm,Context:kd,RuleResult:Vm,Rule:$m,metadataFunctionMap:Pm},public:{reporters:Sp},helpers:{failureSummary:id,incompleteFallbackMessage:ud,processAggregate:sd},utils:{setDefaultFrameMessenger:Ha,cacheNodeSelectors:nd,getNodesMatchingExpression:Jc,convertSelector:la},commons:{dom:{nativelyHidden:Fr,displayHidden:wr,visibilityHidden:Er,contentVisibiltyHidden:Cr,ariaHidden:xr,opacityHidden:Ar,scrollHidden:kr,overflowHidden:Nr,clipHidden:Br,areaHidden:Tr,detailsHidden:Rr}}};o._thisWillBeDeletedDoNotUse=Ws,o.constants=Qt,o.log=en,o.AbstractVirtualNode=an,o.SerialVirtualNode=Rp,o.VirtualNode=Kc,o._cache=Yn,o.imports=Go,o.cleanup=_p,o.configure=function(e){var t=o._audit;if(!t)throw new Error("No audit configured");if(e.axeVersion||e.ver){var n=e.axeVersion||e.ver;if(!/^\\d+\\.\\d+\\.\\d+(-canary)?/.test(n))throw new Error("Invalid configured version ".concat(n));var a=(r=H(n.split("-"),2))[0],r=r[1],i=(a=H(a.split(".").map(Number),3))[0],u=a[1],l=(a=a[2],(s=H(o.version.split("-"),2))[0]),s=s[1],c=(l=H(l.split(".").map(Number),3))[0],d=l[1];l=l[2];if(i!==c||d<u||d===u&&l<a||i===c&&u===d&&a===l&&r&&r!==s)throw new Error("Configured version ".concat(n," is not compatible with current axe version ").concat(o.version))}if(e.reporter&&("function"==typeof e.reporter||Op(e.reporter))&&(t.reporter=e.reporter),e.checks){if(!Array.isArray(e.checks))throw new TypeError("Checks property must be an array");e.checks.forEach((function(e){if(!e.id)throw new TypeError("Configured check ".concat(JSON.stringify(e)," is invalid. Checks must be an object with at least an id property"));t.addCheck(e)}))}var p,f=[];if(e.rules){if(!Array.isArray(e.rules))throw new TypeError("Rules property must be an array");e.rules.forEach((function(e){if(!e.id)throw new TypeError("Configured rule ".concat(JSON.stringify(e)," is invalid. Rules must be an object with at least an id property"));f.push(e.id),t.addRule(e)}))}if(e.disableOtherRules&&t.rules.forEach((function(e){!1===f.includes(e.id)&&(e.enabled=!1)})),void 0!==e.branding?t.setBranding(e.branding):t._constructHelpUrls(),e.tagExclude&&(t.tagExclude=e.tagExclude),e.locale&&t.applyLocale(e.locale),e.standards&&(p=e.standards,Object.keys(Ko).forEach((function(e){p[e]&&(Ko[e]=ir(Ko[e],p[e]))}))),e.noHtml&&(t.noHtml=!0),e.allowedOrigins){if(!Array.isArray(e.allowedOrigins))throw new TypeError("Allowed origins property must be an array");if(e.allowedOrigins.includes("*"))throw new Error('"*" is not allowed. Use "'.concat(Qt.allOrigins,'" instead'));t.setAllowedOrigins(e.allowedOrigins)}},o.frameMessenger=function(e){Ga.updateMessenger(e)},o.getRules=function(e){var t=(e=e||[]).length?o._audit.rules.filter((function(t){return!!e.filter((function(e){return-1!==t.tags.indexOf(e)})).length})):o._audit.rules,n=o._audit.data.rules||{};return t.map((function(e){var t=n[e.id]||{};return{ruleId:e.id,description:t.description,help:t.help,helpUrl:t.helpUrl,tags:e.tags,actIds:e.actIds}}))},o._load=function(e){o._audit=new Ym(e)},o.plugins={},o.registerPlugin=function(e){o.plugins[e.id]=new iD(e)},o.hasReporter=Op,o.getReporter=Mp,o.addReporter=function(e,t,n){Sp[e]=t,n&&(Np=t)},o.reset=function(){var e=o._audit;if(!e)throw new Error("No audit configured");e.resetRulesAndChecks(),Object.keys(Ko).forEach((function(e){Ko[e]=Yo[e]}))},o._runRules=oD,o.runVirtualRule=function(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},a=(n.reporter=n.reporter||o._audit.reporter||"v1",o._selectorData={},t instanceof an||(t=new Rp(t)),Bd(e));if(a)return dp(a=(a=Object.create(a,{excludeHidden:{value:!1}})).runSync({initiator:!0,include:[t],exclude:[],frames:[],page:!1,focusable:!0,size:{},flatTree:[]},n)),fn(a),(a=hn([a])).violations.forEach((function(e){return e.nodes.forEach((function(e){e.failureSummary=id(e)}))})),$({},hd(),a,{toolOptions:n});throw new Error("unknown rule \`"+e+"\`")},o.run=function(){for(var e=arguments.length,t=new Array(e),n=0;n<e;n++)t[n]=arguments[n];aD(t[0]);var a=(c=uD(t)).context,r=c.options,i=void 0===(c=c.callback)?lD:c,u=(c=function(e){var t,n,a;return"function"==typeof Promise&&e===lD?t=new Promise((function(e,t){n=t,a=e})):(a=function(t){return e(null,t)},n=function(t){return e(t)}),{thenable:t,reject:n,resolve:a}}(i)).thenable,l=c.resolve,s=c.reject;try{bn(o._audit,"No audit configured"),bn(!o._running,"Axe is already running. Use \`await axe.run()\` to wait for the previous run to finish before starting a new run.")}catch(e){var c=e;if("function"!=typeof i||i===lD)throw c;return void i(c.message)}return o._running=!0,r.performanceTimer&&o.utils.performanceTimer.start(),o._runRules(a,r,(function(e,t){function n(e){o._running=!1,t();try{s(e)}catch(e){o.log(e)}}r.performanceTimer&&o.utils.performanceTimer.end();try{var a=e,i=r,u=function(e){o._running=!1,t();try{l(e)}catch(e){o.log(e)}},c=n;void 0!==(a=Mp(i.reporter)(a,i,u,c))&&u(a)}catch(e){n(e)}}),(function(e){r.performanceTimer&&o.utils.performanceTimer.end(),o._running=!1,i(e),s(e)})),u},o.setup=function(e){if(o._tree)throw new Error("Axe is already setup. Call \`axe.teardown()\` before calling \`axe.setup\` again.");return aD(e=e&&"object"===r(e.documentElement)&&"object"===r(e.defaultView)?e.documentElement:e),o._tree=ad(e),o._selectorData=jn(o._tree),o._tree[0]},o.teardown=rD,o.runPartial=function(){for(var e=arguments.length,t=new Array(e),n=0;n<e;n++)t[n]=arguments[n];var a=(r=uD(t)).options,r=r.context,i=(bn(o._audit,"Axe is not configured. Audit is missing."),bn(!o._running,"Axe is already running. Use \`await axe.run()\` to wait for the previous run to finish before starting a new run."),new kd(r,o._tree));return o._tree=i.flatTree,o._selectorData=jn(i.flatTree),o._running=!0,a.elementRef=!1,new Promise((function(e,t){o._audit.run(i,a,e,t)})).then((function(e){e=Qa.mapRawResults(e);var t,n=i.frames.map((function(e){return e=e.node,Qa.toSpec(e)}));return i.initiator&&(t=hd()),o._running=!1,rD(),{results:e,frames:n,environmentData:t}})).catch((function(e){return o._running=!1,rD(),Promise.reject(e)}))},o.finishRun=function(e){var t,n=ea(n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}),a=(e.find((function(e){return e.environmentData}))||{}).environmentData;o._audit.normalizeOptions(n),n.reporter=null!=(p=null!=(p=n.reporter)?p:null==(p=o._audit)?void 0:p.reporter)?p:"v1";var r=[],i=Z(p=e);try{for(i.s();!(t=i.n()).done;){var u,l=t.value,s=r.shift();l&&(l.frameSpec=null!=s?s:null,u=function(e){var t=e.frames,n=e.frameSpec;return n?t.map((function(e){return Qa.mergeSpecs(e,n)})):t}(l),r.unshift.apply(r,z(u)))}}catch(e){i.e(e)}finally{i.f()}var c,d,p=ar(e);return(p=o._audit.after(p,n)).forEach(dp),p=p.map(fn),c=p,d=$({environmentData:a},n),new Promise((function(e,t){Mp(d.reporter)(c,d,e,t)}))},o.commons=Hl,o.utils=rn,o.addReporter("na",(function(e,t,n){console.warn('"na" reporter will be deprecated in axe v4.0. Use the "v2" reporter instead.'),"function"==typeof t&&(n=t,t={});var a=t.environmentData,r=q(r=t,F);n($({},hd(a),{toolOptions:r},sd(e,t)))})),o.addReporter("no-passes",(function(e,t,n){"function"==typeof t&&(n=t,t={});var a=t.environmentData,r=q(r=t,w);t.resultTypes=["violations"],e=sd(e,t).violations,n($({},hd(a),{toolOptions:r,violations:e}))})),o.addReporter("rawEnv",(function(e,t,n){"function"==typeof t&&(n=t,t={});var a=t.environmentData;t=q(t,E),sD(e,t,(function(e){var t=hd(a);n({raw:e,env:t})}))})),o.addReporter("raw",sD),o.addReporter("v1",(function(e,t,n){function a(e){e.nodes.forEach((function(e){e.failureSummary=id(e)}))}"function"==typeof t&&(n=t,t={});var r=t.environmentData,o=q(o=t,C);(e=sd(e,t)).incomplete.forEach(a),e.violations.forEach(a),n($({},hd(r),{toolOptions:o},e))})),o.addReporter("v2",(function(e,t,n){"function"==typeof t&&(n=t,t={});var a=t.environmentData,r=q(r=t,x);e=sd(e,t),n($({},hd(a),{toolOptions:r},e))}),!0),o._load({lang:"en",data:{rules:{accesskeys:{description:"Ensures every accesskey attribute value is unique",help:"accesskey attribute value should be unique"},"area-alt":{description:"Ensures <area> elements of image maps have alternate text",help:"Active <area> elements must have alternate text"},"aria-allowed-attr":{description:"Ensures an element's role supports its ARIA attributes",help:"Elements must only use supported ARIA attributes"},"aria-allowed-role":{description:"Ensures role attribute has an appropriate value for the element",help:"ARIA role should be appropriate for the element"},"aria-braille-equivalent":{description:"Ensure aria-braillelabel and aria-brailleroledescription have a non-braille equivalent",help:"aria-braille attributes must have a non-braille equivalent"},"aria-command-name":{description:"Ensures every ARIA button, link and menuitem has an accessible name",help:"ARIA commands must have an accessible name"},"aria-conditional-attr":{description:"Ensures ARIA attributes are used as described in the specification of the element's role",help:"ARIA attributes must be used as specified for the element's role"},"aria-deprecated-role":{description:"Ensures elements do not use deprecated roles",help:"Deprecated ARIA roles must not be used"},"aria-dialog-name":{description:"Ensures every ARIA dialog and alertdialog node has an accessible name",help:"ARIA dialog and alertdialog nodes should have an accessible name"},"aria-hidden-body":{description:'Ensures aria-hidden="true" is not present on the document body.',help:'aria-hidden="true" must not be present on the document body'},"aria-hidden-focus":{description:"Ensures aria-hidden elements are not focusable nor contain focusable elements",help:"ARIA hidden element must not be focusable or contain focusable elements"},"aria-input-field-name":{description:"Ensures every ARIA input field has an accessible name",help:"ARIA input fields must have an accessible name"},"aria-meter-name":{description:"Ensures every ARIA meter node has an accessible name",help:"ARIA meter nodes must have an accessible name"},"aria-progressbar-name":{description:"Ensures every ARIA progressbar node has an accessible name",help:"ARIA progressbar nodes must have an accessible name"},"aria-prohibited-attr":{description:"Ensures ARIA attributes are not prohibited for an element's role",help:"Elements must only use permitted ARIA attributes"},"aria-required-attr":{description:"Ensures elements with ARIA roles have all required ARIA attributes",help:"Required ARIA attributes must be provided"},"aria-required-children":{description:"Ensures elements with an ARIA role that require child roles contain them",help:"Certain ARIA roles must contain particular children"},"aria-required-parent":{description:"Ensures elements with an ARIA role that require parent roles are contained by them",help:"Certain ARIA roles must be contained by particular parents"},"aria-roledescription":{description:"Ensure aria-roledescription is only used on elements with an implicit or explicit role",help:"aria-roledescription must be on elements with a semantic role"},"aria-roles":{description:"Ensures all elements with a role attribute use a valid value",help:"ARIA roles used must conform to valid values"},"aria-text":{description:'Ensures role="text" is used on elements with no focusable descendants',help:'"role=text" should have no focusable descendants'},"aria-toggle-field-name":{description:"Ensures every ARIA toggle field has an accessible name",help:"ARIA toggle fields must have an accessible name"},"aria-tooltip-name":{description:"Ensures every ARIA tooltip node has an accessible name",help:"ARIA tooltip nodes must have an accessible name"},"aria-treeitem-name":{description:"Ensures every ARIA treeitem node has an accessible name",help:"ARIA treeitem nodes should have an accessible name"},"aria-valid-attr-value":{description:"Ensures all ARIA attributes have valid values",help:"ARIA attributes must conform to valid values"},"aria-valid-attr":{description:"Ensures attributes that begin with aria- are valid ARIA attributes",help:"ARIA attributes must conform to valid names"},"audio-caption":{description:"Ensures <audio> elements have captions",help:"<audio> elements must have a captions track"},"autocomplete-valid":{description:"Ensure the autocomplete attribute is correct and suitable for the form field",help:"autocomplete attribute must be used correctly"},"avoid-inline-spacing":{description:"Ensure that text spacing set through style attributes can be adjusted with custom stylesheets",help:"Inline text spacing must be adjustable with custom stylesheets"},blink:{description:"Ensures <blink> elements are not used",help:"<blink> elements are deprecated and must not be used"},"button-name":{description:"Ensures buttons have discernible text",help:"Buttons must have discernible text"},bypass:{description:"Ensures each page has at least one mechanism for a user to bypass navigation and jump straight to the content",help:"Page must have means to bypass repeated blocks"},"color-contrast-enhanced":{description:"Ensures the contrast between foreground and background colors meets WCAG 2 AAA enhanced contrast ratio thresholds",help:"Elements must meet enhanced color contrast ratio thresholds"},"color-contrast":{description:"Ensures the contrast between foreground and background colors meets WCAG 2 AA minimum contrast ratio thresholds",help:"Elements must meet minimum color contrast ratio thresholds"},"css-orientation-lock":{description:"Ensures content is not locked to any specific display orientation, and the content is operable in all display orientations",help:"CSS Media queries must not lock display orientation"},"definition-list":{description:"Ensures <dl> elements are structured correctly",help:"<dl> elements must only directly contain properly-ordered <dt> and <dd> groups, <script>, <template> or <div> elements"},dlitem:{description:"Ensures <dt> and <dd> elements are contained by a <dl>",help:"<dt> and <dd> elements must be contained by a <dl>"},"document-title":{description:"Ensures each HTML document contains a non-empty <title> element",help:"Documents must have <title> element to aid in navigation"},"duplicate-id-active":{description:"Ensures every id attribute value of active elements is unique",help:"IDs of active elements must be unique"},"duplicate-id-aria":{description:"Ensures every id attribute value used in ARIA and in labels is unique",help:"IDs used in ARIA and labels must be unique"},"duplicate-id":{description:"Ensures every id attribute value is unique",help:"id attribute value must be unique"},"empty-heading":{description:"Ensures headings have discernible text",help:"Headings should not be empty"},"empty-table-header":{description:"Ensures table headers have discernible text",help:"Table header text should not be empty"},"focus-order-semantics":{description:"Ensures elements in the focus order have a role appropriate for interactive content",help:"Elements in the focus order should have an appropriate role"},"form-field-multiple-labels":{description:"Ensures form field does not have multiple label elements",help:"Form field must not have multiple label elements"},"frame-focusable-content":{description:"Ensures <frame> and <iframe> elements with focusable content do not have tabindex=-1",help:"Frames with focusable content must not have tabindex=-1"},"frame-tested":{description:"Ensures <iframe> and <frame> elements contain the axe-core script",help:"Frames should be tested with axe-core"},"frame-title-unique":{description:"Ensures <iframe> and <frame> elements contain a unique title attribute",help:"Frames must have a unique title attribute"},"frame-title":{description:"Ensures <iframe> and <frame> elements have an accessible name",help:"Frames must have an accessible name"},"heading-order":{description:"Ensures the order of headings is semantically correct",help:"Heading levels should only increase by one"},"hidden-content":{description:"Informs users about hidden content.",help:"Hidden content on the page should be analyzed"},"html-has-lang":{description:"Ensures every HTML document has a lang attribute",help:"<html> element must have a lang attribute"},"html-lang-valid":{description:"Ensures the lang attribute of the <html> element has a valid value",help:"<html> element must have a valid value for the lang attribute"},"html-xml-lang-mismatch":{description:"Ensure that HTML elements with both valid lang and xml:lang attributes agree on the base language of the page",help:"HTML elements with lang and xml:lang must have the same base language"},"identical-links-same-purpose":{description:"Ensure that links with the same accessible name serve a similar purpose",help:"Links with the same name must have a similar purpose"},"image-alt":{description:"Ensures <img> elements have alternate text or a role of none or presentation",help:"Images must have alternate text"},"image-redundant-alt":{description:"Ensure image alternative is not repeated as text",help:"Alternative text of images should not be repeated as text"},"input-button-name":{description:"Ensures input buttons have discernible text",help:"Input buttons must have discernible text"},"input-image-alt":{description:'Ensures <input type="image"> elements have alternate text',help:"Image buttons must have alternate text"},"label-content-name-mismatch":{description:"Ensures that elements labelled through their content must have their visible text as part of their accessible name",help:"Elements must have their visible text as part of their accessible name"},"label-title-only":{description:"Ensures that every form element has a visible label and is not solely labeled using hidden labels, or the title or aria-describedby attributes",help:"Form elements should have a visible label"},label:{description:"Ensures every form element has a label",help:"Form elements must have labels"},"landmark-banner-is-top-level":{description:"Ensures the banner landmark is at top level",help:"Banner landmark should not be contained in another landmark"},"landmark-complementary-is-top-level":{description:"Ensures the complementary landmark or aside is at top level",help:"Aside should not be contained in another landmark"},"landmark-contentinfo-is-top-level":{description:"Ensures the contentinfo landmark is at top level",help:"Contentinfo landmark should not be contained in another landmark"},"landmark-main-is-top-level":{description:"Ensures the main landmark is at top level",help:"Main landmark should not be contained in another landmark"},"landmark-no-duplicate-banner":{description:"Ensures the document has at most one banner landmark",help:"Document should not have more than one banner landmark"},"landmark-no-duplicate-contentinfo":{description:"Ensures the document has at most one contentinfo landmark",help:"Document should not have more than one contentinfo landmark"},"landmark-no-duplicate-main":{description:"Ensures the document has at most one main landmark",help:"Document should not have more than one main landmark"},"landmark-one-main":{description:"Ensures the document has a main landmark",help:"Document should have one main landmark"},"landmark-unique":{help:"Ensures landmarks are unique",description:"Landmarks should have a unique role or role/label/title (i.e. accessible name) combination"},"link-in-text-block":{description:"Ensure links are distinguished from surrounding text in a way that does not rely on color",help:"Links must be distinguishable without relying on color"},"link-name":{description:"Ensures links have discernible text",help:"Links must have discernible text"},list:{description:"Ensures that lists are structured correctly",help:"<ul> and <ol> must only directly contain <li>, <script> or <template> elements"},listitem:{description:"Ensures <li> elements are used semantically",help:"<li> elements must be contained in a <ul> or <ol>"},marquee:{description:"Ensures <marquee> elements are not used",help:"<marquee> elements are deprecated and must not be used"},"meta-refresh-no-exceptions":{description:'Ensures <meta http-equiv="refresh"> is not used for delayed refresh',help:"Delayed refresh must not be used"},"meta-refresh":{description:'Ensures <meta http-equiv="refresh"> is not used for delayed refresh',help:"Delayed refresh under 20 hours must not be used"},"meta-viewport-large":{description:'Ensures <meta name="viewport"> can scale a significant amount',help:"Users should be able to zoom and scale the text up to 500%"},"meta-viewport":{description:'Ensures <meta name="viewport"> does not disable text scaling and zooming',help:"Zooming and scaling must not be disabled"},"nested-interactive":{description:"Ensures interactive controls are not nested as they are not always announced by screen readers or can cause focus problems for assistive technologies",help:"Interactive controls must not be nested"},"no-autoplay-audio":{description:"Ensures <video> or <audio> elements do not autoplay audio for more than 3 seconds without a control mechanism to stop or mute the audio",help:"<video> or <audio> elements must not play automatically"},"object-alt":{description:"Ensures <object> elements have alternate text",help:"<object> elements must have alternate text"},"p-as-heading":{description:"Ensure bold, italic text and font-size is not used to style <p> elements as a heading",help:"Styled <p> elements must not be used as headings"},"page-has-heading-one":{description:"Ensure that the page, or at least one of its frames contains a level-one heading",help:"Page should contain a level-one heading"},"presentation-role-conflict":{description:"Elements marked as presentational should not have global ARIA or tabindex to ensure all screen readers ignore them",help:"Ensure elements marked as presentational are consistently ignored"},region:{description:"Ensures all page content is contained by landmarks",help:"All page content should be contained by landmarks"},"role-img-alt":{description:'Ensures [role="img"] elements have alternate text',help:'[role="img"] elements must have an alternative text'},"scope-attr-valid":{description:"Ensures the scope attribute is used correctly on tables",help:"scope attribute should be used correctly"},"scrollable-region-focusable":{description:"Ensure elements that have scrollable content are accessible by keyboard",help:"Scrollable region must have keyboard access"},"select-name":{description:"Ensures select element has an accessible name",help:"Select element must have an accessible name"},"server-side-image-map":{description:"Ensures that server-side image maps are not used",help:"Server-side image maps must not be used"},"skip-link":{description:"Ensure all skip links have a focusable target",help:"The skip-link target should exist and be focusable"},"svg-img-alt":{description:"Ensures <svg> elements with an img, graphics-document or graphics-symbol role have an accessible text",help:"<svg> elements with an img role must have an alternative text"},tabindex:{description:"Ensures tabindex attribute values are not greater than 0",help:"Elements should not have tabindex greater than zero"},"table-duplicate-name":{description:"Ensure the <caption> element does not contain the same text as the summary attribute",help:"tables should not have the same summary and caption"},"table-fake-caption":{description:"Ensure that tables with a caption use the <caption> element.",help:"Data or header cells must not be used to give caption to a data table."},"target-size":{description:"Ensure touch target have sufficient size and space",help:"All touch targets must be 24px large, or leave sufficient space"},"td-has-header":{description:"Ensure that each non-empty data cell in a <table> larger than 3 by 3  has one or more table headers",help:"Non-empty <td> elements in larger <table> must have an associated table header"},"td-headers-attr":{description:"Ensure that each cell in a table that uses the headers attribute refers only to other cells in that table",help:"Table cells that use the headers attribute must only refer to cells in the same table"},"th-has-data-cells":{description:"Ensure that <th> elements and elements with role=columnheader/rowheader have data cells they describe",help:"Table headers in a data table must refer to data cells"},"valid-lang":{description:"Ensures lang attributes have valid values",help:"lang attribute must have a valid value"},"video-caption":{description:"Ensures <video> elements have captions",help:"<video> elements must have captions"}},checks:{abstractrole:{impact:"serious",messages:{pass:"Abstract roles are not used",fail:{singular:"Abstract role cannot be directly used: \${data.values}",plural:"Abstract roles cannot be directly used: \${data.values}"}}},"aria-allowed-attr":{impact:"critical",messages:{pass:"ARIA attributes are used correctly for the defined role",fail:{singular:"ARIA attribute is not allowed: \${data.values}",plural:"ARIA attributes are not allowed: \${data.values}"},incomplete:"Check that there is no problem if the ARIA attribute is ignored on this element: \${data.values}"}},"aria-allowed-role":{impact:"minor",messages:{pass:"ARIA role is allowed for given element",fail:{singular:"ARIA role \${data.values} is not allowed for given element",plural:"ARIA roles \${data.values} are not allowed for given element"},incomplete:{singular:"ARIA role \${data.values} must be removed when the element is made visible, as it is not allowed for the element",plural:"ARIA roles \${data.values} must be removed when the element is made visible, as they are not allowed for the element"}}},"aria-busy":{impact:"serious",messages:{pass:"Element has an aria-busy attribute",fail:'Element uses aria-busy="true" while showing a loader'}},"aria-conditional-attr":{impact:"serious",messages:{pass:"ARIA attribute is allowed",fail:{checkbox:'Remove aria-checked, or set it to "\${data.checkState}" to match the real checkbox state',rowSingular:"This attribute is supported with treegrid rows, but not \${data.ownerRole}: \${data.invalidAttrs}",rowPlural:"These attributes are supported with treegrid rows, but not \${data.ownerRole}: \${data.invalidAttrs}"}}},"aria-errormessage":{impact:"critical",messages:{pass:"aria-errormessage exists and references elements visible to screen readers that use a supported aria-errormessage technique",fail:{singular:"aria-errormessage value \`\${data.values}\` must use a technique to announce the message (e.g., aria-live, aria-describedby, role=alert, etc.)",plural:"aria-errormessage values \`\${data.values}\` must use a technique to announce the message (e.g., aria-live, aria-describedby, role=alert, etc.)",hidden:"aria-errormessage value \`\${data.values}\` cannot reference a hidden element"},incomplete:{singular:"ensure aria-errormessage value \`\${data.values}\` references an existing element",plural:"ensure aria-errormessage values \`\${data.values}\` reference existing elements",idrefs:"unable to determine if aria-errormessage element exists on the page: \${data.values}"}}},"aria-hidden-body":{impact:"critical",messages:{pass:"No aria-hidden attribute is present on document body",fail:"aria-hidden=true should not be present on the document body"}},"aria-level":{impact:"serious",messages:{pass:"aria-level values are valid",incomplete:"aria-level values greater than 6 are not supported in all screenreader and browser combinations"}},"aria-prohibited-attr":{impact:"serious",messages:{pass:"ARIA attribute is allowed",fail:{hasRolePlural:'\${data.prohibited} attributes cannot be used with role "\${data.role}".',hasRoleSingular:'\${data.prohibited} attribute cannot be used with role "\${data.role}".',noRolePlural:"\${data.prohibited} attributes cannot be used on a \${data.nodeName} with no valid role attribute.",noRoleSingular:"\${data.prohibited} attribute cannot be used on a \${data.nodeName} with no valid role attribute."},incomplete:{hasRoleSingular:'\${data.prohibited} attribute is not well supported with role "\${data.role}".',hasRolePlural:'\${data.prohibited} attributes are not well supported with role "\${data.role}".',noRoleSingular:"\${data.prohibited} attribute is not well supported on a \${data.nodeName} with no valid role attribute.",noRolePlural:"\${data.prohibited} attributes are not well supported on a \${data.nodeName} with no valid role attribute."}}},"aria-required-attr":{impact:"critical",messages:{pass:"All required ARIA attributes are present",fail:{singular:"Required ARIA attribute not present: \${data.values}",plural:"Required ARIA attributes not present: \${data.values}"}}},"aria-required-children":{impact:"critical",messages:{pass:"Required ARIA children are present",fail:{singular:"Required ARIA child role not present: \${data.values}",plural:"Required ARIA children role not present: \${data.values}",unallowed:"Element has children which are not allowed: \${data.values}"},incomplete:{singular:"Expecting ARIA child role to be added: \${data.values}",plural:"Expecting ARIA children role to be added: \${data.values}"}}},"aria-required-parent":{impact:"critical",messages:{pass:"Required ARIA parent role present",fail:{singular:"Required ARIA parent role not present: \${data.values}",plural:"Required ARIA parents role not present: \${data.values}"}}},"aria-roledescription":{impact:"serious",messages:{pass:"aria-roledescription used on a supported semantic role",incomplete:"Check that the aria-roledescription is announced by supported screen readers",fail:"Give the element a role that supports aria-roledescription"}},"aria-unsupported-attr":{impact:"critical",messages:{pass:"ARIA attribute is supported",fail:"ARIA attribute is not widely supported in screen readers and assistive technologies: \${data.values}"}},"aria-valid-attr-value":{impact:"critical",messages:{pass:"ARIA attribute values are valid",fail:{singular:"Invalid ARIA attribute value: \${data.values}",plural:"Invalid ARIA attribute values: \${data.values}"},incomplete:{noId:"ARIA attribute element ID does not exist on the page: \${data.needsReview}",noIdShadow:"ARIA attribute element ID does not exist on the page or is a descendant of a different shadow DOM tree: \${data.needsReview}",ariaCurrent:'ARIA attribute value is invalid and will be treated as "aria-current=true": \${data.needsReview}',idrefs:"Unable to determine if ARIA attribute element ID exists on the page: \${data.needsReview}",empty:"ARIA attribute value is ignored while empty: \${data.needsReview}"}}},"aria-valid-attr":{impact:"critical",messages:{pass:"ARIA attribute name is valid",fail:{singular:"Invalid ARIA attribute name: \${data.values}",plural:"Invalid ARIA attribute names: \${data.values}"}}},"braille-label-equivalent":{impact:"serious",messages:{pass:"aria-braillelabel is used on an element with accessible text",fail:"aria-braillelabel is used on an element with no accessible text",incomplete:"Unable to compute accessible text"}},"braille-roledescription-equivalent":{impact:"serious",messages:{pass:"aria-brailleroledescription is used on an element with aria-roledescription",fail:{noRoleDescription:"aria-brailleroledescription is used on an element with no aria-roledescription",emptyRoleDescription:"aria-brailleroledescription is used on an element with an empty aria-roledescription"}}},deprecatedrole:{impact:"minor",messages:{pass:"ARIA role is not deprecated",fail:"The role used is deprecated: \${data}"}},fallbackrole:{impact:"serious",messages:{pass:"Only one role value used",fail:"Use only one role value, since fallback roles are not supported in older browsers",incomplete:"Use only role 'presentation' or 'none' since they are synonymous."}},"has-global-aria-attribute":{impact:"minor",messages:{pass:{singular:"Element has global ARIA attribute: \${data.values}",plural:"Element has global ARIA attributes: \${data.values}"},fail:"Element does not have global ARIA attribute"}},"has-widget-role":{impact:"minor",messages:{pass:"Element has a widget role.",fail:"Element does not have a widget role."}},invalidrole:{impact:"critical",messages:{pass:"ARIA role is valid",fail:{singular:"Role must be one of the valid ARIA roles: \${data.values}",plural:"Roles must be one of the valid ARIA roles: \${data.values}"}}},"is-element-focusable":{impact:"minor",messages:{pass:"Element is focusable.",fail:"Element is not focusable."}},"no-implicit-explicit-label":{impact:"serious",messages:{pass:"There is no mismatch between a <label> and accessible name",incomplete:"Check that the <label> does not need be part of the ARIA \${data} field's name"}},unsupportedrole:{impact:"critical",messages:{pass:"ARIA role is supported",fail:"The role used is not widely supported in screen readers and assistive technologies: \${data}"}},"valid-scrollable-semantics":{impact:"minor",messages:{pass:"Element has valid semantics for an element in the focus order.",fail:"Element has invalid semantics for an element in the focus order."}},"color-contrast-enhanced":{impact:"serious",messages:{pass:"Element has sufficient color contrast of \${data.contrastRatio}",fail:{default:"Element has insufficient color contrast of \${data.contrastRatio} (foreground color: \${data.fgColor}, background color: \${data.bgColor}, font size: \${data.fontSize}, font weight: \${data.fontWeight}). Expected contrast ratio of \${data.expectedContrastRatio}",fgOnShadowColor:"Element has insufficient color contrast of \${data.contrastRatio} between the foreground and shadow color (foreground color: \${data.fgColor}, text-shadow color: \${data.shadowColor}, font size: \${data.fontSize}, font weight: \${data.fontWeight}). Expected contrast ratio of \${data.expectedContrastRatio}",shadowOnBgColor:"Element has insufficient color contrast of \${data.contrastRatio} between the shadow color and background color (text-shadow color: \${data.shadowColor}, background color: \${data.bgColor}, font size: \${data.fontSize}, font weight: \${data.fontWeight}). Expected contrast ratio of \${data.expectedContrastRatio}"},incomplete:{default:"Unable to determine contrast ratio",bgImage:"Element's background color could not be determined due to a background image",bgGradient:"Element's background color could not be determined due to a background gradient",imgNode:"Element's background color could not be determined because element contains an image node",bgOverlap:"Element's background color could not be determined because it is overlapped by another element",fgAlpha:"Element's foreground color could not be determined because of alpha transparency",elmPartiallyObscured:"Element's background color could not be determined because it's partially obscured by another element",elmPartiallyObscuring:"Element's background color could not be determined because it partially overlaps other elements",outsideViewport:"Element's background color could not be determined because it's outside the viewport",equalRatio:"Element has a 1:1 contrast ratio with the background",shortTextContent:"Element content is too short to determine if it is actual text content",nonBmp:"Element content contains only non-text characters",pseudoContent:"Element's background color could not be determined due to a pseudo element"}}},"color-contrast":{impact:"serious",messages:{pass:{default:"Element has sufficient color contrast of \${data.contrastRatio}",hidden:"Element is hidden"},fail:{default:"Element has insufficient color contrast of \${data.contrastRatio} (foreground color: \${data.fgColor}, background color: \${data.bgColor}, font size: \${data.fontSize}, font weight: \${data.fontWeight}). Expected contrast ratio of \${data.expectedContrastRatio}",fgOnShadowColor:"Element has insufficient color contrast of \${data.contrastRatio} between the foreground and shadow color (foreground color: \${data.fgColor}, text-shadow color: \${data.shadowColor}, font size: \${data.fontSize}, font weight: \${data.fontWeight}). Expected contrast ratio of \${data.expectedContrastRatio}",shadowOnBgColor:"Element has insufficient color contrast of \${data.contrastRatio} between the shadow color and background color (text-shadow color: \${data.shadowColor}, background color: \${data.bgColor}, font size: \${data.fontSize}, font weight: \${data.fontWeight}). Expected contrast ratio of \${data.expectedContrastRatio}"},incomplete:{default:"Unable to determine contrast ratio",bgImage:"Element's background color could not be determined due to a background image",bgGradient:"Element's background color could not be determined due to a background gradient",imgNode:"Element's background color could not be determined because element contains an image node",bgOverlap:"Element's background color could not be determined because it is overlapped by another element",complexTextShadows:"Element's contrast could not be determined because it uses complex text shadows",fgAlpha:"Element's foreground color could not be determined because of alpha transparency",elmPartiallyObscured:"Element's background color could not be determined because it's partially obscured by another element",elmPartiallyObscuring:"Element's background color could not be determined because it partially overlaps other elements",outsideViewport:"Element's background color could not be determined because it's outside the viewport",equalRatio:"Element has a 1:1 contrast ratio with the background",shortTextContent:"Element content is too short to determine if it is actual text content",nonBmp:"Element content contains only non-text characters",pseudoContent:"Element's background color could not be determined due to a pseudo element"}}},"link-in-text-block-style":{impact:"serious",messages:{pass:"Links can be distinguished from surrounding text by visual styling",incomplete:{default:"Check if the link needs styling to distinguish it from nearby text",pseudoContent:"Check if the link's pseudo style is sufficient to distinguish it from the surrounding text"},fail:"The link has no styling (such as underline) to distinguish it from the surrounding text"}},"link-in-text-block":{impact:"serious",messages:{pass:"Links can be distinguished from surrounding text in some way other than by color",fail:{fgContrast:"The link has insufficient color contrast of \${data.contrastRatio}:1 with the surrounding text. (Minimum contrast is \${data.requiredContrastRatio}:1, link text: \${data.nodeColor}, surrounding text: \${data.parentColor})",bgContrast:"The link background has insufficient color contrast of \${data.contrastRatio} (Minimum contrast is \${data.requiredContrastRatio}:1, link background color: \${data.nodeBackgroundColor}, surrounding background color: \${data.parentBackgroundColor})"},incomplete:{default:"Element's foreground contrast ratio could not be determined",bgContrast:"Element's background contrast ratio could not be determined",bgImage:"Element's contrast ratio could not be determined due to a background image",bgGradient:"Element's contrast ratio could not be determined due to a background gradient",imgNode:"Element's contrast ratio could not be determined because element contains an image node",bgOverlap:"Element's contrast ratio could not be determined because of element overlap"}}},"autocomplete-appropriate":{impact:"serious",messages:{pass:"the autocomplete value is on an appropriate element",fail:"the autocomplete value is inappropriate for this type of input"}},"autocomplete-valid":{impact:"serious",messages:{pass:"the autocomplete attribute is correctly formatted",fail:"the autocomplete attribute is incorrectly formatted"}},accesskeys:{impact:"serious",messages:{pass:"Accesskey attribute value is unique",fail:"Document has multiple elements with the same accesskey"}},"focusable-content":{impact:"serious",messages:{pass:"Element contains focusable elements",fail:"Element should have focusable content"}},"focusable-disabled":{impact:"serious",messages:{pass:"No focusable elements contained within element",incomplete:"Check if the focusable elements immediately move the focus indicator",fail:"Focusable content should be disabled or be removed from the DOM"}},"focusable-element":{impact:"serious",messages:{pass:"Element is focusable",fail:"Element should be focusable"}},"focusable-modal-open":{impact:"serious",messages:{pass:"No focusable elements while a modal is open",incomplete:"Check that focusable elements are not tabbable in the current state"}},"focusable-no-name":{impact:"serious",messages:{pass:"Element is not in tab order or has accessible text",fail:"Element is in tab order and does not have accessible text",incomplete:"Unable to determine if element has an accessible name"}},"focusable-not-tabbable":{impact:"serious",messages:{pass:"No focusable elements contained within element",incomplete:"Check if the focusable elements immediately move the focus indicator",fail:'Focusable content should have tabindex="-1" or be removed from the DOM'}},"frame-focusable-content":{impact:"serious",messages:{pass:"Element does not have focusable descendants",fail:"Element has focusable descendants",incomplete:"Could not determine if element has descendants"}},"landmark-is-top-level":{impact:"moderate",messages:{pass:"The \${data.role} landmark is at the top level.",fail:"The \${data.role} landmark is contained in another landmark."}},"no-focusable-content":{impact:"serious",messages:{pass:"Element does not have focusable descendants",fail:{default:"Element has focusable descendants",notHidden:'Using a negative tabindex on an element inside an interactive control does not prevent assistive technologies from focusing the element (even with aria-hidden="true")'},incomplete:"Could not determine if element has descendants"}},"page-has-heading-one":{impact:"moderate",messages:{pass:"Page has at least one level-one heading",fail:"Page must have a level-one heading"}},"page-has-main":{impact:"moderate",messages:{pass:"Document has at least one main landmark",fail:"Document does not have a main landmark"}},"page-no-duplicate-banner":{impact:"moderate",messages:{pass:"Document does not have more than one banner landmark",fail:"Document has more than one banner landmark"}},"page-no-duplicate-contentinfo":{impact:"moderate",messages:{pass:"Document does not have more than one contentinfo landmark",fail:"Document has more than one contentinfo landmark"}},"page-no-duplicate-main":{impact:"moderate",messages:{pass:"Document does not have more than one main landmark",fail:"Document has more than one main landmark"}},tabindex:{impact:"serious",messages:{pass:"Element does not have a tabindex greater than 0",fail:"Element has a tabindex greater than 0"}},"alt-space-value":{impact:"critical",messages:{pass:"Element has a valid alt attribute value",fail:"Element has an alt attribute containing only a space character, which is not ignored by all screen readers"}},"duplicate-img-label":{impact:"minor",messages:{pass:"Element does not duplicate existing text in <img> alt text",fail:"Element contains <img> element with alt text that duplicates existing text"}},"explicit-label":{impact:"critical",messages:{pass:"Form element has an explicit <label>",fail:"Form element does not have an explicit <label>",incomplete:"Unable to determine if form element has an explicit <label>"}},"help-same-as-label":{impact:"minor",messages:{pass:"Help text (title or aria-describedby) does not duplicate label text",fail:"Help text (title or aria-describedby) text is the same as the label text"}},"hidden-explicit-label":{impact:"critical",messages:{pass:"Form element has a visible explicit <label>",fail:"Form element has explicit <label> that is hidden",incomplete:"Unable to determine if form element has explicit <label> that is hidden"}},"implicit-label":{impact:"critical",messages:{pass:"Form element has an implicit (wrapped) <label>",fail:"Form element does not have an implicit (wrapped) <label>",incomplete:"Unable to determine if form element has an implicit (wrapped} <label>"}},"label-content-name-mismatch":{impact:"serious",messages:{pass:"Element contains visible text as part of it's accessible name",fail:"Text inside the element is not included in the accessible name"}},"multiple-label":{impact:"moderate",messages:{pass:"Form field does not have multiple label elements",incomplete:"Multiple label elements is not widely supported in assistive technologies. Ensure the first label contains all necessary information."}},"title-only":{impact:"serious",messages:{pass:"Form element does not solely use title attribute for its label",fail:"Only title used to generate label for form element"}},"landmark-is-unique":{impact:"moderate",messages:{pass:"Landmarks must have a unique role or role/label/title (i.e. accessible name) combination",fail:"The landmark must have a unique aria-label, aria-labelledby, or title to make landmarks distinguishable"}},"has-lang":{impact:"serious",messages:{pass:"The <html> element has a lang attribute",fail:{noXHTML:"The xml:lang attribute is not valid on HTML pages, use the lang attribute.",noLang:"The <html> element does not have a lang attribute"}}},"valid-lang":{impact:"serious",messages:{pass:"Value of lang attribute is included in the list of valid languages",fail:"Value of lang attribute not included in the list of valid languages"}},"xml-lang-mismatch":{impact:"moderate",messages:{pass:"Lang and xml:lang attributes have the same base language",fail:"Lang and xml:lang attributes do not have the same base language"}},dlitem:{impact:"serious",messages:{pass:"Description list item has a <dl> parent element",fail:"Description list item does not have a <dl> parent element"}},listitem:{impact:"serious",messages:{pass:'List item has a <ul>, <ol> or role="list" parent element',fail:{default:"List item does not have a <ul>, <ol> parent element",roleNotValid:'List item does not have a <ul>, <ol> parent element without a role, or a role="list"'}}},"only-dlitems":{impact:"serious",messages:{pass:"dl element only has direct children that are allowed inside; <dt>, <dd>, or <div> elements",fail:"dl element has direct children that are not allowed: \${data.values}"}},"only-listitems":{impact:"serious",messages:{pass:"List element only has direct children that are allowed inside <li> elements",fail:"List element has direct children that are not allowed: \${data.values}"}},"structured-dlitems":{impact:"serious",messages:{pass:"When not empty, element has both <dt> and <dd> elements",fail:"When not empty, element does not have at least one <dt> element followed by at least one <dd> element"}},caption:{impact:"critical",messages:{pass:"The multimedia element has a captions track",incomplete:"Check that captions is available for the element"}},"frame-tested":{impact:"critical",messages:{pass:"The iframe was tested with axe-core",fail:"The iframe could not be tested with axe-core",incomplete:"The iframe still has to be tested with axe-core"}},"no-autoplay-audio":{impact:"moderate",messages:{pass:"<video> or <audio> does not output audio for more than allowed duration or has controls mechanism",fail:"<video> or <audio> outputs audio for more than allowed duration and does not have a controls mechanism",incomplete:"Check that the <video> or <audio> does not output audio for more than allowed duration or provides a controls mechanism"}},"css-orientation-lock":{impact:"serious",messages:{pass:"Display is operable, and orientation lock does not exist",fail:"CSS Orientation lock is applied, and makes display inoperable",incomplete:"CSS Orientation lock cannot be determined"}},"meta-viewport-large":{impact:"minor",messages:{pass:"<meta> tag does not prevent significant zooming on mobile devices",fail:"<meta> tag limits zooming on mobile devices"}},"meta-viewport":{impact:"critical",messages:{pass:"<meta> tag does not disable zooming on mobile devices",fail:"\${data} on <meta> tag disables zooming on mobile devices"}},"target-offset":{impact:"serious",messages:{pass:"Target has sufficient space from its closest neighbors. Safe clickable space has a diameter of \${data.closestOffset}px which is at least \${data.minOffset}px.",fail:"Target has insufficient space to its closest neighbors. Safe clickable space has a diameter of \${data.closestOffset}px instead of at least \${data.minOffset}px.",incomplete:{default:"Element with negative tabindex has insufficient space to its closest neighbors. Safe clickable space has a diameter of \${data.closestOffset}px instead of at least \${data.minOffset}px. Is this a target?",nonTabbableNeighbor:"Target has insufficient space to its closest neighbors. Safe clickable space has a diameter of \${data.closestOffset}px instead of at least \${data.minOffset}px. Is the neighbor a target?"}}},"target-size":{impact:"serious",messages:{pass:{default:"Control has sufficient size (\${data.width}px by \${data.height}px, should be at least \${data.minSize}px by \${data.minSize}px)",obscured:"Control is ignored because it is fully obscured and thus not clickable"},fail:{default:"Target has insufficient size (\${data.width}px by \${data.height}px, should be at least \${data.minSize}px by \${data.minSize}px)",partiallyObscured:"Target has insufficient size because it is partially obscured (smallest space is \${data.width}px by \${data.height}px, should be at least \${data.minSize}px by \${data.minSize}px)"},incomplete:{default:"Element with negative tabindex has insufficient size (\${data.width}px by \${data.height}px, should be at least \${data.minSize}px by \${data.minSize}px). Is this a target?",contentOverflow:"Element size could not be accurately determined due to overflow content",partiallyObscured:"Element with negative tabindex has insufficient size because it is partially obscured (smallest space is \${data.width}px by \${data.height}px, should be at least \${data.minSize}px by \${data.minSize}px). Is this a target?",partiallyObscuredNonTabbable:"Target has insufficient size because it is partially obscured by a neighbor with negative tabindex (smallest space is \${data.width}px by \${data.height}px, should be at least \${data.minSize}px by \${data.minSize}px). Is the neighbor a target?"}}},"header-present":{impact:"serious",messages:{pass:"Page has a heading",fail:"Page does not have a heading"}},"heading-order":{impact:"moderate",messages:{pass:"Heading order valid",fail:"Heading order invalid",incomplete:"Unable to determine previous heading"}},"identical-links-same-purpose":{impact:"minor",messages:{pass:"There are no other links with the same name, that go to a different URL",incomplete:"Check that links have the same purpose, or are intentionally ambiguous."}},"internal-link-present":{impact:"serious",messages:{pass:"Valid skip link found",fail:"No valid skip link found"}},landmark:{impact:"serious",messages:{pass:"Page has a landmark region",fail:"Page does not have a landmark region"}},"meta-refresh-no-exceptions":{impact:"minor",messages:{pass:"<meta> tag does not immediately refresh the page",fail:"<meta> tag forces timed refresh of page"}},"meta-refresh":{impact:"critical",messages:{pass:"<meta> tag does not immediately refresh the page",fail:"<meta> tag forces timed refresh of page (less than 20 hours)"}},"p-as-heading":{impact:"serious",messages:{pass:"<p> elements are not styled as headings",fail:"Heading elements should be used instead of styled <p> elements",incomplete:"Unable to determine if <p> elements are styled as headings"}},region:{impact:"moderate",messages:{pass:"All page content is contained by landmarks",fail:"Some page content is not contained by landmarks"}},"skip-link":{impact:"moderate",messages:{pass:"Skip link target exists",incomplete:"Skip link target should become visible on activation",fail:"No skip link target"}},"unique-frame-title":{impact:"serious",messages:{pass:"Element's title attribute is unique",fail:"Element's title attribute is not unique"}},"duplicate-id-active":{impact:"serious",messages:{pass:"Document has no active elements that share the same id attribute",fail:"Document has active elements with the same id attribute: \${data}"}},"duplicate-id-aria":{impact:"critical",messages:{pass:"Document has no elements referenced with ARIA or labels that share the same id attribute",fail:"Document has multiple elements referenced with ARIA with the same id attribute: \${data}"}},"duplicate-id":{impact:"minor",messages:{pass:"Document has no static elements that share the same id attribute",fail:"Document has multiple static elements with the same id attribute: \${data}"}},"aria-label":{impact:"serious",messages:{pass:"aria-label attribute exists and is not empty",fail:"aria-label attribute does not exist or is empty"}},"aria-labelledby":{impact:"serious",messages:{pass:"aria-labelledby attribute exists and references elements that are visible to screen readers",fail:"aria-labelledby attribute does not exist, references elements that do not exist or references elements that are empty",incomplete:"ensure aria-labelledby references an existing element"}},"avoid-inline-spacing":{impact:"serious",messages:{pass:"No inline styles with '!important' that affect text spacing has been specified",fail:{singular:"Remove '!important' from inline style \${data.values}, as overriding this is not supported by most browsers",plural:"Remove '!important' from inline styles \${data.values}, as overriding this is not supported by most browsers"}}},"button-has-visible-text":{impact:"critical",messages:{pass:"Element has inner text that is visible to screen readers",fail:"Element does not have inner text that is visible to screen readers",incomplete:"Unable to determine if element has children"}},"doc-has-title":{impact:"serious",messages:{pass:"Document has a non-empty <title> element",fail:"Document does not have a non-empty <title> element"}},exists:{impact:"minor",messages:{pass:"Element does not exist",incomplete:"Element exists"}},"has-alt":{impact:"critical",messages:{pass:"Element has an alt attribute",fail:"Element does not have an alt attribute"}},"has-visible-text":{impact:"minor",messages:{pass:"Element has text that is visible to screen readers",fail:"Element does not have text that is visible to screen readers",incomplete:"Unable to determine if element has children"}},"important-letter-spacing":{impact:"serious",messages:{pass:"Letter-spacing in the style attribute is not set to !important, or meets the minimum",fail:"letter-spacing in the style attribute must not use !important, or be at \${data.minValue}em (current \${data.value}em)"}},"important-line-height":{impact:"serious",messages:{pass:"line-height in the style attribute is not set to !important, or meets the minimum",fail:"line-height in the style attribute must not use !important, or be at \${data.minValue}em (current \${data.value}em)"}},"important-word-spacing":{impact:"serious",messages:{pass:"word-spacing in the style attribute is not set to !important, or meets the minimum",fail:"word-spacing in the style attribute must not use !important, or be at \${data.minValue}em (current \${data.value}em)"}},"is-on-screen":{impact:"serious",messages:{pass:"Element is not visible",fail:"Element is visible"}},"non-empty-alt":{impact:"critical",messages:{pass:"Element has a non-empty alt attribute",fail:{noAttr:"Element has no alt attribute",emptyAttr:"Element has an empty alt attribute"}}},"non-empty-if-present":{impact:"critical",messages:{pass:{default:"Element does not have a value attribute","has-label":"Element has a non-empty value attribute"},fail:"Element has a value attribute and the value attribute is empty"}},"non-empty-placeholder":{impact:"serious",messages:{pass:"Element has a placeholder attribute",fail:{noAttr:"Element has no placeholder attribute",emptyAttr:"Element has an empty placeholder attribute"}}},"non-empty-title":{impact:"serious",messages:{pass:"Element has a title attribute",fail:{noAttr:"Element has no title attribute",emptyAttr:"Element has an empty title attribute"}}},"non-empty-value":{impact:"critical",messages:{pass:"Element has a non-empty value attribute",fail:{noAttr:"Element has no value attribute",emptyAttr:"Element has an empty value attribute"}}},"presentational-role":{impact:"minor",messages:{pass:'Element\\'s default semantics were overriden with role="\${data.role}"',fail:{default:'Element\\'s default semantics were not overridden with role="none" or role="presentation"',globalAria:"Element's role is not presentational because it has a global ARIA attribute",focusable:"Element's role is not presentational because it is focusable",both:"Element's role is not presentational because it has a global ARIA attribute and is focusable",iframe:'Using the "title" attribute on an \${data.nodeName} element with a presentational role behaves inconsistently between screen readers'}}},"role-none":{impact:"minor",messages:{pass:'Element\\'s default semantics were overriden with role="none"',fail:'Element\\'s default semantics were not overridden with role="none"'}},"role-presentation":{impact:"minor",messages:{pass:'Element\\'s default semantics were overriden with role="presentation"',fail:'Element\\'s default semantics were not overridden with role="presentation"'}},"svg-non-empty-title":{impact:"serious",messages:{pass:"Element has a child that is a title",fail:{noTitle:"Element has no child that is a title",emptyTitle:"Element child title is empty"},incomplete:"Unable to determine element has a child that is a title"}},"caption-faked":{impact:"serious",messages:{pass:"The first row of a table is not used as a caption",fail:"The first child of the table should be a caption instead of a table cell"}},"html5-scope":{impact:"moderate",messages:{pass:"Scope attribute is only used on table header elements (<th>)",fail:"In HTML 5, scope attributes may only be used on table header elements (<th>)"}},"same-caption-summary":{impact:"minor",messages:{pass:"Content of summary attribute and <caption> are not duplicated",fail:"Content of summary attribute and <caption> element are identical",incomplete:"Unable to determine if <table> element has a caption"}},"scope-value":{impact:"critical",messages:{pass:"Scope attribute is used correctly",fail:"The value of the scope attribute may only be 'row' or 'col'"}},"td-has-header":{impact:"critical",messages:{pass:"All non-empty data cells have table headers",fail:"Some non-empty data cells do not have table headers"}},"td-headers-attr":{impact:"serious",messages:{pass:"The headers attribute is exclusively used to refer to other cells in the table",incomplete:"The headers attribute is empty",fail:"The headers attribute is not exclusively used to refer to other cells in the table"}},"th-has-data-cells":{impact:"serious",messages:{pass:"All table header cells refer to data cells",fail:"Not all table header cells refer to data cells",incomplete:"Table data cells are missing or empty"}},"hidden-content":{impact:"minor",messages:{pass:"All content on the page has been analyzed.",fail:"There were problems analyzing the content on this page.",incomplete:"There is hidden content on the page that was not analyzed. You will need to trigger the display of this content in order to analyze it."}}},failureSummaries:{any:{failureMessage:function(e){var t="Fix any of the following:",n=e;if(n)for(var a=-1,r=n.length-1;a<r;)t+="\\n  "+n[a+=1].split("\\n").join("\\n  ");return t}},none:{failureMessage:function(e){var t="Fix all of the following:",n=e;if(n)for(var a=-1,r=n.length-1;a<r;)t+="\\n  "+n[a+=1].split("\\n").join("\\n  ");return t}}},incompleteFallbackMessage:"axe couldn't tell the reason. Time to break out the element inspector!"},rules:[{id:"accesskeys",impact:"serious",selector:"[accesskey]",excludeHidden:!1,tags:["cat.keyboard","best-practice"],all:[],any:[],none:["accesskeys"]},{id:"area-alt",impact:"critical",selector:"map area[href]",excludeHidden:!1,tags:["cat.text-alternatives","wcag2a","wcag244","wcag412","section508","section508.22.a","TTv5","TT6.a","EN-301-549","EN-9.2.4.4","EN-9.4.1.2","ACT"],actIds:["c487ae"],all:[],any:[{options:{attribute:"alt"},id:"non-empty-alt"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-allowed-attr",impact:"critical",matches:"aria-allowed-attr-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],actIds:["5c01ea"],all:[{options:{validTreeRowAttrs:["aria-posinset","aria-setsize","aria-expanded","aria-level"]},id:"aria-allowed-attr"}],any:[],none:["aria-unsupported-attr"]},{id:"aria-allowed-role",impact:"minor",excludeHidden:!1,selector:"[role]",matches:"aria-allowed-role-matches",tags:["cat.aria","best-practice"],all:[],any:[{options:{allowImplicit:!0,ignoredTags:[]},id:"aria-allowed-role"}],none:[]},{id:"aria-braille-equivalent",reviewOnFail:!0,impact:"serious",selector:"[aria-brailleroledescription], [aria-braillelabel]",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],all:["braille-roledescription-equivalent","braille-label-equivalent"],any:[],none:[]},{id:"aria-command-name",impact:"serious",selector:'[role="link"], [role="button"], [role="menuitem"]',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","TTv5","TT6.a","EN-301-549","EN-9.4.1.2","ACT"],actIds:["97a4e1"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-conditional-attr",impact:"serious",matches:"aria-allowed-attr-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],actIds:["5c01ea"],all:[{options:{invalidTableRowAttrs:["aria-posinset","aria-setsize","aria-expanded","aria-level"]},id:"aria-conditional-attr"}],any:[],none:[]},{id:"aria-deprecated-role",impact:"minor",selector:"[role]",matches:"no-empty-role-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],actIds:["674b10"],all:[],any:[],none:["deprecatedrole"]},{id:"aria-dialog-name",impact:"serious",selector:'[role="dialog"], [role="alertdialog"]',matches:"no-naming-method-matches",tags:["cat.aria","best-practice"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-hidden-body",impact:"critical",selector:"body",excludeHidden:!1,matches:"is-initiator-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],all:[],any:["aria-hidden-body"],none:[]},{id:"aria-hidden-focus",impact:"serious",selector:'[aria-hidden="true"]',matches:"aria-hidden-focus-matches",excludeHidden:!1,tags:["cat.name-role-value","wcag2a","wcag412","TTv5","TT6.a","EN-301-549","EN-9.4.1.2"],actIds:["6cfa84"],all:["focusable-modal-open","focusable-disabled","focusable-not-tabbable"],any:[],none:[]},{id:"aria-input-field-name",impact:"serious",selector:'[role="combobox"], [role="listbox"], [role="searchbox"], [role="slider"], [role="spinbutton"], [role="textbox"]',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","TTv5","TT5.c","EN-301-549","EN-9.4.1.2","ACT"],actIds:["e086e5"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["no-implicit-explicit-label"]},{id:"aria-meter-name",impact:"serious",selector:'[role="meter"]',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag111","EN-301-549","EN-9.1.1.1"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-progressbar-name",impact:"serious",selector:'[role="progressbar"]',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag111","EN-301-549","EN-9.1.1.1"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-prohibited-attr",impact:"serious",matches:"aria-allowed-attr-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],actIds:["5c01ea"],all:[],any:[],none:[{options:{elementsAllowedAriaLabel:["applet","input"]},id:"aria-prohibited-attr"}]},{id:"aria-required-attr",impact:"critical",selector:"[role]",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],actIds:["4e8ab6"],all:[],any:["aria-required-attr"],none:[]},{id:"aria-required-children",impact:"critical",selector:"[role]",matches:"aria-required-children-matches",tags:["cat.aria","wcag2a","wcag131","EN-301-549","EN-9.1.3.1"],actIds:["bc4a75","ff89c9"],all:[],any:[{options:{reviewEmpty:["doc-bibliography","doc-endnotes","grid","list","listbox","menu","menubar","table","tablist","tree","treegrid","rowgroup"]},id:"aria-required-children"},"aria-busy"],none:[]},{id:"aria-required-parent",impact:"critical",selector:"[role]",matches:"aria-required-parent-matches",tags:["cat.aria","wcag2a","wcag131","EN-301-549","EN-9.1.3.1"],actIds:["ff89c9"],all:[],any:[{options:{ownGroupRoles:["listitem","treeitem"]},id:"aria-required-parent"}],none:[]},{id:"aria-roledescription",impact:"serious",selector:"[aria-roledescription]",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2","deprecated"],enabled:!1,all:[],any:[{options:{supportedRoles:["button","img","checkbox","radio","combobox","menuitemcheckbox","menuitemradio"]},id:"aria-roledescription"}],none:[]},{id:"aria-roles",impact:"critical",selector:"[role]",matches:"no-empty-role-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],actIds:["674b10"],all:[],any:[],none:["invalidrole","abstractrole","unsupportedrole"]},{id:"aria-text",impact:"serious",selector:"[role=text]",tags:["cat.aria","best-practice"],all:[],any:["no-focusable-content"],none:[]},{id:"aria-toggle-field-name",impact:"serious",selector:'[role="checkbox"], [role="menuitemcheckbox"], [role="menuitemradio"], [role="radio"], [role="switch"], [role="option"]',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","TTv5","TT5.c","EN-301-549","EN-9.4.1.2","ACT"],actIds:["e086e5"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["no-implicit-explicit-label"]},{id:"aria-tooltip-name",impact:"serious",selector:'[role="tooltip"]',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-treeitem-name",impact:"serious",selector:'[role="treeitem"]',matches:"no-naming-method-matches",tags:["cat.aria","best-practice"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-valid-attr-value",impact:"critical",matches:"aria-has-attr-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],actIds:["6a7281"],all:[{options:[],id:"aria-valid-attr-value"},"aria-errormessage","aria-level"],any:[],none:[]},{id:"aria-valid-attr",impact:"critical",matches:"aria-has-attr-matches",tags:["cat.aria","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],actIds:["5f99a7"],all:[],any:[{options:[],id:"aria-valid-attr"}],none:[]},{id:"audio-caption",impact:"critical",selector:"audio",enabled:!1,excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag121","EN-301-549","EN-9.1.2.1","section508","section508.22.a","deprecated"],actIds:["2eb176","afb423"],all:[],any:[],none:["caption"]},{id:"autocomplete-valid",impact:"serious",matches:"autocomplete-matches",tags:["cat.forms","wcag21aa","wcag135","EN-301-549","EN-9.1.3.5","ACT"],actIds:["73f2c2"],all:[{options:{stateTerms:["none","false","true","disabled","enabled","undefined","null"]},id:"autocomplete-valid"}],any:[],none:[]},{id:"avoid-inline-spacing",impact:"serious",selector:"[style]",matches:"is-visible-on-screen-matches",tags:["cat.structure","wcag21aa","wcag1412","EN-301-549","EN-9.1.4.12","ACT"],actIds:["24afc2","9e45ec","78fd32"],all:[{options:{cssProperty:"letter-spacing",minValue:.12},id:"important-letter-spacing"},{options:{cssProperty:"word-spacing",minValue:.16},id:"important-word-spacing"},{options:{multiLineOnly:!0,cssProperty:"line-height",minValue:1.5,normalValue:1},id:"important-line-height"}],any:[],none:[]},{id:"blink",impact:"serious",selector:"blink",excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag222","section508","section508.22.j","TTv5","TT2.b","EN-301-549","EN-9.2.2.2"],all:[],any:[],none:["is-on-screen"]},{id:"button-name",impact:"critical",selector:"button",matches:"no-explicit-name-required-matches",tags:["cat.name-role-value","wcag2a","wcag412","section508","section508.22.a","TTv5","TT6.a","EN-301-549","EN-9.4.1.2","ACT"],actIds:["97a4e1","m6b1q3"],all:[],any:["button-has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"bypass",impact:"serious",selector:"html",pageLevel:!0,matches:"bypass-matches",reviewOnFail:!0,tags:["cat.keyboard","wcag2a","wcag241","section508","section508.22.o","TTv5","TT9.a","EN-301-549","EN-9.2.4.1"],actIds:["cf77f2","047fe0","b40fd1","3e12e1","ye5d6e"],all:[],any:["internal-link-present",{options:{selector:":is(h1, h2, h3, h4, h5, h6):not([role]), [role=heading]"},id:"header-present"},{options:{selector:"main, [role=main]"},id:"landmark"}],none:[]},{id:"color-contrast-enhanced",impact:"serious",matches:"color-contrast-matches",excludeHidden:!1,enabled:!1,tags:["cat.color","wcag2aaa","wcag146","ACT"],actIds:["09o5cg"],all:[],any:[{options:{ignoreUnicode:!0,ignoreLength:!1,ignorePseudo:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:7,minThreshold:4.5},large:{expected:4.5,minThreshold:3}},pseudoSizeThreshold:.25,shadowOutlineEmMax:.1,textStrokeEmMin:.03},id:"color-contrast-enhanced"}],none:[]},{id:"color-contrast",impact:"serious",matches:"color-contrast-matches",excludeHidden:!1,tags:["cat.color","wcag2aa","wcag143","TTv5","TT13.c","EN-301-549","EN-9.1.4.3","ACT"],actIds:["afw4f7","09o5cg"],all:[],any:[{options:{ignoreUnicode:!0,ignoreLength:!1,ignorePseudo:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:4.5},large:{expected:3}},pseudoSizeThreshold:.25,shadowOutlineEmMax:.2,textStrokeEmMin:.03},id:"color-contrast"}],none:[]},{id:"css-orientation-lock",impact:"serious",selector:"html",tags:["cat.structure","wcag134","wcag21aa","EN-301-549","EN-9.1.3.4","experimental"],actIds:["b33eff"],all:[{options:{degreeThreshold:2},id:"css-orientation-lock"}],any:[],none:[],preload:!0},{id:"definition-list",impact:"serious",selector:"dl",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131","EN-301-549","EN-9.1.3.1"],all:[],any:[],none:["structured-dlitems",{options:{validRoles:["definition","term","listitem"],validNodeNames:["dt","dd"],divGroups:!0},id:"only-dlitems"}]},{id:"dlitem",impact:"serious",selector:"dd, dt",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131","EN-301-549","EN-9.1.3.1"],all:[],any:["dlitem"],none:[]},{id:"document-title",impact:"serious",selector:"html",matches:"is-initiator-matches",tags:["cat.text-alternatives","wcag2a","wcag242","TTv5","TT12.a","EN-301-549","EN-9.2.4.2","ACT"],actIds:["2779a5"],all:[],any:["doc-has-title"],none:[]},{id:"duplicate-id-active",impact:"serious",selector:"[id]",matches:"duplicate-id-active-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a-obsolete","wcag411","deprecated"],enabled:!1,actIds:["3ea0c8"],all:[],any:["duplicate-id-active"],none:[]},{id:"duplicate-id-aria",impact:"critical",selector:"[id]",matches:"duplicate-id-aria-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag412","EN-301-549","EN-9.4.1.2"],reviewOnFail:!0,actIds:["3ea0c8"],all:[],any:["duplicate-id-aria"],none:[]},{id:"duplicate-id",impact:"minor",selector:"[id]",matches:"duplicate-id-misc-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a-obsolete","wcag411","deprecated"],enabled:!1,actIds:["3ea0c8"],all:[],any:["duplicate-id"],none:[]},{id:"empty-heading",impact:"minor",selector:'h1, h2, h3, h4, h5, h6, [role="heading"]',matches:"heading-matches",tags:["cat.name-role-value","best-practice"],actIds:["ffd0e9"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"empty-table-header",impact:"minor",selector:'th:not([role]), [role="rowheader"], [role="columnheader"]',tags:["cat.name-role-value","best-practice"],all:[],any:["has-visible-text"],none:[]},{id:"focus-order-semantics",impact:"minor",selector:"div, h1, h2, h3, h4, h5, h6, [role=heading], p, span",matches:"inserted-into-focus-order-matches",tags:["cat.keyboard","best-practice","experimental"],all:[],any:[{options:[],id:"has-widget-role"},{options:{roles:["tooltip"]},id:"valid-scrollable-semantics"}],none:[]},{id:"form-field-multiple-labels",impact:"moderate",selector:"input, select, textarea",matches:"label-matches",tags:["cat.forms","wcag2a","wcag332","TTv5","TT5.c","EN-301-549","EN-9.3.3.2"],all:[],any:[],none:["multiple-label"]},{id:"frame-focusable-content",impact:"serious",selector:"html",matches:"frame-focusable-content-matches",tags:["cat.keyboard","wcag2a","wcag211","TTv5","TT4.a","EN-301-549","EN-9.2.1.1"],actIds:["akn7bn"],all:[],any:["frame-focusable-content"],none:[]},{id:"frame-tested",impact:"critical",selector:"html, frame, iframe",tags:["cat.structure","best-practice","review-item"],all:[{options:{isViolation:!1},id:"frame-tested"}],any:[],none:[]},{id:"frame-title-unique",impact:"serious",selector:"frame[title], iframe[title]",matches:"frame-title-has-text-matches",tags:["cat.text-alternatives","wcag2a","wcag412","TTv5","TT12.d","EN-301-549","EN-9.4.1.2"],actIds:["4b1c6c"],all:[],any:[],none:["unique-frame-title"],reviewOnFail:!0},{id:"frame-title",impact:"serious",selector:"frame, iframe",matches:"no-negative-tabindex-matches",tags:["cat.text-alternatives","wcag2a","wcag412","section508","section508.22.i","TTv5","TT12.d","EN-301-549","EN-9.4.1.2"],actIds:["cae760"],all:[],any:[{options:{attribute:"title"},id:"non-empty-title"},"aria-label","aria-labelledby","presentational-role"],none:[]},{id:"heading-order",impact:"moderate",selector:"h1, h2, h3, h4, h5, h6, [role=heading]",matches:"heading-matches",tags:["cat.semantics","best-practice"],all:[],any:["heading-order"],none:[]},{id:"hidden-content",impact:"minor",selector:"*",excludeHidden:!1,tags:["cat.structure","best-practice","experimental","review-item"],all:[],any:["hidden-content"],none:[]},{id:"html-has-lang",impact:"serious",selector:"html",matches:"is-initiator-matches",tags:["cat.language","wcag2a","wcag311","TTv5","TT11.a","EN-301-549","EN-9.3.1.1","ACT"],actIds:["b5c3f8"],all:[],any:[{options:{attributes:["lang","xml:lang"]},id:"has-lang"}],none:[]},{id:"html-lang-valid",impact:"serious",selector:'html[lang]:not([lang=""]), html[xml\\\\:lang]:not([xml\\\\:lang=""])',tags:["cat.language","wcag2a","wcag311","TTv5","TT11.a","EN-301-549","EN-9.3.1.1","ACT"],actIds:["bf051a"],all:[],any:[],none:[{options:{attributes:["lang","xml:lang"]},id:"valid-lang"}]},{id:"html-xml-lang-mismatch",impact:"moderate",selector:"html[lang][xml\\\\:lang]",matches:"xml-lang-mismatch-matches",tags:["cat.language","wcag2a","wcag311","EN-301-549","EN-9.3.1.1","ACT"],actIds:["5b7ae0"],all:["xml-lang-mismatch"],any:[],none:[]},{id:"identical-links-same-purpose",impact:"minor",selector:'a[href], area[href], [role="link"]',excludeHidden:!1,enabled:!1,matches:"identical-links-same-purpose-matches",tags:["cat.semantics","wcag2aaa","wcag249"],actIds:["b20e66"],all:["identical-links-same-purpose"],any:[],none:[]},{id:"image-alt",impact:"critical",selector:"img",matches:"no-explicit-name-required-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","TTv5","TT7.a","TT7.b","EN-301-549","EN-9.1.1.1","ACT"],actIds:["23a2a8"],all:[],any:["has-alt","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:["alt-space-value"]},{id:"image-redundant-alt",impact:"minor",selector:"img",tags:["cat.text-alternatives","best-practice"],all:[],any:[],none:[{options:{parentSelector:"button, [role=button], a[href], p, li, td, th"},id:"duplicate-img-label"}]},{id:"input-button-name",impact:"critical",selector:'input[type="button"], input[type="submit"], input[type="reset"]',matches:"no-explicit-name-required-matches",tags:["cat.name-role-value","wcag2a","wcag412","section508","section508.22.a","TTv5","TT5.c","EN-301-549","EN-9.4.1.2","ACT"],actIds:["97a4e1"],all:[],any:["non-empty-if-present",{options:{attribute:"value"},id:"non-empty-value"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"input-image-alt",impact:"critical",selector:'input[type="image"]',matches:"no-explicit-name-required-matches",tags:["cat.text-alternatives","wcag2a","wcag111","wcag412","section508","section508.22.a","TTv5","TT7.a","EN-301-549","EN-9.1.1.1","EN-9.4.1.2","ACT"],actIds:["59796f"],all:[],any:[{options:{attribute:"alt"},id:"non-empty-alt"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"label-content-name-mismatch",impact:"serious",matches:"label-content-name-mismatch-matches",tags:["cat.semantics","wcag21a","wcag253","EN-301-549","EN-9.2.5.3","experimental"],actIds:["2ee8b8"],all:[],any:[{options:{pixelThreshold:.1,occurrenceThreshold:3},id:"label-content-name-mismatch"}],none:[]},{id:"label-title-only",impact:"serious",selector:"input, select, textarea",matches:"label-matches",tags:["cat.forms","best-practice"],all:[],any:[],none:["title-only"]},{id:"label",impact:"critical",selector:"input, textarea",matches:"label-matches",tags:["cat.forms","wcag2a","wcag412","section508","section508.22.n","TTv5","TT5.c","EN-301-549","EN-9.4.1.2","ACT"],actIds:["e086e5"],all:[],any:["implicit-label","explicit-label","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},{options:{attribute:"placeholder"},id:"non-empty-placeholder"},"presentational-role"],none:["hidden-explicit-label"]},{id:"landmark-banner-is-top-level",impact:"moderate",selector:"header:not([role]), [role=banner]",matches:"landmark-has-body-context-matches",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-complementary-is-top-level",impact:"moderate",selector:"aside:not([role]), [role=complementary]",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-contentinfo-is-top-level",impact:"moderate",selector:"footer:not([role]), [role=contentinfo]",matches:"landmark-has-body-context-matches",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-main-is-top-level",impact:"moderate",selector:"main:not([role]), [role=main]",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-no-duplicate-banner",impact:"moderate",selector:"header:not([role]), [role=banner]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"header:not([role]), [role=banner]",role:"banner"},id:"page-no-duplicate-banner"}],none:[]},{id:"landmark-no-duplicate-contentinfo",impact:"moderate",selector:"footer:not([role]), [role=contentinfo]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"footer:not([role]), [role=contentinfo]",role:"contentinfo"},id:"page-no-duplicate-contentinfo"}],none:[]},{id:"landmark-no-duplicate-main",impact:"moderate",selector:"main:not([role]), [role=main]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"main:not([role]), [role='main']"},id:"page-no-duplicate-main"}],none:[]},{id:"landmark-one-main",impact:"moderate",selector:"html",tags:["cat.semantics","best-practice"],all:[{options:{selector:"main:not([role]), [role='main']",passForModal:!0},id:"page-has-main"}],any:[],none:[]},{id:"landmark-unique",impact:"moderate",selector:"[role=banner], [role=complementary], [role=contentinfo], [role=main], [role=navigation], [role=region], [role=search], [role=form], form, footer, header, aside, main, nav, section",tags:["cat.semantics","best-practice"],matches:"landmark-unique-matches",all:[],any:["landmark-is-unique"],none:[]},{id:"link-in-text-block",impact:"serious",selector:"a[href], [role=link]",matches:"link-in-text-block-matches",excludeHidden:!1,tags:["cat.color","wcag2a","wcag141","TTv5","TT13.a","EN-301-549","EN-9.1.4.1"],all:[],any:[{options:{requiredContrastRatio:3,allowSameColor:!0},id:"link-in-text-block"},"link-in-text-block-style"],none:[]},{id:"link-name",impact:"serious",selector:"a[href]",tags:["cat.name-role-value","wcag2a","wcag244","wcag412","section508","section508.22.a","TTv5","TT6.a","EN-301-549","EN-9.2.4.4","EN-9.4.1.2","ACT"],actIds:["c487ae"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["focusable-no-name"]},{id:"list",impact:"serious",selector:"ul, ol",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131","EN-301-549","EN-9.1.3.1"],all:[],any:[],none:[{options:{validRoles:["listitem"],validNodeNames:["li"]},id:"only-listitems"}]},{id:"listitem",impact:"serious",selector:"li",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131","EN-301-549","EN-9.1.3.1"],all:[],any:["listitem"],none:[]},{id:"marquee",impact:"serious",selector:"marquee",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag222","TTv5","TT2.b","EN-301-549","EN-9.2.2.2"],all:[],any:[],none:["is-on-screen"]},{id:"meta-refresh-no-exceptions",impact:"minor",selector:'meta[http-equiv="refresh"][content]',excludeHidden:!1,enabled:!1,tags:["cat.time-and-media","wcag2aaa","wcag224","wcag325"],actIds:["bisz58"],all:[],any:[{options:{minDelay:72e3,maxDelay:!1},id:"meta-refresh-no-exceptions"}],none:[]},{id:"meta-refresh",impact:"critical",selector:'meta[http-equiv="refresh"][content]',excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag221","TTv5","TT8.a","EN-301-549","EN-9.2.2.1"],actIds:["bc659a","bisz58"],all:[],any:[{options:{minDelay:0,maxDelay:72e3},id:"meta-refresh"}],none:[]},{id:"meta-viewport-large",impact:"minor",selector:'meta[name="viewport"]',matches:"is-initiator-matches",excludeHidden:!1,tags:["cat.sensory-and-visual-cues","best-practice"],all:[],any:[{options:{scaleMinimum:5,lowerBound:2},id:"meta-viewport-large"}],none:[]},{id:"meta-viewport",impact:"critical",selector:'meta[name="viewport"]',matches:"is-initiator-matches",excludeHidden:!1,tags:["cat.sensory-and-visual-cues","wcag2aa","wcag144","EN-301-549","EN-9.1.4.4","ACT"],actIds:["b4f0c3"],all:[],any:[{options:{scaleMinimum:2},id:"meta-viewport"}],none:[]},{id:"nested-interactive",impact:"serious",matches:"nested-interactive-matches",tags:["cat.keyboard","wcag2a","wcag412","TTv5","TT6.a","EN-301-549","EN-9.4.1.2"],actIds:["307n5z"],all:[],any:["no-focusable-content"],none:[]},{id:"no-autoplay-audio",impact:"moderate",excludeHidden:!1,selector:"audio[autoplay], video[autoplay]",matches:"no-autoplay-audio-matches",reviewOnFail:!0,tags:["cat.time-and-media","wcag2a","wcag142","TTv5","TT2.a","EN-301-549","EN-9.1.4.2","ACT"],actIds:["80f0bf"],preload:!0,all:[{options:{allowedDuration:3},id:"no-autoplay-audio"}],any:[],none:[]},{id:"object-alt",impact:"serious",selector:"object[data]",matches:"object-is-loaded-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","EN-301-549","EN-9.1.1.1"],actIds:["8fc3b6"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"p-as-heading",impact:"serious",selector:"p",matches:"p-as-heading-matches",tags:["cat.semantics","wcag2a","wcag131","EN-301-549","EN-9.1.3.1","experimental"],all:[{options:{margins:[{weight:150,italic:!0},{weight:150,size:1.15},{italic:!0,size:1.15},{size:1.4}],passLength:1,failLength:.5},id:"p-as-heading"}],any:[],none:[]},{id:"page-has-heading-one",impact:"moderate",selector:"html",tags:["cat.semantics","best-practice"],all:[{options:{selector:"h1:not([role], [aria-level]), :is(h1, h2, h3, h4, h5, h6):not([role])[aria-level=1], [role=heading][aria-level=1]",passForModal:!0},id:"page-has-heading-one"}],any:[],none:[]},{id:"presentation-role-conflict",impact:"minor",selector:'img[alt=\\'\\'], [role="none"], [role="presentation"]',matches:"has-implicit-chromium-role-matches",tags:["cat.aria","best-practice","ACT"],actIds:["46ca7f"],all:[],any:[],none:["is-element-focusable","has-global-aria-attribute"]},{id:"region",impact:"moderate",selector:"body *",tags:["cat.keyboard","best-practice"],all:[],any:[{options:{regionMatcher:"dialog, [role=dialog], [role=alertdialog], svg"},id:"region"}],none:[]},{id:"role-img-alt",impact:"serious",selector:"[role='img']:not(img, area, input, object)",matches:"html-namespace-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","TTv5","TT7.a","EN-301-549","EN-9.1.1.1","ACT"],actIds:["23a2a8"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"scope-attr-valid",impact:"moderate",selector:"td[scope], th[scope]",tags:["cat.tables","best-practice"],all:["html5-scope",{options:{values:["row","col","rowgroup","colgroup"]},id:"scope-value"}],any:[],none:[]},{id:"scrollable-region-focusable",impact:"serious",selector:"*:not(select,textarea)",matches:"scrollable-region-focusable-matches",tags:["cat.keyboard","wcag2a","wcag211","TTv5","TT4.a","EN-301-549","EN-9.2.1.1"],actIds:["0ssw9k"],all:[],any:["focusable-content","focusable-element"],none:[]},{id:"select-name",impact:"critical",selector:"select",tags:["cat.forms","wcag2a","wcag412","section508","section508.22.n","TTv5","TT5.c","EN-301-549","EN-9.4.1.2","ACT"],actIds:["e086e5"],all:[],any:["implicit-label","explicit-label","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:["hidden-explicit-label"]},{id:"server-side-image-map",impact:"minor",selector:"img[ismap]",tags:["cat.text-alternatives","wcag2a","wcag211","section508","section508.22.f","TTv5","TT4.a","EN-301-549","EN-9.2.1.1"],all:[],any:[],none:["exists"]},{id:"skip-link",impact:"moderate",selector:'a[href^="#"], a[href^="/#"]',matches:"skip-link-matches",tags:["cat.keyboard","best-practice"],all:[],any:["skip-link"],none:[]},{id:"svg-img-alt",impact:"serious",selector:'[role="img"], [role="graphics-symbol"], svg[role="graphics-document"]',matches:"svg-namespace-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","TTv5","TT7.a","EN-301-549","EN-9.1.1.1","ACT"],actIds:["7d6734"],all:[],any:["svg-non-empty-title","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"tabindex",impact:"serious",selector:"[tabindex]",tags:["cat.keyboard","best-practice"],all:[],any:["tabindex"],none:[]},{id:"table-duplicate-name",impact:"minor",selector:"table",tags:["cat.tables","best-practice"],all:[],any:[],none:["same-caption-summary"]},{id:"table-fake-caption",impact:"serious",selector:"table",matches:"data-table-matches",tags:["cat.tables","experimental","wcag2a","wcag131","section508","section508.22.g","EN-301-549","EN-9.1.3.1"],all:["caption-faked"],any:[],none:[]},{id:"target-size",impact:"serious",selector:"*",enabled:!1,matches:"widget-not-inline-matches",tags:["cat.sensory-and-visual-cues","wcag22aa","wcag258"],all:[],any:[{options:{minSize:24},id:"target-size"},{options:{minOffset:24},id:"target-offset"}],none:[]},{id:"td-has-header",impact:"critical",selector:"table",matches:"data-table-large-matches",tags:["cat.tables","experimental","wcag2a","wcag131","section508","section508.22.g","TTv5","TT14.b","EN-301-549","EN-9.1.3.1"],all:["td-has-header"],any:[],none:[]},{id:"td-headers-attr",impact:"serious",selector:"table",matches:"table-or-grid-role-matches",tags:["cat.tables","wcag2a","wcag131","section508","section508.22.g","TTv5","TT14.b","EN-301-549","EN-9.1.3.1"],actIds:["a25f45"],all:["td-headers-attr"],any:[],none:[]},{id:"th-has-data-cells",impact:"serious",selector:"table",matches:"data-table-matches",tags:["cat.tables","wcag2a","wcag131","section508","section508.22.g","TTv5","TT14.b","EN-301-549","EN-9.1.3.1"],actIds:["d0f69e"],all:["th-has-data-cells"],any:[],none:[]},{id:"valid-lang",impact:"serious",selector:"[lang]:not(html), [xml\\\\:lang]:not(html)",tags:["cat.language","wcag2aa","wcag312","TTv5","TT11.b","EN-301-549","EN-9.3.1.2","ACT"],actIds:["de46e4"],all:[],any:[],none:[{options:{attributes:["lang","xml:lang"]},id:"valid-lang"}]},{id:"video-caption",impact:"critical",selector:"video",tags:["cat.text-alternatives","wcag2a","wcag122","section508","section508.22.a","TTv5","TT17.a","EN-301-549","EN-9.1.2.2"],actIds:["eac66b"],all:[],any:[],none:["caption"]}],checks:[{id:"abstractrole",evaluate:"abstractrole-evaluate"},{id:"aria-allowed-attr",evaluate:"aria-allowed-attr-evaluate",options:{validTreeRowAttrs:["aria-posinset","aria-setsize","aria-expanded","aria-level"]}},{id:"aria-allowed-role",evaluate:"aria-allowed-role-evaluate",options:{allowImplicit:!0,ignoredTags:[]}},{id:"aria-busy",evaluate:"aria-busy-evaluate"},{id:"aria-conditional-attr",evaluate:"aria-conditional-attr-evaluate",options:{invalidTableRowAttrs:["aria-posinset","aria-setsize","aria-expanded","aria-level"]}},{id:"aria-errormessage",evaluate:"aria-errormessage-evaluate"},{id:"aria-hidden-body",evaluate:"aria-hidden-body-evaluate"},{id:"aria-level",evaluate:"aria-level-evaluate"},{id:"aria-prohibited-attr",evaluate:"aria-prohibited-attr-evaluate",options:{elementsAllowedAriaLabel:["applet","input"]}},{id:"aria-required-attr",evaluate:"aria-required-attr-evaluate"},{id:"aria-required-children",evaluate:"aria-required-children-evaluate",options:{reviewEmpty:["doc-bibliography","doc-endnotes","grid","list","listbox","menu","menubar","table","tablist","tree","treegrid","rowgroup"]}},{id:"aria-required-parent",evaluate:"aria-required-parent-evaluate",options:{ownGroupRoles:["listitem","treeitem"]}},{id:"aria-roledescription",evaluate:"aria-roledescription-evaluate",options:{supportedRoles:["button","img","checkbox","radio","combobox","menuitemcheckbox","menuitemradio"]}},{id:"aria-unsupported-attr",evaluate:"aria-unsupported-attr-evaluate"},{id:"aria-valid-attr-value",evaluate:"aria-valid-attr-value-evaluate",options:[]},{id:"aria-valid-attr",evaluate:"aria-valid-attr-evaluate",options:[]},{id:"braille-label-equivalent",evaluate:"braille-label-equivalent-evaluate"},{id:"braille-roledescription-equivalent",evaluate:"braille-roledescription-equivalent-evaluate"},{id:"deprecatedrole",evaluate:"deprecatedrole-evaluate"},{id:"fallbackrole",evaluate:"fallbackrole-evaluate"},{id:"has-global-aria-attribute",evaluate:"has-global-aria-attribute-evaluate"},{id:"has-widget-role",evaluate:"has-widget-role-evaluate",options:[]},{id:"invalidrole",evaluate:"invalidrole-evaluate"},{id:"is-element-focusable",evaluate:"is-element-focusable-evaluate"},{id:"no-implicit-explicit-label",evaluate:"no-implicit-explicit-label-evaluate"},{id:"unsupportedrole",evaluate:"unsupportedrole-evaluate"},{id:"valid-scrollable-semantics",evaluate:"valid-scrollable-semantics-evaluate",options:{roles:["tooltip"]}},{id:"color-contrast-enhanced",evaluate:"color-contrast-evaluate",options:{ignoreUnicode:!0,ignoreLength:!1,ignorePseudo:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:7,minThreshold:4.5},large:{expected:4.5,minThreshold:3}},pseudoSizeThreshold:.25,shadowOutlineEmMax:.1,textStrokeEmMin:.03}},{id:"color-contrast",evaluate:"color-contrast-evaluate",options:{ignoreUnicode:!0,ignoreLength:!1,ignorePseudo:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:4.5},large:{expected:3}},pseudoSizeThreshold:.25,shadowOutlineEmMax:.2,textStrokeEmMin:.03}},{id:"link-in-text-block-style",evaluate:"link-in-text-block-style-evaluate"},{id:"link-in-text-block",evaluate:"link-in-text-block-evaluate",options:{requiredContrastRatio:3,allowSameColor:!0}},{id:"autocomplete-appropriate",evaluate:"autocomplete-appropriate-evaluate",deprecated:!0},{id:"autocomplete-valid",evaluate:"autocomplete-valid-evaluate",options:{stateTerms:["none","false","true","disabled","enabled","undefined","null"]}},{id:"accesskeys",evaluate:"accesskeys-evaluate",after:"accesskeys-after"},{id:"focusable-content",evaluate:"focusable-content-evaluate"},{id:"focusable-disabled",evaluate:"focusable-disabled-evaluate"},{id:"focusable-element",evaluate:"focusable-element-evaluate"},{id:"focusable-modal-open",evaluate:"focusable-modal-open-evaluate"},{id:"focusable-no-name",evaluate:"focusable-no-name-evaluate"},{id:"focusable-not-tabbable",evaluate:"focusable-not-tabbable-evaluate"},{id:"frame-focusable-content",evaluate:"frame-focusable-content-evaluate"},{id:"landmark-is-top-level",evaluate:"landmark-is-top-level-evaluate"},{id:"no-focusable-content",evaluate:"no-focusable-content-evaluate"},{id:"page-has-heading-one",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:"h1:not([role], [aria-level]), :is(h1, h2, h3, h4, h5, h6):not([role])[aria-level=1], [role=heading][aria-level=1]",passForModal:!0}},{id:"page-has-main",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:"main:not([role]), [role='main']",passForModal:!0}},{id:"page-no-duplicate-banner",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"header:not([role]), [role=banner]",role:"banner"}},{id:"page-no-duplicate-contentinfo",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"footer:not([role]), [role=contentinfo]",role:"contentinfo"}},{id:"page-no-duplicate-main",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"main:not([role]), [role='main']"}},{id:"tabindex",evaluate:"tabindex-evaluate"},{id:"alt-space-value",evaluate:"alt-space-value-evaluate"},{id:"duplicate-img-label",evaluate:"duplicate-img-label-evaluate",options:{parentSelector:"button, [role=button], a[href], p, li, td, th"}},{id:"explicit-label",evaluate:"explicit-evaluate"},{id:"help-same-as-label",evaluate:"help-same-as-label-evaluate"},{id:"hidden-explicit-label",evaluate:"hidden-explicit-label-evaluate"},{id:"implicit-label",evaluate:"implicit-evaluate"},{id:"label-content-name-mismatch",evaluate:"label-content-name-mismatch-evaluate",options:{pixelThreshold:.1,occurrenceThreshold:3}},{id:"multiple-label",evaluate:"multiple-label-evaluate"},{id:"title-only",evaluate:"title-only-evaluate"},{id:"landmark-is-unique",evaluate:"landmark-is-unique-evaluate",after:"landmark-is-unique-after"},{id:"has-lang",evaluate:"has-lang-evaluate",options:{attributes:["lang","xml:lang"]}},{id:"valid-lang",evaluate:"valid-lang-evaluate",options:{attributes:["lang","xml:lang"]}},{id:"xml-lang-mismatch",evaluate:"xml-lang-mismatch-evaluate"},{id:"dlitem",evaluate:"dlitem-evaluate"},{id:"listitem",evaluate:"listitem-evaluate"},{id:"only-dlitems",evaluate:"invalid-children-evaluate",options:{validRoles:["definition","term","listitem"],validNodeNames:["dt","dd"],divGroups:!0}},{id:"only-listitems",evaluate:"invalid-children-evaluate",options:{validRoles:["listitem"],validNodeNames:["li"]}},{id:"structured-dlitems",evaluate:"structured-dlitems-evaluate"},{id:"caption",evaluate:"caption-evaluate"},{id:"frame-tested",evaluate:"frame-tested-evaluate",after:"frame-tested-after",options:{isViolation:!1}},{id:"no-autoplay-audio",evaluate:"no-autoplay-audio-evaluate",options:{allowedDuration:3}},{id:"css-orientation-lock",evaluate:"css-orientation-lock-evaluate",options:{degreeThreshold:2}},{id:"meta-viewport-large",evaluate:"meta-viewport-scale-evaluate",options:{scaleMinimum:5,lowerBound:2}},{id:"meta-viewport",evaluate:"meta-viewport-scale-evaluate",options:{scaleMinimum:2}},{id:"target-offset",evaluate:"target-offset-evaluate",options:{minOffset:24}},{id:"target-size",evaluate:"target-size-evaluate",options:{minSize:24}},{id:"header-present",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:":is(h1, h2, h3, h4, h5, h6):not([role]), [role=heading]"}},{id:"heading-order",evaluate:"heading-order-evaluate",after:"heading-order-after"},{id:"identical-links-same-purpose",evaluate:"identical-links-same-purpose-evaluate",after:"identical-links-same-purpose-after"},{id:"internal-link-present",evaluate:"internal-link-present-evaluate"},{id:"landmark",evaluate:"has-descendant-evaluate",options:{selector:"main, [role=main]"}},{id:"meta-refresh-no-exceptions",evaluate:"meta-refresh-evaluate",options:{minDelay:72e3,maxDelay:!1}},{id:"meta-refresh",evaluate:"meta-refresh-evaluate",options:{minDelay:0,maxDelay:72e3}},{id:"p-as-heading",evaluate:"p-as-heading-evaluate",options:{margins:[{weight:150,italic:!0},{weight:150,size:1.15},{italic:!0,size:1.15},{size:1.4}],passLength:1,failLength:.5}},{id:"region",evaluate:"region-evaluate",after:"region-after",options:{regionMatcher:"dialog, [role=dialog], [role=alertdialog], svg"}},{id:"skip-link",evaluate:"skip-link-evaluate"},{id:"unique-frame-title",evaluate:"unique-frame-title-evaluate",after:"unique-frame-title-after"},{id:"duplicate-id-active",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"duplicate-id-aria",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"duplicate-id",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"aria-label",evaluate:"aria-label-evaluate"},{id:"aria-labelledby",evaluate:"aria-labelledby-evaluate"},{id:"avoid-inline-spacing",evaluate:"avoid-inline-spacing-evaluate",options:{cssProperties:["line-height","letter-spacing","word-spacing"]}},{id:"button-has-visible-text",evaluate:"has-text-content-evaluate"},{id:"doc-has-title",evaluate:"doc-has-title-evaluate"},{id:"exists",evaluate:"exists-evaluate"},{id:"has-alt",evaluate:"has-alt-evaluate"},{id:"has-visible-text",evaluate:"has-text-content-evaluate"},{id:"important-letter-spacing",evaluate:"inline-style-property-evaluate",options:{cssProperty:"letter-spacing",minValue:.12}},{id:"important-line-height",evaluate:"inline-style-property-evaluate",options:{multiLineOnly:!0,cssProperty:"line-height",minValue:1.5,normalValue:1}},{id:"important-word-spacing",evaluate:"inline-style-property-evaluate",options:{cssProperty:"word-spacing",minValue:.16}},{id:"is-on-screen",evaluate:"is-on-screen-evaluate"},{id:"non-empty-alt",evaluate:"attr-non-space-content-evaluate",options:{attribute:"alt"}},{id:"non-empty-if-present",evaluate:"non-empty-if-present-evaluate"},{id:"non-empty-placeholder",evaluate:"attr-non-space-content-evaluate",options:{attribute:"placeholder"}},{id:"non-empty-title",evaluate:"attr-non-space-content-evaluate",options:{attribute:"title"}},{id:"non-empty-value",evaluate:"attr-non-space-content-evaluate",options:{attribute:"value"}},{id:"presentational-role",evaluate:"presentational-role-evaluate"},{id:"role-none",evaluate:"matches-definition-evaluate",deprecated:!0,options:{matcher:{attributes:{role:"none"}}}},{id:"role-presentation",evaluate:"matches-definition-evaluate",deprecated:!0,options:{matcher:{attributes:{role:"presentation"}}}},{id:"svg-non-empty-title",evaluate:"svg-non-empty-title-evaluate"},{id:"caption-faked",evaluate:"caption-faked-evaluate"},{id:"html5-scope",evaluate:"html5-scope-evaluate"},{id:"same-caption-summary",evaluate:"same-caption-summary-evaluate"},{id:"scope-value",evaluate:"scope-value-evaluate",options:{values:["row","col","rowgroup","colgroup"]}},{id:"td-has-header",evaluate:"td-has-header-evaluate"},{id:"td-headers-attr",evaluate:"td-headers-attr-evaluate"},{id:"th-has-data-cells",evaluate:"th-has-data-cells-evaluate"},{id:"hidden-content",evaluate:"hidden-content-evaluate"}]})}("object"==typeof window?window:this);`});function NX(e){return(!e||typeof e=="string")&&(e=new Error(e)),{__failedInBrowser:!0,name:e.name||"Error",message:e.message||"unknown error",stack:e.stack}}function MX(e){let t=window.__ElementMatches||window.Element.prototype.matches,n=[],r=s(a=>{for(let o of a){if(!e||t.call(o,e)){let i=o;n.push(i)}o.shadowRoot&&r(o.shadowRoot.querySelectorAll("*"))}},"_findAllElements");return r(document.querySelectorAll("*")),n}function Cu(e,t=[],n=500){let a=["autofill-information","autofill-prediction","title"];e instanceof ShadowRoot&&(e=e.host);try{let o=e.cloneNode();e.ownerDocument.createElement("template").content.append(o),t.concat(a).forEach(m=>{o.removeAttribute(m)});let c=0;for(let m of o.getAttributeNames()){if(c>n){o.removeAttribute(m);continue}let p=o.getAttribute(m);if(p===null)continue;let h=!1;if(m==="src"&&"currentSrc"in e){let y=e,v=y.currentSrc,D=y.ownerDocument.location.href;new URL(p,D).toString()!==v&&(p=v,h=!0)}let f=Na(p,75);if(f!==p&&(h=!0),p=f,h)if(m==="style"){let y=o;y.style.cssText=p}else o.setAttribute(m,p);c+=m.length+p.length}let u=/^[\s\S]*?>/,[l]=o.outerHTML.match(u)||[];return l&&c>n?l.slice(0,l.length-1)+" …>":l||""}catch{return`<${e.localName}>`}}function LX(){function e(){let n=Date.now(),r=0;for(;Date.now()-n<500;){let o="";for(let i=0;i<1e4;i++)o+="a";if(o.length===1)throw new Error("will never happen, but prevents compiler optimizations");r++}let a=(Date.now()-n)/1e3;return Math.round(r/10/a)}s(e,"benchmarkIndexGC");function t(){let n=[],r=[];for(let c=0;c<1e5;c++)n[c]=r[c]=c;let a=Date.now(),o=0;for(;o%10!==0||Date.now()-a<500;){let c=o%2===0?n:r,u=o%2===0?r:n;for(let l=0;l<c.length;l++)u[l]=c[l];o++}let i=(Date.now()-a)/1e3;return Math.round(o/10/i)}return s(t,"benchmarkIndexNoGC"),(e()+t())/2}function Jg(e){let t=s(i=>i.nodeType===Node.DOCUMENT_FRAGMENT_NODE,"isShadowRoot"),n=s(i=>t(i)?i.host:i.parentNode,"getNodeParent");function r(i){if(t(i))return"a";let c=0,u;for(;u=i.previousSibling;)i=u,!(i.nodeType===Node.TEXT_NODE&&(i.nodeValue||"").trim().length===0)&&c++;return c}s(r,"getNodeIndex");let a=e,o=[];for(;a&&n(a);){let i=r(a);o.push([i,a.nodeName]),a=n(a)}return o.reverse(),o.join(",")}function Zg(e){function t(r){let a=r.tagName.toLowerCase();return r.id?a+="#"+r.id:r.classList.length>0&&(a+="."+r.classList[0]),a}s(t,"getSelectorPart");let n=[];for(;n.length<4&&(n.unshift(t(e)),!(!e.parentElement||(e=e.parentElement,e.tagName==="HTML"))););return n.join(" > ")}function PX(e){function t(a,o){return a.style[o]||window.getComputedStyle(a)[o]}s(t,"getStyleAttrValue");let n=document.querySelector("html");if(!n)throw new Error("html element not found in document");if(n.scrollHeight<=n.clientHeight||!["scroll","auto","visible"].includes(t(n,"overflowY")))return!1;let r=e;for(;r;){let a=t(r,"position");if(a==="fixed"||a==="sticky")return!0;r=r.parentElement}return!1}function es(e){let t=e.tagName.toLowerCase();if(t!=="html"&&t!=="body"){let n=e instanceof HTMLElement&&e.innerText||e.getAttribute("alt")||e.getAttribute("aria-label");if(n)return Na(n,80);{let r=e.querySelector("[alt], [aria-label]");if(r)return es(r)}}return null}function Qg(e){let n=(window.__HTMLElementBoundingClientRect||window.HTMLElement.prototype.getBoundingClientRect).call(e);return{top:Math.round(n.top),bottom:Math.round(n.bottom),left:Math.round(n.left),right:Math.round(n.right),width:Math.round(n.width),height:Math.round(n.height)}}function OX(e){let n=Math.floor(40/e),r=window.requestIdleCallback;window.requestIdleCallback=(a,o)=>r(s(c=>{let u=Date.now();c.__timeRemaining=c.timeRemaining,c.timeRemaining=()=>{let l=c.__timeRemaining();return Math.min(l,Math.max(0,n-(Date.now()-u)))},c.timeRemaining.toString=()=>"function timeRemaining() { [native code] }",a(c)},"cbWrap"),o),window.requestIdleCallback.toString=()=>"function requestIdleCallback() { [native code] }"}function kp(e){window.__lighthouseNodesDontTouchOrAllVarianceGoesAway||(window.__lighthouseNodesDontTouchOrAllVarianceGoesAway=new Map),e=e instanceof ShadowRoot?e.host:e;let t=Zg(e),n=window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.get(e);return n||(n=[window.__lighthouseExecutionContextUniqueIdentifier===void 0?"page":window.__lighthouseExecutionContextUniqueIdentifier,window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.size,e.tagName].join("-"),window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.set(e,n)),{lhId:n,devtoolsNodePath:Jg(e),selector:t,boundingRect:Qg(e),snippet:Cu(e),nodeLabel:es(e)||t}}function Na(e,t){return Me.truncate(e,t)}function BX(){if(globalThis.isDevtools||globalThis.isLightrider)return!0;let e=No("core/lib/page-functions.js");try{return e.resolve("lighthouse-logger"),!1}catch{return!0}}function jX(){if(!BX())return"";let t=(()=>{let a=s(()=>{},"a")}).toString().replace("/* @__PURE__ */","").match(/=\s*([\w_]+)\(/);if(!t)throw new Error("Could not determine esbuild function wrapper name");let n=s((a,o)=>Object.defineProperty(a,"name",{value:o,configurable:!0}),"esbuildFunctionWrapper");return`let ${t[1]}=${n}`}function ku(e){let t=e.toString().match(/function ([\w$]+)/);if(!t)throw new Error(`could not find function name for: ${e}`);return t[1]}var UX,Cp,II,NI,qX,me,Zt=b(()=>{"use strict";d();Hi();Fn();s(NX,"wrapRuntimeEvalErrorInBrowser");s(MX,"getElementsInDocument");s(Cu,"getOuterHTMLSnippet");s(LX,"computeBenchmarkIndex");s(Jg,"getNodePath");s(Zg,"getNodeSelector");s(PX,"isPositionFixed");s(es,"getNodeLabel");s(Qg,"getBoundingClientRect");s(OX,"wrapRequestIdleCallback");s(kp,"getNodeDetails");s(Na,"truncate");s(BX,"isBundledEnvironment");UX=jX();s(jX,"createEsbuildFunctionWrapper");s(ku,"getRuntimeFunctionName");Cp={truncate:ku(Na),getNodeLabel:ku(es),getOuterHTMLSnippet:ku(Cu),getNodeDetails:ku(kp)};Na.toString=()=>`function ${Cp.truncate}(string, characterLimit) {
  const Util = { ${Me.truncate} };
  return Util.truncate(string, characterLimit);
}`;II=es.toString();es.toString=()=>`function ${Cp.getNodeLabel}(element) {
  ${Na};
  return (${II})(element);
}`;NI=Cu.toString();Cu.toString=()=>`function ${Cp.getOuterHTMLSnippet}(element, ignoreAttrs = [], snippetCharacterLimit = 500) {
  ${Na};
  return (${NI})(element, ignoreAttrs, snippetCharacterLimit);
}`;qX=kp.toString();kp.toString=()=>`function ${Cp.getNodeDetails}(element) {
  ${Na};
  ${Jg};
  ${Zg};
  ${Qg};
  ${NI};
  ${II};
  return (${qX})(element);
}`;me={wrapRuntimeEvalErrorInBrowser:NX,getElementsInDocument:MX,getOuterHTMLSnippet:Cu,computeBenchmarkIndex:LX,getNodeDetails:kp,getNodePath:Jg,getNodeSelector:Zg,getNodeLabel:es,isPositionFixed:PX,wrapRequestIdleCallback:OX,getBoundingClientRect:Qg,truncate:Na,esbuildFunctionWrapperString:UX,getRuntimeFunctionName:ku}});var MI={};T(MI,{default:()=>HX});async function ey(){let e=window.axe,t=`lighthouse-${Math.random()}`;e.configure({branding:{application:t},noHtml:!0});let n=await e.run(document,{elementRef:!0,runOnly:{type:"tag",values:["wcag2a","wcag2aa"]},resultTypes:["violations","inapplicable"],rules:{accesskeys:{enabled:!0},"area-alt":{enabled:!1},"aria-allowed-role":{enabled:!0},"aria-braille-equivalent":{enabled:!1},"aria-conditional-attr":{enabled:!1},"aria-deprecated-role":{enabled:!1},"aria-dialog-name":{enabled:!0},"aria-prohibited-attr":{enabled:!1},"aria-roledescription":{enabled:!1},"aria-treeitem-name":{enabled:!0},"aria-text":{enabled:!0},"audio-caption":{enabled:!1},blink:{enabled:!1},"duplicate-id-active":{enabled:!0},"duplicate-id":{enabled:!1},"empty-heading":{enabled:!0},"frame-focusable-content":{enabled:!1},"frame-title-unique":{enabled:!1},"heading-order":{enabled:!0},"html-xml-lang-mismatch":{enabled:!0},"identical-links-same-purpose":{enabled:!0},"image-redundant-alt":{enabled:!0},"input-button-name":{enabled:!0},"label-content-name-mismatch":{enabled:!0},"landmark-one-main":{enabled:!0},"link-in-text-block":{enabled:!0},marquee:{enabled:!1},"meta-viewport":{enabled:!0},"nested-interactive":{enabled:!1},"no-autoplay-audio":{enabled:!1},"role-img-alt":{enabled:!1},"scrollable-region-focusable":{enabled:!1},"select-name":{enabled:!0},"server-side-image-map":{enabled:!1},"skip-link":{enabled:!0},"svg-img-alt":{enabled:!1},tabindex:{enabled:!0},"table-duplicate-name":{enabled:!0},"table-fake-caption":{enabled:!0},"target-size":{enabled:!0},"td-has-header":{enabled:!0}}});return document.documentElement.scrollTop=0,{violations:n.violations.map(Ap),incomplete:n.incomplete.map(Ap),notApplicable:n.inapplicable.map(r=>({id:r.id})),passes:n.passes.map(r=>({id:r.id})),version:n.testEngine.version}}async function zX(){let e={x:window.scrollX,y:window.scrollY};try{return await ey()}finally{window.scrollTo(e.x,e.y)}}function Ap(e){let t=e.nodes.map(a=>{let{target:o,failureSummary:i,element:c}=a,u=getNodeDetails(c),l=new Set,m=s(f=>[null,"minor","moderate","serious","critical"].indexOf(f),"impactToNumber"),p=[...a.any,...a.all,...a.none].sort((f,y)=>m(y.impact)-m(f.impact));for(let f of p)for(let y of f.relatedNodes||[]){let v=y.element;if(l.size>=3)break;v&&c!==v&&l.add(v)}let h=[...l].map(getNodeDetails);return{target:o,failureSummary:i,node:u,relatedNodes:h}}),n=e.error,r;return n instanceof Error&&(r={name:n.name,message:n.message}),{id:e.id,impact:e.impact||void 0,tags:e.tags,nodes:t,error:r}}var ty,HX,LI=b(()=>{"use strict";d();Se();FI();Zt();s(ey,"runA11yChecks");s(zX,"runA11yChecksAndResetScroll");s(Ap,"createAxeRuleResultArtifact");ty=class extends ${static{s(this,"Accessibility")}meta={supportedModes:["snapshot","navigation"]};static pageFns={runA11yChecks:ey,createAxeRuleResultArtifact:Ap};getArtifact(t){return t.driver.executionContext.evaluate(zX,{args:[],useIsolation:!0,deps:[RI,me.getNodeDetails,Ap,ey]})}},HX=ty});function PI(e){if(!(/No node.*found/.test(e.message)||/Node.*does not belong to the document/.test(e.message)))throw e}async function OI(e,t){try{return(await e.sendCommand("DOM.resolveNode",{backendNodeId:t})).object.objectId}catch(n){return PI(n)}}async function BI(e,t){try{let{nodeId:n}=await e.sendCommand("DOM.pushNodeByPathToFrontend",{path:t}),{object:{objectId:r}}=await e.sendCommand("DOM.resolveNode",{nodeId:n});return r}catch(n){return PI(n)}}var ny=b(()=>{"use strict";d();s(PI,"handlePotentialMissingNodeError");s(OI,"resolveNodeIdToObjectId");s(BI,"resolveDevtoolsNodePathToObjectId")});var UI={};T(UI,{default:()=>WX});function GX(){let e=s(r=>{try{return new URL(r,window.location.href).href}catch{return""}},"resolveURLOrEmpty");function t(r){return(r.getAttribute("onclick")||"").slice(0,1024)}return s(t,"getTruncatedOnclick"),getElementsInDocument("a").map(r=>r instanceof HTMLAnchorElement?{href:r.href,rawHref:r.getAttribute("href")||"",onclick:t(r),role:r.getAttribute("role")||"",name:r.name,text:r.innerText,rel:r.rel,target:r.target,id:r.getAttribute("id")||"",node:getNodeDetails(r)}:{href:e(r.href.baseVal),rawHref:r.getAttribute("href")||"",onclick:t(r),role:r.getAttribute("role")||"",text:r.textContent||"",rel:"",target:r.target.baseVal||"",id:r.getAttribute("id")||"",node:getNodeDetails(r)})}async function VX(e,t){let n=await BI(e,t);return n?(await e.sendCommand("DOMDebugger.getEventListeners",{objectId:n})).listeners.map(({type:a})=>({type:a})):[]}var ry,WX,jI=b(()=>{"use strict";d();Se();Zt();ny();s(GX,"collectAnchorElements");s(VX,"getEventListeners");ry=class extends ${static{s(this,"AnchorElements")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(t){let n=t.driver.defaultSession,r=await t.driver.executionContext.evaluate(GX,{args:[],useIsolation:!0,deps:[me.getElementsInDocument,me.getNodeDetails]});await n.sendCommand("DOM.enable"),await n.sendCommand("DOM.getDocument",{depth:-1,pierce:!0});let a=r.map(async i=>{let c=await VX(n,i.node.devtoolsNodePath);return{...i,listeners:c}}),o=await Promise.all(a);return await n.sendCommand("DOM.disable"),o}},WX=ry});var Ma,_p=b(()=>{"use strict";d();jt();Zt();Ma=class e{static{s(this,"ExecutionContext")}constructor(t){this._session=t,this._executionContextId=void 0,this._executionContextIdentifiersCreated=0,t.on("Page.frameNavigated",()=>this.clearContextId()),t.on("Runtime.executionContextDestroyed",n=>{n.executionContextId===this._executionContextId&&this.clearContextId()})}getContextId(){return this._executionContextId}clearContextId(){this._executionContextId=void 0}async _getOrCreateIsolatedContextId(){if(typeof this._executionContextId=="number")return this._executionContextId;await this._session.sendCommand("Page.enable"),await this._session.sendCommand("Runtime.enable");let n=(await this._session.sendCommand("Page.getFrameTree")).frameTree.frame.id,r=await this._session.sendCommand("Page.createIsolatedWorld",{frameId:n,worldName:"lighthouse_isolated_context"});return this._executionContextId=r.executionContextId,this._executionContextIdentifiersCreated++,r.executionContextId}async _evaluateInContext(t,n){let r=this._session.hasNextProtocolTimeout()?this._session.getNextProtocolTimeout():6e4,a=n===void 0?void 0:this._executionContextIdentifiersCreated,o={expression:`(function wrapInNativePromise() {
        ${e._cachedNativesPreamble};
        globalThis.__lighthouseExecutionContextUniqueIdentifier =
          ${a};
        ${me.esbuildFunctionWrapperString}
        return new Promise(function (resolve) {
          return Promise.resolve()
            .then(_ => ${t})
            .catch(${me.wrapRuntimeEvalErrorInBrowser})
            .then(resolve);
        });
      }())
      //# sourceURL=_lighthouse-eval.js`,includeCommandLineAPI:!0,awaitPromise:!0,returnByValue:!0,timeout:r,contextId:n};this._session.setNextProtocolTimeout(r);let i=await this._session.sendCommand("Runtime.evaluate",o),c=i.exceptionDetails;if(c){let m=["Runtime.evaluate exception",`Expression: ${t.replace(/\s+/g," ").substring(0,100)}
---- (elided)`,c.stackTrace?null:`Parse error at: ${c.lineNumber+1}:${c.columnNumber+1}`,c.exception?.description||c.text].filter(Boolean),p=new Error(m.join(`
`));return Promise.reject(p)}if(i.result===void 0)return Promise.reject(new Error('Runtime.evaluate response did not contain a "result" object'));let u=i.result.value;return u?.__failedInBrowser?Promise.reject(Object.assign(new Error,u)):u}async evaluateAsync(t,n={}){let r=n.useIsolation?await this._getOrCreateIsolatedContextId():void 0;try{return await this._evaluateInContext(t,r)}catch(a){if(r&&a.message.includes("Cannot find context")){this.clearContextId();let o=await this._getOrCreateIsolatedContextId();return this._evaluateInContext(t,o)}throw a}}evaluate(t,n){let r=e.serializeArguments(n.args),o=`(() => {
      ${e.serializeDeps(n.deps)}
      return (${t})(${r});
    })()`;return this.evaluateAsync(o,n)}async evaluateOnNewDocument(t,n){let r=e.serializeArguments(n.args),a=e.serializeDeps(n.deps),o=`(() => {
      ${e._cachedNativesPreamble};
      ${a};
      (${t})(${r});
    })()
    //# sourceURL=_lighthouse-eval.js`;await this._session.sendCommand("Page.addScriptToEvaluateOnNewDocument",{source:o})}async cacheNativesOnNewDocument(){await this.evaluateOnNewDocument(()=>{window.__nativePromise=window.Promise,window.__nativeURL=window.URL,window.__nativePerformance=window.performance,window.__nativeFetch=window.fetch,window.__ElementMatches=window.Element.prototype.matches,window.__HTMLElementBoundingClientRect=window.HTMLElement.prototype.getBoundingClientRect},{args:[]})}static _cachedNativesPreamble=["const Promise = globalThis.__nativePromise || globalThis.Promise","const URL = globalThis.__nativeURL || globalThis.URL","const performance = globalThis.__nativePerformance || globalThis.performance","const fetch = globalThis.__nativeFetch || globalThis.fetch"].join(`;
`);static serializeArguments(t){return t.map(n=>n===void 0?"undefined":JSON.stringify(n)).join(",")}static serializeDeps(t){return t=[me.esbuildFunctionWrapperString,...t||[]],t.map(n=>{if(typeof n=="function"){let r=n.toString(),a=me.getRuntimeFunctionName(n);return a!==n.name?`${r}; const ${n.name} = ${a};`:r}else return n}).join(`
`)}}});function qI(){return{promise:Promise.resolve(),cancel(){}}}function Rp(e){let t=s(()=>{throw new Error("waitForFrameNavigated.cancel() called before it was defined")},"cancel");return{promise:new Promise((r,a)=>{e.once("Page.frameNavigated",r),t=s(()=>{e.off("Page.frameNavigated",r),a(new Error("Wait for navigated cancelled"))},"cancel")}),cancel:t}}function $X(e,t,n){let r=s(()=>{throw new Error("waitForFcp.cancel() called before it was defined")},"cancel");return{promise:new Promise((o,i)=>{let c=setTimeout(()=>{i(new j(j.errors.NO_FCP))},n),u,l=s(p=>{p.name==="firstContentfulPaint"&&(u=setTimeout(()=>{o(),r()},t))},"lifecycleListener");e.on("Page.lifecycleEvent",l);let m=!1;r=s(()=>{m||(m=!0,e.off("Page.lifecycleEvent",l),c&&clearTimeout(c),u&&clearTimeout(u),i(new Error("Wait for FCP canceled")))},"cancel")}),cancel:r}}function ay(e,t,n){let r=!1,a,o=s(()=>{throw new Error("waitForNetworkIdle.cancel() called before it was defined")},"cancel"),{networkQuietThresholdMs:i,busyEvent:c,idleEvent:u,isIdle:l}=n;return{promise:new Promise((p,h)=>{let f=s(()=>{t.once(c,y),a=setTimeout(()=>{o(),p()},i)},"onIdle"),y=s(()=>{t.once(u,f),a&&clearTimeout(a)},"onBusy"),v=s(()=>{r=!0,l(t)?f():y()},"domContentLoadedListener"),D=s(()=>{if(!r){F.verbose("waitFor","Waiting on DomContentLoaded");return}let S=t.getInflightRequests();if(F.isVerbose()&&S.length<20&&S.length>0){F.verbose("waitFor",`=== Waiting on ${S.length} requests to finish`);for(let k of S)F.verbose("waitFor",`Waiting on ${k.url.slice(0,120)} to finish`)}},"logStatus");t.on("requeststarted",D),t.on("requestfinished",D),t.on(c,D),n.pretendDCLAlreadyFired?v():e.once("Page.domContentEventFired",v);let E=!1;o=s(()=>{E||(E=!0,a&&clearTimeout(a),n.pretendDCLAlreadyFired||e.off("Page.domContentEventFired",v),t.removeListener(c,y),t.removeListener(u,f),t.removeListener("requeststarted",D),t.removeListener("requestfinished",D),t.removeListener(c,D))},"cancel")}),cancel:o}}function YX(e,t){if(!t)return{promise:Promise.resolve(),cancel:()=>{}};let n,r=!1;async function a(u,l){if(r)return;let m=await u.evaluate(XX,{args:[],useIsolation:!0});if(!r&&typeof m=="number")if(m>=t)F.verbose("waitFor",`CPU has been idle for ${m} ms`),l();else{F.verbose("waitFor",`CPU has been idle for ${m} ms`);let p=t-m;n=setTimeout(()=>a(u,l),p)}}s(a,"checkForQuiet");let o=s(()=>{throw new Error("waitForCPUIdle.cancel() called before it was defined")},"cancel"),i=new Ma(e);return{promise:new Promise((u,l)=>{i.evaluate(KX,{args:[],useIsolation:!0}).then(()=>a(i,u)).catch(l),o=s(()=>{r||(r=!0,n&&clearTimeout(n),l(new Error("Wait for CPU idle canceled")))},"cancel")}),cancel:o}}function KX(){if(window.____lastLongTask!==void 0)return;window.____lastLongTask=performance.now(),new window.PerformanceObserver(t=>{let n=t.getEntries();for(let r of n)if(r.entryType==="longtask"){let a=r.startTime+r.duration;window.____lastLongTask=Math.max(window.____lastLongTask||0,a)}}).observe({type:"longtask",buffered:!0})}function XX(){return new Promise(e=>{let t=performance.now(),n=window.____lastLongTask||0;setTimeout(()=>{let r=window.____lastLongTask||0,a=n===r?t-n:0;e(a)},150)})}function oy(e,t){let n=s(()=>{throw new Error("waitForLoadEvent.cancel() called before it was defined")},"cancel");return{promise:new Promise((a,o)=>{let i,c=s(function(){i=setTimeout(a,t)},"loadListener");e.once("Page.loadEventFired",c);let u=!1;n=s(()=>{u||(u=!0,e.off("Page.loadEventFired",c),i&&clearTimeout(i))},"cancel")}),cancel:n}}async function JX(e){try{return e.setNextProtocolTimeout(1e3),await e.sendCommand("Runtime.evaluate",{expression:'"ping"',returnByValue:!0,timeout:1e3}),!1}catch{return!0}}async function zI(e,t,n){let{pauseAfterFcpMs:r,pauseAfterLoadMs:a,networkQuietThresholdMs:o,cpuQuietThresholdMs:i,maxWaitForLoadedMs:c,maxWaitForFcpMs:u}=n,{waitForFcp:l,waitForLoadEvent:m,waitForNetworkIdle:p,waitForCPUIdle:h}=n._waitForTestOverrides||ZX,f,y=u?l(e,r,u):qI(),v=m(e,a),D=p(e,t,{networkQuietThresholdMs:o,busyEvent:"network-2-busy",idleEvent:"network-2-idle",isIdle:z=>z.is2Idle()}),E=p(e,t,{networkQuietThresholdMs:o,busyEvent:"network-critical-busy",idleEvent:"network-critical-idle",isIdle:z=>z.isCriticalIdle()}),S=qI(),k=Promise.all([y.promise,v.promise,D.promise,E.promise]).then(()=>(S=h(e,i),S.promise)).then(()=>s(async function(){return F.verbose("waitFor","loadEventFired and network considered idle"),{timedOut:!1}},"cleanupFn")).catch(z=>function(){throw z}),C=new Promise((z,B)=>{f=setTimeout(z,c)}).then(z=>async()=>{if(F.warn("waitFor","Timed out waiting for page load. Checking if page is hung..."),await JX(e))throw F.warn("waitFor","Page appears to be hung, killing JavaScript..."),await e.sendCommand("Emulation.setScriptExecutionDisabled",{value:!0}),await e.sendCommand("Runtime.terminateExecution"),new j(j.errors.PAGE_HUNG);let B=t.getInflightRequests().map(J=>J.url);return B.length>0&&F.warn("waitFor","Remaining inflight requests URLs",B),{timedOut:!0}}),R=await Promise.race([k,C]);return f&&clearTimeout(f),y.cancel(),v.cancel(),D.cancel(),S.cancel(),R()}function HI(e){function t(){let n=s(()=>{},"resolve"),r=new Promise(a=>n=a);return console.log(["You have enabled Lighthouse navigation debug mode.",'When you have finished inspecting the page, evaluate "continueLighthouseRun()"',"in the console to continue with the Lighthouse run."].join(" ")),window.continueLighthouseRun=n,r}return s(t,"createInPagePromise"),e.defaultSession.setNextProtocolTimeout(2**31-1),e.executionContext.evaluate(t,{args:[]})}var ZX,Fp=b(()=>{"use strict";d();Ae();It();_p();s(qI,"waitForNothing");s(Rp,"waitForFrameNavigated");s($X,"waitForFcp");s(ay,"waitForNetworkIdle");s(YX,"waitForCPUIdle");s(KX,"registerPerformanceObserverInPage");s(XX,"checkTimeSinceLastLongTaskInPage");s(oy,"waitForLoadEvent");s(JX,"isPageHung");ZX={waitForFcp:$X,waitForLoadEvent:oy,waitForCPUIdle:YX,waitForNetworkIdle:ay};s(zI,"waitForFullyLoaded");s(HI,"waitForUserToContinue")});var GI={};T(GI,{DevtoolsMessageLog:()=>Ip,default:()=>_t});var iy,Ip,_t,Mn=b(()=>{"use strict";d();Se();iy=class e extends ${static{s(this,"DevtoolsLog")}static symbol=Symbol("DevtoolsLog");meta={symbol:e.symbol,supportedModes:["timespan","navigation"]};constructor(){super(),this._messageLog=new Ip(/^(Page|Network|Target|Runtime)\./),this._onProtocolMessage=t=>this._messageLog.record(t)}async startSensitiveInstrumentation({driver:t}){this._messageLog.reset(),this._messageLog.beginRecording(),t.targetManager.on("protocolevent",this._onProtocolMessage),await t.defaultSession.sendCommand("Page.enable")}async stopSensitiveInstrumentation({driver:t}){this._messageLog.endRecording(),t.targetManager.off("protocolevent",this._onProtocolMessage)}async getArtifact(){return this._messageLog.messages}},Ip=class{static{s(this,"DevtoolsMessageLog")}constructor(t){this._filter=t,this._messages=[],this._isRecording=!1}get messages(){return this._messages}reset(){this._messages=[]}beginRecording(){this._isRecording=!0}endRecording(){this._isRecording=!1}record(t){this._isRecording&&typeof t.method=="string"&&(this._filter&&!this._filter.test(t.method)||this._messages.push(t))}},_t=iy});var VI={};T(VI,{default:()=>tJ});var QX,eJ,sy,tJ,WI=b(()=>{"use strict";d();Se();Fp();Mn();QX=100,eJ=100,sy=class e extends ${static{s(this,"BFCacheFailures")}meta={supportedModes:["navigation","timespan"],dependencies:{DevtoolsLog:_t.symbol}};static processBFCacheEventList(t){let n={Circumstantial:{},PageSupportNeeded:{},SupportPending:{}};for(let r of t){let a=n[r.type];a[r.reason]=[]}return{notRestoredReasonsTree:n}}static processBFCacheEventTree(t){let n={Circumstantial:{},PageSupportNeeded:{},SupportPending:{}};function r(a){for(let o of a.explanations){let i=n[o.type],c=i[o.reason]||[];c.push(a.url),i[o.reason]=c}for(let o of a.children)r(o)}return s(r,"traverse"),r(t),{notRestoredReasonsTree:n}}static processBFCacheEvent(t){return t?.notRestoredExplanationsTree?e.processBFCacheEventTree(t.notRestoredExplanationsTree):e.processBFCacheEventList(t?.notRestoredExplanations||[])}async activelyCollectBFCacheEvent(t){let n=t.driver.defaultSession,r;function a(u){r=u}s(a,"onBfCacheNotUsed"),n.on("Page.backForwardCacheNotUsed",a);let o=await n.sendCommand("Page.getNavigationHistory"),i=o.entries[o.currentIndex];await Promise.all([n.sendCommand("Page.navigate",{url:"chrome://terms"}),oy(n,eJ).promise]);let[,c]=await Promise.all([n.sendCommand("Page.navigateToHistoryEntry",{entryId:i.id}),Rp(n).promise]);if(await new Promise(u=>setTimeout(u,QX)),c.type!=="BackForwardCacheRestore"&&!r)throw new Error("bfcache failed but the failure reasons were not emitted in time");return n.off("Page.backForwardCacheNotUsed",a),r}passivelyCollectBFCacheEvents(t){let n=[];for(let r of t.dependencies.DevtoolsLog)r.method==="Page.backForwardCacheNotUsed"&&n.push(r.params);return n}async getArtifact(t){let n=this.passivelyCollectBFCacheEvents(t);if(t.gatherMode==="navigation"&&!t.settings.usePassiveGathering){let r=await this.activelyCollectBFCacheEvent(t);r&&n.push(r)}return n.map(e.processBFCacheEvent)}},tJ=sy});var $I={};T($I,{default:()=>rJ});function nJ(){return caches.keys().then(e=>Promise.all(e.map(t=>caches.open(t)))).then(e=>{let t=[];return Promise.all(e.map(n=>n.keys().then(r=>{t.push(...r.map(a=>a.url))}))).then(n=>t)})}var cy,rJ,YI=b(()=>{"use strict";d();Se();s(nJ,"getCacheContents");cy=class extends ${static{s(this,"CacheContents")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(t){return await t.driver.executionContext.evaluate(nJ,{args:[]})}},rJ=cy});var KI={};T(KI,{default:()=>oJ});function aJ(e){if(typeof e.value<"u"||e.type==="undefined")return String(e.value);if(typeof e.description=="string"&&e.description!==e.className)return e.description;let t=e.subtype||e.type,n=e.className||"Object";return`[${t} ${n}]`}var uy,oJ,XI=b(()=>{"use strict";d();Se();s(aJ,"remoteObjectToString");uy=class extends ${static{s(this,"ConsoleMessages")}meta={supportedModes:["timespan","navigation"]};constructor(){super(),this._logEntries=[],this._onConsoleAPICalled=this.onConsoleAPICalled.bind(this),this._onExceptionThrown=this.onExceptionThrown.bind(this),this._onLogEntryAdded=this.onLogEntry.bind(this)}onConsoleAPICalled(t){let{type:n}=t;if(n!=="warning"&&n!=="error")return;let a=(t.args||[]).map(aJ).join(" ");if(!a&&!t.stackTrace)return;let{url:o,lineNumber:i,columnNumber:c}=t.stackTrace?.callFrames[0]||{},u={eventType:"consoleAPI",source:n==="warning"?"console.warn":"console.error",level:n,text:a,stackTrace:t.stackTrace,timestamp:t.timestamp,url:o,lineNumber:i,columnNumber:c};this._logEntries.push(u)}onExceptionThrown(t){let n=t.exceptionDetails.exception?t.exceptionDetails.exception.description:t.exceptionDetails.text;if(!n)return;let r={eventType:"exception",source:"exception",level:"error",text:n,stackTrace:t.exceptionDetails.stackTrace,timestamp:t.timestamp,url:t.exceptionDetails.url,scriptId:t.exceptionDetails.scriptId,lineNumber:t.exceptionDetails.lineNumber,columnNumber:t.exceptionDetails.columnNumber};this._logEntries.push(r)}onLogEntry(t){let{source:n,level:r,text:a,stackTrace:o,timestamp:i,url:c,lineNumber:u}=t.entry,l=t.entry.stackTrace?.callFrames[0];this._logEntries.push({eventType:"protocolLog",source:n,level:r,text:a,stackTrace:o,timestamp:i,url:c,scriptId:l?.scriptId,lineNumber:u,columnNumber:l?.columnNumber})}async startInstrumentation(t){let n=t.driver.defaultSession;n.on("Log.entryAdded",this._onLogEntryAdded),await n.sendCommand("Log.enable"),await n.sendCommand("Log.startViolationsReport",{config:[{name:"discouragedAPIUse",threshold:-1}]}),n.on("Runtime.consoleAPICalled",this._onConsoleAPICalled),n.on("Runtime.exceptionThrown",this._onExceptionThrown),await n.sendCommand("Runtime.enable")}async stopInstrumentation({driver:t}){await t.defaultSession.sendCommand("Log.stopViolationsReport"),await t.defaultSession.off("Log.entryAdded",this._onLogEntryAdded),await t.defaultSession.sendCommand("Log.disable"),await t.defaultSession.off("Runtime.consoleAPICalled",this._onConsoleAPICalled),await t.defaultSession.off("Runtime.exceptionThrown",this._onExceptionThrown),await t.defaultSession.sendCommand("Runtime.disable")}async getArtifact(){return this._logEntries}},oJ=uy});var JI={};T(JI,{default:()=>iJ});var ly,iJ,ZI=b(()=>{"use strict";d();Ae();Se();or();ly=class extends ${static{s(this,"CSSUsage")}constructor(){super(),this._session=void 0,this._sheetPromises=new Map,this._ruleUsage=void 0,this._onStylesheetAdded=this._onStylesheetAdded.bind(this)}meta={supportedModes:["snapshot","timespan","navigation"]};async _onStylesheetAdded(t){if(!this._session)throw new Error("Session not initialized");let n=t.header.styleSheetId,r=this._session.sendCommand("CSS.getStyleSheetText",{styleSheetId:n}).then(a=>({header:t.header,content:a.text})).catch(a=>(F.warn("CSSUsage",`Error fetching content of stylesheet with URL "${t.header.sourceURL}"`),Rt.captureException(a,{tags:{gatherer:"CSSUsage"},extra:{url:t.header.sourceURL},level:"error"}),a));this._sheetPromises.set(n,r)}async startCSSUsageTracking(t){let n=t.driver.defaultSession;this._session=n,n.on("CSS.styleSheetAdded",this._onStylesheetAdded),await n.sendCommand("DOM.enable"),await n.sendCommand("CSS.enable"),await n.sendCommand("CSS.startRuleUsageTracking")}async stopCSSUsageTracking(t){let n=t.driver.defaultSession,r=await n.sendCommand("CSS.stopRuleUsageTracking");this._ruleUsage=r.ruleUsage,n.off("CSS.styleSheetAdded",this._onStylesheetAdded)}async startInstrumentation(t){t.gatherMode==="timespan"&&await this.startCSSUsageTracking(t)}async stopInstrumentation(t){t.gatherMode==="timespan"&&await this.stopCSSUsageTracking(t)}async getArtifact(t){let n=t.driver.defaultSession,r=t.driver.executionContext;t.gatherMode!=="timespan"&&(await this.startCSSUsageTracking(t),await r.evaluateAsync("getComputedStyle(document.body)"),await this.stopCSSUsageTracking(t));let a=new Map,o=await Promise.all(this._sheetPromises.values());for(let i of o)i instanceof Error||i.header.length!==0&&a.set(i.content,i);if(await n.sendCommand("CSS.disable"),await n.sendCommand("DOM.disable"),!this._ruleUsage)throw new Error("Issue collecting rule usages");return{rules:this._ruleUsage,stylesheets:Array.from(a.values())}}},iJ=ly});var QI={};T(QI,{default:()=>sJ});var dy,sJ,eN=b(()=>{"use strict";d();Mn();Se();dy=class extends ${static{s(this,"DevtoolsLogCompat")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:_t.symbol}};async getArtifact(t){return{defaultPass:t.dependencies.DevtoolsLog}}},sJ=dy});var tN={};T(tN,{default:()=>uJ});function cJ(){if(!document.doctype)return null;let e=document.compatMode,{name:t,publicId:n,systemId:r}=document.doctype;return{name:t,publicId:n,systemId:r,documentCompatMode:e}}var my,uJ,nN=b(()=>{"use strict";d();Se();s(cJ,"getDoctype");my=class extends ${static{s(this,"Doctype")}meta={supportedModes:["snapshot","navigation"]};getArtifact(t){return t.driver.executionContext.evaluate(cJ,{args:[],useIsolation:!0})}},uJ=my});var rN={};T(rN,{default:()=>dJ});function lJ(e=document.body,t=!0){let n=null,r=-1,a=-1,o=0,i=null,c=s(function(l,m=1){m>r&&(n=l,r=m),l.children.length>a&&(i=l,a=l.children.length);let p=l.firstElementChild;for(;p;)c(p,m+1),t&&p.shadowRoot&&c(p.shadowRoot,m+1),p=p.nextElementSibling,o++;return{maxDepth:r,maxWidth:a,numElements:o}},"_calcDOMWidthAndHeight"),u=c(e);return{depth:{max:u.maxDepth,...getNodeDetails(n)},width:{max:u.maxWidth,...getNodeDetails(i)},totalBodyElements:u.numElements}}var py,dJ,aN=b(()=>{"use strict";d();Se();Zt();s(lJ,"getDOMStats");py=class extends ${static{s(this,"DOMStats")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(t){let n=t.driver;await n.defaultSession.sendCommand("DOM.enable");let r=await n.executionContext.evaluate(lJ,{args:[],useIsolation:!0,deps:[me.getNodeDetails]});return await n.defaultSession.sendCommand("DOM.disable"),r}},dJ=py});var oN={};T(oN,{default:()=>bJ});var mJ,pJ,fJ,hJ,gJ,yJ,fy,bJ,iN=b(()=>{"use strict";d();Ae();Se();Ze();lt();or();de();Mn();mJ=5e3,pJ=2e3*1024,fJ=.92,hJ=.85,gJ=4096,yJ=/^image\/((x|ms|x-ms)-)?(png|bmp|jpeg)$/,fy=class e extends ${static{s(this,"OptimizedImages")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:_t.symbol}};constructor(){super(),this._encodingStartAt=0}static filterImageRequests(t){let n=new Set;return t.reduce((r,a)=>{if(n.has(a.url)||!a.finished||a.sessionTargetType!=="page")return r;n.add(a.url);let o=a.resourceType===G.TYPES.Image&&yJ.test(a.mimeType),i=G.getResourceSizeOnNetwork(a);return o&&i>gJ&&r.push({requestId:a.requestId,url:a.url,mimeType:a.mimeType,resourceSize:i}),r},[])}_getEncodedResponse(t,n,r){n=G.getRequestIdForBackend(n);let o={requestId:n,encoding:r,quality:r==="jpeg"?fJ:hJ,sizeOnly:!0};return t.sendCommand("Audits.getEncodedResponse",o)}async calculateImageStats(t,n){let r=n.resourceSize;if(Date.now()-this._encodingStartAt>mJ||r>pJ)return{originalSize:r,jpegSize:void 0,webpSize:void 0};let a=await this._getEncodedResponse(t,n.requestId,"jpeg"),o=await this._getEncodedResponse(t,n.requestId,"webp");return{originalSize:r,jpegSize:a.encodedSize,webpSize:o.encodedSize}}async computeOptimizedImages(t,n){this._encodingStartAt=Date.now();let r=[];for(let a of n)try{let i={failed:!1,...await this.calculateImageStats(t,a),...a};r.push(i)}catch(o){F.warn("optimized-images",o.message),Rt.captureException(o,{tags:{gatherer:"OptimizedImages"},extra:{imageUrl:Y.elideDataURI(a.url)},level:"warning"});let i={failed:!0,errMsg:o.message,...a};r.push(i)}return r}async getArtifact(t){let n=t.dependencies.DevtoolsLog,r=await H.request(n,t),a=e.filterImageRequests(r).sort((c,u)=>u.resourceSize-c.resourceSize),o=await this.computeOptimizedImages(t.driver.defaultSession,a),i=o.filter(c=>!c.failed);if(o.length&&!i.length)throw new Error("All image optimizations failed");return o}},bJ=fy});var Np,hy=b(()=>{d();Np={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"}});function vJ(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0}var sN,cN=b(()=>{d();s(vJ,"ZStream");sN=vJ});function ts(e,t,n,r,a){if(t.subarray&&e.subarray){e.set(t.subarray(n,n+r),a);return}for(var o=0;o<r;o++)e[a+o]=t[n+o]}var gy,ea,yy=b(()=>{"use strict";d();s(ts,"arraySet");gy=Uint8Array,ea=Uint16Array});function rs(e){for(var t=e.length;--t>=0;)e[t]=0}function vy(e,t,n,r,a){this.static_tree=e,this.extra_bits=t,this.extra_base=n,this.elems=r,this.max_length=a,this.has_stree=e&&e.length}function wy(e,t){this.dyn_tree=e,this.max_code=0,this.stat_desc=t}function SN(e){return e<256?Ru[e]:Ru[256+(e>>>7)]}function Iu(e,t){e.pending_buf[e.pending++]=t&255,e.pending_buf[e.pending++]=t>>>8&255}function kn(e,t,n){e.bi_valid>by-n?(e.bi_buf|=t<<e.bi_valid&65535,Iu(e,e.bi_buf),e.bi_buf=t>>by-e.bi_valid,e.bi_valid+=n-by):(e.bi_buf|=t<<e.bi_valid&65535,e.bi_valid+=n)}function Sr(e,t,n){kn(e,n[t*2],n[t*2+1])}function kN(e,t){var n=0;do n|=e&1,e>>>=1,n<<=1;while(--t>0);return n>>>1}function _J(e){e.bi_valid===16?(Iu(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):e.bi_valid>=8&&(e.pending_buf[e.pending++]=e.bi_buf&255,e.bi_buf>>=8,e.bi_valid-=8)}function RJ(e,t){var n=t.dyn_tree,r=t.max_code,a=t.stat_desc.static_tree,o=t.stat_desc.has_stree,i=t.stat_desc.extra_bits,c=t.stat_desc.extra_base,u=t.stat_desc.max_length,l,m,p,h,f,y,v=0;for(h=0;h<=qo;h++)e.bl_count[h]=0;for(n[e.heap[e.heap_max]*2+1]=0,l=e.heap_max+1;l<yN;l++)m=e.heap[l],h=n[n[m*2+1]*2+1]+1,h>u&&(h=u,v++),n[m*2+1]=h,!(m>r)&&(e.bl_count[h]++,f=0,m>=c&&(f=i[m-c]),y=n[m*2],e.opt_len+=y*(h+f),o&&(e.static_len+=y*(a[m*2+1]+f)));if(v!==0){do{for(h=u-1;e.bl_count[h]===0;)h--;e.bl_count[h]--,e.bl_count[h+1]+=2,e.bl_count[u]--,v-=2}while(v>0);for(h=u;h!==0;h--)for(m=e.bl_count[h];m!==0;)p=e.heap[--l],!(p>r)&&(n[p*2+1]!==h&&(e.opt_len+=(h-n[p*2+1])*n[p*2],n[p*2+1]=h),m--)}}function CN(e,t,n){var r=new Array(qo+1),a=0,o,i;for(o=1;o<=qo;o++)r[o]=a=a+n[o-1]<<1;for(i=0;i<=t;i++){var c=e[i*2+1];c!==0&&(e[i*2]=kN(r[c]++,c))}}function FJ(){var e,t,n,r,a,o=new Array(qo+1);for(n=0,r=0;r<Ty-1;r++)for(Cy[r]=n,e=0;e<1<<Ey[r];e++)Fu[n++]=r;for(Fu[n-1]=r,a=0,r=0;r<16;r++)for(Lp[r]=a,e=0;e<1<<Mp[r];e++)Ru[a++]=r;for(a>>=7;r<ns;r++)for(Lp[r]=a<<7,e=0;e<1<<Mp[r]-7;e++)Ru[256+a++]=r;for(t=0;t<=qo;t++)o[t]=0;for(e=0;e<=143;)ta[e*2+1]=8,e++,o[8]++;for(;e<=255;)ta[e*2+1]=9,e++,o[9]++;for(;e<=279;)ta[e*2+1]=7,e++,o[7]++;for(;e<=287;)ta[e*2+1]=8,e++,o[8]++;for(CN(ta,_u+1,o),e=0;e<ns;e++)Au[e*2+1]=5,Au[e*2]=kN(e,5);EN=new vy(ta,Ey,Nu+1,_u,qo),xN=new vy(Au,Mp,0,ns,qo),TN=new vy(new Array(0),CJ,0,Sy,kJ)}function AN(e){var t;for(t=0;t<_u;t++)e.dyn_ltree[t*2]=0;for(t=0;t<ns;t++)e.dyn_dtree[t*2]=0;for(t=0;t<Sy;t++)e.bl_tree[t*2]=0;e.dyn_ltree[ky*2]=1,e.opt_len=e.static_len=0,e.last_lit=e.matches=0}function _N(e){e.bi_valid>8?Iu(e,e.bi_buf):e.bi_valid>0&&(e.pending_buf[e.pending++]=e.bi_buf),e.bi_buf=0,e.bi_valid=0}function IJ(e,t,n,r){_N(e),r&&(Iu(e,n),Iu(e,~n)),ts(e.pending_buf,e.window,t,n,e.pending),e.pending+=n}function dN(e,t,n,r){var a=t*2,o=n*2;return e[a]<e[o]||e[a]===e[o]&&r[t]<=r[n]}function Dy(e,t,n){for(var r=e.heap[n],a=n<<1;a<=e.heap_len&&(a<e.heap_len&&dN(t,e.heap[a+1],e.heap[a],e.depth)&&a++,!dN(t,r,e.heap[a],e.depth));)e.heap[n]=e.heap[a],n=a,a<<=1;e.heap[n]=r}function mN(e,t,n){var r,a,o=0,i,c;if(e.last_lit!==0)do r=e.pending_buf[e.d_buf+o*2]<<8|e.pending_buf[e.d_buf+o*2+1],a=e.pending_buf[e.l_buf+o],o++,r===0?Sr(e,a,t):(i=Fu[a],Sr(e,i+Nu+1,t),c=Ey[i],c!==0&&(a-=Cy[i],kn(e,a,c)),r--,i=SN(r),Sr(e,i,n),c=Mp[i],c!==0&&(r-=Lp[i],kn(e,r,c)));while(o<e.last_lit);Sr(e,ky,t)}function xy(e,t){var n=t.dyn_tree,r=t.stat_desc.static_tree,a=t.stat_desc.has_stree,o=t.stat_desc.elems,i,c,u=-1,l;for(e.heap_len=0,e.heap_max=yN,i=0;i<o;i++)n[i*2]!==0?(e.heap[++e.heap_len]=u=i,e.depth[i]=0):n[i*2+1]=0;for(;e.heap_len<2;)l=e.heap[++e.heap_len]=u<2?++u:0,n[l*2]=1,e.depth[l]=0,e.opt_len--,a&&(e.static_len-=r[l*2+1]);for(t.max_code=u,i=e.heap_len>>1;i>=1;i--)Dy(e,n,i);l=o;do i=e.heap[1],e.heap[1]=e.heap[e.heap_len--],Dy(e,n,1),c=e.heap[1],e.heap[--e.heap_max]=i,e.heap[--e.heap_max]=c,n[l*2]=n[i*2]+n[c*2],e.depth[l]=(e.depth[i]>=e.depth[c]?e.depth[i]:e.depth[c])+1,n[i*2+1]=n[c*2+1]=l,e.heap[1]=l++,Dy(e,n,1);while(e.heap_len>=2);e.heap[--e.heap_max]=e.heap[1],RJ(e,t),CN(n,u,e.bl_count)}function pN(e,t,n){var r,a=-1,o,i=t[0*2+1],c=0,u=7,l=4;for(i===0&&(u=138,l=3),t[(n+1)*2+1]=65535,r=0;r<=n;r++)o=i,i=t[(r+1)*2+1],!(++c<u&&o===i)&&(c<l?e.bl_tree[o*2]+=c:o!==0?(o!==a&&e.bl_tree[o*2]++,e.bl_tree[bN*2]++):c<=10?e.bl_tree[vN*2]++:e.bl_tree[wN*2]++,c=0,a=o,i===0?(u=138,l=3):o===i?(u=6,l=3):(u=7,l=4))}function fN(e,t,n){var r,a=-1,o,i=t[0*2+1],c=0,u=7,l=4;for(i===0&&(u=138,l=3),r=0;r<=n;r++)if(o=i,i=t[(r+1)*2+1],!(++c<u&&o===i)){if(c<l)do Sr(e,o,e.bl_tree);while(--c!==0);else o!==0?(o!==a&&(Sr(e,o,e.bl_tree),c--),Sr(e,bN,e.bl_tree),kn(e,c-3,2)):c<=10?(Sr(e,vN,e.bl_tree),kn(e,c-3,3)):(Sr(e,wN,e.bl_tree),kn(e,c-11,7));c=0,a=o,i===0?(u=138,l=3):o===i?(u=6,l=3):(u=7,l=4)}}function NJ(e){var t;for(pN(e,e.dyn_ltree,e.l_desc.max_code),pN(e,e.dyn_dtree,e.d_desc.max_code),xy(e,e.bl_desc),t=Sy-1;t>=3&&e.bl_tree[DN[t]*2+1]===0;t--);return e.opt_len+=3*(t+1)+5+5+4,t}function MJ(e,t,n,r){var a;for(kn(e,t-257,5),kn(e,n-1,5),kn(e,r-4,4),a=0;a<r;a++)kn(e,e.bl_tree[DN[a]*2+1],3);fN(e,e.dyn_ltree,t-1),fN(e,e.dyn_dtree,n-1)}function LJ(e){var t=4093624447,n;for(n=0;n<=31;n++,t>>>=1)if(t&1&&e.dyn_ltree[n*2]!==0)return uN;if(e.dyn_ltree[9*2]!==0||e.dyn_ltree[10*2]!==0||e.dyn_ltree[13*2]!==0)return lN;for(n=32;n<Nu;n++)if(e.dyn_ltree[n*2]!==0)return lN;return uN}function RN(e){hN||(FJ(),hN=!0),e.l_desc=new wy(e.dyn_ltree,EN),e.d_desc=new wy(e.dyn_dtree,xN),e.bl_desc=new wy(e.bl_tree,TN),e.bi_buf=0,e.bi_valid=0,AN(e)}function Ay(e,t,n,r){kn(e,(EJ<<1)+(r?1:0),3),IJ(e,t,n,!0)}function FN(e){kn(e,gN<<1,3),Sr(e,ky,ta),_J(e)}function IN(e,t,n,r){var a,o,i=0;e.level>0?(e.strm.data_type===DJ&&(e.strm.data_type=LJ(e)),xy(e,e.l_desc),xy(e,e.d_desc),i=NJ(e),a=e.opt_len+3+7>>>3,o=e.static_len+3+7>>>3,o<=a&&(a=o)):a=o=n+5,n+4<=a&&t!==-1?Ay(e,t,n,r):e.strategy===wJ||o===a?(kn(e,(gN<<1)+(r?1:0),3),mN(e,ta,Au)):(kn(e,(xJ<<1)+(r?1:0),3),MJ(e,e.l_desc.max_code+1,e.d_desc.max_code+1,i+1),mN(e,e.dyn_ltree,e.dyn_dtree)),AN(e),r&&_N(e)}function na(e,t,n){return e.pending_buf[e.d_buf+e.last_lit*2]=t>>>8&255,e.pending_buf[e.d_buf+e.last_lit*2+1]=t&255,e.pending_buf[e.l_buf+e.last_lit]=n&255,e.last_lit++,t===0?e.dyn_ltree[n*2]++:(e.matches++,t--,e.dyn_ltree[(Fu[n]+Nu+1)*2]++,e.dyn_dtree[SN(t)*2]++),e.last_lit===e.lit_bufsize-1}var wJ,uN,lN,DJ,EJ,gN,xJ,TJ,SJ,Ty,Nu,_u,ns,Sy,yN,qo,by,kJ,ky,bN,vN,wN,Ey,Mp,CJ,DN,AJ,ta,Au,Ru,Fu,Cy,Lp,EN,xN,TN,hN,NN=b(()=>{"use strict";d();yy();wJ=4,uN=0,lN=1,DJ=2;s(rs,"zero");EJ=0,gN=1,xJ=2,TJ=3,SJ=258,Ty=29,Nu=256,_u=Nu+1+Ty,ns=30,Sy=19,yN=2*_u+1,qo=15,by=16,kJ=7,ky=256,bN=16,vN=17,wN=18,Ey=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],Mp=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],CJ=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],DN=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],AJ=512,ta=new Array((_u+2)*2);rs(ta);Au=new Array(ns*2);rs(Au);Ru=new Array(AJ);rs(Ru);Fu=new Array(SJ-TJ+1);rs(Fu);Cy=new Array(Ty);rs(Cy);Lp=new Array(ns);rs(Lp);s(vy,"StaticTreeDesc");s(wy,"TreeDesc");s(SN,"d_code");s(Iu,"put_short");s(kn,"send_bits");s(Sr,"send_code");s(kN,"bi_reverse");s(_J,"bi_flush");s(RJ,"gen_bitlen");s(CN,"gen_codes");s(FJ,"tr_static_init");s(AN,"init_block");s(_N,"bi_windup");s(IJ,"copy_block");s(dN,"smaller");s(Dy,"pqdownheap");s(mN,"compress_block");s(xy,"build_tree");s(pN,"scan_tree");s(fN,"send_tree");s(NJ,"build_bl_tree");s(MJ,"send_all_trees");s(LJ,"detect_data_type");hN=!1;s(RN,"_tr_init");s(Ay,"_tr_stored_block");s(FN,"_tr_align");s(IN,"_tr_flush_block");s(na,"_tr_tally")});function PJ(e,t,n,r){for(var a=e&65535|0,o=e>>>16&65535|0,i=0;n!==0;){i=n>2e3?2e3:n,n-=i;do a=a+t[r++]|0,o=o+a|0;while(--i);a%=65521,o%=65521}return a|o<<16|0}var MN,LN=b(()=>{d();s(PJ,"adler32");MN=PJ});function OJ(){for(var e,t=[],n=0;n<256;n++){e=n;for(var r=0;r<8;r++)e=e&1?3988292384^e>>>1:e>>>1;t[n]=e}return t}function UJ(e,t,n,r){var a=BJ,o=r+n;e^=-1;for(var i=r;i<o;i++)e=e>>>8^a[(e^t[i])&255];return e^-1}var BJ,ra,PN=b(()=>{d();s(OJ,"makeTable");BJ=OJ();s(UJ,"crc32");ra=UJ});function Ba(e,t){return e.msg=Np[t],t}function UN(e){return(e<<1)-(e>4?9:0)}function zo(e){for(var t=e.length;--t>=0;)e[t]=0}function La(e){var t=e.state,n=t.pending;n>e.avail_out&&(n=e.avail_out),n!==0&&(ts(e.output,t.pending_buf,t.pending_out,n,e.next_out),e.next_out+=n,t.pending_out+=n,e.total_out+=n,e.avail_out-=n,t.pending-=n,t.pending===0&&(t.pending_out=0))}function Qt(e,t){IN(e,e.block_start>=0?e.block_start:-1,e.strstart-e.block_start,t),e.block_start=e.strstart,La(e.strm)}function Xe(e,t){e.pending_buf[e.pending++]=t}function Mu(e,t){e.pending_buf[e.pending++]=t>>>8&255,e.pending_buf[e.pending++]=t&255}function rZ(e,t,n,r){var a=e.avail_in;return a>r&&(a=r),a===0?0:(e.avail_in-=a,ts(t,e.input,e.next_in,a,n),e.state.wrap===1?e.adler=MN(e.adler,t,a,n):e.state.wrap===2&&(e.adler=ra(e.adler,t,a,n)),e.next_in+=a,e.total_in+=a,a)}function jN(e,t){var n=e.max_chain_length,r=e.strstart,a,o,i=e.prev_length,c=e.nice_match,u=e.strstart>e.w_size-ir?e.strstart-(e.w_size-ir):0,l=e.window,m=e.w_mask,p=e.prev,h=e.strstart+Oa,f=l[r+i-1],y=l[r+i];e.prev_length>=e.good_match&&(n>>=2),c>e.lookahead&&(c=e.lookahead);do if(a=t,!(l[a+i]!==y||l[a+i-1]!==f||l[a]!==l[r]||l[++a]!==l[r+1])){r+=2,a++;do;while(l[++r]===l[++a]&&l[++r]===l[++a]&&l[++r]===l[++a]&&l[++r]===l[++a]&&l[++r]===l[++a]&&l[++r]===l[++a]&&l[++r]===l[++a]&&l[++r]===l[++a]&&r<h);if(o=Oa-(h-r),r=h-Oa,o>i){if(e.match_start=t,i=o,o>=c)break;f=l[r+i-1],y=l[r+i]}}while((t=p[t&m])>u&&--n!==0);return i<=e.lookahead?i:e.lookahead}function Ou(e){var t=e.w_size,n,r,a,o,i;do{if(o=e.window_size-e.lookahead-e.strstart,e.strstart>=t+(t-ir)){ts(e.window,e.window,t,t,0),e.match_start-=t,e.strstart-=t,e.block_start-=t,r=e.hash_size,n=r;do a=e.head[--n],e.head[n]=a>=t?a-t:0;while(--r);r=t,n=r;do a=e.prev[--n],e.prev[n]=a>=t?a-t:0;while(--r);o+=t}if(e.strm.avail_in===0)break;if(r=rZ(e.strm,e.window,e.strstart+e.lookahead,o),e.lookahead+=r,e.lookahead+e.insert>=et)for(i=e.strstart-e.insert,e.ins_h=e.window[i],e.ins_h=(e.ins_h<<e.hash_shift^e.window[i+1])&e.hash_mask;e.insert&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[i+et-1])&e.hash_mask,e.prev[i&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=i,i++,e.insert--,!(e.lookahead+e.insert<et)););}while(e.lookahead<ir&&e.strm.avail_in!==0)}function aZ(e,t){var n=65535;for(n>e.pending_buf_size-5&&(n=e.pending_buf_size-5);;){if(e.lookahead<=1){if(Ou(e),e.lookahead===0&&t===Vo)return Vt;if(e.lookahead===0)break}e.strstart+=e.lookahead,e.lookahead=0;var r=e.block_start+n;if((e.strstart===0||e.strstart>=r)&&(e.lookahead=e.strstart-r,e.strstart=r,Qt(e,!1),e.strm.avail_out===0)||e.strstart-e.block_start>=e.w_size-ir&&(Qt(e,!1),e.strm.avail_out===0))return Vt}return e.insert=0,t===Ua?(Qt(e,!0),e.strm.avail_out===0?Go:is):(e.strstart>e.block_start&&(Qt(e,!1),e.strm.avail_out===0),Vt)}function Ry(e,t){for(var n,r;;){if(e.lookahead<ir){if(Ou(e),e.lookahead<ir&&t===Vo)return Vt;if(e.lookahead===0)break}if(n=0,e.lookahead>=et&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+et-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),n!==0&&e.strstart-n<=e.w_size-ir&&(e.match_length=jN(e,n)),e.match_length>=et)if(r=na(e,e.strstart-e.match_start,e.match_length-et),e.lookahead-=e.match_length,e.match_length<=e.max_lazy_match&&e.lookahead>=et){e.match_length--;do e.strstart++,e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+et-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart;while(--e.match_length!==0);e.strstart++}else e.strstart+=e.match_length,e.match_length=0,e.ins_h=e.window[e.strstart],e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+1])&e.hash_mask;else r=na(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(r&&(Qt(e,!1),e.strm.avail_out===0))return Vt}return e.insert=e.strstart<et-1?e.strstart:et-1,t===Ua?(Qt(e,!0),e.strm.avail_out===0?Go:is):e.last_lit&&(Qt(e,!1),e.strm.avail_out===0)?Vt:Pu}function as(e,t){for(var n,r,a;;){if(e.lookahead<ir){if(Ou(e),e.lookahead<ir&&t===Vo)return Vt;if(e.lookahead===0)break}if(n=0,e.lookahead>=et&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+et-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),e.prev_length=e.match_length,e.prev_match=e.match_start,e.match_length=et-1,n!==0&&e.prev_length<e.max_lazy_match&&e.strstart-n<=e.w_size-ir&&(e.match_length=jN(e,n),e.match_length<=5&&(e.strategy===GJ||e.match_length===et&&e.strstart-e.match_start>4096)&&(e.match_length=et-1)),e.prev_length>=et&&e.match_length<=e.prev_length){a=e.strstart+e.lookahead-et,r=na(e,e.strstart-1-e.prev_match,e.prev_length-et),e.lookahead-=e.prev_length-1,e.prev_length-=2;do++e.strstart<=a&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+et-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart);while(--e.prev_length!==0);if(e.match_available=0,e.match_length=et-1,e.strstart++,r&&(Qt(e,!1),e.strm.avail_out===0))return Vt}else if(e.match_available){if(r=na(e,0,e.window[e.strstart-1]),r&&Qt(e,!1),e.strstart++,e.lookahead--,e.strm.avail_out===0)return Vt}else e.match_available=1,e.strstart++,e.lookahead--}return e.match_available&&(r=na(e,0,e.window[e.strstart-1]),e.match_available=0),e.insert=e.strstart<et-1?e.strstart:et-1,t===Ua?(Qt(e,!0),e.strm.avail_out===0?Go:is):e.last_lit&&(Qt(e,!1),e.strm.avail_out===0)?Vt:Pu}function oZ(e,t){for(var n,r,a,o,i=e.window;;){if(e.lookahead<=Oa){if(Ou(e),e.lookahead<=Oa&&t===Vo)return Vt;if(e.lookahead===0)break}if(e.match_length=0,e.lookahead>=et&&e.strstart>0&&(a=e.strstart-1,r=i[a],r===i[++a]&&r===i[++a]&&r===i[++a])){o=e.strstart+Oa;do;while(r===i[++a]&&r===i[++a]&&r===i[++a]&&r===i[++a]&&r===i[++a]&&r===i[++a]&&r===i[++a]&&r===i[++a]&&a<o);e.match_length=Oa-(o-a),e.match_length>e.lookahead&&(e.match_length=e.lookahead)}if(e.match_length>=et?(n=na(e,1,e.match_length-et),e.lookahead-=e.match_length,e.strstart+=e.match_length,e.match_length=0):(n=na(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++),n&&(Qt(e,!1),e.strm.avail_out===0))return Vt}return e.insert=0,t===Ua?(Qt(e,!0),e.strm.avail_out===0?Go:is):e.last_lit&&(Qt(e,!1),e.strm.avail_out===0)?Vt:Pu}function iZ(e,t){for(var n;;){if(e.lookahead===0&&(Ou(e),e.lookahead===0)){if(t===Vo)return Vt;break}if(e.match_length=0,n=na(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++,n&&(Qt(e,!1),e.strm.avail_out===0))return Vt}return e.insert=0,t===Ua?(Qt(e,!0),e.strm.avail_out===0?Go:is):e.last_lit&&(Qt(e,!1),e.strm.avail_out===0)?Vt:Pu}function kr(e,t,n,r,a){this.good_length=e,this.max_lazy=t,this.nice_length=n,this.max_chain=r,this.func=a}function sZ(e){e.window_size=2*e.w_size,zo(e.head),e.max_lazy_match=os[e.level].max_lazy,e.good_match=os[e.level].good_length,e.nice_match=os[e.level].nice_length,e.max_chain_length=os[e.level].max_chain,e.strstart=0,e.block_start=0,e.lookahead=0,e.insert=0,e.match_length=e.prev_length=et-1,e.match_available=0,e.ins_h=0}function cZ(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=Ny,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new ea(QJ*2),this.dyn_dtree=new ea((2*JJ+1)*2),this.bl_tree=new ea((2*ZJ+1)*2),zo(this.dyn_ltree),zo(this.dyn_dtree),zo(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new ea(eZ+1),this.heap=new ea(2*Fy+1),zo(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new ea(2*Fy+1),zo(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}function uZ(e){var t;return!e||!e.state?Ba(e,ja):(e.total_in=e.total_out=0,e.data_type=$J,t=e.state,t.pending=0,t.pending_out=0,t.wrap<0&&(t.wrap=-t.wrap),t.status=t.wrap?My:Ho,e.adler=t.wrap===2?0:1,t.last_flush=Vo,RN(t),Pa)}function Ly(e){var t=uZ(e);return t===Pa&&sZ(e.state),t}function qN(e,t,n,r,a,o){if(!e)return ja;var i=1;if(t===HJ&&(t=6),r<0?(i=0,r=-r):r>15&&(i=2,r-=16),a<1||a>YJ||n!==Ny||r<8||r>15||t<0||t>9||o<0||o>WJ)return Ba(e,ja);r===8&&(r=9);var c=new cZ;return e.state=c,c.strm=e,c.wrap=i,c.gzhead=null,c.w_bits=r,c.w_size=1<<c.w_bits,c.w_mask=c.w_size-1,c.hash_bits=a+7,c.hash_size=1<<c.hash_bits,c.hash_mask=c.hash_size-1,c.hash_shift=~~((c.hash_bits+et-1)/et),c.window=new gy(c.w_size*2),c.head=new ea(c.hash_size),c.prev=new ea(c.w_size),c.lit_bufsize=1<<a+6,c.pending_buf_size=c.lit_bufsize*4,c.pending_buf=new gy(c.pending_buf_size),c.d_buf=1*c.lit_bufsize,c.l_buf=(1+2)*c.lit_bufsize,c.level=t,c.strategy=o,c.method=n,Ly(e)}function zN(e,t){var n,r,a,o;if(!e||!e.state||t>ON||t<0)return e?Ba(e,ja):ja;if(r=e.state,!e.output||!e.input&&e.avail_in!==0||r.status===Lu&&t!==Ua)return Ba(e,e.avail_out===0?_y:ja);if(r.strm=e,n=r.last_flush,r.last_flush=t,r.status===My)if(r.wrap===2)e.adler=0,Xe(r,31),Xe(r,139),Xe(r,8),r.gzhead?(Xe(r,(r.gzhead.text?1:0)+(r.gzhead.hcrc?2:0)+(r.gzhead.extra?4:0)+(r.gzhead.name?8:0)+(r.gzhead.comment?16:0)),Xe(r,r.gzhead.time&255),Xe(r,r.gzhead.time>>8&255),Xe(r,r.gzhead.time>>16&255),Xe(r,r.gzhead.time>>24&255),Xe(r,r.level===9?2:r.strategy>=Pp||r.level<2?4:0),Xe(r,r.gzhead.os&255),r.gzhead.extra&&r.gzhead.extra.length&&(Xe(r,r.gzhead.extra.length&255),Xe(r,r.gzhead.extra.length>>8&255)),r.gzhead.hcrc&&(e.adler=ra(e.adler,r.pending_buf,r.pending,0)),r.gzindex=0,r.status=Iy):(Xe(r,0),Xe(r,0),Xe(r,0),Xe(r,0),Xe(r,0),Xe(r,r.level===9?2:r.strategy>=Pp||r.level<2?4:0),Xe(r,nZ),r.status=Ho);else{var i=Ny+(r.w_bits-8<<4)<<8,c=-1;r.strategy>=Pp||r.level<2?c=0:r.level<6?c=1:r.level===6?c=2:c=3,i|=c<<6,r.strstart!==0&&(i|=tZ),i+=31-i%31,r.status=Ho,Mu(r,i),r.strstart!==0&&(Mu(r,e.adler>>>16),Mu(r,e.adler&65535)),e.adler=1}if(r.status===Iy)if(r.gzhead.extra){for(a=r.pending;r.gzindex<(r.gzhead.extra.length&65535)&&!(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>a&&(e.adler=ra(e.adler,r.pending_buf,r.pending-a,a)),La(e),a=r.pending,r.pending===r.pending_buf_size));)Xe(r,r.gzhead.extra[r.gzindex]&255),r.gzindex++;r.gzhead.hcrc&&r.pending>a&&(e.adler=ra(e.adler,r.pending_buf,r.pending-a,a)),r.gzindex===r.gzhead.extra.length&&(r.gzindex=0,r.status=Op)}else r.status=Op;if(r.status===Op)if(r.gzhead.name){a=r.pending;do{if(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>a&&(e.adler=ra(e.adler,r.pending_buf,r.pending-a,a)),La(e),a=r.pending,r.pending===r.pending_buf_size)){o=1;break}r.gzindex<r.gzhead.name.length?o=r.gzhead.name.charCodeAt(r.gzindex++)&255:o=0,Xe(r,o)}while(o!==0);r.gzhead.hcrc&&r.pending>a&&(e.adler=ra(e.adler,r.pending_buf,r.pending-a,a)),o===0&&(r.gzindex=0,r.status=Bp)}else r.status=Bp;if(r.status===Bp)if(r.gzhead.comment){a=r.pending;do{if(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>a&&(e.adler=ra(e.adler,r.pending_buf,r.pending-a,a)),La(e),a=r.pending,r.pending===r.pending_buf_size)){o=1;break}r.gzindex<r.gzhead.comment.length?o=r.gzhead.comment.charCodeAt(r.gzindex++)&255:o=0,Xe(r,o)}while(o!==0);r.gzhead.hcrc&&r.pending>a&&(e.adler=ra(e.adler,r.pending_buf,r.pending-a,a)),o===0&&(r.status=Up)}else r.status=Up;if(r.status===Up&&(r.gzhead.hcrc?(r.pending+2>r.pending_buf_size&&La(e),r.pending+2<=r.pending_buf_size&&(Xe(r,e.adler&255),Xe(r,e.adler>>8&255),e.adler=0,r.status=Ho)):r.status=Ho),r.pending!==0){if(La(e),e.avail_out===0)return r.last_flush=-1,Pa}else if(e.avail_in===0&&UN(t)<=UN(n)&&t!==Ua)return Ba(e,_y);if(r.status===Lu&&e.avail_in!==0)return Ba(e,_y);if(e.avail_in!==0||r.lookahead!==0||t!==Vo&&r.status!==Lu){var u=r.strategy===Pp?iZ(r,t):r.strategy===VJ?oZ(r,t):os[r.level].func(r,t);if((u===Go||u===is)&&(r.status=Lu),u===Vt||u===Go)return e.avail_out===0&&(r.last_flush=-1),Pa;if(u===Pu&&(t===jJ?FN(r):t!==ON&&(Ay(r,0,0,!1),t===qJ&&(zo(r.head),r.lookahead===0&&(r.strstart=0,r.block_start=0,r.insert=0))),La(e),e.avail_out===0))return r.last_flush=-1,Pa}return t!==Ua?Pa:r.wrap<=0?BN:(r.wrap===2?(Xe(r,e.adler&255),Xe(r,e.adler>>8&255),Xe(r,e.adler>>16&255),Xe(r,e.adler>>24&255),Xe(r,e.total_in&255),Xe(r,e.total_in>>8&255),Xe(r,e.total_in>>16&255),Xe(r,e.total_in>>24&255)):(Mu(r,e.adler>>>16),Mu(r,e.adler&65535)),La(e),r.wrap>0&&(r.wrap=-r.wrap),r.pending!==0?Pa:BN)}function HN(e){var t;return!e||!e.state?ja:(t=e.state.status,t!==My&&t!==Iy&&t!==Op&&t!==Bp&&t!==Up&&t!==Ho&&t!==Lu?Ba(e,ja):(e.state=null,t===Ho?Ba(e,zJ):Pa))}var Vo,jJ,qJ,Ua,ON,Pa,BN,ja,zJ,_y,HJ,GJ,Pp,VJ,WJ,$J,Ny,YJ,KJ,XJ,Fy,JJ,ZJ,QJ,eZ,et,Oa,ir,tZ,My,Iy,Op,Bp,Up,Ho,Lu,Vt,Pu,Go,is,nZ,os,GN=b(()=>{d();yy();NN();LN();PN();hy();Vo=0,jJ=1,qJ=3,Ua=4,ON=5,Pa=0,BN=1,ja=-2,zJ=-3,_y=-5,HJ=-1,GJ=1,Pp=2,VJ=3,WJ=4,$J=2,Ny=8,YJ=9,KJ=29,XJ=256,Fy=XJ+1+KJ,JJ=30,ZJ=19,QJ=2*Fy+1,eZ=15,et=3,Oa=258,ir=Oa+et+1,tZ=32,My=42,Iy=69,Op=73,Bp=91,Up=103,Ho=113,Lu=666,Vt=1,Pu=2,Go=3,is=4,nZ=3;s(Ba,"err");s(UN,"rank");s(zo,"zero");s(La,"flush_pending");s(Qt,"flush_block_only");s(Xe,"put_byte");s(Mu,"putShortMSB");s(rZ,"read_buf");s(jN,"longest_match");s(Ou,"fill_window");s(aZ,"deflate_stored");s(Ry,"deflate_fast");s(as,"deflate_slow");s(oZ,"deflate_rle");s(iZ,"deflate_huff");s(kr,"Config");os=[new kr(0,0,0,0,aZ),new kr(4,4,8,4,Ry),new kr(4,5,16,8,Ry),new kr(4,6,32,32,Ry),new kr(4,4,16,16,as),new kr(8,16,32,32,as),new kr(8,16,128,128,as),new kr(8,32,128,256,as),new kr(32,128,258,1024,as),new kr(32,258,258,4096,as)];s(sZ,"lm_init");s(cZ,"DeflateState");s(uZ,"deflateResetKeep");s(Ly,"deflateReset");s(qN,"deflateInit2");s(zN,"deflate");s(HN,"deflateEnd")});var VN=b(()=>{d()});var Gp={};T(Gp,{DEFLATE:()=>cs,DEFLATERAW:()=>ss,GUNZIP:()=>qp,GZIP:()=>Bu,INFLATE:()=>zp,INFLATERAW:()=>Uu,NONE:()=>Py,UNZIP:()=>ju,Z_BEST_COMPRESSION:()=>bZ,Z_BEST_SPEED:()=>yZ,Z_BINARY:()=>SZ,Z_BLOCK:()=>JN,Z_BUF_ERROR:()=>hZ,Z_DATA_ERROR:()=>fZ,Z_DEFAULT_COMPRESSION:()=>vZ,Z_DEFAULT_STRATEGY:()=>TZ,Z_DEFLATED:()=>QN,Z_ERRNO:()=>mZ,Z_FILTERED:()=>wZ,Z_FINISH:()=>XN,Z_FIXED:()=>xZ,Z_FULL_FLUSH:()=>KN,Z_HUFFMAN_ONLY:()=>DZ,Z_NEED_DICT:()=>dZ,Z_NO_COMPRESSION:()=>gZ,Z_NO_FLUSH:()=>WN,Z_OK:()=>Hp,Z_PARTIAL_FLUSH:()=>$N,Z_RLE:()=>EZ,Z_STREAM_END:()=>ZN,Z_STREAM_ERROR:()=>pZ,Z_SYNC_FLUSH:()=>YN,Z_TEXT:()=>kZ,Z_TREES:()=>lZ,Z_UNKNOWN:()=>CZ,Zlib:()=>Cr});function Cr(e){if(e<cs||e>ju)throw new TypeError("Bad argument");this.mode=e,this.init_done=!1,this.write_in_progress=!1,this.pending_close=!1,this.windowBits=0,this.level=0,this.memLevel=0,this.strategy=0,this.dictionary=null}function AZ(e,t){for(var n=0;n<e.length;n++)this[t+n]=e[n]}var Py,cs,zp,Bu,qp,ss,Uu,ju,WN,$N,YN,KN,XN,JN,lZ,Hp,ZN,dZ,mZ,pZ,fZ,hZ,gZ,yZ,bZ,vZ,wZ,DZ,EZ,xZ,TZ,SZ,kZ,CZ,QN,jp,eM=b(()=>{d();hy();cN();GN();VN();Py=0,cs=1,zp=2,Bu=3,qp=4,ss=5,Uu=6,ju=7,WN=0,$N=1,YN=2,KN=3,XN=4,JN=5,lZ=6,Hp=0,ZN=1,dZ=2,mZ=-1,pZ=-2,fZ=-3,hZ=-5,gZ=0,yZ=1,bZ=9,vZ=-1,wZ=1,DZ=2,EZ=3,xZ=4,TZ=0,SZ=0,kZ=1,CZ=2,QN=8;s(Cr,"Zlib");Cr.prototype.init=function(e,t,n,r,a){this.windowBits=e,this.level=t,this.memLevel=n,this.strategy=r,(this.mode===Bu||this.mode===qp)&&(this.windowBits+=16),this.mode===ju&&(this.windowBits+=32),(this.mode===ss||this.mode===Uu)&&(this.windowBits=-this.windowBits),this.strm=new sN;var o;switch(this.mode){case cs:case Bu:case ss:o=qN(this.strm,this.level,QN,this.windowBits,this.memLevel,this.strategy);break;case zp:case qp:case Uu:case ju:o=(this.strm,this.windowBits,void 0);break;default:throw new Error("Unknown mode "+this.mode)}if(o!==Hp){this._error(o);return}this.write_in_progress=!1,this.init_done=!0};Cr.prototype.params=function(){throw new Error("deflateParams Not supported")};Cr.prototype._writeCheck=function(){if(!this.init_done)throw new Error("write before init");if(this.mode===Py)throw new Error("already finalized");if(this.write_in_progress)throw new Error("write already in progress");if(this.pending_close)throw new Error("close is pending")};Cr.prototype.write=function(e,t,n,r,a,o,i){this._writeCheck(),this.write_in_progress=!0;var c=this;return process.nextTick(function(){c.write_in_progress=!1;var u=c._write(e,t,n,r,a,o,i);c.callback(u[0],u[1]),c.pending_close&&c.close()}),this};s(AZ,"bufferSet");Cr.prototype.writeSync=function(e,t,n,r,a,o,i){return this._writeCheck(),this._write(e,t,n,r,a,o,i)};Cr.prototype._write=function(e,t,n,r,a,o,i){if(this.write_in_progress=!0,e!==WN&&e!==$N&&e!==YN&&e!==KN&&e!==XN&&e!==JN)throw new Error("Invalid flush value");t==null&&(t=new Buffer(0),r=0,n=0),a._set?a.set=a._set:a.set=AZ;var c=this.strm;c.avail_in=r,c.input=t,c.next_in=n,c.avail_out=i,c.output=a,c.next_out=o;var u;switch(this.mode){case cs:case Bu:case ss:u=zN(c,e);break;case ju:case zp:case qp:case Uu:u=void 0;break;default:throw new Error("Unknown mode "+this.mode)}return u!==ZN&&u!==Hp&&this._error(u),this.write_in_progress=!1,[c.avail_in,c.avail_out]};Cr.prototype.close=function(){if(this.write_in_progress){this.pending_close=!0;return}this.pending_close=!1,this.mode===cs||this.mode===Bu||this.mode===ss?HN(this.strm):(this.strm,void 0),this.mode=Py};Cr.prototype.reset=function(){switch(this.mode){case cs:case ss:jp=Ly(this.strm);break;case zp:case Uu:jp=(this.strm,void 0);break}jp!==Hp&&this._error(jp)};Cr.prototype._error=function(e){this.onerror(Np[e]+": "+this.strm.msg,e),this.write_in_progress=!1,this.pending_close&&this.close()}});function _Z(e,t){if(!e)throw new Error(t)}function tM(e,t,n){return typeof t=="function"&&(n=t,t={}),RZ(new Vp(t),e,n)}function RZ(e,t,n){var r=[],a=0;e.on("error",i),e.on("end",c),e.end(t),o();function o(){for(var u;(u=e.read())!==null;)r.push(u),a+=u.length;e.once("readable",o)}s(o,"flow");function i(u){e.removeListener("end",c),e.removeListener("readable",o),n(u)}s(i,"onError");function c(){var u=Buffer.concat(r,a);r=[],n(null,u),e.close()}s(c,"onEnd")}function By(e){if(!(this instanceof By))return new By(e);Mt.call(this,e,Z.DEFLATE)}function Uy(e){if(!(this instanceof Uy))return new Uy(e);Mt.call(this,e,Z.INFLATE)}function Vp(e){if(!(this instanceof Vp))return new Vp(e);Mt.call(this,e,Z.GZIP)}function jy(e){if(!(this instanceof jy))return new jy(e);Mt.call(this,e,Z.GUNZIP)}function qy(e){if(!(this instanceof qy))return new qy(e);Mt.call(this,e,Z.DEFLATERAW)}function zy(e){if(!(this instanceof zy))return new zy(e);Mt.call(this,e,Z.INFLATERAW)}function Hy(e){if(!(this instanceof Hy))return new Hy(e);Mt.call(this,e,Z.UNZIP)}function Mt(e,t){if(this._opts=e=e||{},this._chunkSize=e.chunkSize||Z.Z_DEFAULT_CHUNK,hn.call(this,e),e.flush&&e.flush!==Z.Z_NO_FLUSH&&e.flush!==Z.Z_PARTIAL_FLUSH&&e.flush!==Z.Z_SYNC_FLUSH&&e.flush!==Z.Z_FULL_FLUSH&&e.flush!==Z.Z_FINISH&&e.flush!==Z.Z_BLOCK)throw new Error("Invalid flush flag: "+e.flush);if(this._flushFlag=e.flush||Z.Z_NO_FLUSH,e.chunkSize&&(e.chunkSize<Z.Z_MIN_CHUNK||e.chunkSize>Z.Z_MAX_CHUNK))throw new Error("Invalid chunk size: "+e.chunkSize);if(e.windowBits&&(e.windowBits<Z.Z_MIN_WINDOWBITS||e.windowBits>Z.Z_MAX_WINDOWBITS))throw new Error("Invalid windowBits: "+e.windowBits);if(e.level&&(e.level<Z.Z_MIN_LEVEL||e.level>Z.Z_MAX_LEVEL))throw new Error("Invalid compression level: "+e.level);if(e.memLevel&&(e.memLevel<Z.Z_MIN_MEMLEVEL||e.memLevel>Z.Z_MAX_MEMLEVEL))throw new Error("Invalid memLevel: "+e.memLevel);if(e.strategy&&e.strategy!=Z.Z_FILTERED&&e.strategy!=Z.Z_HUFFMAN_ONLY&&e.strategy!=Z.Z_RLE&&e.strategy!=Z.Z_FIXED&&e.strategy!=Z.Z_DEFAULT_STRATEGY)throw new Error("Invalid strategy: "+e.strategy);if(e.dictionary&&!Buffer.isBuffer(e.dictionary))throw new Error("Invalid dictionary: it should be a Buffer instance");this._binding=new Z.Zlib(t);var n=this;this._hadError=!1,this._binding.onerror=function(o,i){n._binding=null,n._hadError=!0;var c=new Error(o);c.errno=i,c.code=Z.codes[i],n.emit("error",c)};var r=Z.Z_DEFAULT_COMPRESSION;typeof e.level=="number"&&(r=e.level);var a=Z.Z_DEFAULT_STRATEGY;typeof e.strategy=="number"&&(a=e.strategy),this._binding.init(e.windowBits||Z.Z_DEFAULT_WINDOWBITS,r,e.memLevel||Z.Z_DEFAULT_MEMLEVEL,a,e.dictionary),this._buffer=new Buffer(this._chunkSize),this._offset=0,this._closed=!1,this._level=r,this._strategy=a,this.once("end",this.close)}var Z,Oy,nM=b(()=>{d();wg();eM();Fa();s(_Z,"assert");Z={};Object.keys(Gp).forEach(function(e){Z[e]=Gp[e]});Z.Z_MIN_WINDOWBITS=8;Z.Z_MAX_WINDOWBITS=15;Z.Z_DEFAULT_WINDOWBITS=15;Z.Z_MIN_CHUNK=64;Z.Z_MAX_CHUNK=1/0;Z.Z_DEFAULT_CHUNK=16*1024;Z.Z_MIN_MEMLEVEL=1;Z.Z_MAX_MEMLEVEL=9;Z.Z_DEFAULT_MEMLEVEL=8;Z.Z_MIN_LEVEL=-1;Z.Z_MAX_LEVEL=9;Z.Z_DEFAULT_LEVEL=Z.Z_DEFAULT_COMPRESSION;Oy={Z_OK:Z.Z_OK,Z_STREAM_END:Z.Z_STREAM_END,Z_NEED_DICT:Z.Z_NEED_DICT,Z_ERRNO:Z.Z_ERRNO,Z_STREAM_ERROR:Z.Z_STREAM_ERROR,Z_DATA_ERROR:Z.Z_DATA_ERROR,Z_MEM_ERROR:Z.Z_MEM_ERROR,Z_BUF_ERROR:Z.Z_BUF_ERROR,Z_VERSION_ERROR:Z.Z_VERSION_ERROR};Object.keys(Oy).forEach(function(e){Oy[Oy[e]]=e});s(tM,"gzip");s(RZ,"zlibBuffer");s(By,"Deflate");s(Uy,"Inflate");s(Vp,"Gzip");s(jy,"Gunzip");s(qy,"DeflateRaw");s(zy,"InflateRaw");s(Hy,"Unzip");s(Mt,"Zlib");Ft(Mt,hn);Mt.prototype.params=function(e,t,n){if(e<Z.Z_MIN_LEVEL||e>Z.Z_MAX_LEVEL)throw new RangeError("Invalid compression level: "+e);if(t!=Z.Z_FILTERED&&t!=Z.Z_HUFFMAN_ONLY&&t!=Z.Z_RLE&&t!=Z.Z_FIXED&&t!=Z.Z_DEFAULT_STRATEGY)throw new TypeError("Invalid strategy: "+t);if(this._level!==e||this._strategy!==t){var r=this;this.flush(Z.Z_SYNC_FLUSH,function(){r._binding.params(e,t),r._hadError||(r._level=e,r._strategy=t,n&&n())})}else process.nextTick(n)};Mt.prototype.reset=function(){return this._binding.reset()};Mt.prototype._flush=function(e){this._transform(new Buffer(0),"",e)};Mt.prototype.flush=function(e,t){var n=this._writableState;if((typeof e=="function"||e===void 0&&!t)&&(t=e,e=Z.Z_FULL_FLUSH),n.ended)t&&process.nextTick(t);else if(n.ending)t&&this.once("end",t);else if(n.needDrain){var r=this;this.once("drain",function(){r.flush(t)})}else this._flushFlag=e,this.write(new Buffer(0),"",t)};Mt.prototype.close=function(e){if(e&&process.nextTick(e),!this._closed){this._closed=!0,this._binding.close();var t=this;process.nextTick(function(){t.emit("close")})}};Mt.prototype._transform=function(e,t,n){var r,a=this._writableState,o=a.ending||a.ended,i=o&&(!e||a.length===e.length);if(!e===null&&!Buffer.isBuffer(e))return n(new Error("invalid input"));i?r=Z.Z_FINISH:(r=this._flushFlag,e.length>=a.length&&(this._flushFlag=this._opts.flush||Z.Z_NO_FLUSH)),this._processChunk(e,r,n)};Mt.prototype._processChunk=function(e,t,n){var r=e&&e.length,a=this._chunkSize-this._offset,o=0,i=this,c=typeof n=="function";if(!c){var u=[],l=0,m;this.on("error",function(v){m=v});do var p=this._binding.writeSync(t,e,o,r,this._buffer,this._offset,a);while(!this._hadError&&y(p[0],p[1]));if(this._hadError)throw m;var h=Buffer.concat(u,l);return this.close(),h}var f=this._binding.write(t,e,o,r,this._buffer,this._offset,a);f.buffer=e,f.callback=y;function y(v,D){if(!i._hadError){var E=a-D;if(_Z(E>=0,"have should not go down"),E>0){var S=i._buffer.slice(i._offset,i._offset+E);i._offset+=E,c?i.push(S):(u.push(S),l+=S.length)}if((D===0||i._offset>=i._chunkSize)&&(a=i._chunkSize,i._offset=0,i._buffer=new Buffer(i._chunkSize)),D===0){if(o+=r-v,r=v,!c)return!0;var k=i._binding.write(t,e,o,r,i._buffer,i._offset,i._chunkSize);k.callback=y,k.buffer=e;return}if(!c)return!1;n()}}s(y,"callback")};Ft(By,Mt);Ft(Uy,Mt);Ft(Vp,Mt);Ft(jy,Mt);Ft(qy,Mt);Ft(zy,Mt);Ft(Hy,Mt)});async function Wp(e,t,n=1e3){return t=G.getRequestIdForBackend(t),e.setNextProtocolTimeout(n),(await e.sendCommand("Network.getResponseBody",{requestId:t})).body}var Gy=b(()=>{"use strict";d();lt();s(Wp,"fetchResponseBodyFromCache")});var rM={};T(rM,{default:()=>PZ});var FZ,IZ,NZ,MZ,LZ,Vy,PZ,aM=b(()=>{"use strict";d();Ci();nM();Ae();Se();Ze();lt();Mn();Gy();de();FZ="chrome-extension:",IZ=["content-encoding","x-original-content-encoding","x-content-encoding-over-network"],NZ=["gzip","br","deflate"],MZ=["image","audio","video"],LZ=[G.TYPES.Document,G.TYPES.Script,G.TYPES.Stylesheet,G.TYPES.XHR,G.TYPES.Fetch,G.TYPES.EventSource],Vy=class e extends ${static{s(this,"ResponseCompression")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:_t.symbol}};static filterUnoptimizedResponses(t){let n=[];return t.forEach(r=>{if(r.sessionTargetType!=="page")return;let a=r.mimeType,o=r.resourceType||G.TYPES.Other,i=r.resourceSize,u=!(a&&MZ.some(p=>a.startsWith(p)))&&LZ.includes(o),l=r.url.startsWith(FZ);if(!u||!i||!r.finished||l||!r.transferSize||r.statusCode===304)return;(r.responseHeaders||[]).find(p=>IZ.includes(p.name.toLowerCase())&&NZ.includes(p.value))||n.push({requestId:r.requestId,url:r.url,mimeType:a,transferSize:r.transferSize,resourceSize:i,gzipSize:0})}),n}async getCompressibleRecords(t,n){let r=t.driver.defaultSession,a=e.filterUnoptimizedResponses(n);return Promise.all(a.map(o=>Wp(r,o.requestId).then(i=>i?new Promise((c,u)=>tM(i,(l,m)=>{if(l)return u(l);o.gzipSize=U.byteLength(m,"utf8"),c(o)})):o).catch(i=>{if(!i?.message?.includes("No resource with given identifier found"))throw i.extra={url:Y.elideDataURI(o.url)},i;return F.error("ResponseCompression",i.message),o.gzipSize=void 0,o})))}async getArtifact(t){let n=t.dependencies.DevtoolsLog,r=await H.request(n,t);return this.getCompressibleRecords(t,r)}},PZ=Vy});var oM={};T(oM,{default:()=>UZ});function OZ(){window.___linkMediaChanges=[],Object.defineProperty(HTMLLinkElement.prototype,"media",{set:function(e){let t={href:this.href,media:e,msSinceHTMLEnd:Date.now()-performance.timing.responseEnd,matches:window.matchMedia(e).matches};window.___linkMediaChanges.push(t),this.setAttribute("media",e)}})}async function BZ(){let e=window.___linkMediaChanges;try{let t=[...document.querySelectorAll("link")].filter(r=>{if(!r.getAttribute("href"))return!1;let a=r.rel==="stylesheet"&&window.matchMedia(r.media).matches&&!r.disabled,o=r.rel==="import"&&!r.hasAttribute("async");return a||o}).map(r=>({tagName:"LINK",url:r.href,href:r.href,rel:r.rel,media:r.media,disabled:r.disabled,mediaChanges:e.filter(a=>a.href===r.href)})),n=[...document.querySelectorAll("head script[src]")].filter(r=>r instanceof SVGScriptElement?!1:!r.hasAttribute("async")&&!r.hasAttribute("defer")&&!/^data:/.test(r.src)&&!/^blob:/.test(r.src)&&r.getAttribute("type")!=="module").map(r=>({tagName:"SCRIPT",url:r.src,src:r.src}));return[...t,...n]}catch(t){let n="Unable to gather Scripts/Stylesheets/HTML Imports on the page";throw new Error(`${n}: ${t.message}`)}}var Wy,UZ,iM=b(()=>{"use strict";d();de();Mn();Se();s(OZ,"installMediaListener");s(BZ,"collectTagsThatBlockFirstPaint");Wy=class e extends ${static{s(this,"TagsBlockingFirstPaint")}meta={supportedModes:["navigation"],dependencies:{DevtoolsLog:_t.symbol}};static _filteredAndIndexedByUrl(t){let n=new Map;for(let r of t){if(!r.finished)continue;let a=r.initiator.type==="parser",o=/(css|script)/.test(r.mimeType)&&a,i=r.failed;(r.mimeType&&r.mimeType.includes("html")||o||i&&a)&&n.set(r.url,r)}return n}static async findBlockingTags(t,n){let r=n.reduce((c,u)=>Math.min(c,u.networkEndTime),1/0),a=await t.executionContext.evaluate(BZ,{args:[]}),o=e._filteredAndIndexedByUrl(n),i=[];for(let c of a){let u=o.get(c.url);if(!u||u.isLinkPreload)continue;let l=u.networkEndTime,m;if(c.tagName==="LINK"){let f=c.mediaChanges.filter(y=>!y.matches).map(y=>y.msSinceHTMLEnd);if(f.length>0){let y=Math.min(...f),v=Math.max(u.networkRequestTime,r+y/1e3);l=Math.min(l,v)}m=c.mediaChanges}let{tagName:p,url:h}=c;i.push({tag:{tagName:p,url:h,mediaChanges:m},transferSize:u.transferSize,startTime:u.networkRequestTime,endTime:l}),o.delete(c.url)}return i}async startSensitiveInstrumentation(t){let{executionContext:n}=t.driver;await n.evaluateOnNewDocument(OZ,{args:[]})}async getArtifact(t){let n=t.dependencies.DevtoolsLog,r=await H.request(n,t);return e.findBlockingTags(t.driver,r)}},UZ=Wy});function zZ(e,t){let r=e.match(/Chrome\/([\d.]+)/)?.[1]||"99.0.1234.0",[a]=r.split(".",1),o=[{brand:"Chromium",version:a},{brand:"Google Chrome",version:a},{brand:"Lighthouse",version:ip}],i={platform:"Android",platformVersion:"11.0",architecture:"",model:"moto g power (2022)"},c={platform:"macOS",platformVersion:"10.15.7",architecture:"x86",model:""},u=t==="mobile";return{brands:o,fullVersion:r,...u?i:c,mobile:u}}async function $p(e,t){if(t.emulatedUserAgent!==!1){let n=t.emulatedUserAgent;await e.sendCommand("Network.setUserAgentOverride",{userAgent:n,userAgentMetadata:zZ(n,t.formFactor)})}if(t.screenEmulation.disabled!==!0){let{width:n,height:r,deviceScaleFactor:a,mobile:o}=t.screenEmulation,i={width:n,height:r,deviceScaleFactor:a,mobile:o};await e.sendCommand("Emulation.setDeviceMetricsOverride",i),await e.sendCommand("Emulation.setTouchEmulationEnabled",{enabled:i.mobile})}}async function sM(e,t){if(t.throttlingMethod!=="devtools")return uM(e);await Promise.all([HZ(e,t.throttling),GZ(e,t.throttling)])}async function cM(e){await Promise.all([uM(e),VZ(e)])}function HZ(e,t){let n={offline:!1,latency:t.requestLatencyMs||0,downloadThroughput:t.downloadThroughputKbps||0,uploadThroughput:t.uploadThroughputKbps||0};return n.downloadThroughput=Math.floor(n.downloadThroughput*1024/8),n.uploadThroughput=Math.floor(n.uploadThroughput*1024/8),e.sendCommand("Network.emulateNetworkConditions",n)}function uM(e){return e.sendCommand("Network.emulateNetworkConditions",jZ)}function GZ(e,t){let n=t.cpuSlowdownMultiplier;return e.sendCommand("Emulation.setCPUThrottlingRate",{rate:n})}function VZ(e){return e.sendCommand("Emulation.setCPUThrottlingRate",qZ)}var jZ,qZ,Yp=b(()=>{"use strict";d();Wi();jZ={latency:0,downloadThroughput:0,uploadThroughput:0,offline:!1},qZ={rate:1};s(zZ,"parseUseragentIntoMetadata");s($p,"emulate");s(sM,"throttle");s(cM,"clearThrottling");s(HZ,"enableNetworkThrottling");s(uM,"clearNetworkThrottling");s(GZ,"enableCPUThrottling");s(VZ,"clearCPUThrottling")});var dM={};T(dM,{default:()=>JZ});function lM(e){return e.replace(/(-\w)/g,t=>t[1].toUpperCase())}function YZ(){let e=lM(window.screen.orientation.type);return{width:window.outerWidth,height:window.outerHeight,screenOrientation:{type:e,angle:window.screen.orientation.angle},deviceScaleFactor:window.devicePixelRatio}}function KZ(){return{width:window.innerWidth,height:window.innerHeight}}function XZ(){return new Promise(e=>{requestAnimationFrame(()=>requestAnimationFrame(e))})}var WZ,$Z,Yy,JZ,mM=b(()=>{"use strict";d();Se();Yp();Zt();Fp();WZ=30,$Z=16383;s(lM,"kebabCaseToCamelCase");s(YZ,"getObservedDeviceMetrics");s(KZ,"getScreenshotAreaSize");s(XZ,"waitForDoubleRaf");Yy=class extends ${static{s(this,"FullPageScreenshot")}meta={supportedModes:["snapshot","timespan","navigation"]};async _resizeViewport(t,n){let r=t.driver.defaultSession,a=await r.sendCommand("Page.getLayoutMetrics"),o=Math.round(n.height*a.cssContentSize.height/a.cssLayoutViewport.clientHeight),i=Math.min(o,$Z),c=t.driver.networkMonitor,u=ay(r,c,{pretendDCLAlreadyFired:!0,networkQuietThresholdMs:1e3,busyEvent:"network-critical-busy",idleEvent:"network-critical-idle",isIdle:l=>l.isCriticalIdle()});await r.sendCommand("Emulation.setDeviceMetricsOverride",{mobile:n.mobile,deviceScaleFactor:1,height:i,width:0}),await Promise.race([new Promise(l=>setTimeout(l,1e3*5)),u.promise]),u.cancel(),await t.driver.executionContext.evaluate(XZ,{args:[]})}async _takeScreenshot(t){let r="data:image/webp;base64,"+(await t.driver.defaultSession.sendCommand("Page.captureScreenshot",{format:"webp",quality:WZ})).data,a=await t.driver.executionContext.evaluate(KZ,{args:[],useIsolation:!0});return{data:r,width:a.width,height:a.height}}async _resolveNodes(t){function n(){let i={};if(!window.__lighthouseNodesDontTouchOrAllVarianceGoesAway)return i;let c=window.__lighthouseNodesDontTouchOrAllVarianceGoesAway;for(let[u,l]of c.entries()){let m=getBoundingClientRect(u);i[l]=m}return i}s(n,"resolveNodes");function r({useIsolation:i}){return t.driver.executionContext.evaluate(n,{args:[],useIsolation:i,deps:[me.getBoundingClientRect]})}s(r,"resolveNodesInPage");let a=await r({useIsolation:!1}),o=await r({useIsolation:!0});return{...a,...o}}async getArtifact(t){let n=t.driver.defaultSession,r=t.driver.executionContext,a=t.settings,o=!a.screenEmulation.disabled,i={...a.screenEmulation};try{if(!a.usePassiveGathering){if(!o){let l=await r.evaluate(YZ,{args:[],useIsolation:!0,deps:[lM]});i.height=l.height,i.width=l.width,i.deviceScaleFactor=l.deviceScaleFactor,i.mobile=a.formFactor==="mobile"}await this._resizeViewport(t,i)}let[c,u]=await Promise.all([this._takeScreenshot(t),this._resolveNodes(t)]);return{screenshot:c,nodes:u}}finally{a.usePassiveGathering||(o?await $p(n,a):await n.sendCommand("Emulation.setDeviceMetricsOverride",{mobile:i.mobile,deviceScaleFactor:i.deviceScaleFactor,height:i.height,width:0}))}}},JZ=Yy});var pM={};T(pM,{default:()=>ZZ});var Ky,ZZ,fM=b(()=>{"use strict";d();Ae();Se();Ky=class e extends ${static{s(this,"GlobalListeners")}meta={supportedModes:["snapshot","timespan","navigation"]};static _filterForAllowlistedTypes(t){return t.type==="pagehide"||t.type==="unload"||t.type==="visibilitychange"}getListenerIndentifier(t){return`${t.type}:${t.scriptId}:${t.columnNumber}:${t.lineNumber}`}dedupeListeners(t){let n=new Set;return t.filter(r=>{let a=this.getListenerIndentifier(r);return n.has(a)?!1:(n.add(a),!0)})}async getArtifact(t){let n=t.driver.defaultSession,r=[];for(let a of t.driver.targetManager.mainFrameExecutionContexts()){let o;try{let{result:c}=await n.sendCommand("Runtime.evaluate",{expression:"window",returnByValue:!1,uniqueContextId:a.uniqueId});if(!c.objectId)throw new Error("Error fetching information about the global object");o=c.objectId}catch(c){F.warn("Execution context is no longer valid",a,c);continue}let i=await n.sendCommand("DOMDebugger.getEventListeners",{objectId:o});for(let c of i.listeners)if(e._filterForAllowlistedTypes(c)){let{type:u,scriptId:l,lineNumber:m,columnNumber:p}=c;r.push({type:u,scriptId:l,lineNumber:m,columnNumber:p})}}return this.dedupeListeners(r)}},ZZ=Ky});var hM={};T(hM,{default:()=>eQ});function QZ(){let e=window.__HTMLElementBoundingClientRect||window.HTMLElement.prototype.getBoundingClientRect;return getElementsInDocument("iframe").map(n=>{let r=e.call(n),{top:a,bottom:o,left:i,right:c,width:u,height:l}=r;return{id:n.id,src:n.src,clientRect:{top:a,bottom:o,left:i,right:c,width:u,height:l},isPositionFixed:isPositionFixed(n),node:getNodeDetails(n)}})}var Xy,eQ,gM=b(()=>{"use strict";d();Se();Zt();s(QZ,"collectIFrameElements");Xy=class extends ${static{s(this,"IFrameElements")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(t){return await t.driver.executionContext.evaluate(QZ,{args:[],useIsolation:!0,deps:[me.getElementsInDocument,me.isPositionFixed,me.getNodeDetails]})}},eQ=Xy});var Zy={};T(Zy,{default:()=>sQ,findMostSpecificMatchedCSSRule:()=>zu,getEffectiveFontRule:()=>yM});function qu(e){return!!e&&!!e.cssProperties.find(({name:t})=>t===tQ)}function zu(e=[],t){let n;for(let r=e.length-1;r>=0;r--)if(t(e[r].rule.style)){n=e[r].rule;break}if(n)return{type:"Regular",...n.style,parentRule:{origin:n.origin,selectors:n.selectorList.selectors}}}function aQ(e=[]){for(let{inlineStyle:t,matchedCSSRules:n}of e){if(qu(t))return{type:"Inline",...t};let r=zu(n,qu);if(r)return r}}function yM({attributesStyle:e,inlineStyle:t,matchedCSSRules:n,inherited:r}){if(qu(t))return{type:"Inline",...t};let a=zu(n,qu);if(a)return a;if(qu(e))return{type:"Attributes",...e};let o=aQ(r);if(o)return o}function oQ(e){return e?Array.from(e.trim()).length:0}async function iQ(e,t){let n=await e.sendCommand("CSS.getMatchedStylesForNode",{nodeId:t}),r=yM(n);if(r)return{type:r.type,range:r.range,styleSheetId:r.styleSheetId,parentRule:r.parentRule&&{origin:r.parentRule.origin,selectors:r.parentRule.selectors}}}var tQ,nQ,rQ,Jy,sQ,Qy=b(()=>{"use strict";d();Se();tQ="font-size",nQ=12,rQ=50;s(qu,"hasFontSizeDeclaration");s(zu,"findMostSpecificMatchedCSSRule");s(aQ,"findInheritedCSSRule");s(yM,"getEffectiveFontRule");s(oQ,"getTextLength");s(iQ,"fetchSourceRule");Jy=class e extends ${static{s(this,"FontSize")}meta={supportedModes:["snapshot","navigation"]};static async fetchFailingNodeSourceRules(t,n){let r=n.sort((u,l)=>l.textLength-u.textLength).slice(0,rQ);await t.sendCommand("DOM.getDocument",{depth:-1,pierce:!0});let{nodeIds:a}=await t.sendCommand("DOM.pushNodesByBackendIdsToFrontend",{backendNodeIds:r.map(u=>u.parentNode.backendNodeId)}),o=r.map(async(u,l)=>{u.nodeId=a[l];try{let m=await iQ(t,a[l]);u.cssRule=m}catch{u.cssRule=void 0}return u}),i=await Promise.all(o),c=i.reduce((u,{textLength:l})=>u+=l,0);return{analyzedFailingNodesData:i,analyzedFailingTextLength:c}}getTextNodesInLayoutFromSnapshot(t){let n=t.strings,r=s(i=>n[i],"getString"),a=s(i=>parseFloat(n[i]),"getFloat"),o=[];for(let i=0;i<t.documents.length;i++){let c=t.documents[i];if(!c.nodes.backendNodeId||!c.nodes.parentIndex||!c.nodes.attributes||!c.nodes.nodeName)throw new Error("Unexpected response from DOMSnapshot.captureSnapshot.");let u=c.nodes,l=s(m=>({backendNodeId:u.backendNodeId[m],attributes:u.attributes[m].map(r),nodeName:r(u.nodeName[m])}),"getParentData");for(let m of c.textBoxes.layoutIndex){let p=n[c.layout.text[m]];if(!p)continue;let h=c.layout.nodeIndex[m],f=c.layout.styles[m],[y]=f,v=a(y),D=u.parentIndex[h],E=u.parentIndex[D],S=l(D),k=E!==void 0?l(E):void 0;o.push({nodeIndex:h,backendNodeId:u.backendNodeId[h],fontSize:v,textLength:oQ(p),parentNode:{...S,parentNode:k}})}}return o}findFailingNodes(t){let n=[],r=0,a=0;for(let o of this.getTextNodesInLayoutFromSnapshot(t))r+=o.textLength,o.fontSize<nQ&&(a+=o.textLength,n.push({nodeId:0,parentNode:o.parentNode,textLength:o.textLength,fontSize:o.fontSize}));return{totalTextLength:r,failingTextLength:a,failingNodes:n}}async getArtifact(t){let n=t.driver.defaultSession,r=new Map,a=s(p=>r.set(p.header.styleSheetId,p.header),"onStylesheetAdded");n.on("CSS.styleSheetAdded",a),await Promise.all([n.sendCommand("DOMSnapshot.enable"),n.sendCommand("DOM.enable"),n.sendCommand("CSS.enable")]);let o=await n.sendCommand("DOMSnapshot.captureSnapshot",{computedStyles:["font-size"]}),{totalTextLength:i,failingTextLength:c,failingNodes:u}=this.findFailingNodes(o),{analyzedFailingNodesData:l,analyzedFailingTextLength:m}=await e.fetchFailingNodeSourceRules(n,u);return n.off("CSS.styleSheetAdded",a),l.filter(p=>p.cssRule?.styleSheetId).forEach(p=>p.cssRule.stylesheet=r.get(p.cssRule.styleSheetId)),await Promise.all([n.sendCommand("DOMSnapshot.disable"),n.sendCommand("DOM.disable"),n.sendCommand("CSS.disable")]),{analyzedFailingNodesData:l,analyzedFailingTextLength:m,failingTextLength:c,totalTextLength:i}}},sQ=Jy});var DM={};T(DM,{default:()=>dQ});function nb(e){let t=e.getBoundingClientRect();return{top:t.top,bottom:t.bottom,left:t.left,right:t.right}}function rb(e,t){return e.parentElement&&e.parentElement.tagName==="PICTURE"?window.getComputedStyle(e.parentElement).getPropertyValue("position"):t.getPropertyValue("position")}function vM(e){return e.filter(n=>n.localName==="img").map(n=>{let r=window.getComputedStyle(n),a=!!n.parentElement&&n.parentElement.tagName==="PICTURE",o=!a&&!n.srcset;return{src:n.currentSrc,srcset:n.srcset,displayedWidth:n.width,displayedHeight:n.height,clientRect:nb(n),attributeWidth:n.getAttribute("width"),attributeHeight:n.getAttribute("height"),naturalDimensions:o?{width:n.naturalWidth,height:n.naturalHeight}:void 0,cssRules:void 0,computedStyles:{position:rb(n,r),objectFit:r.getPropertyValue("object-fit"),imageRendering:r.getPropertyValue("image-rendering")},isCss:!1,isPicture:a,loading:n.loading,isInShadowDOM:n.getRootNode()instanceof ShadowRoot,fetchPriority:n.fetchPriority,node:getNodeDetails(n)}})}function wM(e){let t=/^url\("([^"]+)"\)$/,n=[];for(let r of e){let a=window.getComputedStyle(r);if(!a.backgroundImage||!t.test(a.backgroundImage))continue;let i=a.backgroundImage.match(t)[1];n.push({src:i,srcset:"",displayedWidth:r.clientWidth,displayedHeight:r.clientHeight,clientRect:nb(r),attributeWidth:null,attributeHeight:null,naturalDimensions:void 0,cssEffectiveRules:void 0,computedStyles:{position:rb(r,a),objectFit:"",imageRendering:a.getPropertyValue("image-rendering")},isCss:!0,isPicture:!1,isInShadowDOM:r.getRootNode()instanceof ShadowRoot,node:getNodeDetails(r)})}return n}function cQ(){let e=getElementsInDocument();return vM(e).concat(wM(e))}function uQ(e){return new Promise((t,n)=>{let r=new Image;r.addEventListener("error",a=>n(new Error("determineNaturalSize failed img load"))),r.addEventListener("load",()=>{t({naturalWidth:r.naturalWidth,naturalHeight:r.naturalHeight})}),r.src=e})}function Kp(e,t){if(!e||!e.cssProperties)return;let n=e.cssProperties.find(({name:r})=>r===t);if(n)return n.value}function lQ(e,t){let r=zu(e,s(a=>Kp(a,t),"isDeclarationofInterest"));if(r)return Kp(r,t)}function eb({attributesStyle:e,inlineStyle:t,matchedCSSRules:n},r){let a=Kp(t,r);if(a)return a;let o=Kp(e,r);if(o)return o;let i=lQ(n,r);return i||null}function bM(e){return e.naturalDimensions?e.naturalDimensions.height*e.naturalDimensions.width:e.displayedHeight*e.displayedWidth}var tb,dQ,EM=b(()=>{"use strict";d();Ae();Se();Zt();Qy();s(nb,"getClientRect");s(rb,"getPosition");s(vM,"getHTMLImages");s(wM,"getCSSImages");s(cQ,"collectImageElementInfo");s(uQ,"determineNaturalSize");s(Kp,"findSizeDeclaration");s(lQ,"findMostSpecificCSSRule");s(eb,"getEffectiveSizingRule");s(bM,"getPixelArea");tb=class extends ${static{s(this,"ImageElements")}meta={supportedModes:["snapshot","timespan","navigation"]};constructor(){super(),this._naturalSizeCache=new Map}async fetchElementWithSizeInformation(t,n){let r=n.src,a=this._naturalSizeCache.get(r);if(!a)try{t.defaultSession.setNextProtocolTimeout(250),a=await t.executionContext.evaluate(uQ,{args:[r],useIsolation:!0}),this._naturalSizeCache.set(r,a)}catch{}a&&(n.naturalDimensions={width:a.naturalWidth,height:a.naturalHeight})}async fetchSourceRules(t,n,r){try{let{nodeId:a}=await t.sendCommand("DOM.pushNodeByPathToFrontend",{path:n});if(!a)return;let o=await t.sendCommand("CSS.getMatchedStylesForNode",{nodeId:a}),i=eb(o,"width"),c=eb(o,"height"),u=eb(o,"aspect-ratio");r.cssEffectiveRules={width:i,height:c,aspectRatio:u}}catch(a){if(/No node.*found/.test(a.message))return;throw a}}async collectExtraDetails(t,n){let r=!1;setTimeout(o=>r=!0,5e3);let a=0;for(let o of n){if(r){a++;continue}!o.isInShadowDOM&&!o.isCss&&await this.fetchSourceRules(t.defaultSession,o.node.devtoolsNodePath,o),(o.isPicture||o.isCss||o.srcset)&&await this.fetchElementWithSizeInformation(t,o)}r&&F.warn("ImageElements",`Reached gathering budget of 5s. Skipped extra details for ${a}/${n.length}`)}async getArtifact(t){let n=t.driver.defaultSession,a=await t.driver.executionContext.evaluate(cQ,{args:[],useIsolation:!0,deps:[me.getElementsInDocument,me.getBoundingClientRect,me.getNodeDetails,nb,rb,vM,wM]});return await Promise.all([n.sendCommand("DOM.enable"),n.sendCommand("CSS.enable"),n.sendCommand("DOM.getDocument",{depth:-1,pierce:!0})]),a.sort((o,i)=>bM(i)-bM(o)),await this.collectExtraDetails(t.driver,a),await Promise.all([n.sendCommand("DOM.disable"),n.sendCommand("CSS.disable")]),a}},dQ=tb});var xM={};T(xM,{default:()=>pQ});function mQ(){let e=[],t=new Map,n=new Map,r=getElementsInDocument("form");for(let i of r)t.set(i,{id:i.id,name:i.name,autocomplete:i.autocomplete,node:getNodeDetails(i)});let a=getElementsInDocument("label");for(let i of a)n.set(i,{for:i.htmlFor,node:getNodeDetails(i)});let o=getElementsInDocument("textarea, input, select");for(let i of o){let c=i.form,u=c?[...t.keys()].indexOf(c):void 0,l=[...i.labels||[]].map(p=>[...n.keys()].indexOf(p)),m;i.readOnly||(m=!i.dispatchEvent(new ClipboardEvent("paste",{cancelable:!0}))),e.push({parentFormIndex:u,labelIndices:l,id:i.id,name:i.name,type:i.type,placeholder:i instanceof HTMLSelectElement?void 0:i.placeholder,autocomplete:{property:i.autocomplete,attribute:i.getAttribute("autocomplete"),prediction:i.getAttribute("autofill-prediction")},preventsPaste:m,node:getNodeDetails(i)})}return{inputs:e,forms:[...t.values()],labels:[...n.values()]}}var ab,pQ,TM=b(()=>{"use strict";d();Se();Zt();s(mQ,"collectElements");ab=class extends ${static{s(this,"Inputs")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(t){return t.driver.executionContext.evaluate(mQ,{args:[],useIsolation:!0,deps:[me.getElementsInDocument,me.getNodeDetails]})}},pQ=ab});var SM={};T(SM,{default:()=>fQ});var ob,fQ,kM=b(()=>{"use strict";d();Se();de();Mn();ob=class extends ${static{s(this,"InspectorIssues")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:_t.symbol}};constructor(){super(),this._issues=[],this._onIssueAdded=this.onIssueAdded.bind(this)}onIssueAdded(t){this._issues.push(t.issue)}async startInstrumentation(t){let n=t.driver.defaultSession;n.on("Audits.issueAdded",this._onIssueAdded),await n.sendCommand("Audits.enable")}async stopInstrumentation(t){let n=t.driver.defaultSession;n.off("Audits.issueAdded",this._onIssueAdded),await n.sendCommand("Audits.disable")}async getArtifact(t){let n=t.dependencies.DevtoolsLog,r=await H.request(n,t),a={attributionReportingIssue:[],blockedByResponseIssue:[],bounceTrackingIssue:[],clientHintIssue:[],contentSecurityPolicyIssue:[],cookieDeprecationMetadataIssue:[],corsIssue:[],deprecationIssue:[],federatedAuthRequestIssue:[],genericIssue:[],heavyAdIssue:[],lowTextContrastIssue:[],mixedContentIssue:[],navigatorUserAgentIssue:[],propertyRuleIssue:[],quirksModeIssue:[],cookieIssue:[],sharedArrayBufferIssue:[],stylesheetLoadingIssue:[],federatedAuthUserInfoRequestIssue:[]},o=Object.keys(a);for(let i of o){let c=`${i}Details`,u=this._issues.map(l=>l.details[c]);for(let l of u){if(!l)continue;let m="request"in l&&l.request&&l.request.requestId;m?r.find(p=>p.requestId===m)&&a[i].push(l):a[i].push(l)}}return a}},fQ=ob});var CM={};T(CM,{default:()=>hQ});var ib,hQ,AM=b(()=>{"use strict";d();Ae();Se();ib=class e extends ${static{s(this,"InstallabilityErrors")}meta={supportedModes:["snapshot","navigation"]};static async getInstallabilityErrors(t){let n={msg:"Get webapp installability errors",id:"lh:gather:getInstallabilityErrors"};F.time(n);let a=(await t.sendCommand("Page.getInstallabilityErrors")).installabilityErrors;return F.timeEnd(n),{errors:a}}async getArtifact(t){let n=t.driver;try{return await e.getInstallabilityErrors(n.defaultSession)}catch{return{errors:[{errorId:"protocol-timeout",errorArguments:[]}]}}}},hQ=ib});var _M={};T(_M,{default:()=>gQ});var sb,gQ,RM=b(()=>{"use strict";d();Se();sb=class extends ${static{s(this,"JsUsage")}meta={supportedModes:["snapshot","timespan","navigation"]};constructor(){super(),this._scriptUsages=[]}async startInstrumentation(t){let n=t.driver.defaultSession;await n.sendCommand("Profiler.enable"),await n.sendCommand("Profiler.startPreciseCoverage",{detailed:!1})}async stopInstrumentation(t){let n=t.driver.defaultSession,r=await n.sendCommand("Profiler.takePreciseCoverage");this._scriptUsages=r.result,await n.sendCommand("Profiler.stopPreciseCoverage"),await n.sendCommand("Profiler.disable")}async getArtifact(){let t={};for(let n of this._scriptUsages)n.url===""||n.url==="_lighthouse-eval.js"||n.url!=="__puppeteer_evaluation_script__"&&(t[n.scriptId]=n);return t}},gQ=sb});var MM=I((pSe,NM)=>{"use strict";d();var yQ=/^utf-?8|ascii|utf-?16-?le|ucs-?2|base-?64|latin-?1$/i,bQ=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,vQ=/\s|\uFEFF|\xA0/,wQ=/\r?\n[\x20\x09]+/g,DQ=/[;,"]/,EQ=/[;,"]|\s/,xQ=/^[!#$%&'*+\-\.^_`|~\da-zA-Z]+$/,aa={IDLE:1,URI:2,ATTR:4};function FM(e){return e.replace(bQ,"")}s(FM,"trim");function Xp(e){return vQ.test(e)}s(Xp,"hasWhitespace");function TQ(e,t){for(;Xp(e[t]);)t++;return t}s(TQ,"skipWhitespace");function IM(e){return EQ.test(e)||!xQ.test(e)}s(IM,"needsQuotes");function SQ(e,t){return Object.keys(e).length===Object.keys(t).length&&Object.keys(e).every(n=>n in t&&e[n]===t[n])}s(SQ,"shallowCompareObjects");var Ot=class e{static{s(this,"Link")}constructor(t){this.refs=[],t&&this.parse(t)}rel(t){for(var n=[],r=t.toLowerCase(),a=0;a<this.refs.length;a++)this.refs[a].rel.toLowerCase()===r&&n.push(this.refs[a]);return n}get(t,n){t=t.toLowerCase();for(var r=[],a=0;a<this.refs.length;a++)this.refs[a][t]===n&&r.push(this.refs[a]);return r}set(t){return this.refs.push(t),this}setUnique(t){return this.refs.some(n=>SQ(n,t))||this.refs.push(t),this}has(t,n){t=t.toLowerCase();for(var r=0;r<this.refs.length;r++)if(this.refs[r][t]===n)return!0;return!1}parse(t,o){o=o||0,t=o?t.slice(o):t,t=FM(t).replace(wQ,"");for(var r=aa.IDLE,a=t.length,o=0,i=null;o<a;)if(r===aa.IDLE){if(Xp(t[o])){o++;continue}else if(t[o]==="<"){i!=null&&(i.rel!=null?this.refs.push(...e.expandRelations(i)):this.refs.push(i));var c=t.indexOf(">",o);if(c===-1)throw new Error("Expected end of URI delimiter at offset "+o);i={uri:t.slice(o+1,c)},o=c,r=aa.URI}else throw new Error('Unexpected character "'+t[o]+'" at offset '+o);o++}else if(r===aa.URI)if(Xp(t[o])){o++;continue}else if(t[o]===";")r=aa.ATTR,o++;else if(t[o]===",")r=aa.IDLE,o++;else throw new Error('Unexpected character "'+t[o]+'" at offset '+o);else if(r===aa.ATTR){if(t[o]===";"||Xp(t[o])){o++;continue}var c=t.indexOf("=",o);c===-1&&(c=t.indexOf(";",o)),c===-1&&(c=t.length);var u=FM(t.slice(o,c)).toLowerCase(),l="";if(o=c+1,o=TQ(t,o),t[o]==='"')for(o++;o<a;){if(t[o]==='"'){o++;break}t[o]==="\\"&&o++,l+=t[o],o++}else{for(var c=o+1;!DQ.test(t[c])&&c<a;)c++;l=t.slice(o,c),o=c}switch(i[u]&&e.isSingleOccurenceAttr(u)||(u[u.length-1]==="*"?i[u]=e.parseExtendedValue(l):(l=u==="type"?l.toLowerCase():l,i[u]!=null?Array.isArray(i[u])?i[u].push(l):i[u]=[i[u],l]:i[u]=l)),t[o]){case",":r=aa.IDLE;break;case";":r=aa.ATTR;break}o++}else throw new Error('Unknown parser state "'+r+'"');return i!=null&&(i.rel!=null?this.refs.push(...e.expandRelations(i)):this.refs.push(i)),i=null,this}toString(){for(var t=[],n="",r=null,a=0;a<this.refs.length;a++)r=this.refs[a],n=Object.keys(this.refs[a]).reduce(function(o,i){return i==="uri"?o:o+"; "+e.formatAttribute(i,r[i])},"<"+r.uri+">"),t.push(n);return t.join(", ")}};Ot.isCompatibleEncoding=function(e){return yQ.test(e)};Ot.parse=function(e,t){return new Ot().parse(e,t)};Ot.isSingleOccurenceAttr=function(e){return e==="rel"||e==="type"||e==="media"||e==="title"||e==="title*"};Ot.isTokenAttr=function(e){return e==="rel"||e==="type"||e==="anchor"};Ot.escapeQuotes=function(e){return e.replace(/"/g,'\\"')};Ot.expandRelations=function(e){var t=e.rel.split(" ");return t.map(function(n){var r=Object.assign({},e);return r.rel=n,r})};Ot.parseExtendedValue=function(e){var t=/([^']+)?(?:'([^']*)')?(.+)/.exec(e);return{language:t[2].toLowerCase(),encoding:Ot.isCompatibleEncoding(t[1])?null:t[1].toLowerCase(),value:Ot.isCompatibleEncoding(t[1])?decodeURIComponent(t[3]):t[3]}};Ot.formatExtendedAttribute=function(e,t){var n=(t.encoding||"utf-8").toUpperCase(),r=t.language||"en",a="";return Buffer.isBuffer(t.value)&&Ot.isCompatibleEncoding(n)?a=t.value.toString(n):Buffer.isBuffer(t.value)?a=t.value.toString("hex").replace(/[0-9a-f]{2}/gi,"%$1"):a=encodeURIComponent(t.value),e+"="+n+"'"+r+"'"+a};Ot.formatAttribute=function(e,t){return Array.isArray(t)?t.map(n=>Ot.formatAttribute(e,n)).join("; "):e[e.length-1]==="*"||typeof t!="string"?Ot.formatExtendedAttribute(e,t):(Ot.isTokenAttr(e)?t=IM(t)?'"'+Ot.escapeQuotes(t)+'"':Ot.escapeQuotes(t):IM(t)&&(t=encodeURIComponent(t),t=t.replace(/%20/g," ").replace(/%2C/g,",").replace(/%3B/g,";"),t='"'+t+'"'),e+"="+t)};NM.exports=Ot});var cb,_e,Bt=b(()=>{"use strict";d();ue();de();Uo();cb=class{static{s(this,"MainResource")}static async compute_(t,n){let{mainDocumentUrl:r}=t.URL;if(!r)throw new Error("mainDocumentUrl must exist to get the main resource");let a=await H.request(t.devtoolsLog,n),o=Gt.findLastDocumentForUrl(a,r);if(!o)throw new Error("Unable to identify the main resource");return o}},_e=q(cb,["URL","devtoolsLog"])});var PM={};T(PM,{UIStrings:()=>lb,default:()=>RQ});function CQ(e,t){try{return new URL(e,t).href}catch{return null}}function AQ(e){return e==="anonymous"?"anonymous":e==="use-credentials"?"use-credentials":null}function _Q(){let e=getElementsInDocument("link"),t=[];for(let n of e){if(!(n instanceof HTMLLinkElement))continue;let r=n.getAttribute("href")||"",a=n.closest("head")?"head":"body";t.push({rel:n.rel,href:n.href,hreflang:n.hreflang,as:n.as,crossOrigin:n.crossOrigin,hrefRaw:r,source:a,fetchPriority:n.fetchPriority,node:getNodeDetails(n)})}return t}var LM,lb,kQ,ub,RQ,OM=b(()=>{"use strict";d();LM=Lt(MM(),1);Se();Zt();Mn();Bt();Fn();A();lb={headerParseWarning:"Error parsing `link` header ({error}): `{header}`"},kQ=w("core/gather/gatherers/link-elements.js",lb);s(CQ,"normalizeUrlOrNull");s(AQ,"getCrossoriginFromHeader");s(_Q,"getLinkElementsInDOM");ub=class e extends ${static{s(this,"LinkElements")}constructor(){super(),this.meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:_t.symbol}}}static getLinkElementsInDOM(t){return t.driver.executionContext.evaluate(_Q,{args:[],useIsolation:!0,deps:[me.getNodeDetails,me.getElementsInDocument]})}static async getLinkElementsInHeaders(t,n){let r=await _e.request({devtoolsLog:n,URL:t.baseArtifacts.URL},t),a=[];for(let o of r.responseHeaders){if(o.name.toLowerCase()!=="link")continue;let i=[];try{i=LM.default.parse(o.value).refs}catch(c){let u=Me.truncate(o.value,100),l=kQ(lb.headerParseWarning,{error:c.message,header:u});t.baseArtifacts.LighthouseRunWarnings.push(l)}for(let c of i)a.push({rel:c.rel||"",href:CQ(c.uri,t.baseArtifacts.URL.finalDisplayedUrl),hrefRaw:c.uri||"",hreflang:c.hreflang||"",as:c.as||"",crossOrigin:AQ(c.crossorigin),source:"headers",fetchPriority:c.fetchpriority,node:null})}return a}async getArtifact(t){let n=t.dependencies.DevtoolsLog,r=await e.getLinkElementsInDOM(t),a=await e.getLinkElementsInHeaders(t,n),o=r.concat(a);for(let i of o)i.rel=i.rel.toLowerCase();return o}},RQ=ub});var BM={};T(BM,{default:()=>FQ});var db,FQ,UM=b(()=>{"use strict";d();Se();Mn();Gy();Bt();db=class extends ${static{s(this,"MainDocumentContent")}meta={supportedModes:["navigation"],dependencies:{DevtoolsLog:_t.symbol}};async getArtifact(t){let n=t.dependencies.DevtoolsLog,r=await _e.request({devtoolsLog:n,URL:t.baseArtifacts.URL},t),a=t.driver.defaultSession;return Wp(a,r.requestId)}},FQ=db});var jM={};T(jM,{default:()=>NQ});function IQ(){let e={getElementsInDocument,getNodeDetails};return e.getElementsInDocument("head meta").map(n=>{let r=s(a=>{let o=n.attributes.getNamedItem(a);if(o)return o.value},"getAttribute");return{name:n.name.toLowerCase(),content:n.content,property:r("property"),httpEquiv:n.httpEquiv?n.httpEquiv.toLowerCase():void 0,charset:r("charset"),node:e.getNodeDetails(n)}})}var mb,NQ,qM=b(()=>{"use strict";d();Se();Zt();s(IQ,"collectMetaElements");mb=class extends ${static{s(this,"MetaElements")}meta={supportedModes:["snapshot","navigation"]};getArtifact(t){return t.driver.executionContext.evaluate(IQ,{args:[],useIsolation:!0,deps:[me.getElementsInDocument,me.getNodeDetails]})}},NQ=mb});var zM={};T(zM,{default:()=>MQ});var pb,MQ,HM=b(()=>{"use strict";d();Se();Mn();pb=class e extends ${static{s(this,"NetworkUserAgent")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:_t.symbol}};static getNetworkUserAgent(t){for(let n of t){if(n.method!=="Network.requestWillBeSent")continue;let r=n.params.request.headers["User-Agent"];if(r)return r}return""}async getArtifact(t){return e.getNetworkUserAgent(t.dependencies.DevtoolsLog)}},MQ=pb});var GM={};T(GM,{default:()=>PQ});function LQ(){return getElementsInDocument("script").map(t=>({type:t.type||null,src:t.src||null,id:t.id||null,async:t.async,defer:t.defer,source:t.closest("head")?"head":"body",node:getNodeDetails(t)}))}var fb,PQ,VM=b(()=>{"use strict";d();Se();de();lt();Zt();Mn();s(LQ,"collectAllScriptElements");fb=class extends ${static{s(this,"ScriptElements")}meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:_t.symbol}};async _getArtifact(t,n){let a=await t.driver.executionContext.evaluate(LQ,{args:[],useIsolation:!0,deps:[me.getNodeDetails,me.getElementsInDocument]}),o=n.filter(i=>i.resourceType===G.TYPES.Script).filter(i=>i.sessionTargetType==="page");for(let i=0;i<o.length;i++){let c=o[i];a.find(l=>l.src===c.url)||a.push({type:null,src:c.url,id:null,async:!1,defer:!1,source:"network",node:null})}return a}async getArtifact(t){let n=t.dependencies.DevtoolsLog,r=await H.request(n,t);return this._getArtifact(t,r)}},PQ=fb});var WM={};T(WM,{default:()=>gb});async function OQ(e,t,n){if(n){let r=[];for(let a of e){let o=await t(a);r.push(o)}return r}else{let r=e.map(t);return await Promise.all(r)}}function BQ(e){return e.embedderName?e.hasSourceURL&&e.url==="_lighthouse-eval.js":!0}var hb,gb,yb=b(()=>{"use strict";d();Se();s(OQ,"runInSeriesOrParallel");s(BQ,"isLighthouseRuntimeEvaluateScript");hb=class e extends ${static{s(this,"Scripts")}static symbol=Symbol("Scripts");meta={symbol:e.symbol,supportedModes:["timespan","navigation"]};_scriptParsedEvents=[];_scriptContents=[];constructor(){super(),this.onScriptParsed=this.onScriptParsed.bind(this)}onScriptParsed(t){BQ(t)||this._scriptParsedEvents.push(t)}async startInstrumentation(t){let n=t.driver.defaultSession;n.on("Debugger.scriptParsed",this.onScriptParsed),await n.sendCommand("Debugger.enable")}async stopInstrumentation(t){let n=t.driver.defaultSession,r=t.baseArtifacts.HostFormFactor;n.off("Debugger.scriptParsed",this.onScriptParsed),this._scriptContents=await OQ(this._scriptParsedEvents,({scriptId:a})=>n.sendCommand("Debugger.getScriptSource",{scriptId:a}).then(o=>o.scriptSource).catch(()=>{}),r==="mobile"),await n.sendCommand("Debugger.disable")}async getArtifact(){return this._scriptParsedEvents.map((n,r)=>({name:n.url,...n,url:n.embedderName||n.url,content:this._scriptContents[r]}))}},gb=hb});var $M={};T($M,{default:()=>jQ});function UQ(){let e={getElementsInDocument,getNodeDetails},t="object, embed, applet";return e.getElementsInDocument(t).map(r=>({tagName:r.tagName,type:r.getAttribute("type"),src:r.getAttribute("src"),data:r.getAttribute("data"),code:r.getAttribute("code"),params:Array.from(r.children).filter(a=>a.tagName==="PARAM").map(a=>({name:a.getAttribute("name")||"",value:a.getAttribute("value")||""})),node:e.getNodeDetails(r)}))}var bb,jQ,YM=b(()=>{"use strict";d();Se();Zt();s(UQ,"getEmbeddedContent");bb=class extends ${static{s(this,"EmbeddedContent")}meta={supportedModes:["snapshot","navigation"]};getArtifact(t){return t.driver.executionContext.evaluate(UQ,{args:[],deps:[me.getElementsInDocument,me.getNodeDetails]})}},jQ=bb});var KM={};T(KM,{default:()=>qQ});var vb,qQ,XM=b(()=>{"use strict";d();Se();vb=class extends ${static{s(this,"RobotsTxt")}meta={supportedModes:["snapshot","navigation"]};async getArtifact(t){let{finalDisplayedUrl:n}=t.baseArtifacts.URL,r=new URL("/robots.txt",n).href;return t.driver.fetcher.fetchResource(r).catch(a=>({status:null,content:null,errorMessage:a.message}))}},qQ=vb});function Db(e,{x:t,y:n}){return e.left<=t&&e.right>=t&&e.top<=n&&e.bottom>=n}function wb(e,t){return t.top>=e.top&&t.right<=e.right&&t.bottom<=e.bottom&&t.left>=e.left}function JM(e){return e.filter(t=>t.width>1&&t.height>1)}function ZM(e){let t=new Set(e);for(let n of e)for(let r of e)if(n!==r&&t.has(r)&&wb(r,n)){t.delete(n);break}return Array.from(t)}function Jp(e){return{x:e.left+e.width/2,y:e.top+e.height/2}}function Zp(e,t){return e.left<=t.right&&t.left<=e.right&&e.top<=t.bottom&&t.top<=e.bottom}function Eb(e,t){if(e.length===0)throw new Error("No rects to take bounds of");let n=Number.MAX_VALUE,r=-Number.MAX_VALUE,a=Number.MAX_VALUE,o=-Number.MAX_VALUE;for(let c of e)n=Math.min(n,c.left),r=Math.max(r,c.right),a=Math.min(a,c.top),o=Math.max(o,c.bottom);let i=t/2;return n-=i,r+=i,a-=i,o+=i,{left:n,right:r,top:a,bottom:o,width:r-n,height:o-a}}function QM(e){return Eb(e,0)}function zQ({left:e,top:t,right:n,bottom:r}){return{left:e,top:t,right:n,bottom:r,width:n-e,height:r-t}}function HQ({x:e,y:t,width:n,height:r}){return{left:e,top:t,right:e+n,bottom:t+r,width:n,height:r}}function Gu(e,t){let n=Math.min(e.bottom,t.bottom)-Math.max(e.top,t.top);if(n<=0)return 0;let r=Math.min(e.right,t.right)-Math.max(e.left,t.left);return r<=0?0:r*n}function e3(e,t){return zQ({left:e.left+e.width/2-t/2,top:e.top+e.height/2-t/2,right:e.right-e.width/2+t/2,bottom:e.bottom-e.height/2+t/2})}function Hu(e){return e.width*e.height}function t3(e){let t=e[0];for(let n of e)Hu(n)>Hu(t)&&(t=n);return t}function n3(e,t){for(let n of e)for(let r of t)if(!wb(n,r)&&!wb(r,n))return!1;return!0}function xb(e){let t={x:e[0],y:e[1],width:e[2],height:e[3]};return HQ(t)}var Vu=b(()=>{"use strict";d();s(Db,"rectContainsPoint");s(wb,"rectContains");s(JM,"filterOutTinyRects");s(ZM,"filterOutRectsContainedByOthers");s(Jp,"getRectCenterPoint");s(Zp,"rectsTouchOrOverlap");s(Eb,"getBoundingRectWithPadding");s(QM,"getBoundingRect");s(zQ,"addRectWidthAndHeight");s(HQ,"addRectTopAndBottom");s(Gu,"getRectOverlapArea");s(e3,"getRectAtCenter");s(Hu,"getRectArea");s(t3,"getLargestRect");s(n3,"allRectsContainedWithinEachOther");s(xb,"traceRectToLHRect")});var c3={};T(c3,{default:()=>$Q});function r3(e){return!!(e.offsetWidth||e.offsetHeight||e.getClientRects().length)}function kb(e){let t=Array.from(e.getClientRects()).map(n=>{let{width:r,height:a,left:o,top:i,right:c,bottom:u}=n;return{width:r,height:a,left:o,top:i,right:c,bottom:u}});for(let n of e.children)t.push(...kb(n));return t}function Cb(e,t){return e.parentElement?e.parentElement.matches(t)?!0:Cb(e.parentElement,t):!1}function a3(e){if(!e.parentElement)return!1;let t=e.parentElement,n=e.textContent||"";if((t.textContent||"").length-n.length<5)return!1;for(let a of e.parentElement.childNodes){if(a===e)continue;let o=(a.textContent||"").trim();if(a.nodeType===Node.TEXT_NODE&&o.length>0)return!0}return!1}function Ab(e){let{display:t}=getComputedStyle(e);return t!=="inline"&&t!=="inline-block"?!1:a3(e)?!0:e.parentElement?Ab(e.parentElement):!1}function o3(e,t){let n=window.innerHeight,r=Math.floor(t.y/n)*n;window.scrollY!==r&&window.scrollTo(0,r);let a=document.elementFromPoint(t.x,t.y-window.scrollY);return a===e||e.contains(a)}function i3(e){return document.querySelectorAll("*").forEach(t=>{let n=getComputedStyle(t).position;(n==="fixed"||n==="sticky")&&t.classList.add(e)}),s(function(){Array.from(document.getElementsByClassName(e)).forEach(n=>{n.classList.remove(e)})},"undo")}function s3(e,t){let n=[];window.scrollTo(0,0);let r=getElementsInDocument(e),a=[];r.forEach(c=>{Cb(c,e)||Ab(c)||r3(c)&&a.push({tapTargetElement:c,clientRects:kb(c)})});let o=i3(t),i=[];a.forEach(({tapTargetElement:c,clientRects:u})=>{let l=u.filter(m=>m.width!==0&&m.height!==0);l=l.filter(m=>{let p=getRectCenterPoint(m);return o3(c,p)}),l.length>0&&i.push({tapTargetElement:c,visibleClientRects:l})});for(let{tapTargetElement:c,visibleClientRects:u}of i)n.push({clientRects:u,href:c.href||"",node:getNodeDetails(c)});return o(),n}function WQ(e,t){let n={x:window.scrollX,y:window.scrollY};try{return s3(e,t)}finally{window.scrollTo(n.x,n.y)}}var GQ,VQ,Sb,$Q,u3=b(()=>{"use strict";d();Se();Zt();Vu();GQ=["button","a","input","textarea","select","option","[role=button]","[role=checkbox]","[role=link]","[role=menuitem]","[role=menuitemcheckbox]","[role=menuitemradio]","[role=option]","[role=scrollbar]","[role=slider]","[role=spinbutton]"],VQ=GQ.join(",");s(r3,"elementIsVisible");s(kb,"getClientRects");s(Cb,"elementHasAncestorTapTarget");s(a3,"hasTextNodeSiblingsFormingTextBlock");s(Ab,"elementIsInTextBlock");s(o3,"elementCenterIsAtZAxisTop");s(i3,"disableFixedAndStickyElementPointerEvents");s(s3,"gatherTapTargets");s(WQ,"gatherTapTargetsAndResetScroll");Sb=class extends ${static{s(this,"TapTargets")}constructor(){super(),this.meta={supportedModes:["snapshot","navigation"]}}async addStyleRule(t,n){let r=await t.sendCommand("Page.getFrameTree"),{styleSheetId:a}=await t.sendCommand("CSS.createStyleSheet",{frameId:r.frameTree.frame.id}),o=`.${n} { pointer-events: none !important }`;return await t.sendCommand("CSS.setStyleSheetText",{styleSheetId:a,text:o}),a}async removeStyleRule(t,n){await t.sendCommand("CSS.setStyleSheetText",{styleSheetId:n,text:""})}async getArtifact(t){let n=t.driver.defaultSession;await n.sendCommand("DOM.enable"),await n.sendCommand("CSS.enable");let r="lighthouse-disable-pointer-events",a=await this.addStyleRule(n,r),o=await t.driver.executionContext.evaluate(WQ,{args:[VQ,r],useIsolation:!0,deps:[me.getNodeDetails,me.getElementsInDocument,i3,r3,Cb,o3,kb,a3,Ab,Jp,me.getNodePath,me.getNodeSelector,me.getNodeLabel,s3]});return await this.removeStyleRule(n,a),await n.sendCommand("CSS.disable"),await n.sendCommand("DOM.disable"),o}},$Q=Sb});function l3(e){return new Promise((t,n)=>{let r=s(a=>{let o=a.versions.filter(c=>c.status!=="redundant"),i=o.find(c=>c.status==="activated");(!o.length||i)&&(e.off("ServiceWorker.workerVersionUpdated",r),e.sendCommand("ServiceWorker.disable").then(c=>t(a),n))},"versionUpdatedListener");e.on("ServiceWorker.workerVersionUpdated",r),e.sendCommand("ServiceWorker.enable").catch(n)})}function d3(e){return new Promise((t,n)=>{e.once("ServiceWorker.workerRegistrationUpdated",r=>{e.sendCommand("ServiceWorker.disable").then(a=>t(r),n)}),e.sendCommand("ServiceWorker.enable").catch(n)})}var m3=b(()=>{"use strict";d();s(l3,"getServiceWorkerVersions");s(d3,"getServiceWorkerRegistrations")});var p3={};T(p3,{default:()=>KQ});var _b,KQ,f3=b(()=>{"use strict";d();Se();m3();_b=class extends ${static{s(this,"ServiceWorker")}meta={supportedModes:["navigation"]};async getArtifact(t){let n=t.driver.defaultSession,{versions:r}=await l3(n),{registrations:a}=await d3(n);return{versions:r,registrations:a}}},KQ=_b});var h3=I(us=>{"use strict";d();Object.defineProperty(us,"__esModule",{value:!0});us.ParsedURL=us.normalizePath=void 0;function XQ(e){if(e.indexOf("..")===-1&&e.indexOf(".")===-1)return e;let t=(e[0]==="/"?e.substring(1):e).split("/"),n=[];for(let a of t)a!=="."&&(a===".."?n.pop():n.push(a));let r=n.join("/");return e[0]==="/"&&r&&(r="/"+r),r[r.length-1]!=="/"&&(e[e.length-1]==="/"||t[t.length-1]==="."||t[t.length-1]==="..")&&(r=r+"/"),r}s(XQ,"normalizePath");us.normalizePath=XQ;var Rb=class e{static{s(this,"ParsedURL")}isValid;url;scheme;user;host;port;path;queryParams;fragment;folderPathComponents;lastPathComponent;blobInnerScheme;#e;#r;constructor(t){this.isValid=!1,this.url=t,this.scheme="",this.user="",this.host="",this.port="",this.path="",this.queryParams="",this.fragment="",this.folderPathComponents="",this.lastPathComponent="";let n=this.url.startsWith("blob:"),a=(n?t.substring(5):t).match(e.urlRegex());if(a)this.isValid=!0,n?(this.blobInnerScheme=a[2].toLowerCase(),this.scheme="blob"):this.scheme=a[2].toLowerCase(),this.user=a[3]??"",this.host=a[4]??"",this.port=a[5]??"",this.path=a[6]??"/",this.queryParams=a[7]??"",this.fragment=a[8]??"";else{if(this.url.startsWith("data:")){this.scheme="data";return}if(this.url.startsWith("blob:")){this.scheme="blob";return}if(this.url==="about:blank"){this.scheme="about";return}this.path=this.url}let o=this.path.lastIndexOf("/");o!==-1?(this.folderPathComponents=this.path.substring(0,o),this.lastPathComponent=this.path.substring(o+1)):this.lastPathComponent=this.path}static concatenate(t,...n){return t.concat(...n)}static beginsWithWindowsDriveLetter(t){return/^[A-Za-z]:/.test(t)}static beginsWithScheme(t){return/^[A-Za-z][A-Za-z0-9+.-]*:/.test(t)}static isRelativeURL(t){return!this.beginsWithScheme(t)||this.beginsWithWindowsDriveLetter(t)}get displayName(){return this.#e?this.#e:this.isDataURL()?this.dataURLDisplayName():this.isBlobURL()?this.url:this.isAboutBlank()?this.url:(this.#e=this.lastPathComponent,this.#e||(this.#e=(this.host||"")+"/"),this.#e==="/"&&(this.#e=this.url),this.#e)}static urlRegexInstance=null};us.ParsedURL=Rb});var y3=I((w2e,g3)=>{"use strict";d();var JQ=h3();g3.exports={ParsedURL:JQ}});var v3=I((E2e,b3)=>{"use strict";d();function ZQ(e,t,n,r,a){let o=r||0,i=a!==void 0?a:e.length;for(;o<i;){let c=o+i>>1;n(t,e[c])>0?o=c+1:i=c}return i}s(ZQ,"lowerBound");function QQ(e,t,n,r,a){let o=r||0,i=a!==void 0?a:e.length;for(;o<i;){let c=o+i>>1;n(t,e[c])>=0?o=c+1:i=c}return i}s(QQ,"upperBound");b3.exports={ArrayUtilities:{lowerBound:ZQ,upperBound:QQ},DevToolsPath:{EmptyUrlString:""}}});var S3=I((Ar,T3)=>{"use strict";d();var eee=y3(),Wo=v3();Object.defineProperty(Ar,"__esModule",{value:!0});Ar.SourceMap=Ar.SourceMapEntry=Ar.parseSourceMap=void 0;function E3(e){return e.startsWith(")]}")&&(e=e.substring(e.indexOf(`
`))),e.charCodeAt(0)===65279&&(e=e.slice(1)),JSON.parse(e)}s(E3,"parseSourceMap");Ar.parseSourceMap=E3;var $o=class{static{s(this,"SourceMapEntry")}lineNumber;columnNumber;sourceURL;sourceLineNumber;sourceColumnNumber;name;constructor(t,n,r,a,o,i){this.lineNumber=t,this.columnNumber=n,this.sourceURL=r,this.sourceLineNumber=a,this.sourceColumnNumber=o,this.name=i}static compare(t,n){return t.lineNumber!==n.lineNumber?t.lineNumber-n.lineNumber:t.columnNumber-n.columnNumber}};Ar.SourceMapEntry=$o;var w3="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",x3=new Map;for(let e=0;e<w3.length;++e)x3.set(w3.charAt(e),e);var D3=new WeakMap,ls=class e{static{s(this,"SourceMap")}#e;#r;#a;#i;#n;#t;constructor(t,n,r){this.#e=r,this.#r=t,this.#a=n,this.#i=n.startsWith("data:")?t:n,this.#n=null,this.#t=new Map,"sections"in this.#e&&this.#e.sections.find(a=>"url"in a)&&console.warn(`SourceMap "${n}" contains unsupported "URL" field in one of its sections.`),this.eachSection(this.parseSources.bind(this))}compiledURL(){return this.#r}url(){return this.#a}sourceURLs(){return[...this.#t.keys()]}embeddedContentByURL(t){let n=this.#t.get(t);return n?n.content:null}findEntry(t,n){let r=this.mappings(),a=Wo.ArrayUtilities.upperBound(r,void 0,(o,i)=>t-i.lineNumber||n-i.columnNumber);return a?r[a-1]:null}findEntryRanges(t,n){let r=this.mappings(),a=Wo.ArrayUtilities.upperBound(r,void 0,(E,S)=>t-S.lineNumber||n-S.columnNumber);if(!a)return null;let o=a-1,i=r[o].sourceURL;if(!i)return null;let c=a<r.length?r[a].lineNumber:2**31-1,u=a<r.length?r[a].columnNumber:2**31-1,l=new TextUtils.TextRange.TextRange(r[o].lineNumber,r[o].columnNumber,c,u),m=this.reversedMappings(i),p=r[o].sourceLineNumber,h=r[o].sourceColumnNumber,f=Wo.ArrayUtilities.upperBound(m,void 0,(E,S)=>p-r[S].sourceLineNumber||h-r[S].sourceColumnNumber);if(!f)return null;let y=f<m.length?r[m[f]].sourceLineNumber:2**31-1,v=f<m.length?r[m[f]].sourceColumnNumber:2**31-1,D=new TextUtils.TextRange.TextRange(p,h,y,v);return{range:l,sourceRange:D,sourceURL:i}}sourceLineMapping(t,n,r){let a=this.mappings(),o=this.reversedMappings(t),i=Wo.ArrayUtilities.lowerBound(o,n,m),c=Wo.ArrayUtilities.upperBound(o,n,m);if(i>=o.length||a[o[i]].sourceLineNumber!==n)return null;let u=o.slice(i,c);if(!u.length)return null;let l=Wo.ArrayUtilities.lowerBound(u,r,(p,h)=>p-a[h].sourceColumnNumber);return l>=u.length?a[u[u.length-1]]:a[u[l]];function m(p,h){return p-a[h].sourceLineNumber}}findReverseIndices(t,n,r){let a=this.mappings(),o=this.reversedMappings(t),i=Wo.ArrayUtilities.upperBound(o,void 0,(u,l)=>n-a[l].sourceLineNumber||r-a[l].sourceColumnNumber),c=i;for(;c>0&&a[o[c-1]].sourceLineNumber===a[o[i-1]].sourceLineNumber&&a[o[c-1]].sourceColumnNumber===a[o[i-1]].sourceColumnNumber;)--c;return o.slice(c,i)}findReverseEntries(t,n,r){let a=this.mappings();return this.findReverseIndices(t,n,r).map(o=>a[o])}findReverseRanges(t,n,r){let a=this.mappings(),o=this.findReverseIndices(t,n,r),i=[];for(let c=0;c<o.length;++c){let u=o[c],l=u+1;for(;c+1<o.length&&l===o[c+1];)++l,++c;let m=a[u].lineNumber,p=a[u].columnNumber,h=l<a.length?a[l].lineNumber:2**31-1,f=l<a.length?a[l].columnNumber:2**31-1;i.push(new TextUtils.TextRange.TextRange(m,p,h,f))}return i}mappings(){return this.#o(),this.#n??[]}reversedMappings(t){return this.#o(),this.#t.get(t)?.reverseMappings??[]}#o(){this.#n===null&&(this.#n=[],this.eachSection(this.parseMap.bind(this)),this.mappings().sort($o.compare),this.#s(this.#n),this.#e=null)}#s(t){let n=new Map;for(let a=0;a<t.length;a++){let o=t[a].sourceURL;if(!o)continue;let i=n.get(o);i||(i=[],n.set(o,i)),i.push(a)}for(let[a,o]of n.entries()){let i=this.#t.get(a);i&&(o.sort(r),i.reverseMappings=o)}function r(a,o){let i=t[a],c=t[o];return i.sourceLineNumber-c.sourceLineNumber||i.sourceColumnNumber-c.sourceColumnNumber||i.lineNumber-c.lineNumber||i.columnNumber-c.columnNumber}s(r,"sourceMappingComparator")}eachSection(t){if(this.#e)if("sections"in this.#e)for(let n of this.#e.sections)"map"in n&&t(n.map,n.offset.line,n.offset.column);else t(this.#e,0,0)}parseSources(t){let n=[],r=t.sourceRoot??"",a=new Set(t.x_google_ignoreList);for(let o=0;o<t.sources.length;++o){let i=t.sources[o];eee.ParsedURL.ParsedURL.isRelativeURL(i)&&(r&&!r.endsWith("/")&&i&&!i.startsWith("/")?i=r.concat("/",i):i=r.concat(i));let c=i,u=t.sourcesContent&&t.sourcesContent[o];if(n.push(c),!this.#t.has(c)){let l=u??null,m=a.has(o);this.#t.set(c,{content:l,ignoreListHint:m,reverseMappings:null})}}D3.set(t,n)}parseMap(t,n,r){let a=0,o=0,i=0,c=0,u=D3.get(t),l=t.names??[],m=new e.StringCharIterator(t.mappings),p=u&&u[a];for(;;){if(m.peek()===",")m.next();else{for(;m.peek()===";";)n+=1,r=0,m.next();if(!m.hasNext())break}if(r+=this.decodeVLQ(m),!m.hasNext()||this.isSeparator(m.peek())){this.mappings().push(new $o(n,r));continue}let h=this.decodeVLQ(m);if(h&&(a+=h,u&&(p=u[a])),o+=this.decodeVLQ(m),i+=this.decodeVLQ(m),!m.hasNext()||this.isSeparator(m.peek())){this.mappings().push(new $o(n,r,p,o,i));continue}c+=this.decodeVLQ(m),this.mappings().push(new $o(n,r,p,o,i,l[c]))}}isSeparator(t){return t===","||t===";"}decodeVLQ(t){let n=0,r=0,a=e._VLQ_CONTINUATION_MASK;for(;a&e._VLQ_CONTINUATION_MASK;)a=x3.get(t.next())||0,n+=(a&e._VLQ_BASE_MASK)<<r,r+=e._VLQ_BASE_SHIFT;let o=n&1;return n>>=1,o?-n:n}mapsOrigin(){let t=this.mappings();if(t.length>0){let n=t[0];return n?.lineNumber===0||n.columnNumber===0}return!1}hasIgnoreListHint(t){return this.#t.get(t)?.ignoreListHint??!1}findRanges(t,n){let r=this.mappings(),a=[];if(!r.length)return[];let o=null;(r[0].lineNumber!==0||r[0].columnNumber!==0)&&n?.isStartMatching&&(o=TextUtils.TextRange.TextRange.createUnboundedFromLocation(0,0),a.push(o));for(let{sourceURL:i,lineNumber:c,columnNumber:u}of r){let l=i&&t(i);if(!o&&l){o=TextUtils.TextRange.TextRange.createUnboundedFromLocation(c,u),a.push(o);continue}o&&!l&&(o.endLine=c,o.endColumn=u,o=null)}return a}};Ar.SourceMap=ls;(function(e){e._VLQ_BASE_SHIFT=5,e._VLQ_BASE_MASK=32-1,e._VLQ_CONTINUATION_MASK=32;class t{static{s(this,"StringCharIterator")}string;position;constructor(r){this.string=r,this.position=0}next(){return this.string.charAt(this.position++)}peek(){return this.string.charAt(this.position)}hasNext(){return this.position<this.string.length}}e.StringCharIterator=t})(ls=Ar.SourceMap||(Ar.SourceMap={}));T3.exports=ls;ls.parseSourceMap=E3});var Fb=I((C2e,C3)=>{"use strict";d();var k3={SourceMap:S3()};k3.SourceMap.prototype.computeLastGeneratedColumns=function(){let e=this.mappings();if(!(e.length&&e[0].lastColumnNumber!==void 0))for(let t=0;t<e.length-1;t++){let n=e[t],r=e[t+1];n.lineNumber===r.lineNumber&&(n.lastColumnNumber=r.columnNumber)}};C3.exports=k3});var A3={};T(A3,{default:()=>tee});var Ib,Nb,tee,_3=b(()=>{"use strict";d();Ib=Lt(Fb(),1);Se();yb();Nb=class extends ${static{s(this,"SourceMaps")}meta={supportedModes:["timespan","navigation"],dependencies:{Scripts:gb.symbol}};async fetchSourceMap(t,n){let r=await t.fetcher.fetchResource(n,{timeout:1500});if(r.content===null)throw new Error(`Failed fetching source map (${r.status})`);return Ib.default.SourceMap.parseSourceMap(r.content)}parseSourceMapFromDataUrl(t){let n=Buffer.from(t.split(",")[1],"base64");return Ib.default.SourceMap.parseSourceMap(n.toString())}_resolveUrl(t,n){try{return new URL(t,n).href}catch{return}}async _retrieveMapFromScript(t,n){if(!n.sourceMapURL)throw new Error("precondition failed: event.sourceMapURL should exist");let r=n.sourceMapURL.startsWith("data:"),a=n.name,o=r?n.sourceMapURL:this._resolveUrl(n.sourceMapURL,n.name);if(!o)return{scriptId:n.scriptId,scriptUrl:a,errorMessage:`Could not resolve map url: ${n.sourceMapURL}`};let i=r?void 0:o;try{let c=r?this.parseSourceMapFromDataUrl(o):await this.fetchSourceMap(t,o);if(typeof c.version!="number")throw new Error("Map has no numeric `version` field");if(!Array.isArray(c.sources))throw new Error("Map has no `sources` list");if(typeof c.mappings!="string")throw new Error("Map has no `mappings` field");return c.sections&&(c.sections=c.sections.filter(u=>u.map)),{scriptId:n.scriptId,scriptUrl:a,sourceMapUrl:i,map:c}}catch(c){return{scriptId:n.scriptId,scriptUrl:a,sourceMapUrl:i,errorMessage:c.toString()}}}async getArtifact(t){let n=t.dependencies.Scripts.filter(r=>r.sourceMapURL).map(r=>this._retrieveMapFromScript(t.driver,r));return Promise.all(n)}},tee=Nb});var R3={};T(R3,{default:()=>aee});async function ree(){let e=[],t=d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests;for(let[n,r]of Object.entries(t))try{let a,o=new Promise(c=>a=setTimeout(()=>c(!1),1e3)),i=await Promise.race([r.test(window),o]);a&&clearTimeout(a),i&&e.push({id:r.id,name:n,version:i.version,npm:r.npm})}catch{}return e}var nee,Mb,aee,F3=b(()=>{"use strict";d();Jr();Hi();Ae();Se();nee=`function _createTimeoutHelper(){let e;return{timeoutPromise:new Promise(((t,o)=>{e=setTimeout((()=>o(new Error("Timed out"))),5e3)})),clearTimeout:()=>clearTimeout(e)}}var UNKNOWN_VERSION=null,d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests={GWT:{id:"gwt",icon:"gwt",url:"http://www.gwtproject.org/",test:function(e){var t=e.document,o=t.getElementById("__gwt_historyFrame"),n=t.gwt_uid,r=t.body.__listener,i=t.body.__eventBits,s=e.__gwt_activeModules,c=e.__gwt_jsonp__,u=e.__gwt_scriptsLoaded||e.__gwt_stylesLoaded||e.__gwt_activeModules;if(o||n||r||i||s||c||u){for(var a=t.getElementsByTagName("iframe"),l=UNKNOWN_VERSION,N=0;N<a.length;N++)try{if(a[N].tabIndex<0&&a[N].contentWindow&&a[N].contentWindow.$gwt_version){l=a[N].contentWindow.$gwt_version;break}}catch(e){}return"0.0.999"==l&&(l="Google Internal"),{version:l}}return!1}},Ink:{id:"ink",icon:"ink",url:"http://ink.sapo.pt/",test:function(e){return!(!e.Ink||!e.Ink.createModule)&&{version:UNKNOWN_VERSION}}},Vaadin:{id:"vaadin",icon:"vaadin",url:"https://vaadin.com/",test:function(e){return!(!e.vaadin||!e.vaadin.registerWidgetset)&&{version:UNKNOWN_VERSION}}},Bootstrap:{id:"bootstrap",icon:"bootstrap",url:"http://getbootstrap.com/",npm:"bootstrap",test:function(e){var t,o=e.$&&e.$.fn;if(o&&(["affix","alert","button","carousel","collapse","dropdown","modal","popover","scrollspy","tab","tooltip"].some((function(o){if(e.$.fn[o]){if(e.$.fn[o].Constructor&&e.$.fn[o].Constructor.VERSION)return t=e.$.fn[o].Constructor.VERSION,!0;if(new RegExp("\\\\$this\\\\.data\\\\((?:'|\\")(?:bs\\\\.){1}"+o).test(e.$.fn[o].toString()))return t=">= 3.0.0 & <= 3.1.1",!0;if(new RegExp("\\\\$this\\\\.data\\\\((?:'|\\")"+o).test(e.$.fn[o].toString()))return t=">= 2.0.0 & <= 2.3.2",!0}return!1})),t))return{version:t};return!1}},Zurb:{id:"zurb",icon:"zurb",url:"https://foundation.zurb.com/",npm:"foundation-sites",test:function(e){return!(!e.Foundation||!e.Foundation.Toggler)&&{version:e.Foundation.version||UNKNOWN_VERSION}}},Polymer:{id:"polymer",icon:"polymer",url:"https://www.polymer-project.org/",npm:"@polymer/polymer",test:function(e){return!(!e.Polymer||!e.Polymer.dom)&&{version:e.Polymer.version||UNKNOWN_VERSION}}},LitElement:{id:"litelement",icon:"polymer",url:"https://lit-element.polymer-project.org/",npm:"lit-element",test:function(e){if(e.litElementVersions&&e.litElementVersions.length){var t=[...e.litElementVersions].sort(((e,t)=>e.localeCompare(t,void 0,{numeric:!0})));return{version:t[t.length-1]}}return!1}},"lit-html":{id:"lit-html",icon:"polymer",url:"https://lit-html.polymer-project.org/",npm:"lit-element",test:function(e){if(e.litHtmlVersions&&e.litHtmlVersions.length){var t=[...e.litHtmlVersions].sort(((e,t)=>e.localeCompare(t,void 0,{numeric:!0})));return{version:t[t.length-1]}}return!1}},Highcharts:{id:"highcharts",icon:"highcharts",url:"http://www.highcharts.com",npm:"highcharts",test:function(e){return!(!e.Highcharts||!e.Highcharts.Point)&&{version:e.Highcharts.version||UNKNOWN_VERSION}}},InfoVis:{id:"jit",icon:"jit",url:"http://philogb.github.com/jit/",test:function(e){return!(!e.$jit||!e.$jit.PieChart)&&{version:e.$jit.version||UNKNOWN_VERSION}}},FlotCharts:{id:"flotcharts",icon:"flotcharts",url:"http://www.flotcharts.org/",npm:"flot",test:function(e){return!(!e.$||!e.$.plot)&&{version:e.$.plot.version||UNKNOWN_VERSION}}},CreateJS:{id:"createjs",icon:"createjs",url:"https://createjs.com/",npm:"createjs",test:function(e){return!(!e.createjs||!e.createjs.promote)&&{version:UNKNOWN_VERSION}}},"Google Maps":{id:"gmaps",icon:"gmaps",url:"https://developers.google.com/maps/",test:function(e){return!(!e.google||!e.google.maps)&&{version:e.google.maps.version||UNKNOWN_VERSION}}},jQuery:{id:"jquery",icon:"jquery",url:"http://jquery.com",npm:"jquery",test:function(e){var t=e.jQuery||e.$;return!!(t&&t.fn&&t.fn.jquery)&&{version:t.fn.jquery.replace(/[^\\d+\\.+]/g,"")||UNKNOWN_VERSION}}},"jQuery (Fast path)":{id:"jquery-fast",icon:"jquery",url:"http://jquery.com",npm:"jquery",test:function(e){var t=e.jQuery||e.$;return!(!t||!t.fn)&&{version:UNKNOWN_VERSION}}},"jQuery UI":{id:"jquery_ui",icon:"jquery_ui",url:"http://jqueryui.com",npm:"jquery-ui",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;if(t&&t.fn&&t.fn.jquery&&t.ui){for(var o="accordion,datepicker,dialog,draggable,droppable,progressbar,resizable,selectable,slider,menu,grid,tabs".split(","),n=[],r=0;r<o.length;r++)t.ui[o[r]]&&n.push(o[r].substr(0,1).toUpperCase()+o[r].substr(1));return{version:t.ui.version||UNKNOWN_VERSION,details:n.length?"Plugins used: "+n.join(","):""}}return!1}},Dojo:{id:"dojo",icon:"dojo",url:"http://dojotoolkit.org",npm:"dojo",test:function(e){return!(!e.dojo||!e.dojo.delegate)&&{version:e.dojo.version?e.dojo.version.toString():UNKNOWN_VERSION,details:"Details: "+(e.dijit?"Uses Dijit":"none")}}},Prototype:{id:"prototype",icon:"prototype",url:"http://prototypejs.org",test:function(e){return!(!e.Prototype||!e.Prototype.BrowserFeatures)&&{version:e.Prototype.Version||UNKNOWN_VERSION}}},Scriptaculous:{id:"scriptaculous",icon:"scriptaculous",url:"http://script.aculo.us",test:function(e){return!(!e.Scriptaculous||!e.Scriptaculous.load)&&{version:e.Scriptaculous.Version||UNKNOWN_VERSION}}},MooTools:{id:"mootools",icon:"mootools",url:"https://mootools.net/",test:function(e){return!(!e.MooTools||!e.MooTools.build)&&{version:e.MooTools.version||UNKNOWN_VERSION}}},Spry:{id:"spry",icon:"spry",url:"http://labs.adobe.com/technologies/spry",test:function(e){return!(!e.Spry||!e.Spry.Data)&&{version:UNKNOWN_VERSION}}},"YUI 2":{id:"yui",icon:"yui",url:"http://developer.yahoo.com/yui/2/",test:function(e){return!(!e.YAHOO||!e.YAHOO.util)&&{version:e.YAHOO.VERSION||UNKNOWN_VERSION}}},"YUI 3":{id:"yui3",icon:"yui3",url:"https://yuilibrary.com/",npm:"yui",test:function(e){return!(!e.YUI||!e.YUI.Env)&&{version:e.YUI.version||UNKNOWN_VERSION}}},Qooxdoo:{id:"qooxdoo",icon:"qooxdoo",url:"http://www.qooxdoo.org/",npm:"qooxdoo",test:function(e){return!(!e.qx||!e.qx.Bootstrap)&&{version:UNKNOWN_VERSION}}},"Ext JS":{id:"extjs",icon:"extjs",url:"https://www.sencha.com/products/extjs/",test:function(e){return e.Ext&&e.Ext.versions?{version:e.Ext.versions.core.version}:!!e.Ext&&{version:e.Ext.version||UNKNOWN_VERSION}}},Ezoic:{id:"ezoic",icon:"ezoic",url:"https://www.ezoic.com/",test:function(e){return!(!e.__ez||!e.__ez.template)&&{version:UNKNOWN_VERSION}}},base2:{id:"base2",icon:"base2",url:"http://code.google.com/p/base2",test:function(e){return!(!e.base2||!e.base2.dom)&&{version:e.base2.version||UNKNOWN_VERSION}}},"Closure Library":{id:"closure",icon:"closure",url:"https://developers.google.com/closure/library/",npm:"google-closure-library",test:function(e){return!(!e.goog||!e.goog.provide)&&{version:UNKNOWN_VERSION}}},"Rapha&euml;l":{id:"raphael",icon:"raphael",url:"http://dmitrybaranovskiy.github.io/raphael/",test:function(e){return!(!e.Raphael||!e.Raphael.circle)&&{version:e.Raphael.version||UNKNOWN_VERSION}}},React:{id:"react",icon:"react",url:"https://reactjs.org/",npm:"react",test:function(e){function t(e){return null!=e&&null!=e._reactRootContainer}var o=document.getElementById("react-root"),n=document.querySelector("*[data-reactroot]");return!!(t(document.body)||t(document.body.firstElementChild)||null!=document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return t(e)?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()||o&&o.innerText.length>0||n||e.React&&e.React.Component)&&{version:e.React&&e.React.version||UNKNOWN_VERSION}}},"React (Fast path)":{id:"react-fast",icon:"react",url:"https://reactjs.org/",npm:"react",test:function(e){function t(e){return null!=e&&null!=e._reactRootContainer}var o=document.getElementById("react-root"),n=document.querySelector("*[data-reactroot]");return!!(t(document.body)||t(document.body.firstElementChild)||o||n||e.React)&&{version:e.React&&e.React.version||UNKNOWN_VERSION}}},"Next.js":{id:"next",icon:"next",url:"https://nextjs.org/",npm:"next",test:function(e){return!(!e.__NEXT_DATA__||!e.__NEXT_DATA__.buildId)&&{version:window.next&&window.next.version||UNKNOWN_VERSION}}},"Next.js (Fast path)":{id:"next-fast",icon:"next",url:"https://nextjs.org/",npm:"next",test:function(e){return!!e.__NEXT_DATA__&&{version:UNKNOWN_VERSION}}},Preact:{id:"preact",icon:"preact",url:"https://preactjs.com/",npm:"preact",test:function(e){var t="undefined"!=typeof Symbol&&Symbol.for&&Symbol.for("preactattr");function o(e){return"__k"in e&&"props"in e.__k&&"type"in e.__k||("_component"in e||"__preactattr_"in e||t&&null!=e[t])}function n(e){return null!=e&&o(e)&&e}var r=n(document.body)||n(document.body.firstElementChild);if(r||(r=document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return o(e)?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()),r||e.preact){var i=UNKNOWN_VERSION;return r&&("__k"in r&&(i="10"),"__preactattr_"in r&&(i="8"),t&&null!=r[t]&&(i="7")),{version:i}}return!1}},"Preact (Fast path)":{id:"preact-fast",icon:"preact",url:"https://preactjs.com/",npm:"preact",test:function(e){var t=UNKNOWN_VERSION;function o(e){return null!=e&&function(e){return null!=e.__k?(t="10",!0):null!=e._component||null!=e.__preactattr_}(e)}return!(!o(document.body)&&!o(document.body.firstElementChild)&&!e.preact)&&{version:t}}},Modernizr:{id:"modernizr",icon:"modernizr",url:"https://modernizr.com/",npm:"modernizr",test:function(e){return!(!e.Modernizr||!e.Modernizr.addTest)&&{version:e.Modernizr._version||UNKNOWN_VERSION}}},"Processing.js":{id:"processingjs",icon:"processingjs",url:"http://processingjs.org",npm:"processing-js",test:function(e){return!(!e.Processing||!e.Processing.box)&&{version:Processing.version||UNKNOWN_VERSION}}},Backbone:{id:"backbone",icon:"backbone",url:"http://backbonejs.org/",npm:"backbone",test:function(e){return!(!e.Backbone||!e.Backbone.Model.extend)&&{version:e.Backbone.VERSION||UNKNOWN_VERSION}}},Leaflet:{id:"leaflet",icon:"leaflet",url:"http://leafletjs.com",npm:"leaflet",test:function(e){return!(!e.L||!e.L.GeoJSON||!e.L.marker&&!e.L.Marker)&&{version:e.L.version||e.L.VERSION||UNKNOWN_VERSION}}},Mapbox:{id:"mapbox",icon:"mapbox",url:"https://www.mapbox.com/",npm:"mapbox-gl",test:function(e){return!!(e.L&&e.L.mapbox&&e.L.mapbox.geocoder)&&{version:e.L.mapbox.VERSION||UNKNOWN_VERSION}}},"Lo-Dash":{id:"lodash",icon:"lodash",url:"https://lodash.com/",npm:"lodash",test:function(e){var t="function"==typeof(t=e._)&&t,o="function"==typeof(o=t&&t.chain)&&o,n=(o||t||function(){return{}})(1);return!(!t||!n.__wrapped__)&&{version:t.VERSION||UNKNOWN_VERSION}}},Underscore:{id:"underscore",icon:"underscore",url:"http://underscorejs.org/",npm:"underscore",test:function(e){return!(!e._||"function"!=typeof e._.tap||d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests["Lo-Dash"].test(e))&&{version:e._.VERSION||UNKNOWN_VERSION}}},Sammy:{id:"sammy",icon:"sammy",url:"http://sammyjs.org",test:function(e){return!(!e.Sammy||!e.Sammy.Application.curry)&&{version:e.Sammy.VERSION||UNKNOWN_VERSION}}},Rico:{id:"rico",icon:"rico",url:"http://openrico.sourceforge.net/examples/index.html",test:function(e){return!(!e.Rico||!window.Rico.checkIfComplete)&&{version:e.Rico.Version||UNKNOWN_VERSION}}},MochiKit:{id:"mochikit",icon:"mochikit",url:"https://mochi.github.io/mochikit/",test:function(e){return!(!e.MochiKit||!e.MochiKit.Base.module)&&{version:MochiKit.VERSION||UNKNOWN_VERSION}}},"gRapha&euml;l":{id:"graphael",icon:"graphael",url:"https://github.com/DmitryBaranovskiy/g.raphael",test:function(e){return!(!e.Raphael||!e.Raphael.fn.g)&&{version:UNKNOWN_VERSION}}},Glow:{id:"glow",icon:"glow",url:"http://www.bbc.co.uk/glow/",test:function(e){return e.gloader&&e.gloader.getRequests?{version:UNKNOWN_VERSION}:e.glow&&e.glow.dom?{version:e.glow.VERSION||UNKNOWN_VERSION}:!!e.Glow&&{version:e.Glow.version||UNKNOWN_VERSION}}},"Socket.IO":{id:"socketio",icon:"socketio",url:"https://socket.io/",npm:"socket.io",test:function(e){return!(!e.io||!e.io.sockets&&!e.io.Socket)&&{version:e.io.version||UNKNOWN_VERSION}}},Mustache:{id:"mustache",icon:"mustache",url:"http://mustache.github.io/",npm:"mustache",test:function(e){return!(!e.Mustache||!e.Mustache.to_html)&&{version:e.Mustache.version||UNKNOWN_VERSION}}},"Fabric.js":{id:"fabricjs",icon:"icon38",url:"http://fabricjs.com/",npm:"fabric",test:function(e){return!(!e.fabric||!e.fabric.util)&&{version:e.fabric.version||UNKNOWN_VERSION}}},FuseJS:{id:"fusejs",icon:"fusejs",url:"http://fusejs.io/",npm:"fuse.js",test:function(e){return!!e.Fuse&&{version:UNKNOWN_VERSION}}},"Tween.js":{id:"tweenjs",icon:"icon38",url:"https://github.com/tweenjs/tween.js",npm:"tween.js",test:function(e){return!(!e.TWEEN||!e.TWEEN.Easing)&&{version:UNKNOWN_VERSION}}},SproutCore:{id:"sproutcore",icon:"sproutcore",url:"http://sproutcore.com/",test:function(e){return!(!e.SC||!e.SC.Application)&&{version:UNKNOWN_VERSION}}},"Zepto.js":{id:"zepto",icon:"zepto",url:"http://zeptojs.com",npm:"zepto",test:function(e){return!(!e.Zepto||!e.Zepto.fn)&&{version:UNKNOWN_VERSION}}},"three.js":{id:"threejs",icon:"icon38",url:"https://threejs.org/",npm:"three",test:function(e){return e.THREE&&e.THREE.REVISION?{version:"r"+e.THREE.REVISION}:!!e.THREE&&{version:UNKNOWN_VERSION}}},PhiloGL:{id:"philogl",icon:"philogl",url:"http://www.senchalabs.org/philogl/",npm:"philogl",test:function(e){return!(!e.PhiloGL||!e.PhiloGL.Camera)&&{version:e.PhiloGL.version||UNKNOWN_VERSION}}},CamanJS:{id:"camanjs",icon:"camanjs",url:"http://camanjs.com/",npm:"caman",test:function(e){return e.Caman&&e.Caman.version?{version:e.Caman.version.release}:!!e.Caman&&{version:UNKNOWN_VERSION}}},yepnope:{id:"yepnope",icon:"yepnope",url:"http://yepnopejs.com/",test:function(e){return!(!e.yepnope||!e.yepnope.injectJs)&&{version:UNKNOWN_VERSION}}},LABjs:{id:"labjs",icon:"icon38",url:"https://github.com/getify/LABjs",test:function(e){return!(!e.$LAB||!e.$LAB.setOptions)&&{version:UNKNOWN_VERSION}}},"Head JS":{id:"headjs",icon:"headjs",url:"http://headjs.com/",npm:"headjs",test:function(e){return!(!e.head||!e.head.js)&&{version:UNKNOWN_VERSION}}},ControlJS:{id:"controljs",icon:"icon38",url:"http://stevesouders.com/controljs/",test:function(e){return!(!e.CJS||!e.CJS.start)&&{version:UNKNOWN_VERSION}}},RequireJS:{id:"requirejs",icon:"requirejs",url:"http://requirejs.org/",npm:"requirejs",test:function(e){var t=e.require||e.requirejs;return!(!t||!(t.load||t.s&&t.s.contexts&&t.s.contexts._&&(t.s.contexts._.loaded||t.s.contexts._.load)))&&{version:t.version||UNKNOWN_VERSION}}},RightJS:{id:"rightjs",icon:"rightjs",url:"http://rightjs.org/",test:function(e){return!(!e.RightJS||!e.RightJS.isNode)&&{version:e.RightJS.version||UNKNOWN_VERSION}}},"jQuery Tools":{id:"jquerytools",icon:"jquerytools",url:"http://jquerytools.github.io/",test:function(e){var t=e.jQuery||e.$;return!(!t||!t.tools)&&{version:t.tools.version||UNKNOWN_VERSION}}},Pusher:{id:"pusher",icon:"pusher",url:"https://pusher.com/docs/",npm:"pusher-js",test:function(e){return!(!e.Pusher||!e.Pusher.Channel)&&{version:e.Pusher.VERSION||UNKNOWN_VERSION}}},"Paper.js":{id:"paperjs",icon:"paperjs",url:"http://paperjs.org/",npm:"paper",test:function(e){return!(!e.paper||!e.paper.Point)&&{version:e.paper.version||UNKNOWN_VERSION}}},Swiffy:{id:"swiffy",icon:"icon38",url:"https://developers.google.com/swiffy/",test:function(e){return!(!e.swiffy||!e.swiffy.Stage)&&{version:UNKNOWN_VERSION}}},Move:{id:"move",icon:"move",url:"https://github.com/rsms/move",npm:"move",test:function(e){return!(!e.move||!e.move.compile)&&{version:e.move.version()||UNKNOWN_VERSION}}},AmplifyJS:{id:"amplifyjs",icon:"amplifyjs",url:"http://amplifyjs.com/",npm:"amplifyjs",test:function(e){return!(!e.amplify||!e.amplify.publish)&&{version:UNKNOWN_VERSION}}},"Popcorn.js":{id:"popcornjs",icon:"popcornjs",url:"https://github.com/mozilla/popcorn-js/",test:function(e){return!(!e.Popcorn||!e.Popcorn.Events)&&{version:e.Popcorn.version||UNKNOWN_VERSION}}},D3:{id:"d3",icon:"d3",url:"https://d3js.org/",npm:"d3",test:function(e){return!(!e.d3||!e.d3.select)&&{version:e.d3.version||UNKNOWN_VERSION}}},Handlebars:{id:"handlebars",icon:"handlebars",url:"http://handlebarsjs.com/",npm:"handlebars",test:function(e){return!(!e.Handlebars||!e.Handlebars.compile)&&{version:e.Handlebars.VERSION||UNKNOWN_VERSION}}},Handsontable:{id:"handsontable",icon:"handsontable",url:"https://handsontable.com/",npm:"handsontable",test:function(e){return!(!e.Handsontable||!e.Handsontable.Core)&&{version:e.Handsontable.version||UNKNOWN_VERSION}}},Knockout:{id:"knockout",icon:"knockout",url:"http://knockoutjs.com/",npm:"knockout",test:function(e){return!(!e.ko||!e.ko.applyBindings)&&{version:e.ko.version||UNKNOWN_VERSION}}},Spine:{id:"spine",icon:"icon38",url:"http://spine.github.io/",test:function(e){return!(!e.Spine||!e.Spine.Controller)&&{version:e.Spine.version||UNKNOWN_VERSION}}},"jQuery Mobile":{id:"jquery-mobile",icon:"jquery_mobile",url:"http://jquerymobile.com/",npm:"jquery-mobile",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;return!!(t&&t.fn&&t.fn.jquery&&t.mobile)&&{version:t.mobile.version||UNKNOWN_VERSION}}},"WebFont Loader":{id:"webfontloader",icon:"icon38",url:"https://github.com/typekit/webfontloader",npm:"webfontloader",test:function(e){return!(!e.WebFont||!e.WebFont.load)&&{version:UNKNOWN_VERSION}}},Angular:{id:"angular",icon:"angular",url:"https://angular.io/",npm:"@angular/core",test:function(e){var t=e.document.querySelector("[ng-version]");return t?{version:t.getAttribute("ng-version")||UNKNOWN_VERSION}:!!(e.ng&&e.ng.probe instanceof Function)&&{version:UNKNOWN_VERSION}}},AngularJS:{id:"angularjs",icon:"angularjs",url:"https://angularjs.org/",npm:"angular",test:function(e){var t=e.angular;return!!(t&&t.version&&t.version.full)&&{version:t.version.full}}},Ionic:{id:"ionic",icon:"ionic",url:"https://ionicframework.com/",npm:"@ionic/cli",test:function(e){var t=e.document.querySelector("ion-app");return!(!t||"ION-APP"!==t.nodeName)&&{version:UNKNOWN_VERSION}}},"Ember.js":{id:"emberjs",icon:"emberjs",url:"https://emberjs.com/",npm:"ember-source",test:function(e){var t=e.Ember||e.Em;return!(!t||!t.GUID_KEY)&&{version:t.VERSION||UNKNOWN_VERSION}}},"Hammer.js":{id:"hammerjs",icon:"hammerjs",url:"http://eightmedia.github.io/hammer.js/",npm:"hammerjs",test:function(e){return!(!e.Hammer||!e.Hammer.Pinch)&&{version:e.Hammer.VERSION||"&lt; 1.0.10"}}},"Visibility.js":{id:"visibilityjs",icon:"icon38",url:"https://github.com/ai/visibilityjs",npm:"visibilityjs",test:function(e){return!(!e.Visibility||!e.Visibility.every)&&{version:UNKNOWN_VERSION}}},"Velocity.js":{id:"velocityjs",icon:"icon38",url:"http://velocityjs.org/",npm:"velocity-animate",test:function(e){var t=e.jQuery||e.$,o=t?t.Velocity:e.Velocity;return o&&o.RegisterEffect&&o.version?{version:o.version.major+"."+o.version.minor+"."+o.version.patch}:!(!o||!o.RegisterEffect)&&{version:UNKNOWN_VERSION}}},"IfVisible.js":{id:"ifvisiblejs",icon:"icon38",url:"http://serkanyersen.github.io/ifvisible.js/",npm:"ifvisible.js",test:function(e){var t=e.ifvisible;return!(!t||"ifvisible.object.event.identifier"!==t.__ceGUID)&&{version:UNKNOWN_VERSION}}},"Pixi.js":{id:"pixi",icon:"pixi",url:"http://www.pixijs.com/",npm:"pixi.js",test:function(e){var t=e.PIXI;return!!(t&&t.WebGLRenderer&&t.VERSION)&&{version:t.VERSION.replace("v","")||UNKNOWN_VERSION}}},"DC.js":{id:"dcjs",icon:"dcjs",url:"http://dc-js.github.io/dc.js/",npm:"dc",test:function(e){var t=e.dc;return!(!t||!t.registerChart)&&{version:t.version||UNKNOWN_VERSION}}},"GreenSock JS":{id:"greensock",icon:"greensock",url:"https://greensock.com/gsap",npm:"gsap",test:function(e){return!(!e.TweenMax||!e.TweenMax.pauseAll)&&{version:e.TweenMax.version||UNKNOWN_VERSION}}},FastClick:{id:"fastclick",icon:"fastclick",url:"https://github.com/ftlabs/fastclick",npm:"fastclick",test:function(e){return!(!e.FastClick||!e.FastClick.notNeeded)&&{version:UNKNOWN_VERSION}}},Isotope:{id:"isotope",icon:"isotope",url:"https://isotope.metafizzy.co/",npm:"isotope-layout",test:function(e){return!!(e.Isotope||null!=e.$&&e.$.Isotope)&&{version:UNKNOWN_VERSION}}},Marionette:{id:"marionette",icon:"marionette",url:"https://marionettejs.com/",npm:"backbone.marionette",test:function(e){return!(!e.Marionette||!e.Marionette.Application)&&{version:e.Marionette.VERSION||UNKNOWN_VERSION}}},Can:{id:"canjs",icon:"canjs",url:"https://canjs.com/",npm:"can",test:function(e){return!(!e.can||!e.can.Construct)&&{version:e.can.VERSION||UNKNOWN_VERSION}}},Vue:{id:"vue",icon:"vue",url:"https://vuejs.org/",npm:"vue",test:function(e){return!(null===document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return null!=e.__vue__?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()&&!e.Vue)&&{version:e.Vue&&e.Vue.version||UNKNOWN_VERSION}}},"Vue (Fast path)":{id:"vue-fast",icon:"vue",url:"https://vuejs.org/",npm:"vue",test:function(e){return!!e.Vue&&{version:e.Vue&&e.Vue.version||UNKNOWN_VERSION}}},"Nuxt.js":{id:"nuxt",icon:"nuxt",url:"https://nuxtjs.org/",npm:"nuxt",test:function(e){return!!(e.__NUXT__||e.$nuxt||[...e.document.querySelectorAll("*")].some((e=>e.__vue__?.nuxt)))&&{version:UNKNOWN_VERSION}}},"Nuxt.js (Fast path)":{id:"nuxt-fast",icon:"nuxt",url:"https://nuxtjs.org/",npm:"nuxt",test:function(e){return!(!e.__NUXT__&&!e.$nuxt)&&{version:UNKNOWN_VERSION}}},Two:{id:"two",icon:"two",url:"https://two.js.org/",npm:"two.js",test:function(e){return!(!e.Two||!e.Two.Utils)&&{version:e.Two.Version||UNKNOWN_VERSION}}},Brewser:{id:"brewser",icon:"brewser",url:"https://robertpataki.github.io/brewser/",npm:"brewser",test:function(e){return!(!e.BREWSER||!e.BREWSER.ua)&&{version:BREWSER.VERSION||UNKNOWN_VERSION}}},"Material Design Lite":{id:"materialdesignlite",icon:"mdl",url:"https://getmdl.io/",npm:"material-design-lite",test:function(e){return!(!e.componentHandler||!e.componentHandler.upgradeElement)&&{version:UNKNOWN_VERSION}}},"Kendo UI":{id:"kendoui",icon:"kendoui",url:"https://github.com/telerik/kendo-ui-core",npm:"kendo-ui-core",test:function(e){return!!(e.kendo&&e.kendo.View&&e.kendo.View.extend)&&{version:e.kendo.version||UNKNOWN_VERSION}}},"Matter.js":{id:"matterjs",icon:"matter-js",url:"http://brm.io/matter-js/",npm:"matter-js",test:function(e){return!(!e.Matter||!e.Matter.Engine)&&{version:UNKNOWN_VERSION}}},Riot:{id:"riot",icon:"riot",url:"http://riotjs.com/",npm:"riot",test:function(e){return!(!e.riot||!e.riot.mixin)&&{version:e.riot.version||UNKNOWN_VERSION}}},"Sea.js":{id:"seajs",icon:"icon38",url:"https://seajs.github.io/seajs/docs/",npm:"seajs",test:function(e){return!(!e.seajs||!e.seajs.use)&&{version:e.seajs.version||UNKNOWN_VERSION}}},"Moment.js":{id:"momentjs",icon:"momentjs",url:"http://momentjs.com/",npm:"moment",test:function(e){return!(!e.moment||!e.moment.isMoment&&!e.moment.lang)&&{version:e.moment.version||UNKNOWN_VERSION}}},"Moment Timezone":{id:"moment-timezone",icon:"momentjs",url:"http://momentjs.com/timezone/",npm:"moment-timezone",test:function(e){return!(!e.moment||!e.moment.tz)&&{version:e.moment.tz.version||UNKNOWN_VERSION}}},ScrollMagic:{id:"scrollmagic",icon:"scrollmagic",url:"http://scrollmagic.io/",npm:"scrollmagic",test:function(e){return!(!e.ScrollMagic||!e.ScrollMagic.Controller)&&{version:ScrollMagic.version||UNKNOWN_VERSION}}},SWFObject:{id:"swfobject",icon:"icon38",url:"https://github.com/swfobject/swfobject",test:function(e){return e.swfobject&&e.swfobject.embedSWF?{version:e.swfobject.version||UNKNOWN_VERSION}:!(!e.deconcept||!e.deconcept.SWFObject)&&{version:UNKNOWN_VERSION}}},FlexSlider:{id:"flexslider",icon:"icon38",url:"https://woocommerce.com/flexslider/",npm:"flexslider",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;return!!(t&&t.fn&&t.fn.jquery&&t.flexslider)&&{version:UNKNOWN_VERSION}}},SPF:{id:"spf",icon:"icon38",url:"https://youtube.github.io/spfjs/",npm:"spf",test:function(e){return!(!e.spf||!e.spf.init)&&{version:UNKNOWN_VERSION}}},"Numeral.js":{id:"numeraljs",icon:"icon38",url:"http://numeraljs.com/",npm:"numeraljs",test:function(e){return!(!e.numeral||!e.isNumeral)&&{version:e.numeral.version||UNKNOWN_VERSION}}},"boomerang.js":{id:"boomerangjs",icon:"icon38",url:"https://soasta.github.io/boomerang/",npm:"boomerangjs",test:function(e){return!!(e.BOOMR&&e.BOOMR.utils&&e.BOOMR.init)&&{version:e.BOOMR.version||UNKNOWN_VERSION}}},Framer:{id:"framer",icon:"framer",url:"https://framer.com/",npm:"framerjs",test:function(e){return!(!e.Framer||!e.Framer.Layer)&&{version:e.Framer.Version.build||UNKNOWN_VERSION}}},Marko:{id:"marko",icon:"marko",url:"https://markojs.com/",npm:"marko",test:function(e){return!!document.querySelector("[data-marko-key], [data-marko]")&&{version:UNKNOWN_VERSION}}},AMP:{id:"amp",icon:"amp",url:"https://amp.dev/",npm:"https://www.npmjs.com/org/ampproject",test:function(e){var t=e.document.documentElement.getAttribute("amp-version");return!!t&&{version:t}}},Gatsby:{id:"gatsby",icon:"gatsby",url:"https://www.gatsbyjs.org/",npm:"gatsby",test:function(e){return!!document.getElementById("___gatsby")&&{version:UNKNOWN_VERSION}}},Shopify:{id:"shopify",icon:"shopify",url:"https://www.shopify.com/",npm:null,test:function(e){return!(!e.Shopify||!e.Shopify.shop)&&{version:UNKNOWN_VERSION}}},Magento:{id:"magento",icon:"magento",url:"https://magento.com/",npm:null,test:function(e){const t=/\\/static(?:\\/version\\d+)?\\/frontend\\/.+\\/.+\\/requirejs\\/require(?:\\.min)?\\.js/;return!!Array.from(document.querySelectorAll("script[src]")||[]).some((e=>t.test(e.src)))&&{version:2}}},WordPress:{id:"wordpress",icon:"wordpress",url:"https://wordpress.org/",npm:null,test:function(e){const t=!!document.querySelector('link[rel="https://api.w.org/"]'),o=!!document.querySelectorAll('link[href*="wp-includes"], script[src*="wp-includes"]').length;if(!t&&!o)return!1;const n=document.querySelector('meta[name=generator][content^="WordPress"]');return{version:n?n.getAttribute("content").replace(/^\\w+\\s/,""):UNKNOWN_VERSION}}},Wix:{id:"wix",icon:"wix",url:"https://www.wix.com/",npm:null,test:function(e){return(e.wixPerformanceMeasurements&&e.wixPerformanceMeasurements.info||!(!e.wixBiSession||!e.wixBiSession.info))&&{version:UNKNOWN_VERSION}}},Workbox:{id:"workbox",icon:"workbox",url:"https://developers.google.com/web/tools/workbox/",npm:"workbox-sw",test:async function(e){var t=e.navigator;if(!("serviceWorker"in t))return!1;const{timeoutPromise:o,clearTimeout:n}=_createTimeoutHelper(),r=t.serviceWorker.getRegistration().then((function(e){var o=t.serviceWorker.controller?t.serviceWorker.controller.scriptURL:e.active.scriptURL;return fetch(o,{credentials:"include",headers:{"service-worker":"script"}}).then((function(e){return e.text()})).then((function(e){if(/new Workbox|new workbox|workbox\\.precaching\\.|workbox\\.strategies/gm.test(e)){var t=/workbox.*?\\b((0|[1-9]\\d*)\\.(0|[1-9]\\d*)\\.(0|[1-9]\\d*)(-(0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*)(\\.(0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*))*)?(\\+[0-9a-zA-Z-]+(\\.[0-9a-zA-Z-]+)*)?)\\b/gim.exec(e),o=UNKNOWN_VERSION;return Array.isArray(t)&&t.length>1&&t[1]&&(o=t[1]),{version:o}}return!1}))})).catch((function(e){return!1}));return Promise.race([r,o]).catch((function(e){return!1})).finally((e=>(n(),e)))}},Boq:{id:"boq",icon:"icon38",url:"https://github.com/johnmichel/Library-Detector-for-Chrome/pull/143",npm:null,test:function(e){return!!e.WIZ_global_data&&{version:UNKNOWN_VERSION}}},Wiz:{id:"wiz",icon:"icon38",url:"https://github.com/johnmichel/Library-Detector-for-Chrome/pull/147",npm:null,test:function(e){return!!document.__wizdispatcher&&{version:UNKNOWN_VERSION}}},"core-js":{id:"corejs",icon:"icon38",url:"https://github.com/zloirock/core-js",npm:"core-js",test:function(e){const t=e["__core-js_shared__"],o=e.core;if(t){const e=t.versions;return{version:Array.isArray(e)?e.map((e=>\`core-js-\${e.mode}@\${e.version}\`)).join("; "):UNKNOWN_VERSION}}return!!o&&{version:o.version||UNKNOWN_VERSION}}},Drupal:{id:"drupal",icon:"drupal",url:"https://www.drupal.org/",npm:null,test:function(e){const t=document.querySelector('meta[name="generator"][content^="Drupal"]'),o=t?t.getAttribute("content").replace(/\\D+/gi,""):UNKNOWN_VERSION,n=/\\/sites\\/(?:default|all)\\/(?:themes|modules|files)/,r=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(r.some((e=>n.test(e.src)))||r.some((e=>n.test(e.href)))||t||e.Drupal&&e.Drupal.behaviors)&&{version:o}}},TYPO3:{id:"typo3",icon:"typo3",url:"https://typo3.org/",npm:null,test:function(e){const t=document.querySelector('meta[name="generator"][content^="TYPO3"]'),o=/\\/(typo3conf|typo3temp|fileadmin)/,n=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(t||n.some((e=>o.test(e.src)))||n.some((e=>o.test(e.href))))&&{version:UNKNOWN_VERSION}}},"Create React App":{id:"create-react-app",icon:"cra",url:"https://create-react-app.dev/",npm:"react-scripts",test:function(e){let t,o,n=e.document.body.firstElementChild;do{"noscript"===n.localName?t=n:"root"===n.id&&(o=n)}while(n=n.nextElementSibling);return!!(o&&t&&/You need to enable JavaScript to run this app/.test(t.textContent))&&{version:UNKNOWN_VERSION}}},"Guess.js":{id:"guessjs",icon:"guessjs",url:"https://guess-js.github.io/",test:function(e){return!(!e.__GUESS__||!e.__GUESS__.guess)&&{version:UNKNOWN_VERSION}}},"October CMS":{id:"octobercms",icon:"october",url:"https://octobercms.com/",npm:null,test:function(e){const t=document.querySelector('meta[name="generator"][content^="OctoberCMS"]'),o=document.querySelector('meta[name="generator"][content^="October CMS"]'),n=/\\/modules\\/system\\/assets\\/(css|js)\\/framework(\\.extras|\\.combined)?(-min)?/,r=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(t||o||r.some((e=>n.test(e.src||e.href))))&&{version:UNKNOWN_VERSION}}},Joomla:{id:"joomla",icon:"joomla",url:"https://www.joomla.org/",npm:null,test:function(e){const t=document.querySelector('meta[name=generator][content^="Joomla"]'),o=!!document.querySelectorAll('script[src*="/media/jui/js/bootstrap.min.js"]').length;return t?{version:t.getAttribute("content").replace(/^\\w+\\s/,"")}:!(!e.Joomla&&!o)&&{version:UNKNOWN_VERSION}}},Sugar:{id:"sugar",icon:"sugar",url:"https://sugarjs.com",npm:"sugar",test:function(e){return e.Sugar?{version:e.Sugar.VERSION||UNKNOWN_VERSION}:!!e.Array.SugarMethods&&{version:UNKNOWN_VERSION}}},Bento:{id:"bentojs",icon:"bentojs",url:"https://bentojs.dev",npm:"https://www.npmjs.com/org/bentoproject",test:function(e){return!(!e.BENTO||!e.BENTO.push)&&{version:UNKNOWN_VERSION}}},"WP Rocket":{id:"wp-rocket",icon:"wp-rocket",url:"https://wp-rocket.me/",npm:null,test:async function(e){const t="undefined"!=typeof RocketLazyLoadScripts||"undefined"!=typeof RocketPreloadLinksConfig||"undefined"!=typeof rocket_lazy,o=!!document.querySelector("style#wpr-usedcss"),n=document.lastChild.nodeType===Node.COMMENT_NODE&&document.lastChild.textContent.includes("WP Rocket");return!!(o||t||n)&&{version:UNKNOWN_VERSION}}},NitroPack:{id:"nitropack",icon:"nitropack",url:"https://nitropack.io/",npm:null,test:async function(e){return!!document.querySelector('meta[name="generator"][content="NitroPack"]')&&{version:UNKNOWN_VERSION}}},Remix:{id:"remix",icon:"remix",url:"https://remix.run/",npm:"remix",test:function(e){return!!e.__remixContext&&{version:UNKNOWN_VERSION}}}};`;s(ree,"detectLibraries");Mb=class e extends ${static{s(this,"Stacks")}constructor(){super(),this.meta={supportedModes:["snapshot","navigation"]}}static async collectStacks(t){let n={msg:"Collect stacks",id:"lh:gather:collectStacks"};F.time(n);let a=(await t.evaluate(ree,{args:[],deps:[nee]})).map(o=>({detector:"js",id:o.id,name:o.name,version:typeof o.version=="number"?String(o.version):o.version||void 0,npm:o.npm||void 0}));return F.timeEnd(n),a}async getArtifact(t){try{return await e.collectStacks(t.driver.executionContext)}catch{return[]}}},aee=Mb});var I3={};T(I3,{default:()=>oee});var Lb,oee,N3=b(()=>{"use strict";d();Mi();Se();Lb=class extends ${static{s(this,"TraceCompat")}meta={supportedModes:["timespan","navigation"],dependencies:{Trace:Xr.symbol}};async getArtifact(t){return{defaultPass:t.dependencies.Trace}}},oee=Lb});var Pb,zt,sr=b(()=>{"use strict";d();ue();Nt();Pg();Pb=class{static{s(this,"ProcessedNavigation")}static isProcessedTrace(t){return"timeOriginEvt"in t}static async compute_(t,n){if(this.isProcessedTrace(t))return wu.processNavigation(t);let r=await ke.request(t,n);return wu.processNavigation(r)}},zt=q(Pb,null)});var iee,M3,see,Ob,ds,Qp=b(()=>{"use strict";d();Nt();ue();iee=new Set(["keydown","keypress","keyup"]),M3=new Set(["mousedown","mouseup","pointerdown","pointerup","click"]),see={keyboard:iee,tapOrClick:M3,drag:M3},Ob=class e{static{s(this,"Responsiveness")}static getHighPercentileResponsiveness(t){let n=t.frameTreeEvents.filter(a=>a.name==="Responsiveness.Renderer.UserInteraction").sort((a,o)=>o.args.data.maxDuration-a.args.data.maxDuration);if(n.length===0)return null;let r=Math.min(9,Math.floor(n.length/50));return n[r]}static findInteractionEvent(t,{traceEvents:n}){let r=n.filter(u=>u.name==="EventTiming"&&u.ph!=="e");if(r.length&&r.every(u=>!u.args.data?.frame))return{name:"FallbackTiming",duration:t.args.data.maxDuration};let{maxDuration:a,interactionType:o}=t.args.data,i,c=Number.POSITIVE_INFINITY;for(let u of r){if(u.args.data.frame!==t.args.frame)continue;let{type:l,duration:m}=u.args.data,p=see[o];if(!p)throw new Error(`unexpected responsiveness interactionType '${o}'`);if(!p.has(l))continue;let h=Math.abs(m-a);h<c&&(i=u,c=h)}if(!i)throw new Error(`no interaction event found for responsiveness type '${o}'`);if(c>5)throw new Error(`no interaction event found within 5ms of responsiveness maxDuration (max: ${a}, closest ${i.args.data.duration})`);return i}static async compute_(t,n){let{settings:r,trace:a}=t;if(r.throttlingMethod==="simulate")throw new Error("Responsiveness currently unsupported by simulated throttling");let o=await ke.request(a,n),i=e.getHighPercentileResponsiveness(o);if(!i)return null;let c=e.findInteractionEvent(i,a);return JSON.parse(JSON.stringify(c))}},ds=q(Ob,["trace","settings"])});var cee,Bb,qa,Wu=b(()=>{"use strict";d();ue();Nt();Vu();cee=500,Bb=class e{static{s(this,"CumulativeLayoutShift")}static getLayoutShiftEvents(t){let n=[],r=!1,a=t.timestamps.timeOrigin,o=t.frameEvents.find(i=>i.name==="viewport");o&&(a=o.ts);for(let i of t.frameTreeEvents)if(!(i.name!=="LayoutShift"||!i.args.data||i.args.data.is_main_frame===void 0)){if(i.args.data.weighted_score_delta===void 0)throw new Error("CLS missing weighted_score_delta");if(i.args.data.had_recent_input){if((i.ts-a)/1e3>cee||r)continue}else r=!0;n.push({ts:i.ts,isMainFrame:i.args.data.is_main_frame,weightedScore:i.args.data.weighted_score_delta,impactedNodes:i.args.data.impacted_nodes})}return n}static getImpactByNodeId(t){let n=new Map;for(let r of t){if(!r.impactedNodes)continue;let a=0,o=new Map;for(let i of r.impactedNodes){if(!i.node_id||!i.old_rect||!i.new_rect)continue;let c=xb(i.old_rect),u=xb(i.new_rect),l=Hu(c)+Hu(u)-Gu(c,u);o.set(i.node_id,l),a+=l}for(let[i,c]of o.entries()){let u=n.get(i)||0;u+=c/a*r.weightedScore,n.set(i,u)}}return n}static calculate(t){let a=0,o=0,i=Number.NEGATIVE_INFINITY,c=Number.NEGATIVE_INFINITY;for(let u of t)(u.ts-i>5e6||u.ts-c>1e6)&&(i=u.ts,o=0),c=u.ts,o+=u.weightedScore,a=Math.max(a,o);return a}static async compute_(t,n){let r=await ke.request(t,n),a=e.getLayoutShiftEvents(r),o=e.getImpactByNodeId(a),i=a.filter(c=>c.isMainFrame);return{cumulativeLayoutShift:e.calculate(a),cumulativeLayoutShiftMainFrame:e.calculate(i),impactByNodeId:o}}},qa=q(Bb,null)});var L3={};T(L3,{default:()=>dee});function lee(){let e=this.nodeType===document.ELEMENT_NODE?this:this.parentElement,t;return e&&(t={node:getNodeDetails(e)}),t}var uee,Ub,dee,P3=b(()=>{"use strict";d();Se();ny();Zt();or();Mi();Nt();sr();It();Qp();Wu();_p();uee=15;s(lee,"getNodeDetailsData");Ub=class e extends ${static{s(this,"TraceElements")}meta={supportedModes:["timespan","navigation"],dependencies:{Trace:Xr.symbol}};animationIdToName=new Map;constructor(){super(),this._onAnimationStarted=this._onAnimationStarted.bind(this)}_onAnimationStarted({animation:{id:t,name:n}}){n&&this.animationIdToName.set(t,n)}static async getTopLayoutShiftElements(t,n){let{impactByNodeId:r}=await qa.request(t,n);return[...r.entries()].sort((a,o)=>o[1]-a[1]).slice(0,uee).map(([a])=>({nodeId:a}))}static async getResponsivenessElement(t,n){let{settings:r}=n;try{let a=await ds.request({trace:t,settings:r},n);return!a||a.name==="FallbackTiming"?void 0:{nodeId:a.args.data.nodeId}}catch{return}}async getAnimatedElements(t){let n=new Map;for(let o of t){if(o.name!=="Animation"||!o.id2||!o.id2.local)continue;let i=o.id2.local,c=n.get(i)||{begin:void 0,status:void 0};o.ph==="b"?c.begin=o:o.ph==="n"&&o.args.data&&o.args.data.compositeFailed!==void 0&&(c.status=o),n.set(i,c)}let r=new Map;for(let{begin:o,status:i}of n.values()){let c=o?.args?.data?.nodeId,u=o?.args?.data?.id,l=i?.args?.data?.compositeFailed,m=i?.args?.data?.unsupportedProperties;if(!c||!u)continue;let p=r.get(c)||new Set;p.add({animationId:u,failureReasonsMask:l,unsupportedProperties:m}),r.set(c,p)}let a=[];for(let[o,i]of r){let c=[];for(let{animationId:u,failureReasonsMask:l,unsupportedProperties:m}of i){let p=this.animationIdToName.get(u);c.push({name:p,failureReasonsMask:l,unsupportedProperties:m})}a.push({nodeId:o,animations:c})}return a}static async getLcpElement(t,n){let r;try{r=await zt.request(t,n)}catch(o){if(n.gatherMode==="timespan"&&o.code===j.errors.NO_FCP.code)return;throw o}let a=r.largestContentfulPaintEvt?.args?.data;if(!(a?.nodeId===void 0||!a.type))return{nodeId:a.nodeId,type:a.type}}async startInstrumentation(t){await t.driver.defaultSession.sendCommand("Animation.enable"),t.driver.defaultSession.on("Animation.animationStarted",this._onAnimationStarted)}async stopInstrumentation(t){t.driver.defaultSession.off("Animation.animationStarted",this._onAnimationStarted),await t.driver.defaultSession.sendCommand("Animation.disable")}async getArtifact(t){let n=t.driver.defaultSession,r=t.dependencies.Trace;if(!r)throw new Error("Trace is missing!");let a=await ke.request(r,t),{mainThreadEvents:o}=a,i=await e.getLcpElement(r,t),c=await e.getTopLayoutShiftElements(r,t),u=await this.getAnimatedElements(o),l=await e.getResponsivenessElement(r,t),m=new Map([["largest-contentful-paint",i?[i]:[]],["layout-shift",c],["animation",u],["responsiveness",l?[l]:[]]]),p=[];for(let[h,f]of m)for(let y=0;y<f.length;y++){let v=f[y].nodeId,D;try{let E=await OI(n,v);if(!E)continue;let S=Ma.serializeDeps([me.getNodeDetails,lee]);D=await n.sendCommand("Runtime.callFunctionOn",{objectId:E,functionDeclaration:`function () {
              ${S}
              return getNodeDetailsData.call(this);
            }`,returnByValue:!0,awaitPromise:!0})}catch(E){Rt.captureException(E,{tags:{gatherer:"TraceElements"},level:"error"});continue}D?.result?.value&&p.push({traceEventType:h,...D.result.value,animations:f[y].animations,nodeId:v,type:f[y].type})}return p}},dee=Ub});var O3={};T(O3,{default:()=>pee});function mee(){return{innerWidth:window.innerWidth,innerHeight:window.innerHeight,outerWidth:window.outerWidth,outerHeight:window.outerHeight,devicePixelRatio:window.devicePixelRatio}}var jb,pee,B3=b(()=>{"use strict";d();Se();s(mee,"getViewportDimensions");jb=class extends ${static{s(this,"ViewportDimensions")}meta={supportedModes:["snapshot","timespan","navigation"]};async getArtifact(t){let r=await t.driver.executionContext.evaluate(mee,{args:[],useIsolation:!0});if(!Object.values(r).every(Number.isFinite)){let o=JSON.stringify(r);throw new Error(`ViewportDimensions results were not numeric: ${o}`)}return r}},pee=jb});function Vn(e,t){let n,r;return typeof e=="string"?n=t?e.trim():e:(e!==void 0&&(r="ERROR: expected a string."),n=void 0),{raw:e,value:n,warning:r}}function U3(e){let t=Vn(e);return t.value===void 0,t}function gee(e){return Vn(e.name,!0)}function yee(e){return Vn(e.short_name,!0)}function bee(e,t){let n=new URL(e),r=new URL(t);return n.origin===r.origin}function vee(e,t,n){let r=e.start_url;if(r==="")return{raw:r,value:n,warning:"ERROR: start_url string empty"};if(r===void 0)return{raw:r,value:n};if(typeof r!="string")return{raw:r,value:n,warning:"ERROR: expected a string."};let a;try{a=new URL(r,t).href}catch{return{raw:r,value:n,warning:`ERROR: invalid start_url relative to ${t}`}}return bee(a,n)?{raw:r,value:a}:{raw:r,value:n,warning:"ERROR: start_url must be same-origin as document"}}function wee(e){let t=Vn(e.display,!0),n=t.value;if(!n)return{raw:e,value:qb,warning:t.warning};let r=n.toLowerCase();return fee.includes(r)?{raw:e,value:r,warning:void 0}:{raw:e,value:qb,warning:"ERROR: 'display' has invalid value "+r+`. will fall back to ${qb}.`}}function Dee(e){let t=Vn(e.orientation,!0);return t.value&&!hee.includes(t.value.toLowerCase())&&(t.value=void 0,t.warning="ERROR: 'orientation' has an invalid value, will be ignored."),t}function Eee(e,t){let n=Vn(e.src,!0);if(n.value===""&&(n.value=void 0),n.value)try{n.value=new URL(n.value,t).href}catch{n.warning=`ERROR: invalid icon url will be ignored: '${e.src}'`,n.value=void 0}let r=Vn(e.type,!0),a=Vn(e.purpose),o={raw:e.purpose,value:["any"],warning:void 0};a.value!==void 0&&(o.value=a.value.split(/\s+/).map(l=>l.toLowerCase()));let i={raw:e.density,value:1,warning:void 0};i.raw!==void 0&&(i.value=parseFloat(i.raw),(isNaN(i.value)||!isFinite(i.value)||i.value<=0)&&(i.value=1,i.warning="ERROR: icon density cannot be NaN, +∞, or less than or equal to +0."));let c,u=Vn(e.sizes);if(u.value!==void 0){let l=new Set;u.value.trim().split(/\s+/).forEach(m=>l.add(m.toLowerCase())),c={raw:e.sizes,value:l.size>0?Array.from(l):void 0,warning:void 0}}else c={...u,value:void 0};return{raw:e,value:{src:n,type:r,density:i,sizes:c,purpose:o},warning:void 0}}function xee(e,t){let n=e.icons;if(n===void 0)return{raw:n,value:[],warning:void 0};if(!Array.isArray(n))return{raw:n,value:[],warning:"ERROR: 'icons' expected to be an array but is not."};let r=n.filter(i=>i.src!==void 0).map(i=>Eee(i,t)),a=r.filter(i=>{let c=[i.warning,i.value.type.warning,i.value.src.warning,i.value.sizes.warning,i.value.density.warning].filter(Boolean),u=!!i.value.src.value;return!!c.length&&!u}),o=r.filter(i=>i.value.src.value!==void 0);return{raw:n,value:o,warning:a.length?"WARNING: Some icons were ignored due to warnings.":void 0}}function Tee(e){let t=Vn(e.platform,!0),n=Vn(e.id,!0),r=Vn(e.url,!0);if(r.value)try{r.value=new URL(r.value).href}catch{r.value=void 0,r.warning=`ERROR: invalid application URL ${e.url}`}return{raw:e,value:{platform:t,id:n,url:r},warning:void 0}}function See(e){let t=e.related_applications;if(t===void 0)return{raw:t,value:void 0,warning:void 0};if(!Array.isArray(t))return{raw:t,value:void 0,warning:"ERROR: 'related_applications' expected to be an array but is not."};let n=t.filter(r=>!!r.platform).map(Tee).filter(r=>!!r.value.id.value||!!r.value.url.value);return{raw:t,value:n,warning:void 0}}function kee(e){let t=e.prefer_related_applications,n,r;return typeof t=="boolean"?n=t:(t!==void 0&&(r="ERROR: 'prefer_related_applications' expected to be a boolean."),n=void 0),{raw:t,value:n,warning:r}}function Cee(e){return U3(e.theme_color)}function Aee(e){return U3(e.background_color)}function j3(e,t,n){if(t===void 0||n===void 0)throw new Error("Manifest and document URLs required for manifest parsing.");let r;try{r=JSON.parse(e)}catch(i){return{raw:e,value:void 0,warning:"ERROR: file isn't valid JSON: "+i,url:t}}let a={name:gee(r),short_name:yee(r),start_url:vee(r,t,n),display:wee(r),orientation:Dee(r),icons:xee(r,t),related_applications:See(r),prefer_related_applications:kee(r),theme_color:Cee(r),background_color:Aee(r)},o;try{new URL(t).protocol.startsWith("http")||(o="WARNING: manifest URL not available over a valid network protocol")}catch{o=`ERROR: invalid manifest URL: '${t}'`}return{raw:e,value:a,warning:o,url:t}}var fee,qb,hee,q3=b(()=>{"use strict";d();fee=["fullscreen","standalone","minimal-ui","browser"],qb="browser",hee=["any","natural","landscape","portrait","portrait-primary","portrait-secondary","landscape-primary","landscape-secondary"];s(Vn,"parseString");s(U3,"parseColor");s(gee,"parseName");s(yee,"parseShortName");s(bee,"checkSameOrigin");s(vee,"parseStartUrl");s(wee,"parseDisplay");s(Dee,"parseOrientation");s(Eee,"parseIcon");s(xee,"parseIcons");s(Tee,"parseApplication");s(See,"parseRelatedApplications");s(kee,"parsePreferRelatedApplications");s(Cee,"parseThemeColor");s(Aee,"parseBackgroundColor");s(j3,"parseManifest")});var z3={};T(z3,{default:()=>_ee});var zb,_ee,H3=b(()=>{"use strict";d();Ae();q3();Se();zb=class e extends ${static{s(this,"WebAppManifest")}meta={supportedModes:["snapshot","navigation"]};static async fetchAppManifest(t){t.setNextProtocolTimeout(1e4);let n;try{n=await t.sendCommand("Page.getAppManifest")}catch(c){if(c.code==="PROTOCOL_TIMEOUT")return F.error("WebAppManifest","Failed fetching manifest",c),null;throw c}let r=n.data;if(!r)return null;let a=3,o=65279;return r.charCodeAt(0)===o&&(r=Buffer.from(r).slice(a).toString()),{...n,data:r}}static async getWebAppManifest(t,n){let r={msg:"Get webapp manifest",id:"lh:gather:getWebAppManifest"};F.time(r);let a=await e.fetchAppManifest(t);if(!a)return null;let o=j3(a.data,a.url,n);return F.timeEnd(r),o}async getArtifact(t){let n=t.driver,{finalDisplayedUrl:r}=t.baseArtifacts.URL;try{return await e.getWebAppManifest(n.defaultSession,r)}catch{return null}}},_ee=zb});var G3,Ree,Hb,N,te=b(()=>{"use strict";d();V();A();G3={failingElementsHeader:"Failing Elements"},Ree=w("core/audits/accessibility/axe-audit.js",G3),Hb=class extends g{static{s(this,"AxeAudit")}static audit(t){if((t.Accessibility.notApplicable||[]).find(v=>v.id===this.meta.id))return{score:null,notApplicable:!0};let a=t.Accessibility.incomplete||[],o=a.find(v=>v.id===this.meta.id);if(o?.error)return{score:null,errorMessage:`axe-core Error: ${o.error.message||"Unknown error"}`};let i=this.meta.scoreDisplayMode===g.SCORING_MODES.INFORMATIVE,c=t.Accessibility.violations||[],l=(i?c.concat(a):c).find(v=>v.id===this.meta.id),m=l?.impact,p=l?.tags;if(i&&!l)return{score:null,notApplicable:!0};let h=[];l?.nodes&&(h=l.nodes.map(v=>({node:{...g.makeNodeItem(v.node),explanation:v.failureSummary},subItems:v.relatedNodes.length?{type:"subitems",items:v.relatedNodes.map(D=>({relatedNode:g.makeNodeItem(D)}))}:void 0})));let f=[{key:"node",valueType:"node",subItemsHeading:{key:"relatedNode",valueType:"node"},label:Ree(G3.failingElementsHeader)}],y;return(m||p)&&(y={type:"debugdata",impact:m,tags:p}),{score:+(l===void 0),details:{...g.makeTableDetails(f,h),debugData:y}}}},N=Hb});var V3={};T(V3,{UIStrings:()=>$u,default:()=>Fee});var $u,Gb,Vb,Fee,W3=b(()=>{"use strict";d();te();A();$u={title:"`[accesskey]` values are unique",failureTitle:"`[accesskey]` values are not unique",description:"Access keys let users quickly focus a part of the page. For proper navigation, each access key must be unique. [Learn more about access keys](https://dequeuniversity.com/rules/axe/4.8/accesskeys)."},Gb=w("core/audits/accessibility/accesskeys.js",$u),Vb=class extends N{static{s(this,"Accesskeys")}static get meta(){return{id:"accesskeys",title:Gb($u.title),failureTitle:Gb($u.failureTitle),description:Gb($u.description),requiredArtifacts:["Accessibility"]}}},Fee=Vb});var $3={};T($3,{UIStrings:()=>Yu,default:()=>Iee});var Yu,Wb,$b,Iee,Y3=b(()=>{"use strict";d();te();A();Yu={title:"`[aria-*]` attributes match their roles",failureTitle:"`[aria-*]` attributes do not match their roles",description:"Each ARIA `role` supports a specific subset of `aria-*` attributes. Mismatching these invalidates the `aria-*` attributes. [Learn how to match ARIA attributes to their roles](https://dequeuniversity.com/rules/axe/4.8/aria-allowed-attr)."},Wb=w("core/audits/accessibility/aria-allowed-attr.js",Yu),$b=class extends N{static{s(this,"ARIAAllowedAttr")}static get meta(){return{id:"aria-allowed-attr",title:Wb(Yu.title),failureTitle:Wb(Yu.failureTitle),description:Wb(Yu.description),requiredArtifacts:["Accessibility"]}}},Iee=$b});var K3={};T(K3,{UIStrings:()=>Ku,default:()=>Nee});var Ku,Yb,Kb,Nee,X3=b(()=>{"use strict";d();te();A();Ku={title:'Values assigned to `role=""` are valid ARIA roles.',failureTitle:'Values assigned to `role=""` are not valid ARIA roles.',description:"ARIA `role`s enable assistive technologies to know the role of each element on the web page. If the `role` values are misspelled, not existing ARIA `role` values, or abstract roles, then the purpose of the element will not be communicated to users of assistive technologies. [Learn more about ARIA roles](https://dequeuniversity.com/rules/axe/4.8/aria-allowed-role)."},Yb=w("core/audits/accessibility/aria-allowed-role.js",Ku),Kb=class extends N{static{s(this,"ARIAAllowedRole")}static get meta(){return{id:"aria-allowed-role",title:Yb(Ku.title),failureTitle:Yb(Ku.failureTitle),description:Yb(Ku.description),requiredArtifacts:["Accessibility"]}}},Nee=Kb});var J3={};T(J3,{UIStrings:()=>Xu,default:()=>Mee});var Xu,Xb,Jb,Mee,Z3=b(()=>{"use strict";d();te();A();Xu={title:"`button`, `link`, and `menuitem` elements have accessible names",failureTitle:"`button`, `link`, and `menuitem` elements do not have accessible names.",description:"When an element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn how to make command elements more accessible](https://dequeuniversity.com/rules/axe/4.8/aria-command-name)."},Xb=w("core/audits/accessibility/aria-command-name.js",Xu),Jb=class extends N{static{s(this,"AriaCommandName")}static get meta(){return{id:"aria-command-name",title:Xb(Xu.title),failureTitle:Xb(Xu.failureTitle),description:Xb(Xu.description),requiredArtifacts:["Accessibility"]}}},Mee=Jb});var Q3={};T(Q3,{UIStrings:()=>Ju,default:()=>Lee});var Ju,Zb,Qb,Lee,eL=b(()=>{"use strict";d();te();A();Ju={title:'Elements with `role="dialog"` or `role="alertdialog"` have accessible names.',failureTitle:'Elements with `role="dialog"` or `role="alertdialog"` do not have accessible names.',description:"ARIA dialog elements without accessible names may prevent screen readers users from discerning the purpose of these elements. [Learn how to make ARIA dialog elements more accessible](https://dequeuniversity.com/rules/axe/4.8/aria-dialog-name)."},Zb=w("core/audits/accessibility/aria-dialog-name.js",Ju),Qb=class extends N{static{s(this,"AriaDialogName")}static get meta(){return{id:"aria-dialog-name",title:Zb(Ju.title),failureTitle:Zb(Ju.failureTitle),description:Zb(Ju.description),requiredArtifacts:["Accessibility"]}}},Lee=Qb});var tL={};T(tL,{UIStrings:()=>Zu,default:()=>Pee});var Zu,ev,tv,Pee,nL=b(()=>{"use strict";d();te();A();Zu={title:'`[aria-hidden="true"]` is not present on the document `<body>`',failureTitle:'`[aria-hidden="true"]` is present on the document `<body>`',description:'Assistive technologies, like screen readers, work inconsistently when `aria-hidden="true"` is set on the document `<body>`. [Learn how `aria-hidden` affects the document body](https://dequeuniversity.com/rules/axe/4.8/aria-hidden-body).'},ev=w("core/audits/accessibility/aria-hidden-body.js",Zu),tv=class extends N{static{s(this,"AriaHiddenBody")}static get meta(){return{id:"aria-hidden-body",title:ev(Zu.title),failureTitle:ev(Zu.failureTitle),description:ev(Zu.description),requiredArtifacts:["Accessibility"]}}},Pee=tv});var rL={};T(rL,{UIStrings:()=>Qu,default:()=>Oee});var Qu,nv,rv,Oee,aL=b(()=>{"use strict";d();te();A();Qu={title:'`[aria-hidden="true"]` elements do not contain focusable descendents',failureTitle:'`[aria-hidden="true"]` elements contain focusable descendents',description:'Focusable descendents within an `[aria-hidden="true"]` element prevent those interactive elements from being available to users of assistive technologies like screen readers. [Learn how `aria-hidden` affects focusable elements](https://dequeuniversity.com/rules/axe/4.8/aria-hidden-focus).'},nv=w("core/audits/accessibility/aria-hidden-focus.js",Qu),rv=class extends N{static{s(this,"AriaHiddenFocus")}static get meta(){return{id:"aria-hidden-focus",title:nv(Qu.title),failureTitle:nv(Qu.failureTitle),description:nv(Qu.description),requiredArtifacts:["Accessibility"]}}},Oee=rv});var oL={};T(oL,{UIStrings:()=>el,default:()=>Bee});var el,av,ov,Bee,iL=b(()=>{"use strict";d();te();A();el={title:"ARIA input fields have accessible names",failureTitle:"ARIA input fields do not have accessible names",description:"When an input field doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more about input field labels](https://dequeuniversity.com/rules/axe/4.8/aria-input-field-name)."},av=w("core/audits/accessibility/aria-input-field-name.js",el),ov=class extends N{static{s(this,"AriaInputFieldName")}static get meta(){return{id:"aria-input-field-name",title:av(el.title),failureTitle:av(el.failureTitle),description:av(el.description),requiredArtifacts:["Accessibility"]}}},Bee=ov});var sL={};T(sL,{UIStrings:()=>tl,default:()=>Uee});var tl,iv,sv,Uee,cL=b(()=>{"use strict";d();te();A();tl={title:"ARIA `meter` elements have accessible names",failureTitle:"ARIA `meter` elements do not have accessible names.",description:"When a meter element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn how to name `meter` elements](https://dequeuniversity.com/rules/axe/4.8/aria-meter-name)."},iv=w("core/audits/accessibility/aria-meter-name.js",tl),sv=class extends N{static{s(this,"AriaMeterName")}static get meta(){return{id:"aria-meter-name",title:iv(tl.title),failureTitle:iv(tl.failureTitle),description:iv(tl.description),requiredArtifacts:["Accessibility"]}}},Uee=sv});var uL={};T(uL,{UIStrings:()=>nl,default:()=>jee});var nl,cv,uv,jee,lL=b(()=>{"use strict";d();te();A();nl={title:"ARIA `progressbar` elements have accessible names",failureTitle:"ARIA `progressbar` elements do not have accessible names.",description:"When a `progressbar` element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn how to label `progressbar` elements](https://dequeuniversity.com/rules/axe/4.8/aria-progressbar-name)."},cv=w("core/audits/accessibility/aria-progressbar-name.js",nl),uv=class extends N{static{s(this,"AriaProgressbarName")}static get meta(){return{id:"aria-progressbar-name",title:cv(nl.title),failureTitle:cv(nl.failureTitle),description:cv(nl.description),requiredArtifacts:["Accessibility"]}}},jee=uv});var dL={};T(dL,{UIStrings:()=>rl,default:()=>qee});var rl,lv,dv,qee,mL=b(()=>{"use strict";d();te();A();rl={title:"`[role]`s have all required `[aria-*]` attributes",failureTitle:"`[role]`s do not have all required `[aria-*]` attributes",description:"Some ARIA roles have required attributes that describe the state of the element to screen readers. [Learn more about roles and required attributes](https://dequeuniversity.com/rules/axe/4.8/aria-required-attr)."},lv=w("core/audits/accessibility/aria-required-attr.js",rl),dv=class extends N{static{s(this,"ARIARequiredAttr")}static get meta(){return{id:"aria-required-attr",title:lv(rl.title),failureTitle:lv(rl.failureTitle),description:lv(rl.description),requiredArtifacts:["Accessibility"]}}},qee=dv});var pL={};T(pL,{UIStrings:()=>al,default:()=>zee});var al,mv,pv,zee,fL=b(()=>{"use strict";d();te();A();al={title:"Elements with an ARIA `[role]` that require children to contain a specific `[role]` have all required children.",failureTitle:"Elements with an ARIA `[role]` that require children to contain a specific `[role]` are missing some or all of those required children.",description:"Some ARIA parent roles must contain specific child roles to perform their intended accessibility functions. [Learn more about roles and required children elements](https://dequeuniversity.com/rules/axe/4.8/aria-required-children)."},mv=w("core/audits/accessibility/aria-required-children.js",al),pv=class extends N{static{s(this,"AriaRequiredChildren")}static get meta(){return{id:"aria-required-children",title:mv(al.title),failureTitle:mv(al.failureTitle),description:mv(al.description),requiredArtifacts:["Accessibility"]}}},zee=pv});var hL={};T(hL,{UIStrings:()=>ol,default:()=>Hee});var ol,fv,hv,Hee,gL=b(()=>{"use strict";d();te();A();ol={title:"`[role]`s are contained by their required parent element",failureTitle:"`[role]`s are not contained by their required parent element",description:"Some ARIA child roles must be contained by specific parent roles to properly perform their intended accessibility functions. [Learn more about ARIA roles and required parent element](https://dequeuniversity.com/rules/axe/4.8/aria-required-parent)."},fv=w("core/audits/accessibility/aria-required-parent.js",ol),hv=class extends N{static{s(this,"AriaRequiredParent")}static get meta(){return{id:"aria-required-parent",title:fv(ol.title),failureTitle:fv(ol.failureTitle),description:fv(ol.description),requiredArtifacts:["Accessibility"]}}},Hee=hv});var yL={};T(yL,{UIStrings:()=>il,default:()=>Gee});var il,gv,yv,Gee,bL=b(()=>{"use strict";d();te();A();il={title:"`[role]` values are valid",failureTitle:"`[role]` values are not valid",description:"ARIA roles must have valid values in order to perform their intended accessibility functions. [Learn more about valid ARIA roles](https://dequeuniversity.com/rules/axe/4.8/aria-roles)."},gv=w("core/audits/accessibility/aria-roles.js",il),yv=class extends N{static{s(this,"AriaRoles")}static get meta(){return{id:"aria-roles",title:gv(il.title),failureTitle:gv(il.failureTitle),description:gv(il.description),requiredArtifacts:["Accessibility"]}}},Gee=yv});var vL={};T(vL,{UIStrings:()=>sl,default:()=>Vee});var sl,bv,vv,Vee,wL=b(()=>{"use strict";d();te();A();sl={title:"Elements with the `role=text` attribute do not have focusable descendents.",failureTitle:"Elements with the `role=text` attribute do have focusable descendents.",description:"Adding `role=text` around a text node split by markup enables VoiceOver to treat it as one phrase, but the element's focusable descendents will not be announced. [Learn more about the `role=text` attribute](https://dequeuniversity.com/rules/axe/4.8/aria-text)."},bv=w("core/audits/accessibility/aria-text.js",sl),vv=class extends N{static{s(this,"AriaText")}static get meta(){return{id:"aria-text",title:bv(sl.title),failureTitle:bv(sl.failureTitle),description:bv(sl.description),requiredArtifacts:["Accessibility"]}}},Vee=vv});var DL={};T(DL,{UIStrings:()=>cl,default:()=>Wee});var cl,wv,Dv,Wee,EL=b(()=>{"use strict";d();te();A();cl={title:"ARIA toggle fields have accessible names",failureTitle:"ARIA toggle fields do not have accessible names",description:"When a toggle field doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more about toggle fields](https://dequeuniversity.com/rules/axe/4.8/aria-toggle-field-name)."},wv=w("core/audits/accessibility/aria-toggle-field-name.js",cl),Dv=class extends N{static{s(this,"AriaToggleFieldName")}static get meta(){return{id:"aria-toggle-field-name",title:wv(cl.title),failureTitle:wv(cl.failureTitle),description:wv(cl.description),requiredArtifacts:["Accessibility"]}}},Wee=Dv});var xL={};T(xL,{UIStrings:()=>ul,default:()=>$ee});var ul,Ev,xv,$ee,TL=b(()=>{"use strict";d();te();A();ul={title:"ARIA `tooltip` elements have accessible names",failureTitle:"ARIA `tooltip` elements do not have accessible names.",description:"When a tooltip element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn how to name `tooltip` elements](https://dequeuniversity.com/rules/axe/4.8/aria-tooltip-name)."},Ev=w("core/audits/accessibility/aria-tooltip-name.js",ul),xv=class extends N{static{s(this,"AriaTooltipName")}static get meta(){return{id:"aria-tooltip-name",title:Ev(ul.title),failureTitle:Ev(ul.failureTitle),description:Ev(ul.description),requiredArtifacts:["Accessibility"]}}},$ee=xv});var SL={};T(SL,{UIStrings:()=>ll,default:()=>Yee});var ll,Tv,Sv,Yee,kL=b(()=>{"use strict";d();te();A();ll={title:"ARIA `treeitem` elements have accessible names",failureTitle:"ARIA `treeitem` elements do not have accessible names.",description:"When a `treeitem` element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more about labeling `treeitem` elements](https://dequeuniversity.com/rules/axe/4.8/aria-treeitem-name)."},Tv=w("core/audits/accessibility/aria-treeitem-name.js",ll),Sv=class extends N{static{s(this,"AriaTreeitemName")}static get meta(){return{id:"aria-treeitem-name",title:Tv(ll.title),failureTitle:Tv(ll.failureTitle),description:Tv(ll.description),requiredArtifacts:["Accessibility"]}}},Yee=Sv});var CL={};T(CL,{UIStrings:()=>dl,default:()=>Kee});var dl,kv,Cv,Kee,AL=b(()=>{"use strict";d();te();A();dl={title:"`[aria-*]` attributes have valid values",failureTitle:"`[aria-*]` attributes do not have valid values",description:"Assistive technologies, like screen readers, can't interpret ARIA attributes with invalid values. [Learn more about valid values for ARIA attributes](https://dequeuniversity.com/rules/axe/4.8/aria-valid-attr-value)."},kv=w("core/audits/accessibility/aria-valid-attr-value.js",dl),Cv=class extends N{static{s(this,"ARIAValidAttr")}static get meta(){return{id:"aria-valid-attr-value",title:kv(dl.title),failureTitle:kv(dl.failureTitle),description:kv(dl.description),requiredArtifacts:["Accessibility"]}}},Kee=Cv});var _L={};T(_L,{UIStrings:()=>ml,default:()=>Xee});var ml,Av,_v,Xee,RL=b(()=>{"use strict";d();te();A();ml={title:"`[aria-*]` attributes are valid and not misspelled",failureTitle:"`[aria-*]` attributes are not valid or misspelled",description:"Assistive technologies, like screen readers, can't interpret ARIA attributes with invalid names. [Learn more about valid ARIA attributes](https://dequeuniversity.com/rules/axe/4.8/aria-valid-attr)."},Av=w("core/audits/accessibility/aria-valid-attr.js",ml),_v=class extends N{static{s(this,"ARIAValidAttr")}static get meta(){return{id:"aria-valid-attr",title:Av(ml.title),failureTitle:Av(ml.failureTitle),description:Av(ml.description),requiredArtifacts:["Accessibility"]}}},Xee=_v});var FL={};T(FL,{UIStrings:()=>pl,default:()=>Jee});var pl,Rv,Fv,Jee,IL=b(()=>{"use strict";d();te();A();pl={title:"Buttons have an accessible name",failureTitle:"Buttons do not have an accessible name",description:`When a button doesn't have an accessible name, screen readers announce it as "button", making it unusable for users who rely on screen readers. [Learn how to make buttons more accessible](https://dequeuniversity.com/rules/axe/4.8/button-name).`},Rv=w("core/audits/accessibility/button-name.js",pl),Fv=class extends N{static{s(this,"ButtonName")}static get meta(){return{id:"button-name",title:Rv(pl.title),failureTitle:Rv(pl.failureTitle),description:Rv(pl.description),requiredArtifacts:["Accessibility"]}}},Jee=Fv});var NL={};T(NL,{UIStrings:()=>fl,default:()=>Zee});var fl,Iv,Nv,Zee,ML=b(()=>{"use strict";d();te();A();fl={title:"The page contains a heading, skip link, or landmark region",failureTitle:"The page does not contain a heading, skip link, or landmark region",description:"Adding ways to bypass repetitive content lets keyboard users navigate the page more efficiently. [Learn more about bypass blocks](https://dequeuniversity.com/rules/axe/4.8/bypass)."},Iv=w("core/audits/accessibility/bypass.js",fl),Nv=class extends N{static{s(this,"Bypass")}static get meta(){return{id:"bypass",title:Iv(fl.title),failureTitle:Iv(fl.failureTitle),description:Iv(fl.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},Zee=Nv});var LL={};T(LL,{UIStrings:()=>hl,default:()=>Qee});var hl,Mv,Lv,Qee,PL=b(()=>{"use strict";d();te();A();hl={title:"Background and foreground colors have a sufficient contrast ratio",failureTitle:"Background and foreground colors do not have a sufficient contrast ratio.",description:"Low-contrast text is difficult or impossible for many users to read. [Learn how to provide sufficient color contrast](https://dequeuniversity.com/rules/axe/4.8/color-contrast)."},Mv=w("core/audits/accessibility/color-contrast.js",hl),Lv=class extends N{static{s(this,"ColorContrast")}static get meta(){return{id:"color-contrast",title:Mv(hl.title),failureTitle:Mv(hl.failureTitle),description:Mv(hl.description),requiredArtifacts:["Accessibility"]}}},Qee=Lv});var OL={};T(OL,{UIStrings:()=>gl,default:()=>ete});var gl,Pv,Ov,ete,BL=b(()=>{"use strict";d();te();A();gl={title:"`<dl>`'s contain only properly-ordered `<dt>` and `<dd>` groups, `<script>`, `<template>` or `<div>` elements.",failureTitle:"`<dl>`'s do not contain only properly-ordered `<dt>` and `<dd>` groups, `<script>`, `<template>` or `<div>` elements.",description:"When definition lists are not properly marked up, screen readers may produce confusing or inaccurate output. [Learn how to structure definition lists correctly](https://dequeuniversity.com/rules/axe/4.8/definition-list)."},Pv=w("core/audits/accessibility/definition-list.js",gl),Ov=class extends N{static{s(this,"DefinitionList")}static get meta(){return{id:"definition-list",title:Pv(gl.title),failureTitle:Pv(gl.failureTitle),description:Pv(gl.description),requiredArtifacts:["Accessibility"]}}},ete=Ov});var UL={};T(UL,{UIStrings:()=>yl,default:()=>tte});var yl,Bv,Uv,tte,jL=b(()=>{"use strict";d();te();A();yl={title:"Definition list items are wrapped in `<dl>` elements",failureTitle:"Definition list items are not wrapped in `<dl>` elements",description:"Definition list items (`<dt>` and `<dd>`) must be wrapped in a parent `<dl>` element to ensure that screen readers can properly announce them. [Learn how to structure definition lists correctly](https://dequeuniversity.com/rules/axe/4.8/dlitem)."},Bv=w("core/audits/accessibility/dlitem.js",yl),Uv=class extends N{static{s(this,"DLItem")}static get meta(){return{id:"dlitem",title:Bv(yl.title),failureTitle:Bv(yl.failureTitle),description:Bv(yl.description),requiredArtifacts:["Accessibility"]}}},tte=Uv});var qL={};T(qL,{UIStrings:()=>bl,default:()=>nte});var bl,jv,qv,nte,zL=b(()=>{"use strict";d();te();A();bl={title:"Document has a `<title>` element",failureTitle:"Document doesn't have a `<title>` element",description:"The title gives screen reader users an overview of the page, and search engine users rely on it heavily to determine if a page is relevant to their search. [Learn more about document titles](https://dequeuniversity.com/rules/axe/4.8/document-title)."},jv=w("core/audits/accessibility/document-title.js",bl),qv=class extends N{static{s(this,"DocumentTitle")}static get meta(){return{id:"document-title",title:jv(bl.title),failureTitle:jv(bl.failureTitle),description:jv(bl.description),requiredArtifacts:["Accessibility"]}}},nte=qv});var HL={};T(HL,{UIStrings:()=>vl,default:()=>rte});var vl,zv,Hv,rte,GL=b(()=>{"use strict";d();te();A();vl={title:"`[id]` attributes on active, focusable elements are unique",failureTitle:"`[id]` attributes on active, focusable elements are not unique",description:"All focusable elements must have a unique `id` to ensure that they're visible to assistive technologies. [Learn how to fix duplicate `id`s](https://dequeuniversity.com/rules/axe/4.8/duplicate-id-active)."},zv=w("core/audits/accessibility/duplicate-id-active.js",vl),Hv=class extends N{static{s(this,"DuplicateIdActive")}static get meta(){return{id:"duplicate-id-active",title:zv(vl.title),failureTitle:zv(vl.failureTitle),description:zv(vl.description),requiredArtifacts:["Accessibility"]}}},rte=Hv});var VL={};T(VL,{UIStrings:()=>wl,default:()=>ate});var wl,Gv,Vv,ate,WL=b(()=>{"use strict";d();te();A();wl={title:"ARIA IDs are unique",failureTitle:"ARIA IDs are not unique",description:"The value of an ARIA ID must be unique to prevent other instances from being overlooked by assistive technologies. [Learn how to fix duplicate ARIA IDs](https://dequeuniversity.com/rules/axe/4.8/duplicate-id-aria)."},Gv=w("core/audits/accessibility/duplicate-id-aria.js",wl),Vv=class extends N{static{s(this,"DuplicateIdAria")}static get meta(){return{id:"duplicate-id-aria",title:Gv(wl.title),failureTitle:Gv(wl.failureTitle),description:Gv(wl.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},ate=Vv});var $L={};T($L,{UIStrings:()=>Dl,default:()=>ote});var Dl,Wv,$v,ote,YL=b(()=>{"use strict";d();te();A();Dl={title:"All heading elements contain content.",failureTitle:"Heading elements do not contain content.",description:"A heading with no content or inaccessible text prevent screen reader users from accessing information on the page's structure. [Learn more about headings](https://dequeuniversity.com/rules/axe/4.8/empty-heading)."},Wv=w("core/audits/accessibility/empty-heading.js",Dl),$v=class extends N{static{s(this,"EmptyHeading")}static get meta(){return{id:"empty-heading",title:Wv(Dl.title),failureTitle:Wv(Dl.failureTitle),description:Wv(Dl.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},ote=$v});var KL={};T(KL,{UIStrings:()=>El,default:()=>ite});var El,Yv,Kv,ite,XL=b(()=>{"use strict";d();te();A();El={title:"No form fields have multiple labels",failureTitle:"Form fields have multiple labels",description:"Form fields with multiple labels can be confusingly announced by assistive technologies like screen readers which use either the first, the last, or all of the labels. [Learn how to use form labels](https://dequeuniversity.com/rules/axe/4.8/form-field-multiple-labels)."},Yv=w("core/audits/accessibility/form-field-multiple-labels.js",El),Kv=class extends N{static{s(this,"FormFieldMultipleLabels")}static get meta(){return{id:"form-field-multiple-labels",title:Yv(El.title),failureTitle:Yv(El.failureTitle),description:Yv(El.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},ite=Kv});var JL={};T(JL,{UIStrings:()=>xl,default:()=>ste});var xl,Xv,Jv,ste,ZL=b(()=>{"use strict";d();te();A();xl={title:"`<frame>` or `<iframe>` elements have a title",failureTitle:"`<frame>` or `<iframe>` elements do not have a title",description:"Screen reader users rely on frame titles to describe the contents of frames. [Learn more about frame titles](https://dequeuniversity.com/rules/axe/4.8/frame-title)."},Xv=w("core/audits/accessibility/frame-title.js",xl),Jv=class extends N{static{s(this,"FrameTitle")}static get meta(){return{id:"frame-title",title:Xv(xl.title),failureTitle:Xv(xl.failureTitle),description:Xv(xl.description),requiredArtifacts:["Accessibility"]}}},ste=Jv});var QL={};T(QL,{UIStrings:()=>Tl,default:()=>cte});var Tl,Zv,Qv,cte,e8=b(()=>{"use strict";d();te();A();Tl={title:"Heading elements appear in a sequentially-descending order",failureTitle:"Heading elements are not in a sequentially-descending order",description:"Properly ordered headings that do not skip levels convey the semantic structure of the page, making it easier to navigate and understand when using assistive technologies. [Learn more about heading order](https://dequeuniversity.com/rules/axe/4.8/heading-order)."},Zv=w("core/audits/accessibility/heading-order.js",Tl),Qv=class extends N{static{s(this,"HeadingOrder")}static get meta(){return{id:"heading-order",title:Zv(Tl.title),failureTitle:Zv(Tl.failureTitle),description:Zv(Tl.description),requiredArtifacts:["Accessibility"]}}},cte=Qv});var t8={};T(t8,{UIStrings:()=>Sl,default:()=>ute});var Sl,e0,t0,ute,n8=b(()=>{"use strict";d();te();A();Sl={title:"`<html>` element has a `[lang]` attribute",failureTitle:"`<html>` element does not have a `[lang]` attribute",description:"If a page doesn't specify a `lang` attribute, a screen reader assumes that the page is in the default language that the user chose when setting up the screen reader. If the page isn't actually in the default language, then the screen reader might not announce the page's text correctly. [Learn more about the `lang` attribute](https://dequeuniversity.com/rules/axe/4.8/html-has-lang)."},e0=w("core/audits/accessibility/html-has-lang.js",Sl),t0=class extends N{static{s(this,"HTMLHasLang")}static get meta(){return{id:"html-has-lang",title:e0(Sl.title),failureTitle:e0(Sl.failureTitle),description:e0(Sl.description),requiredArtifacts:["Accessibility"]}}},ute=t0});var r8={};T(r8,{UIStrings:()=>kl,default:()=>lte});var kl,n0,r0,lte,a8=b(()=>{"use strict";d();te();A();kl={title:"`<html>` element has a valid value for its `[lang]` attribute",failureTitle:"`<html>` element does not have a valid value for its `[lang]` attribute.",description:"Specifying a valid [BCP 47 language](https://www.w3.org/International/questions/qa-choosing-language-tags#question) helps screen readers announce text properly. [Learn how to use the `lang` attribute](https://dequeuniversity.com/rules/axe/4.8/html-lang-valid)."},n0=w("core/audits/accessibility/html-lang-valid.js",kl),r0=class extends N{static{s(this,"HTMLLangValid")}static get meta(){return{id:"html-lang-valid",title:n0(kl.title),failureTitle:n0(kl.failureTitle),description:n0(kl.description),requiredArtifacts:["Accessibility"]}}},lte=r0});var o8={};T(o8,{UIStrings:()=>Cl,default:()=>dte});var Cl,a0,o0,dte,i8=b(()=>{"use strict";d();te();A();Cl={title:"`<html>` element has an `[xml:lang]` attribute with the same base language as the `[lang]` attribute.",failureTitle:"`<html>` element does not have an `[xml:lang]` attribute with the same base language as the `[lang]` attribute.",description:"If the webpage does not specify a consistent language, then the screen reader might not announce the page's text correctly. [Learn more about the `lang` attribute](https://dequeuniversity.com/rules/axe/4.8/html-xml-lang-mismatch)."},a0=w("core/audits/accessibility/html-xml-lang-mismatch.js",Cl),o0=class extends N{static{s(this,"HTMLXMLLangMismatch")}static get meta(){return{id:"html-xml-lang-mismatch",title:a0(Cl.title),failureTitle:a0(Cl.failureTitle),description:a0(Cl.description),requiredArtifacts:["Accessibility"]}}},dte=o0});var s8={};T(s8,{UIStrings:()=>Al,default:()=>mte});var Al,i0,s0,mte,c8=b(()=>{"use strict";d();te();A();Al={title:"Identical links have the same purpose.",failureTitle:"Identical links do not have the same purpose.",description:"Links with the same destination should have the same description, to help users understand the link's purpose and decide whether to follow it. [Learn more about identical links](https://dequeuniversity.com/rules/axe/4.8/identical-links-same-purpose)."},i0=w("core/audits/accessibility/identical-links-same-purpose.js",Al),s0=class extends N{static{s(this,"IdenticalLinksSamePurpose")}static get meta(){return{id:"identical-links-same-purpose",title:i0(Al.title),failureTitle:i0(Al.failureTitle),description:i0(Al.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},mte=s0});var u8={};T(u8,{UIStrings:()=>_l,default:()=>pte});var _l,c0,u0,pte,l8=b(()=>{"use strict";d();te();A();_l={title:"Image elements have `[alt]` attributes",failureTitle:"Image elements do not have `[alt]` attributes",description:"Informative elements should aim for short, descriptive alternate text. Decorative elements can be ignored with an empty alt attribute. [Learn more about the `alt` attribute](https://dequeuniversity.com/rules/axe/4.8/image-alt)."},c0=w("core/audits/accessibility/image-alt.js",_l),u0=class extends N{static{s(this,"ImageAlt")}static get meta(){return{id:"image-alt",title:c0(_l.title),failureTitle:c0(_l.failureTitle),description:c0(_l.description),requiredArtifacts:["Accessibility"]}}},pte=u0});var d8={};T(d8,{UIStrings:()=>Rl,default:()=>fte});var Rl,l0,d0,fte,m8=b(()=>{"use strict";d();te();A();Rl={title:"Image elements do not have `[alt]` attributes that are redundant text.",failureTitle:"Image elements have `[alt]` attributes that are redundant text.",description:"Informative elements should aim for short, descriptive alternative text. Alternative text that is exactly the same as the text adjacent to the link or image is potentially confusing for screen reader users, because the text will be read twice. [Learn more about the `alt` attribute](https://dequeuniversity.com/rules/axe/4.8/image-redundant-alt)."},l0=w("core/audits/accessibility/image-redundant-alt.js",Rl),d0=class extends N{static{s(this,"ImageRedundantAlt")}static get meta(){return{id:"image-redundant-alt",title:l0(Rl.title),failureTitle:l0(Rl.failureTitle),description:l0(Rl.description),requiredArtifacts:["Accessibility"]}}},fte=d0});var p8={};T(p8,{UIStrings:()=>Fl,default:()=>hte});var Fl,m0,p0,hte,f8=b(()=>{"use strict";d();te();A();Fl={title:"Input buttons have discernible text.",failureTitle:"Input buttons do not have discernible text.",description:"Adding discernable and accessible text to input buttons may help screen reader users understand the purpose of the input button. [Learn more about input buttons](https://dequeuniversity.com/rules/axe/4.8/input-button-name)."},m0=w("core/audits/accessibility/input-button-name.js",Fl),p0=class extends N{static{s(this,"InputButtonName")}static get meta(){return{id:"input-button-name",title:m0(Fl.title),failureTitle:m0(Fl.failureTitle),description:m0(Fl.description),requiredArtifacts:["Accessibility"]}}},hte=p0});var h8={};T(h8,{UIStrings:()=>Il,default:()=>gte});var Il,f0,h0,gte,g8=b(()=>{"use strict";d();te();A();Il={title:'`<input type="image">` elements have `[alt]` text',failureTitle:'`<input type="image">` elements do not have `[alt]` text',description:"When an image is being used as an `<input>` button, providing alternative text can help screen reader users understand the purpose of the button. [Learn about input image alt text](https://dequeuniversity.com/rules/axe/4.8/input-image-alt)."},f0=w("core/audits/accessibility/input-image-alt.js",Il),h0=class extends N{static{s(this,"InputImageAlt")}static get meta(){return{id:"input-image-alt",title:f0(Il.title),failureTitle:f0(Il.failureTitle),description:f0(Il.description),requiredArtifacts:["Accessibility"]}}},gte=h0});var y8={};T(y8,{UIStrings:()=>Nl,default:()=>yte});var Nl,g0,y0,yte,b8=b(()=>{"use strict";d();te();A();Nl={title:"Elements with visible text labels have matching accessible names.",failureTitle:"Elements with visible text labels do not have matching accessible names.",description:"Visible text labels that do not match the accessible name can result in a confusing experience for screen reader users. [Learn more about accessible names](https://dequeuniversity.com/rules/axe/4.8/label-content-name-mismatch)."},g0=w("core/audits/accessibility/label-content-name-mismatch.js",Nl),y0=class extends N{static{s(this,"LabelContentNameMismatch")}static get meta(){return{id:"label-content-name-mismatch",title:g0(Nl.title),failureTitle:g0(Nl.failureTitle),description:g0(Nl.description),requiredArtifacts:["Accessibility"]}}},yte=y0});var v8={};T(v8,{UIStrings:()=>Ml,default:()=>bte});var Ml,b0,v0,bte,w8=b(()=>{"use strict";d();te();A();Ml={title:"Form elements have associated labels",failureTitle:"Form elements do not have associated labels",description:"Labels ensure that form controls are announced properly by assistive technologies, like screen readers. [Learn more about form element labels](https://dequeuniversity.com/rules/axe/4.8/label)."},b0=w("core/audits/accessibility/label.js",Ml),v0=class extends N{static{s(this,"Label")}static get meta(){return{id:"label",title:b0(Ml.title),failureTitle:b0(Ml.failureTitle),description:b0(Ml.description),requiredArtifacts:["Accessibility"]}}},bte=v0});var D8={};T(D8,{UIStrings:()=>Ll,default:()=>vte});var Ll,w0,D0,vte,E8=b(()=>{"use strict";d();te();A();Ll={title:"Document has a main landmark.",failureTitle:"Document does not have a main landmark.",description:"One main landmark helps screen reader users navigate a web page. [Learn more about landmarks](https://dequeuniversity.com/rules/axe/4.8/landmark-one-main)."},w0=w("core/audits/accessibility/landmark-one-main.js",Ll),D0=class extends N{static{s(this,"LandmarkOneMain")}static get meta(){return{id:"landmark-one-main",title:w0(Ll.title),failureTitle:w0(Ll.failureTitle),description:w0(Ll.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},vte=D0});var x8={};T(x8,{UIStrings:()=>Pl,default:()=>wte});var Pl,E0,x0,wte,T8=b(()=>{"use strict";d();te();A();Pl={title:"Links are distinguishable without relying on color.",failureTitle:"Links rely on color to be distinguishable.",description:"Low-contrast text is difficult or impossible for many users to read. Link text that is discernible improves the experience for users with low vision. [Learn how to make links distinguishable](https://dequeuniversity.com/rules/axe/4.8/link-in-text-block)."},E0=w("core/audits/accessibility/link-in-text-block.js",Pl),x0=class extends N{static{s(this,"LinkInTextBlock")}static get meta(){return{id:"link-in-text-block",title:E0(Pl.title),failureTitle:E0(Pl.failureTitle),description:E0(Pl.description),requiredArtifacts:["Accessibility"]}}},wte=x0});var S8={};T(S8,{UIStrings:()=>Ol,default:()=>Dte});var Ol,T0,S0,Dte,k8=b(()=>{"use strict";d();te();A();Ol={title:"Links have a discernible name",failureTitle:"Links do not have a discernible name",description:"Link text (and alternate text for images, when used as links) that is discernible, unique, and focusable improves the navigation experience for screen reader users. [Learn how to make links accessible](https://dequeuniversity.com/rules/axe/4.8/link-name)."},T0=w("core/audits/accessibility/link-name.js",Ol),S0=class extends N{static{s(this,"LinkName")}static get meta(){return{id:"link-name",title:T0(Ol.title),failureTitle:T0(Ol.failureTitle),description:T0(Ol.description),requiredArtifacts:["Accessibility"]}}},Dte=S0});var C8={};T(C8,{UIStrings:()=>Bl,default:()=>Ete});var Bl,k0,C0,Ete,A8=b(()=>{"use strict";d();te();A();Bl={title:"Lists contain only `<li>` elements and script supporting elements (`<script>` and `<template>`).",failureTitle:"Lists do not contain only `<li>` elements and script supporting elements (`<script>` and `<template>`).",description:"Screen readers have a specific way of announcing lists. Ensuring proper list structure aids screen reader output. [Learn more about proper list structure](https://dequeuniversity.com/rules/axe/4.8/list)."},k0=w("core/audits/accessibility/list.js",Bl),C0=class extends N{static{s(this,"List")}static get meta(){return{id:"list",title:k0(Bl.title),failureTitle:k0(Bl.failureTitle),description:k0(Bl.description),requiredArtifacts:["Accessibility"]}}},Ete=C0});var _8={};T(_8,{UIStrings:()=>Ul,default:()=>xte});var Ul,A0,_0,xte,R8=b(()=>{"use strict";d();te();A();Ul={title:"List items (`<li>`) are contained within `<ul>`, `<ol>` or `<menu>` parent elements",failureTitle:"List items (`<li>`) are not contained within `<ul>`, `<ol>` or `<menu>` parent elements.",description:"Screen readers require list items (`<li>`) to be contained within a parent `<ul>`, `<ol>` or `<menu>` to be announced properly. [Learn more about proper list structure](https://dequeuniversity.com/rules/axe/4.8/listitem)."},A0=w("core/audits/accessibility/listitem.js",Ul),_0=class extends N{static{s(this,"ListItem")}static get meta(){return{id:"listitem",title:A0(Ul.title),failureTitle:A0(Ul.failureTitle),description:A0(Ul.description),requiredArtifacts:["Accessibility"]}}},xte=_0});var R0,ot,yn=b(()=>{"use strict";d();V();R0=class extends g{static{s(this,"ManualAudit")}static get partialMeta(){return{scoreDisplayMode:g.SCORING_MODES.MANUAL,requiredArtifacts:[]}}static audit(){return{score:0}}},ot=R0});var F8={};T(F8,{default:()=>Tte});var F0,Tte,I8=b(()=>{"use strict";d();yn();F0=class extends ot{static{s(this,"CustomControlsLabels")}static get meta(){return Object.assign({id:"custom-controls-labels",description:"Custom interactive controls have associated labels, provided by aria-label or aria-labelledby. [Learn more about custom controls and labels](https://developer.chrome.com/docs/lighthouse/accessibility/custom-controls-labels/).",title:"Custom controls have associated labels"},super.partialMeta)}},Tte=F0});var N8={};T(N8,{default:()=>Ste});var I0,Ste,M8=b(()=>{"use strict";d();yn();I0=class extends ot{static{s(this,"CustomControlsRoles")}static get meta(){return Object.assign({id:"custom-controls-roles",description:"Custom interactive controls have appropriate ARIA roles. [Learn how to add roles to custom controls](https://developer.chrome.com/docs/lighthouse/accessibility/custom-control-roles/).",title:"Custom controls have ARIA roles"},super.partialMeta)}},Ste=I0});var L8={};T(L8,{default:()=>kte});var N0,kte,P8=b(()=>{"use strict";d();yn();N0=class extends ot{static{s(this,"FocusTraps")}static get meta(){return Object.assign({id:"focus-traps",description:"A user can tab into and out of any control or region without accidentally trapping their focus. [Learn how to avoid focus traps](https://developer.chrome.com/docs/lighthouse/accessibility/focus-traps/).",title:"User focus is not accidentally trapped in a region"},super.partialMeta)}},kte=N0});var O8={};T(O8,{default:()=>Cte});var M0,Cte,B8=b(()=>{"use strict";d();yn();M0=class extends ot{static{s(this,"FocusableControls")}static get meta(){return Object.assign({id:"focusable-controls",description:"Custom interactive controls are keyboard focusable and display a focus indicator. [Learn how to make custom controls focusable](https://developer.chrome.com/docs/lighthouse/accessibility/focusable-controls/).",title:"Interactive controls are keyboard focusable"},super.partialMeta)}},Cte=M0});var U8={};T(U8,{default:()=>Ate});var L0,Ate,j8=b(()=>{"use strict";d();yn();L0=class extends ot{static{s(this,"InteractiveElementAffordance")}static get meta(){return Object.assign({id:"interactive-element-affordance",description:"Interactive elements, such as links and buttons, should indicate their state and be distinguishable from non-interactive elements. [Learn how to decorate interactive elements with affordance hints](https://developer.chrome.com/docs/lighthouse/accessibility/interactive-element-affordance/).",title:"Interactive elements indicate their purpose and state"},super.partialMeta)}},Ate=L0});var q8={};T(q8,{default:()=>_te});var P0,_te,z8=b(()=>{"use strict";d();yn();P0=class extends ot{static{s(this,"LogicalTabOrder")}static get meta(){return Object.assign({id:"logical-tab-order",description:"Tabbing through the page follows the visual layout. Users cannot focus elements that are offscreen. [Learn more about logical tab ordering](https://developer.chrome.com/docs/lighthouse/accessibility/logical-tab-order/).",title:"The page has a logical tab order"},super.partialMeta)}},_te=P0});var H8={};T(H8,{default:()=>Rte});var O0,Rte,G8=b(()=>{"use strict";d();yn();O0=class extends ot{static{s(this,"ManagedFocus")}static get meta(){return Object.assign({id:"managed-focus",description:"If new content, such as a dialog, is added to the page, the user's focus is directed to it. [Learn how to direct focus to new content](https://developer.chrome.com/docs/lighthouse/accessibility/managed-focus/).",title:"The user's focus is directed to new content added to the page"},super.partialMeta)}},Rte=O0});var V8={};T(V8,{default:()=>Fte});var B0,Fte,W8=b(()=>{"use strict";d();yn();B0=class extends ot{static{s(this,"OffscreenContentHidden")}static get meta(){return Object.assign({id:"offscreen-content-hidden",description:"Offscreen content is hidden with display: none or aria-hidden=true. [Learn how to properly hide offscreen content](https://developer.chrome.com/docs/lighthouse/accessibility/offscreen-content-hidden/).",title:"Offscreen content is hidden from assistive technology"},super.partialMeta)}},Fte=B0});var $8={};T($8,{default:()=>Ite});var U0,Ite,Y8=b(()=>{"use strict";d();yn();U0=class extends ot{static{s(this,"UseLandmarks")}static get meta(){return Object.assign({id:"use-landmarks",description:"Landmark elements (`<main>`, `<nav>`, etc.) are used to improve the keyboard navigation of the page for assistive technology. [Learn more about landmark elements](https://developer.chrome.com/docs/lighthouse/accessibility/use-landmarks/).",title:"HTML5 landmark elements are used to improve navigation"},super.partialMeta)}},Ite=U0});var K8={};T(K8,{default:()=>Nte});var j0,Nte,X8=b(()=>{"use strict";d();yn();j0=class extends ot{static{s(this,"VisualOrderFollowsDOM")}static get meta(){return Object.assign({id:"visual-order-follows-dom",description:"DOM order matches the visual order, improving navigation for assistive technology. [Learn more about DOM and visual ordering](https://developer.chrome.com/docs/lighthouse/accessibility/visual-order-follows-dom/).",title:"Visual order on the page follows DOM order"},super.partialMeta)}},Nte=j0});var J8={};T(J8,{UIStrings:()=>jl,default:()=>Mte});var jl,q0,z0,Mte,Z8=b(()=>{"use strict";d();te();A();jl={title:'The document does not use `<meta http-equiv="refresh">`',failureTitle:'The document uses `<meta http-equiv="refresh">`',description:"Users do not expect a page to refresh automatically, and doing so will move focus back to the top of the page. This may create a frustrating or confusing experience. [Learn more about the refresh meta tag](https://dequeuniversity.com/rules/axe/4.8/meta-refresh)."},q0=w("core/audits/accessibility/meta-refresh.js",jl),z0=class extends N{static{s(this,"MetaRefresh")}static get meta(){return{id:"meta-refresh",title:q0(jl.title),failureTitle:q0(jl.failureTitle),description:q0(jl.description),requiredArtifacts:["Accessibility"]}}},Mte=z0});var Q8={};T(Q8,{UIStrings:()=>ql,default:()=>Lte});var ql,H0,G0,Lte,eP=b(()=>{"use strict";d();te();A();ql={title:'`[user-scalable="no"]` is not used in the `<meta name="viewport">` element and the `[maximum-scale]` attribute is not less than 5.',failureTitle:'`[user-scalable="no"]` is used in the `<meta name="viewport">` element or the `[maximum-scale]` attribute is less than 5.',description:"Disabling zooming is problematic for users with low vision who rely on screen magnification to properly see the contents of a web page. [Learn more about the viewport meta tag](https://dequeuniversity.com/rules/axe/4.8/meta-viewport)."},H0=w("core/audits/accessibility/meta-viewport.js",ql),G0=class extends N{static{s(this,"MetaViewport")}static get meta(){return{id:"meta-viewport",title:H0(ql.title),failureTitle:H0(ql.failureTitle),description:H0(ql.description),requiredArtifacts:["Accessibility"]}}},Lte=G0});var tP={};T(tP,{UIStrings:()=>zl,default:()=>Pte});var zl,V0,W0,Pte,nP=b(()=>{"use strict";d();te();A();zl={title:"`<object>` elements have alternate text",failureTitle:"`<object>` elements do not have alternate text",description:"Screen readers cannot translate non-text content. Adding alternate text to `<object>` elements helps screen readers convey meaning to users. [Learn more about alt text for `object` elements](https://dequeuniversity.com/rules/axe/4.8/object-alt)."},V0=w("core/audits/accessibility/object-alt.js",zl),W0=class extends N{static{s(this,"ObjectAlt")}static get meta(){return{id:"object-alt",title:V0(zl.title),failureTitle:V0(zl.failureTitle),description:V0(zl.description),requiredArtifacts:["Accessibility"]}}},Pte=W0});var rP={};T(rP,{UIStrings:()=>Hl,default:()=>Ote});var Hl,$0,Y0,Ote,aP=b(()=>{"use strict";d();te();A();Hl={title:"Select elements have associated label elements.",failureTitle:"Select elements do not have associated label elements.",description:"Form elements without effective labels can create frustrating experiences for screen reader users. [Learn more about the `select` element](https://dequeuniversity.com/rules/axe/4.8/select-name)."},$0=w("core/audits/accessibility/select-name.js",Hl),Y0=class extends N{static{s(this,"SelectName")}static get meta(){return{id:"select-name",title:$0(Hl.title),failureTitle:$0(Hl.failureTitle),description:$0(Hl.description),requiredArtifacts:["Accessibility"]}}},Ote=Y0});var oP={};T(oP,{UIStrings:()=>Gl,default:()=>Bte});var Gl,K0,X0,Bte,iP=b(()=>{"use strict";d();te();A();Gl={title:"Skip links are focusable.",failureTitle:"Skip links are not focusable.",description:"Including a skip link can help users skip to the main content to save time. [Learn more about skip links](https://dequeuniversity.com/rules/axe/4.8/skip-link)."},K0=w("core/audits/accessibility/skip-link.js",Gl),X0=class extends N{static{s(this,"SkipLink")}static get meta(){return{id:"skip-link",title:K0(Gl.title),failureTitle:K0(Gl.failureTitle),description:K0(Gl.description),requiredArtifacts:["Accessibility"]}}},Bte=X0});var sP={};T(sP,{UIStrings:()=>Vl,default:()=>Ute});var Vl,J0,Z0,Ute,cP=b(()=>{"use strict";d();te();A();Vl={title:"No element has a `[tabindex]` value greater than 0",failureTitle:"Some elements have a `[tabindex]` value greater than 0",description:"A value greater than 0 implies an explicit navigation ordering. Although technically valid, this often creates frustrating experiences for users who rely on assistive technologies. [Learn more about the `tabindex` attribute](https://dequeuniversity.com/rules/axe/4.8/tabindex)."},J0=w("core/audits/accessibility/tabindex.js",Vl),Z0=class extends N{static{s(this,"TabIndex")}static get meta(){return{id:"tabindex",title:J0(Vl.title),failureTitle:J0(Vl.failureTitle),description:J0(Vl.description),requiredArtifacts:["Accessibility"]}}},Ute=Z0});var uP={};T(uP,{UIStrings:()=>Wl,default:()=>jte});var Wl,Q0,ew,jte,lP=b(()=>{"use strict";d();te();A();Wl={title:"Tables have different content in the summary attribute and `<caption>`.",failureTitle:"Tables have the same content in the summary attribute and `<caption>.`",description:"The summary attribute should describe the table structure, while `<caption>` should have the onscreen title. Accurate table mark-up helps users of screen readers. [Learn more about summary and caption](https://dequeuniversity.com/rules/axe/4.8/table-duplicate-name)."},Q0=w("core/audits/accessibility/table-duplicate-name.js",Wl),ew=class extends N{static{s(this,"TableDuplicateName")}static get meta(){return{id:"table-duplicate-name",title:Q0(Wl.title),failureTitle:Q0(Wl.failureTitle),description:Q0(Wl.description),requiredArtifacts:["Accessibility"]}}},jte=ew});var dP={};T(dP,{UIStrings:()=>$l,default:()=>qte});var $l,tw,nw,qte,mP=b(()=>{"use strict";d();te();A();$l={title:"Tables use `<caption>` instead of cells with the `[colspan]` attribute to indicate a caption.",failureTitle:"Tables do not use `<caption>` instead of cells with the `[colspan]` attribute to indicate a caption.",description:"Screen readers have features to make navigating tables easier. Ensuring that tables use the actual caption element instead of cells with the `[colspan]` attribute may improve the experience for screen reader users. [Learn more about captions](https://dequeuniversity.com/rules/axe/4.8/table-fake-caption)."},tw=w("core/audits/accessibility/table-fake-caption.js",$l),nw=class extends N{static{s(this,"TableFakeCaption")}static get meta(){return{id:"table-fake-caption",title:tw($l.title),failureTitle:tw($l.failureTitle),description:tw($l.description),requiredArtifacts:["Accessibility"]}}},qte=nw});var pP={};T(pP,{UIStrings:()=>Yl,default:()=>zte});var Yl,rw,aw,zte,fP=b(()=>{"use strict";d();te();A();Yl={title:"Touch targets have sufficient size and spacing.",failureTitle:"Touch targets do not have sufficient size or spacing.",description:"Touch targets with sufficient size and spacing help users who may have difficulty targeting small controls to activate the targets. [Learn more about touch targets](https://dequeuniversity.com/rules/axe/4.8/target-size)."},rw=w("core/audits/accessibility/target-size.js",Yl),aw=class extends N{static{s(this,"TargetSize")}static get meta(){return{id:"target-size",title:rw(Yl.title),failureTitle:rw(Yl.failureTitle),description:rw(Yl.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},zte=aw});var hP={};T(hP,{UIStrings:()=>Kl,default:()=>Hte});var Kl,ow,iw,Hte,gP=b(()=>{"use strict";d();te();A();Kl={title:"`<td>` elements in a large `<table>` have one or more table headers.",failureTitle:"`<td>` elements in a large `<table>` do not have table headers.",description:"Screen readers have features to make navigating tables easier. Ensuring that `<td>` elements in a large table (3 or more cells in width and height) have an associated table header may improve the experience for screen reader users. [Learn more about table headers](https://dequeuniversity.com/rules/axe/4.8/td-has-header)."},ow=w("core/audits/accessibility/td-has-header.js",Kl),iw=class extends N{static{s(this,"TDHasHeader")}static get meta(){return{id:"td-has-header",title:ow(Kl.title),failureTitle:ow(Kl.failureTitle),description:ow(Kl.description),requiredArtifacts:["Accessibility"]}}},Hte=iw});var yP={};T(yP,{UIStrings:()=>Xl,default:()=>Gte});var Xl,sw,cw,Gte,bP=b(()=>{"use strict";d();te();A();Xl={title:"Cells in a `<table>` element that use the `[headers]` attribute refer to table cells within the same table.",failureTitle:"Cells in a `<table>` element that use the `[headers]` attribute refer to an element `id` not found within the same table.",description:"Screen readers have features to make navigating tables easier. Ensuring `<td>` cells using the `[headers]` attribute only refer to other cells in the same table may improve the experience for screen reader users. [Learn more about the `headers` attribute](https://dequeuniversity.com/rules/axe/4.8/td-headers-attr)."},sw=w("core/audits/accessibility/td-headers-attr.js",Xl),cw=class extends N{static{s(this,"TDHeadersAttr")}static get meta(){return{id:"td-headers-attr",title:sw(Xl.title),failureTitle:sw(Xl.failureTitle),description:sw(Xl.description),requiredArtifacts:["Accessibility"]}}},Gte=cw});var vP={};T(vP,{UIStrings:()=>Jl,default:()=>Vte});var Jl,uw,lw,Vte,wP=b(()=>{"use strict";d();te();A();Jl={title:'`<th>` elements and elements with `[role="columnheader"/"rowheader"]` have data cells they describe.',failureTitle:'`<th>` elements and elements with `[role="columnheader"/"rowheader"]` do not have data cells they describe.',description:"Screen readers have features to make navigating tables easier. Ensuring table headers always refer to some set of cells may improve the experience for screen reader users. [Learn more about table headers](https://dequeuniversity.com/rules/axe/4.8/th-has-data-cells)."},uw=w("core/audits/accessibility/th-has-data-cells.js",Jl),lw=class extends N{static{s(this,"THHasDataCells")}static get meta(){return{id:"th-has-data-cells",title:uw(Jl.title),failureTitle:uw(Jl.failureTitle),description:uw(Jl.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},Vte=lw});var DP={};T(DP,{UIStrings:()=>Zl,default:()=>Wte});var Zl,dw,mw,Wte,EP=b(()=>{"use strict";d();te();A();Zl={title:"`[lang]` attributes have a valid value",failureTitle:"`[lang]` attributes do not have a valid value",description:"Specifying a valid [BCP 47 language](https://www.w3.org/International/questions/qa-choosing-language-tags#question) on elements helps ensure that text is pronounced correctly by a screen reader. [Learn how to use the `lang` attribute](https://dequeuniversity.com/rules/axe/4.8/valid-lang)."},dw=w("core/audits/accessibility/valid-lang.js",Zl),mw=class extends N{static{s(this,"ValidLang")}static get meta(){return{id:"valid-lang",title:dw(Zl.title),failureTitle:dw(Zl.failureTitle),description:dw(Zl.description),requiredArtifacts:["Accessibility"]}}},Wte=mw});var xP={};T(xP,{UIStrings:()=>Ql,default:()=>$te});var Ql,pw,fw,$te,TP=b(()=>{"use strict";d();te();A();Ql={title:'`<video>` elements contain a `<track>` element with `[kind="captions"]`',failureTitle:'`<video>` elements do not contain a `<track>` element with `[kind="captions"]`.',description:"When a video provides a caption it is easier for deaf and hearing impaired users to access its information. [Learn more about video captions](https://dequeuniversity.com/rules/axe/4.8/video-caption)."},pw=w("core/audits/accessibility/video-caption.js",Ql),fw=class extends N{static{s(this,"VideoCaption")}static get meta(){return{id:"video-caption",title:pw(Ql.title),failureTitle:pw(Ql.failureTitle),description:pw(Ql.description),scoreDisplayMode:N.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},$te=fw});var kP={};T(kP,{UIStrings:()=>sn,default:()=>Xte});var sn,bn,Yte,Kte,SP,hw,Xte,CP=b(()=>{"use strict";d();Ae();V();A();sn={title:"`<input>` elements correctly use `autocomplete`",failureTitle:"`<input>` elements do not have correct `autocomplete` attributes",description:"`autocomplete` helps users submit forms quicker. To reduce user effort, consider enabling by setting the `autocomplete` attribute to a valid value. [Learn more about `autocomplete` in forms](https://developers.google.com/web/fundamentals/design-and-ux/input/forms#use_metadata_to_enable_auto-complete)",columnSuggestions:"Suggested Token",columnCurrent:"Current Value",warningInvalid:'`autocomplete` token(s): "{token}" is invalid in {snippet}',warningOrder:'Review order of tokens: "{tokens}" in {snippet}',reviewOrder:"Review order of tokens",manualReview:"Requires manual review"},bn=w("core/audits/autocomplete.js",sn),Yte=["name","honorific-prefix","given-name","additional-name","family-name","honorific-suffix","nickname","username","new-password","current-password","one-time-code","organization-title","organization","street-address","address-line1","address-line2","address-line3","address-level4","address-level3","address-level2","address-level1","country","country-name","postal-code","cc-name","cc-given-name","cc-additional-name","cc-family-name","cc-number","cc-exp","cc-exp-month","cc-exp-year","cc-csc","cc-type","transaction-currency","transaction-amount","language","bday","bday-day","bday-month","bday-year","sex","url","photo","tel","tel-country-code","tel-national","tel-area-code","on","tel-local","tel-local-prefix","tel-local-suffix","tel-extension","email","impp","off","additional-name-initial","home","work","mobile","fax","pager","shipping","billing"],Kte=["NO_SERVER_DATA","UNKNOWN_TYPE","EMPTY_TYPE","HTML_TYPE_UNSPECIFIED","HTML_TYPE_UNRECOGNIZED"],SP={NO_SERVER_DATA:bn(sn.manualReview),UNKNOWN_TYPE:bn(sn.manualReview),EMPTY_TYPE:bn(sn.manualReview),NAME_FIRST:"given-name",NAME_MIDDLE:"additional-name",NAME_LAST:"family-name",NAME_FULL:"name",NAME_MIDDLE_INITIAL:"additional-name-initial",NAME_SUFFIX:"honorific-suffix",NAME_BILLING_FIRST:"billing given-name",NAME_BILLING_MIDDLE:"billing additional-name",NAME_BILLING_LAST:"billing family-name",NAME_BILLING_MIDDLE_INITIAL:"billing additional-name-initial",NAME_BILLING_FULL:"billing name",NAME_BILLING_SUFFIX:"billing honorific-suffix",EMAIL_ADDRESS:"email",MERCHANT_EMAIL_SIGNUP:"email",PHONE_HOME_NUMBER:"tel-local",PHONE_HOME_CITY_CODE:"tel-area-code",PHONE_HOME_COUNTRY_CODE:"tel-country-code",PHONE_HOME_CITY_AND_NUMBER:"tel-national",PHONE_HOME_WHOLE_NUMBER:"tel",PHONE_HOME_EXTENSION:"tel-extension",PHONE_BILLING_NUMBER:"billing tel-local",PHONE_BILLING_CITY_CODE:"billing tel-area-code",PHONE_BILLING_COUNTRY_CODE:"tel-country-code",PHONE_BILLING_CITY_AND_NUMBER:"tel-national",PHONE_BILLING_WHOLE_NUMBER:"tel",ADDRESS_HOME_STREET_ADDRESS:"street-address",ADDRESS_HOME_LINE1:"address-line1",ADDRESS_HOME_LINE2:"address-line2",ADDRESS_HOME_LINE3:"address-line3",ADDRESS_HOME_STATE:"address-level1",ADDRESS_HOME_CITY:"address-level2",ADDRESS_HOME_DEPENDENT_LOCALITY:"address-level3",ADDRESS_HOME_ZIP:"postal-code",ADDRESS_HOME_COUNTRY:"country-name",ADDRESS_BILLING_DEPENDENT_LOCALITY:"billing address-level3",ADDRESS_BILLING_STREET_ADDRESS:"billing street-address",ADDRESS_BILLING_LINE1:"billing address-line1",ADDRESS_BILLING_LINE2:"billing address-line2",ADDRESS_BILLING_LINE3:"billing address-line3",ADDRESS_BILLING_APT_NUM:"billing address-level3",ADDRESS_BILLING_CITY:"billing address-level2",ADDRESS_BILLING_STATE:"billing address-level1",ADDRESS_BILLING_ZIP:"billing postal-code",ADDRESS_BILLING_COUNTRY:"billing country-name",CREDIT_CARD_NAME_FULL:"cc-name",CREDIT_CARD_NAME_FIRST:"cc-given-name",CREDIT_CARD_NAME_LAST:"cc-family-name",CREDIT_CARD_NUMBER:"cc-number",CREDIT_CARD_EXP_MONTH:"cc-exp-month",CREDIT_CARD_EXP_2_DIGIT_YEAR:"cc-exp-year",CREDIT_CARD_EXP_4_DIGIT_YEAR:"cc-exp-year",CREDIT_CARD_EXP_DATE_2_DIGIT_YEAR:"cc-exp",CREDIT_CARD_EXP_DATE_4_DIGIT_YEAR:"cc-exp",CREDIT_CARD_TYPE:"cc-type",CREDIT_CARD_VERIFICATION_CODE:"cc-csc",COMPANY_NAME:"organization",PASSWORD:"current-password",ACCOUNT_CREATION_PASSWORD:"new-password",HTML_TYPE_UNSPECIFIED:bn(sn.manualReview),HTML_TYPE_NAME:"name",HTML_TYPE_HONORIFIC_PREFIX:"honorific-prefix",HTML_TYPE_GIVEN_NAME:"given-name",HTML_TYPE_ADDITIONAL_NAME:"additional-name",HTML_TYPE_FAMILY_NAME:"family-name",HTML_TYPE_ORGANIZATION:"organization",HTML_TYPE_STREET_ADDRESS:"street-address",HTML_TYPE_ADDRESS_LINE1:"address-line1",HTML_TYPE_ADDRESS_LINE2:"address-line2",HTML_TYPE_ADDRESS_LINE3:"address-line3",HTML_TYPE_ADDRESS_LEVEL1:"address-level1",HTML_TYPE_ADDRESS_LEVEL2:"address-level2",HTML_TYPE_ADDRESS_LEVEL3:"address-level3",HTML_TYPE_COUNTRY_CODE:"tel-country-code",HTML_TYPE_COUNTRY_NAME:"country-name",HTML_TYPE_POSTAL_CODE:"postal-code",HTML_TYPE_FULL_ADDRESS:"street-address",HTML_TYPE_CREDIT_CARD_NAME_FULL:"cc-name",HTML_TYPE_CREDIT_CARD_NAME_FIRST:"cc-given-name",HTML_TYPE_CREDIT_CARD_NAME_LAST:"cc-family-name",HTML_TYPE_CREDIT_CARD_NUMBER:"cc-number",HTML_TYPE_CREDIT_CARD_EXP:"cc-exp",HTML_TYPE_CREDIT_CARD_EXP_MONTH:"cc-exp-month",HTML_TYPE_CREDIT_CARD_EXP_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_VERIFICATION_CODE:"cc-csc",HTML_TYPE_CREDIT_CARD_TYPE:"cc-csc",HTML_TYPE_TEL:"tel",HTML_TYPE_TEL_COUNTRY_CODE:"tel-country-code",HTML_TYPE_TEL_NATIONAL:"tel-national",HTML_TYPE_TEL_AREA_CODE:"tel-area-code",HTML_TYPE_TEL_LOCAL:"tel-local",HTML_TYPE_TEL_LOCAL_PREFIX:"tel-local-prefix",HTML_TYPE_TEL_LOCAL_SUFFIX:"tel-local-suffix",HTML_TYPE_TEL_EXTENSION:"tel-extension",HTML_TYPE_EMAIL:"email",HTML_TYPE_ADDITIONAL_NAME_INITIAL:"additional-name-initial",HTML_TYPE_CREDIT_CARD_EXP_DATE_2_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_EXP_DATE_4_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_EXP_2_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_EXP_4_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_UPI_VPA:bn(sn.manualReview),HTML_TYPE_ONE_TIME_CODE:"one-time-code",HTML_TYPE_UNRECOGNIZED:bn(sn.manualReview),HTML_TYPE_TRANSACTION_AMOUNT:"transaction-amount",HTML_TYPE_TRANSACTION_CURRENCY:"transaction-currency"},hw=class extends g{static{s(this,"AutocompleteAudit")}static get meta(){return{id:"autocomplete",title:bn(sn.title),failureTitle:bn(sn.failureTitle),description:bn(sn.description),requiredArtifacts:["Inputs"]}}static checkAttributeValidity(t){if(!t.autocomplete.attribute)return{hasValidTokens:!1};let n=t.autocomplete.attribute.split(" ");for(let r of n)if(r.slice(0,8)!=="section-"&&!Yte.includes(r))return{hasValidTokens:!1};return t.autocomplete.property?{hasValidTokens:!0,isValidOrder:!0}:{hasValidTokens:!0,isValidOrder:!1}}static audit(t){let n=[],r=[],a=!1;for(let u of t.Inputs.inputs){let l=this.checkAttributeValidity(u);if(l.hasValidTokens&&l.isValidOrder||!u.autocomplete.prediction||Kte.includes(u.autocomplete.prediction)&&!u.autocomplete.attribute)continue;a=!0;let m=SP[u.autocomplete.prediction];if(u.autocomplete.attribute||(u.autocomplete.attribute=""),u.autocomplete.attribute&&r.push(bn(sn.warningInvalid,{token:u.autocomplete.attribute,snippet:u.node.snippet})),l.isValidOrder===!1&&(r.push(bn(sn.warningOrder,{tokens:u.autocomplete.attribute,snippet:u.node.snippet})),m=sn.reviewOrder),!(u.autocomplete.prediction in SP)&&l.isValidOrder){F.warn(`Autocomplete prediction (${u.autocomplete.prediction})
            not found in our mapping`);continue}n.push({node:g.makeNodeItem(u.node),suggestion:m,current:u.autocomplete.attribute})}let o=[{key:"node",valueType:"node",label:bn(x.columnFailingElem)},{key:"current",valueType:"text",label:bn(sn.columnCurrent)},{key:"suggestion",valueType:"text",label:bn(sn.columnSuggestions)}],i=g.makeTableDetails(o,n),c;return n.length>0&&(c=bn(x.displayValueElementsFound,{nodeCount:n.length})),{score:n.length>0?0:1,notApplicable:!a,displayValue:c,details:i,warnings:r}}},Xte=hw});var M,L,AP,_P=b(()=>{"use strict";d();A();M={notMainFrame:"Navigation happened in a frame other than the main frame.",backForwardCacheDisabled:"Back/forward cache is disabled by flags. Visit chrome://flags/#back-forward-cache to enable it locally on this device.",relatedActiveContentsExist:"The page was opened using '`window.open()`' and another tab has a reference to it, or the page opened a window.",HTTPStatusNotOK:"Only pages with a status code of 2XX can be cached.",schemeNotHTTPOrHTTPS:"Only pages whose URL scheme is HTTP / HTTPS can be cached.",loading:"The page did not finish loading before navigating away.",wasGrantedMediaAccess:"Pages that have granted access to record video or audio are not currently eligible for back/forward cache.",HTTPMethodNotGET:"Only pages loaded via a GET request are eligible for back/forward cache.",subframeIsNavigating:"An iframe on the page started a navigation that did not complete.",timeout:"The page exceeded the maximum time in back/forward cache and was expired.",cacheLimit:"The page was evicted from the cache to allow another page to be cached.",JavaScriptExecution:"Chrome detected an attempt to execute JavaScript while in the cache.",rendererProcessKilled:"The renderer process for the page in back/forward cache was killed.",rendererProcessCrashed:"The renderer process for the page in back/forward cache crashed.",grantedMediaStreamAccess:"Pages that have granted media stream access are not currently eligible for back/forward cache.",cacheFlushed:"The cache was intentionally cleared.",serviceWorkerVersionActivation:"The page was evicted from back/forward cache due to a service worker activation.",sessionRestored:"Chrome restarted and cleared the back/forward cache entries.",serviceWorkerPostMessage:"A service worker attempted to send the page in back/forward cache a `MessageEvent`.",enteredBackForwardCacheBeforeServiceWorkerHostAdded:"A service worker was activated while the page was in back/forward cache.",serviceWorkerClaim:"The page was claimed by a service worker while it is in back/forward cache.",haveInnerContents:"Pages that use portals are not currently eligible for back/forward cache.",timeoutPuttingInCache:"The page timed out entering back/forward cache (likely due to long-running pagehide handlers).",backForwardCacheDisabledByLowMemory:"Back/forward cache is disabled due to insufficient memory.",backForwardCacheDisabledByCommandLine:"Back/forward cache is disabled by the command line.",networkRequestDatapipeDrainedAsBytesConsumer:"Pages that have inflight fetch() or XHR are not currently eligible for back/forward cache.",networkRequestRedirected:"The page was evicted from back/forward cache because an active network request involved a redirect.",networkRequestTimeout:"The page was evicted from the cache because a network connection was open too long. Chrome limits the amount of time that a page may receive data while cached.",networkExceedsBufferLimit:"The page was evicted from the cache because an active network connection received too much data. Chrome limits the amount of data that a page may receive while cached.",navigationCancelledWhileRestoring:"Navigation was cancelled before the page could be restored from back/forward cache.",backForwardCacheDisabledForPrerender:"Back/forward cache is disabled for prerenderer.",userAgentOverrideDiffers:"Browser has changed the user agent override header.",foregroundCacheLimit:"The page was evicted from the cache to allow another page to be cached.",backForwardCacheDisabledForDelegate:"Back/forward cache is not supported by delegate.",unloadHandlerExistsInMainFrame:"The page has an unload handler in the main frame.",unloadHandlerExistsInSubFrame:"The page has an unload handler in a sub frame.",serviceWorkerUnregistration:"ServiceWorker was unregistered while a page was in back/forward cache.",noResponseHead:"Pages that do not have a valid response head cannot enter back/forward cache.",cacheControlNoStore:"Pages with cache-control:no-store header cannot enter back/forward cache.",ineligibleAPI:"Ineligible APIs were used.",internalError:"Internal error.",webSocket:"Pages with WebSocket cannot enter back/forward cache.",webTransport:"Pages with WebTransport cannot enter back/forward cache.",webRTC:"Pages with WebRTC cannot enter back/forward cache.",mainResourceHasCacheControlNoStore:"Pages whose main resource has cache-control:no-store cannot enter back/forward cache.",mainResourceHasCacheControlNoCache:"Pages whose main resource has cache-control:no-cache cannot enter back/forward cache.",subresourceHasCacheControlNoStore:"Pages whose subresource has cache-control:no-store cannot enter back/forward cache.",subresourceHasCacheControlNoCache:"Pages whose subresource has cache-control:no-cache cannot enter back/forward cache.",containsPlugins:"Pages containing plugins are not currently eligible for back/forward cache.",documentLoaded:"The document did not finish loading before navigating away.",dedicatedWorkerOrWorklet:"Pages that use a dedicated worker or worklet are not currently eligible for back/forward cache.",outstandingNetworkRequestOthers:"Pages with an in-flight network request are not currently eligible for back/forward cache.",outstandingIndexedDBTransaction:"Page with ongoing indexed DB transactions are not currently eligible for back/forward cache.",requestedNotificationsPermission:"Pages that have requested notifications permissions are not currently eligible for back/forward cache.",requestedMIDIPermission:"Pages that have requested MIDI permissions are not currently eligible for back/forward cache.",requestedAudioCapturePermission:"Pages that have requested audio capture permissions are not currently eligible for back/forward cache.",requestedVideoCapturePermission:"Pages that have requested video capture permissions are not currently eligible for back/forward cache.",requestedBackForwardCacheBlockedSensors:"Pages that have requested sensor permissions are not currently eligible for back/forward cache.",requestedBackgroundWorkPermission:"Pages that have requested background sync or fetch permissions are not currently eligible for back/forward cache.",broadcastChannel:"The page cannot be cached because it has a BroadcastChannel instance with registered listeners.",indexedDBConnection:"Pages that have an open IndexedDB connection are not currently eligible for back/forward cache.",webXR:"Pages that use WebXR are not currently eligible for back/forward cache.",sharedWorker:"Pages that use SharedWorker are not currently eligible for back/forward cache.",webLocks:"Pages that use WebLocks are not currently eligible for back/forward cache.",webHID:"Pages that use WebHID are not currently eligible for back/forward cache.",webShare:"Pages that use WebShare are not currently eligible for back/forwad cache.",requestedStorageAccessGrant:"Pages that have requested storage access are not currently eligible for back/forward cache.",webNfc:"Pages that use WebNfc are not currently eligible for back/forwad cache.",outstandingNetworkRequestFetch:"Pages with an in-flight fetch network request are not currently eligible for back/forward cache.",outstandingNetworkRequestXHR:"Pages with an in-flight XHR network request are not currently eligible for back/forward cache.",appBanner:"Pages that requested an AppBanner are not currently eligible for back/forward cache.",printing:"Pages that show Printing UI are not currently eligible for back/forward cache.",webDatabase:"Pages that use WebDatabase are not currently eligible for back/forward cache.",pictureInPicture:"Pages that use Picture-in-Picture are not currently eligible for back/forward cache.",portal:"Pages that use portals are not currently eligible for back/forward cache.",speechRecognizer:"Pages that use SpeechRecognizer are not currently eligible for back/forward cache.",idleManager:"Pages that use IdleManager are not currently eligible for back/forward cache.",paymentManager:"Pages that use PaymentManager are not currently eligible for back/forward cache.",speechSynthesis:"Pages that use SpeechSynthesis are not currently eligible for back/forward cache.",keyboardLock:"Pages that use Keyboard lock are not currently eligible for back/forward cache.",webOTPService:"Pages that use WebOTPService are not currently eligible for bfcache.",outstandingNetworkRequestDirectSocket:"Pages with an in-flight network request are not currently eligible for back/forward cache.",injectedJavascript:"Pages that `JavaScript` is injected into by extensions are not currently eligible for back/forward cache.",injectedStyleSheet:"Pages that a `StyleSheet` is injected into by extensions are not currently eligible for back/forward cache.",contentSecurityHandler:"Pages that use SecurityHandler are not eligible for back/forward cache.",contentWebAuthenticationAPI:"Pages that use WebAuthetication API are not eligible for back/forward cache.",contentFileChooser:"Pages that use FileChooser API are not eligible for back/forward cache.",contentSerial:"Pages that use Serial API are not eligible for back/forward cache.",contentFileSystemAccess:"Pages that use File System Access API are not eligible for back/forward cache.",contentMediaDevicesDispatcherHost:"Pages that use Media Device Dispatcher are not eligible for back/forward cache.",contentWebBluetooth:"Pages that use WebBluetooth API are not eligible for back/forward cache.",contentWebUSB:"Pages that use WebUSB API are not eligible for back/forward cache.",contentMediaSession:"Pages that use MediaSession API and set a playback state are not eligible for back/forward cache.",contentMediaSessionService:"Pages that use MediaSession API and set action handlers are not eligible for back/forward cache.",contentMediaPlay:"A media player was playing upon navigating away.",contentScreenReader:"Back/forward cache is disabled due to screen reader.",embedderPopupBlockerTabHelper:"Popup blocker was present upon navigating away.",embedderSafeBrowsingTriggeredPopupBlocker:"Safe Browsing considered this page to be abusive and blocked popup.",embedderSafeBrowsingThreatDetails:"Safe Browsing details were shown upon navigating away.",embedderAppBannerManager:"App Banner was present upon navigating away.",embedderDomDistillerViewerSource:"DOM Distiller Viewer was present upon navigating away.",embedderDomDistillerSelfDeletingRequestDelegate:"DOM distillation was in progress upon navigating away.",embedderOomInterventionTabHelper:"Out-Of-Memory Intervention bar was present upon navigating away.",embedderOfflinePage:"The offline page was shown upon navigating away.",embedderChromePasswordManagerClientBindCredentialManager:"Chrome Password Manager was present upon navigating away.",embedderPermissionRequestManager:"There were permission requests upon navigating away.",embedderModalDialog:"Modal dialog such as form resubmission or http password dialog was shown for the page upon navigating away.",embedderExtensions:"Back/forward cache is disabled due to extensions.",embedderExtensionMessaging:"Back/forward cache is disabled due to extensions using messaging API.",embedderExtensionMessagingForOpenPort:"Extensions with long-lived connection should close the connection before entering back/forward cache.",embedderExtensionSentMessageToCachedFrame:"Extensions with long-lived connection attempted to send messages to frames in back/forward cache.",errorDocument:"Back/forward cache is disabled due to a document error.",fencedFramesEmbedder:"Pages using FencedFrames cannot be stored in bfcache.",keepaliveRequest:"Back/forward cache is disabled due to a keepalive request.",authorizationHeader:"Back/forward cache is disabled due to a keepalive request.",indexedDBEvent:"Back/forward cache is disabled due to an IndexedDB event.",cookieDisabled:"Back/forward cache is disabled because cookies are disabled on a page that uses `Cache-Control: no-store`."},L=w("core/lib/bf-cache-strings.js",M),AP={NotPrimaryMainFrame:{name:L(M.notMainFrame)},BackForwardCacheDisabled:{name:L(M.backForwardCacheDisabled)},RelatedActiveContentsExist:{name:L(M.relatedActiveContentsExist)},HTTPStatusNotOK:{name:L(M.HTTPStatusNotOK)},SchemeNotHTTPOrHTTPS:{name:L(M.schemeNotHTTPOrHTTPS)},Loading:{name:L(M.loading)},WasGrantedMediaAccess:{name:L(M.wasGrantedMediaAccess)},HTTPMethodNotGET:{name:L(M.HTTPMethodNotGET)},SubframeIsNavigating:{name:L(M.subframeIsNavigating)},Timeout:{name:L(M.timeout)},CacheLimit:{name:L(M.cacheLimit)},JavaScriptExecution:{name:L(M.JavaScriptExecution)},RendererProcessKilled:{name:L(M.rendererProcessKilled)},RendererProcessCrashed:{name:L(M.rendererProcessCrashed)},GrantedMediaStreamAccess:{name:L(M.grantedMediaStreamAccess)},CacheFlushed:{name:L(M.cacheFlushed)},ServiceWorkerVersionActivation:{name:L(M.serviceWorkerVersionActivation)},SessionRestored:{name:L(M.sessionRestored)},ServiceWorkerPostMessage:{name:L(M.serviceWorkerPostMessage)},EnteredBackForwardCacheBeforeServiceWorkerHostAdded:{name:L(M.enteredBackForwardCacheBeforeServiceWorkerHostAdded)},ServiceWorkerClaim:{name:L(M.serviceWorkerClaim)},HaveInnerContents:{name:L(M.haveInnerContents)},TimeoutPuttingInCache:{name:L(M.timeoutPuttingInCache)},BackForwardCacheDisabledByLowMemory:{name:L(M.backForwardCacheDisabledByLowMemory)},BackForwardCacheDisabledByCommandLine:{name:L(M.backForwardCacheDisabledByCommandLine)},NetworkRequestDatapipeDrainedAsBytesConsumer:{name:L(M.networkRequestDatapipeDrainedAsBytesConsumer)},NetworkRequestRedirected:{name:L(M.networkRequestRedirected)},NetworkRequestTimeout:{name:L(M.networkRequestTimeout)},NetworkExceedsBufferLimit:{name:L(M.networkExceedsBufferLimit)},NavigationCancelledWhileRestoring:{name:L(M.navigationCancelledWhileRestoring)},BackForwardCacheDisabledForPrerender:{name:L(M.backForwardCacheDisabledForPrerender)},UserAgentOverrideDiffers:{name:L(M.userAgentOverrideDiffers)},ForegroundCacheLimit:{name:L(M.foregroundCacheLimit)},BackForwardCacheDisabledForDelegate:{name:L(M.backForwardCacheDisabledForDelegate)},UnloadHandlerExistsInMainFrame:{name:L(M.unloadHandlerExistsInMainFrame)},UnloadHandlerExistsInSubFrame:{name:L(M.unloadHandlerExistsInSubFrame)},ServiceWorkerUnregistration:{name:L(M.serviceWorkerUnregistration)},NoResponseHead:{name:L(M.noResponseHead)},CacheControlNoStore:{name:L(M.cacheControlNoStore)},CacheControlNoStoreCookieModified:{name:L(M.cacheControlNoStore)},CacheControlNoStoreHTTPOnlyCookieModified:{name:L(M.cacheControlNoStore)},DisableForRenderFrameHostCalled:{name:L(M.ineligibleAPI)},BlocklistedFeatures:{name:L(M.ineligibleAPI)},SchedulerTrackedFeatureUsed:{name:L(M.ineligibleAPI)},DomainNotAllowed:{name:L(M.internalError)},ConflictingBrowsingInstance:{name:L(M.internalError)},NotMostRecentNavigationEntry:{name:L(M.internalError)},IgnoreEventAndEvict:{name:L(M.internalError)},BrowsingInstanceNotSwapped:{name:L(M.internalError)},ActivationNavigationsDisallowedForBug1234857:{name:L(M.internalError)},Unknown:{name:L(M.internalError)},RenderFrameHostReused_SameSite:{name:L(M.internalError)},RenderFrameHostReused_CrossSite:{name:L(M.internalError)},WebSocket:{name:L(M.webSocket)},WebTransport:{name:L(M.webTransport)},WebRTC:{name:L(M.webRTC)},MainResourceHasCacheControlNoStore:{name:L(M.mainResourceHasCacheControlNoStore)},MainResourceHasCacheControlNoCache:{name:L(M.mainResourceHasCacheControlNoCache)},SubresourceHasCacheControlNoStore:{name:L(M.subresourceHasCacheControlNoStore)},SubresourceHasCacheControlNoCache:{name:L(M.subresourceHasCacheControlNoCache)},ContainsPlugins:{name:L(M.containsPlugins)},DocumentLoaded:{name:L(M.documentLoaded)},DedicatedWorkerOrWorklet:{name:L(M.dedicatedWorkerOrWorklet)},OutstandingNetworkRequestOthers:{name:L(M.outstandingNetworkRequestOthers)},OutstandingIndexedDBTransaction:{name:L(M.outstandingIndexedDBTransaction)},RequestedNotificationsPermission:{name:L(M.requestedNotificationsPermission)},RequestedMIDIPermission:{name:L(M.requestedMIDIPermission)},RequestedAudioCapturePermission:{name:L(M.requestedAudioCapturePermission)},RequestedVideoCapturePermission:{name:L(M.requestedVideoCapturePermission)},RequestedBackForwardCacheBlockedSensors:{name:L(M.requestedBackForwardCacheBlockedSensors)},RequestedBackgroundWorkPermission:{name:L(M.requestedBackgroundWorkPermission)},BroadcastChannel:{name:L(M.broadcastChannel)},IndexedDBConnection:{name:L(M.indexedDBConnection)},WebXR:{name:L(M.webXR)},SharedWorker:{name:L(M.sharedWorker)},WebLocks:{name:L(M.webLocks)},WebHID:{name:L(M.webHID)},WebShare:{name:L(M.webShare)},RequestedStorageAccessGrant:{name:L(M.requestedStorageAccessGrant)},WebNfc:{name:L(M.webNfc)},OutstandingNetworkRequestFetch:{name:L(M.outstandingNetworkRequestFetch)},OutstandingNetworkRequestXHR:{name:L(M.outstandingNetworkRequestXHR)},AppBanner:{name:L(M.appBanner)},Printing:{name:L(M.printing)},WebDatabase:{name:L(M.webDatabase)},PictureInPicture:{name:L(M.pictureInPicture)},Portal:{name:L(M.portal)},SpeechRecognizer:{name:L(M.speechRecognizer)},IdleManager:{name:L(M.idleManager)},PaymentManager:{name:L(M.paymentManager)},SpeechSynthesis:{name:L(M.speechSynthesis)},KeyboardLock:{name:L(M.keyboardLock)},WebOTPService:{name:L(M.webOTPService)},OutstandingNetworkRequestDirectSocket:{name:L(M.outstandingNetworkRequestDirectSocket)},InjectedJavascript:{name:L(M.injectedJavascript)},InjectedStyleSheet:{name:L(M.injectedStyleSheet)},Dummy:{name:L(M.internalError)},ContentSecurityHandler:{name:L(M.contentSecurityHandler)},ContentWebAuthenticationAPI:{name:L(M.contentWebAuthenticationAPI)},ContentFileChooser:{name:L(M.contentFileChooser)},ContentSerial:{name:L(M.contentSerial)},ContentFileSystemAccess:{name:L(M.contentFileSystemAccess)},ContentMediaDevicesDispatcherHost:{name:L(M.contentMediaDevicesDispatcherHost)},ContentWebBluetooth:{name:L(M.contentWebBluetooth)},ContentWebUSB:{name:L(M.contentWebUSB)},ContentMediaSession:{name:L(M.contentMediaSession)},ContentMediaSessionService:{name:L(M.contentMediaSessionService)},ContentMediaPlay:{name:L(M.contentMediaPlay)},ContentScreenReader:{name:L(M.contentScreenReader)},EmbedderPopupBlockerTabHelper:{name:L(M.embedderPopupBlockerTabHelper)},EmbedderSafeBrowsingTriggeredPopupBlocker:{name:L(M.embedderSafeBrowsingTriggeredPopupBlocker)},EmbedderSafeBrowsingThreatDetails:{name:L(M.embedderSafeBrowsingThreatDetails)},EmbedderAppBannerManager:{name:L(M.embedderAppBannerManager)},EmbedderDomDistillerViewerSource:{name:L(M.embedderDomDistillerViewerSource)},EmbedderDomDistillerSelfDeletingRequestDelegate:{name:L(M.embedderDomDistillerSelfDeletingRequestDelegate)},EmbedderOomInterventionTabHelper:{name:L(M.embedderOomInterventionTabHelper)},EmbedderOfflinePage:{name:L(M.embedderOfflinePage)},EmbedderChromePasswordManagerClientBindCredentialManager:{name:L(M.embedderChromePasswordManagerClientBindCredentialManager)},EmbedderPermissionRequestManager:{name:L(M.embedderPermissionRequestManager)},EmbedderModalDialog:{name:L(M.embedderModalDialog)},EmbedderExtensions:{name:L(M.embedderExtensions)},EmbedderExtensionMessaging:{name:L(M.embedderExtensionMessaging)},EmbedderExtensionMessagingForOpenPort:{name:L(M.embedderExtensionMessagingForOpenPort)},EmbedderExtensionSentMessageToCachedFrame:{name:L(M.embedderExtensionSentMessageToCachedFrame)},ErrorDocument:{name:L(M.errorDocument)},FencedFramesEmbedder:{name:L(M.fencedFramesEmbedder)},KeepaliveRequest:{name:L(M.keepaliveRequest)},AuthorizationHeader:{name:L(M.authorizationHeader)},IndexedDBEvent:{name:L(M.indexedDBEvent)},CookieDisabled:{name:L(M.cookieDisabled)}}});var RP={};T(RP,{UIStrings:()=>Wn,default:()=>Qte});var Wn,_r,Jte,Zte,gw,Qte,FP=b(()=>{"use strict";d();V();A();_P();Wn={title:"Page didn't prevent back/forward cache restoration",failureTitle:"Page prevented back/forward cache restoration",description:"Many navigations are performed by going back to a previous page, or forwards again. The back/forward cache (bfcache) can speed up these return navigations. [Learn more about the bfcache](https://developer.chrome.com/docs/lighthouse/performance/bf-cache/)",actionableFailureType:"Actionable",notActionableFailureType:"Not actionable",supportPendingFailureType:"Pending browser support",failureReasonColumn:"Failure reason",failureTypeColumn:"Failure type",warningHeadless:'Back/forward cache cannot be tested in old Headless Chrome (`--chrome-flags="--headless=old"`). To see audit results, use the new Headless Chrome (`--chrome-flags="--headless=new"`) or standard Chrome.',displayValue:`{itemCount, plural,
    =1 {1 failure reason}
    other {# failure reasons}
    }`},_r=w("core/audits/bf-cache.js",Wn),Jte=["PageSupportNeeded","SupportPending","Circumstantial"],Zte={PageSupportNeeded:_r(Wn.actionableFailureType),Circumstantial:_r(Wn.notActionableFailureType),SupportPending:_r(Wn.supportPendingFailureType)},gw=class extends g{static{s(this,"BFCache")}static get meta(){return{id:"bf-cache",title:_r(Wn.title),failureTitle:_r(Wn.failureTitle),description:_r(Wn.description),supportedModes:["navigation","timespan"],guidanceLevel:2,requiredArtifacts:["BFCacheFailures","HostProduct"],scoreDisplayMode:g.SCORING_MODES.BINARY}}static async audit(t){if(/HeadlessChrome/.test(t.HostProduct))return{score:null,notApplicable:!0,warnings:[_r(Wn.warningHeadless)]};let n=t.BFCacheFailures;if(!n.length)return{score:1};let{notRestoredReasonsTree:r}=n[0],a=0,o=[];for(let l of Jte){let m=r[l];for(let[p,h]of Object.entries(m))a+=h.length,o.push({reason:AP[p]?.name??p,failureType:Zte[l],subItems:{type:"subitems",items:h.map(f=>({frameUrl:f}))},protocolReason:p})}let i=[{key:"reason",valueType:"text",subItemsHeading:{key:"frameUrl",valueType:"url"},label:_r(Wn.failureReasonColumn)},{key:"failureType",valueType:"text",label:_r(Wn.failureTypeColumn)}],c=g.makeTableDetails(i,o),u=a?_r(Wn.displayValue,{itemCount:a}):void 0;return{score:o.length?0:1,displayValue:u,details:c}}},Qte=gw});var vn,yw,ed=b(()=>{"use strict";d();vn={parseHTML:{id:"parseHTML",label:"Parse HTML & CSS",traceEventNames:["ParseHTML","ParseAuthorStyleSheet"]},styleLayout:{id:"styleLayout",label:"Style & Layout",traceEventNames:["ScheduleStyleRecalculation","UpdateLayoutTree","InvalidateLayout","Layout"]},paintCompositeRender:{id:"paintCompositeRender",label:"Rendering",traceEventNames:["Animation","HitTest","PaintSetup","Paint","PaintImage","RasterTask","ScrollLayer","UpdateLayer","UpdateLayerTree","CompositeLayers","PrePaint"]},scriptParseCompile:{id:"scriptParseCompile",label:"Script Parsing & Compilation",traceEventNames:["v8.compile","v8.compileModule","v8.parseOnBackground"]},scriptEvaluation:{id:"scriptEvaluation",label:"Script Evaluation",traceEventNames:["EventDispatch","EvaluateScript","v8.evaluateModule","FunctionCall","TimerFire","FireIdleCallback","FireAnimationFrame","RunMicrotasks","V8.Execute"]},garbageCollection:{id:"garbageCollection",label:"Garbage Collection",traceEventNames:["MinorGC","MajorGC","BlinkGC.AtomicPhase","ThreadState::performIdleLazySweep","ThreadState::completeSweep","BlinkGCMarking"]},other:{id:"other",label:"Other",traceEventNames:["MessageLoop::RunTask","TaskQueueManager::ProcessTaskFromWorkQueue","ThreadControllerImpl::DoWork"]}},yw={};for(let e of Object.values(vn))for(let t of e.traceEventNames)yw[t]=e});var ms,bw=b(()=>{"use strict";d();jt();ed();ms=class e{static{s(this,"MainThreadTasks")}static _createNewTaskNode(t,n){let r=t.ph==="X"&&!n,a=t.ph==="B"&&n&&n.ph==="E";if(!r&&!a)throw new Error("Invalid parameters for _createNewTaskNode");let o=t.ts,i=n?n.ts:t.ts+Number(t.dur||0);return{event:t,endEvent:n,startTime:o,endTime:i,duration:i-o,unbounded:!1,parent:void 0,children:[],attributableURLs:[],group:vn.other,selfTime:NaN}}static _assignAllTimersUntilTs(t,n,r,a){for(;a.length;){let o=a.pop();if(!o)break;if(o.ts>n){a.push(o);break}if(o.ts<t.startTime)continue;let i=o.args.data.timerId;r.timers.set(i,t)}}static _createTasksFromStartAndEndEvents(t,n,r){let a=[],o=n.slice().reverse();for(let i=0;i<t.length;i++){let c=t[i];if(c.ph==="X"){a.push(e._createNewTaskNode(c));continue}let u=-1,l=0,m=i+1;for(let y=o.length-1;y>=0;y--){let v=o[y];for(;m<t.length&&!(t[m].ts>=v.ts);m++)t[m].name===c.name&&l++;if(v.name===c.name&&!(v.ts<c.ts)){if(l>0){l--;continue}u=y;break}}let p,h=!1;u===-1?(p={...c,ph:"E",ts:r},h=!0):u===o.length-1?p=o.pop():p=o.splice(u,1)[0];let f=e._createNewTaskNode(c,p);f.unbounded=h,a.push(f)}if(o.length)throw new Error(`Fatal trace logic error - ${o.length} unmatched end events`);return a}static _createTaskRelationships(t,n,r){let a,o=n.slice().reverse();for(let i=0;i<t.length;i++){let c=t[i];if(c.event.name==="XHRReadyStateChange"){let u=c.event.args.data,l=u?.url;u&&l&&u.readyState===1&&r.xhrs.set(l,c)}for(;a&&Number.isFinite(a.endTime)&&a.endTime<=c.startTime;)e._assignAllTimersUntilTs(a,a.endTime,r,o),a=a.parent;if(a){if(c.endTime>a.endTime){let u=c.endTime-a.endTime;if(u<1e3)a.endTime=c.endTime,a.duration+=u;else if(c.unbounded)c.endTime=a.endTime,c.duration=c.endTime-c.startTime;else if(c.startTime-a.startTime<1e3&&!a.children.length){let l=c,m=a,p=a.parent;if(p){let h=p.children.length-1;if(p.children[h]!==m)throw new Error("Fatal trace logic error - impossible children");p.children.pop(),p.children.push(l)}l.parent=p,l.startTime=m.startTime,l.duration=l.endTime-l.startTime,a=l,c=m}else{let l=new Error("Fatal trace logic error - child cannot end after parent");throw l.timeDelta=u,l.nextTaskEvent=c.event,l.nextTaskEndEvent=c.endEvent,l.nextTaskEndTime=c.endTime,l.currentTaskEvent=a.event,l.currentTaskEndEvent=a.endEvent,l.currentTaskEndTime=a.endTime,l}}c.parent=a,a.children.push(c),e._assignAllTimersUntilTs(a,c.startTime,r,o)}a=c}a&&e._assignAllTimersUntilTs(a,a.endTime,r,o)}static _createTasksFromEvents(t,n,r){let a=[],o=[],i=[];for(let l of t)(l.ph==="X"||l.ph==="B")&&a.push(l),l.ph==="E"&&o.push(l),l.name==="TimerInstall"&&i.push(l);let u=e._createTasksFromStartAndEndEvents(a,o,r).sort((l,m)=>l.startTime-m.startTime||m.duration-l.duration);return e._createTaskRelationships(u,i,n),u.sort((l,m)=>l.startTime-m.startTime||m.duration-l.duration)}static _computeRecursiveSelfTime(t,n){if(n&&t.endTime>n.endTime)throw new Error("Fatal trace logic error - child cannot end after parent");let r=t.children.map(a=>e._computeRecursiveSelfTime(a,t)).reduce((a,o)=>a+o,0);return t.selfTime=t.duration-r,t.duration}static _computeRecursiveAttributableURLs(t,n,r,a){let o=t.event.args,i={...o.beginData||{},...o.data||{}},c=i.frame||"",u=a.frameURLsById.get(c),l=(i.stackTrace||[]).map(f=>f.url),m=l[0];c&&u&&u.startsWith("about:")&&m&&(a.frameURLsById.set(c,m),u=m);let p=[];switch(t.event.name){case"v8.compile":case"EvaluateScript":case"FunctionCall":p=[i.url,u];break;case"v8.compileModule":p=[t.event.args.fileName];break;case"TimerFire":{let f=t.event.args.data.timerId,y=a.timers.get(f);if(!y)break;p=y.attributableURLs;break}case"ParseHTML":p=[i.url,u];break;case"ParseAuthorStyleSheet":p=[i.styleSheetUrl,u];break;case"UpdateLayoutTree":case"Layout":case"Paint":if(u){p=[u];break}if(r.length)break;p=a.lastTaskURLs;break;case"XHRReadyStateChange":case"XHRLoad":{let f=i.url,y=i.readyState;if(!f||typeof y=="number"&&y!==4)break;let v=a.xhrs.get(f);if(!v)break;p=v.attributableURLs;break}default:p=[];break}let h=Array.from(n);for(let f of[...p,...l])f&&(r.includes(f)||r.push(f),h[h.length-1]!==f&&h.push(f));t.attributableURLs=h,t.children.forEach(f=>e._computeRecursiveAttributableURLs(f,h,r,a)),!h.length&&!t.parent&&r.length&&e._setRecursiveEmptyAttributableURLs(t,r)}static _setRecursiveEmptyAttributableURLs(t,n){t.attributableURLs.length||(t.attributableURLs=n.slice(),t.children.forEach(r=>e._setRecursiveEmptyAttributableURLs(r,n)))}static _computeRecursiveTaskGroup(t,n){let r=yw[t.event.name];t.group=r||n||vn.other,t.children.forEach(a=>e._computeRecursiveTaskGroup(a,t.group))}static getMainThreadTasks(t,n,r,a){let o=new Map,i=new Map,c=new Map;n.forEach(({id:h,url:f})=>c.set(h,f));let l={timers:o,xhrs:i,frameURLsById:c,lastTaskURLs:[]},m=e._createTasksFromEvents(t,l,r);for(let h of m)h.parent||(e._computeRecursiveSelfTime(h,void 0),e._computeRecursiveAttributableURLs(h,[],[],l),e._computeRecursiveTaskGroup(h),l.lastTaskURLs=h.attributableURLs);let p=a??m[0].startTime;for(let h of m)if(h.startTime=(h.startTime-p)/1e3,h.endTime=(h.endTime-p)/1e3,h.duration/=1e3,h.selfTime/=1e3,!Number.isFinite(h.selfTime))throw new Error("Invalid task timing data");return m}static printTaskTreeToDebugString(t,n={}){let r=Math.max(...t.map(v=>v.endTime),0),{printWidth:a=100,startTime:o=0,endTime:i=r,taskLabelFn:c=s(v=>v.event.name,"taskLabelFn")}=n;function u(v){let D=0;for(;v.parent;v=v.parent)D++;return D}s(u,"computeTaskDepth");let m=(i-o)/a,p=new Map,h=new Map;for(let v of t){if(v.startTime>i||v.endTime<o)continue;let D=u(v),E=h.get(D)||[];E.push(v),h.set(D,E);let S=String.fromCharCode(65+p.size%26);p.set(v,{id:S,task:v})}let f=[`Trace Duration: ${r.toFixed(0)}ms`,`Range: [${o}, ${i}]`,`█ = ${m.toFixed(2)}ms`,""],y=Array.from(h.entries()).sort((v,D)=>v[0]-D[0]);for(let[,v]of y){let D=Array.from({length:a}).map(()=>" ");for(let E of v){let S=Math.max(E.startTime,o),k=Math.min(E.endTime,i),{id:C}=p.get(E)||{id:"?"},R=Math.floor(S/m),z=Math.floor(k/m),B=Math.floor((R+z)/2);for(let J=R;J<=z;J++)D[J]="█";for(let J=0;J<C.length;J++)D[B]=C}f.push(D.join(""))}f.push("");for(let{id:v,task:D}of p.values())f.push(`${v} = ${c(D)}`);return f.join(`
`)}}});var vw,Cn,za=b(()=>{"use strict";d();ue();bw();Nt();vw=class{static{s(this,"MainThreadTasks")}static async compute_(t,n){let{mainThreadEvents:r,frames:a,timestamps:o}=await ke.request(t,n);return ms.getMainThreadTasks(r,a,o.traceEnd,o.timeOrigin)}},Cn=q(vw,null)});function td(e){let t=new Set;for(let n of e)n.resourceType===G.TYPES.Script&&t.add(n.url);return t}function ps(e,t){let n=e.attributableURLs.find(o=>t.has(o)),r=e.attributableURLs[0],a=n||r;return(!a||a==="about:blank")&&(ene.has(e.event.name)?a="Browser":tne.has(e.event.name)?a="Browser GC":a="Unattributable"),a}function ef(e,t){let n=td(t),r=new Map;for(let a of e){let o=ps(a,n),i=r.get(o)||{},c=i[a.group.id]||0;i[a.group.id]=c+a.selfTime,r.set(o,i)}return r}var ene,tne,nd=b(()=>{"use strict";d();lt();ene=new Set(["CpuProfiler::StartProfiling"]),tne=new Set(["V8.GCCompactor","MajorGC","MinorGC"]);s(td,"getJavaScriptURLs");s(ps,"getAttributableURLForTask");s(ef,"getExecutionTimingsByURL")});var ww,cn,Ha=b(()=>{"use strict";d();vr();Nt();sr();de();ww=class{static{s(this,"Metric")}constructor(){}static getMetricComputationInput(t){return{trace:t.trace,devtoolsLog:t.devtoolsLog,gatherContext:t.gatherContext,settings:t.settings,URL:t.URL}}static computeSimulatedMetric(t,n){throw new Error("Unimplemented")}static computeObservedMetric(t,n){throw new Error("Unimplemented")}static async compute_(t,n){let r=t.gatherContext||{gatherMode:"navigation"},{trace:a,devtoolsLog:o,settings:i}=t;if(!a||!o||!i)throw new Error("Did not provide necessary metric computation data");let c=await ke.request(a,n),u=r.gatherMode==="timespan"?void 0:await zt.request(a,n),l=Object.assign({networkRecords:await H.request(o,n),gatherContext:r,processedTrace:c,processedNavigation:u},t);switch(qt.assertHasToplevelEvents(l.processedTrace.mainThreadEvents),i.throttlingMethod){case"simulate":if(r.gatherMode!=="navigation")throw new Error(`${r.gatherMode} does not support throttlingMethod simulate`);return this.computeSimulatedMetric(l,n);case"provided":case"devtools":return this.computeObservedMetric(l,n);default:throw new TypeError(`Unrecognized throttling method: ${i.throttlingMethod}`)}}},cn=ww});var pt,Rr=b(()=>{"use strict";d();Ha();pt=class extends cn{static{s(this,"NavigationMetric")}static computeSimulatedMetric(t,n){throw new Error("Unimplemented")}static computeObservedMetric(t,n){throw new Error("Unimplemented")}static async compute_(t,n){if(t.gatherContext.gatherMode!=="navigation")throw new Error(`${this.name} can only be computed on navigations`);return super.compute_(t,n)}}});var Wt,oa=b(()=>{"use strict";d();gn();lt();sr();Nn();Gn();Wt=class{static{s(this,"LanternMetric")}static getScriptUrls(t,n){let r=new Set;return t.traverse(a=>{a.type===ye.TYPES.NETWORK&&a.record.resourceType===G.TYPES.Script&&n?.(a)&&r.add(a.record.url)}),r}static get COEFFICIENTS(){throw new Error("COEFFICIENTS unimplemented!")}static getScaledCoefficients(t){return this.COEFFICIENTS}static getOptimisticGraph(t,n){throw new Error("Optimistic graph unimplemented!")}static getPessimisticGraph(t,n){throw new Error("Pessmistic graph unimplemented!")}static getEstimateFromSimulation(t,n){return t}static async computeMetricWithGraphs(t,n,r){if((t.gatherContext||{gatherMode:"navigation"}).gatherMode!=="navigation")throw new Error("Lantern metrics can only be computed on navigations");let o=this.name.replace("Lantern",""),i=await xt.request(t,n),c=await zt.request(t.trace,n),u=t.simulator||await Pt.request(t,n),l=this.getOptimisticGraph(i,c),m=this.getPessimisticGraph(i,c),p={label:`optimistic${o}`},h=u.simulate(l,p);p={label:`optimisticFlex${o}`,flexibleOrdering:!0};let f=u.simulate(l,p);p={label:`pessimistic${o}`};let y=u.simulate(m,p),v=this.getEstimateFromSimulation(h.timeInMs<f.timeInMs?h:f,{...r,optimistic:!0}),D=this.getEstimateFromSimulation(y,{...r,optimistic:!1}),E=this.getScaledCoefficients(u.rtt),S=E.intercept>0?Math.min(1,v.timeInMs/1e3):1;return{timing:E.intercept*S+E.optimistic*v.timeInMs+E.pessimistic*D.timeInMs,optimisticEstimate:v,pessimisticEstimate:D,optimisticGraph:l,pessimisticGraph:m}}static async compute_(t,n){return this.computeMetricWithGraphs(t,n)}}});var Dw,Tt,cr=b(()=>{"use strict";d();ue();oa();gn();Dw=class extends Wt{static{s(this,"LanternFirstContentfulPaint")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getRenderBlockingNodeData(t,{cutoffTimestamp:n,treatNodeAsRenderBlocking:r,additionalCpuNodesToTreatAsRenderBlocking:a}){let o=new Map,i=[];t.traverse(f=>{if(f.type===ye.TYPES.CPU){f.startTime<=n&&i.push(f);let y=f.getEvaluateScriptURLs();for(let v of y){let D=o.get(v)||f;o.set(v,f.startTime<D.startTime?f:D)}}}),i.sort((f,y)=>f.startTime-y.startTime);let c=Wt.getScriptUrls(t,f=>f.endTime<=n&&r(f)),u=new Set,l=new Set;for(let f of c){let y=o.get(f);if(y){if(i.includes(y)){l.add(y.id);continue}u.add(f)}}let m=i.find(f=>f.didPerformLayout());m&&l.add(m.id);let p=i.find(f=>f.childEvents.some(y=>y.name==="Paint"));p&&l.add(p.id);let h=i.find(f=>f.childEvents.some(y=>y.name==="ParseHTML"));return h&&l.add(h.id),a&&i.filter(a).forEach(f=>l.add(f.id)),{definitelyNotRenderBlockingScriptUrls:u,renderBlockingCpuNodeIds:l}}static getFirstPaintBasedGraph(t,{cutoffTimestamp:n,treatNodeAsRenderBlocking:r,additionalCpuNodesToTreatAsRenderBlocking:a}){let o=this.getRenderBlockingNodeData(t,{cutoffTimestamp:n,treatNodeAsRenderBlocking:r,additionalCpuNodesToTreatAsRenderBlocking:a}),{definitelyNotRenderBlockingScriptUrls:i,renderBlockingCpuNodeIds:c}=o;return t.cloneWithRelationships(u=>{if(u.type===ye.TYPES.NETWORK){if((u.endTime>n||u.startTime>n)&&!u.isMainDocument())return!1;let m=u.record.url;return i.has(m)?!1:r(u)}else return c.has(u.id)})}static getOptimisticGraph(t,n){return this.getFirstPaintBasedGraph(t,{cutoffTimestamp:n.timestamps.firstContentfulPaint,treatNodeAsRenderBlocking:r=>r.hasRenderBlockingPriority()&&r.initiatorType!=="script"})}static getPessimisticGraph(t,n){return this.getFirstPaintBasedGraph(t,{cutoffTimestamp:n.timestamps.firstContentfulPaint,treatNodeAsRenderBlocking:r=>r.hasRenderBlockingPriority()})}},Tt=q(Dw,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var Ew,Ga,rd=b(()=>{"use strict";d();ue();Rr();cr();Ew=class extends pt{static{s(this,"FirstContentfulPaint")}static computeSimulatedMetric(t,n){let r=pt.getMetricComputationInput(t);return Tt.request(r,n)}static async computeObservedMetric(t){let{processedNavigation:n}=t;return{timing:n.timings.firstContentfulPaint,timestamp:n.timestamps.firstContentfulPaint}}},Ga=q(Ew,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var xw,fs,tf=b(()=>{"use strict";d();ue();oa();It();cr();xw=class extends Wt{static{s(this,"LanternFirstMeaningfulPaint")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(t,n){let r=n.timestamps.firstMeaningfulPaint;if(!r)throw new j(j.errors.NO_FMP);return Tt.getFirstPaintBasedGraph(t,{cutoffTimestamp:r,treatNodeAsRenderBlocking:a=>a.hasRenderBlockingPriority()&&a.initiatorType!=="script"})}static getPessimisticGraph(t,n){let r=n.timestamps.firstMeaningfulPaint;if(!r)throw new j(j.errors.NO_FMP);return Tt.getFirstPaintBasedGraph(t,{cutoffTimestamp:r,treatNodeAsRenderBlocking:a=>a.hasRenderBlockingPriority(),additionalCpuNodesToTreatAsRenderBlocking:a=>a.didPerformLayout()})}static async compute_(t,n){let r=await Tt.request(t,n),a=await this.computeMetricWithGraphs(t,n);return a.timing=Math.max(a.timing,r.timing),a}},fs=q(xw,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var nne,Tw,An,Yo=b(()=>{"use strict";d();ue();oa();gn();lt();tf();nne=20,Tw=class e extends Wt{static{s(this,"LanternInteractive")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(t){let n=nne*1e3;return t.cloneWithRelationships(r=>{if(r.type===ye.TYPES.CPU)return r.event.dur>n;let a=r.record.resourceType===G.TYPES.Image,o=r.record.resourceType===G.TYPES.Script;return!a&&(o||r.record.priority==="High"||r.record.priority==="VeryHigh")})}static getPessimisticGraph(t){return t}static getEstimateFromSimulation(t,n){if(!n.fmpResult)throw new Error("missing fmpResult");let r=e.getLastLongTaskEndTime(t.nodeTimings),a=n.optimistic?n.fmpResult.optimisticEstimate.timeInMs:n.fmpResult.pessimisticEstimate.timeInMs;return{timeInMs:Math.max(a,r),nodeTimings:t.nodeTimings}}static async compute_(t,n){let r=await fs.request(t,n),a=await this.computeMetricWithGraphs(t,n,{fmpResult:r});return a.timing=Math.max(a.timing,r.timing),a}static getLastLongTaskEndTime(t,n=50){return Array.from(t.entries()).filter(([r,a])=>r.type!==ye.TYPES.CPU?!1:a.duration>n).map(([r,a])=>a.endTime).reduce((r,a)=>Math.max(r||0,a||0),0)}},An=q(Tw,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var rne,hs,Sw=b(()=>{"use strict";d();Kr();Ae();jt();jg();lt();Ze();rne=Be,hs=class extends rne{static{s(this,"NetworkMonitor")}_networkRecorder=void 0;_frameNavigations=[];constructor(t){super(),this._targetManager=t,this._session=t.rootSession(),this._onFrameNavigated=n=>this._frameNavigations.push(n.frame),this._onProtocolMessage=n=>{this._networkRecorder&&this._networkRecorder.dispatch(n)}}async enable(){if(this._networkRecorder)return;this._frameNavigations=[],this._networkRecorder=new Zi;let t=s(n=>r=>{this.emit(n,r),this._emitNetworkStatus()},"reEmit");this._networkRecorder.on("requeststarted",t("requeststarted")),this._networkRecorder.on("requestfinished",t("requestfinished")),this._session.on("Page.frameNavigated",this._onFrameNavigated),this._targetManager.on("protocolevent",this._onProtocolMessage)}async disable(){this._networkRecorder&&(this._session.off("Page.frameNavigated",this._onFrameNavigated),this._targetManager.off("protocolevent",this._onProtocolMessage),this._frameNavigations=[],this._networkRecorder=void 0)}async getNavigationUrls(){let t=this._frameNavigations;if(!t.length)return{};let n=t.filter(a=>!a.parentId);n.length||F.warn("NetworkMonitor","No detected navigations");let r=n[0]?.url;if(this._networkRecorder){let o=this._networkRecorder.getRawRecords().find(i=>i.url===r);for(;o?.redirectSource;)o=o.redirectSource,r=o.url}return{requestedUrl:r,mainDocumentUrl:n[n.length-1]?.url}}getInflightRequests(){return this._networkRecorder?this._networkRecorder.getRawRecords().filter(t=>!t.finished):[]}isIdle(){return this._isActiveIdlePeriod(0)}isCriticalIdle(){if(!this._networkRecorder)return!1;let r=this._networkRecorder.getRawRecords().find(a=>a.resourceType==="Document")?.frameId;return this._isActiveIdlePeriod(0,a=>a.frameId===r&&(a.priority==="VeryHigh"||a.priority==="High"))}is2Idle(){return this._isActiveIdlePeriod(2)}_isActiveIdlePeriod(t,n){if(!this._networkRecorder)return!1;let r=this._networkRecorder.getRawRecords(),a=0;for(let o=0;o<r.length;o++){let i=r[o];i.finished||n&&!n(i)||G.isNonNetworkRequest(i)||a++}return a<=t}_emitNetworkStatus(){let t=this.isIdle(),n=this.is2Idle(),r=this.isCriticalIdle();this.emit(t?"networkidle":"networkbusy"),this.emit(n?"network-2-idle":"network-2-busy"),this.emit(r?"network-critical-idle":"network-critical-busy"),n&&t?F.verbose("NetworkRecorder","network fully-quiet"):n&&!t?F.verbose("NetworkRecorder","network semi-quiet"):F.verbose("NetworkRecorder","network busy")}static findNetworkQuietPeriods(t,n,r=1/0){let a=[];t.forEach(u=>{Y.isNonNetworkProtocol(u.protocol)||u.protocol==="ws"||u.protocol==="wss"||(a.push({time:u.networkRequestTime*1e3,isStart:!0}),u.finished&&a.push({time:u.networkEndTime*1e3,isStart:!1}))}),a=a.filter(u=>u.time<=r).sort((u,l)=>u.time-l.time);let o=0,i=0,c=[];return a.forEach(u=>{u.isStart?(o===n&&c.push({start:i,end:u.time}),o++):(o--,o===n&&(i=u.time))}),o<=n&&c.push({start:i,end:r}),c.filter(u=>u.start!==u.end)}}});var nf,ane,kw,Fr,gs=b(()=>{"use strict";d();ue();Rr();Yo();Sw();vr();It();nf=5e3,ane=2,kw=class e extends pt{static{s(this,"Interactive")}static _findNetworkQuietPeriods(t,n){let r=n.timestamps.traceEnd/1e3,a=t.filter(o=>o.finished&&o.requestMethod==="GET"&&!o.failed&&o.statusCode<400);return hs.findNetworkQuietPeriods(a,ane,r)}static _findCPUQuietPeriods(t,n){let r=n.timestamps.timeOrigin/1e3,a=n.timestamps.traceEnd/1e3;if(t.length===0)return[{start:0,end:a}];let o=[];return t.forEach((i,c)=>{c===0&&o.push({start:0,end:i.start+r}),c===t.length-1?o.push({start:i.end+r,end:a}):o.push({start:i.end+r,end:t[c+1].start+r})}),o}static findOverlappingQuietPeriods(t,n,r){let a=r.timestamps.firstContentfulPaint/1e3,o=s(h=>h.end>a+nf&&h.end-h.start>=nf,"isLongEnoughQuietPeriod"),i=this._findNetworkQuietPeriods(n,r).filter(o),c=this._findCPUQuietPeriods(t,r).filter(o),u=c.slice(),l=i.slice(),m=u.shift(),p=l.shift();for(;m&&p;)if(m.start>=p.start){if(p.end>=m.start+nf)return{cpuQuietPeriod:m,networkQuietPeriod:p,cpuQuietPeriods:c,networkQuietPeriods:i};p=l.shift()}else{if(m.end>=p.start+nf)return{cpuQuietPeriod:m,networkQuietPeriod:p,cpuQuietPeriods:c,networkQuietPeriods:i};m=u.shift()}throw new j(m?j.errors.NO_TTI_NETWORK_IDLE_PERIOD:j.errors.NO_TTI_CPU_IDLE_PERIOD)}static computeSimulatedMetric(t,n){let r=pt.getMetricComputationInput(t);return An.request(r,n)}static computeObservedMetric(t){let{processedTrace:n,processedNavigation:r,networkRecords:a}=t;if(!r.timestamps.domContentLoaded)throw new j(j.errors.NO_DCL);let o=qt.getMainThreadTopLevelEvents(n).filter(m=>m.duration>=50),c=e.findOverlappingQuietPeriods(o,a,r).cpuQuietPeriod,u=Math.max(c.start,r.timestamps.firstContentfulPaint/1e3,r.timestamps.domContentLoaded/1e3)*1e3,l=(u-r.timestamps.timeOrigin)/1e3;return Promise.resolve({timing:l,timestamp:u})}},Fr=q(kw,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});function ad(e,t,n,r){let a=50;if(r&&(a*=e.duration/r.duration),e.duration<a||e.end<t||e.start>n)return 0;let o=Math.max(e.start,t),c=Math.min(e.end,n)-o;return c<a?0:c-a}function od(e,t,n){if(n<=t)return 0;let r=0;for(let a of e)r+=ad(a,t,n);return r}var rf=b(()=>{"use strict";d();s(ad,"calculateTbtImpactForEvent");s(od,"calculateSumOfBlockingTime")});var Cw,IP,NP=b(()=>{"use strict";d();ue();oa();gn();cr();Yo();rf();Cw=class e extends Wt{static{s(this,"LanternTotalBlockingTime")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(t){return t}static getPessimisticGraph(t){return t}static getEstimateFromSimulation(t,n){if(!n.fcpResult)throw new Error("missing fcpResult");if(!n.interactiveResult)throw new Error("missing interactiveResult");let r=n.optimistic?n.fcpResult.pessimisticEstimate.timeInMs:n.fcpResult.optimisticEstimate.timeInMs,a=n.optimistic?n.interactiveResult.optimisticEstimate.timeInMs:n.interactiveResult.pessimisticEstimate.timeInMs,o=50,i=e.getTopLevelEvents(t.nodeTimings,o);return{timeInMs:od(i,r,a),nodeTimings:t.nodeTimings}}static async compute_(t,n){let r=await Tt.request(t,n),a=await An.request(t,n);return this.computeMetricWithGraphs(t,n,{fcpResult:r,interactiveResult:a})}static getTopLevelEvents(t,n){let r=[];for(let[a,o]of t.entries())a.type===ye.TYPES.CPU&&(o.duration<n||r.push({start:o.startTime,end:o.endTime,duration:o.duration}));return r}},IP=q(Cw,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var Aw,Ir,ys=b(()=>{"use strict";d();ue();Ha();vr();NP();gs();rf();Aw=class extends cn{static{s(this,"TotalBlockingTime")}static computeSimulatedMetric(t,n){let r=cn.getMetricComputationInput(t);return IP.request(r,n)}static async computeObservedMetric(t,n){let r=qt.getMainThreadTopLevelEvents(t.processedTrace);if(t.processedNavigation){let{firstContentfulPaint:a}=t.processedNavigation.timings,o=cn.getMetricComputationInput(t),i=(await Fr.request(o,n)).timing;return{timing:od(r,a,i)}}else return{timing:od(r,0,t.processedTrace.timings.traceEnd)}}},Ir=q(Aw,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var _w,Va,id=b(()=>{"use strict";d();ue();za();rd();gs();ys();Nt();rf();_w=class{static{s(this,"TBTImpactTasks")}static getTopLevelTask(t){let n=t;for(;n.parent;)n=n.parent;return n}static async getTbtBounds(t,n){let r=await ke.request(t.trace,n);if(t.gatherContext.gatherMode!=="navigation")return{startTimeMs:0,endTimeMs:r.timings.traceEnd};let a=await Ga.request(t,n),o=await Fr.request(t,n),i=a.timing,c=o.timing;return"optimisticEstimate"in a&&(i=a.optimisticEstimate.timeInMs),"pessimisticEstimate"in o&&(c=o.pessimisticEstimate.timeInMs),{startTimeMs:i,endTimeMs:c}}static createImpactTasks(t,n){let r=[];for(let a of t){let o=n.get(a)||0,i=o;for(let c of a.children){let u=n.get(c)||0;i-=u}r.push({...a,tbtImpact:o,selfTbtImpact:i})}return r}static computeImpactsFromObservedTasks(t,n,r){let a=new Map;for(let o of t){let i={start:o.startTime,end:o.endTime,duration:o.duration},c=this.getTopLevelTask(o),u={start:c.startTime,end:c.endTime,duration:c.duration},l=ad(i,n,r,u);a.set(o,l)}return this.createImpactTasks(t,a)}static computeImpactsFromLantern(t,n,r,a){let o=new Map,i=new Map,c=new Map;for(let u of t)c.set(u.event,u);for(let[u,l]of n){if(u.type!=="cpu")continue;let m={start:l.startTime,end:l.endTime,duration:l.duration},p=ad(m,r,a),h=c.get(u.event);h&&(i.set(h,m),o.set(h,p))}for(let u of t){if(o.has(u))continue;let l=this.getTopLevelTask(u),m=i.get(l);if(!m)continue;let h=(u.startTime-l.startTime)/l.duration*m.duration+m.start,f=(l.endTime-u.endTime)/l.duration,y=m.end-f*m.duration,v={start:h,end:y,duration:y-h},D=ad(v,r,a,m);o.set(u,D)}return this.createImpactTasks(t,o)}static async compute_(t,n){let r=await Ir.request(t,n),a=await Cn.request(t.trace,n),{startTimeMs:o,endTimeMs:i}=await this.getTbtBounds(t,n);return"pessimisticEstimate"in r?this.computeImpactsFromLantern(a,r.pessimisticEstimate.nodeTimings,o,i):this.computeImpactsFromObservedTasks(a,o,i)}},Va=q(_w,["trace","devtoolsLog","URL","gatherContext","settings","simulator"])});var MP={};T(MP,{UIStrings:()=>sa,default:()=>ine});var sa,ia,Rw,ine,LP=b(()=>{"use strict";d();Ae();V();ed();A();de();za();nd();id();or();Fn();sa={title:"JavaScript execution time",failureTitle:"Reduce JavaScript execution time",description:"Consider reducing the time spent parsing, compiling, and executing JS. You may find delivering smaller JS payloads helps with this. [Learn how to reduce Javascript execution time](https://developer.chrome.com/docs/lighthouse/performance/bootup-time/).",columnTotal:"Total CPU Time",columnScriptEval:"Script Evaluation",columnScriptParse:"Script Parse",chromeExtensionsWarning:"Chrome extensions negatively affected this page's load performance. Try auditing the page in incognito mode or from a Chrome profile without extensions."},ia=w("core/audits/bootup-time.js",sa),Rw=class e extends g{static{s(this,"BootupTime")}static get meta(){return{id:"bootup-time",title:ia(sa.title),failureTitle:ia(sa.failureTitle),description:ia(sa.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:1,requiredArtifacts:["traces","devtoolsLogs","URL","GatherContext"]}}static get defaultOptions(){return{p10:1282,median:3500,thresholdInMs:50}}static async getTbtImpact(t,n){let r=0;try{let a=g.makeMetricComputationDataInput(t,n),o=await Va.request(a,n);for(let i of o){let c=i.group.id;c!=="scriptEvaluation"&&c!=="scriptParseCompile"||(r+=i.selfTbtImpact)}}catch(a){Rt.captureException(a,{tags:{audit:this.meta.id},level:"error"}),F.error(this.meta.id,a.message)}return r}static async audit(t,n){let r=n.settings||{},a=t.traces[e.DEFAULT_PASS],o=t.devtoolsLogs[e.DEFAULT_PASS],i=await H.request(o,n),c=await Cn.request(a,n),u=r.throttlingMethod==="simulate"?r.throttling.cpuSlowdownMultiplier:1,l=ef(c,i);l.delete("_lighthouse-eval.js");let m=await this.getTbtImpact(t,n),p=!1,h=0,f=Array.from(l).map(([S,k])=>{let C=0;for(let[B,J]of Object.entries(k))k[B]=J*u,C+=J*u;let R=k[vn.scriptEvaluation.id]||0,z=k[vn.scriptParseCompile.id]||0;return C>=n.options.thresholdInMs&&(h+=R+z),p=p||S.startsWith("chrome-extension:")&&R>100,{url:S,total:C,scripting:R,scriptParseCompile:z}}).filter(S=>S.total>=n.options.thresholdInMs).sort((S,k)=>k.total-S.total),y;p&&(y=[ia(sa.chromeExtensionsWarning)]);let v=[{key:"url",valueType:"url",label:ia(x.columnURL)},{key:"total",granularity:1,valueType:"ms",label:ia(sa.columnTotal)},{key:"scripting",granularity:1,valueType:"ms",label:ia(sa.columnScriptEval)},{key:"scriptParseCompile",granularity:1,valueType:"ms",label:ia(sa.columnScriptParse)}],D=e.makeTableDetails(v,f,{wastedMs:h,sortedBy:["total"]}),E=g.computeLogNormalScore({p10:n.options.p10,median:n.options.median},h);return{score:E,scoreDisplayMode:E>=Me.PASS_THRESHOLD?g.SCORING_MODES.INFORMATIVE:void 0,notApplicable:!f.length,numericValue:h,numericUnit:"millisecond",displayValue:h>0?ia(x.seconds,{timeInMs:h}):"",details:D,runWarnings:y,metricSavings:{TBT:m}}}},ine=Rw});var Fw,$n,Ko=b(()=>{"use strict";d();ue();oa();It();cr();Fw=class e extends Wt{static{s(this,"LanternLargestContentfulPaint")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static isNotLowPriorityImageNode(t){if(t.type!=="network")return!0;let n=t.record.resourceType==="Image",r=t.record.priority==="Low"||t.record.priority==="VeryLow";return!n||!r}static getOptimisticGraph(t,n){let r=n.timestamps.largestContentfulPaint;if(!r)throw new j(j.errors.NO_LCP);return Tt.getFirstPaintBasedGraph(t,{cutoffTimestamp:r,treatNodeAsRenderBlocking:e.isNotLowPriorityImageNode})}static getPessimisticGraph(t,n){let r=n.timestamps.largestContentfulPaint;if(!r)throw new j(j.errors.NO_LCP);return Tt.getFirstPaintBasedGraph(t,{cutoffTimestamp:r,treatNodeAsRenderBlocking:a=>!0,additionalCpuNodesToTreatAsRenderBlocking:a=>a.didPerformLayout()})}static getEstimateFromSimulation(t){let n=Array.from(t.nodeTimings.entries()).filter(r=>e.isNotLowPriorityImageNode(r[0])).map(r=>r[1].endTime);return{timeInMs:Math.max(...n),nodeTimings:t.nodeTimings}}static async compute_(t,n){let r=await Tt.request(t,n),a=await this.computeMetricWithGraphs(t,n);return a.timing=Math.max(a.timing,r.timing),a}},$n=q(Fw,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var Iw,bs,af=b(()=>{"use strict";d();ue();de();sr();It();Iw=class{static{s(this,"LCPImageRecord")}static async compute_(t,n){let{trace:r,devtoolsLog:a}=t,o=await H.request(a,n),i=await zt.request(r,n);if(i.timings.largestContentfulPaint===void 0)throw new j(j.errors.NO_LCP);let c=i.largestContentfulPaintEvt;if(!c)return;let u=r.traceEvents.filter(p=>p.name==="LargestImagePaint::Candidate"&&p.args.frame===c.args.frame&&p.args.data?.DOMNodeId===c.args.data?.nodeId&&p.args.data?.size===c.args.data?.size).sort((p,h)=>h.ts-p.ts)[0],l=u?.args.data?.imageUrl;return l?o.filter(p=>p.url===l&&p.finished&&p.frameId===u.args.frame&&p.networkRequestTime<(i.timestamps.largestContentfulPaint||0)).map(p=>{for(;p.redirectDestination;)p=p.redirectDestination;return p}).filter(p=>p.resourceType==="Image").sort((p,h)=>p.networkEndTime-h.networkEndTime)[0]:void 0}},bs=q(Iw,["devtoolsLog","trace"])});var sne,cne,une,ve,Ln=b(()=>{"use strict";d();V();Yo();A();de();Gn();Nn();Ko();cr();af();sne=w("core/audits/byte-efficiency/byte-efficiency-audit.js",{}),cne=150,une=935,ve=class extends g{static{s(this,"ByteEfficiencyAudit")}static scoreForWastedMs(t){return g.computeLogNormalScore({p10:cne,median:une},t)}static async audit(t,n){let r=t.GatherContext,a=t.devtoolsLogs[g.DEFAULT_PASS],o=n?.settings||{},i={devtoolsLog:a,settings:o},c=await H.request(a,n);if(!c.some(h=>h.transferSize)&&r.gatherMode==="timespan")return{score:1,notApplicable:!0};let l=g.makeMetricComputationDataInput(t,n),[m,p]=await Promise.all([this.audit_(t,c,n),Pt.request(i,n)]);return this.createAuditProduct(m,p,l,n)}static computeWasteWithGraph(t,n,r,a){a=Object.assign({label:""},a);let o=`${this.meta.id}-${a.label}-before`,i=`${this.meta.id}-${a.label}-after`,c=r.simulate(n,{label:o}),u=a.providedWastedBytesByUrl||new Map;if(!a.providedWastedBytesByUrl)for(let{url:h,wastedBytes:f}of t)u.set(h,(u.get(h)||0)+f);let l=new Map;n.traverse(h=>{if(h.type!=="network")return;let f=u.get(h.record.url);if(!f)return;let y=h.record.transferSize;l.set(h.record.requestId,y),h.record.transferSize=Math.max(y-f,0)});let m=r.simulate(n,{label:i});n.traverse(h=>{if(h.type!=="network")return;let f=l.get(h.record.requestId);f!==void 0&&(h.record.transferSize=f)});let p=c.timeInMs-m.timeInMs;return{savings:Math.round(Math.max(p,0)/10)*10,simulationBeforeChanges:c,simulationAfterChanges:m}}static computeWasteWithTTIGraph(t,n,r,a){a=Object.assign({includeLoad:!0},a);let{savings:o,simulationBeforeChanges:i,simulationAfterChanges:c}=this.computeWasteWithGraph(t,n,r,{...a,label:"overallLoad"}),l=An.getLastLongTaskEndTime(i.nodeTimings)-An.getLastLongTaskEndTime(c.nodeTimings);return a.includeLoad&&(l=Math.max(l,o)),Math.round(Math.max(l,0)/10)*10}static async createAuditProduct(t,n,r,a){let o=t.items.sort((h,f)=>f.wastedBytes-h.wastedBytes),i=o.reduce((h,f)=>h+f.wastedBytes,0),c={FCP:0,LCP:0},u;if(r.gatherContext.gatherMode==="navigation"){let h=await xt.request(r,a),{optimisticGraph:f}=await Tt.request(r,a),{optimisticGraph:y}=await $n.request(r,a);u=this.computeWasteWithTTIGraph(o,h,n,{providedWastedBytesByUrl:t.wastedBytesByUrl});let{savings:v}=this.computeWasteWithGraph(o,f,n,{providedWastedBytesByUrl:t.wastedBytesByUrl,label:"fcp"}),{savings:D}=this.computeWasteWithGraph(o,y,n,{providedWastedBytesByUrl:t.wastedBytesByUrl,label:"lcp"}),E=0,S=await bs.request(r,a);if(S){let k=o.find(C=>C.url===S.url);k&&(E=n.computeWastedMsFromWastedBytes(k.wastedBytes))}c.FCP=v,c.LCP=Math.max(D,E)}else u=n.computeWastedMsFromWastedBytes(i);let l=t.displayValue||"";typeof t.displayValue>"u"&&i&&(l=sne(x.displayValueByteSavings,{wastedBytes:i}));let m=t.sortedBy||["wastedBytes"],p=g.makeOpportunityDetails(t.headings,o,{overallSavingsMs:u,overallSavingsBytes:i,sortedBy:m});return p.debugData={type:"debugdata",metricSavings:c},{explanation:t.explanation,warnings:t.warnings,displayValue:l,numericValue:u,numericUnit:"millisecond",score:o.length?0:1,details:p,metricSavings:c}}static audit_(t,n,r){throw new Error("audit_ unimplemented")}}});function lne(e,t,n){let r=n.split(`
`),a={},o=t,i=o;e.computeLastGeneratedColumns();for(let c of e.mappings()){let u=c.sourceURL,l=c.lineNumber,m=c.columnNumber,p=c.lastColumnNumber;if(!u)continue;let h=r[l];if(h==null){let y=`${e.url()} mapping for line out of bounds: ${l+1}`;return F.error("JSBundles",y),{errorMessage:y}}if(m>h.length){let y=`${e.url()} mapping for column out of bounds: ${l+1}:${m}`;return F.error("JSBundles",y),{errorMessage:y}}let f=0;if(p!==void 0){if(p>h.length){let y=`${e.url()} mapping for last column out of bounds: ${l+1}:${p}`;return F.error("JSBundles",y),{errorMessage:y}}f=p-m}else f=h.length-m+1;a[u]=(a[u]||0)+f,i-=f}return{files:a,unmappedBytes:i,totalBytes:o}}var PP,Nw,un,ca=b(()=>{"use strict";d();Ae();ue();PP=Lt(Fb(),1);s(lne,"computeGeneratedFileSizes");Nw=class{static{s(this,"JSBundles")}static async compute_(t){let{SourceMaps:n,Scripts:r}=t,a=[];for(let o of n){if(!o.map)continue;let{scriptId:i,map:c}=o;if(!c.mappings)continue;let u=r.find(y=>y.scriptId===i);if(!u)continue;let l=o.scriptUrl||"compiled.js",m=o.sourceMapUrl||"compiled.js.map",p=new PP.default.SourceMap(l,m,c),h=lne(p,u.length||0,u.content||""),f={rawMap:c,script:u,map:p,sizes:h};a.push(f)}return a}},un=q(Nw,["Scripts","SourceMaps"])});var dne,mne,Mw,sd,Lw=b(()=>{"use strict";d();ue();ca();dne=.1,mne=1024*.5,Mw=class e{static{s(this,"ModuleDuplication")}static normalizeSource(t){t=t.replace(/\?$/,"");let n=t.lastIndexOf("node_modules");return n!==-1&&(t=t.substring(n)),t}static _shouldIgnoreSource(t){return!!(t.includes("webpack/bootstrap")||t.includes("(webpack)/buildin")||t.includes("external "))}static _normalizeAggregatedData(t){for(let[n,r]of t.entries()){let a=r;if(a.sort((o,i)=>i.resourceSize-o.resourceSize),a.length>1){let o=a[0].resourceSize;a=a.filter(i=>i.resourceSize/o>=dne)}a=a.filter(o=>o.resourceSize>=mne),a.length>1?t.set(n,a):t.delete(n)}}static async compute_(t,n){let r=await un.request(t,n),a=new Map;for(let{rawMap:i,sizes:c}of r){if("errorMessage"in c)continue;let u=[];a.set(i,u);for(let l=0;l<i.sources.length;l++){if(this._shouldIgnoreSource(i.sources[l]))continue;let m=(i.sourceRoot||"")+i.sources[l],p=c.files[m];u.push({source:e.normalizeSource(i.sources[l]),resourceSize:p})}}let o=new Map;for(let{rawMap:i,script:c}of r){let u=a.get(i);if(u)for(let l of u){let m=o.get(l.source);m||(m=[],o.set(l.source,m)),m.push({scriptId:c.scriptId,scriptUrl:c.url,resourceSize:l.resourceSize})}}return this._normalizeAggregatedData(o),o}},sd=q(Mw,["Scripts","SourceMaps"])});function of(e){return!!(e.startLine||e.startColumn)}function Pw(e,t){let n=e.find(r=>r.url===t.url);for(;n?.redirectDestination;)n=n.redirectDestination;return n}function sf(e,t,n){if(e){if(e.resourceType===n)return e.transferSize||0;{let r=e.transferSize||0,a=e.resourceSize||0,o=Number.isFinite(a)&&a>0?r/a:1;return Math.round(t*o)}}else switch(n){case"Stylesheet":return Math.round(t*.2);case"Script":case"Document":return Math.round(t*.33);default:return Math.round(t*.5)}}function Ow(e,t,n){if(!e)switch(n){case"Stylesheet":return Math.round(t*.2);case"Script":case"Document":return Math.round(t*.33);default:return Math.round(t*.5)}let r=e.transferSize||0;if(G.isContentEncoded(e)?e.responseHeadersTransferSize&&(r=Math.max(0,r-e.responseHeadersTransferSize)):r=e.resourceSize,e.resourceType===n)return r;{let a=e.resourceSize||0,o=Number.isFinite(a)&&a>0?r/a:1;return Math.round(t*o)}}function vs(e,t,n,r){let a=e.get(t);if(a!==void 0)return a;let o=n.Scripts.find(i=>i.url===t);if(!o)a=1;else{let i=Pw(r,o),c=i?.resourceSize||o.length||0;a=Ow(i,c,"Script")/c}return e.set(t,a),a}var Wa=b(()=>{"use strict";d();lt();s(of,"isInline");s(Pw,"getRequestForScript");s(sf,"estimateTransferSize");s(Ow,"estimateCompressedContentSize");s(vs,"estimateCompressionRatioForContent")});var BP={};T(BP,{UIStrings:()=>cf,default:()=>fne});function OP(e,t,n=0){let r=e.indexOf(t,n);return r===-1?e.length:r}var cf,cd,pne,Bw,fne,UP=b(()=>{"use strict";d();Ln();Lw();A();Wa();cf={title:"Remove duplicate modules in JavaScript bundles",description:"Remove large, duplicate JavaScript modules from bundles to reduce unnecessary bytes consumed by network activity. "},cd=w("core/audits/byte-efficiency/duplicated-javascript.js",cf),pne=1024;s(OP,"indexOfOrEnd");Bw=class e extends ve{static{s(this,"DuplicatedJavascript")}static get meta(){return{id:"duplicated-javascript",title:cd(cf.title),description:cd(cf.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:2,requiredArtifacts:["devtoolsLogs","traces","SourceMaps","Scripts","GatherContext","URL"]}}static _getNodeModuleName(t){let n=t.split("node_modules/");t=n[n.length-1];let r=OP(t,"/");return t[0]==="@"?t.slice(0,OP(t,"/",r+1)):t.slice(0,r)}static async _getDuplicationGroupedByNodeModules(t,n){let r=await sd.request(t,n),a=new Map;for(let[o,i]of r.entries()){if(!o.includes("node_modules")){a.set(o,i);continue}let c="node_modules/"+e._getNodeModuleName(o),u=a.get(c)||[];for(let{scriptId:l,scriptUrl:m,resourceSize:p}of i){let h=u.find(f=>f.scriptId===l);h||(h={scriptId:l,scriptUrl:m,resourceSize:0},u.push(h)),h.resourceSize+=p}a.set(c,u)}for(let o of r.values())o.sort((i,c)=>c.resourceSize-i.resourceSize);return a}static async audit_(t,n,r){let a=r.options?.ignoreThresholdInBytes||pne,o=await e._getDuplicationGroupedByNodeModules(t,r),i=new Map,c=[],u=0,l=new Set,m=new Map;for(let[h,f]of o.entries()){let y=[],v=0;for(let D=0;D<f.length;D++){let E=f[D],S=E.scriptId,C=t.Scripts.find(B=>B.scriptId===S)?.url||"",R=vs(i,C,t,n),z=Math.round(E.resourceSize*R);y.push({url:C,sourceTransferBytes:z}),D!==0&&(v+=z,m.set(C,(m.get(C)||0)+z))}if(v<=a){u+=v;for(let D of y)l.add(D.url);continue}c.push({source:h,wastedBytes:v,url:"",totalBytes:0,subItems:{type:"subitems",items:y}})}u>a&&c.push({source:"Other",wastedBytes:u,url:"",totalBytes:0,subItems:{type:"subitems",items:Array.from(l).map(h=>({url:h}))}});let p=[{key:"source",valueType:"code",subItemsHeading:{key:"url",valueType:"url"},label:cd(x.columnSource)},{key:null,valueType:"bytes",subItemsHeading:{key:"sourceTransferBytes"},granularity:10,label:cd(x.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",granularity:10,label:cd(x.columnWastedBytes)}];return{items:c,headings:p,wastedBytesByUrl:m}}},fne=Bw});var jP={};T(jP,{UIStrings:()=>uf,default:()=>gne});var uf,ud,hne,Uw,gne,qP=b(()=>{"use strict";d();lt();Ln();A();uf={title:"Use video formats for animated content",description:"Large GIFs are inefficient for delivering animated content. Consider using MPEG4/WebM videos for animations and PNG/WebP for static images instead of GIF to save network bytes. [Learn more about efficient video formats](https://developer.chrome.com/docs/lighthouse/performance/efficient-animated-content/)"},ud=w("core/audits/byte-efficiency/efficient-animated-content.js",uf),hne=100*1024,Uw=class e extends ve{static{s(this,"EfficientAnimatedContent")}static get meta(){return{id:"efficient-animated-content",title:ud(uf.title),description:ud(uf.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:3,requiredArtifacts:["devtoolsLogs","traces","GatherContext","URL"]}}static getPercentSavings(t){return Math.round(29.1*Math.log10(t)-100.7)/100}static audit_(t,n){let a=n.filter(i=>i.mimeType==="image/gif"&&i.resourceType===G.TYPES.Image&&(i.resourceSize||0)>hne).map(i=>{let c=i.resourceSize||0;return{url:i.url,totalBytes:c,wastedBytes:Math.round(c*e.getPercentSavings(c))}}),o=[{key:"url",valueType:"url",label:ud(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:ud(x.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:ud(x.columnWastedBytes)}];return{items:a,headings:o}}},gne=Uw});var $P=I((eMe,WP)=>{d();var zP=/:\/\/(\S*?)(:\d+)?(\/|$)/,HP=/([a-z0-9.-]+\.[a-z0-9]+|localhost)/i,yne=/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/,bne=/[^.]+\.([^.]+|(gov|com|co|ne)\.\w{2})$/i;function GP(e){return typeof e!="string"||e.length>1e4||e.startsWith("data:")?null:zP.test(e)?e.match(zP)[1]:HP.test(e)?e.match(HP)[0]:null}s(GP,"getDomainFromOriginOrURL");function jw(e){let t=GP(e);if(!t)return null;if(yne.test(t))return t;let n=t.match(bne);return n&&n[0]||t}s(jw,"getRootDomain");function vne(e,t){return e.length<=t.length?e:e.split(".").slice(1).join(".")}s(vne,"sliceSubdomainFromDomain");function VP(e,t,n,r){let a=GP(r),o=jw(a);if(!(!a||!o)){if(e.has(a))return e.get(a);for(let i=a;i.length>o.length;i=vne(i,o))if(t.has(i))return t.get(i);if(n.has(o))return n.get(o)}}s(VP,"getEntityInDataset");function wne(e,t,n,r){let a=VP(e,t,n,r),o=a&&a.products;if(o&&typeof r=="string"){for(let i of o)for(let c of i.urlPatterns)if(c instanceof RegExp&&c.test(r)||typeof c=="string"&&r.includes(c))return i}}s(wne,"getProductInDataset");function Dne(e){return e.map(t=>{let n={company:t.name,categories:[t.category],...t},r=(t.products||[]).map(a=>({company:n.company,category:n.category,categories:[n.category],facades:[],...a,urlPatterns:(a.urlPatterns||[]).map(o=>o.startsWith("REGEXP:")?new RegExp(o.slice(7)):o)}));return n.products=r,n})}s(Dne,"cloneEntities");function Ene(e){let t=Dne(e),n=new Map,r=new Map,a=new Map;for(let c of t){c.totalExecutionTime=Number(c.totalExecutionTime)||0,c.totalOccurrences=Number(c.totalOccurrences)||0,c.averageExecutionTime=c.totalExecutionTime/c.totalOccurrences;for(let u of c.domains){if(n.has(u)){let m=n.get(u);throw new Error(`Duplicate domain ${u} (${c.name} and ${m.name})`)}n.set(u,c);let l=jw(u);if(u.startsWith("*.")){let m=u.slice(2);m===l?r.set(l,c):a.set(m,c)}}}for(let[c,u]of r.entries())u||r.delete(c);let o=VP.bind(null,n,a,r),i=wne.bind(null,n,a,r);return{getEntity:o,getProduct:i,getRootDomain:jw,entities:t}}s(Ene,"createAPIFromDataset");WP.exports={createAPIFromDataset:Ene}});var YP=I((rMe,xne)=>{xne.exports=[{name:"Google/Doubleclick Ads",company:"Google",homepage:"https://marketingplatform.google.com/about/enterprise/",category:"ad",domains:["adservice.google.com","adservice.google.com.au","adservice.google.com.sg","adservice.google.com.br","adservice.google.com.ua","adservice.google.co.uk","adservice.google.co.jp","adservice.google.co.in","adservice.google.co.kr","adservice.google.co.id","adservice.google.co.nz","adservice.google.ie","adservice.google.se","adservice.google.de","adservice.google.ca","adservice.google.be","adservice.google.es","adservice.google.ch","adservice.google.fr","adservice.google.nl","*.googleadservices.com","*.googlesyndication.com","*.googletagservices.com","*.2mdn.net","*.doubleclick.net"]},{name:"Facebook",homepage:"https://www.facebook.com",category:"social",domains:["*.facebook.com","*.atlassbx.com","*.fbsbx.com","fbcdn-photos-e-a.akamaihd.net","*.facebook.net","*.fbcdn.net"],products:[{name:"Facebook Messenger Customer Chat",urlPatterns:["REGEXP:connect\\.facebook\\.net\\/.*\\/sdk\\/xfbml\\.customerchat\\.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"Instagram",homepage:"https://www.instagram.com",category:"social",domains:["*.cdninstagram.com","*.instagram.com"]},{name:"Google CDN",company:"Google",homepage:"https://developers.google.com/speed/libraries/",category:"cdn",domains:["ajax.googleapis.com","commondatastorage.googleapis.com","www.gstatic.com","ssl.gstatic.com"]},{name:"Google Maps",company:"Google",homepage:"https://www.google.com/maps",category:"utility",domains:["maps.google.com","maps-api-ssl.google.com","maps.googleapis.com","mts.googleapis.com","mt.googleapis.com","mt0.googleapis.com","mt1.googleapis.com","mt2.googleapis.com","mt3.googleapis.com","khm0.googleapis.com","khm1.googleapis.com","khms.googleapis.com","khms1.googleapis.com","khms2.googleapis.com","maps.gstatic.com"]},{name:"Other Google APIs/SDKs",company:"Google",homepage:"https://developers.google.com/apis-explorer/#p/",category:"utility",domains:["accounts.google.com","apis.google.com","calendar.google.com","clients2.google.com","cse.google.com","news.google.com","pay.google.com","payments.google.com","play.google.com","smartlock.google.com","www.google.com","www.google.de","www.google.co.jp","www.google.com.au","www.google.co.uk","www.google.ie","www.google.com.sg","www.google.co.in","www.google.com.br","www.google.ca","www.google.co.kr","www.google.co.nz","www.google.co.id","www.google.fr","www.google.be","www.google.com.ua","www.google.nl","www.google.ru","www.google.se","www.googleapis.com","imasdk.googleapis.com","storage.googleapis.com","translate.googleapis.com","translate.google.com","translate-pa.googleapis.com","lh3.googleusercontent.com","jnn-pa.googleapis.com","csi.gstatic.com"]},{name:"Firebase",homepage:"https://developers.google.com/apis-explorer/#p/",category:"utility",domains:["firebasestorage.googleapis.com","firestore.googleapis.com","firebaseinstallations.googleapis.com","firebase.googleapis.com","firebaseremoteconfig.googleapis.com"]},{name:"Google Analytics",company:"Google",homepage:"https://marketingplatform.google.com/about/analytics/",category:"analytics",domains:["*.google-analytics.com","*.urchin.com","analytics.google.com"]},{name:"Google Optimize",company:"Google",homepage:"https://marketingplatform.google.com/about/optimize/",category:"analytics",domains:["www.googleoptimize.com"]},{name:"Google AMP",company:"Google",homepage:"https://github.com/google/amp-client-id-library",category:"analytics",domains:["ampcid.google.com"]},{name:"Google Tag Manager",company:"Google",homepage:"https://marketingplatform.google.com/about/tag-manager/",category:"tag-manager",domains:["*.googletagmanager.com"]},{name:"Google Fonts",company:"Google",homepage:"https://fonts.google.com/",category:"cdn",domains:["fonts.googleapis.com","fonts.gstatic.com"]},{name:"Adobe TypeKit",company:"Adobe",homepage:"https://fonts.adobe.com/",category:"cdn",domains:["*.typekit.com","*.typekit.net"]},{name:"YouTube",homepage:"https://youtube.com",category:"video",domains:["*.youtube.com","*.ggpht.com","*.youtube-nocookie.com","*.ytimg.com"],products:[{name:"YouTube Embedded Player",urlPatterns:["youtube.com/embed/"],facades:[{name:"Lite YouTube",repo:"https://github.com/paulirish/lite-youtube-embed"},{name:"Ngx Lite Video",repo:"https://github.com/karim-mamdouh/ngx-lite-video"}]}]},{name:"Twitter",homepage:"https://twitter.com",category:"social",domains:["*.vine.co","*.twimg.com","*.twitpic.com","platform.twitter.com","syndication.twitter.com"]},{name:"AddThis",homepage:"https://www.addthis.com/",category:"social",domains:["*.addthis.com","*.addthiscdn.com","*.addthisedge.com"]},{name:"AddToAny",homepage:"https://www.addtoany.com/",category:"social",domains:["*.addtoany.com"]},{name:"Akamai",homepage:"https://www.akamai.com/",category:"cdn",domains:["23.62.3.183","*.akamaitechnologies.com","*.akamaitechnologies.fr","*.akamai.net","*.akamaiedge.net","*.akamaihd.net","*.akamaized.net","*.edgefcs.net","*.edgekey.net","edgesuite.net","*.srip.net"]},{name:"Blogger",homepage:"https://www.blogger.com/",category:"hosting",domains:["*.blogblog.com","*.blogger.com","*.blogspot.com","images-blogger-opensocial.googleusercontent.com"]},{name:"Gravatar",homepage:"https://en.gravatar.com/",category:"social",domains:["*.gravatar.com"]},{name:"Yandex Metrica",company:"Yandex",homepage:"https://metrica.yandex.com/about?",category:"analytics",domains:["mc.yandex.ru","mc.yandex.com","d31j93rd8oukbv.cloudfront.net"]},{name:"Hotjar",homepage:"https://www.hotjar.com/",category:"analytics",domains:["*.hotjar.com","*.hotjar.io"]},{name:"Baidu Analytics",homepage:"https://tongji.baidu.com/web/welcome/login",category:"analytics",domains:["hm.baidu.com","hmcdn.baidu.com"]},{name:"Insider",homepage:"",category:"analytics",domains:["*.useinsider.com"]},{name:"Adobe Experience Cloud",company:"Adobe",homepage:"",category:"analytics",domains:["*.2o7.net","du8783wkf05yr.cloudfront.net","*.hitbox.com","*.imageg.net","*.nedstat.com","*.omtrdc.net"]},{name:"Adobe Tag Manager",company:"Adobe",homepage:"https://www.adobe.com/experience-platform/",category:"tag-manager",domains:["*.adobedtm.com","*.demdex.net","*.everesttech.net","sstats.adobe.com","hbrt.adobe.com"]},{name:"jQuery CDN",homepage:"https://code.jquery.com/",category:"cdn",domains:["*.jquery.com"]},{name:"Cloudflare CDN",homepage:"https://cdnjs.com/",category:"cdn",domains:["cdnjs.cloudflare.com","amp.cloudflare.com"]},{name:"Cloudflare",homepage:"https://www.cloudflare.com/website-optimization/",category:"utility",domains:["ajax.cloudflare.com","*.nel.cloudflare.com","static.cloudflareinsights.com"]},{name:"WordPress",company:"Automattic",homepage:"https://wp.com/",category:"hosting",domains:["*.wordpress.com","s0.wp.com","s2.wp.com","*.w.org","c0.wp.com","s1.wp.com","i0.wp.com","i1.wp.com","i2.wp.com","widgets.wp.com"]},{name:"WordPress Site Stats",company:"Automattic",homepage:"https://wp.com/",category:"analytics",domains:["pixel.wp.com","stats.wp.com"]},{name:"Hatena Blog",homepage:"https://hatenablog.com/",category:"hosting",domains:["*.st-hatena.com","*.hatena.ne.jp"]},{name:"Shopify",homepage:"https://www.shopify.com/",category:"hosting",domains:["*.shopify.com","*.shopifyapps.com","*.shopifycdn.com","*.shopifysvc.com"]},{name:"Dealer",homepage:"https://www.dealer.com/",category:"hosting",domains:["*.dealer.com"]},{name:"PIXNET",homepage:"https://www.pixnet.net/",category:"social",domains:["*.pixfs.net","*.pixnet.net"]},{name:"Moat",homepage:"https://moat.com/",category:"ad",domains:["*.moatads.com","*.moatpixel.com"]},{name:"33 Across",homepage:"https://33across.com/",category:"ad",domains:["*.33across.com"]},{name:"OpenX",homepage:"https://www.openx.com/",category:"ad",domains:["*.deliverimp.com","*.openxadexchange.com","*.servedbyopenx.com","*.jump-time.net","*.openx.net","*.openxcdn.net"]},{name:"Amazon Ads",homepage:"https://ad.amazon.com/",category:"ad",domains:["*.amazon-adsystem.com"]},{name:"Rubicon Project",homepage:"https://rubiconproject.com/",category:"ad",domains:["*.rubiconproject.com","*.chango.com","*.fimserve.com"]},{name:"The Trade Desk",homepage:"https://www.thetradedesk.com/",category:"ad",domains:["*.adsrvr.org","d1eoo1tco6rr5e.cloudfront.net"]},{name:"Bidswitch",homepage:"https://www.bidswitch.com/",category:"ad",domains:["*.bidswitch.net"]},{name:"LiveRamp IdentityLink",homepage:"https://liveramp.com/discover-identitylink/",category:"analytics",domains:["*.circulate.com","*.rlcdn.com"]},{name:"Drawbridge",homepage:"https://www.drawbridge.com/",category:"ad",domains:["*.adsymptotic.com"]},{name:"AOL / Oath / Verizon Media",homepage:"https://www.oath.com/",category:"ad",domains:["*.advertising.com","*.aol.com","*.aolcdn.com","*.blogsmithmedia.com","*.oath.com","*.aol.net","*.tacoda.net","*.aol.co.uk"]},{name:"Xaxis",homepage:"https://www.xaxis.com/",category:"ad",domains:["*.247realmedia.com","*.mookie1.com","*.gmads.net"]},{name:"Freshdesk",company:"Freshworks",homepage:"https://freshdesk.com/",category:"customer-success",domains:["d36mpcpuzc4ztk.cloudfront.net"]},{name:"Help Scout",homepage:"https://www.helpscout.net/",category:"customer-success",domains:["djtflbt20bdde.cloudfront.net","*.helpscout.net"],products:[{name:"Help Scout Beacon",urlPatterns:["beacon-v2.helpscout.net"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"Alexa",homepage:"https://www.alexa.com/",category:"analytics",domains:["*.alexametrics.com","d31qbv1cthcecs.cloudfront.net"]},{name:"OneSignal",homepage:"https://onesignal.com/",category:"utility",domains:["*.onesignal.com"]},{name:"Lucky Orange",homepage:"https://www.luckyorange.com/",category:"analytics",domains:["*.luckyorange.com","d10lpsik1i8c69.cloudfront.net","*.luckyorange.net"]},{name:"Crazy Egg",homepage:"https://www.crazyegg.com/",category:"analytics",domains:["*.cetrk.com","*.crazyegg.com","*.hellobar.com","dnn506yrbagrg.cloudfront.net"]},{name:"Yandex Ads",company:"Yandex",homepage:"https://yandex.com/adv/",category:"ad",domains:["an.yandex.ru"]},{name:"Salesforce",homepage:"https://www.salesforce.com/products/marketing-cloud/",category:"analytics",domains:["*.krxd.net"]},{name:"Salesforce Commerce Cloud",homepage:"https://www.salesforce.com/products/commerce-cloud/overview/",category:"hosting",domains:["*.cquotient.com","*.demandware.net","demandware.edgesuite.net"]},{name:"Optimizely",homepage:"https://www.optimizely.com/",category:"analytics",domains:["*.optimizely.com"]},{name:"LiveChat",homepage:"https://www.livechat.com/",category:"customer-success",domains:["*.livechatinc.com","*.livechat.com","*.livechat-static.com"]},{name:"VK",homepage:"https://vk.com/",category:"social",domains:["*.vk.com"]},{name:"Tumblr",homepage:"https://tumblr.com/",category:"social",domains:["*.tumblr.com"]},{name:"Wistia",homepage:"https://wistia.com/",category:"video",domains:["*.wistia.com","embedwistia-a.akamaihd.net","*.wistia.net"]},{name:"Brightcove",homepage:"https://www.brightcove.com/en/",category:"video",domains:["*.brightcove.com","*.brightcove.net","*.zencdn.net"]},{name:"JSDelivr CDN",homepage:"https://www.jsdelivr.com/",category:"cdn",domains:["*.jsdelivr.net"]},{name:"Sumo",homepage:"https://sumo.com/",category:"marketing",domains:["*.sumo.com","*.sumome.com","sumo.b-cdn.net"]},{name:"Vimeo",homepage:"https://vimeo.com/",category:"video",domains:["*.vimeo.com","*.vimeocdn.com"],products:[{name:"Vimeo Embedded Player",urlPatterns:["player.vimeo.com/video/"],facades:[{name:"Lite Vimeo",repo:"https://github.com/slightlyoff/lite-vimeo"},{name:"Lite Vimeo Embed",repo:"https://github.com/luwes/lite-vimeo-embed"},{name:"Ngx Lite Video",repo:"https://github.com/karim-mamdouh/ngx-lite-video"}]}]},{name:"Disqus",homepage:"https://disqus.com/",category:"social",domains:["*.disqus.com","*.disquscdn.com"]},{name:"Yandex APIs",company:"Yandex",homepage:"https://yandex.ru/",category:"utility",domains:["api-maps.yandex.ru","money.yandex.ru"]},{name:"Yandex CDN",company:"Yandex",homepage:"https://yandex.ru/",category:"cdn",domains:["*.yandex.st","*.yastatic.net"]},{name:"Integral Ad Science",homepage:"https://integralads.com/uk/",category:"ad",domains:["*.adsafeprotected.com","*.iasds01.com"]},{name:"Tealium",homepage:"https://tealium.com/",category:"tag-manager",domains:["*.aniview.com","*.delvenetworks.com","*.limelight.com","*.tiqcdn.com","*.llnwd.net","*.tealiumiq.com"]},{name:"Pubmatic",homepage:"https://pubmatic.com/",category:"ad",domains:["*.pubmatic.com"]},{name:"Olark",homepage:"https://www.olark.com/",category:"customer-success",domains:["*.olark.com"]},{name:"Tawk.to",homepage:"https://www.tawk.to/",category:"customer-success",domains:["*.tawk.to"]},{name:"OptinMonster",homepage:"https://optinmonster.com/",category:"marketing",domains:["*.opmnstr.com","*.optmnstr.com","*.optmstr.com"]},{name:"ZenDesk",homepage:"https://zendesk.com/",category:"customer-success",domains:["*.zdassets.com","*.zendesk.com","*.zopim.com"]},{name:"Pusher",homepage:"https://pusher.com/",category:"utility",domains:["*.pusher.com","*.pusherapp.com"]},{name:"Drift",homepage:"https://www.drift.com/",category:"marketing",domains:["*.drift.com","*.driftt.com"],products:[{name:"Drift Live Chat",urlPatterns:["REGEXP:js\\.driftt\\.com\\/include\\/.*\\/.*\\.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"Sentry",homepage:"https://sentry.io/",category:"utility",domains:["*.getsentry.com","*.ravenjs.com","*.sentry-cdn.com","*.sentry.io"]},{name:"Amazon Web Services",homepage:"https://aws.amazon.com/s3/",category:"other",domains:["*.amazon.com","*.amazonaws.com","*.amazonwebapps.com","*.amazonwebservices.com","*.elasticbeanstalk.com","*.images-amazon.com","*.amazon.co.uk"]},{name:"Amazon Pay",homepage:"https://pay.amazon.com",category:"utility",domains:["payments.amazon.com","*.payments-amazon.com"]},{name:"Media.net",homepage:"https://www.media.net/",category:"ad",domains:["*.media.net","*.mnet-ad.net"]},{name:"Yahoo!",homepage:"https://www.yahoo.com/",category:"ad",domains:["*.bluelithium.com","*.hostingprod.com","*.lexity.com","*.yahoo.com","*.yahooapis.com","*.yimg.com","*.zenfs.com","*.yahoo.net"]},{name:"Adroll",homepage:"https://www.adroll.com/",category:"ad",domains:["*.adroll.com"]},{name:"Twitch",homepage:"https://twitch.tv/",category:"video",domains:["*.twitch.tv"]},{name:"Taboola",homepage:"https://www.taboola.com/",category:"ad",domains:["*.taboola.com","*.taboolasyndication.com"]},{name:"Sizmek",homepage:"https://www.sizmek.com/",category:"ad",domains:["*.serving-sys.com","*.peer39.net"]},{name:"Scorecard Research",homepage:"https://www.scorecardresearch.com/",category:"ad",domains:["*.scorecardresearch.com"]},{name:"Criteo",homepage:"https://www.criteo.com/",category:"ad",domains:["*.criteo.com","*.emailretargeting.com","*.criteo.net"]},{name:"Segment",homepage:"https://segment.com/",category:"analytics",domains:["*.segment.com","*.segment.io"]},{name:"ShareThis",homepage:"https://www.sharethis.com/",category:"social",domains:["*.sharethis.com"]},{name:"Distil Networks",homepage:"https://www.distilnetworks.com/",category:"utility",domains:["*.areyouahuman.com"]},{name:"Connexity",homepage:"https://connexity.com/",category:"analytics",domains:["*.connexity.net"]},{name:"Popads",homepage:"https://www.popads.net/",category:"ad",domains:["*.popads.net"]},{name:"CreateJS CDN",homepage:"https://code.createjs.com/",category:"cdn",domains:["*.createjs.com"]},{name:"Squarespace",homepage:"https://www.squarespace.com/",category:"hosting",domains:["*.squarespace.com"]},{name:"Media Math",homepage:"https://www.mediamath.com/",category:"ad",domains:["*.mathads.com","*.mathtag.com"]},{name:"Mixpanel",homepage:"https://mixpanel.com/",category:"analytics",domains:["*.mixpanel.com","*.mxpnl.com"]},{name:"FontAwesome CDN",homepage:"https://fontawesome.com/",category:"cdn",domains:["*.fontawesome.com"]},{name:"Hubspot",homepage:"https://hubspot.com/",category:"marketing",domains:["*.hs-scripts.com","*.hubspot.com","*.leadin.com","*.hs-analytics.net","*.hscollectedforms.net","*.hscta.net","*.hsforms.net","*.hsleadflows.net","*.hsstatic.net","*.hubspot.net","*.hsforms.com","*.hs-banner.com","*.hs-embed-reporting.com","*.hs-growth-metrics.com","*.hs-data.com","*.hsadspixel.net","*.hubapi.com"]},{name:"Mailchimp",homepage:"https://mailchimp.com/",category:"marketing",domains:["*.chimpstatic.com","*.list-manage.com","*.mailchimp.com"]},{name:"MGID",homepage:"https://www.mgid.com/",category:"ad",domains:["*.mgid.com","*.dt07.net"]},{name:"Stripe",homepage:"https://stripe.com",category:"utility",domains:["*.stripe.com","*.stripecdn.com","*.stripe.network"]},{name:"PayPal",homepage:"https://paypal.com",category:"utility",domains:["*.paypal.com","*.paypalobjects.com"]},{name:"Market GID",homepage:"https://www.marketgid.com/",category:"ad",domains:["*.marketgid.com"]},{name:"Pinterest",homepage:"https://pinterest.com/",category:"social",domains:["*.pinimg.com","*.pinterest.com"]},{name:"New Relic",homepage:"https://newrelic.com/",category:"utility",domains:["*.newrelic.com","*.nr-data.net"]},{name:"AppDynamics",homepage:"https://www.appdynamics.com/",category:"utility",domains:["*.appdynamics.com","*.eum-appdynamics.com","d3tjaysgumg9lf.cloudfront.net"]},{name:"Parking Crew",homepage:"https://parkingcrew.net/",category:"other",domains:["d1lxhc4jvstzrp.cloudfront.net","*.parkingcrew.net"]},{name:"WordAds",company:"Automattic",homepage:"https://wordads.co/",category:"ad",domains:["*.pubmine.com"]},{name:"AppNexus",homepage:"https://www.appnexus.com/",category:"ad",domains:["*.adnxs.com","*.ctasnet.com","*.adrdgt.com"]},{name:"Histats",homepage:"https://www.histats.com/",category:"analytics",domains:["*.histats.com"]},{name:"DoubleVerify",homepage:"https://www.doubleverify.com/",category:"ad",domains:["*.doubleverify.com","*.dvtps.com","*.iqfp1.com"]},{name:"Mediavine",homepage:"https://www.mediavine.com/",category:"ad",domains:["*.mediavine.com"]},{name:"Wix",homepage:"https://www.wix.com/",category:"hosting",domains:["*.parastorage.com","*.wix.com","*.wixstatic.com","*.wixapps.net"]},{name:"Webflow",homepage:"https://webflow.com/",category:"hosting",domains:["*.uploads-ssl.webflow.com","*.assets-global.website-files.com","*.assets.website-files.com"]},{name:"Weebly",homepage:"https://www.weebly.com/",category:"hosting",domains:["*.editmysite.com"]},{name:"LinkedIn",homepage:"https://www.linkedin.com/",category:"social",domains:["*.bizographics.com","platform.linkedin.com","*.slideshare.com","*.slidesharecdn.com","*.oribi.io"]},{name:"LinkedIn Ads",category:"ad",domains:["*.licdn.com","*.ads.linkedin.com","ads.linkedin.com","www.linkedin.com"]},{name:"Vox Media",homepage:"https://www.voxmedia.com/",category:"content",domains:["*.vox-cdn.com","*.voxmedia.com"]},{name:"Hotmart",homepage:"https://www.hotmart.com/",category:"content",domains:["*.hotmart.com"]},{name:"SoundCloud",homepage:"https://www.soundcloud.com/",category:"content",domains:["*.sndcdn.com","*.soundcloud.com","*.stratus.sc"]},{name:"Spotify",homepage:"https://www.spotify.com/",category:"content",domains:["*.scdn.co","*.spotify.com"]},{name:"AMP",homepage:"https://amp.dev/",category:"content",domains:["*.ampproject.org"]},{name:"Beeketing",homepage:"https://beeketing.com/",category:"marketing",domains:["*.beeketing.com"]},{name:"Albacross",homepage:"https://albacross.com/",category:"marketing",domains:["*.albacross.com"]},{name:"TrafficJunky",homepage:"https://www.trafficjunky.com/",category:"ad",domains:["*.contentabc.com","*.trafficjunky.net"]},{name:"Bootstrap CDN",homepage:"https://www.bootstrapcdn.com/",category:"cdn",domains:["*.bootstrapcdn.com"]},{name:"Shareaholic",homepage:"https://www.shareaholic.com/",category:"social",domains:["*.shareaholic.com","dsms0mj1bbhn4.cloudfront.net"]},{name:"Snowplow",homepage:"https://snowplowanalytics.com/",category:"analytics",domains:["d32hwlnfiv2gyn.cloudfront.net"]},{name:"RD Station",homepage:"https://www.rdstation.com/en/",category:"marketing",domains:["d335luupugsy2.cloudfront.net"]},{name:"Jivochat",homepage:"https://www.jivochat.com/",category:"customer-success",domains:["*.jivosite.com"]},{name:"Listrak",homepage:"https://www.listrak.com/",category:"marketing",domains:["*.listrak.com","*.listrakbi.com"]},{name:"Ontame",homepage:"https://www.ontame.io",category:"analytics",domains:["*.ontame.io"]},{name:"Ipify",homepage:"https://www.ipify.org",category:"utility",domains:["*.ipify.org"]},{name:"Ensighten",homepage:"https://www.ensighten.com/",category:"tag-manager",domains:["*.ensighten.com"]},{name:"EpiServer",homepage:"https://www.episerver.com",category:"content",domains:["*.episerver.net"]},{name:"mPulse",homepage:"https://developer.akamai.com/akamai-mpulse",category:"analytics",domains:["*.akstat.io","*.go-mpulse.net","*.mpulse.net","*.mpstat.us"]},{name:"Pingdom RUM",homepage:"https://www.pingdom.com/product/performance-monitoring/",category:"analytics",domains:["*.pingdom.net"]},{name:"SpeedCurve RUM",company:"SpeedCurve",homepage:"https://www.speedcurve.com/features/performance-monitoring/",category:"analytics",domains:["*.speedcurve.com"]},{name:"Radar",company:"Cedexis",homepage:"https://www.cedexis.com/radar/",category:"analytics",domains:["*.cedexis-test.com","*.cedexis.com","*.cmdolb.com","cedexis.leasewebcdn.com","*.cedexis-radar.net","*.cedexis.net","cedexis-test01.insnw.net","cedexisakamaitest.azureedge.net","cedexispub.cdnetworks.net","cs600.wac.alphacdn.net","cs600.wpc.edgecastdns.net","global2.cmdolb.com","img-cedexis.mncdn.com","a-cedexis.msedge.net","zn3vgszfh.fastestcdn.net"]},{name:"Byside",homepage:"https://byside.com",category:"analytics",domains:["*.byside.com"]},{name:"VWO",homepage:"https://vwo.com",category:"analytics",domains:["*.vwo.com","*.visualwebsiteoptimizer.com","d5phz18u4wuww.cloudfront.net","*.wingify.com"]},{name:"Bing Ads",homepage:"https://bingads.microsoft.com",category:"ad",domains:["*.bing.com","*.microsoft.com","*.msn.com","*.s-msft.com","*.s-msn.com","*.msads.net","*.msecnd.net"]},{name:"GoSquared",homepage:"https://www.gosquared.com",category:"analytics",domains:["*.gosquared.com","d1l6p2sc9645hc.cloudfront.net"]},{name:"Usabilla",homepage:"https://usabilla.com",category:"analytics",domains:["*.usabilla.com","d6tizftlrpuof.cloudfront.net"]},{name:"Fastly Insights",homepage:"https://insights.fastlylabs.com",category:"analytics",domains:["*.fastly-insights.com"]},{name:"Visual IQ",homepage:"https://www.visualiq.com",category:"analytics",domains:["*.myvisualiq.net"]},{name:"Snapchat",homepage:"https://www.snapchat.com",category:"analytics",domains:["*.snapchat.com","*.sc-static.net"]},{name:"Atlas Solutions",homepage:"https://atlassolutions.com",category:"analytics",domains:["*.atdmt.com"]},{name:"Quantcast",homepage:"https://www.quantcast.com",category:"analytics",domains:["*.brtstats.com","*.quantcount.com","*.quantserve.com","*.semantictec.com","*.ntv.io"]},{name:"Spiceworks",homepage:"https://www.spiceworks.com",category:"analytics",domains:["*.spiceworks.com"]},{name:"Marketo",homepage:"https://www.marketo.com",category:"analytics",domains:["*.marketo.com","*.mktoresp.com","*.marketo.net"]},{name:"Intercom",homepage:"https://www.intercom.com",category:"customer-success",domains:["*.intercomcdn.com","*.intercom.io"],products:[{name:"Intercom Widget",urlPatterns:["widget.intercom.io","js.intercomcdn.com/shim.latest.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"},{name:"Intercom Facade",repo:"https://github.com/danielbachhuber/intercom-facade/"}]}]},{name:"Unpkg",homepage:"https://unpkg.com",category:"cdn",domains:["*.unpkg.com","*.npmcdn.com"]},{name:"ReadSpeaker",homepage:"https://www.readspeaker.com",category:"other",domains:["*.readspeaker.com"]},{name:"Browsealoud",homepage:"https://www.texthelp.com/en-gb/products/browsealoud/",category:"other",domains:["*.browsealoud.com","*.texthelp.com"]},{name:"15gifts",category:"customer-success",domains:["*.15gifts.com","*.primefuse.com"]},{name:"1xRUN",category:"utility",domains:["*.1xrun.com"]},{name:"2AdPro Media Solutions",category:"ad",domains:["*.2adpro.com"]},{name:"301 Digital Media",category:"content",domains:["*.301ads.com","*.301network.com"]},{name:"360 picnic platform",company:"MediaV",category:"ad",domains:["*.mediav.com"]},{name:"365 Media Group",category:"content",domains:["*.365dm.com"]},{name:"365 Tech Services",category:"hosting",domains:["*.365webservices.co.uk"]},{name:"3D Issue",category:"utility",domains:["*.3dissue.com","*.pressjack.com"]},{name:"47Line Technologies",category:"other",domains:["*.pejs.net"]},{name:"4finance",category:"utility",domains:["*.4finance.com"]},{name:"5miles",category:"content",domains:["*.5milesapp.com"]},{name:"77Tool",company:"77Agency",category:"analytics",domains:["*.77tracking.com"]},{name:"9xb",category:"ad",domains:["*.9xb.com"]},{name:"@UK",category:"hosting",domains:["*.uk-plc.net"]},{name:"A Perfect Pocket",category:"hosting",domains:["*.aperfectpocketdata.com"]},{name:"A-FIS PTE",category:"analytics",domains:["*.websta.me"]},{name:"AB Tasty",category:"analytics",domains:["*.abtasty.com","d1447tq2m68ekg.cloudfront.net"]},{name:"ABA RESEARCH",category:"analytics",domains:["*.abaresearch.uk","qmodal.azurewebsites.net"]},{name:"ADMIZED",category:"ad",domains:["*.admized.com"]},{name:"ADNOLOGIES",category:"ad",domains:["*.heias.com"]},{name:"ADventori",category:"ad",domains:["*.adventori.com"]},{name:"AI Media Group",category:"ad",domains:["*.aimediagroup.com"]},{name:"AIR.TV",category:"ad",domains:["*.air.tv"]},{name:"AKQA",category:"ad",domains:["*.srtk.net"]},{name:"AOL ad",company:"AOL",category:"ad",domains:["*.atwola.com"]},{name:"AOL On",company:"AOL",category:"content",domains:["*.5min.com"]},{name:"AOL Sponsored Listiings",company:"AOL",category:"ad",domains:["*.adsonar.com"]},{name:"APSIS Lead",company:"APSIS International AB",category:"ad",domains:["*.prospecteye.com"]},{name:"APSIS Profile Cloud",company:"APSIS",category:"analytics",domains:["*.innomdc.com"]},{name:"APSIS Forms",company:"APSIS",category:"other",domains:["*.apsisforms.com"]},{name:"ARENA",company:"Altitude",category:"ad",domains:["*.altitude-arena.com"]},{name:"ARM",category:"analytics",domains:["*.tag4arm.com"]},{name:"ASAPP",category:"other",domains:["*.asapp.com"]},{name:"ASP",category:"hosting",domains:["*.goshowoff.com"]},{name:"AT Internet",category:"analytics",domains:["*.ati-host.net"]},{name:"ATTRAQT",category:"utility",domains:["*.attraqt.com","*.locayta.com"]},{name:"AVANSER",category:"analytics",domains:["*.avanser.com.au"]},{name:"AVG",company:"AVG Technologies",category:"utility",domains:["*.avg.com"]},{name:"AWeber",category:"ad",domains:["*.aweber.com"]},{name:"AXS",category:"content",domains:["*.axs.com"]},{name:"Accentuate",company:"Accentuate Digital",category:"utility",homepage:"https://www.accentuate.io/",domains:["*.accentuate.io"]},{name:"Accenture",category:"analytics",domains:["*.tmvtp.com"]},{name:"Accord Holdings",category:"ad",domains:["*.agcdn.com"]},{name:"Accordant Media",category:"ad",domains:["*.a3cloud.net"]},{name:"Account Kit",category:"other",domains:["*.accountkit.com"]},{name:"Accuen Media (Omnicom Media Group)",category:"content",domains:["*.p-td.com"]},{name:"Accuweather",category:"content",domains:["*.accuweather.com"]},{name:"Acquisio",category:"ad",domains:["*.acq.io"]},{name:"Act-On Software",category:"marketing",domains:["*.actonsoftware.com"]},{name:"ActBlue",category:"other",domains:["*.actblue.com"]},{name:"Active Agent",category:"ad",domains:["*.active-agent.com"]},{name:"ActiveCampaign",category:"ad",domains:["*.trackcmp.net","app-us1.com","*.app-us1.com"]},{name:"AcuityAds",category:"ad",domains:["*.acuityplatform.com"]},{name:"Acxiom",category:"ad",domains:["*.acxiom-online.com","*.acxiomapac.com","*.delivery.net"]},{name:"Ad4Screen",category:"ad",domains:["*.a4.tl"]},{name:"Ad6Media",category:"ad",domains:["*.ad6media.fr"]},{name:"AdCurve",category:"ad",domains:["*.shop2market.com"]},{name:"AdEasy",category:"ad",domains:["*.adeasy.ru"]},{name:"AdExtent",category:"ad",domains:["*.adextent.com"]},{name:"AdForge Edge",company:"AdForge",category:"ad",domains:["*.adforgeinc.com"]},{name:"AdGear",company:"Samsung Electronics",category:"ad",domains:["*.adgear.com","*.adgrx.com"]},{name:"AdInMedia",category:"ad",domains:["*.fastapi.net"]},{name:"AdJug",category:"ad",domains:["*.adjug.com"]},{name:"AdMatic",category:"ad",domains:["*.admatic.com.tr"]},{name:"AdMedia",category:"ad",domains:["*.admedia.com"]},{name:"AdRecover",category:"ad",domains:["*.adrecover.com"]},{name:"AdRiver",category:"ad",domains:["*.adriver.ru"]},{name:"AdSniper",category:"ad",domains:["*.adsniper.ru","*.sniperlog.ru"]},{name:"AdSpeed",category:"ad",domains:["*.adspeed.net"]},{name:"AdSpruce",category:"ad",domains:["*.adspruce.com"]},{name:"AdSupply",category:"ad",domains:["*.doublepimp.com"]},{name:"AdTheorent",category:"ad",domains:["*.adentifi.com"]},{name:"AdThink AudienceInsights",company:"AdThink Media",category:"analytics",domains:["*.audienceinsights.net"]},{name:"AdTrue",company:"FPT AdTrue",category:"ad",domains:["*.adtrue.com"]},{name:"AdYapper",category:"ad",domains:["*.adyapper.com"]},{name:"Adacado",category:"ad",domains:["*.adacado.com"]},{name:"Adap.tv",category:"ad",domains:["*.adap.tv"]},{name:"Adapt Services",category:"hosting",domains:["*.adcmps.com"]},{name:"Adaptive Web",category:"hosting",domains:["*.adaptive.co.uk"]},{name:"Adara Media",category:"ad",domains:["*.yieldoptimizer.com"]},{name:"Adblade",category:"ad",domains:["*.adblade.com"]},{name:"Adbrain",category:"ad",domains:["*.adbrn.com"]},{name:"AddEvent",category:"utility",domains:["*.addevent.com"]},{name:"AddShoppers",category:"social",domains:["*.addshoppers.com","d3rr3d0n31t48m.cloudfront.net","*.shop.pe"]},{name:"AddThisEvent",category:"hosting",domains:["*.addthisevent.com"]},{name:"Addoox MetaNetwork",company:"Addoox",category:"ad",domains:["*.metanetwork.net"]},{name:"Addvantage Media",category:"ad",domains:["*.addvantagemedia.com","*.simplytechnology.net"]},{name:"AD EBis",category:"analytics",homepage:"https://www.ebis.ne.jp/",domains:["*.ebis.ne.jp"]},{name:"Adecs",category:"customer-success",domains:["*.adecs.co.uk"]},{name:"Adelphic",category:"ad",domains:["*.ipredictive.com"]},{name:"Adestra",category:"ad",domains:["*.adestra.com","*.msgfocus.com"]},{name:"Adform",category:"ad",domains:["*.adform.net","*.adformdsp.net"]},{name:"Adkontekst",category:"ad",domains:["*.adkontekst.pl"]},{name:"Adlead",category:"ad",domains:["*.webelapp.com"]},{name:"Adledge",category:"utility",domains:["*.adledge.com"]},{name:"Adloox",category:"ad",domains:["*.adlooxtracking.com"]},{name:"Adlux",category:"ad",domains:["*.adlux.com"]},{name:"Admedo",category:"ad",domains:["*.a8723.com","*.adizio.com","*.admedo.com"]},{name:"Admeta",company:"Wideorbit",category:"ad",domains:["*.atemda.com"]},{name:"Admetrics",company:"Next Tuesday",category:"analytics",domains:["*.nt.vc"]},{name:"Admiral",category:"ad",domains:["*.unknowntray.com"]},{name:"Admitad",category:"ad",domains:["*.lenmit.com"]},{name:"Admixer for Publishers",company:"Admixer",category:"ad",domains:["*.admixer.net"]},{name:"Adnium",category:"ad",domains:["*.adnium.com"]},{name:"Adnostic",company:"Dennis Publishing",category:"ad",domains:["*.adnostic.co.uk"]},{name:"Adobe Marketing Cloud",company:"Adobe Systems",category:"ad",domains:["*.adobetag.com"]},{name:"Adobe Scene7",company:"Adobe Systems",category:"content",domains:["wwwimages.adobe.com","*.scene7.com","*.everestads.net","*.everestjs.net"]},{name:"Adobe Systems",category:"content",domains:["adobe.com","www.adobe.com"]},{name:"Adobe Business Catalyst",homepage:"https://www.businesscatalyst.com/",category:"hosting",domains:["*.businesscatalyst.com"]},{name:"Adocean",company:"Gemius",category:"ad",domains:["*.adocean.pl"]},{name:"Adometry",company:"Google",category:"ad",domains:["*.dmtry.com"]},{name:"Adomik",category:"analytics",domains:["*.adomik.com"]},{name:"Adotmob",category:"ad",domains:["*.adotmob.com"]},{name:"Adrian Quevedo",category:"hosting",domains:["*.adrianquevedo.com"]},{name:"Adroit Digital Solutions",category:"ad",domains:["*.imiclk.com","*.abmr.net"]},{name:"AdsNative",category:"ad",domains:["*.adsnative.com"]},{name:"AdsWizz",category:"ad",domains:["*.adswizz.com"]},{name:"Adscale",category:"ad",domains:["*.adscale.de"]},{name:"Adschoom",company:"JSWeb Production",category:"ad",domains:["*.adschoom.com"]},{name:"Adscience",category:"ad",domains:["*.adscience.nl"]},{name:"Adsiduous",category:"ad",domains:["*.adsiduous.com"]},{name:"Adsty",category:"ad",domains:["*.adx1.com"]},{name:"Adtech (AOL)",category:"ad",domains:["*.adtechus.com"]},{name:"Adtegrity",category:"ad",domains:["*.adtpix.com"]},{name:"Adthink",company:"Adthink Media",category:"ad",domains:["*.adxcore.com","*.dcoengine.com"]},{name:"AdultWebmasterEmpire.Com",category:"ad",domains:["*.awempire.com"]},{name:"Adunity",category:"ad",domains:["*.adunity.com"]},{name:"Advance Magazine Group",category:"content",domains:["*.condenastdigital.com","*.condenet.com","*.condenast.co.uk"]},{name:"Adverline Board",company:"Adverline",category:"ad",domains:["*.adverline.com","*.adnext.fr"]},{name:"AdvertServe",category:"ad",domains:["*.advertserve.com"]},{name:"Advolution",category:"utility",domains:["*.advolution.de"]},{name:"Adwise",category:"ad",domains:["*.adwise.bg"]},{name:"Adyen",category:"utility",domains:["*.adyen.com"]},{name:"Adyoulike",category:"ad",domains:["*.adyoulike.com","*.omnitagjs.com","*.adyoulike.net"]},{name:"Adzerk",category:"ad",domains:["*.adzerk.net"]},{name:"Adzip",company:"Adbox Digital",category:"ad",domains:["*.adzip.co"]},{name:"AerServ",category:"ad",domains:["*.aerserv.com"]},{name:"Affectv",category:"ad",domains:["*.affectv.com","*.affec.tv"]},{name:"Affiliate Window",company:"Digital Window",category:"ad",domains:["*.dwin1.com"]},{name:"Affiliatly",category:"ad",domains:["*.affiliatly.com"]},{name:"Affino",category:"ad",domains:["affino.com"]},{name:"Affirm",category:"utility",domains:["*.affirm.com"]},{name:"Afterpay",company:"Block",category:"utility",homepage:"https://www.afterpay.com/",domains:["*.afterpay.com"]},{name:"Agenda Media",category:"ad",domains:["*.agendamedia.co.uk"]},{name:"Aggregate Knowledge",company:"Neustar",category:"ad",domains:["*.agkn.com"]},{name:"AgilOne",category:"marketing",domains:["*.agilone.com"]},{name:"Agility",category:"hosting",domains:["*.agilitycms.com"]},{name:"Ahalogy",category:"social",domains:["*.ahalogy.com"]},{name:"Aheadworks",category:"utility",domains:["*.aheadworks.com"]},{name:"AirPR",category:"analytics",domains:["*.airpr.com"]},{name:"Aira",category:"ad",domains:["*.aira.net"]},{name:"Airport Parking and Hotels",category:"content",domains:["*.aph.com"]},{name:"Akanoo",category:"analytics",domains:["*.akanoo.com"]},{name:"Alchemy",company:"AndBeyond.Media",category:"ad",domains:["*.andbeyond.media"]},{name:"AlephD",company:"AOL",category:"ad",domains:["*.alephd.com"]},{name:"AliveChat",company:"AYU Technology Solutions",category:"customer-success",domains:["*.websitealive.com","*.websitealive7.com"]},{name:"All Access",category:"other",domains:["*.allaccess.com.ph"]},{name:"Alliance for Audited Media",category:"ad",domains:["*.aamsitecertifier.com"]},{name:"Allyde",category:"marketing",domains:["*.mautic.com"]},{name:"AlphaSSL",category:"utility",domains:["*.alphassl.com"]},{name:"Altitude",category:"ad",domains:["*.altitudeplatform.com"]},{name:"Altocloud",category:"analytics",domains:["*.altocloud.com"]},{name:"Amadeus",category:"content",domains:["*.e-travel.com"]},{name:"Amazon CloudFront",company:"Amazon",category:"utility",domains:["cloudfront.net"]},{name:"Ambassador",category:"ad",domains:["*.getambassador.com"]},{name:"Ambient",company:"Ericcson",category:"other",domains:["*.adnetwork.vn","*.ambientplatform.vn"]},{name:"Amelia Communication",category:"hosting",domains:["*.sara.media"]},{name:"Amobee",category:"marketing",domains:["*.amgdgt.com","*.kontera.com"]},{name:"Amplience",category:"marketing",domains:["*.10cms.com","*.amplience.com","*.amplience.net","*.bigcontent.io","*.adis.ws"]},{name:"Amplitude Mobile Analytics",company:"Amplitude",category:"analytics",domains:["*.amplitude.com","d24n15hnbwhuhn.cloudfront.net"]},{name:"Anametrix",company:"Ensighten",category:"analytics",domains:["*.anametrix.com"]},{name:"Ancora Platform",company:"Ancora Media Solutions",category:"ad",domains:["*.ancoraplatform.com"]},{name:"Anedot",category:"other",domains:["*.anedot.com"]},{name:"AnimateJS",category:"utility",domains:["*.animatedjs.com"]},{name:"AnswerDash",category:"customer-success",domains:["*.answerdash.com"]},{name:"Answers",category:"analytics",domains:["*.answcdn.com","*.answers.com","*.dsply.com"]},{name:"Apester",category:"analytics",domains:["*.apester.com","*.qmerce.com"]},{name:"Apligraf SmartWeb",company:"Apligraf",category:"utility",domains:["*.apligraf.com.br"]},{name:"Appier",category:"ad",domains:["*.appier.net"]},{name:"Appsolute",category:"utility",homepage:"https://appsolute.us/",domains:["dropahint.love"]},{name:"Apptus eSales",company:"Apptus",category:"analytics",domains:["*.apptus.com"]},{name:"Arbor",company:"LiveRamp",category:"other",domains:["*.pippio.com"]},{name:"Ardent Creative",category:"hosting",domains:["*.ardentcreative.co.uk"]},{name:"Arnold Clark Automobiles",category:"content",domains:["*.arnoldclark.com"]},{name:"Atom Content Marketing",category:"content",domains:["*.atomvault.net"]},{name:"Atom Data",category:"other",domains:["*.atomdata.io"]},{name:"Attribution",category:"ad",domains:["*.attributionapp.com"]},{name:"Audience 360",company:"Datapoint Media",category:"ad",domains:["*.dpmsrv.com"]},{name:"Audience Science",category:"ad",domains:["*.revsci.net"]},{name:"AudienceSearch",company:"Intimate Merger",category:"ad",domains:["*.im-apps.net"]},{name:"Auditorius",category:"ad",domains:["*.audtd.com"]},{name:"Augur",category:"analytics",domains:["*.augur.io"]},{name:"Auto Link Maker",company:"Apple",category:"ad",domains:["*.apple.com"]},{name:"Autopilot",category:"ad",domains:["*.autopilothq.com"]},{name:"Avail",company:"RichRelevance",category:"ad",domains:["*.avail.net"]},{name:"AvantLink",category:"ad",domains:["*.avmws.com"]},{name:"Avco Systems",category:"utility",domains:["*.avcosystems.com"]},{name:"Avid Media",category:"customer-success",domains:["*.adspdbl.com","*.metadsp.co.uk"]},{name:"Avocet Systems",category:"ad",domains:["*.avocet.io","ads.avct.cloud"]},{name:"Avora",category:"analytics",domains:["*.truedash.com"]},{name:"Azure Traffic Manager",company:"Microsoft",category:"other",domains:["*.gateway.net","*.trafficmanager.net"]},{name:"Azure Web Services",company:"Microsoft",category:"cdn",domains:["*.azurewebsites.net","*.azureedge.net","*.msedge.net","*.windows.net"]},{name:"BAM",category:"analytics",domains:["*.bam-x.com"]},{name:"Baifendian Technology",category:"marketing",domains:["*.baifendian.com"]},{name:"Bankrate",category:"utility",domains:["*.bankrate.com"]},{name:"BannerFlow",company:"Nordic Factory Solutions",category:"ad",domains:["*.bannerflow.com"]},{name:"Barclaycard SmartPay",company:"Barclaycard",category:"utility",domains:["*.barclaycardsmartpay.com"]},{name:"Barilliance",category:"analytics",domains:["*.barilliance.net","dn3y71tq7jf07.cloudfront.net"]},{name:"Barnebys",category:"other",domains:["*.barnebys.com"]},{name:"Basis",company:"Basis Technologies",category:"ad",homepage:"https://basis.net/",domains:["*.basis.net"]},{name:"Batch Media",category:"ad",domains:["*.t4ft.de"]},{name:"Bauer Consumer Media",category:"content",domains:["*.bauercdn.com","*.greatmagazines.co.uk"]},{name:"Baynote",category:"analytics",domains:["*.baynote.net"]},{name:"Bazaarvoice",category:"analytics",domains:["*.bazaarvoice.com","*.feedmagnet.com"]},{name:"Beachfront Media",category:"ad",domains:["*.bfmio.com"]},{name:"BeamPulse",category:"analytics",domains:["*.beampulse.com"]},{name:"Beeswax",category:"ad",domains:["*.bidr.io"]},{name:"Beetailer",category:"social",domains:["*.beetailer.com"]},{name:"Best Of Media S.A.",category:"content",domains:["*.servebom.com"]},{name:"Bet365",category:"ad",domains:["*.bet365affiliates.com"]},{name:"Betfair",category:"other",domains:["*.cdnbf.net"]},{name:"Betgenius",company:"Genius Sports",category:"content",domains:["*.connextra.com"]},{name:"Better Banners",category:"ad",domains:["*.betterbannerscloud.com"]},{name:"Better Business Bureau",category:"analytics",domains:["*.bbb.org"]},{name:"Between Digital",category:"ad",domains:["*.betweendigital.com"]},{name:"BidTheatre",category:"ad",domains:["*.bidtheatre.com"]},{name:"Bidtellect",category:"ad",domains:["*.bttrack.com"]},{name:"Bigcommerce",category:"marketing",domains:["*.bigcommerce.com"]},{name:"BitGravity",company:"Tata Communications",category:"content",domains:["*.bitgravity.com"]},{name:"Bitly",category:"utility",domains:["*.bitly.com","*.lemde.fr","*.bit.ly"]},{name:"Bizible",category:"ad",domains:["*.bizible.com","*.bizibly.com"]},{name:"Bizrate",category:"analytics",domains:["*.bizrate.com"]},{name:"BlastCasta",category:"social",domains:["*.poweringnews.com"]},{name:"Blindado",category:"utility",domains:["*.siteblindado.com"]},{name:"Blis",category:"ad",domains:["*.blismedia.com"]},{name:"Blogg.se",category:"hosting",domains:["*.cdnme.se","*.publishme.se"]},{name:"BloomReach",category:"ad",domains:["*.brcdn.com","*.brsrvr.com","*.brsvr.com"]},{name:"Bloomberg",category:"content",domains:["*.gotraffic.net"]},{name:"Shop Logic",company:"BloomReach",category:"marketing",domains:["*.goshoplogic.com"]},{name:"Blue State Digital",category:"ad",domains:["*.bsd.net"]},{name:"Blue Triangle Technologies",category:"analytics",domains:["*.btttag.com"]},{name:"BlueCava",category:"ad",domains:["*.bluecava.com"]},{name:"BlueKai",company:"Oracle",category:"ad",domains:["*.bkrtx.com","*.bluekai.com"]},{name:"Bluecore",category:"analytics",domains:["*.bluecore.com"]},{name:"Bluegg",category:"hosting",domains:["d1va5oqn59yrvt.cloudfront.net"]},{name:"Bold Commerce",category:"utility",domains:["*.shappify-cdn.com","*.shappify.com","*.boldapps.net"]},{name:"BoldChat",company:"LogMeIn",category:"customer-success",domains:["*.boldchat.com"]},{name:"Bombora",category:"ad",domains:["*.mlno6.com"]},{name:"Bonnier",category:"content",domains:["*.bonniercorp.com"]},{name:"Bookatable",category:"content",domains:["*.bookatable.com","*.livebookings.com"]},{name:"Booking.com",category:"content",domains:["*.bstatic.com"]},{name:"Boomtrain",category:"ad",domains:["*.boomtrain.com","*.boomtrain.net"]},{name:"BoostSuite",category:"ad",domains:["*.poweredbyeden.com"]},{name:"Boostable",category:"ad",domains:["*.boostable.com"]},{name:"Bootstrap Chinese network",category:"cdn",domains:["*.bootcss.com"]},{name:"Booxscale",category:"ad",domains:["*.booxscale.com"]},{name:"Borderfree",company:"pitney bowes",category:"utility",domains:["*.borderfree.com","*.fiftyone.com"]},{name:"BowNow",category:"analytics",homepage:"https://bow-now.jp/",domains:["*.bownow.jp"]},{name:"Box",category:"hosting",domains:["*.box.com"]},{name:"Boxever",category:"analytics",domains:["*.boxever.com"]},{name:"Braintree Payments",company:"Paypal",category:"utility",domains:["*.braintreegateway.com"]},{name:"Branch Metrics",category:"ad",domains:["*.branch.io","*.app.link"]},{name:"Brand Finance",category:"other",domains:["*.brandirectory.com"]},{name:"Brand View",category:"analytics",domains:["*.brandview.com"]},{name:"Brandscreen",category:"ad",domains:["*.rtbidder.net"]},{name:"BridgeTrack",company:"Sapient",category:"ad",domains:["*.bridgetrack.com"]},{name:"BrightRoll",company:"Yahoo!",category:"ad",domains:["*.btrll.com"]},{name:"BrightTag / Signal",company:"Signal",homepage:"https://www.signal.co",category:"tag-manager",domains:["*.btstatic.com","*.thebrighttag.com"]},{name:"Brightcove ZenCoder",company:"Brightcove",category:"other",domains:["*.zencoder.net"]},{name:"Bronto Software",category:"marketing",domains:["*.bm23.com","*.bronto.com","*.brontops.com"]},{name:"Browser-Update.org",category:"other",domains:["*.browser-update.org"]},{name:"Buffer",category:"social",domains:["*.bufferapp.com"]},{name:"Bugsnag",category:"utility",domains:["*.bugsnag.com","d2wy8f7a9ursnm.cloudfront.net"]},{name:"Burst Media",category:"ad",domains:["*.burstnet.com","*.1rx.io"]},{name:"Burt",category:"analytics",domains:["*.richmetrics.com","*.burt.io"]},{name:"Business Message",category:"ad",domains:["*.message-business.com"]},{name:"Business Week",company:"Bloomberg",category:"social",domains:["*.bwbx.io"]},{name:"Buto",company:"Big Button",category:"ad",domains:["*.buto.tv"]},{name:"Button",category:"ad",domains:["*.btncdn.com"]},{name:"BuySellAds",category:"ad",domains:["*.buysellads.com","*.buysellads.net"]},{name:"BuySight (AOL)",category:"ad",domains:["*.pulsemgr.com"]},{name:"Buyapowa",category:"ad",domains:["*.co-buying.com"]},{name:"BuzzFeed",category:"social",domains:["*.buzzfed.com","*.buzzfeed.com"]},{name:"C1X",category:"ad",domains:["*.c1exchange.com"]},{name:"C3 Metrics",category:"analytics",domains:["*.c3tag.com"]},{name:"CANDDi",company:"Campaign and Digital Intelligence",category:"ad",domains:["*.canddi.com"]},{name:"CCM benchmark Group",category:"social",domains:["*.ccm2.net"]},{name:"CD Networks",category:"utility",domains:["*.gccdn.net"]},{name:"CDN Planet",category:"analytics",domains:["*.cdnplanet.com"]},{name:"InAuth",category:"utility",homepage:"https://www.inauth.com/",domains:["*.cdn-net.com"]},{name:"CJ Affiliate",company:"Conversant",category:"ad",domains:["*.cj.com","*.dpbolvw.net"]},{name:"CJ Affiliate by Conversant",company:"Conversant",category:"ad",domains:["*.ftjcfx.com"]},{name:"CNBC",category:"content",domains:["*.cnbc.com"]},{name:"CNET Content Solutions",company:"CBS Interactive",category:"content",domains:["*.cnetcontent.com"]},{name:"CPEx",category:"content",domains:["*.cpex.cz"]},{name:"CPXi",category:"ad",domains:["*.cpxinteractive.com"]},{name:"CUBED Attribution",company:"CUBED",category:"ad",domains:["*.withcubed.com"]},{name:"Cachefly",category:"utility",domains:["*.cachefly.net"]},{name:"Calendly",category:"other",domains:["*.calendly.com"]},{name:"CallRail",category:"analytics",domains:["*.callrail.com"]},{name:"CallTrackingMetrics",category:"analytics",domains:["*.tctm.co"]},{name:"Canned Banners",category:"ad",domains:["*.cannedbanners.com"]},{name:"Canopy Labs",category:"analytics",domains:["*.canopylabs.com"]},{name:"Capita",category:"utility",domains:["*.crcom.co.uk"]},{name:"Captify Media",category:"ad",domains:["*.cpx.to"]},{name:"Captiify",category:"ad",domains:["*.captifymedia.com"]},{name:"Captivate Ai",category:"ad",domains:["*.captivate.ai"]},{name:"Captora",category:"marketing",domains:["*.captora.com"]},{name:"Carcloud",category:"other",domains:["*.carcloud.co.uk"]},{name:"Cardlytics",category:"ad",domains:["*.cardlytics.com"]},{name:"Cardosa Enterprises",category:"analytics",domains:["*.y-track.com"]},{name:"Caspian Media",category:"ad",domains:["*.caspianmedia.com"]},{name:"Cast",category:"utility",domains:["*.cast.rocks"]},{name:"Catch",category:"other",domains:["*.getcatch.com"]},{name:"Cavisson",category:"analytics",domains:["*.cavisson.com"]},{name:"Cedato",category:"ad",domains:["*.algovid.com","*.vdoserv.com"]},{name:"Celebrus Technologies",category:"analytics",domains:["*.celebrus.com"]},{name:"Celtra",category:"ad",domains:["*.celtra.com"]},{name:"Centro",category:"ad",domains:["*.brand-server.com"]},{name:"Ceros",category:"other",domains:["ceros.com","view.ceros.com"]},{name:"Ceros Analytics",company:"Ceros",category:"analytics",domains:["api.ceros.com"]},{name:"Certona",category:"analytics",domains:["*.certona.net"]},{name:"Certum",category:"utility",domains:["*.ocsp-certum.com","*.certum.pl"]},{name:"Cgrdirect",category:"other",domains:["*.cgrdirect.co.uk"]},{name:"Channel 5 Media",category:"ad",domains:["*.five.tv"]},{name:"Channel.me",category:"customer-success",domains:["*.channel.me"]},{name:"ChannelAdvisor",category:"ad",domains:["*.channeladvisor.com","*.searchmarketing.com"]},{name:"ChannelApe",company:"ChannelApe",category:"other",homepage:"https://www.channelape.com/",domains:["*.channelape.com"]},{name:"Chargeads Oscar",company:"Chargeads",category:"ad",domains:["*.chargeads.com"]},{name:"Charities Aid Foundation",category:"utility",domains:["*.cafonline.org"]},{name:"Chartbeat",category:"analytics",domains:["*.chartbeat.com","*.chartbeat.net"]},{name:"Cheapflights Media",company:"Momondo",category:"content",domains:["*.momondo.net"]},{name:"CheckM8",category:"ad",domains:["*.checkm8.com"]},{name:"CheckRate",company:"FreeStart",category:"utility",domains:["*.checkrate.co.uk"]},{name:"Checkfront",category:"other",domains:["*.checkfront.com","dcg3jth5savst.cloudfront.net"]},{name:"CheetahMail",company:"Experian",category:"ad",domains:["*.chtah.com"]},{name:"Chitika",category:"ad",domains:["*.chitika.net"]},{name:"ChoiceStream",category:"ad",domains:["*.choicestream.com"]},{name:"Cint",category:"social",domains:["*.cint.com"]},{name:"Civic",category:"hosting",domains:["*.civiccomputing.com"]},{name:"ClearRise",category:"customer-success",domains:["*.clearrise.com"]},{name:"Clearstream",category:"ad",domains:["*.clrstm.com"]},{name:"Clerk.io ApS",category:"analytics",domains:["*.clerk.io"]},{name:"CleverDATA",category:"ad",domains:["*.1dmp.io"]},{name:"CleverTap",category:"analytics",domains:["d2r1yp2w7bby2u.cloudfront.net"]},{name:"Click Density",category:"analytics",domains:["*.clickdensity.com"]},{name:"Click4Assistance",category:"customer-success",domains:["*.click4assistance.co.uk"]},{name:"ClickDesk",category:"customer-success",domains:["*.clickdesk.com","d1gwclp1pmzk26.cloudfront.net"]},{name:"ClickDimensions",category:"ad",domains:["*.clickdimensions.com"]},{name:"Clickadu (Winner Solutions)",category:"ad",domains:["*.clickadu.com"]},{name:"Clickagy Audience Lab",company:"Clickagy",category:"ad",domains:["*.clickagy.com"]},{name:"Clickio",category:"ad",domains:[]},{name:"Clicktale",category:"analytics",domains:["*.cdngc.net","*.clicktale.net"]},{name:"Clicktripz",category:"content",domains:["*.clicktripz.com"]},{name:"Clik.com Websites",category:"content",domains:["*.clikpic.com"]},{name:"Cloud Technologies",category:"ad",domains:["*.behavioralengine.com","*.behavioralmailing.com"]},{name:"Cloud-A",category:"other",domains:["*.bulkstorage.ca"]},{name:"Cloud.typography",company:"Hoefler &amp; Co",category:"cdn",domains:["*.typography.com"]},{name:"CloudSponge",category:"ad",domains:["*.cloudsponge.com"]},{name:"CloudVPS",category:"other",domains:["*.adoftheyear.com","*.objectstore.eu"]},{name:"Cloudinary",category:"content",domains:["*.cloudinary.com"]},{name:"Cloudqp",company:"Cloudwp",category:"other",domains:["*.cloudwp.io"]},{name:"Cludo",category:"utility",domains:["*.cludo.com"]},{name:"Cognesia",category:"marketing",domains:["*.intelli-direct.com"]},{name:"CogoCast",company:"Cogo Labs",category:"ad",domains:["*.cogocast.net"]},{name:"Colbenson",category:"utility",domains:["*.colbenson.com"]},{name:"Collective",category:"ad",domains:["*.collective-media.net"]},{name:"Com Laude",category:"other",domains:["*.gdimg.net"]},{name:"Comm100",category:"customer-success",domains:["*.comm100.com"]},{name:"CommerceHub",category:"marketing",domains:["*.mercent.com"]},{name:"Commission Factory",category:"ad",domains:["*.cfjump.com"]},{name:"Communicator",category:"ad",domains:["*.communicatorcorp.com","*.communicatoremail.com"]},{name:"Comodo",category:"utility",domains:["*.comodo.com","*.trust-provider.com","*.trustlogo.com","*.usertrust.com","*.comodo.net"]},{name:"Comodo Certificate Authority",company:"Comodo",category:"utility",domains:["crt.comodoca.com","*.comodoca4.com","ocsp.comodoca.com","ocsp.usertrust.com","crt.usertrust.com"]},{name:"Compete",company:"Millwood Brown Digital",category:"analytics",domains:["*.c-col.com","*.compete.com"]},{name:"Compuware",category:"analytics",domains:["*.axf8.net"]},{name:"Conductrics",category:"analytics",domains:["*.conductrics.com"]},{name:"Confirmit",category:"analytics",domains:["*.confirmit.com"]},{name:"Connatix",category:"ad",domains:["*.connatix.com"]},{name:"Connect Events",category:"hosting",domains:["*.connectevents.com.au"]},{name:"Constant Contact",category:"ad",domains:["*.ctctcdn.com"]},{name:"Constructor.io",category:"utility",domains:["*.cnstrc.com"]},{name:"Contabo",category:"hosting",domains:["185.2.100.179"]},{name:"Content Media Corporation",category:"content",domains:["*.contentmedia.eu"]},{name:"ContentSquare",category:"analytics",domains:["d1m6l9dfulcyw7.cloudfront.net","*.content-square.net","*.contentsquare.net"]},{name:"ContextWeb",category:"ad",domains:["*.contextweb.com"]},{name:"Continental Exchange Solutions",category:"utility",domains:["*.hifx.com"]},{name:"Converge-Digital",category:"ad",domains:["*.converge-digital.com"]},{name:"Conversant",category:"analytics",domains:["*.dotomi.com","*.dtmpub.com","*.emjcd.com","mediaplex.com","*.tqlkg.com","*.fastclick.net"]},{name:"Conversant Ad Server",company:"Conversant",category:"ad",domains:["adfarm.mediaplex.com","*.mediaplex.com"]},{name:"Conversant Tag Manager",company:"Conversant",category:"tag-manager",domains:["*.mplxtms.com"]},{name:"Conversio",category:"ad",domains:["*.conversio.com"]},{name:"Conversion Labs",category:"ad",domains:["*.net.pl"]},{name:"Conversion Logic",category:"ad",domains:["*.conversionlogic.net"]},{name:"Convert Insights",category:"analytics",domains:["*.convertexperiments.com"]},{name:"ConvertMedia",category:"ad",domains:["*.admailtiser.com","*.basebanner.com","*.cmbestsrv.com","*.vidfuture.com","*.zorosrv.com"]},{name:"Convertro",category:"ad",domains:["*.convertro.com"]},{name:"Conviva",category:"content",domains:["*.conviva.com"]},{name:"Cookie Reports",category:"utility",domains:["*.cookiereports.com"]},{name:"Cookie-Script.com",category:"utility",domains:["*.cookie-script.com"]},{name:"CookieQ",company:"Baycloud Systems",category:"utility",domains:["*.cookieq.com"]},{name:"CoolaData",category:"analytics",domains:["*.cooladata.com"]},{name:"CopperEgg",category:"analytics",domains:["*.copperegg.com","d2vig74li2resi.cloudfront.net"]},{name:"Council ad Network",category:"ad",domains:["*.counciladvertising.net"]},{name:"Covert Pics",category:"content",domains:["*.covet.pics"]},{name:"Cox Digital Solutions",category:"ad",domains:["*.afy11.net"]},{name:"Creafi Online Media",category:"ad",domains:["*.creafi-online-media.com"]},{name:"Creators",category:"content",domains:["*.creators.co"]},{name:"Crimson Hexagon Analytics",company:"Crimson Hexagon",category:"analytics",domains:["*.hexagon-analytics.com"]},{name:"Crimtan",category:"ad",domains:["*.ctnsnet.com"]},{name:"Cross Pixel Media",category:"ad",domains:["*.crsspxl.com"]},{name:"Crosswise",category:"ad",domains:["*.univide.com"]},{name:"Crowd Control",company:"Lotame",category:"ad",domains:["*.crwdcntrl.net"]},{name:"Crowd Ignite",category:"ad",domains:["*.crowdignite.com"]},{name:"CrowdTwist",category:"ad",domains:["*.crowdtwist.com"]},{name:"Crowdskout",category:"ad",domains:["*.crowdskout.com"]},{name:"Crowdynews",category:"social",domains:["*.breakingburner.com"]},{name:"Curalate",category:"marketing",domains:["*.curalate.com","d116tqlcqfmz3v.cloudfront.net"]},{name:"Customer Acquisition Cloud",company:"[24]7",category:"ad",domains:["*.campanja.com"]},{name:"Customer.io",category:"ad",domains:["*.customer.io"]},{name:"Custora",category:"analytics",domains:["*.custora.com"]},{name:"Cxense",category:"ad",domains:["*.cxense.com","*.cxpublic.com","*.emediate.dk","*.emediate.eu"]},{name:"CyberKnight",company:"Namogoo",category:"utility",domains:["*.namogoo.com"]},{name:"CyberSource (Visa)",category:"utility",domains:["*.authorize.net"]},{name:"Cybernet Quest",category:"analytics",domains:["*.cqcounter.com"]},{name:"D.A. Consortium",category:"ad",domains:["*.eff1.net"]},{name:"D4t4 Solutions",category:"analytics",domains:["*.u5e.com"]},{name:"DCSL Software",category:"hosting",domains:["*.dcslsoftware.com"]},{name:"DMG Media",category:"content",domains:["*.mol.im","*.and.co.uk","*.anm.co.uk","*.dailymail.co.uk"]},{name:"DTSCOUT",category:"ad",domains:["*.dtscout.com"]},{name:"Dailykarma",category:"utility",homepage:"https://www.dailykarma.com/",domains:["*.dailykarma.io"]},{name:"Dailymotion",category:"content",domains:["*.dailymotion.com","*.dmxleo.com","*.dm.gg","*.pxlad.io","*.dmcdn.net","*.sublimevideo.net"]},{name:"Dash Hudson",company:"Dash Hudson",category:"content",domains:["*.dashhudson.com"]},{name:"Datacamp",category:"utility",domains:["*.cdn77.org"]},{name:"Datalicious",category:"tag-manager",domains:["*.supert.ag","*.optimahub.com"]},{name:"Datalogix",category:"ad",domains:["*.nexac.com"]},{name:"Datawrapper",category:"utility",domains:["*.datawrapper.de","*.dwcdn.net"]},{name:"Dataxu",category:"marketing",domains:["*.w55c.net"]},{name:"DatoCMS",homepage:"https://www.datocms.com/",category:"content",domains:["*.datocms-assets.com"]},{name:"Datonics",category:"ad",domains:["*.pro-market.net"]},{name:"Dealtime",category:"content",domains:["*.dealtime.com"]},{name:"Debenhams Geo Location",company:"Debenhams",category:"utility",domains:["176.74.183.134"]},{name:"Decibel Insight",category:"analytics",domains:["*.decibelinsight.net"]},{name:"Deep Forest Media",company:"Rakuten",category:"ad",domains:["*.dpclk.com"]},{name:"DeepIntent",category:"ad",domains:["*.deepintent.com"]},{name:"Delicious Media",category:"social",domains:["*.delicious.com"]},{name:"Delineo",category:"ad",domains:["*.delineo.com"]},{name:"Delta Projects AB",category:"ad",domains:["*.de17a.com"]},{name:"Demand Media",category:"content",domains:["*.dmtracker.com"]},{name:"DemandBase",category:"marketing",domains:["*.demandbase.com"]},{name:"DemandJump",category:"analytics",domains:["*.demandjump.com"]},{name:"Dennis Publishing",category:"content",domains:["*.alphr.com"]},{name:"Devatics",category:"analytics",domains:["*.devatics.com","*.devatics.io"]},{name:"Developer Media",category:"ad",domains:["*.developermedia.com"]},{name:"DialogTech",category:"ad",domains:["*.dialogtech.com"]},{name:"DialogTech SourceTrak",company:"DialogTech",category:"ad",domains:["d31y97ze264gaa.cloudfront.net"]},{name:"DigiCert",category:"utility",domains:["*.digicert.com"]},{name:"Digioh",category:"ad",domains:["*.lightboxcdn.com"]},{name:"Digital Look",category:"content",domains:["*.digitallook.com"]},{name:"Digital Media Exchange",company:"NDN",category:"content",domains:["*.newsinc.com"]},{name:"Digital Millennium Copyright Act Services",category:"utility",domains:["*.dmca.com"]},{name:"Digital Ocean",category:"other",domains:["95.85.62.56"]},{name:"Digital Remedy",category:"ad",domains:["*.consumedmedia.com"]},{name:"Digital Window",category:"ad",domains:["*.awin1.com","*.zenaps.com"]},{name:"DigitalScirocco",category:"analytics",domains:["*.digitalscirocco.net"]},{name:"Digitial Point",category:"utility",domains:["*.dpstatic.com"]},{name:"Diligent (Adnetik)",category:"ad",domains:["*.wtp101.com"]},{name:"Directed Edge",category:"social",domains:["*.directededge.com"]},{name:"Distribute Travel",category:"ad",domains:["*.dtrck.net"]},{name:"District M",category:"ad",domains:["*.districtm.io"]},{name:"DistroScale",category:"ad",domains:["*.jsrdn.com"]},{name:"Divido",category:"utility",domains:["*.divido.com"]},{name:"Dow Jones",category:"content",domains:["*.dowjones.com","*.dowjoneson.com"]},{name:"Drifty Co",category:"utility",domains:["*.onicframework.com"]},{name:"Drip",company:"The Numa Group",category:"ad",domains:["*.getdrip.com"]},{name:"Dropbox",category:"utility",domains:["*.dropboxusercontent.com"]},{name:"Dyn Real User Monitoring",company:"Dyn",category:"analytics",domains:["*.jisusaiche.biz","*.dynapis.com","*.jisusaiche.com","*.dynapis.info"]},{name:"DynAdmic",category:"ad",domains:["*.dyntrk.com"]},{name:"Dynamic Converter",category:"utility",domains:["*.dynamicconverter.com"]},{name:"Dynamic Dummy Image Generator",company:"Open Source",category:"utility",domains:["*.dummyimage.com"]},{name:"Dynamic Logic",category:"ad",domains:["*.dl-rms.com","*.questionmarket.com"]},{name:"Dynamic Yield",category:"customer-success",domains:["*.dynamicyield.com"]},{name:"Dynatrace",category:"analytics",domains:["*.ruxit.com","js-cdn.dynatrace.com"]},{name:"ec-concier",homepage:"https://ec-concier.com/",category:"marketing",domains:["*.ec-concier.com"]},{name:"ECT News Network",category:"content",domains:["*.ectnews.com"]},{name:"ELITechGroup",category:"analytics",domains:["*.elitechnology.com"]},{name:"EMAP",category:"content",domains:["*.emap.com"]},{name:"EMedia Solutions",category:"ad",domains:["*.e-shots.eu"]},{name:"EQ works",category:"ad",domains:["*.eqads.com"]},{name:"ESV Digital",category:"analytics",domains:["*.esearchvision.com"]},{name:"Ebiquity",category:"analytics",domains:["*.ebiquitymedia.com"]},{name:"Eco Rebates",category:"ad",domains:["*.ecorebates.com"]},{name:"Ecwid",category:"hosting",domains:["*.ecwid.com","*.shopsettings.com","d3fi9i0jj23cau.cloudfront.net","d3j0zfs7paavns.cloudfront.net"]},{name:"Edge Web Fonts",company:"Adobe Systems",category:"cdn",domains:["*.edgefonts.net"]},{name:"Edition Digital",category:"ad",domains:["*.editiondigital.com"]},{name:"Edot Web Technologies",category:"hosting",domains:["*.edot.co.za"]},{name:"Effective Measure",category:"ad",domains:["*.effectivemeasure.net"]},{name:"Effiliation sa",category:"ad",domains:["*.effiliation.com"]},{name:"Ekm Systems",category:"analytics",domains:["*.ekmsecure.com","*.ekmpinpoint.co.uk"]},{name:"Elastera",category:"hosting",domains:["*.elastera.net"]},{name:"Elastic Ad",category:"ad",domains:["*.elasticad.net"]},{name:"Elastic Load Balancing",company:"Amazon Web Services",category:"hosting",domains:["*.105app.com"]},{name:"Elecard StreamEye",company:"Elecard",category:"other",domains:["*.streameye.net"]},{name:"Elevate",company:"Elevate Technology Solutions",category:"utility",domains:["*.elevaate.technology"]},{name:"Elicit",category:"utility",domains:["*.elicitapp.com"]},{name:"Elogia",category:"ad",domains:["*.elogia.net"]},{name:"Email Attitude",company:"1000mercis",category:"ad",domains:["*.email-attitude.com"]},{name:"EmailCenter",category:"ad",domains:["*.emailcenteruk.com"]},{name:"Embedly",category:"content",domains:["*.embedly.com","*.embed.ly"]},{name:"EmpathyBroker Site Search",company:"EmpathyBroker",category:"utility",domains:["*.empathybroker.com"]},{name:"Enfusen",category:"analytics",domains:["*.enfusen.com"]},{name:"Engadget",company:"Engadget (AOL)",category:"content",domains:["*.gdgt.com"]},{name:"Engagio",category:"marketing",domains:["*.engagio.com"]},{name:"Ensighten Manage",company:"Ensighten",category:"tag-manager",domains:["*.levexis.com"]},{name:"EntityLink",category:"other",domains:["*.entitytag.co.uk"]},{name:"Entrust Datacard",category:"utility",domains:["*.entrust.com","*.entrust.net"]},{name:"Equiniti",category:"utility",domains:["*.equiniti.com"]},{name:"Errorception",category:"utility",domains:["*.errorception.com"]},{name:"Esri ArcGIS",company:"Esri",category:"utility",domains:["*.arcgis.com","*.arcgisonline.com"]},{name:"Ethnio",category:"analytics",domains:["*.ethn.io"]},{name:"Eulerian Technologies",category:"ad",domains:["*.eolcdn.com"]},{name:"Euroland",category:"utility",domains:["*.euroland.com"]},{name:"European Interactive Digital ad Alli",category:"utility",domains:["*.edaa.eu"]},{name:"Eventbrite",category:"hosting",domains:["*.evbuc.com","*.eventbrite.co.uk"]},{name:"Everflow",category:"analytics",domains:["*.tp88trk.com"]},{name:"Evergage",category:"analytics",domains:["*.evergage.com","*.evgnet.com"]},{name:"Everquote",category:"content",domains:["*.evq1.com"]},{name:"Everyday Health",category:"ad",domains:["*.agoramedia.com"]},{name:"Evidon",category:"analytics",domains:["*.evidon.com"]},{name:"Evolve Media",category:"content",domains:["*.evolvemediallc.com"]},{name:"Exactag",category:"ad",domains:["*.exactag.com"]},{name:"ExoClick",category:"ad",domains:["*.exoclick.com"]},{name:"Expedia",category:"content",domains:["*.travel-assets.com","*.trvl-media.com","*.trvl-px.com","*.uciservice.com"]},{name:"Expedia Australia",company:"Expedia",category:"content",domains:["*.expedia.com.au"]},{name:"Expedia Canada",company:"Expedia",category:"content",domains:["*.expedia.ca"]},{name:"Expedia France",company:"Expedia",category:"content",domains:["*.expedia.fr"]},{name:"Expedia Germany",company:"Expedia",category:"content",domains:["*.expedia.de"]},{name:"Expedia Italy",company:"Expedia",category:"content",domains:["*.expedia.it"]},{name:"Expedia Japan",company:"Expedia",category:"content",domains:["*.expedia.co.jp"]},{name:"Expedia USA",company:"Expedia",category:"content",domains:["*.expedia.com"]},{name:"Expedia United Kingdom",company:"Expedia",category:"content",domains:["*.expedia.co.uk"]},{name:"Experian",category:"utility",domains:["*.audienceiq.com","*.experian.com","*.experianmarketingservices.digital"]},{name:"Experian Cross-Channel Marketing Platform",company:"Experian",category:"marketing",domains:["*.eccmp.com","*.ccmp.eu"]},{name:"Exponea",category:"analytics",domains:["*.exponea.com"]},{name:"Exponential Interactive",category:"ad",domains:["*.exponential.com"]},{name:"Extensis WebInk",category:"cdn",domains:["*.webink.com"]},{name:"Extole",category:"ad",domains:["*.extole.com","*.extole.io"]},{name:"Ey-Seren",category:"analytics",domains:["*.webabacus.com"]},{name:"EyeView",category:"ad",domains:["*.eyeviewads.com"]},{name:"Eyeota",category:"ad",domains:["*.eyeota.net"]},{name:"Ezakus Pretargeting",company:"Ezakus",category:"ad",domains:["*.ezakus.net"]},{name:"Ezoic",category:"analytics",domains:["*.ezoic.net"]},{name:"FLXone",company:"Teradata",category:"ad",domains:["*.pangolin.blue","*.flx1.com","d2hlpp31teaww3.cloudfront.net","*.flxpxl.com"]},{name:"Fairfax Media",category:"content",domains:["ads.fairfax.com.au","resources.fairfax.com.au"]},{name:"Fairfax Media Analtics",company:"Fairfax Media",category:"analytics",domains:["analytics.fairfax.com.au"]},{name:"Falk Technologies",category:"ad",domains:["*.angsrvr.com"]},{name:"Fanplayr",category:"analytics",domains:["*.fanplayr.com","d38nbbai6u794i.cloudfront.net"]},{name:"Fast Thinking",company:"NE Marketing",category:"marketing",domains:["*.fast-thinking.co.uk"]},{name:"Fastest Forward",category:"analytics",domains:["*.gaug.es"]},{name:"Fastly",category:"utility",domains:["*.fastly.net"]},{name:"Feedbackify",company:"InsideMetrics",category:"analytics",domains:["*.feedbackify.com"]},{name:"Feefo.com",company:"Feefo",category:"analytics",domains:["*.feefo.com"]},{name:"Fidelity Media",category:"ad",domains:["*.fidelity-media.com"]},{name:"Filestack",category:"content",domains:["*.filepicker.io"]},{name:"Finsbury Media",category:"ad",domains:["*.finsburymedia.com"]},{name:"Firepush",category:"utility",domains:["*.firepush.io"]},{name:"FirstImpression",category:"ad",domains:["*.firstimpression.io"]},{name:"Fit Analytics",category:"other",domains:["*.fitanalytics.com"]},{name:"Fits Me",category:"analytics",domains:["*.fits.me"]},{name:"Fivetran",category:"analytics",domains:["*.fivetran.com"]},{name:"FlexShopper",category:"utility",domains:["*.flexshopper.com"]},{name:"Flickr",category:"content",domains:["*.flickr.com","*.staticflickr.com"]},{name:"Flipboard",category:"social",domains:["*.flipboard.com"]},{name:"Flipdesk",category:"customer-success",homepage:"https://flipdesk.jp/",domains:["*.flipdesk.jp"]},{name:"Flipp",category:"analytics",domains:["*.wishabi.com","d2e0sxz09bo7k2.cloudfront.net","*.wishabi.net"]},{name:"Flite",category:"ad",domains:["*.flite.com"]},{name:"Flixmedia",category:"analytics",domains:["*.flix360.com","*.flixcar.com","*.flixfacts.com","*.flixsyndication.net","*.flixfacts.co.uk"]},{name:"Flockler",category:"ad",domains:["*.flockler.com"]},{name:"Flowplayer",category:"content",domains:["*.flowplayer.org"]},{name:"Flowzymes Ky",category:"cdn",domains:["*.jquerytools.org"]},{name:"Fomo",category:"ad",domains:["*.notifyapp.io"]},{name:"Fonecall",category:"analytics",domains:["*.web-call-analytics.com"]},{name:"Fontdeck",category:"cdn",domains:["*.fontdeck.com"]},{name:"Foodity Technologies",category:"ad",domains:["*.foodity.com"]},{name:"Force24",category:"ad",domains:["*.force24.co.uk"]},{name:"ForeSee",company:"Answers",category:"analytics",domains:["*.4seeresults.com","*.answerscloud.com","*.foresee.com","*.foreseeresults.com"]},{name:"Forensiq",category:"utility",domains:["*.fqtag.com"]},{name:"Fort Awesome",category:"cdn",domains:["*.fortawesome.com"]},{name:"Forter",category:"utility",domains:["*.forter.com"]},{name:"Forward Internet Group",category:"hosting",domains:["*.f3d.io"]},{name:"Forward3D",category:"ad",domains:["*.forward3d.com"]},{name:"Fospha",category:"analytics",domains:["*.fospha.com"]},{name:"Foursixty",category:"customer-success",domains:["*.foursixty.com"]},{name:"FoxyCart",category:"utility",domains:["*.foxycart.com"]},{name:"Fraudlogix",category:"utility",domains:["*.yabidos.com"]},{name:"FreakOut",category:"ad",domains:["*.fout.jp"]},{name:"Freespee",category:"customer-success",domains:["*.freespee.com"]},{name:"Freetobook",category:"content",domains:["*.freetobook.com"]},{name:"Fresh 8 Gaming",category:"ad",domains:["*.fresh8.co"]},{name:"Fresh Relevance",category:"analytics",domains:["*.freshrelevance.com","*.cloudfront.ne","d1y9qtn9cuc3xw.cloudfront.net","d81mfvml8p5ml.cloudfront.net","dkpklk99llpj0.cloudfront.net"]},{name:"Friendbuy",category:"ad",domains:["*.friendbuy.com","djnf6e5yyirys.cloudfront.net"]},{name:"Frienefit",category:"ad",domains:["*.frienefit.com"]},{name:"FuelX",category:"ad",domains:["*.fuelx.com"]},{name:"Full Circle Studies",category:"analytics",domains:["*.securestudies.com"]},{name:"FullStory",category:"analytics",domains:["*.fullstory.com"]},{name:"Fyber",category:"ad",domains:["*.fyber.com"]},{name:"G-Forces Web Management",category:"hosting",domains:["*.gforcesinternal.co.uk"]},{name:"G4 Native",company:"Gravity4",category:"ad",domains:["*.triggit.com"]},{name:"GET ME IN!  (TicketMaster)",category:"content",domains:["*.getmein.com"]},{name:"GIPHY",category:"content",domains:["*.giphy.com"]},{name:"GainCloud",company:"GainCloud Systems",category:"other",domains:["*.egaincloud.net"]},{name:"Gath Adams",category:"content",domains:["*.iwantthatflight.com.au"]},{name:"Gecko Tribe",category:"social",domains:["*.geckotribe.com"]},{name:"Gemius",category:"ad",domains:["*.gemius.pl"]},{name:"Genesis Media",category:"ad",domains:["*.bzgint.com","*.genesismedia.com","*.genesismediaus.com"]},{name:"Genie Ventures",category:"ad",domains:["*.genieventures.co.uk"]},{name:"Geniee",category:"ad",domains:["*.href.asia","*.genieessp.jp","*.genieesspv.jp","*.gssprt.jp"]},{name:"Geniuslink",category:"analytics",domains:["*.geni.us"]},{name:"GeoRiot",category:"other",domains:["*.georiot.com"]},{name:"GeoTrust",category:"utility",domains:["*.geotrust.com"]},{name:"Geoplugin",category:"utility",domains:["*.geoplugin.com","*.geoplugin.net"]},{name:"Georeferencer",company:"Klokan Technologies",category:"utility",domains:["*.georeferencer.com"]},{name:"GetIntent RTBSuite",company:"GetIntent",category:"ad",domains:["*.adhigh.net"]},{name:"GetResponse",category:"ad",domains:["*.getresponse.com"]},{name:"GetSiteControl",company:"GetWebCraft",category:"utility",domains:["*.getsitecontrol.com"]},{name:"GetSocial",category:"social",domains:["*.getsocial.io"]},{name:"Getty Images",category:"content",domains:["*.gettyimages.com","*.gettyimages.co.uk"]},{name:"Gfycat",company:"Gycat",category:"utility",domains:["*.gfycat.com"]},{name:"Ghostery Enterprise",company:"Ghostery",category:"marketing",domains:["*.betrad.com"]},{name:"Giant Media",category:"ad",domains:["*.videostat.com"]},{name:"Gigya",category:"analytics",domains:["*.gigya.com"]},{name:"GitHub",category:"utility",domains:["*.github.com","*.githubusercontent.com","*.github.io","*.rawgit.com"]},{name:"Gladly",company:"Gladly",homepage:"https://www.gladly.com/",category:"customer-success",domains:["*.gladly.com"]},{name:"Glassdoor",category:"content",domains:["*.glassdoor.com"]},{name:"Gleam",category:"marketing",domains:["*.gleam.io"]},{name:"Global Digital Markets",category:"ad",domains:["*.gdmdigital.com"]},{name:"Global-e",category:"hosting",domains:["*.global-e.com"]},{name:"GlobalSign",category:"utility",domains:["*.globalsign.com","*.globalsign.net"]},{name:"GlobalWebIndex",category:"analytics",domains:["*.globalwebindex.net"]},{name:"Globase International",category:"ad",domains:["*.globase.com"]},{name:"GoDataFeed",category:"other",domains:["*.godatafeed.com"]},{name:"Google APIs",company:"Google",category:"utility",domains:["googleapis.com"]},{name:"Google Ad Block Detection",company:"Google",category:"ad",domains:["*.0emn.com","*.0fmm.com"]},{name:"Google Analytics Experiments",company:"Google",category:"analytics",domains:["*.gexperiments1.com"]},{name:"Google DoubleClick Ad Exchange",company:"Google",category:"ad",domains:["*.admeld.com"]},{name:"Google IPV6 Metrics",company:"Google",category:"analytics",domains:["*.ipv6test.net"]},{name:"Google Plus",company:"Google",category:"social",domains:["plus.google.com"]},{name:"Google Trusted Stores",company:"Google",category:"utility",domains:["*.googlecommerce.com"]},{name:"Google Video",company:"Google",category:"content",domains:["*.googlevideo.com"]},{name:"Google reCAPTCHA",company:"Google",category:"utility",domains:["*.recaptcha.net"]},{name:"GovMetric",company:"ROL Solutions",category:"analytics",domains:["*.govmetric.com"]},{name:"Granify",category:"analytics",domains:["*.granify.com"]},{name:"Grapeshot",category:"ad",domains:["*.gscontxt.net","*.grapeshot.co.uk"]},{name:"Gravity (AOL)",category:"analytics",domains:["*.grvcdn.com"]},{name:"Groovy Gecko",category:"content",domains:["*.ggwebcast.com","*.groovygecko.net"]},{name:"GroupM",category:"ad",domains:["*.qservz.com"]},{name:"Guardian Media",category:"ad",domains:["*.theguardian.com","*.guardian.co.uk"]},{name:"GumGum",category:"ad",domains:["*.gumgum.com"]},{name:"Gumtree",category:"content",domains:["*.gumtree.com"]},{name:"H264 Codec",company:"Cisco",category:"other",domains:["*.openh264.org"]},{name:"HERE",category:"analytics",domains:["*.medio.com"]},{name:"HP Optimost",company:"Hewlett-Packard Development Company",category:"marketing",domains:["*.hp.com","d2uncb19xzxhzx.cloudfront.net"]},{name:"Has Offers",company:"TUNE",category:"ad",domains:["*.go2cloud.org"]},{name:"Hawk Search",category:"utility",domains:["*.hawksearch.com"]},{name:"Haymarket Media Group",category:"content",domains:["*.brandrepublic.com","*.hbpl.co.uk"]},{name:"Heap",category:"analytics",domains:["*.heapanalytics.com"]},{name:"Hearst Communications",category:"content",domains:["*.h-cdn.co","*.hearstdigital.com","*.hearstlabs.com","*.hearst.io","*.cdnds.net"]},{name:"Heatmap",category:"analytics",domains:["*.heatmap.it"]},{name:"Heroku",category:"other",domains:["*.herokuapp.com"]},{name:"Hexton",category:"utility",domains:["*.hextom.com"]},{name:"Hibernia Networks",category:"utility",domains:["*.hiberniacdn.com"]},{name:"High Impact Media",category:"ad",domains:["*.reactx.com"]},{name:"Highcharts",category:"utility",domains:["*.highcharts.com"]},{name:"Highwinds",category:"utility",domains:["*.hwcdn.net"]},{name:"HitsLink",category:"analytics",domains:["*.hitslink.com"]},{name:"Hola Networks",category:"other",domains:["*.h-cdn.com"]},{name:"Hootsuite",category:"analytics",domains:["*.hootsuite.com"]},{name:"HotUKDeals",category:"analytics",domains:["*.hotukdeals.com"]},{name:"HotWords",company:"Media Response Group",category:"ad",domains:["*.hotwords.com.br"]},{name:"HotelsCombined",category:"content",domains:["*.datahc.com"]},{name:"Hoverr",category:"ad",domains:["*.hoverr.media"]},{name:"Hull.js",category:"utility",domains:["*.hull.io","*.hullapp.io"]},{name:"Hupso Website Analyzer",company:"Hupso",category:"analytics",domains:["*.hupso.com"]},{name:"I-Behavior",company:"WPP",category:"ad",domains:["*.ib-ibi.com"]},{name:"i-mobile",company:"i-mobile",category:"ad",domains:["*.i-mobile.co.jp"]},{name:"IBM Digital Analytics",company:"IBM",category:"analytics",domains:["*.cmcore.com","coremetrics.com","data.coremetrics.com","data.de.coremetrics.com","libs.de.coremetrics.com","tmscdn.de.coremetrics.com","iocdn.coremetrics.com","libs.coremetrics.com","tmscdn.coremetrics.com","*.s81c.com","*.unica.com","*.coremetrics.eu"]},{name:"IBM Digital Data Exchange",company:"IBM",category:"tag-manager",domains:["tagmanager.coremetrics.com"]},{name:"IBM Tealeaf",company:"IBM",category:"analytics",domains:["*.ibmcloud.com"]},{name:"IBM Acoustic Campaign",company:"IBM",category:"analytics",domains:["www.sc.pages01.net","www.sc.pages02.net","www.sc.pages03.net","www.sc.pages04.net","www.sc.pages05.net","www.sc.pages06.net","www.sc.pages07.net","www.sc.pages08.net","www.sc.pages09.net","www.sc.pagesA.net"]},{name:"ICF Technology",category:"content",domains:["*.camads.net"]},{name:"IFDNRG",category:"hosting",domains:["*.ifdnrg.com"]},{name:"IMRG",category:"analytics",domains:["*.peermap.com","*.imrg.org"]},{name:"IPONWEB",category:"ad",domains:["*.company-target.com","*.liadm.com","*.iponweb.net","*.p161.net"]},{name:"IQ Mobile",category:"utility",domains:["*.iqm.cc"]},{name:"IS Group",category:"hosting",domains:["*.creative-serving.com"]},{name:"IT Dienstleistungen Tim Prinzkosky",category:"utility",domains:["*.flaticons.net"]},{name:"IXI Digital",company:"Equifax",category:"ad",domains:["*.ixiaa.com"]},{name:"IcoMoon",category:"cdn",domains:["d19ayerf5ehaab.cloudfront.net","d1azc1qln24ryf.cloudfront.net"]},{name:"IdenTrust",category:"utility",domains:["*.identrust.com"]},{name:"Ido",category:"customer-success",domains:["*.idio.co"]},{name:"Ignition One",category:"marketing",domains:["*.searchignite.com"]},{name:"ImageShack",category:"content",domains:["*.yfrog.com"]},{name:"Imagen Studio",category:"utility",domains:["*.telephonesky.com"]},{name:"Imagini Holdings",category:"ad",domains:["*.vdna-assets.com"]},{name:"Img Safe",category:"content",domains:["*.imgsafe.org"]},{name:"Imgur",category:"utility",domains:["*.imgur.com"]},{name:"Impact Radius",category:"ad",domains:["*.impactradius-event.com","*.impactradius-go.com","*.7eer.net","d3cxv97fi8q177.cloudfront.net","*.evyy.net","*.ojrq.net","utt.impactcdn.com","*.sjv.io"]},{name:"Improve Digital",category:"ad",domains:["*.360yield.com"]},{name:"Improvely",category:"analytics",domains:["*.iljmp.com"]},{name:"InMobi",category:"ad",domains:["*.inmobi.com"]},{name:"InSkin Media",category:"ad",domains:["*.inskinad.com","*.inskinmedia.com"]},{name:"Inbenta",category:"customer-success",domains:["*.inbenta.com"]},{name:"Incisive Media",category:"content",domains:["*.incisivemedia.com"]},{name:"Indeed",category:"content",domains:["*.indeed.com"]},{name:"Index Exchange",company:"WPP",category:"ad",domains:["*.casalemedia.com","*.indexww.com"]},{name:"Indoona",category:"other",domains:["*.indoona.com"]},{name:"Infectious Media",category:"ad",domains:["*.impdesk.com","*.impressiondesk.com","*.inmz.net"]},{name:"Inference Mobile",category:"ad",domains:["*.inferencemobile.com"]},{name:"Infinity Tracking",category:"analytics",domains:["*.infinity-tracking.net"]},{name:"Infoline",category:"analytics",domains:["*.ioam.de"]},{name:"Infolinks",category:"ad",domains:["*.infolinks.com"]},{name:"Infopark",category:"hosting",domains:["*.scrvt.com"]},{name:"Infusionsoft",category:"ad",domains:["*.infusionsoft.com"]},{name:"Ink",category:"ad",domains:["*.inktad.com"]},{name:"Inktel Contact Center Solutions",company:"Inktel",category:"customer-success",domains:["*.inktel.com"]},{name:"Inneractive",category:"ad",domains:["*.inner-active.mobi"]},{name:"Innovid",category:"ad",homepage:"https://www.innovid.com/",domains:["*.innovid.com"]},{name:"Insight Express",category:"analytics",domains:["*.insightexpressai.com"]},{name:"Insipio",category:"other",domains:["*.insipio.com"]},{name:"Inspectlet",category:"analytics",domains:["*.inspectlet.com"]},{name:"Instansive",category:"utility",domains:["*.instansive.com"]},{name:"Instart",homepage:"https://www.instart.com/",category:"utility",domains:["*.insnw.net"]},{name:"Instembedder",category:"content",domains:["*.instaembedder.com"]},{name:"Instinctive",category:"ad",domains:["*.instinctiveads.com"]},{name:"Intelligent Reach",category:"ad",domains:["*.ist-track.com"]},{name:"Intent HQ",category:"analytics",domains:["*.intenthq.com"]},{name:"Intent IQ",category:"ad",domains:["*.intentiq.com"]},{name:"Intercept Interactive",category:"ad",domains:["*.undertone.com"]},{name:"Interest Graph",company:"AOL",category:"ad",domains:["*.gravity.com"]},{name:"Internet Brands",category:"content",domains:["*.ibpxl.com"]},{name:"Interpublic Group",category:"ad",domains:["*.mbww.com"]},{name:"Interstate",category:"analytics",domains:["*.interstateanalytics.com"]},{name:"Interview",category:"analytics",domains:["*.efm.me"]},{name:"Intilery",category:"customer-success",domains:["*.intilery-analytics.com"]},{name:"Investis",category:"utility",domains:["*.investis.com"]},{name:"Investis Flife",category:"hosting",domains:["*.quartalflife.com"]},{name:"Invodo",category:"ad",domains:["*.invodo.com"]},{name:"iSite",category:"analytics",domains:["*.isitetv.com"]},{name:"Issue",category:"content",domains:["*.issue.by"]},{name:"J.D. Williams & Co",category:"content",domains:["*.drct2u.com"]},{name:"Janrain",category:"analytics",domains:["*.janrain.com","*.janrainbackplane.com","*.rpxnow.com","d3hmp0045zy3cs.cloudfront.net"]},{name:"Jellyfish",category:"ad",domains:["*.jellyfish.net"]},{name:"JetStream",category:"content",domains:["*.xlcdn.com"]},{name:"JingDong",category:"content",domains:["*.3.com","*.jd.com"]},{name:"Jivox",category:"ad",domains:["*.jivox.com"]},{name:"Jobvite",category:"content",domains:["*.jobvite.com"]},{name:"Johnston Press",category:"content",domains:["*.johnstonpress.co.uk","*.jpress.co.uk"]},{name:"Join the Dots (Research)",category:"social",domains:["*.jtdiscuss.com"]},{name:"JotForm",category:"utility",domains:["*.jotformpro.com"]},{name:"JuicyAds",category:"ad",domains:["*.juicyads.com"]},{name:"JustPremium",category:"ad",domains:["*.net.net"]},{name:"JustPremium Ads",company:"JustPremium",category:"ad",domains:["*.justpremium.com"]},{name:"JustUno",category:"ad",domains:["*.justuno.com","d2j3qa5nc37287.cloudfront.net"]},{name:"KINX (Korea Internet Neutral eXchange)",category:"other",domains:["*.kinxcdn.com"]},{name:"KISSmetrics",category:"analytics",domains:["*.kissmetrics.com","doug1izaerwt3.cloudfront.net","dsyszv14g9ymi.cloudfront.net"]},{name:"Kaizen Platform",category:"analytics",domains:["*.kaizenplatform.net"]},{name:"Kakao",category:"social",domains:["*.daum.net","*.daumcdn.net"]},{name:"Kaltura Video Platform",company:"Kaltura",category:"content",domains:["*.kaltura.com"]},{name:"Kameleoon",category:"analytics",domains:["*.kameleoon.com","*.kameleoon.eu"]},{name:"Kampyle",category:"analytics",domains:["*.kampyle.com"]},{name:"Kantar",category:"analytics",domains:["*.sesamestats.com"]},{name:"Kargo",category:"marketing",domains:["*.kargo.com"]},{name:"KARTE",company:"Plaid",homepage:"https://karte.io/",category:"marketing",domains:["*.karte.io"]},{name:"Kauli",category:"ad",domains:["*.kau.li"]},{name:"Keen",company:"Keen",homepage:"https://keen.io/",category:"analytics",domains:["*.keen.io","d26b395fwzu5fz.cloudfront.net"]},{name:"Kelkoo",category:"hosting",domains:["*.kelkoo.com"]},{name:"Kenshoo",category:"marketing",domains:["*.xg4ken.com"]},{name:"Key CDN",category:"utility",domains:["*.kxcdn.com"]},{name:"Keynote",company:"Dynatrace",category:"analytics",domains:["*.keynote.com"]},{name:"Keywee",category:"ad",domains:["*.keywee.co"]},{name:"Kiosked",category:"ad",domains:["*.kiosked.com"]},{name:"Klarna",category:"utility",domains:["*.klarna.com"]},{name:"Klaviyo",category:"ad",domains:["*.klaviyo.com"]},{name:"Klevu Search",company:"Klevu",category:"utility",domains:["*.klevu.com"]},{name:"Klick2Contact",category:"customer-success",domains:["*.klick2contact.com"]},{name:"Knight Lab",company:"Northwestern University",category:"utility",domains:["*.knightlab.com"]},{name:"Kodajo",category:"other",domains:["*.kodajo.com"]},{name:"Komoona",category:"ad",domains:["*.komoona.com"]},{name:"Korrelate",company:"JD Power",category:"analytics",domains:["*.korrelate.net"]},{name:"LKQD",category:"ad",domains:["*.lkqd.net"]},{name:"Layer0",category:"cdn",domains:["*.layer0.co"]},{name:"Layershift",category:"hosting",domains:["109.109.138.174"]},{name:"Lead Forensics",category:"ad",domains:["*.200summit.com","*.baw5tracker.com","*.business-path-55.com","*.bux1le001.com","*.central-core-7.com","*.direct-azr-78.com","*.explore-123.com","*.forensics1000.com","*.gldsta-02-or.com","*.green-bloc9.com","*.lansrv040.com","*.lead-123.com","*.leadforensics.com","*.mavic852.com","*.mon-com-net.com","*.peak-ip-54.com","*.snta0034.com","*.svr-prc-01.com","*.syntace-094.com","*.tghbn12.com","*.trail-web.com","*.web-01-gbl.com","*.web-cntr-07.com","*.trackdiscovery.net"]},{name:"Lead Intelligence",company:"Magnetise Solutions",category:"ad",domains:["*.leadintelligence.co.uk"]},{name:"LeadLander",category:"analytics",domains:["*.formalyzer.com","*.trackalyzer.com"]},{name:"Leaflet",category:"utility",domains:["*.leafletjs.com"]},{name:"LeasdBoxer",company:"LeadBoxer",category:"ad",domains:["*.leadboxer.com"]},{name:"LeaseWeb",homepage:"https://www.leaseweb.com/",category:"cdn",domains:["*.lswcdn.net","*.leasewebcdn.com"]},{name:"Leboncoin",category:"content",domains:["*.leboncoin.fr"]},{name:"Lengow",category:"hosting",domains:["*.lengow.com"]},{name:"Lessbuttons",category:"social",domains:["*.lessbuttons.com"]},{name:"Letter Press",category:"ad",domains:["*.getletterpress.com"]},{name:"Level 3 Communications",category:"utility",domains:["footprint.net"]},{name:"Level3",category:"other",domains:["secure.footprint.net"]},{name:"Lifestreet Media",category:"social",domains:["*.lfstmedia.com"]},{name:"LiftSuggest",category:"analytics",domains:["d2blwevgjs7yom.cloudfront.net"]},{name:"Ligatus",category:"ad",domains:["*.ligadx.com"]},{name:"LightStep",category:"analytics",domains:["*.lightstep.com"]},{name:"LightWidget",category:"utility",domains:["*.lightwidget.com"]},{name:"Likelihood",company:"LIkeihood",category:"hosting",domains:["*.likelihood.com"]},{name:"LikeShop",company:"Dash Hudson",category:"content",domains:["likeshop.me"]},{name:"LINE Corporation",category:"ad",domains:["*.line-scdn.net","*.line.me"]},{name:"Linkcious",category:"analytics",domains:["*.linkcious.com"]},{name:"Linking Mobile",category:"ad",domains:["*.linkingmobile.com"]},{name:"LittleData",category:"analytics",homepage:"https://www.littledata.io/",domains:["*.littledata.io"]},{name:"LiveBurst",category:"ad",domains:["*.liveburst.com"]},{name:"LiveClicker",category:"ad",domains:["*.liveclicker.net"]},{name:"LiveHelpNow",category:"customer-success",domains:["*.livehelpnow.net"]},{name:"LiveInternet",category:"analytics",domains:["*.yadro.ru"]},{name:"LiveJournal",category:"social",domains:["*.livejournal.com","*.livejournal.net"]},{name:"LivePerson",category:"customer-success",homepage:"https://www.liveperson.com/",domains:["*.liveperson.com","*.look.io","*.liveperson.net","*.lpsnmedia.net"]},{name:"LiveRail",company:"Facebook",category:"ad",domains:["*.liverail.com","*.lrcdn.net"]},{name:"LiveTex",category:"customer-success",domains:["*.livetex.ru"]},{name:"Livefyre",category:"content",domains:["*.fyre.co","*.livefyre.com"]},{name:"Living Map Company",category:"utility",domains:["*.livingmap.com"]},{name:"Local World",category:"content",domains:["*.thelocalpeople.co.uk"]},{name:"LockerDome",category:"analytics",domains:["*.lockerdome.com"]},{name:"Logentries",company:"Rapid",category:"utility",domains:["*.logentries.com"]},{name:"Logicalis",category:"analytics",domains:["*.trovus.co.uk"]},{name:"LoginRadius",company:"LoginRadius",homepage:"https://www.loginradius.com/",category:"ad",domains:["*.loginradius.com","*.lrcontent.com"]},{name:"LongTail Ad Solutions",category:"ad",domains:["*.jwpcdn.com","*.jwplatform.com","*.jwplayer.com","*.jwpltx.com","*.jwpsrv.com","*.longtailvideo.com"]},{name:"Loop Commerce",category:"other",domains:["*.loopassets.net"]},{name:"Loop11",category:"analytics",domains:["*.loop11.com"]},{name:"LoopMe",category:"ad",domains:["*.loopme.biz","*.loopme.com","*.vntsm.com","*.loopme.me"]},{name:"Looper",category:"content",domains:["*.looper.com"]},{name:"Loyalty Point",category:"ad",domains:["*.loyaltypoint.pl"]},{name:"LoyaltyLion",category:"ad",domains:["*.loyaltylion.com","*.loyaltylion.net","dg1f2pfrgjxdq.cloudfront.net"]},{name:"Luma Tag",category:"analytics",domains:["*.lumatag.co.uk"]},{name:"Lumesse",category:"content",domains:["*.recruitmentplatform.com"]},{name:"Luminate",category:"ad",domains:["*.luminate.com"]},{name:"Lynchpin Analytics",category:"analytics",domains:["*.lypn.net"]},{name:"Lyris",category:"ad",domains:["*.clicktracks.com"]},{name:"Lytics",category:"ad",domains:["*.lytics.io"]},{name:"MEC WebTrack",company:"MEC",category:"ad",domains:["*.e-webtrack.net"]},{name:"MECLABS Institute",category:"analytics",domains:["*.meclabs.com","*.meclabsdata.com"]},{name:"MLveda",category:"utility",domains:["*.mlveda.com"]},{name:"Macromill",company:"Macromill",category:"analytics",homepage:"https://group.macromill.com/",domains:["*.macromill.com"]},{name:"Macropod BugHerd",company:"Macropod",category:"utility",domains:["*.bugherd.com"]},{name:"Madison Logic",category:"marketing",domains:["*.ml314.com"]},{name:"Madmetrics",company:"Keyade",category:"analytics",domains:["*.keyade.com"]},{name:"Magnetic",category:"ad",domains:["*.domdex.com","d3ezl4ajpp2zy8.cloudfront.net"]},{name:"Magnetic Platform",company:"Magnetic",category:"ad",domains:["*.magnetic.is"]},{name:"MailMunch",category:"ad",domains:["*.mailmunch.co"]},{name:"MailPlus",category:"ad",domains:["*.mailplus.nl"]},{name:"Mapbox",category:"utility",domains:["*.mapbox.com"]},{name:"Maptive",category:"utility",domains:["*.maptive.com"]},{name:"Marcaria.com",category:"other",domains:["*.gooo.al"]},{name:"Marchex",category:"analytics",domains:["*.voicestar.com","*.marchex.io"]},{name:"Mark and Mini",category:"ad",domains:["*.markandmini.com"]},{name:"Marker",category:"utility",domains:["*.marker.io"]},{name:"Marketing Dashboards",company:"GroupM",category:"analytics",domains:["*.m-decision.com"]},{name:"Marketizator",category:"analytics",domains:["*.marketizator.com"]},{name:"Marketplace Web Service",company:"Amazon",category:"other",domains:["*.ssl-images-amazon.com"]},{name:"Mashable",category:"social",domains:["*.mshcdn.com"]},{name:"MatchWork",category:"utility",domains:["*.matchwork.com"]},{name:"MathJax",category:"utility",domains:["*.mathjax.org"]},{name:"Mather Economics",category:"analytics",domains:["*.matheranalytics.com"]},{name:"MaxCDN Enterprise",company:"MaxCDN",category:"utility",domains:["*.netdna-cdn.com","*.netdna-ssl.com"]},{name:"MaxMind",category:"utility",domains:["*.maxmind.com"]},{name:"MaxPoint Interactive",category:"ad",domains:["*.mxptint.net"]},{name:"Maxsi",category:"analytics",domains:["*.evisitanalyst.com"]},{name:"Maxymiser",category:"analytics",domains:["*.maxymiser.net, maxymiser.hs.llnwd.net"]},{name:"McAffee",category:"utility",domains:["*.mcafeesecure.com","*.scanalert.com"]},{name:"Measured",category:"analytics",domains:["*.measured.com"],homepage:"https://www.measured.com/"},{name:"Media IQ",category:"analytics",domains:["*.mediaiqdigital.com"]},{name:"Media Management Technologies",category:"ad",domains:["*.speedshiftmedia.com"]},{name:"Media Temple",category:"hosting",domains:["*.goodlayers2.com"]},{name:"Mediabong",category:"ad",domains:["*.mediabong.net"]},{name:"Mediahawk",category:"analytics",domains:["*.mediahawk.co.uk"]},{name:"Mediahub",category:"ad",domains:["*.hubverifyandoptimize.com","*.projectwatchtower.com"]},{name:"Mediasyndicator",category:"ad",domains:["*.creativesyndicator.com"]},{name:"Medium",category:"content",domains:["*.medium.com"]},{name:"Meetrics",category:"ad",domains:["*.de.com","*.meetrics.net","*.mxcdn.net"]},{name:"Mega",company:"Mega Information Technology",category:"other",domains:["*.mgcdn.com"]},{name:"Melt",category:"ad",domains:["*.meltdsp.com","*.mesp.com"]},{name:"Meltwater Group",category:"customer-success",domains:["*.meltwaternews.com"]},{name:"Meme",category:"ad",domains:["*.viewwonder.com"]},{name:"MentAd",category:"ad",domains:["*.mentad.com"]},{name:"Mention Me",category:"ad",domains:["*.mention-me.com"]},{name:"Merchant Equipment Store",category:"utility",domains:["*.merchantequip.com"]},{name:"Merchenta",category:"customer-success",domains:["*.merchenta.com"]},{name:"Merkle Digital Data Exchange",company:"Merkle",category:"ad",domains:["*.brilig.com"]},{name:"Merkle Paid Search",company:"Merkle",category:"ad",domains:["*.rkdms.com"]},{name:"Met Office",category:"content",domains:["*.metoffice.gov.uk"]},{name:"Meta Broadcast",category:"social",domains:["*.metabroadcast.com"]},{name:"Michael Associates",category:"ad",domains:["*.checktestsite.com"]},{name:"Michelin",category:"content",domains:["*.viamichelin.com"]},{name:"Microad",category:"ad",domains:["*.microad.jp"]},{name:"Microsoft Certificate Services",company:"Microsoft",category:"utility",domains:["*.msocsp.com"]},{name:"Microsoft Hosted Libs",company:"Microsoft",category:"cdn",domains:["*.aspnetcdn.com"]},{name:"Microsoft XBox Live",company:"Microsoft",category:"marketing",domains:["*.xboxlive.com"]},{name:"Mightypop",category:"ad",domains:["*.mightypop.ca"]},{name:"Mika Tuupola",category:"utility",domains:["*.appelsiini.net"]},{name:"Millennial Media",category:"ad",domains:["*.jumptap.com"]},{name:"Mirror Image Internet",category:"utility",domains:["*.miisolutions.net"]},{name:"Mobify",category:"utility",domains:["*.mobify.com","*.mobify.net"]},{name:"Mobile Nations",category:"social",domains:["*.mobilenations.com"]},{name:"Mobivate",category:"ad",domains:["*.mobivatebulksms.com"]},{name:"Momondo",category:"content",domains:["*.momondo.dk"]},{name:"Momondo Group",category:"content",domains:["*.momondogrouo.com","*.momondogroup.com"]},{name:"Monarch Ads",category:"ad",domains:["*.monarchads.com"]},{name:"Monetate",category:"analytics",domains:["*.monetate.net"]},{name:"MonetizeMore",category:"ad",domains:["*.m2.ai"]},{name:"Monitor",company:"Econda",category:"analytics",domains:["*.econda-monitor.de"]},{name:"Monkey Frog Media",category:"content",domains:["*.monkeyfrogmedia.com"]},{name:"Monotype",category:"cdn",domains:["*.fonts.com","*.fonts.net"]},{name:"Moore-Wilson",category:"ad",domains:["*.mwdev.co.uk"]},{name:"Moovweb",category:"utility",domains:["*.moovweb.net"]},{name:"Mopinion",category:"analytics",domains:["*.mopinion.com"]},{name:"MotionPoint",category:"other",domains:["*.convertlanguage.com"]},{name:"Mouse3K",category:"analytics",domains:["*.mouse3k.com"]},{name:"MouseStats",category:"analytics",domains:["*.mousestats.com"]},{name:"Mouseflow",category:"analytics",domains:["*.mouseflow.com"]},{name:"Movable Ink",category:"analytics",domains:["*.micpn.com"]},{name:"MovingIMAGE24",category:"content",domains:["*.edge-cdn.net"]},{name:"Moxielinks",category:"ad",domains:["*.moxielinks.com"]},{name:"Moz Recommended Companies",company:"Moz",category:"analytics",domains:["d2eeipcrcdle6.cloudfront.net"]},{name:"Mozilla",category:"utility",domains:["*.mozilla.org"]},{name:"Multiview",category:"content",domains:["*.multiview.com","*.track-mv.com"]},{name:"Mux",category:"analytics",domains:["*.litix.io"]},{name:"MyAds",company:"MyBuys",category:"analytics",domains:["*.veruta.com"]},{name:"MyBuys",category:"analytics",domains:["*.mybuys.com"]},{name:"MyFonts",category:"cdn",domains:["*.myfonts.net"]},{name:"MyRegistry",category:"other",domains:["*.myregistry.com"]},{name:"MySpace",company:"Specific Media",category:"social",domains:["*.myspace.com"]},{name:"Mynewsdesk",category:"utility",domains:["*.mynewsdesk.com"]},{name:"NAVIS",category:"content",domains:["*.navistechnologies.info"]},{name:"NCC Group Real User Monitoring",company:"NCC Group",category:"analytics",domains:["*.nccgroup-webperf.com"]},{name:"NEORY Marketing Cloud",company:"NEORY",category:"marketing",domains:["*.ad-srv.net"]},{name:"Nanigans",category:"ad",domains:["*.nanigans.com"]},{name:"Nano Interactive",category:"ad",domains:["*.audiencemanager.de"]},{name:"Nanorep",company:"Nanorep Technologies",category:"customer-success",domains:["*.nanorep.com"]},{name:"Narrative",category:"ad",domains:["*.narrative.io"]},{name:"Native Ads",category:"ad",domains:["*.nativeads.com"]},{name:"Nativo",category:"ad",domains:["*.postrelease.com"]},{name:"Navegg",category:"ad",domains:["*.navdmp.com"]},{name:"NaviStone",category:"ad",domains:["*.murdoog.com"]},{name:"Naytev",category:"analytics",domains:["*.naytev.com"]},{name:"Needle",category:"analytics",domains:["*.needle.com"]},{name:"Neiman Marcus",category:"content",domains:["*.ctscdn.com"]},{name:"Nend",category:"ad",domains:["*.nend.net"]},{name:"Neodata",category:"ad",domains:["*.neodatagroup.com"]},{name:"Net Applications",category:"analytics",domains:["*.hitsprocessor.com"]},{name:"Net Reviews",category:"analytics",domains:["*.avis-verifies.com"]},{name:"NetAffiliation",company:"Kwanco",category:"ad",domains:["*.metaffiliation.com"]},{name:"NetDirector",company:"G-Forces Web Management",category:"other",domains:["*.netdirector.co.uk"]},{name:"NetFlix",category:"content",domains:["*.nflxext.com","*.nflximg.net"]},{name:"Nielsen NetRatings SiteCensus",company:"The Nielsen Company",homepage:"http://www.nielsen-online.com/intlpage.html",category:"analytics",domains:["*.imrworldwide.com"]},{name:"NetSeer",category:"ad",domains:["*.netseer.com","*.ns-cdn.com"]},{name:"NetShelter",company:"Ziff Davis Tech",category:"ad",domains:["*.netshelter.net"]},{name:"Netmining",company:"Ignition One",category:"ad",domains:["*.netmng.com"]},{name:"Netop",category:"customer-success",domains:["*.netop.com"]},{name:"Network Solutions",category:"utility",domains:["*.netsolssl.com","*.networksolutions.com"]},{name:"Neustar AdAdvisor",company:"Neustar",category:"ad",domains:["*.adadvisor.net"]},{name:"New Approach Media",category:"ad",domains:["*.newapproachmedia.co.uk"]},{name:"NewShareCounts",category:"social",domains:["*.newsharecounts.com"]},{name:"News",category:"social",domains:["*.news.com.au","*.newsanalytics.com.au","*.newsapi.com.au","*.newscdn.com.au","*.newsdata.com.au","*.newsdiscover.com.au","*.news-static.com"]},{name:"Newsquest",category:"content",domains:["*.newsquestdigital.co.uk"]},{name:"Newzulu",category:"content",domains:["*.filemobile.com","*.projects.fm"]},{name:"Nexcess.Net",category:"hosting",domains:["*.nexcesscdn.net"]},{name:"Nexstar Media Group",category:"ad",domains:["*.yashi.com"]},{name:"NextPerf",company:"Rakuten Marketing",category:"ad",domains:["*.nxtck.com"]},{name:"Nine.com.au",company:"Nine Digital",category:"content",domains:["*.9msn.com.au"]},{name:"NitroSell",category:"hosting",domains:["*.nitrosell.com"]},{name:"Nochex",category:"utility",domains:["*.nochex.com"]},{name:"Northern &amp; Shell Media Group",category:"content",domains:["*.northernandshell.co.uk"]},{name:"Nosto",category:"analytics",domains:["*.nosto.com"]},{name:"Now Interact",category:"analytics",domains:["*.nowinteract.com"]},{name:"Numberly",company:"1000mercis",category:"ad",domains:["*.mmtro.com","*.nzaza.com"]},{name:"NyaConcepts",category:"analytics",domains:["*.xclusive.ly"]},{name:"O2",category:"other",domains:["*.o2.co.uk"]},{name:"GoDaddy",homepage:"https://www.godaddy.com/",category:"utility",domains:["*.godaddy.com","*.wsimg.com"]},{name:"ObjectPlanet",category:"analytics",domains:["*.easypolls.net"]},{name:"OhMyAd",category:"ad",domains:["*.ohmyad.co"]},{name:"Okas Concepts",category:"utility",domains:["*.okasconcepts.com"]},{name:"Okta",category:"analytics",domains:["*.okta.com"]},{name:"Olapic",category:"content",domains:["*.photorank.me"]},{name:"Ometria",category:"analytics",domains:["*.ometria.com"]},{name:"Omniconvert",category:"analytics",domains:["*.omniconvert.com","d2tgfbvjf3q6hn.cloudfront.net","d3vbj265bmdenw.cloudfront.net"]},{name:"Omniroot",company:"Verizon",category:"utility",domains:["*.omniroot.com"]},{name:"OnAudience",company:"Cloud Technologies",category:"ad",domains:["*.onaudience.com"]},{name:"OnScroll",category:"ad",domains:["*.onscroll.com"]},{name:"OnState",category:"ad",domains:["*.onstate.co.uk"]},{name:"OnYourMap",category:"utility",domains:["*.onyourmap.com"]},{name:"One by AOL",company:"AOL",category:"ad",domains:["*.adtechjp.com","*.adtech.de"]},{name:"One by AOL:Mobile",company:"AOL",category:"ad",domains:["*.nexage.com"]},{name:"OneAll",category:"analytics",domains:["*.oneall.com"]},{name:"OneSoon",category:"analytics",domains:["*.adalyser.com"]},{name:"OneTag",category:"ad",domains:["*.onetag-sys.com"]},{name:"Onet",category:"ad",domains:["*.onet.pl"]},{name:"Online Rewards",company:"Mastercard",category:"ad",domains:["*.loyaltygateway.com"]},{name:"Online republic",category:"content",domains:["*.imallcdn.net"]},{name:"Ooyala",category:"ad",domains:["*.ooyala.com"]},{name:"OpenTable",company:"Priceline Group",category:"content",domains:["*.opentable.com","*.opentable.co.uk","*.toptable.co.uk"]},{name:"OpenX Ad Exchange",company:"OpenX Technologies",category:"ad",domains:["*.liftdna.com"]},{name:"Opinion Stage",category:"analytics",domains:["*.opinionstage.com"]},{name:"OpinionBar",category:"analytics",domains:["*.opinionbar.com"]},{name:"Opta",company:"Perform Group",category:"content",domains:["*.opta.net"]},{name:"OptiMonk",category:"ad",domains:["*.optimonk.com"]},{name:"Optilead",category:"analytics",domains:["*.dyn-img.com","*.leadcall.co.uk","*.optilead.co.uk"]},{name:"Optimatic",category:"ad",domains:["*.optimatic.com"]},{name:"Optimise Media Group",category:"utility",domains:["*.omguk.com"]},{name:"Optimost",company:"OpenText",category:"ad",domains:["*.optimost.com"]},{name:"Optimove",company:"Mobius Solutions",category:"analytics",domains:["*.optimove.net"]},{name:"Optorb",category:"ad",domains:["*.optorb.com"]},{name:"Oracle",category:"marketing",domains:["*.custhelp.com","*.eloqua.com","*.en25.com","*.estara.com","*.instantservice.com"]},{name:"Oracle Recommendations On Demand",company:"Oracle",category:"analytics",domains:["*.atgsvcs.com"]},{name:"Oracle Responsys",company:"Oracle",category:"marketing",domains:["*.adrsp.net","*.responsys.net"]},{name:"Order Security-VOID",company:"Order Security",category:"analytics",domains:["*.order-security.com"]},{name:"Oriel",category:"ad",domains:["*.oriel.io"]},{name:"Outbrain",homepage:"https://www.outbrain.com/",category:"ad",domains:["*.outbrain.com","*.outbrainimg.com","*.visualrevenue.com"]},{name:"OverStream",company:"Coull",category:"ad",domains:["*.coull.com"]},{name:"Overdrive",category:"content",domains:["*.contentreserve.com"]},{name:"Overstock",category:"utility",domains:["*.ostkcdn.com"]},{name:"OwnerIQ",category:"ad",domains:["*.owneriq.net"]},{name:"OzCart",category:"utility",domains:["*.ozcart.com.au"]},{name:"Ozone Media",category:"ad",domains:["*.adadyn.com"]},{name:"Loqate",company:"Loqate",category:"other",domains:["*.pcapredict.com","*.postcodeanywhere.co.uk"]},{name:"PEER 1 Hosting",category:"hosting",domains:["*.peer1.com"]},{name:"PERFORM",category:"content",domains:["*.performgroup.com"]},{name:"PICnet",category:"hosting",domains:["*.nonprofitsoapbox.com"]},{name:"Pacnet",company:"Telstra",category:"other",domains:["*.cdndelivery.net"]},{name:"Pagefair",category:"ad",domains:["*.pagefair.com","*.pagefair.net"]},{name:"Pagely",category:"other",domains:["*.optnmstr.com"]},{name:"Pagesuite",category:"ad",domains:["*.pagesuite-professional.co.uk"]},{name:"Pardot",category:"marketing",domains:["*.pardot.com"]},{name:"Parse.ly",category:"analytics",domains:["*.parsely.com","d1z2jf7jlzjs58.cloudfront.net"]},{name:"Pay per Click",company:"Eysys",category:"ad",domains:["*.eysys.com"]},{name:"PayPal Ads",category:"ad",domains:["*.where.com"]},{name:"Peaks & Pies",category:"analytics",domains:["*.bunchbox.co"]},{name:"PebblePost",category:"ad",domains:["*.pbbl.co"]},{name:"Peerius",category:"analytics",domains:["*.peerius.com"]},{name:"Peermap",company:"IMRG",category:"analytics",domains:["peermapcontent.affino.com"]},{name:"Penske Media",category:"content",domains:["*.pmc.com"]},{name:"Penton",category:"utility",domains:["*.pisces-penton.com"]},{name:"Pepper",category:"ad",domains:["*.peppercorp.com"]},{name:"Perfect Audience",company:"Marin Software",category:"ad",domains:["*.prfct.co","*.marinsm.com","*.perfectaudience.com"]},{name:"Perfect Market",category:"ad",domains:["*.perfectmarket.com"]},{name:"Perfect Privacy",category:"other",domains:["*.suitesmart.com"]},{name:"Perform Group",category:"content",domains:["*.performfeeds.com","*.premiumtv.co.uk"]},{name:"Performio",category:"ad",domains:["*.performax.cz"]},{name:"PerimeterX Bot Defender",company:"PerimeterX",category:"utility",domains:["*.perimeterx.net","*.pxi.pub"]},{name:"Periscope",category:"content",domains:["*.periscope.tv"]},{name:"Permutive",category:"ad",domains:["*.permutive.com","d3alqb8vzo7fun.cloudfront.net"]},{name:"Petametrics",category:"analytics",domains:["*.petametrics.com"]},{name:"PhotoBucket",category:"content",domains:["*.photobucket.com"]},{name:"Picreel",category:"analytics",domains:["*.pcrl.co","*.picreel.com"]},{name:"Pictela (AOL)",category:"analytics",domains:["*.pictela.net"]},{name:"PistonHeads",category:"social",domains:["*.pistonheads.com"]},{name:"Piwik",category:"analytics",domains:["*.drtvtracker.com","*.piwikpro.com","*.raac33.net"]},{name:"Pixalate",category:"utility",domains:["*.adrta.com"]},{name:"Pixlee",category:"social",domains:["*.pixlee.com"]},{name:"Placed",category:"analytics",domains:["*.placed.com"]},{name:"Planning-inc",category:"analytics",domains:["*.planning-inc.co.uk"]},{name:"PlayAd Media Group",category:"ad",domains:["*.youplay.se"]},{name:"Playbuzz",category:"hosting",domains:["*.playbuzz.com"]},{name:"Pleenq",category:"ad",domains:["*.pleenq.com"]},{name:"Plentific",category:"content",domains:["*.plentific.com"]},{name:"PluginDetect",category:"other",domains:["dtlilztwypawv.cloudfront.net"]},{name:"Po.st",company:"RadiumOne",category:"utility",domains:["*.po.st"]},{name:"Pointpin",category:"utility",domains:["*.pointp.in"]},{name:"Pointroll (Garnett)",category:"ad",domains:["*.pointroll.com"]},{name:"Polar",homepage:"https://polar.me/",category:"ad",domains:["*.polarmobile.ca","*.mediaeverywhere.com","*.mediavoice.com","*.plrsrvcs.com","*.polarcdn-engine.com","*.polarcdn-meraxes.com","*.polarcdn-pentos.com","*.polarcdn-static.com","*.polarcdn-terrax.com","*.polarcdn.com","*.polarmobile.com","*.poweredbypolar.com","*.mediaconductor.me","*.polaracademy.me"]},{name:"PollDaddy (Automattic)",category:"ad",domains:["static.polldaddy.com","*.poll.fm"]},{name:"Polldaddy",company:"Automattic",category:"analytics",domains:["polldaddy.com","*.polldaddy.com"]},{name:"Polyfill service",company:"Polyfill.io",category:"other",domains:["*.polyfill.io"]},{name:"MegaPopAds",category:"ad",domains:["*.megapopads.com"]},{name:"Populis",category:"ad",domains:["*.populisengage.com"]},{name:"Postimage.org",category:"content",domains:["*.postimg.org"]},{name:"PowerFront",category:"hosting",domains:["*.inside-graph.com"]},{name:"PowerReviews",category:"analytics",domains:["*.powerreviews.com"]},{name:"Powerlinks.com",category:"ad",domains:["*.powerlinks.com"]},{name:"Press+",category:"ad",domains:["*.pipol.com","*.ppjol.com","*.ppjol.net"]},{name:"PressArea",category:"utility",domains:["*.pressarea.com"]},{name:"Pretio Interactive",category:"ad",domains:["*.pretio.in"]},{name:"Prezi",category:"utility",domains:["*.prezi.com"]},{name:"PriceGrabber",category:"content",domains:["*.pgcdn.com","*.pricegrabber.com"]},{name:"PriceRunner",category:"content",domains:["*.pricerunner.com"]},{name:"PrintFriendly",category:"utility",domains:["*.printfriendly.com"]},{name:"Privy",category:"ad",domains:["*.privy.com","*.privymktg.com"]},{name:"Proclivity Media",category:"analytics",domains:["*.pswec.com"]},{name:"Profitshare",category:"ad",domains:["*.profitshare.ro"]},{name:"Programattik",category:"ad",domains:["*.programattik.com"]},{name:"Proper Media",category:"content",domains:["*.proper.io"]},{name:"Property Week",category:"content",domains:["*.propertyweek.com"]},{name:"Provide Support",category:"customer-success",domains:["*.providesupport.com"]},{name:"Proweb Uk",category:"hosting",domains:["*.proweb.net"]},{name:"Proximic (ComScore)",category:"ad",domains:["*.proximic.com"]},{name:"Psyma",category:"ad",domains:["*.psyma.com"]},{name:"PubFactory",company:"Safari Books Online",category:"content",domains:["*.pubfactory.com"]},{name:"PubNation",category:"ad",domains:["*.pubnation.com"]},{name:"Publicidad.net",category:"ad",domains:["*.publicidad.tv"]},{name:"PublishThis",company:"Ultra Unlimited",category:"ad",domains:["*.publishthis.com"]},{name:"Pulse Insights",category:"analytics",domains:["*.pulseinsights.com"]},{name:"Pulsepoint",category:"marketing",domains:["*.displaymarketplace.com"]},{name:"Purch",category:"ad",domains:["*.bestofmedia.com","*.purch.com"]},{name:"Pure Chat",category:"customer-success",domains:["*.purechat.com"]},{name:"PushCrew",category:"ad",domains:["*.pushcrew.com"]},{name:"Q1Media",category:"ad",domains:["*.q1media.com","*.q1mediahydraplatform.com"]},{name:"Qbase Software Development",category:"hosting",domains:["*.smartwebportal.co.uk"]},{name:"Qeryz",category:"analytics",domains:["*.qeryz.com"]},{name:"Qode Interactive",category:"hosting",domains:["*.qodeinteractive.com"]},{name:"Qrius",category:"social",domains:["*.qrius.me"]},{name:"Qualaroo",category:"analytics",domains:["*.qualaroo.com"]},{name:"Qualtrics",category:"analytics",domains:["*.qualtrics.com"]},{name:"Qubit",company:"Qubit",category:"analytics",domains:["*.qubit.com","*.qutics.com","d3c3cq33003psk.cloudfront.net","*.goqubit.com","*.qubitproducts.com"]},{name:"Qubit Deliver",company:"Qubit",category:"analytics",domains:["d1m54pdnjzjnhe.cloudfront.net","d22rutvoghj3db.cloudfront.net","dd6zx4ibq538k.cloudfront.net"]},{name:"QuestionPro",category:"analytics",domains:["*.questionpro.com"]},{name:"Queue-it",category:"other",domains:["*.queue-it.net"]},{name:"QuinStreet",category:"ad",domains:["*.Quinstreet.com","*.b2btechleadform.com","*.qnsr.com","*.qsstats.com"]},{name:"QuoVadis",category:"utility",domains:["*.quovadisglobal.com"]},{name:"Qzzr",category:"analytics",domains:["*.movementventures.com","*.qzzr.com"]},{name:"RapidAPI",category:"utility",domains:["*.rapidapi.com"]},{name:"RCS Media Group",category:"ad",domains:["*.rcsadv.it"]},{name:"REVIVVE",category:"ad",domains:["*.revivve.com"]},{name:"RSSinclude",category:"social",domains:["*.rssinclude.com"]},{name:"RTB House AdPilot",company:"RTB House",category:"ad",domains:["*.erne.co","*.creativecdn.com"]},{name:"RTB Media",category:"ad",domains:["*.rtb-media.me"]},{name:"RUN",category:"ad",domains:["*.runadtag.com","*.rundsp.com"]},{name:"Rackspace",category:"hosting",domains:["*.rackcdn.com","*.rackspacecloud.com","*.raxcdn.com","*.websitetestlink.com"]},{name:"RadiumOne",category:"ad",domains:["*.gwallet.com","*.r1-cdn.net"]},{name:"Rakuten DC Storm",company:"Rakuten",category:"analytics",domains:["*.dc-storm.com","*.h4k5.com","*.stormiq.com"]},{name:"Rakuten LinkShare",company:"Rakuten",category:"ad",domains:["*.linksynergy.com"]},{name:"Rakuten Marketing",company:"Rakuten",category:"ad",domains:["*.rakuten-static.com","*.rmtag.com","tag.rmp.rakuten.com"]},{name:"Rakuten MediaForge",company:"Rakuten",category:"ad",domains:["*.mediaforge.com"]},{name:"Rambler",company:"Rambler & Co",category:"utility",domains:["*.rambler.ru"]},{name:"Ranker",category:"content",domains:["*.ranker.com","*.rnkr-static.com"]},{name:"Ravelin",category:"utility",domains:["*.ravelin.com"]},{name:"Raygun",category:"utility",domains:["*.raygun.io","*.rapidzebra.io"]},{name:"ReCollect",category:"utility",domains:["*.recollect.net"]},{name:"ReSRC",category:"utility",domains:["*.resrc.it"]},{name:"ReTargeter",category:"ad",domains:["*.retargeter.com"]},{name:"Reach Group",category:"ad",domains:["*.redintelligence.net"]},{name:"ReachDynamics",category:"ad",domains:["*.rdcdn.com"]},{name:"ReachForce",category:"ad",domains:["*.reachforce.com"]},{name:"ReachLocal",category:"ad",domains:["*.rtrk.co.nz"]},{name:"ReachMee",category:"content",domains:["*.reachmee.com"]},{name:"Reactful",category:"analytics",domains:["*.reactful.com"]},{name:"Realtime",company:"internet business technologies",category:"utility",domains:["*.realtime.co"]},{name:"Realtime Media (Brian Communications)",category:"ad",domains:["*.rtm.com"]},{name:"Realtime Targeting",category:"ad",domains:["*.idtargeting.com"]},{name:"Realytics",category:"analytics",domains:["dcniko1cv0rz.cloudfront.net","*.realytics.net"]},{name:"RebelMouse",category:"ad",domains:["*.rebelmouse.com","*.rbl.ms"]},{name:"Receiptful",category:"utility",domains:["*.receiptful.com"]},{name:"Recite Me",category:"other",domains:["*.reciteme.com"]},{name:"RecoBell",category:"analytics",domains:["*.recobell.io"]},{name:"Recommend",category:"analytics",domains:["*.recommend.pro"]},{name:"Red Eye International",category:"ad",domains:["*.pajmc.com"]},{name:"Redfish Group",category:"ad",domains:["*.wmps.com"]},{name:"Reevoo",category:"analytics",domains:["*.reevoo.com"]},{name:"Refersion",category:"ad",domains:["*.refersion.com"]},{name:"Refined Ads",category:"ad",domains:["*.refinedads.com"]},{name:"Reflektion",category:"analytics",domains:["*.reflektion.com","d26opx5dl8t69i.cloudfront.net"]},{name:"Reflow",company:"Scenestealer",category:"ad",domains:["*.reflow.tv"]},{name:"Reklama",category:"ad",domains:["*.o2.pl","*.wp.pl"]},{name:"Relevad ReleStar",company:"Relevad",category:"ad",domains:["*.relestar.com"]},{name:"Remarketing Pixel",company:"Adsterra Network",category:"ad",domains:["*.datadbs.com","*.remarketingpixel.com"]},{name:"Remintrex",company:"SmartUp Venture",category:"ad",domains:["*.remintrex.com"]},{name:"Republer",category:"ad",domains:["*.republer.com"]},{name:"Research Now",category:"analytics",domains:["*.researchgnow.com","*.researchnow.com"]},{name:"Research Online",company:"Skills Development Scotland",category:"content",domains:["*.researchonline.org.uk"]},{name:"Resonance Insights",category:"analytics",domains:["*.res-x.com"]},{name:"Resonate Networks",category:"analytics",domains:["*.reson8.com"]},{name:"Response Team",category:"ad",domains:["*.i-transactads.com"]},{name:"ResponseTap",category:"analytics",domains:["*.adinsight.com","*.responsetap.com"]},{name:"ResponsiveVoice",category:"other",domains:["*.responsivevoice.org"]},{name:"Retention Science",category:"ad",domains:["*.retentionscience.com","d1stxfv94hrhia.cloudfront.net"]},{name:"Revcontent",category:"content",domains:["*.revcontent.com"]},{name:"Revee",category:"ad",domains:["*.revee.com"]},{name:"Revenue Conduit",category:"utility",domains:["*.revenueconduit.com"]},{name:"RevenueMantra",category:"ad",domains:["*.revenuemantra.com"]},{name:"Reviews.co.uk",category:"analytics",domains:["*.reviews.co.uk"]},{name:"Reviews.io",category:"analytics",domains:["*.reviews.io"]},{name:"Revolver Maps",category:"analytics",domains:["*.revolvermaps.com"]},{name:"Revv",category:"utility",domains:["*.revv.co"]},{name:"RichRelevance",category:"analytics",domains:["*.richrelevance.com"]},{name:"RightNow Service Cloud",company:"Oracle",category:"customer-success",domains:["*.rightnowtech.com","*.rnengage.com"]},{name:"Rightster",category:"ad",domains:["*.ads-creativesyndicator.com"]},{name:"Riskified",category:"utility",domains:["*.riskified.com"]},{name:"Rockerbox",category:"analytics",homepage:"https://www.rockerbox.com/",domains:["getrockerbox.com"]},{name:"Rocket Fuel",category:"ad",domains:["*.rfihub.com","*.ru4.com","*.rfihub.net","*.ad1x.com"]},{name:"Rollbar",category:"utility",domains:["*.rollbar.com","d37gvrvc0wt4s1.cloudfront.net"]},{name:"RomanCart",category:"utility",domains:["*.romancart.com"]},{name:"Rondavu",category:"ad",domains:["*.rondavu.com"]},{name:"Roomkey",category:"content",domains:["*.roomkey.com"]},{name:"Roost",category:"utility",domains:["*.goroost.com"]},{name:"Roxot",category:"ad",domains:["*.rxthdr.com"]},{name:"Roxr Software",category:"analytics",domains:["*.getclicky.com"]},{name:"Rtoaster",company:"Brainpad",homepage:"https://www.brainpad.co.jp/rtoaster/",category:"marketing",domains:["*.rtoaster.jp"]},{name:"Rubikloud.com",category:"analytics",domains:["*.rubikloud.com"]},{name:"Ruler Analytics",company:"Ruler",category:"analytics",domains:["*.nyltx.com","*.ruleranalytics.com"]},{name:"Runner",company:"Rambler & Co",category:"content",domains:["*.begun.ru"]},{name:"S4M",category:"ad",domains:["*.sam4m.com"]},{name:"SAP Hybris Marketing Convert",company:"SAP",category:"ad",domains:["*.seewhy.com"]},{name:"SAS Institute",category:"ad",domains:["*.aimatch.com","*.sas.com"]},{name:"SATORI",homepage:"https://satori.marketing/",category:"marketing",domains:["satori.segs.jp"]},{name:"SC ShopMania Net SRL",category:"content",domains:["*.shopmania.com"]},{name:"SDL Media Manager",company:"SDL",category:"other",domains:["*.sdlmedia.com"]},{name:"SFR",category:"other",domains:["*.sfr.fr"]},{name:"SLI Systems",category:"utility",domains:["*.resultslist.com","*.resultspage.com","*.sli-spark.com"]},{name:"SMARTASSISTANT",company:"Smart Information Systems",category:"customer-success",domains:["*.smartassistant.com"]},{name:"SMARTSTREAM.TV",category:"ad",domains:["*.smartstream.tv"]},{name:"SPX",company:"Smaato",category:"ad",domains:["*.smaato.net"]},{name:"Sabio",category:"customer-success",domains:["*.sabio.co.uk"]},{name:"Sailthru",category:"analytics",domains:["*.sail-horizon.com","*.sail-personalize.com","*.sail-track.com"]},{name:"Sailthru Sightlines",company:"Sailthru",category:"marketing",domains:["*.sailthru.com"]},{name:"Sajari Pty",category:"utility",domains:["*.sajari.com"]},{name:"SaleCycle",category:"ad",domains:["*.salecycle.com","d16fk4ms6rqz1v.cloudfront.net","d22j4fzzszoii2.cloudfront.net","d30ke5tqu2tkyx.cloudfront.net","dn1i8v75r669j.cloudfront.net"]},{name:"Salesforce Live Agent",company:"Salesforce.com",category:"customer-success",domains:["*.salesforceliveagent.com"]},{name:"Salesforce.com",category:"ad",domains:["*.force.com","*.salesforce.com"]},{name:"Samba TV",company:"Samba",category:"content",domains:["*.samba.tv"]},{name:"Samplicio.us",category:"analytics",domains:["*.samplicio.us"]},{name:"Say Media",category:"ad",domains:["*.saymedia.com"]},{name:"Scenario",category:"analytics",domains:["*.getscenario.com"]},{name:"Schuh (image shard)",company:"Schuh",category:"other",domains:["d2ob0iztsaxy5v.cloudfront.net"]},{name:"Science Rockstars",category:"analytics",domains:["*.persuasionapi.com"]},{name:"ScientiaMobile",category:"analytics",domains:["*.wurflcloud.com","*.wurfl.io"]},{name:"Scoota",category:"ad",domains:["*.rockabox.co","*.scoota.co","d31i2625d5nv27.cloudfront.net","dyjnzf8evxrp2.cloudfront.net"]},{name:"ScribbleLive",category:"ad",domains:["*.scribblelive.com"]},{name:"SearchForce",category:"ad",domains:["*.searchforce.net"]},{name:"SearchSpring",category:"utility",domains:["*.searchspring.net"]},{name:"Searchanise",category:"analytics",domains:["*.searchanise.com"]},{name:"Sears Holdings",category:"content",domains:["*.shld.net"]},{name:"Secomapp",category:"utility",domains:["*.secomapp.com"]},{name:"SecuredVisit",company:"4Cite Marketing",category:"ad",domains:["*.securedvisit.com"]},{name:"SecurityMetrics",category:"utility",domains:["*.securitymetrics.com"]},{name:"Segmento",category:"ad",domains:["*.rutarget.ru"]},{name:"Segmint",category:"analytics",domains:["*.segmint.net"]},{name:"Sekindo",category:"content",domains:["*.sekindo.com"]},{name:"Seldon",category:"analytics",domains:["*.rummblelabs.com"]},{name:"SelectMedia International",category:"content",domains:["*.selectmedia.asia"]},{name:"Selligent",category:"ad",domains:["*.emsecure.net","*.slgnt.eu","targetemsecure.blob.core.windows.net"]},{name:"Sellpoints",category:"analytics",domains:["*.sellpoints.com"]},{name:"Semantics3",category:"analytics",domains:["*.hits.io"]},{name:"Semasio",category:"analytics",domains:["*.semasio.net"]},{name:"Semcasting Site Visitor Attribution",company:"Semcasting",category:"ad",domains:["*.smartzonessva.com"]},{name:"Sentifi",category:"social",domains:["*.sentifi.com"]},{name:"ServMetric",category:"analytics",domains:["*.servmetric.com"]},{name:"ServiceSource International",category:"marketing",domains:["*.scoutanalytics.net"]},{name:"ServiceTick",category:"analytics",domains:["*.servicetick.com"]},{name:"Servo",company:"Xervo",category:"hosting",domains:["*.onmodulus.net"]},{name:"SessionCam",company:"ServiceTick",category:"analytics",domains:["*.sessioncam.com","d2oh4tlt9mrke9.cloudfront.net"]},{name:"Seznam",category:"utility",domains:["*.imedia.cz"]},{name:"Sharethrough",category:"ad",domains:["*.sharethrough.com"]},{name:"SharpSpring",category:"marketing",domains:["*.sharpspring.com","*.marketingautomation.services"]},{name:"ShopRunner",category:"content",domains:["*.shoprunner.com","*.s-9.us"]},{name:"ShopStorm",category:"utility",domains:["*.shopstorm.com"]},{name:"Shopatron",category:"hosting",domains:["*.shopatron.com"]},{name:"Shopgate",category:"utility",domains:["*.shopgate.com"]},{name:"ShopiMind",company:"ShopIMind",category:"ad",domains:["*.shopimind.com"]},{name:"Shopkeeper Tools",category:"utility",domains:["*.shopkeepertools.com"]},{name:"Sidecar",category:"other",domains:["*.getsidecar.com","d3v27wwd40f0xu.cloudfront.net"]},{name:"Sidereel",category:"analytics",domains:["*.sidereel.com"]},{name:"Sift Science",category:"utility",domains:["*.siftscience.com"]},{name:"Signal",category:"tag-manager",domains:["*.sitetagger.co.uk"]},{name:"Signyfyd",category:"utility",domains:["*.signifyd.com"]},{name:"Silktide",category:"hosting",domains:["*.silktide.com"]},{name:"Silverpop",company:"IBM",category:"ad",domains:["*.mkt912.com","*.mkt922.com","*.mkt932.com","*.mkt941.com","*.mkt51.net","*.mkt61.net","*.pages01.net","*.pages02.net","*.pages03.net","*.pages04.net","*.pages05.net"]},{name:"Simplaex",category:"marketing",domains:["*.simplaex.net"]},{name:"SimpleReach",category:"analytics",domains:["*.simplereach.com","d8rk54i4mohrb.cloudfront.net"]},{name:"Simplestream",category:"content",domains:["*.simplestream.com"]},{name:"Simpli.fi",category:"ad",domains:["*.simpli.fi"]},{name:"Simplicity Marketing",category:"ad",domains:["*.flashtalking.com"]},{name:"SinnerSchrader Deutschland",category:"ad",domains:["*.s2Betrieb.de"]},{name:"Sirv",category:"other",domains:["*.sirv.com"]},{name:"Site Meter",category:"analytics",domains:["*.sitemeter.com"]},{name:"Site24x7 Real User Monitoring",company:"Site24x7",category:"analytics",domains:["*.site24x7rum.com"]},{name:"SiteGainer",category:"analytics",domains:["*.sitegainer.com","d191y0yd6d0jy4.cloudfront.net"]},{name:"SiteScout",company:"Centro",category:"ad",domains:["*.pixel.ad","*.sitescout.com"]},{name:"Siteimprove",category:"utility",domains:["*.siteimprove.com","*.siteimproveanalytics.com"]},{name:"Six Degrees Group",category:"hosting",domains:["*.fstech.co.uk"]},{name:"Skimbit",category:"ad",domains:["*.redirectingat.com","*.skimresources.com","*.skimresources.net"]},{name:"Skimlinks",category:"ad",domains:["*.skimlinks.com"]},{name:"SkyGlue Technology",category:"analytics",domains:["*.skyglue.com"]},{name:"SkyScanner",category:"content",domains:["*.skyscanner.net"]},{name:"Skybet",company:"Bonne Terre t/a Sky Vegas (Sky)",category:"other",domains:["*.skybet.com"]},{name:"Skype",category:"other",domains:["*.skype.com"]},{name:"Slate Group",category:"content",domains:["*.cdnslate.com"]},{name:"SlimCut Media Outstream",company:"SlimCut Media",category:"ad",domains:["*.freeskreen.com"]},{name:"Smart Insight Tracking",company:"Emarsys",category:"analytics",domains:["*.scarabresearch.com"]},{name:"Smart AdServer",category:"ad",domains:["*.01net.com","*.sascdn.com","*.sasqos.com","*.smartadserver.com"]},{name:"SmartFocus",category:"analytics",domains:["*.emv2.com","*.emv3.com","*.predictiveintent.com","*.smartfocus.com","*.themessagecloud.com"]},{name:"Smarter Click",category:"ad",domains:["*.smct.co","*.smarterclick.co.uk"]},{name:"SmarterHQ",category:"analytics",domains:["*.smarterhq.io","d1n00d49gkbray.cloudfront.net","*.smarterremarketer.net"]},{name:"Smarttools",category:"customer-success",domains:["*.smartertrack.com"]},{name:"Smartzer",category:"ad",domains:["*.smartzer.com"]},{name:"Snack Media",category:"content",domains:["*.snack-media.com"]},{name:"Snacktools",category:"ad",domains:["*.bannersnack.com"]},{name:"SnapEngage",category:"customer-success",domains:["*.snapengage.com"]},{name:"SnapWidget",category:"content",domains:["*.snapwidget.com"]},{name:"Soasta",category:"analytics",domains:["*.lognormal.net"]},{name:"SociableLabs",category:"ad",domains:["*.sociablelabs.net","*.sociablelabs.com"]},{name:"Social Annex",category:"customer-success",domains:["*.socialannex.com"]},{name:"SocialShopWave",category:"social",domains:["*.socialshopwave.com"]},{name:"Socialphotos",category:"social",domains:["*.slpht.com"]},{name:"Sociomantic Labs",company:"DunnHumby",category:"ad",domains:["*.sociomantic.com"]},{name:"SodaHead",category:"analytics",domains:["*.sodahead.com"]},{name:"Softwebzone",category:"hosting",domains:["*.softwebzone.com"]},{name:"Sojern",category:"marketing",domains:["*.sojern.com"]},{name:"Sokrati",category:"marketing",domains:["*.sokrati.com"]},{name:"Sonobi",category:"ad",domains:["*.sonobi.com"]},{name:"Sooqr Search",company:"Sooqr",category:"utility",domains:["*.sooqr.com"]},{name:"Sophus3",category:"analytics",domains:["*.s3ae.com","*.sophus3.com"]},{name:"Sorenson Media",category:"content",domains:["*.sorensonmedia.com"]},{name:"Sortable",category:"ad",domains:["*.deployads.com"]},{name:"Sotic",category:"hosting",domains:["*.sotic.net","*.soticservers.net"]},{name:"Soundest",category:"ad",domains:["*.soundestlink.com","*.soundest.net"]},{name:"Sourcepoint",category:"ad",domains:["*.decenthat.com","*.fallingfalcon.com","*.summerhamster.com","d2lv4zbk7v5f93.cloudfront.net","d3qxwzhswv93jk.cloudfront.net"]},{name:"SourceKnowledge",homepage:"https://www.sourceknowledge.com",category:"ad",domains:["*.provenpixel.com"]},{name:"SpaceNet",category:"hosting",domains:["*.nmm.de"]},{name:"Sparkflow",company:"Intercept Interactive",category:"ad",domains:["*.sparkflow.net"]},{name:"Specific Media",category:"ad",domains:["*.specificmedia.com","*.adviva.net","*.specificclick.net"]},{name:"Spicy",company:"Data-Centric Alliance",category:"ad",domains:["*.sspicy.ru"]},{name:"Spoke",category:"customer-success",domains:["*.121d8.com"]},{name:"Spongecell",category:"ad",domains:["*.spongecell.com"]},{name:"Spot.IM",category:"social",domains:["*.spot.im","*.spotim.market"]},{name:"SpotXchange",category:"ad",domains:["*.spotxcdn.com","*.spotxchange.com","*.spotx.tv"]},{name:"SpringServer",category:"ad",domains:["*.springserve.com"]},{name:"Spylight",category:"other",domains:["*.spylight.com"]},{name:"SreamAMG",company:"StreamAMG",category:"other",domains:["*.streamamg.com"]},{name:"StackAdapt",category:"ad",domains:["*.stackadapt.com"]},{name:"StackExchange",category:"social",domains:["*.sstatic.net"]},{name:"Stackla PTY",category:"social",domains:["*.stackla.com"]},{name:"Stailamedia",category:"ad",domains:["*.stailamedia.com"]},{name:"Stamped.io",category:"analytics",domains:["*.stamped.io"]},{name:"Starfield Services Root Certificate Authority",company:"Starfield Technologies",category:"utility",domains:["*.starfieldtech.com","ss2.us","*.ss2.us"]},{name:"Starfield Technologies",category:"utility",domains:["*.websiteprotection.com"]},{name:"StatCounter",category:"analytics",domains:["*.statcounter.com"]},{name:"Statful",category:"analytics",domains:["*.statful.com"]},{name:"Steelhouse",category:"ad",domains:["*.steelhousemedia.com"]},{name:"Steepto",category:"ad",domains:["*.steepto.com"]},{name:"StellaService",category:"analytics",domains:["*.stellaservice.com"]},{name:"StickyADS.tv",category:"ad",domains:["*.stickyadstv.com"]},{name:"STINGRAY",company:"FlexOne",category:"ad",domains:["*.impact-ad.jp"]},{name:"Storify",company:"Adobe Systems",category:"social",domains:["*.storify.com"]},{name:"Storm Tag Manager",company:"Rakuten",category:"tag-manager",domains:["*.stormcontainertag.com"]},{name:"Storygize",category:"ad",domains:["*.storygize.net"]},{name:"Strands",category:"utility",domains:["*.strands.com"]},{name:"StreamRail",category:"ad",domains:["*.streamrail.com","*.streamrail.net"]},{name:"StrikeAd",category:"ad",domains:["*.strikead.com"]},{name:"Struq",company:"Quantcast",category:"ad",domains:["*.struq.com"]},{name:"StrÃ¶er Digital Media",category:"ad",domains:["*.stroeerdigitalmedia.de"]},{name:"StumbleUpon",category:"content",domains:["*.stumble-upon.com","*.stumbleupon.com"]},{name:"Sub2 Technologies",category:"analytics",domains:["*.sub2tech.com"]},{name:"SublimeSkinz",category:"ad",domains:["*.ayads.co"]},{name:"Sumo Logic",category:"utility",domains:["*.sumologic.com"]},{name:"Sunday Times Driving",category:"content",domains:["*.driving.co.uk"]},{name:"SundaySky",category:"ad",domains:["*.sundaysky.com","dds6m601du5ji.cloudfront.net"]},{name:"Sunrise Integration",category:"utility",domains:["*.sunriseintegration.com"]},{name:"Supertool Network Technology",category:"analytics",domains:["*.miaozhen.com"]},{name:"Survata",category:"analytics",domains:["*.survata.com"]},{name:"SurveyGizmo",category:"analytics",domains:["*.surveygizmo.eu"]},{name:"SurveyMonkey",category:"analytics",domains:["*.surveymonkey.com"]},{name:"Survicate",category:"analytics",domains:["*.survicate.com"]},{name:"Sweet Tooth",category:"ad",domains:["*.sweettooth.io"]},{name:"Swiftype",category:"utility",domains:["*.swiftype.com","*.swiftypecdn.com"]},{name:"Switch Concepts",category:"ad",domains:["*.switchadhub.com"]},{name:"SwitchAds",company:"Switch Concepts",category:"ad",domains:["*.switchads.com"]},{name:"Swogo",category:"analytics",domains:["*.xsellapp.com"]},{name:"Swoop",category:"ad",domains:["*.swoop.com"]},{name:"Symantec",category:"utility",domains:["*.norton.com","*.symantec.com","*.symcb.com","*.symcd.com"]},{name:"Syncapse",category:"social",domains:["*.clickable.net"]},{name:"Synergetic",category:"ad",domains:["*.synergetic.ag"]},{name:"Synthetix",category:"customer-success",domains:["*.syn-finity.com","*.synthetix-ec1.com","*.synthetix.com"]},{name:"Syte",category:"other",domains:["*.syteapi.com"]},{name:"TINT",category:"content",domains:["*.71n7.com","d33w9bm0n1egwm.cloudfront.net","d36hc0p18k1aoc.cloudfront.net","d3l7tj34e9fc43.cloudfront.net"]},{name:"TNS (Kantar Group)",category:"analytics",domains:["*.tns-counter.ru"]},{name:"TRUSTe",category:"utility",domains:["*.truste.com"]},{name:"TV Genius",company:"Ericcson Media Services",category:"content",domains:["*.tvgenius.net"]},{name:"TVSquared",category:"ad",domains:["*.tvsquared.com"]},{name:"TVTY",category:"ad",domains:["*.distribeo.com","*.ogigl.com"]},{name:"Tactics bvba",category:"hosting",domains:["*.influid.co"]},{name:"Tag Inspector",company:"InfoTrust",category:"analytics",domains:["d22xmn10vbouk4.cloudfront.net"]},{name:"TagCommander",category:"tag-manager",domains:["*.commander1.com","*.tagcommander.com"]},{name:"Tagboard",category:"social",domains:["*.tagboard.com"]},{name:"Taggstar",company:"Taggstar UK",category:"ad",domains:["*.taggstar.com"]},{name:"Tail Target",company:"Tail",category:"ad",domains:["*.tailtarget.com"]},{name:"Tailored",category:"other",domains:["d24qm7bu56swjs.cloudfront.net","dw3vahmen1rfy.cloudfront.net","*.tailored.to"]},{name:"Taleo Enterprise Cloud Service",company:"Oracle",category:"content",domains:["*.taleo.net"]},{name:"Talkable",category:"ad",domains:["*.talkable.com","d2jjzw81hqbuqv.cloudfront.net"]},{name:"TapSense",category:"ad",domains:["*.tapsense.com"]},{name:"Tapad",category:"ad",domains:["*.tapad.com"]},{name:"Teads",category:"ad",domains:["*.teads.tv"]},{name:"Team Internet Tonic",company:"Team Internet",category:"ad",domains:["*.dntrax.com"]},{name:"TechTarget",category:"content",domains:["*.techtarget.com","*.ttgtmedia.com"]},{name:"Technorati",company:"Synacor",category:"ad",domains:["*.technoratimedia.com"]},{name:"Teedhaze",category:"content",domains:["*.fuel451.com"]},{name:"Tell Apart",category:"analytics",domains:["*.tellapart.com","*.tellaparts.com"]},{name:"Tencent",category:"content",domains:["*.qq.com","*.ywxi.net"]},{name:"Thanx Media",category:"utility",domains:["*.hawksearch.info"]},{name:"Thawte",category:"utility",domains:["*.thawte.com"]},{name:"Thesis",category:"analytics",homepage:"https://www.thesistesting.com/",domains:["*.ttsep.com"]},{name:"The AA",category:"ad",domains:["*.adstheaa.com"]},{name:"The ADEX",category:"ad",domains:["*.theadex.com"]},{name:"The Best Day",category:"social",domains:["*.thebestday.com"]},{name:"The Filter",company:"Exabre",category:"analytics",domains:["*.thefilter.com"]},{name:"The Guardian",category:"analytics",domains:["*.ophan.co.uk"]},{name:"The Hut Group",category:"content",domains:["*.thcdn.com"]},{name:"The Numa Group",category:"other",domains:["*.hittail.com"]},{name:"The Publisher Desk",category:"ad",domains:["*.206ads.com","*.publisherdesk.com"]},{name:"The Sydney Morning Herald",company:"Fairfax Media",category:"content",domains:["*.smh.com.au"]},{name:"The Wall Street Jounal",category:"content",domains:["*.wsj.net"]},{name:"The Wall Street Journal",category:"content",domains:["*.marketwatch.com"]},{name:"TheFind",category:"content",domains:["*.thefind.com"]},{name:"Thinglink",category:"utility",domains:["*.thinglink.com"]},{name:"Thirdpresence",category:"ad",domains:["*.thirdpresence.com"]},{name:"ThreatMetrix",category:"utility",domains:["*.online-metrix.net"]},{name:"Throtle",homepage:"https://throtle.io/",category:"analytics",domains:["*.thrtle.com","*.v12group.com"]},{name:"TicketMaster",category:"content",domains:["*.t-x.io","*.tmcs.net"]},{name:"TikTok",company:"ByteDance Ltd",homepage:"https://www.tiktok.com/en/",category:"social",domains:["*.tiktok.com","*.ipstatp.com"]},{name:"Tidio Live Chat",company:"Tidio",homepage:"https://www.tidiochat.com/en/",category:"customer-success",domains:["*.tidiochat.com"]},{name:"Tiledesk Live Chat",company:"Tiledesk SRL",homepage:"https://www.tiledesk.com/",category:"customer-success",domains:["*.tiledesk.com"]},{name:"Time",category:"content",domains:["*.timeinc.net"]},{name:"Time2Perf",category:"ad",domains:["*.time2perf.com"]},{name:"TinyURL",category:"utility",domains:["*.tinyurl.com"]},{name:"Tivo",category:"analytics",domains:["*.rovicorp.com"]},{name:"Tom&Co",category:"hosting",domains:["*.tomandco.uk"]},{name:"Toms Native Ads",company:"Purch",category:"ad",domains:["*.natoms.com"]},{name:"ToneMedia",category:"ad",domains:["*.clickfuse.com"]},{name:"Tonic",company:"Team Internet",category:"ad",domains:["*.dntx.com"]},{name:"Touch Commerce",category:"customer-success",domains:["*.inq.com","*.touchcommerce.com"]},{name:"ToutApp",category:"ad",domains:["*.toutapp.com"]},{name:"TraceView",company:"Solarwinds",category:"analytics",domains:["*.tracelytics.com","d2gfdmu30u15x7.cloudfront.net"]},{name:"TrackJS",category:"analytics",domains:["*.trackjs.com","d2zah9y47r7bi2.cloudfront.net"]},{name:"Tradedoubler",category:"ad",domains:["*.pvnsolutions.com","*.tradedoubler.com"]},{name:"Tradelab",category:"ad",domains:["*.tradelab.fr"]},{name:"TrafficFactory",category:"ad",domains:["*.trafficfactory.biz"]},{name:"TrafficHunt",category:"ad",domains:["*.traffichunt.com"]},{name:"TrafficStars",category:"ad",domains:["*.trafficstars.com","*.tsyndicate.com"]},{name:"Transifex",category:"utility",domains:["*.transifex.com"]},{name:"Travelex",category:"utility",domains:["*.travelex.net","*.travelex.co.uk"]},{name:"Travelocity Canada",company:"Travelocity",category:"content",domains:["*.travelocity.ca"]},{name:"Travelocity USA",company:"Travelocity",category:"content",domains:["*.travelocity.com"]},{name:"Travelzoo",category:"content",domains:["*.travelzoo.com"]},{name:"Treasure Data",category:"analytics",domains:["*.treasuredata.com"]},{name:"Tremor Video",category:"ad",domains:["*.tremorhub.com","*.videohub.tv"]},{name:"Trialfire",category:"analytics",domains:["*.trialfire.com"]},{name:"Tribal Fusion",company:"Exponential Interactive",category:"ad",domains:["*.tribalfusion.com"]},{name:"Triblio",category:"marketing",domains:["*.tribl.io"]},{name:"Triggered Messaging",company:"Fresh Relevance",category:"ad",domains:["*.triggeredmessaging.com"]},{name:"Trinity Mirror",category:"content",domains:["*.mirror.co.uk"]},{name:"Trinity Mirror Digital Media",category:"social",domains:["*.tm-aws.com","*.icnetwork.co.uk"]},{name:"TripAdvisor",category:"content",domains:["*.jscache.com","*.tacdn.com","*.tamgrt.com","*.tripadvisor.com","*.viator.com","*.tripadvisor.co.uk"]},{name:"TripleLift",category:"ad",domains:["*.3lift.com"]},{name:"Tru Optik",category:"ad",domains:["*.truoptik.com"]},{name:"TruConversion",category:"analytics",domains:["*.truconversion.com"]},{name:"Trueffect",category:"marketing",domains:["*.adlegend.com"]},{name:"Truefit",category:"analytics",domains:["*.truefitcorp.com"]},{name:"Trust Guard",category:"utility",domains:["*.trust-guard.com"]},{name:"Trust Pilot",category:"analytics",domains:["*.trustpilot.com"]},{name:"Amazon Trust Services",company:"Amazon",category:"utility",domains:["*.amazontrust.com","o.ss2.us"]},{name:"Google Trust Services",company:"Google",category:"utility",domains:["*.pki.goog"]},{name:"Let's Encrypt",homepage:"https://letsencrypt.org/",category:"utility",domains:["*.letsencrypt.org"]},{name:"TrustX",category:"ad",domains:["*.trustx.org"]},{name:"Trusted Shops",category:"utility",domains:["*.trustedshops.com"]},{name:"Trustev",company:"TransUnion",category:"utility",domains:["*.trustev.com"]},{name:"Trustwave",category:"utility",domains:["*.trustwave.com"]},{name:"Tryzens TradeState",company:"Tryzens",category:"analytics",domains:["*.tryzens-analytics.com"]},{name:"TubeMogul",category:"ad",domains:["*.tubemogul.com"]},{name:"Turn",category:"ad",domains:["*.turn.com"]},{name:"Tutorialize",category:"customer-success",domains:["*.tutorialize.me"]},{name:"Twenga",category:"content",domains:["*.twenga.fr","*.c4tw.net","*.twenga.co.uk"]},{name:"Twitframe",company:"Superblock",category:"utility",domains:["*.twitframe.com"]},{name:"Twitter Online Conversion Tracking",company:"Twitter",category:"ad",domains:["*.ads-twitter.com","analytics.twitter.com"]},{name:"Twitter Short URL",company:"Twitter",category:"social",domains:["*.t.co"]},{name:"Twyn Group",category:"ad",domains:["*.twyn.com"]},{name:"Tynt",company:"33 Across",category:"ad",domains:["*.tynt.com"]},{name:"Typepad",category:"hosting",domains:["*.typepad.com"]},{name:"TyrbooBytes",category:"utility",domains:["*.turbobytes.net"]},{name:"UPS i-parcel",company:"UPS",category:"other",domains:["*.i-parcel.com"]},{name:"US Media Consulting",category:"ad",domains:["*.mediade.sk"]},{name:"Ubertags",category:"tag-manager",domains:["*.ubertags.com"]},{name:"Umbel",category:"analytics",domains:["*.umbel.com"]},{name:"Unanimis",company:"Switch",category:"ad",domains:["*.unanimis.co.uk"]},{name:"Unbounce",category:"ad",domains:["*.ubembed.com","*.unbounce.com","d2xxq4ijfwetlm.cloudfront.net","d9hhrg4mnvzow.cloudfront.net"]},{name:"Underdog Media",category:"ad",domains:["*.underdog.media","*.udmserve.net"]},{name:"Understand Digital",category:"ad",domains:["*.redirecting2.net"]},{name:"Undertone",company:"Perion",category:"ad",domains:["*.legolas-media.com"]},{name:"Unidays",category:"ad",domains:["*.myunidays.com","*.unidays.world"]},{name:"Uniqodo",category:"ad",domains:["*.uniqodo.com"]},{name:"Unite",category:"ad",domains:["*.uadx.com"]},{name:"United Card Services",category:"utility",domains:["*.ucs.su"]},{name:"United Internet",category:"hosting",domains:["*.uicdn.com"]},{name:"United Internet Media",category:"ad",domains:["*.ui-portal.de"]},{name:"United Internet Media AG",category:"hosting",domains:["*.tifbs.net","*.uicdn.net","*.uimserv.net"]},{name:"Unknown",category:"other",domains:[]},{name:"Unruly Media",category:"ad",domains:["*.unrulymedia.com"]},{name:"UpBuild",category:"ad",domains:["*.upbuild.io"]},{name:"UpSellit",category:"analytics",domains:["*.upsellit.com"]},{name:"Upland Software",category:"hosting",domains:["*.clickability.com"]},{name:"Airship",category:"marketing",domains:["*.urbanairship.com","*.aswpsdkus.com"]},{name:"UsabilityTools",category:"analytics",domains:["*.usabilitytools.com"]},{name:"Usablenet.net",category:"utility",domains:["*.usablenet.net"]},{name:"Use It Better",category:"analytics",domains:["*.useitbetter.com"]},{name:"User Replay",category:"analytics",domains:["*.userreplay.net"]},{name:"UserReport",category:"analytics",domains:["*.userreport.com"]},{name:"Userneeds",category:"analytics",domains:["*.userneeds.dk"]},{name:"Userzoom",category:"analytics",domains:["*.userzoom.com"]},{name:"V12 Retail Finance",category:"utility",domains:["*.v12finance.com"]},{name:"Vacaciones eDreams",category:"content",domains:["*.odistatic.net"]},{name:"Varick Media Management",category:"ad",domains:["*.vmmpxl.com"]},{name:"Vdopia Chocolate",company:"Vdopia",category:"ad",domains:["*.vdopia.com"]},{name:"Ve",company:"Ve",homepage:"https://www.ve.com/",category:"marketing",domains:["*.veinteractive.com","*.ve.com"]},{name:"Ve Interactive",company:"Ve",category:"ad",domains:["*.vepxl1.net","*.adgenie.co.uk"]},{name:"Vee24",category:"customer-success",domains:["*.vee24.com"]},{name:"Veeseo",category:"content",domains:["*.veeseo.com"]},{name:"Venatus Media",category:"marketing",domains:["*.alcvid.com","*.venatusmedia.com"]},{name:"Veoxa",category:"ad",domains:["*.veoxa.com"]},{name:"Vergic AB",category:"customer-success",domains:["*.psplugin.com"]},{name:"Vergic Engage Platform",company:"Vergic",category:"customer-success",domains:["*.vergic.com"]},{name:"Verisign (Symantec)",category:"utility",domains:["*.verisign.com"]},{name:"Verizon",category:"utility",domains:["*.public-trust.com"]},{name:"Verizon Digital Media CDN",homepage:"https://www.verizondigitalmedia.com/",category:"cdn",domains:["*.edgecastcdn.net","*.edgecastdns.net"]},{name:"Verizon Uplynk",company:"Verizon",category:"content",domains:["*.uplynk.com"]},{name:"Vero",company:"Semblance",category:"ad",domains:["*.getvero.com","d3qxef4rp70elm.cloudfront.net"]},{name:"VertaMedia",category:"ad",domains:["*.vertamedia.com"]},{name:"Vertical Mass",category:"ad",domains:["*.vmweb.net"]},{name:"Vestorly",category:"ad",domains:["*.oodalab.com"]},{name:"Vextras",category:"other",domains:["*.vextras.com"]},{name:"Viacom",category:"content",domains:["*.mtvnservices.com"]},{name:"Vibrant Media",category:"ad",domains:["*.intellitxt.com","*.picadmedia.com"]},{name:"VidPulse",category:"analytics",domains:["*.vidpulse.com"]},{name:"Video Media Groep",category:"ad",domains:["*.vmg.host","*.inpagevideo.nl"]},{name:"VideoHub",company:"Tremor Video",category:"ad",domains:["*.scanscout.com"]},{name:"Videology",category:"ad",domains:["*.tidaltv.com"]},{name:"Vidible",category:"ad",domains:["*.vidible.tv"]},{name:"VigLink",category:"ad",domains:["*.viglink.com"]},{name:"Vindico",company:"Viant",category:"ad",domains:["*.vindicosuite.com"]},{name:"Viocorp International",category:"content",domains:["*.vioapi.com"]},{name:"ViralNinjas",category:"ad",domains:["*.viralninjas.com"]},{name:"Virool",category:"ad",domains:["*.virool.com"]},{name:"Virtual Earth",company:"Microsoft",category:"utility",domains:["*.virtualearth.net"]},{name:"Visely",company:"Visely",category:"other",homepage:"https://visely.io/",domains:["*.visely.io"]},{name:"VisScore",category:"analytics",domains:["*.visscore.com","d2hkbi3gan6yg6.cloudfront.net"]},{name:"Visible Measures",category:"ad",domains:["*.visiblemeasures.com"]},{name:"Visual Studio",company:"Microsoft",category:"utility",domains:["*.visualstudio.com"]},{name:"VisualDNA",category:"ad",domains:["*.visualdna.com"]},{name:"VisualVisitor",category:"ad",domains:["*.id-visitors.com"]},{name:"Vivocha S.p.A",category:"customer-success",domains:["*.vivocha.com"]},{name:"Vizu (Nielsen)",category:"analytics",domains:["*.vizu.com"]},{name:"Vizury",category:"ad",domains:["*.vizury.com"]},{name:"VoiceFive",category:"analytics",domains:["*.voicefive.com"]},{name:"Volvelle",company:"Optomaton",category:"ad",domains:["*.volvelle.tech"]},{name:"VouchedFor",category:"analytics",domains:["*.vouchedfor.co.uk"]},{name:"WARPCACHE",category:"utility",domains:["*.warpcache.net"]},{name:"WISHLIST",company:"Shopapps",category:"social",domains:["*.shopapps.in"]},{name:"WP Engine",category:"hosting",domains:["*.wpengine.com"]},{name:"WalkMe",category:"customer-success",domains:["*.walkme.com"]},{name:"Watching That",category:"other",domains:["*.watchingthat.com"]},{name:"Wayfair",category:"analytics",domains:["*.wayfair.com"]},{name:"Web CEO",category:"other",domains:["*.websiteceo.com"]},{name:"Web Dissector",company:"Beijing Gridsum Technologies",category:"analytics",domains:["*.gridsumdissector.com","*.webdissector.com"]},{name:"Web Forensics",category:"analytics",domains:["*.webforensics.co.uk"]},{name:"Web Security and Performance",company:"NCC Group",category:"utility",domains:["*.nccgroup.trust"]},{name:"WebEngage",category:"customer-success",domains:["*.webengage.co","*.webengage.com","d23nd6ymopvz52.cloudfront.net","d3701cc9l7v9a6.cloudfront.net"]},{name:"WebInsight",company:"dotMailer",category:"analytics",domains:["*.trackedlink.net","*.trackedweb.net"]},{name:"WebPageOne Solutions",category:"other",domains:["*.webpageone.com"]},{name:"WebSpectator",category:"ad",domains:["*.webspectator.com"]},{name:"WebTuna",company:"Application Performance",category:"analytics",domains:["*.webtuna.com"]},{name:"WebVideoCore",company:"StreamingVideoProvider",category:"content",domains:["*.webvideocore.net"]},{name:"WebWombat",category:"utility",domains:["*.ic.com.au"]},{name:"Webcollage",category:"customer-success",domains:["*.webcollage.net"]},{name:"Webcore",category:"ad",domains:["*.onefeed.co.uk"]},{name:"Webkul",company:"Webkul Software",category:"utility",domains:["*.webkul.com"]},{name:"Webmarked",category:"utility",domains:["*.webmarked.net"]},{name:"Weborama",category:"ad",domains:["*.weborama.com","*.weborama.fr"]},{name:"WebpageFX",category:"ad",domains:["*.leadmanagerfx.com"]},{name:"Webphone",company:"IP WEB SERVICES",category:"customer-success",domains:["*.webphone.net"]},{name:"Webselect selectcommerce",company:"Webselect Internet",category:"hosting",domains:["*.webselect.net"]},{name:"Webthinking",category:"hosting",domains:["*.webthinking.co.uk"]},{name:"Webtrekk",category:"analytics",domains:["*.wbtrk.net","*.webtrekk-asia.net","*.webtrekk.net","*.wt-eu02.net","*.wt-safetag.com"]},{name:"Webtrends",category:"analytics",domains:["*.webtrends.com","*.webtrendslive.com","d1q62gfb8siqnm.cloudfront.net"]},{name:"Webtype",category:"cdn",domains:["*.webtype.com"]},{name:"White Ops",category:"utility",domains:["*.acexedge.com","*.tagsrvcs.com"]},{name:"Whitespace",category:"ad",domains:["*.whitespacers.com"]},{name:"WhosOn Live Chat Software",category:"customer-success",domains:["*.whoson.com"]},{name:"Wibbitz",category:"other",domains:["*.wibbitz.com"]},{name:"Wide Area Communications",category:"hosting",domains:["*.widearea.co.uk"]},{name:"WideOrbit",category:"marketing",domains:["*.admaym.com"]},{name:"William Reed",category:"content",domains:["*.wrbm.com"]},{name:"WillyFogg.com",category:"content",domains:["*.willyfogg.com"]},{name:"Windows",company:"Microsoft",category:"utility",domains:["*.windowsupdate.com"]},{name:"WisePops",category:"utility",domains:["*.wisepops.com"]},{name:"Wishlist King",company:"Appmate",category:"other",homepage:"https://appmate.io/",domains:["*.appmate.io"]},{name:"Wishpond Technologies",category:"marketing",domains:["*.wishpond.com","*.wishpond.net"]},{name:"WizRocket Technologies",category:"analytics",domains:["*.wzrkt.com"]},{name:"Woopra",category:"analytics",domains:["*.woopra.com"]},{name:"Woosmap",category:"utility",domains:["*.woosmap.com"]},{name:"WorkCast",category:"hosting",domains:["*.workcast.net"]},{name:"World News Media",category:"content",domains:["*.wnmedia.co.uk"]},{name:"Worldpay",category:"utility",domains:["*.worldpay.com"]},{name:"Wow Analytics",category:"analytics",domains:["*.wowanalytics.co.uk"]},{name:"Wowcher",category:"ad",domains:["*.wowcher.co.uk"]},{name:"Wufoo",category:"utility",domains:["*.wufoo.com"]},{name:"Wunderkind",category:"marketing",homepage:"https://www.wunderkind.co/",domains:["*.bounceexchange.com","*.bouncex.net","*.wknd.ai","*.cdnbasket.net","*.cdnwidget.com"]},{name:"Wyng",category:"ad",domains:["*.offerpop.com"]},{name:"XMLSHOP",category:"hosting",domains:["*.xmlshop.biz"]},{name:"XiTi",company:"AT Internet",category:"analytics",domains:["*.xiti.com","*.aticdn.net"],homepage:"https://www.atinternet.com/en/"},{name:"YUDU",category:"content",domains:["*.yudu.com"]},{name:"Yahoo! Ad Exchange",company:"Yahoo!",category:"ad",domains:["*.yieldmanager.com","*.browsiprod.com"]},{name:"Yahoo! JAPAN Ads",company:"Yahoo! JAPAN",category:"ad",homepage:"https://marketing.yahoo.co.jp/service/yahooads/",domains:["yads.c.yimg.jp","s.yimg.jp","b92.yahoo.co.jp"]},{name:"Yahoo! Tag Manager",company:"Yahoo! JAPAN",category:"tag-manager",homepage:"https://marketing.yahoo.co.jp/service/tagmanager/",domains:["*.yjtag.jp"]},{name:"Yahoo! Small Business",company:"Yahoo!",category:"hosting",domains:["*.aabacosmallbusiness.com"]},{name:"Yellow Robot",category:"ad",domains:["*.backinstock.org"]},{name:"YieldPartners",category:"ad",domains:["*.yieldpartners.com"]},{name:"Yieldbot",category:"ad",domains:["*.yldbt.com"]},{name:"Yieldify",category:"ad",domains:["*.yieldify.com","*.yieldifylabs.com","d33wq5gej88ld6.cloudfront.net","dwmvwp56lzq5t.cloudfront.net"]},{name:"Yieldlab",category:"ad",domains:["*.yieldlab.net"]},{name:"Yieldmo",category:"ad",domains:["*.yieldmo.com"]},{name:"Yieldr",category:"ad",domains:["*.254a.com"]},{name:"Yo",category:"utility",domains:["*.yopify.com"]},{name:"YoYo",category:"utility",domains:["*.goadservices.com"]},{name:"Yotpo",homepage:"https://www.yotpo.com/",category:"marketing",domains:["*.yotpo.com","*.swellrewards.com"]},{name:"Yottaa",category:"hosting",domains:["*.yottaa.com","*.yottaa.net"]},{name:"YourAmigo",category:"utility",domains:["*.youramigo.com"]},{name:"YuMe",category:"ad",domains:["*.yume.com","*.yumenetworks.com"]},{name:"Yummley",category:"other",domains:["*.yummly.com"]},{name:"ZEDO",category:"ad",domains:["*.zedo.com"]},{name:"Zafu",category:"analytics",domains:["*.zafu.com"]},{name:"Zaius",category:"ad",domains:["*.zaius.com"]},{name:"Zamplus ad",category:"ad",domains:["*.zampda.net"]},{name:"Zanox",category:"ad",domains:["*.zanox.com","*.zanox.ws"]},{name:"Zapper",category:"utility",domains:["*.zapper.com"]},{name:"Zarget",category:"analytics",domains:["*.zarget.com"]},{name:"Zemanta",category:"ad",domains:["*.zemanta.com"]},{name:"Zen Internet",category:"other",domains:["*.zyen.com"]},{name:"Zenovia Digital Exchange",category:"ad",domains:["*.rhythmxchange.com","*.zenoviaexchange.com"]},{name:"ZergNet",category:"content",domains:["*.zergnet.com"]},{name:"Zerogrey",category:"hosting",domains:["*.zerogrey.com"]},{name:"Ziff Davis Tech",category:"ad",domains:["*.adziff.com","*.zdbb.net"]},{name:"Zmags",category:"marketing",domains:["*.zmags.com"]},{name:"Zolando",category:"content",domains:["*.ztat.net"]},{name:"Zoover",category:"analytics",domains:["*.zoover.nl","*.zoover.co.uk"]},{name:"Zopim",category:"customer-success",domains:["*.zopim.io"]},{name:"[24]7",category:"customer-success",domains:["*.247-inc.net","*.247inc.net","d1af033869koo7.cloudfront.net"]},{name:"adKernel",category:"ad",domains:["*.adkernel.com"]},{name:"adMarketplace",company:"AMPexchange",category:"ad",domains:["*.ampxchange.com","*.admarketplace.net"]},{name:"addtocalendar",category:"utility",domains:["*.addtocalendar.com"]},{name:"adnanny",category:"ad",domains:["*.adserver01.de"]},{name:"affilinet",category:"ad",domains:["*.reussissonsensemble.fr","*.successfultogether.co.uk"]},{name:"audioBoom",category:"social",domains:["*.audioboom.com","*.audioboo.fm"]},{name:"bPay by Barclaycard",company:"Barclays Bank",category:"utility",domains:["*.bpay.co.uk"]},{name:"bRealTime",category:"ad",domains:["*.brealtime.com"]},{name:"bd4travel",category:"analytics",domains:["*.bd4travel.com"]},{name:"bizinformation-VOID",company:"bizinformation",category:"analytics",domains:["*.bizinformation.org"]},{name:"carrot",category:"social",domains:["*.sharebutton.co"]},{name:"cloudIQ",category:"analytics",domains:["*.cloud-iq.com"]},{name:"comScore",category:"analytics",domains:["*.adxpose.com","*.comscore.com","*.sitestat.com","*.zqtk.net"]},{name:"content.ad",category:"ad",domains:["*.content.ad"]},{name:"d3 Media",company:"d3 Technologies",category:"other",domains:["*.d3sv.net"]},{name:"dexiMEDIA",category:"ad",domains:["*.deximedia.com"]},{name:"dianomi",category:"ad",domains:["*.dianomi.com","*.dianomioffers.co.uk"]},{name:"donReach",category:"social",domains:["*.donreach.com"]},{name:"dotMailer",category:"ad",domains:["*.dmtrk.com","*.dotmailer.com","*.emlfiles.com"]},{name:"dotMailer Surveys",company:"dotMailer",category:"analytics",domains:["*.dotmailer-surveys.com"]},{name:"dstillery",category:"ad",domains:["*.dstillery.com","*.media6degrees.com"]},{name:"eBay",category:"ad",domains:["*.ebay.com","*.ebayimg.com","*.fetchback.com"]},{name:"eBay Enterprise",category:"hosting",domains:["*.csdata1.com","*.gsipartners.com"]},{name:"eBuzzing",company:"Teads Managed Services",category:"ad",domains:["*.ebz.io"]},{name:"eDigital Research",category:"customer-success",domains:["*.edigitalresearch.com","*.edigitalsurvey.com","*.edrcdn.com","*.ecustomeropinions.com"]},{name:"eGain",category:"analytics",domains:["*.analytics-egain.com","*.egain.com"]},{name:"eHost",category:"hosting",domains:["*.ehosts.net"]},{name:"eKomi",category:"analytics",domains:["*.ekomi.com","*.ekomi.de"]},{name:"eWAY",company:"Web Active Pty",category:"utility",domains:["*.eway.com.au"]},{name:"eXTReMe digital",category:"analytics",domains:["*.extreme-dm.com"]},{name:"eXelate",category:"ad",domains:["*.exelator.com"]},{name:"ecommercefeed.net",category:"marketing",domains:["*.ecommercefeed.net"]},{name:"engage:BDR",category:"ad",domains:["*.bnmla.com","*.ebdr3.com"]},{name:"epago",category:"ad",domains:["*.adaos-ads.net"]},{name:"epoq internet services",category:"analytics",domains:["*.epoq.de"]},{name:"etouches",category:"hosting",domains:["*.etouches.com"]},{name:"etracker",category:"analytics",domains:["*.etracker.com","*.etracker.de"]},{name:"everestads.com",category:"content",domains:["*.verestads.net"]},{name:"exebid.DCA",company:"Data-Centric Alliance",category:"ad",domains:["*.exe.bid"]},{name:"eyeReturn Marketing",category:"marketing",domains:["*.eyereturn.com"]},{name:"feedoptimise",category:"hosting",domains:["*.feedoptimise.com","d1w78njrm56n7g.cloudfront.net"]},{name:"fifty-five",category:"ad",domains:["*.55labs.com"]},{name:"fluct",category:"ad",domains:["*.adingo.jp"]},{name:"freegeoip.net",company:"(community-funded)",category:"utility",domains:["*.freegeoip.net"]},{name:"freewheel.tv",category:"content",domains:["*.fwmrm.net"]},{name:"gnatta",category:"customer-success",domains:["*.gnatta.com"]},{name:"home.pl",category:"hosting",domains:["*.nscontext.eu"]},{name:"hyfn",category:"ad",domains:["*.hyfn.com"]},{name:"iAdvize SAS",category:"customer-success",domains:["*.iadvize.com"]},{name:"iBillboard",category:"ad",domains:["*.ibillboard.com"]},{name:"iCrossing",category:"ad",domains:["*.ic-live.com"]},{name:"iFactory",company:"RDW Group",category:"hosting",domains:["*.ifactory.com"]},{name:"iGoDigital",category:"analytics",domains:["*.igodigital.com"]},{name:"iJento",company:"Fopsha",category:"ad",domains:["*.ijento.com"]},{name:"iPage",category:"hosting",domains:["*.ipage.com"]},{name:"iPerceptions",category:"customer-success",domains:["*.iperceptions.com"]},{name:"iTunes",company:"Apple",category:"content",domains:["*.mzstatic.com"]},{name:"imgix",company:"Zebrafish Labs",category:"utility",domains:["*.imgix.net"]},{name:"infogr.am",category:"utility",domains:["*.infogr.am","*.jifo.co"]},{name:"iotec",category:"analytics",domains:["*.dsp.io"]},{name:"iovation",category:"utility",domains:["*.iesnare.com"]},{name:"ipinfo.io",category:"utility",domains:["*.ipinfo.io"]},{name:"issuu",category:"content",domains:["*.issuu.com","*.isu.pub"]},{name:"iubenda",category:"utility",domains:["*.iubenda.com"]},{name:"j2 Cloud Services",category:"ad",domains:["*.campaigner.com"]},{name:"jsonip.com",category:"analytics",domains:["*.jsonip.com"]},{name:"linkpulse",category:"analytics",domains:["*.lp4.io"]},{name:"loGo_net",category:"analytics",domains:["*.logo-net.co.uk"]},{name:"mainADV",category:"ad",domains:["*.httptrack.com","*.solocpm.com"]},{name:"mbr targeting",category:"ad",domains:["*.m6r.eu"]},{name:"media.ventive",category:"ad",domains:["*.contentspread.net"]},{name:"metrigo",category:"ad",domains:["*.metrigo.com"]},{name:"minicabit.com",category:"content",domains:["*.minicabit.com"]},{name:"mobiManage",category:"hosting",domains:["*.mobimanage.com"]},{name:"moving-pictures",category:"other",domains:["*.moving-pictures.biz","*.v6-moving-pictures.com","*.vtstat.com","*.moving-pictures.de"]},{name:"my6sense",category:"ad",domains:["*.mynativeplatform.com"]},{name:"myThings",category:"ad",domains:["*.mythings.com","*.mythingsmedia.net"]},{name:"mymovies",category:"content",domains:["*.mymovies.net"]},{name:"nRelate-VOID",company:"nRelate",category:"content",domains:["*.nrelate.com"]},{name:"nToklo",category:"analytics",domains:["*.ntoklo.com"]},{name:"neXeps",category:"ad",domains:["*.nexeps.com"]},{name:"ninemsn Pty.",category:"utility",domains:["*.ninemsn.com.au"]},{name:"nugg.ad",category:"ad",domains:["*.nuggad.net"]},{name:"numero interactive",company:"numero",category:"ad",domains:["*.numerointeractive.com"]},{name:"optMD",company:"Optimax Media Delivery",category:"ad",domains:["*.optmd.com"]},{name:"otracking.com",category:"analytics",domains:["*.otracking.com"]},{name:"paysafecard",company:"Paysafe Group",category:"utility",domains:["*.paysafecard.com"]},{name:"piano",category:"ad",domains:["*.npttech.com","*.tinypass.com"]},{name:"piclike",category:"ad",domains:["*.piclike.us"]},{name:"placehold.it",category:"utility",domains:["*.placehold.it"]},{name:"plista",category:"ad",domains:["*.plista.com"]},{name:"prebid.org",category:"utility",domains:["*.prebid.org"]},{name:"reEmbed",category:"other",domains:["*.reembed.com"]},{name:"reddit",category:"social",domains:["*.reddit.com","*.redditstatic.com"]},{name:"rewardStyle.com",category:"ad",domains:["*.rewardstyle.com"]},{name:"rss2json",category:"utility",domains:["*.rss2json.com"]},{name:"sage Pay",company:"Sage Pay Europe",category:"utility",domains:["*.sagepay.com"]},{name:"section.io",category:"utility",domains:["*.squixa.net"]},{name:"smartclip",category:"ad",domains:["*.smartclip.net"]},{name:"sovrn",category:"ad",domains:["*.lijit.com"]},{name:"stackpile.io",company:"StackPile",category:"tag-manager",domains:["*.stackpile.io"]},{name:"template-help.com",category:"hosting",domains:["*.template-help.com"]},{name:"test",company:"test only",category:"other",domains:["*.testtesttest.com"]},{name:"trueAnthem",category:"social",domains:["*.tru.am"]},{name:"tweetmeme-VOID",company:"tweetmeme",category:"analytics",domains:["*.tweetmeme.com"]},{name:"uLogin",category:"other",domains:["*.ulogin.ru"]},{name:"uLogix",category:"ad",domains:["*.ulogix.ru"]},{name:"ucfunnel ucX",company:"ucfunnel",category:"ad",domains:["*.aralego.com"]},{name:"up-value",category:"ad",domains:["*.up-value.de"]},{name:"wywy",category:"ad",domains:["*.wywy.com","*.wywyuserservice.com"]},{name:"CDK Dealer Management",company:"CDK Global",homepage:"https://www.cdkglobal.com/us",category:"hosting",domains:["*.assets-cdk.com"]},{name:"fam",company:"Fing Co Ltd.",homepage:"http://admin.fam-ad.com/report/",category:"ad",domains:["*.fam-ad.com"]},{name:"zypmedia",category:"ad",domains:["*.extend.tv"]},{name:"codigo",homepage:"https://www.codigo.se",category:"analytics",domains:["*.codigo.se"]},{name:"Playground",homepage:"https://playground.xyz",category:"ad",domains:["*.playground.xyz"]},{name:"RAM",homepage:"https://www2.rampanel.com/",category:"analytics",domains:["*.rampanel.com"]},{name:"Adition",homepage:"https://www.adition.com",category:"ad",domains:["*.adition.com"]},{name:"Widespace",homepage:"https://www.widespace.com",category:"ad",domains:["*.widespace.com"]},{name:"Colpirio",homepage:"https://www.widespace.com",category:"analytics",domains:["*.colpirio.com"]},{name:"Brandmetrics",homepage:"https://www.brandmetrics.com",category:"analytics",domains:["*.brandmetrics.com"]},{name:"EasyAd",homepage:"https://web.easy-ads.com/",category:"ad",domains:["*.easy-ads.com"]},{name:"Glimr",homepage:"https://glimr.io/",category:"analytics",domains:["*.glimr.io"]},{name:"Webtreck",homepage:"https://www.webtrekk.com/en/home/",category:"analytics",domains:["*.wcfbc.net"]},{name:"DigiTrust",homepage:"http://www.digitru.st/",category:"analytics",domains:["*.digitru.st"]},{name:"Kantar Sifo",homepage:"https://www.kantarsifo.se",category:"analytics",domains:["*.research-int.se"]},{name:"Concert",homepage:"https://concert.io/",category:"ad",domains:["*.concert.io"]},{name:"Emerse",homepage:"https://www.emerse.com/",category:"ad",domains:["*.emerse.com"]},{name:"Iterate",homepage:"https://iteratehq.com/",category:"analytics",domains:["*.iteratehq.com"]},{name:"Cookiebot",homepage:"https://www.cookiebot.com/",category:"utility",domains:["*.cookiebot.com"]},{name:"Netlify",homepage:"https://www.netlify.com/",category:"utility",domains:["*.netlify.com","*.netlifyusercontent.com"]},{name:"Scroll",homepage:"https://scroll.com/",category:"utility",domains:["*.scroll.com"]},{name:"Consumable",homepage:"https://consumable.com/",category:"ad",domains:["*.serverbid.com"]},{name:"DMD Marketing",homepage:"https://www.dmdconnects.com/",category:"ad",domains:["*.medtargetsystem.com"]},{name:"Catchpoint",homepage:"https://www.catchpoint.com/",category:"analytics",domains:["*.3gl.net","*.3genlabs.net"]},{name:"Terminus",homepage:"https://terminus.com/",category:"ad",domains:["*.terminus.services"]},{name:"Acceptable Ads",homepage:"https://acceptableads.com/",category:"ad",domains:["*.aaxads.com","*.aaxdetect.com"]},{name:"ClearBrain",homepage:"https://www.clearbrain.com/",category:"analytics",domains:["*.clearbrain.com"]},{name:"Optanon",homepage:"https://www.cookielaw.org/",category:"consent-provider",domains:["*.onetrust.com","*.cookielaw.org"]},{name:"TrustArc",homepage:"https://www.trustarc.com/",category:"utility",domains:["*.trustarc.com"]},{name:"iSpot.tv",homepage:"https://www.ispot.tv/",category:"ad",domains:["*.ispot.tv"]},{name:"RevJet",homepage:"https://www.revjet.com/",category:"ad",domains:["*.revjet.com"]},{name:"atlasRTX",homepage:"https://www.atlasrtx.com/",category:"customer-success",domains:["*.atlasrtx.com"]},{name:"ContactAtOnce",homepage:"https://www.contactatonce.com/",category:"customer-success",domains:["*.contactatonce.com"]},{name:"Algolia",homepage:"https://www.algolia.com/",category:"utility",domains:["*.algolianet.com","*.algolia.net","*.algolia.io"]},{name:"EMX Digital",homepage:"https://emxdigital.com",category:"ad",domains:["*.emxdgt.com"]},{name:"Moxie",homepage:"https://www.gomoxie.com/",category:"utility",domains:["*.gomoxie.solutions"]},{name:"Scripps Network Digital",homepage:"https://www.scrippsnetworksdigital.com/",category:"ad",domains:["*.snidigital.com"]},{name:"TurnTo",homepage:"https://www.turntonetworks.com/",category:"utility",domains:["*.turnto.com"]},{name:"Quantum Metric",homepage:"https://www.quantummetric.com/",category:"analytics",domains:["*.quantummetric.com"]},{name:"Carbon Ads",homepage:"https://www.carbonads.net/",category:"ad",domains:["*.carbonads.net","*.carbonads.com"]},{name:"Ably",homepage:"https://www.ably.io/",category:"utility",domains:["*.ably.io"]},{name:"Sectigo",homepage:"https://sectigo.com/",category:"utility",domains:["*.sectigo.com"]},{name:"Specless",homepage:"https://gospecless.com/",category:"ad",domains:["*.specless.tech"]},{name:"Loggly",homepage:"https://www.loggly.com/",category:"analytics",domains:["*.loggly.com","d9jmv9u00p0mv.cloudfront.net"]},{name:"Intent Media",homepage:"https://intent.com/",category:"ad",domains:["*.intentmedia.net"]},{name:"Supership",homepage:"https://supership.jp/",category:"ad",domains:["*.socdm.com"]},{name:"F@N Communications",homepage:"https://www.fancs.com/",category:"ad",domains:["*.ladsp.com"]},{name:"Vidyard",homepage:"https://www.vidyard.com/",category:"utility",domains:["*.vidyard.com"]},{name:"RapidSSL",homepage:"https://www.rapidssl.com/",category:"utility",domains:["*.rapidssl.com"]},{name:"Coherent Path",homepage:"https://coherentpath.com/",category:"utility",domains:["*.coherentpath.com"]},{name:"Attentive",homepage:"https://attentivemobile.com/",category:"ad",domains:["*.attn.tv","*.attentivemobile.com"]},{name:"emetriq",homepage:"https://www.emetriq.com/",category:"ad",domains:["*.emetriq.de","*.xplosion.de"]},{name:"Bonzai",homepage:"https://www.bonzai.co/",category:"ad",domains:["*.bonzai.co"]},{name:"Freshchat",homepage:"https://www.freshworks.com/live-chat-software/",category:"customer-success",domains:["*.freshchat.com","*.freshworksapi.com"],products:[{name:"Freshdesk Messaging",urlPatterns:["wchat.freshchat.com"],facades:[{name:"Freshdesk Messaging (formerly Freshchat) Facade",repo:"https://github.com/coliff/freshdesk-messaging-facade/"}]}]},{name:"Contentful",homepage:"https://www.contentful.com/",category:"utility",domains:["*.contentful.com"]},{name:"PureCars",homepage:"https://www.purecars.com/",category:"marketing",domains:["*.purecars.com"]},{name:"Tray Commerce",homepage:"https://www.tray.com.br/",category:"marketing",domains:["*.tcdn.com.br"]},{name:"AdScore",homepage:"https://www.adscore.com/",category:"ad",domains:["*.adsco.re"]},{name:"WebsiteBuilder.com",homepage:"https://www.websitebuilder.com",category:"hosting",domains:["*.mywebsitebuilder.com"]},{name:"mParticle",homepage:"https://www.mparticle.com/",category:"utility",domains:["*.mparticle.com"]},{name:"Ada",homepage:"https://www.ada.support/",category:"customer-success",domains:["*.ada.support"]},{name:"Quora Ads",homepage:"https://www.quora.com/business/",category:"ad",domains:["*.quora.com"]},{name:"Auth0",homepage:"https://auth0.com/",category:"utility",domains:["*.auth0.com"]},{name:"Bridgewell DSP",homepage:"https://www.bridgewell.com/",category:"ad",domains:["*.scupio.com"]},{name:"Wicked Reports",homepage:"https://www.wickedreports.com/",category:"marketing",domains:["*.wickedreports.com"]},{name:"Jaywing",homepage:"https://jaywing.com/",category:"marketing",domains:["*.jaywing.com"]},{name:"Holimetrix",homepage:"https://u360.d-bi.fr/",category:"marketing",domains:["*.d-bi.fr"]},{name:"iZooto",homepage:"https://www.izooto.com",category:"marketing",domains:["*.izooto.com"]},{name:"Ordergroove",homepage:"https://www.ordergroove.com/",category:"marketing",domains:["*.ordergroove.com"]},{name:"PageSense",homepage:"https://www.zoho.com/pagesense/",category:"analytics",domains:["*.pagesense.io"]},{name:"Vizzit",homepage:"https://www.vizzit.se",category:"analytics",domains:["*.vizzit.se"]},{name:"Click Guardian",homepage:"https://www.clickguardian.co.uk/",category:"ad",domains:["*.clickguardian.app","*.clickguardian.co.uk"]},{name:"Smartsupp",company:"Smartsupp.com",homepage:"https://www.smartsupp.com",category:"customer-success",domains:["*.smartsuppchat.com","*.smartsupp.com","smartsupp-widget-161959.c.cdn77.org","*.smartsuppcdn.com"]},{name:"Smartlook",company:"Smartsupp.com",homepage:"https://www.smartlook.com/",category:"analytics",domains:["*.smartlook.com"]},{name:"Luigis Box",company:"Luigis Box",homepage:"https://www.luigisbox.com/",category:"utility",domains:["*.luigisbox.com"]},{name:"Targito",company:"VIVmail.cz",homepage:"https://www.targito.com",category:"marketing",domains:["*.targito.com"]},{name:"Foxentry",company:"AVANTRO",homepage:"https://foxentry.cz/",category:"utility",domains:["*.foxentry.cz"]},{name:"Pendo",homepage:"https://www.pendo.io",category:"analytics",domains:["*.pendo.io"]},{name:"Braze",homepage:"https://www.braze.com",category:"analytics",domains:["*.appboycdn.com"]},{name:"Usersnap",homepage:"https://usersnap.com",category:"customer-success",domains:["*.usersnap.com"]},{name:"Rewardful",homepage:"https://www.getrewardful.com",category:"analytics",domains:["*.wdfl.co"]},{name:"Launch Darkly",homepage:"https://launchdarkly.com",category:"utility",domains:["*.launchdarkly.com"]},{name:"Statuspage",company:"Atlassian",homepage:"https://www.statuspage.io",category:"utility",domains:["*.statuspage.io"]},{name:"HyperInzerce",homepage:"https://hyperinzerce.cz",category:"ad",domains:["*.hyperinzerce.cz"]},{name:"POWr",homepage:"https://www.powr.io",category:"utility",domains:["*.powr.io"]},{name:"Coral",company:"Coral",homepage:"https://coralproject.net",category:"content",domains:["*.coral.coralproject.net"]},{name:"Bolt",homepage:"https://www.bolt.com/",category:"utility",domains:["*.bolt.com"]},{name:"Judge.me",homepage:"https://judge.me/",category:"marketing",domains:["*.judge.me"]},{name:"Tilda",homepage:"https://tilda.cc/",category:"hosting",domains:["*.tildacdn.com"]},{name:"SalesLoft",homepage:"https://salesloft.com/",category:"marketing",domains:["*.salesloft.com"]},{name:"Accessibe Accessibility Overlay",company:"Accessibe",homepage:"https://accessibe.com/",category:"utility",domains:["*.accessibe.com","*.acsbapp.com","*.acsbap.com"]},{name:"Builder",homepage:"https://www.builder.io/",category:"hosting",domains:["*.builder.io"]},{name:"Pepperjam",homepage:"https://www.pepperjam.com/",category:"marketing",domains:["*.pepperjam.com","*.affiliatetechnology.com"]},{name:"Reach",homepage:"https://withreach.com/",category:"utility",domains:["*.gointerpay.net"]},{name:"Chameleon",homepage:"https://www.trychameleon.com/",category:"marketing",domains:["*.trychameleon.com"]},{name:"Matomo",company:"InnoCraft",homepage:"https://matomo.org/",category:"analytics",domains:["*.matomo.cloud"]},{name:"Segmanta",homepage:"https://segmanta.com/",category:"marketing",domains:["*.segmanta.com"]},{name:"Podsights",homepage:"https://podsights.com/",category:"marketing",domains:["*.pdst.fm","us-central1-adaptive-growth.cloudfunctions.net"]},{name:"Chatwoot",homepage:"https://www.chatwoot.com/",category:"customer-success",domains:["*.chatwoot.com"]},{name:"Crisp",homepage:"https://crisp.chat/",category:"customer-success",domains:["*.crisp.chat"]},{name:"Admiral CMP",homepage:"https://www.getadmiral.com",category:"consent-provider",domains:["admiral.mgr.consensu.org","*.admiral.mgr.consensu.org"]},{name:"Adnuntius CMP",homepage:"https://adnuntius.com",category:"consent-provider",domains:["adnuntiusconsent.mgr.consensu.org","*.adnuntiusconsent.mgr.consensu.org"]},{name:"Clickio CMP",homepage:"https://clickio.com",category:"consent-provider",domains:["clickio.mgr.consensu.org","*.clickio.mgr.consensu.org"]},{name:"AppConsent CMP",homepage:"https://appconsent.io/en",category:"consent-provider",domains:["appconsent.mgr.consensu.org","*.appconsent.mgr.consensu.org"]},{name:"DMG Media CMP",homepage:"https://www.dmgmedia.co.uk",category:"consent-provider",domains:["dmgmedia.mgr.consensu.org","*.dmgmedia.mgr.consensu.org"]},{name:"Axel Springer CMP",homepage:"https://www.axelspringer.com",category:"consent-provider",domains:["axelspringer.mgr.consensu.org","*.axelspringer.mgr.consensu.org"]},{name:"Bedrock CMP",homepage:"https://www.bedrockstreaming.com",category:"consent-provider",domains:["bedrock.mgr.consensu.org","*.bedrock.mgr.consensu.org"]},{name:"BMIND CMP",homepage:"https://www.bmind.es",category:"consent-provider",domains:["bmind.mgr.consensu.org","*.bmind.mgr.consensu.org"]},{name:"Borlabs CMP",homepage:"https://borlabs.io",category:"consent-provider",domains:["borlabs.mgr.consensu.org","*.borlabs.mgr.consensu.org"]},{name:"Civic CMP",homepage:"https://www.civicuk.com",category:"consent-provider",domains:["cookiecontrol.mgr.consensu.org","*.cookiecontrol.mgr.consensu.org"]},{name:"Commanders Act CMP",homepage:"https://www.commandersact.com",category:"consent-provider",domains:["commandersact.mgr.consensu.org","*.commandersact.mgr.consensu.org"]},{name:"Complianz CMP",homepage:"https://complianz.io/",category:"consent-provider",domains:["complianz.mgr.consensu.org","*.complianz.mgr.consensu.org"]},{name:"Consent Desk CMP",homepage:"https://www.consentdesk.com/",category:"consent-provider",domains:["consentdesk.mgr.consensu.org","*.consentdesk.mgr.consensu.org"]},{name:"Consent Manager CMP",homepage:"https://consentmanager.net",category:"consent-provider",domains:["consentmanager.mgr.consensu.org","*.consentmanager.mgr.consensu.org"]},{name:"Conversant CMP",homepage:"https://www.conversantmedia.eu/",category:"consent-provider",domains:["conversant.mgr.consensu.org","*.conversant.mgr.consensu.org"]},{name:"Cookie Information CMP",homepage:"https://www.cookieinformation.com/",category:"consent-provider",domains:["cookieinformation.mgr.consensu.org","*.cookieinformation.mgr.consensu.org"]},{name:"Cookiebot CMP",homepage:"https://www.cookiebot.com",category:"consent-provider",domains:["cookiebot.mgr.consensu.org","*.cookiebot.mgr.consensu.org"]},{name:"Truendo CMP",homepage:"https://truendo.com/",category:"consent-provider",domains:["truendo.mgr.consensu.org","*.truendo.mgr.consensu.org"]},{name:"Dentsu CMP",homepage:"https://www.dentsuaegisnetwork.de/",category:"consent-provider",domains:["dan.mgr.consensu.org","*.dan.mgr.consensu.org"]},{name:"Didomi CMP",homepage:"https://www.didomi.io/en/",category:"consent-provider",domains:["didomi.mgr.consensu.org","*.didomi.mgr.consensu.org"]},{name:"Ensighten CMP",homepage:"https://www.ensighten.com/",category:"consent-provider",domains:["ensighten.mgr.consensu.org","*.ensighten.mgr.consensu.org"]},{name:"Evidon CMP",homepage:"https://evidon.com",category:"consent-provider",domains:["evidon.mgr.consensu.org","*.evidon.mgr.consensu.org"]},{name:"Ezoic CMP",homepage:"https://www.ezoic.com/",category:"consent-provider",domains:["ezoic.mgr.consensu.org","*.ezoic.mgr.consensu.org"]},{name:"Gemius CMP",homepage:"https://www.gemius.com",category:"consent-provider",domains:["gemius.mgr.consensu.org","*.gemius.mgr.consensu.org"]},{name:"NitroPay CMP",homepage:"https://nitropay.com/",category:"consent-provider",domains:["nitropay.mgr.consensu.org","*.nitropay.mgr.consensu.org"]},{name:"Google FundingChoices",homepage:"https://fundingchoices.google.com/start/",category:"consent-provider",domains:["fundingchoices.mgr.consensu.org","*.fundingchoices.mgr.consensu.org","fundingchoicesmessages.google.com","*.fundingchoicesmessages.google.com"]},{name:"Gravito CMP",homepage:"https://www.gravito.net/",category:"consent-provider",domains:["gravito.mgr.consensu.org","*.gravito.mgr.consensu.org"]},{name:"ID Ward CMP",homepage:"https://id-ward.com/enterprise",category:"consent-provider",domains:["idward.mgr.consensu.org","*.idward.mgr.consensu.org"]},{name:"iubenda CMP",homepage:"https://www.iubenda.com",category:"consent-provider",domains:["iubenda.mgr.consensu.org","*.iubenda.mgr.consensu.org"]},{name:"Jump CMP",homepage:"https://jumpgroup.it/",category:"consent-provider",domains:["avacy.mgr.consensu.org","*.avacy.mgr.consensu.org"]},{name:"LiveRamp CMP",homepage:"https://liveramp.com/",category:"consent-provider",domains:["faktor.mgr.consensu.org","*.faktor.mgr.consensu.org"]},{name:"Madvertise CMP",homepage:"https://madvertise.com/en/",category:"consent-provider",domains:["madvertise.mgr.consensu.org","*.madvertise.mgr.consensu.org"]},{name:"Mairdumont Netletic CMP",homepage:"https://www.mairdumont-netletix.com/",category:"consent-provider",domains:["mdnxmp.mgr.consensu.org","*.mdnxmp.mgr.consensu.org"]},{name:"Marfeel CMP",homepage:"https://www.marfeel.com/",category:"consent-provider",domains:["marfeel.mgr.consensu.org","*.marfeel.mgr.consensu.org"]},{name:"Mediavine CMP",homepage:"https://www.mediavine.com/",category:"consent-provider",domains:["mediavine.mgr.consensu.org","*.mediavine.mgr.consensu.org"]},{name:"ConsentServe CMP",homepage:"https://www.consentserve.com/",category:"consent-provider",domains:["consentserve.mgr.consensu.org","*.consentserve.mgr.consensu.org"]},{name:"Next14 CMP",homepage:"https://www.next14.com/",category:"consent-provider",domains:["next14.mgr.consensu.org","*.next14.mgr.consensu.org"]},{name:"AdRoll CMP",homepage:"https://www.adroll.com/",category:"consent-provider",domains:["adroll.mgr.consensu.org","*.adroll.mgr.consensu.org"]},{name:"Ogury CMP",homepage:"https://www.ogury.com/",category:"consent-provider",domains:["ogury.mgr.consensu.org","*.ogury.mgr.consensu.org"]},{name:"OneTag CMP",homepage:"https://onetag.net",category:"consent-provider",domains:["onetag.mgr.consensu.org","*.onetag.mgr.consensu.org"]},{name:"OneTrust CMP",homepage:"https://onetrust.com",category:"consent-provider",domains:["onetrust.mgr.consensu.org","*.onetrust.mgr.consensu.org"]},{name:"optAd360 CMP",homepage:"https://www.optad360.com/",category:"consent-provider",domains:["optad360.mgr.consensu.org","*.optad360.mgr.consensu.org"]},{name:"Osano CMP",homepage:"https://www.osano.com",category:"consent-provider",domains:["osano.mgr.consensu.org","*.osano.mgr.consensu.org"]},{name:"Playwire CMP",homepage:"https://www.playwire.com",category:"consent-provider",domains:["playwire.mgr.consensu.org","*.playwire.mgr.consensu.org"]},{name:"Pulselive CMP",homepage:"https://www.pulselive.com",category:"consent-provider",domains:["pulselive.mgr.consensu.org","*.pulselive.mgr.consensu.org"]},{name:"Quantcast Choice",homepage:"https://quantcast.com",category:"consent-provider",domains:["quantcast.mgr.consensu.org","*.quantcast.mgr.consensu.org"]},{name:"RCS Pubblicita CMP",homepage:"http://www.rcspubblicita.it/site/home.html",category:"consent-provider",domains:["rcsmediagroup.mgr.consensu.org","*.rcsmediagroup.mgr.consensu.org"]},{name:"Rich Audience CMP",homepage:"https://richaudience.com",category:"consent-provider",domains:["richaudience.mgr.consensu.org","*.richaudience.mgr.consensu.org"]},{name:"Ringier Axel Springer CMP",homepage:"https://www.ringieraxelspringer.pl/en/home/",category:"consent-provider",domains:["rasp.mgr.consensu.org","*.rasp.mgr.consensu.org"]},{name:"Secure Privacy CMP",homepage:"https://secureprivacy.ai/",category:"consent-provider",domains:["secureprivacy.mgr.consensu.org","*.secureprivacy.mgr.consensu.org"]},{name:"Securiti CMP",homepage:"https://securiti.ai/",category:"consent-provider",domains:["securiti.mgr.consensu.org","*.securiti.mgr.consensu.org"]},{name:"Seznam.cz CMP",homepage:"https://www.seznam.cz/",category:"consent-provider",domains:["seznam.mgr.consensu.org","*.seznam.mgr.consensu.org"]},{name:"ShareThis CMP",homepage:"https://sharethis.com",category:"consent-provider",domains:["sharethis.mgr.consensu.org","*.sharethis.mgr.consensu.org"]},{name:"ShinyStat CMP",homepage:"https://www.shinystat.com",category:"consent-provider",domains:["shinystat.mgr.consensu.org","*.shinystat.mgr.consensu.org"]},{name:"Sibbo CMP",homepage:"https://sibboventures.com/en/",category:"consent-provider",domains:["sibboventures.mgr.consensu.org","*.sibboventures.mgr.consensu.org"]},{name:"Singlespot CMP",homepage:"https://www.singlespot.com/en",category:"consent-provider",domains:["singlespot.mgr.consensu.org","*.singlespot.mgr.consensu.org"]},{name:"Sirdata CMP",homepage:"https://www.sirdata.com",category:"consent-provider",domains:["sddan.mgr.consensu.org","*.sddan.mgr.consensu.org"]},{name:"Snigel CMP",homepage:"https://snigel.com",category:"consent-provider",domains:["snigelweb.mgr.consensu.org","*.snigelweb.mgr.consensu.org"]},{name:"Sourcepoint CMP",homepage:"https://sourcepoint.com",category:"consent-provider",domains:["sourcepoint.mgr.consensu.org","*.sourcepoint.mgr.consensu.org"]},{name:"Pubtech CMP",homepage:"https://www.pubtech.ai/",category:"consent-provider",domains:["pubtech.mgr.consensu.org","*.pubtech.mgr.consensu.org"]},{name:"AdMetrics Pro CMP",homepage:"https://admetricspro.com",category:"consent-provider",domains:["cmp.mgr.consensu.org","*.cmp.mgr.consensu.org"]},{name:"Traffective CMP",homepage:"https://traffective.com",category:"consent-provider",domains:["traffective.mgr.consensu.org","*.traffective.mgr.consensu.org"]},{name:"UniConsent CMP",homepage:"https://uniconsent.com",category:"consent-provider",domains:["uniconsent.mgr.consensu.org","*.uniconsent.mgr.consensu.org"]},{name:"TrustArc CMP",homepage:"https://trustarc.com/",category:"consent-provider",domains:["trustarc.mgr.consensu.org","*.trustarc.mgr.consensu.org"]},{name:"Usercentrics CMP",homepage:"https://usercentrics.com",category:"consent-provider",domains:["usercentrics.mgr.consensu.org","*.usercentrics.mgr.consensu.org","*.usercentrics.eu","*.services.usercentrics.eu"]},{name:"WebAds CMP",homepage:"https://www.webads.nl/",category:"consent-provider",domains:["webads.mgr.consensu.org","*.webads.mgr.consensu.org"]},{name:"Trustcommander",company:"Commandersact",homepage:"https://www.commandersact.com",category:"consent-provider",domains:["*.trustcommander.net"]},{name:"Hubvisor",homepage:"https://www.hubvisor.io",category:"ad",domains:["*.hubvisor.io"]},{name:"Castle",homepage:"https://castle.io",category:"utility",domains:["*.castle.io","d2t77mnxyo7adj.cloudfront.net"]},{name:"Wigzo",homepage:"https://www.wigzo.com/",category:"marketing",domains:["*.wigzo.com","*.wigzopush.com"]},{name:"Convertful",homepage:"https://convertful.com/",category:"marketing",domains:["*.convertful.com"]},{name:"OpenLink",company:"MediaWallah",homepage:"https://www.mediawallah.com/",category:"ad",domains:["*.mediawallahscript.com"]},{name:"TPMN",company:"TPMN",homepage:"http://tpmn.io/",category:"ad",domains:["*.tpmn.co.kr"]},{name:"HERO",company:"Klarna",homepage:"https://www.usehero.com/",category:"customer-success",domains:["*.usehero.com"]},{name:"Zync",company:"Zeta Global",homepage:"https://zetaglobal.com/",category:"marketing",domains:["*.rezync.com"]},{name:"AdFuel Video",company:"AdFuel",homepage:"https://goadfuel.com/",category:"ad",domains:["*.videoplayerhub.com"]},{name:"Prefix Box AI Search",company:"Prefix Box",homepage:"https://www.prefixbox.com/",category:"utility",domains:["*.prefixbox.com"]},{name:"SpeedSize Service Worker",company:"SpeedSize",homepage:"https://speedsize.com/",category:"utility",domains:["di6367dava8ow.cloudfront.net","d2d22nphq0yz8t.cloudfront.net"]},{name:"Vonage Video API",company:"Vonage",homepage:"https://www.vonage.com/communications-apis/video/",category:"video",domains:["*.opentok.com"]},{name:"Checkout.com",company:"Checkout.com",homepage:"https://www.checkout.com",category:"utility",domains:["*.checkout.com"]},{name:"Noibu",company:"Noibu",homepage:"https://www.noibu.com",category:"utility",domains:["*.noibu.com"]},{name:"Clarity",company:"Microsoft",homepage:"https://clarity.microsoft.com/",category:"utility",domains:["*.clarity.ms"]},{name:"goinstore",company:"Emplifi",homepage:"https://goinstore.com/",category:"customer-success",domains:["*.goinstore.com"]},{name:"SegmentStream",company:"SegmentStream",homepage:"https://segmentstream.com/",category:"marketing",domains:["*.segmentstream.com"]},{name:"Amazon Associates",company:"Amazon",homepage:"https://affiliate-program.amazon.co.uk/",category:"marketing",domains:["*.associates-amazon.com"]},{name:"DotMetrics",company:"Ipsos",homepage:"https://www.dotmetrics.net/",category:"analytics",domains:["*.dotmetrics.net"]},{name:"Truffle Bid",company:"Truffle",homepage:"https://truffle.bid/",category:"ad",domains:["*.truffle.bid"]},{name:"Hybrid",company:"Hybrid",homepage:"https://hybrid.ai/",category:"ad",domains:["*.hybrid.ai"]},{name:"AdMan Media",company:"AdMan",homepage:"https://admanmedia.com/",category:"video",domains:["*.admanmedia.com"]},{name:"ID5 Identity Cloud",company:"ID5",homepage:"https://id5.io/",category:"ad",domains:["id5-sync.com","*.id5-sync.com"]},{name:"Audience Rate",company:"Audience Rate Limited",homepage:"https://www.audiencerate.com/",category:"ad",domains:["*.audrte.com"]},{name:"Seedtag",company:"Seedtag Advertising",homepage:"https://www.seedtag.com/",category:"ad",domains:["*.seedtag.com"]},{name:"IVI",company:"IVI Technologies",homepage:"http://ivitechnologies.com/",category:"ad",domains:["*.ivitrack.com"]},{name:"Sportradar",company:"Sportradar",homepage:"https://www.sportradar.com/",category:"ad",domains:["*.sportradarserving.com"]},{name:"ZEOTAP",company:"ZEOTAP",homepage:"https://zeotap.com/",category:"ad",domains:["*.zeotap.com"]},{name:"Web Content Assessor",company:"TMT Digital",homepage:"https://mediatrust.com/",category:"ad",domains:["*.webcontentassessor.com"]},{name:"Genie",company:"Media Force",homepage:"https://hellogenie.com/",category:"ad",domains:["*.mfadsrvr.com"]},{name:"mediarithmics",company:"mediarithmics",homepage:"https://www.mediarithmics.com/",category:"ad",domains:["*.mediarithmics.com"]},{name:"Ozone Project",company:"The Ozone Project",homepage:"https://www.ozoneproject.com/",category:"ad",domains:["*.the-ozone-project.com"]},{name:"FiftyAurora",company:"Fifty",homepage:"https://fifty.io/",category:"ad",domains:["*.fiftyt.com"]},{name:"smadex",company:"entravision",homepage:"https://smadex.com/",category:"ad",domains:["*.smadex.com"]},{name:"AWX",company:"Trinity Mirror",category:"ad",domains:["*.tm-awx.com"]},{name:"XPO",company:"Knorex",category:"ad",homepage:"https://www.knorex.com/",domains:["*.brand-display.com"]},{name:"Viafoura",company:"Viafoura",category:"ad",homepage:"https://viafoura.com/",domains:["*.viafoura.co","*.viafoura.net"]},{name:"Adnami",company:"Adnami",category:"ad",homepage:"https://www.adnami.io/",domains:["*.adnami.io"]},{name:"LiveRamp Privacy Manager",company:"LiveRamp",category:"ad",homepage:"https://liveramp.com/privacy-legal-compliance/",domains:["*.privacymanager.io"]},{name:"Onfocus",company:"Onfocus SAS",category:"ad",domains:["*.4dex.io"]},{name:"viewTag",company:"Advanced Store",category:"ad",domains:["*.ad4m.at"]},{name:"MRP Prelytics",company:"Market Resource Partners",category:"ad",homepage:"https://www.mrpfd.com/",domains:["*.mrpdata.net"]},{name:"iPROM",company:"iPROM",category:"ad",homepage:"https://iprom.eu/",domains:["*.iprom.net"]},{name:"Plausible",company:"Plausible",homepage:"https://plausible.io/",category:"analytics",domains:["*.plausible.io"]},{name:"Micro Analytics",company:"Micro Analytics",homepage:"https://microanalytics.io/",category:"analytics",domains:["padmin.microanalytics.io","www.microanalytics.io","dev.microanalytics.io","status.microanalytics.io"]},{name:"Scale8",company:"Scale8",homepage:"https://scale8.com/",category:"analytics",domains:["www.scale8.com","api-dev.scale8.com","cdn.scale8.com","ui.scale8.com"]},{name:"Cabin",company:"Cabin",homepage:"https://withcabin.com/",category:"analytics",domains:["*.withcabin.com"]},{name:"Appcues",company:"Appcues",homepage:"https://www.appcues.com/",category:"analytics",domains:["*.appcues.com"]},{name:"Fathom Analytics",company:"Fathom",homepage:"https://usefathom.com/",category:"analytics",domains:["*.usefathom.com"]},{name:"Clearbit",company:"Clearbit",homepage:"https://clearbit.com/",category:"analytics",domains:["*.clearbitjs.com","*.clearbitscripts.com","*.clearbit.com"]},{name:"G2",company:"G2",homepage:"https://www.g2.com/",category:"utility",domains:["*.g2.com","*.g2crowd.com"]},{name:"Navu",company:"Navu",homepage:"https://navu.co/",category:"ad",domains:["*.navu.co"]},{name:"InZynk",company:"InZynk",homepage:"https://inzynk.com/",category:"ad",domains:["*.inzynk.com","*.inzynk.io"]},{name:"Integrate",company:"Integrate",homepage:"https://www.integrate.com/",category:"ad",domains:["*.integrate.com","*.listenloop.com"]},{name:"Ad Lightning",company:"Boltive",homepage:"https://www.adlightning.com/",category:"ad",domains:["*.adlightning.com"]},{name:"GeoEdge",company:"GeoEdge",homepage:"https://www.geoedge.com/",category:"ad",domains:["*.geoedge.com","*.geoedge.be"]},{name:"Doofinder",company:"Doofinder",homepage:"https://www.doofinder.com/",category:"utility",domains:["cdn.doofinder.com"]},{name:"Revlifter",company:"Revlifter",homepage:"https://www.revlifter.com/",category:"utility",domains:["assets.revlifter.com"]},{name:"Didomi",company:"Didomi",homepage:"https://www.didomi.io/",category:"consent-provider",domains:["sdk.privacy-center.org","api.privacy-center.org"]}]});var XP=I((aMe,KP)=>{d();var{createAPIFromDataset:Tne}=$P(),Sne=YP();KP.exports=Tne(Sne)});var ZP=I((iMe,JP)=>{d();JP.exports=XP()});function QP(e){return qw.default.getEntity(e)}function kne(e){return qw.default.getProduct(e)}function e5(e,t){let n=QP(e);return!(!n||n===t)}function Cne(e,t){return!e5(e,t)}var qw,$a,lf=b(()=>{"use strict";d();qw=Lt(ZP(),1);s(QP,"getEntity");s(kne,"getProduct");s(e5,"isThirdParty");s(Cne,"isFirstParty");$a={getEntity:QP,getProduct:kne,isThirdParty:e5,isFirstParty:Cne}});var zw,ln,ua=b(()=>{"use strict";d();ue();de();Fn();Ze();lf();zw=class e{static{s(this,"EntityClassification")}static makeupChromeExtensionEntity_(t,n,r){let a=Me.getChromeExtensionOrigin(n),o=new URL(a).host,i=r||o,c=t.get(a);if(c)return c;let u={name:i,company:i,category:"Chrome Extension",homepage:"https://chromewebstore.google.com/detail/"+o,categories:[],domains:[],averageExecutionTime:0,totalExecutionTime:0,totalOccurrences:0};return t.set(a,u),u}static _makeUpAnEntity(t,n){if(!Y.isValid(n))return;let r=Me.createOrReturnURL(n);if(r.protocol==="chrome-extension:")return e.makeupChromeExtensionEntity_(t,n);if(!r.protocol.startsWith("http"))return;let a=Y.getRootDomain(n);if(!a)return;if(t.has(a))return t.get(a);let o={name:a,company:a,category:"",categories:[],domains:[a],averageExecutionTime:0,totalExecutionTime:0,totalOccurrences:0,isUnrecognized:!0};return t.set(a,o),o}static _preloadChromeExtensionsToCache(t,n){for(let r of n.values()){if(r.method!=="Runtime.executionContextCreated")continue;let a=r.params.context.origin;a.startsWith("chrome-extension:")&&(t.has(a)||e.makeupChromeExtensionEntity_(t,a,r.params.context.name))}}static async compute_(t,n){let r=await H.request(t.devtoolsLog,n),a=new Map,o=new Map,i=new Map;e._preloadChromeExtensionsToCache(a,t.devtoolsLog);for(let m of r){let{url:p}=m;if(o.has(p))continue;let h=$a.getEntity(p)||e._makeUpAnEntity(a,p);if(!h)continue;let f=i.get(h)||new Set;f.add(p),i.set(h,f),o.set(p,h)}let c=t.URL.mainDocumentUrl||t.URL.finalDisplayedUrl,u=$a.getEntity(c)||e._makeUpAnEntity(a,c);function l(m){return o.get(m)===u}return s(l,"isFirstParty"),{entityByUrl:o,urlsByEntity:i,firstParty:u,isFirstParty:l}}},ln=q(zw,["URL","devtoolsLog"])});var t5={};T(t5,{UIStrings:()=>mf,default:()=>_ne});var Ane,Hw,mf,df,Gw,Vw,_ne,n5=b(()=>{"use strict";d();Jr();V();Ln();ua();ca();A();Wa();Wi();Ane=`{
  "moduleSizes": [11897, 498, 265, 277, 263, 453, 219, 216, 546, 339, 1608, 671, 1525, 420, 214, 504, 98, 524, 196, 268, 642, 204, 742, 618, 169, 394, 127, 433, 1473, 779, 239, 144, 182, 254, 77, 508, 124, 1388, 75, 133, 301, 362, 170, 1078, 182, 490, 195, 321, 316, 447, 551, 216, 284, 253, 17, 107, 295, 356, 345, 1939, 1596, 291, 139, 259, 1291, 179, 528, 174, 61, 326, 20, 444, 522, 104, 1945, 120, 1943, 680, 1409, 850, 630, 288, 38, 695, 569, 106, 587, 208, 370, 606, 766, 535, 616, 200, 170, 224, 422, 970, 978, 498, 284, 241, 210, 151, 194, 178, 814, 205, 189, 215, 111, 236, 147, 237, 191, 691, 212, 432, 499, 445, 176, 333, 129, 414, 617, 380, 251, 199, 524, 515, 681, 160, 259, 295, 283, 178, 472, 786, 520, 202, 575, 575, 349, 549, 458, 166, 173, 508, 1522, 743, 414, 431, 393, 899, 137, 270, 131, 472, 457, 205, 778, 801, 133, 3000],
  "dependencies": {
    "Array.prototype.fill": [0, 5, 8, 11, 21, 23, 25, 26, 29, 36, 37, 54, 55, 57, 58, 60, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 116],
    "Array.prototype.filter": [0, 11, 12, 13, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 117],
    "Array.prototype.find": [0, 5, 11, 12, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 55, 57, 58, 60, 62, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 119],
    "Array.prototype.findIndex": [0, 5, 11, 12, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 55, 57, 58, 60, 62, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 118],
    "Array.prototype.forEach": [0, 9, 11, 12, 14, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 120],
    "Array.from": [0, 10, 11, 19, 20, 21, 22, 23, 25, 26, 27, 29, 36, 37, 41, 46, 49, 50, 54, 57, 58, 60, 61, 64, 66, 72, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 121],
    "Array.isArray": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 62, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 122],
    "Array.prototype.map": [0, 11, 12, 13, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 123],
    "Array.of": [0, 11, 21, 22, 23, 25, 26, 27, 29, 36, 37, 54, 57, 58, 60, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 124],
    "Array.prototype.some": [0, 11, 12, 14, 17, 18, 21, 22, 23, 25, 26, 29, 36, 37, 41, 46, 54, 57, 58, 60, 62, 64, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 114, 125],
    "Date.now": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 126],
    "Date.prototype.toISOString": [0, 11, 21, 22, 23, 25, 26, 28, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 98, 99, 101, 102, 103, 104, 108, 109, 114, 127],
    "Date.prototype.toJSON": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 128],
    "Date.prototype.toString": [0, 25, 26, 29, 54, 58, 60, 74, 94, 114, 129],
    "Function.prototype.name": [0, 130],
    "Number.isInteger": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 67, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 131],
    "Number.isSafeInteger": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 67, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 132],
    "Object.defineProperties": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 133],
    "Object.defineProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 134],
    "Object.freeze": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 136],
    "Object.getPrototypeOf": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 138],
    "Object.isExtensible": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 139],
    "Object.isFrozen": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 140],
    "Object.isSealed": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 141],
    "Object.keys": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 114, 142],
    "Object.preventExtensions": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 143],
    "Object.seal": [0, 7, 11, 15, 21, 23, 25, 26, 27, 29, 36, 37, 39, 54, 57, 58, 59, 60, 66, 73, 74, 75, 79, 80, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 144],
    "Object.setPrototypeOf": [0, 4, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 89, 92, 94, 101, 102, 103, 104, 114, 145],
    "Reflect.apply": [0, 11, 21, 23, 25, 26, 29, 36, 37, 40, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 147],
    "Reflect.construct": [0, 3, 11, 16, 21, 22, 23, 25, 26, 29, 36, 37, 40, 43, 54, 55, 57, 58, 60, 64, 66, 73, 74, 75, 76, 77, 79, 81, 82, 86, 87, 88, 92, 94, 101, 102, 103, 104, 108, 114, 148],
    "Reflect.defineProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 149],
    "Reflect.deleteProperty": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 150],
    "Reflect.get": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 65, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 153],
    "Reflect.getOwnPropertyDescriptor": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 151],
    "Reflect.getPrototypeOf": [0, 11, 21, 23, 24, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 83, 86, 88, 92, 94, 101, 102, 103, 104, 114, 152],
    "Reflect.has": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 154],
    "Reflect.isExtensible": [0, 7, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 84, 86, 88, 92, 94, 101, 102, 103, 104, 114, 155],
    "Reflect.ownKeys": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 156],
    "Reflect.preventExtensions": [0, 11, 21, 23, 25, 26, 29, 36, 37, 39, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 157],
    "Reflect.setPrototypeOf": [0, 4, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 89, 92, 94, 101, 102, 103, 104, 114, 158],
    "String.prototype.codePointAt": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 97, 101, 102, 103, 104, 108, 109, 114, 159],
    "String.fromCodePoint": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 160],
    "String.raw": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 108, 109, 114, 161],
    "String.prototype.repeat": [0, 11, 21, 22, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 99, 101, 102, 103, 104, 108, 109, 114, 162],
    "Object.entries": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 90, 92, 94, 101, 102, 103, 104, 114, 135],
    "Object.getOwnPropertyDescriptors": [0, 11, 21, 23, 25, 26, 27, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 88, 92, 94, 101, 102, 103, 104, 114, 137],
    "Object.values": [0, 11, 21, 23, 25, 26, 29, 36, 37, 54, 57, 58, 60, 66, 73, 74, 75, 79, 81, 82, 86, 87, 88, 90, 92, 94, 101, 102, 103, 104, 114, 146],
    "focus-visible": [163]
  },
  "maxSize": 87683
}`,Hw=JSON.parse(Ane),mf={title:"Avoid serving legacy JavaScript to modern browsers",description:"Polyfills and transforms enable legacy browsers to use new JavaScript features. However, many aren't necessary for modern browsers. For your bundled JavaScript, adopt a modern script deployment strategy using module/nomodule feature detection to reduce the amount of code shipped to modern browsers, while retaining support for legacy browsers. [Learn how to use modern JavaScript](https://web.dev/articles/publish-modern-javascript)"},df=w("core/audits/byte-efficiency/legacy-javascript.js",mf),Gw=class{static{s(this,"CodePatternMatcher")}constructor(t){let n=t.map(r=>`(${r.expression})`).join("|");this.re=new RegExp(`(^\r
|\r|
)|${n}`,"g"),this.patterns=t}match(t){this.re.lastIndex=0;let n=new Set,r=[],a,o=0,i=0;for(;(a=this.re.exec(t))!==null;){let c=a.slice(1),[u,...l]=c;if(u){o++,i=a.index+1;continue}let m=this.patterns[l.findIndex(Boolean)];if(n.has(m)){let p=r.find(h=>h.name===m.name);p&&(p.count+=1);continue}n.add(m),r.push({name:m.name,line:o,column:a.index-i,count:1})}return r}},Vw=class extends ve{static{s(this,"LegacyJavascript")}static get meta(){return{id:"legacy-javascript",scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,description:df(mf.description),title:df(mf.title),guidanceLevel:2,requiredArtifacts:["devtoolsLogs","traces","Scripts","SourceMaps","GatherContext","URL"]}}static buildPolyfillExpression(t,n){let r=s(o=>`['"]${o}['"]`,"qt"),a="";if(t?a+=`${t}\\.${n}\\s?=[^=]`:a+=`(?:window\\.|[\\s;]+)${n}\\s?=[^=]`,t&&(a+=`|${t}\\[${r(n)}\\]\\s?=[^=]`),a+=`|defineProperty\\(${t||"window"},\\s?${r(n)}`,t){let o=t.replace(".prototype","");a+=`|\\$export\\([^,]+,${r(o)},{${n}:`,a+=`|{target:${r(o)}\\S*},{${n}:`}else a+=`|function ${n}\\(`;return a}static getPolyfillData(){let t=[{name:"focus-visible",modules:["focus-visible"]}],n=[["Array.prototype.fill","es6.array.fill"],["Array.prototype.filter","es6.array.filter"],["Array.prototype.find","es6.array.find"],["Array.prototype.findIndex","es6.array.find-index"],["Array.prototype.forEach","es6.array.for-each"],["Array.from","es6.array.from"],["Array.isArray","es6.array.is-array"],["Array.prototype.map","es6.array.map"],["Array.of","es6.array.of"],["Array.prototype.some","es6.array.some"],["Date.now","es6.date.now"],["Date.prototype.toISOString","es6.date.to-iso-string"],["Date.prototype.toJSON","es6.date.to-json"],["Date.prototype.toString","es6.date.to-string"],["Function.prototype.name","es6.function.name"],["Number.isInteger","es6.number.is-integer"],["Number.isSafeInteger","es6.number.is-safe-integer"],["Object.defineProperties","es6.object.define-properties"],["Object.defineProperty","es6.object.define-property"],["Object.freeze","es6.object.freeze"],["Object.getPrototypeOf","es6.object.get-prototype-of"],["Object.isExtensible","es6.object.is-extensible"],["Object.isFrozen","es6.object.is-frozen"],["Object.isSealed","es6.object.is-sealed"],["Object.keys","es6.object.keys"],["Object.preventExtensions","es6.object.prevent-extensions"],["Object.seal","es6.object.seal"],["Object.setPrototypeOf","es6.object.set-prototype-of"],["Reflect.apply","es6.reflect.apply"],["Reflect.construct","es6.reflect.construct"],["Reflect.defineProperty","es6.reflect.define-property"],["Reflect.deleteProperty","es6.reflect.delete-property"],["Reflect.get","es6.reflect.get"],["Reflect.getOwnPropertyDescriptor","es6.reflect.get-own-property-descriptor"],["Reflect.getPrototypeOf","es6.reflect.get-prototype-of"],["Reflect.has","es6.reflect.has"],["Reflect.isExtensible","es6.reflect.is-extensible"],["Reflect.ownKeys","es6.reflect.own-keys"],["Reflect.preventExtensions","es6.reflect.prevent-extensions"],["Reflect.setPrototypeOf","es6.reflect.set-prototype-of"],["String.prototype.codePointAt","es6.string.code-point-at"],["String.fromCodePoint","es6.string.from-code-point"],["String.raw","es6.string.raw"],["String.prototype.repeat","es6.string.repeat"],["Object.entries","es7.object.entries"],["Object.getOwnPropertyDescriptors","es7.object.get-own-property-descriptors"],["Object.values","es7.object.values"]];for(let[r,a]of n)t.push({name:r,modules:[a,a.replace("es6.","es.").replace("es7.","es.").replace("typed.","typed-array.")],corejs:!0});return t}static getCoreJsPolyfillData(){return this.getPolyfillData().filter(t=>t.corejs).map(t=>({name:t.name,coreJs2Module:t.modules[0],coreJs3Module:t.modules[1]}))}static getPolyfillPatterns(){let t=[];for(let{name:n}of this.getCoreJsPolyfillData()){let r=n.split("."),a=r.length>1?r.slice(0,r.length-1).join("."):null,o=r[r.length-1];t.push({name:n,expression:this.buildPolyfillExpression(a,o)})}return t}static getTransformPatterns(){return[{name:"@babel/plugin-transform-classes",expression:"Cannot call a class as a function",estimateBytes:t=>150+t.count*17},{name:"@babel/plugin-transform-regenerator",expression:/regeneratorRuntime\(?\)?\.a?wrap/.source,estimateBytes:t=>t.count*80},{name:"@babel/plugin-transform-spread",expression:/\.apply\(void 0,\s?_toConsumableArray/.source,estimateBytes:t=>1169+t.count*20}]}static detectAcrossScripts(t,n,r,a){let o=new Map,i=this.getPolyfillData();for(let c of Object.values(n)){if(!c.content)continue;let u=t.match(c.content),l=a.find(m=>m.script.scriptId===c.scriptId);if(l)for(let{name:m,modules:p}of i){if(u.some(y=>y.name===m))continue;let h=l.rawMap.sources.find(y=>p.some(v=>y.endsWith(`${v}.js`)));if(!h)continue;let f=l.map.mappings().find(y=>y.sourceURL===h);f?u.push({name:m,line:f.lineNumber,column:f.columnNumber,count:1}):u.push({name:m,line:0,column:0,count:1})}u.length&&o.set(c,u)}return o}static estimateWastedBytes(t){let n=t.filter(u=>!u.name.startsWith("@")),r=t.filter(u=>u.name.startsWith("@")),a=0,o=new Set;for(let u of n){let l=Hw.dependencies[u.name];if(l)for(let m of l)o.add(m)}a+=[...o].reduce((u,l)=>u+Hw.moduleSizes[l],0),a=Math.min(a,Hw.maxSize);let i=0;for(let u of r){let l=this.getTransformPatterns().find(m=>m.name===u.name);!l||!l.estimateBytes||(i+=l.estimateBytes(u))}return a+i}static async audit_(t,n,r){let a=t.devtoolsLogs[g.DEFAULT_PASS],o=await ln.request({URL:t.URL,devtoolsLog:a},r),i=await un.request(t,r),c=[],u=new Gw([...this.getPolyfillPatterns(),...this.getTransformPatterns()]),l=new Map,m=this.detectAcrossScripts(u,t.Scripts,n,i);for(let[f,y]of m.entries()){let v=vs(l,f.url,t,n),D=Math.round(this.estimateWastedBytes(y)*v),E={url:f.url,wastedBytes:D,subItems:{type:"subitems",items:[]},totalBytes:0},S=i.find(k=>k.script.scriptId===f.scriptId);for(let k of y){let{name:C,line:R,column:z}=k,B={signal:C,location:ve.makeSourceLocation(f.url,R,z,S)};E.subItems.items.push(B)}c.push(E)}let p=new Map;for(let f of c)o.isFirstParty(f.url)&&p.set(f.url,f.wastedBytes);let h=[{key:"url",valueType:"url",subItemsHeading:{key:"location",valueType:"source-location"},label:df(x.columnURL)},{key:null,valueType:"code",subItemsHeading:{key:"signal"},label:""},{key:"wastedBytes",valueType:"bytes",label:df(x.columnWastedBytes)}];return{items:c,headings:h,wastedBytesByUrl:p}}},_ne=Vw});var r5={};T(r5,{UIStrings:()=>pf,default:()=>Fne});var pf,ld,Rne,Ww,Fne,a5=b(()=>{"use strict";d();Ln();Ze();A();pf={title:"Serve images in next-gen formats",description:"Image formats like WebP and AVIF often provide better compression than PNG or JPEG, which means faster downloads and less data consumption. [Learn more about modern image formats](https://developer.chrome.com/docs/lighthouse/performance/uses-webp-images/)."},ld=w("core/audits/byte-efficiency/modern-image-formats.js",pf),Rne=8192,Ww=class e extends ve{static{s(this,"ModernImageFormats")}static get meta(){return{id:"modern-image-formats",title:ld(pf.title),description:ld(pf.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:3,requiredArtifacts:["OptimizedImages","devtoolsLogs","traces","URL","GatherContext","ImageElements"]}}static estimateWebPSizeFromDimensions(t){let n=t.naturalWidth*t.naturalHeight,r=2*1/10;return Math.round(n*r)}static estimateAvifSizeFromDimensions(t){let n=t.naturalWidth*t.naturalHeight,r=2*1/12;return Math.round(n*r)}static estimateAvifSizeFromWebPAndJpegEstimates(t){if(!t.jpegSize||!t.webpSize)return;let n=t.jpegSize*5/10,r=t.webpSize*8/10;return n/2+r/2}static audit_(t){let n=t.URL.finalDisplayedUrl,r=t.OptimizedImages,a=t.ImageElements,o=new Map;a.forEach(l=>o.set(l.src,l));let i=[],c=[];for(let l of r){let m=o.get(l.url);if(l.failed){c.push(`Unable to decode ${Y.getURLDisplayName(l.url)}`);continue}if(l.mimeType==="image/webp"||l.mimeType==="image/avif")continue;let p=l.jpegSize,h=l.webpSize,f=e.estimateAvifSizeFromWebPAndJpegEstimates({jpegSize:p,webpSize:h}),y=!0;if(typeof h>"u"){if(!m){c.push(`Unable to locate resource ${Y.getURLDisplayName(l.url)}`);continue}if(!m.naturalDimensions)continue;let k=m.naturalDimensions.height,C=m.naturalDimensions.width;if(!C||!k)continue;h=e.estimateWebPSizeFromDimensions({naturalHeight:k,naturalWidth:C}),f=e.estimateAvifSizeFromDimensions({naturalHeight:k,naturalWidth:C}),y=!1}if(h===void 0||f===void 0)continue;let v=l.originalSize-h,D=l.originalSize-f;if(D<Rne)continue;let E=Y.elideDataURI(l.url),S=!Y.originsMatch(n,l.url);i.push({node:m?ve.makeNodeItem(m.node):void 0,url:E,fromProtocol:y,isCrossOrigin:S,totalBytes:l.originalSize,wastedBytes:D,wastedWebpBytes:v})}let u=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:ld(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:ld(x.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:ld(x.columnWastedBytes)}];return{warnings:c,items:i,headings:u}}},Fne=Ww});var c5={};T(c5,{UIStrings:()=>ff,default:()=>Nne});var ff,dd,$w,Ine,o5,i5,s5,Yw,Nne,u5=b(()=>{"use strict";d();Ln();lt();or();Ze();A();gs();Nt();ff={title:"Defer offscreen images",description:"Consider lazy-loading offscreen and hidden images after all critical resources have finished loading to lower time to interactive. [Learn how to defer offscreen images](https://developer.chrome.com/docs/lighthouse/performance/offscreen-images/)."},dd=w("core/audits/byte-efficiency/offscreen-images.js",ff),$w=100,Ine=3,o5=2048,i5=75,s5=50,Yw=class e extends ve{static{s(this,"OffscreenImages")}static get meta(){return{id:"offscreen-images",title:dd(ff.title),description:dd(ff.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,supportedModes:["navigation"],guidanceLevel:2,requiredArtifacts:["ImageElements","ViewportDimensions","GatherContext","devtoolsLogs","traces","URL"]}}static computeVisiblePixels(t,n){let r=n.innerWidth,a=n.innerHeight,o=Ine*n.innerHeight,i=Math.max(t.top,-1*$w),c=Math.min(t.right,r+$w),u=Math.min(t.bottom,a+o),l=Math.max(t.left,-1*$w);return Math.max(c-l,0)*Math.max(u-i,0)}static computeWaste(t,n,r){let a=r.find(p=>p.url===t.src);if(!a||t.loading==="lazy"||t.loading==="eager")return null;let o=Y.elideDataURI(t.src),i=t.displayedWidth*t.displayedHeight,c=this.computeVisiblePixels(t.clientRect,n),u=i===0?1:1-c/i,l=G.getResourceSizeOnNetwork(a),m=Math.round(l*u);return Number.isFinite(u)?{node:ve.makeNodeItem(t.node),url:o,requestStartTime:a.networkRequestTime,totalBytes:l,wastedBytes:m,wastedPercent:100*u}:new Error(`Invalid image sizing information ${o}`)}static filterLanternResults(t,n){let r=n.pessimisticEstimate.nodeTimings,a=0,o=new Map;for(let[i,c]of r)i.type==="cpu"&&c.duration>=50?a=Math.max(a,c.startTime):i.type==="network"&&o.set(i.record.url,c.startTime);return t.filter(i=>i.wastedBytes<o5||i.wastedPercent<i5?!1:(o.get(i.url)||0)<a-s5)}static filterObservedResults(t,n){return t.filter(r=>r.wastedBytes<o5||r.wastedPercent<i5?!1:r.requestStartTime<n/1e3-s5)}static computeWasteWithTTIGraph(t,n,r){return super.computeWasteWithTTIGraph(t,n,r,{includeLoad:!1})}static async audit_(t,n,r){let a=t.ImageElements,o=t.ViewportDimensions,i=t.GatherContext,c=t.traces[ve.DEFAULT_PASS],u=t.devtoolsLogs[ve.DEFAULT_PASS],l=t.URL,m=[],p=new Map;for(let D of a){let E=e.computeWaste(D,o,n);if(E===null)continue;if(E instanceof Error){m.push(E.message),Rt.captureException(E,{tags:{audit:this.meta.id},level:"warning"});continue}let S=p.get(E.url);(!S||S.wastedBytes>E.wastedBytes)&&p.set(E.url,E)}let h=r.settings,f,y=Array.from(p.values());try{let D={trace:c,devtoolsLog:u,gatherContext:i,settings:h,URL:l},E=await Fr.request(D,r),S=E;f=r.settings.throttlingMethod==="simulate"?e.filterLanternResults(y,S):e.filterObservedResults(y,E.timestamp)}catch(D){if(r.settings.throttlingMethod==="simulate")throw D;f=e.filterObservedResults(y,await ke.request(c,r).then(E=>E.timestamps.traceEnd))}let v=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:dd(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:dd(x.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:dd(x.columnWastedBytes)}];return{warnings:m,items:f,headings:v}}},Nne=Yw});var ws,Kw,Ds,hf=b(()=>{"use strict";d();ue();de();Fn();Wa();ws=100,Kw=class e{static{s(this,"UnusedCSS")}static indexStylesheetsById(t,n){let r=n.filter(a=>a.resourceSize>0).reduce((a,o)=>(a[o.url]=o,a),{});return t.reduce((a,o)=>(a[o.header.styleSheetId]=Object.assign({usedRules:[],networkRecord:r[o.header.sourceURL]},o),a),{})}static indexUsedRules(t,n){t.forEach(r=>{let a=n[r.styleSheetId];a&&r.used&&a.usedRules.push(r)})}static computeUsage(t){let n=0,r=t.content.length;for(let c of t.usedRules)n+=c.endOffset-c.startOffset;let a=sf(t.networkRecord,r,"Stylesheet"),o=(r-n)/r;return{wastedBytes:Math.round(o*a),wastedPercent:o*100,totalBytes:a}}static determineContentPreview(t){let n=Me.truncate(t||"",ws*5,"").replace(/( {2,}|\t)+/g,"  ").replace(/\n\s+}/g,`
}`).trim();if(n.length>ws){let r=n.indexOf("{"),a=n.indexOf("}");if(r===-1||a===-1||r>a||r>ws)n=Me.truncate(n,ws);else if(a<ws)n=n.slice(0,a+1)+" …";else{let o=Me.truncate(n,ws,""),i=o.lastIndexOf(";");n=i<r?o+"… } …":n.slice(0,i+1)+" … } …"}}return n}static mapSheetToResult(t){let n=t.header.sourceURL;(!n||t.header.isInline)&&(n=e.determineContentPreview(t.content));let r=e.computeUsage(t);return{url:n,...r}}static async compute_(t,n){let{CSSUsage:r,devtoolsLog:a}=t,o=await H.request(a,n),i=e.indexStylesheetsById(r.stylesheets,o);return e.indexUsedRules(r.rules,i),Object.keys(i).map(u=>e.mapSheetToResult(i[u]))}},Ds=q(Kw,["CSSUsage","devtoolsLog"])});var d5={};T(d5,{UIStrings:()=>gf,default:()=>One});function Lne(e){let t={};return Array.from(e.keys()).forEach(r=>{if(r.type!=="network")return;let a=e.get(r);a&&(t[r.record.url]={node:r,nodeTiming:a})}),t}function Pne(e,t,n){let r=e.get(t);if(!r)return;let a=l5(t,r,n);r.duration-a.duration&&(t.traverse(i=>{e.delete(i)}),e.set(t,a))}function l5(e,t,n){let r={...t};return n.some(a=>a.id==="amp")&&e.type===ye.TYPES.NETWORK&&e.record.resourceType===G.TYPES.Stylesheet&&t.endTime>2100&&(r.endTime=Math.max(t.startTime,2100),r.duration=r.endTime-r.startTime),r}var Mne,gf,Es,Xw,One,m5=b(()=>{"use strict";d();V();A();gn();hf();lt();sr();Gn();rd();Mne=50,gf={title:"Eliminate render-blocking resources",description:"Resources are blocking the first paint of your page. Consider delivering critical JS/CSS inline and deferring all non-critical JS/styles. [Learn how to eliminate render-blocking resources](https://developer.chrome.com/docs/lighthouse/performance/render-blocking-resources/)."},Es=w("core/audits/byte-efficiency/render-blocking-resources.js",gf);s(Lne,"getNodesAndTimingByUrl");s(Pne,"adjustNodeTimings");s(l5,"computeStackSpecificTiming");Xw=class e extends g{static{s(this,"RenderBlockingResources")}static get meta(){return{id:"render-blocking-resources",title:Es(gf.title),supportedModes:["navigation"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,description:Es(gf.description),guidanceLevel:2,requiredArtifacts:["URL","TagsBlockingFirstPaint","traces","devtoolsLogs","CSSUsage","GatherContext","Stacks"]}}static async computeResults(t,n){let r=t.GatherContext,a=t.traces[g.DEFAULT_PASS],o=t.devtoolsLogs[g.DEFAULT_PASS],i={devtoolsLog:o,settings:n.settings},c=await zt.request(a,n),u=await Pt.request(i,n),l=await e.computeWastedCSSBytes(t,n),m={...n.settings,throttlingMethod:"simulate"},p={trace:a,devtoolsLog:o,gatherContext:r,simulator:u,settings:m,URL:t.URL},h=await Ga.request(p,n),f=c.timestamps.firstContentfulPaint/1e3,y=Lne(h.optimisticEstimate.nodeTimings),v=[],D=new Set;for(let S of t.TagsBlockingFirstPaint){if(S.endTime>f||!y[S.tag.url])continue;let{node:k,nodeTiming:C}=y[S.tag.url],R=l5(k,C,t.Stacks);k.traverse(B=>D.add(B.id));let z=Math.round(R.duration);z<Mne||v.push({url:S.tag.url,totalBytes:S.transferSize,wastedMs:z})}if(!v.length)return{results:v,wastedMs:0};let E=e.estimateSavingsWithGraphs(u,h.optimisticGraph,D,l,t.Stacks);return{results:v,wastedMs:E}}static estimateSavingsWithGraphs(t,n,r,a,o){let{nodeTimings:i}=t.simulate(n),c=new Map(i),u=0,l=n.cloneWithRelationships(y=>{Pne(c,y,o);let v=r.has(y.id);if(y.type!==ye.TYPES.NETWORK)return!v;let D=y.record.resourceType===G.TYPES.Stylesheet;if(v&&D){let E=a.get(y.record.url)||0;u+=(y.record.transferSize||0)-E}return!v});if(l.type!=="network")throw new Error("minimalFCPGraph not a NetworkNode");let m=Math.max(...Array.from(Array.from(c).map(y=>y[1].endTime))),p=l.record.transferSize,h=p||0;l.record.transferSize=h+u;let f=t.simulate(l).timeInMs;return l.record.transferSize=p,Math.round(Math.max(m-f,0))}static async computeWastedCSSBytes(t,n){let r=new Map;try{let a=await Ds.request({CSSUsage:t.CSSUsage,devtoolsLog:t.devtoolsLogs[g.DEFAULT_PASS]},n);for(let o of a)r.set(o.url,o.wastedBytes)}catch{}return r}static async audit(t,n){let{results:r,wastedMs:a}=await e.computeResults(t,n),o;r.length>0&&(o=Es(x.displayValueMsSavings,{wastedMs:a}));let i=[{key:"url",valueType:"url",label:Es(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:Es(x.columnTransferSize)},{key:"wastedMs",valueType:"timespanMs",label:Es(x.columnWastedMs)}],c=g.makeOpportunityDetails(i,r,{overallSavingsMs:a});return{displayValue:o,score:r.length?0:1,numericValue:a,numericUnit:"millisecond",details:c,metricSavings:{FCP:a,LCP:a}}}},One=Xw});var p5={};T(p5,{UIStrings:()=>Ts,default:()=>Bne});var Ts,xs,Jw,Bne,f5=b(()=>{"use strict";d();V();A();lt();de();Fn();Ts={title:"Avoids enormous network payloads",failureTitle:"Avoid enormous network payloads",description:"Large network payloads cost users real money and are highly correlated with long load times. [Learn how to reduce payload sizes](https://developer.chrome.com/docs/lighthouse/performance/total-byte-weight/).",displayValue:"Total size was {totalBytes, number, bytes} KiB"},xs=w("core/audits/byte-efficiency/total-byte-weight.js",Ts),Jw=class extends g{static{s(this,"TotalByteWeight")}static get meta(){return{id:"total-byte-weight",title:xs(Ts.title),failureTitle:xs(Ts.failureTitle),description:xs(Ts.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:1,requiredArtifacts:["devtoolsLogs"]}}static get defaultOptions(){return{p10:2667*1024,median:4e3*1024}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await H.request(r,n),o=0,i=[];a.forEach(m=>{if(G.isNonNetworkRequest(m)||!m.transferSize)return;let p={url:m.url,totalBytes:m.transferSize};o+=p.totalBytes,i.push(p)}),i=i.sort((m,p)=>p.totalBytes-m.totalBytes||m.url.localeCompare(p.url)).slice(0,10);let c=g.computeLogNormalScore({p10:n.options.p10,median:n.options.median},o),u=[{key:"url",valueType:"url",label:xs(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:xs(x.columnTransferSize)}],l=g.makeTableDetails(u,i,{sortedBy:["totalBytes"]});return{score:c,scoreDisplayMode:c>=Me.PASS_THRESHOLD?g.SCORING_MODES.INFORMATIVE:void 0,numericValue:o,numericUnit:"byte",displayValue:xs(Ts.displayValue,{totalBytes:o}),details:l}}},Bne=Jw});function qne(e,t){for(let n=t;n>0;n--){let r=Math.max(0,n-6),a=e.slice(r,n);if(!jne.test(a))return Une.test(a)}return!0}function h5(e,t){let n=0,r=!1,a=!1,o=!1,i=!1,c=!1,u=!1,l=null,m=[];for(let p=0;p<e.length;p++){let h=e.substr(p,2),f=h.charAt(0),y=f===" "||f===`
`||f==="	",v=f==="'"||f==='"'||f==="`";r?f===`
`&&(r=!1):a?(o&&n++,h==="*/"&&(o&&n++,a=!1,p++)):i?(n++,l==="`"&&h==="${"?(m.push("templateBrace"),i=!1,n++,p++):f==="\\"?(n++,p++):f===l&&(i=!1)):c?(n++,f==="\\"?(n++,p++):f==="["?u=!0:f==="]"&&u?u=!1:f==="/"&&!u&&(c=!1)):h==="/*"?(a=!0,o=e.charAt(p+2)==="!",o&&(n+=2),p++):h==="//"&&t.singlelineComments?(r=!0,a=!1,o=!1,p++):f==="/"&&t.regex&&qne(e,p)?(c=!0,n++):f==="{"&&m.length?(m.push("normalBrace"),n++):f==="}"&&m.length?(m[m.length-1]==="templateBrace"&&(i=!0,l="`"),m.pop(),n++):v?(i=!0,l=f,n++):y||n++}return a||i?e.length:n}function g5(e){return h5(e,{singlelineComments:!0,regex:!0})}function y5(e){return h5(e,{singlelineComments:!1,regex:!1})}var Une,jne,Zw=b(()=>{"use strict";d();Une=/(return|case|else|{|\(|\[|\.\.\.|;|,|<|>|<=|>=|==|!=|===|!==|\+|-|\*|%|\*\*|\+\+|--|<<|>>|>>>|&|\||\^|!|~|&&|\|\||\?|:|=|\+=|-=|\*=|%=|\*\*=|<<=|>>=|>>>=|&=|\|=|\^=|=>|\/|\/=|\})$/,jne=/( |\n|\t)+$/;s(qne,"hasPunctuatorBefore");s(h5,"computeTokenLength");s(g5,"computeJSTokenLength");s(y5,"computeCSSTokenLength")});var b5={};T(b5,{UIStrings:()=>yf,default:()=>Gne});var yf,md,zne,Hne,Qw,Gne,v5=b(()=>{"use strict";d();Ln();hf();A();Zw();Wa();yf={title:"Minify CSS",description:"Minifying CSS files can reduce network payload sizes. [Learn how to minify CSS](https://developer.chrome.com/docs/lighthouse/performance/unminified-css/)."},md=w("core/audits/byte-efficiency/unminified-css.js",yf),zne=5,Hne=2048,Qw=class e extends ve{static{s(this,"UnminifiedCSS")}static get meta(){return{id:"unminified-css",title:md(yf.title),description:md(yf.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:3,requiredArtifacts:["CSSUsage","devtoolsLogs","traces","URL","GatherContext"]}}static computeTokenLength(t){return y5(t)}static computeWaste(t,n){let r=t.content,a=e.computeTokenLength(r),o=t.header.sourceURL;(!o||t.header.isInline)&&(o=Ds.determineContentPreview(t.content));let i=sf(n,r.length,"Stylesheet"),c=1-a/r.length,u=Math.round(i*c);return{url:o,totalBytes:i,wastedBytes:u,wastedPercent:100*c}}static audit_(t,n){let r=[];for(let o of t.CSSUsage.stylesheets){let i=n.find(u=>u.url===o.header.sourceURL);if(!o.content)continue;let c=e.computeWaste(o,i);c.wastedPercent<zne||c.wastedBytes<Hne||!Number.isFinite(c.wastedBytes)||r.push(c)}let a=[{key:"url",valueType:"url",label:md(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:md(x.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:md(x.columnWastedBytes)}];return{items:r,headings:a}}},Gne=Qw});var w5={};T(w5,{UIStrings:()=>bf,default:()=>$ne});var bf,pd,Vne,Wne,eD,$ne,D5=b(()=>{"use strict";d();Ln();A();Zw();Wa();Fn();bf={title:"Minify JavaScript",description:"Minifying JavaScript files can reduce payload sizes and script parse time. [Learn how to minify JavaScript](https://developer.chrome.com/docs/lighthouse/performance/unminified-javascript/)."},pd=w("core/audits/byte-efficiency/unminified-javascript.js",bf),Vne=10,Wne=2048,eD=class e extends ve{static{s(this,"UnminifiedJavaScript")}static get meta(){return{id:"unminified-javascript",title:pd(bf.title),description:pd(bf.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:3,requiredArtifacts:["Scripts","devtoolsLogs","traces","GatherContext","URL"]}}static computeWaste(t,n,r){let a=t.length,o=g5(t),i=Ow(r,a,"Script"),c=1-o/a,u=Math.round(i*c);return{url:n,totalBytes:i,wastedBytes:u,wastedPercent:100*c}}static audit_(t,n){let r=[],a=[];for(let i of t.Scripts){if(!i.content)continue;let c=Pw(n,i),u=of(i)?`inline: ${Me.truncate(i.content,40)}`:i.url;try{let l=e.computeWaste(i.content,u,c);if(l.wastedPercent<Vne||l.wastedBytes<Wne||!Number.isFinite(l.wastedBytes))continue;r.push(l)}catch(l){a.push(`Unable to process script ${i.url}: ${l.message}`)}}let o=[{key:"url",valueType:"url",label:pd(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:pd(x.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:pd(x.columnWastedBytes)}];return{items:r,warnings:a,headings:o}}},$ne=eD});var E5={};T(E5,{UIStrings:()=>vf,default:()=>Kne});var vf,fd,Yne,tD,Kne,x5=b(()=>{"use strict";d();Ln();hf();A();vf={title:"Reduce unused CSS",description:"Reduce unused rules from stylesheets and defer CSS not used for above-the-fold content to decrease bytes consumed by network activity. [Learn how to reduce unused CSS](https://developer.chrome.com/docs/lighthouse/performance/unused-css-rules/)."},fd=w("core/audits/byte-efficiency/unused-css-rules.js",vf),Yne=10*1024,tD=class extends ve{static{s(this,"UnusedCSSRules")}static get meta(){return{id:"unused-css-rules",title:fd(vf.title),description:fd(vf.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:2,requiredArtifacts:["CSSUsage","URL","devtoolsLogs","traces","GatherContext"]}}static async audit_(t,n,r){let o=(await Ds.request({CSSUsage:t.CSSUsage,devtoolsLog:t.devtoolsLogs[ve.DEFAULT_PASS]},r)).filter(c=>c&&c.wastedBytes>Yne),i=[{key:"url",valueType:"url",label:fd(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:fd(x.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:fd(x.columnWastedBytes)}];return{items:o,headings:i}}},Kne=tD});var nD,wf,rD=b(()=>{"use strict";d();ue();nD=class e{static{s(this,"UnusedJavascriptSummary")}static computeWaste(t){let n=0;for(let o of t.functions)n=Math.max(n,...o.ranges.map(i=>i.endOffset));let r=new Uint8Array(n);for(let o of t.functions)for(let i of o.ranges)if(i.count===0)for(let c=i.startOffset;c<i.endOffset;c++)r[c]=1;let a=0;for(let o of r)a+=o;return{unusedByIndex:r,unusedLength:a,contentLength:n}}static createItem(t,n){let r=n.unusedLength/n.contentLength||0,a=Math.round(n.contentLength*r);return{scriptId:t,totalBytes:n.contentLength,wastedBytes:a,wastedPercent:100*r}}static createSourceWastedBytes(t,n){if(!n.script.content)return;let r={},a=n.script.content.split(`
`).map(l=>l.length),o=0,i=a.map(l=>{let m=o;return o+=l+1,m});n.map.computeLastGeneratedColumns();for(let l of n.map.mappings()){let m=i[l.lineNumber];m+=l.columnNumber;let p=l.lastColumnNumber!==void 0?l.lastColumnNumber-1:a[l.lineNumber];for(let h=l.columnNumber;h<=p;h++){if(t.unusedByIndex[m]===1){let f=l.sourceURL||"(unmapped)";r[f]=(r[f]||0)+1}m+=1}}let c=Object.entries(r).sort(([l,m],[p,h])=>h-m),u={};for(let[l,m]of c)u[l]=m;return u}static async compute_(t){let{scriptId:n,scriptCoverage:r,bundle:a}=t,o=e.computeWaste(r),i=e.createItem(n,o);return a?{...i,sourcesWastedBytes:e.createSourceWastedBytes(o,a)}:i}},wf=q(nD,["bundle","scriptCoverage","scriptId"])});var T5={};T(T5,{UIStrings:()=>Df,default:()=>ere});function Zne(e){if(!e.length)return"";let t=e.reduce((r,a)=>r>a?r:a),n=e.reduce((r,a)=>r>a?a:r);for(;!t.startsWith(n);)n=n.slice(0,-1);return n}function Qne(e,t){return t&&e.startsWith(t)?"…"+e.slice(t.length):e}var Df,hd,Xne,Jne,aD,ere,S5=b(()=>{"use strict";d();Ln();rD();ca();A();Wa();Df={title:"Reduce unused JavaScript",description:"Reduce unused JavaScript and defer loading scripts until they are required to decrease bytes consumed by network activity. [Learn how to reduce unused JavaScript](https://developer.chrome.com/docs/lighthouse/performance/unused-javascript/)."},hd=w("core/audits/byte-efficiency/unused-javascript.js",Df),Xne=20*1024,Jne=512;s(Zne,"commonPrefix");s(Qne,"trimCommonPrefix");aD=class extends ve{static{s(this,"UnusedJavaScript")}static get meta(){return{id:"unused-javascript",title:hd(Df.title),description:hd(Df.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:2,requiredArtifacts:["JsUsage","Scripts","SourceMaps","GatherContext","devtoolsLogs","traces","URL"]}}static async audit_(t,n,r){let a=await un.request(t,r),{unusedThreshold:o=Xne,bundleSourceUnusedThreshold:i=Jne}=r.options||{},c=new Map,u=[];for(let[l,m]of Object.entries(t.JsUsage)){let p=t.Scripts.find(E=>E.scriptId===l);if(!p)continue;let h=a.find(E=>E.script.scriptId===l),f=await wf.request({scriptId:l,scriptCoverage:m,bundle:h},r);if(f.wastedBytes===0||f.totalBytes===0)continue;let y=vs(c,p.url,t,n),v={url:p.url,totalBytes:Math.round(y*f.totalBytes),wastedBytes:Math.round(y*f.wastedBytes),wastedPercent:f.wastedPercent};if(v.wastedBytes<=o||(u.push(v),!h||"errorMessage"in h.sizes))continue;let D=h.sizes;if(f.sourcesWastedBytes){let E=Object.entries(f.sourcesWastedBytes).sort((k,C)=>C[1]-k[1]).slice(0,5).map(([k,C])=>{let R=k==="(unmapped)"?D.unmappedBytes:D.files[k];return{source:k,unused:Math.round(C*y),total:Math.round(R*y)}}).filter(k=>k.unused>=i),S=Zne(h.map.sourceURLs());v.subItems={type:"subitems",items:E.map(({source:k,unused:C,total:R})=>({source:Qne(k,S),sourceBytes:R,sourceWastedBytes:C}))}}}return{items:u,headings:[{key:"url",valueType:"url",subItemsHeading:{key:"source",valueType:"code"},label:hd(x.columnURL)},{key:"totalBytes",valueType:"bytes",subItemsHeading:{key:"sourceBytes"},label:hd(x.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",subItemsHeading:{key:"sourceWastedBytes"},label:hd(x.columnWastedBytes)}]}}},ere=aD});var C5=I((U3e,k5)=>{d();k5.exports=s(function(t){if(typeof t!="string")return null;var n=/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g,r={},a=t.replace(n,function(i,c,u,l){var m=u||l;return r[c]=m?m.toLowerCase():!0,""});if(r["max-age"])try{var o=parseInt(r["max-age"],10);if(isNaN(o))return null;r["max-age"]=o}catch{}return a?null:r},"parseCacheControl")});var _5={};T(_5,{UIStrings:()=>Ss,default:()=>iD});var A5,Ss,Xo,tre,oD,iD,sD=b(()=>{"use strict";d();A5=Lt(C5(),1);V();lt();Ze();k1();A();de();Ss={title:"Uses efficient cache policy on static assets",failureTitle:"Serve static assets with an efficient cache policy",description:"A long cache lifetime can speed up repeat visits to your page. [Learn more about efficient cache policies](https://developer.chrome.com/docs/lighthouse/performance/uses-long-cache-ttl/).",displayValue:`{itemCount, plural,
    =1 {1 resource found}
    other {# resources found}
    }`},Xo=w("core/audits/byte-efficiency/uses-long-cache-ttl.js",Ss),tre=.925,oD=class e extends g{static{s(this,"CacheHeaders")}static get meta(){return{id:"uses-long-cache-ttl",title:Xo(Ss.title),failureTitle:Xo(Ss.failureTitle),description:Xo(Ss.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:3,requiredArtifacts:["devtoolsLogs"]}}static get defaultOptions(){return{p10:28*1024,median:128*1024}}static getCacheHitProbability(t){let n=[0,.2,1,3,8,12,24,48,72,168,8760,1/0];if(n.length!==12)throw new Error("deciles 0-10 and 1 for overflow");let r=t/3600,a=n.findIndex(l=>l>=r);if(a===n.length-1)return 1;if(a===0)return 0;let o=n[a],i=n[a-1],c=a/10,u=(a-1)/10;return h_(i,u,o,c,r)}static computeCacheLifetimeInSeconds(t,n){if(n&&n["max-age"]!==void 0)return n["max-age"];let r=t.get("expires");if(r){let a=new Date(r).getTime();return a?Math.ceil((a-Date.now())/1e3):0}return null}static isCacheableAsset(t){let n=new Set([200,203,206]),r=new Set([G.TYPES.Font,G.TYPES.Image,G.TYPES.Media,G.TYPES.Script,G.TYPES.Stylesheet]);return G.isNonNetworkRequest(t)?!1:n.has(t.statusCode)&&r.has(t.resourceType||"Other")}static shouldSkipRecord(t,n){return!!(!n&&(t.get("pragma")||"").includes("no-cache")||n&&(n["must-revalidate"]||n["no-cache"]||n["no-store"]||n["stale-while-revalidate"]||n.private))}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await H.request(r,n),o=[],i=0;for(let l of a){if(!e.isCacheableAsset(l))continue;let m=new Map;for(let S of l.responseHeaders||[])if(m.has(S.name.toLowerCase())){let k=m.get(S.name.toLowerCase());m.set(S.name.toLowerCase(),`${k}, ${S.value}`)}else m.set(S.name.toLowerCase(),S.value);let p=(0,A5.default)(m.get("cache-control"));if(this.shouldSkipRecord(m,p))continue;let h=e.computeCacheLifetimeInSeconds(m,p);if(h!==null&&(!Number.isFinite(h)||h<=0))continue;h=h||0;let f=e.getCacheHitProbability(h);if(f>tre)continue;let y=Y.elideDataURI(l.url),v=l.transferSize||0,D=(1-f)*v;i+=D;let E;p&&(E={type:"debugdata",...p}),o.push({url:y,debugData:E,cacheLifetimeMs:h*1e3,cacheHitProbability:f,totalBytes:v,wastedBytes:D})}o.sort((l,m)=>l.cacheLifetimeMs-m.cacheLifetimeMs||m.totalBytes-l.totalBytes||l.url.localeCompare(m.url));let c=[{key:"url",valueType:"url",label:Xo(x.columnURL)},{key:"cacheLifetimeMs",valueType:"ms",label:Xo(x.columnCacheTTL),displayUnit:"duration"},{key:"totalBytes",valueType:"bytes",label:Xo(x.columnTransferSize),displayUnit:"kb",granularity:1}],u=g.makeTableDetails(c,o,{wastedBytes:i,sortedBy:["totalBytes"],skipSumming:["cacheLifetimeMs"]});return{score:o.length?0:1,numericValue:i,numericUnit:"byte",displayValue:Xo(Ss.displayValue,{itemCount:o.length}),details:u}}},iD=oD});var R5={};T(R5,{UIStrings:()=>Ef,default:()=>rre});var Ef,gd,nre,cD,rre,F5=b(()=>{"use strict";d();Ln();Ze();A();Ef={title:"Efficiently encode images",description:"Optimized images load faster and consume less cellular data. [Learn how to efficiently encode images](https://developer.chrome.com/docs/lighthouse/performance/uses-optimized-images/)."},gd=w("core/audits/byte-efficiency/uses-optimized-images.js",Ef),nre=4096,cD=class e extends ve{static{s(this,"UsesOptimizedImages")}static get meta(){return{id:"uses-optimized-images",title:gd(Ef.title),description:gd(Ef.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:2,requiredArtifacts:["OptimizedImages","ImageElements","GatherContext","devtoolsLogs","traces","URL"]}}static computeSavings(t){let n=t.originalSize-t.jpegSize,r=100*n/t.originalSize;return{bytes:n,percent:r}}static estimateJPEGSizeFromDimensions(t){let n=t.naturalWidth*t.naturalHeight,r=2*1/8;return Math.round(n*r)}static audit_(t){let n=t.URL.finalDisplayedUrl,r=t.OptimizedImages,a=t.ImageElements,o=new Map;a.forEach(l=>o.set(l.src,l));let i=[],c=[];for(let l of r){let m=o.get(l.url);if(l.failed){c.push(`Unable to decode ${Y.getURLDisplayName(l.url)}`);continue}else if(/(jpeg|bmp)/.test(l.mimeType)===!1)continue;let p=l.jpegSize,h=!0;if(typeof p>"u"){if(!m){c.push(`Unable to locate resource ${Y.getURLDisplayName(l.url)}`);continue}if(!m.naturalDimensions)continue;let D=m.naturalDimensions.height,E=m.naturalDimensions.width;if(!D||!E)continue;p=e.estimateJPEGSizeFromDimensions({naturalHeight:D,naturalWidth:E}),h=!1}if(l.originalSize<p+nre)continue;let f=Y.elideDataURI(l.url),y=!Y.originsMatch(n,l.url),v=e.computeSavings({...l,jpegSize:p});i.push({node:m?ve.makeNodeItem(m.node):void 0,url:f,fromProtocol:h,isCrossOrigin:y,totalBytes:l.originalSize,wastedBytes:v.bytes})}let u=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:gd(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:gd(x.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:gd(x.columnWastedBytes)}];return{warnings:c,items:i,headings:u}}},rre=cD});var uD,I5,N5=b(()=>{"use strict";d();Ze();ue();uD=class e{static{s(this,"ImageRecords")}static indexNetworkRecords(t){return t.reduce((n,r)=>((/^image/.test(r.mimeType)||/\.(avif|webp)$/i.test(r.url))&&r.finished&&r.statusCode===200&&(n[r.url]=r),n),{})}static async compute_(t){let n=e.indexNetworkRecords(t.networkRecords),r=[];for(let a of t.ImageElements){let i=n[a.src]?.mimeType;r.push({...a,mimeType:i||Y.guessMimeType(a.src)})}return r.sort((a,o)=>{let i=n[a.src]||{};return(n[o.src]||{}).resourceSize-i.resourceSize}),r}},I5=q(uD,["ImageElements","networkRecords"])});var mD={};T(mD,{UIStrings:()=>ks,default:()=>dD,str_:()=>Ya});var ks,Ya,are,ore,lD,dD,pD=b(()=>{"use strict";d();Ln();lt();N5();Ze();A();ks={title:"Properly size images",description:"Serve images that are appropriately-sized to save cellular data and improve load time. [Learn how to size images](https://developer.chrome.com/docs/lighthouse/performance/uses-responsive-images/)."},Ya=w("core/audits/byte-efficiency/uses-responsive-images.js",ks),are=4096,ore=12288,lD=class e extends ve{static{s(this,"UsesResponsiveImages")}static get meta(){return{id:"uses-responsive-images",title:Ya(ks.title),description:Ya(ks.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:2,requiredArtifacts:["ImageElements","ViewportDimensions","GatherContext","devtoolsLogs","traces","URL"]}}static getDisplayedDimensions(t,n){if(t.displayedWidth&&t.displayedHeight)return{width:t.displayedWidth*n.devicePixelRatio,height:t.displayedHeight*n.devicePixelRatio};let r=n.innerWidth,a=n.innerHeight*2,o=t.naturalWidth/t.naturalHeight,i=r/a,c=r,u=a;return o>i?u=r/o:c=a*o,{width:c*n.devicePixelRatio,height:u*n.devicePixelRatio}}static computeWaste(t,n,r){let a=r.find(h=>h.url===t.src);if(!a)return null;let o=this.getDisplayedDimensions(t,n),i=o.width*o.height,c=Y.elideDataURI(t.src),u=t.naturalWidth*t.naturalHeight,l=1-i/u,m=G.getResourceSizeOnNetwork(a),p=Math.round(m*l);return{node:ve.makeNodeItem(t.node),url:c,totalBytes:m,wastedBytes:p,wastedPercent:100*l}}static determineAllowableWaste(t){return t.srcset||t.isPicture?ore:are}static async audit_(t,n,r){let a=await I5.request({ImageElements:t.ImageElements,networkRecords:n},r),o=t.ViewportDimensions,i=new Map,c=[];for(let m of a){if(m.mimeType==="image/svg+xml"||m.isCss||!m.naturalDimensions)continue;let p=m.naturalDimensions.height,h=m.naturalDimensions.width;if(!h||!p)continue;let f=e.computeWaste({...m,naturalHeight:p,naturalWidth:h},o,n);if(!f)continue;let y=f.wastedBytes>this.determineAllowableWaste(m),v=i.get(f.url);y&&!c.includes(f.url)?(!v||v.wastedBytes>f.wastedBytes)&&i.set(f.url,f):(i.delete(f.url),c.push(f.url))}let u=Array.from(i.values()),l=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:Ya(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:Ya(x.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:Ya(x.columnWastedBytes)}];return{items:u,headings:l}}},dD=lD});var M5={};T(M5,{UIStrings:()=>Cs,default:()=>sre});var Cs,yd,ire,fD,sre,L5=b(()=>{"use strict";d();V();pD();Ze();A();Cs={title:"Images were appropriate for their displayed size",failureTitle:"Images were larger than their displayed size",columnDisplayedDimensions:"Displayed dimensions",columnActualDimensions:"Actual dimensions"},yd=w("core/audits/byte-efficiency/uses-responsive-images-snapshot.js",Cs),ire=1365,fD=class extends g{static{s(this,"UsesResponsiveImagesSnapshot")}static get meta(){return{id:"uses-responsive-images-snapshot",title:yd(Cs.title),failureTitle:yd(Cs.failureTitle),description:Ya(ks.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,supportedModes:["snapshot"],guidanceLevel:2,requiredArtifacts:["ImageElements","ViewportDimensions"]}}static async audit(t){let n=1,r=[];for(let i of t.ImageElements){if(i.isCss||!i.naturalDimensions)continue;let c=i.naturalDimensions,u=dD.getDisplayedDimensions({...i,naturalWidth:c.width,naturalHeight:c.height},t.ViewportDimensions),l=c.width*c.height,m=u.width*u.height;l<=m||(l-m>ire&&(n=0),r.push({node:g.makeNodeItem(i.node),url:Y.elideDataURI(i.src),displayedDimensions:`${u.width}x${u.height}`,actualDimensions:`${c.width}x${c.height}`}))}let a=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:yd(x.columnURL)},{key:"displayedDimensions",valueType:"text",label:yd(Cs.columnDisplayedDimensions)},{key:"actualDimensions",valueType:"text",label:yd(Cs.columnActualDimensions)}],o=g.makeTableDetails(a,r);return{score:n,details:o}}},sre=fD});var P5={};T(P5,{UIStrings:()=>xf,default:()=>lre});var xf,bd,cre,ure,hD,lre,O5=b(()=>{"use strict";d();Ln();Ze();A();xf={title:"Enable text compression",description:"Text-based resources should be served with compression (gzip, deflate or brotli) to minimize total network bytes. [Learn more about text compression](https://developer.chrome.com/docs/lighthouse/performance/uses-text-compression/)."},bd=w("core/audits/byte-efficiency/uses-text-compression.js",xf),cre=1400,ure=.1,hD=class extends ve{static{s(this,"ResponsesAreCompressed")}static get meta(){return{id:"uses-text-compression",title:bd(xf.title),description:bd(xf.description),scoreDisplayMode:ve.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:3,requiredArtifacts:["ResponseCompression","GatherContext","devtoolsLogs","traces","URL"]}}static audit_(t){let n=t.ResponseCompression,r=[];n.forEach(o=>{if(!o.gzipSize||o.gzipSize<0)return;let i=o.resourceSize,c=o.gzipSize,u=i-c;if(1-c/i<ure||u<cre||o.transferSize<c)return;let l=Y.elideDataURI(o.url);r.find(p=>p.url===l&&p.totalBytes===o.resourceSize)||r.push({url:l,totalBytes:i,wastedBytes:u})});let a=[{key:"url",valueType:"url",label:bd(x.columnURL)},{key:"totalBytes",valueType:"bytes",label:bd(x.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:bd(x.columnWastedBytes)}];return{items:r,headings:a}}},lre=hD});var B5={};T(B5,{UIStrings:()=>As,default:()=>dre});var As,Tf,gD,dre,U5=b(()=>{"use strict";d();V();A();As={title:"Content is sized correctly for the viewport",failureTitle:"Content is not sized correctly for the viewport",description:"If the width of your app's content doesn't match the width of the viewport, your app might not be optimized for mobile screens. [Learn how to size content for the viewport](https://developer.chrome.com/docs/lighthouse/pwa/content-width/).",explanation:"The viewport size of {innerWidth}px does not match the window size of {outerWidth}px."},Tf=w("core/audits/content-width.js",As),gD=class extends g{static{s(this,"ContentWidth")}static get meta(){return{id:"content-width",title:Tf(As.title),failureTitle:Tf(As.failureTitle),description:Tf(As.description),requiredArtifacts:["ViewportDimensions"]}}static audit(t,n){let r=t.ViewportDimensions.innerWidth,a=t.ViewportDimensions.outerWidth,o=r===a;if(n.settings.formFactor==="desktop")return{score:1,notApplicable:!0};let i;return o||(i=Tf(As.explanation,{innerWidth:t.ViewportDimensions.innerWidth,outerWidth:t.ViewportDimensions.outerWidth})),{score:Number(o),explanation:i}}},dre=gD});var yD,Sf,bD=b(()=>{"use strict";d();ue();lt();Bt();Nn();yD=class e{static{s(this,"CriticalRequestChains")}static isCritical(t,n){if(!n)throw new Error("mainResource not provided");if(t.requestId===n.requestId)return!0;if(t.isLinkPreload)return!1;for(;t.redirectDestination;)t=t.redirectDestination;let r=t.resourceType===G.TYPES.Document&&t.frameId!==n.frameId;return[G.TYPES.Image,G.TYPES.XHR,G.TYPES.Fetch,G.TYPES.EventSource].includes(t.resourceType||"Other")||r||t.mimeType&&t.mimeType.startsWith("image/")||!t.initiatorRequest?!1:["VeryHigh","High","Medium"].includes(t.priority)}static extractChainsFromGraph(t,n){let r={};function a(c){let u=r;for(let l of c)u[l.requestId]||(u[l.requestId]={request:l,children:{}}),u=u[l.requestId].children}s(a,"addChain");let o=new Set;function i(c){return c.getDependents().filter(u=>u.getDependencies().every(l=>o.has(l)))}return s(i,"getNextNodes"),n.traverse((c,u)=>{if(o.add(c),c.type!=="network"||!e.isCritical(c.record,t))return;let l=u.filter(m=>m.type==="network").reverse().map(m=>m.record);l.some(m=>!e.isCritical(m,t))||G.isNonNetworkRequest(c.record)||a(l)},i),r}static async compute_(t,n){let r=await _e.request(t,n),a=await xt.request(t,n);return e.extractChainsFromGraph(r,a)}},Sf=q(yD,["URL","devtoolsLog","trace"])});var j5={};T(j5,{UIStrings:()=>vd,default:()=>mre});var vd,vD,wD,mre,q5=b(()=>{"use strict";d();V();A();bD();vd={title:"Avoid chaining critical requests",description:"The Critical Request Chains below show you what resources are loaded with a high priority. Consider reducing the length of chains, reducing the download size of resources, or deferring the download of unnecessary resources to improve page load. [Learn how to avoid chaining critical requests](https://developer.chrome.com/docs/lighthouse/performance/critical-request-chains/).",displayValue:`{itemCount, plural,
    =1 {1 chain found}
    other {# chains found}
    }`},vD=w("core/audits/critical-request-chains.js",vd),wD=class e extends g{static{s(this,"CriticalRequestChains")}static get meta(){return{id:"critical-request-chains",title:vD(vd.title),description:vD(vd.description),scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],guidanceLevel:1,requiredArtifacts:["traces","devtoolsLogs","URL"]}}static _traverse(t,n){function r(a,o,i,c=0){let u=Object.keys(a);u.length!==0&&u.forEach(l=>{let m=a[l];i||(i=m.request.networkRequestTime),n({depth:o,id:l,node:m,chainDuration:m.request.networkEndTime-i,chainTransferSize:c+m.request.transferSize}),m.children&&r(m.children,o+1,i)},"")}s(r,"walk"),r(t,0)}static _getLongestChain(t){let n={duration:0,length:0,transferSize:0};return e._traverse(t,r=>{let a=r.chainDuration;a>n.duration&&(n.duration=a,n.transferSize=r.chainTransferSize,n.length=r.depth)}),n.length++,n}static flattenRequests(t){let n={},r=new Map;function a(o){let i=o.node.request,c={url:i.url,startTime:i.networkRequestTime/1e3,endTime:i.networkEndTime/1e3,responseReceivedTime:i.responseHeadersEndTime/1e3,transferSize:i.transferSize},u=r.get(o.id);if(u?u.request=c:(u={request:c},n[o.id]=u),o.node.children)for(let l of Object.keys(o.node.children)){let m={request:{}};r.set(l,m),u.children||(u.children={}),u.children[l]=m}r.set(o.id,u)}return s(a,"flatten"),e._traverse(t,a),n}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.URL,i=await Sf.request({devtoolsLog:a,trace:r,URL:o},n),c=0;function u(f,y){Object.keys(f).forEach(D=>{let E=f[D];E.children?u(E.children,y+1):c++},"")}s(u,"walk");let l=e.flattenRequests(i),m=Object.keys(l)[0],p=m&&l[m].children;p&&Object.keys(p).length>0&&u(p,0);let h=e._getLongestChain(i);return{score:+(c===0),notApplicable:c===0,displayValue:c?vD(vd.displayValue,{itemCount:c}):"",details:{type:"criticalrequestchain",chains:l,longestChain:h}}}},mre=wD});var _s=I(Nr=>{"use strict";d();Object.defineProperty(Nr,"__esModule",{value:!0});Nr.Type=Nr.Severity=Nr.Finding=void 0;var DD=class e{static{s(this,"Finding")}constructor(t,n,r,a,o){this.type=t,this.description=n,this.severity=r,this.directive=a,this.value=o}static getHighestSeverity(t){if(t.length===0)return ED.NONE;let n=t.map(a=>a.severity),r=s((a,o)=>a<o?a:o,"min");return n.reduce(r,ED.NONE)}equals(t){return t instanceof e?t.type===this.type&&t.description===this.description&&t.severity===this.severity&&t.directive===this.directive&&t.value===this.value:!1}};Nr.Finding=DD;var ED;(function(e){e[e.HIGH=10]="HIGH",e[e.SYNTAX=20]="SYNTAX",e[e.MEDIUM=30]="MEDIUM",e[e.HIGH_MAYBE=40]="HIGH_MAYBE",e[e.STRICT_CSP=45]="STRICT_CSP",e[e.MEDIUM_MAYBE=50]="MEDIUM_MAYBE",e[e.INFO=60]="INFO",e[e.NONE=100]="NONE"})(ED=Nr.Severity||(Nr.Severity={}));var pre;(function(e){e[e.MISSING_SEMICOLON=100]="MISSING_SEMICOLON",e[e.UNKNOWN_DIRECTIVE=101]="UNKNOWN_DIRECTIVE",e[e.INVALID_KEYWORD=102]="INVALID_KEYWORD",e[e.NONCE_CHARSET=106]="NONCE_CHARSET",e[e.MISSING_DIRECTIVES=300]="MISSING_DIRECTIVES",e[e.SCRIPT_UNSAFE_INLINE=301]="SCRIPT_UNSAFE_INLINE",e[e.SCRIPT_UNSAFE_EVAL=302]="SCRIPT_UNSAFE_EVAL",e[e.PLAIN_URL_SCHEMES=303]="PLAIN_URL_SCHEMES",e[e.PLAIN_WILDCARD=304]="PLAIN_WILDCARD",e[e.SCRIPT_ALLOWLIST_BYPASS=305]="SCRIPT_ALLOWLIST_BYPASS",e[e.OBJECT_ALLOWLIST_BYPASS=306]="OBJECT_ALLOWLIST_BYPASS",e[e.NONCE_LENGTH=307]="NONCE_LENGTH",e[e.IP_SOURCE=308]="IP_SOURCE",e[e.DEPRECATED_DIRECTIVE=309]="DEPRECATED_DIRECTIVE",e[e.SRC_HTTP=310]="SRC_HTTP",e[e.STRICT_DYNAMIC=400]="STRICT_DYNAMIC",e[e.STRICT_DYNAMIC_NOT_STANDALONE=401]="STRICT_DYNAMIC_NOT_STANDALONE",e[e.NONCE_HASH=402]="NONCE_HASH",e[e.UNSAFE_INLINE_FALLBACK=403]="UNSAFE_INLINE_FALLBACK",e[e.ALLOWLIST_FALLBACK=404]="ALLOWLIST_FALLBACK",e[e.IGNORED=405]="IGNORED",e[e.REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS=500]="REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS",e[e.REPORTING_DESTINATION_MISSING=600]="REPORTING_DESTINATION_MISSING",e[e.REPORT_TO_ONLY=601]="REPORT_TO_ONLY"})(pre=Nr.Type||(Nr.Type={}))});var Mr=I(xe=>{"use strict";d();Object.defineProperty(xe,"__esModule",{value:!0});xe.CspError=xe.isHash=xe.HASH_PATTERN=xe.STRICT_HASH_PATTERN=xe.isNonce=xe.NONCE_PATTERN=xe.STRICT_NONCE_PATTERN=xe.isUrlScheme=xe.isKeyword=xe.isDirective=xe.Version=xe.FETCH_DIRECTIVES=xe.Directive=xe.TrustedTypesSink=xe.Keyword=xe.Csp=void 0;var Rs=_s(),xD=class e{static{s(this,"Csp")}constructor(){this.directives={}}clone(){let t=new e;for(let[n,r]of Object.entries(this.directives))r&&(t.directives[n]=[...r]);return t}convertToString(){let t="";for(let[n,r]of Object.entries(this.directives)){if(t+=n,r!==void 0)for(let a,o=0;a=r[o];o++)t+=" ",t+=a;t+="; "}return t}getEffectiveCsp(t,n){let r=n||[],a=this.clone(),o=a.getEffectiveDirective(it.SCRIPT_SRC),i=this.directives[o]||[],c=a.directives[o];if(c&&(a.policyHasScriptNonces()||a.policyHasScriptHashes()))if(t>=Cf.CSP2)i.includes(la.UNSAFE_INLINE)&&(kf(c,la.UNSAFE_INLINE),r.push(new Rs.Finding(Rs.Type.IGNORED,"unsafe-inline is ignored if a nonce or a hash is present. (CSP2 and above)",Rs.Severity.NONE,o,la.UNSAFE_INLINE)));else for(let u of i)(u.startsWith("'nonce-")||u.startsWith("'sha"))&&kf(c,u);if(c&&this.policyHasStrictDynamic())if(t>=Cf.CSP3)for(let u of i)(!u.startsWith("'")||u===la.SELF||u===la.UNSAFE_INLINE)&&(kf(c,u),r.push(new Rs.Finding(Rs.Type.IGNORED,"Because of strict-dynamic this entry is ignored in CSP3 and above",Rs.Severity.NONE,o,u)));else kf(c,la.STRICT_DYNAMIC);return t<Cf.CSP3&&(delete a.directives[it.REPORT_TO],delete a.directives[it.WORKER_SRC],delete a.directives[it.MANIFEST_SRC],delete a.directives[it.TRUSTED_TYPES],delete a.directives[it.REQUIRE_TRUSTED_TYPES_FOR]),a}getEffectiveDirective(t){return!(t in this.directives)&&xe.FETCH_DIRECTIVES.includes(t)?it.DEFAULT_SRC:t}getEffectiveDirectives(t){return[...new Set(t.map(r=>this.getEffectiveDirective(r)))]}policyHasScriptNonces(){let t=this.getEffectiveDirective(it.SCRIPT_SRC);return(this.directives[t]||[]).some(r=>z5(r))}policyHasScriptHashes(){let t=this.getEffectiveDirective(it.SCRIPT_SRC);return(this.directives[t]||[]).some(r=>H5(r))}policyHasStrictDynamic(){let t=this.getEffectiveDirective(it.SCRIPT_SRC);return(this.directives[t]||[]).includes(la.STRICT_DYNAMIC)}};xe.Csp=xD;var la;(function(e){e.SELF="'self'",e.NONE="'none'",e.UNSAFE_INLINE="'unsafe-inline'",e.UNSAFE_EVAL="'unsafe-eval'",e.WASM_EVAL="'wasm-eval'",e.WASM_UNSAFE_EVAL="'wasm-unsafe-eval'",e.STRICT_DYNAMIC="'strict-dynamic'",e.UNSAFE_HASHED_ATTRIBUTES="'unsafe-hashed-attributes'",e.UNSAFE_HASHES="'unsafe-hashes'",e.REPORT_SAMPLE="'report-sample'",e.BLOCK="'block'",e.ALLOW="'allow'"})(la=xe.Keyword||(xe.Keyword={}));var fre;(function(e){e.SCRIPT="'script'"})(fre=xe.TrustedTypesSink||(xe.TrustedTypesSink={}));var it;(function(e){e.CHILD_SRC="child-src",e.CONNECT_SRC="connect-src",e.DEFAULT_SRC="default-src",e.FONT_SRC="font-src",e.FRAME_SRC="frame-src",e.IMG_SRC="img-src",e.MEDIA_SRC="media-src",e.OBJECT_SRC="object-src",e.SCRIPT_SRC="script-src",e.SCRIPT_SRC_ATTR="script-src-attr",e.SCRIPT_SRC_ELEM="script-src-elem",e.STYLE_SRC="style-src",e.STYLE_SRC_ATTR="style-src-attr",e.STYLE_SRC_ELEM="style-src-elem",e.PREFETCH_SRC="prefetch-src",e.MANIFEST_SRC="manifest-src",e.WORKER_SRC="worker-src",e.BASE_URI="base-uri",e.PLUGIN_TYPES="plugin-types",e.SANDBOX="sandbox",e.DISOWN_OPENER="disown-opener",e.FORM_ACTION="form-action",e.FRAME_ANCESTORS="frame-ancestors",e.NAVIGATE_TO="navigate-to",e.REPORT_TO="report-to",e.REPORT_URI="report-uri",e.BLOCK_ALL_MIXED_CONTENT="block-all-mixed-content",e.UPGRADE_INSECURE_REQUESTS="upgrade-insecure-requests",e.REFLECTED_XSS="reflected-xss",e.REFERRER="referrer",e.REQUIRE_SRI_FOR="require-sri-for",e.TRUSTED_TYPES="trusted-types",e.REQUIRE_TRUSTED_TYPES_FOR="require-trusted-types-for",e.WEBRTC="webrtc"})(it=xe.Directive||(xe.Directive={}));xe.FETCH_DIRECTIVES=[it.CHILD_SRC,it.CONNECT_SRC,it.DEFAULT_SRC,it.FONT_SRC,it.FRAME_SRC,it.IMG_SRC,it.MANIFEST_SRC,it.MEDIA_SRC,it.OBJECT_SRC,it.SCRIPT_SRC,it.SCRIPT_SRC_ATTR,it.SCRIPT_SRC_ELEM,it.STYLE_SRC,it.STYLE_SRC_ATTR,it.STYLE_SRC_ELEM,it.WORKER_SRC];var Cf;(function(e){e[e.CSP1=1]="CSP1",e[e.CSP2=2]="CSP2",e[e.CSP3=3]="CSP3"})(Cf=xe.Version||(xe.Version={}));function hre(e){return Object.values(it).includes(e)}s(hre,"isDirective");xe.isDirective=hre;function gre(e){return Object.values(la).includes(e)}s(gre,"isKeyword");xe.isKeyword=gre;function yre(e){return new RegExp("^[a-zA-Z][+a-zA-Z0-9.-]*:$").test(e)}s(yre,"isUrlScheme");xe.isUrlScheme=yre;xe.STRICT_NONCE_PATTERN=new RegExp("^'nonce-[a-zA-Z0-9+/_-]+[=]{0,2}'$");xe.NONCE_PATTERN=new RegExp("^'nonce-(.+)'$");function z5(e,t){return(t?xe.STRICT_NONCE_PATTERN:xe.NONCE_PATTERN).test(e)}s(z5,"isNonce");xe.isNonce=z5;xe.STRICT_HASH_PATTERN=new RegExp("^'(sha256|sha384|sha512)-[a-zA-Z0-9+/]+[=]{0,2}'$");xe.HASH_PATTERN=new RegExp("^'(sha256|sha384|sha512)-(.+)'$");function H5(e,t){return(t?xe.STRICT_HASH_PATTERN:xe.HASH_PATTERN).test(e)}s(H5,"isHash");xe.isHash=H5;var TD=class extends Error{static{s(this,"CspError")}constructor(t){super(t)}};xe.CspError=TD;function kf(e,t){if(e.includes(t)){let n=e.findIndex(r=>t===r);e.splice(n,1)}}s(kf,"arrayRemove")});var G5=I(_n=>{"use strict";d();var bre=_n&&_n.__createBinding||(Object.create?function(e,t,n,r){r===void 0&&(r=n),Object.defineProperty(e,r,{enumerable:!0,get:function(){return t[n]}})}:function(e,t,n,r){r===void 0&&(r=n),e[r]=t[n]}),vre=_n&&_n.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),wre=_n&&_n.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(e!=null)for(var n in e)n!=="default"&&Object.prototype.hasOwnProperty.call(e,n)&&bre(t,e,n);return vre(t,e),t};Object.defineProperty(_n,"__esModule",{value:!0});_n.checkInvalidKeyword=_n.checkMissingSemicolon=_n.checkUnknownDirective=void 0;var Ka=wre(Mr()),Dre=Mr(),wn=_s();function Ere(e){let t=[];for(let n of Object.keys(e.directives))Ka.isDirective(n)||(n.endsWith(":")?t.push(new wn.Finding(wn.Type.UNKNOWN_DIRECTIVE,"CSP directives don't end with a colon.",wn.Severity.SYNTAX,n)):t.push(new wn.Finding(wn.Type.UNKNOWN_DIRECTIVE,'Directive "'+n+'" is not a known CSP directive.',wn.Severity.SYNTAX,n)));return t}s(Ere,"checkUnknownDirective");_n.checkUnknownDirective=Ere;function xre(e){let t=[];for(let[n,r]of Object.entries(e.directives))if(r!==void 0)for(let a of r)Ka.isDirective(a)&&t.push(new wn.Finding(wn.Type.MISSING_SEMICOLON,'Did you forget the semicolon? "'+a+'" seems to be a directive, not a value.',wn.Severity.SYNTAX,n,a));return t}s(xre,"checkMissingSemicolon");_n.checkMissingSemicolon=xre;function Tre(e){let t=[],n=Object.values(Dre.Keyword).map(r=>r.replace(/'/g,""));for(let[r,a]of Object.entries(e.directives))if(a!==void 0)for(let o of a){if(n.some(i=>i===o)||o.startsWith("nonce-")||o.match(/^(sha256|sha384|sha512)-/)){t.push(new wn.Finding(wn.Type.INVALID_KEYWORD,'Did you forget to surround "'+o+'" with single-ticks?',wn.Severity.SYNTAX,r,o));continue}if(o.startsWith("'")){if(r===Ka.Directive.REQUIRE_TRUSTED_TYPES_FOR){if(o===Ka.TrustedTypesSink.SCRIPT)continue}else if(r===Ka.Directive.TRUSTED_TYPES){if(o==="'allow-duplicates'"||o==="'none'")continue}else if(Ka.isKeyword(o)||Ka.isHash(o)||Ka.isNonce(o))continue;t.push(new wn.Finding(wn.Type.INVALID_KEYWORD,o+" seems to be an invalid CSP keyword.",wn.Severity.SYNTAX,r,o))}}return t}s(Tre,"checkInvalidKeyword");_n.checkInvalidKeyword=Tre});var V5=I(Af=>{"use strict";d();Object.defineProperty(Af,"__esModule",{value:!0});Af.URLS=void 0;Af.URLS=["//gstatic.com/fsn/angular_js-bundle1.js","//www.gstatic.com/fsn/angular_js-bundle1.js","//www.googleadservices.com/pageadimg/imgad","//yandex.st/angularjs/1.2.16/angular-cookies.min.js","//yastatic.net/angularjs/1.2.23/angular.min.js","//yuedust.yuedu.126.net/js/components/angular/angular.js","//art.jobs.netease.com/script/angular.js","//csu-c45.kxcdn.com/angular/angular.js","//elysiumwebsite.s3.amazonaws.com/uploads/blog-media/rockstar/angular.min.js","//inno.blob.core.windows.net/new/libs/AngularJS/1.2.1/angular.min.js","//gift-talk.kakao.com/public/javascripts/angular.min.js","//ajax.googleapis.com/ajax/libs/angularjs/1.2.0rc1/angular-route.min.js","//master-sumok.ru/vendors/angular/angular-cookies.js","//ayicommon-a.akamaihd.net/static/vendor/angular-1.4.2.min.js","//pangxiehaitao.com/framework/angular-1.3.9/angular-animate.min.js","//cdnjs.cloudflare.com/ajax/libs/angular.js/1.2.16/angular.min.js","//96fe3ee995e96e922b6b-d10c35bd0a0de2c718b252bc575fdb73.ssl.cf1.rackcdn.com/angular.js","//oss.maxcdn.com/angularjs/1.2.20/angular.min.js","//reports.zemanta.com/smedia/common/angularjs/1.2.11/angular.js","//cdn.shopify.com/s/files/1/0225/6463/t/1/assets/angular-animate.min.js","//parademanagement.com.s3-website-ap-southeast-1.amazonaws.com/js/angular.min.js","//cdn.jsdelivr.net/angularjs/1.1.2/angular.min.js","//eb2883ede55c53e09fd5-9c145fb03d93709ea57875d307e2d82e.ssl.cf3.rackcdn.com/components/angular-resource.min.js","//andors-trail.googlecode.com/git/AndorsTrailEdit/lib/angular.min.js","//cdn.walkme.com/General/EnvironmentTests/angular/angular.min.js","//laundrymail.com/angular/angular.js","//s3-eu-west-1.amazonaws.com/staticancpa/js/angular-cookies.min.js","//collade.demo.stswp.com/js/vendor/angular.min.js","//mrfishie.github.io/sailor/bower_components/angular/angular.min.js","//askgithub.com/static/js/angular.min.js","//services.amazon.com/solution-providers/assets/vendor/angular-cookies.min.js","//raw.githubusercontent.com/angular/code.angularjs.org/master/1.0.7/angular-resource.js","//prb-resume.appspot.com/bower_components/angular-animate/angular-animate.js","//dl.dropboxusercontent.com/u/30877786/angular.min.js","//static.tumblr.com/x5qdx0r/nPOnngtff/angular-resource.min_1_.js","//storage.googleapis.com/assets-prod.urbansitter.net/us-sym/assets/vendor/angular-sanitize/angular-sanitize.min.js","//twitter.github.io/labella.js/bower_components/angular/angular.min.js","//cdn2-casinoroom.global.ssl.fastly.net/js/lib/angular-animate.min.js","//www.adobe.com/devnet-apps/flashshowcase/lib/angular/angular.1.1.5.min.js","//eternal-sunset.herokuapp.com/bower_components/angular/angular.js","//cdn.bootcss.com/angular.js/1.2.0/angular.min.js"]});var W5=I(_f=>{"use strict";d();Object.defineProperty(_f,"__esModule",{value:!0});_f.URLS=void 0;_f.URLS=["//vk.com/swf/video.swf","//ajax.googleapis.com/ajax/libs/yui/2.8.0r4/build/charts/assets/charts.swf"]});var $5=I(Fs=>{"use strict";d();Object.defineProperty(Fs,"__esModule",{value:!0});Fs.URLS=Fs.NEEDS_EVAL=void 0;Fs.NEEDS_EVAL=["googletagmanager.com","www.googletagmanager.com","www.googleadservices.com","google-analytics.com","ssl.google-analytics.com","www.google-analytics.com"];Fs.URLS=["//bebezoo.1688.com/fragment/index.htm","//www.google-analytics.com/gtm/js","//googleads.g.doubleclick.net/pagead/conversion/1036918760/wcm","//www.googleadservices.com/pagead/conversion/1070110417/wcm","//www.google.com/tools/feedback/escalation-options","//pin.aliyun.com/check_audio","//offer.alibaba.com/market/CID100002954/5/fetchKeyword.do","//ccrprod.alipay.com/ccr/arriveTime.json","//group.aliexpress.com/ajaxAcquireGroupbuyProduct.do","//detector.alicdn.com/2.7.3/index.php","//suggest.taobao.com/sug","//translate.google.com/translate_a/l","//count.tbcdn.cn//counter3","//wb.amap.com/channel.php","//translate.googleapis.com/translate_a/l","//afpeng.alimama.com/ex","//accounts.google.com/o/oauth2/revoke","//pagead2.googlesyndication.com/relatedsearch","//yandex.ru/soft/browsers/check","//api.facebook.com/restserver.php","//mts0.googleapis.com/maps/vt","//syndication.twitter.com/widgets/timelines/765840589183213568","//www.youtube.com/profile_style","//googletagmanager.com/gtm/js","//mc.yandex.ru/watch/24306916/1","//share.yandex.net/counter/gpp/","//ok.go.mail.ru/lady_on_lady_recipes_r.json","//d1f69o4buvlrj5.cloudfront.net/__efa_15_1_ornpba.xekq.arg/optout_check","//www.googletagmanager.com/gtm/js","//api.vk.com/method/wall.get","//www.sharethis.com/get-publisher-info.php","//google.ru/maps/vt","//pro.netrox.sc/oapi/h_checksite.ashx","//vimeo.com/api/oembed.json/","//de.blog.newrelic.com/wp-admin/admin-ajax.php","//ajax.googleapis.com/ajax/services/search/news","//ssl.google-analytics.com/gtm/js","//pubsub.pubnub.com/subscribe/demo/hello_world/","//pass.yandex.ua/services","//id.rambler.ru/script/topline_info.js","//m.addthis.com/live/red_lojson/100eng.json","//passport.ngs.ru/ajax/check","//catalog.api.2gis.ru/ads/search","//gum.criteo.com/sync","//maps.google.com/maps/vt","//ynuf.alipay.com/service/um.json","//securepubads.g.doubleclick.net/gampad/ads","//c.tiles.mapbox.com/v3/texastribune.tx-congress-cvap/6/15/26.grid.json","//rexchange.begun.ru/banners","//an.yandex.ru/page/147484","//links.services.disqus.com/api/ping","//api.map.baidu.com/","//tj.gongchang.com/api/keywordrecomm/","//data.gongchang.com/livegrail/","//ulogin.ru/token.php","//beta.gismeteo.ru/api/informer/layout.js/120x240-3/ru/","//maps.googleapis.com/maps/api/js/GeoPhotoService.GetMetadata","//a.config.skype.com/config/v1/Skype/908_1.33.0.111/SkypePersonalization","//maps.beeline.ru/w","//target.ukr.net/","//www.meteoprog.ua/data/weather/informer/Poltava.js","//cdn.syndication.twimg.com/widgets/timelines/599200054310604802","//wslocker.ru/client/user.chk.php","//community.adobe.com/CommunityPod/getJSON","//maps.google.lv/maps/vt","//dev.virtualearth.net/REST/V1/Imagery/Metadata/AerialWithLabels/26.318581","//awaps.yandex.ru/10/8938/02400400.","//a248.e.akamai.net/h5.hulu.com/h5.mp4","//nominatim.openstreetmap.org/","//plugins.mozilla.org/en-us/plugins_list.json","//h.cackle.me/widget/32153/bootstrap","//graph.facebook.com/1/","//fellowes.ugc.bazaarvoice.com/data/reviews.json","//widgets.pinterest.com/v3/pidgets/boards/ciciwin/hedgehog-squirrel-crafts/pins/","//www.linkedin.com/countserv/count/share","//se.wikipedia.org/w/api.php","//cse.google.com/api/007627024705277327428/cse/r3vs7b0fcli/queries/js","//relap.io/api/v2/similar_pages_jsonp.js","//c1n3.hypercomments.com/stream/subscribe","//maps.google.de/maps/vt","//books.google.com/books","//connect.mail.ru/share_count","//tr.indeed.com/m/newjobs","//www-onepick-opensocial.googleusercontent.com/gadgets/proxy","//www.panoramio.com/map/get_panoramas.php","//client.siteheart.com/streamcli/client","//www.facebook.com/restserver.php","//autocomplete.travelpayouts.com/avia","//www.googleapis.com/freebase/v1/topic/m/0344_","//mts1.googleapis.com/mapslt/ft","//api.twitter.com/1/statuses/oembed.json","//fast.wistia.com/embed/medias/o75jtw7654.json","//partner.googleadservices.com/gampad/ads","//pass.yandex.ru/services","//gupiao.baidu.com/stocks/stockbets","//widget.admitad.com/widget/init","//api.instagram.com/v1/tags/partykungen23328/media/recent","//video.media.yql.yahoo.com/v1/video/sapi/streams/063fb76c-6c70-38c5-9bbc-04b7c384de2b","//ib.adnxs.com/jpt","//pass.yandex.com/services","//www.google.de/maps/vt","//clients1.google.com/complete/search","//api.userlike.com/api/chat/slot/proactive/","//www.youku.com/index_cookielist/s/jsonp","//mt1.googleapis.com/mapslt/ft","//api.mixpanel.com/track/","//wpd.b.qq.com/cgi/get_sign.php","//pipes.yahooapis.com/pipes/pipe.run","//gdata.youtube.com/feeds/api/videos/WsJIHN1kNWc","//9.chart.apis.google.com/chart","//cdn.syndication.twitter.com/moments/709229296800440320","//api.flickr.com/services/feeds/photos_friends.gne","//cbks0.googleapis.com/cbk","//www.blogger.com/feeds/5578653387562324002/posts/summary/4427562025302749269","//query.yahooapis.com/v1/public/yql","//kecngantang.blogspot.com/feeds/posts/default/-/Komik","//www.travelpayouts.com/widgets/50f53ce9ada1b54bcc000031.json","//i.cackle.me/widget/32586/bootstrap","//translate.yandex.net/api/v1.5/tr.json/detect","//a.tiles.mapbox.com/v3/zentralmedia.map-n2raeauc.jsonp","//maps.google.ru/maps/vt","//c1n2.hypercomments.com/stream/subscribe","//rec.ydf.yandex.ru/cookie","//cdn.jsdelivr.net"]});var K5=I(Lr=>{"use strict";d();Object.defineProperty(Lr,"__esModule",{value:!0});Lr.applyCheckFunktionToDirectives=Lr.matchWildcardUrls=Lr.getHostname=Lr.getSchemeFreeUrl=void 0;function SD(e){return e=e.replace(/^\w[+\w.-]*:\/\//i,""),e=e.replace(/^\/\//,""),e}s(SD,"getSchemeFreeUrl");Lr.getSchemeFreeUrl=SD;function Sre(e){let t=new URL("https://"+SD(e).replace(":*","").replace("*","wildcard_placeholder")).hostname.replace("wildcard_placeholder","*"),n=/^\[[\d:]+\]/;return SD(e).match(n)&&!t.match(n)?"["+t+"]":t}s(Sre,"getHostname");Lr.getHostname=Sre;function Y5(e){return e.startsWith("//")?e.replace("//","https://"):e}s(Y5,"setScheme");function kre(e,t){let n=new URL(Y5(e.replace(":*","").replace("*","wildcard_placeholder"))),r=t.map(l=>new URL(Y5(l))),a=n.hostname.toLowerCase(),o=a.startsWith("wildcard_placeholder."),i=a.replace(/^\wildcard_placeholder/i,""),c=n.pathname,u=c!=="/";for(let l of r){let m=l.hostname;if(m.endsWith(i)&&!(!o&&a!==m)){if(u){if(c.endsWith("/")){if(!l.pathname.startsWith(c))continue}else if(l.pathname!==c)continue}return l}}return null}s(kre,"matchWildcardUrls");Lr.matchWildcardUrls=kre;function Cre(e,t){let n=Object.keys(e.directives);for(let r of n){let a=e.directives[r];a&&t(r,a)}}s(Cre,"applyCheckFunktionToDirectives");Lr.applyCheckFunktionToDirectives=Cre});var rO=I(fe=>{"use strict";d();var Are=fe&&fe.__createBinding||(Object.create?function(e,t,n,r){r===void 0&&(r=n),Object.defineProperty(e,r,{enumerable:!0,get:function(){return t[n]}})}:function(e,t,n,r){r===void 0&&(r=n),e[r]=t[n]}),_re=fe&&fe.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),wd=fe&&fe.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(e!=null)for(var n in e)n!=="default"&&Object.prototype.hasOwnProperty.call(e,n)&&Are(t,e,n);return _re(t,e),t};Object.defineProperty(fe,"__esModule",{value:!0});fe.checkHasConfiguredReporting=fe.checkSrcHttp=fe.checkNonceLength=fe.checkDeprecatedDirective=fe.checkIpSource=fe.looksLikeIpAddress=fe.checkFlashObjectAllowlistBypass=fe.checkScriptAllowlistBypass=fe.checkMissingDirectives=fe.checkMultipleMissingBaseUriDirective=fe.checkMissingBaseUriDirective=fe.checkMissingScriptSrcDirective=fe.checkMissingObjectSrcDirective=fe.checkWildcards=fe.checkPlainUrlSchemes=fe.checkScriptUnsafeEval=fe.checkScriptUnsafeInline=fe.URL_SCHEMES_CAUSING_XSS=fe.DIRECTIVES_CAUSING_XSS=void 0;var Rre=wd(V5()),Fre=wd(W5()),X5=wd($5()),J5=wd(Mr()),Oe=Mr(),Q=_s(),Pr=wd(K5());fe.DIRECTIVES_CAUSING_XSS=[Oe.Directive.SCRIPT_SRC,Oe.Directive.OBJECT_SRC,Oe.Directive.BASE_URI];fe.URL_SCHEMES_CAUSING_XSS=["data:","http:","https:"];function Ire(e){let t=e.getEffectiveDirective(Oe.Directive.SCRIPT_SRC);return(e.directives[t]||[]).includes(Oe.Keyword.UNSAFE_INLINE)?[new Q.Finding(Q.Type.SCRIPT_UNSAFE_INLINE,"'unsafe-inline' allows the execution of unsafe in-page scripts and event handlers.",Q.Severity.HIGH,t,Oe.Keyword.UNSAFE_INLINE)]:[]}s(Ire,"checkScriptUnsafeInline");fe.checkScriptUnsafeInline=Ire;function Nre(e){let t=e.getEffectiveDirective(Oe.Directive.SCRIPT_SRC);return(e.directives[t]||[]).includes(Oe.Keyword.UNSAFE_EVAL)?[new Q.Finding(Q.Type.SCRIPT_UNSAFE_EVAL,"'unsafe-eval' allows the execution of code injected into DOM APIs such as eval().",Q.Severity.MEDIUM_MAYBE,t,Oe.Keyword.UNSAFE_EVAL)]:[]}s(Nre,"checkScriptUnsafeEval");fe.checkScriptUnsafeEval=Nre;function Mre(e){let t=[],n=e.getEffectiveDirectives(fe.DIRECTIVES_CAUSING_XSS);for(let r of n){let a=e.directives[r]||[];for(let o of a)fe.URL_SCHEMES_CAUSING_XSS.includes(o)&&t.push(new Q.Finding(Q.Type.PLAIN_URL_SCHEMES,o+" URI in "+r+" allows the execution of unsafe scripts.",Q.Severity.HIGH,r,o))}return t}s(Mre,"checkPlainUrlSchemes");fe.checkPlainUrlSchemes=Mre;function Lre(e){let t=[],n=e.getEffectiveDirectives(fe.DIRECTIVES_CAUSING_XSS);for(let r of n){let a=e.directives[r]||[];for(let o of a)if(Pr.getSchemeFreeUrl(o)==="*"){t.push(new Q.Finding(Q.Type.PLAIN_WILDCARD,r+" should not allow '*' as source",Q.Severity.HIGH,r,o));continue}}return t}s(Lre,"checkWildcards");fe.checkWildcards=Lre;function Z5(e){let t=[];return Oe.Directive.OBJECT_SRC in e.directives?t=e.directives[Oe.Directive.OBJECT_SRC]:Oe.Directive.DEFAULT_SRC in e.directives&&(t=e.directives[Oe.Directive.DEFAULT_SRC]),t!==void 0&&t.length>=1?[]:[new Q.Finding(Q.Type.MISSING_DIRECTIVES,"Missing object-src allows the injection of plugins which can execute JavaScript. Can you set it to 'none'?",Q.Severity.HIGH,Oe.Directive.OBJECT_SRC)]}s(Z5,"checkMissingObjectSrcDirective");fe.checkMissingObjectSrcDirective=Z5;function Q5(e){return Oe.Directive.SCRIPT_SRC in e.directives||Oe.Directive.DEFAULT_SRC in e.directives?[]:[new Q.Finding(Q.Type.MISSING_DIRECTIVES,"script-src directive is missing.",Q.Severity.HIGH,Oe.Directive.SCRIPT_SRC)]}s(Q5,"checkMissingScriptSrcDirective");fe.checkMissingScriptSrcDirective=Q5;function eO(e){return tO([e])}s(eO,"checkMissingBaseUriDirective");fe.checkMissingBaseUriDirective=eO;function tO(e){let t=s(r=>r.policyHasScriptNonces()||r.policyHasScriptHashes()&&r.policyHasStrictDynamic(),"needsBaseUri"),n=s(r=>Oe.Directive.BASE_URI in r.directives,"hasBaseUri");if(e.some(t)&&!e.some(n)){let r="Missing base-uri allows the injection of base tags. They can be used to set the base URL for all relative (script) URLs to an attacker controlled domain. Can you set it to 'none' or 'self'?";return[new Q.Finding(Q.Type.MISSING_DIRECTIVES,r,Q.Severity.HIGH,Oe.Directive.BASE_URI)]}return[]}s(tO,"checkMultipleMissingBaseUriDirective");fe.checkMultipleMissingBaseUriDirective=tO;function Pre(e){return[...Z5(e),...Q5(e),...eO(e)]}s(Pre,"checkMissingDirectives");fe.checkMissingDirectives=Pre;function Ore(e){let t=[],n=e.getEffectiveDirective(Oe.Directive.SCRIPT_SRC),r=e.directives[n]||[];if(r.includes(Oe.Keyword.NONE))return t;for(let a of r){if(a===Oe.Keyword.SELF){t.push(new Q.Finding(Q.Type.SCRIPT_ALLOWLIST_BYPASS,"'self' can be problematic if you host JSONP, AngularJS or user uploaded files.",Q.Severity.MEDIUM_MAYBE,n,a));continue}if(a.startsWith("'")||J5.isUrlScheme(a)||a.indexOf(".")===-1)continue;let o="//"+Pr.getSchemeFreeUrl(a),i=Pr.matchWildcardUrls(o,Rre.URLS),c=Pr.matchWildcardUrls(o,X5.URLS);if(c){let u=X5.NEEDS_EVAL.includes(c.hostname),l=r.includes(Oe.Keyword.UNSAFE_EVAL);u&&!l&&(c=null)}if(c||i){let u="",l="";c&&(u=c.hostname,l=" JSONP endpoints"),i&&(u=i.hostname,l+=l.trim()===""?"":" and",l+=" Angular libraries"),t.push(new Q.Finding(Q.Type.SCRIPT_ALLOWLIST_BYPASS,u+" is known to host"+l+" which allow to bypass this CSP.",Q.Severity.HIGH,n,a))}else t.push(new Q.Finding(Q.Type.SCRIPT_ALLOWLIST_BYPASS,"No bypass found; make sure that this URL doesn't serve JSONP replies or Angular libraries.",Q.Severity.MEDIUM_MAYBE,n,a))}return t}s(Ore,"checkScriptAllowlistBypass");fe.checkScriptAllowlistBypass=Ore;function Bre(e){let t=[],n=e.getEffectiveDirective(Oe.Directive.OBJECT_SRC),r=e.directives[n]||[],a=e.directives[Oe.Directive.PLUGIN_TYPES];if(a&&!a.includes("application/x-shockwave-flash"))return[];for(let o of r){if(o===Oe.Keyword.NONE)return[];let i="//"+Pr.getSchemeFreeUrl(o),c=Pr.matchWildcardUrls(i,Fre.URLS);c?t.push(new Q.Finding(Q.Type.OBJECT_ALLOWLIST_BYPASS,c.hostname+" is known to host Flash files which allow to bypass this CSP.",Q.Severity.HIGH,n,o)):n===Oe.Directive.OBJECT_SRC&&t.push(new Q.Finding(Q.Type.OBJECT_ALLOWLIST_BYPASS,"Can you restrict object-src to 'none' only?",Q.Severity.MEDIUM_MAYBE,n,o))}return t}s(Bre,"checkFlashObjectAllowlistBypass");fe.checkFlashObjectAllowlistBypass=Bre;function nO(e){return!!(e.startsWith("[")&&e.endsWith("]")||/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/.test(e))}s(nO,"looksLikeIpAddress");fe.looksLikeIpAddress=nO;function Ure(e){let t=[],n=s((r,a)=>{for(let o of a){let i=Pr.getHostname(o);nO(i)&&(i==="127.0.0.1"?t.push(new Q.Finding(Q.Type.IP_SOURCE,r+" directive allows localhost as source. Please make sure to remove this in production environments.",Q.Severity.INFO,r,o)):t.push(new Q.Finding(Q.Type.IP_SOURCE,r+" directive has an IP-Address as source: "+i+" (will be ignored by browsers!). ",Q.Severity.INFO,r,o)))}},"checkIp");return Pr.applyCheckFunktionToDirectives(e,n),t}s(Ure,"checkIpSource");fe.checkIpSource=Ure;function jre(e){let t=[];return Oe.Directive.REFLECTED_XSS in e.directives&&t.push(new Q.Finding(Q.Type.DEPRECATED_DIRECTIVE,"reflected-xss is deprecated since CSP2. Please, use the X-XSS-Protection header instead.",Q.Severity.INFO,Oe.Directive.REFLECTED_XSS)),Oe.Directive.REFERRER in e.directives&&t.push(new Q.Finding(Q.Type.DEPRECATED_DIRECTIVE,"referrer is deprecated since CSP2. Please, use the Referrer-Policy header instead.",Q.Severity.INFO,Oe.Directive.REFERRER)),Oe.Directive.DISOWN_OPENER in e.directives&&t.push(new Q.Finding(Q.Type.DEPRECATED_DIRECTIVE,"disown-opener is deprecated since CSP3. Please, use the Cross Origin Opener Policy header instead.",Q.Severity.INFO,Oe.Directive.DISOWN_OPENER)),t}s(jre,"checkDeprecatedDirective");fe.checkDeprecatedDirective=jre;function qre(e){let t=new RegExp("^'nonce-(.+)'$"),n=[];return Pr.applyCheckFunktionToDirectives(e,(r,a)=>{for(let o of a){let i=o.match(t);if(!i)continue;i[1].length<8&&n.push(new Q.Finding(Q.Type.NONCE_LENGTH,"Nonces should be at least 8 characters long.",Q.Severity.MEDIUM,r,o)),J5.isNonce(o,!0)||n.push(new Q.Finding(Q.Type.NONCE_CHARSET,"Nonces should only use the base64 charset.",Q.Severity.INFO,r,o))}}),n}s(qre,"checkNonceLength");fe.checkNonceLength=qre;function zre(e){let t=[];return Pr.applyCheckFunktionToDirectives(e,(n,r)=>{for(let a of r){let o=n===Oe.Directive.REPORT_URI?"Use HTTPS to send violation reports securely.":"Allow only resources downloaded over HTTPS.";a.startsWith("http://")&&t.push(new Q.Finding(Q.Type.SRC_HTTP,o,Q.Severity.MEDIUM,n,a))}}),t}s(zre,"checkSrcHttp");fe.checkSrcHttp=zre;function Hre(e){return(e.directives[Oe.Directive.REPORT_URI]||[]).length>0?[]:(e.directives[Oe.Directive.REPORT_TO]||[]).length>0?[new Q.Finding(Q.Type.REPORT_TO_ONLY,"This CSP policy only provides a reporting destination via the 'report-to' directive. This directive is only supported in Chromium-based browsers so it is recommended to also use a 'report-uri' directive.",Q.Severity.INFO,Oe.Directive.REPORT_TO)]:[new Q.Finding(Q.Type.REPORTING_DESTINATION_MISSING,"This CSP policy does not configure a reporting destination. This makes it difficult to maintain the CSP policy over time and monitor for any breakages.",Q.Severity.INFO,Oe.Directive.REPORT_URI)]}s(Hre,"checkHasConfiguredReporting");fe.checkHasConfiguredReporting=Hre});var aO=I(Kt=>{"use strict";d();var Gre=Kt&&Kt.__createBinding||(Object.create?function(e,t,n,r){r===void 0&&(r=n),Object.defineProperty(e,r,{enumerable:!0,get:function(){return t[n]}})}:function(e,t,n,r){r===void 0&&(r=n),e[r]=t[n]}),Vre=Kt&&Kt.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),Wre=Kt&&Kt.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(e!=null)for(var n in e)n!=="default"&&Object.prototype.hasOwnProperty.call(e,n)&&Gre(t,e,n);return Vre(t,e),t};Object.defineProperty(Kt,"__esModule",{value:!0});Kt.checkRequiresTrustedTypesForScripts=Kt.checkAllowlistFallback=Kt.checkUnsafeInlineFallback=Kt.checkStrictDynamicNotStandalone=Kt.checkStrictDynamic=void 0;var Jo=Wre(Mr()),Rf=Mr(),Dn=_s();function $re(e){let t=e.getEffectiveDirective(Jo.Directive.SCRIPT_SRC),n=e.directives[t]||[];return n.some(a=>!a.startsWith("'"))&&!n.includes(Rf.Keyword.STRICT_DYNAMIC)?[new Dn.Finding(Dn.Type.STRICT_DYNAMIC,"Host allowlists can frequently be bypassed. Consider using 'strict-dynamic' in combination with CSP nonces or hashes.",Dn.Severity.STRICT_CSP,t)]:[]}s($re,"checkStrictDynamic");Kt.checkStrictDynamic=$re;function Yre(e){let t=e.getEffectiveDirective(Jo.Directive.SCRIPT_SRC);return(e.directives[t]||[]).includes(Rf.Keyword.STRICT_DYNAMIC)&&!e.policyHasScriptNonces()&&!e.policyHasScriptHashes()?[new Dn.Finding(Dn.Type.STRICT_DYNAMIC_NOT_STANDALONE,"'strict-dynamic' without a CSP nonce/hash will block all scripts.",Dn.Severity.INFO,t)]:[]}s(Yre,"checkStrictDynamicNotStandalone");Kt.checkStrictDynamicNotStandalone=Yre;function Kre(e){if(!e.policyHasScriptNonces()&&!e.policyHasScriptHashes())return[];let t=e.getEffectiveDirective(Jo.Directive.SCRIPT_SRC);return(e.directives[t]||[]).includes(Rf.Keyword.UNSAFE_INLINE)?[]:[new Dn.Finding(Dn.Type.UNSAFE_INLINE_FALLBACK,"Consider adding 'unsafe-inline' (ignored by browsers supporting nonces/hashes) to be backward compatible with older browsers.",Dn.Severity.STRICT_CSP,t)]}s(Kre,"checkUnsafeInlineFallback");Kt.checkUnsafeInlineFallback=Kre;function Xre(e){let t=e.getEffectiveDirective(Jo.Directive.SCRIPT_SRC),n=e.directives[t]||[];return n.includes(Rf.Keyword.STRICT_DYNAMIC)?n.some(r=>["http:","https:","*"].includes(r)||r.includes("."))?[]:[new Dn.Finding(Dn.Type.ALLOWLIST_FALLBACK,"Consider adding https: and http: url schemes (ignored by browsers supporting 'strict-dynamic') to be backward compatible with older browsers.",Dn.Severity.STRICT_CSP,t)]:[]}s(Xre,"checkAllowlistFallback");Kt.checkAllowlistFallback=Xre;function Jre(e){let t=e.getEffectiveDirective(Jo.Directive.REQUIRE_TRUSTED_TYPES_FOR);return(e.directives[t]||[]).includes(Jo.TrustedTypesSink.SCRIPT)?[]:[new Dn.Finding(Dn.Type.REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS,`Consider requiring Trusted Types for scripts to lock down DOM XSS injection sinks. You can do this by adding "require-trusted-types-for 'script'" to your policy.`,Dn.Severity.INFO,Jo.Directive.REQUIRE_TRUSTED_TYPES_FOR)]}s(Jre,"checkRequiresTrustedTypesForScripts");Kt.checkRequiresTrustedTypesForScripts=Jre});var cO=I(Ja=>{"use strict";d();Object.defineProperty(Ja,"__esModule",{value:!0});Ja.evaluateForSyntaxErrors=Ja.evaluateForWarnings=Ja.evaluateForFailure=void 0;var kD=G5(),Xa=rO(),CD=aO(),oO=Mr();function sO(e,t){return e.some(n=>n.equals(t))}s(sO,"arrayContains");function Zre(e){let t=[];if(e.length===0)return t;let n=e[0];for(let r of n)e.every(a=>sO(a,r))&&t.push(r);return t}s(Zre,"setIntersection");function Qre(e){let t=[];for(let n of e)for(let r of n)sO(t,r)||t.push(r);return t}s(Qre,"setUnion");function Is(e,t){let n=[];for(let r of e)n.push(t(r));return Zre(n)}s(Is,"atLeastOnePasses");function iO(e,t){let n=[];for(let r of e)n.push(t(r));return Qre(n)}s(iO,"atLeastOneFails");function eae(e){let t=[...Is(e,Xa.checkMissingScriptSrcDirective),...Is(e,Xa.checkMissingObjectSrcDirective),...Xa.checkMultipleMissingBaseUriDirective(e)],n=e.map(o=>o.getEffectiveCsp(oO.Version.CSP3)),r=n.filter(o=>{let i=o.getEffectiveDirective(oO.Directive.SCRIPT_SRC);return o.directives[i]}),a=[...Is(r,CD.checkStrictDynamic),...Is(r,Xa.checkScriptUnsafeInline),...Is(n,Xa.checkWildcards),...Is(n,Xa.checkPlainUrlSchemes)];return[...t,...a]}s(eae,"evaluateForFailure");Ja.evaluateForFailure=eae;function tae(e){return[...iO(e,CD.checkUnsafeInlineFallback),...iO(e,CD.checkAllowlistFallback)]}s(tae,"evaluateForWarnings");Ja.evaluateForWarnings=tae;function nae(e){let t=[];for(let n of e){let r=[...Xa.checkNonceLength(n),...kD.checkUnknownDirective(n),...Xa.checkDeprecatedDirective(n),...kD.checkMissingSemicolon(n),...kD.checkInvalidKeyword(n)];t.push(r)}return t}s(nae,"evaluateForSyntaxErrors");Ja.evaluateForSyntaxErrors=nae});var lO=I(Yn=>{"use strict";d();var rae=Yn&&Yn.__createBinding||(Object.create?function(e,t,n,r){r===void 0&&(r=n),Object.defineProperty(e,r,{enumerable:!0,get:function(){return t[n]}})}:function(e,t,n,r){r===void 0&&(r=n),e[r]=t[n]}),aae=Yn&&Yn.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),oae=Yn&&Yn.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(e!=null)for(var n in e)n!=="default"&&Object.prototype.hasOwnProperty.call(e,n)&&rae(t,e,n);return aae(t,e),t};Object.defineProperty(Yn,"__esModule",{value:!0});Yn.TEST_ONLY=Yn.CspParser=void 0;var Dd=oae(Mr()),AD=class{static{s(this,"CspParser")}constructor(t){this.csp=new Dd.Csp,this.parse(t)}parse(t){this.csp=new Dd.Csp;let n=t.split(";");for(let r=0;r<n.length;r++){let o=n[r].trim().match(/\S+/g);if(Array.isArray(o)){let i=o[0].toLowerCase();if(i in this.csp.directives)continue;Dd.isDirective(i);let c=[];for(let u,l=1;u=o[l];l++)u=uO(u),c.includes(u)||c.push(u);this.csp.directives[i]=c}}return this.csp}};Yn.CspParser=AD;function uO(e){e=e.trim();let t=e.toLowerCase();return Dd.isKeyword(t)||Dd.isUrlScheme(e)?t:e}s(uO,"normalizeDirectiveValue");Yn.TEST_ONLY={normalizeDirectiveValue:uO}});function mO(e){let t=iae[e.type];return t?Vi(t)?t:typeof t=="string"?mn(t,{keyword:e.value||""}):(t=t[e.directive],t||(F.warn("CSP Evaluator",`No translation found for description: ${e.description}`),e.description)):(F.warn("CSP Evaluator",`No translation found for description: ${e.description}`),e.description)}function sae(e){return new dO.CspParser(e).csp}function _D(e){let t=e.map(sae),n=(0,Ns.evaluateForFailure)(t),r=(0,Ns.evaluateForWarnings)(t),a=(0,Ns.evaluateForSyntaxErrors)(t);return{bypasses:n,warnings:r,syntax:a}}var Ns,dn,dO,Zo,Ht,mn,iae,pO=b(()=>{"use strict";d();Ns=Lt(cO(),1),dn=Lt(_s(),1),dO=Lt(lO(),1),Zo=Lt(Mr(),1);Ae();A();Qr();Ht={missingBaseUri:"Missing `base-uri` allows injected `<base>` tags to set the base URL for all relative URLs (e.g. scripts) to an attacker controlled domain. Consider setting `base-uri` to `'none'` or `'self'`.",missingScriptSrc:"`script-src` directive is missing. This can allow the execution of unsafe scripts.",missingObjectSrc:"Missing `object-src` allows the injection of plugins that execute unsafe scripts. Consider setting `object-src` to `'none'` if you can.",strictDynamic:"Host allowlists can frequently be bypassed. Consider using CSP nonces or hashes instead, along with `'strict-dynamic'` if necessary.",unsafeInline:"`'unsafe-inline'` allows the execution of unsafe in-page scripts and event handlers. Consider using CSP nonces or hashes to allow scripts individually.",unsafeInlineFallback:"Consider adding `'unsafe-inline'` (ignored by browsers supporting nonces/hashes) to be backward compatible with older browsers.",allowlistFallback:"Consider adding https: and http: URL schemes (ignored by browsers supporting `'strict-dynamic'`) to be backward compatible with older browsers.",reportToOnly:"The reporting destination is only configured via the report-to directive. This directive is only supported in Chromium-based browsers so it is recommended to also use a `report-uri` directive.",reportingDestinationMissing:"No CSP configures a reporting destination. This makes it difficult to maintain the CSP over time and monitor for any breakages.",nonceLength:"Nonces should be at least 8 characters long.",nonceCharset:"Nonces should use the base64 charset.",missingSemicolon:"Did you forget the semicolon? {keyword} seems to be a directive, not a keyword.",unknownDirective:"Unknown CSP directive.",unknownKeyword:"{keyword} seems to be an invalid keyword.",deprecatedReflectedXSS:"`reflected-xss` is deprecated since CSP2. Please, use the X-XSS-Protection header instead.",deprecatedReferrer:"`referrer` is deprecated since CSP2. Please, use the Referrer-Policy header instead.",deprecatedDisownOpener:"`disown-opener` is deprecated since CSP3. Please, use the Cross-Origin-Opener-Policy header instead.",plainWildcards:"Avoid using plain wildcards ({keyword}) in this directive. Plain wildcards allow scripts to be sourced from an unsafe domain.",plainUrlScheme:"Avoid using plain URL schemes ({keyword}) in this directive. Plain URL schemes allow scripts to be sourced from an unsafe domain."},mn=w("core/lib/csp-evaluator.js",Ht),iae={[dn.Type.MISSING_SEMICOLON]:Ht.missingSemicolon,[dn.Type.UNKNOWN_DIRECTIVE]:mn(Ht.unknownDirective),[dn.Type.INVALID_KEYWORD]:Ht.unknownKeyword,[dn.Type.MISSING_DIRECTIVES]:{[Zo.Directive.BASE_URI]:mn(Ht.missingBaseUri),[Zo.Directive.SCRIPT_SRC]:mn(Ht.missingScriptSrc),[Zo.Directive.OBJECT_SRC]:mn(Ht.missingObjectSrc)},[dn.Type.SCRIPT_UNSAFE_INLINE]:mn(Ht.unsafeInline),[dn.Type.PLAIN_WILDCARD]:Ht.plainWildcards,[dn.Type.PLAIN_URL_SCHEMES]:Ht.plainUrlScheme,[dn.Type.NONCE_LENGTH]:mn(Ht.nonceLength),[dn.Type.NONCE_CHARSET]:mn(Ht.nonceCharset),[dn.Type.DEPRECATED_DIRECTIVE]:{[Zo.Directive.REFLECTED_XSS]:mn(Ht.deprecatedReflectedXSS),[Zo.Directive.REFERRER]:mn(Ht.deprecatedReferrer),[Zo.Directive.DISOWN_OPENER]:mn(Ht.deprecatedDisownOpener)},[dn.Type.STRICT_DYNAMIC]:mn(Ht.strictDynamic),[dn.Type.UNSAFE_INLINE_FALLBACK]:mn(Ht.unsafeInlineFallback),[dn.Type.ALLOWLIST_FALLBACK]:mn(Ht.allowlistFallback),[dn.Type.REPORTING_DESTINATION_MISSING]:mn(Ht.reportingDestinationMissing),[dn.Type.REPORT_TO_ONLY]:mn(Ht.reportToOnly)};s(mO,"getTranslatedDescription");s(sae,"parseCsp");s(_D,"evaluateRawCspsForXss")});var fO={};T(fO,{UIStrings:()=>da,default:()=>cae});var da,Kn,RD,cae,hO=b(()=>{"use strict";d();V();Bt();A();pO();da={title:"Ensure CSP is effective against XSS attacks",description:"A strong Content Security Policy (CSP) significantly reduces the risk of cross-site scripting (XSS) attacks. [Learn how to use a CSP to prevent XSS](https://developer.chrome.com/docs/lighthouse/best-practices/csp-xss/)",noCsp:"No CSP found in enforcement mode",metaTagMessage:"The page contains a CSP defined in a `<meta>` tag. Consider moving the CSP to an HTTP header or defining another strict CSP in an HTTP header.",columnDirective:"Directive",columnSeverity:"Severity",itemSeveritySyntax:"Syntax"},Kn=w("core/audits/csp-xss.js",da),RD=class extends g{static{s(this,"CspXss")}static get meta(){return{id:"csp-xss",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:Kn(da.title),description:Kn(da.description),requiredArtifacts:["devtoolsLogs","MetaElements","URL"]}}static async getRawCsps(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await _e.request({devtoolsLog:r,URL:t.URL},n),o=t.MetaElements.filter(c=>c.httpEquiv&&c.httpEquiv.toLowerCase()==="content-security-policy").flatMap(c=>(c.content||"").split(",")).filter(c=>c.replace(/\s/g,""));return{cspHeaders:a.responseHeaders.filter(c=>c.name.toLowerCase()==="content-security-policy").flatMap(c=>c.value.split(",")).filter(c=>c.replace(/\s/g,"")),cspMetaTags:o}}static findingToTableItem(t,n){return{directive:t.directive,description:mO(t),severity:n}}static constructSyntaxResults(t,n){let r=[];for(let a=0;a<t.length;++a){let o=t[a].map(i=>this.findingToTableItem(i));o.length&&r.push({severity:Kn(da.itemSeveritySyntax),description:{type:"code",value:n[a]},subItems:{type:"subitems",items:o}})}return r}static constructResults(t,n){let r=[...t,...n];if(!r.length)return{score:0,results:[{severity:Kn(x.itemSeverityHigh),description:Kn(da.noCsp),directive:void 0}]};let{bypasses:a,warnings:o,syntax:i}=_D(r),c=[...this.constructSyntaxResults(i,r),...a.map(m=>this.findingToTableItem(m,Kn(x.itemSeverityHigh))),...o.map(m=>this.findingToTableItem(m,Kn(x.itemSeverityMedium)))],l=_D(t).bypasses.length>0||t.length===0;return n.length>0&&l&&c.push({severity:Kn(x.itemSeverityMedium),description:Kn(da.metaTagMessage),directive:void 0}),{score:a.length?0:1,results:c}}static async audit(t,n){let{cspHeaders:r,cspMetaTags:a}=await this.getRawCsps(t,n),{score:o,results:i}=this.constructResults(r,a),c=[{key:"description",valueType:"text",subItemsHeading:{key:"description"},label:Kn(x.columnDescription)},{key:"directive",valueType:"code",subItemsHeading:{key:"directive"},label:Kn(da.columnDirective)},{key:"severity",valueType:"text",subItemsHeading:{key:"severity"},label:Kn(da.columnSeverity)}],u=g.makeTableDetails(c,i);return{score:o,notApplicable:!i.length,details:u}}},cae=RD});var FD,gO,yO=b(()=>{"use strict";d();FD={AuthorizationCoveredByWildcard:"Authorization will not be covered by the wildcard symbol (*) in CORS `Access-Control-Allow-Headers` handling.",CanRequestURLHTTPContainingNewline:"Resource requests whose URLs contained both removed whitespace `(n|r|t)` characters and less-than characters (`<`) are blocked. Please remove newlines and encode less-than characters from places like element attribute values in order to load these resources.",ChromeLoadTimesConnectionInfo:"`chrome.loadTimes()` is deprecated, instead use standardized API: Navigation Timing 2.",ChromeLoadTimesFirstPaintAfterLoadTime:"`chrome.loadTimes()` is deprecated, instead use standardized API: Paint Timing.",ChromeLoadTimesWasAlternateProtocolAvailable:"`chrome.loadTimes()` is deprecated, instead use standardized API: `nextHopProtocol` in Navigation Timing 2.",CookieWithTruncatingChar:"Cookies containing a `(0|r|n)` character will be rejected instead of truncated.",CrossOriginAccessBasedOnDocumentDomain:"Relaxing the same-origin policy by setting `document.domain` is deprecated, and will be disabled by default. This deprecation warning is for a cross-origin access that was enabled by setting `document.domain`.",CrossOriginWindowAlert:"Triggering window.alert from cross origin iframes has been deprecated and will be removed in the future.",CrossOriginWindowConfirm:"Triggering window.confirm from cross origin iframes has been deprecated and will be removed in the future.",CSSSelectorInternalMediaControlsOverlayCastButton:"The `disableRemotePlayback` attribute should be used in order to disable the default Cast integration instead of using `-internal-media-controls-overlay-cast-button` selector.",DataUrlInSvgUse:"Support for data: URLs in SVG <use> element is deprecated and it will be removed in the future.",DocumentDomainSettingWithoutOriginAgentClusterHeader:"Relaxing the same-origin policy by setting `document.domain` is deprecated, and will be disabled by default. To continue using this feature, please opt-out of origin-keyed agent clusters by sending an `Origin-Agent-Cluster: ?0` header along with the HTTP response for the document and frames. See https://developer.chrome.com/blog/immutable-document-domain/ for more details.",DOMMutationEvents:"DOM Mutation Events, including `DOMSubtreeModified`, `DOMNodeInserted`, `DOMNodeRemoved`, `DOMNodeRemovedFromDocument`, `DOMNodeInsertedIntoDocument`, and `DOMCharacterDataModified` are deprecated (https://w3c.github.io/uievents/#legacy-event-types) and will be removed. Please use `MutationObserver` instead.",ExpectCTHeader:"The `Expect-CT` header is deprecated and will be removed. Chrome requires Certificate Transparency for all publicly trusted certificates issued after April 30, 2018.",GeolocationInsecureOrigin:"`getCurrentPosition()` and `watchPosition()` no longer work on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",GeolocationInsecureOriginDeprecatedNotRemoved:"`getCurrentPosition()` and `watchPosition()` are deprecated on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",GetUserMediaInsecureOrigin:"`getUserMedia()` no longer works on insecure origins. To use this feature, you should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",HostCandidateAttributeGetter:"`RTCPeerConnectionIceErrorEvent.hostCandidate` is deprecated. Please use `RTCPeerConnectionIceErrorEvent.address` or `RTCPeerConnectionIceErrorEvent.port` instead.",IdentityInCanMakePaymentEvent:"The merchant origin and arbitrary data from the `canmakepayment` service worker event are deprecated and will be removed: `topOrigin`, `paymentRequestOrigin`, `methodData`, `modifiers`.",InsecurePrivateNetworkSubresourceRequest:"The website requested a subresource from a network that it could only access because of its users' privileged network position. These requests expose non-public devices and servers to the internet, increasing the risk of a cross-site request forgery (CSRF) attack, and/or information leakage. To mitigate these risks, Chrome deprecates requests to non-public subresources when initiated from non-secure contexts, and will start blocking them.",InterestGroupDailyUpdateUrl:"The `dailyUpdateUrl` field of `InterestGroups` passed to `joinAdInterestGroup()` has been renamed to `updateUrl`, to more accurately reflect its behavior.",LocalCSSFileExtensionRejected:"CSS cannot be loaded from `file:` URLs unless they end in a `.css` file extension.",MediaSourceAbortRemove:"Using `SourceBuffer.abort()` to abort `remove()`'s asynchronous range removal is deprecated due to specification change. Support will be removed in the future. You should listen to the `updateend` event instead. `abort()` is intended to only abort an asynchronous media append or reset parser state.",MediaSourceDurationTruncatingBuffered:"Setting `MediaSource.duration` below the highest presentation timestamp of any buffered coded frames is deprecated due to specification change. Support for implicit removal of truncated buffered media will be removed in the future. You should instead perform explicit `remove(newDuration, oldDuration)` on all `sourceBuffers`, where `newDuration < oldDuration`.",NonStandardDeclarativeShadowDOM:"The older, non-standardized `shadowroot` attribute is deprecated, and will *no longer function* in M119. Please use the new, standardized `shadowrootmode` attribute instead.",NoSysexWebMIDIWithoutPermission:"Web MIDI will ask a permission to use even if the sysex is not specified in the `MIDIOptions`.",NotificationInsecureOrigin:"The Notification API may no longer be used from insecure origins. You should consider switching your application to a secure origin, such as HTTPS. See https://goo.gle/chrome-insecure-origins for more details.",NotificationPermissionRequestedIframe:"Permission for the Notification API may no longer be requested from a cross-origin iframe. You should consider requesting permission from a top-level frame or opening a new window instead.",ObsoleteCreateImageBitmapImageOrientationNone:"Option `imageOrientation: 'none'` in createImageBitmap is deprecated. Please use createImageBitmap with option \\{imageOrientation: 'from-image'\\} instead.",ObsoleteWebRtcCipherSuite:"Your partner is negotiating an obsolete (D)TLS version. Please check with your partner to have this fixed.",OverflowVisibleOnReplacedElement:"Specifying `overflow: visible` on img, video and canvas tags may cause them to produce visual content outside of the element bounds. See https://github.com/WICG/shared-element-transitions/blob/main/debugging_overflow_on_images.md.",PaymentInstruments:"`paymentManager.instruments` is deprecated. Please use just-in-time install for payment handlers instead.",PaymentRequestCSPViolation:"Your `PaymentRequest` call bypassed Content-Security-Policy (CSP) `connect-src` directive. This bypass is deprecated. Please add the payment method identifier from the `PaymentRequest` API (in `supportedMethods` field) to your CSP `connect-src` directive.",PersistentQuotaType:"`StorageType.persistent` is deprecated. Please use standardized `navigator.storage` instead.",PictureSourceSrc:"`<source src>` with a `<picture>` parent is invalid and therefore ignored. Please use `<source srcset>` instead.",PrefixedCancelAnimationFrame:"webkitCancelAnimationFrame is vendor-specific. Please use the standard cancelAnimationFrame instead.",PrefixedRequestAnimationFrame:"webkitRequestAnimationFrame is vendor-specific. Please use the standard requestAnimationFrame instead.",PrefixedVideoDisplayingFullscreen:"HTMLVideoElement.webkitDisplayingFullscreen is deprecated. Please use Document.fullscreenElement instead.",PrefixedVideoEnterFullScreen:"HTMLVideoElement.webkitEnterFullScreen() is deprecated. Please use Element.requestFullscreen() instead.",PrefixedVideoEnterFullscreen:"HTMLVideoElement.webkitEnterFullscreen() is deprecated. Please use Element.requestFullscreen() instead.",PrefixedVideoExitFullScreen:"HTMLVideoElement.webkitExitFullScreen() is deprecated. Please use Document.exitFullscreen() instead.",PrefixedVideoExitFullscreen:"HTMLVideoElement.webkitExitFullscreen() is deprecated. Please use Document.exitFullscreen() instead.",PrefixedVideoSupportsFullscreen:"HTMLVideoElement.webkitSupportsFullscreen is deprecated. Please use Document.fullscreenEnabled instead.",PrivacySandboxExtensionsAPI:"We're deprecating the API `chrome.privacy.websites.privacySandboxEnabled`, though it will remain active for backward compatibility until release M113. Instead, please use `chrome.privacy.websites.topicsEnabled`, `chrome.privacy.websites.fledgeEnabled` and `chrome.privacy.websites.adMeasurementEnabled`. See https://developer.chrome.com/docs/extensions/reference/privacy/#property-websites-privacySandboxEnabled.",RangeExpand:"Range.expand() is deprecated. Please use Selection.modify() instead.",RequestedSubresourceWithEmbeddedCredentials:"Subresource requests whose URLs contain embedded credentials (e.g. `https://user:pass@host/`) are blocked.",RTCConstraintEnableDtlsSrtpFalse:"The constraint `DtlsSrtpKeyAgreement` is removed. You have specified a `false` value for this constraint, which is interpreted as an attempt to use the removed `SDES key negotiation` method. This functionality is removed; use a service that supports `DTLS key negotiation` instead.",RTCConstraintEnableDtlsSrtpTrue:"The constraint `DtlsSrtpKeyAgreement` is removed. You have specified a `true` value for this constraint, which had no effect, but you can remove this constraint for tidiness.",RTCPeerConnectionGetStatsLegacyNonCompliant:"The callback-based getStats() is deprecated and will be removed. Use the spec-compliant getStats() instead.",RtcpMuxPolicyNegotiate:"The `rtcpMuxPolicy` option is deprecated and will be removed.",SharedArrayBufferConstructedWithoutIsolation:"`SharedArrayBuffer` will require cross-origin isolation. See https://developer.chrome.com/blog/enabling-shared-array-buffer/ for more details.",TextToSpeech_DisallowedByAutoplay:"`speechSynthesis.speak()` without user activation is deprecated and will be removed.",V8SharedArrayBufferConstructedInExtensionWithoutIsolation:"Extensions should opt into cross-origin isolation to continue using `SharedArrayBuffer`. See https://developer.chrome.com/docs/extensions/mv3/cross-origin-isolation/.",WebSQL:"Web SQL is deprecated. Please use SQLite WebAssembly or Indexed Database",WindowPlacementPermissionDescriptorUsed:"The permission descriptor `window-placement` is deprecated. Use `window-management` instead. For more help, check https://bit.ly/window-placement-rename.",WindowPlacementPermissionPolicyParsed:"The permission policy `window-placement` is deprecated. Use `window-management` instead. For more help, check https://bit.ly/window-placement-rename.",XHRJSONEncodingDetection:"UTF-16 is not supported by response json in `XMLHttpRequest`",XMLHttpRequestSynchronousInNonWorkerOutsideBeforeUnload:"Synchronous `XMLHttpRequest` on the main thread is deprecated because of its detrimental effects to the end user's experience. For more help, check https://xhr.spec.whatwg.org/.",XRSupportsSession:"`supportsSession()` is deprecated. Please use `isSessionSupported()` and check the resolved boolean value instead."},gO={AuthorizationCoveredByWildcard:{milestone:97},CSSSelectorInternalMediaControlsOverlayCastButton:{chromeStatusFeature:5714245488476160},CanRequestURLHTTPContainingNewline:{chromeStatusFeature:5735596811091968},ChromeLoadTimesConnectionInfo:{chromeStatusFeature:5637885046816768},ChromeLoadTimesFirstPaintAfterLoadTime:{chromeStatusFeature:5637885046816768},ChromeLoadTimesWasAlternateProtocolAvailable:{chromeStatusFeature:5637885046816768},CookieWithTruncatingChar:{milestone:103},CrossOriginAccessBasedOnDocumentDomain:{milestone:115},DOMMutationEvents:{chromeStatusFeature:5083947249172480,milestone:127},DataUrlInSvgUse:{chromeStatusFeature:5128825141198848,milestone:119},DocumentDomainSettingWithoutOriginAgentClusterHeader:{milestone:115},ExpectCTHeader:{chromeStatusFeature:6244547273687040,milestone:107},IdentityInCanMakePaymentEvent:{chromeStatusFeature:5190978431352832},InsecurePrivateNetworkSubresourceRequest:{chromeStatusFeature:5436853517811712,milestone:92},LocalCSSFileExtensionRejected:{milestone:64},MediaSourceAbortRemove:{chromeStatusFeature:6107495151960064},MediaSourceDurationTruncatingBuffered:{chromeStatusFeature:6107495151960064},NoSysexWebMIDIWithoutPermission:{chromeStatusFeature:5138066234671104,milestone:82},NonStandardDeclarativeShadowDOM:{chromeStatusFeature:6239658726391808,milestone:119},NotificationPermissionRequestedIframe:{chromeStatusFeature:6451284559265792},ObsoleteCreateImageBitmapImageOrientationNone:{milestone:111},ObsoleteWebRtcCipherSuite:{milestone:81},OverflowVisibleOnReplacedElement:{chromeStatusFeature:5137515594383360,milestone:108},PaymentInstruments:{chromeStatusFeature:5099285054488576},PaymentRequestCSPViolation:{chromeStatusFeature:6286595631087616},PersistentQuotaType:{chromeStatusFeature:5176235376246784,milestone:106},RTCConstraintEnableDtlsSrtpFalse:{milestone:97},RTCConstraintEnableDtlsSrtpTrue:{milestone:97},RTCPeerConnectionGetStatsLegacyNonCompliant:{chromeStatusFeature:4631626228695040,milestone:117},RequestedSubresourceWithEmbeddedCredentials:{chromeStatusFeature:5669008342777856},RtcpMuxPolicyNegotiate:{chromeStatusFeature:5654810086866944,milestone:62},SharedArrayBufferConstructedWithoutIsolation:{milestone:106},TextToSpeech_DisallowedByAutoplay:{chromeStatusFeature:5687444770914304,milestone:71},V8SharedArrayBufferConstructedInExtensionWithoutIsolation:{milestone:96},WebSQL:{chromeStatusFeature:5134293578285056,milestone:115},WindowPlacementPermissionDescriptorUsed:{chromeStatusFeature:5137018030391296,milestone:112},WindowPlacementPermissionPolicyParsed:{chromeStatusFeature:5137018030391296,milestone:112},XHRJSONEncodingDetection:{milestone:93},XRSupportsSession:{milestone:80}}});function bO(e){let t,n=e.type,r=FD[n];r&&(t=uae(r));let a=[],o=gO[n],i=o?.chromeStatusFeature??0;i!==0&&a.push({link:`https://chromestatus.com/feature/${i}`,linkTitle:ID(Ff.feature)});let c=o?.milestone??0;return c!==0&&a.push({link:"https://chromiumdash.appspot.com/schedule",linkTitle:ID(Ff.milestone,{milestone:c})}),{substitutions:new Map([["PLACEHOLDER_title",ID(Ff.title)],["PLACEHOLDER_message",t]]),links:a,message:t}}var Ff,ID,uae,vO=b(()=>{"use strict";d();A();yO();Ff={feature:"Check the feature status page for more details.",milestone:"This change will go into effect with milestone {milestone}.",title:"Deprecated Feature Used"},ID=w("core/lib/deprecation-description.js",Ff),uae=w("core/lib/deprecation-description.js",FD);s(bO,"getIssueDetailDescription")});var wO={};T(wO,{UIStrings:()=>Qo,default:()=>lae});var Qo,Ms,ND,lae,DO=b(()=>{"use strict";d();V();ca();A();vO();Qo={title:"Avoids deprecated APIs",failureTitle:"Uses deprecated APIs",description:"Deprecated APIs will eventually be removed from the browser. [Learn more about deprecated APIs](https://developer.chrome.com/docs/lighthouse/best-practices/deprecations/).",displayValue:`{itemCount, plural,
    =1 {1 warning found}
    other {# warnings found}
    }`,columnDeprecate:"Deprecation / Warning",columnLine:"Line"},Ms=w("core/audits/deprecations.js",Qo),ND=class extends g{static{s(this,"Deprecations")}static get meta(){return{id:"deprecations",title:Ms(Qo.title),failureTitle:Ms(Qo.failureTitle),description:Ms(Qo.description),requiredArtifacts:["InspectorIssues","SourceMaps","Scripts"]}}static async audit(t,n){let r=await un.request(t,n),a=t.InspectorIssues.deprecationIssue.map(u=>{let{scriptId:l,url:m,lineNumber:p,columnNumber:h}=u.sourceCodeLocation,f=r.find(S=>S.script.scriptId===l),y=bO(u),v;y.links.length&&(v={type:"subitems",items:y.links.map(S=>({type:"link",url:S.link,text:S.linkTitle}))});let D=u.message;return{value:y.message||D||u.type,source:g.makeSourceLocation(m,p,h-1,f),subItems:v}}),o=[{key:"value",valueType:"text",label:Ms(Qo.columnDeprecate)},{key:"source",valueType:"source-location",label:Ms(x.columnSource)}],i=g.makeTableDetails(o,a),c;return a.length>0&&(c=Ms(Qo.displayValue,{itemCount:a.length})),{score:+(a.length===0),displayValue:c,details:i}}},lae=ND});var EO={};T(EO,{default:()=>dae});var MD,dae,xO=b(()=>{"use strict";d();V();za();de();jo();Bt();MD=class extends g{static{s(this,"Diagnostics")}static get meta(){return{id:"diagnostics",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:"Diagnostics",description:"Collection of useful page vitals.",supportedModes:["navigation"],requiredArtifacts:["URL","traces","devtoolsLogs"]}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=await Cn.request(r,n),i=await H.request(a,n),c=await ar.request(a,n),u=await _e.request({devtoolsLog:a,URL:t.URL},n),l=o.filter(D=>!D.parent),m=u.transferSize,p=i.reduce((D,E)=>D+(E.transferSize||0),0),h=l.reduce((D,E)=>D+(E.duration||0),0),f=Math.max(...c.additionalRttByOrigin.values())+c.rtt,y=Math.max(...c.serverResponseTimeByOrigin.values());return{score:1,details:{type:"debugdata",items:[{numRequests:i.length,numScripts:i.filter(D=>D.resourceType==="Script").length,numStylesheets:i.filter(D=>D.resourceType==="Stylesheet").length,numFonts:i.filter(D=>D.resourceType==="Font").length,numTasks:l.length,numTasksOver10ms:l.filter(D=>D.duration>10).length,numTasksOver25ms:l.filter(D=>D.duration>25).length,numTasksOver50ms:l.filter(D=>D.duration>50).length,numTasksOver100ms:l.filter(D=>D.duration>100).length,numTasksOver500ms:l.filter(D=>D.duration>500).length,rtt:c.rtt,throughput:c.throughput,maxRtt:f,maxServerLatency:y,totalByteWeight:p,totalTaskTime:h,mainDocumentTransferSize:m}]}}}},dae=MD});var kO={};T(kO,{CHARSET_HTML_REGEX:()=>SO,CHARSET_HTTP_REGEX:()=>PD,IANA_REGEX:()=>TO,UIStrings:()=>Ed,default:()=>pae});var Ed,LD,mae,TO,SO,PD,OD,pae,CO=b(()=>{"use strict";d();V();A();Bt();Ed={title:"Properly defines charset",failureTitle:"Charset declaration is missing or occurs too late in the HTML",description:"A character encoding declaration is required. It can be done with a `<meta>` tag in the first 1024 bytes of the HTML or in the Content-Type HTTP response header. [Learn more about declaring the character encoding](https://developer.chrome.com/docs/lighthouse/best-practices/charset/)."},LD=w("core/audits/dobetterweb/charset.js",Ed),mae="content-type",TO=/^[a-zA-Z0-9-_:.()]{2,}$/,SO=/<meta[^>]+charset[^<]+>/i,PD=/charset\s*=\s*[a-zA-Z0-9-_:.()]{2,}/i,OD=class extends g{static{s(this,"CharsetDefined")}static get meta(){return{id:"charset",title:LD(Ed.title),failureTitle:LD(Ed.failureTitle),description:LD(Ed.description),requiredArtifacts:["MainDocumentContent","URL","devtoolsLogs","MetaElements"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await _e.request({devtoolsLog:r,URL:t.URL},n),o=!1;if(a.responseHeaders){let c=a.responseHeaders.find(u=>u.name.toLowerCase()===mae);c&&(o=PD.test(c.value))}let i=65279;return o=o||t.MainDocumentContent.charCodeAt(0)===i,SO.test(t.MainDocumentContent.slice(0,1024))&&(o=o||t.MetaElements.some(c=>c.charset&&TO.test(c.charset)||c.httpEquiv==="content-type"&&c.content&&PD.test(c.content))),{score:Number(o)}}},pae=OD});var AO={};T(AO,{UIStrings:()=>ur,default:()=>fae});var ur,ma,BD,fae,_O=b(()=>{"use strict";d();V();A();Nt();ur={title:"Page has the HTML doctype",failureTitle:"Page lacks the HTML doctype, thus triggering quirks-mode",description:"Specifying a doctype prevents the browser from switching to quirks-mode. [Learn more about the doctype declaration](https://developer.chrome.com/docs/lighthouse/best-practices/doctype/).",explanationNoDoctype:"Document must contain a doctype",explanationWrongDoctype:"Document contains a `doctype` that triggers `quirks-mode`",explanationLimitedQuirks:"Document contains a `doctype` that triggers `limited-quirks-mode`",explanationPublicId:"Expected publicId to be an empty string",explanationSystemId:"Expected systemId to be an empty string",explanationBadDoctype:"Doctype name must be the string `html`"},ma=w("core/audits/dobetterweb/doctype.js",ur),BD=class extends g{static{s(this,"Doctype")}static get meta(){return{id:"doctype",title:ma(ur.title),failureTitle:ma(ur.failureTitle),description:ma(ur.description),requiredArtifacts:["Doctype"],__internalOptionalArtifacts:["InspectorIssues","traces"]}}static async audit(t,n){if(!t.Doctype)return{score:0,explanation:ma(ur.explanationNoDoctype)};let r=t.Doctype.name,a=t.Doctype.publicId,o=t.Doctype.systemId,i=t.Doctype.documentCompatMode,c=t.traces?.[g.DEFAULT_PASS],u=[];if(c&&t.InspectorIssues){let p=(await ke.request(c,n)).mainFrameInfo.frameId;u=t.InspectorIssues.quirksModeIssue.filter(h=>h.frameId===p)}let l=u.some(m=>m.isLimitedQuirksMode);return i==="CSS1Compat"&&!l?{score:1}:l?{score:0,explanation:ma(ur.explanationLimitedQuirks)}:a!==""?{score:0,explanation:ma(ur.explanationPublicId)}:o!==""?{score:0,explanation:ma(ur.explanationSystemId)}:r!=="html"?{score:0,explanation:ma(ur.explanationBadDoctype)}:{score:0,explanation:ma(ur.explanationWrongDoctype)}}},fae=BD});var RO={};T(RO,{UIStrings:()=>lr,default:()=>hae});var lr,Or,UD,hae,FO=b(()=>{"use strict";d();V();A();id();Fn();lr={title:"Avoids an excessive DOM size",failureTitle:"Avoid an excessive DOM size",description:"A large DOM will increase memory usage, cause longer [style calculations](https://developers.google.com/web/fundamentals/performance/rendering/reduce-the-scope-and-complexity-of-style-calculations), and produce costly [layout reflows](https://developers.google.com/speed/articles/reflow). [Learn how to avoid an excessive DOM size](https://developer.chrome.com/docs/lighthouse/performance/dom-size/).",columnStatistic:"Statistic",columnValue:"Value",displayValue:`{itemCount, plural,
    =1 {1 element}
    other {# elements}
    }`,statisticDOMElements:"Total DOM Elements",statisticDOMDepth:"Maximum DOM Depth",statisticDOMWidth:"Maximum Child Elements"},Or=w("core/audits/dobetterweb/dom-size.js",lr),UD=class extends g{static{s(this,"DOMSize")}static get meta(){return{id:"dom-size",title:Or(lr.title),failureTitle:Or(lr.failureTitle),description:Or(lr.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:1,requiredArtifacts:["DOMStats","URL","GatherContext"],__internalOptionalArtifacts:["traces","devtoolsLogs"]}}static get defaultOptions(){return{p10:818,median:1400}}static async computeTbtImpact(t,n){let r=0,{GatherContext:a,devtoolsLogs:o,traces:i}=t;if(a.gatherMode!=="navigation")return;if(!o?.[g.DEFAULT_PASS]||!i?.[g.DEFAULT_PASS])return 0;let c=g.makeMetricComputationDataInput(t,n);try{let u=await Va.request(c,n);for(let l of u)l.group.id==="styleLayout"&&(r+=l.selfTbtImpact)}catch{}return Math.round(r)}static async audit(t,n){let r=t.DOMStats,a=g.computeLogNormalScore({p10:n.options.p10,median:n.options.median},r.totalBodyElements),o=[{key:"statistic",valueType:"text",label:Or(lr.columnStatistic)},{key:"node",valueType:"node",label:Or(x.columnElement)},{key:"value",valueType:"numeric",label:Or(lr.columnValue)}],i=[{statistic:Or(lr.statisticDOMElements),value:{type:"numeric",granularity:1,value:r.totalBodyElements}},{node:g.makeNodeItem(r.depth),statistic:Or(lr.statisticDOMDepth),value:{type:"numeric",granularity:1,value:r.depth.max}},{node:g.makeNodeItem(r.width),statistic:Or(lr.statisticDOMWidth),value:{type:"numeric",granularity:1,value:r.width.max}}],c=await this.computeTbtImpact(t,n);return{score:a,scoreDisplayMode:a>=Me.PASS_THRESHOLD?g.SCORING_MODES.INFORMATIVE:void 0,numericValue:r.totalBodyElements,numericUnit:"element",displayValue:Or(lr.displayValue,{itemCount:r.totalBodyElements}),details:g.makeTableDetails(o,i),metricSavings:{TBT:c}}}},hae=UD});var jD,Xt,xd=b(()=>{"use strict";d();V();ca();jD=class extends g{static{s(this,"ViolationAudit")}static async getViolationResults(t,n,r){let a=await un.request(t,n);function o(c){return c!==void 0}s(o,"filterUndefined");let i=new Set;return t.ConsoleMessages.filter(c=>c.url&&c.source==="violation"&&r.test(c.text)).map(c=>{let u=a.find(l=>l.script.scriptId===c.scriptId);return g.makeSourceLocationFromConsoleMessage(c,u)}).filter(o).filter(c=>{let u=`${c.url}!${c.line}!${c.column}`;return i.has(u)?!1:(i.add(u),!0)}).map(c=>({source:c}))}},Xt=jD});var IO={};T(IO,{UIStrings:()=>Td,default:()=>gae});var Td,If,qD,gae,NO=b(()=>{"use strict";d();xd();A();Td={title:"Avoids requesting the geolocation permission on page load",failureTitle:"Requests the geolocation permission on page load",description:"Users are mistrustful of or confused by sites that request their location without context. Consider tying the request to a user action instead. [Learn more about the geolocation permission](https://developer.chrome.com/docs/lighthouse/best-practices/geolocation-on-start/)."},If=w("core/audits/dobetterweb/geolocation-on-start.js",Td),qD=class extends Xt{static{s(this,"GeolocationOnStart")}static get meta(){return{id:"geolocation-on-start",title:If(Td.title),failureTitle:If(Td.failureTitle),description:If(Td.description),supportedModes:["navigation"],requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"]}}static async audit(t,n){let r=await Xt.getViolationResults(t,n,/geolocation/),a=[{key:"source",valueType:"source-location",label:If(x.columnSource)}],o=Xt.makeTableDetails(a,r);return{score:+(r.length===0),details:o}}},gae=qD});var MO={};T(MO,{UIStrings:()=>Za,default:()=>yae});var Za,Ls,zD,yae,LO=b(()=>{"use strict";d();V();A();Za={title:"No issues in the `Issues` panel in Chrome Devtools",failureTitle:"Issues were logged in the `Issues` panel in Chrome Devtools",description:"Issues logged to the `Issues` panel in Chrome Devtools indicate unresolved problems. They can come from network request failures, insufficient security controls, and other browser concerns. Open up the Issues panel in Chrome DevTools for more details on each issue.",columnIssueType:"Issue type",issueTypeBlockedByResponse:"Blocked by cross-origin policy",issueTypeHeavyAds:"Heavy resource usage by ads"},Ls=w("core/audits/dobetterweb/inspector-issues.js",Za),zD=class extends g{static{s(this,"IssuesPanelEntries")}static get meta(){return{id:"inspector-issues",title:Ls(Za.title),failureTitle:Ls(Za.failureTitle),description:Ls(Za.description),requiredArtifacts:["InspectorIssues"]}}static getMixedContentRow(t){let n=new Set;for(let r of t){let a=r.request?.url||r.mainResourceURL;n.add(a)}return{issueType:"Mixed content",subItems:{type:"subitems",items:Array.from(n).map(r=>({url:r}))}}}static getCookieRow(t){let n=new Set;for(let r of t){let a=r.request?.url||r.cookieUrl;a&&n.add(a)}return{issueType:"Cookie",subItems:{type:"subitems",items:Array.from(n).map(r=>({url:r}))}}}static getBlockedByResponseRow(t){let n=new Set;for(let r of t){let a=r.request?.url;a&&n.add(a)}return{issueType:Ls(Za.issueTypeBlockedByResponse),subItems:{type:"subitems",items:Array.from(n).map(r=>({url:r}))}}}static getContentSecurityPolicyRow(t){let n=new Set;for(let r of t){let a=r.blockedURL;a&&n.add(a)}return{issueType:"Content security policy",subItems:{type:"subitems",items:Array.from(n).map(r=>({url:r}))}}}static audit(t){let n=[{key:"issueType",valueType:"text",subItemsHeading:{key:"url",valueType:"url"},label:Ls(Za.columnIssueType)}],r=t.InspectorIssues,a=[];r.mixedContentIssue.length&&a.push(this.getMixedContentRow(r.mixedContentIssue)),r.cookieIssue.length&&a.push(this.getCookieRow(r.cookieIssue)),r.blockedByResponseIssue.length&&a.push(this.getBlockedByResponseRow(r.blockedByResponseIssue)),r.heavyAdIssue.length&&a.push({issueType:Ls(Za.issueTypeHeavyAds)});let o=r.contentSecurityPolicyIssue.filter(i=>i.contentSecurityPolicyViolationType!=="kTrustedTypesSinkViolation"&&i.contentSecurityPolicyViolationType!=="kTrustedTypesPolicyViolation");return o.length&&a.push(this.getContentSecurityPolicyRow(o)),{score:a.length>0?0:1,details:g.makeTableDetails(n,a)}}},yae=zD});var PO={};T(PO,{UIStrings:()=>Sd,default:()=>bae});var Sd,Nf,HD,bae,OO=b(()=>{"use strict";d();V();A();Sd={title:"Detected JavaScript libraries",description:"All front-end JavaScript libraries detected on the page. [Learn more about this JavaScript library detection diagnostic audit](https://developer.chrome.com/docs/lighthouse/best-practices/js-libraries/).",columnVersion:"Version"},Nf=w("core/audits/dobetterweb/js-libraries.js",Sd),HD=class extends g{static{s(this,"JsLibrariesAudit")}static get meta(){return{id:"js-libraries",title:Nf(Sd.title),scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,description:Nf(Sd.description),requiredArtifacts:["Stacks"]}}static audit(t){let n=t.Stacks.filter(i=>i.detector==="js").filter(i=>!i.id.endsWith("-fast")).map(i=>({name:i.name,version:i.version,npm:i.npm})),r=[{key:"name",valueType:"text",label:Nf(x.columnName)},{key:"version",valueType:"text",label:Nf(Sd.columnVersion)}],a=g.makeTableDetails(r,n),o={type:"debugdata",stacks:t.Stacks.map(i=>({id:i.id,version:i.version}))};return n.length?{score:1,details:{...a,debugData:o}}:{score:null,notApplicable:!0}}},bae=HD});var BO={};T(BO,{UIStrings:()=>kd,default:()=>vae});var kd,Mf,GD,vae,UO=b(()=>{"use strict";d();xd();A();kd={title:"Avoids `document.write()`",failureTitle:"Avoid `document.write()`",description:"For users on slow connections, external scripts dynamically injected via `document.write()` can delay page load by tens of seconds. [Learn how to avoid document.write()](https://developer.chrome.com/docs/lighthouse/best-practices/no-document-write/)."},Mf=w("core/audits/dobetterweb/no-document-write.js",kd),GD=class extends Xt{static{s(this,"NoDocWriteAudit")}static get meta(){return{id:"no-document-write",title:Mf(kd.title),failureTitle:Mf(kd.failureTitle),description:Mf(kd.description),guidanceLevel:2,requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"],scoreDisplayMode:Xt.SCORING_MODES.METRIC_SAVINGS}}static async audit(t,n){let r=await Xt.getViolationResults(t,n,/document\.write/),a=[{key:"source",valueType:"source-location",label:Mf(x.columnSource)}],o=Xt.makeTableDetails(a,r);return{score:+(r.length===0),details:o}}},vae=GD});var jO={};T(jO,{UIStrings:()=>Cd,default:()=>wae});var Cd,Lf,VD,wae,qO=b(()=>{"use strict";d();xd();A();Cd={title:"Avoids requesting the notification permission on page load",failureTitle:"Requests the notification permission on page load",description:"Users are mistrustful of or confused by sites that request to send notifications without context. Consider tying the request to user gestures instead. [Learn more about responsibly getting permission for notifications](https://developer.chrome.com/docs/lighthouse/best-practices/notification-on-start/)."},Lf=w("core/audits/dobetterweb/notification-on-start.js",Cd),VD=class extends Xt{static{s(this,"NotificationOnStart")}static get meta(){return{id:"notification-on-start",title:Lf(Cd.title),failureTitle:Lf(Cd.failureTitle),description:Lf(Cd.description),supportedModes:["navigation"],requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"]}}static async audit(t,n){let r=await Xt.getViolationResults(t,n,/notification permission/),a=[{key:"source",valueType:"source-location",label:Lf(x.columnSource)}],o=Xt.makeTableDetails(a,r);return{score:+(r.length===0),details:o}}},wae=VD});var zO={};T(zO,{UIStrings:()=>Ad,default:()=>Dae});var Ad,Pf,WD,Dae,HO=b(()=>{"use strict";d();V();A();Ad={title:"Allows users to paste into input fields",failureTitle:"Prevents users from pasting into input fields",description:"Preventing input pasting is a bad practice for the UX, and weakens security by blocking password managers.[Learn more about user-friendly input fields](https://developer.chrome.com/docs/lighthouse/best-practices/paste-preventing-inputs/)."},Pf=w("core/audits/dobetterweb/paste-preventing-inputs.js",Ad),WD=class extends g{static{s(this,"PastePreventingInputsAudit")}static get meta(){return{id:"paste-preventing-inputs",title:Pf(Ad.title),failureTitle:Pf(Ad.failureTitle),description:Pf(Ad.description),requiredArtifacts:["Inputs"]}}static audit(t){let n=t.Inputs.inputs.filter(o=>o.preventsPaste),r=[];n.forEach(o=>{r.push({node:g.makeNodeItem(o.node),type:o.type})});let a=[{key:"node",valueType:"node",label:Pf(x.columnFailingElem)}];return{score:+(n.length===0),details:g.makeTableDetails(a,r)}}},Dae=WD});var GO={};T(GO,{UIStrings:()=>ti,default:()=>xae});var ti,ei,Eae,$D,xae,VO=b(()=>{"use strict";d();V();ua();Ze();Yo();lt();de();Gn();Nn();Ko();cr();A();ti={title:"Use HTTP/2",description:"HTTP/2 offers many benefits over HTTP/1.1, including binary headers and multiplexing. [Learn more about HTTP/2](https://developer.chrome.com/docs/lighthouse/best-practices/uses-http2/).",displayValue:`{itemCount, plural,
    =1 {1 request not served via HTTP/2}
    other {# requests not served via HTTP/2}
    }`,columnProtocol:"Protocol"},ei=w("core/audits/dobetterweb/uses-http2.js",ti),Eae=new Set([G.TYPES.Document,G.TYPES.Font,G.TYPES.Image,G.TYPES.Stylesheet,G.TYPES.Script,G.TYPES.Media]),$D=class e extends g{static{s(this,"UsesHTTP2Audit")}static get meta(){return{id:"uses-http2",title:ei(ti.title),description:ei(ti.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:3,supportedModes:["timespan","navigation"],requiredArtifacts:["URL","devtoolsLogs","traces","GatherContext"]}}static computeWasteWithGraph(t,n,r,a){a=Object.assign({label:""},a);let o=`${this.meta.id}-${a.label}-before`,i=`${this.meta.id}-${a.label}-after`,c=!0,u=new Set(t.map(f=>f.url)),l=r.simulate(n,{label:o,flexibleOrdering:c}),m=new Map;n.traverse(f=>{f.type==="network"&&u.has(f.record.url)&&(m.set(f.record.requestId,f.record.protocol),f.record.protocol="h2")});let p=r.simulate(n,{label:i,flexibleOrdering:c});n.traverse(f=>{if(f.type!=="network")return;let y=m.get(f.record.requestId);y!==void 0&&(f.record.protocol=y)});let h=l.timeInMs-p.timeInMs;return{savings:Math.round(Math.max(h,0)/10)*10,simulationBefore:l,simulationAfter:p}}static computeWasteWithTTIGraph(t,n,r){let{savings:a,simulationBefore:o,simulationAfter:i}=this.computeWasteWithGraph(t,n,r,{label:"tti"}),c=An.getLastLongTaskEndTime(o.nodeTimings)-An.getLastLongTaskEndTime(i.nodeTimings),u=Math.max(c,a);return Math.round(Math.max(u,0)/10)*10}static isMultiplexableStaticAsset(t,n){if(!Eae.has(t.resourceType))return!1;if(t.resourceSize<100){let r=n.entityByUrl.get(t.url);if(r){if(n.firstParty?.name===r.name)return!0;if(!r.isUnrecognized)return!1}}return!0}static determineNonHttp2Resources(t,n){let r=[],a=new Set,o=new Map;for(let i of t){if(!e.isMultiplexableStaticAsset(i,n)||Y.isLikeLocalhost(i.parsedURL.host))continue;let c=o.get(i.parsedURL.securityOrigin)||[];c.push(i),o.set(i.parsedURL.securityOrigin,c)}for(let i of t)a.has(i.url)||i.fetchedViaServiceWorker||!/HTTP\/[01][.\d]?/i.test(i.protocol)||(o.get(i.parsedURL.securityOrigin)||[]).length<6||(a.add(i.url),r.push({protocol:i.protocol,url:i.url}));return r}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.URL,i=await H.request(a,n),c=await ln.request({URL:o,devtoolsLog:a},n),u=e.determineNonHttp2Resources(i,c),l;if(u.length>0&&(l=ei(ti.displayValue,{itemCount:u.length})),t.GatherContext.gatherMode==="timespan"){let z=[{key:"url",valueType:"url",label:ei(x.columnURL)},{key:"protocol",valueType:"text",label:ei(ti.columnProtocol)}],B=g.makeTableDetails(z,u);return{displayValue:l,score:u.length?0:1,details:B}}let m=n?.settings||{},p={devtoolsLog:a,settings:m},h=await xt.request({trace:r,devtoolsLog:a,URL:o},n),f=await Pt.request(p,n),y=g.makeMetricComputationDataInput(t,n),{pessimisticGraph:v}=await Tt.request(y,n),{pessimisticGraph:D}=await $n.request(y,n),E=e.computeWasteWithTTIGraph(u,h,f),S=e.computeWasteWithGraph(u,v,f,{label:"fcp"}),k=e.computeWasteWithGraph(u,D,f,{label:"lcp"}),C=[{key:"url",valueType:"url",label:ei(x.columnURL)},{key:"protocol",valueType:"text",label:ei(ti.columnProtocol)}],R=g.makeOpportunityDetails(C,u,{overallSavingsMs:E});return{displayValue:l,numericValue:E,numericUnit:"millisecond",score:u.length?0:1,details:R,metricSavings:{LCP:k.savings,FCP:S.savings}}}},xae=$D});var WO={};T(WO,{UIStrings:()=>_d,default:()=>Tae});var _d,Of,YD,Tae,$O=b(()=>{"use strict";d();xd();A();_d={title:"Uses passive listeners to improve scrolling performance",failureTitle:"Does not use passive listeners to improve scrolling performance",description:"Consider marking your touch and wheel event listeners as `passive` to improve your page's scroll performance. [Learn more about adopting passive event listeners](https://developer.chrome.com/docs/lighthouse/best-practices/uses-passive-event-listeners/)."},Of=w("core/audits/dobetterweb/uses-passive-event-listeners.js",_d),YD=class extends Xt{static{s(this,"PassiveEventsAudit")}static get meta(){return{id:"uses-passive-event-listeners",title:Of(_d.title),failureTitle:Of(_d.failureTitle),description:Of(_d.description),guidanceLevel:3,requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"],scoreDisplayMode:Xt.SCORING_MODES.METRIC_SAVINGS}}static async audit(t,n){let r=await Xt.getViolationResults(t,n,/passive event listener/),a=[{key:"source",valueType:"source-location",label:Of(x.columnSource)}],o=Xt.makeTableDetails(a,r);return{score:+(r.length===0),details:o}}},Tae=YD});var YO={};T(YO,{UIStrings:()=>Fd,default:()=>Sae});var Fd,Rd,KD,Sae,KO=b(()=>{"use strict";d();Ae();V();ca();A();Fd={title:"No browser errors logged to the console",failureTitle:"Browser errors were logged to the console",description:"Errors logged to the console indicate unresolved problems. They can come from network request failures and other browser concerns. [Learn more about this errors in console diagnostic audit](https://developer.chrome.com/docs/lighthouse/best-practices/errors-in-console/)"},Rd=w("core/audits/errors-in-console.js",Fd),KD=class e extends g{static{s(this,"ErrorLogs")}static get meta(){return{id:"errors-in-console",title:Rd(Fd.title),failureTitle:Rd(Fd.failureTitle),description:Rd(Fd.description),requiredArtifacts:["ConsoleMessages","SourceMaps","Scripts"]}}static get defaultOptions(){return{ignoredPatterns:["ERR_BLOCKED_BY_CLIENT.Inspector"]}}static filterAccordingToOptions(t,n){let{ignoredPatterns:r,...a}=n,o=Object.keys(a);return o.length&&F.warn(this.meta.id,"Unrecognized options",o),r?t.filter(({description:i})=>{if(!i)return!0;for(let c of r)if(c instanceof RegExp&&c.test(i)||typeof c=="string"&&i.includes(c))return!1;return!0}):t}static async audit(t,n){let r=n.options,a=await un.request(t,n),o=t.ConsoleMessages.filter(m=>m.level==="error").map(m=>{let p=a.find(h=>h.script.scriptId===m.scriptId);return{source:m.source,description:m.text,sourceLocation:g.makeSourceLocationFromConsoleMessage(m,p)}}),i=e.filterAccordingToOptions(o,r).sort((m,p)=>(m.description||"").localeCompare(p.description||"")),c=[{key:"sourceLocation",valueType:"source-location",label:Rd(x.columnSource)},{key:"description",valueType:"code",label:Rd(x.columnDescription)}],u=g.makeTableDetails(c,i);return{score:+(i.length===0),details:u}}},Sae=KD});var kae,XD,XO,JO=b(()=>{"use strict";d();ue();kae="Screenshot",XD=class{static{s(this,"Screenshots")}static async compute_(t){return t.traceEvents.filter(n=>n.name===kae).map(n=>({timestamp:n.ts,datauri:`data:image/jpeg;base64,${n.args.snapshot}`}))}},XO=q(XD,null)});var ZO={};T(ZO,{default:()=>Cae});var JD,Cae,QO=b(()=>{"use strict";d();V();It();Nt();JO();JD=class extends g{static{s(this,"FinalScreenshot")}static get meta(){return{id:"final-screenshot",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:"Final Screenshot",description:"The last screenshot captured of the pageload.",requiredArtifacts:["traces","GatherContext"]}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=await ke.request(r,n),o=await XO.request(r,n),{timeOrigin:i}=a.timestamps,c=o[o.length-1];if(!c){if(t.GatherContext.gatherMode==="timespan")return{notApplicable:!0,score:1};throw new j(j.errors.NO_SCREENSHOTS)}return{score:1,details:{type:"screenshot",timing:Math.round((c.timestamp-i)/1e3),timestamp:c.timestamp,data:c.datauri}}}},Cae=JD});var t6={};T(t6,{UIStrings:()=>Os,default:()=>QD});var Aae,e6,_ae,Os,Ps,ZD,QD,eE=b(()=>{"use strict";d();V();Ze();A();or();de();Aae=/^(block|fallback|optional|swap)$/,e6=/url\((.*?)\)/,_ae=new RegExp(e6,"g"),Os={title:"All text remains visible during webfont loads",failureTitle:"Ensure text remains visible during webfont load",description:"Leverage the `font-display` CSS feature to ensure text is user-visible while webfonts are loading. [Learn more about `font-display`](https://developer.chrome.com/docs/lighthouse/performance/font-display/).",undeclaredFontOriginWarning:"{fontCountForOrigin, plural, =1 {Lighthouse was unable to automatically check the `font-display` value for the origin {fontOrigin}.} other {Lighthouse was unable to automatically check the `font-display` values for the origin {fontOrigin}.}}"},Ps=w("core/audits/font-display.js",Os),ZD=class e extends g{static{s(this,"FontDisplay")}static get meta(){return{id:"font-display",title:Ps(Os.title),failureTitle:Ps(Os.failureTitle),description:Ps(Os.description),supportedModes:["navigation"],guidanceLevel:3,requiredArtifacts:["devtoolsLogs","CSSUsage","URL"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS}}static findFontDisplayDeclarations(t,n){let r=new Set,a=new Set;for(let o of t.CSSUsage.stylesheets){let c=o.content.replace(/(\r|\n)+/g," ").match(/@font-face\s*{(.*?)}/g)||[];for(let u of c){let l=u.match(_ae);if(!l)continue;let p=u.match(/font-display\s*:\s*(\w+)\s*(;|\})/)?.[1]||"",f=n.test(p)?r:a,y=l.map(v=>v.match(e6)[1].trim()).map(v=>/^('|").*\1$/.test(v)?v.substr(1,v.length-2):v);for(let v of y)try{let D=Y.isValid(o.header.sourceURL)?o.header.sourceURL:t.URL.finalDisplayedUrl,E=new URL(v,D);f.add(E.href)}catch(D){Rt.captureException(D,{tags:{audit:this.meta.id}})}}}return{passingURLs:r,failingURLs:a}}static getWarningsForFontUrls(t){let n=new Map;for(let a of t){let o=Y.getOrigin(a);if(!o)continue;let i=n.get(o)||0;n.set(o,i+1)}return[...n].map(([a,o])=>Ps(Os.undeclaredFontOriginWarning,{fontCountForOrigin:o,fontOrigin:a}))}static async audit(t,n){let r=t.devtoolsLogs[this.DEFAULT_PASS],a=await H.request(r,n),{passingURLs:o,failingURLs:i}=e.findFontDisplayDeclarations(t,Aae),c=[],u=a.filter(p=>p.resourceType==="Font").filter(p=>!/^data:/.test(p.url)).filter(p=>!/^blob:/.test(p.url)).filter(p=>i.has(p.url)?!0:(o.has(p.url)||c.push(p.url),!1)).map(p=>{let h=Math.min(p.networkEndTime-p.networkRequestTime,3e3);return{url:p.url,wastedMs:h}}),l=[{key:"url",valueType:"url",label:Ps(x.columnURL)},{key:"wastedMs",valueType:"ms",label:Ps(x.columnWastedMs)}],m=g.makeTableDetails(l,u);return{score:+(u.length===0),details:m,warnings:e.getWarningsForFontUrls(c)}}},QD=ZD});var r6={};T(r6,{UIStrings:()=>ni,default:()=>Rae});var ni,Bs,n6,tE,Rae,a6=b(()=>{"use strict";d();V();Ze();A();ni={title:"Displays images with correct aspect ratio",failureTitle:"Displays images with incorrect aspect ratio",description:"Image display dimensions should match natural aspect ratio. [Learn more about image aspect ratio](https://developer.chrome.com/docs/lighthouse/best-practices/image-aspect-ratio/).",columnDisplayed:"Aspect Ratio (Displayed)",columnActual:"Aspect Ratio (Actual)"},Bs=w("core/audits/image-aspect-ratio.js",ni),n6=2,tE=class e extends g{static{s(this,"ImageAspectRatio")}static get meta(){return{id:"image-aspect-ratio",title:Bs(ni.title),failureTitle:Bs(ni.failureTitle),description:Bs(ni.description),requiredArtifacts:["ImageElements"]}}static computeAspectRatios(t){let n=Y.elideDataURI(t.src),r=t.naturalDimensions.width/t.naturalDimensions.height,a=t.displayedWidth/t.displayedHeight,o=t.displayedWidth/r,i=t.displayedHeight*r,c=o<i?Math.abs(o-t.displayedHeight)<n6:Math.abs(i-t.displayedWidth)<n6;return{url:n,node:g.makeNodeItem(t.node),displayedAspectRatio:`${t.displayedWidth} x ${t.displayedHeight}
        (${a.toFixed(2)})`,actualAspectRatio:`${t.naturalDimensions.width} x ${t.naturalDimensions.height}
        (${r.toFixed(2)})`,doRatiosMatch:c}}static audit(t){let n=t.ImageElements,r=[];n.filter(o=>!o.isCss&&Y.guessMimeType(o.src)!=="image/svg+xml"&&o.naturalDimensions&&o.naturalDimensions.height>5&&o.naturalDimensions.width>5&&o.displayedWidth&&o.displayedHeight&&o.computedStyles.objectFit==="fill").forEach(o=>{let i=o,c=e.computeAspectRatios(i);c.doRatiosMatch||r.push(c)});let a=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:Bs(x.columnURL)},{key:"displayedAspectRatio",valueType:"text",label:Bs(ni.columnDisplayed)},{key:"actualAspectRatio",valueType:"text",label:Bs(ni.columnActual)}];return{score:+(r.length===0),details:g.makeTableDetails(a,r)}}},Rae=tE});var i6={};T(i6,{UIStrings:()=>Qa,default:()=>Hae});function Nae(e,t){return(e.bottom-e.top)*(e.right-e.left)>0&&e.top<=t.innerHeight&&e.bottom>=0&&e.left<=t.innerWidth&&e.right>=0}function Mae(e,t){return e.bottom-e.top<=t.innerHeight&&e.right-e.left<=t.innerWidth}function Lae(e){let t=["pixelated","crisp-edges"],n=/ \d+(\.\d+)?x/;return!(e.displayedWidth<=1||e.displayedHeight<=1||!e.naturalDimensions||!e.naturalDimensions.width||!e.naturalDimensions.height||Y.guessMimeType(e.src)==="image/svg+xml"||e.isCss||e.computedStyles.objectFit!=="fill"||t.includes(e.computedStyles.imageRendering)||n.test(e.srcset))}function Pae(e){return!!e.naturalDimensions}function Oae(e,t){let[n,r]=Uae(e.displayedWidth,e.displayedHeight,t);return e.naturalDimensions.width>=n&&e.naturalDimensions.height>=r}function Bae(e,t){let[n,r]=jae(e.displayedWidth,e.displayedHeight,t);return{url:Y.elideDataURI(e.src),node:g.makeNodeItem(e.node),displayedSize:`${e.displayedWidth} x ${e.displayedHeight}`,actualSize:`${e.naturalDimensions.width} x ${e.naturalDimensions.height}`,actualPixels:e.naturalDimensions.width*e.naturalDimensions.height,expectedSize:`${n} x ${r}`,expectedPixels:n*r}}function Uae(e,t,n){let r=Fae;(e>o6||t>o6)&&(r=Iae);let a=rE(n),o=Math.ceil(r*a*e),i=Math.ceil(r*a*t);return[o,i]}function jae(e,t,n){let r=Math.ceil(rE(n)*e),a=Math.ceil(rE(n)*t);return[r,a]}function qae(e){e.sort((n,r)=>n.url===r.url?0:n.url<r.url?-1:1);let t=[];for(let n of e){let r=t[t.length-1];r&&r.url===n.url?r.expectedPixels<n.expectedPixels&&(t[t.length-1]=n):t.push(n)}return t}function zae(e){return e.sort((t,n)=>n.expectedPixels-n.actualPixels-(t.expectedPixels-t.actualPixels))}function rE(e){return e>=2?2:e>=1.5?1.5:1}var Qa,ri,Fae,Iae,o6,nE,Hae,s6=b(()=>{"use strict";d();V();Ze();A();Qa={title:"Serves images with appropriate resolution",failureTitle:"Serves images with low resolution",description:"Image natural dimensions should be proportional to the display size and the pixel ratio to maximize image clarity. [Learn how to provide responsive images](https://web.dev/articles/serve-responsive-images).",columnDisplayed:"Displayed size",columnActual:"Actual size",columnExpected:"Expected size"},ri=w("core/audits/image-size-responsive.js",Qa),Fae=1,Iae=.75,o6=64;s(Nae,"isVisible");s(Mae,"isSmallerThanViewport");s(Lae,"isCandidate");s(Pae,"imageHasNaturalDimensions");s(Oae,"imageHasRightSize");s(Bae,"getResult");s(Uae,"allowedImageSize");s(jae,"expectedImageSize");s(qae,"deduplicateResultsByUrl");s(zae,"sortResultsBySizeDelta");nE=class extends g{static{s(this,"ImageSizeResponsive")}static get meta(){return{id:"image-size-responsive",title:ri(Qa.title),failureTitle:ri(Qa.failureTitle),description:ri(Qa.description),requiredArtifacts:["ImageElements","ViewportDimensions"]}}static audit(t){let n=t.ViewportDimensions.devicePixelRatio,r=Array.from(t.ImageElements).filter(Lae).filter(Pae).filter(i=>!Oae(i,n)).filter(i=>Nae(i.clientRect,t.ViewportDimensions)).filter(i=>Mae(i.clientRect,t.ViewportDimensions)).map(i=>Bae(i,n)),a=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:ri(x.columnURL)},{key:"displayedSize",valueType:"text",label:ri(Qa.columnDisplayed)},{key:"actualSize",valueType:"text",label:ri(Qa.columnActual)},{key:"expectedSize",valueType:"text",label:ri(Qa.columnExpected)}],o=zae(qae(r));return{score:+(r.length===0),details:g.makeTableDetails(a,o)}}};s(rE,"quantizeDpr");Hae=nE});function Id(e){return!(!e||!e.icons||e.icons.value.length===0)}function aE(e,t){let n=t.icons.value,r=[];return n.filter(a=>{let o=a.value.type.value;if(o)return o==="image/png";let i=a.value.src.value;return i&&new URL(i).pathname.endsWith(".png")}).forEach(a=>{a.value.sizes.value&&r.push(...a.value.sizes.value)}),r.filter(a=>/\d+x\d+/.test(a)).filter(a=>{let o=a.split(/x/i),i=[parseFloat(o[0]),parseFloat(o[1])],c=i[0]>=e&&i[1]>=e,u=i[0]===i[1];return c&&u})}function c6(e){return e.icons.value.some(n=>n.value.purpose?.value&&n.value.purpose.value.includes("maskable"))}var u6=b(()=>{"use strict";d();s(Id,"doExist");s(aE,"pngSizedAtLeast");s(c6,"containsMaskableIcon")});var l6,d6,oE,eo,Nd=b(()=>{"use strict";d();ue();u6();l6=["minimal-ui","fullscreen","standalone"],d6=12,oE=class e{static{s(this,"ManifestValues")}static get manifestChecks(){return[{id:"hasStartUrl",failureText:"Manifest does not contain a `start_url`",validate:t=>!!t.start_url.value},{id:"hasIconsAtLeast144px",failureText:"Manifest does not have a PNG icon of at least 144px",validate:t=>Id(t)&&aE(144,t).length>0},{id:"hasIconsAtLeast512px",failureText:"Manifest does not have a PNG icon of at least 512px",validate:t=>Id(t)&&aE(512,t).length>0},{id:"fetchesIcon",failureText:"Manifest icon failed to be fetched",validate:(t,n)=>{let r=["cannot-download-icon","no-icon-available"];return Id(t)&&!n.some(a=>r.includes(a.errorId))}},{id:"hasPWADisplayValue",failureText:"Manifest's `display` value is not one of: "+l6.join(" | "),validate:t=>l6.includes(t.display.value)},{id:"hasBackgroundColor",failureText:"Manifest does not have `background_color`",validate:t=>!!t.background_color.value},{id:"hasThemeColor",failureText:"Manifest does not have `theme_color`",validate:t=>!!t.theme_color.value},{id:"hasShortName",failureText:"Manifest does not have `short_name`",validate:t=>!!t.short_name.value},{id:"shortNameLength",failureText:`Manifest's \`short_name\` is too long (>${d6} characters) to be displayed on a homescreen without truncation`,validate:t=>!!t.short_name.value&&t.short_name.value.length<=d6},{id:"hasName",failureText:"Manifest does not have `name`",validate:t=>!!t.name.value},{id:"hasMaskableIcon",failureText:"Manifest does not have at least one icon that is maskable",validate:t=>Id(t)&&c6(t)}]}static async compute_({WebAppManifest:t,InstallabilityErrors:n}){if(t===null)return{isParseFailure:!0,parseFailureReason:"No manifest was fetched",allChecks:[]};let r=t.value;return r===void 0?{isParseFailure:!0,parseFailureReason:"Manifest failed to parse as valid JSON",allChecks:[]}:{isParseFailure:!1,allChecks:e.manifestChecks.map(o=>({id:o.id,failureText:o.failureText,passing:o.validate(r,n.errors)}))}}},eo=q(oE,["InstallabilityErrors","WebAppManifest"])});var m6={};T(m6,{UIStrings:()=>Br,default:()=>Vae});var Br,pa,iE,Vae,p6=b(()=>{"use strict";d();V();A();Nd();Br={title:"Web app manifest and service worker meet the installability requirements",failureTitle:"Web app manifest or service worker do not meet the installability requirements",description:"Service worker is the technology that enables your app to use many Progressive Web App features, such as offline, add to homescreen, and push notifications. With proper service worker and manifest implementations, browsers can proactively prompt users to add your app to their homescreen, which can lead to higher engagement. [Learn more about manifest installability requirements](https://developer.chrome.com/docs/lighthouse/pwa/installable-manifest/).",columnValue:"Failure reason",displayValue:`{itemCount, plural,
    =1 {1 reason}
    other {# reasons}
    }`,noErrorId:"Installability error id '{errorId}' is not recognized","not-in-main-frame":"Page is not loaded in the main frame","not-from-secure-origin":"Page is not served from a secure origin","no-manifest":"Page has no manifest <link> URL","start-url-not-valid":"Manifest start URL is not valid","manifest-missing-name-or-short-name":"Manifest does not contain a `name` or `short_name` field","manifest-display-not-supported":"Manifest `display` property must be one of `standalone`, `fullscreen`, or `minimal-ui`","manifest-empty":"Manifest could not be fetched, is empty, or could not be parsed","manifest-missing-suitable-icon":'Manifest does not contain a suitable icon - PNG, SVG or WebP format of at least {value0} px is required, the sizes attribute must be set, and the purpose attribute, if set, must include "any".',"no-acceptable-icon":'No supplied icon is at least {value0} px square in PNG, SVG or WebP format, with the purpose attribute unset or set to "any"',"cannot-download-icon":"Could not download a required icon from the manifest","no-icon-available":"Downloaded icon was empty or corrupted","platform-not-supported-on-android":"The specified application platform is not supported on Android","no-id-specified":"No Play store ID provided","ids-do-not-match":"The Play Store app URL and Play Store ID do not match","already-installed":"The app is already installed","url-not-supported-for-webapk":"A URL in the manifest contains a username, password, or port","in-incognito":"Page is loaded in an incognito window","not-offline-capable":"Page does not work offline","no-url-for-service-worker":"Could not check service worker without a 'start_url' field in the manifest","prefer-related-applications":"Manifest specifies prefer_related_applications: true","prefer-related-applications-only-beta-stable":"prefer_related_applications is only supported on Chrome Beta and Stable channels on Android.","manifest-display-override-not-supported":"Manifest contains 'display_override' field, and the first supported display mode must be one of 'standalone', 'fullscreen', or 'minimal-ui'","manifest-location-changed":"Manifest URL changed while the manifest was being fetched.","warn-not-offline-capable":"Page does not work offline. The page will not be regarded as installable after Chrome 93, stable release August 2021.","protocol-timeout":"Lighthouse could not determine if the page is installable. Please try with a newer version of Chrome.","pipeline-restarted":"PWA has been uninstalled and installability checks resetting."},pa=w("core/audits/installable-manifest.js",Br),iE=class e extends g{static{s(this,"InstallableManifest")}static get meta(){return{id:"installable-manifest",title:pa(Br.title),failureTitle:pa(Br.failureTitle),description:pa(Br.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors"]}}static getInstallabilityErrors(t){let n=t.InstallabilityErrors.errors,r=[],a=[],o=/{([^}]+)}/g;for(let i of n){if(i.errorId==="in-incognito")continue;if(i.errorId==="warn-not-offline-capable"){a.push(pa(Br[i.errorId]));continue}if(i.errorId==="pipeline-restarted")continue;let c=Br[i.errorId];if(c===void 0){r.push(pa(Br.noErrorId,{errorId:i.errorId}));continue}let u=c.match(o)||[],l=i.errorArguments?.length&&i.errorArguments[0].value;if(c&&i.errorArguments.length!==u.length){let m=JSON.stringify(i.errorArguments),p=i.errorArguments.length>u.length?`${i.errorId} has unexpected arguments ${m}`:`${i.errorId} does not have the expected number of arguments.`;r.push(p)}else c&&l?r.push(pa(c,{value0:l})):c&&r.push(pa(c))}return{i18nErrors:r,warnings:a}}static async audit(t,n){let{i18nErrors:r,warnings:a}=e.getInstallabilityErrors(t),o=t.WebAppManifest?t.WebAppManifest.url:null,i=[{key:"reason",valueType:"text",label:pa(Br.columnValue)}],c=r.map(l=>({reason:l}));if(!c.length){let l=await eo.request(t,n);l.isParseFailure&&c.push({reason:l.parseFailureReason})}let u={type:"debugdata",manifestUrl:o};return c.length>0?{score:0,warnings:a,numericValue:c.length,numericUnit:"element",displayValue:pa(Br.displayValue,{itemCount:c.length}),details:{...g.makeTableDetails(i,c),debugData:u}}:{score:1,warnings:a,details:{...g.makeTableDetails(i,c),debugData:u}}}},Vae=iE});var h6={};T(h6,{UIStrings:()=>Xn,default:()=>Wae});var Xn,f6,to,sE,Wae,g6=b(()=>{"use strict";d();V();Ze();lt();de();A();Xn={title:"Uses HTTPS",failureTitle:"Does not use HTTPS",description:"All sites should be protected with HTTPS, even ones that don't handle sensitive data. This includes avoiding [mixed content](https://developers.google.com/web/fundamentals/security/prevent-mixed-content/what-is-mixed-content), where some resources are loaded over HTTP despite the initial request being served over HTTPS. HTTPS prevents intruders from tampering with or passively listening in on the communications between your app and your users, and is a prerequisite for HTTP/2 and many new web platform APIs. [Learn more about HTTPS](https://developer.chrome.com/docs/lighthouse/pwa/is-on-https/).",displayValue:`{itemCount, plural,
    =1 {1 insecure request found}
    other {# insecure requests found}
    }`,columnInsecureURL:"Insecure URL",columnResolution:"Request Resolution",allowed:"Allowed",blocked:"Blocked",warning:"Allowed with warning",upgraded:"Automatically upgraded to HTTPS"},f6={MixedContentAutomaticallyUpgraded:Xn.upgraded,MixedContentBlocked:Xn.blocked,MixedContentWarning:Xn.warning},to=w("core/audits/is-on-https.js",Xn),sE=class extends g{static{s(this,"HTTPS")}static get meta(){return{id:"is-on-https",title:to(Xn.title),failureTitle:to(Xn.failureTitle),description:to(Xn.description),requiredArtifacts:["devtoolsLogs","InspectorIssues"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],o=(await H.request(r,n)).filter(l=>!G.isSecureRequest(l)).map(l=>Y.elideDataURI(l.url)),i=Array.from(new Set(o)).map(l=>({url:l,resolution:void 0})),c=[{key:"url",valueType:"url",label:to(Xn.columnInsecureURL)},{key:"resolution",valueType:"text",label:to(Xn.columnResolution)}];for(let l of t.InspectorIssues.mixedContentIssue){let m=i.find(p=>p.url===l.insecureURL);m||(m={url:l.insecureURL},i.push(m)),m.resolution=f6[l.resolutionStatus]?to(f6[l.resolutionStatus]):l.resolutionStatus}for(let l of i)l.resolution||(l.resolution=to(Xn.allowed));let u;return i.length>0&&(u=to(Xn.displayValue,{itemCount:i.length})),{score:+(i.length===0),displayValue:u,details:g.makeTableDetails(c,i)}}},Wae=sE});var cE,Ur,Us=b(()=>{"use strict";d();ue();Rr();It();Ko();cE=class extends pt{static{s(this,"LargestContentfulPaint")}static computeSimulatedMetric(t,n){let r=pt.getMetricComputationInput(t);return $n.request(r,n)}static async computeObservedMetric(t){let{processedNavigation:n}=t;if(n.timings.largestContentfulPaint===void 0)throw new j(j.errors.NO_LCP);return{timing:n.timings.largestContentfulPaint,timestamp:n.timestamps.largestContentfulPaint}}},Ur=q(cE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var y6={};T(y6,{UIStrings:()=>dE,default:()=>mE});var dE,uE,lE,mE,pE=b(()=>{"use strict";d();V();A();Us();dE={description:"Largest Contentful Paint marks the time at which the largest text or image is painted. [Learn more about the Largest Contentful Paint metric](https://developer.chrome.com/docs/lighthouse/performance/lighthouse-largest-contentful-paint/)"},uE=w("core/audits/metrics/largest-contentful-paint.js",dE),lE=class extends g{static{s(this,"LargestContentfulPaint")}static get meta(){return{id:"largest-contentful-paint",title:uE(x.largestContentfulPaintMetric),description:uE(dE.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["HostUserAgent","traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:2500,median:4e3}},desktop:{scoring:{p10:1200,median:2400}}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.GatherContext,i={trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL},c=await Ur.request(i,n),u=n.options[n.settings.formFactor];return{score:g.computeLogNormalScore(u.scoring,c.timing),scoringOptions:u.scoring,numericValue:c.timing,numericUnit:"millisecond",displayValue:uE(x.seconds,{timeInMs:c.timing})}}},mE=lE});var fE,Bf,hE=b(()=>{"use strict";d();ue();Rr();Bt();jo();fE=class extends pt{static{s(this,"TimeToFirstByte")}static async computeSimulatedMetric(t,n){let r=await _e.request(t,n),a=await ar.request(t.devtoolsLog,n),o=(await this.computeObservedMetric(t,n)).timing,i=a.serverResponseTimeByOrigin.get(r.parsedURL.securityOrigin);if(i===void 0)throw new Error("No response time for origin");let c=2;r.protocol.startsWith("h3")||(c+=1),r.parsedURL.scheme==="https"&&(c+=1);let u=t.settings.throttling.rttMs*c+i;return{timing:Math.max(o,u)}}static async computeObservedMetric(t,n){let r=await _e.request(t,n);if(!r.timing)throw new Error("missing timing for main resource");let{processedNavigation:a}=t,o=a.timestamps.timeOrigin,c=(r.timing.requestTime*1e3+r.timing.receiveHeadersStart)*1e3;return{timing:(c-o)/1e3,timestamp:c}}},Bf=q(fE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var gE,js,Uf=b(()=>{"use strict";d();ue();It();Us();sr();hE();af();gE=class{static{s(this,"LCPBreakdown")}static async compute_(t,n){let r=await zt.request(t.trace,n),a=r.timings.largestContentfulPaint;if(a===void 0)throw new j(j.errors.NO_LCP);let o=r.timestamps.timeOrigin/1e3,{timing:i}=await Bf.request(t,n),c=await bs.request(t,n);if(!c)return{ttfb:i};let{timing:u}=await Ur.request(t,n),l=u/a,m=(c.networkRequestTime-o)*l,p=Math.max(i,Math.min(m,u)),h=(c.networkEndTime-o)*l,f=Math.max(p,Math.min(h,u));return{ttfb:i,loadStart:p,loadEnd:f}}},js=q(gE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var b6={};T(b6,{UIStrings:()=>mr,default:()=>$ae});var mr,dr,yE,$ae,v6=b(()=>{"use strict";d();Ae();V();A();Us();pE();Uf();or();mr={title:"Largest Contentful Paint element",description:"This is the largest contentful element painted within the viewport. [Learn more about the Largest Contentful Paint element](https://developer.chrome.com/docs/lighthouse/performance/lighthouse-largest-contentful-paint/)",columnPhase:"Phase",columnPercentOfLCP:"% of LCP",columnTiming:"Timing",itemTTFB:"TTFB",itemLoadDelay:"Load Delay",itemLoadTime:"Load Time",itemRenderDelay:"Render Delay"},dr=w("core/audits/largest-contentful-paint-element.js",mr),yE=class extends g{static{s(this,"LargestContentfulPaintElement")}static get meta(){return{id:"largest-contentful-paint-element",title:dr(mr.title),description:dr(mr.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:1,supportedModes:["navigation"],requiredArtifacts:["traces","TraceElements","devtoolsLogs","GatherContext","settings","URL"]}}static makeElementTable(t){let n=t.TraceElements.find(o=>o.traceEventType==="largest-contentful-paint");if(!n)return;let r=[{key:"node",valueType:"node",label:dr(x.columnElement)}],a=[{node:g.makeNodeItem(n.node)}];return g.makeTableDetails(r,a)}static async makePhaseTable(t,n,r){let{ttfb:a,loadStart:o,loadEnd:i}=await js.request(n,r),c=0,u=0,l=t-a;o&&i&&(c=o-a,u=i-o,l=t-i);let m=[{phase:dr(mr.itemTTFB),timing:a},{phase:dr(mr.itemLoadDelay),timing:c},{phase:dr(mr.itemLoadTime),timing:u},{phase:dr(mr.itemRenderDelay),timing:l}].map(h=>{let y=`${(100*h.timing/t).toFixed(0)}%`;return{...h,percent:y}}),p=[{key:"phase",valueType:"text",label:dr(mr.columnPhase)},{key:"percent",valueType:"text",label:dr(mr.columnPercentOfLCP)},{key:"timing",valueType:"ms",label:dr(mr.columnTiming)}];return g.makeTableDetails(p,m)}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.GatherContext,i={trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL},c=this.makeElementTable(t);if(!c)return{score:null,notApplicable:!0,metricSavings:{LCP:0}};let u=[c],l,m=0;try{m=(await Ur.request(i,n)).timing,l=dr(x.ms,{timeInMs:m});let v=await this.makePhaseTable(m,i,n);u.push(v)}catch(y){Rt.captureException(y,{tags:{audit:this.meta.id},level:"error"}),F.error(this.meta.id,y.message)}let p=g.makeListDetails(u),h=mE.defaultOptions[n.settings.formFactor].scoring.p10,f=Math.max(0,m-h);return{score:f?0:1,scoreDisplayMode:f?void 0:g.SCORING_MODES.INFORMATIVE,displayValue:l,details:p,metricSavings:{LCP:f}}}},$ae=yE});var D6={};T(D6,{UIStrings:()=>vE,default:()=>wE});var vE,w6,bE,wE,DE=b(()=>{"use strict";d();V();Wu();A();vE={description:"Cumulative Layout Shift measures the movement of visible elements within the viewport. [Learn more about the Cumulative Layout Shift metric](https://web.dev/articles/cls)."},w6=w("core/audits/metrics/cumulative-layout-shift.js",vE),bE=class extends g{static{s(this,"CumulativeLayoutShift")}static get meta(){return{id:"cumulative-layout-shift",title:w6(x.cumulativeLayoutShiftMetric),description:w6(vE.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,requiredArtifacts:["traces"]}}static get defaultOptions(){return{p10:.1,median:.25}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],{cumulativeLayoutShift:a,impactByNodeId:o,...i}=await qa.request(r,n),c={type:"debugdata",items:[i]},u={p10:n.options.p10,median:n.options.median};return{score:g.computeLogNormalScore(u,a),scoringOptions:u,numericValue:a,numericUnit:"unitless",displayValue:a.toLocaleString(n.settings.locale),details:c}}},wE=bE});var E6={};T(E6,{UIStrings:()=>Md,default:()=>Yae});var Md,qs,EE,Yae,x6=b(()=>{"use strict";d();V();A();Wu();DE();Md={title:"Avoid large layout shifts",description:"These DOM elements were most affected by layout shifts. Some layout shifts may not be included in the CLS metric value due to [windowing](https://web.dev/articles/cls#what_is_cls). [Learn how to improve CLS](https://web.dev/articles/optimize-cls)",columnContribution:"Layout shift impact"},qs=w("core/audits/layout-shift-elements.js",Md),EE=class extends g{static{s(this,"LayoutShiftElements")}static get meta(){return{id:"layout-shift-elements",title:qs(Md.title),description:qs(Md.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:2,requiredArtifacts:["traces","TraceElements"]}}static async audit(t,n){let{cumulativeLayoutShift:r,impactByNodeId:a}=await qa.request(t.traces[g.DEFAULT_PASS],n),o=t.TraceElements.filter(m=>m.traceEventType==="layout-shift").map(m=>({node:g.makeNodeItem(m.node),score:a.get(m.nodeId)||0}));if(o.length<a.size){let m=o.reduce((h,{score:f})=>h+=f,0),p=Array.from(a.values()).reduce((h,f)=>h+f);o.push({node:{type:"code",value:qs(x.otherResourceType)},score:p-m})}let i=[{key:"node",valueType:"node",label:qs(x.columnElement)},{key:"score",valueType:"numeric",granularity:.001,label:qs(Md.columnContribution)}],c=g.makeTableDetails(i,o),u;a.size>0&&(u=qs(x.displayValueElementsFound,{nodeCount:a.size}));let l=r<=wE.defaultOptions.p10;return{score:l?1:0,scoreDisplayMode:l?g.SCORING_MODES.INFORMATIVE:void 0,metricSavings:{CLS:r},notApplicable:c.items.length===0,displayValue:u,details:c}}},Yae=EE});var T6={};T(T6,{UIStrings:()=>Ld,default:()=>Xae});var Ld,jf,Kae,xE,Xae,S6=b(()=>{"use strict";d();V();A();Uf();Us();Ld={title:"Largest Contentful Paint image was not lazily loaded",failureTitle:"Largest Contentful Paint image was lazily loaded",description:"Above-the-fold images that are lazily loaded render later in the page lifecycle, which can delay the largest contentful paint. [Learn more about optimal lazy loading](https://web.dev/articles/lcp-lazy-loading)."},jf=w("core/audits/lcp-lazy-loaded.js",Ld),Kae=.15,xE=class extends g{static{s(this,"LargestContentfulPaintLazyLoaded")}static get meta(){return{id:"lcp-lazy-loaded",title:jf(Ld.title),failureTitle:jf(Ld.failureTitle),description:jf(Ld.description),supportedModes:["navigation"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:3,requiredArtifacts:["TraceElements","ViewportDimensions","ImageElements","traces","devtoolsLogs","GatherContext","URL"]}}static isImageInViewport(t,n){let r=t.clientRect.top,a=n.innerHeight;return r<a}static async audit(t,n){let r=t.TraceElements.find(h=>h.traceEventType==="largest-contentful-paint"&&h.type==="image"),a=r?t.ImageElements.find(h=>h.node.devtoolsNodePath===r.node.devtoolsNodePath):void 0;if(!a||!this.isImageInViewport(a,t.ViewportDimensions))return{score:null,notApplicable:!0,metricSavings:{LCP:0}};let o=[{key:"node",valueType:"node",label:jf(x.columnElement)}],i=g.makeTableDetails(o,[{node:g.makeNodeItem(a.node)}]),c=a.loading==="lazy",u=g.makeMetricComputationDataInput(t,n),{timing:l}=await Ur.request(u,n),m=await js.request(u,n),p=0;if(c&&m.loadStart!==void 0){let h=m.loadStart-m.ttfb;p=Math.min(l*Kae,h)}return{score:c?0:1,metricSavings:{LCP:p},details:i}}},Xae=xE});var k6={};T(k6,{UIStrings:()=>Pd,default:()=>eoe});function Qae(e,t){let n=e.indexOf(t);return n>-1?n:e.push(t)-1}function TE(e){return Math.round(e*10)/10}var Jae,Zae,Pd,zs,SE,eoe,C6=b(()=>{"use strict";d();V();de();A();za();Nn();Gn();nd();ys();Jae={startTime:0,endTime:0,duration:0},Zae=20,Pd={title:"Avoid long main-thread tasks",description:"Lists the longest tasks on the main thread, useful for identifying worst contributors to input delay. [Learn how to avoid long main-thread tasks](https://web.dev/articles/long-tasks-devtools)",displayValue:`{itemCount, plural,
  =1 {# long task found}
  other {# long tasks found}
  }`},zs=w("core/audits/long-tasks.js",Pd);s(Qae,"insertUrl");s(TE,"roundTenths");SE=class e extends g{static{s(this,"LongTasks")}static get meta(){return{id:"long-tasks",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:zs(Pd.title),description:zs(Pd.description),requiredArtifacts:["traces","devtoolsLogs","URL","GatherContext"],guidanceLevel:1}}static getTimingBreakdown(t,n,r=new Map){let a=e.getTiming(t,n),o=0;if(a.duration>0)for(let u of t.children){let{duration:l}=e.getTimingBreakdown(u,n,r);o+=l}let i=a.duration-o,c=r.get(t.group.id)||0;return r.set(t.group.id,c+i),{startTime:a.startTime,duration:a.duration,timeByTaskGroup:r}}static makeDebugData(t,n,r){let a=[],o=[];for(let i of t){let c=ps(i,n),{startTime:u,duration:l,timeByTaskGroup:m}=e.getTimingBreakdown(i,r),p=[...m].map(([h,f])=>[h,TE(f)]).sort((h,f)=>h[0].localeCompare(f[0]));o.push({urlIndex:Qae(a,c),startTime:TE(u),duration:TE(l),...Object.fromEntries(p)})}return{type:"debugdata",urls:a,tasks:o}}static getTiming(t,n){let r=t;n&&(r=n.get(t.event)||Jae);let{duration:a,startTime:o}=r;return{duration:a,startTime:o}}static async audit(t,n){let r=n.settings||{},a=t.URL,o=t.traces[g.DEFAULT_PASS],i=await Cn.request(o,n),c=t.devtoolsLogs[e.DEFAULT_PASS],u=await H.request(c,n),l=g.makeMetricComputationDataInput(t,n),m=await Ir.request(l,n),p;if(r.throttlingMethod==="simulate"){p=new Map;let S={devtoolsLog:c,settings:n.settings},k=await xt.request({trace:o,devtoolsLog:c,URL:a},n),R=await(await Pt.request(S,n)).simulate(k,{label:"long-tasks-diagnostic"});for(let[z,B]of R.nodeTimings.entries())z.type==="cpu"&&p.set(z.event,B)}let h=td(u),f=i.map(S=>{let{duration:k}=e.getTiming(S,p);return{task:S,duration:k}}).filter(({task:S,duration:k})=>k>=50&&!S.unbounded&&!S.parent).sort((S,k)=>k.duration-S.duration).map(({task:S})=>S),y=f.map(S=>{let k=e.getTiming(S,p);return{url:ps(S,h),duration:k.duration,startTime:k.startTime}}).slice(0,Zae),v=[{key:"url",valueType:"url",label:zs(x.columnURL)},{key:"startTime",valueType:"ms",granularity:1,label:zs(x.columnStartTime)},{key:"duration",valueType:"ms",granularity:1,label:zs(x.columnDuration)}],D=g.makeTableDetails(v,y,{sortedBy:["duration"],skipSumming:["startTime"]});D.debugData=e.makeDebugData(f,h,p);let E;return y.length>0&&(E=zs(Pd.displayValue,{itemCount:y.length})),{score:y.length===0?1:0,notApplicable:y.length===0,details:D,displayValue:E,metricSavings:{TBT:m.timing}}}},eoe=SE});var A6={};T(A6,{default:()=>toe});var kE,toe,_6=b(()=>{"use strict";d();V();za();kE=class extends g{static{s(this,"MainThreadTasks")}static get meta(){return{id:"main-thread-tasks",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:"Tasks",description:"Lists the toplevel main thread tasks that executed during page load.",requiredArtifacts:["traces"]}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],o=(await Cn.request(r,n)).filter(u=>u.duration>5&&!u.parent).map(u=>({duration:u.duration,startTime:u.startTime})),i=[{key:"startTime",valueType:"ms",granularity:1,label:"Start Time"},{key:"duration",valueType:"ms",granularity:1,label:"End Time"}];return{score:1,details:g.makeTableDetails(i,o)}}},toe=kE});var R6={};T(R6,{UIStrings:()=>Gs,default:()=>noe});var Gs,Hs,CE,noe,F6=b(()=>{"use strict";d();Ae();V();ed();A();za();ys();or();Fn();Gs={title:"Minimizes main-thread work",failureTitle:"Minimize main-thread work",description:"Consider reducing the time spent parsing, compiling and executing JS. You may find delivering smaller JS payloads helps with this. [Learn how to minimize main-thread work](https://developer.chrome.com/docs/lighthouse/performance/mainthread-work-breakdown/)",columnCategory:"Category"},Hs=w("core/audits/mainthread-work-breakdown.js",Gs),CE=class e extends g{static{s(this,"MainThreadWorkBreakdown")}static get meta(){return{id:"mainthread-work-breakdown",title:Hs(Gs.title),failureTitle:Hs(Gs.failureTitle),description:Hs(Gs.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,guidanceLevel:1,requiredArtifacts:["traces","devtoolsLogs","URL","GatherContext"]}}static get defaultOptions(){return{p10:2017,median:4e3}}static getExecutionTimingsByGroup(t){let n=new Map;for(let r of t){let a=n.get(r.group.id)||0;n.set(r.group.id,a+r.selfTime)}return n}static async audit(t,n){let r=n.settings||{},a=t.traces[e.DEFAULT_PASS],o=0;try{let v=g.makeMetricComputationDataInput(t,n);o=(await Ir.request(v,n)).timing}catch(v){Rt.captureException(v,{tags:{audit:this.meta.id},level:"error"}),F.error(this.meta.id,v.message)}let i=await Cn.request(a,n),c=r.throttlingMethod==="simulate"?r.throttling.cpuSlowdownMultiplier:1,u=e.getExecutionTimingsByGroup(i),l=0,m={},p=Array.from(u).map(([v,D])=>{let E=D*c;l+=E;let S=m[v]||0;return m[v]=S+E,{group:v,groupLabel:vn[v].label,duration:E}}),h=[{key:"groupLabel",valueType:"text",label:Hs(Gs.columnCategory)},{key:"duration",valueType:"ms",granularity:1,label:Hs(x.columnTimeSpent)}];p.sort((v,D)=>m[D.group]-m[v.group]);let f=e.makeTableDetails(h,p,{sortedBy:["duration"]}),y=g.computeLogNormalScore({p10:n.options.p10,median:n.options.median},l);return{score:y,scoreDisplayMode:y>=Me.PASS_THRESHOLD?g.SCORING_MODES.INFORMATIVE:void 0,numericValue:l,numericUnit:"millisecond",displayValue:Hs(x.seconds,{timeInMs:l}),details:f,metricSavings:{TBT:o}}}},noe=CE});var N6={};T(N6,{UIStrings:()=>qf,default:()=>roe});var qf,I6,AE,roe,M6=b(()=>{"use strict";d();yn();A();qf={title:"Site works cross-browser",description:"To reach the most number of users, sites should work across every major browser. [Learn about cross-browser compatibility](https://developer.chrome.com/docs/lighthouse/pwa/pwa-cross-browser/)."},I6=w("core/audits/manual/pwa-cross-browser.js",qf),AE=class extends ot{static{s(this,"PWACrossBrowser")}static get meta(){return Object.assign({id:"pwa-cross-browser",title:I6(qf.title),description:I6(qf.description)},super.partialMeta)}},roe=AE});var P6={};T(P6,{UIStrings:()=>zf,default:()=>aoe});var zf,L6,_E,aoe,O6=b(()=>{"use strict";d();yn();A();zf={title:"Each page has a URL",description:"Ensure individual pages are deep linkable via URL and that URLs are unique for the purpose of shareability on social media. [Learn more about providing deep links](https://developer.chrome.com/docs/lighthouse/pwa/pwa-each-page-has-url/)."},L6=w("core/audits/manual/pwa-each-page-has-url.js",zf),_E=class extends ot{static{s(this,"PWAEachPageHasURL")}static get meta(){return Object.assign({id:"pwa-each-page-has-url",title:L6(zf.title),description:L6(zf.description)},super.partialMeta)}},aoe=_E});var U6={};T(U6,{UIStrings:()=>Hf,default:()=>ooe});var Hf,B6,RE,ooe,j6=b(()=>{"use strict";d();yn();A();Hf={title:"Page transitions don't feel like they block on the network",description:"Transitions should feel snappy as you tap around, even on a slow network. This experience is key to a user's perception of performance. [Learn more about page transitions](https://developer.chrome.com/docs/lighthouse/pwa/pwa-page-transitions/)."},B6=w("core/audits/manual/pwa-page-transitions.js",Hf),RE=class extends ot{static{s(this,"PWAPageTransitions")}static get meta(){return Object.assign({id:"pwa-page-transitions",title:B6(Hf.title),description:B6(Hf.description)},super.partialMeta)}},ooe=RE});var q6={};T(q6,{UIStrings:()=>Od,default:()=>ioe});var Od,FE,IE,ioe,z6=b(()=>{"use strict";d();V();Nd();A();Od={title:"Manifest has a maskable icon",failureTitle:"Manifest doesn't have a maskable icon",description:"A maskable icon ensures that the image fills the entire shape without being letterboxed when installing the app on a device. [Learn about maskable manifest icons](https://developer.chrome.com/docs/lighthouse/pwa/maskable-icon-audit/)."},FE=w("core/audits/maskable-icon.js",Od),IE=class extends g{static{s(this,"MaskableIcon")}static get meta(){return{id:"maskable-icon",title:FE(Od.title),failureTitle:FE(Od.failureTitle),description:FE(Od.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors"]}}static async audit(t,n){let r=await eo.request(t,n);return r.isParseFailure?{score:0,explanation:r.parseFailureReason}:{score:r.allChecks.find(o=>o.id==="hasMaskableIcon")?.passing?1:0}}},ioe=IE});var H6=I((e6e,Gf)=>{d();var ai=(Jr(),Q9(P2));if(ai&&ai.default){Gf.exports=ai.default;for(let e in ai)Gf.exports[e]=ai[e]}else ai&&(Gf.exports=ai)});var W6=I((n6e,Vf)=>{d();var V6=V6||function(e){return Buffer.from(e).toString("base64")};function soe(e){var t=this,n=Math.round,r=Math.floor,a=new Array(64),o=new Array(64),i=new Array(64),c=new Array(64),u,l,m,p,h=new Array(65535),f=new Array(65535),y=new Array(64),v=new Array(64),D=[],E=0,S=7,k=new Array(64),C=new Array(64),R=new Array(64),z=new Array(256),B=new Array(2048),J,ne=[0,1,5,6,14,15,27,28,2,4,7,13,16,26,29,42,3,8,12,17,25,30,41,43,9,11,18,24,31,40,44,53,10,19,23,32,39,45,52,54,20,22,33,38,46,51,55,60,21,34,37,47,50,56,59,61,35,36,48,49,57,58,62,63],K=[0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0],oe=[0,1,2,3,4,5,6,7,8,9,10,11],Re=[0,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,125],ce=[1,2,3,0,4,17,5,18,33,49,65,6,19,81,97,7,34,113,20,50,129,145,161,8,35,66,177,193,21,82,209,240,36,51,98,114,130,9,10,22,23,24,25,26,37,38,39,40,41,42,52,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,225,226,227,228,229,230,231,232,233,234,241,242,243,244,245,246,247,248,249,250],gt=[0,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0],pe=[0,1,2,3,4,5,6,7,8,9,10,11],Te=[0,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,119],ut=[0,1,2,3,17,4,5,33,49,6,18,65,81,7,97,113,19,34,50,129,8,20,66,145,161,177,193,9,35,51,82,240,21,98,114,209,10,22,36,52,225,37,241,23,24,25,26,38,39,40,41,42,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,130,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,226,227,228,229,230,231,232,233,234,242,243,244,245,246,247,248,249,250];function Qe(P){for(var ie=[16,11,10,16,24,40,51,61,12,12,14,19,26,58,60,55,14,13,16,24,40,57,69,56,14,17,22,29,51,87,80,62,18,22,37,56,68,109,103,77,24,35,55,64,81,104,113,92,49,64,78,87,103,121,120,101,72,92,95,98,112,100,103,99],ge=0;ge<64;ge++){var le=r((ie[ge]*P+50)/100);le<1?le=1:le>255&&(le=255),a[ne[ge]]=le}for(var Ce=[17,18,24,47,99,99,99,99,18,21,26,66,99,99,99,99,24,26,56,99,99,99,99,99,47,66,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99],Fe=0;Fe<64;Fe++){var We=r((Ce[Fe]*P+50)/100);We<1?We=1:We>255&&(We=255),o[ne[Fe]]=We}for(var $e=[1,1.387039845,1.306562965,1.175875602,1,.785694958,.5411961,.275899379],Ct=0,mt=0;mt<8;mt++)for(var W=0;W<8;W++)i[Ct]=1/(a[ne[Ct]]*$e[mt]*$e[W]*8),c[Ct]=1/(o[ne[Ct]]*$e[mt]*$e[W]*8),Ct++}s(Qe,"initQuantTables");function je(P,ie){for(var ge=0,le=0,Ce=new Array,Fe=1;Fe<=16;Fe++){for(var We=1;We<=P[Fe];We++)Ce[ie[le]]=[],Ce[ie[le]][0]=ge,Ce[ie[le]][1]=Fe,le++,ge++;ge*=2}return Ce}s(je,"computeHuffmanTbl");function Ut(){u=je(K,oe),l=je(gt,pe),m=je(Re,ce),p=je(Te,ut)}s(Ut,"initHuffmanTbl");function Ye(){for(var P=1,ie=2,ge=1;ge<=15;ge++){for(var le=P;le<ie;le++)f[32767+le]=ge,h[32767+le]=[],h[32767+le][1]=ge,h[32767+le][0]=le;for(var Ce=-(ie-1);Ce<=-P;Ce++)f[32767+Ce]=ge,h[32767+Ce]=[],h[32767+Ce][1]=ge,h[32767+Ce][0]=ie-1+Ce;P<<=1,ie<<=1}}s(Ye,"initCategoryNumber");function ze(){for(var P=0;P<256;P++)B[P]=19595*P,B[P+256>>0]=38470*P,B[P+512>>0]=7471*P+32768,B[P+768>>0]=-11059*P,B[P+1024>>0]=-21709*P,B[P+1280>>0]=32768*P+8421375,B[P+1536>>0]=-27439*P,B[P+1792>>0]=-5329*P}s(ze,"initRGBYUVTable");function Ne(P){for(var ie=P[0],ge=P[1]-1;ge>=0;)ie&1<<ge&&(E|=1<<S),ge--,S--,S<0&&(E==255?(O(255),O(0)):O(E),S=7,E=0)}s(Ne,"writeBits");function O(P){D.push(P)}s(O,"writeByte");function se(P){O(P>>8&255),O(P&255)}s(se,"writeWord");function nt(P,ie){var ge,le,Ce,Fe,We,$e,Ct,mt,W=0,re,Ee=8,wt=64;for(re=0;re<Ee;++re){ge=P[W],le=P[W+1],Ce=P[W+2],Fe=P[W+3],We=P[W+4],$e=P[W+5],Ct=P[W+6],mt=P[W+7];var Ie=ge+mt,qe=ge-mt,at=le+Ct,we=le-Ct,Je=Ce+$e,Jt=Ce-$e,yt=Fe+We,Bn=Fe-We,gr=Ie+yt,To=Ie-yt,xi=at+Je,Ti=at-Je;P[W]=gr+xi,P[W+4]=gr-xi;var jc=(Ti+To)*.707106781;P[W+2]=To+jc,P[W+6]=To-jc,gr=Bn+Jt,xi=Jt+we,Ti=we+qe;var qc=(gr-Ti)*.382683433,Em=.5411961*gr+qc,zc=1.306562965*Ti+qc,Hc=xi*.707106781,Gc=qe+Hc,Vc=qe-Hc;P[W+5]=Vc+Em,P[W+3]=Vc-Em,P[W+1]=Gc+zc,P[W+7]=Gc-zc,W+=8}for(W=0,re=0;re<Ee;++re){ge=P[W],le=P[W+8],Ce=P[W+16],Fe=P[W+24],We=P[W+32],$e=P[W+40],Ct=P[W+48],mt=P[W+56];var jS=ge+mt,Yh=ge-mt,qS=le+Ct,zS=le-Ct,HS=Ce+$e,GS=Ce-$e,VS=Fe+We,$9=Fe-We,Wc=jS+VS,Kh=jS-VS,xm=qS+HS,Tm=qS-HS;P[W]=Wc+xm,P[W+32]=Wc-xm;var WS=(Tm+Kh)*.707106781;P[W+16]=Kh+WS,P[W+48]=Kh-WS,Wc=$9+GS,xm=GS+zS,Tm=zS+Yh;var $S=(Wc-Tm)*.382683433,YS=.5411961*Wc+$S,KS=1.306562965*Tm+$S,XS=xm*.707106781,JS=Yh+XS,ZS=Yh-XS;P[W+40]=ZS+YS,P[W+24]=ZS-YS,P[W+8]=JS+KS,P[W+56]=JS-KS,W++}var Sm;for(re=0;re<wt;++re)Sm=P[re]*ie[re],y[re]=Sm>0?Sm+.5|0:Sm-.5|0;return y}s(nt,"fDCTQuant");function rt(){se(65504),se(16),O(74),O(70),O(73),O(70),O(0),O(1),O(1),O(0),se(1),se(1),O(0),O(0)}s(rt,"writeAPP0");function He(P){if(P){se(65505),P[0]===69&&P[1]===120&&P[2]===105&&P[3]===102?se(P.length+2):(se(P.length+5+2),O(69),O(120),O(105),O(102),O(0));for(var ie=0;ie<P.length;ie++)O(P[ie])}}s(He,"writeAPP1");function Ge(P,ie){se(65472),se(17),O(8),se(ie),se(P),O(3),O(1),O(17),O(0),O(2),O(17),O(1),O(3),O(17),O(1)}s(Ge,"writeSOF0");function Le(){se(65499),se(132),O(0);for(var P=0;P<64;P++)O(a[P]);O(1);for(var ie=0;ie<64;ie++)O(o[ie])}s(Le,"writeDQT");function ee(){se(65476),se(418),O(0);for(var P=0;P<16;P++)O(K[P+1]);for(var ie=0;ie<=11;ie++)O(oe[ie]);O(16);for(var ge=0;ge<16;ge++)O(Re[ge+1]);for(var le=0;le<=161;le++)O(ce[le]);O(1);for(var Ce=0;Ce<16;Ce++)O(gt[Ce+1]);for(var Fe=0;Fe<=11;Fe++)O(pe[Fe]);O(17);for(var We=0;We<16;We++)O(Te[We+1]);for(var $e=0;$e<=161;$e++)O(ut[$e])}s(ee,"writeDHT");function X(P){typeof P>"u"||P.constructor!==Array||P.forEach(ie=>{if(typeof ie=="string"){se(65534);var ge=ie.length;se(ge+2);var le;for(le=0;le<ge;le++)O(ie.charCodeAt(le))}})}s(X,"writeCOM");function dt(){se(65498),se(12),O(3),O(1),O(0),O(2),O(17),O(3),O(17),O(0),O(63),O(0)}s(dt,"writeSOS");function De(P,ie,ge,le,Ce){for(var Fe=Ce[0],We=Ce[240],$e,Ct=16,mt=63,W=64,re=nt(P,ie),Ee=0;Ee<W;++Ee)v[ne[Ee]]=re[Ee];var wt=v[0]-ge;ge=v[0],wt==0?Ne(le[0]):($e=32767+wt,Ne(le[f[$e]]),Ne(h[$e]));for(var Ie=63;Ie>0&&v[Ie]==0;Ie--);if(Ie==0)return Ne(Fe),ge;for(var qe=1,at;qe<=Ie;){for(var we=qe;v[qe]==0&&qe<=Ie;++qe);var Je=qe-we;if(Je>=Ct){at=Je>>4;for(var Jt=1;Jt<=at;++Jt)Ne(We);Je=Je&15}$e=32767+v[qe],Ne(Ce[(Je<<4)+f[$e]]),Ne(h[$e]),qe++}return Ie!=mt&&Ne(Fe),ge}s(De,"processDU");function Pe(){for(var P=String.fromCharCode,ie=0;ie<256;ie++)z[ie]=P(ie)}s(Pe,"initCharLookupTable"),this.encode=function(P,ie){var ge=new Date().getTime();ie&&On(ie),D=new Array,E=0,S=7,se(65496),rt(),X(P.comments),He(P.exifBuffer),Le(),Ge(P.width,P.height),ee(),dt();var le=0,Ce=0,Fe=0;E=0,S=7,this.encode.displayName="_encode_";for(var We=P.data,$e=P.width,Ct=P.height,mt=$e*4,W=$e*3,re,Ee=0,wt,Ie,qe,at,we,Je,Jt,yt;Ee<Ct;){for(re=0;re<mt;){for(at=mt*Ee+re,we=at,Je=-1,Jt=0,yt=0;yt<64;yt++)Jt=yt>>3,Je=(yt&7)*4,we=at+Jt*mt+Je,Ee+Jt>=Ct&&(we-=mt*(Ee+1+Jt-Ct)),re+Je>=mt&&(we-=re+Je-mt+4),wt=We[we++],Ie=We[we++],qe=We[we++],k[yt]=(B[wt]+B[Ie+256>>0]+B[qe+512>>0]>>16)-128,C[yt]=(B[wt+768>>0]+B[Ie+1024>>0]+B[qe+1280>>0]>>16)-128,R[yt]=(B[wt+1280>>0]+B[Ie+1536>>0]+B[qe+1792>>0]>>16)-128;le=De(k,i,le,u,m),Ce=De(C,c,Ce,l,p),Fe=De(R,c,Fe,l,p),re+=32}Ee+=8}if(S>=0){var Bn=[];Bn[1]=S+1,Bn[0]=(1<<S+1)-1,Ne(Bn)}if(se(65497),typeof Vf>"u")return new Uint8Array(D);return Buffer.from(D);var gr,To};function On(P){if(P<=0&&(P=1),P>100&&(P=100),J!=P){var ie=0;P<50?ie=Math.floor(5e3/P):ie=Math.floor(200-P*2),Qe(ie),J=P}}s(On,"setQuality");function nr(){var P=new Date().getTime();e||(e=50),Pe(),Ut(),Ye(),ze(),On(e);var ie=new Date().getTime()-P}s(nr,"init"),nr()}s(soe,"JPEGEncoder");typeof Vf<"u"?Vf.exports=G6:typeof window<"u"&&(window["jpeg-js"]=window["jpeg-js"]||{},window["jpeg-js"].encode=G6);function G6(e,t){typeof t>"u"&&(t=50);var n=new soe(t),r=n.encode(e,t);return{data:r,width:e.width,height:e.height}}s(G6,"encode")});var Y6=I((o6e,ME)=>{d();var NE=s(function(){"use strict";var t=new Int32Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),n=4017,r=799,a=3406,o=2276,i=1567,c=3784,u=5793,l=2896;function m(){}s(m,"constructor");function p(S,k){for(var C=0,R=[],z,B,J=16;J>0&&!S[J-1];)J--;R.push({children:[],index:0});var ne=R[0],K;for(z=0;z<J;z++){for(B=0;B<S[z];B++){for(ne=R.pop(),ne.children[ne.index]=k[C];ne.index>0;){if(R.length===0)throw new Error("Could not recreate Huffman Table");ne=R.pop()}for(ne.index++,R.push(ne);R.length<=z;)R.push(K={children:[],index:0}),ne.children[ne.index]=K.children,ne=K;C++}z+1<J&&(R.push(K={children:[],index:0}),ne.children[ne.index]=K.children,ne=K)}return R[0].children}s(p,"buildHuffmanTable");function h(S,k,C,R,z,B,J,ne,K,oe){var Re=C.precision,ce=C.samplesPerLine,gt=C.scanLines,pe=C.mcusPerLine,Te=C.progressive,ut=C.maxH,Qe=C.maxV,je=k,Ut=0,Ye=0;function ze(){if(Ye>0)return Ye--,Ut>>Ye&1;if(Ut=S[k++],Ut==255){var W=S[k++];if(W)throw new Error("unexpected marker: "+(Ut<<8|W).toString(16))}return Ye=7,Ut>>>7}s(ze,"readBit");function Ne(W){for(var re=W,Ee;(Ee=ze())!==null;){if(re=re[Ee],typeof re=="number")return re;if(typeof re!="object")throw new Error("invalid huffman sequence")}return null}s(Ne,"decodeHuffman");function O(W){for(var re=0;W>0;){var Ee=ze();if(Ee===null)return;re=re<<1|Ee,W--}return re}s(O,"receive");function se(W){var re=O(W);return re>=1<<W-1?re:re+(-1<<W)+1}s(se,"receiveAndExtend");function nt(W,re){var Ee=Ne(W.huffmanTableDC),wt=Ee===0?0:se(Ee);re[0]=W.pred+=wt;for(var Ie=1;Ie<64;){var qe=Ne(W.huffmanTableAC),at=qe&15,we=qe>>4;if(at===0){if(we<15)break;Ie+=16;continue}Ie+=we;var Je=t[Ie];re[Je]=se(at),Ie++}}s(nt,"decodeBaseline");function rt(W,re){var Ee=Ne(W.huffmanTableDC),wt=Ee===0?0:se(Ee)<<K;re[0]=W.pred+=wt}s(rt,"decodeDCFirst");function He(W,re){re[0]|=ze()<<K}s(He,"decodeDCSuccessive");var Ge=0;function Le(W,re){if(Ge>0){Ge--;return}for(var Ee=B,wt=J;Ee<=wt;){var Ie=Ne(W.huffmanTableAC),qe=Ie&15,at=Ie>>4;if(qe===0){if(at<15){Ge=O(at)+(1<<at)-1;break}Ee+=16;continue}Ee+=at;var we=t[Ee];re[we]=se(qe)*(1<<K),Ee++}}s(Le,"decodeACFirst");var ee=0,X;function dt(W,re){for(var Ee=B,wt=J,Ie=0;Ee<=wt;){var qe=t[Ee],at=re[qe]<0?-1:1;switch(ee){case 0:var we=Ne(W.huffmanTableAC),Je=we&15,Ie=we>>4;if(Je===0)Ie<15?(Ge=O(Ie)+(1<<Ie),ee=4):(Ie=16,ee=1);else{if(Je!==1)throw new Error("invalid ACn encoding");X=se(Je),ee=Ie?2:3}continue;case 1:case 2:re[qe]?re[qe]+=(ze()<<K)*at:(Ie--,Ie===0&&(ee=ee==2?3:0));break;case 3:re[qe]?re[qe]+=(ze()<<K)*at:(re[qe]=X<<K,ee=0);break;case 4:re[qe]&&(re[qe]+=(ze()<<K)*at);break}Ee++}ee===4&&(Ge--,Ge===0&&(ee=0))}s(dt,"decodeACSuccessive");function De(W,re,Ee,wt,Ie){var qe=Ee/pe|0,at=Ee%pe,we=qe*W.v+wt,Je=at*W.h+Ie;W.blocks[we]===void 0&&oe.tolerantDecoding||re(W,W.blocks[we][Je])}s(De,"decodeMcu");function Pe(W,re,Ee){var wt=Ee/W.blocksPerLine|0,Ie=Ee%W.blocksPerLine;W.blocks[wt]===void 0&&oe.tolerantDecoding||re(W,W.blocks[wt][Ie])}s(Pe,"decodeBlock");var On=R.length,nr,P,ie,ge,le,Ce;Te?B===0?Ce=ne===0?rt:He:Ce=ne===0?Le:dt:Ce=nt;var Fe=0,We,$e;On==1?$e=R[0].blocksPerLine*R[0].blocksPerColumn:$e=pe*C.mcusPerColumn,z||(z=$e);for(var Ct,mt;Fe<$e;){for(P=0;P<On;P++)R[P].pred=0;if(Ge=0,On==1)for(nr=R[0],le=0;le<z;le++)Pe(nr,Ce,Fe),Fe++;else for(le=0;le<z;le++){for(P=0;P<On;P++)for(nr=R[P],Ct=nr.h,mt=nr.v,ie=0;ie<mt;ie++)for(ge=0;ge<Ct;ge++)De(nr,Ce,Fe,ie,ge);if(Fe++,Fe===$e)break}if(Fe===$e)do{if(S[k]===255&&S[k+1]!==0)break;k+=1}while(k<S.length-2);if(Ye=0,We=S[k]<<8|S[k+1],We<65280)throw new Error("marker was not found");if(We>=65488&&We<=65495)k+=2;else break}return k-je}s(h,"decodeScan");function f(S,k){var C=[],R=k.blocksPerLine,z=k.blocksPerColumn,B=R<<3,J=new Int32Array(64),ne=new Uint8Array(64);function K(je,Ut,Ye){var ze=k.quantizationTable,Ne,O,se,nt,rt,He,Ge,Le,ee,X=Ye,dt;for(dt=0;dt<64;dt++)X[dt]=je[dt]*ze[dt];for(dt=0;dt<8;++dt){var De=8*dt;if(X[1+De]==0&&X[2+De]==0&&X[3+De]==0&&X[4+De]==0&&X[5+De]==0&&X[6+De]==0&&X[7+De]==0){ee=u*X[0+De]+512>>10,X[0+De]=ee,X[1+De]=ee,X[2+De]=ee,X[3+De]=ee,X[4+De]=ee,X[5+De]=ee,X[6+De]=ee,X[7+De]=ee;continue}Ne=u*X[0+De]+128>>8,O=u*X[4+De]+128>>8,se=X[2+De],nt=X[6+De],rt=l*(X[1+De]-X[7+De])+128>>8,Le=l*(X[1+De]+X[7+De])+128>>8,He=X[3+De]<<4,Ge=X[5+De]<<4,ee=Ne-O+1>>1,Ne=Ne+O+1>>1,O=ee,ee=se*c+nt*i+128>>8,se=se*i-nt*c+128>>8,nt=ee,ee=rt-Ge+1>>1,rt=rt+Ge+1>>1,Ge=ee,ee=Le+He+1>>1,He=Le-He+1>>1,Le=ee,ee=Ne-nt+1>>1,Ne=Ne+nt+1>>1,nt=ee,ee=O-se+1>>1,O=O+se+1>>1,se=ee,ee=rt*o+Le*a+2048>>12,rt=rt*a-Le*o+2048>>12,Le=ee,ee=He*r+Ge*n+2048>>12,He=He*n-Ge*r+2048>>12,Ge=ee,X[0+De]=Ne+Le,X[7+De]=Ne-Le,X[1+De]=O+Ge,X[6+De]=O-Ge,X[2+De]=se+He,X[5+De]=se-He,X[3+De]=nt+rt,X[4+De]=nt-rt}for(dt=0;dt<8;++dt){var Pe=dt;if(X[8+Pe]==0&&X[16+Pe]==0&&X[24+Pe]==0&&X[32+Pe]==0&&X[40+Pe]==0&&X[48+Pe]==0&&X[56+Pe]==0){ee=u*Ye[dt+0]+8192>>14,X[0+Pe]=ee,X[8+Pe]=ee,X[16+Pe]=ee,X[24+Pe]=ee,X[32+Pe]=ee,X[40+Pe]=ee,X[48+Pe]=ee,X[56+Pe]=ee;continue}Ne=u*X[0+Pe]+2048>>12,O=u*X[32+Pe]+2048>>12,se=X[16+Pe],nt=X[48+Pe],rt=l*(X[8+Pe]-X[56+Pe])+2048>>12,Le=l*(X[8+Pe]+X[56+Pe])+2048>>12,He=X[24+Pe],Ge=X[40+Pe],ee=Ne-O+1>>1,Ne=Ne+O+1>>1,O=ee,ee=se*c+nt*i+2048>>12,se=se*i-nt*c+2048>>12,nt=ee,ee=rt-Ge+1>>1,rt=rt+Ge+1>>1,Ge=ee,ee=Le+He+1>>1,He=Le-He+1>>1,Le=ee,ee=Ne-nt+1>>1,Ne=Ne+nt+1>>1,nt=ee,ee=O-se+1>>1,O=O+se+1>>1,se=ee,ee=rt*o+Le*a+2048>>12,rt=rt*a-Le*o+2048>>12,Le=ee,ee=He*r+Ge*n+2048>>12,He=He*n-Ge*r+2048>>12,Ge=ee,X[0+Pe]=Ne+Le,X[56+Pe]=Ne-Le,X[8+Pe]=O+Ge,X[48+Pe]=O-Ge,X[16+Pe]=se+He,X[40+Pe]=se-He,X[24+Pe]=nt+rt,X[32+Pe]=nt-rt}for(dt=0;dt<64;++dt){var On=128+(X[dt]+8>>4);Ut[dt]=On<0?0:On>255?255:On}}s(K,"quantizeAndInverse"),E(B*z*8);for(var oe,Re,ce=0;ce<z;ce++){var gt=ce<<3;for(oe=0;oe<8;oe++)C.push(new Uint8Array(B));for(var pe=0;pe<R;pe++){K(k.blocks[ce][pe],ne,J);var Te=0,ut=pe<<3;for(Re=0;Re<8;Re++){var Qe=C[gt+Re];for(oe=0;oe<8;oe++)Qe[ut+oe]=ne[Te++]}}}return C}s(f,"buildComponentData");function y(S){return S<0?0:S>255?255:S}s(y,"clampTo8bit"),m.prototype={load:s(function(k){var C=new XMLHttpRequest;C.open("GET",k,!0),C.responseType="arraybuffer",C.onload=function(){var R=new Uint8Array(C.response||C.mozResponseArrayBuffer);this.parse(R),this.onload&&this.onload()}.bind(this),C.send(null)},"load"),parse:s(function(k){var C=this.opts.maxResolutionInMP*1e3*1e3,R=0,z=k.length;function B(){var we=k[R]<<8|k[R+1];return R+=2,we}s(B,"readUint16");function J(){var we=B(),Je=k.subarray(R,R+we-2);return R+=Je.length,Je}s(J,"readDataBlock");function ne(we){var Je=1,Jt=1,yt,Bn;for(Bn in we.components)we.components.hasOwnProperty(Bn)&&(yt=we.components[Bn],Je<yt.h&&(Je=yt.h),Jt<yt.v&&(Jt=yt.v));var gr=Math.ceil(we.samplesPerLine/8/Je),To=Math.ceil(we.scanLines/8/Jt);for(Bn in we.components)if(we.components.hasOwnProperty(Bn)){yt=we.components[Bn];var xi=Math.ceil(Math.ceil(we.samplesPerLine/8)*yt.h/Je),Ti=Math.ceil(Math.ceil(we.scanLines/8)*yt.v/Jt),jc=gr*yt.h,qc=To*yt.v,Em=qc*jc,zc=[];E(Em*256);for(var Hc=0;Hc<qc;Hc++){for(var Gc=[],Vc=0;Vc<jc;Vc++)Gc.push(new Int32Array(64));zc.push(Gc)}yt.blocksPerLine=xi,yt.blocksPerColumn=Ti,yt.blocks=zc}we.maxH=Je,we.maxV=Jt,we.mcusPerLine=gr,we.mcusPerColumn=To}s(ne,"prepareComponents");var K=null,oe=null,Re=null,ce,gt,pe=[],Te=[],ut=[],Qe=[],je=B(),Ut=-1;if(this.comments=[],je!=65496)throw new Error("SOI not found");for(je=B();je!=65497;){var Ye,ze,Ne;switch(je){case 65280:break;case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:var O=J();if(je===65534){var se=String.fromCharCode.apply(null,O);this.comments.push(se)}je===65504&&O[0]===74&&O[1]===70&&O[2]===73&&O[3]===70&&O[4]===0&&(K={version:{major:O[5],minor:O[6]},densityUnits:O[7],xDensity:O[8]<<8|O[9],yDensity:O[10]<<8|O[11],thumbWidth:O[12],thumbHeight:O[13],thumbData:O.subarray(14,14+3*O[12]*O[13])}),je===65505&&O[0]===69&&O[1]===120&&O[2]===105&&O[3]===102&&O[4]===0&&(this.exifBuffer=O.subarray(5,O.length)),je===65518&&O[0]===65&&O[1]===100&&O[2]===111&&O[3]===98&&O[4]===101&&O[5]===0&&(oe={version:O[6],flags0:O[7]<<8|O[8],flags1:O[9]<<8|O[10],transformCode:O[11]});break;case 65499:for(var nt=B(),rt=nt+R-2;R<rt;){var He=k[R++];E(256);var Ge=new Int32Array(64);if(He>>4)if(He>>4===1)for(ze=0;ze<64;ze++){var Le=t[ze];Ge[Le]=B()}else throw new Error("DQT: invalid table spec");else for(ze=0;ze<64;ze++){var Le=t[ze];Ge[Le]=k[R++]}pe[He&15]=Ge}break;case 65472:case 65473:case 65474:B(),ce={},ce.extended=je===65473,ce.progressive=je===65474,ce.precision=k[R++],ce.scanLines=B(),ce.samplesPerLine=B(),ce.components={},ce.componentsOrder=[];var ee=ce.scanLines*ce.samplesPerLine;if(ee>C){var X=Math.ceil((ee-C)/1e6);throw new Error(`maxResolutionInMP limit exceeded by ${X}MP`)}var dt=k[R++],De,Pe=0,On=0;for(Ye=0;Ye<dt;Ye++){De=k[R];var nr=k[R+1]>>4,P=k[R+1]&15,ie=k[R+2];if(nr<=0||P<=0)throw new Error("Invalid sampling factor, expected values above 0");ce.componentsOrder.push(De),ce.components[De]={h:nr,v:P,quantizationIdx:ie},R+=3}ne(ce),Te.push(ce);break;case 65476:var ge=B();for(Ye=2;Ye<ge;){var le=k[R++],Ce=new Uint8Array(16),Fe=0;for(ze=0;ze<16;ze++,R++)Fe+=Ce[ze]=k[R];E(16+Fe);var We=new Uint8Array(Fe);for(ze=0;ze<Fe;ze++,R++)We[ze]=k[R];Ye+=17+Fe,(le>>4?ut:Qe)[le&15]=p(Ce,We)}break;case 65501:B(),gt=B();break;case 65500:B(),B();break;case 65498:var $e=B(),Ct=k[R++],mt=[],W;for(Ye=0;Ye<Ct;Ye++){W=ce.components[k[R++]];var re=k[R++];W.huffmanTableDC=Qe[re>>4],W.huffmanTableAC=ut[re&15],mt.push(W)}var Ee=k[R++],wt=k[R++],Ie=k[R++],qe=h(k,R,ce,mt,gt,Ee,wt,Ie>>4,Ie&15,this.opts);R+=qe;break;case 65535:k[R]!==255&&R--;break;default:if(k[R-3]==255&&k[R-2]>=192&&k[R-2]<=254){R-=3;break}else if(je===224||je==225){if(Ut!==-1)throw new Error(`first unknown JPEG marker at offset ${Ut.toString(16)}, second unknown JPEG marker ${je.toString(16)} at offset ${(R-1).toString(16)}`);Ut=R-1;let we=B();if(k[R+we-2]===255){R+=we-2;break}}throw new Error("unknown JPEG marker "+je.toString(16))}je=B()}if(Te.length!=1)throw new Error("only single frame JPEGs supported");for(var Ye=0;Ye<Te.length;Ye++){var at=Te[Ye].components;for(var ze in at)at[ze].quantizationTable=pe[at[ze].quantizationIdx],delete at[ze].quantizationIdx}this.width=ce.samplesPerLine,this.height=ce.scanLines,this.jfif=K,this.adobe=oe,this.components=[];for(var Ye=0;Ye<ce.componentsOrder.length;Ye++){var W=ce.components[ce.componentsOrder[Ye]];this.components.push({lines:f(ce,W),scaleX:W.h/ce.maxH,scaleY:W.v/ce.maxV})}},"parse"),getData:s(function(k,C){var R=this.width/k,z=this.height/C,B,J,ne,K,oe,Re,ce,gt,pe,Te,ut=0,Qe,je,Ut,Ye,ze,Ne,O,se,nt,rt,He,Ge=k*C*this.components.length;E(Ge);var Le=new Uint8Array(Ge);switch(this.components.length){case 1:for(B=this.components[0],Te=0;Te<C;Te++)for(oe=B.lines[0|Te*B.scaleY*z],pe=0;pe<k;pe++)Qe=oe[0|pe*B.scaleX*R],Le[ut++]=Qe;break;case 2:for(B=this.components[0],J=this.components[1],Te=0;Te<C;Te++)for(oe=B.lines[0|Te*B.scaleY*z],Re=J.lines[0|Te*J.scaleY*z],pe=0;pe<k;pe++)Qe=oe[0|pe*B.scaleX*R],Le[ut++]=Qe,Qe=Re[0|pe*J.scaleX*R],Le[ut++]=Qe;break;case 3:for(He=!0,this.adobe&&this.adobe.transformCode?He=!0:typeof this.opts.colorTransform<"u"&&(He=!!this.opts.colorTransform),B=this.components[0],J=this.components[1],ne=this.components[2],Te=0;Te<C;Te++)for(oe=B.lines[0|Te*B.scaleY*z],Re=J.lines[0|Te*J.scaleY*z],ce=ne.lines[0|Te*ne.scaleY*z],pe=0;pe<k;pe++)He?(Qe=oe[0|pe*B.scaleX*R],je=Re[0|pe*J.scaleX*R],Ut=ce[0|pe*ne.scaleX*R],se=y(Qe+1.402*(Ut-128)),nt=y(Qe-.3441363*(je-128)-.71413636*(Ut-128)),rt=y(Qe+1.772*(je-128))):(se=oe[0|pe*B.scaleX*R],nt=Re[0|pe*J.scaleX*R],rt=ce[0|pe*ne.scaleX*R]),Le[ut++]=se,Le[ut++]=nt,Le[ut++]=rt;break;case 4:if(!this.adobe)throw new Error("Unsupported color mode (4 components)");for(He=!1,this.adobe&&this.adobe.transformCode?He=!0:typeof this.opts.colorTransform<"u"&&(He=!!this.opts.colorTransform),B=this.components[0],J=this.components[1],ne=this.components[2],K=this.components[3],Te=0;Te<C;Te++)for(oe=B.lines[0|Te*B.scaleY*z],Re=J.lines[0|Te*J.scaleY*z],ce=ne.lines[0|Te*ne.scaleY*z],gt=K.lines[0|Te*K.scaleY*z],pe=0;pe<k;pe++)He?(Qe=oe[0|pe*B.scaleX*R],je=Re[0|pe*J.scaleX*R],Ut=ce[0|pe*ne.scaleX*R],Ye=gt[0|pe*K.scaleX*R],ze=255-y(Qe+1.402*(Ut-128)),Ne=255-y(Qe-.3441363*(je-128)-.71413636*(Ut-128)),O=255-y(Qe+1.772*(je-128))):(ze=oe[0|pe*B.scaleX*R],Ne=Re[0|pe*J.scaleX*R],O=ce[0|pe*ne.scaleX*R],Ye=gt[0|pe*K.scaleX*R]),Le[ut++]=255-ze,Le[ut++]=255-Ne,Le[ut++]=255-O,Le[ut++]=255-Ye;break;default:throw new Error("Unsupported color mode")}return Le},"getData"),copyToImageData:s(function(k,C){var R=k.width,z=k.height,B=k.data,J=this.getData(R,z),ne=0,K=0,oe,Re,ce,gt,pe,Te,ut,Qe,je;switch(this.components.length){case 1:for(Re=0;Re<z;Re++)for(oe=0;oe<R;oe++)ce=J[ne++],B[K++]=ce,B[K++]=ce,B[K++]=ce,C&&(B[K++]=255);break;case 3:for(Re=0;Re<z;Re++)for(oe=0;oe<R;oe++)ut=J[ne++],Qe=J[ne++],je=J[ne++],B[K++]=ut,B[K++]=Qe,B[K++]=je,C&&(B[K++]=255);break;case 4:for(Re=0;Re<z;Re++)for(oe=0;oe<R;oe++)pe=J[ne++],Te=J[ne++],ce=J[ne++],gt=J[ne++],ut=255-y(pe*(1-gt/255)+gt),Qe=255-y(Te*(1-gt/255)+gt),je=255-y(ce*(1-gt/255)+gt),B[K++]=ut,B[K++]=Qe,B[K++]=je,C&&(B[K++]=255);break;default:throw new Error("Unsupported color mode")}},"copyToImageData")};var v=0,D=0;function E(S=0){var k=v+S;if(k>D){var C=Math.ceil((k-D)/1024/1024);throw new Error(`maxMemoryUsageInMB limit exceeded by at least ${C}MB`)}v=k}return s(E,"requestMemoryAllocation"),m.resetMaxMemoryUsage=function(S){v=0,D=S},m.getBytesAllocated=function(){return v},m.requestMemoryAllocation=E,m},"jpegImage")();typeof ME<"u"?ME.exports=$6:typeof window<"u"&&(window["jpeg-js"]=window["jpeg-js"]||{},window["jpeg-js"].decode=$6);function $6(e,t={}){var n={colorTransform:void 0,useTArray:!1,formatAsRGBA:!0,tolerantDecoding:!0,maxResolutionInMP:100,maxMemoryUsageInMB:512},r={...n,...t},a=new Uint8Array(e),o=new NE;o.opts=r,NE.resetMaxMemoryUsage(r.maxMemoryUsageInMB*1024*1024),o.parse(a);var i=r.formatAsRGBA?4:3,c=o.width*o.height*i;try{NE.requestMemoryAllocation(c);var u={width:o.width,height:o.height,exifBuffer:o.exifBuffer,data:r.useTArray?new Uint8Array(c):Buffer.alloc(c)};o.comments.length>0&&(u.comments=o.comments)}catch(l){throw l instanceof RangeError?new Error("Could not allocate enough memory for the image. Required: "+c):l instanceof ReferenceError&&l.message==="Buffer is not defined"?new Error("Buffer is not globally defined in this environment. Consider setting useTArray to true"):l}return o.copyToImageData(u,r.formatAsRGBA),u}s($6,"decode")});var LE=I((c6e,K6)=>{d();var coe=W6(),uoe=Y6();K6.exports={encode:coe,decode:uoe}});var J6=I((l6e,X6)=>{"use strict";d();var loe=H6(),PE=LE();function Wf(e,t,n,r,a){return a[(e+t*r)*4+n]}s(Wf,"getPixel");function doe(e,t,n){return Wf(e,t,0,n.width,n.data)>=249&&Wf(e,t,1,n.width,n.data)>=249&&Wf(e,t,2,n.width,n.data)>=249}s(doe,"isWhitePixel");function moe(e){let t=s(function(){let o=[];for(let i=0;i<256;i++)o[i]=0;return o},"createHistogramArray"),n=e.width,r=e.height,a=[t(),t(),t()];for(let o=0;o<r;o++)for(let i=0;i<n;i++)if(!doe(i,o,e))for(let c=0;c<a.length;c++){let u=Wf(i,o,c,n,e.data);a[c][u]++}return a}s(moe,"convertPixelsToHistogram");function poe(e){let t=PE.decode(e[0].getImage()),n=t.width,r=t.height,a=Buffer.alloc(n*r*4),o=0;for(;o<a.length;)a[o++]=255,a[o++]=255,a[o++]=255,a[o++]=255;var i=PE.encode({data:a,width:n,height:r});return i.data}s(poe,"synthesizeWhiteFrame");var foe="disabled-by-default-devtools.screenshot";function hoe(e,t){t=t||{};let n;e=typeof e=="string"?loe.readFileSync(e,"utf-8"):e;try{n=typeof e=="string"?JSON.parse(e):e}catch(p){throw new Error("Speedline: Invalid JSON"+p.message)}let r=n.traceEvents||n,a=Number.MAX_VALUE,o=-Number.MAX_VALUE;r.forEach(p=>{p.ts!==0&&(a=Math.min(a,p.ts),o=Math.max(o,p.ts))}),a=(t.timeOrigin||a)/1e3,o/=1e3;let i=null,c=r.filter(p=>p.cat.includes(foe)&&p.ts>=a*1e3);c.sort((p,h)=>p.ts-h.ts);let u=c.map(function(p){let h=p.args&&p.args.snapshot,f=p.ts/1e3;if(h===i)return null;i=h;let y=Buffer.from(h,"base64");return OE(y,f)}).filter(Boolean);if(u.length===0)return Promise.reject(new Error("No screenshots found in trace"));let l=OE(poe(u),a);u.unshift(l);let m={startTs:a,endTs:o,frames:u};return Promise.resolve(m)}s(hoe,"extractFramesFromTimeline");function OE(e,t){let n=null,r=null,a=null,o=null,i=null,c=null;return{getHistogram:function(){if(n)return n;let u=this.getParsedImage();return n=moe(u),n},getTimeStamp:function(){return t},setProgress:function(u,l){r=u,a=!!l},setPerceptualProgress:function(u,l){o=u,i=!!l},getImage:function(){return e},getParsedImage:function(){return c||(c=PE.decode(e)),c},getProgress:function(){return r},isProgressInterpolated:function(){return a},getPerceptualProgress:function(){return o},isPerceptualProgressInterpolated:function(){return i}}}s(OE,"frame");X6.exports={extractFramesFromTimeline:hoe,create:OE}});var Q6=I((p6e,Z6)=>{d();var BE;(function(e){"use strict";(function(a){a[a.Grey=1]="Grey",a[a.GreyAlpha=2]="GreyAlpha",a[a.RGB=3]="RGB",a[a.RGBAlpha=4]="RGBAlpha"})(e.Channels||(e.Channels={}));var t=e.Channels;function n(a,o,i,c,u,l,m){if(i===void 0&&(i=8),c===void 0&&(c=.01),u===void 0&&(u=.03),l===void 0&&(l=!0),m===void 0&&(m=8),a.width!==o.width||a.height!==o.height)throw new Error("Images have different sizes!");var p=(1<<m)-1,h=Math.pow(c*p,2),f=Math.pow(u*p,2),y=0,v=0,D=0;function E(S,k,C,R){var z,B,J;z=B=J=0;for(var ne=0;ne<S.length;ne++)B+=Math.pow(S[ne]-C,2),J+=Math.pow(k[ne]-R,2),z+=(S[ne]-C)*(k[ne]-R);var K=S.length-1;B/=K,J/=K,z/=K;var oe=(2*C*R+h)*(2*z+f),Re=(Math.pow(C,2)+Math.pow(R,2)+h)*(B+J+f);v+=oe/Re,D+=(2*z+f)/(B+J+f),y++}return s(E,"iteration"),r._iterate(a,o,i,l,E),{ssim:v/y,mcs:D/y}}s(n,"compare"),e.compare=n;var r;(function(a){function o(u,l,m,p,h){for(var f=u.width,y=u.height,v=0;v<y;v+=m)for(var D=0;D<f;D+=m){var E=Math.min(m,f-D),S=Math.min(m,y-v),k=i(u,D,v,E,S,p),C=i(l,D,v,E,S,p),R=c(k),z=c(C);h(k,C,R,z)}}s(o,"_iterate"),a._iterate=o;function i(u,l,m,p,h,f){for(var y=u.data,v=new Float32Array(new ArrayBuffer(p*h*4)),D=0,E=m+h,S=m;S<E;S++){var k=S*u.width,C=(k+l)*u.channels,R=(k+l+p)*u.channels;switch(u.channels){case 1:for(;C<R;)v[D++]=y[C++];break;case 2:for(;C<R;)v[D++]=y[C++]*(y[C++]/255);break;case 3:if(f)for(;C<R;)v[D++]=y[C++]*.212655+y[C++]*.715158+y[C++]*.072187;else for(;C<R;)v[D++]=y[C++]+y[C++]+y[C++];break;case 4:if(f)for(;C<R;)v[D++]=(y[C++]*.212655+y[C++]*.715158+y[C++]*.072187)*(y[C++]/255);else for(;C<R;)v[D++]=(y[C++]+y[C++]+y[C++])*(y[C++]/255);break}}return v}s(i,"_lumaValuesForWindow");function c(u){for(var l=0,m=0;m<u.length;m++)l+=u[m];return l/u.length}s(c,"_averageLuma")})(r||(r={}))})(BE||(BE={}));Z6.exports=BE});var r4=I((g6e,n4)=>{"use strict";d();var goe=Q6(),yoe=5,boe=3,voe=-1,jE=voe,e4=yoe-jE,woe=Math.log((boe-jE)/e4);function t4(e){let t=e/1e3;return e4*Math.exp(woe*t)+jE}s(t4,"calculateFastModeAllowableChange");function Doe(e,t,n){let r=0,a=0,o=e.getHistogram(),i=t.getHistogram(),c=n.getHistogram();for(let l=0;l<3;l++)for(let m=0;m<256;m++){let p=o[l][m],h=i[l][m],f=c[l][m],y=Math.abs(p-h),v=Math.abs(f-h);a+=Math.min(y,v),r+=v}let u;return a===0&&r===0?u=100:u=Math.floor(a/r*100),u}s(Doe,"calculateFrameProgress");function $f(e,t,n,r,a,o){if(!r){e.forEach(p=>o(p,a(p),!1));return}let i=e[t],c=e[n],u=c.getTimeStamp()-i.getTimeStamp(),l=a(i),m=a(c);if(o(i,l,!1),o(c,m,!1),Math.abs(l-m)<t4(u))for(let p=t+1;p<n;p++)o(e[p],l,!0);else if(n-t>1){let p=Math.floor((t+n)/2);$f(e,t,p,r,a,o),$f(e,p,n,r,a,o)}}s($f,"calculateProgressBetweenFrames");function Eoe(e,t){let n=e[0],r=e[e.length-1];function a(i){return typeof i.getProgress()=="number"?i.getProgress():Doe(i,n,r)}s(a,"getProgress");function o(i,c,u){return i.setProgress(c,u)}return s(o,"setProgress"),$f(e,0,e.length-1,t&&t.fastMode,a,o),e}s(Eoe,"calculateVisualProgress");function UE(e,t){let n={channels:4},r=Object.assign(e.getParsedImage(),n),a=Object.assign(t.getParsedImage(),n);return goe.compare(r,a).ssim}s(UE,"calculateFrameSimilarity");function xoe(e,t){let n=e[0],r=e[e.length-1],a=UE(n,r);function o(c){if(typeof c.getPerceptualProgress()=="number")return c.getPerceptualProgress();let u=UE(c,r);return Math.max(100*(u-a)/(1-a),0)}s(o,"getProgress");function i(c,u,l){return c.setPerceptualProgress(u,l)}return s(i,"setProgress"),$f(e,0,e.length-1,t&&t.fastMode,o,i),e}s(xoe,"calculatePerceptualProgress");function Toe(e,t){let n=typeof e[0].getProgress()=="number",r=typeof e[0].getPerceptualProgress()=="number",a=n?"getProgress":"getPerceptualProgress",o=t.startTs,i,c;for(let f=0;f<e.length&&!c;f++)e[f][a]()>0&&(c=e[f].getTimeStamp());for(let f=0;f<e.length&&!i;f++)e[f][a]()>=100&&(i=e[f].getTimeStamp());let u=e[0].getTimeStamp(),l=e[0].getProgress(),m=e[0].getPerceptualProgress(),p=c-o,h=c-o;return e.forEach(function(f){if(f.getTimeStamp()>c){let y=f.getTimeStamp()-u;p+=y*(1-l),h+=y*(1-m)}u=f.getTimeStamp(),l=f.getProgress()/100,m=f.getPerceptualProgress()/100}),p=n?p:void 0,h=r?h:void 0,{firstPaintTs:c,visuallyCompleteTs:i,speedIndex:p,perceptualSpeedIndex:h}}s(Toe,"calculateSpeedIndexes");n4.exports={calculateFastModeAllowableChange:t4,calculateFrameSimilarity:UE,calculateVisualProgress:Eoe,calculatePerceptualProgress:xoe,calculateSpeedIndexes:Toe}});var o4=I((v6e,a4)=>{"use strict";d();var Soe=J6(),qE=r4();function koe(e,t){let n=qE.calculateSpeedIndexes(e,t),r=Math.floor(t.endTs-t.startTs),a=Math.floor(n.firstPaintTs-t.startTs),o=Math.floor(n.visuallyCompleteTs-t.startTs);return{beginning:t.startTs,end:t.endTs,frames:e,first:a,complete:o,duration:r,speedIndex:n.speedIndex,perceptualSpeedIndex:n.perceptualSpeedIndex}}s(koe,"calculateValues");var oi={All:"all",pSI:"perceptualSpeedIndex",SI:"speedIndex"};a4.exports=function(e,t){let n=t&&t.include||oi.All;if(!Object.keys(oi).some(r=>oi[r]===n))throw new Error(`Unrecognized include option: ${n}`);return Soe.extractFramesFromTimeline(e,t).then(function(r){let a=r.frames;return(n===oi.All||n===oi.SI)&&qE.calculateVisualProgress(a,t),(n===oi.All||n===oi.pSI)&&qE.calculatePerceptualProgress(a,t),koe(a,r)})}});var i4,zE,no,Bd=b(()=>{"use strict";d();i4=Lt(o4(),1);ue();It();Nt();zE=class{static{s(this,"Speedline")}static async compute_(t,n){return ke.request(t,n).then(r=>{let a=t.traceEvents.slice(),o=r.timestamps.timeOrigin;return(0,i4.default)(a,{timeOrigin:o,fastMode:!0,include:"speedIndex"})}).catch(r=>{throw/No screenshots found in trace/.test(r.message)?new j(j.errors.NO_SCREENSHOTS):r}).then(r=>{if(r.frames.length===0)throw new j(j.errors.NO_SPEEDLINE_FRAMES);if(r.speedIndex===0)throw new j(j.errors.SPEEDINDEX_OF_ZERO);return r})}},no=q(zE,null)});var HE,s4,c4=b(()=>{"use strict";d();ue();Rr();HE=class extends pt{static{s(this,"FirstContentfulPaintAllFrames")}static computeSimulatedMetric(){throw new Error("FCP All Frames not implemented in lantern")}static async computeObservedMetric(t){let{processedNavigation:n}=t;return{timing:n.timings.firstContentfulPaintAllFrames,timestamp:n.timestamps.firstContentfulPaintAllFrames}}},s4=q(HE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var GE,Yf,VE=b(()=>{"use strict";d();ue();Rr();It();tf();GE=class extends pt{static{s(this,"FirstMeaningfulPaint")}static computeSimulatedMetric(t,n){let r=pt.getMetricComputationInput(t);return fs.request(r,n)}static async computeObservedMetric(t){let{processedNavigation:n}=t;if(n.timings.firstMeaningfulPaint===void 0)throw new j(j.errors.NO_FMP);return{timing:n.timings.firstMeaningfulPaint,timestamp:n.timestamps.firstMeaningfulPaint}}},Yf=q(GE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var WE,u4,l4=b(()=>{"use strict";d();ue();Rr();It();WE=class extends pt{static{s(this,"LargestContentfulPaintAllFrames")}static async computeSimulatedMetric(){throw new Error("LCP All Frames not implemented in lantern")}static async computeObservedMetric(t){let{processedNavigation:n}=t;if(n.timings.largestContentfulPaintAllFrames===void 0)throw new j(j.errors.NO_LCP_ALL_FRAMES);return{timing:n.timings.largestContentfulPaintAllFrames,timestamp:n.timestamps.largestContentfulPaintAllFrames}}},u4=q(WE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var $E,Kf,YE=b(()=>{"use strict";d();ue();oa();gn();Bd();cr();zn();$E=class e extends Wt{static{s(this,"LanternSpeedIndex")}static get COEFFICIENTS(){return{intercept:-250,optimistic:1.4,pessimistic:.65}}static getScaledCoefficients(t){let n=this.COEFFICIENTS,r=In.mobileSlow4G.rttMs-30,a=Math.max((t-30)/r,0);return{intercept:n.intercept*a,optimistic:.5+(n.optimistic-.5)*a,pessimistic:.5+(n.pessimistic-.5)*a}}static getOptimisticGraph(t){return t}static getPessimisticGraph(t){return t}static getEstimateFromSimulation(t,n){if(!n.fcpResult)throw new Error("missing fcpResult");if(!n.speedline)throw new Error("missing speedline");let r=n.fcpResult.pessimisticEstimate.timeInMs;return{timeInMs:n.optimistic?n.speedline.speedIndex:e.computeLayoutBasedSpeedIndex(t.nodeTimings,r),nodeTimings:t.nodeTimings}}static async compute_(t,n){let r=await no.request(t.trace,n),a=await Tt.request(t,n),o=await this.computeMetricWithGraphs(t,n,{speedline:r,fcpResult:a});return o.timing=Math.max(o.timing,a.timing),o}static computeLayoutBasedSpeedIndex(t,n){let r=[];for(let[i,c]of t.entries())if(i.type===ye.TYPES.CPU&&i.childEvents.some(u=>u.name==="Layout")){let u=Math.max(Math.log2(c.endTime-c.startTime),0);r.push({time:c.endTime,weight:u})}let a=r.map(i=>i.weight*Math.max(i.time,n)).reduce((i,c)=>i+c,0),o=r.map(i=>i.weight).reduce((i,c)=>i+c,0);return o?a/o:n}},Kf=q($E,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var KE,Xf,XE=b(()=>{"use strict";d();ue();Rr();YE();Bd();KE=class extends pt{static{s(this,"SpeedIndex")}static computeSimulatedMetric(t,n){let r=pt.getMetricComputationInput(t);return Kf.request(r,n)}static async computeObservedMetric(t,n){let r=await no.request(t.trace,n),a=Math.round(r.speedIndex),o=(a+r.beginning)*1e3;return Promise.resolve({timing:a,timestamp:o})}},Xf=q(KE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var JE,d4,m4=b(()=>{"use strict";d();ue();oa();gn();cr();JE=class e extends Wt{static{s(this,"LanternMaxPotentialFID")}static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(t){return t}static getPessimisticGraph(t){return t}static getEstimateFromSimulation(t,n){if(!n.fcpResult)throw new Error("missing fcpResult");let r=n.optimistic?n.fcpResult.pessimisticEstimate.timeInMs:n.fcpResult.optimisticEstimate.timeInMs,a=e.getTimingsAfterFCP(t.nodeTimings,r);return{timeInMs:Math.max(...a.map(o=>o.duration),16),nodeTimings:t.nodeTimings}}static async compute_(t,n){let r=await Tt.request(t,n);return super.computeMetricWithGraphs(t,n,{fcpResult:r})}static getTimingsAfterFCP(t,n){return Array.from(t.entries()).filter(([r,a])=>r.type===ye.TYPES.CPU&&a.endTime>n).map(([r,a])=>a)}},d4=q(JE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var ZE,Jf,QE=b(()=>{"use strict";d();ue();Rr();m4();vr();ZE=class extends pt{static{s(this,"MaxPotentialFID")}static computeSimulatedMetric(t,n){let r=pt.getMetricComputationInput(t);return d4.request(r,n)}static computeObservedMetric(t){let{firstContentfulPaint:n}=t.processedNavigation.timings,r=qt.getMainThreadTopLevelEvents(t.processedTrace,n).filter(a=>a.duration>=1);return Promise.resolve({timing:Math.max(...r.map(a=>a.duration),16)})}},Jf=q(ZE,["devtoolsLog","gatherContext","settings","simulator","trace","URL"])});var ex,Vs,Zf=b(()=>{"use strict";d();Nt();sr();Bd();rd();c4();VE();Us();l4();gs();Wu();XE();QE();ys();ue();hE();Uf();ex=class e{static{s(this,"TimingSummary")}static async summarize(t,n,r,a,o,i){let c={trace:t,devtoolsLog:n,gatherContext:r,settings:a,URL:o},u=s((Re,ce)=>Re.request(ce,i).catch(gt=>{}),"requestOrUndefined"),l=await ke.request(t,i),m=await u(zt,t),p=await no.request(t,i),h=await u(Ga,c),f=await u(s4,c),y=await u(Yf,c),v=await u(Ur,c),D=await u(u4,c),E=await u(Fr,c),S=await u(qa,t),k=await u(Jf,c),C=await u(Xf,c),R=await u(Ir,c),z=await u(js,c),B=await u(Bf,c),{cumulativeLayoutShift:J,cumulativeLayoutShiftMainFrame:ne}=S||{},K={firstContentfulPaint:h?.timing,firstContentfulPaintTs:h?.timestamp,firstContentfulPaintAllFrames:f?.timing,firstContentfulPaintAllFramesTs:f?.timestamp,firstMeaningfulPaint:y?.timing,firstMeaningfulPaintTs:y?.timestamp,largestContentfulPaint:v?.timing,largestContentfulPaintTs:v?.timestamp,largestContentfulPaintAllFrames:D?.timing,largestContentfulPaintAllFramesTs:D?.timestamp,interactive:E?.timing,interactiveTs:E?.timestamp,speedIndex:C?.timing,speedIndexTs:C?.timestamp,totalBlockingTime:R?.timing,maxPotentialFID:k?.timing,cumulativeLayoutShift:J,cumulativeLayoutShiftMainFrame:ne,lcpLoadStart:z?.loadStart,lcpLoadEnd:z?.loadEnd,timeToFirstByte:B?.timing,timeToFirstByteTs:B?.timestamp,observedTimeOrigin:l.timings.timeOrigin,observedTimeOriginTs:l.timestamps.timeOrigin,observedNavigationStart:m?.timings.timeOrigin,observedNavigationStartTs:m?.timestamps.timeOrigin,observedFirstPaint:m?.timings.firstPaint,observedFirstPaintTs:m?.timestamps.firstPaint,observedFirstContentfulPaint:m?.timings.firstContentfulPaint,observedFirstContentfulPaintTs:m?.timestamps.firstContentfulPaint,observedFirstContentfulPaintAllFrames:m?.timings.firstContentfulPaintAllFrames,observedFirstContentfulPaintAllFramesTs:m?.timestamps.firstContentfulPaintAllFrames,observedFirstMeaningfulPaint:m?.timings.firstMeaningfulPaint,observedFirstMeaningfulPaintTs:m?.timestamps.firstMeaningfulPaint,observedLargestContentfulPaint:m?.timings.largestContentfulPaint,observedLargestContentfulPaintTs:m?.timestamps.largestContentfulPaint,observedLargestContentfulPaintAllFrames:m?.timings.largestContentfulPaintAllFrames,observedLargestContentfulPaintAllFramesTs:m?.timestamps.largestContentfulPaintAllFrames,observedTraceEnd:l.timings.traceEnd,observedTraceEndTs:l.timestamps.traceEnd,observedLoad:m?.timings.load,observedLoadTs:m?.timestamps.load,observedDomContentLoaded:m?.timings.domContentLoaded,observedDomContentLoadedTs:m?.timestamps.domContentLoaded,observedCumulativeLayoutShift:J,observedCumulativeLayoutShiftMainFrame:ne,observedFirstVisualChange:p.first,observedFirstVisualChangeTs:(p.first+p.beginning)*1e3,observedLastVisualChange:p.complete,observedLastVisualChangeTs:(p.complete+p.beginning)*1e3,observedSpeedIndex:p.speedIndex,observedSpeedIndexTs:(p.speedIndex+p.beginning)*1e3},oe={lcpInvalidated:!!m?.lcpInvalidated};return{metrics:K,debugInfo:oe}}static async compute_(t,n){return e.summarize(t.trace,t.devtoolsLog,t.gatherContext,t.settings,t.URL,n)}},Vs=q(ex,["devtoolsLog","gatherContext","settings","trace","URL"])});var p4={};T(p4,{default:()=>Aoe});var Coe,tx,Aoe,f4=b(()=>{"use strict";d();V();Zf();Coe=new Set(["cumulativeLayoutShift","cumulativeLayoutShiftMainFrame","observedCumulativeLayoutShift","observedCumulativeLayoutShiftMainFrame"]),tx=class extends g{static{s(this,"Metrics")}static get meta(){return{id:"metrics",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:"Metrics",description:"Collects all available metrics.",supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static async audit(t,n){let r=t.GatherContext,a=t.traces[g.DEFAULT_PASS],o=t.devtoolsLogs[g.DEFAULT_PASS],i=t.URL,c=await Vs.request({trace:a,devtoolsLog:o,gatherContext:r,settings:n.settings,URL:i},n),u=c.metrics,l=c.debugInfo;for(let[p,h]of Object.entries(u)){let f=p;typeof h=="number"&&!Coe.has(f)&&(u[f]=Math.round(h))}let m={type:"debugdata",items:[u,l]};return{score:1,numericValue:u.interactive||0,numericUnit:"millisecond",details:m}}},Aoe=tx});var h4={};T(h4,{UIStrings:()=>ax,default:()=>_oe});var ax,nx,rx,_oe,g4=b(()=>{"use strict";d();V();A();rd();ax={description:"First Contentful Paint marks the time at which the first text or image is painted. [Learn more about the First Contentful Paint metric](https://developer.chrome.com/docs/lighthouse/performance/first-contentful-paint/)."},nx=w("core/audits/metrics/first-contentful-paint.js",ax),rx=class extends g{static{s(this,"FirstContentfulPaint")}static get meta(){return{id:"first-contentful-paint",title:nx(x.firstContentfulPaintMetric),description:nx(ax.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:1800,median:3e3}},desktop:{scoring:{p10:934,median:1600}}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.GatherContext,i={trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL},c=await Ga.request(i,n),u=n.options[n.settings.formFactor];return{score:g.computeLogNormalScore(u.scoring,c.timing),scoringOptions:u.scoring,numericValue:c.timing,numericUnit:"millisecond",displayValue:nx(x.seconds,{timeInMs:c.timing})}}},_oe=rx});var y4={};T(y4,{UIStrings:()=>sx,default:()=>Roe});var sx,ox,ix,Roe,b4=b(()=>{"use strict";d();V();A();VE();sx={description:"First Meaningful Paint measures when the primary content of a page is visible. [Learn more about the First Meaningful Paint metric](https://developer.chrome.com/docs/lighthouse/performance/first-meaningful-paint/)."},ox=w("core/audits/metrics/first-meaningful-paint.js",sx),ix=class extends g{static{s(this,"FirstMeaningfulPaint")}static get meta(){return{id:"first-meaningful-paint",title:ox(x.firstMeaningfulPaintMetric),description:ox(sx.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:2336,median:4e3}},desktop:{scoring:{p10:934,median:1600}}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.GatherContext,i={trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL},c=await Yf.request(i,n),u=n.options[n.settings.formFactor];return{score:g.computeLogNormalScore(u.scoring,c.timing),numericValue:c.timing,numericUnit:"millisecond",displayValue:ox(x.seconds,{timeInMs:c.timing})}}},Roe=ix});var v4={};T(v4,{UIStrings:()=>lx,default:()=>dx});var lx,cx,ux,dx,mx=b(()=>{"use strict";d();V();Qp();A();lx={description:"Interaction to Next Paint measures page responsiveness, how long it takes the page to visibly respond to user input. [Learn more about the Interaction to Next Paint metric](https://web.dev/articles/inp)."},cx=w("core/audits/metrics/interaction-to-next-paint.js",lx),ux=class extends g{static{s(this,"InteractionToNextPaint")}static get meta(){return{id:"interaction-to-next-paint",title:cx(x.interactionToNextPaint),description:cx(lx.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["timespan"],requiredArtifacts:["traces"]}}static get defaultOptions(){return{p10:200,median:500}}static async audit(t,n){let{settings:r}=n;if(r.throttlingMethod==="simulate")return{score:null,notApplicable:!0};let o={trace:t.traces[g.DEFAULT_PASS],settings:r},i=await ds.request(o,n);if(i===null)return{score:null,notApplicable:!0};let c=i.name==="FallbackTiming"?i.duration:i.args.data.duration;return{score:g.computeLogNormalScore({p10:n.options.p10,median:n.options.median},c),numericValue:c,numericUnit:"millisecond",displayValue:cx(x.ms,{timeInMs:c})}}},dx=ux});var w4={};T(w4,{UIStrings:()=>hx,default:()=>Foe});var hx,px,fx,Foe,D4=b(()=>{"use strict";d();V();A();gs();hx={description:"Time to Interactive is the amount of time it takes for the page to become fully interactive. [Learn more about the Time to Interactive metric](https://developer.chrome.com/docs/lighthouse/performance/interactive/)."},px=w("core/audits/metrics/interactive.js",hx),fx=class extends g{static{s(this,"InteractiveMetric")}static get meta(){return{id:"interactive",title:px(x.interactiveMetric),description:px(hx.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:3785,median:7300}},desktop:{scoring:{p10:2468,median:4500}}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.GatherContext,i={trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL},u=(await Fr.request(i,n)).timing,l=n.options[n.settings.formFactor];return{score:g.computeLogNormalScore(l.scoring,u),numericValue:u,numericUnit:"millisecond",displayValue:px(x.seconds,{timeInMs:u})}}},Foe=fx});var E4={};T(E4,{UIStrings:()=>bx,default:()=>Ioe});var bx,gx,yx,Ioe,x4=b(()=>{"use strict";d();V();QE();Nt();sr();A();bx={description:"The maximum potential First Input Delay that your users could experience is the duration of the longest task. [Learn more about the Maximum Potential First Input Delay metric](https://developer.chrome.com/docs/lighthouse/performance/lighthouse-max-potential-fid/)."},gx=w("core/audits/metrics/max-potential-fid.js",bx),yx=class e extends g{static{s(this,"MaxPotentialFID")}static get meta(){return{id:"max-potential-fid",title:gx(x.maxPotentialFIDMetric),description:gx(bx.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{p10:130,median:250}}static getLongAnimationFrameDetails(t,n){let{firstContentfulPaint:r,timeOrigin:a}=n.timestamps,o=t.mainThreadEvents.filter(p=>p.name==="LongAnimationFrame"&&p.ph==="b");if(o.length===0)return;let i=-1/0,c,u=-1/0,l,m=[];for(let p of o){let h=p.args?.data?.duration,f=p.args?.data?.blockingDuration;h===void 0||f===void 0||(m.push({startTime:(p.ts-a)/1e3,duration:h,blockingDuration:f}),!(p.ts<r)&&(h>i&&(i=h,c=p),f>u&&(u=f,l=p)))}return{type:"debugdata",observedMaxDurationLoaf:c,observedMaxBlockingLoaf:l,observedLoafs:m}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.GatherContext,i={trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL},c=await Jf.request(i,n),u=await ke.request(r,n),l=await zt.request(r,n),m=e.getLongAnimationFrameDetails(u,l);return{score:g.computeLogNormalScore({p10:n.options.p10,median:n.options.median},c.timing),numericValue:c.timing,numericUnit:"millisecond",displayValue:gx(x.ms,{timeInMs:c.timing}),details:m}}},Ioe=yx});var T4={};T(T4,{UIStrings:()=>Dx,default:()=>Noe});var Dx,vx,wx,Noe,S4=b(()=>{"use strict";d();V();A();XE();Dx={description:"Speed Index shows how quickly the contents of a page are visibly populated. [Learn more about the Speed Index metric](https://developer.chrome.com/docs/lighthouse/performance/speed-index/)."},vx=w("core/audits/metrics/speed-index.js",Dx),wx=class extends g{static{s(this,"SpeedIndex")}static get meta(){return{id:"speed-index",title:vx(x.speedIndexMetric),description:vx(Dx.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:3387,median:5800}},desktop:{scoring:{p10:1311,median:2300}}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.GatherContext,i={trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL},c=await Xf.request(i,n),u=n.options[n.settings.formFactor];return{score:g.computeLogNormalScore(u.scoring,c.timing),scoringOptions:u.scoring,numericValue:c.timing,numericUnit:"millisecond",displayValue:vx(x.seconds,{timeInMs:c.timing})}}},Noe=wx});var k4={};T(k4,{UIStrings:()=>Tx,default:()=>Moe});var Tx,Ex,xx,Moe,C4=b(()=>{"use strict";d();V();ys();A();Tx={description:"Sum of all time periods between FCP and Time to Interactive, when task length exceeded 50ms, expressed in milliseconds. [Learn more about the Total Blocking Time metric](https://developer.chrome.com/docs/lighthouse/performance/lighthouse-total-blocking-time/)."},Ex=w("core/audits/metrics/total-blocking-time.js",Tx),xx=class extends g{static{s(this,"TotalBlockingTime")}static get meta(){return{id:"total-blocking-time",title:Ex(x.totalBlockingTimeMetric),description:Ex(Tx.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static get defaultOptions(){return{mobile:{scoring:{p10:200,median:600}},desktop:{scoring:{p10:150,median:350}}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.GatherContext,i={trace:r,devtoolsLog:a,gatherContext:o,settings:n.settings,URL:t.URL};if(o.gatherMode==="timespan"&&n.settings.throttlingMethod==="simulate")return{score:1,notApplicable:!0};let c=await Ir.request(i,n),u=n.options[n.settings.formFactor];return{score:g.computeLogNormalScore(u.scoring,c.timing),scoringOptions:u.scoring,numericValue:c.timing,numericUnit:"millisecond",displayValue:Ex(x.ms,{timeInMs:c.timing})}}},Moe=xx});var A4={};T(A4,{default:()=>Loe});var Sx,Loe,_4=b(()=>{"use strict";d();V();Ze();de();Bt();ua();Sx=class extends g{static{s(this,"NetworkRequests")}static get meta(){return{id:"network-requests",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:"Network Requests",description:"Lists the network requests that were made during page load.",requiredArtifacts:["devtoolsLogs","URL","GatherContext"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await H.request(r,n),o=await ln.request({URL:t.URL,devtoolsLog:r},n),i=a.reduce((f,y)=>Math.min(f,y.rendererStartTime),1/0),c;t.GatherContext.gatherMode==="navigation"&&(c=(await _e.request({devtoolsLog:r,URL:t.URL},n)).frameId);let u=s(f=>f<i||!Number.isFinite(f)?void 0:f-i,"normalizeTime"),l=a.map(f=>{let y=f.lrStatistics?.endTimeDeltaMs,v=f.lrStatistics?.TCPMs,D=f.lrStatistics?.requestMs,E=f.lrStatistics?.responseMs,S=f.isLinkPreload||void 0,k=c&&f.frameId===c||void 0,C=o.entityByUrl.get(f.url);return{url:Y.elideDataURI(f.url),sessionTargetType:f.sessionTargetType,protocol:f.protocol,rendererStartTime:u(f.rendererStartTime),networkRequestTime:u(f.networkRequestTime),networkEndTime:u(f.networkEndTime),finished:f.finished,transferSize:f.transferSize,resourceSize:f.resourceSize,statusCode:f.statusCode,mimeType:f.mimeType,resourceType:f.resourceType,priority:f.priority,isLinkPreload:S,experimentalFromMainFrame:k,entity:C?.name,lrEndTimeDeltaMs:y,lrTCPMs:v,lrRequestMs:D,lrResponseMs:E}}),m=[{key:"url",valueType:"url",label:"URL"},{key:"protocol",valueType:"text",label:"Protocol"},{key:"networkRequestTime",valueType:"ms",granularity:1,label:"Network Request Time"},{key:"networkEndTime",valueType:"ms",granularity:1,label:"Network End Time"},{key:"transferSize",valueType:"bytes",displayUnit:"kb",granularity:1,label:"Transfer Size"},{key:"resourceSize",valueType:"bytes",displayUnit:"kb",granularity:1,label:"Resource Size"},{key:"statusCode",valueType:"text",label:"Status Code"},{key:"mimeType",valueType:"text",label:"MIME Type"},{key:"resourceType",valueType:"text",label:"Resource Type"}],p=g.makeTableDetails(m,l),h=Number.isFinite(i)?i*1e3:void 0;return p.debugData={type:"debugdata",networkStartTimeTs:h},{score:1,details:p}}},Loe=Sx});var R4={};T(R4,{UIStrings:()=>Qf,default:()=>Poe});var Qf,Ud,kx,Poe,F4=b(()=>{"use strict";d();V();A();de();jo();Qf={title:"Network Round Trip Times",description:"Network round trip times (RTT) have a large impact on performance. If the RTT to an origin is high, it's an indication that servers closer to the user could improve performance. [Learn more about the Round Trip Time](https://hpbn.co/primer-on-latency-and-bandwidth/)."},Ud=w("core/audits/network-rtt.js",Qf),kx=class extends g{static{s(this,"NetworkRTT")}static get meta(){return{id:"network-rtt",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:Ud(Qf.title),description:Ud(Qf.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS];if(!(await H.request(r,n)).length)return{score:1,notApplicable:!0};let o=await ar.request(r,n),i=0,c=o.rtt,u=[];for(let[p,h]of o.additionalRttByOrigin.entries()){if(!p.startsWith("http"))continue;let f=h+c;u.push({origin:p,rtt:f}),i=Number.isFinite(f)?Math.max(f,i):i}u.sort((p,h)=>h.rtt-p.rtt);let l=[{key:"origin",valueType:"text",label:Ud(x.columnURL)},{key:"rtt",valueType:"ms",granularity:1,label:Ud(x.columnTimeSpent)}],m=g.makeTableDetails(l,u,{sortedBy:["rtt"]});return{score:1,numericValue:i,numericUnit:"millisecond",displayValue:Ud(x.ms,{timeInMs:i}),details:m}}},Poe=kx});var I4={};T(I4,{UIStrings:()=>eh,default:()=>Ooe});var eh,jd,Cx,Ooe,N4=b(()=>{"use strict";d();V();A();de();jo();eh={title:"Server Backend Latencies",description:"Server latencies can impact web performance. If the server latency of an origin is high, it's an indication the server is overloaded or has poor backend performance. [Learn more about server response time](https://hpbn.co/primer-on-web-performance/#analyzing-the-resource-waterfall)."},jd=w("core/audits/network-server-latency.js",eh),Cx=class extends g{static{s(this,"NetworkServerLatency")}static get meta(){return{id:"network-server-latency",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:jd(eh.title),description:jd(eh.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS];if(!(await H.request(r,n)).length)return{score:1,notApplicable:!0};let o=await ar.request(r,n),i=0,c=[];for(let[m,p]of o.serverResponseTimeByOrigin.entries())m.startsWith("http")&&(i=Math.max(p,i),c.push({origin:m,serverResponseTime:p}));c.sort((m,p)=>p.serverResponseTime-m.serverResponseTime);let u=[{key:"origin",valueType:"text",label:jd(x.columnURL)},{key:"serverResponseTime",valueType:"ms",granularity:1,label:jd(x.columnTimeSpent)}],l=g.makeTableDetails(u,c,{sortedBy:["serverResponseTime"]});return{score:Math.max(1-i/500,0),numericValue:i,numericUnit:"millisecond",displayValue:jd(x.ms,{timeInMs:i}),details:l}}},Ooe=Cx});var M4={};T(M4,{UIStrings:()=>qd,default:()=>Boe});var qd,th,Ax,Boe,L4=b(()=>{"use strict";d();V();ca();A();qd={title:"Avoids `unload` event listeners",failureTitle:"Registers an `unload` listener",description:"The `unload` event does not fire reliably and listening for it can prevent browser optimizations like the Back-Forward Cache. Use `pagehide` or `visibilitychange` events instead. [Learn more about unload event listeners](https://web.dev/articles/bfcache#never_use_the_unload_event)"},th=w("core/audits/no-unload-listeners.js",qd),Ax=class extends g{static{s(this,"NoUnloadListeners")}static get meta(){return{id:"no-unload-listeners",title:th(qd.title),failureTitle:th(qd.failureTitle),description:th(qd.description),requiredArtifacts:["GlobalListeners","SourceMaps","Scripts"]}}static async audit(t,n){let r=t.GlobalListeners.filter(c=>c.type==="unload");if(!r.length)return{score:1};let a=await un.request(t,n),o=[{key:"source",valueType:"source-location",label:th(x.columnSource)}],i=r.map(c=>{let{lineNumber:u,columnNumber:l}=c,m=t.Scripts.find(h=>h.scriptId===c.scriptId);if(!m)return{source:{type:"url",value:`(unknown):${u}:${l}`}};let p=a.find(h=>h.script.scriptId===m.scriptId);return{source:g.makeSourceLocation(m.url,u,l,p)}});return{score:0,details:g.makeTableDetails(o,i)}}},Boe=Ax});var P4={};T(P4,{UIStrings:()=>Jn,default:()=>qoe});function joe(e,t){return Uoe.filter(n=>e&n.flag).map(n=>n.text===Jn.unsupportedCSSProperty?ii(n.text,{propertyCount:t.length,properties:t.join(", ")}):ii(n.text))}var Jn,ii,Uoe,_x,qoe,O4=b(()=>{"use strict";d();V();A();Jn={title:"Avoid non-composited animations",description:"Animations which are not composited can be janky and increase CLS. [Learn how to avoid non-composited animations](https://developer.chrome.com/docs/lighthouse/performance/non-composited-animations/)",displayValue:`{itemCount, plural,
  =1 {# animated element found}
  other {# animated elements found}
  }`,unsupportedCSSProperty:`{propertyCount, plural,
    =1 {Unsupported CSS Property: {properties}}
    other {Unsupported CSS Properties: {properties}}
  }`,transformDependsBoxSize:"Transform-related property depends on box size",filterMayMovePixels:"Filter-related property may move pixels",nonReplaceCompositeMode:'Effect has composite mode other than "replace"',incompatibleAnimations:"Target has another animation which is incompatible",unsupportedTimingParameters:"Effect has unsupported timing parameters"},ii=w("core/audits/non-composited-animations.js",Jn),Uoe=[{flag:8192,text:Jn.unsupportedCSSProperty},{flag:2048,text:Jn.transformDependsBoxSize},{flag:4096,text:Jn.filterMayMovePixels},{flag:16,text:Jn.nonReplaceCompositeMode},{flag:64,text:Jn.incompatibleAnimations},{flag:8,text:Jn.unsupportedTimingParameters}];s(joe,"getActionableFailureReasons");_x=class extends g{static{s(this,"NonCompositedAnimations")}static get meta(){return{id:"non-composited-animations",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:ii(Jn.title),description:ii(Jn.description),guidanceLevel:2,requiredArtifacts:["TraceElements","HostUserAgent"]}}static async audit(t){let n=t.HostUserAgent.match(/Chrome\/(\d+)/);if(!n||Number(n[1])<86)return{score:1,notApplicable:!0,metricSavings:{CLS:0}};let r=[],a=!1;t.TraceElements.forEach(u=>{if(u.traceEventType!=="animation")return;let l=u.animations||[],m=new Map;for(let{name:h,failureReasonsMask:f,unsupportedProperties:y}of l){if(!f)continue;let v=joe(f,y||[]);for(let D of v){h&&(a=!0);let E=m.get(h)||new Set;E.add(D),m.set(h,E)}}if(!m.size)return;let p=[];for(let[h,f]of m)for(let y of f)p.push({failureReason:y,animation:h});r.push({node:g.makeNodeItem(u.node),subItems:{type:"subitems",items:p}})});let o=[{key:"node",valueType:"node",subItemsHeading:{key:"failureReason",valueType:"text"},label:ii(x.columnElement)}];a&&o.push({key:null,valueType:"text",subItemsHeading:{key:"animation",valueType:"text"},label:ii(x.columnName)});let i=g.makeTableDetails(o,r),c;return r.length>0&&(c=ii(Jn.displayValue,{itemCount:r.length})),{score:r.length===0?1:0,notApplicable:r.length===0,metricSavings:{CLS:0},details:i,displayValue:c}}},qoe=_x});var B4={};T(B4,{default:()=>zoe});var zoe,U4=b(()=>{"use strict";d();zoe={meta:{id:"oopif-iframe-test-audit",title:"IFrame Elements",failureTitle:"IFrame Elements",description:"Audit to force the inclusion of IFrameElements artifact",requiredArtifacts:["IFrameElements"]},audit:()=>({score:1})}});var Rx,nh,Fx=b(()=>{"use strict";d();ua();ue();de();lt();xu();Ze();Rx=class e{static{s(this,"ResourceSummary")}static determineResourceType(t){return t.resourceType&&{Stylesheet:"stylesheet",Image:"image",Media:"media",Font:"font",Script:"script",Document:"document"}[t.resourceType]||"other"}static summarize(t,n,r,a){let o={stylesheet:{count:0,resourceSize:0,transferSize:0},image:{count:0,resourceSize:0,transferSize:0},media:{count:0,resourceSize:0,transferSize:0},font:{count:0,resourceSize:0,transferSize:0},script:{count:0,resourceSize:0,transferSize:0},document:{count:0,resourceSize:0,transferSize:0},other:{count:0,resourceSize:0,transferSize:0},total:{count:0,resourceSize:0,transferSize:0},"third-party":{count:0,resourceSize:0,transferSize:0}},i=Tr.getMatchingBudget(r,n.mainDocumentUrl),c=[];return i?.options?.firstPartyHostnames?c=i.options.firstPartyHostnames:c=a.firstParty?.domains.map(u=>`*.${u}`)||[`*.${Y.getRootDomain(n.finalDisplayedUrl)}`],t.filter(u=>!(this.determineResourceType(u)==="other"&&u.url.endsWith("/favicon.ico")||G.isNonNetworkRequest(u))).forEach(u=>{let l=this.determineResourceType(u);o[l].count++,o[l].resourceSize+=u.resourceSize,o[l].transferSize+=u.transferSize,o.total.count++,o.total.resourceSize+=u.resourceSize,o.total.transferSize+=u.transferSize,c.some(p=>{let h=new URL(u.url);return p.startsWith("*.")?h.hostname.endsWith(p.slice(2)):h.hostname===p})||(o["third-party"].count++,o["third-party"].resourceSize+=u.resourceSize,o["third-party"].transferSize+=u.transferSize)}),o}static async compute_(t,n){let r=await H.request(t.devtoolsLog,n),a=await ln.request({URL:t.URL,devtoolsLog:t.devtoolsLog},n);return e.summarize(r,t.URL,t.budgets,a)}},nh=q(Rx,["URL","devtoolsLog","budgets"])});var j4={};T(j4,{UIStrings:()=>zd,default:()=>Hoe});var zd,ro,Ix,Hoe,q4=b(()=>{"use strict";d();V();Fx();Bt();xu();A();zd={title:"Performance budget",description:"Keep the quantity and size of network requests under the targets set by the provided performance budget. [Learn more about performance budgets](https://developers.google.com/web/tools/lighthouse/audits/budgets).",requestCountOverBudget:`{count, plural,
    =1 {1 request}
    other {# requests}
   }`},ro=w("core/audits/performance-budget.js",zd),Ix=class extends g{static{s(this,"ResourceBudget")}static get meta(){return{id:"performance-budget",title:ro(zd.title),description:ro(zd.description),scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","URL"]}}static getRowLabel(t){return{total:x.totalResourceType,document:x.documentResourceType,script:x.scriptResourceType,stylesheet:x.stylesheetResourceType,image:x.imageResourceType,media:x.mediaResourceType,font:x.fontResourceType,other:x.otherResourceType,"third-party":x.thirdPartyResourceType}[t]}static tableItems(t,n){return Object.keys(n).map(a=>{let o=ro(this.getRowLabel(a)),i=n[a].count,c=n[a].transferSize,u,l;if(t.resourceSizes){let m=t.resourceSizes.find(p=>p.resourceType===a);m&&c>m.budget*1024&&(u=c-m.budget*1024)}if(t.resourceCounts){let m=t.resourceCounts.find(p=>p.resourceType===a);if(m&&i>m.budget){let p=i-m.budget;l=ro(zd.requestCountOverBudget,{count:p})}}return{resourceType:a,label:o,requestCount:i,transferSize:c,countOverBudget:l,sizeOverBudget:u}}).filter(a=>!!(t.resourceSizes&&t.resourceSizes.some(o=>o.resourceType===a.resourceType)||t.resourceCounts&&t.resourceCounts.some(o=>o.resourceType===a.resourceType))).sort((a,o)=>(o.sizeOverBudget||0)-(a.sizeOverBudget||0))}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a={devtoolsLog:r,URL:t.URL,budgets:n.settings.budgets},o=await nh.request(a,n),i=await _e.request({URL:t.URL,devtoolsLog:r},n),c=Tr.getMatchingBudget(n.settings.budgets,i.url);if(!c)return{score:0,notApplicable:!0};let u=[{key:"label",valueType:"text",label:ro(x.columnResourceType)},{key:"requestCount",valueType:"numeric",label:ro(x.columnRequests)},{key:"transferSize",valueType:"bytes",label:ro(x.columnTransferSize)},{key:"countOverBudget",valueType:"text",label:""},{key:"sizeOverBudget",valueType:"bytes",label:ro(x.columnOverBudget)}];return{details:g.makeTableDetails(u,this.tableItems(c,o),{sortedBy:["sizeOverBudget"]}),score:1}}},Hoe=Ix});var z4={};T(z4,{default:()=>$oe});var Goe,Voe,Woe,Nx,$oe,H4=b(()=>{"use strict";d();V();A();cr();tf();Yo();YE();Ko();Zf();zn();Goe=3651,Voe=1e4,Woe=w("core/audits/predictive-perf.js",{}),Nx=class extends g{static{s(this,"PredictivePerf")}static get meta(){return{id:"predictive-perf",title:"Predicted Performance (beta)",description:"Predicted performance evaluates how your site will perform under a cellular connection on a mobile device.",scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL"]}}static async audit(t,n){let r=t.GatherContext,a=t.traces[g.DEFAULT_PASS],o=t.devtoolsLogs[g.DEFAULT_PASS],i=t.URL,c=JSON.parse(JSON.stringify(qn)),u={trace:a,devtoolsLog:o,gatherContext:r,settings:c,URL:i},l=await Tt.request(u,n),m=await fs.request(u,n),p=await An.request(u,n),h=await Kf.request(u,n),f=await $n.request(u,n),y=await Vs.request(u,n),v={roughEstimateOfFCP:l.timing,optimisticFCP:l.optimisticEstimate.timeInMs,pessimisticFCP:l.pessimisticEstimate.timeInMs,roughEstimateOfFMP:m.timing,optimisticFMP:m.optimisticEstimate.timeInMs,pessimisticFMP:m.pessimisticEstimate.timeInMs,roughEstimateOfTTI:p.timing,optimisticTTI:p.optimisticEstimate.timeInMs,pessimisticTTI:p.pessimisticEstimate.timeInMs,roughEstimateOfSI:h.timing,optimisticSI:h.optimisticEstimate.timeInMs,pessimisticSI:h.pessimisticEstimate.timeInMs,roughEstimateOfLCP:f.timing,optimisticLCP:f.optimisticEstimate.timeInMs,pessimisticLCP:f.pessimisticEstimate.timeInMs,roughEstimateOfTTFB:y.metrics.timeToFirstByte,roughEstimateOfLCPLoadStart:y.metrics.lcpLoadStart,roughEstimateOfLCPLoadEnd:y.metrics.lcpLoadEnd};return{score:g.computeLogNormalScore({p10:Goe,median:Voe},v.roughEstimateOfTTI),numericValue:v.roughEstimateOfTTI,numericUnit:"millisecond",displayValue:Woe(x.ms,{timeInMs:v.roughEstimateOfTTI}),details:{type:"debugdata",items:[v]}}}},$oe=Nx});var G4={};T(G4,{UIStrings:()=>Hd,default:()=>Koe});var Yoe,Hd,rh,Mx,Koe,V4=b(()=>{"use strict";d();V();A();eE();de();Yoe=/^(optional)$/,Hd={title:"Fonts with `font-display: optional` are preloaded",failureTitle:"Fonts with `font-display: optional` are not preloaded",description:"Preload `optional` fonts so first-time visitors may use them. [Learn more about preloading fonts](https://web.dev/articles/preload-optional-fonts)"},rh=w("core/audits/preload-fonts.js",Hd),Mx=class e extends g{static{s(this,"PreloadFontsAudit")}static get meta(){return{id:"preload-fonts",title:rh(Hd.title),failureTitle:rh(Hd.failureTitle),description:rh(Hd.description),requiredArtifacts:["devtoolsLogs","URL","CSSUsage"]}}static getURLsAttemptedToPreload(t){let n=t.filter(r=>r.resourceType==="Font").filter(r=>r.isLinkPreload).map(r=>r.url);return new Set(n)}static async audit_(t,n){let r=t.devtoolsLogs[this.DEFAULT_PASS],a=await H.request(r,n),o=QD.findFontDisplayDeclarations(t,Yoe).passingURLs,i=e.getURLsAttemptedToPreload(a),c=Array.from(o).filter(l=>!i.has(l)).map(l=>({url:l})),u=[{key:"url",valueType:"url",label:rh(x.columnURL)}];return{score:c.length>0?0:1,details:g.makeTableDetails(u,c),notApplicable:o.size===0}}static async audit(){return{score:1,notApplicable:!0}}},Koe=Mx});var W4={};T(W4,{UIStrings:()=>ah,default:()=>Xoe});var ah,Gd,Lx,Xoe,$4=b(()=>{"use strict";d();V();A();lt();Bt();Ko();Gn();af();ah={title:"Preload Largest Contentful Paint image",description:"If the LCP element is dynamically added to the page, you should preload the image in order to improve LCP. [Learn more about preloading LCP elements](https://web.dev/articles/optimize-lcp#optimize_when_the_resource_is_discovered)."},Gd=w("core/audits/prioritize-lcp-image.js",ah),Lx=class e extends g{static{s(this,"PrioritizeLcpImage")}static get meta(){return{id:"prioritize-lcp-image",title:Gd(ah.title),description:Gd(ah.description),supportedModes:["navigation"],guidanceLevel:3,requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL","TraceElements"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS}}static shouldPreloadRequest(t,n,r){return t.isLinkPreload||G.isNonNetworkRequest(t)||r.length<=2?!1:t.frameId===n.frameId}static findLCPNode(t,n){for(let{node:r}of t.traverseGenerator())if(r.type==="network"&&r.record.requestId===n.requestId)return r}static getLcpInitiatorPath(t,n){let r=[],a=!1,o=t;for(;o;){a||=o.requestId===n.requestId;let i=o.initiator?.type??"other";if(o.initiatorRequest&&o.initiatorRequest===o.redirectSource&&(i="redirect"),!o.initiatorRequest&&!a&&(i="fallbackToMain"),r.push({url:o.url,initiatorType:i}),a)break;o=o.initiatorRequest||n}return r}static getLCPNodeToPreload(t,n,r){if(!r)return{};let a=e.findLCPNode(n,r),o=e.getLcpInitiatorPath(r,t);return a?{lcpNodeToPreload:e.shouldPreloadRequest(r,t,o)?a:void 0,initiatorPath:o}:{initiatorPath:o}}static computeWasteWithGraph(t,n,r,a){if(!n)return{wastedMs:0,results:[]};let o=r.cloneWithRelationships(),i=new Set;for(let D of n.getDependencies())i.add(D.id);let c=null,u=null;for(let{node:D}of o.traverseGenerator())D.type==="network"&&(D.isMainDocument()?u=D:D.id===n.id&&(c=D));if(!u)throw new Error("Could not find main document node");if(!c)throw new Error("Could not find the LCP node");c.removeAllDependencies(),c.addDependency(u);let l=a.simulate(r,{flexibleOrdering:!0}),m=a.simulate(o,{flexibleOrdering:!0}),p=l.nodeTimings.get(n);if(!p)throw new Error("Impossible - node timings should never be undefined");let h=m.nodeTimings.get(c);if(!h)throw new Error("Impossible - node timings should never be undefined");let f=Array.from(m.nodeTimings.keys()).reduce((D,E)=>D.set(E.id,E),new Map),y=0;for(let D of Array.from(i)){let E=f.get(D);if(!E)throw new Error("Impossible - node should never be undefined");let k=m.nodeTimings.get(E)?.endTime||0;y=Math.max(y,k)}let v=p.endTime-Math.max(h.endTime,y);return{wastedMs:v,results:[{node:g.makeNodeItem(t.node),url:n.record.url,wastedMs:v}]}}static async audit(t,n){let r=t.GatherContext,a=t.traces[e.DEFAULT_PASS],o=t.devtoolsLogs[e.DEFAULT_PASS],i=t.URL,c=n.settings,u={trace:a,devtoolsLog:o,gatherContext:r,settings:c,URL:i},l=t.TraceElements.find(R=>R.traceEventType==="largest-contentful-paint");if(!l||l.type!=="image")return{score:null,notApplicable:!0,metricSavings:{LCP:0}};let m=await _e.request({devtoolsLog:o,URL:i},n),p=await $n.request(u,n),h=await Pt.request({devtoolsLog:o,settings:c},n),f=await bs.request({trace:a,devtoolsLog:o},n),y=p.pessimisticGraph,{lcpNodeToPreload:v,initiatorPath:D}=e.getLCPNodeToPreload(m,y,f),{results:E,wastedMs:S}=e.computeWasteWithGraph(l,v,y,h),k=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:Gd(x.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:Gd(x.columnWastedMs)}],C=g.makeOpportunityDetails(k,E,{overallSavingsMs:S,sortedBy:["wastedMs"]});return D&&(C.debugData={type:"debugdata",initiatorPath:D,pathLength:D.length}),{score:E.length?0:1,numericValue:S,numericUnit:"millisecond",displayValue:S?Gd(x.displayValueMsSavings,{wastedMs:S}):"",details:C,metricSavings:{LCP:S}}}},Xoe=Lx});var Y4={};T(Y4,{UIStrings:()=>oh,default:()=>Joe});var oh,Vd,Px,Joe,K4=b(()=>{"use strict";d();V();A();Nt();de();Yo();oh={title:"Avoid multiple page redirects",description:"Redirects introduce additional delays before the page can be loaded. [Learn how to avoid page redirects](https://developer.chrome.com/docs/lighthouse/performance/redirects/)."},Vd=w("core/audits/redirects.js",oh),Px=class e extends g{static{s(this,"Redirects")}static get meta(){return{id:"redirects",title:Vd(oh.title),description:Vd(oh.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,supportedModes:["navigation"],guidanceLevel:2,requiredArtifacts:["URL","GatherContext","devtoolsLogs","traces"]}}static getDocumentRequestChain(t,n){let r=[];for(let a of n.processEvents){if(a.name!=="navigationStart")continue;let o=a.args.data||{};if(!o.documentLoaderURL||!o.isLoadingMainFrame)continue;let i=t.find(c=>c.requestId===o.navigationId);for(;i;)r.push(i),i=i.redirectDestination}if(!r.length)throw new Error("No navigation requests found");return r}static async audit(t,n){let r=n.settings,a=t.traces[g.DEFAULT_PASS],o=t.devtoolsLogs[g.DEFAULT_PASS],i=t.GatherContext,c=await ke.request(a,n),u=await H.request(o,n),l={trace:a,devtoolsLog:o,gatherContext:i,settings:r,URL:t.URL},m=await An.request(l,n),p=new Map;for(let[E,S]of m.pessimisticEstimate.nodeTimings.entries())E.type==="network"&&p.set(E.record.requestId,S);let h=e.getDocumentRequestChain(u,c),f=0,y=[];for(let E=0;E<h.length&&!(h.length<2);E++){let S=h[E],k=h[E+1]||S,C=p.get(S.requestId),R=p.get(k.requestId);if(!C||!R)throw new Error("Could not find redirects in graph");let z=R.startTime-C.startTime,B=k.networkRequestTime-S.networkRequestTime,J=r.throttlingMethod==="simulate"?z:B;f+=J,y.push({url:S.url,wastedMs:J})}let v=[{key:"url",valueType:"url",label:Vd(x.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:Vd(x.columnTimeSpent)}],D=g.makeOpportunityDetails(v,y,{overallSavingsMs:f});return{score:y.length?0:1,numericValue:f,numericUnit:"millisecond",displayValue:f?Vd(x.displayValueMsSavings,{wastedMs:f}):"",details:D,metricSavings:{LCP:f,FCP:f}}}},Joe=Px});var X4={};T(X4,{default:()=>Zoe});var Zn,Ox,Zoe,J4=b(()=>{"use strict";d();V();Fx();A();Zn=w("core/audits/resource-summary.js"),Ox=class extends g{static{s(this,"ResourceSummary")}static get meta(){return{id:"resource-summary",title:"Resources Summary",description:"Aggregates all network requests and groups them by type",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,requiredArtifacts:["devtoolsLogs","URL"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await nh.request({devtoolsLog:r,URL:t.URL,budgets:n.settings.budgets},n),o=[{key:"label",valueType:"text",label:Zn(x.columnResourceType)},{key:"requestCount",valueType:"numeric",label:Zn(x.columnRequests)},{key:"transferSize",valueType:"bytes",label:Zn(x.columnTransferSize)}],i={total:Zn(x.totalResourceType),document:Zn(x.documentResourceType),script:Zn(x.scriptResourceType),stylesheet:Zn(x.stylesheetResourceType),image:Zn(x.imageResourceType),media:Zn(x.mediaResourceType),font:Zn(x.fontResourceType),other:Zn(x.otherResourceType),"third-party":Zn(x.thirdPartyResourceType)},u=Object.keys(a).map(f=>({resourceType:f,label:i[f],requestCount:a[f].count,transferSize:a[f].transferSize})),l=u.find(f=>f.resourceType==="third-party")||[],p=u.filter(f=>f.resourceType!=="third-party").sort((f,y)=>y.transferSize-f.transferSize).concat(l);return{details:g.makeTableDetails(o,p),score:null}}},Zoe=Ox});var Q4={};T(Q4,{default:()=>eie});var Z4,Qoe,Bx,eie,eB=b(()=>{"use strict";d();Z4=Lt(LE(),1);V();It();Bd();Qoe=8,Bx=class e extends g{static{s(this,"ScreenshotThumbnails")}static get meta(){return{id:"screenshot-thumbnails",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:"Screenshot Thumbnails",description:"This is what the load of your site looked like.",requiredArtifacts:["traces","GatherContext"]}}static scaleImageToThumbnail(t,n){let r=t.width/n,a=Math.floor(t.height/r),o=new Uint8Array(n*a*4);for(let i=0;i<n;i++)for(let c=0;c<a;c++){let u=Math.floor(i*r),m=(Math.floor(c*r)*t.width+u)*4,p=(c*n+i)*4;o[p]=t.data[m],o[p+1]=t.data[m+1],o[p+2]=t.data[m+2],o[p+3]=t.data[m+3]}return{width:n,height:a,data:o}}static async _audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=new Map,o=await no.request(r,n),i=n.options.minimumTimelineDuration||3e3,c=n.options.numberOfThumbnails||Qoe,u=n.options.thumbnailWidth||null,l=[],m=o.frames.filter(f=>!f.isProgressInterpolated()),p=o.complete||Math.max(...o.frames.map(f=>f.getTimeStamp()-o.beginning)),h=Math.max(p,i);if(!m.length||!Number.isFinite(h))throw new j(j.errors.INVALID_SPEEDLINE);for(let f=1;f<=c;f++){let y=o.beginning+h*f/c,v=null;f===c?v=m[m.length-1]:m.forEach(S=>{S.getTimeStamp()<=y&&(v=S)});let D,E=a.get(v);if(E)D=E;else if(u!==null){let S=v.getParsedImage(),k=e.scaleImageToThumbnail(S,u);D=Z4.default.encode(k,90).data.toString("base64"),a.set(v,D)}else D=v.getImage().toString("base64"),a.set(v,D);l.push({timing:Math.round(y-o.beginning),timestamp:y*1e3,data:`data:image/jpeg;base64,${D}`})}return{score:1,details:{type:"filmstrip",scale:h,items:l}}}static async audit(t,n){try{return await this._audit(t,n)}catch(r){if(new Set([j.errors.NO_SCREENSHOTS.code,j.errors.SPEEDINDEX_OF_ZERO.code,j.errors.NO_SPEEDLINE_FRAMES.code,j.errors.INVALID_SPEEDLINE.code]).has(r.code)&&t.GatherContext.gatherMode==="timespan")return{notApplicable:!0,score:1};throw r}}},eie=Bx});var tB={};T(tB,{default:()=>tie});var tie,nB=b(()=>{"use strict";d();tie={meta:{id:"script-elements-test-audit",title:"ScriptElements",failureTitle:"ScriptElements",description:"Audit to force the inclusion of ScriptElements artifact",requiredArtifacts:["ScriptElements"]},audit:()=>({score:1})}});var rB={};T(rB,{default:()=>nie});var Ux,nie,aB=b(()=>{"use strict";d();V();ca();rD();Lw();Wa();Ux=class e extends g{static{s(this,"ScriptTreemapDataAudit")}static get meta(){return{id:"script-treemap-data",scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,title:"Script Treemap Data",description:"Used for treemap app",requiredArtifacts:["traces","devtoolsLogs","SourceMaps","Scripts","JsUsage","URL"]}}static makeScriptNode(t,n,r){function a(l){return{name:l,resourceBytes:0}}s(a,"newNode");let o=a(n);function i(l,m){let p=o;o.resourceBytes+=m.resourceBytes,m.unusedBytes&&(o.unusedBytes=(o.unusedBytes||0)+m.unusedBytes);let h=l.replace(n,"").split(/\/+/);h.forEach((f,y)=>{if(f.length===0)return;let v=y===h.length-1,D=p.children&&p.children.find(E=>E.name===f);D||(D=a(f),p.children=p.children||[],p.children.push(D)),p=D,p.resourceBytes+=m.resourceBytes,m.unusedBytes&&(p.unusedBytes=(p.unusedBytes||0)+m.unusedBytes),v&&m.duplicatedNormalizedModuleName!==void 0&&(p.duplicatedNormalizedModuleName=m.duplicatedNormalizedModuleName)})}s(i,"addAllNodesInSourcePath");for(let[l,m]of Object.entries(r))i(l,m);function c(l){for(;l.children&&l.children.length===1;)l.name+="/"+l.children[0].name,l.children=l.children[0].children;if(l.children)for(let m of l.children)c(m)}if(s(c,"collapseAll"),c(o),!o.name)return{...o,name:t,children:o.children};let u={...o};return u.name=t,u.children=[o],u}static async makeNodes(t,n){let r=[],a=new Map,o=await un.request(t,n),i=await sd.request(t,n);for(let c of t.Scripts){if(c.scriptLanguage!=="JavaScript")continue;let u=c.url,l=o.find(f=>c.scriptId===f.script.scriptId),m=t.JsUsage[c.scriptId],p=m?await wf.request({scriptId:c.scriptId,scriptCoverage:m,bundle:l},n):void 0,h;if(l&&!("errorMessage"in l.sizes)){let f={};for(let y of Object.keys(l.sizes.files)){let v={resourceBytes:l.sizes.files[y]};p?.sourcesWastedBytes&&(v.unusedBytes=p.sourcesWastedBytes[y]);let D=y;l.rawMap.sourceRoot&&y.startsWith(l.rawMap.sourceRoot)&&(D=y.replace(l.rawMap.sourceRoot,""));let E=sd.normalizeSource(D);i.has(E)&&(v.duplicatedNormalizedModuleName=E),f[y]=v}if(l.sizes.unmappedBytes){let y={resourceBytes:l.sizes.unmappedBytes};p?.sourcesWastedBytes&&(y.unusedBytes=p.sourcesWastedBytes["(unmapped)"]),f["(unmapped)"]=y}h=this.makeScriptNode(c.url,l.rawMap.sourceRoot||"",f)}else h={name:u,resourceBytes:p?.totalBytes??c.length??0,unusedBytes:p?.wastedBytes};if(of(c)){let f=a.get(c.executionContextAuxData.frameId);f||(f={name:u,resourceBytes:0,unusedBytes:void 0,children:[]},a.set(c.executionContextAuxData.frameId,f),r.push(f)),f.resourceBytes+=h.resourceBytes,h.unusedBytes&&(f.unusedBytes=(f.unusedBytes||0)+h.unusedBytes),h.name=c.content?"(inline) "+c.content.trimStart().substring(0,15)+"…":"(inline)",f.children?.push(h)}else r.push(h)}return r}static async audit(t,n){return{score:1,details:{type:"treemap-data",nodes:await e.makeNodes(t,n)}}}},nie=Ux});var oB={};T(oB,{UIStrings:()=>jr,default:()=>rie});var jr,ao,jx,rie,iB=b(()=>{"use strict";d();V();Ze();Bt();A();jr={title:"Document has a valid `rel=canonical`",failureTitle:"Document does not have a valid `rel=canonical`",description:"Canonical links suggest which URL to show in search results. [Learn more about canonical links](https://developer.chrome.com/docs/lighthouse/seo/canonical/).",explanationConflict:"Multiple conflicting URLs ({urlList})",explanationInvalid:"Invalid URL ({url})",explanationRelative:"Is not an absolute URL ({url})",explanationPointsElsewhere:"Points to another `hreflang` location ({url})",explanationRoot:"Points to the domain's root URL (the homepage), instead of an equivalent page of content"},ao=w("core/audits/seo/canonical.js",jr),jx=class e extends g{static{s(this,"Canonical")}static get meta(){return{id:"canonical",title:ao(jr.title),failureTitle:ao(jr.failureTitle),description:ao(jr.description),supportedModes:["navigation"],requiredArtifacts:["LinkElements","URL","devtoolsLogs"]}}static collectCanonicalURLs(t){let n=new Set,r=new Set,a,o;for(let i of t)if(i.source!=="body")if(i.rel==="canonical"){if(!i.hrefRaw)continue;i.href?Y.isValid(i.hrefRaw)?n.add(i.href):o=i:a=i}else i.rel==="alternate"&&i.href&&i.hreflang&&r.add(i.href);return{uniqueCanonicalURLs:n,hreflangURLs:r,invalidCanonicalLink:a,relativeCanonicallink:o}}static findInvalidCanonicalURLReason(t){let{uniqueCanonicalURLs:n,invalidCanonicalLink:r,relativeCanonicallink:a}=t;if(r)return{score:0,explanation:ao(jr.explanationInvalid,{url:r.hrefRaw})};if(a)return{score:0,explanation:ao(jr.explanationRelative,{url:a.hrefRaw})};let o=Array.from(n);if(o.length===0)return{score:1,notApplicable:!0};if(o.length>1)return{score:0,explanation:ao(jr.explanationConflict,{urlList:o.join(", ")})}}static findCommonCanonicalURLMistakes(t,n,r){let{hreflangURLs:a}=t;if(a.has(r.href)&&a.has(n.href)&&r.href!==n.href)return{score:0,explanation:ao(jr.explanationPointsElsewhere,{url:r.href})};if(n.origin===r.origin&&n.pathname==="/"&&r.pathname!=="/")return{score:0,explanation:ao(jr.explanationRoot)}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await _e.request({devtoolsLog:r,URL:t.URL},n),o=new URL(a.url),i=e.collectCanonicalURLs(t.LinkElements),c=e.findInvalidCanonicalURLReason(i);if(c)return c;let u=new URL([...i.uniqueCanonicalURLs][0]),l=e.findCommonCanonicalURLMistakes(i,u,o);return l||{score:1}}},rie=jx});var sB={};T(sB,{UIStrings:()=>Ws,default:()=>aie});var Ws,ih,qx,aie,cB=b(()=>{"use strict";d();V();A();Ws={title:"Links are crawlable",failureTitle:"Links are not crawlable",description:"Search engines may use `href` attributes on links to crawl websites. Ensure that the `href` attribute of anchor elements links to an appropriate destination, so more pages of the site can be discovered. [Learn how to make links crawlable](https://support.google.com/webmasters/answer/9112205)",columnFailingLink:"Uncrawlable Link"},ih=w("core/audits/seo/crawlable-anchors.js",Ws),qx=class extends g{static{s(this,"CrawlableAnchors")}static get meta(){return{id:"crawlable-anchors",title:ih(Ws.title),failureTitle:ih(Ws.failureTitle),description:ih(Ws.description),requiredArtifacts:["AnchorElements","URL"]}}static audit({AnchorElements:t,URL:n}){let r=t.filter(({rawHref:i,name:c="",role:u="",id:l,href:m})=>{if(i=i.replace(/\s/g,""),c=c.trim(),u=u.trim(),u.length>0||i.startsWith("mailto:")||i===""&&l)return;let p=/javascript:void(\(|)0(\)|)/;if(i.startsWith("file:"))return!0;if(!(c.length>0)){if(m===""||p.test(i))return!0;try{new URL(i,n.finalDisplayedUrl)}catch{return!0}}}),a=[{key:"node",valueType:"node",label:ih(Ws.columnFailingLink)}],o=r.map(i=>({node:g.makeNodeItem(i.node)}));return{score:+(r.length===0),details:g.makeTableDetails(a,o)}}},aie=qx});var lB=I($d=>{d();$d.getRenderingDataFromViewport=function(e,t,n,r,a){var o=t/100,i=n/100,c=null,u=null,l=null,m=null,p=null,h=null,f=null,y=null,v=null,D=t,E=n,S="zoom",k="resizes-visual";if(e["maximum-scale"]!==void 0&&(c=sh(e["maximum-scale"])),e["minimum-scale"]!==void 0&&(u=sh(e["minimum-scale"])),e["initial-scale"]!==void 0&&(l=sh(e["initial-scale"])),u!==null&&c===null&&(u=Wd(r,sh(e["minimum-scale"]))),e.width!==void 0&&(m="extend-to-zoom",h=uB(e.width,o,i)),e.height!==void 0&&(p="extend-to-zoom",f=uB(e.height,o,i)),e["user-scalable"]!==void 0)if(S=e["user-scalable"],typeof S=="number")S>=1||S<=-1?S="zoom":S="fixed";else switch(S){case"yes":case"device-width":case"device-height":S="zoom";break;case"no":default:S="fixed";break}if(e["interactive-widget"]!==void 0)switch(e["interactive-widget"]){case"overlays-content":case"resizes-content":case"resizes-visual":k=e["interactive-widget"];break;default:k="resizes-visual";break}l!==null&&(e.width===void 0||y===void 0)&&(e.height!==void 0?(m=null,h=null):(m="extend-to-zoom",h="extend-to-zoom")),u!==null&&c!==null&&(c=$s(u,c)),l!==null&&(l=zx(l,u,c));var C=l===null&&c===null?null:Wd(l,c),R,z;return C===null?(h==="extend-to-zoom"&&(h=null),f==="extend-to-zoom"&&(f=null),m==="extend-to-zoom"&&(m=h),p==="extend-to-zoom"&&(p=f)):(R=D/C,z=E/C,h==="extend-to-zoom"&&(h=R),f==="extend-to-zoom"&&(f=z),m==="extend-to-zoom"&&(m=$s(R,h)),p==="extend-to-zoom"&&(p=$s(z,f))),(m!==null||h!==null)&&(y=$s(m,Wd(h,D))),(p!==null||f!==null)&&(v=$s(p,Wd(f,E))),y===null&&(v===null?y=D:E!==0?y=Math.round(v*(D/E)):y=D),v===null&&(D!==0?v=Math.round(y*(E/D)):v=E),{zoom:l,width:y,height:v,userZoom:S,interactiveWidget:k}};function Wd(e,t){return e===null?t:t===null?e:Math.min(e,t)}s(Wd,"min");function $s(e,t){return e===null?t:t===null?e:Math.max(e,t)}s($s,"max");function uB(e,t,n){return typeof e=="number"?e>=0?zx(e,1,1e4):void 0:e==="device-width"?100*t:e==="device-height"?100*n:1}s(uB,"translateLengthProperty");function sh(e){if(typeof e=="number")return e>=0?zx(e,.1,10):void 0;if(e==="yes")return 1;if(e==="device-width"||e==="device-height")return 10;if(e==="no"||e===null)return .1}s(sh,"translateZoomProperty");function zx(e,t,n){return $s(Wd(e,n),t)}s(zx,"clamp");$d.parseMetaViewPortContent=function(e){for(var t={validProperties:{},unknownProperties:{},invalidValues:{}},n=1;n<=e.length;){for(;n<=e.length&&RegExp(` |
|	|\0d|,|;|=`).test(e[n-1]);)n++;n<=e.length&&(n=iie(t,e,n))}return t};var oie=["width","height","initial-scale","minimum-scale","maximum-scale","user-scalable","shrink-to-fit","viewport-fit","interactive-widget"];function iie(e,t,n){for(var r=n;n<=t.length&&!RegExp(` |
|	|\0d|,|;|=`).test(t[n-1]);)n++;if(n>t.length||RegExp(",|;").test(t[n-1]))return n;for(var a=t.slice(r-1,n-1);n<=t.length&&!RegExp(",|;|=").test(t[n-1]);)n++;if(n>t.length||RegExp(",|;").test(t[n-1]))return n;for(;n<=t.length&&RegExp(` |
|	|\0d|=`).test(t[n-1]);)n++;if(n>t.length||RegExp(",|;").test(t[n-1]))return n;for(r=n;n<=t.length&&!RegExp(` |
|	|\0d|,|;|=`).test(t[n-1]);)n++;var o=t.slice(r-1,n-1);return sie(e,a,o),n}s(iie,"parseProperty");function sie(e,t,n){if(oie.indexOf(t)>=0){var r=parseFloat(n);if(!isNaN(r)){e.validProperties[t]=r;return}var a=n.toLowerCase();if(a==="yes"||a==="no"||a==="device-width"||a==="device-height"||t.toLowerCase()==="viewport-fit"&&(a==="auto"||a==="cover")||t.toLowerCase()==="interactive-widget"&&$d.expectedValues["interactive-widget"].includes(a)){e.validProperties[t]=a;return}e.validProperties[t]=null,e.invalidValues[t]=n}else e.unknownProperties[t]=n}s(sie,"setProperty");$d.expectedValues={width:["device-width","device-height","a positive number"],height:["device-width","device-height","a positive number"],"initial-scale":["a positive number"],"minimum-scale":["a positive number"],"maximum-scale":["a positive number"],"user-scalable":["yes","no","0","1"],"shrink-to-fit":["yes","no"],"viewport-fit":["auto","cover"],"interactive-widget":["overlays-content","resizes-content","resizes-visual"]}});var dB,Hx,Ys,ch=b(()=>{"use strict";d();dB=Lt(lB(),1);ue();Hx=class{static{s(this,"ViewportMeta")}static async compute_(t){let n=t.find(u=>u.name==="viewport");if(!n)return{hasViewportTag:!1,isMobileOptimized:!1,parserWarnings:[]};let r=[],a=dB.default.parseMetaViewPortContent(n.content||"");Object.keys(a.unknownProperties).length&&r.push(`Invalid properties found: ${JSON.stringify(a.unknownProperties)}`),Object.keys(a.invalidValues).length&&r.push(`Invalid values found: ${JSON.stringify(a.invalidValues)}`);let o=a.validProperties,i=Number(o["initial-scale"]);return!isNaN(i)&&i<1?{hasViewportTag:!0,isMobileOptimized:!1,parserWarnings:r}:{hasViewportTag:!0,isMobileOptimized:!!(o.width||i),parserWarnings:r}}},Ys=q(Hx,null)});var mB={};T(mB,{UIStrings:()=>Qn,default:()=>hie});function uie(e){let t=new Map;return e.forEach(n=>{let{nodeId:r,cssRule:a,fontSize:o,textLength:i,parentNode:c}=n,u=fie(a,r),l=t.get(u);l?l.textLength+=i:t.set(u,{nodeId:r,parentNode:c,cssRule:a,fontSize:o,textLength:i})}),[...t.values()]}function lie(e=[]){let t=new Map;for(let n=0;n<e.length;n+=2){let r=e[n],a=e[n+1];if(!r||!a)continue;let o=a.trim();o&&t.set(r.toLowerCase(),o)}return t}function die(e){let t=lie(e.attributes);if(t.has("id"))return"#"+t.get("id");{let n=t.get("class");if(n)return"."+n.split(/\s+/).join(".")}return e.nodeName.toLowerCase()}function mie(e){let n=(e.attributes||[]).map((r,a)=>a%2===0?` ${r}`:`="${r}"`).join("");return{type:"node",selector:e.parentNode?die(e.parentNode):"",snippet:`<${e.nodeName.toLowerCase()}${n}>`}}function pie(e,t,n){if(!t||t.type==="Attributes"||t.type==="Inline")return{source:{type:"url",value:e},selector:mie(n)};if(t.parentRule&&t.parentRule.origin==="user-agent")return{source:{type:"code",value:"User Agent Stylesheet"},selector:t.parentRule.selectors.map(a=>a.text).join(", ")};let r="";if(t.parentRule&&(r=t.parentRule.selectors.map(o=>o.text).join(", ")),t.stylesheet&&!t.stylesheet.sourceURL)return{source:{type:"code",value:"dynamic"},selector:r};if(t.stylesheet&&t.range){let{range:a,stylesheet:o}=t,i=o.hasSourceURL?"comment":"network",c=a.startLine,u=a.startColumn;o.isInline&&i!=="comment"&&(c+=o.startLine,a.startLine===0&&(u+=o.startColumn));let m=g.makeSourceLocation(o.sourceURL,c,u);return m.urlProvider=i,{source:m,selector:r}}return{selector:r,source:{type:"code",value:"Unknown"}}}function fie(e,t){if(e&&e.type==="Regular"){let n=e.range?e.range.startLine:0,r=e.range?e.range.startColumn:0;return`${e.styleSheetId}@${n}:${r}`}else return`node_${t}`}var cie,Qn,pr,Gx,hie,pB=b(()=>{"use strict";d();A();V();ch();cie=60,Qn={title:"Document uses legible font sizes",failureTitle:"Document doesn't use legible font sizes",description:"Font sizes less than 12px are too small to be legible and require mobile visitors to “pinch to zoom” in order to read. Strive to have >60% of page text ≥12px. [Learn more about legible font sizes](https://developer.chrome.com/docs/lighthouse/seo/font-size/).",displayValue:"{decimalProportion, number, extendedPercent} legible text",explanationViewport:"Text is illegible because there's no viewport meta tag optimized for mobile screens.",additionalIllegibleText:"Add'l illegible text",legibleText:"Legible text",columnSelector:"Selector",columnPercentPageText:"% of Page Text",columnFontSize:"Font Size"},pr=w("core/audits/seo/font-size.js",Qn);s(uie,"getUniqueFailingRules");s(lie,"getAttributeMap");s(die,"getSelector");s(mie,"nodeToTableNode");s(pie,"findStyleRuleSource");s(fie,"getFontArtifactId");Gx=class extends g{static{s(this,"FontSize")}static get meta(){return{id:"font-size",title:pr(Qn.title),failureTitle:pr(Qn.failureTitle),description:pr(Qn.description),requiredArtifacts:["FontSize","URL","MetaElements"]}}static async audit(t,n){if(n.settings.formFactor==="desktop")return{score:1,notApplicable:!0};if(!(await Ys.request(t.MetaElements,n)).isMobileOptimized)return{score:0,explanation:pr(Qn.explanationViewport)};let{analyzedFailingNodesData:a,analyzedFailingTextLength:o,failingTextLength:i,totalTextLength:c}=t.FontSize;if(c===0)return{score:1};let u=uie(a),l=(c-i)/c*100,m=t.URL.finalDisplayedUrl,p=[{key:"source",valueType:"source-location",label:pr(x.columnSource)},{key:"selector",valueType:"code",label:pr(Qn.columnSelector)},{key:"coverage",valueType:"text",label:pr(Qn.columnPercentPageText)},{key:"fontSize",valueType:"text",label:pr(Qn.columnFontSize)}],h=u.sort((E,S)=>S.textLength-E.textLength).map(({cssRule:E,textLength:S,fontSize:k,parentNode:C})=>{let R=S/c*100,z=pie(m,E,C);return{source:z.source,selector:z.selector,coverage:`${R.toFixed(2)}%`,fontSize:`${k}px`}});if(o<i){let E=(i-o)/c*100;h.push({source:{type:"code",value:pr(Qn.additionalIllegibleText)},selector:"",coverage:`${E.toFixed(2)}%`,fontSize:"< 12px"})}l>0&&h.push({source:{type:"code",value:pr(Qn.legibleText)},selector:"",coverage:`${l.toFixed(2)}%`,fontSize:"≥ 12px"});let f=l/100,y=pr(Qn.displayValue,{decimalProportion:f}),v=g.makeTableDetails(p,h),D=l>=cie;return{score:Number(D),details:v,displayValue:y}}},hie=Gx});function fB(e){let t=gie;for(;e.length<3;)e+="`";for(let n=0;n<=e.length-1;n++){let r=e.charCodeAt(n)-96;if(t=t[r],!t)return!1}return!0}var gie,hB=b(()=>{"use strict";d();gie=[,[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,,,,,1,1,1,1,,,1,1,1,,1,,1,,1,1],[1,1,1,,1,1,,1,1,1,,1,,,1,1,1,,,1,1,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,,,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1],[,1,,,,,,1,,1,,,,,1,,1,,,,1,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,,,1,,,,,1,1,1,,1,,1,,1,,,,,,1],[1,,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,,1,,1,,,,,1,,1,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,,1,1,1,,1,,1,1,1,,,1,1,1,1,1,1,1,1],[,,1,,,1,,1,,,,1,1,1,,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1,1,1,1,1,,,1,1,1],[1,1,1,1,1,,,1,,,1,,,1,1,1,,,,,1,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1],[,1,,1,1,1,,1,1,,1,,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,,,1,1,1,,,1,1,,,,,,1,1],[1,1,1,,,,,1,,,,1,1,,1,,,,,,1,,,,,1],[,1,,,1,,,1,,,,,,1],[,1,,1,,,,1,,,,1],[1,,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,,1,,,1,1,1,1],[,1,1,1,1,1,,,1,,,1,,1,1,,1,,1,,,,,1,,1],[,1,,,,1,,,1,1,,1,,1,1,1,1,,1,1,,,1,,,1],[,1,1,,,,,,1,,,,1,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,,1,1,1,,,1,1,1,1,1,1,,1,,,,,1,1,,1,,1],[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,1,1],[,1,1,1,,,,1,1,1,,1,1,,,1,1,,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,,1,,,,,1,1,1,,,1,,1,,,1,1],[,,,,1,,,,,,,,,,,,,,,,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,,1,1,1,,1,1,,,,1,1,1,1,1,,,1,1,1,,,,,1],[1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,1,,,,,,,1],[,1,1,,1,1,,1,,,,,,,,,,,,,1],,[1,1,1,,,,,,,,,,,,,1],[,,,,,,,,1,,,1,,,1,1,,,,,1]],[,[1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,,1],[,,,1,,,,,,,,,,,,,,,1],[,1,,,1,1,,1,,1,1,,,,1,1,,,1,1,,,,1],[1,,,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,,,,1],,[,1,1,1,1,1,,1,1,1,,1,1,,1,1,,,1,1,1,1,,1,1,,1],[,1,,,1,,,1,,1,,,1,1,1,1,,,1,1,,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,,,1,1,1,1,1,1,1,,,1,,,1,,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,,,,1],[,,,,,,,1,,,,1,,1,1],[,1,1,1,1,1,1,1,,,,1,1,1,1,1,,,1,1,,1,1,1,1,1],[,1,,,1,1,,1,,1,1,1,,,1,1,,,1,,1,1,1,1,,1],[,1,1,1,,1,1,,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1],[,,,,,,,,,,,,,,,,1],,[,1,1,1,1,1,,1,1,1,,,1,,1,1,,1,1,1,1,1,,1,,1],[,,1,,,1,,,1,1,,,1,,1,1,,1],[,1,1,,1,,,,1,1,,1,,1,1,1,1,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,1,,1,,1,1],,[,1,1,,1,,,1,,1,,,,1,1,1,,,,,,1,,,,1],[1,1,,,1,1,,1,,,,,1,,1]],[,[,1],[,,,1,,,,1,,,,1,,,,1,,,1,,,1],[,,,,,,,,,,,,,,,,,,1,1,,,,,,1],,[1,,,,,1],[,1,,,,1,,,,1],[,1,,,,,,,,,,,1,,,1,,,,,,,,,1,1],[,,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,1,,1],[,1],[,1,,1,,1,,1,,1,,1,1,1,,1,1,,1,,,,,,,1],[1,,,,,1,,,1,1,,1,,1,,1,1,,,,,1,,,1],[,1,1,,,1,,1,,1,,1,,1,1,1,1,,,1,,1,,1,1,1],[1,1,1,1,1,,1,,1,,,,1,1,1,1,,1,1,,,1,1,1,1],[1,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],,[,1,,,,,,1,1,1,,1,,,,1,,,1,1,1,,,1],[1,,,,,1,,1,1,1,,1,1,1,1,1,,1,,1,,1,,,1,1],[1,,1,1,,,,,1,,,,,,1,1,,,1,1,1,1,,,1,,1],[1,,,,,,,,,,,,,,,,,1],[,,,,,1,,,1,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,,,1],[,1,,,,1]],[,[1,1,1,,1,,1,1,1,1,1,1,1,1,1,,1,,1,,1,1,,,1,1,1],[,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],,[,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1],,[1,1,,,,1,1,,,,,,1,,,,1,,1,,1,1,,1],[1],[,,,,,,,,,,,1,,,,,,,,,,,1],[,1,,,,,,,1,1,,,1,,1,,,,1,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,,1],[,,1,,,,,1,,1],[1,,,,1,,,,,1,,,,1,1,,,,1,1,,,,,1],[,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[1,,,1,1,,,,,,,1,,1,,1,1,1,1,1,1],[,,,,,1,,,,,,,1,,,,,,,1],,[,,1,1,1,1,1,,1,1,1,,,1,1,,,1,1,,1,1,1,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,,,,1],,[1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,,,1,1,1,1,,,,,,1,,1,,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,,,,1,,1,,,1,1,1,1,1],[,,,,,,,,,,,1,,,,,,,,,1,,,,1],[,1,1,,1,1,,1,,,,1,1,,1,1,,,1,,1,1,,1],[,1,,1,,1,,,1,,,1,1,,1,1,,,1,1,1],[,1,1,1,1,1,,1,1,,,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,,,,,,,,,1,,1,,1,1,,,,1,,,1],[,1,,,1,1,,,,,,,,,1,1,1,,,,,1],[1,,,1,1,,,,1,1,1,1,1,,,1,,,1,,,1,,1,,1],[,1,1,,1,1,,1,1,,,,1,1,1,,,1,1,,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,,,,1,,,,,,,,,1],[,1,,,,,,,,1,,,,,1,,,,1,,,1],[,1,1,1,1,,,1,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1],[,,,,,1,,1,,,,,1,1,1,1,1,,,1,,,,1],[,1,,,,,,,,1,,,,,,,,,,,,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,1,,,,1,,1,1,1,1,1,,1,1,,,,,,1],[,1,1,1,1,1,1,1,,1,1,,,1,1,,,,1,,1,1,,1,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,1,1,,1,,,1,1,1,1,,,1,,,,,,,1],[,1,,,,,,,,1,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1],[,1,1,,,,,,,,,,,,1,1,,,,,,1],[,1,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,,,,,1],[1,1,,,1,,,1,1,1,,,,1],,[,,,,,,,,,,,,,1,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,1,,,,,,,1],[1,1,1,,1,,1,1,1,1,1,1,1,1,,1,,,1,,1,,,1,1],[,,,,,,,,,1],[,1,,,,1,,,,,,1,,,1,,,,,1],[,1,1,,1,1,,,,,,,,,,,,,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,1,1,1,,,,1,1,,,,1,,1],[1,1,1,1,1,1,,,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,,1,1],[,,,,,,,,,,,,,,,1,,,,1],,[1,1,,1,,1,,,,,,1,,1,,1,1,,1,,1,1,,1,1,,1],[,,1,,,,,,1,,,,1,,1,,,,,1],[1,,,,,,,,,1,,,,,,1,,,,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,,1,,,,,,1,,,1,,,,,,,,1],[,1,,1,,,,,,,,,,,,1],,[1,1,,,,,,,,,,,,,,,,,,,,,,1,1],[1]],[,[1,,,,,,,,,1,,,,,1,,1,,1],[,1,1,,1,1,,1,1,1,,,1,1,1,,,,1,,,1,,,,1],[,1,,,,,,,1,,,,1,,,,,,1],[1,1,1,1,1,1,,,,1,,,,,,,,,1,1,1,1],[1],[,1,1,,,1,1,,,,,1,,1,,,,,,,,1,,,,1],[1,,1,,,1,,1,,,,,1,1,1,1,,,,1,,,,1],[,,1,,,,,,,1,,,,,,,1,,,,,,,1],[1,,,,,,,,,,,,,,1,,,,1],[,,,1,,1,,,,,1,,,,1,1,,,,1],[1,,,,,1,,,,1,,1,1,,,1,1,,1,1,1,,1,1,1,,1],[,1,1,,,,,1,,1,,1,1,1,,1,1,,,1,,1,1,1],[,1,,,,1,,,,1,,,1,,1,1,,,1,1,,,,,,1],[1,,1,1,,1,,1,1,,1,,1,1,1,1,1,,,1,1,,,,,,1],[1,,,,,,,,,,,,,,,,,,1,,,1,,1],[,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,,1,,1],[,1,,,,1,,,1,1,,1,,,1,1,,,1,,,1,,,1,1],[1,1,,1,1,1,,1,1,1,,1,,1,1,1,,,1,,1,1],[1,,1,1,1,1,,,,1,,1,1,1,,1,,,1,1,1,,1,1,1,1,1],[1,,,,,,,,,,,,,1],[,,1,,,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,,,1,,1,,1,,,,1],[,,,1,,,,,,,,,1],[,1,,,,,,,,,,,,,,1,,,,,,,,,1],[,,,,,,,,1,1,,,,,,,,,1,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,,,1,1,1],[,,,,,1,,,,1,1,1,,,1,1,,,1,,1,1,,1],[,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,1,,,,,,,,,,,,,1],[,,1,,,1,,1,1,1,,1,1,,1,,,,1,,1,1],,[,,1,,,1,,,,,,1,,,,1],[,,,,,,,,,1,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,,1,1,,1,,1,,,1,1,1,,,1],[,,,,,1,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,1,,1,1,,1,,,1],[,,,,,1,,,,,,,,,,,,,,1],[,1,1,1,1,,,,,1,,,1,,1,,,,1,1,,,,1,1],[,1,,,1,,,1,,1,1,,1,,,,,,,1],[,,1,,1,,,1,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,,,,,,,,,,1,,1,1],[,,,,,,,,,,,,1],,[,1,1,1,1,,,,1,1,,1,1,1,1,1,1,,1,1,1,1,,1,,1],[1,,,,1,,,,,,,,,,1],[1,,,,,,,,,1],,[,1,,,,1,,,,,,,,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,,1,,,,1,1,,,1,1,,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,1],[1,1,1,,,,,1,1,1,,1,1,1,1,,,1,1,,1,1,,,,,1],[,1,,,,,,,1,1,,,1,1,1,,1,,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,,,1,,,,1,,,1,,,,1,,,,,,,1,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1],[1,1,1,,1,,,1,1,1,1,,1,1,1,1,,,,1,,1,,1,,,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,,1,1,,,,,,,,,1],,[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,,1,,1,,,,1],[,1,,,1,1,,1,1,1,,,1,1,1,1,1,,1,1,1,,1,,,1],[1,,,1,,,,1,1,1,,,,,1,1,,,,1,,1],[1,1,,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,,1,,1,,,,,,,,1,,1],[,1,,,,1,,1,1,,,,1,1,,1,,,,1,1,1,,1],,[,1,,,,,,1,,,,,,,1],[,,,,,,,,1,,,,1,,1,,,,,,,,,,,,1]],[,[,1,1,,1,1,1,1,,1,1,1,,1,1,,1,1,,1,1,1,1,1,1,,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,,,1,,,,,,,,1,,,,,,1,,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,,1,,1,1,1,1,1,1,1,,1,1,,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1],[,1,1,,,,,1,1,1,,,1,,1,1,,,,1,,1,,,1,1],[,,,,,,,1,,,,1,1,1,1,1,,1,,,,,,,,1],[1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,,1,,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,1,1,,1,,1,1,1,,1,,1,1,,1,1,,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,,1,,,,,1,,1],[,1,1,1,,1,,1,,1,,,,1,,1,,,1,,,,,,1,1],[,1,,,1,1,,1,,1,,1,1,1,1,1,,1,1,,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,,1,,1,,1,,,,,,1,,1,,,,1,1]],[,[,1,,1,,,,,,,,,,,,,,,1,,,,1],[,,,,,,,,,1,,1,1,1,,1,,,1,,1,1],[1,1,,,,,,,1,,,,,,,1,,,,,,1],[,1,,,,,,,,,,1,,,,,,,,,1,1],,[,,,,,,,,,,,,,,,1,,,,1,,1],[,,1,1,,1,,1,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,,,,,,,,1],[1,,1,1,,,,1,,,,,,,,,1,,,1,,,1,1],[,1,1,,1,1,,1,1,1,1,1,1,1,1,1,,,1,1,,1,1,,1],[,1,,,1,1,,,,,,1,,1,,1,,,1,,1,1],[1,1,1,1,,1,,1,,1,,1,1,,1,1,1,1,1,,1,1,1,1,1],[,1,1,,,1,,1,,1,1,1,,,1,1,1,,1,1,1,1,,1,1],[,,,,1,,,1,,,,,,,1,,,,1,1],[,1,,,,,,,,,,1,,1,,1,,,,,1,,,,,1],,[1,1,,1,,1,,1,1,,,,,,1,1,,,1,1,1,1,1,1,1,1,1],[1,1,,1,,,,,,1,,,,,,1,1,,,,1,1,,,1],[,1,1,,1,1,,,,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,,,1,,,,1,,,,1,1],[,,,,1],[,,,,,,,,,1,,,1],,[,,1,,1,,,,,,,,,1,,,,,,,,,,,,1],[,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,,,1],[,1,,1,,,,,,1,,,,,1,1,,,,,1,1],[,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,,,1,,1,1,1],[,1,,,,1,,,,,,,1],[,1,,,1,,,1,,1,,1,1,,1,,,,,1,,1,,,,1,1],[,1,,,1,,,1,1,1,,1,1,1,1,1,,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,1,1,,,,1,1,,,,,,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,,1,1,,1,1,1,1,1],[,1,,,,1,,,,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,1,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,,1,1,1,,1,1,1,,,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,,,,,,,1,1,,,,,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,1,,1,1,1,1],,[,1,1,,,,,1,,1,,,,1,1,1,,,1,,,,,1],[,,,,,,,,,,,,,1],[,,,,,1,,,,,,,,1,1,,,,,1,,1,,,1,1],[,,,,,,,,,,,,,,1]],[,[,1],,,,,,,,,,,,,,,,,,,,[1,1,1,1,1,,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,1,1,1,1],[,1,,1,,1,,,1,1,1,,1,1,1,1,1,,,1,,,,1,,1,1],[,1,,1,,1,,,1,,,,,1,,,,,,1,1],[,1,,1,,,,,1,,,,1,,1,1,1,1,1,1,1,1,,1],[,1,,,,,,,,,,,,,,,1]],[,[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,,,,,,,,,1,1,,,,1],[,,,,,,1],[,,1],[,1,1,,,1,,1,,1,1,,1,1,1,,,,1,1,1,,,,,1],,[,1,,,,1,,,,,,1,,,1,,,,1,1,,1],[,,,,,,,1,,,,,,,,,1],[,1,,,,1,1,,,,,,1,1,1,,,,1,,1,1],[,,,,,,,1,,1,,,,,,,,,,1],[,1,1,,,,,,1,1,,,,1,,,,,,,1,,,1],,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,,1,,,1,,,,,1,,1,,1,,1,,,,,1],[1,1,1,1,1,1,1,1,,,,,1,1,,1,1,,1,,,1,,1],[,,,,,,,,,,,,,,1,,,,,,1],,[,,,,,,,,,1,,,,,,1,,,,,1],[,,1,,,,,,,1,,,1,1],[,,,1,,,,,1,,,,,1,,,,,,1,,,,1],[1,,1,1,,1,1,1,1,1,,1,,,,1,1,1,,,1,1,,,,1,1],,[1,1,,,,,,,,,,1,,1,,1,,,1],[,,,,1,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,1],[,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,,1,,,1,,,,,,,,1,,,,,,1,,,,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,1,,,,1,1,1,1,1,1,,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,1,,1,1,,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,,1,,1,,1,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,,,,,,1,,1,,,,,1,1,,,,,1],[1,,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,,1,,,,1,1,1,1,1,,,1,1,,1,,1],[,1,1,1,1,,,,,1,,1,1,1,1,1,,,1,1,,,,1,1,1],[,1,1,1,1,1,,1,,,,,1,,1,,1,,,1,,,1,1,,1]],[,[1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,,,,,1,,,,,1,1,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,,,,1,,1,1,,1,1,1,1,1,,,1,,1,,1],[1,1,1,,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,,1,,,,,,,,,,1,1,1,1,1,1,1,,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,1,1,,,,,,1,1,1,1,1,,,,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,,1,1,1],[,1,1,1,,1,,1,1,1,1,,,1,1,1,,1,1,1,1,1,,,1,1],[1,1,,,,1,,,1,1,1,,1,,1,,1,,1,1,1,1,1,,1,,1],[,1,,,,,,,1,,1,,1,1,1,1,,,,,,,,,1]],[,[,,,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,1,,,1,,,,,,1,,,1,,,,1],,[,1,,,,1,,1,,1,1,,1,1,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],[1,1,1,,,1,,,,,,,,,1,1,,,,,,,,,,1],[,1,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1,,,1],[,,,,,,,,,1],[1,1,,,,,,1,1,1,,1,1,,,,1,1,,1,,1,1,1,,1],[,1,1,1,,1,1,,,1,,1,1,1,1,,,,,,,1,,1],[,1,1,1,1,,,1,,1,,,,1,1,1,1,,1,1,,1],[,1,,,1,1,,1,,,,1,,1,1,,1,,1,,,1,,,1,,1],[,,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,,,,,1],,[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1],[,1,,,,,,,1,1,,1,,,,,1,,,1,,1],[,1,,,,1,,,1,,,,,,,,1,,1,,,1],[,,,,,,,,,,,,,1,1,,,,1,,,1],[,,,,,1,,,1,,,,1],[,1],,[,1],[1,,,,,,,,,,,,,,1,,,,,1]],[,[,1,,,,1,1,1,1,1,1,,1,1,1,1,1,,1,1,,1,1,,,1],[,,1,,,,,,,,,1],,,[1,,,1,1,,,,,,,,1,1,,1,1,,1],,[,,,,,,,,,,,,,,,,,,1,,1],,[1,,,1,1,,1,1,,,,,1,,1,,,,,1,1,,1],,[,1,,,,,,,,1,1,1,1,1,,1,1,,,,1,1],[,,,,,,,,,,,,,,,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,,1,1,1,1,1,1],[,,,,,,,,,,,1,,1,,,1],[1,,,,,,,,,,,,,,,,,,1,,1],,,[,1,,,,,,,,,,,,,,1,,,,1,1],[,,,,,,,,,1,,,1,,,,,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,1,1,,,,,,1],,[,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,1,1,,1,1,1,1,1,1,,,1,1,1,1,1,,1,1],[,1,,,,,,,,1],[,,,,1,,,1,,,1,1,,,,,,,,,,1,,,,1],[,1,,1,1,,,1,1,1,,,,1,1,1,1,,1,1,1,1,,1],[,,,,,,,1],[,1,1,,,,,1,,1,,,,,,1,,,,,,1,,1,,1],[,1,,,,,,1,,,,1,,,,,,,,,,1],[,,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1,1,1,1,,1],[,1,,,,,,,,1],[,1,1,,1,,,,,,,,1,,,,,,1,,,1,,1,,1],[,1,,1,,1,,1,1,1,,1,1,1,,1,,,1,1,,1,1,1,1,1],[,1,1,1,1,1,,,1,1,,,,1,1,1,,,,1,1,,,1,1],[,,1,1,1,1,,1,,1,,1,,1,1,1,1,,,,,1,,1,,1],[1,1,1,1,1,1,1,1,,1,,1,,1,1,1,,,1,1,,,,1,,1],[,,,1],,[,1,1,,1,,,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1],[,1,,,,,,1,,1,,1,,,,,,,1,1,,1,1],[,,,,,,1,,1,1,,1,,1,,,,,,,,,,1],[,1,1,,1,,,,1,,,,1,1,1,,,,1,,1,1,1,,1,1],,[,1,1,,,,,,,,,,,,,1,,,1,,,,,1],[,1,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,1,,,,1,,,,,1,,,,,,,1]],[,[,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[,1,1,1,1,1,,1,,1,1,,,1,1,1,1,,1,,,,,1,1,1],[,,1,1,,1,,1,1,,,,1,1,1,1,,,1,,1,1,1,1,,1],[,1,,1,,,,,,,,1,,1,,1,,,,,,,,,,1],[,,1,,1,,,1,,,,,1,1,,,1,,1,1,1,1],[,1],[,1,1,,1,,1,1,,1,,,1,1,1,,,,1,,,1,,1],[1,1,,1,1,1,,,,,,,,,,,,,1,,1,1,1],[,1,1,,,,,,,1,,,1,,1,,1,,1,1,,,1,,,1],[,,1,,,,,,,,,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,,1,,,,,1,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,,1,,1,1,1,,,1,1,1,1,,,,1,1],[,,,1,1,,,1,,1,,1,,1,1,1,1,,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,,1,,1,,,,1,1,,,1,1,,1,1,,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1,,1,1,,,1],[,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,,1,,,1,,,1,,1,1,1,1,1,,1,,1,1],[,,,,,1,,,,1,,,,,1,1,,,,1],[,1,,1,1,1,,1,,,1,1,1,,,1,,,1,,1,,,1],[,,1,,,,,,,,,1,,1,,,,,1,,1],[,1,1,,,,,,,,1,1,1,,,,,,,,1,,,,,1],[,,,,,,,,1,,,,,1,,,1]],[,[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,,1,1,1,1,1,1,1,1,,,,,,,,,1,1],[,,,,,,,,1,,,,1,,1,,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,1,,1,,1,,,,1,1,,1,,1,,,,1,1,1,1,1,,,1],,[,1,,,,,,,,1,,,1,1,,,1,,1,1,,1,,1],[,1,,,1,,,,,,,,1,,,,,,,1],[1,1,,,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1],,[,1,,,,,,1,,1,,1,1,1,1,1,,,1,,1,1,,,,1],[,1,1,,,1,,1,,1,,,1,1,1,1,,,1,,,1,,,,1],[,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1],[,1,,,1,1,,1,1,,,1,1,,1,1,,1,,1,,1],[1,,1,,,,,1,,1,,1,1,1,1,,,,,1,1,,,,1,1],[,1,1,,,,,1,1,,,1,,1,1,1,1,,,,,,,,,,1],,[,1,1,,,1,,,,1,,1,1,1,1,1,,,,1,,,,1,,1],[,,,1,1,,,1,,,,,1,,1,1,1,,1,1,,,,,,1],[,1,,,,,,,,,,,1,,,,1,,,,,,,1,,1],[,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,1,,,,,1,,1,,,1,1,,1,1,,1],[,1,,,,,,1,,,,,1,1,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1,,,1,,,,,1],[,,,,,,,1,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,,1,,,,,,,1,,,,,,,,1,,,1],[,1,,,,,,,1],[,,,,,,,,,,1],[,1,,,,,,1,1,,,,,,1],,[,1,1,,,,,,1,,,,,1,1,,,,1],[1,,1,,1,,,,,1,,,,,1,,,,,,,,,1,1],[,1,1,,,,,,,,,1,1,1,1,,,,1,,,,,1,,,1],,[,1,1,,1,,,1,1,,,1,,,1,1,1,,1,,1,1,1,,,,1],[,,,,,1,,,,,1,,,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,,,1,,,,,1,,,,,1,,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,1],[,1,,,,,,1,,,,,,,1,1,1,,,1],[,1,,,,,,,,,,1,1,1,,,,,1,,,1],[,,,,,1,,1,,,,,1,1,1,,1,1,,1,1,1,,,1,1],[1,1,,,,,,,1,,,,,1,1,,,,,,,,,,,1],,[,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,,1,,,,,1,,,1,,,,1,,1],[,1,,,,,,,,,1]]];s(fB,"isValidLang")});var gB={};T(gB,{UIStrings:()=>si,default:()=>wie});function bie(e){return e.startsWith("http:")||e.startsWith("https:")}function vie(e){if(e.toLowerCase()===yie)return!0;let[t]=e.split("-");return fB(t.toLowerCase())}var yie,si,Yd,Vx,wie,yB=b(()=>{"use strict";d();V();A();hB();yie="x-default",si={title:"Document has a valid `hreflang`",failureTitle:"Document doesn't have a valid `hreflang`",description:"hreflang links tell search engines what version of a page they should list in search results for a given language or region. [Learn more about `hreflang`](https://developer.chrome.com/docs/lighthouse/seo/hreflang/).",unexpectedLanguage:"Unexpected language code",notFullyQualified:"Relative href value"},Yd=w("core/audits/seo/hreflang.js",si);s(bie,"isFullyQualified");s(vie,"isExpectedLanguageCode");Vx=class extends g{static{s(this,"Hreflang")}static get meta(){return{id:"hreflang",title:Yd(si.title),failureTitle:Yd(si.failureTitle),description:Yd(si.description),supportedModes:["navigation"],requiredArtifacts:["LinkElements","URL"]}}static audit({LinkElements:t}){let n=[],r=t.filter(i=>{let c=i.rel==="alternate",u=i.hreflang,l=i.source==="body";return c&&u&&!l});for(let i of r){let c=[],u;vie(i.hreflang)||c.push(Yd(si.unexpectedLanguage)),bie(i.hrefRaw.toLowerCase())||c.push(Yd(si.notFullyQualified)),i.source==="head"?i.node?u={...g.makeNodeItem(i.node),snippet:`<link rel="alternate" hreflang="${i.hreflang}" href="${i.hrefRaw}" />`}:u={type:"node",snippet:`<link rel="alternate" hreflang="${i.hreflang}" href="${i.hrefRaw}" />`}:i.source==="headers"&&(u=`Link: <${i.hrefRaw}>; rel="alternate"; hreflang="${i.hreflang}"`),!(!u||!c.length)&&n.push({source:u,subItems:{type:"subitems",items:c.map(l=>({reason:l}))}})}let a=[{key:"source",valueType:"code",subItemsHeading:{key:"reason",valueType:"text"},label:""}],o=g.makeTableDetails(a,n);return{score:+(n.length===0),details:o}}},wie=Vx});var bB={};T(bB,{UIStrings:()=>Kd,default:()=>xie});var Die,Eie,Kd,Wx,$x,xie,vB=b(()=>{"use strict";d();V();A();Bt();Die=400,Eie=599,Kd={title:"Page has successful HTTP status code",failureTitle:"Page has unsuccessful HTTP status code",description:"Pages with unsuccessful HTTP status codes may not be indexed properly. [Learn more about HTTP status codes](https://developer.chrome.com/docs/lighthouse/seo/http-status-code/)."},Wx=w("core/audits/seo/http-status-code.js",Kd),$x=class extends g{static{s(this,"HTTPStatusCode")}static get meta(){return{id:"http-status-code",title:Wx(Kd.title),failureTitle:Wx(Kd.failureTitle),description:Wx(Kd.description),requiredArtifacts:["devtoolsLogs","URL","GatherContext"],supportedModes:["navigation"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=t.URL,i=(await _e.request({devtoolsLog:r,URL:a},n)).statusCode;return i>=Die&&i<=Eie?{score:0,displayValue:`${i}`}:{score:1}}},xie=$x});var TB=I((_7e,xB)=>{d();function wB(e){return e?Array.isArray(e)?e.map(wB):String(e).trim():null}s(wB,"trimLine");function Tie(e){var t=e.indexOf("#");return t>-1?e.substr(0,t):e}s(Tie,"removeComments");function Sie(e){var t=String(e).indexOf(":");return!e||t<0?null:[e.slice(0,t),e.slice(t+1)]}s(Sie,"splitLine");function Yx(e){var t=e.toLowerCase(),n=t.indexOf("/");return n>-1&&(t=t.substr(0,n)),t.trim()}s(Yx,"formatUserAgent");function kie(e){try{return DB(encodeURI(e).replace(/%25/g,"%"))}catch{return e}}s(kie,"normaliseEncoding");function DB(e){return e.replace(/%[0-9a-fA-F]{2}/g,function(t){return t.toUpperCase()})}s(DB,"urlEncodeToUpper");function Cie(e,t){var n=new Array(t.length+1),r=1;n[0]=0;for(var a=0;a<e.length;a++){if(e[a]==="$"&&a+1===e.length)return n[r-1]===t.length;if(e[a]=="*"){r=t.length-n[0]+1;for(var o=1;o<r;o++)n[o]=n[o-1]+1}else{for(var i=0,o=0;o<r;o++)n[o]<t.length&&t[n[o]]===e[a]&&(n[i++]=n[o]+1);if(i==0)return!1;r=i}}return!0}s(Cie,"matches");function Aie(e,t){for(var n=/\r\n|\r|\n/,r=e.split(n).map(Tie).map(Sie).map(wB),a=[],o=!0,i=0;i<r.length;i++){var c=r[i];if(!(!c||!c[0])){switch(c[0].toLowerCase()){case"user-agent":o&&(a.length=0),c[1]&&a.push(Yx(c[1]));break;case"disallow":t.addRule(a,c[1],!1,i+1);break;case"allow":t.addRule(a,c[1],!0,i+1);break;case"crawl-delay":t.setCrawlDelay(a,c[1]);break;case"sitemap":c[1]&&t.addSitemap(c[1]);break;case"host":c[1]&&t.setPreferredHost(c[1].toLowerCase());break}o=c[0].toLowerCase()!=="user-agent"}}}s(Aie,"parseRobots");function _ie(e,t){for(var n=null,r=0;r<t.length;r++){var a=t[r];Cie(a.pattern,e)&&(!n||a.pattern.length>n.pattern.length||a.pattern.length==n.pattern.length&&a.allow&&!n.allow)&&(n=a)}return n}s(_ie,"findRule");function EB(e){try{var e=new URL(e,"http://robots-relative.samclarke.com/");return e.port||(e.port=e.protocol==="https:"?443:80),e}catch{return null}}s(EB,"parseUrl");function er(e,t){this._url=EB(e)||{},this._rules=Object.create(null),this._sitemaps=[],this._preferredHost=null,Aie(t||"",this)}s(er,"Robots");er.prototype.addRule=function(e,t,n,r){var a=this._rules;e.forEach(function(o){a[o]=a[o]||[],t&&a[o].push({pattern:kie(t),allow:n,lineNumber:r})})};er.prototype.setCrawlDelay=function(e,t){var n=this._rules,r=Number(t);e.forEach(function(a){n[a]=n[a]||[],!isNaN(r)&&(n[a].crawlDelay=r)})};er.prototype.addSitemap=function(e){this._sitemaps.push(e)};er.prototype.setPreferredHost=function(e){this._preferredHost=e};er.prototype._getRule=function(e,t){var n=EB(e)||{},r=Yx(t||"*");if(!(n.protocol!==this._url.protocol||n.hostname!==this._url.hostname||n.port!==this._url.port)){var a=this._rules[r]||this._rules["*"]||[],o=DB(n.pathname+n.search),i=_ie(o,a);return i}};er.prototype.isAllowed=function(e,t){var n=this._getRule(e,t);if(!(typeof n>"u"))return!n||n.allow};er.prototype.getMatchingLineNumber=function(e,t){var n=this._getRule(e,t);return n?n.lineNumber:-1};er.prototype.isDisallowed=function(e,t){return!this.isAllowed(e,t)};er.prototype.getCrawlDelay=function(e){var t=Yx(e||"*");return(this._rules[t]||this._rules["*"]||{}).crawlDelay};er.prototype.getPreferredHost=function(){return this._preferredHost};er.prototype.getSitemaps=function(){return this._sitemaps.slice(0)};xB.exports=er});var kB=I((I7e,SB)=>{d();var Rie=TB();SB.exports=function(e,t){return new Rie(e,t)}});var FB={};T(FB,{UIStrings:()=>Xd,default:()=>Lie});function Nie(e){let t=e.split(":");if(t.length<=1||t[0]!==RB)return!1;let n=Date.parse(t.slice(1).join(":"));return!isNaN(n)&&n<Date.now()}function AB(e){return e.split(",").map(t=>t.toLowerCase().trim()).some(t=>Fie.has(t)||Nie(t))}function Mie(e){let t=e.match(/^([^,:]+):/);if(t&&t[1].toLowerCase()!==RB)return t[1]}var _B,CB,Fie,Iie,RB,Xd,Kx,Xx,Lie,IB=b(()=>{"use strict";d();_B=Lt(kB(),1);V();Bt();A();CB=new Set([void 0,"Googlebot","bingbot","DuckDuckBot","archive.org_bot"]),Fie=new Set(["noindex","none"]),Iie="x-robots-tag",RB="unavailable_after",Xd={title:"Page isn’t blocked from indexing",failureTitle:"Page is blocked from indexing",description:"Search engines are unable to include your pages in search results if they don't have permission to crawl them. [Learn more about crawler directives](https://developer.chrome.com/docs/lighthouse/seo/is-crawlable/)."},Kx=w("core/audits/seo/is-crawlable.js",Xd);s(Nie,"isUnavailable");s(AB,"hasBlockingDirective");s(Mie,"getUserAgentFromHeaderDirectives");Xx=class e extends g{static{s(this,"IsCrawlable")}static get meta(){return{id:"is-crawlable",title:Kx(Xd.title),failureTitle:Kx(Xd.failureTitle),description:Kx(Xd.description),supportedModes:["navigation"],requiredArtifacts:["MetaElements","RobotsTxt","URL","devtoolsLogs"]}}static handleMetaElement(t){let n=t.content||"";if(AB(n))return{source:{...g.makeNodeItem(t.node),snippet:`<meta name="${t.name}" content="${n}" />`}}}static determineIfCrawlableForUserAgent(t,n,r,a,o){let i=[],c;if(t&&(c=r.find(u=>u.name===t.toLowerCase())),c||(c=r.find(u=>u.name==="robots")),c){let u=e.handleMetaElement(c);u&&i.push(u)}for(let u of n.responseHeaders||[]){if(u.name.toLowerCase()!==Iie)continue;let l=Mie(u.value);if(l!==t&&l!==void 0)continue;let m=u.value.trim();t&&u.value.startsWith(`${t}:`)&&(m=u.value.replace(`${t}:`,"")),AB(m)&&i.push({source:`${u.name}: ${u.value}`})}if(a&&!a.isAllowed(n.url,t)){let u=a.getMatchingLineNumber(n.url)||1;i.push({source:{type:"source-location",url:o.href,urlProvider:"network",line:u-1,column:0}})}return i}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await _e.request({devtoolsLog:r,URL:t.URL},n),o=new URL("/robots.txt",a.url),i=t.RobotsTxt.content?(0,_B.default)(o.href,t.RobotsTxt.content):void 0,c=[],u=[];for(let f of CB){let y=e.determineIfCrawlableForUserAgent(f,a,t.MetaElements,i,o);y.length>0&&c.push(f),f===void 0&&u.push(...y)}let l=c.length===CB.size?0:1,m=[];if(l&&c.length>0){let f=c.filter(Boolean).join(", ");m.push(`The following bot user agents are blocked from crawling: ${f}. The audit is otherwise passing, because at least one bot was explicitly allowed.`)}let p=[{key:"source",valueType:"code",label:"Blocking Directive Source"}],h=g.makeTableDetails(p,l===0?u:[]);return{score:l,details:h,warnings:m}}},Lie=Xx});var NB={};T(NB,{UIStrings:()=>Ks,default:()=>Oie});var Pie,Ks,uh,Jx,Oie,MB=b(()=>{"use strict";d();V();Ze();A();Pie=new Set(["click here","click this","go","here","information","learn more","more","more info","more information","right here","read more","see more","start","this","ここをクリック","こちらをクリック","リンク","続きを読む","続く","全文表示","click aquí","click aqui","clicka aquí","clicka aqui","pincha aquí","pincha aqui","aquí","aqui","más","mas","más información","más informacion","mas información","mas informacion","este","enlace","este enlace","empezar","clique aqui","ir","mais informação","mais informações","mais","veja mais","여기","여기를 클릭","클릭","링크","자세히","자세히 보기","계속","이동","전체 보기","här","klicka här","läs mer","mer","mer info","mer information","அடுத்த பக்கம்","மறுபக்கம்","முந்தைய பக்கம்","முன்பக்கம்","மேலும் அறிக","மேலும் தகவலுக்கு","மேலும் தரவுகளுக்கு","தயவுசெய்து இங்கே அழுத்தவும்","இங்கே கிளிக் செய்யவும்"]),Ks={title:"Links have descriptive text",failureTitle:"Links do not have descriptive text",description:"Descriptive link text helps search engines understand your content. [Learn how to make links more accessible](https://developer.chrome.com/docs/lighthouse/seo/link-text/).",displayValue:`{itemCount, plural,
    =1 {1 link found}
    other {# links found}
    }`},uh=w("core/audits/seo/link-text.js",Ks),Jx=class extends g{static{s(this,"LinkText")}static get meta(){return{id:"link-text",title:uh(Ks.title),failureTitle:uh(Ks.failureTitle),description:uh(Ks.description),requiredArtifacts:["URL","AnchorElements"]}}static audit(t){let n=t.AnchorElements.filter(i=>i.href&&!i.rel.includes("nofollow")).filter(i=>{let c=i.href.toLowerCase();return c.startsWith("javascript:")||c.startsWith("mailto:")||Y.equalWithExcludedFragments(i.href,t.URL.finalDisplayedUrl)?!1:Pie.has(i.text.trim().toLowerCase())}).map(i=>({href:i.href,text:i.text.trim()})),r=[{key:"href",valueType:"url",label:"Link destination"},{key:"text",valueType:"text",label:"Link Text"}],a=g.makeTableDetails(r,n),o;return n.length&&(o=uh(Ks.displayValue,{itemCount:n.length})),{score:+(n.length===0),details:a,displayValue:o}}},Oie=Jx});var PB={};T(PB,{UIStrings:()=>lh,default:()=>Bie});var lh,LB,Zx,Bie,OB=b(()=>{"use strict";d();yn();A();lh={description:"Run the [Structured Data Testing Tool](https://search.google.com/structured-data/testing-tool/) and the [Structured Data Linter](http://linter.structured-data.org/) to validate structured data. [Learn more about Structured Data](https://developer.chrome.com/docs/lighthouse/seo/structured-data/).",title:"Structured data is valid"},LB=w("core/audits/seo/manual/structured-data.js",lh),Zx=class extends ot{static{s(this,"StructuredData")}static get meta(){return Object.assign({id:"structured-data",description:LB(lh.description),title:LB(lh.title)},super.partialMeta)}},Bie=Zx});var BB={};T(BB,{UIStrings:()=>Xs,default:()=>Uie});var Xs,dh,Qx,Uie,UB=b(()=>{"use strict";d();V();A();Xs={title:"Document has a meta description",failureTitle:"Document does not have a meta description",description:"Meta descriptions may be included in search results to concisely summarize page content. [Learn more about the meta description](https://developer.chrome.com/docs/lighthouse/seo/meta-description/).",explanation:"Description text is empty."},dh=w("core/audits/seo/meta-description.js",Xs),Qx=class extends g{static{s(this,"Description")}static get meta(){return{id:"meta-description",title:dh(Xs.title),failureTitle:dh(Xs.failureTitle),description:dh(Xs.description),requiredArtifacts:["MetaElements"]}}static audit(t){let n=t.MetaElements.find(a=>a.name==="description");return n?(n.content||"").trim().length===0?{score:0,explanation:dh(Xs.explanation)}:{score:1}:{score:0}}},Uie=Qx});var zB={};T(zB,{UIStrings:()=>Jd,default:()=>Gie});function Hie(e){return e=e.trim().toLowerCase(),jie.has(e)||e.startsWith(jB)||e.startsWith(qB)}function tT(e){try{let n=new URL(e,"http://example.com").pathname.split(".");if(n.length<2)return!1;let r=n[n.length-1];return qie.has(r.trim().toLowerCase())}catch{return!1}}var jB,qB,jie,qie,zie,Jd,eT,nT,Gie,HB=b(()=>{"use strict";d();V();A();jB="application/x-java-applet",qB="application/x-java-bean",jie=new Set(["application/x-shockwave-flash",jB,qB,"application/x-silverlight","application/x-silverlight-2"]),qie=new Set(["swf","flv","class","xap"]),zie=new Set(["code","movie","source","src"]),Jd={title:"Document avoids plugins",failureTitle:"Document uses plugins",description:"Search engines can't index plugin content, and many devices restrict plugins or don't support them. [Learn more about avoiding plugins](https://developer.chrome.com/docs/lighthouse/seo/plugins/)."},eT=w("core/audits/seo/plugins.js",Jd);s(Hie,"isPluginType");s(tT,"isPluginURL");nT=class extends g{static{s(this,"Plugins")}static get meta(){return{id:"plugins",title:eT(Jd.title),failureTitle:eT(Jd.failureTitle),description:eT(Jd.description),requiredArtifacts:["EmbeddedContent"]}}static audit(t){let n=t.EmbeddedContent.filter(o=>{if(o.tagName==="APPLET"||(o.tagName==="EMBED"||o.tagName==="OBJECT")&&o.type&&Hie(o.type))return!0;let i=o.src||o.code;return o.tagName==="EMBED"&&i&&tT(i)||o.tagName==="OBJECT"&&o.data&&tT(o.data)?!0:o.params.filter(u=>zie.has(u.name.trim().toLowerCase())&&tT(u.value)).length>0}).map(o=>({source:g.makeNodeItem(o.node)})),r=[{key:"source",valueType:"code",label:"Element source"}],a=g.makeTableDetails(r,n);return{score:+(n.length===0),details:a}}},Gie=nT});var VB={};T(VB,{UIStrings:()=>oo,default:()=>Qie});function Xie(e,t){if(!Yie.has(e))throw new Error("Unknown directive");if(e===GB){let n;try{n=new URL(t)}catch{throw new Error("Invalid sitemap URL")}if(!Kie.has(n.protocol))throw new Error("Invalid sitemap URL protocol")}if(e===aT&&!t)throw new Error("No user-agent specified");if(e===oT||e===iT){if(t!==""&&t[0]!=="/"&&t[0]!=="*")throw new Error('Pattern should either be empty, start with "/" or "*"');let n=t.indexOf("$");if(n!==-1&&n!==t.length-1)throw new Error('"$" should only be used at the end of the pattern')}}function Jie(e){let t=e.indexOf("#");if(t!==-1&&(e=e.substr(0,t)),e=e.trim(),e.length===0)return null;let n=e.indexOf(":");if(n===-1)throw new Error("Syntax not understood");let r=e.slice(0,n).trim().toLowerCase(),a=e.slice(n+1).trim();return Xie(r,a),{directive:r,value:a}}function Zie(e){let t=[],n=!1;return e.split(/\r\n|\r|\n/).forEach((r,a)=>{let o;try{o=Jie(r)}catch(i){t.push({index:(a+1).toString(),line:r,message:i.message.toString()})}o&&(o.directive===aT?n=!0:!n&&$ie.has(o.directive)&&t.push({index:(a+1).toString(),line:r,message:"No user-agent specified"}))}),t}var Vie,Wie,GB,aT,oT,iT,$ie,Yie,Kie,oo,Js,rT,Qie,WB=b(()=>{"use strict";d();V();A();Vie=400,Wie=500,GB="sitemap",aT="user-agent",oT="allow",iT="disallow",$ie=new Set([oT,iT]),Yie=new Set([aT,iT,oT,GB,"crawl-delay","clean-param","host","request-rate","visit-time","noindex"]),Kie=new Set(["https:","http:","ftp:"]),oo={title:"robots.txt is valid",failureTitle:"robots.txt is not valid",description:"If your robots.txt file is malformed, crawlers may not be able to understand how you want your website to be crawled or indexed. [Learn more about robots.txt](https://developer.chrome.com/docs/lighthouse/seo/invalid-robots-txt/).",displayValueHttpBadCode:"Request for robots.txt returned HTTP status: {statusCode}",displayValueValidationError:`{itemCount, plural,
    =1 {1 error found}
    other {# errors found}
    }`,explanation:"Lighthouse was unable to download a robots.txt file"},Js=w("core/audits/seo/robots-txt.js",oo);s(Xie,"verifyDirective");s(Jie,"parseLine");s(Zie,"validateRobots");rT=class extends g{static{s(this,"RobotsTxt")}static get meta(){return{id:"robots-txt",title:Js(oo.title),failureTitle:Js(oo.failureTitle),description:Js(oo.description),requiredArtifacts:["RobotsTxt"]}}static audit(t){let{status:n,content:r}=t.RobotsTxt;if(!n)return{score:0,explanation:Js(oo.explanation)};if(n>=Wie)return{score:0,displayValue:Js(oo.displayValueHttpBadCode,{statusCode:n})};if(n>=Vie||r==="")return{score:1,notApplicable:!0};if(r===null)throw new Error(`Status ${n} was valid, but content was null`);let a=Zie(r),o=[{key:"index",valueType:"text",label:"Line #"},{key:"line",valueType:"code",label:"Content"},{key:"message",valueType:"code",label:"Error"}],i=g.makeTableDetails(o,a),c;return a.length&&(c=Js(oo.displayValueValidationError,{itemCount:a.length})),{score:+(a.length===0),details:i,displayValue:c}}},Qie=rT});function $B(e){return e=JM(e),e=ZM(e),e=YB(e),e}function mh(e,t){return Math.abs(e-t)<=10}function YB(e){for(let t=0;t<e.length;t++)for(let n=t+1;n<e.length;n++){let r=e[t],a=e[n],o=mh(r.top,a.top)||mh(r.bottom,a.bottom),i=mh(r.left,a.left)||mh(r.right,a.right);if(Zp(r,a)&&(o||i)){let u=QM([r,a]),l=Jp(u);if(!(Db(r,l)||Db(a,l)))continue;return e=e.filter(m=>m!==r&&m!==a),e.push(u),YB(e)}}return e}var KB=b(()=>{"use strict";d();Vu();s($B,"getTappableRectsFromClientRects");s(mh,"almostEqual");s(YB,"mergeTouchingClientRects")});var XB={};T(XB,{UIStrings:()=>fa,default:()=>cse});function tse(e){return e.map(t=>({tapTarget:t,paddedBoundsRect:Eb(t.clientRects,Zd)}))}function nse(e){return e.width<Zd||e.height<Zd}function rse(e){return e.filter(t=>t.tapTarget.clientRects.every(nse))}function ase(e,t){let n=[];return e.forEach(r=>{let a=$B(r.tapTarget.clientRects);for(let o of t){if(o===r||!Zp(r.paddedBoundsRect,o.paddedBoundsRect)||r.tapTarget.href===o.tapTarget.href&&/https?:\/\//.test(r.tapTarget.href))continue;let i=o.tapTarget.clientRects;if(n3(a,i))continue;let c=ose(a,i);c&&n.push({...c,tapTarget:r.tapTarget,overlappingTarget:o.tapTarget})}}),n}function ose(e,t){let n=null;for(let r of e){let a=e3(r,Zd),o=Gu(a,r);for(let i of t){let c=Gu(a,i),u=c/o;u<ese||(!n||u>n.overlapScoreRatio)&&(n={overlapScoreRatio:u,tapTargetScore:o,overlappingTargetScore:c})}}return n}function ise(e){let t=[];return e.forEach((n,r)=>{let a=e.find(c=>c.tapTarget===n.overlappingTarget&&c.overlappingTarget===n.tapTarget);if(!a){t.push(n);return}let{overlapScoreRatio:o}=n,{overlapScoreRatio:i}=a;(o>i||o===i&&r<e.indexOf(a))&&t.push(n)}),t}function sse(e){let t=e.map(n=>{let r=t3(n.tapTarget.clientRects),a=Math.floor(r.width),o=Math.floor(r.height),i=a+"x"+o;return{tapTarget:g.makeNodeItem(n.tapTarget.node),overlappingTarget:g.makeNodeItem(n.overlappingTarget.node),tapTargetScore:n.tapTargetScore,overlappingTargetScore:n.overlappingTargetScore,overlapScoreRatio:n.overlapScoreRatio,size:i,width:a,height:o}});return t.sort((n,r)=>r.overlapScoreRatio-n.overlapScoreRatio),t}var fa,io,Zd,ese,ph,cse,JB=b(()=>{"use strict";d();V();ch();Vu();KB();A();fa={title:"Tap targets are sized appropriately",failureTitle:"Tap targets are not sized appropriately",description:"Interactive elements like buttons and links should be large enough (48x48px), or have enough space around them, to be easy enough to tap without overlapping onto other elements. [Learn more about tap targets](https://developer.chrome.com/docs/lighthouse/seo/tap-targets/).",tapTargetHeader:"Tap Target",overlappingTargetHeader:"Overlapping Target",explanationViewportMetaNotOptimized:"Tap targets are too small because there's no viewport meta tag optimized for mobile screens",displayValue:"{decimalProportion, number, percent} appropriately sized tap targets"},io=w("core/audits/seo/tap-targets.js",fa),Zd=48,ese=.25;s(tse,"getBoundedTapTargets");s(nse,"clientRectBelowMinimumSize");s(rse,"getTooSmallTargets");s(ase,"getAllOverlapFailures");s(ose,"getOverlapFailureForTargetPair");s(ise,"mergeSymmetricFailures");s(sse,"getTableItems");ph=class extends g{static{s(this,"TapTargets")}static get meta(){return{id:"tap-targets",title:io(fa.title),failureTitle:io(fa.failureTitle),description:io(fa.description),requiredArtifacts:["MetaElements","TapTargets"]}}static async audit(t,n){if(n.settings.formFactor==="desktop")return{score:1,notApplicable:!0};if(!(await Ys.request(t.MetaElements,n)).isMobileOptimized)return{score:0,explanation:io(fa.explanationViewportMetaNotOptimized)};let a=tse(t.TapTargets),o=rse(a),i=ase(o,a),c=ise(i),u=sse(c),l=[{key:"tapTarget",valueType:"node",label:io(fa.tapTargetHeader)},{key:"size",valueType:"text",label:io(x.columnSize)},{key:"overlappingTarget",valueType:"node",label:io(fa.overlappingTargetHeader)}],m=g.makeTableDetails(l,u),p=t.TapTargets.length,h=new Set(i.map(E=>E.tapTarget)).size,f=p-h,y=1,v=1;h>0&&(v=f/p,y=v*.89);let D=io(fa.displayValue,{decimalProportion:v});return{score:y,details:m,displayValue:D}}};ph.FINGER_SIZE_PX=Zd;cse=ph});var ZB={};T(ZB,{UIStrings:()=>Qs,default:()=>dse});var Qs,Zs,use,lse,sT,dse,QB=b(()=>{"use strict";d();V();A();Bt();Qs={title:"Initial server response time was short",failureTitle:"Reduce initial server response time",description:"Keep the server response time for the main document short because all other requests depend on it. [Learn more about the Time to First Byte metric](https://developer.chrome.com/docs/lighthouse/performance/time-to-first-byte/).",displayValue:"Root document took {timeInMs, number, milliseconds} ms"},Zs=w("core/audits/server-response-time.js",Qs),use=600,lse=100,sT=class e extends g{static{s(this,"ServerResponseTime")}static get meta(){return{id:"server-response-time",title:Zs(Qs.title),failureTitle:Zs(Qs.failureTitle),description:Zs(Qs.description),supportedModes:["navigation"],guidanceLevel:1,requiredArtifacts:["devtoolsLogs","URL","GatherContext"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS}}static calculateResponseTime(t){return globalThis.isLightrider&&t.lrStatistics?t.lrStatistics.requestMs:t.timing?t.timing.receiveHeadersStart-t.timing.sendEnd:null}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await _e.request({devtoolsLog:r,URL:t.URL},n),o=e.calculateResponseTime(a);if(o===null)throw new Error("no timing found for main resource");let i=o<use,c=Zs(Qs.displayValue,{timeInMs:o}),u=[{key:"url",valueType:"url",label:Zs(x.columnURL)},{key:"responseTime",valueType:"timespanMs",label:Zs(x.columnTimeSpent)}],l=Math.max(o-lse,0),m=g.makeOpportunityDetails(u,[{url:a.url,responseTime:o}],{overallSavingsMs:l});return{numericValue:o,numericUnit:"millisecond",score:Number(i),scoreDisplayMode:i?g.SCORING_MODES.INFORMATIVE:void 0,displayValue:c,details:m,metricSavings:{FCP:l,LCP:l}}}},dse=sT});var cT,fh,uT=b(()=>{"use strict";d();V();cT=class extends g{static{s(this,"MultiCheckAudit")}static async audit(t,n){let r=await this.audit_(t,n);return this.createAuditProduct(r)}static createAuditProduct(t){let n={...t,...t.manifestValues,manifestValues:void 0,allChecks:void 0};t.manifestValues?.allChecks&&t.manifestValues.allChecks.forEach(a=>{n[a.id]=a.passing});let r={type:"debugdata",items:[n]};return t.failures.length>0?{score:0,explanation:`Failures: ${t.failures.join(`,
`)}.`,details:r}:{score:1,details:r}}static audit_(t,n){throw new Error("audit_ unimplemented")}},fh=cT});var eU={};T(eU,{UIStrings:()=>Qd,default:()=>mse});var Qd,lT,dT,mse,tU=b(()=>{"use strict";d();uT();Nd();A();Qd={title:"Configured for a custom splash screen",failureTitle:"Is not configured for a custom splash screen",description:"A themed splash screen ensures a high-quality experience when users launch your app from their homescreens. [Learn more about splash screens](https://developer.chrome.com/docs/lighthouse/pwa/splash-screen/)."},lT=w("core/audits/splash-screen.js",Qd),dT=class e extends fh{static{s(this,"SplashScreen")}static get meta(){return{id:"splash-screen",title:lT(Qd.title),failureTitle:lT(Qd.failureTitle),description:lT(Qd.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors"]}}static assessManifest(t,n){if(t.isParseFailure&&t.parseFailureReason){n.push(t.parseFailureReason);return}let r=["hasName","hasBackgroundColor","hasThemeColor","hasIconsAtLeast512px"];t.allChecks.filter(a=>r.includes(a.id)).forEach(a=>{a.passing||n.push(a.failureText)})}static async audit_(t,n){let r=[],a=await eo.request(t,n);return e.assessManifest(a,r),{failures:r,manifestValues:a}}},mse=dT});var nU={};T(nU,{UIStrings:()=>em,default:()=>pse});var em,mT,pT,pse,rU=b(()=>{"use strict";d();uT();Nd();A();em={title:"Sets a theme color for the address bar.",failureTitle:"Does not set a theme color for the address bar.",description:"The browser address bar can be themed to match your site. [Learn more about theming the address bar](https://developer.chrome.com/docs/lighthouse/pwa/themed-omnibox/)."},mT=w("core/audits/themed-omnibox.js",em),pT=class e extends fh{static{s(this,"ThemedOmnibox")}static get meta(){return{id:"themed-omnibox",title:mT(em.title),failureTitle:mT(em.failureTitle),description:mT(em.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors","MetaElements"]}}static assessMetaThemecolor(t,n){t?t.content||n.push("The theme-color meta tag did not contain a content value"):n.push('No `<meta name="theme-color">` tag found')}static assessManifest(t,n){if(t.isParseFailure&&t.parseFailureReason){n.push(t.parseFailureReason);return}let r=t.allChecks.find(a=>a.id==="hasThemeColor");r&&!r.passing&&n.push(r.failureText)}static async audit_(t,n){let r=[],a=t.MetaElements.find(i=>i.name==="theme-color"),o=await eo.request(t,n);return e.assessManifest(o,r),e.assessMetaThemecolor(a,r),{failures:r,manifestValues:o,themeColor:a?.content||null}}},pse=pT});var aU={};T(aU,{UIStrings:()=>tc,default:()=>fse});var tc,ec,fT,fse,oU=b(()=>{"use strict";d();V();A();tc={title:"Avoids third-party cookies",failureTitle:"Uses third-party cookies",description:"Support for third-party cookies will be removed in a future version of Chrome. [Learn more about phasing out third-party cookies](https://developer.chrome.com/en/docs/privacy-sandbox/third-party-cookie-phase-out/).",displayValue:`{itemCount, plural,
    =1 {1 cookie found}
    other {# cookies found}
    }`},ec=w("core/audits/third-party-cookies.js",tc),fT=class extends g{static{s(this,"ThirdPartyCookies")}static get meta(){return{id:"third-party-cookies",title:ec(tc.title),failureTitle:ec(tc.failureTitle),description:ec(tc.description),requiredArtifacts:["InspectorIssues"]}}static getCookieId(t){if(!t.cookie)return t.rawCookieLine??"no-cookie-info";let{domain:n,path:r,name:a}=t.cookie;return`${n};${r};${a}`}static async audit(t){let n=new Set,r=[];for(let c of t.InspectorIssues.cookieIssue){let u=c.cookieWarningReasons.includes("WarnThirdPartyPhaseout"),l=c.cookieExclusionReasons.includes("ExcludeThirdPartyPhaseout");if(!u&&!l)continue;let m=c.cookie?.name||c.rawCookieLine;if(!m)continue;let p=this.getCookieId(c);n.has(p)||(n.add(p),r.push({name:m,url:c.cookieUrl}))}let a=[{key:"name",valueType:"text",label:ec(x.columnName)},{key:"url",valueType:"url",label:ec(x.columnURL)}],o=g.makeTableDetails(a,r),i;return r.length>0&&(i=ec(tc.displayValue,{itemCount:r.length})),{score:r.length?0:1,displayValue:i,details:o}}},fse=fT});var iU={};T(iU,{UIStrings:()=>ui,default:()=>gT});var ui,ci,hse,hT,gT,yT=b(()=>{"use strict";d();V();ua();A();de();nd();id();ui={title:"Minimize third-party usage",failureTitle:"Reduce the impact of third-party code",description:"Third-party code can significantly impact load performance. Limit the number of redundant third-party providers and try to load third-party code after your page has primarily finished loading. [Learn how to minimize third-party impact](https://developers.google.com/web/fundamentals/performance/optimizing-content-efficiency/loading-third-party-javascript/).",columnThirdParty:"Third-Party",displayValue:"Third-party code blocked the main thread for {timeInMs, number, milliseconds} ms"},ci=w("core/audits/third-party-summary.js",ui),hse=250,hT=class e extends g{static{s(this,"ThirdPartySummary")}static get meta(){return{id:"third-party-summary",title:ci(ui.title),failureTitle:ci(ui.failureTitle),description:ci(ui.description),guidanceLevel:1,scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,requiredArtifacts:["traces","devtoolsLogs","URL","GatherContext"]}}static getSummaries(t,n,r,a){let o=new Map,i=new Map,c={mainThreadTime:0,blockingTime:0,transferSize:0,tbtImpact:0};for(let m of t){let p=o.get(m.url)||{...c};p.transferSize+=m.transferSize,o.set(m.url,p)}let u=td(t);for(let m of n){let p=ps(m,u),h=o.get(p)||{...c},f=m.selfTime*r;h.mainThreadTime+=f,h.blockingTime+=Math.max(f-50,0),h.tbtImpact+=m.selfTbtImpact,o.set(p,h)}let l=new Map;for(let[m,p]of o.entries()){let h=a.entityByUrl.get(m);if(!h){o.delete(m);continue}let f=i.get(h)||{...c};f.transferSize+=p.transferSize,f.mainThreadTime+=p.mainThreadTime,f.blockingTime+=p.blockingTime,f.tbtImpact+=p.tbtImpact,i.set(h,f);let y=l.get(h)||[];y.push(m),l.set(h,y)}return{byURL:o,byEntity:i,urls:l}}static makeSubItems(t,n){return(n.urls.get(t)||[]).map(o=>({url:o,...n.byURL.get(o)})).sort((o,i)=>i.blockingTime-o.blockingTime||i.transferSize-o.transferSize)}static async audit(t,n){let r=n.settings||{},a=t.devtoolsLogs[g.DEFAULT_PASS],o=await H.request(a,n),i=await ln.request({URL:t.URL,devtoolsLog:a},n),c=i.firstParty,u=g.makeMetricComputationDataInput(t,n),l=await Va.request(u,n),m=r.throttlingMethod==="simulate"?r.throttling.cpuSlowdownMultiplier:1,p=e.getSummaries(o,l,m,i),h={wastedBytes:0,wastedMs:0,tbtImpact:0},f=Array.from(p.byEntity.entries()).filter(([E])=>!(c&&c===E)).map(([E,S])=>(h.wastedBytes+=S.transferSize,h.wastedMs+=S.blockingTime,h.tbtImpact+=S.tbtImpact,{...S,entity:E.name,subItems:{type:"subitems",items:e.makeSubItems(E,p)}})).sort((E,S)=>S.blockingTime-E.blockingTime||S.transferSize-E.transferSize),y=[{key:"entity",valueType:"text",label:ci(ui.columnThirdParty),subItemsHeading:{key:"url",valueType:"url"}},{key:"transferSize",granularity:1,valueType:"bytes",label:ci(x.columnTransferSize),subItemsHeading:{key:"transferSize"}},{key:"blockingTime",granularity:1,valueType:"ms",label:ci(x.columnBlockingTime),subItemsHeading:{key:"blockingTime"}}];if(!f.length)return{score:1,notApplicable:!0,metricSavings:{TBT:0}};let v=g.makeTableDetails(y,f,{...h,isEntityGrouped:!0}),D=h.wastedMs<=hse;return{score:Number(D),scoreDisplayMode:D?g.SCORING_MODES.INFORMATIVE:void 0,displayValue:ci(ui.displayValue,{timeInMs:h.wastedMs}),details:v,metricSavings:{TBT:h.tbtImpact}}}},gT=hT});var sU={};T(sU,{UIStrings:()=>fr,default:()=>yse});var fr,ha,gse,bT,yse,cU=b(()=>{"use strict";d();V();A();ua();lf();de();yT();id();fr={title:"Lazy load third-party resources with facades",failureTitle:"Some third-party resources can be lazy loaded with a facade",description:"Some third-party embeds can be lazy loaded. Consider replacing them with a facade until they are required. [Learn how to defer third-parties with a facade](https://developer.chrome.com/docs/lighthouse/performance/third-party-facades/).",displayValue:`{itemCount, plural,
  =1 {# facade alternative available}
  other {# facade alternatives available}
  }`,columnProduct:"Product",categoryVideo:"{productName} (Video)",categoryCustomerSuccess:"{productName} (Customer Success)",categoryMarketing:"{productName} (Marketing)",categorySocial:"{productName} (Social)"},ha=w("core/audits/third-party-facades.js",fr),gse={video:fr.categoryVideo,"customer-success":fr.categoryCustomerSuccess,marketing:fr.categoryMarketing,social:fr.categorySocial},bT=class e extends g{static{s(this,"ThirdPartyFacades")}static get meta(){return{id:"third-party-facades",title:ha(fr.title),failureTitle:ha(fr.failureTitle),description:ha(fr.description),supportedModes:["navigation"],guidanceLevel:3,requiredArtifacts:["traces","devtoolsLogs","URL","GatherContext"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS}}static condenseItems(t){t.sort((o,i)=>i.transferSize-o.transferSize);let n=t.findIndex(o=>o.transferSize<1e3)||1;if((n===-1||n>5)&&(n=5),n>=t.length-1)return;let a=t.splice(n).reduce((o,i)=>(o.transferSize+=i.transferSize,o.blockingTime+=i.blockingTime,o));a.transferSize<1e3||(a.url=ha(x.otherResourcesLabel),t.push(a))}static getProductsWithFacade(t,n){let r=new Map;for(let a of t.keys()){let o=n.entityByUrl.get(a);if(!o||n.isFirstParty(a))continue;let i=$a.getProduct(a);!i||!i.facades||!i.facades.length||r.has(i.name)||r.set(i.name,{product:i,entity:o})}return Array.from(r.values())}static async audit(t,n){let r=n.settings,a=t.devtoolsLogs[g.DEFAULT_PASS],o=await H.request(a,n),i=await ln.request({URL:t.URL,devtoolsLog:a},n),c=g.makeMetricComputationDataInput(t,n),u=await Va.request(c,n),l=r.throttlingMethod==="simulate"?r.throttling.cpuSlowdownMultiplier:1,m=gT.getSummaries(o,u,l,i),p=e.getProductsWithFacade(m.byURL,i),h=0,f=[];for(let{product:v,entity:D}of p){let E=gse[v.categories[0]],S;E?S=ha(E,{productName:v.name}):S=v.name;let k=m.urls.get(D),C=m.byEntity.get(D);if(!k||!C)continue;h+=C.tbtImpact;let R=Array.from(k).map(z=>{let B=m.byURL.get(z);return{url:z,...B}});this.condenseItems(R),f.push({product:S,transferSize:C.transferSize,blockingTime:C.blockingTime,subItems:{type:"subitems",items:R},entity:D.name})}if(!f.length)return{score:1,notApplicable:!0,metricSavings:{TBT:0}};let y=[{key:"product",valueType:"text",subItemsHeading:{key:"url",valueType:"url"},label:ha(fr.columnProduct)},{key:"transferSize",valueType:"bytes",subItemsHeading:{key:"transferSize"},granularity:1,label:ha(x.columnTransferSize)},{key:"blockingTime",valueType:"ms",subItemsHeading:{key:"blockingTime"},granularity:1,label:ha(x.columnBlockingTime)}];return{score:0,displayValue:ha(fr.displayValue,{itemCount:f.length}),details:g.makeTableDetails(y,f),metricSavings:{TBT:h}}}},yse=bT});var uU={};T(uU,{UIStrings:()=>rc,default:()=>bse});var rc,nc,vT,bse,lU=b(()=>{"use strict";d();V();Zf();Bt();xu();A();rc={title:"Timing budget",description:"Set a timing budget to help you keep an eye on the performance of your site. Performant sites load fast and respond to user input events quickly. [Learn more about performance budgets](https://developers.google.com/web/tools/lighthouse/audits/budgets).",columnTimingMetric:"Metric",columnMeasurement:"Measurement"},nc=w("core/audits/timing-budget.js",rc),vT=class extends g{static{s(this,"TimingBudget")}static get meta(){return{id:"timing-budget",title:nc(rc.title),description:nc(rc.description),scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","traces","URL","GatherContext"]}}static getRowLabel(t){let n={"first-contentful-paint":x.firstContentfulPaintMetric,interactive:x.interactiveMetric,"first-meaningful-paint":x.firstMeaningfulPaintMetric,"max-potential-fid":x.maxPotentialFIDMetric,"total-blocking-time":x.totalBlockingTimeMetric,"speed-index":x.speedIndexMetric,"largest-contentful-paint":x.largestContentfulPaintMetric,"cumulative-layout-shift":x.cumulativeLayoutShiftMetric};return nc(n[t])}static getMeasurement(t,n){return{"first-contentful-paint":n.firstContentfulPaint,interactive:n.interactive,"first-meaningful-paint":n.firstMeaningfulPaint,"max-potential-fid":n.maxPotentialFID,"total-blocking-time":n.totalBlockingTime,"speed-index":n.speedIndex,"largest-contentful-paint":n.largestContentfulPaint,"cumulative-layout-shift":n.cumulativeLayoutShift}[t]}static tableItems(t,n){let r=[];if(!t.timings)return r;r=t.timings.map(o=>{let i=o.metric,c=this.getRowLabel(i),u=this.getMeasurement(i,n),l=u&&u>o.budget?u-o.budget:void 0;return{metric:i,label:c,measurement:u,overBudget:l}}).sort((o,i)=>(i.overBudget||0)-(o.overBudget||0));let a=r.find(o=>o.metric==="cumulative-layout-shift");return a&&(typeof a.measurement=="number"&&(a.measurement={type:"numeric",value:Number(a.measurement),granularity:.01}),typeof a.overBudget=="number"&&(a.overBudget={type:"numeric",value:Number(a.overBudget),granularity:.01})),r}static async audit(t,n){let r=t.GatherContext,a=t.devtoolsLogs[g.DEFAULT_PASS],o=t.traces[g.DEFAULT_PASS],i=t.URL,c=await _e.request({URL:i,devtoolsLog:a},n),u={trace:o,devtoolsLog:a,gatherContext:r,settings:n.settings,URL:i},l=(await Vs.request(u,n)).metrics,m=Tr.getMatchingBudget(n.settings.budgets,c.url);if(!m)return{score:0,notApplicable:!0};let p=[{key:"label",valueType:"text",label:nc(rc.columnTimingMetric)},{key:"measurement",valueType:"ms",label:nc(rc.columnMeasurement)},{key:"overBudget",valueType:"ms",label:nc(x.columnOverBudget)}];return{details:g.makeTableDetails(p,this.tableItems(m,l),{sortedBy:["overBudget"]}),score:1}}},bse=vT});var dU={};T(dU,{UIStrings:()=>tm,default:()=>vse});var tm,hh,wT,vse,mU=b(()=>{"use strict";d();V();A();Ze();tm={title:"Image elements have explicit `width` and `height`",failureTitle:"Image elements do not have explicit `width` and `height`",description:"Set an explicit width and height on image elements to reduce layout shifts and improve CLS. [Learn how to set image dimensions](https://web.dev/articles/optimize-cls#images_without_dimensions)"},hh=w("core/audits/unsized-images.js",tm),wT=class e extends g{static{s(this,"UnsizedImages")}static get meta(){return{id:"unsized-images",title:hh(tm.title),failureTitle:hh(tm.failureTitle),description:hh(tm.description),guidanceLevel:3,requiredArtifacts:["ImageElements"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS}}static doesHtmlAttrProvideExplicitSize(t){return!t||t.startsWith("+")?!1:parseInt(t,10)>=0}static isCssPropExplicitlySet(t){return t?!["auto","initial","unset","inherit"].includes(t):!1}static isSizedImage(t){if(t.cssEffectiveRules===void 0)return!0;let n=t.attributeWidth,r=t.attributeHeight,a=t.cssEffectiveRules.width,o=t.cssEffectiveRules.height,i=t.cssEffectiveRules.aspectRatio,c=e.doesHtmlAttrProvideExplicitSize(n),u=e.isCssPropExplicitlySet(a),l=e.doesHtmlAttrProvideExplicitSize(r),m=e.isCssPropExplicitlySet(o),p=e.isCssPropExplicitlySet(i),h=c||u,f=l||m;return h&&f||h&&p||f&&p}static isNonNetworkSvg(t){let n=Y.guessMimeType(t.src)==="image/svg+xml",r=t.src.slice(0,t.src.indexOf(":")),a=Y.isNonNetworkProtocol(r);return n&&a}static async audit(t){let n=t.ImageElements.filter(o=>!o.isCss&&!o.isInShadowDOM),r=[];for(let o of n){if(o.computedStyles.position==="fixed"||o.computedStyles.position==="absolute"||e.isNonNetworkSvg(o)||e.isSizedImage(o))continue;let c=o.node.boundingRect;c.width===0&&c.height===0||r.push({url:Y.elideDataURI(o.src),node:g.makeNodeItem(o.node)})}let a=[{key:"node",valueType:"node",label:""},{key:"url",valueType:"url",label:hh(x.columnURL)}];return{score:r.length>0?0:1,details:g.makeTableDetails(a,r),metricSavings:{CLS:0}}}},vse=wT});var DT,pU,fU=b(()=>{"use strict";d();ue();Nt();DT=class{static{s(this,"UserTimings")}static async compute_(t,n){let r=await ke.request(t,n),a=[],o={};return r.processEvents.filter(i=>i.cat.includes("blink.user_timing")?i.name!=="requestStart"&&i.name!=="navigationStart"&&i.name!=="paintNonDefaultBackgroundColor"&&i.args.frame===void 0:!1).forEach(i=>{i.ph==="R"||i.ph.toUpperCase()==="I"?a.push({name:i.name,isMark:!0,args:i.args,startTime:i.ts}):i.ph.toLowerCase()==="b"?o[i.name]=i.ts:i.ph.toLowerCase()==="e"&&a.push({name:i.name,isMark:!1,args:i.args,startTime:o[i.name],endTime:i.ts,duration:i.ts-o[i.name]})}),a.forEach(i=>{i.startTime=(i.startTime-r.timeOriginEvt.ts)/1e3,i.isMark||(i.endTime=(i.endTime-r.timeOriginEvt.ts)/1e3,i.duration=i.duration/1e3)}),a}},pU=q(DT,null)});var hU={};T(hU,{UIStrings:()=>ac,default:()=>wse});var ac,li,ET,wse,gU=b(()=>{"use strict";d();V();A();fU();ac={title:"User Timing marks and measures",description:"Consider instrumenting your app with the User Timing API to measure your app's real-world performance during key user experiences. [Learn more about User Timing marks](https://developer.chrome.com/docs/lighthouse/performance/user-timings/).",displayValue:`{itemCount, plural,
    =1 {1 user timing}
    other {# user timings}
    }`,columnType:"Type"},li=w("core/audits/user-timings.js",ac),ET=class e extends g{static{s(this,"UserTimings")}static get meta(){return{id:"user-timings",title:li(ac.title),description:li(ac.description),scoreDisplayMode:g.SCORING_MODES.INFORMATIVE,guidanceLevel:2,requiredArtifacts:["traces"]}}static get excludedPrefixes(){return["goog_"]}static excludeEvent(t){return e.excludedPrefixes.every(n=>!t.name.startsWith(n))}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],o=(await pU.request(r,n)).filter(e.excludeEvent),i=o.map(m=>({name:m.name,startTime:m.startTime,duration:m.isMark?void 0:m.duration,timingType:m.isMark?"Mark":"Measure"})).sort((m,p)=>m.timingType===p.timingType?m.startTime-p.startTime:m.timingType==="Measure"?-1:1),c=[{key:"name",valueType:"text",label:li(x.columnName)},{key:"timingType",valueType:"text",label:li(ac.columnType)},{key:"startTime",valueType:"ms",granularity:.01,label:li(x.columnStartTime)},{key:"duration",valueType:"ms",granularity:.01,label:li(x.columnDuration)}],u=g.makeTableDetails(c,i),l;return o.length&&(l=li(ac.displayValue,{itemCount:o.length})),{score:+(o.length===0),notApplicable:o.length===0,displayValue:l,details:u}}},wse=ET});var yU={};T(yU,{UIStrings:()=>di,default:()=>xse});var Dse,Ese,di,so,xT,xse,bU=b(()=>{"use strict";d();V();Ze();A();de();Bt();Gn();sr();Nn();Ko();cr();Dse=15e3,Ese=50,di={title:"Preconnect to required origins",description:"Consider adding `preconnect` or `dns-prefetch` resource hints to establish early connections to important third-party origins. [Learn how to preconnect to required origins](https://developer.chrome.com/docs/lighthouse/performance/uses-rel-preconnect/).",unusedWarning:'A `<link rel=preconnect>` was found for "{securityOrigin}" but was not used by the browser. Only use `preconnect` for important origins that the page will certainly request.',crossoriginWarning:'A `<link rel=preconnect>` was found for "{securityOrigin}" but was not used by the browser. Check that you are using the `crossorigin` attribute properly.',tooManyPreconnectLinksWarning:"More than 2 `<link rel=preconnect>` connections were found. These should be used sparingly and only to the most important origins."},so=w("core/audits/uses-rel-preconnect.js",di),xT=class e extends g{static{s(this,"UsesRelPreconnectAudit")}static get meta(){return{id:"uses-rel-preconnect",title:so(di.title),description:so(di.description),supportedModes:["navigation"],guidanceLevel:3,requiredArtifacts:["traces","devtoolsLogs","URL","LinkElements"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS}}static hasValidTiming(t){return!!t.timing&&t.timing.connectEnd>=0&&t.timing.connectStart>=0}static hasAlreadyConnectedToOrigin(t){return t.timing?t.timing.dnsStart===-1&&t.timing.dnsEnd===-1&&t.timing.connectStart===-1&&t.timing.connectEnd===-1||t.timing.dnsEnd-t.timing.dnsStart===0&&t.timing.connectEnd-t.timing.connectStart===0:!1}static socketStartTimeIsBelowThreshold(t,n){return Math.max(0,t.networkRequestTime-n.networkEndTime)<Dse}static async audit(t,n){let r=t.traces[e.DEFAULT_PASS],a=t.devtoolsLogs[e.DEFAULT_PASS],o=n.settings,i=0,c=0,u=[],[l,m,p,h,f]=await Promise.all([H.request(a,n),_e.request({devtoolsLog:a,URL:t.URL},n),Pt.request({devtoolsLog:a,settings:o},n),zt.request(r,n),xt.request({trace:r,devtoolsLog:a,URL:t.URL},n)]),{rtt:y,additionalRttByOrigin:v}=p.getOptions(),D=await $n.getPessimisticGraph(f,h),E=new Set;D.traverse(K=>{K.type==="network"&&E.add(K.record.url)});let S=await Tt.getPessimisticGraph(f,h),k=new Set;S.traverse(K=>{K.type==="network"&&k.add(K.record.url)});let C=new Map;l.forEach(K=>{if(!e.hasValidTiming(K)||K.initiator.url===m.url||!K.parsedURL||!K.parsedURL.securityOrigin||m.parsedURL.securityOrigin===K.parsedURL.securityOrigin||!E.has(K.url)||e.hasAlreadyConnectedToOrigin(K)||!e.socketStartTimeIsBelowThreshold(K,m))return;let oe=K.parsedURL.securityOrigin,Re=C.get(oe)||[];Re.push(K),C.set(oe,Re)});let R=t.LinkElements.filter(K=>K.rel==="preconnect"),z=new Set(R.map(K=>Y.getOrigin(K.href||""))),B=[];C.forEach(K=>{let oe=K.reduce((ut,Qe)=>Qe.networkRequestTime<ut.networkRequestTime?Qe:ut);if(!oe.timing)return;let Re=oe.parsedURL.securityOrigin,ce=v.get(Re)||0,gt=y+ce;oe.parsedURL.scheme==="https"&&(gt=gt*2);let pe=oe.networkRequestTime-m.networkEndTime+oe.timing.dnsStart,Te=Math.min(gt,pe);if(!(Te<Ese)){if(z.has(Re)){u.push(so(di.crossoriginWarning,{securityOrigin:Re}));return}i=Math.max(Te,i),k.has(oe.url)&&(c=Math.max(Te,i)),B.push({url:Re,wastedMs:Te})}}),B=B.sort((K,oe)=>oe.wastedMs-K.wastedMs);for(let K of z)K&&(l.some(oe=>K===oe.parsedURL.securityOrigin)||u.push(so(di.unusedWarning,{securityOrigin:K})));if(R.length>=2)return{score:1,warnings:R.length>=3?[...u,so(di.tooManyPreconnectLinksWarning)]:u,metricSavings:{LCP:i,FCP:c}};let J=[{key:"url",valueType:"url",label:so(x.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:so(x.columnWastedMs)}],ne=g.makeOpportunityDetails(J,B,{overallSavingsMs:i,sortedBy:["wastedMs"]});return{score:B.length?0:1,numericValue:i,numericUnit:"millisecond",displayValue:i?so(x.displayValueMsSavings,{wastedMs:i}):"",warnings:u,details:ne,metricSavings:{LCP:i,FCP:c}}}},xse=xT});var vU={};T(vU,{UIStrings:()=>nm,default:()=>Sse});var nm,oc,Tse,TT,Sse,wU=b(()=>{"use strict";d();Ze();lt();V();bD();A();Bt();Nn();Gn();nm={title:"Preload key requests",description:"Consider using `<link rel=preload>` to prioritize fetching resources that are currently requested later in page load. [Learn how to preload key requests](https://developer.chrome.com/docs/lighthouse/performance/uses-rel-preload/).",crossoriginWarning:'A preload `<link>` was found for "{preloadURL}" but was not used by the browser. Check that you are using the `crossorigin` attribute properly.'},oc=w("core/audits/uses-rel-preload.js",nm),Tse=100,TT=class e extends g{static{s(this,"UsesRelPreloadAudit")}static get meta(){return{id:"uses-rel-preload",title:oc(nm.title),description:oc(nm.description),supportedModes:["navigation"],guidanceLevel:3,requiredArtifacts:["devtoolsLogs","traces","URL"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS}}static getURLsToPreload(t,n){let r=new Set;return n.traverse((a,o)=>{if(a.type!=="network")return;let i=o.slice(1).filter(c=>c.type==="network");e.shouldPreloadRequest(a.record,t,i)&&r.add(a.record.url)}),r}static getURLsFailedToPreload(t){let n=[];t.traverse(i=>i.type==="network"&&n.push(i.record));let r=n.filter(i=>i.isLinkPreload),a=new Map;for(let i of r){let c=a.get(i.frameId)||new Set;c.add(i.url),a.set(i.frameId,c)}let o=n.filter(i=>{let c=a.get(i.frameId);return!c||!c.has(i.url)?!1:!(i.fromDiskCache||i.fromMemoryCache||i.fromPrefetchCache)&&!i.isLinkPreload});return new Set(o.map(i=>i.url))}static shouldPreloadRequest(t,n,r){let a=n.redirects?n.redirects.length:0;return t.isLinkPreload||!Sf.isCritical(t,n)||G.isNonNetworkRequest(t)||r.length!==a+2||t.frameId!==n.frameId?!1:Y.rootDomainsMatch(t.url,n.url)}static computeWasteWithGraph(t,n,r){if(!t.size)return{wastedMs:0,results:[]};let a=r.simulate(n,{flexibleOrdering:!0}),o=n.cloneWithRelationships(),i=[],c=null;if(o.traverse(p=>{p.type==="network"&&(p.isMainDocument()?c=p:p.record&&t.has(p.record.url)&&i.push(p))}),!c)throw new Error("Could not find main document node");for(let p of i)p.removeAllDependencies(),p.addDependency(c);let u=r.simulate(o,{flexibleOrdering:!0}),l=Array.from(a.nodeTimings.keys()).reduce((p,h)=>p.set(h.record,h),new Map),m=[];for(let p of i){let h=l.get(p.record),f=u.nodeTimings.get(p),y=a.nodeTimings.get(h);if(!y||!f)throw new Error("Missing preload node");let v=Math.round(y.endTime-f.endTime);v<Tse||m.push({url:p.record.url,wastedMs:v})}return m.length?{wastedMs:Math.max(...m.map(p=>p.wastedMs)),results:m}:{wastedMs:0,results:m}}static async audit_(t,n){let r=t.traces[e.DEFAULT_PASS],a=t.devtoolsLogs[e.DEFAULT_PASS],o=t.URL,i={devtoolsLog:a,settings:n.settings},[c,u,l]=await Promise.all([_e.request({devtoolsLog:a,URL:o},n),xt.request({trace:r,devtoolsLog:a,URL:o},n),Pt.request(i,n)]),m=e.getURLsToPreload(c,u),{results:p,wastedMs:h}=e.computeWasteWithGraph(m,u,l);p.sort((E,S)=>S.wastedMs-E.wastedMs);let f,y=e.getURLsFailedToPreload(u);y.size&&(f=Array.from(y).map(E=>oc(nm.crossoriginWarning,{preloadURL:E})));let v=[{key:"url",valueType:"url",label:oc(x.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:oc(x.columnWastedMs)}],D=g.makeOpportunityDetails(v,p,{overallSavingsMs:h,sortedBy:["wastedMs"]});return{score:p.length?0:1,numericValue:h,numericUnit:"millisecond",displayValue:h?oc(x.displayValueMsSavings,{wastedMs:h}):"",details:D,warnings:f}}static async audit(){return{score:1,notApplicable:!0,details:g.makeOpportunityDetails([],[],{overallSavingsMs:0})}}},Sse=TT});var DU={};T(DU,{UIStrings:()=>co,default:()=>Cse});var co,mi,kse,ST,Cse,EU=b(()=>{"use strict";d();V();ua();A();Fn();Ze();co={title:"Page has valid source maps",failureTitle:"Missing source maps for large first-party JavaScript",description:"Source maps translate minified code to the original source code. This helps developers debug in production. In addition, Lighthouse is able to provide further insights. Consider deploying source maps to take advantage of these benefits. [Learn more about source maps](https://developer.chrome.com/docs/devtools/javascript/source-maps/).",columnMapURL:"Map URL",missingSourceMapErrorMessage:"Large JavaScript file is missing a source map",missingSourceMapItemsWarningMesssage:"{missingItems, plural,\n    =1 {Warning: missing 1 item in `.sourcesContent`}\n    other {Warning: missing # items in `.sourcesContent`}\n    }"},mi=w("core/audits/valid-source-maps.js",co),kse=500*1024,ST=class extends g{static{s(this,"ValidSourceMaps")}static get meta(){return{id:"valid-source-maps",title:mi(co.title),failureTitle:mi(co.failureTitle),description:mi(co.description),requiredArtifacts:["Scripts","SourceMaps","URL","devtoolsLogs"]}}static isLargeFirstPartyJS(t,n){let r=t.url;if(!t.length||!r||!Y.isValid(r)||!Me.createOrReturnURL(r).protocol.startsWith("http"))return!1;let a=t.length>=kse;return n.isFirstParty(r)&&a}static async audit(t,n){let{SourceMaps:r}=t,a=t.devtoolsLogs[g.DEFAULT_PASS],o=await ln.request({URL:t.URL,devtoolsLog:a},n),i=new Set,c=!1,u=[];for(let m of t.Scripts){let p=r.find(y=>y.scriptId===m.scriptId),h=[];if(this.isLargeFirstPartyJS(m,o)&&(!p||!p.map)&&(c=!0,i.add(m.url),h.push({error:mi(co.missingSourceMapErrorMessage)})),p&&!p.map&&h.push({error:p.errorMessage}),p?.map){let y=p.map.sourcesContent||[],v=0;for(let D=0;D<p.map.sources.length;D++)(y.length<D||!y[D])&&(v+=1);v>0&&h.push({error:mi(co.missingSourceMapItemsWarningMesssage,{missingItems:v})})}(p||h.length)&&u.push({scriptUrl:m.url,sourceMapUrl:p?.sourceMapUrl,subItems:{type:"subitems",items:h}})}let l=[{key:"scriptUrl",valueType:"url",subItemsHeading:{key:"error"},label:mi(x.columnURL)},{key:"sourceMapUrl",valueType:"url",label:mi(co.columnMapURL)}];return u.sort((m,p)=>{let h=i.has(m.scriptUrl),f=i.has(p.scriptUrl);return h&&!f?-1:!h&&f?1:m.subItems.items.length&&!p.subItems.items.length?-1:!m.subItems.items.length&&p.subItems.items.length?1:p.scriptUrl.localeCompare(m.scriptUrl)}),{score:c?0:1,details:g.makeTableDetails(l,u)}}},Cse=ST});var xU={};T(xU,{UIStrings:()=>ic,default:()=>Ase});var ic,gh,kT,Ase,TU=b(()=>{"use strict";d();V();ch();A();ic={title:'Has a `<meta name="viewport">` tag with `width` or `initial-scale`',failureTitle:'Does not have a `<meta name="viewport">` tag with `width` or `initial-scale`',description:'A `<meta name="viewport">` not only optimizes your app for mobile screen sizes, but also prevents [a 300 millisecond delay to user input](https://developer.chrome.com/blog/300ms-tap-delay-gone-away/). [Learn more about using the viewport meta tag](https://developer.chrome.com/docs/lighthouse/pwa/viewport/).',explanationNoTag:'No `<meta name="viewport">` tag found'},gh=w("core/audits/viewport.js",ic),kT=class extends g{static{s(this,"Viewport")}static get meta(){return{id:"viewport",title:gh(ic.title),failureTitle:gh(ic.failureTitle),description:gh(ic.description),guidanceLevel:3,requiredArtifacts:["MetaElements"],scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS}}static async audit(t,n){let r=await Ys.request(t.MetaElements,n),a=300;return r.hasViewportTag?(r.isMobileOptimized&&(a=0),{score:Number(r.isMobileOptimized),metricSavings:{INP:a},warnings:r.parserWarnings}):{score:0,explanation:gh(ic.explanationNoTag),metricSavings:{INP:a}}}},Ase=kT});var SU={};T(SU,{UIStrings:()=>uo,default:()=>Rse});var _se,uo,sc,CT,Rse,kU=b(()=>{"use strict";d();V();Qp();Nt();A();de();bw();ed();vr();nd();mx();It();_se=1,uo={title:"Minimizes work during key interaction",failureTitle:"Minimize work during key interaction",description:"This is the thread-blocking work occurring during the Interaction to Next Paint measurement. [Learn more about the Interaction to Next Paint metric](https://web.dev/articles/inp).",inputDelay:"Input delay",processingTime:"Processing time",presentationDelay:"Presentation delay",displayValue:"{timeInMs, number, milliseconds} ms spent on event '{interactionType}'",eventTarget:"Event target"},sc=w("core/audits/work-during-interaction.js",uo),CT=class e extends g{static{s(this,"WorkDuringInteraction")}static get meta(){return{id:"work-during-interaction",title:sc(uo.title),failureTitle:sc(uo.failureTitle),description:sc(uo.description),scoreDisplayMode:g.SCORING_MODES.METRIC_SAVINGS,supportedModes:["timespan"],guidanceLevel:1,requiredArtifacts:["traces","devtoolsLogs","TraceElements"]}}static recursivelyClipTasks(t,n,r,a){let o=t.event.ts,i=t.endEvent?.ts??t.event.ts+Number(t.event.dur||0);t.startTime=Math.max(r,Math.min(a,o))/1e3,t.endTime=Math.max(r,Math.min(a,i))/1e3,t.duration=t.endTime-t.startTime;let c=t.children.map(u=>e.recursivelyClipTasks(u,t,r,a)).reduce((u,l)=>u+l,0);return t.selfTime=t.duration-c,t.duration}static clipTasksByTs(t,n,r){for(let a of t)a.parent||e.recursivelyClipTasks(a,void 0,n,r)}static getPhaseTimes(t){let n=t.args.data,r=t.ts,a=r-n.timeStamp*1e3,o=a+n.processingStart*1e3,i=a+n.processingEnd*1e3,c=r+n.duration*1e3;return{inputDelay:{startTs:r,endTs:o},processingTime:{startTs:o,endTs:i},presentationDelay:{startTs:i,endTs:c}}}static getThreadBreakdownTable(t,n,r,a){let o=qt.filteredTraceSort(n.traceEvents,h=>h.pid===t.pid&&h.tid===t.tid),i=o.reduce((h,f)=>Math.max(f.ts+(f.dur||0),h),0),{frames:c}=r,u=ms.getMainThreadTasks(o,c,i),l=e.getPhaseTimes(t),m=[];for(let[h,f]of Object.entries(l)){e.clipTasksByTs(u,f.startTs,f.endTs);let y=ef(u,a),v=[];for(let[E,S]of y){let k=Object.values(S).reduce((B,J)=>B+J),C=S[vn.scriptEvaluation.id]||0,R=S[vn.styleLayout.id]||0,z=S[vn.paintCompositeRender.id]||0;v.push({url:E,total:k,scripting:C,layout:R,render:z})}let D=v.filter(E=>E.total>_se).sort((E,S)=>S.total-E.total);m.push({phase:sc(uo[h]),total:(f.endTs-f.startTs)/1e3,subItems:{type:"subitems",items:D}})}let p=[{key:"phase",valueType:"text",subItemsHeading:{key:"url",valueType:"url"},label:"Phase"},{key:"total",valueType:"ms",subItemsHeading:{key:"total",granularity:1,valueType:"ms"},granularity:1,label:"Total time"},{key:null,valueType:"ms",subItemsHeading:{key:"scripting",granularity:1,valueType:"ms"},label:"Script evaluation"},{key:null,valueType:"ms",subItemsHeading:{key:"layout",granularity:1,valueType:"ms"},label:vn.styleLayout.label},{key:null,valueType:"ms",subItemsHeading:{key:"render",granularity:1,valueType:"ms"},label:vn.paintCompositeRender.label}];return{table:g.makeTableDetails(p,m,{sortedBy:["total"]}),phases:l}}static getTraceElementTable(t){let n=t.find(o=>o.traceEventType==="responsiveness");if(!n)return;let r=[{key:"node",valueType:"node",label:sc(uo.eventTarget)}],a=[{node:g.makeNodeItem(n.node)}];return g.makeTableDetails(r,a)}static async audit(t,n){let{settings:r}=n;if(r.throttlingMethod==="simulate")return{score:null,notApplicable:!0,metricSavings:{INP:0}};let a=t.traces[e.DEFAULT_PASS],o={trace:a,settings:r},i=await ds.request(o,n);if(i===null)return{score:null,notApplicable:!0,metricSavings:{INP:0}};if(i.name==="FallbackTiming")throw new j(j.errors.UNSUPPORTED_OLD_CHROME,{featureName:"detailed EventTiming trace events"});let c=[],u=e.getTraceElementTable(t.TraceElements);u&&c.push(u);let l=t.devtoolsLogs[e.DEFAULT_PASS],m=await H.request(l,n),p=await ke.request(a,n),{table:h,phases:f}=e.getThreadBreakdownTable(i,a,p,m);c.push(h);let y=i.args.data.type;c.push({type:"debugdata",interactionType:y,phases:f});let v=i.args.data.duration,D=sc(uo.displayValue,{timeInMs:v,interactionType:y}),E=v<dx.defaultOptions.p10;return{score:E?1:0,scoreDisplayMode:E?g.SCORING_MODES.INFORMATIVE:void 0,displayValue:D,details:{type:"list",items:c},metricSavings:{INP:v}}}},Rse=CT});var St,lo,pn,ae,cc,CU,yh,ft=b(()=>{d();A();St={GROUPS__METRICS:"Metrics",GROUPS__ADS_PERFORMANCE:"Ad Speed",GROUPS__ADS_BEST_PRACTICES:"Tag Best Practices",NOT_APPLICABLE__DEFAULT:"Audit not applicable",NOT_APPLICABLE__INVALID_TIMING:"Invalid timing task data",NOT_APPLICABLE__NO_AD_RELATED_REQ:"No ad-related requests",NOT_APPLICABLE__NO_AD_RENDERED:"No ads rendered",NOT_APPLICABLE__NO_ADS_VIEWPORT:"No ads in viewport",NOT_APPLICABLE__NO_ADS:"No ads requested",NOT_APPLICABLE__NO_BIDS:"No bids detected",NOT_APPLICABLE__NO_EVENT_MATCHING_REQ:"No event matches network records",NOT_APPLICABLE__NO_GPT:"GPT not requested",NOT_APPLICABLE__NO_RECORDS:"No successful network records",NOT_APPLICABLE__NO_VISIBLE_SLOTS:"No visible slots",NOT_APPLICABLE__NO_TAG:"No tag requested",NOT_APPLICABLE__NO_TAGS:"No tags requested",NOT_APPLICABLE__NO_TASKS:"No tasks to compare",NOT_APPLICABLE__NO_VALID_AD_WIDTHS:"No requested ads contain ads of valid width",NOT_APPLICABLE__NO_LAYOUT_SHIFTS:"No layout shift events found",ERRORS__AREA_LARGER_THAN_VIEWPORT:"Calculated ad area is larger than viewport",ERRORS__VIEWPORT_AREA_ZERO:"Viewport area is zero",WARNINGS__NO_ADS:"No ads were requested when fetching this page.",WARNINGS__NO_AD_RENDERED:"No ads were rendered when rendering this page.",WARNINGS__NO_TAG:"The GPT tag was not requested."},lo=w("node_modules/lighthouse-plugin-publisher-ads/messages/common-strings.js",St),pn=s(e=>({notApplicable:!0,score:1,displayValue:lo(e)}),"notApplicableObj"),ae={Default:pn(St.NOT_APPLICABLE__DEFAULT),InvalidTiming:pn(St.NOT_APPLICABLE__INVALID_TIMING),NoAdRelatedReq:pn(St.NOT_APPLICABLE__NO_AD_RELATED_REQ),NoAdRendered:pn(St.NOT_APPLICABLE__NO_AD_RENDERED),NoAdsViewport:pn(St.NOT_APPLICABLE__NO_ADS_VIEWPORT),NoAds:pn(St.NOT_APPLICABLE__NO_ADS),NoBids:pn(St.NOT_APPLICABLE__NO_BIDS),NoEventMatchingReq:pn(St.NOT_APPLICABLE__NO_EVENT_MATCHING_REQ),NoGpt:pn(St.NOT_APPLICABLE__NO_GPT),NoLayoutShifts:pn(St.NOT_APPLICABLE__NO_LAYOUT_SHIFTS),NoRecords:pn(St.NOT_APPLICABLE__NO_RECORDS),NoVisibleSlots:pn(St.NOT_APPLICABLE__NO_VISIBLE_SLOTS),NoTag:pn(St.NOT_APPLICABLE__NO_TAG),NoTags:pn(St.NOT_APPLICABLE__NO_TAGS),NoTasks:pn(St.NOT_APPLICABLE__NO_TASKS),NoValidAdWidths:pn(St.NOT_APPLICABLE__NO_VALID_AD_WIDTHS)},cc={NoAds:lo(St.WARNINGS__NO_ADS),NoAdRendered:lo(St.WARNINGS__NO_AD_RENDERED),NoTag:lo(St.WARNINGS__NO_TAG)},CU={ViewportAreaZero:lo(St.ERRORS__VIEWPORT_AREA_ZERO)},yh={Metrics:lo(St.GROUPS__METRICS),AdsPerformance:lo(St.GROUPS__ADS_PERFORMANCE),AdsBestPractices:lo(St.GROUPS__ADS_BEST_PRACTICES)}});var AU={};T(AU,{UIStrings:()=>AT,default:()=>Ise});var kt,AT,Fse,Ise,_U=b(()=>{d();A();ft();kt="lighthouse-plugin-publisher-ads",AT={categoryDescription:"A Lighthouse plugin to improve ad speed and overall quality that is targeted at sites using GPT or AdSense tag. [Learn more](https://developers.google.com/publisher-ads-audits/reference)"},Fse=w("node_modules/lighthouse-plugin-publisher-ads/plugin.js",AT),Ise={audits:[{path:`${kt}/audits/ad-blocking-tasks`},{path:`${kt}/audits/ad-render-blocking-resources`},{path:`${kt}/audits/ad-request-critical-path`},{path:`${kt}/audits/bid-request-from-page-start`},{path:`${kt}/audits/ad-request-from-page-start`},{path:`${kt}/audits/ad-top-of-viewport`},{path:`${kt}/audits/ads-in-viewport`},{path:`${kt}/audits/async-ad-tags`},{path:`${kt}/audits/blocking-load-events`},{path:`${kt}/audits/bottleneck-requests`},{path:`${kt}/audits/duplicate-tags`},{path:`${kt}/audits/first-ad-render`},{path:`${kt}/audits/full-width-slots`},{path:`${kt}/audits/gpt-bids-parallel`},{path:`${kt}/audits/loads-gpt-from-official-source`},{path:`${kt}/audits/loads-ad-tag-over-https`},{path:`${kt}/audits/script-injected-tags`},{path:`${kt}/audits/serial-header-bidding`},{path:`${kt}/audits/tag-load-time`},{path:`${kt}/audits/viewport-ad-density`},{path:`${kt}/audits/cumulative-ad-shift`},{path:`${kt}/audits/deprecated-api-usage`},{path:`${kt}/audits/gpt-errors-overall`},{path:`${kt}/audits/total-ad-blocking-time`}],groups:{metrics:{title:yh.Metrics},"ads-performance":{title:yh.AdsPerformance},"ads-best-practices":{title:yh.AdsBestPractices}},category:{title:"Publisher Ads",description:Fse(AT.categoryDescription),auditRefs:[{id:"tag-load-time",weight:5,group:"metrics"},{id:"bid-request-from-page-start",weight:5,group:"metrics"},{id:"ad-request-from-page-start",weight:25,group:"metrics"},{id:"first-ad-render",weight:10,group:"metrics"},{id:"cumulative-ad-shift",weight:5,group:"metrics"},{id:"total-ad-blocking-time",weight:2,group:"metrics"},{id:"gpt-bids-parallel",weight:1,group:"ads-performance"},{id:"serial-header-bidding",weight:1,group:"ads-performance"},{id:"bottleneck-requests",weight:1,group:"ads-performance"},{id:"script-injected-tags",weight:1,group:"ads-performance"},{id:"blocking-load-events",weight:1,group:"ads-performance"},{id:"ad-render-blocking-resources",weight:1,group:"ads-performance"},{id:"ad-blocking-tasks",weight:1,group:"ads-performance"},{id:"ad-request-critical-path",weight:0,group:"ads-performance"},{id:"ads-in-viewport",weight:4,group:"ads-best-practices"},{id:"async-ad-tags",weight:2,group:"ads-best-practices"},{id:"loads-ad-tag-over-https",weight:1,group:"ads-best-practices"},{id:"loads-gpt-from-official-source",weight:4,group:"ads-best-practices"},{id:"viewport-ad-density",weight:2,group:"ads-best-practices"},{id:"ad-top-of-viewport",weight:2,group:"ads-best-practices"},{id:"duplicate-tags",weight:1,group:"ads-best-practices"},{id:"deprecated-gpt-api-usage",weight:0,group:"ads-best-practices"},{id:"gpt-errors-overall",weight:0,group:"ads-best-practices"}]}}});var RU,FU=b(()=>{d();RU=[{label:"Prebid JS",patterns:["^https?://([^.]*.)?prebid[.]org/.*","^https?://acdn[.]adnxs[.]com/prebid/.*"]},{label:"33Across",patterns:["^https?://ssc[.]33across.com/api/.*"]},{label:"AppNexus",patterns:["^https?://ib[.]adnxs[.]com/.*"]},{label:"Amazon Ads",patterns:["^https?://[a-z-_.]*[.]amazon-adsystem[.]com/.*bid.*"]},{label:"AdTechus (AOL)",patterns:["^https?://([^.]*.)?adserver[.]adtechus[.]com/.*"]},{label:"Aardvark",patterns:["^https?://thor[.]rtk[.]io/.*"]},{label:"AdBlade",patterns:["^https?://rtb[.]adblade[.]com/prebidjs/bid.*"]},{label:"AdBund",patterns:["^https?://us-east-engine[.]adbund[.]xyz/prebid/ad/get.*","^https?://us-west-engine[.]adbund[.]xyz/prebid/ad/get.*"]},{label:"AdButler",patterns:["^https?://servedbyadbutler[.]com/adserve.*"]},{label:"Adequant",patterns:["^https?://rex[.]adequant[.]com/rex/c2s_prebid.*"]},{label:"AdForm",patterns:["^https?://adx[.]adform[.]net/adx.*"]},{label:"AdMedia",patterns:["^https?://b[.]admedia[.]com/banner/prebid/bidder.*"]},{label:"AdMixer",patterns:["^https?://inv-nets[.]admixer[.]net/prebid[.]aspx.*","^https?://inv-nets[.]admixer[.]net/videoprebid[.]aspx.*"]},{label:"AOL",patterns:["^https?://adserver-us[.]adtech[.]advertising[.]com.*","^https?://adserver-eu[.]adtech[.]advertising[.]com.*","^https?://adserver-as[.]adtech[.]advertising[.]com.*","^https?://adserver[.]adtech[.]de/pubapi/.*"]},{label:"Beachfront",patterns:["^https?://reachms[.]bfmio[.]com/bid[.]json?exchange_id=.*"]},{label:"Bidfluence",patterns:["^https?://cdn[.]bidfluence[.]com/forge[.]js.*"]},{label:"Brightcom",patterns:["^https?://hb[.]iselephant[.]com/auc/ortb.*"]},{label:"C1x",patterns:["^https?://ht-integration[.]c1exchange[.]com:9000/ht.*"]},{label:"CentroBid",patterns:["^https?://t[.]brand-server[.]com/hb.*"]},{label:"Conversant",patterns:["^https?://media[.]msg[.]dotomi[.]com/s2s/.*"]},{label:"Criteo",patterns:["^https?://static[.]criteo[.]net/js/ld/publishertag[.]js.*","^https?://([^.]*.)?bidder[.]criteo[.]com/cdb.*","^https?://([^.]*.)?rtax[.]criteo[.]com/delivery/rta.*","^https?://([^.]*.)?rtax[.]eu[.]criteo[.]com/delivery/rta.*"]},{label:"Datablocks",patterns:["^https?://[a-z0-9_.-]*[.]dblks[.]net/.*"]},{label:"Districtm",patterns:["^https?://prebid[.]districtm[.]ca/lib[.]js.*"]},{label:"E-Planning",patterns:["^https?://ads[.]us[.]e-planning[.]net.*"]},{label:"Essens",patterns:["^https?://bid[.]essrtb[.]com/bid/prebid_call.*"]},{label:"Facebook",patterns:["^https?://an[.]facebook[.]com/v2/placementbid[.]json.*"]},{label:"FeatureForward",patterns:["^https?://prmbdr[.]featureforward[.]com/newbidder/.*"]},{label:"Fidelity",patterns:["^https?://x[.]fidelity-media[.]com.*"]},{label:"GetIntent",patterns:["^https?://px[.]adhigh[.]net/rtb/direct_banner.*","^https?://px[.]adhigh[.]net/rtb/direct_vast.*"]},{label:"GumGum",patterns:["^https?://g2[.]gumgum[.]com/hbid/imp.*"]},{label:"Hiromedia",patterns:["^https?://hb-rtb[.]ktdpublishers[.]com/bid/get.*"]},{label:"Imonomy",patterns:["^https?://b[.]imonomy[.]com/openrtb/hb/.*"]},{label:"ImproveDigital",patterns:["^https?://ad[.]360yield[.]com/hb.*"]},{label:"IndexExchange",patterns:["^https?://as(-sec)?[.]casalemedia[.]com/(cygnus|headertag).*","^https?://js(-sec)?[.]indexww[.]com/ht/.*"]},{label:"InnerActive",patterns:["^https?://ad-tag[.]inner-active[.]mobi/simpleM2M/requestJsonAd.*"]},{label:"Innity",patterns:["^https?://as[.]innity[.]com/synd/.*"]},{label:"JCM",patterns:["^https?://media[.]adfrontiers[.]com/pq.*"]},{label:"JustPremium",patterns:["^https?://pre[.]ads[.]justpremium[.]com/v/.*"]},{label:"Kargo",patterns:["^https?://krk[.]kargo[.]com/api/v1/bid.*"]},{label:"Komoona",patterns:["^https?://bidder[.]komoona[.]com/v1/GetSBids.*"]},{label:"KruxLink",patterns:["^https?://link[.]krxd[.]net/hb.*"]},{label:"Kumma",patterns:["^https?://cdn[.]kumma[.]com/pb_ortb[.]js.*"]},{label:"Mantis",patterns:["^https?://mantodea[.]mantisadnetwork[.]com/website/prebid.*"]},{label:"MarsMedia",patterns:["^https?://bid306[.]rtbsrv[.]com:9306/bidder.*"]},{label:"Media.net",patterns:["^https?://contextual[.]media[.]net/bidexchange.*"]},{label:"MemeGlobal",patterns:["^https?://stinger[.]memeglobal[.]com/api/v1/services/prebid.*"]},{label:"MobFox",patterns:["^https?://my[.]mobfox[.]com/request[.]php.*"]},{label:"NanoInteractive",patterns:["^https?://tmp[.]audiencemanager[.]de/hb.*"]},{label:"OpenX",patterns:["^https?://([^.]*.)?d[.]openx[.]net/w/1[.]0/arj.*","^https?://([^.]*.)?servedbyopenx[.]com/.*"]},{label:"Piximedia",patterns:["^https?://static[.]adserver[.]pm/prebid.*"]},{label:"Platformio",patterns:["^https?://piohbdisp[.]hb[.]adx1[.]com.*"]},{label:"Pollux",patterns:["^https?://adn[.]plxnt[.]com/prebid.*"]},{label:"PubGears",patterns:["^https?://c[.]pubgears[.]com/tags.*"]},{label:"Pubmatic",patterns:["^https?://ads[.]pubmatic[.]com/AdServer/js/gshowad[.]js.*","^https?://([^.]*.)?gads.pubmatic[.]com/.*","^https?://hbopenbid.pubmatic[.]com/.*"]},{label:"Pulsepoint",patterns:["^https?://bid[.]contextweb[.]com/header/tag.*"]},{label:"Quantcast",patterns:["^https?://global[.]qc[.]rtb[.]quantserve[.]com:8080/qchb.*"]},{label:"Rhythmone",patterns:["^https?://tag[.]1rx[.]io/rmp/.*"]},{label:"Roxot",patterns:["^https?://r[.]rxthdr[.]com.*"]},{label:"Rubicon",patterns:["^https?://([^.]*.)?(fastlane|optimized-by|anvil)[.]rubiconproject[.]com/a/api.*","^https?://fastlane-adv[.]rubiconproject[.]com/v1/auction/video.*"]},{label:"Sekindo",patterns:["^https?://hb[.]sekindo[.]com/live/liveView[.]php.*"]},{label:"ShareThrough",patterns:["^https?://btlr[.]sharethrough[.]com/header-bid/.*"]},{label:"Smart AdServer",patterns:["^https?://prg[.]smartadserver[.]com/prebid.*"]},{label:"Sonobi",patterns:["^https?://apex[.]go[.]sonobi[.]com/trinity[.]js.*"]},{label:"Sovrn",patterns:["^https?://ap[.]lijit[.]com/rtb/bid.*"]},{label:"SpringServe",patterns:["^https?://bidder[.]springserve[.]com/display/hbid.*"]},{label:"StickyAds",patterns:["^https?://cdn[.]stickyadstv[.]com/mustang/mustang[.]min[.]js.*","^https?://cdn[.]stickyadstv[.]com/prime-time/.*"]},{label:"TapSense3",patterns:["^https?://ads04[.]tapsense[.]com/ads/headerad.*"]},{label:"ThoughtLeadr",patterns:["^https?://a[.]thoughtleadr[.]com/v4/.*"]},{label:"TremorBid",patterns:["^https?://([^.]*.)?ads[.]tremorhub[.]com/ad/tag.*"]},{label:"Trion",patterns:["^https?://in-appadvertising[.]com/api/bidRequest.*"]},{label:"TripleLift",patterns:["^https?://tlx[.]3lift[.]com/header/auction.*"]},{label:"TrustX",patterns:["^https?://sofia[.]trustx[.]org/hb.*"]},{label:"UCFunnel",patterns:["^https?://agent[.]aralego[.]com/header.*"]},{label:"Underdog Media",patterns:["^https?://udmserve[.]net/udm/img[.]fetch.*"]},{label:"UnRuly",patterns:["^https?://targeting[.]unrulymedia[.]com/prebid.*"]},{label:"VertaMedia",patterns:["^https?://rtb[.]vertamedia[.]com/hb/.*"]},{label:"Vertoz",patterns:["^https?://hb[.]vrtzads[.]com/vzhbidder/bid.*"]},{label:"WideOrbig",patterns:["^https?://([^.]*.)?atemda[.]com/JSAdservingMP[.]ashx.*"]},{label:"WideSpace",patterns:["^https?://engine[.]widespace[.]com/map/engine/hb/.*"]},{label:"YieldBot",patterns:["^https?://cdn[.]yldbt[.]com/js/yieldbot[.]intent[.]js.*"]},{label:"YieldMo",patterns:["^https?://ads[.]yieldmo[.]com/exchange/prebid.*"]}]});var NU=I((rqe,IU)=>{d();var Nse=/([a-zA-Z][a-zA-Z_-]*)\s*(?:=(?:"([^"]*)"|([^ \t",;]*)))?/g,st={maxAge:"max-age",sharedMaxAge:"s-maxage",maxStale:"max-stale",minFresh:"min-fresh",immutable:"immutable",mustRevalidate:"must-revalidate",noCache:"no-cache",noStore:"no-store",noTransform:"no-transform",onlyIfCached:"only-if-cached",private:"private",proxyRevalidate:"proxy-revalidate",public:"public"};function qr(e){return e===null}s(qr,"parseBooleanOnly");function bh(e){if(!e)return null;let t=parseInt(e,10);return!Number.isFinite(t)||t<0?null:t}s(bh,"parseDuration");var uc=class{static{s(this,"CacheControl")}constructor(){this.maxAge=null,this.sharedMaxAge=null,this.maxStale=null,this.maxStaleDuration=null,this.minFresh=null,this.immutable=null,this.mustRevalidate=null,this.noCache=null,this.noStore=null,this.noTransform=null,this.onlyIfCached=null,this.private=null,this.proxyRevalidate=null,this.public=null}parse(t){if(!t||t.length===0)return this;let n={},r=t.match(Nse)||[];return Array.prototype.forEach.call(r,a=>{let o=a.split("=",2),[i]=o,c=null;o.length>1&&(c=o[1].trim()),n[i.toLowerCase()]=c}),this.maxAge=bh(n[st.maxAge]),this.sharedMaxAge=bh(n[st.sharedMaxAge]),this.maxStale=qr(n[st.maxStale]),this.maxStaleDuration=bh(n[st.maxStale]),this.maxStaleDuration&&(this.maxStale=!0),this.minFresh=bh(n[st.minFresh]),this.immutable=qr(n[st.immutable]),this.mustRevalidate=qr(n[st.mustRevalidate]),this.noCache=qr(n[st.noCache]),this.noStore=qr(n[st.noStore]),this.noTransform=qr(n[st.noTransform]),this.onlyIfCached=qr(n[st.onlyIfCached]),this.private=qr(n[st.private]),this.proxyRevalidate=qr(n[st.proxyRevalidate]),this.public=qr(n[st.public]),this}format(){let t=[];return typeof this.maxAge=="number"&&t.push(`${st.maxAge}=${this.maxAge}`),typeof this.sharedMaxAge=="number"&&t.push(`${st.sharedMaxAge}=${this.sharedMaxAge}`),this.maxStale&&(typeof this.maxStaleDuration=="number"?t.push(`${st.maxStale}=${this.maxStaleDuration}`):t.push(st.maxStale)),typeof this.minFresh=="number"&&t.push(`${st.minFresh}=${this.minFresh}`),this.immutable&&t.push(st.immutable),this.mustRevalidate&&t.push(st.mustRevalidate),this.noCache&&t.push(st.noCache),this.noStore&&t.push(st.noStore),this.noTransform&&t.push(st.noTransform),this.onlyIfCached&&t.push(st.onlyIfCached),this.private&&t.push(st.private),this.proxyRevalidate&&t.push(st.proxyRevalidate),this.public&&t.push(st.public),t.join(", ")}};function Mse(e){return new uc().parse(e)}s(Mse,"parse");function Lse(e){return e instanceof uc?e.format():uc.prototype.format.call(e)}s(Lse,"format");IU.exports={CacheControl:uc,parse:Mse,format:Lse}});function _T(e,t){let n=t.toLowerCase();return(e.responseHeaders||[]).find(r=>r.name.toLowerCase()===n)}function vh(e){if(!iD.isCacheableAsset(e))return!1;let t=_T(e,"cache-control");if(t){try{let n=(0,MU.parse)(t.value);if(n.noStore||n.noCache||n.maxAge===0)return!1}catch{}return!0}return!!_T(e,"expires")||!!_T(e,"last-modified")}var MU,RT=b(()=>{d();sD();MU=Lt(NU(),1);s(_T,"getHeader");s(vh,"isCacheable")});function En(e){let t;try{t=typeof e=="string"?new URL(e):e}catch{t=new URL("http://_")}return t}function pi(e){return e=En(e),/(^|\.)(doubleclick.net|google(syndication|tagservices).com)$/.test(e.hostname)}function FT(e){e=En(e);let t=e.host==="pagead2.googlesyndication.com",n=["/pagead/js/adsbygoogle.js","/pagead/show_ads.js"].includes(e.pathname);return t&&n}function Pse(e){e=En(e);let t=e.host==="pagead2.googlesyndication.com",n=/(^\/pagead\/js\/.*\/show_ads_impl.*?\.js)/.test(e.pathname);return t&&n}function wh(e){return e=En(e),FT(e)||Pse(e)}function Ose(e){if(!e)return!1;let t=new URL(e.url);return t.pathname==="/pagead/ads"&&t.host==="googleads.g.doubleclick.net"}function Bse(e){return/(^aswift_\d+)/.test(e.id)}function lc(e){let{host:t,pathname:n}=En(e);return["securepubads.g.doubleclick.net","googleads4.g.doubleclick.net"].includes(t)&&["/pcs/view","/pagead/adview"].includes(n)}function dc(e){let{host:t,pathname:n}=En(e),r=["www.googletagservices.com","pagead2.googlesyndication.com","securepubads.g.doubleclick.net"].includes(t),a=["/tag/js/gpt.js","/tag/js/gpt_mobile.js"].includes(n);return r&&a}function IT(e){let{host:t,pathname:n}=En(e),r=["cdn.ampproject.org"].includes(t),a=["/v0/amp-ad-0.1.js"].includes(n);return r&&a}function zr(e){return pi(e)&&/(^\/gpt\/pubads_impl([a-z_]*)((?<!rendering)_)\d+\.js)/.test(En(e).pathname)}function LU(e){return/^\/[a-z_]*\/\d+\/v0\/amp-ad-network-doubleclick-impl-0.1.js/.test(En(e).pathname)}function mo(e){return e=En(e),dc(e)||zr(e)}function Use(e){return IT(e)||LU(e)}function NT(e){return e?new URL(e.url).pathname==="/gampad/ads"&&e.resourceType==="XHR"&&pi(e.url):!1}function jse(e){if(!e)return!1;let t=new URL(e.url);return t.pathname==="/gampad/ads"&&t.host==="securepubads.g.doubleclick.net"&&e.resourceType==="Fetch"}function MT(e){return/(^google_ads_iframe_)/.test(e.id)}function mc(e){return FT(e)||dc(e)||IT(e)}function rm(e){return wh(e)||mo(e)||Use(e)}function Hr(e){return Ose(e)||NT(e)||jse(e)}function pc(e){return Bse(e)||MT(e)}function fc(e){return FT(e)||zr(e)||LU(e)}function PU(e,t){return t.some(n=>e.includes(n))}function po(e){for(let t of RU)for(let n of t.patterns)if(new RegExp(n).test(e))return t.label}function am(e){return!!po(typeof e=="string"?e:e.url)}function qse(e){return(e.resourceSize==null||e.resourceSize>0)&&e.resourceType!="Image"&&!vh(e)}function ga(e){return am(e)&&qse(e)}function OU(e){return["parser","preload","other"].includes(e.initiator.type)}function BU(e){let t=new URL(e),n=60,r=t.pathname.length>n?t.pathname.substr(0,n)+"...":t.pathname;return t.origin+r}function Dh(e){let t=po(e);if(t)return t;if(mo(e))return"GPT";if(wh(e))return"AdSense";if(IT(e))return"AMP tag";let n=$a.getEntity(e);if(n)return n.name;let{host:r}=new URL(e),[a=""]=r.match(/([^.]*(\.[a-z]{2,3}){1,2})$/)||[];return a||r}function fi(e){let t=typeof e=="string"?e:e.url;if(!t)return!1;if(rm(t)||po(t))return!0;let n=$a.getEntity(t);return n?n.categories.includes("ad"):!1}var ht=b(()=>{d();FU();lf();RT();s(En,"toURL");s(pi,"isGoogleAds");s(FT,"isAdSenseTag");s(Pse,"isAdSenseImplTag");s(wh,"isAdSense");s(Ose,"isAdSenseAdRequest");s(Bse,"isAdSenseIframe");s(lc,"isImpressionPing");s(dc,"isGptTag");s(IT,"isAMPTag");s(zr,"isGptImplTag");s(LU,"isAMPImplTag");s(mo,"isGpt");s(Use,"isAMP");s(NT,"isGptAdRequest");s(jse,"isAMPAdRequest");s(MT,"isGptIframe");s(mc,"isAdTag");s(rm,"isAdScript");s(Hr,"isAdRequest");s(pc,"isAdIframe");s(fc,"isImplTag");s(PU,"containsAnySubstring");s(po,"getHeaderBidder");s(am,"isBidRelatedRequest");s(qse,"isPossibleBidRequest");s(ga,"isBidRequest");s(OU,"isStaticRequest");s(BU,"trimUrl");s(Dh,"getNameOrTld");s(fi,"isAdRelated")});function UU(e){return e.args.frame||e.args.data&&e.args.data.frame||null}function zse(e){let t=new Set;for(let{args:n}of e.childEvents)n.data&&n.data.url&&t.add(n.data.url);return Array.from(t)}function Hse(e){return!!zse(e).find(t=>am(t)||pi(En(t)))}function Gse(e){return e.event.dur>50*1e3}function Eh(e,t){e===t||e.endTime>t.startTime||e.addDependent(t)}function jU(e){let t=[],n=[];e.traverse(r=>{r.type===ye.TYPES.NETWORK&&(dc(r.record.url)&&r.record.resourceType==="Script"?n.push(r):NT(r.record)&&t.push(r))}),e.traverse(r=>{if(r.type===ye.TYPES.NETWORK){if(zr(r.record.url)){let a=r;for(let o of n)Eh(o,a)}if(am(r.record)){let a=r;for(let o of t)Eh(a,o)}if(lc(r.record.url)){let a=r;for(let o of t){Eh(o,a);for(let i of o.getDependents())Eh(i,a)}}}})}var LT,en,hi=b(()=>{d();gn();vu();oa();bu();ht();s(UU,"getFrame");s(zse,"getCpuNodeUrls");s(Hse,"isAdTask");s(Gse,"isLongTask");s(Eh,"addEdge");s(jU,"addEdges");LT=class e extends Wt{static{s(this,"AdLanternMetric")}static get COEFFICIENTS(){return{intercept:0,optimistic:1,pessimistic:0}}static getPessimisticGraph(t){let n=t.cloneWithRelationships(r=>!0);return jU(n),n}static getOptimisticGraph(t){let n=t.record.frameId,r=e.getPessimisticGraph(t),a=r.cloneWithRelationships(o=>{if(o.type===ye.TYPES.CPU)return Gse(o)||Hse(o)||!!UU(o.event)&&UU(o.event)!==n;if(o.hasRenderBlockingPriority())return!0;let i=o.record.url;return am(i)||pi(En(i))});return jU(r),a}static getEstimateFromSimulation(t,n){throw new Error("getEstimateFromSimulation not implemented by "+this.name)}static findTiming(t,n){let r={startTime:1/0,endTime:-1/0,duration:0};for(let[a,o]of t.entries())n(a,o)&&r.startTime>o.startTime&&(r=o);return r}static findNetworkTiming(t,n){return this.findTiming(t,r=>r.type===ye.TYPES.NETWORK&&n(r.record))}},en=LT});function qU(e){let t=e.find(n=>fc(new URL(n.url)));return t?t.endTime:-1}function xh(e){let t=e.find(Hr);return t?t.startTime:-1}function zU(e){let t=e.find(ga);return t?t.startTime:-1}function HU(e){let t=e.find(n=>lc(n.url));return t?t.startTime:-1}function Gr(e,t=-1){let n=e.find(r=>r.statusCode==200);return n?n.startTime:t}async function hr(e,t,n){let r=new Map,a=await H.request(t,n);if(n.settings.throttlingMethod=="simulate"){let o=await xt.request({trace:e,devtoolsLog:t},n),i=en.getOptimisticGraph(o),c=await Pt.request({devtoolsLog:t,settings:n.settings},n),{nodeTimings:u}=c.simulate(i,{});for(let[{record:l},m]of u.entries())l&&r.set(l,m)}else{let o=Gr(a);for(let i of a)r.set(i,{startTime:(i.startTime-o)*1e3,endTime:(i.endTime-o)*1e3,duration:(i.endTime-i.startTime)*1e3})}return r}function Th(e){if(e.args.data&&["EvaluateScript","FunctionCall"].includes(e.name)){if(e.args.data.url)return e.args.data.url;if(e.args.data.stackTrace)return e.args.data.stackTrace[0].url}}async function GU(e,t,n){let r=await H.request(t,n),a=Gr(r)*1e3,o=new Map;for(let u of e.traceEvents){let l=Th(u);if(!l)continue;let m=u.ts/1e3-a;(!o.has(l)||o.get(l)>m)&&o.set(l,m)}if(n.settings.throttlingMethod!=="simulate")return o;let i=await hr(e,t,n),c=new Map;for(let[u,l]of i.entries()){let m=o.get(u.url);if(!m||c.has(u.url))continue;let p=u.startTime*1e3-a,h=l.endTime,f=n.settings.throttling.cpuSlowdownMultiplier,y=m-p,v=f*y;c.set(u.url,h+v)}return c}var tr=b(()=>{d();hi();Gn();de();Nn();ht();s(qU,"getTagEndTime");s(xh,"getAdStartTime");s(zU,"getBidStartTime");s(HU,"getImpressionStartTime");s(Gr,"getPageStartTime");s(hr,"getTimingsByRecord");s(Th,"getScriptUrl");s(GU,"getScriptEvaluationTimes")});var om,im,hc,Sh=b(()=>{d();hi();Ha();ue();tr();ht();om=class extends en{static{s(this,"LanternAdRequestTime")}static getEstimateFromSimulation(t,n){let{nodeTimings:r}=t;return{timeInMs:en.findNetworkTiming(r,Hr).startTime,nodeTimings:r}}};om=q(om);im=class extends cn{static{s(this,"AdRequestTime")}static async computeSimulatedMetric(t,n){return om.request(t,n)}static async computeObservedMetric(t){let{networkRecords:n}=t,r=Gr(n),o=(xh(n)-r)*1e3;return Promise.resolve({timing:o})}static async request(t,n){throw Error("Not implemented -- class not decorated")}};im=q(im);hc=im});function fo(e,t=new Set){let n=e.attributableURLs.find(c=>t.has(c)),r=e.attributableURLs[0],a=n||r;if(a)return a;let o=50,i="";for(let c of e.children){let u=fo(c,t);u&&c.duration>o&&(i=u,o=c.duration)}return i}var kh=b(()=>{d();s(fo,"getAttributableUrl")});function $se(e,t){if(e.duration<Vse)return!1;let n=fo(e,t);if(!n)return!1;if(e.parent){let r=fo(e.parent,t);return n!=r}return!0}var Vse,Wse,sm,Ch,PT=b(()=>{d();hi();gn();Ha();vu();kh();Gn();za();ue();bu();de();Nn();Vse=50,Wse=100;s($se,"isLong");sm=class extends cn{static{s(this,"LongTasks")}static async getSimulationGraph(t,n,r){let a=await xt.request({trace:t,devtoolsLog:n},r);return en.getOptimisticGraph(a)}static async computeSimulatedResult(t,n,r){let a=await this.getSimulationGraph(t,n,r),o=await Pt.request({devtoolsLog:n,settings:r.settings},r),{nodeTimings:i}=o.simulate(a,{}),c=[];for(let[u,l]of i.entries())u.type!==ye.TYPES.CPU||l.duration<Wse||c.push({event:u.event,startTime:l.startTime,endTime:l.endTime,duration:l.duration,selfTime:l.duration,attributableURLs:Array.from(u.getEvaluateScriptURLs()),children:[],parent:u.parent,unbounded:u.unbounded,group:u.group});return c}static async computeObservedResult(t,n,r){let a=await Cn.request(t,r),o=await H.request(n,r),i=new Set(o.filter(c=>c.resourceType==="Script").map(c=>c.url));return a.filter(c=>$se(c,i))}static async compute_({trace:t,devtoolsLog:n},r){return r.settings.throttlingMethod=="simulate"?this.computeSimulatedResult(t,n,r):this.computeObservedResult(t,n,r)}static async request(t,n){throw Error("Not implemented -- class not decorated")}};sm=q(sm);Ch=sm});var VU={};T(VU,{UIStrings:()=>ya,default:()=>Kse});var ya,gi,Yse,OT,Kse,WU=b(()=>{d();Sh();A();PT();ft();ct();kh();ht();ya={title:"No long tasks blocking ad-related network requests",failureTitle:"Avoid long tasks that block ad-related network requests",description:"Tasks blocking the main thread can delay ad requests and cause a poor user experience. Consider removing long blocking tasks or moving them off of the main thread. These tasks can be especially detrimental to performance on less powerful devices. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-blocking-tasks).",failureDisplayValue:"{timeInMs, number, seconds} s blocked",columnScript:"Attributable URL",columnStartTime:"Start",columnDuration:"Duration"},gi=w("node_modules/lighthouse-plugin-publisher-ads/audits/ad-blocking-tasks.js",ya),Yse=[{key:"script",itemType:"url",text:gi(ya.columnScript)},{key:"startTime",itemType:"ms",text:gi(ya.columnStartTime),granularity:1},{key:"duration",itemType:"ms",text:gi(ya.columnDuration),granularity:1}],OT=class e extends g{static{s(this,"AdBlockingTasks")}static get meta(){return{id:"ad-blocking-tasks",title:gi(ya.title),failureTitle:gi(ya.failureTitle),description:gi(ya.description),requiredArtifacts:["traces","devtoolsLogs"]}}static async audit(t,n){let r=n.settings.throttlingMethod=="simulate"?200:100,a=t.traces[g.DEFAULT_PASS],o=t.devtoolsLogs[g.DEFAULT_PASS],i={trace:a,devtoolsLog:o,settings:n.settings},c=[];try{c=await Ch.request(i,n)}catch{return ae.InvalidTiming}if(!c.length)return ae.NoTasks;let{timing:u}=await hc.request(i,n);if(!(u>0))return ae.NoAdRelatedReq;let l=[];for(let y of c){if(y.startTime>u||y.duration<r)continue;let v=fo(y);if(v&&rm(new URL(v)))continue;let D=v&&new URL(v),E=D&&D.origin+D.pathname||"Other";l.push({script:E,rawUrl:v,startTime:y.startTime,endTime:y.endTime,duration:y.duration,isTopLevel:!y.parent})}let m=Array.from(l),p=10;m.length>p&&(m=l.filter(y=>y.script!=="Other"&&y.isTopLevel).sort((y,v)=>v.duration-y.duration).splice(0,p).sort((y,v)=>y.startTime-v.startTime));let h=m.reduce((y,v)=>v.isTopLevel?y+v.duration:y,0),f=m.length>0;return{score:f?0:1,numericValue:h,numericUnit:"millisecond",displayValue:f?gi(ya.failureDisplayValue,{timeInMs:h}):"",details:e.makeTableDetails(Yse,m)}}},Kse=OT});var $U={};T($U,{UIStrings:()=>ba,default:()=>Zse});var ba,yi,Xse,Jse,BT,Zse,YU=b(()=>{d();A();de();ft();ct();tr();ht();ba={title:"Minimal render-blocking resources found",failureTitle:"Avoid render-blocking resources",description:"Render-blocking resources slow down tag load times. Consider loading critical JS/CSS inline or loading scripts asynchronously or loading the tag earlier in the head. [Learn more](https://developers.google.com/web/tools/lighthouse/audits/blocking-resources).",failureDisplayValue:"Up to {timeInMs, number, seconds} s tag load time improvement",columnUrl:"Resource",columnStartTime:"Start",columnDuration:"Duration"},yi=w("node_modules/lighthouse-plugin-publisher-ads/audits/ad-render-blocking-resources.js",ba),Xse=100,Jse=[{key:"url",itemType:"url",text:yi(ba.columnUrl)},{key:"startTime",itemType:"ms",text:yi(ba.columnStartTime),granularity:1},{key:"duration",itemType:"ms",text:yi(ba.columnDuration),granularity:1}],BT=class e extends g{static{s(this,"AdRenderBlockingResources")}static get meta(){return{id:"ad-render-blocking-resources",title:yi(ba.title),failureTitle:yi(ba.failureTitle),scoreDisplayMode:"binary",description:yi(ba.description),requiredArtifacts:["LinkElements","ScriptElements","devtoolsLogs","traces"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=t.traces[g.DEFAULT_PASS],o=await H.request(r,n),i=o.find(k=>mc(new URL(k.url)));if(!i)return ae.NoTag;let c=await hr(a,r,n),u=new Set;for(let k of t.LinkElements)k.href&&k.rel=="stylesheet"&&u.add(k.href);for(let k of t.ScriptElements)k.src&&!k.defer&&!k.async&&u.add(k.src);let m=o.filter(k=>k.endTime<i.startTime).filter(k=>k!=i.initiatorRequest).filter(k=>k.initiator.type="parser").filter(k=>u.has(k.url)).map(k=>Object.assign({url:k.url},c.get(k)));m.sort((k,C)=>k.endTime-C.endTime);let p=c.get(i)||{startTime:1/0},h=m.map(k=>k.startTime),f=m.map(k=>k.endTime),y=Math.min(...h),D=Math.min(Math.max(...f),p.startTime)-y,E="";return m.length>0&&D>0&&(E=yi(ba.failureDisplayValue,{timeInMs:D})),{score:m.length>0&&D>Xse?0:1,numericValue:m.length,numericUnit:"unitless",displayValue:E,details:{opportunity:D,...e.makeTableDetails(Jse,m)}}}},Zse=BT});function cm(e){if(e==null)throw new Error("Expected not to be null");return e}var UT=b(()=>{d();s(cm,"assert")});function Qse(e,t,n){let r=t.xhrEdges.get(e.url);if(!r)return!1;for(let{url:a}of n)if(r.has(a))return!0;return!1}function ece(e,t,n,r){let a=n.allRecords.filter(o=>o.resourceType!=null).filter(o=>["Script","XHR"].includes(o.resourceType||"")&&o.endTime<t.startTime).filter(o=>o.initiatorRequest==e||xt.getNetworkInitiators(o).includes(e.url));for(let o of a)o.resourceType=="XHR"&&Qse(o,n,r)&&um(n,o,r)}function KU(e,t,n){let r=XU(e,t),a=new Set;return um(r,n,a),a}function um(e,t,n=new Set){if(!t||n.has(t))return n;n.add(t);let r=new Set;for(let a=t.initiator.stack;a;a=a.parent)for(let{url:o}of a.callFrames){if(r.has(o))continue;r.add(o);let i=e.requestsByUrl.get(o);if(i&&(um(e,i,n),i.resourceType=="Script")){let c=a.callFrames[0].url,u=e.requestsByUrl.get(c);u&&ece(u,t,e,n)}}return um(e,t.initiatorRequest||null,n),n}function XU(e,t){let n=new Map;for(let o of e)n.set(o.url,o);let r=t.filter(o=>o.name.startsWith("XHR")).filter(o=>!!(o.args.data||{}).url),a=new Map;for(let o of r){let i=o.args.data||{},c=a.get(i.url)||new Set;for(let{url:u}of i.stackTrace||[])c.add(u);a.set(i.url,c)}return{requestsByUrl:n,xhrEdges:a,allRecords:e}}function tce(e,t){return Math.max(e.startTime,t.startTime)>Math.min(e.endTime,t.endTime)||e.type&&t.type&&e.type!=t.type||e.type=="Script"?!1:e.nameOrTld==t.nameOrTld}function nce(e){e.sort((n,r)=>n.nameOrTld!=r.nameOrTld?n.nameOrTld<r.nameOrTld?-1:1:n.type!=r.type?n.type<r.type?-1:1:n.startTime!=r.startTime?n.startTime<r.startTime?-1:1:n.endTime-r.endTime);let t=[];for(let n=0;n<e.length;n++){let r=e[n],a;for(;n<e.length&&(a=e[n+1],!(!a||!tce(a,r)));)r.endTime=Math.max(r.endTime,a.endTime),r.duration=r.endTime-r.startTime,n++;t.push(r)}return t.sort((n,r)=>n.startTime-r.startTime),t}function rce(e){if(!e.length)return[];let t=cm(e[0]);t.selfTime=t.duration;let n=t.startTime;for(let r of e){if(r.endTime<n||r==t)continue;let a=Math.max(n,r.startTime),o=Math.min(t.endTime,r.endTime);a<o&&(t.selfTime-=o-a),n=Math.max(n,o),r.endTime>t.endTime&&(r.selfTime=r.endTime-a,t=r)}}async function ho(e,t,n){let r=await H.request(t,n),a=r.find(Hr)||r.find(ga)||r.find(fi);if(a==null)return Promise.resolve([]);let o=new Set,i=cm(a),c=r.filter(v=>mo(v.url)||wh(v.url)),u=r.filter(v=>ga(v)&&v.endTime<=i.startTime),l=XU(r,e.traceEvents);for(let v of[i,...u,...c])um(l,v,o);let m=new Set(["Script","XHR","Fetch","EventStream","Document",void 0]),p=Array.from(o).filter(v=>v.endTime<i.startTime).filter(v=>m.has(v.resourceType)).filter(v=>v.mimeType!="text/css"),h=await hr(e,t,n),f=p.map(v=>{let{startTime:D,endTime:E}=h.get(v)||v;return{startTime:D,endTime:E,duration:E-D,selfTime:0,url:BU(v.url),nameOrTld:Dh(v.url),type:v.resourceType,record:v}}),y=nce(f);return rce(y),y}var gc=b(()=>{d();gn();vu();bu();de();UT();ht();Nn();tr();ht();s(Qse,"isXhrCritical");s(ece,"addInitiatedRequests");s(KU,"getCriticalGraph");s(um,"linkGraph");s(XU,"buildNetworkSummary");s(tce,"areSimilarRequests");s(nce,"computeSummaries");s(rce,"computeSelfTimes");s(ho,"computeAdRequestWaterfall")});var JU={};T(JU,{UIStrings:()=>Vr,default:()=>cce});function oce(e){let t=0,n=0;for(let{startTime:r,endTime:a}of e)r>=t?(++n,t=a):t=Math.min(t,a);return n}function sce(e){let t=1/0,n=[];for(let r=0;r<e.length;){let{startTime:a,endTime:o}=e[r];for(a-t>ice&&n.push(a-t),t=o;++r<e.length&&e[r].startTime<t;)t=Math.max(t,e[r].endTime)}return n}var Vr,go,ace,ice,jT,cce,ZU=b(()=>{d();A();ft();ct();gc();Vr={title:"Ad request waterfall",failureTitle:"Reduce critical path for ad loading",description:"Consider reducing the number of resources, loading multiple resources simultaneously, or loading resources earlier to improve ad speed. Requests that block ad loading can be found below. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-request-critical-path).",displayValue:"{serialResources, plural, =1 {1 serial resource} other {# serial resources}}",columnUrl:"Request",columnType:"Type",columnStartTime:"Start",columnEndTime:"End"},go=w("node_modules/lighthouse-plugin-publisher-ads/audits/ad-request-critical-path.js",Vr),ace=[{key:"nameOrTld",itemType:"text",text:go(Vr.columnType)},{key:"url",itemType:"url",text:go(Vr.columnUrl)},{key:"startTime",itemType:"ms",text:go(Vr.columnStartTime),granularity:1},{key:"endTime",itemType:"ms",text:go(Vr.columnEndTime),granularity:1}];s(oce,"computeDepth");ice=150;s(sce,"computeIdleTimes");jT=class e extends g{static{s(this,"AdRequestCriticalPath")}static get meta(){return{id:"ad-request-critical-path",title:go(Vr.title),failureTitle:go(Vr.failureTitle),description:go(Vr.description),scoreDisplayMode:"informative",requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=(await ho(r,a,n)).filter(p=>p.startTime>0&&p.startTime<p.endTime);if(!o.length)return ae.NoAds;let i=oce(o),c=i>3;for(let p of o)delete p.record;let u=sce(o),l=Math.max(...u),m=u.reduce((p,h)=>p+h,0);return{numericValue:i,numericUnit:"unitless",score:c?0:1,displayValue:go(Vr.displayValue,{serialResources:i}),details:{size:o.length,depth:i,maxIdleTime:l,totalIdleTime:m,...e.makeTableDetails(ace,o)}}}},cce=jT});var lm,dm,QU,e7=b(()=>{d();hi();Ha();ue();tr();ht();lm=class extends en{static{s(this,"LanternBidRequestTime")}static getEstimateFromSimulation(t,n){let{nodeTimings:r}=t,a=en.findNetworkTiming(r,ga).startTime,o=en.findNetworkTiming(r,Hr).startTime;return a>o?{timeInMs:-1,nodeTimings:r}:{timeInMs:a,nodeTimings:r}}};lm=q(lm);dm=class extends cn{static{s(this,"BidRequestTime")}static async computeSimulatedMetric(t,n){return lm.request(t,n)}static async computeObservedMetric(t){let{networkRecords:n}=t,r=Gr(n),a=zU(n);return xh(n)<a?{timing:-1}:{timing:(a-r)*1e3}}static async request(t,n){throw Error("Not implemented -- class not decorated")}};dm=q(dm);QU=dm});var t7={};T(t7,{UIStrings:()=>yc,default:()=>uce});var yc,Ah,qT,uce,n7=b(()=>{d();e7();A();ft();ct();yc={title:"First bid request time",failureTitle:"Reduce time to send the first bid request",description:"This metric measures the elapsed time from the start of page load until the first bid request is made. Delayed bid requests will decrease impressions and viewability, and have a negative impact on ad revenue. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/bid-request-from-page-start).",displayValue:"{timeInMs, number, seconds} s"},Ah=w("node_modules/lighthouse-plugin-publisher-ads/audits/bid-request-from-page-start.js",yc),qT=class extends g{static{s(this,"BidRequestFromPageStart")}static get meta(){return{id:"bid-request-from-page-start",title:Ah(yc.title),failureTitle:Ah(yc.failureTitle),description:Ah(yc.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:4350,median:8e3},provided:{p10:1200,median:2e3}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o={trace:r,devtoolsLog:a,settings:n.settings},i=n.options[n.settings.throttlingMethod=="provided"?"provided":"simulate"],{timing:c}=await QU.request(o,n);return c>0?{numericValue:c,numericUnit:"millisecond",score:g.computeLogNormalScore(i,c),displayValue:Ah(yc.displayValue,{timeInMs:c})}:ae.NoBids}},uce=qT});var r7={};T(r7,{UIStrings:()=>bc,default:()=>lce});var bc,_h,zT,lce,a7=b(()=>{d();Sh();A();ft();ct();bc={title:"First ad request time",failureTitle:"Reduce time to send the first ad request",description:"This metric measures the elapsed time from the start of page load until the first ad request is made. Delayed ad requests will decrease impressions and viewability, and have a negative impact on ad revenue. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-request-from-page-start).",displayValue:"{timeInMs, number, seconds} s"},_h=w("node_modules/lighthouse-plugin-publisher-ads/audits/ad-request-from-page-start.js",bc),zT=class extends g{static{s(this,"AdRequestFromPageStart")}static get meta(){return{id:"ad-request-from-page-start",title:_h(bc.title),failureTitle:_h(bc.failureTitle),description:_h(bc.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:6500,median:1e4},provided:{p10:1900,median:3500}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o={trace:r,devtoolsLog:a,settings:n.settings},i=n.options[n.settings.throttlingMethod=="provided"?"provided":"simulate"],{timing:c}=await hc.request(o,n);if(!(c>0)){let u=ae.NoAds;return u.runWarnings=[cc.NoAds],u}return{numericValue:c,numericUnit:"millisecond",score:g.computeLogNormalScore(i,c),displayValue:_h(bc.displayValue,{timeInMs:c})}}},lce=zT});var o7={};T(o7,{UIStrings:()=>bi,default:()=>pce});var bi,mm,dce,mce,HT,pce,i7=b(()=>{d();A();ft();ct();ht();bi={title:"No ad found at the very top of the viewport",failureTitle:"Move the top ad further down the page",description:"Over 10% of ads are never viewed because users scroll past them before they become viewable. By moving ad slots away from the very top of the viewport, users are more likely to see ads before scrolling away. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-top-of-viewport).",failureDisplayValue:"A scroll of {valueInPx, number} px would hide half of your topmost ad",columnSlot:"Top Slot ID"},mm=w("node_modules/lighthouse-plugin-publisher-ads/audits/ad-top-of-viewport.js",bi),dce=100,mce=[{key:"slot",itemType:"text",text:mm(bi.columnSlot)}],HT=class e extends g{static{s(this,"AdTopOfViewport")}static get meta(){return{id:"ad-top-of-viewport",title:mm(bi.title),failureTitle:mm(bi.failureTitle),description:mm(bi.description),requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(t){let n=t.ViewportDimensions,r=t.IFrameElements.filter(pc).filter(c=>c.clientRect.width*c.clientRect.height>1&&!c.isPositionFixed).map(c=>({midpoint:c.clientRect.top+c.clientRect.height/2,id:c.id}));if(!r.length)return ae.NoVisibleSlots;let a=r.reduce((c,u)=>c.midpoint<u.midpoint?c:u),o=a.midpoint<n.innerHeight;if(!o)return ae.NoAdsViewport;let i=o&&a.midpoint<dce?0:1;return{score:i,numericValue:a.midpoint,numericUnit:"unitless",displayValue:i?"":mm(bi.failureDisplayValue,{valueInPx:a.midpoint}),details:e.makeTableDetails(mce,i?[]:[{slot:a.id}])}}},pce=HT});function s7(e,t){let{innerWidth:n,innerHeight:r}=t,{left:a,top:o,right:i,bottom:c}=e;return a<i&&o<c&&a<n&&o<r&&0<i&&0<c}function GT([e,t,n,r]){return{left:e,top:t,width:n,height:r,right:e+n,bottom:t+r}}function c7(e,t){let n=!(e.right<t.left||t.right<e.left),r=!(e.bottom<t.top||t.bottom<e.top);return n&&r}var VT=b(()=>{d();s(s7,"isBoxInViewport");s(GT,"toClientRect");s(c7,"overlaps")});var u7={};T(u7,{UIStrings:()=>vi,default:()=>hce});var vi,pm,fce,WT,hce,l7=b(()=>{d();ft();ct();A();VT();ht();vi={title:"Few or no ads loaded outside viewport",failureTitle:"Avoid loading ads until they are nearly on-screen",description:"Too many ads loaded outside the viewport lowers viewability rates and impacts user experience. Consider loading ads below the fold lazily as the user scrolls down. Consider using GPT's [Lazy Loading API](https://developers.google.com/doubleclick-gpt/reference#googletag.PubAdsService_enableLazyLoad). [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ads-in-viewport).",failureDisplayValue:"{hiddenAds, plural, =1 {1 ad} other {# ads}} out of view",columnSlot:"Slots Outside Viewport"},pm=w("node_modules/lighthouse-plugin-publisher-ads/audits/ads-in-viewport.js",vi),fce=[{key:"slot",itemType:"text",text:pm(vi.columnSlot)}],WT=class e extends g{static{s(this,"AdsInViewport")}static get meta(){return{id:"ads-in-viewport",title:pm(vi.title),failureTitle:pm(vi.failureTitle),description:pm(vi.description),requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(t){let n=t.ViewportDimensions,r=t.IFrameElements.filter(i=>MT(i)&&i.clientRect.height*i.clientRect.width>1);if(!r.length)return ae.NoVisibleSlots;let a=r.filter(i=>!s7(i.clientRect,n)).map(i=>({slot:i.id})).sort((i,c)=>i.slot.localeCompare(c.slot));return{numericValue:(r.length-a.length)/r.length,numericUnit:"unitless",score:a.length>3?0:1,displayValue:a.length?pm(vi.failureDisplayValue,{hiddenAds:a.length}):"",details:e.makeTableDetails(fce,a)}}},hce=WT});function Rh(e,t){let n=0;for(let r of e)t(r)&&n++;return n}function d7(e,t){let n=new Map;for(let r of e){let a=t(r);if(a!=null){let o=n.get(a)||[];o.push(r),n.set(a,o)}}return n}var Fh=b(()=>{d();s(Rh,"count");s(d7,"bucket")});var p7={};T(p7,{UIStrings:()=>fm,default:()=>yce});function gce(e){return e.priority=="Low"||OU(e)}var fm,$T,YT,yce,f7=b(()=>{d();Fh();A();Bt();de();ft();ct();ht();fm={title:"Ad tag is loaded asynchronously",failureTitle:"Load ad tag asynchronously",description:"Loading the ad tag synchronously blocks content rendering until the tag is fetched and loaded. Consider using the `async` attribute to load gpt.js and/or adsbygoogle.js asynchronously. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/async-ad-tags)."},$T=w("node_modules/lighthouse-plugin-publisher-ads/audits/async-ad-tags.js",fm);s(gce,"isAsync");YT=class extends g{static{s(this,"AsyncAdTags")}static get meta(){return{id:"async-ad-tags",title:$T(fm.title),failureTitle:$T(fm.failureTitle),description:$T(fm.description),requiredArtifacts:["devtoolsLogs","URL"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await H.request(r,n),o=await _e.request({URL:t.URL,devtoolsLog:r},n),i=a.filter(l=>mc(new URL(l.url))).filter(l=>l.frameId===o.frameId);if(!i.length)return ae.NoTag;let c=Rh(i,gce)-i.length;return{score:Number(c===0),numericValue:c,numericUnit:"unitless"}}},yce=YT});var g7={};T(g7,{UIStrings:()=>Wr,default:()=>Ece});function vce(e){let{record:t}=e,n=t&&t.initiator&&t.initiator.stack;if(n){for(;n.parent;)n=n.parent;return n.callFrames[n.callFrames.length-1]}}function wce(e,t){return t.find(n=>n.name=="FunctionCall"&&n.args.data&&n.args.data.functionName==e.functionName&&n.args.data.scriptId==e.scriptId&&n.args.data.url==e.url&&Math.abs(n.args.data.lineNumber==e.lineNumber)<2&&Math.abs(n.args.data.columnNumber==e.columnNumber)<2)}function h7(e,t){let n={},r=[];for(let a of t)a.name==`${e}EventStart`?n={start:a.ts,end:1/0,eventName:e}:a.name==`${e}EventEnd`&&(n.end=a.ts,r.push(n));return r}function Dce(e,t,n){let r=t.find(c=>c.url==e.url),a=t.find(c=>c.url==e.blockedUrl);if(!r||!a)return 0;let o=n.get(r),i=n.get(a);return!o||!i?0:i.startTime-o.endTime}var Wr,yo,bce,KT,Ece,y7=b(()=>{d();A();de();Nt();sr();ft();ct();gc();tr();Wr={title:"Ads not blocked by load events",failureTitle:"Avoid waiting on load events",description:"Waiting on load events increases ad latency. To speed up ads, eliminate the following load event handlers. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/blocking-load-events).",displayValue:"{timeInMs, number, seconds} s blocked",columnEvent:"Event Name",columnTime:"Event Time",columnScript:"Script",columnBlockedUrl:"Blocked URL",columnFunctionName:"Function"},yo=w("node_modules/lighthouse-plugin-publisher-ads/audits/blocking-load-events.js",Wr),bce=[{key:"eventName",itemType:"text",text:yo(Wr.columnEvent)},{key:"time",itemType:"ms",text:yo(Wr.columnTime),granularity:1},{key:"url",itemType:"url",text:yo(Wr.columnScript)},{key:"functionName",itemType:"text",text:yo(Wr.columnFunctionName)}];s(vce,"findOriginalCallFrame");s(wce,"findTraceEventOfCallFrame");s(h7,"findEventIntervals");s(Dce,"quantifyBlockedTime");KT=class e extends g{static{s(this,"BlockingLoadEvents")}static get meta(){return{id:"blocking-load-events",title:yo(Wr.title),failureTitle:yo(Wr.failureTitle),description:yo(Wr.description),requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=await H.request(a,n),i=await ke.request(r,n),{timings:c}=await zt.request(i,n),{processEvents:u}=i,l=await hr(r,a,n),m=(await ho(r,a,n)).sort((D,E)=>D.startTime-E.startTime);if(!m.length)return ae.NoAdRelatedReq;let p=[...h7("domContentLoaded",u),...h7("load",u)],h=[],f=new Set;for(let D of m){let E=vce(D);if(!E)continue;let S=JSON.stringify(E);if(f.has(S))continue;f.add(S);let k=wce(E,u);if(!k)continue;let C=p.find(R=>R.start<=k.ts&&k.ts<=R.end);if(C){let R=Object.assign({eventName:C.eventName,blockedUrl:D.url,time:c[C.eventName],blockedTime:1/0},E);R.blockedTime=Dce(R,o,l),h.push(R)}}let y=h.length>0,v=0;return y&&(v=Math.min(...h.map(D=>D.blockedTime))),{numericValue:h.length,numericUnit:"unitless",score:y?0:1,displayValue:y&&v?yo(Wr.displayValue,{timeInMs:v}):"",details:e.makeTableDetails(bce,h)}}},Ece=KT});var b7={};T(b7,{UIStrings:()=>va,default:()=>Tce});var va,wi,xce,XT,Tce,v7=b(()=>{d();A();ft();ct();gc();ht();va={title:"No bottleneck requests found",failureTitle:"Avoid bottleneck requests",description:"Speed up, load earlier, parallelize, or eliminate the following requests and their dependencies in order to speed up ad loading. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/bottleneck-requests).",displayValue:"{blockedTime, number, seconds} s spent blocked on requests",columnUrl:"Blocking Request",columnInitiatorUrl:"Initiator Request",columnStartTime:"Start",columnSelfTime:"Exclusive Time",columnDuration:"Total Time"},wi=w("node_modules/lighthouse-plugin-publisher-ads/audits/bottleneck-requests.js",va),xce=[{key:"url",itemType:"url",text:wi(va.columnUrl)},{key:"selfTime",itemType:"ms",text:wi(va.columnSelfTime),granularity:1},{key:"duration",itemType:"ms",text:wi(va.columnDuration),granularity:1}],XT=class e extends g{static{s(this,"BottleneckRequests")}static get meta(){return{id:"bottleneck-requests",title:wi(va.title),failureTitle:wi(va.failureTitle),description:wi(va.description),requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o=(await ho(r,a,n)).filter(f=>f.startTime>0);if(!o.length)return ae.NoAdRelatedReq;let i=250,c=1e3,u=s(f=>!rm(En(f.url))&&(f.selfTime>i||f.duration>c),"isBottleneck"),l=s(f=>f.selfTime*3+f.duration,"cost"),m=o.filter(u).sort((f,y)=>l(y)-l(f)).slice(0,5),p=m.reduce((f,y)=>f+y.selfTime,0)/1e3,h=p*1e3>i*4;for(let f of m)delete f.record;return{numericValue:m.length,numericUnit:"unitless",score:h?0:1,displayValue:h?wi(va.displayValue,{blockedTime:p}):"",details:e.makeTableDetails(xce,m)}}},Tce=XT});var w7={};T(w7,{UIStrings:()=>bo,default:()=>Cce});var bo,vc,Sce,kce,JT,Cce,D7=b(()=>{d();A();Bt();de();lt();ft();ct();ht();bo={title:"No duplicate tags found",failureTitle:"Load tags only once",description:"Loading a tag more than once in the same page is redundant and adds overhead without benefit. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/duplicate-tags).",failureDisplayValue:"{duplicateTags, plural, =1 {1 duplicate tag} other {# duplicate tags}}",columnScript:"Script",columnNumReqs:"Duplicate Requests",columnFrameId:"Frame ID"},vc=w("node_modules/lighthouse-plugin-publisher-ads/audits/duplicate-tags.js",bo),Sce=["googletagservices.com/tag/js/gpt.js","securepubads.g.doubleclick.net/tag/js/gpt.js","pagead2.googlesyndication.com/pagead/js/adsbygoogle.js","pagead2.googlesyndication.com/pagead/js/show_ads.js","cdn.ampproject.org/v0/amp-ad-0.1.js"],kce=[{key:"script",itemType:"url",text:vc(bo.columnScript)},{key:"numReqs",itemType:"text",text:vc(bo.columnNumReqs)}],JT=class e extends g{static{s(this,"DuplicateTags")}static get meta(){return{id:"duplicate-tags",title:vc(bo.title),failureTitle:vc(bo.failureTitle),description:vc(bo.description),requiredArtifacts:["devtoolsLogs","URL"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await H.request(r,n),o=await _e.request({URL:t.URL,devtoolsLog:r},n),i=a.filter(l=>l.frameId===o.frameId).filter(l=>PU(l.url,Sce)).filter(l=>l.resourceType===G.TYPES.Script);if(!i.length)return ae.NoTags;let c=new Map;for(let l of i){let m=new URL(l.url).pathname,p=c.get(m)||0;c.set(m,p+1)}let u=[];for(let[l,m]of c)m>1&&u.push({script:l,numReqs:m});return{numericValue:u.length,numericUnit:"unitless",score:u.length?0:1,details:e.makeTableDetails(kce,u),displayValue:u.length?vc(bo.failureDisplayValue,{duplicateTags:u.length}):""}}},Cce=JT});var hm,gm,E7,x7=b(()=>{d();hi();Ha();ue();tr();ht();hm=class extends en{static{s(this,"LanternAdRenderTime")}static getEstimateFromSimulation(t,n){let{nodeTimings:r}=t;return{timeInMs:en.findNetworkTiming(r,o=>!!o.url&&lc(new URL(o.url))).startTime,nodeTimings:r}}};hm=q(hm);gm=class extends cn{static{s(this,"AdRenderTime")}static async computeSimulatedMetric(t,n){return hm.request(t,n)}static async computeObservedMetric(t,n){let{networkRecords:r}=t,a=Gr(r),i=(HU(r)-a)*1e3;return Promise.resolve({timing:i})}static async request(t,n){throw Error("Not implemented -- class not decorated")}};gm=q(gm);E7=gm});var T7={};T(T7,{UIStrings:()=>wc,default:()=>Ace});var wc,Ih,ZT,Ace,S7=b(()=>{d();x7();A();ft();ct();wc={title:"Latency of first ad render",failureTitle:"Reduce time to render first ad",description:"This metric measures the time for the first ad iframe to render from page navigation. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/first-ad-render).",displayValue:"{timeInMs, number, seconds} s"},Ih=w("node_modules/lighthouse-plugin-publisher-ads/audits/first-ad-render.js",wc),ZT=class extends g{static{s(this,"FirstAdRender")}static get meta(){return{id:"first-ad-render",title:Ih(wc.title),failureTitle:Ih(wc.failureTitle),description:Ih(wc.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:12900,median:22e3},provided:{p10:2750,median:3700}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],o={devtoolsLog:t.devtoolsLogs[g.DEFAULT_PASS],trace:r,settings:n.settings},{timing:i}=await E7.request(o,n);if(!(i>0)){let u=ae.NoAdRendered;return u.runWarnings=[cc.NoAdRendered],u}let c=n.options[n.settings.throttlingMethod=="provided"?"provided":"simulate"];return{numericValue:i,numericUnit:"millisecond",score:g.computeLogNormalScore(c,i),displayValue:Ih(wc.displayValue,{timeInMs:i})}}},Ace=ZT});var k7={};T(k7,{UIStrings:()=>Dc,default:()=>_ce});var Dc,Nh,QT,_ce,C7=b(()=>{d();A();de();ft();ct();ht();Dc={title:"Ad slots effectively use horizontal space",failureTitle:"Increase the width of ad slots",description:"Ad slots that utilize most of the page width generally experience increased click-through rate over smaller ad sizes. We recommend leaving no more than 25% of the viewport width unutilized on mobile devices.",failureDisplayValue:"{percentUnused, number, percent} of viewport width is underutilized"},Nh=w("node_modules/lighthouse-plugin-publisher-ads/audits/full-width-slots.js",Dc),QT=class extends g{static{s(this,"FullWidthSlots")}static get meta(){return{id:"full-width-slots",title:Nh(Dc.title),failureTitle:Nh(Dc.failureTitle),description:Nh(Dc.description),requiredArtifacts:["ViewportDimensions","devtoolsLogs"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await H.request(r,n),i=t.ViewportDimensions.innerWidth,c=a.filter(Hr).map(y=>new URL(y.url));if(!c.length)return ae.NoAds;let m=c.map(y=>y.searchParams.get("prev_iu_szs")||y.searchParams.get("sz")).join("|").split(/[|,]/).map(y=>parseInt(y.split("x")[0])).filter(y=>y<=i&&y>1);if(!m.length)return ae.NoValidAdWidths;let h=1-Math.max(...m)/i,f=h>.25?0:1;return{score:f,numericValue:h,numericUnit:"unitless",displayValue:f?"":Nh(Dc.failureDisplayValue,{percentUnused:h})}}},_ce=QT});var A7={};T(A7,{UIStrings:()=>vo,default:()=>Ice});var Rce,vo,Fce,eS,Ice,_7=b(()=>{d();de();UT();ft();ct();gc();tr();ht();Rce="gpt-bids-parallel",vo={title:"GPT and bids loaded in parallel",failureTitle:"Load GPT and bids in parallel",description:"To optimize ad loading, bid requests should not wait on GPT to load. This issue can often be fixed by making sure that bid requests do not wait on `googletag.pubadsReady` or `googletag.cmd.push`. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/gpt-bids-parallel).",columnBidder:"Bidder",columnUrl:"URL",columnStartTime:"Start",columnDuration:"Duration"},Fce=[{key:"bidder",itemType:"text",text:vo.columnBidder},{key:"url",itemType:"url",text:vo.columnUrl},{key:"startTime",itemType:"ms",text:vo.columnStartTime},{key:"duration",itemType:"ms",text:vo.columnDuration}],eS=class e extends g{static{s(this,"GptBidsInParallel")}static get meta(){return{id:Rce,title:vo.title,failureTitle:vo.failureTitle,description:vo.description,requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=t.traces[g.DEFAULT_PASS],o=await H.request(r,n),i=o.find(h=>zr(h.url));if(!i)return ae.NoGpt;let c=o.filter(ga).filter(h=>h.frameId==i.frameId);if(!c.length)return ae.NoBids;let u=await hr(a,r,n),l=[],m=new Set;for(let h of c)if(KU(o,a.traceEvents,h).has(i)){let{startTime:f,endTime:y}=u.get(h)||h,v=cm(po(h.url));if(m.has(v))continue;m.add(v),l.push({bidder:v,url:h.url,startTime:f,duration:y-f})}let p=l.length>0;return{numericValue:l.length,numericUnit:"unitless",score:p?0:1,details:p?e.makeTableDetails(Fce,l):void 0}}},Ice=eS});var R7={};T(R7,{UIStrings:()=>ym,default:()=>Nce});var ym,tS,nS,Nce,F7=b(()=>{d();A();de();ft();ct();ht();ym={title:"GPT tag is loaded from an official source",failureTitle:"Load GPT from an official source",description:"Load GPT from 'securepubads.g.doubleclick.net' for standard integrations or from 'pagead2.googlesyndication.com' for limited ads. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/loads-gpt-from-official-source)."},tS=w("node_modules/lighthouse-plugin-publisher-ads/audits/loads-gpt-from-official-source.js",ym),nS=class extends g{static{s(this,"LoadsGptFromOfficalSource")}static get meta(){return{id:"loads-gpt-from-official-source",title:tS(ym.title),failureTitle:tS(ym.failureTitle),description:tS(ym.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],o=(await H.request(r,n)).map(c=>new URL(c.url)).find(dc);if(!o)return ae.NoGpt;let i=["securepubads.g.doubleclick.net","pagead2.googlesyndication.com"].includes(o.host);return{score:Number(i),numericValue:+!i,numericUnit:"unitless"}}},Nce=nS});var I7={};T(I7,{UIStrings:()=>bm,default:()=>Mce});var bm,rS,aS,Mce,N7=b(()=>{d();A();de();ft();ct();ht();bm={title:"Ad tag is loaded over HTTPS",failureTitle:"Load ad tag over HTTPS",description:'For privacy and security, always load GPT/AdSense over HTTPS. Insecure pages should explicitly request the ad script securely. GPT Example: `<script async src="https://securepubads.g.doubleclick.net/tag/js/gpt.js">` AdSense Example: `<script async src="https://pagead2.googlesyndication.com/pagead/js/adsbygoogle.js">`. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/loads-ad-tag-over-https).'},rS=w("node_modules/lighthouse-plugin-publisher-ads/audits/loads-ad-tag-over-https.js",bm),aS=class extends g{static{s(this,"LoadsAdTagOverHttps")}static get meta(){return{id:"loads-ad-tag-over-https",title:rS(bm.title),failureTitle:rS(bm.failureTitle),description:rS(bm.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=await H.request(r,n);if(!a.find(l=>l.statusCode==200))return ae.NoRecords;let i=a.filter(l=>mc(new URL(l.url))),c=i.filter(l=>l.isSecure),u={type:"debugdata",numAdTagHttpReqs:i.length-c.length,numAdTagHttpsReqs:c.length};if(!i.length){let l=ae.NoTag;return l.details=u,l}return{numericValue:u.numAdTagHttpReqs,score:u.numAdTagHttpReqs?0:1,details:u}}},Mce=aS});var M7={};T(M7,{UIStrings:()=>wo,default:()=>jce});function Bce(e){if(e.initiator.type!=="script")return!1;let t=xt.getNetworkInitiators(e);return!(t.length!==1||t[0]!==e.documentURL)}async function Uce(e,t){let n=e.devtoolsLogs[g.DEFAULT_PASS],r=e.traces[g.DEFAULT_PASS],a=[],o=await ho(r,n,t);for(let{record:i}of o)!i||i.resourceType!=="Script"||(Bce(i)||Oce.find(c=>i.url.match(c)))&&a.push(i);return a}var Lce,wo,Ec,Pce,Oce,oS,jce,L7=b(()=>{d();Fh();A();Nn();ft();ct();gc();tr();Lce=400,wo={title:"Ad scripts are loaded statically",failureTitle:"Load ad scripts statically",description:"Load the following scripts directly with `<script async src=...>` instead of injecting scripts with JavaScript. Doing so allows the browser to preload scripts sooner. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/script-injected-tags).",failureDisplayValue:"Load {tags, plural, =1 {1 script} other {# scripts}} statically",columnUrl:"Script",columnLoadTime:"Load Time"},Ec=w("node_modules/lighthouse-plugin-publisher-ads/audits/script-injected-tags.js",wo),Pce=[{key:"url",itemType:"url",text:Ec(wo.columnUrl)},{key:"loadTime",itemType:"ms",granularity:1,text:Ec(wo.columnLoadTime)}],Oce=[/amazon-adsystem\.com\/aax2\/apstag.js/,/js-sec\.indexww\.com\/ht\/p\/.*\.js/,/pubads\.g\.doubleclick\.net\/tag\/js\/gpt\.js/,/static\.criteo\.net\/js\/.*\/publishertag\.js/,/www\.googletagservices\.com\/tag\/js\/gpt\.js/,/pagead2\.googlesyndication\.com\/pagead\/js\/adsbygoogle\.js/,/cdn\.ampproject\.org\/v0\/amp-ad-\d+\.\d+\.js/];s(Bce,"initiatedByInlineScript");s(Uce,"findStaticallyLoadableTags");oS=class e extends g{static{s(this,"StaticAdTags")}static get meta(){return{id:"script-injected-tags",title:Ec(wo.title),failureTitle:Ec(wo.failureTitle),description:Ec(wo.description),requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(t,n){let r=await Uce(t,n);if(!r.length)return ae.NoTag;let a=new Set,o=[],i=t.devtoolsLogs[g.DEFAULT_PASS],c=t.traces[g.DEFAULT_PASS],u=await GU(c,i,n);for(let m of r){if(a.has(m.url))continue;a.add(m.url);let p=r.filter(f=>f.url===m.url);if(Rh(p,f=>f.initiator.type==="parser"&&!f.isLinkPreload)===0){let f=u.get(m.url)||0;if(f<Lce)continue;o.push({url:m.url,loadTime:f})}}o.sort((m,p)=>m.loadTime-p.loadTime);let l=o.length>0;return{displayValue:l?Ec(wo.failureDisplayValue,{tags:o.length}):"",score:+!l,numericValue:o.length,numericUnit:"unitless",details:e.makeTableDetails(Pce,o)}}},jce=oS});var P7={};T(P7,{UIStrings:()=>wa,default:()=>$ce});function Hce(e,t,n){let r=[];for(let a of e){let o=n.get(a);o&&r.push(Object.assign({},o,{url:a.url,type:t}))}return r}function Gce(e){return pi(new URL(e.url))?xc.AD:po(e.url)?xc.BID:xc.UNKNOWN}function Vce(e){return(e.resourceSize==null||e.resourceSize>0)&&e.resourceType!="Image"&&e.endTime-e.startTime>=qce&&!vh(e)}function Wce(e){let t=new URL(e);return t.search="",t.toString()}var wa,Di,qce,zce,xc,iS,$ce,O7=b(()=>{d();Sh();A();Bt();de();ft();ct();Fh();tr();RT();ht();wa={title:"Header bidding is parallelized",failureTitle:"Parallelize bid requests",description:"Send header bidding requests simultaneously, rather than serially, to retrieve bids more quickly. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/serial-header-bidding).",columnBidder:"Bidder",columnUrl:"URL",columnStartTime:"Start",columnDuration:"Duration"},Di=w("node_modules/lighthouse-plugin-publisher-ads/audits/serial-header-bidding.js",wa),qce=.05,zce=[{key:"bidder",itemType:"text",text:Di(wa.columnBidder)},{key:"url",itemType:"url",text:Di(wa.columnUrl)},{key:"startTime",itemType:"ms",text:Di(wa.columnStartTime)},{key:"duration",itemType:"ms",text:Di(wa.columnDuration)}],xc={AD:"ad",BID:"bid",UNKNOWN:"unknown"};s(Hce,"constructRecords");s(Gce,"checkRecordType");s(Vce,"isPossibleBid");s(Wce,"clearQueryString");iS=class e extends g{static{s(this,"SerialHeaderBidding")}static get meta(){return{id:"serial-header-bidding",title:Di(wa.title),failureTitle:Di(wa.failureTitle),description:Di(wa.description),requiredArtifacts:["devtoolsLogs","traces","URL"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS],a=t.traces[g.DEFAULT_PASS],o=await H.request(r,n);if(!o.length)return ae.NoRecords;let i=await _e.request({URL:t.URL,devtoolsLog:r},n),c=o.filter(Vce).filter(D=>D.frameId==i.frameId),u=d7(c,Gce);if(!u.has(xc.BID))return ae.NoBids;let l={trace:a,devtoolsLog:r,settings:n.settings},{timing:m}=await hc.request(l,n),p=await hr(a,r,n),h=Hce(u.get(xc.BID)||[],xc.BID,p),f=[],y;for(let D of h)m>0&&D.endTime>m||(D.bidder=po(D.url),D.url=Wce(D.url),y&&D.startTime>=y.endTime&&(f.push(y),f.push(D)),(!y||D.endTime<y.endTime||D.startTime>=y.endTime)&&(y=D));f=Array.from(new Set(f));let v=f.length>1;return{numericValue:Number(v),numericUnit:"unitless",score:v?0:1,details:v?e.makeTableDetails(zce,f):void 0}}},$ce=iS});var vm,wm,B7,U7=b(()=>{d();hi();Ha();ue();tr();ht();vm=class extends en{static{s(this,"LanternTagLoadTime")}static getEstimateFromSimulation(t,n){let{nodeTimings:r}=t;return{timeInMs:en.findNetworkTiming(r,o=>!!o.url&&fc(new URL(o.url))).endTime,nodeTimings:r}}};vm=q(vm);wm=class extends cn{static{s(this,"TagLoadTime")}static async computeSimulatedMetric(t,n){return vm.request(t,n)}static async computeObservedMetric(t,n){let{networkRecords:r}=t,a=Gr(r),i=(qU(r)-a)*1e3;return Promise.resolve({timing:i})}static async request(t,n){throw Error("Not implemented -- class not decorated")}};wm=q(wm);B7=wm});var j7={};T(j7,{UIStrings:()=>Tc,default:()=>Yce});var Tc,Mh,sS,Yce,q7=b(()=>{d();U7();A();ft();ct();Tc={title:"Tag load time",failureTitle:"Reduce tag load time",description:"This metric measures the time for the ad tag's implementation script (pubads_impl.js for GPT; adsbygoogle.js for AdSense) to load after the page loads. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/tag-load-time).",displayValue:"{timeInMs, number, seconds} s"},Mh=w("node_modules/lighthouse-plugin-publisher-ads/audits/tag-load-time.js",Tc),sS=class extends g{static{s(this,"TagLoadTime")}static get meta(){return{id:"tag-load-time",title:Mh(Tc.title),failureTitle:Mh(Tc.failureTitle),description:Mh(Tc.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:4350,median:8e3},provided:{p10:1200,median:2e3}}}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=t.devtoolsLogs[g.DEFAULT_PASS],o={trace:r,devtoolsLog:a,settings:n.settings},i=n.options[n.settings.throttlingMethod=="provided"?"provided":"simulate"],{timing:c}=await B7.request(o,n);if(!(c>0)){let u=ae.NoTag;return u.runWarnings=[cc.NoTag],u}return{numericValue:c,numericUnit:"millisecond",score:g.computeLogNormalScore(i,c),displayValue:Mh(Tc.displayValue,{timeInMs:c})}}},Yce=sS});var z7={};T(z7,{UIStrings:()=>Sc,default:()=>Xce});function Kce(e,t){let n=new Set([...e.map(a=>a.clientRect.left),...e.map(a=>a.clientRect.right)].map(a=>Math.min(Math.max(1,a),t.innerWidth-1)));e=e.sort((a,o)=>a.clientRect.top!==o.clientRect.top?a.clientRect.top-o.clientRect.top:a.clientRect.bottom-o.clientRect.bottom);let r=0;for(let a of n){let o=0,i=0;for(let c of e){if(a<c.clientRect.left||a>c.clientRect.right)continue;if(c.isPositionFixed){o+=c.clientRect.height;continue}let u=c.clientRect.bottom-Math.max(i,c.clientRect.top);u>0&&(o+=u),i=Math.max(i,c.clientRect.bottom)}r=Math.max(r,o)}return r}var Sc,Lh,cS,Xce,H7=b(()=>{d();A();ft();ct();ht();Sc={title:"Ads to page-height ratio is within recommended range",failureTitle:"Reduce ads to page-height ratio",description:"The ads to page-height ratio can impact user experience and ultimately user retention. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/viewport-ad-density).",displayValue:"{adDensity, number, percent} ads to page-height ratio"},Lh=w("node_modules/lighthouse-plugin-publisher-ads/audits/viewport-ad-density.js",Sc);s(Kce,"computeAdLength");cS=class extends g{static{s(this,"ViewportAdDensity")}static get meta(){return{id:"viewport-ad-density",title:Lh(Sc.title),failureTitle:Lh(Sc.failureTitle),description:Lh(Sc.description),requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(t){let n=t.ViewportDimensions,r=t.IFrameElements.filter(l=>pc(l)&&l.clientRect.width*l.clientRect.height>1);if(!r.length)return ae.NoVisibleSlots;if(n.innerHeight<=0)throw new Error(CU.ViewportAreaZero);let a=Kce(r,n),i=Math.max(...r.map(l=>l.clientRect.top+l.clientRect.height/2))+n.innerHeight,c=Math.min(1,a/i);return{score:c>.3?0:1,numericValue:c,numericUnit:"unitless",displayValue:Lh(Sc.displayValue,{adDensity:c})}}},Xce=cS});var G7={};T(G7,{UIStrings:()=>Dm,default:()=>Jce});var Dm,uS,lS,Jce,V7=b(()=>{d();A();ft();ct();tr();ht();VT();Dm={title:"Cumulative ad shift",failureTitle:"Reduce ad-related layout shift",description:"Measures layout shifts that were caused by ads or happened near ads. Reducing cumulative ad-related layout shift will improve user experience. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/cumulative-ad-shift)."},uS=w("node_modules/lighthouse-plugin-publisher-ads/audits/cumulative-ad-shift.js",Dm),lS=class extends g{static{s(this,"CumulativeAdShift")}static get meta(){return{id:"cumulative-ad-shift",title:uS(Dm.title),failureTitle:uS(Dm.failureTitle),description:uS(Dm.description),scoreDisplayMode:g.SCORING_MODES.NUMERIC,requiredArtifacts:["traces","IFrameElements"]}}static get defaultOptions(){return{p10:.05,median:.25}}static isAdExpansion(t,n){if(!t.args||!t.args.data)return!1;for(let r of t.args.data.impacted_nodes||[]){let a=GT(r.old_rect||[]),o=GT(r.new_rect||[]);if(!(a.top>o.top||a.height!==o.height))for(let i of n){let c=i.clientRect;if((a.top>=c.top||o.top>=c.bottom)&&c7(a,c))return!0}}return!1}static isAttributableToTask(t,n){if(!t.args||!t.args.data)return!1;let r=50*1e3;return!!n.find(o=>o.ts<t.ts&&t.ts-o.ts<r)}static compute(t,n,r,a){let o=0,i=0,c=0,u=0,l=0,m=0;for(let p of t)!p.args||!p.args.data||!p.args.data.is_main_frame||(o+=p.args.data.score,i++,(this.isAdExpansion(p,r)||this.isAttributableToTask(p,n))&&(c+=p.args.data.score,u++,p.ts<a&&(l+=p.args.data.score,m++)));return{cumulativeShift:o,numShifts:i,cumulativeAdShift:c,numAdShifts:u,cumulativePreImplTagAdShift:l,numPreImplTagAdShifts:m}}static getLayoutShiftEventsByWindow(t){let a=0,o=[],i=0,c=[];for(let u of t){if(u.name!=="LayoutShift"||!u.args||!u.args.data)continue;if(c.length){let m=c[0],p=c[c.length-1];(p.ts-m.ts>5e6||u.ts-p.ts>1e6)&&(i>a&&(o=c,a=i),c=[],i=0)}c.push(u);let l=u.args.data;i+=l.weighted_score_delta||l.score||0}return o.length||(o=c),o}static async audit(t,n){let r=t.traces[g.DEFAULT_PASS],a=this.getLayoutShiftEventsByWindow(r.traceEvents);if(!a.length)return ae.NoLayoutShifts;let o=r.traceEvents.filter(m=>fi(Th(m)||"")),i=o.find(m=>fc(Th(m)||""))||{ts:1/0},c=t.IFrameElements.filter(pc),u=this.compute(a,o,c,i.ts),l=u.cumulativeAdShift;return!c.length&&!l?ae.NoAdRendered:{numericValue:l,numericUnit:"unitless",score:g.computeLogNormalScore({p10:n.options.p10,median:n.options.median},l),displayValue:l.toLocaleString(n.settings.locale),details:u}}},Jce=lS});var W7={};T(W7,{UIStrings:()=>Cc,default:()=>Zce});var Cc,kc,dS,Zce,$7=b(()=>{d();A();de();ft();ct();ht();Cc={title:"Deprecated GPT API Usage",failureTitle:"Avoid deprecated GPT APIs",description:"Deprecated GPT API methods should be avoided to ensure your page is tagged correctly. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/deprecated-gpt-api-usage).",displayValue:"{numErrors, plural, =1 {1 error} other {# errors}} found"},kc=w("node_modules/lighthouse-plugin-publisher-ads/audits/deprecated-api-usage.js",Cc),dS=class extends g{static{s(this,"DeprecatedApiUsage")}static get meta(){return{id:"deprecated-gpt-api-usage",title:kc(Cc.title),failureTitle:kc(Cc.failureTitle),description:kc(Cc.description),scoreDisplayMode:"informative",requiredArtifacts:["ConsoleMessages","devtoolsLogs"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS];if(!(await H.request(r,n)).find(m=>zr(m.url)))return ae.NoGpt;let i=t.ConsoleMessages.filter(m=>m.level==="warning"||m.level==="error").filter(m=>m.url&&mo(m.url)).filter(m=>m.text.toLowerCase().includes("deprecated")||m.text.toLowerCase().includes("discouraged")).map(m=>({source:m.source,description:m.text,url:m.url,timestamp:m.timestamp})).sort((m,p)=>(m.timestamp||0)-(p.timestamp||0)),c=[{key:"url",itemType:"url",text:kc(x.columnURL)},{key:"description",itemType:"code",text:kc(x.columnDescription)}],u=g.makeTableDetails(c,i),l=i.length;return{score:+(l===0),details:u,displayValue:kc(Cc.displayValue,{numErrors:l})}}},Zce=dS});var Y7={};T(Y7,{UIStrings:()=>_c,default:()=>Qce});var _c,Ac,mS,Qce,K7=b(()=>{d();A();de();ft();ct();ht();_c={title:"GPT Errors",failureTitle:"Fix GPT errors",description:"Fix GPT errors to ensure your page is tagged as intended. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/gpt-errors-overall).",displayValue:"{numErrors, plural, =1 {1 error} other {# errors}} found"},Ac=w("node_modules/lighthouse-plugin-publisher-ads/audits/gpt-errors-overall.js",_c),mS=class extends g{static{s(this,"GptErrorsOverall")}static get meta(){return{id:"gpt-errors-overall",title:Ac(_c.title),failureTitle:Ac(_c.failureTitle),description:Ac(_c.description),scoreDisplayMode:"informative",requiredArtifacts:["ConsoleMessages","devtoolsLogs"]}}static async audit(t,n){let r=t.devtoolsLogs[g.DEFAULT_PASS];if(!(await H.request(r,n)).find(m=>zr(m.url)))return ae.NoGpt;let i=t.ConsoleMessages.filter(m=>m.level==="error"||m.level==="warning").filter(m=>m.url&&mo(m.url)).filter(m=>!m.text.toLowerCase().includes("deprecated")&&!m.text.toLowerCase().includes("discouraged")).map(m=>({source:m.source,description:m.text,url:m.url,timestamp:m.timestamp})).sort((m,p)=>(m.timestamp||0)-(p.timestamp||0)),c=[{key:"url",itemType:"url",text:Ac(x.columnURL)},{key:"description",itemType:"code",text:Ac(x.columnDescription)}],u=g.makeTableDetails(c,i),l=i.length;return{score:+(l===0),details:u,displayValue:Ac(_c.displayValue,{numErrors:l})}}},Qce=mS});var X7={};T(X7,{UIStrings:()=>Do,default:()=>tue});var Do,Rc,eue,pS,tue,J7=b(()=>{d();A();PT();de();ft();ct();kh();ht();Do={title:"Total ad JS blocking time",failureTitle:"Reduce ad JS blocking time",description:"Ad-related scripts are blocking the main thread. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/total-ad-blocking-time).",failureDisplayValue:"{timeInMs, number, seconds} s blocked",columnName:"Name",columnBlockingTime:"Blocking Time"},Rc=w("node_modules/lighthouse-plugin-publisher-ads/audits/total-ad-blocking-time.js",Do),eue=[{key:"name",itemType:"text",text:Rc(Do.columnName)},{key:"blockingTime",itemType:"ms",text:Rc(Do.columnBlockingTime),granularity:1}],pS=class e extends g{static{s(this,"TotalAdBlockingTime")}static get meta(){return{id:"total-ad-blocking-time",title:Rc(Do.title),failureTitle:Rc(Do.failureTitle),description:Rc(Do.description),requiredArtifacts:["traces","devtoolsLogs"]}}static get defaultOptions(){return{simulate:{p10:290,median:600},provided:{p10:150,median:350}}}static async audit(t,n){let a=t.traces[g.DEFAULT_PASS],o=t.devtoolsLogs[g.DEFAULT_PASS];if(!(await H.request(o,n)).find(f=>fi(f.url)))return ae.NoAdRelatedReq;let c={trace:a,devtoolsLog:o,settings:n.settings},u=[];try{u=await Ch.request(c,n)}catch{return ae.InvalidTiming}let l=0,m=new Map;for(let f of u){let y=fo(f);if(!y||!fi(y)||f.parent)continue;let v=f.duration-50;l+=v;let D=Dh(y),E=m.get(D)||0;m.set(D,E+v)}let p=[];for(let[f,y]of m.entries())p.push({name:f,blockingTime:y});p.sort((f,y)=>y.blockingTime-f.blockingTime);let h=n.options[n.settings.throttlingMethod]||n.options.provided;return{score:g.computeLogNormalScore(h,l),numericValue:l,numericUnit:"millisecond",displayValue:Rc(Do.failureDisplayValue,{timeInMs:l}),details:e.makeTableDetails(eue,p)}}},tue=pS});var Z7={};T(Z7,{default:()=>nue});var nue,Q7=b(()=>{d();nue={audits:[{path:"lighthouse-plugin-soft-navigation/audits/soft-nav-fcp"},{path:"lighthouse-plugin-soft-navigation/audits/soft-nav-lcp"}],groups:{metrics:{title:"Metrics associated with a soft navigation"}},category:{title:"Soft Navigation",supportedModes:["timespan"],auditRefs:[{id:"soft-nav-fcp",weight:1,group:"metrics"},{id:"soft-nav-lcp",weight:1,group:"metrics"}]}}});function Ph(e){let t,n,r,a;for(let c of e)switch(c.name){case"SoftNavigationHeuristics::UserInitiatedClick":n||(t=c);break;case"SoftNavigationHeuristics_SoftNavigationDetected":if(n)throw new Error("Multiple soft navigations detected");n=c;break;case"largestContentfulPaint::Candidate":t&&(r=c);break;case"firstContentfulPaint":t&&(a=c);break}if(!t)return{};let o=t.ts,i=s(c=>{if(c)return(c.ts-o)/1e3},"getTiming");return{lcpTiming:i(r),fcpTiming:i(a)}}var fS=b(()=>{d();s(Ph,"computeMetricTimings")});var e9={};T(e9,{default:()=>rue});var hS,rue,t9=b(()=>{d();ct();Nt();fS();hS=class extends g{static{s(this,"SoftNavFCP")}static get meta(){return{id:"soft-nav-fcp",title:"Soft Navigation First Contentful Paint",description:"First Contentful Paint of a soft navigation.",scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["timespan"],requiredArtifacts:["Trace"]}}static async audit(t,n){let r=t.Trace,a=await ke.request(r,n),{fcpTiming:o}=Ph(a.mainThreadEvents);return o?{numericValue:o,numericUnit:"millisecond",displayValue:`${o} ms`,score:g.computeLogNormalScore({p10:1800,median:3e3},o)}:{notApplicable:!0,score:1}}},rue=hS});var n9={};T(n9,{default:()=>aue});var gS,aue,r9=b(()=>{d();ct();Nt();fS();gS=class extends g{static{s(this,"SoftNavLCP")}static get meta(){return{id:"soft-nav-lcp",title:"Soft Navigation Largest Contentful Paint",description:"Largest Contentful Paint of a soft navigation.",scoreDisplayMode:g.SCORING_MODES.NUMERIC,supportedModes:["timespan"],requiredArtifacts:["Trace"]}}static async audit(t,n){let r=t.Trace,a=await ke.request(r,n),{lcpTiming:o}=Ph(a.mainThreadEvents);return o?{numericValue:o,numericUnit:"millisecond",displayValue:`${o} ms`,score:g.computeLogNormalScore({p10:2500,median:4e3},o)}:{notApplicable:!0,score:1}}},aue=gS});function yS(){if(globalThis.isDevtools||globalThis.isLightrider)return!0;try{return Fc.resolve("lighthouse-logger"),!1}catch{return!0}}function s9(e,t,n=!1){if(typeof e>"u"||e===null)return t;if(typeof t>"u")return e;if(Array.isArray(t)){if(n)return t;if(!Array.isArray(e))throw new TypeError(`Expected array but got ${typeof e}`);let r=e.slice();return t.forEach(a=>{r.some(o=>(0,i9.default)(o,a))||r.push(a)}),r}else if(typeof t=="object"){if(typeof e!="object")throw new TypeError(`Expected object but got ${typeof e}`);if(Array.isArray(e))throw new TypeError("Expected object but got Array");return Object.keys(t).forEach(r=>{let a=n||r==="settings"&&typeof e[r]=="object";e[r]=s9(e[r],t[r],a)}),e}return t}function c9(e,t,n){let r=new Map,a=e||[];for(let o=0;o<a.length;o++){let i=a[o];r.set(n(i),{index:o,item:i})}for(let o of t||[]){let i=r.get(n(o));if(i){let c=i.item,u=typeof o=="object"&&typeof c=="object"?Ei(c,o,!0):o;a[i.index]=u}else a.push(o)}return a}function iue(e){if(typeof e=="string")return{path:e};if("implementation"in e||"instance"in e)return e;if("path"in e){if(typeof e.path!="string")throw new Error("Invalid Gatherer type "+JSON.stringify(e));return e}else{if(typeof e=="function")return{implementation:e};if(e&&typeof e.getArtifact=="function")return{instance:e};throw new Error("Invalid Gatherer type "+JSON.stringify(e))}}function sue(e){if(typeof e=="string")return{path:e,options:{}};if("implementation"in e&&typeof e.implementation.audit=="function")return e;if("path"in e&&typeof e.path=="string")return e;if("audit"in e&&typeof e.audit=="function")return{implementation:e,options:{}};throw new Error("Invalid Audit type "+JSON.stringify(e))}async function bS(e){Dt.isAbsolute(e)&&(e=Mo.pathToFileURL(e).href);let t;if(a9.has(e)?t=await a9.get(e):e.match(/\.(js|mjs|cjs)$/)?t=await import(e):(e+=".js",t=await import(e)),t.default)return t.default;let n=new Set(["meta"]),r=Object.keys(t).filter(a=>t[a]&&t[a]instanceof Object?Object.getOwnPropertyNames(t[a]).some(o=>n.has(o)):!1);if(r.length===1)return r[0];throw r.length>1?new Error(`module '${e}' has too many possible exports`):new Error(`module '${e}' missing default export`)}async function cue(e,t,n){let r=t.find(i=>i===`${e}.js`),a=`../gather/gatherers/${e}`;r||(a=vS(e,n,"gatherer"));let o=await bS(a);return{instance:new o,implementation:o,path:e}}function uue(e,t,n){let r=`${e}.js`,a=t.find(i=>i===r),o=`../audits/${e}`;if(!a)if(yS())o=e;else{let i=vS(e,n,"audit");yS()?o=Dt.relative("",i):o=i}return bS(o)}function lue(e={}){let t={};for(let n of Object.keys(e))n in qn&&(t[n]=e[n]);return t}function u9(e={},t=void 0){let n=sp(t?.locale||e.locale),{defaultSettings:r}=xr,a=Ei(wS(r),e,!0),o=Ei(a,lue(t),!0);return o.budgets&&(o.budgets=Tr.initializeBudget(o.budgets)),o.locale=n,o.emulatedUserAgent===!0&&(o.emulatedUserAgent=Ia[o.formFactor]),$g(o),o}async function l9(e,t,n){let r=e.plugins||[],a=n?.plugins||[],o=new Set([...r,...a]);for(let i of o){yI(e,i);let c=yS()?i:vS(i,t,"plugin"),u=await bS(c),l=AI.parsePlugin(u,i);e=Ei(e,l)}return e}async function d9(e,t,n){let r=iue(e);if(r.instance)return{instance:r.instance,implementation:r.implementation,path:r.path};if(r.implementation){let a=r.implementation;return{instance:new a,implementation:r.implementation,path:r.path}}else if(r.path){let a=r.path;return cue(a,t,n)}else throw new Error("Invalid expanded Gatherer: "+JSON.stringify(r))}async function m9(e,t){if(!e)return null;let n=tn.getAuditList(),r=e.map(async i=>{let c=sue(i),u;return"implementation"in c?u=c.implementation:u=await uue(c.path,n,t),{implementation:u,path:c.path,options:c.options||{}}}),a=await Promise.all(r),o=oue(a);return o.forEach(i=>Wg(i)),o}function vS(e,t,n){try{return Fc.resolve(e)}catch{}try{return Fc.resolve(e,{paths:[process.cwd()]})}catch{}let r=Dt.resolve(process.cwd(),e);try{return Fc.resolve(r)}catch{}let a="Unable to locate "+(n?`${n}: `:"")+`\`${e}\`.
     Tried to resolve the module from these locations:
       
       ${r}`;if(!t)throw new Error(a);let o=Dt.resolve(t,e);try{return Fc.resolve(o)}catch{}try{return Fc.resolve(e,{paths:[t]})}catch{}throw new Error(a+`
       ${o}`)}function o9(e){return typeof e=="object"?Object.assign(Object.create(Object.getPrototypeOf(e)),e):e}function wS(e){return JSON.parse(JSON.stringify(e))}function DS(e){let t=wS(e);return Array.isArray(e.audits)&&(t.audits=e.audits.map(n=>o9(n))),Array.isArray(e.artifacts)&&(t.artifacts=e.artifacts.map(n=>({...n,gatherer:o9(n.gatherer)}))),t}var i9,Fc,oue,Ei,a9,ES=b(()=>{"use strict";d();Aa();Hi();mu();i9=Lt(iu(),1);zn();xu();_I();Eo();A();Kg();Lo();Fc=No("core/config/config-helpers.js");s(yS,"isBundledEnvironment");oue=s(function(e){let t=[];for(let n of e){let r=n.path&&t.find(a=>a.path===n.path);if(!r){t.push(n);continue}r.options=Object.assign({},r.options,n.options)}return t},"mergeOptionsOfItems");s(s9,"_mergeConfigFragment");Ei=s9;s(c9,"mergeConfigFragmentArrayByKey");s(iue,"expandGathererShorthand");s(sue,"expandAuditShorthand");a9=new Map([["../gather/gatherers/accessibility",Promise.resolve().then(()=>(LI(),MI))],["../gather/gatherers/anchor-elements",Promise.resolve().then(()=>(jI(),UI))],["../gather/gatherers/bf-cache-failures",Promise.resolve().then(()=>(WI(),VI))],["../gather/gatherers/cache-contents",Promise.resolve().then(()=>(YI(),$I))],["../gather/gatherers/console-messages",Promise.resolve().then(()=>(XI(),KI))],["../gather/gatherers/css-usage",Promise.resolve().then(()=>(ZI(),JI))],["../gather/gatherers/devtools-log-compat",Promise.resolve().then(()=>(eN(),QI))],["../gather/gatherers/devtools-log",Promise.resolve().then(()=>(Mn(),GI))],["../gather/gatherers/dobetterweb/doctype",Promise.resolve().then(()=>(nN(),tN))],["../gather/gatherers/dobetterweb/domstats",Promise.resolve().then(()=>(aN(),rN))],["../gather/gatherers/dobetterweb/optimized-images",Promise.resolve().then(()=>(iN(),oN))],["../gather/gatherers/dobetterweb/response-compression",Promise.resolve().then(()=>(aM(),rM))],["../gather/gatherers/dobetterweb/tags-blocking-first-paint",Promise.resolve().then(()=>(iM(),oM))],["../gather/gatherers/full-page-screenshot",Promise.resolve().then(()=>(mM(),dM))],["../gather/gatherers/global-listeners",Promise.resolve().then(()=>(fM(),pM))],["../gather/gatherers/iframe-elements",Promise.resolve().then(()=>(gM(),hM))],["../gather/gatherers/image-elements",Promise.resolve().then(()=>(EM(),DM))],["../gather/gatherers/inputs",Promise.resolve().then(()=>(TM(),xM))],["../gather/gatherers/inspector-issues",Promise.resolve().then(()=>(kM(),SM))],["../gather/gatherers/installability-errors",Promise.resolve().then(()=>(AM(),CM))],["../gather/gatherers/js-usage",Promise.resolve().then(()=>(RM(),_M))],["../gather/gatherers/link-elements",Promise.resolve().then(()=>(OM(),PM))],["../gather/gatherers/main-document-content",Promise.resolve().then(()=>(UM(),BM))],["../gather/gatherers/meta-elements",Promise.resolve().then(()=>(qM(),jM))],["../gather/gatherers/network-user-agent",Promise.resolve().then(()=>(HM(),zM))],["../gather/gatherers/script-elements",Promise.resolve().then(()=>(VM(),GM))],["../gather/gatherers/scripts",Promise.resolve().then(()=>(yb(),WM))],["../gather/gatherers/seo/embedded-content",Promise.resolve().then(()=>(YM(),$M))],["../gather/gatherers/seo/font-size",Promise.resolve().then(()=>(Qy(),Zy))],["../gather/gatherers/seo/robots-txt",Promise.resolve().then(()=>(XM(),KM))],["../gather/gatherers/seo/tap-targets",Promise.resolve().then(()=>(u3(),c3))],["../gather/gatherers/service-worker",Promise.resolve().then(()=>(f3(),p3))],["../gather/gatherers/source-maps",Promise.resolve().then(()=>(_3(),A3))],["../gather/gatherers/stacks",Promise.resolve().then(()=>(F3(),R3))],["../gather/gatherers/trace-compat",Promise.resolve().then(()=>(N3(),I3))],["../gather/gatherers/trace-elements",Promise.resolve().then(()=>(P3(),L3))],["../gather/gatherers/trace",Promise.resolve().then(()=>(Mi(),L2))],["../gather/gatherers/viewport-dimensions",Promise.resolve().then(()=>(B3(),O3))],["../gather/gatherers/web-app-manifest",Promise.resolve().then(()=>(H3(),z3))],["../audits/accessibility/accesskeys",Promise.resolve().then(()=>(W3(),V3))],["../audits/accessibility/aria-allowed-attr",Promise.resolve().then(()=>(Y3(),$3))],["../audits/accessibility/aria-allowed-role",Promise.resolve().then(()=>(X3(),K3))],["../audits/accessibility/aria-command-name",Promise.resolve().then(()=>(Z3(),J3))],["../audits/accessibility/aria-dialog-name",Promise.resolve().then(()=>(eL(),Q3))],["../audits/accessibility/aria-hidden-body",Promise.resolve().then(()=>(nL(),tL))],["../audits/accessibility/aria-hidden-focus",Promise.resolve().then(()=>(aL(),rL))],["../audits/accessibility/aria-input-field-name",Promise.resolve().then(()=>(iL(),oL))],["../audits/accessibility/aria-meter-name",Promise.resolve().then(()=>(cL(),sL))],["../audits/accessibility/aria-progressbar-name",Promise.resolve().then(()=>(lL(),uL))],["../audits/accessibility/aria-required-attr",Promise.resolve().then(()=>(mL(),dL))],["../audits/accessibility/aria-required-children",Promise.resolve().then(()=>(fL(),pL))],["../audits/accessibility/aria-required-parent",Promise.resolve().then(()=>(gL(),hL))],["../audits/accessibility/aria-roles",Promise.resolve().then(()=>(bL(),yL))],["../audits/accessibility/aria-text",Promise.resolve().then(()=>(wL(),vL))],["../audits/accessibility/aria-toggle-field-name",Promise.resolve().then(()=>(EL(),DL))],["../audits/accessibility/aria-tooltip-name",Promise.resolve().then(()=>(TL(),xL))],["../audits/accessibility/aria-treeitem-name",Promise.resolve().then(()=>(kL(),SL))],["../audits/accessibility/aria-valid-attr-value",Promise.resolve().then(()=>(AL(),CL))],["../audits/accessibility/aria-valid-attr",Promise.resolve().then(()=>(RL(),_L))],["../audits/accessibility/button-name",Promise.resolve().then(()=>(IL(),FL))],["../audits/accessibility/bypass",Promise.resolve().then(()=>(ML(),NL))],["../audits/accessibility/color-contrast",Promise.resolve().then(()=>(PL(),LL))],["../audits/accessibility/definition-list",Promise.resolve().then(()=>(BL(),OL))],["../audits/accessibility/dlitem",Promise.resolve().then(()=>(jL(),UL))],["../audits/accessibility/document-title",Promise.resolve().then(()=>(zL(),qL))],["../audits/accessibility/duplicate-id-active",Promise.resolve().then(()=>(GL(),HL))],["../audits/accessibility/duplicate-id-aria",Promise.resolve().then(()=>(WL(),VL))],["../audits/accessibility/empty-heading",Promise.resolve().then(()=>(YL(),$L))],["../audits/accessibility/form-field-multiple-labels",Promise.resolve().then(()=>(XL(),KL))],["../audits/accessibility/frame-title",Promise.resolve().then(()=>(ZL(),JL))],["../audits/accessibility/heading-order",Promise.resolve().then(()=>(e8(),QL))],["../audits/accessibility/html-has-lang",Promise.resolve().then(()=>(n8(),t8))],["../audits/accessibility/html-lang-valid",Promise.resolve().then(()=>(a8(),r8))],["../audits/accessibility/html-xml-lang-mismatch",Promise.resolve().then(()=>(i8(),o8))],["../audits/accessibility/identical-links-same-purpose",Promise.resolve().then(()=>(c8(),s8))],["../audits/accessibility/image-alt",Promise.resolve().then(()=>(l8(),u8))],["../audits/accessibility/image-redundant-alt",Promise.resolve().then(()=>(m8(),d8))],["../audits/accessibility/input-button-name",Promise.resolve().then(()=>(f8(),p8))],["../audits/accessibility/input-image-alt",Promise.resolve().then(()=>(g8(),h8))],["../audits/accessibility/label-content-name-mismatch",Promise.resolve().then(()=>(b8(),y8))],["../audits/accessibility/label",Promise.resolve().then(()=>(w8(),v8))],["../audits/accessibility/landmark-one-main",Promise.resolve().then(()=>(E8(),D8))],["../audits/accessibility/link-in-text-block",Promise.resolve().then(()=>(T8(),x8))],["../audits/accessibility/link-name",Promise.resolve().then(()=>(k8(),S8))],["../audits/accessibility/list",Promise.resolve().then(()=>(A8(),C8))],["../audits/accessibility/listitem",Promise.resolve().then(()=>(R8(),_8))],["../audits/accessibility/manual/custom-controls-labels",Promise.resolve().then(()=>(I8(),F8))],["../audits/accessibility/manual/custom-controls-roles",Promise.resolve().then(()=>(M8(),N8))],["../audits/accessibility/manual/focus-traps",Promise.resolve().then(()=>(P8(),L8))],["../audits/accessibility/manual/focusable-controls",Promise.resolve().then(()=>(B8(),O8))],["../audits/accessibility/manual/interactive-element-affordance",Promise.resolve().then(()=>(j8(),U8))],["../audits/accessibility/manual/logical-tab-order",Promise.resolve().then(()=>(z8(),q8))],["../audits/accessibility/manual/managed-focus",Promise.resolve().then(()=>(G8(),H8))],["../audits/accessibility/manual/offscreen-content-hidden",Promise.resolve().then(()=>(W8(),V8))],["../audits/accessibility/manual/use-landmarks",Promise.resolve().then(()=>(Y8(),$8))],["../audits/accessibility/manual/visual-order-follows-dom",Promise.resolve().then(()=>(X8(),K8))],["../audits/accessibility/meta-refresh",Promise.resolve().then(()=>(Z8(),J8))],["../audits/accessibility/meta-viewport",Promise.resolve().then(()=>(eP(),Q8))],["../audits/accessibility/object-alt",Promise.resolve().then(()=>(nP(),tP))],["../audits/accessibility/select-name",Promise.resolve().then(()=>(aP(),rP))],["../audits/accessibility/skip-link",Promise.resolve().then(()=>(iP(),oP))],["../audits/accessibility/tabindex",Promise.resolve().then(()=>(cP(),sP))],["../audits/accessibility/table-duplicate-name",Promise.resolve().then(()=>(lP(),uP))],["../audits/accessibility/table-fake-caption",Promise.resolve().then(()=>(mP(),dP))],["../audits/accessibility/target-size",Promise.resolve().then(()=>(fP(),pP))],["../audits/accessibility/td-has-header",Promise.resolve().then(()=>(gP(),hP))],["../audits/accessibility/td-headers-attr",Promise.resolve().then(()=>(bP(),yP))],["../audits/accessibility/th-has-data-cells",Promise.resolve().then(()=>(wP(),vP))],["../audits/accessibility/valid-lang",Promise.resolve().then(()=>(EP(),DP))],["../audits/accessibility/video-caption",Promise.resolve().then(()=>(TP(),xP))],["../audits/autocomplete",Promise.resolve().then(()=>(CP(),kP))],["../audits/bf-cache",Promise.resolve().then(()=>(FP(),RP))],["../audits/bootup-time",Promise.resolve().then(()=>(LP(),MP))],["../audits/byte-efficiency/duplicated-javascript",Promise.resolve().then(()=>(UP(),BP))],["../audits/byte-efficiency/efficient-animated-content",Promise.resolve().then(()=>(qP(),jP))],["../audits/byte-efficiency/legacy-javascript",Promise.resolve().then(()=>(n5(),t5))],["../audits/byte-efficiency/modern-image-formats",Promise.resolve().then(()=>(a5(),r5))],["../audits/byte-efficiency/offscreen-images",Promise.resolve().then(()=>(u5(),c5))],["../audits/byte-efficiency/render-blocking-resources",Promise.resolve().then(()=>(m5(),d5))],["../audits/byte-efficiency/total-byte-weight",Promise.resolve().then(()=>(f5(),p5))],["../audits/byte-efficiency/unminified-css",Promise.resolve().then(()=>(v5(),b5))],["../audits/byte-efficiency/unminified-javascript",Promise.resolve().then(()=>(D5(),w5))],["../audits/byte-efficiency/unused-css-rules",Promise.resolve().then(()=>(x5(),E5))],["../audits/byte-efficiency/unused-javascript",Promise.resolve().then(()=>(S5(),T5))],["../audits/byte-efficiency/uses-long-cache-ttl",Promise.resolve().then(()=>(sD(),_5))],["../audits/byte-efficiency/uses-optimized-images",Promise.resolve().then(()=>(F5(),R5))],["../audits/byte-efficiency/uses-responsive-images-snapshot",Promise.resolve().then(()=>(L5(),M5))],["../audits/byte-efficiency/uses-responsive-images",Promise.resolve().then(()=>(pD(),mD))],["../audits/byte-efficiency/uses-text-compression",Promise.resolve().then(()=>(O5(),P5))],["../audits/content-width",Promise.resolve().then(()=>(U5(),B5))],["../audits/critical-request-chains",Promise.resolve().then(()=>(q5(),j5))],["../audits/csp-xss",Promise.resolve().then(()=>(hO(),fO))],["../audits/deprecations",Promise.resolve().then(()=>(DO(),wO))],["../audits/diagnostics",Promise.resolve().then(()=>(xO(),EO))],["../audits/dobetterweb/charset",Promise.resolve().then(()=>(CO(),kO))],["../audits/dobetterweb/doctype",Promise.resolve().then(()=>(_O(),AO))],["../audits/dobetterweb/dom-size",Promise.resolve().then(()=>(FO(),RO))],["../audits/dobetterweb/geolocation-on-start",Promise.resolve().then(()=>(NO(),IO))],["../audits/dobetterweb/inspector-issues",Promise.resolve().then(()=>(LO(),MO))],["../audits/dobetterweb/js-libraries",Promise.resolve().then(()=>(OO(),PO))],["../audits/dobetterweb/no-document-write",Promise.resolve().then(()=>(UO(),BO))],["../audits/dobetterweb/notification-on-start",Promise.resolve().then(()=>(qO(),jO))],["../audits/dobetterweb/paste-preventing-inputs",Promise.resolve().then(()=>(HO(),zO))],["../audits/dobetterweb/uses-http2",Promise.resolve().then(()=>(VO(),GO))],["../audits/dobetterweb/uses-passive-event-listeners",Promise.resolve().then(()=>($O(),WO))],["../audits/errors-in-console",Promise.resolve().then(()=>(KO(),YO))],["../audits/final-screenshot",Promise.resolve().then(()=>(QO(),ZO))],["../audits/font-display",Promise.resolve().then(()=>(eE(),t6))],["../audits/image-aspect-ratio",Promise.resolve().then(()=>(a6(),r6))],["../audits/image-size-responsive",Promise.resolve().then(()=>(s6(),i6))],["../audits/installable-manifest",Promise.resolve().then(()=>(p6(),m6))],["../audits/is-on-https",Promise.resolve().then(()=>(g6(),h6))],["../audits/largest-contentful-paint-element",Promise.resolve().then(()=>(v6(),b6))],["../audits/layout-shift-elements",Promise.resolve().then(()=>(x6(),E6))],["../audits/lcp-lazy-loaded",Promise.resolve().then(()=>(S6(),T6))],["../audits/long-tasks",Promise.resolve().then(()=>(C6(),k6))],["../audits/main-thread-tasks",Promise.resolve().then(()=>(_6(),A6))],["../audits/mainthread-work-breakdown",Promise.resolve().then(()=>(F6(),R6))],["../audits/manual/pwa-cross-browser",Promise.resolve().then(()=>(M6(),N6))],["../audits/manual/pwa-each-page-has-url",Promise.resolve().then(()=>(O6(),P6))],["../audits/manual/pwa-page-transitions",Promise.resolve().then(()=>(j6(),U6))],["../audits/maskable-icon",Promise.resolve().then(()=>(z6(),q6))],["../audits/metrics",Promise.resolve().then(()=>(f4(),p4))],["../audits/metrics/cumulative-layout-shift",Promise.resolve().then(()=>(DE(),D6))],["../audits/metrics/first-contentful-paint",Promise.resolve().then(()=>(g4(),h4))],["../audits/metrics/first-meaningful-paint",Promise.resolve().then(()=>(b4(),y4))],["../audits/metrics/interaction-to-next-paint",Promise.resolve().then(()=>(mx(),v4))],["../audits/metrics/interactive",Promise.resolve().then(()=>(D4(),w4))],["../audits/metrics/largest-contentful-paint",Promise.resolve().then(()=>(pE(),y6))],["../audits/metrics/max-potential-fid",Promise.resolve().then(()=>(x4(),E4))],["../audits/metrics/speed-index",Promise.resolve().then(()=>(S4(),T4))],["../audits/metrics/total-blocking-time",Promise.resolve().then(()=>(C4(),k4))],["../audits/network-requests",Promise.resolve().then(()=>(_4(),A4))],["../audits/network-rtt",Promise.resolve().then(()=>(F4(),R4))],["../audits/network-server-latency",Promise.resolve().then(()=>(N4(),I4))],["../audits/no-unload-listeners",Promise.resolve().then(()=>(L4(),M4))],["../audits/non-composited-animations",Promise.resolve().then(()=>(O4(),P4))],["../audits/oopif-iframe-test-audit",Promise.resolve().then(()=>(U4(),B4))],["../audits/performance-budget",Promise.resolve().then(()=>(q4(),j4))],["../audits/predictive-perf",Promise.resolve().then(()=>(H4(),z4))],["../audits/preload-fonts",Promise.resolve().then(()=>(V4(),G4))],["../audits/prioritize-lcp-image",Promise.resolve().then(()=>($4(),W4))],["../audits/redirects",Promise.resolve().then(()=>(K4(),Y4))],["../audits/resource-summary",Promise.resolve().then(()=>(J4(),X4))],["../audits/screenshot-thumbnails",Promise.resolve().then(()=>(eB(),Q4))],["../audits/script-elements-test-audit",Promise.resolve().then(()=>(nB(),tB))],["../audits/script-treemap-data",Promise.resolve().then(()=>(aB(),rB))],["../audits/seo/canonical",Promise.resolve().then(()=>(iB(),oB))],["../audits/seo/crawlable-anchors",Promise.resolve().then(()=>(cB(),sB))],["../audits/seo/font-size",Promise.resolve().then(()=>(pB(),mB))],["../audits/seo/hreflang",Promise.resolve().then(()=>(yB(),gB))],["../audits/seo/http-status-code",Promise.resolve().then(()=>(vB(),bB))],["../audits/seo/is-crawlable",Promise.resolve().then(()=>(IB(),FB))],["../audits/seo/link-text",Promise.resolve().then(()=>(MB(),NB))],["../audits/seo/manual/structured-data",Promise.resolve().then(()=>(OB(),PB))],["../audits/seo/meta-description",Promise.resolve().then(()=>(UB(),BB))],["../audits/seo/plugins",Promise.resolve().then(()=>(HB(),zB))],["../audits/seo/robots-txt",Promise.resolve().then(()=>(WB(),VB))],["../audits/seo/tap-targets",Promise.resolve().then(()=>(JB(),XB))],["../audits/server-response-time",Promise.resolve().then(()=>(QB(),ZB))],["../audits/splash-screen",Promise.resolve().then(()=>(tU(),eU))],["../audits/themed-omnibox",Promise.resolve().then(()=>(rU(),nU))],["../audits/third-party-cookies",Promise.resolve().then(()=>(oU(),aU))],["../audits/third-party-facades",Promise.resolve().then(()=>(cU(),sU))],["../audits/third-party-summary",Promise.resolve().then(()=>(yT(),iU))],["../audits/timing-budget",Promise.resolve().then(()=>(lU(),uU))],["../audits/unsized-images",Promise.resolve().then(()=>(mU(),dU))],["../audits/user-timings",Promise.resolve().then(()=>(gU(),hU))],["../audits/uses-rel-preconnect",Promise.resolve().then(()=>(bU(),yU))],["../audits/uses-rel-preload",Promise.resolve().then(()=>(wU(),vU))],["../audits/valid-source-maps",Promise.resolve().then(()=>(EU(),DU))],["../audits/viewport",Promise.resolve().then(()=>(TU(),xU))],["../audits/work-during-interaction",Promise.resolve().then(()=>(kU(),SU))],["lighthouse-plugin-publisher-ads",Promise.resolve().then(()=>(_U(),AU))],["lighthouse-plugin-publisher-ads/audits/ad-blocking-tasks",Promise.resolve().then(()=>(WU(),VU))],["lighthouse-plugin-publisher-ads/audits/ad-render-blocking-resources",Promise.resolve().then(()=>(YU(),$U))],["lighthouse-plugin-publisher-ads/audits/ad-request-critical-path",Promise.resolve().then(()=>(ZU(),JU))],["lighthouse-plugin-publisher-ads/audits/bid-request-from-page-start",Promise.resolve().then(()=>(n7(),t7))],["lighthouse-plugin-publisher-ads/audits/ad-request-from-page-start",Promise.resolve().then(()=>(a7(),r7))],["lighthouse-plugin-publisher-ads/audits/ad-top-of-viewport",Promise.resolve().then(()=>(i7(),o7))],["lighthouse-plugin-publisher-ads/audits/ads-in-viewport",Promise.resolve().then(()=>(l7(),u7))],["lighthouse-plugin-publisher-ads/audits/async-ad-tags",Promise.resolve().then(()=>(f7(),p7))],["lighthouse-plugin-publisher-ads/audits/blocking-load-events",Promise.resolve().then(()=>(y7(),g7))],["lighthouse-plugin-publisher-ads/audits/bottleneck-requests",Promise.resolve().then(()=>(v7(),b7))],["lighthouse-plugin-publisher-ads/audits/duplicate-tags",Promise.resolve().then(()=>(D7(),w7))],["lighthouse-plugin-publisher-ads/audits/first-ad-render",Promise.resolve().then(()=>(S7(),T7))],["lighthouse-plugin-publisher-ads/audits/full-width-slots",Promise.resolve().then(()=>(C7(),k7))],["lighthouse-plugin-publisher-ads/audits/gpt-bids-parallel",Promise.resolve().then(()=>(_7(),A7))],["lighthouse-plugin-publisher-ads/audits/loads-gpt-from-official-source",Promise.resolve().then(()=>(F7(),R7))],["lighthouse-plugin-publisher-ads/audits/loads-ad-tag-over-https",Promise.resolve().then(()=>(N7(),I7))],["lighthouse-plugin-publisher-ads/audits/script-injected-tags",Promise.resolve().then(()=>(L7(),M7))],["lighthouse-plugin-publisher-ads/audits/serial-header-bidding",Promise.resolve().then(()=>(O7(),P7))],["lighthouse-plugin-publisher-ads/audits/tag-load-time",Promise.resolve().then(()=>(q7(),j7))],["lighthouse-plugin-publisher-ads/audits/viewport-ad-density",Promise.resolve().then(()=>(H7(),z7))],["lighthouse-plugin-publisher-ads/audits/cumulative-ad-shift",Promise.resolve().then(()=>(V7(),G7))],["lighthouse-plugin-publisher-ads/audits/deprecated-api-usage",Promise.resolve().then(()=>($7(),W7))],["lighthouse-plugin-publisher-ads/audits/gpt-errors-overall",Promise.resolve().then(()=>(K7(),Y7))],["lighthouse-plugin-publisher-ads/audits/total-ad-blocking-time",Promise.resolve().then(()=>(J7(),X7))],["lighthouse-plugin-soft-navigation",Promise.resolve().then(()=>(Q7(),Z7))],["lighthouse-plugin-soft-navigation/audits/soft-nav-fcp",Promise.resolve().then(()=>(t9(),e9))],["lighthouse-plugin-soft-navigation/audits/soft-nav-lcp",Promise.resolve().then(()=>(r9(),n9))]]);s(bS,"requireWrapper");s(cue,"requireGatherer");s(uue,"requireAudit");s(lue,"cleanFlagsForSettings");s(u9,"resolveSettings");s(l9,"mergePlugins");s(d9,"resolveGathererToDefn");s(m9,"resolveAuditsToDefns");s(vS,"resolveModulePath");s(o9,"shallowClone");s(wS,"deepClone");s(DS,"deepCloneConfigJson")});function mue(e,t){let{configPath:n}=t;if(n&&!Dt.isAbsolute(n))throw new Error("configPath must be an absolute path");e||(e=Tp,n=due);let r=n?Dt.dirname(n):void 0;return{configWorkingCopy:DS(e),configPath:n,configDir:r}}function pue(e){if(!e.extends)return e;if(e.extends!=="lighthouse:default")throw new Error("`lighthouse:default` is the only valid extension method.");let{artifacts:t,...n}=e,r=DS(Tp),a=Ei(r,n);return a.artifacts=c9(r.artifacts,t,o=>o.id),a}function fue(e,t,n){if(!("dependencies"in t.instance.meta))return;let r=Object.entries(t.instance.meta.dependencies).map(([a,o])=>{let i=n.get(o);return i||Yg(e.id,a),gI(t,i.gatherer)||vI(e.id,a),[a,{id:i.id}]});return Object.fromEntries(r)}async function hue(e,t){if(!e)return null;let n={msg:"Resolve artifact definitions",id:"lh:config:resolveArtifactsToDefns"};F.time(n,"verbose");let r=[...e];r.sort((c,u)=>{let l=p9[c.id]||0,m=p9[u.id]||0;return l-m});let a=new Map,o=tn.getGathererList(),i=[];for(let c of r){let u=c.gatherer,l=await d9(u,o,t),m={id:c.id,gatherer:l,dependencies:fue(c,l,a)},p=m.gatherer.instance.meta.symbol;p&&a.set(p,m),i.push(m)}return F.timeEnd(n),i}function gue(e,t){t==="timespan"&&e.throttlingMethod==="simulate"&&(e.throttlingMethod="devtools")}function yue(e){e.throttlingMethod!=="simulate"&&(e.cpuQuietThresholdMs=Math.max(e.cpuQuietThresholdMs||0,Ji.cpuQuietThresholdMs),e.networkQuietThresholdMs=Math.max(e.networkQuietThresholdMs||0,Ji.networkQuietThresholdMs),e.pauseAfterFcpMs=Math.max(e.pauseAfterFcpMs||0,Ji.pauseAfterFcpMs),e.pauseAfterLoadMs=Math.max(e.pauseAfterLoadMs||0,Ji.pauseAfterLoadMs))}async function Da(e,t,n={}){let r={msg:"Initialize config",id:"lh:config"};F.time(r,"verbose");let{configWorkingCopy:a,configDir:o}=mue(t,n);a=pue(a),a=await l9(a,o,n);let i=u9(a.settings||{},n);gue(i,e),yue(i);let u={artifacts:await hue(a.artifacts,o),audits:await m9(a.audits,o),categories:a.categories||null,groups:a.groups||null,settings:i};return bI(u),u=EI(u,e),u=xI(u,i),F.timeEnd(r),{resolvedConfig:u}}var due,p9,Ic=b(()=>{"use strict";d();Aa();Ae();Eo();Vg();zn();Kg();TI();ES();Lo();Qr();due=Dt.join("","../../config/default-config.js"),p9={FullPageScreenshot:1,BFCacheFailures:1};s(mue,"resolveWorkingCopy");s(pue,"resolveExtensions");s(fue,"resolveArtifactDependencies");s(hue,"resolveArtifactsToDefns");s(gue,"overrideSettingsForGatherMode");s(yue,"overrideThrottlingWindows");s(Da,"initializeConfig")});var f9={};T(f9,{default:()=>bue});var bue,h9=b(()=>{d();bue={}});async function Due(e){if(e.flags.enableErrorReporting&&Nc._shouldSample())try{let t=await Promise.resolve().then(()=>(h9(),f9));t.init({...e.environmentData,dsn:vue});let n=e.flags;try{let{resolvedConfig:i}=await Da("navigation",e.config,e.flags);n=i.settings}catch{}let r={channel:n.channel,formFactor:n.formFactor,throttlingMethod:n.throttlingMethod};t.setTags(r);let a={...n.throttling,url:e.url};t.setExtras(a),Nc.captureMessage=(...i)=>t.captureMessage(...i),Nc.captureBreadcrumb=(...i)=>t.addBreadcrumb(...i),Nc.getContext=()=>a;let o=new Map;Nc.captureException=async(i,c={})=>{if(!i||i.expected)return;let u=c.tags||{};if(u.audit){let l=`audit-${u.audit}-${i.message}`;if(o.has(l))return;o.set(l,!0)}if(u.gatherer){let l=`gatherer-${u.gatherer}-${i.message}`;if(o.has(l))return;o.set(l,!0)}i.protocolMethod&&(c.fingerprint=["{{ default }}",i.protocolMethod,i.protocolError],c.tags=c.tags||{},c.tags.protocolMethod=i.protocolMethod),t.withScope(l=>{c.level&&l.setLevel(c.level),c.tags&&l.setTags(c.tags);let m;c.extra&&(m={...c.extra}),i.extra&&(m={...m,...i.extra}),m&&l.setExtras(m),t.captureException(i)})}}catch{F.warn("sentry","Could not load Sentry, errors will not be reported.")}}var vue,wue,xS,Nc,Rt,or=b(()=>{"use strict";d();Ae();Ic();vue="https://a6bb0da87ee048cc9ae2a345fc09ab2e:63a7029f46f74265981b7e005e0f69f8@sentry.io/174697",wue=.01,xS=s(()=>{},"noop"),Nc={init:Due,captureMessage:xS,captureBreadcrumb:xS,getContext:xS,captureException:async()=>{},_shouldSample(){return wue>=Math.random()}};s(Due,"init");Rt=Nc});var Mc,g9=b(()=>{d();Mc={}});var Lc,Oh=b(()=>{"use strict";d();g9();Lc=class e{static{s(this,"ReportGenerator")}static replaceStrings(t,n){if(n.length===0)return t;let r=n[0],a=n.slice(1);return t.split(r.search).map(o=>e.replaceStrings(o,a)).join(r.replacement)}static sanitizeJson(t){return JSON.stringify(t).replace(/</g,"\\u003c").replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}static generateReportHtml(t){let n=e.sanitizeJson(t),r=Mc.REPORT_JAVASCRIPT.replace(/<\//g,"\\u003c/");return e.replaceStrings(Mc.REPORT_TEMPLATE,[{search:"%%LIGHTHOUSE_JSON%%",replacement:n},{search:"%%LIGHTHOUSE_JAVASCRIPT%%",replacement:r}])}static generateFlowReportHtml(t){let n=e.sanitizeJson(t),r=Mc.FLOW_REPORT_JAVASCRIPT.replace(/<\//g,"\\u003c/");return e.replaceStrings(Mc.FLOW_REPORT_TEMPLATE,[{search:"%%LIGHTHOUSE_FLOW_JSON%%",replacement:n},{search:"%%LIGHTHOUSE_FLOW_JAVASCRIPT%%",replacement:r},{search:"/*%%LIGHTHOUSE_FLOW_CSS%%*/",replacement:Mc.FLOW_REPORT_CSS}])}static generateReportCSV(t){let n=`\r
`,r=",",a=s(u=>`"${u.replace(/"/g,'""')}"`,"escape"),o=s(u=>u.map(l=>l===null?"null":l.toString()).map(a),"rowFormatter"),i=[],c=["requestedUrl","finalDisplayedUrl","fetchTime","gatherMode"];i.push(o(c)),i.push(o(c.map(u=>t[u]??null))),i.push([]),i.push(["category","score"]);for(let u of Object.values(t.categories))i.push(o([u.id,u.score]));i.push([]),i.push(["category","audit","score","displayValue","description"]);for(let u of Object.values(t.categories))for(let l of u.auditRefs){let m=t.audits[l.id];m&&i.push(o([u.id,l.id,m.score,m.displayValue||"",m.description]))}return i.map(u=>u.join(r)).join(n)}static isFlowResult(t){return"steps"in t}static generateReport(t,n){let r=Array.isArray(n);typeof n=="string"&&(n=[n]);let a=n.map(o=>{if(o==="html")return e.isFlowResult(t)?e.generateFlowReportHtml(t):e.generateReportHtml(t);if(o==="csv"){if(e.isFlowResult(t))throw new Error("CSV output is not support for user flows");return e.generateReportCSV(t)}if(o==="json")return JSON.stringify(t,null,2);throw new Error("Invalid output mode: "+o)});return r?a:a[0]}}});var TS,tn,Eo=b(()=>{"use strict";d();Jr();Aa();Ae();TS=Lt(iu(),1);y_();V();Qr();JR();mI();or();Oh();It();Wi();Lo();ua();Ze();tn=class e{static{s(this,"Runner")}static async audit(t,n){let{resolvedConfig:r,computedCache:a}=n,o=r.settings;try{let i={msg:"Audit phase",id:"lh:runner:audit"};F.time(i,"verbose");let c=[];if(o.gatherMode&&!o.auditMode)return;if(!r.audits)throw new Error("No audits to evaluate.");let u=await e._runAudits(o,r.audits,t,c,a),l={msg:"Generating results...",id:"lh:runner:generate"};F.time(l),t.LighthouseRunWarnings&&c.push(...t.LighthouseRunWarnings);let p={"axe-core":t.Accessibility?.version},h={};r.categories&&(h=Wm.scoreAllCategories(r.categories,u)),F.timeEnd(l),F.timeEnd(i);let f=t.FullPageScreenshot;(r.settings.disableFullPageScreenshot||f instanceof Error)&&(f=void 0);let y={lighthouseVersion:ip,requestedUrl:t.URL.requestedUrl,mainDocumentUrl:t.URL.mainDocumentUrl,finalDisplayedUrl:t.URL.finalDisplayedUrl,finalUrl:t.URL.mainDocumentUrl,fetchTime:t.fetchTime,gatherMode:t.GatherContext.gatherMode,runtimeError:e.getArtifactRuntimeError(t),runWarnings:c,userAgent:t.HostUserAgent,environment:{networkUserAgent:t.NetworkUserAgent,hostUserAgent:t.HostUserAgent,benchmarkIndex:t.BenchmarkIndex,benchmarkIndexes:t.BenchmarkIndexes,credits:p},audits:u,configSettings:o,categories:h,categoryGroups:r.groups||void 0,stackPacks:XR(t.Stacks),entities:await e.getEntityClassification(t,{computedCache:a}),fullPageScreenshot:f,timing:this._getTiming(t),i18n:{rendererFormattedStrings:uR(o.locale),icuMessagePaths:{}}};y.i18n.icuMessagePaths=Z1(y,o.locale);let v=y;if(o.auditMode){let E=e._getDataSavePath(o);lI(v,E)}let D=Lc.generateReport(v,o.output);return{lhr:v,artifacts:t,report:D}}catch(i){throw e.createRunnerError(i,o)}}static async getEntityClassification(t,n){let r=t.devtoolsLogs?.[g.DEFAULT_PASS];if(!r)return;let a=await ln.request({URL:t.URL,devtoolsLog:r},n),o=[];for(let[i,c]of a.urlsByEntity){let u=new Set;for(let m of c){let p=Y.getOrigin(m);p&&u.add(p)}let l={name:i.name,homepage:i.homepage,origins:[...u]};i===a.firstParty&&(l.isFirstParty=!0),i.isUnrecognized&&(l.isUnrecognized=!0),i.category&&(l.category=i.category),o.push(l)}return o}static async gather(t,n){let r=n.resolvedConfig.settings;try{let a=Rt.getContext();Rt.captureBreadcrumb({message:"Run started",category:"lifecycle",data:a});let o;if(r.auditMode&&!r.gatherMode){let i=this._getDataSavePath(r);o=cI(i)}else{let i={msg:"Gather phase",id:"lh:runner:gather"};if(F.time(i,"verbose"),o=await t({resolvedConfig:n.resolvedConfig}),F.timeEnd(i),o.Timing=F.takeTimeEntries(),r.gatherMode){let c=this._getDataSavePath(r);await uI(o,c)}}return o}catch(a){throw e.createRunnerError(a,r)}}static createRunnerError(t,n){return t.friendlyMessage&&(t.friendlyMessage=Po(t.friendlyMessage,n.locale)),Rt.captureException(t,{level:"fatal"}),t}static _getTiming(t){let n=t.Timing||[],r=F.takeTimeEntries(),a=[...n,...r].map(m=>[`${m.startTime}-${m.name}-${m.duration}`,m]),o=Array.from(new Map(a).values()).map(m=>({startTime:parseFloat(m.startTime.toFixed(2)),name:m.name,duration:parseFloat(m.duration.toFixed(2)),entryType:m.entryType})).sort((m,p)=>m.startTime-p.startTime),i=o.find(m=>m.name==="lh:runner:gather"),c=o.find(m=>m.name==="lh:runner:audit"),u=i?.duration||0,l=c?.duration||0;return{entries:o,total:u+l}}static async _runAudits(t,n,r,a,o){let i={msg:"Analyzing and running audits...",id:"lh:runner:auditing"};if(F.time(i),r.settings){let l={locale:void 0,gatherMode:void 0,auditMode:void 0,output:void 0,channel:void 0,budgets:void 0},m=Object.assign({},r.settings,l),p=Object.assign({},t,l),h=new Set([...Object.keys(m),...Object.keys(p)]);for(let f of h)if(!(0,TS.default)(m[f],p[f]))throw new Error(`Cannot change settings between gathering and auditing…
Difference found at: \`${f}\`
    ${m[f]}
vs
    ${p[f]}`);if(!(0,TS.default)(m,p))throw new Error("Cannot change settings between gathering and auditing")}let c={settings:t,computedCache:o},u={};for(let l of n){let m=l.implementation.meta.id,p=await e._runAudit(l,r,c,a);u[m]=p}return F.timeEnd(i),u}static async _runAudit(t,n,r,a){let o=t.implementation,i={msg:`Auditing: ${Po(o.meta.title,"en-US")}`,id:`lh:audit:${o.meta.id}`};F.time(i);let c;try{if(n.PageLoadError)throw n.PageLoadError;for(let f of o.meta.requiredArtifacts){let y=n[f]===void 0,v=f==="traces"&&!n.traces?.[g.DEFAULT_PASS],D=f==="devtoolsLogs"&&!n.devtoolsLogs?.[g.DEFAULT_PASS];if(y||v||D)throw F.warn("Runner",`${f} gatherer, required by audit ${o.meta.id}, did not run.`),new j(j.errors.MISSING_REQUIRED_ARTIFACT,{artifactName:f});if(n[f]instanceof Error){let E=n[f];F.warn("Runner",`${f} gatherer, required by audit ${o.meta.id}, encountered an error: ${E.message}`);let S=new j(j.errors.ERRORED_REQUIRED_ARTIFACT,{artifactName:f,errorMessage:E.message},{cause:E});throw S.expected=!0,S}}let l={options:Object.assign({},o.defaultOptions,t.options),...r},p=o.meta.requiredArtifacts.concat(o.meta.__internalOptionalArtifacts||[]).reduce((f,y)=>{let v=n[y];return f[y]=v,f},{}),h=await o.audit(p,l);a.push(...h.runWarnings||[]),c=g.generateAuditResult(o,h)}catch(u){u.code!=="MISSING_REQUIRED_ARTIFACT"&&u.code!=="ERRORED_REQUIRED_ARTIFACT"&&F.warn(o.meta.id,`Caught exception: ${u.message}`),Rt.captureException(u,{tags:{audit:o.meta.id},level:"error"});let l=u.friendlyMessage?u.friendlyMessage:u.message,m=u.cause?.stack??u.stack;c=g.generateErrorAuditResult(o,l,m)}return F.timeEnd(i),c}static getArtifactRuntimeError(t){let n=[t.PageLoadError,...Object.values(t)];for(let r of n)if(r instanceof j&&r.lhrRuntimeError){let o=r.friendlyMessage||r.message;return{code:r.code,message:o}}}static getAuditList(){let t=["audit.js","violation-audit.js","accessibility/axe-audit.js","multi-check-audit.js","byte-efficiency/byte-efficiency-audit.js","manual/manual-audit.js"];return["accessibility","audit.js","autocomplete.js","bf-cache.js","bootup-time.js","byte-efficiency","content-width.js","critical-request-chains.js","csp-xss.js","deprecations.js","diagnostics.js","dobetterweb","errors-in-console.js","final-screenshot.js","font-display.js","image-aspect-ratio.js","image-size-responsive.js","installable-manifest.js","is-on-https.js","largest-contentful-paint-element.js","layout-shift-elements.js","lcp-lazy-loaded.js","long-tasks.js","main-thread-tasks.js","mainthread-work-breakdown.js","manual","maskable-icon.js","metrics","metrics.js","multi-check-audit.js","network-requests.js","network-rtt.js","network-server-latency.js","no-unload-listeners.js","non-composited-animations.js","oopif-iframe-test-audit.js","performance-budget.js","predictive-perf.js","preload-fonts.js","prioritize-lcp-image.js","redirects.js","resource-summary.js","screenshot-thumbnails.js","script-elements-test-audit.js","script-treemap-data.js","seo","server-response-time.js","splash-screen.js","themed-omnibox.js","third-party-cookies.js","third-party-facades.js","third-party-summary.js","timing-budget.js","unsized-images.js","user-timings.js","uses-rel-preconnect.js","uses-rel-preload.js","valid-source-maps.js","viewport.js","violation-audit.js","work-during-interaction.js",...["charset.js","doctype.js","dom-size.js","geolocation-on-start.js","inspector-issues.js","js-libraries.js","no-document-write.js","notification-on-start.js","paste-preventing-inputs.js","uses-http2.js","uses-passive-event-listeners.js"].map(r=>`dobetterweb/${r}`),...["cumulative-layout-shift.js","first-contentful-paint.js","first-meaningful-paint.js","interaction-to-next-paint.js","interactive.js","largest-contentful-paint.js","max-potential-fid.js","speed-index.js","total-blocking-time.js"].map(r=>`metrics/${r}`),...["canonical.js","crawlable-anchors.js","font-size.js","hreflang.js","http-status-code.js","is-crawlable.js","link-text.js","manual","meta-description.js","plugins.js","robots-txt.js","tap-targets.js"].map(r=>`seo/${r}`),...["structured-data.js"].map(r=>`seo/manual/${r}`),...["accesskeys.js","aria-allowed-attr.js","aria-allowed-role.js","aria-command-name.js","aria-dialog-name.js","aria-hidden-body.js","aria-hidden-focus.js","aria-input-field-name.js","aria-meter-name.js","aria-progressbar-name.js","aria-required-attr.js","aria-required-children.js","aria-required-parent.js","aria-roles.js","aria-text.js","aria-toggle-field-name.js","aria-tooltip-name.js","aria-treeitem-name.js","aria-valid-attr-value.js","aria-valid-attr.js","axe-audit.js","button-name.js","bypass.js","color-contrast.js","definition-list.js","dlitem.js","document-title.js","duplicate-id-active.js","duplicate-id-aria.js","empty-heading.js","form-field-multiple-labels.js","frame-title.js","heading-order.js","html-has-lang.js","html-lang-valid.js","html-xml-lang-mismatch.js","identical-links-same-purpose.js","image-alt.js","image-redundant-alt.js","input-button-name.js","input-image-alt.js","label-content-name-mismatch.js","label.js","landmark-one-main.js","link-in-text-block.js","link-name.js","list.js","listitem.js","manual","meta-refresh.js","meta-viewport.js","object-alt.js","select-name.js","skip-link.js","tabindex.js","table-duplicate-name.js","table-fake-caption.js","target-size.js","td-has-header.js","td-headers-attr.js","th-has-data-cells.js","valid-lang.js","video-caption.js"].map(r=>`accessibility/${r}`),...["custom-controls-labels.js","custom-controls-roles.js","focus-traps.js","focusable-controls.js","interactive-element-affordance.js","logical-tab-order.js","managed-focus.js","offscreen-content-hidden.js","use-landmarks.js","visual-order-follows-dom.js"].map(r=>`accessibility/manual/${r}`),...["byte-efficiency-audit.js","duplicated-javascript.js","efficient-animated-content.js","legacy-javascript.js","modern-image-formats.js","offscreen-images.js","polyfill-graph-data.json","render-blocking-resources.js","total-byte-weight.js","unminified-css.js","unminified-javascript.js","unused-css-rules.js","unused-javascript.js","uses-long-cache-ttl.js","uses-optimized-images.js","uses-responsive-images-snapshot.js","uses-responsive-images.js","uses-text-compression.js"].map(r=>`byte-efficiency/${r}`),...["manual-audit.js","pwa-cross-browser.js","pwa-each-page-has-url.js","pwa-page-transitions.js"].map(r=>`manual/${r}`)].filter(r=>/\.js$/.test(r)&&!t.includes(r)).sort()}static getGathererList(){return["accessibility.js","anchor-elements.js","bf-cache-failures.js","cache-contents.js","console-messages.js","css-usage.js","devtools-log-compat.js","devtools-log.js","dobetterweb","full-page-screenshot.js","global-listeners.js","iframe-elements.js","image-elements.js","inputs.js","inspector-issues.js","installability-errors.js","js-usage.js","link-elements.js","main-document-content.js","meta-elements.js","network-user-agent.js","script-elements.js","scripts.js","seo","service-worker.js","source-maps.js","stacks.js","trace-compat.js","trace-elements.js","trace.js","viewport-dimensions.js","web-app-manifest.js",...["embedded-content.js","font-size.js","robots-txt.js","tap-targets.js"].map(n=>`seo/${n}`),...["doctype.js","domstats.js","optimized-images.js","response-compression.js","tags-blocking-first-paint.js"].map(n=>`dobetterweb/${n}`)].filter(n=>/\.js$/.test(n)&&n!=="gatherer.js").sort()}static _getDataSavePath(t){let{auditMode:n,gatherMode:r}=t;return typeof n=="string"?Dt.resolve(process.cwd(),n):typeof r=="string"?Dt.resolve(process.cwd(),r):Dt.join(process.cwd(),"latest-run")}}});var Eue,xue,Bh,y9=b(()=>{"use strict";d();Kr();It();Eue=3e4,xue=jn,Bh=class extends xue{static{s(this,"ProtocolSession")}constructor(t){super(),this._cdpSession=t,this._targetInfo=void 0,this._nextProtocolTimeout=void 0,this._handleProtocolEvent=this._handleProtocolEvent.bind(this),this._cdpSession.on("*",this._handleProtocolEvent)}id(){return this._cdpSession.id()}_handleProtocolEvent(t,...n){this.emit(t,...n)}setTargetInfo(t){this._targetInfo=t}hasNextProtocolTimeout(){return this._nextProtocolTimeout!==void 0}getNextProtocolTimeout(){return this._nextProtocolTimeout||Eue}setNextProtocolTimeout(t){this._nextProtocolTimeout=t}sendCommand(t,...n){let r=this.getNextProtocolTimeout();this._nextProtocolTimeout=void 0;let a,o=new Promise((u,l)=>{r!==1/0&&(a=setTimeout(l,r,new j(j.errors.PROTOCOL_TIMEOUT,{protocolMethod:t})))}),i=this._cdpSession.send(t,...n);return Promise.race([i,o]).finally(()=>{a&&clearTimeout(a)})}async dispose(){this._cdpSession.off("*",this._handleProtocolEvent),await this._cdpSession.detach()}}});var Tue,Uh,b9=b(()=>{"use strict";d();Kr();Ae();y9();Tue=jn,Uh=class extends Tue{static{s(this,"TargetManager")}constructor(t){super(),this._enabled=!1,this._rootCdpSession=t,this._mainFrameId="",this._targetIdToTargets=new Map,this._executionContextIdToDescriptions=new Map,this._onSessionAttached=this._onSessionAttached.bind(this),this._onFrameNavigated=this._onFrameNavigated.bind(this),this._onExecutionContextCreated=this._onExecutionContextCreated.bind(this),this._onExecutionContextDestroyed=this._onExecutionContextDestroyed.bind(this),this._onExecutionContextsCleared=this._onExecutionContextsCleared.bind(this)}async _onFrameNavigated(t){if(!t.frame.parentId&&this._enabled)try{await this._rootCdpSession.send("Target.setAutoAttach",{autoAttach:!0,flatten:!0,waitForDebuggerOnStart:!0})}catch(n){if(this._enabled)throw n}}_findSession(t){for(let{session:n,cdpSession:r}of this._targetIdToTargets.values())if(r.id()===t)return n;throw new Error(`session ${t} not found`)}_isAcceptedTargetType(t){return t==="page"||t==="iframe"||t==="worker"}rootSession(){let t=this._rootCdpSession.id();return this._findSession(t)}mainFrameExecutionContexts(){return[...this._executionContextIdToDescriptions.values()].filter(t=>t.auxData.frameId===this._mainFrameId)}async _onSessionAttached(t){let n=new Bh(t);try{let{targetInfo:r}=await n.sendCommand("Target.getTargetInfo"),a=r.type;if(!this._isAcceptedTargetType(a))return;let o=r.targetId;if(this._targetIdToTargets.has(o))return;n.setTargetInfo(r);let i=r.url||r.targetId;F.verbose("target-manager",`target ${i} attached`);let u=this._getProtocolEventListener(a,n.id());t.on("*",u),t.on("sessionattached",this._onSessionAttached);let l={target:r,cdpSession:t,session:n,protocolListener:u};this._targetIdToTargets.set(o,l),await n.sendCommand("Network.enable"),await n.sendCommand("Target.setAutoAttach",{autoAttach:!0,flatten:!0,waitForDebuggerOnStart:!0})}catch(r){if(/Target closed/.test(r.message))return;throw r}finally{await n.sendCommand("Runtime.runIfWaitingForDebugger").catch(()=>{})}}_onExecutionContextCreated(t){t.context.name!=="__puppeteer_utility_world__"&&t.context.name!=="lighthouse_isolated_context"&&this._executionContextIdToDescriptions.set(t.context.uniqueId,t.context)}_onExecutionContextDestroyed(t){this._executionContextIdToDescriptions.delete(t.executionContextUniqueId)}_onExecutionContextsCleared(){this._executionContextIdToDescriptions.clear()}_getProtocolEventListener(t,n){return s((a,o)=>{let i={method:a,params:o,targetType:t,sessionId:n};this.emit("protocolevent",i)},"onProtocolEvent")}async enable(){this._enabled||(this._enabled=!0,this._targetIdToTargets=new Map,this._executionContextIdToDescriptions=new Map,this._rootCdpSession.on("Page.frameNavigated",this._onFrameNavigated),this._rootCdpSession.on("Runtime.executionContextCreated",this._onExecutionContextCreated),this._rootCdpSession.on("Runtime.executionContextDestroyed",this._onExecutionContextDestroyed),this._rootCdpSession.on("Runtime.executionContextsCleared",this._onExecutionContextsCleared),await this._rootCdpSession.send("Page.enable"),await this._rootCdpSession.send("Runtime.enable"),this._mainFrameId=(await this._rootCdpSession.send("Page.getFrameTree")).frameTree.frame.id,await this._onSessionAttached(this._rootCdpSession))}async disable(){this._rootCdpSession.off("Page.frameNavigated",this._onFrameNavigated),this._rootCdpSession.off("Runtime.executionContextCreated",this._onExecutionContextCreated),this._rootCdpSession.off("Runtime.executionContextDestroyed",this._onExecutionContextDestroyed),this._rootCdpSession.off("Runtime.executionContextsCleared",this._onExecutionContextsCleared);for(let{cdpSession:t,protocolListener:n}of this._targetIdToTargets.values())t.off("*",n),t.off("sessionattached",this._onSessionAttached);await this._rootCdpSession.send("Page.disable"),await this._rootCdpSession.send("Runtime.disable"),this._enabled=!1,this._targetIdToTargets=new Map,this._executionContextIdToDescriptions=new Map,this._mainFrameId=""}}});var jh,v9=b(()=>{"use strict";d();jt();jh=class{static{s(this,"Fetcher")}constructor(t){this.session=t}async fetchResource(t,n={timeout:2e3}){return globalThis.isLightrider?this._wrapWithTimeout(this._fetchWithFetchApi(t),n.timeout):this._fetchResourceOverProtocol(t,n)}async _fetchWithFetchApi(t){let n=await fetch(t),r=null;try{r=await n.text()}catch{}return{content:r,status:n.status}}async _readIOStream(t,n={timeout:2e3}){let r=Date.now(),a,o="";for(;!a||!a.eof;){if(Date.now()-r>n.timeout)throw new Error("Waiting for the end of the IO stream exceeded the allotted time.");a=await this.session.sendCommand("IO.read",{handle:t});let c=a.base64Encoded?Buffer.from(a.data,"base64").toString("utf-8"):a.data;o=o.concat(c)}return o}async _loadNetworkResource(t){let n=await this.session.sendCommand("Page.getFrameTree"),r=await this.session.sendCommand("Network.loadNetworkResource",{frameId:n.frameTree.frame.id,url:t,options:{disableCache:!0,includeCredentials:!0}});return{stream:r.resource.success&&r.resource.stream||null,status:r.resource.httpStatusCode||null}}async _fetchResourceOverProtocol(t,n){let r=Date.now(),a=await this._wrapWithTimeout(this._loadNetworkResource(t),n.timeout),o=a.status&&a.status>=200&&a.status<=299;if(!a.stream||!o)return{status:a.status,content:null};let i=n.timeout-(Date.now()-r),c=await this._readIOStream(a.stream,{timeout:i});return{status:a.status,content:c}}async _wrapWithTimeout(t,n){let r,a=new Promise((i,c)=>{r=setTimeout(c,n,new Error("Timed out fetching resource"))});return await Promise.race([t,a]).finally(()=>clearTimeout(r))}}});var Pn,SS,xo,qh=b(()=>{"use strict";d();Ae();_p();b9();v9();Sw();Pn=s(()=>{throw new Error("Session not connected")},"throwNotConnectedFn"),SS={setTargetInfo:Pn,hasNextProtocolTimeout:Pn,getNextProtocolTimeout:Pn,setNextProtocolTimeout:Pn,on:Pn,once:Pn,off:Pn,sendCommand:Pn,dispose:Pn},xo=class{static{s(this,"Driver")}constructor(t){this._page=t,this._targetManager=void 0,this._networkMonitor=void 0,this._executionContext=void 0,this._fetcher=void 0,this.defaultSession=SS}get executionContext(){return this._executionContext?this._executionContext:Pn()}get fetcher(){return this._fetcher?this._fetcher:Pn()}get targetManager(){return this._targetManager?this._targetManager:Pn()}get networkMonitor(){return this._networkMonitor?this._networkMonitor:Pn()}async url(){return this._page.url()}async connect(){if(this.defaultSession!==SS)return;let t={msg:"Connecting to browser",id:"lh:driver:connect"};F.time(t);let n=await this._page.target().createCDPSession();this._targetManager=new Uh(n),await this._targetManager.enable(),this._networkMonitor=new hs(this._targetManager),await this._networkMonitor.enable(),this.defaultSession=this._targetManager.rootSession(),this._executionContext=new Ma(this.defaultSession),this._fetcher=new jh(this.defaultSession),F.timeEnd(t)}async disconnect(){this.defaultSession!==SS&&(await this._targetManager?.disable(),await this._networkMonitor?.disable(),await this.defaultSession.dispose())}}});function w9(e,t){return new Error(`Dependency "${e.id}" failed with exception: ${t.message}`)}function Pc(){return{startInstrumentation:{},startSensitiveInstrumentation:{},stopSensitiveInstrumentation:{},stopInstrumentation:{},getArtifact:{}}}async function xn(e){let{driver:t,page:n,artifactDefinitions:r,artifactState:a,baseArtifacts:o,phase:i,gatherMode:c,computedCache:u,settings:l}=e,m=Sue[i],p=m&&a[m]||{},h=i==="getArtifact";for(let f of r){F.verbose(`artifacts:${i}`,f.id);let y=f.gatherer.instance,D=(p[f.id]||Promise.resolve()).then(async()=>{let E=h?await kue(f,a.getArtifact):{},S={msg:`Getting artifact: ${f.id}`,id:`lh:gather:getArtifact:${f.id}`};h&&F.time(S);let k=await y[i]({gatherMode:c,driver:t,page:n,baseArtifacts:o,dependencies:E,computedCache:u,settings:l});return h&&F.timeEnd(S),k});await D.catch(E=>{Rt.captureException(E,{tags:{gatherer:f.id,phase:i},level:"error"}),F.error(f.id,E.message)}),a[i][f.id]=D}}async function kue(e,t){if(!e.dependencies)return{};let n=Object.entries(e.dependencies).map(async([r,a])=>{let o=t[a.id];if(o===void 0)throw new Error(`"${a.id}" did not run`);if(o instanceof Error)throw w9(a,o);let i=Promise.resolve().then(()=>o).catch(c=>Promise.reject(w9(a,c)));return[r,await i]});return Object.fromEntries(await Promise.all(n))}async function Oc(e){let t={};for(let[n,r]of Object.entries(e.getArtifact)){let a=await r.catch(o=>o);a!==void 0&&(t[n]=a)}return t}var Sue,zh=b(()=>{"use strict";d();Ae();or();s(w9,"createDependencyError");s(Pc,"getEmptyArtifactState");Sue={startInstrumentation:void 0,startSensitiveInstrumentation:"startInstrumentation",stopSensitiveInstrumentation:"startSensitiveInstrumentation",stopInstrumentation:"stopSensitiveInstrumentation",getArtifact:"stopInstrumentation"};s(xn,"collectPhaseArtifacts");s(kue,"collectArtifactDependencies");s(Oc,"awaitArtifacts")});async function E9(e){let t={msg:"Getting browser version",id:"lh:gather:getVersion"};F.time(t,"verbose");let n=await e.sendCommand("Browser.getVersion"),r=n.product.match(/\/(\d+)/),a=r?parseInt(r[1]):0;return F.timeEnd(t),Object.assign(n,{milestone:a})}async function x9(e){let t={msg:"Benchmarking machine",id:"lh:gather:getBenchmarkIndex"};F.time(t);let n=await e.evaluate(me.computeBenchmarkIndex,{args:[]});return F.timeEnd(t),n}function _ue(e){let{settings:t,baseArtifacts:n}=e,{throttling:r,throttlingMethod:a}=t,o=qn.throttling;if(t.channel!=="cli")return;let i=a==="simulate"||a==="devtools",c=r.cpuSlowdownMultiplier===o.cpuSlowdownMultiplier;if(!(!i||!c)&&!(n.BenchmarkIndex>Cue))return Aue(D9.warningSlowHostCpu)}function T9(e){return[_ue(e)].filter(t=>!!t)}var D9,Cue,Aue,S9=b(()=>{"use strict";d();Ae();zn();Zt();A();D9={warningSlowHostCpu:"The tested device appears to have a slower CPU than  Lighthouse expects. This can negatively affect your performance score. Learn more about [calibrating an appropriate CPU slowdown multiplier](https://github.com/GoogleChrome/lighthouse/blob/main/docs/throttling.md#cpu-throttling)."},Cue=1e3,Aue=w("core/gather/driver/environment.js",D9);s(E9,"getBrowserVersion");s(x9,"getBenchmarkIndex");s(_ue,"getSlowHostCpuWarning");s(T9,"getEnvironmentWarnings")});async function Bc(e,t,n){let r=await x9(t.executionContext),{userAgent:a,product:o}=await E9(t.defaultSession);return{fetchTime:new Date().toJSON(),Timing:[],LighthouseRunWarnings:[],settings:e.settings,BenchmarkIndex:r,HostUserAgent:a,HostFormFactor:a.includes("Android")||a.includes("Mobile")?"mobile":"desktop",HostProduct:o,URL:{finalDisplayedUrl:""},PageLoadError:null,GatherContext:n}}function Rue(e){let t=[];for(let n of e)t.some(r=>(0,k9.default)(n,r))||t.push(n);return t}function Uc(e,t){e.LighthouseRunWarnings.push(...T9({settings:e.settings,baseArtifacts:e}));let n={...e,...t};if(n.Timing=F.getTimeEntries(),n.LighthouseRunWarnings=Rue(e.LighthouseRunWarnings),n.PageLoadError&&!n.URL.finalDisplayedUrl&&(n.URL.finalDisplayedUrl=n.URL.requestedUrl||""),!n.URL.finalDisplayedUrl)throw new Error("Runner did not set finalDisplayedUrl");return n}var k9,Hh=b(()=>{"use strict";d();Ae();k9=Lt(iu(),1);S9();s(Bc,"getBaseArtifacts");s(Rue,"deduplicateWarnings");s(Uc,"finalizeArtifacts")});async function kS(e,t={}){let{flags:n={},config:r}=t;F.setLevel(n.logLevel||"error");let{resolvedConfig:a}=await Da("snapshot",r,n),o=new xo(e);await o.connect();let i=new Map,c=await o.url(),u={resolvedConfig:a,computedCache:i};return{artifacts:await tn.gather(async()=>{let m=await Bc(a,o,{gatherMode:"snapshot"});m.URL={finalDisplayedUrl:c};let p=a.artifacts||[],h=Pc();await xn({phase:"getArtifact",gatherMode:"snapshot",driver:o,page:e,baseArtifacts:m,artifactDefinitions:p,artifactState:h,computedCache:i,settings:a.settings}),await o.disconnect();let f=await Oc(h);return Uc(m,f)},u),runnerOptions:u}}var CS=b(()=>{"use strict";d();Ae();qh();Eo();zh();Ic();Hh();s(kS,"snapshotGather")});async function Vh(e,t,n){let r={msg:"Cleaning origin data",id:"lh:storage:clearDataForOrigin"};F.time(r);let a=[],o=new URL(t).origin,i=n.join(",");e.setNextProtocolTimeout(5e3);try{await e.sendCommand("Storage.clearDataForOrigin",{origin:o,storageTypes:i})}catch(c){if(c.code==="PROTOCOL_TIMEOUT")F.warn("Driver","clearDataForOrigin timed out"),a.push(AS(Gh.warningOriginDataTimeout));else throw c}finally{F.timeEnd(r)}return a}async function C9(e,t){let n=await e.sendCommand("Storage.getUsageAndQuota",{origin:t}),r={local_storage:"Local Storage",indexeddb:"IndexedDB",websql:"Web SQL"},a=n.usageBreakdown.filter(o=>o.usage).map(o=>r[o.storageType]||"").filter(Boolean);if(a.length)return AS(Gh.warningData,{locations:a.join(", "),locationCount:a.length})}async function A9(e){let t={msg:"Cleaning browser cache",id:"lh:storage:clearBrowserCaches"};F.time(t);let n=[];try{await e.sendCommand("Network.clearBrowserCache"),await e.sendCommand("Network.setCacheDisabled",{cacheDisabled:!0}),await e.sendCommand("Network.setCacheDisabled",{cacheDisabled:!1})}catch(r){if(r.code==="PROTOCOL_TIMEOUT")F.warn("Driver","clearBrowserCaches timed out"),n.push(AS(Gh.warningCacheTimeout));else throw r}finally{F.timeEnd(t)}return n}var Gh,AS,_S=b(()=>{"use strict";d();Ae();A();Gh={warningData:`{locationCount, plural,
    =1 {There may be stored data affecting loading performance in this location: {locations}. Audit this page in an incognito window to prevent those resources from affecting your scores.}
    other {There may be stored data affecting loading performance in these locations: {locations}. Audit this page in an incognito window to prevent those resources from affecting your scores.}
  }`,warningCacheTimeout:"Clearing the browser cache timed out. Try auditing this page again and file a bug if the issue persists.",warningOriginDataTimeout:"Clearing the origin data timed out. Try auditing this page again and file a bug if the issue persists."},AS=w("core/gather/driver/storage.js",Gh);s(Vh,"clearDataForOrigin");s(C9,"getImportantStorageWarning");s(A9,"clearBrowserCaches")});async function Wh(e){let t=s(async()=>{await e.sendCommand("Debugger.enable"),await e.sendCommand("Debugger.setSkipAllPauses",{skip:!0}),await e.sendCommand("Debugger.setAsyncCallStackDepth",{maxDepth:8})},"enable");function n(){e.sendCommand("Debugger.resume")}s(n,"onDebuggerPaused");function r(a){a.frame.parentId||t().catch(o=>F.error("Driver",o))}return s(r,"onFrameNavigated"),e.on("Debugger.paused",n),e.on("Page.frameNavigated",r),await t(),async()=>{await e.sendCommand("Debugger.disable"),e.off("Debugger.paused",n),e.off("Page.frameNavigated",r)}}async function Fue(e,t){await e.executionContext.evaluateOnNewDocument(me.wrapRequestIdleCallback,{args:[t.throttling.cpuSlowdownMultiplier]})}async function Iue(e){e.on("Page.javascriptDialogOpening",t=>{F.warn("Driver",`${t.type} dialog opened by the page automatically suppressed.`),e.sendCommand("Page.handleJavaScriptDialog",{accept:!0,promptText:"Lighthouse prompt response"}).catch(n=>F.warn("Driver",n))}),await e.sendCommand("Page.enable")}async function Nue(e,t,n){let r=[],a=await Vh(e,t,n);r.push(...a);let o=await A9(e);r.push(...o);let i=await C9(e,t);return i&&r.push(i),{warnings:r}}async function R9(e,t){let n={msg:"Preparing network conditions",id:"lh:gather:prepareThrottlingAndNetwork"};F.time(n),await sM(e,t);let r=t.blockedUrlPatterns||[];await e.sendCommand("Network.setBlockedURLs",{urls:r});let a=t.extraHeaders;a&&await e.sendCommand("Network.setExtraHTTPHeaders",{headers:a}),F.timeEnd(n)}async function F9(e,t){await e.defaultSession.sendCommand("Network.enable"),await $p(e.defaultSession,t)}async function I9(e,t){let n={msg:"Preparing target for timespan mode",id:"lh:prepare:timespanMode"};F.time(n),await F9(e,t),await R9(e.defaultSession,t),await N9(e),F.timeEnd(n)}async function N9(e){await e.executionContext.evaluate(me.truncate,{args:["aaa",2]})}async function M9(e,t,n){let r={msg:"Preparing target for navigation mode",id:"lh:prepare:navigationMode"};F.time(r);let a=[];if(await F9(e,t),await Iue(e.defaultSession),await e.executionContext.cacheNativesOnNewDocument(),t.throttlingMethod==="simulate"&&await Fue(e,t),await N9(e),!t.disableStorageReset&&typeof n=="string"){let{warnings:i}=await Nue(e.defaultSession,n,t.clearStorageTypes);a.push(...i)}return await R9(e.defaultSession,t),F.timeEnd(r),{warnings:a}}var RS=b(()=>{"use strict";d();Ae();_S();Yp();Zt();s(Wh,"enableAsyncStacks");s(Fue,"shimRequestIdleCallbackOnNewDocument");s(Iue,"dismissJavaScriptDialogs");s(Nue,"resetStorageForUrl");s(R9,"prepareThrottlingAndNetwork");s(F9,"prepareDeviceEmulation");s(I9,"prepareTargetForTimespanMode");s(N9,"warmUpIntlSegmenter");s(M9,"prepareTargetForNavigationMode")});async function FS(e,t={}){let{flags:n={},config:r}=t;F.setLevel(n.logLevel||"error");let{resolvedConfig:a}=await Da("timespan",r,n),o=new xo(e);await o.connect();let i=new Map,c=a.artifacts||[],u=await Bc(a,o,{gatherMode:"timespan"}),l=Pc(),m={driver:o,page:e,artifactDefinitions:c,artifactState:l,baseArtifacts:u,computedCache:i,gatherMode:"timespan",settings:a.settings};await I9(o,a.settings);let p=!1;function h(){p=!0}s(h,"onFrameNavigated"),o.defaultSession.on("Page.frameNavigated",h);let f=await Wh(o.defaultSession);return await xn({phase:"startInstrumentation",...m}),await xn({phase:"startSensitiveInstrumentation",...m}),{async endTimespanGather(){let y=await o.url(),v={resolvedConfig:a,computedCache:i};return{artifacts:await tn.gather(async()=>{u.URL={finalDisplayedUrl:y},await xn({phase:"stopSensitiveInstrumentation",...m}),await xn({phase:"stopInstrumentation",...m}),await f(),o.defaultSession.off("Page.frameNavigated",h),p&&u.LighthouseRunWarnings.push(Lue(L9.warningNavigationDetected)),await xn({phase:"getArtifact",...m}),await o.disconnect();let E=await Oc(l);return Uc(u,E)},v),runnerOptions:v}}}}var L9,Lue,IS=b(()=>{"use strict";d();Ae();qh();Eo();zh();RS();Ic();Hh();A();L9={warningNavigationDetected:"A page navigation was detected during the run. Using timespan mode to audit page navigations is not recommended. Use navigation mode to audit page navigations for better third-party attribution and main thread detection."},Lue=w("core/gather/timespan-runner.js",L9);s(FS,"startTimespanGather")});var P9,O9=b(()=>{d();P9={}});function jue(e){let{pauseAfterFcpMs:t,pauseAfterLoadMs:n,networkQuietThresholdMs:r,cpuQuietThresholdMs:a}=e,o=e.maxWaitForLoad,i=e.maxWaitForFcp;return typeof t!="number"&&(t=Pue),typeof n!="number"&&(n=Oue),typeof r!="number"&&(r=Bue),typeof a!="number"&&(a=Uue),typeof o!="number"&&(o=qn.maxWaitForLoad),typeof i!="number"&&(i=qn.maxWaitForFcp),e.waitUntil.includes("fcp")||(i=void 0),{pauseAfterFcpMs:t,pauseAfterLoadMs:n,networkQuietThresholdMs:r,cpuQuietThresholdMs:a,maxWaitForLoadedMs:o,maxWaitForFcpMs:i}}async function MS(e,t,n){let r=typeof t=="string"?{msg:`Navigating to ${t}`,id:"lh:driver:navigate"}:{msg:"Navigating using a user defined function",id:"lh:driver:navigate"};F.time(r);let a=e.defaultSession,o=e.networkMonitor;await a.sendCommand("Page.enable"),await a.sendCommand("Page.setLifecycleEventsEnabled",{enabled:!0});let i;typeof t=="string"?(a.setNextProtocolTimeout(1/0),i=a.sendCommand("Page.navigate",{url:t})):i=t();let c=n.waitUntil.includes("navigated"),u=n.waitUntil.includes("load"),l=n.waitUntil.includes("fcp"),m=[];if(c){let D=Rp(a).promise;m.push(D.then(()=>({timedOut:!1})))}if(u){let D=jue(n);m.push(zI(a,o,D))}else if(l)throw new Error("Cannot wait for FCP without waiting for page load");let h=(await Promise.all(m)).some(D=>D.timedOut),f=await o.getNavigationUrls(),y=f.requestedUrl;if(typeof t=="string"&&(y&&!Y.equalWithExcludedFragments(t,y)&&F.error("Navigation",`Provided URL (${t}) did not match initial navigation URL (${y})`),y=t),!y)throw Error("No navigations detected when running user defined requestor.");let v=f.mainDocumentUrl||y;return await i,n.debugNavigation&&await HI(e),F.timeEnd(r),{requestedUrl:y,mainDocumentUrl:v,warnings:que({timedOut:h,mainDocumentUrl:v,requestedUrl:y})}}function que(e){let{requestedUrl:t,mainDocumentUrl:n}=e,r=[];return e.timedOut&&r.push(B9(NS.warningTimeout)),Y.equalWithExcludedFragments(t,n)||r.push(B9(NS.warningRedirected,{requested:t,final:n})),r}var NS,B9,Pue,Oue,Bue,Uue,U9=b(()=>{"use strict";d();Ae();Fp();zn();A();Ze();NS={warningRedirected:"The page may not be loading as expected because your test URL ({requested}) was redirected to {final}. Try testing the second URL directly.",warningTimeout:"The page loaded too slowly to finish within the time limit. Results may be incomplete."},B9=w("core/gather/driver/navigation.js",NS),Pue=0,Oue=0,Bue=5e3,Uue=0;s(jue,"resolveWaitForFullyLoadedOptions");s(MS,"gotoURL");s(que,"getNavigationWarnings")});function Hue(e,t){if(e){if(e.failed){let n=e.localizedFailDescription;return n==="net::ERR_NAME_NOT_RESOLVED"||n==="net::ERR_NAME_RESOLUTION_FAILED"||n.startsWith("net::ERR_DNS_")?new j(j.errors.DNS_FAILURE):new j(j.errors.FAILED_DOCUMENT_REQUEST,{errorDetails:n})}else if(e.hasErrorStatusCode())if(t.ignoreStatusCode)t.warnings.push(j9(LS.warningStatusCode,{errorCode:e.statusCode}));else return new j(j.errors.ERRORED_DOCUMENT_REQUEST,{statusCode:`${e.statusCode}`})}else return new j(j.errors.NO_DOCUMENT_REQUEST)}function Gue(e,t){if(!(!e||!t.find(r=>r.documentURL.startsWith("chrome-error://")))&&e.failed)return e.localizedFailDescription.startsWith("net::ERR_CERT")?new j(j.errors.INSECURE_DOCUMENT_REQUEST,{securityMessages:e.localizedFailDescription}):new j(j.errors.CHROME_INTERSTITIAL_ERROR)}function Vue(e){if(e&&!(!e.mimeType||e.statusCode===-1)&&e.mimeType!==zue&&e.mimeType!==q9)return new j(j.errors.NOT_HTML,{mimeType:e.mimeType})}function z9(e,t){let{url:n,networkRecords:r}=t,a=Gt.findResourceForUrl(r,n);if(!a){let l=r.filter(m=>m.resourceType===G.TYPES.Document);l.length&&(a=l.reduce((m,p)=>p.networkRequestTime<m.networkRequestTime?p:m))}let o;a&&(o=Gt.resolveRedirects(a)),o?.mimeType===q9&&t.warnings.push(j9(LS.warningXhtml));let i=Hue(a,t),c=Gue(a,r),u=Vue(o);return c||i||u||e}var LS,j9,zue,q9,H9=b(()=>{"use strict";d();It();Uo();lt();A();LS={warningXhtml:"The page MIME type is XHTML: Lighthouse does not explicitly support this document type",warningStatusCode:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests. (Status code: {errorCode})"},j9=w("core/lib/navigation-error.js",LS),zue="text/html",q9="application/xhtml+xml";s(Hue,"getNetworkError");s(Gue,"getInterstitialError");s(Vue,"getNonHtmlError");s(z9,"getPageLoadError")});async function Yue({driver:e,resolvedConfig:t,requestor:n}){await e.connect(),typeof n=="string"&&!t.settings.skipAboutBlank&&(await e._networkMonitor?.disable(),await MS(e,t.settings.blankPage,{waitUntil:["navigated"]}),await e._networkMonitor?.enable());let r=await Bc(t,e,{gatherMode:"navigation"}),{warnings:a}=await M9(e,t.settings,n);return r.LighthouseRunWarnings.push(...a),{baseArtifacts:r}}async function Kue({driver:e}){await cM(e.defaultSession)}async function Xue(e){let{driver:t,resolvedConfig:n,requestor:r}=e;try{let{requestedUrl:a,mainDocumentUrl:o,warnings:i}=await MS(t,r,{...n.settings,waitUntil:n.settings.pauseAfterFcpMs?["fcp","load"]:["load"]});return e.baseArtifacts.LighthouseRunWarnings.push(...i),{requestedUrl:a,mainDocumentUrl:o,navigationError:void 0}}catch(a){if(!(a instanceof j)||a.code!=="NO_FCP"&&a.code!=="PAGE_HUNG"||typeof r!="string")throw a;return{requestedUrl:r,mainDocumentUrl:r,navigationError:a}}}async function Jue(e,t){let n=t.artifactDefinitions.find(p=>p.gatherer.instance.meta.symbol===_t.symbol),r=t.artifactDefinitions.find(p=>p.gatherer.instance.meta.symbol===Xr.symbol),a=[n,r].filter(p=>!!p);if(!a.length)return{};await xn({...t,phase:"getArtifact",artifactDefinitions:a});let o=t.artifactState.getArtifact,i=n?.id,c=i&&await o[i],u=c&&await H.request(c,e),l=r?.id,m=l&&await o[l];return{devtoolsLog:c,records:u,trace:m}}async function Zue(e,t,n){let{navigationError:r,requestedUrl:a,mainDocumentUrl:o}=n,i=await Jue(e,t),c=i.records?z9(r,{url:o,ignoreStatusCode:e.resolvedConfig.settings.ignoreStatusCode,networkRecords:i.records,warnings:e.baseArtifacts.LighthouseRunWarnings}):r;if(c){let u=e.resolvedConfig.settings.locale,l=Po(c.friendlyMessage,u);F.error("NavigationRunner",l,a);let m={},p="pageLoadError-defaultPass";return i.devtoolsLog&&(m.DevtoolsLogError=i.devtoolsLog,m.devtoolsLogs={[p]:i.devtoolsLog}),i.trace&&(m.TraceError=i.trace,m.traces={[p]:i.trace}),e.baseArtifacts.LighthouseRunWarnings.push(c.friendlyMessage),e.baseArtifacts.PageLoadError=c,m}else return await xn({phase:"getArtifact",...t}),await Oc(t.artifactState)}async function Que(e){if(!e.resolvedConfig.artifacts)throw new Error("No artifacts were defined on the config");let t=Pc(),n={url:await e.driver.url(),gatherMode:"navigation",driver:e.driver,page:e.page,computedCache:e.computedCache,artifactDefinitions:e.resolvedConfig.artifacts,artifactState:t,baseArtifacts:e.baseArtifacts,settings:e.resolvedConfig.settings},r=await Wh(e.driver.defaultSession);await xn({phase:"startInstrumentation",...n}),await xn({phase:"startSensitiveInstrumentation",...n});let a=await Xue(e);return Object.values(n.baseArtifacts.URL).every(Boolean)||(n.baseArtifacts.URL={requestedUrl:a.requestedUrl,mainDocumentUrl:a.mainDocumentUrl,finalDisplayedUrl:await e.driver.url()}),n.url=a.mainDocumentUrl,await xn({phase:"stopSensitiveInstrumentation",...n}),await xn({phase:"stopInstrumentation",...n}),await r(),await Kue(e),Zue(e,n,a)}async function ele({requestedUrl:e,driver:t,resolvedConfig:n,lhBrowser:r,lhPage:a}){!n.settings.disableStorageReset&&e&&await Vh(t.defaultSession,e,n.settings.clearStorageTypes),await t.disconnect(),await a?.close(),await r?.disconnect()}async function PS(e,t,n={}){let{flags:r={},config:a}=n;F.setLevel(r.logLevel||"error");let{resolvedConfig:o}=await Da("navigation",a,r),i=new Map,c=typeof t=="function",u={resolvedConfig:o,computedCache:i};return{artifacts:await tn.gather(async()=>{let m=c?t:Y.normalizeUrl(t),p,h;if(!e){let{hostname:E=Wue,port:S=$ue}=r;p=await P9.connect({browserURL:`http://${E}:${S}`,defaultViewport:null}),h=await p.newPage(),e=h}let y={driver:new xo(e),lhBrowser:p,lhPage:h,page:e,resolvedConfig:o,requestor:m,computedCache:new Map},{baseArtifacts:v}=await Yue(y),D=await Que({...y,baseArtifacts:v});return await ele(y),Uc(v,D)},u),runnerOptions:u}}var Wue,$ue,OS=b(()=>{"use strict";d();O9();Ae();qh();Eo();zh();RS();U9();_S();Yp();Ic();Hh();Qr();It();Ze();H9();Mi();Mn();de();Wue="127.0.0.1",$ue=9222;s(Yue,"_setup");s(Kue,"_cleanupNavigation");s(Xue,"_navigate");s(Jue,"_collectDebugData");s(Zue,"_computeNavigationResult");s(Que,"_navigation");s(ele,"_cleanup");s(PS,"navigationGather")});var tle,aKe,G9=b(()=>{"use strict";d();Oh();CS();IS();OS();Eo();Ic();Qr();ES();A();jt();tle={defaultFlowName:"User flow ({url})",defaultNavigationName:"Navigation report ({url})",defaultTimespanName:"Timespan report ({url})",defaultSnapshotName:"Snapshot report ({url})"},aKe=w("core/user-flow.js",tle)});var uKe,V9=b(()=>{"use strict";d();jt();zn();uKe={extends:"lighthouse:default",settings:{formFactor:"desktop",throttling:In.desktopDense4G,screenEmulation:bp.desktop,emulatedUserAgent:Ia.desktop}}});async function nle(e,t={},n,r){return $h(r,e,{config:n,flags:t})}async function $h(e,t,n){let r=await PS(e,t,n);return tn.audit(r.artifacts,r.runnerOptions)}async function BS(e,t){let n=await kS(e,t);return tn.audit(n.artifacts,n.runnerOptions)}async function US(e,t){let{endTimespanGather:n}=await FS(e,t);return{endTimespan:s(async()=>{let a=await n();return tn.audit(a.artifacts,a.runnerOptions)},"endTimespan")}}var xKe,W9,ct=b(()=>{"use strict";d();Mi();Eo();G9();Oh();IS();CS();OS();jt();V();Se();de();Vg();V9();jt();s(nle,"lighthouse");s($h,"navigation");s(BS,"snapshot");s(US,"startTimespan");xKe=Xr.getDefaultTraceCategories(),W9=nle});d();Ci();Ae();ct();A();Qr();zn();globalThis.Buffer=U;function rle(e,t){let n={onlyCategories:e,screenEmulation:{disabled:!0},ignoreStatusCode:!0};return t==="desktop"&&(n.throttling=In.desktopDense4G,n.emulatedUserAgent=Ia.desktop,n.formFactor="desktop"),{extends:"lighthouse:default",plugins:["lighthouse-plugin-publisher-ads"],settings:n}}s(rle,"createConfig");function ale(e){F.events.addListener("status",e),F.events.addListener("warning",e)}s(ale,"listenForStatus");function ole(e){return sp(e,dR())}s(ole,"lookupCanonicalLocale");function ile(e,{page:t,...n}){return $h(t,e,n)}s(ile,"runLighthouseNavigation");function sle({page:e,...t}){return US(e,t)}s(sle,"startLighthouseTimespan");function cle({page:e,...t}){return BS(e,t)}s(cle,"runLighthouseSnapshot");typeof self<"u"?(globalThis.isDevtools=!0,self.runLighthouseNavigation=ile,self.navigation=$h,self.startLighthouseTimespan=sle,self.startTimespan=US,self.runLighthouseSnapshot=cle,self.snapshot=BS,self.createConfig=rle,self.listenForStatus=ale,self.registerLocaleData=pR,self.lookupLocale=ole):globalThis.runBundledLighthouse=W9;})();
/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 * @license  MIT
 */
/*! Bundled license information:

lighthouse-stack-packs/packs/joomla.js:
  (**
   * @license Copyright 2020 The Lighthouse Authors. All Rights Reserved.
   * Licensed under the Apache License, Version 2.0 (the 'License'); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
   * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
   *)

image-ssim/index.js:
  (**
   * @preserve
   * Copyright 2015 Igor Bezkrovny
   * All rights reserved. (MIT Licensed)
   *
   * ssim.ts - part of Image Quantization Library
   *)
*/
//# sourceMappingURL=lighthouse-dt-bundle.js.map
